=== added file 'MANIFEST.in'
--- MANIFEST.in	1970-01-01 00:00:00 +0000
+++ MANIFEST.in	2010-01-13 16:23:07 +0000
@@ -0,0 +1,3 @@
+include bzr README setup.py
+recursive-include bzrlib *.py *.pyx *.pxd *.txt *.c *.h
+recursive-include tools *.py *.sh

=== modified file 'Makefile'
--- Makefile	2009-10-13 15:05:13 +0000
+++ Makefile	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,7 +39,7 @@
 check: docs check-nodocs
 
 check-nodocs: extensions
-	$(PYTHON) -Werror -O ./bzr selftest -1 --subunit $(tests)
+	$(PYTHON) -Werror -O ./bzr selftest -1v $(tests)
 
 # Run Python style checker (apt-get install pyflakes)
 #
@@ -114,6 +114,7 @@
 clean-sphinx:
 	cd doc/en && make clean
 	cd doc/es && make clean
+	cd doc/ja && make clean
 	cd doc/ru && make clean
 	cd doc/developers && make clean
 
@@ -122,6 +123,8 @@
         doc/en/user-reference/index.txt \
 	doc/es/Makefile \
 	doc/es/make.bat \
+	doc/ja/Makefile \
+	doc/ja/make.bat \
 	doc/ru/Makefile \
 	doc/ru/make.bat \
 	doc/developers/Makefile \
@@ -144,6 +147,7 @@
 	cd doc/en && make html
 	cd doc/es && make html
 	cd doc/ru && make html
+	cd doc/ja && make html
 	cd doc/developers && make html
 
 # Build the PDF docs using Sphinx. This requires numerous LaTeX
@@ -154,6 +158,7 @@
 pdf-sphinx: $(SPHINX_DEPENDENCIES)
 	cd doc/en && make latex
 	cd doc/es && make latex
+	cd doc/ja && make latex
 	cd doc/developers && make latex
 	cd doc/en/_build/latex && make all-pdf
 	cd doc/es/_build/latex && make all-pdf
@@ -166,19 +171,21 @@
 	cd doc/en && make htmlhelp
 	cd doc/es && make htmlhelp
 	cd doc/ru && make htmlhelp
+	cd doc/ja && make htmlhelp
 	cd doc/developers && make htmlhelp
 
 
 ### Documentation Website ###
 
 # Where to build the website
-DOC_WEBSITE_BUILD := build_doc_website
+DOC_WEBSITE_BUILD = build_doc_website
 
 # Build and package docs into a website, complete with downloads.
 doc-website: html-sphinx pdf-sphinx
 	$(PYTHON) tools/package_docs.py doc/en $(DOC_WEBSITE_BUILD)
 	$(PYTHON) tools/package_docs.py doc/es $(DOC_WEBSITE_BUILD)
 	$(PYTHON) tools/package_docs.py doc/ru $(DOC_WEBSITE_BUILD)
+	$(PYTHON) tools/package_docs.py doc/ja $(DOC_WEBSITE_BUILD)
 	$(PYTHON) tools/package_docs.py doc/developers $(DOC_WEBSITE_BUILD)
 
 
@@ -188,33 +195,38 @@
 # support our "plain" html documentation so that Sphinx is not a hard
 # dependency for packagers on older platforms.
 
-rst2html := $(PYTHON) tools/rst2html.py --link-stylesheet --footnote-references=superscript --halt=warning
+rst2html = $(PYTHON) tools/rst2html.py --link-stylesheet --footnote-references=superscript --halt=warning
 
 # translate txt docs to html
-derived_txt_files := \
-	doc/en/user-reference/bzr_man.txt \
+derived_txt_files = \
 	doc/en/release-notes/NEWS.txt
-txt_all := \
+txt_all = \
 	doc/en/tutorials/tutorial.txt \
 	doc/en/tutorials/using_bazaar_with_launchpad.txt \
 	doc/en/tutorials/centralized_workflow.txt \
         $(wildcard doc/es/tutorials/*.txt) \
-        $(wildcard doc/ru/tutorials/*.txt) \
+		$(wildcard doc/ru/tutorials/*.txt) \
+	doc/ja/tutorials/tutorial.txt \
+	doc/ja/tutorials/using_bazaar_with_launchpad.txt \
+	doc/ja/tutorials/centralized_workflow.txt \
 	$(wildcard doc/*/mini-tutorial/index.txt) \
 	$(wildcard doc/*/user-guide/index-plain.txt) \
+	doc/en/admin-guide/index-plain.txt \
 	$(wildcard doc/es/guia-usario/*.txt) \
 	$(derived_txt_files) \
 	doc/en/upgrade-guide/index.txt \
 	doc/index.txt \
 	$(wildcard doc/index.*.txt)
-txt_nohtml := \
+txt_nohtml = \
 	doc/en/user-guide/index.txt \
 	doc/es/user-guide/index.txt \
-	doc/ru/user-guide/index.txt
-txt_files := $(filter-out $(txt_nohtml), $(txt_all))
-htm_files := $(patsubst %.txt, %.html, $(txt_files)) 
+	doc/ja/user-guide/index.txt \
+	doc/ru/user-guide/index.txt \
+	doc/en/admin-guide/index.txt
+txt_files = $(filter-out $(txt_nohtml), $(txt_all))
+htm_files = $(patsubst %.txt, %.html, $(txt_files)) 
 
-non_txt_files := \
+non_txt_files = \
        doc/default.css \
        $(wildcard doc/*/bzr-en-quick-reference.svg) \
        $(wildcard doc/*/bzr-en-quick-reference.png) \
@@ -229,7 +241,7 @@
 
 # doc/developers/*.txt files that should *not* be individually
 # converted to HTML
-dev_txt_nohtml := \
+dev_txt_nohtml = \
 	doc/developers/add.txt \
 	doc/developers/annotate.txt \
 	doc/developers/bundle-creation.txt \
@@ -255,9 +267,9 @@
 	doc/developers/status.txt \
 	doc/developers/uncommit.txt
 
-dev_txt_all := $(wildcard $(addsuffix /*.txt, doc/developers))
-dev_txt_files := $(filter-out $(dev_txt_nohtml), $(dev_txt_all))
-dev_htm_files := $(patsubst %.txt, %.html, $(dev_txt_files)) 
+dev_txt_all = $(wildcard $(addsuffix /*.txt, doc/developers))
+dev_txt_files = $(filter-out $(dev_txt_nohtml), $(dev_txt_all))
+dev_htm_files = $(patsubst %.txt, %.html, $(dev_txt_files)) 
 
 doc/en/user-guide/index-plain.html: $(wildcard $(addsuffix /*.txt, doc/en/user-guide)) 
 	$(rst2html) --stylesheet=../../default.css $(dir $@)index-plain.txt $@
@@ -268,6 +280,9 @@
 #doc/ru/user-guide/index.html: $(wildcard $(addsuffix /*.txt, doc/ru/user-guide)) 
 #	$(rst2html) --stylesheet=../../default.css $(dir $@)index.txt $@
 #
+doc/en/admin-guide/index-plain.html: $(wildcard $(addsuffix /*.txt, doc/en/admin-guide)) 
+	$(rst2html) --stylesheet=../../default.css $(dir $@)index-plain.txt $@
+
 doc/developers/%.html: doc/developers/%.txt
 	$(rst2html) --stylesheet=../default.css $< $@
 
@@ -280,9 +295,6 @@
 %.html: %.txt
 	$(rst2html) --stylesheet=../../default.css $< $@
 
-doc/en/user-reference/bzr_man.txt: $(MAN_DEPENDENCIES)
-	$(PYTHON) tools/generate_docs.py -o $@ rstx
-
 doc/en/release-notes/NEWS.txt: NEWS
 	$(PYTHON) -c "import shutil; shutil.copyfile('$<', '$@')"
 
@@ -299,7 +311,7 @@
 docs-plain: $(ALL_DOCS)
 
 # produce a tree containing just the final docs, ready for uploading to the web
-HTMLDIR := html_docs
+HTMLDIR = html_docs
 html-plain: docs-plain
 	$(PYTHON) tools/win32/ostools.py copytree $(WEB_DOCS) $(HTMLDIR)
 
@@ -325,7 +337,7 @@
 # These are files that need to be copied into the build location to boostrap
 # the build process.
 # Note that the path is relative to tools/win32
-BUILDOUT_FILES := buildout.cfg \
+BUILDOUT_FILES = buildout.cfg \
 	buildout-templates/bin/build-installer.bat.in \
 	ostools.py bootstrap.py
 

=== modified file 'NEWS'
--- NEWS	2009-10-22 01:07:25 +0000
+++ NEWS	2010-02-17 06:01:54 +0000
@@ -6,18 +6,801 @@
    :depth: 1
 
 
-bzr 2.1.0b2 (not released yet)
-##############################
+bzr 2.1.1
+#########
+
+:2.1.1: not released yet
+
+Bug Fixes
+*********
+
+* Register SIGWINCH handler only when creating a ``TextUIFactory``; avoids
+  problems importing bzrlib from a non-main thread.
+  (Elliot Murphy, #521989)
+
+
+bzr 2.1.0
+#########
+
+:Codename: Strasbourg
+:2.1.0: 2010-02-11
+
+This release marks our second long-term-stable series. The Bazaar team
+has decided that we will continue to make bugfix-only 2.0.x and 2.1.x
+releases, along with 2.2 development releases. 
+
+This is a fairly incremental update, focusing on polish and bugfixing.
+There are no changes for supported disk formats. Key updates include
+reduced memory consumption for many operations, a new per-file merge
+hook, ignore patterns can now include '!' to exclude files, globbing
+support for all commands on Windows, and support for addressing home
+directories via ``bzr+ssh://host/~/`` syntax.
+
+Users are encouraged to upgrade from the 2.0 stable series.
+
+Bug Fixes
+*********
+
+* Don't require testtools to use sftp.
+  (Vincent Ladeuil, #516183)
+
+* Fix "AttributeError in Inter1and2Helper" during fetch.
+  (Martin Pool, #513432)
+
+* Ignore ``KeyError`` from ``remove_index`` during ``_abort_write_group``
+  in a pack repository, which can happen harmlessly if the abort occurs during
+  finishing the write group.  Also use ``bzrlib.cleanup`` so that any
+  other errors that occur while aborting the individual packs won't be
+  hidden by secondary failures when removing the corresponding indices.
+  (Andrew Bennetts, #423015)
+  
+* Using the ``bzrlib.chk_map`` module from within multiple threads at the
+  same time was broken due to race conditions with a module level page
+  cache. This shows up as a KeyError in the ``bzrlib.lru_cache`` code with
+  ``bzrlib.chk_map`` in the backtrace, and can be triggered without using
+  the same high level objects such as ``bzrlib.repository.Repository``
+  from different threads. chk_map now uses a thread local cache which may
+  increase memory pressure on processes using threads.
+  (Robert Collins, John Arbash Meinel, #514090)
+
+* The new ``merge_file_content`` should now be ok with tests to avoid
+  regressions.
+  (Vincent Ladeuil, #515597)
+  
+Internals
+*********
+
+* Use ``bzrlib.cleanup`` rather than less robust ``try``/``finally``
+  blocks in several places in ``bzrlib.merge``.  This avoids masking prior
+  errors when errors like ``ImmortalPendingDeletion`` occur during cleanup
+  in ``do_merge``.
+  (Andrew Bennetts, #517275)
+
+API Changes
+***********
+
+* The ``remove_index`` method of
+  ``bzrlib.repofmt.pack_repo.AggregateIndex`` no longer takes a ``pack``
+  argument.  This argument was always ignored.
+  (Andrew Bennetts, #423015)
+
+bzr 2.1.0rc2
+############
+
+:Codename: after the bubbles
+:2.1.0rc2: 2010-01-29
+
+This is a quick-turn-around to update a small issue with our new per-file
+merge hook. We expect no major changes from this to the final 2.1.0.
+
+API Changes
+***********
+
+* The new ``merge_file_content`` hook point has been altered to provide a
+  better API where state for extensions can be stored rather than the
+  too-simple function based approach. This fixes a performance regression
+  where branch configuration would be parsed per-file during merge. As
+  part of this the included news_merger has been refactored into a base
+  helper class ``bzrlib.merge.ConfigurableFileMerger``.
+  (Robert Collins, John Arbash Meinel, #513822)
+
+
+bzr 2.1.0rc1
+############
+
+:Codename: the 'new' stable
+:2.1.0rc1: 2009-01-21
+
+This is the first stable release candidate for Bazaar's 2.1 series. From
+this point onwards, the 2.1 series will be considered stable (as the 2.0
+series) and only bugfixes are expected to be incorporated. The dozen or so
+bugfixes in the 2.0.4 release are also included in this release (along
+with more than 15 more bugfixes). Some of the interesting features are
+support for per-file merge hooks, ``bzr unshelve --preview``, support
+for using ! in ignore files to exclude files from being ignored, a small
+memory leak was squashed, and many ``ObjectNotLocked`` errors were fixed.
+This looks to be a very good start for a new stable series.
+
+
+New Features
+************
+
+* Add bug information to log output when available.
+  (Neil Martinsen-Burrell, Guillermo Gonzalez, #251729)
+
+* Added ``merge_file_content`` hook point to ``Merger``, allowing plugins
+  to register custom merge logic, e.g. to provide smarter merging for
+  particular files.
+
+* Bazaar now includes the ``news_merge`` plugin.  It is disabled by
+  default, to enable it add a ``news_merge_files`` option to your
+  configuration.  Consult ``bzr help news_merge`` for more information.
+  (Andrew Bennetts)
+  
+* ``bzr branch`` now takes a ``--bind`` option. This lets you
+  branch and bind all in one command. (Ian Clatworthy)
+
+* ``bzr switch`` now takes a ``--revision`` option, to allow switching to
+  a specific revision of a branch. (Daniel Watkins, #183559)
+
+* ``bzr unshelve --preview`` can now be used to show how a patch on the
+  shelf would be applied to the working tree.
+  (Guilherme Salgado, #308122)
+
+* ``bzr update`` now takes a ``--revision`` argument. This lets you
+  change the revision of the working tree to any revision in the
+  ancestry of the current or master branch. (Matthieu Moy, Mark Hammond,
+  Martin Pool, #45719)
+
+* ``-Dbytes`` can now be used to display the total number of bytes
+  transferred for the current command. This information is always logged
+  to ``.bzr.log`` for later inspection. (John Arbash Meinel)
+
+* New ignore patterns.  Patterns prefixed with '!' are exceptions to 
+  ignore patterns and take precedence over regular ignores.  Such 
+  exceptions are used to specify files that should be versioned which 
+  would otherwise be ignored.  Patterns prefixed with '!!' act as regular 
+  ignore patterns, but have highest precedence, even over the '!' 
+  exception patterns. (John Whitley, #428031)
+
+* The ``supress_warnings`` configuration option has been introduced to disable
+  various warnings (it currently only supports the ``format_deprecation``
+  warning). The new option can be set in any of the following locations:
+  ``bazaar.conf``, ``locations.conf`` and/or ``branch.conf``.
+  (Ted Gould, Matthew Fuller, Vincent Ladeuil)
+
+Bug Fixes
+*********
+
+* Always show a message if an OS error occurs while trying to run a
+  user-specified commit message editor.
+  (Martin Pool, #504842)
+
+* ``bzr diff`` will now use the epoch when it is unable to determine 
+  the timestamp of a file, if the revision it was introduced in is a
+  ghost. (Jelmer Vernooij, #295611)
+
+* ``bzr switch -b`` can now create branches that are located using directory
+  services such as ``lp:``, even when the branch name doesn't contain a
+  '/'.  (Neil Martinsen-Burrell, #495263)
+
+* ``bzr unshelve`` has improved messages about what it is doing.
+  (Neil Martinsen-Burrell, #496917)
+
+* Concurrent autopacking is more resilient to already-renamed pack files.
+  If we find that a file we are about to obsolete is already obsoleted, we
+  do not try to rename it, and we leave the file in ``obsolete_packs``.
+  The code is also fault tolerant if a file goes missing, assuming that
+  another process already removed the file.
+  (John Arbash Meinel, Gareth White, #507557)
+
+* Fix "Too many concurrent requests" in reconcile when network connection
+  fails.  (Andrew Bennetts, #503878)
+
+* Fixed a side effect mutation of ``RemoteBzrDirFormat._network_name``
+  that caused some tests to fail when run in a non-default order.
+  Probably no user impact.  (Martin Pool, #504102)
+
+* Fixed ``ObjectNotLocked`` error in ``bzr cat -rbranch:../foo FILE``.
+  (Andrew Bennetts, #506274)
+
+* FTP transports support Unicode paths by encoding/decoding them as utf8.
+  (Vincent Ladeuil, #472161)
+
+* Listen to the SIGWINCH signal to update the terminal width.
+  (Vincent Ladeuil, #316357)
+
+* Progress bars are now hidden when ``--quiet`` is given.
+  (Martin Pool, #320035)
+
+* ``SilentUIFactory`` now supports ``make_output_stream`` and discards
+  whatever is written to it.  This un-breaks some plugin tests that
+  depended on this behaviour.
+  (Martin Pool, #499757)
+
+* When operations update the working tree, all affected files should end
+  up with the same mtime. (eg. when versioning a generated file, if you
+  update the source and the generated file together, the generated file
+  should appear up-to-date.)
+  (John Arbash Meinel, Martin <gzlist>, #488724)
+
+Improvements
+************
+
+* Added ``add_cleanup`` and ``cleanup_now`` to ``bzrlib.command.Command``.
+  All the builtin commands now use ``add_cleanup`` rather than
+  ``try``/``finally`` blocks where applicable as it is simpler and more
+  robust.  (Andrew Bennetts)
+
+* All except a small number of storage formats are now hidden, making
+  the help for numerous commands far more digestible. (Ian Clatworthy)
+
+* Attempts to open a shared repository as a branch (e.g. ``bzr branch
+  path/to/repo``) will now include "location is a repository" as a hint in
+  the error message.  (Brian de Alwis, Andrew Bennetts, #440952)
+
+* Push will now inform the user when they are trying to push to a foreign 
+  VCS for which roundtripping is not supported, and will suggest them to 
+  use dpush. (Jelmer Vernooij)
+
+* The version of bzr being run is now written to the log file.
+  (__monty__, #257170)
+
+* Transport network activity indicator is shown more of the time when
+  Bazaar is doing network IO.
+  (Martin Pool)
+
+Documentation
+*************
+
+* Add documentation on creating merges with more than one parent.
+  (Neil Martinsen-Burrell, #481526)
+
+* Better explain the --uncommitted option of merge.
+  (Neil Martinsen-Burrell, #505088)
+
+* Improve discussion of pending merges in the documentation for
+  ``revert``.  (Neil Martinsen-Burrell, #505093)
+
+* Improved help for ``bzr send``. 
+  (Martin Pool, Bojan Nikolic)
+
+* There is a System Administrator's Guide in ``doc/en/admin-guide``,
+  including discussions of installation, relevant plugins, security and 
+  backup. (Neil Martinsen-Burrell)
+
+* The ``conflicts`` help topic has been renamed to ``conflict-types``.
+  (Ian Clatworthy)
+
+* The User Reference is now presented as a series of topics.
+  Many of the included topics have link and format tweaks applied.
+  (Ian Clatworthy)
+
+API Changes
+***********
+
+* Added ``cachedproperty`` decorator to ``bzrlib.decorators``.
+  (Andrew Bennetts)
+
+* Many test features were renamed from ``FooFeature`` to ``foo_feature``
+  to be consistent with instances being lower case and classes being
+  CamelCase. For the features that were more likely to be used, we added a
+  deprecation thunk, but not all. (John Arbash Meinel)
+
+* Merger classes (such as ``Merge3Merger``) now expect a ``this_branch``
+  parameter in their constructors, and provide ``this_branch`` as an
+  attribute. (Andrew Bennetts)
+  
+* The Branch hooks pre_change_branch_tip no longer masks exceptions raised
+  by plugins - the original exceptions are now preserved. (Robert Collins)
+
+* The Transport ``Server.tearDown`` method is now renamed to
+  ``stop_server`` and ``setUp`` to ``start_server`` for consistency with
+  our normal naming pattern, and to avoid confusion with Python's
+  ``TestCase.tearDown``.  (Martin Pool)
+
+* ``WorkingTree.update`` implementations must now accept a ``revision``
+  parameter.
+
+Internals
+*********
+
+* Added ``BzrDir.open_branchV3`` smart server request, which can receive
+  a string of details (such as "location is a repository") as part of a
+  ``nobranch`` response.  (Andrew Bennetts, #440952)
+  
+* New helper osutils.UnicodeOrBytesToBytesWriter which encodes unicode
+  objects but passes str objects straight through. This is used for
+  selftest but may be useful for diff and other operations that generate
+  mixed output. (Robert Collins)
+
+* New exception ``NoRoundtrippingSupport``, for use by foreign branch 
+  plugins. (Jelmer Vernooij)
+
+Testing
+*******
+
+* ``bzrlib.tests.permute_for_extension`` is a helper that simplifies
+  running all tests in the current module, once against a pure python
+  implementation, and once against an extension (pyrex/C) implementation.
+  It can be used to dramatically simplify the implementation of
+  ``load_tests``.  (John Arbash Meinel)
+
+* ``bzrlib.tests.TestCase`` now subclasses ``testtools.testcase.TestCase``.
+  This permits features in testtools such as getUniqueInteger and
+  getUniqueString to be used. Because of this, testtools version 0.9.2 or
+  newer is now a dependency to run bzr selftest. Running with versions of
+  testtools less than 0.9.2 will cause bzr to error while loading the test
+  suite. (Robert Collins)
+
+* Shell-like tests now support the command "mv" for moving files.  The
+  syntax for ``mv file1 file2``, ``mv dir1 dir2`` and ``mv file dir`` is
+  supported.  (Neil Martinsen-Burrell)
+
+* The test progress bar no longer distinguishes tests that 'errored' from
+  tests that 'failed' - they're all just failures.
+  (Martin Pool)
+
+
+bzr 2.0.5 (not released yet)
+############################
 
 :Codename:
-:2.1.0b2: ???
+:2.0.5:
+
+Bug Fixes
+*********
+
+* Handle renames correctly when there are files or directories that 
+  differ only in case.  (Chris Jones, Martin Pool, #368931)
+
+* If ``bzr push --create-prefix`` triggers an unexpected ``NoSuchFile``
+  error, report that error rather than failing with an unhelpful
+  ``UnboundLocalError``.
+  (Andrew Bennetts, #423563)
+
+Documentation
+*************
+
+* Added ``location-alias`` help topic.
+  (Andrew Bennetts, #337834)
+
+bzr 2.0.4
+#########
+
+:Codename: smooth sailing
+:2.0.4: 2010-01-21
+
+The fourth bugfix-only release in the 2.0 series contains more than a
+dozen bugfixes relative to 2.0.3. The primary focus is on handling
+interruptions and concurrent operations more cleanly, there is also a fair
+improvement to ``bzr export`` when exporting a remote branch.
+
+
+Bug Fixes
+*********
+
+* ``bzr annotate`` on another branch with ``-r branch:...`` no longer
+  fails with an ``ObjectNotLocked`` error.  (Andrew Bennetts, #496590)
+
+* ``bzr export dir`` now requests all file content as a record stream,
+  rather than requsting the file content one file-at-a-time. This can make
+  exporting over the network significantly faster (54min => 9min in one
+  case). (John Arbash Meinel, #343218)
+
+* ``bzr serve`` no longer slowly leaks memory. The compiled
+  ``bzrlib.bencode.Encoder()`` class was using ``__del__`` to cleanup and
+  free resources, and it should have been using ``__dealloc__``.
+  This will likely have an impact on any other process that is serving for
+  an extended period of time.  (John Arbash Meinel, #494406)
+
+* Check for SIGINT (Ctrl-C) and other signals immediately if ``readdir``
+  returns ``EINTR`` by calling ``PyErr_CheckSignals``.  This affected the
+  optional ``_readdir_pyx`` extension.  (Andrew Bennetts, #495023)
+
+* Concurrent autopacks will no longer lose a newly created pack file.
+  There was a race condition, where if the reload happened at the right
+  time, the second packer would forget the name of the newly added pack
+  file. (John Arbash Meinel, Gareth White, #507566)
+
+* Give a clearer message if the lockdir disappears after being apparently
+  successfully taken.  (Martin Pool, #498378)
+
+* Give a warning when fetching between repositories (local or remote) with
+  sufficiently different formats that the content will need to be
+  serialized (ie ``InterDifferingSerializer`` or ``inventory-deltas``), so
+  the user has a clue that upgrading could make it faster.
+  (Martin Pool, #456077)
+
+* If we fail to open ``~/.bzr.log`` write a clear message to stderr rather
+  than using ``warning()``. The log file is opened before logging is set
+  up, and it leads to very confusing: 'no handlers for "bzr"' messages for
+  users, rather than something nicer.
+  (John Arbash Meinel, Barry Warsaw, #503886)
+
+* Refuse to build with any Pyrex 0.9.4 release, as they have known bugs.
+  (Martin Pool, John Arbash Meinel, #449372)
+
+* ``setup.py bdist_rpm`` now properly finds extra files needed for the
+  build. (there is still the distutils bug
+  http://bugs.python.org/issue644744) (Joe Julian, #175839)
+
+* The 2a format wasn't properly restarting autopacks when something
+  changed underneath it (like another autopack). Now concurrent
+  autopackers will properly succeed. (John Arbash Meinel, #495000)
+
+* ``TreeTransform`` can now handle when a delta says that the file id for
+  the tree root changes. Rather than trying to rename your working
+  directory, or failing early saying that you can't have multiple
+  tree roots. This also fixes revert, update, and pull when the root id
+  changes.  (John Arbash Meinel, #494269, #504390)
+
+* ``_update_current_block`` no longer suppresses exceptions, so ^C at just
+  the right time will get propagated, rather than silently failing to move
+  the block pointer. (John Arbash Meinel, Gareth White, #495023)
+
+Testing
+*******
+
+* We have a new ``test_source`` that ensures all pyrex ``cdef`` functions
+  handle exceptions somehow. (Possibly by setting ``# cannot_raise``
+  rather than an ``except ?:`` clause.) This should help prevent bugs like
+  bug #495023. (John Arbash Meinel)
+
+
+bzr 2.1.0b4
+###########
+
+:Codename: san francisco airport
+:2.1.0b4: 2009-12-14
+
+The fourth beta release in the 2.1 series brings with it a significant
+number of bugfixes (~20). The test suite is once again (finally) "green"
+on Windows, and should remain that way for future releases. There are a
+few performance related updates (faster upgrade and log), and several UI
+tweaks. There has also been a significant number of tweaks to the runtime
+documentation. 2.1.0b4 include everything from the 2.0.3 release.
 
 
 Compatibility Breaks
 ********************
 
-New Features
-************
+* The BZR_SSH environmental variable may now be set to the path of a secure
+  shell client. If currently set to the value ``ssh`` it will now guess the
+  vendor of the program with that name, to restore the old behaviour that
+  indicated the SSH Corporation client use ``sshcorp`` instead as the magic
+  string. (Martin <gzlist@googlemail.com>, #176292)
+
+New Features
+************
+
+* ``bzr commit`` now has a ``--commit-time`` option.
+  (Alexander Sack, #459276)
+
+* ``-Dhpss`` now increases logging done when run on the bzr server,
+  similarly to how it works on the client. (John Arbash Meinel)
+
+* New option ``bzr unshelve --keep`` applies the changes and leaves them
+  on the shelf.  (Martin Pool, Oscar Fuentes, #492091)
+
+* The ``BZR_COLUMNS`` envrionment variable can be set to force bzr to
+  respect a given terminal width. This can be useful when output is
+  redirected or in obscure cases where the default value is not
+  appropriate. Pagers can use it to get a better control of the line
+  lengths. 
+  (Vincent Ladeuil)
+
+* The new command ``bzr lp-mirror`` will request that Launchpad update its
+  mirror of a local branch. This command will only function if launchpadlib
+  is installed.
+  (Jonathan Lange)
+
+
+Bug Fixes
+*********
+
+* After renaming a file, the dirstate could accidentally reference
+  ``source\\path`` rather than ``source/path`` on Windows. This might be a
+  source of some dirstate-related failures. (John Arbash Meinel)
+
+* ``bzr commit`` now detects commit messages that looks like file names
+  and issues a warning.
+  (Gioele Barabucci, #73073)
+
+* ``bzr ignore /`` no longer causes an IndexError. (Gorder Tyler, #456036)
+
+* ``bzr log -n0 -rN`` should not return revisions beyond its merged revisions.
+  (#325618, #484109, Marius Kruger)
+
+* ``bzr merge --weave`` and ``--lca`` will now create ``.BASE`` files for
+  files with conflicts (similar to ``--merge3``). The contents of the file
+  is a synthesis of all bases used for the merge.
+  (John Arbash Meinel, #40412)
+
+* ``bzr mv --quiet`` really is quiet now.  (Gordon Tyler, #271790)
+
+* ``bzr serve`` is more clear about the risk of supplying --allow-writes.
+  (Robert Collins, #84659)
+
+* ``bzr serve --quiet`` really is quiet now.  (Gordon Tyler, #252834)
+
+* Fix bug with redirected URLs over authenticated HTTP.
+  (Glen Mailer, Neil Martinsen-Burrell, Vincent Ladeuil, #395714)
+
+* Interactive merge doesn't leave branch locks behind.  (Aaron Bentley)
+
+* Lots of bugfixes for the test suite on Windows. We should once again
+  have a test suite with no failures on Windows. (John Arbash Meinel)
+
+* ``osutils.terminal_width()`` obeys the BZR_COLUMNS environment
+  variable but returns None if the terminal is not a tty (when output is
+  redirected for example). Also fixes its usage under OSes that doesn't
+  provide termios.TIOCGWINSZ. Make sure the corresponding tests runs on
+  windows too.
+  (Joke de Buhr, Vincent Ladeuil, #353370, #62539)
+  (John Arbash Meinel, Vincent Ladeuil, #492561)
+
+* Terminate ssh subprocesses when no references to them remain, fixing
+  subprocess and file descriptor leaks.  (Andrew Bennetts, #426662)
+  
+* The ``--hardlink`` option of ``bzr branch`` and ``bzr checkout`` now
+  works for 2a format trees.  Only files unaffected by content filters
+  will be hardlinked.  (Andrew Bennetts, #408193)
+
+* The new glob expansion on Windows would replace all ``\`` characters
+  with ``/`` even if it there wasn't a glob to expand, the arg was quoted,
+  etc. Now only change slashes if there is something being glob expanded.
+  (John Arbash Meinel, #485771)
+
+* Use our faster ``KnownGraph.heads()`` functionality when computing the
+  new rich-root heads. This can cut a conversion time in half (mysql from
+  13.5h => 6.2h) (John Arbash Meinel, #487632)
+
+* When launching a external diff tool via bzr diff --using, temporary files
+  are no longer created, rather, the path to the file in the working tree is
+  passed to the external diff tool. This allows the file to be edited if the
+  diff tool provides for this. (Gary van der Merwe, #490738)
+  
+* The launchpad-open command can now be used from a subdirectory of a
+  branch, not just from the root of the branch. 
+  (Neil Martinsen-Burrell, #489102)
+
+
+Improvements
+************
+
+* ``bzr log`` is now faster. (Ian Clatworthy)
+
+* ``bzr update`` provides feedback on which branch it is up to date with.
+  (Neil Martinsen-Burrell)
+
+* ``bzr upgrade`` from pre-2a to 2a can be significantly faster (4x).
+  For details see the xml8 patch and heads() improvements.
+  (John Arbash Meinel)
+
+* ``bzrlib.urlutils.local_path_from_url`` now accepts
+  'file://localhost/' as well as 'file:///' URLs on POSIX.  (Michael
+  Hudson)
+
+* The progress bar now shows only a spinner and per-operation counts,
+  not an overall progress bar.  The previous bar was often not correlated
+  with real overall operation progress, either because the operations take
+  nonlinear time, or because at the start of the operation Bazaar couldn't
+  estimate how much work there was to do.  (Martin Pool)
+
+Documentation
+*************
+
+* Lots of documentation tweaks for inline help topics and command help
+  information.
+
+API Changes
+***********
+
+* ``bzrlib.textui`` (vestigial module) removed.  (Martin Pool)
+
+* The Launchpad plugin now has a function ``login`` which will log in to
+  Launchpad with launchpadlib, and ``load_branch`` which will return the
+  Launchpad Branch object corresponding to a given Bazaar Branch object.
+  (Jonathan Lange)
+
+Internals
+*********
+
+* New test Feature: ``ModuleAvailableFeature``. It is designed to make it
+  easier to handle what tests you want to run based on what modules can be
+  imported. (Rather than lots of custom-implemented features that were
+  basically copy-and-pasted.) (John Arbash Meinel)
+
+* ``osutils.timer_func()`` can be used to get either ``time.time()`` or
+  ``time.clock()`` when you want to do performance timing.
+  ``time.time()`` is limited to 15ms resolution on Windows, but
+  ``time.clock()`` gives CPU and not wall-clock time on other platforms.
+  (John Arbash Meinel)
+
+* Several code paths that were calling ``Transport.get().read()`` have
+  been changed to the equalivent ``Transport.get_bytes()``. The main
+  difference is that the latter will explicitly call ``file.close()``,
+  rather than expecting the garbage collector to handle it. This helps
+  with some race conditions on Windows during the test suite and sftp
+  tests. (John Arbash Meinel)
+
+Testing
+*******
+
+* TestCaseWithMemoryTransport no longer sets $HOME and $BZR_HOME to
+  unicode strings. (Michael Hudson, #464174)
+
+
+bzr 2.0.3
+#########
+
+:Codename: little italy
+:2.0.3: 2009-12-14
+
+
+The third stable release of Bazaar has a small handful of bugfixes. As
+expected, this has no internal or external compatibility changes versus
+2.0.2 (or 2.0.0).
+
+Bug Fixes
+*********
+
+* ``bzr push --use-existing-dir`` no longer crashes if the directory
+  exists but contains an invalid ``.bzr`` directory.
+  (Andrew Bennetts, #423563)
+
+* Content filters are now applied correctly after pull, merge and switch.
+  (Ian Clatworthy, #385879)
+
+* Fix a potential segfault in the groupcompress hash map handling code.
+  When inserting new entries, if the final hash bucket was empty, we could
+  end up trying to access if ``(last_entry+1)->ptr == NULL``.
+  (John Arbash Meinel, #490228)
+
+* Improve "Binary files differ" hunk handling.  (Aaron Bentley, #436325)
+
+
+bzr 2.1.0b3
+###########
+
+:Codename: after sprint recovery
+:2.1.0b3: 2009-11-16
+
+This release was pushed up from its normal release cycle due to a
+regression in python 2.4 compatibility in 2.1.0b2.  Since this regression
+was caught before 2.1.0b2 was officially announced, the full changelog
+includes both 2.1.0b3 and 2.1.0b2 changes.
+
+Highlights of 2.1.0b3 are: new globbing code for all commands on Windows,
+the test suite now conforms to python's trunk enhanced semantics (skip,
+etc.), and ``bzr info -v`` will now report the correct branch and repo
+formats for Remote objects.
+
+
+New Features
+************
+
+* Users can define a shelve editor to provide shelf functionality at a
+  granularity finer than per-patch-hunk. (Aaron Bentley)
+
+Bug Fixes
+*********
+
+* Fix for shell completion and short options.  (Benoît PIERRE)
+
+* Hooks daughter classes should always call the base constructor.
+  (Alexander Belchenko, Vincent Ladeuil, #389648) 
+
+* Improve "Binary files differ" hunk handling.  (Aaron Bentley, #436325)
+
+* On Windows, do glob expansion at the command-line level (as is usually
+  done in bash, etc.) This means that *all* commands get glob expansion
+  (bzr status, bzr add, bzr mv, etc). It uses a custom command line
+  parser, which allows us to know if a given section was quoted. It means
+  you can now do ``bzr ignore "*.py"``.
+  (John Arbash Meinel, #425510, #426410, #194450)
+
+* Sanitize commit messages that come in from the '-m' flag. We translate
+  '\r\n' => '\n' and a plain '\r' => '\n'. The storage layer doesn't
+  allow those because XML store silently translate it anyway. (The parser
+  auto-translates \r\n => \n in ways that are hard for us to catch.)
+
+* Show correct branch and repository format descriptions in 
+  ``bzr info -v`` on a smart server location.  (Andrew Bennetts, #196080)
+
+* The fix for bug #186920 accidentally broke compatibility with python
+  2.4.  (Vincent Ladeuil, #475585)
+
+* Using ``Repository.get_commit_builder().record_iter_changes()`` now
+  correctly sets ``self.inv_sha1`` to a sha1 string and
+  ``self.new_inventory`` to an Inventory instance after calling
+  ``self.finish_inventory()``. (Previously it accidently set both values
+  as a tuple on ``self.inv_sha1``. This was missed because
+  ``repo.add_revision`` ignores the supplied inventory sha1 and recomputes
+  the sha1 from the repo directly. (John Arbash Meinel)
+
+* Shelve command refuse to run if there is no real terminal.
+  (Alexander Belchenko)
+
+* Avoid unnecessarily flushing of trace file; it's now unbuffered at the
+  Python level.  (Martin Pool)
+
+Documentation
+*************
+
+* Include Japanese translations for documentation (Inada Naoki)
+
+* New API ``ui_factory.make_output_stream`` to be used for sending bulk
+  (rather than user-interaction) data to stdout.  This automatically
+  coordinates with progress bars or other terminal activity, and can be
+  overridden by GUIs.
+  (Martin Pool, 493944)
+
+Internals
+*********
+
+* Some of the core groupcompress functionality now releases the GIL before
+  operation. Similar to how zlib and bz2 operate without the GIL in the
+  core compression and decompression routines. (John Arbash Meinel)
+
+Testing
+*******
+
+* -Dhpssvfs will now trigger on ``RemoteBzrDir._ensure_real``, providing
+  more debugging of VFS access triggers. (Robert Collins)
+
+* KnownFailure is now signalled to ``ExtendedTestResult`` using the same
+  method that Python 2.7 uses - ``addExpectedFailure``. (Robert Collins)
+
+* ``--parallel=fork`` is now compatible with --subunit.
+  (Robert Collins, Vincent Ladeuil, #419776)
+
+* Reporting of failures shows test ids not descriptions and thus shows
+  parameterised tests correctly. (Robert Collins)
+
+* TestNotApplicable is now handled within the TestCase.run method rather
+  than being looked for within ``ExtendedTestResult.addError``. This
+  provides better handling with other ``TestResult`` objects, degrading to
+  sucess rather than error. (Robert Collins)
+
+* The private method ``_testConcluded`` on ``ExtendedTestResult`` has been
+  removed - it was empty and unused. (Robert Collins)
+
+* UnavailableFeature is now handled within the TestCase.run method rather
+  than being looked for within addError. If the Result object does not
+  have an addNotSupported method, addSkip is attempted instead, and
+  failing that addSuccess. (Robert Collins)
+
+* When a TestResult does not have an addSkip method, skipped tests are now
+  reported as successful tests, rather than as errors. This change is
+  to make it possible to get a clean test run with a less capable
+  TestResult. (Robert Collins)
+
+
+
+bzr 2.1.0b2
+###########
+
+:Codename: a load off my mind
+:2.1.0b2: 2009-11-02
+
+This is our second feature-filled release since 2.0, pushing us down the
+path to a 2.1.0. Once again, all bugfixes in 2.0.2 are present in 2.1.0b2.
+
+Key highlights in this release are: improved handling of
+failures-during-cleanup for commit, fixing a long-standing bug with
+``bzr+http`` and shared repositories, all ``lp:`` urls to be resolved
+behind proxies, and a new StaticTuple datatype, allowing us to reduce
+memory consumption (50%) and garbage collector overhead (40% faster) for
+many operations.
+
+* A new ``--concurrency`` option has been added as well as an associated
+  BZR_CONCURRENCY environment variable to specify the number of
+  processes that can be run concurrently when running ``bzr selftest``. The
+  command-line option overrides the environment variable if both are
+  specified. If none is specified. the number of processes is obtained
+  from the OS as before.  (Matt Nordhoff, Vincent Ladeuil)
 
 Bug Fixes
 *********
@@ -25,9 +808,25 @@
 * ``bzr+http`` servers no longer give spurious jail break errors when
   serving branches inside a shared repository.  (Andrew Bennetts, #348308)
 
+* Errors during commit are handled more robustly so that knock-on errors
+  are less likely to occur, and will not obscure the original error if
+  they do occur.  This fixes some causes of ``TooManyConcurrentRequests``
+  and similar errors.  (Andrew Bennetts, #429747, #243391)
+
+* Launchpad urls can now be resolved from behind proxies.
+  (Gordon Tyler, Vincent Ladeuil, #186920)
+
+* Reduce the strictness for StaticTuple, instead add a debug flag
+  ``-Dstatic_tuple`` which will change apis to be strict and raise errors.
+  This way, most users won't see failures, but developers can improve
+  internals. (John Arbash Meinel, #471193)
+
 * TreeTransform.adjust_path updates the limbo paths of descendants of adjusted
   files.  (Aaron Bentley)
 
+* Unicode paths are now handled correctly and consistently by the smart
+  server.  (Andrew Bennetts, Michael Hudson, #458762)
+
 Improvements
 ************
 
@@ -37,11 +836,15 @@
   (John Arbash Meinel)
 
 * Peak memory under certain operations has been reduced significantly.
+  (eg, 'bzr branch launchpad standalone' is cut in half)
   (John Arbash Meinel)
 
 Documentation
 *************
 
+* Filtered views user documentation upgraded to refer to format 2a
+  instead of pre-2.0 formats. (Ian Clatworthy)
+
 API Changes
 ***********
 
@@ -62,14 +865,14 @@
   (John Arbash Meinel)
 
 * ``bzrlib._static_tuple_c.StaticTuple`` is now available and used by
-  the btree index parser. This class functions similarly to ``tuple``
-  objects. However, it can only point to a limited collection of types.
-  (Currently StaticTuple, str, unicode, None, bool, int, long, float, and
-  not subclasses).  This allows us to remove it from the garbage collector
-  (it cannot be in a cycle), it also allows us to intern the objects. In
-  testing, this can reduce peak memory by 20-40%, and significantly
-  improve performance by removing objects from being inspected by the
-  garbage collector.  (John Arbash Meinel)
+  the btree index parser and the chk map parser. This class functions
+  similarly to ``tuple`` objects. However, it can only point to a limited
+  collection of types.  (Currently StaticTuple, str, unicode, None, bool,
+  int, long, float, but not subclasses).  This allows us to remove it from
+  the garbage collector (it cannot be in a cycle), it also allows us to
+  intern the objects. In testing, this can reduce peak memory by 20-40%,
+  and significantly improve performance by removing objects from being
+  inspected by the garbage collector.  (John Arbash Meinel)
 
 * ``GroupCompressBlock._ensure_content()`` will now release the
   ``zlib.decompressobj()`` when the first request is for all of the
@@ -85,21 +888,15 @@
   peak memory for initial copies (~200MB). (John Arbash Meinel)
 
 
-Testing
-*******
-
-
-bzr 2.0.2 (not released yet)
-############################
-
-:Codename:
-:2.0.2: ???
-
-Compatibility Breaks
-********************
-
-New Features
-************
+bzr 2.0.2
+#########
+
+:Codename: after the scare
+:2.0.2: 2009-11-02
+
+The second in our "let's keep the stable bugfixes flowing" series. As
+expected this has a few (~9) bugfixes relative to 2.0.1, and no major api
+changes or features.
 
 Bug Fixes
 *********
@@ -107,20 +904,35 @@
 * Avoid "NoneType has no attribute st_mode" error when files disappear
   from a directory while it's being read.  (Martin Pool, #446033)
 
+* Content filters are now applied correctly after revert.
+  (Ian Clatworthy)
+
+* Diff parsing handles "Binary files differ" hunks.  (Aaron Bentley, #436325)
+
+* Fetching from stacked pre-2a repository via a smart server no longer
+  fails intermittently with "second push failed to complete".
+  (Andrew Bennetts, #437626)
+
+* Fix typos left after test_selftest refactoring.
+  (Vincent Ladeuil, Matt Nordhoff, #461149)
+
+* Fixed ``ObjectNotLocked`` errors during ``bzr log -r NNN somefile``.
+  (Andrew Bennetts, #445171)
+  
+* PreviewTree file names are not limited by the encoding of the temp
+  directory's filesystem. (Aaron Bentley, #436794)
+
 Improvements
 ************
 
+* ``bzr log`` now read-locks branches exactly once, so makes better use of
+  data caches.  (Andrew Bennetts)
+
 Documentation
 *************
 
-API Changes
-***********
-
-Internals
-*********
-
-Testing
-*******
+* Filtered views user documentation upgraded to refer to format 2a
+  instead of pre-2.0 formats. (Ian Clatworthy)
 
 
 bzr 2.1.0b1
@@ -229,6 +1041,10 @@
 Improvements
 ************
 
+* Revision specifiers can now be given in a more DWIM form, without
+  needing explicit prefixes for specifiers like tags or revision id's.
+  See ``bzr help revisionspec`` for full details.  (Matthew Fuller)
+
 * Bazaar gives a warning before exiting, and writes into ``.bzr.log``, if 
   compiled extensions can't be loaded.  This typically indicates a
   packaging or installation problem.  In this case Bazaar will keep
@@ -607,7 +1423,7 @@
 * ``bzr shelve`` and ``bzr unshelve`` now work on windows.
   (Robert Collins, #305006)
 
-* Commit of specific files no longer prevents using the the iter_changes
+* Commit of specific files no longer prevents using the iter_changes
   codepath. On 2a repositories, commit of specific files should now be as
   fast, or slightly faster, than a full commit. (Robert Collins)
 
@@ -1376,7 +2192,7 @@
 ************
 
 * A new repository format ``2a`` has been added.  This is a beta release
-  of the the brisbane-core (aka group-compress) project.  This format now
+  of the brisbane-core (aka group-compress) project.  This format now
   suitable for wider testing by advanced users willing to deal with some
   bugs.  We would appreciate test reports, either positive or negative.
   Format 2a is substantially smaller and faster for many operations on
@@ -2105,7 +2921,7 @@
 
 * Added ``bzrlib.inventory_delta`` module.  This will be used for
   serializing and deserializing inventory deltas for more efficient
-  streaming on the the network.  (Robert Collins, Andrew Bennetts)
+  streaming on the network.  (Robert Collins, Andrew Bennetts)
 
 * ``Branch._get_config`` has been added, which splits out access to the
   specific config file from the branch. This is used to let RemoteBranch
@@ -2300,7 +3116,7 @@
 * Multiple authors for a commit can now be recorded by using the "--author"
   option multiple times. (James Westby, #185772)
 
-* New clean-tree command, from bzrtools.  (Aaron Bentley, Jelmer Vernoij)
+* New clean-tree command, from bzrtools.  (Aaron Bentley, Jelmer Vernooij)
 
 * New command ``bzr launchpad-open`` opens a Launchpad web page for that
   branch in your web browser, as long as the branch is on Launchpad at all.
@@ -4829,7 +5645,7 @@
   exception. (Andrew Bennetts)
 
 * New ``--debugflag``/``-E`` option to ``bzr selftest`` for setting
-  options for debugging tests, these are complementary to the the -D
+  options for debugging tests, these are complementary to the -D
   options.  The ``-Dselftest_debug`` global option has been replaced by the
   ``-E=allow_debug`` option for selftest. (Andrew Bennetts)
 

=== added file 'README_BDIST_RPM'
--- README_BDIST_RPM	1970-01-01 00:00:00 +0000
+++ README_BDIST_RPM	2010-01-10 02:25:31 +0000
@@ -0,0 +1,8 @@
+There is a bug in disttools for distributions who's rpmbuild compresses 
+the man pages. This causes an error building the final packages as it's 
+expecting bzr.1 and not finding it, but finding bzr.1.gz that's unpackaged.
+
+This bug is known to affect Fedora, RHEL, and Centos distributions.
+
+There is a preliminary patch at http://bugs.python.org/issue644744 that
+fixes this issue with disttools.

=== modified file 'bzr'
--- bzr	2009-10-15 04:06:32 +0000
+++ bzr	2010-02-17 05:58:10 +0000
@@ -23,7 +23,7 @@
 import warnings
 
 # update this on each release
-_script_version = (2, 1, 0)
+_script_version = (2, 1, 1)
 
 if __doc__ is None:
     print "bzr does not support python -OO."

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2009-10-15 04:06:32 +0000
+++ bzrlib/__init__.py	2010-02-17 05:58:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -44,7 +44,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 1, 0, 'dev', 2)
+version_info = (2, 1, 1, 'dev', 0)
 
 # API compatibility version: bzrlib is currently API compatible with 1.15.
 api_minimum_version = (2, 1, 0)

=== modified file 'bzrlib/_annotator_pyx.pyx'
--- bzrlib/_annotator_pyx.pyx	2009-07-08 17:09:03 +0000
+++ bzrlib/_annotator_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -83,7 +83,14 @@
     return 0
 
 
-cdef PyObject *_next_tuple_entry(object tpl, Py_ssize_t *pos):
+cdef PyObject *_next_tuple_entry(object tpl, Py_ssize_t *pos): # cannot_raise
+    """Return the next entry from this tuple.
+
+    :param tpl: The tuple we are investigating, *must* be a PyTuple
+    :param pos: The last item we found. Will be updated to the new position.
+    
+    This cannot raise an exception, as it does no error checking.
+    """
     pos[0] = pos[0] + 1
     if pos[0] >= PyTuple_GET_SIZE(tpl):
         return NULL

=== modified file 'bzrlib/_bencode_pyx.pyx'
--- bzrlib/_bencode_pyx.pyx	2009-10-15 18:28:14 +0000
+++ bzrlib/_bencode_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007,2009 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -268,7 +268,7 @@
         self.maxsize = maxsize
         self.tail = p
 
-    def __del__(self):
+    def __dealloc__(self):
         free(self.buffer)
         self.buffer = NULL
         self.maxsize = 0

=== modified file 'bzrlib/_btree_serializer_py.py'
--- bzrlib/_btree_serializer_py.py	2009-03-23 14:59:43 +0000
+++ bzrlib/_btree_serializer_py.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,27 +17,33 @@
 
 """B+Tree index parsing."""
 
+from bzrlib import static_tuple
+
+
 def _parse_leaf_lines(bytes, key_length, ref_list_length):
     lines = bytes.split('\n')
     nodes = []
+    as_st = static_tuple.StaticTuple.from_sequence
+    stuple = static_tuple.StaticTuple
     for line in lines[1:]:
         if line == '':
             return nodes
         elements = line.split('\0', key_length)
         # keys are tuples
-        key = tuple(elements[:key_length])
+        key = as_st(elements[:key_length]).intern()
         line = elements[-1]
         references, value = line.rsplit('\0', 1)
         if ref_list_length:
             ref_lists = []
             for ref_string in references.split('\t'):
-                ref_lists.append(tuple([
-                    tuple(ref.split('\0')) for ref in ref_string.split('\r') if ref
-                    ]))
-            ref_lists = tuple(ref_lists)
-            node_value = (value, ref_lists)
+                ref_list = as_st([as_st(ref.split('\0')).intern()
+                                  for ref in ref_string.split('\r') if ref])
+                ref_lists.append(ref_list)
+            ref_lists = as_st(ref_lists)
+            node_value = stuple(value, ref_lists)
         else:
-            node_value = (value, ())
+            node_value = stuple(value, stuple())
+        # No need for StaticTuple here as it is put into a dict
         nodes.append((key, node_value))
     return nodes
 

=== modified file 'bzrlib/_btree_serializer_pyx.pyx'
--- bzrlib/_btree_serializer_pyx.pyx	2009-10-12 20:07:09 +0000
+++ bzrlib/_btree_serializer_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -65,7 +65,7 @@
 
 
 # TODO: Find some way to import this from _dirstate_helpers
-cdef void* _my_memrchr(void *s, int c, size_t n):
+cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     # It is not present in any win32 standard library
     cdef char *pos

=== modified file 'bzrlib/_chk_map_py.py'
--- bzrlib/_chk_map_py.py	2009-10-08 04:35:01 +0000
+++ bzrlib/_chk_map_py.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,6 +19,8 @@
 import zlib
 import struct
 
+from bzrlib.static_tuple import StaticTuple
+
 _LeafNode = None
 _InternalNode = None
 _unknown = None
@@ -93,7 +95,7 @@
         value_lines = lines[pos:pos+num_value_lines]
         pos += num_value_lines
         value = '\n'.join(value_lines)
-        items[tuple(elements[:-1])] = value
+        items[StaticTuple.from_sequence(elements[:-1])] = value
     if len(items) != length:
         raise AssertionError("item count (%d) mismatch for key %s,"
             " bytes %r" % (length, key, bytes))
@@ -141,7 +143,7 @@
     for line in lines[5:]:
         line = common_prefix + line
         prefix, flat_key = line.rsplit('\x00', 1)
-        items[prefix] = (flat_key,)
+        items[prefix] = StaticTuple(flat_key,)
     if len(items) == 0:
         raise AssertionError("We didn't find any item for %s" % key)
     result._items = items
@@ -155,4 +157,3 @@
     result._node_width = len(prefix)
     result._search_prefix = common_prefix
     return result
-

=== modified file 'bzrlib/_chk_map_pyx.pyx'
--- bzrlib/_chk_map_pyx.pyx	2009-10-08 04:35:01 +0000
+++ bzrlib/_chk_map_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,9 +29,8 @@
 
 cdef extern from "Python.h":
     ctypedef int Py_ssize_t # Required for older pyrex versions
-    struct _PyObject:
+    ctypedef struct PyObject:
         pass
-    ctypedef _PyObject PyObject
     int PyTuple_CheckExact(object p)
     Py_ssize_t PyTuple_GET_SIZE(object t)
     int PyString_CheckExact(object)
@@ -52,6 +51,18 @@
     char *PyString_AS_STRING_ptr "PyString_AS_STRING" (PyObject *s)
     object PyString_FromStringAndSize(char*, Py_ssize_t)
 
+# cimport all of the definitions we will need to access
+from _static_tuple_c cimport StaticTuple,\
+    import_static_tuple_c, StaticTuple_New, \
+    StaticTuple_Intern, StaticTuple_SET_ITEM, StaticTuple_CheckExact
+
+cdef extern from "_static_tuple_c.h":
+    # Defined explicitly rather than cimport-ing. Trying to use cimport, the
+    # type for PyObject is a different class that happens to have the same
+    # name...
+    PyObject * StaticTuple_GET_ITEM_ptr "StaticTuple_GET_ITEM" (StaticTuple,
+                                                                Py_ssize_t)
+
 cdef extern from "zlib.h":
     ctypedef unsigned long uLong
     ctypedef unsigned int uInt
@@ -60,12 +71,18 @@
     uLong crc32(uLong crc, Bytef *buf, uInt len)
 
 
+# Set up the StaticTuple C_API functionality
+import_static_tuple_c()
+
+cdef object _LeafNode
 _LeafNode = None
+cdef object _InternalNode
 _InternalNode = None
+cdef object _unknown
 _unknown = None
 
 # We shouldn't just copy this from _dirstate_helpers_pyx
-cdef void* _my_memrchr(void *s, int c, size_t n):
+cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     cdef char *pos
     cdef char *start
@@ -91,9 +108,9 @@
     cdef char *c_out
     cdef PyObject *bit
 
-    if not PyTuple_CheckExact(key):
-        raise TypeError('key %r is not a tuple' % (key,))
-    num_bits = PyTuple_GET_SIZE(key)
+    if not StaticTuple_CheckExact(key):
+        raise TypeError('key %r is not a StaticTuple' % (key,))
+    num_bits = len(key)
     # 4 bytes per crc32, and another 1 byte between bits
     num_out_bytes = (9 * num_bits) - 1
     out = PyString_FromStringAndSize(NULL, num_out_bytes)
@@ -105,7 +122,7 @@
         # We use the _ptr variant, because GET_ITEM returns a borrowed
         # reference, and Pyrex assumes that returned 'object' are a new
         # reference
-        bit = PyTuple_GET_ITEM_ptr(key, i)
+        bit = StaticTuple_GET_ITEM_ptr(key, i)
         if not PyString_CheckExact_ptr(bit):
             raise TypeError('Bit %d of %r is not a string' % (i, key))
         c_bit = <Bytef *>PyString_AS_STRING_ptr(bit)
@@ -129,9 +146,9 @@
     cdef char *c_out
     cdef PyObject *bit
 
-    if not PyTuple_CheckExact(key):
-        raise TypeError('key %r is not a tuple' % (key,))
-    num_bits = PyTuple_GET_SIZE(key)
+    if not StaticTuple_CheckExact(key):
+        raise TypeError('key %r is not a StaticTuple' % (key,))
+    num_bits = len(key)
     # 4 bytes per crc32, and another 1 byte between bits
     num_out_bytes = (5 * num_bits) - 1
     out = PyString_FromStringAndSize(NULL, num_out_bytes)
@@ -140,10 +157,10 @@
         if i > 0:
             c_out[0] = c'\x00'
             c_out = c_out + 1
-        bit = PyTuple_GET_ITEM_ptr(key, i)
+        bit = StaticTuple_GET_ITEM_ptr(key, i)
         if not PyString_CheckExact_ptr(bit):
-            raise TypeError('Bit %d of %r is not a string: %r' % (i, key,
-            <object>bit))
+            raise TypeError('Bit %d of %r is not a string: %r'
+                            % (i, key, <object>bit))
         c_bit = <Bytef *>PyString_AS_STRING_ptr(bit)
         c_len = PyString_GET_SIZE_ptr(bit)
         crc_val = crc32(0, c_bit, c_len)
@@ -195,6 +212,7 @@
     cdef char *prefix, *value_start, *prefix_tail
     cdef char *next_null, *last_null, *line_start
     cdef char *c_entry, *entry_start
+    cdef StaticTuple entry_bits
 
     if _LeafNode is None:
         from bzrlib import chk_map
@@ -265,12 +283,14 @@
             if next_line == NULL:
                 raise ValueError('missing trailing newline')
             cur = next_line + 1
-        entry_bits = PyTuple_New(width)
+        entry_bits = StaticTuple_New(width)
         for i from 0 <= i < num_prefix_bits:
+            # TODO: Use PyList_GetItem, or turn prefix_bits into a
+            #       tuple/StaticTuple
             entry = prefix_bits[i]
             # SET_ITEM 'steals' a reference
             Py_INCREF(entry)
-            PyTuple_SET_ITEM(entry_bits, i, entry)
+            StaticTuple_SET_ITEM(entry_bits, i, entry)
         value = PyString_FromStringAndSize(value_start, next_line - value_start)
         # The next entry bit needs the 'tail' from the prefix, and first part
         # of the line
@@ -288,7 +308,7 @@
             memcpy(c_entry + prefix_tail_len, line_start, next_null - line_start)
         Py_INCREF(entry)
         i = num_prefix_bits
-        PyTuple_SET_ITEM(entry_bits, i, entry)
+        StaticTuple_SET_ITEM(entry_bits, i, entry)
         while next_null != last_null: # We have remaining bits
             i = i + 1
             if i > width:
@@ -301,11 +321,12 @@
             entry = PyString_FromStringAndSize(entry_start,
                                                next_null - entry_start)
             Py_INCREF(entry)
-            PyTuple_SET_ITEM(entry_bits, i, entry)
+            StaticTuple_SET_ITEM(entry_bits, i, entry)
         if len(entry_bits) != width:
             raise AssertionError(
                 'Incorrect number of elements (%d vs %d)'
                 % (len(entry_bits)+1, width + 1))
+        entry_bits = StaticTuple_Intern(entry_bits)
         PyDict_SetItem(items, entry_bits, value)
     if len(items) != length:
         raise ValueError("item count (%d) mismatch for key %s,"
@@ -343,6 +364,8 @@
         _unknown = chk_map._unknown
     result = _InternalNode(search_key_func=search_key_func)
 
+    if not StaticTuple_CheckExact(key):
+        raise TypeError('key %r is not a StaticTuple' % (key,))
     if not PyString_CheckExact(bytes):
         raise TypeError('bytes must be a plain string not %s' % (type(bytes),))
 
@@ -384,7 +407,8 @@
         memcpy(c_item_prefix + prefix_length, cur, next_null - cur)
         flat_key = PyString_FromStringAndSize(next_null + 1,
                                               next_line - next_null - 1)
-        PyDict_SetItem(items, item_prefix, (flat_key,))
+        flat_key = StaticTuple(flat_key).intern()
+        PyDict_SetItem(items, item_prefix, flat_key)
         cur = next_line + 1
     assert len(items) > 0
     result._items = items
@@ -398,4 +422,3 @@
     result._node_width = len(item_prefix)
     result._search_prefix = PyString_FromStringAndSize(prefix, prefix_length)
     return result
-

=== modified file 'bzrlib/_dirstate_helpers_pyx.pyx'
--- bzrlib/_dirstate_helpers_pyx.pyx	2009-10-02 05:43:41 +0000
+++ bzrlib/_dirstate_helpers_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -119,7 +119,7 @@
     # void *memrchr(void *s, int c, size_t len)
 
 
-cdef void* _my_memrchr(void *s, int c, size_t n):
+cdef void* _my_memrchr(void *s, int c, size_t n): # cannot_raise
     # memrchr seems to be a GNU extension, so we have to implement it ourselves
     cdef char *pos
     cdef char *start
@@ -165,7 +165,7 @@
     return PyString_FromStringAndSize(s, size)
 
 
-cdef int _is_aligned(void *ptr):
+cdef int _is_aligned(void *ptr): # cannot_raise
     """Is this pointer aligned to an integer size offset?
 
     :return: 1 if this pointer is aligned, 0 otherwise.
@@ -173,7 +173,7 @@
     return ((<intptr_t>ptr) & ((sizeof(int))-1)) == 0
 
 
-cdef int _cmp_by_dirs(char *path1, int size1, char *path2, int size2):
+cdef int _cmp_by_dirs(char *path1, int size1, char *path2, int size2): # cannot_raise
     cdef unsigned char *cur1
     cdef unsigned char *cur2
     cdef unsigned char *end1
@@ -295,7 +295,7 @@
 
 
 cdef int _cmp_path_by_dirblock_intern(char *path1, int path1_len,
-                                      char *path2, int path2_len):
+                                      char *path2, int path2_len): # cannot_raise
     """Compare two paths by what directory they are in.
 
     see ``_cmp_path_by_dirblock`` for details.
@@ -768,7 +768,7 @@
     state._dirblock_state = DirState.IN_MEMORY_UNMODIFIED
 
 
-cdef int minikind_from_mode(int mode):
+cdef int minikind_from_mode(int mode): # cannot_raise
     # in order of frequency:
     if S_ISREG(mode):
         return c"f"
@@ -915,7 +915,8 @@
     return link_or_sha1
 
 
-cdef char _minikind_from_string(object string):
+# TODO: Do we want to worry about exceptions here?
+cdef char _minikind_from_string(object string) except? -1:
     """Convert a python string to a char."""
     return PyString_AsString(string)[0]
 
@@ -953,7 +954,7 @@
     raise KeyError(PyString_FromStringAndSize(_minikind, 1))
 
 
-cdef int _versioned_minikind(char minikind):
+cdef int _versioned_minikind(char minikind): # cannot_raise
     """Return non-zero if minikind is in fltd"""
     return (minikind == c'f' or
             minikind == c'd' or
@@ -1373,7 +1374,7 @@
     def iter_changes(self):
         return self
 
-    cdef void _gather_result_for_consistency(self, result):
+    cdef int _gather_result_for_consistency(self, result) except -1:
         """Check a result we will yield to make sure we are consistent later.
         
         This gathers result's parents into a set to output later.
@@ -1381,7 +1382,7 @@
         :param result: A result tuple.
         """
         if not self.partial or not result[0]:
-            return
+            return 0
         self.seen_ids.add(result[0])
         new_path = result[1][1]
         if new_path:
@@ -1391,8 +1392,9 @@
             # Add the root directory which parent_directories does not
             # provide.
             self.search_specific_file_parents.add('')
+        return 0
 
-    cdef void _update_current_block(self):
+    cdef int _update_current_block(self) except -1:
         if (self.block_index < len(self.state._dirblocks) and
             osutils.is_inside(self.current_root, self.state._dirblocks[self.block_index][0])):
             self.current_block = self.state._dirblocks[self.block_index]
@@ -1401,6 +1403,7 @@
         else:
             self.current_block = None
             self.current_block_list = None
+        return 0
 
     def __next__(self):
         # Simple thunk to allow tail recursion without pyrex confusion

=== modified file 'bzrlib/_groupcompress_pyx.pyx'
--- bzrlib/_groupcompress_pyx.pyx	2009-06-10 03:56:49 +0000
+++ bzrlib/_groupcompress_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,10 +31,10 @@
 
 cdef extern from *:
     ctypedef unsigned long size_t
-    void * malloc(size_t)
-    void * realloc(void *, size_t)
-    void free(void *)
-    void memcpy(void *, void *, size_t)
+    void * malloc(size_t) nogil
+    void * realloc(void *, size_t) nogil
+    void free(void *) nogil
+    void memcpy(void *, void *, size_t) nogil
 
 
 cdef extern from "delta.h":
@@ -44,19 +44,16 @@
         unsigned long agg_offset
     struct delta_index:
         pass
-    delta_index * create_delta_index(source_info *src, delta_index *old)
+    delta_index * create_delta_index(source_info *src, delta_index *old) nogil
     delta_index * create_delta_index_from_delta(source_info *delta,
-                                                delta_index *old)
-    void free_delta_index(delta_index *index)
+                                                delta_index *old) nogil
+    void free_delta_index(delta_index *index) nogil
     void *create_delta(delta_index *indexes,
              void *buf, unsigned long bufsize,
-             unsigned long *delta_size, unsigned long max_delta_size)
+             unsigned long *delta_size, unsigned long max_delta_size) nogil
     unsigned long get_delta_hdr_size(unsigned char **datap,
-                                     unsigned char *top)
+                                     unsigned char *top) nogil
     Py_ssize_t DELTA_SIZE_MIN
-    void *patch_delta(void *src_buf, unsigned long src_size,
-                      void *delta_buf, unsigned long delta_size,
-                      unsigned long *dst_size)
 
 
 cdef void *safe_malloc(size_t count) except NULL:
@@ -148,7 +145,8 @@
         src.buf = c_delta
         src.size = c_delta_size
         src.agg_offset = self._source_offset + unadded_bytes
-        index = create_delta_index_from_delta(src, self._index)
+        with nogil:
+            index = create_delta_index_from_delta(src, self._index)
         self._source_offset = src.agg_offset + src.size
         if index != NULL:
             free_delta_index(self._index)
@@ -188,7 +186,8 @@
         self._source_offset = src.agg_offset + src.size
         # We delay creating the index on the first insert
         if source_location != 0:
-            index = create_delta_index(src, self._index)
+            with nogil:
+                index = create_delta_index(src, self._index)
             if index != NULL:
                 free_delta_index(self._index)
                 self._index = index
@@ -201,7 +200,8 @@
 
         # We know that self._index is already NULL, so whatever
         # create_delta_index returns is fine
-        self._index = create_delta_index(&self._source_infos[0], NULL)
+        with nogil:
+            self._index = create_delta_index(&self._source_infos[0], NULL)
         assert self._index != NULL
 
     cdef _expand_sources(self):
@@ -218,6 +218,7 @@
         cdef Py_ssize_t target_size
         cdef void * delta
         cdef unsigned long delta_size
+        cdef unsigned long c_max_delta_size
 
         if self._index == NULL:
             if len(self._sources) == 0:
@@ -234,9 +235,11 @@
         # TODO: inline some of create_delta so we at least don't have to double
         #       malloc, and can instead use PyString_FromStringAndSize, to
         #       allocate the bytes into the final string
-        delta = create_delta(self._index,
-                             target, target_size,
-                             &delta_size, max_delta_size)
+        c_max_delta_size = max_delta_size
+        with nogil:
+            delta = create_delta(self._index,
+                                 target, target_size,
+                                 &delta_size, c_max_delta_size)
         result = None
         if delta:
             result = PyString_FromStringAndSize(<char *>delta, delta_size)
@@ -276,7 +279,8 @@
 
 
 cdef unsigned char *_decode_copy_instruction(unsigned char *bytes,
-    unsigned char cmd, unsigned int *offset, unsigned int *length):
+    unsigned char cmd, unsigned int *offset,
+    unsigned int *length) nogil: # cannot_raise
     """Decode a copy instruction from the next few bytes.
 
     A copy instruction is a variable number of bytes, so we will parse the
@@ -326,6 +330,7 @@
     cdef unsigned char *dst_buf, *out, cmd
     cdef Py_ssize_t size
     cdef unsigned int cp_off, cp_size
+    cdef int failed
 
     data = <unsigned char *>delta
     top = data + delta_size
@@ -335,37 +340,49 @@
     result = PyString_FromStringAndSize(NULL, size)
     dst_buf = <unsigned char*>PyString_AS_STRING(result)
 
-    out = dst_buf
-    while (data < top):
-        cmd = data[0]
-        data = data + 1
-        if (cmd & 0x80):
-            # Copy instruction
-            data = _decode_copy_instruction(data, cmd, &cp_off, &cp_size)
-            if (cp_off + cp_size < cp_size or
-                cp_off + cp_size > source_size or
-                cp_size > size):
-                raise RuntimeError('Something wrong with:'
-                    ' cp_off = %s, cp_size = %s'
-                    ' source_size = %s, size = %s'
-                    % (cp_off, cp_size, source_size, size))
-            memcpy(out, source + cp_off, cp_size)
-            out = out + cp_size
-            size = size - cp_size
-        else:
-            # Insert instruction
-            if cmd == 0:
-                # cmd == 0 is reserved for future encoding
-                # extensions. In the mean time we must fail when
-                # encountering them (might be data corruption).
-                raise RuntimeError('Got delta opcode: 0, not supported')
-            if (cmd > size):
-                raise RuntimeError('Insert instruction longer than remaining'
-                    ' bytes: %d > %d' % (cmd, size))
-            memcpy(out, data, cmd)
-            out = out + cmd
-            data = data + cmd
-            size = size - cmd
+    failed = 0
+    with nogil:
+        out = dst_buf
+        while (data < top):
+            cmd = data[0]
+            data = data + 1
+            if (cmd & 0x80):
+                # Copy instruction
+                data = _decode_copy_instruction(data, cmd, &cp_off, &cp_size)
+                if (cp_off + cp_size < cp_size or
+                    cp_off + cp_size > source_size or
+                    cp_size > size):
+                    failed = 1
+                    break
+                memcpy(out, source + cp_off, cp_size)
+                out = out + cp_size
+                size = size - cp_size
+            else:
+                # Insert instruction
+                if cmd == 0:
+                    # cmd == 0 is reserved for future encoding
+                    # extensions. In the mean time we must fail when
+                    # encountering them (might be data corruption).
+                    failed = 2
+                    break
+                if cmd > size:
+                    failed = 3
+                    break
+                memcpy(out, data, cmd)
+                out = out + cmd
+                data = data + cmd
+                size = size - cmd
+    if failed:
+        if failed == 1:
+            raise ValueError('Something wrong with:'
+                ' cp_off = %s, cp_size = %s'
+                ' source_size = %s, size = %s'
+                % (cp_off, cp_size, source_size, size))
+        elif failed == 2:
+            raise ValueError('Got delta opcode: 0, not supported')
+        elif failed == 3:
+            raise ValueError('Insert instruction longer than remaining'
+                ' bytes: %d > %d' % (cmd, size))
 
     # sanity check
     if (data != top or size != 0):

=== modified file 'bzrlib/_knit_load_data_pyx.pyx'
--- bzrlib/_knit_load_data_pyx.pyx	2009-06-22 12:52:39 +0000
+++ bzrlib/_knit_load_data_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -97,11 +97,12 @@
         self.end_str = NULL
         self.history_len = 0
 
-    cdef void validate(self):
+    cdef int validate(self) except -1:
         if not PyDict_CheckExact(self.cache):
             raise TypeError('kndx._cache must be a python dict')
         if not PyList_CheckExact(self.history):
             raise TypeError('kndx._history must be a python list')
+        return 0
 
     cdef object process_options(self, char *option_str, char *end):
         """Process the options string into a list."""

=== modified file 'bzrlib/_known_graph_py.py'
--- bzrlib/_known_graph_py.py	2009-09-07 14:19:05 +0000
+++ bzrlib/_known_graph_py.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 """Implementation of Graph algorithms when we have already loaded everything.
 """
 
+from collections import deque
 from bzrlib import (
     errors,
     revision,
@@ -62,7 +63,7 @@
         :param parent_map: A dictionary mapping key => parent_keys
         """
         self._nodes = {}
-        # Maps {sorted(revision_id, revision_id): heads}
+        # Maps {frozenset(revision_id, revision_id): heads}
         self._known_heads = {}
         self.do_cache = do_cache
         self._initialize_nodes(parent_map)
@@ -132,6 +133,71 @@
                     # Update known_parent_gdfos for a key we couldn't process
                     known_parent_gdfos[child_key] = known_gdfo
 
+    def add_node(self, key, parent_keys):
+        """Add a new node to the graph.
+
+        If this fills in a ghost, then the gdfos of all children will be
+        updated accordingly.
+        
+        :param key: The node being added. If this is a duplicate, this is a
+            no-op.
+        :param parent_keys: The parents of the given node.
+        :return: None (should we return if this was a ghost, etc?)
+        """
+        nodes = self._nodes
+        if key in nodes:
+            node = nodes[key]
+            if node.parent_keys is None:
+                node.parent_keys = parent_keys
+                # A ghost is being added, we can no-longer trust the heads
+                # cache, so clear it
+                self._known_heads.clear()
+            else:
+                # Make sure we compare a list to a list, as tuple != list.
+                parent_keys = list(parent_keys)
+                existing_parent_keys = list(node.parent_keys)
+                if parent_keys == existing_parent_keys:
+                    return # Identical content
+                else:
+                    raise ValueError('Parent key mismatch, existing node %s'
+                        ' has parents of %s not %s'
+                        % (key, existing_parent_keys, parent_keys))
+        else:
+            node = _KnownGraphNode(key, parent_keys)
+            nodes[key] = node
+        parent_gdfo = 0
+        for parent_key in parent_keys:
+            try:
+                parent_node = nodes[parent_key]
+            except KeyError:
+                parent_node = _KnownGraphNode(parent_key, None)
+                # Ghosts and roots have gdfo 1
+                parent_node.gdfo = 1
+                nodes[parent_key] = parent_node
+            if parent_gdfo < parent_node.gdfo:
+                parent_gdfo = parent_node.gdfo
+            parent_node.child_keys.append(key)
+        node.gdfo = parent_gdfo + 1
+        # Now fill the gdfo to all children
+        # Note that this loop is slightly inefficient, in that we may visit the
+        # same child (and its decendents) more than once, however, it is
+        # 'efficient' in that we only walk to nodes that would be updated,
+        # rather than all nodes
+        # We use a deque rather than a simple list stack, to go for BFD rather
+        # than DFD. So that if a longer path is possible, we walk it before we
+        # get to the final child
+        pending = deque([node])
+        while pending:
+            node = pending.popleft()
+            next_gdfo = node.gdfo + 1
+            for child_key in node.child_keys:
+                child = nodes[child_key]
+                if child.gdfo < next_gdfo:
+                    # This child is being updated, we need to check its
+                    # children
+                    child.gdfo = next_gdfo
+                    pending.append(child)
+
     def heads(self, keys):
         """Return the heads from amongst keys.
 

=== modified file 'bzrlib/_known_graph_pyx.pyx'
--- bzrlib/_known_graph_pyx.pyx	2009-09-07 14:19:05 +0000
+++ bzrlib/_known_graph_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -51,6 +51,7 @@
 
     void Py_INCREF(object)
 
+from collections import deque
 import gc
 
 from bzrlib import errors, revision
@@ -192,7 +193,7 @@
     """This is a class which assumes we already know the full graph."""
 
     cdef public object _nodes
-    cdef object _known_heads
+    cdef public object _known_heads
     cdef public int do_cache
 
     def __init__(self, parent_map, do_cache=True):
@@ -232,6 +233,28 @@
             node = <_KnownGraphNode>temp_node
         return node
 
+    cdef _populate_parents(self, _KnownGraphNode node, parent_keys):
+        cdef Py_ssize_t num_parent_keys, pos
+        cdef _KnownGraphNode parent_node
+
+        num_parent_keys = len(parent_keys)
+        # We know how many parents, so we pre allocate the tuple
+        parent_nodes = PyTuple_New(num_parent_keys)
+        for pos from 0 <= pos < num_parent_keys:
+            # Note: it costs us 10ms out of 40ms to lookup all of these
+            #       parents, it doesn't seem to be an allocation overhead,
+            #       but rather a lookup overhead. There doesn't seem to be
+            #       a way around it, and that is one reason why
+            #       KnownGraphNode maintains a direct pointer to the parent
+            #       node.
+            # We use [] because parent_keys may be a tuple or list
+            parent_node = self._get_or_create_node(parent_keys[pos])
+            # PyTuple_SET_ITEM will steal a reference, so INCREF first
+            Py_INCREF(parent_node)
+            PyTuple_SET_ITEM(parent_nodes, pos, parent_node)
+            PyList_Append(parent_node.children, node)
+        node.parents = parent_nodes
+
     def _initialize_nodes(self, parent_map):
         """Populate self._nodes.
 
@@ -242,7 +265,7 @@
           child keys,
         """
         cdef PyObject *temp_key, *temp_parent_keys, *temp_node
-        cdef Py_ssize_t pos, pos2, num_parent_keys
+        cdef Py_ssize_t pos
         cdef _KnownGraphNode node
         cdef _KnownGraphNode parent_node
 
@@ -253,24 +276,8 @@
         while PyDict_Next(parent_map, &pos, &temp_key, &temp_parent_keys):
             key = <object>temp_key
             parent_keys = <object>temp_parent_keys
-            num_parent_keys = len(parent_keys)
             node = self._get_or_create_node(key)
-            # We know how many parents, so we pre allocate the tuple
-            parent_nodes = PyTuple_New(num_parent_keys)
-            for pos2 from 0 <= pos2 < num_parent_keys:
-                # Note: it costs us 10ms out of 40ms to lookup all of these
-                #       parents, it doesn't seem to be an allocation overhead,
-                #       but rather a lookup overhead. There doesn't seem to be
-                #       a way around it, and that is one reason why
-                #       KnownGraphNode maintains a direct pointer to the parent
-                #       node.
-                # We use [] because parent_keys may be a tuple or list
-                parent_node = self._get_or_create_node(parent_keys[pos2])
-                # PyTuple_SET_ITEM will steal a reference, so INCREF first
-                Py_INCREF(parent_node)
-                PyTuple_SET_ITEM(parent_nodes, pos2, parent_node)
-                PyList_Append(parent_node.children, node)
-            node.parents = parent_nodes
+            self._populate_parents(node, parent_keys)
 
     def _find_tails(self):
         cdef PyObject *temp_node
@@ -334,6 +341,76 @@
                     # anymore
                     child.seen = 0
 
+    def add_node(self, key, parent_keys):
+        """Add a new node to the graph.
+
+        If this fills in a ghost, then the gdfos of all children will be
+        updated accordingly.
+        
+        :param key: The node being added. If this is a duplicate, this is a
+            no-op.
+        :param parent_keys: The parents of the given node.
+        :return: None (should we return if this was a ghost, etc?)
+        """
+        cdef PyObject *maybe_node
+        cdef _KnownGraphNode node, parent_node, child_node
+        cdef long parent_gdfo, next_gdfo
+
+        maybe_node = PyDict_GetItem(self._nodes, key)
+        if maybe_node != NULL:
+            node = <_KnownGraphNode>maybe_node
+            if node.parents is None:
+                # We are filling in a ghost
+                self._populate_parents(node, parent_keys)
+                # We can't trust cached heads anymore
+                self._known_heads.clear()
+            else: # Ensure that the parent_key list matches
+                existing_parent_keys = []
+                for parent_node in node.parents:
+                    existing_parent_keys.append(parent_node.key)
+                # Make sure we use a list for the comparison, in case it was a
+                # tuple, etc
+                parent_keys = list(parent_keys)
+                if existing_parent_keys == parent_keys:
+                    # Exact match, nothing more to do
+                    return
+                else:
+                    raise ValueError('Parent key mismatch, existing node %s'
+                        ' has parents of %s not %s'
+                        % (key, existing_parent_keys, parent_keys))
+        else:
+            node = _KnownGraphNode(key)
+            PyDict_SetItem(self._nodes, key, node)
+            self._populate_parents(node, parent_keys)
+        parent_gdfo = 0
+        for parent_node in node.parents:
+            if parent_node.gdfo == -1:
+                # This is a newly introduced ghost, so it gets gdfo of 1
+                parent_node.gdfo = 1
+            if parent_gdfo < parent_node.gdfo:
+                parent_gdfo = parent_node.gdfo
+        node.gdfo = parent_gdfo + 1
+        # Now fill the gdfo to all children
+        # Note that this loop is slightly inefficient, in that we may visit the
+        # same child (and its decendents) more than once, however, it is
+        # 'efficient' in that we only walk to nodes that would be updated,
+        # rather than all nodes
+        # We use a deque rather than a simple list stack, to go for BFD rather
+        # than DFD. So that if a longer path is possible, we walk it before we
+        # get to the final child
+        pending = deque([node])
+        pending_popleft = pending.popleft
+        pending_append = pending.append
+        while pending:
+            node = pending_popleft()
+            next_gdfo = node.gdfo + 1
+            for child_node in node.children:
+                if child_node.gdfo < next_gdfo:
+                    # This child is being updated, we need to check its
+                    # children
+                    child_node.gdfo = next_gdfo
+                    pending_append(child_node)
+
     def heads(self, keys):
         """Return the heads from amongst keys.
 
@@ -626,7 +703,7 @@
             self._revno_first, self._revno_second, self._revno_last,
             self.is_first_child, self.seen_by_child)
 
-    cdef int has_pending_parents(self):
+    cdef int has_pending_parents(self): # cannot_raise
         if self.left_pending_parent is not None or self.pending_parents:
             return 1
         return 0

=== modified file 'bzrlib/_patiencediff_c.c'
--- bzrlib/_patiencediff_c.c	2009-03-23 14:59:43 +0000
+++ bzrlib/_patiencediff_c.c	2009-10-29 06:11:23 +0000
@@ -298,7 +298,7 @@
         apos = SENTINEL;
         /* loop through all lines in the linked list */
         for (i = h[equiv].a_pos; i != SENTINEL; i = lines_a[i].next) {
-            /* the index is lower than alo, the the next line */
+            /* the index is lower than alo, continue to the next line */
             if (i < alo) {
                 h[equiv].a_pos = i;
                 continue;
@@ -319,7 +319,7 @@
         /* check for duplicates of this line in lines_b[blo:bhi] */
         /* loop through all lines in the linked list */
         for (i = h[equiv].b_pos; i != SENTINEL; i = lines_b[i].next) {
-            /* the index is lower than blo, the the next line */
+            /* the index is lower than blo, continue to the next line */
             if (i < blo) {
                 h[equiv].b_pos = i;
                 continue;

=== modified file 'bzrlib/_readdir_pyx.pyx'
--- bzrlib/_readdir_pyx.pyx	2009-10-08 07:03:05 +0000
+++ bzrlib/_readdir_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -78,6 +78,7 @@
 
 
 cdef extern from 'Python.h':
+    int PyErr_CheckSignals() except -1
     char * PyString_AS_STRING(object)
     ctypedef int Py_ssize_t # Required for older pyrex versions
     ctypedef struct PyObject:
@@ -271,6 +272,12 @@
         return result
 
 
+cdef raise_os_error(int errnum, char *msg_prefix, path):
+    if errnum == EINTR:
+        PyErr_CheckSignals()
+    raise OSError(errnum, msg_prefix + strerror(errnum), path)
+
+
 cdef _read_dir(path):
     """Like os.listdir, this reads the contents of a directory.
 
@@ -298,16 +305,16 @@
         # passing full paths every time.
         orig_dir_fd = open(".", O_RDONLY, 0)
         if orig_dir_fd == -1:
-            raise OSError(errno, "open: " + strerror(errno), ".")
+            raise_os_error(errno, "open: ", ".")
         if -1 == chdir(path):
-            raise OSError(errno, "chdir: " + strerror(errno), path)
+            raise_os_error(errno, "chdir: ", path)
     else:
         orig_dir_fd = -1
 
     try:
         the_dir = opendir(".")
         if NULL == the_dir:
-            raise OSError(errno, "opendir: " + strerror(errno), path)
+            raise_os_error(errno, "opendir: ", path)
         try:
             result = []
             entry = &sentinel
@@ -319,6 +326,8 @@
                     errno = 0
                     entry = readdir(the_dir)
                     if entry == NULL and (errno == EAGAIN or errno == EINTR):
+                        if errno == EINTR:
+                            PyErr_CheckSignals()
                         # try again
                         continue
                     else:
@@ -330,7 +339,7 @@
                         # we consider ENOTDIR to be 'no error'.
                         continue
                     else:
-                        raise OSError(errno, "readdir: " + strerror(errno), path)
+                        raise_os_error(errno, "readdir: ", path)
                 name = entry.d_name
                 if not (name[0] == c"." and (
                     (name[1] == 0) or 
@@ -340,7 +349,7 @@
                     stat_result = lstat(entry.d_name, &statvalue._st)
                     if stat_result != 0:
                         if errno != ENOENT:
-                            raise OSError(errno, "lstat: " + strerror(errno),
+                            raise_os_error(errno, "lstat: ",
                                 path + "/" + entry.d_name)
                         else:
                             # the file seems to have disappeared after being
@@ -358,7 +367,7 @@
                         statvalue, None))
         finally:
             if -1 == closedir(the_dir):
-                raise OSError(errno, "closedir: " + strerror(errno), path)
+                raise_os_error(errno, "closedir: ", path)
     finally:
         if -1 != orig_dir_fd:
             failed = False
@@ -366,7 +375,7 @@
                 # try to close the original directory anyhow
                 failed = True
             if -1 == close(orig_dir_fd) or failed:
-                raise OSError(errno, "return to orig_dir: " + strerror(errno))
+                raise_os_error(errno, "return to orig_dir: ", "")
 
     return result
 

=== modified file 'bzrlib/_rio_pyx.pyx'
--- bzrlib/_rio_pyx.pyx	2009-05-15 02:36:03 +0000
+++ bzrlib/_rio_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,7 +49,7 @@
 
 from bzrlib.rio import Stanza
 
-cdef int _valid_tag_char(char c):
+cdef int _valid_tag_char(char c): # cannot_raise
     return (c == c'_' or c == c'-' or 
             (c >= c'a' and c <= c'z') or
             (c >= c'A' and c <= c'Z') or

=== modified file 'bzrlib/_simple_set_pyx.pxd'
--- bzrlib/_simple_set_pyx.pxd	2009-10-09 16:49:45 +0000
+++ bzrlib/_simple_set_pyx.pxd	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,4 +88,4 @@
 cdef api int SimpleSet_Discard(object self, object key) except -1
 cdef api PyObject *SimpleSet_Get(SimpleSet self, object key) except? NULL
 cdef api Py_ssize_t SimpleSet_Size(object self) except -1
-cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key)
+cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key) except -1

=== modified file 'bzrlib/_simple_set_pyx.pyx'
--- bzrlib/_simple_set_pyx.pyx	2009-10-14 15:57:06 +0000
+++ bzrlib/_simple_set_pyx.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -540,7 +540,8 @@
     return _check_self(self)._used
 
 
-cdef api int SimpleSet_Next(object self, Py_ssize_t *pos, PyObject **key):
+cdef api int SimpleSet_Next(object self, Py_ssize_t *pos,
+                            PyObject **key) except -1:
     """Walk over items in a SimpleSet.
 
     :param pos: should be initialized to 0 by the caller, and will be updated
@@ -567,7 +568,8 @@
     return 1
 
 
-cdef int SimpleSet_traverse(SimpleSet self, visitproc visit, void *arg):
+cdef int SimpleSet_traverse(SimpleSet self, visitproc visit,
+                            void *arg) except -1:
     """This is an implementation of 'tp_traverse' that hits the whole table.
 
     Cython/Pyrex don't seem to let you define a tp_traverse, and they only

=== modified file 'bzrlib/_static_tuple_c.c'
--- bzrlib/_static_tuple_c.c	2009-10-22 08:28:04 +0000
+++ bzrlib/_static_tuple_c.c	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-/* Copyright (C) 2009 Canonical Ltd
+/* Copyright (C) 2009, 2010 Canonical Ltd
  * 
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
@@ -179,7 +179,8 @@
 static StaticTuple *
 StaticTuple_FromSequence(PyObject *sequence)
 {
-    StaticTuple *new;
+    StaticTuple *new = NULL;
+    PyObject *as_tuple = NULL;
     PyObject *item;
     Py_ssize_t i, size;
 
@@ -188,16 +189,18 @@
         return (StaticTuple *)sequence;
     }
     if (!PySequence_Check(sequence)) {
-        PyErr_Format(PyExc_TypeError, "Type %s is not a sequence type",
-                     Py_TYPE(sequence)->tp_name);
-        return NULL;
+        as_tuple = PySequence_Tuple(sequence);
+        if (as_tuple == NULL)
+            goto done;
+        sequence = as_tuple;
     }
     size = PySequence_Size(sequence);
-    if (size == -1)
-        return NULL;
+    if (size == -1) {
+        goto done;
+    }
     new = StaticTuple_New(size);
     if (new == NULL) {
-        return NULL;
+        goto done;
     }
     for (i = 0; i < size; ++i) {
         // This returns a new reference, which we then 'steal' with 
@@ -205,10 +208,13 @@
         item = PySequence_GetItem(sequence, i);
         if (item == NULL) {
             Py_DECREF(new);
-            return NULL;
+            new = NULL;
+            goto done;
         }
         StaticTuple_SET_ITEM(new, i, item);
     }
+done:
+    Py_XDECREF(as_tuple);
     return (StaticTuple *)new;
 }
 
@@ -308,8 +314,8 @@
     if (tuple_repr == NULL) {
         return NULL;
     }
-    result = PyString_FromFormat("%s%s", Py_TYPE(self)->tp_name,
-                                         PyString_AsString(tuple_repr));
+    result = PyString_FromFormat("StaticTuple%s",
+                                 PyString_AsString(tuple_repr));
     return result;
 }
 
@@ -578,6 +584,29 @@
 
 
 static PyObject *
+StaticTuple_reduce(StaticTuple *self)
+{
+    PyObject *result = NULL, *as_tuple = NULL;
+
+    result = PyTuple_New(2);
+    if (!result) {
+        return NULL;
+    }
+    as_tuple = StaticTuple_as_tuple(self);
+    if (as_tuple == NULL) {
+        Py_DECREF(result);
+        return NULL;
+    }
+    Py_INCREF(&StaticTuple_Type);
+    PyTuple_SET_ITEM(result, 0, (PyObject *)&StaticTuple_Type);
+    PyTuple_SET_ITEM(result, 1, as_tuple);
+    return result;
+}
+
+static char StaticTuple_reduce_doc[] = "__reduce__() => tuple\n";
+
+
+static PyObject *
 StaticTuple_add(PyObject *v, PyObject *w)
 {
     Py_ssize_t i, len_v, len_w;
@@ -692,6 +721,7 @@
      METH_STATIC | METH_VARARGS,
      "Create a StaticTuple from a given sequence. This functions"
      " the same as the tuple() constructor."},
+    {"__reduce__", (PyCFunction)StaticTuple_reduce, METH_NOARGS, StaticTuple_reduce_doc},
     {NULL, NULL} /* sentinel */
 };
 
@@ -739,7 +769,7 @@
 PyTypeObject StaticTuple_Type = {
     PyObject_HEAD_INIT(NULL)
     0,                                           /* ob_size */
-    "StaticTuple",                               /* tp_name */
+    "bzrlib._static_tuple_c.StaticTuple",        /* tp_name */
     sizeof(StaticTuple),                         /* tp_basicsize */
     sizeof(PyObject *),                          /* tp_itemsize */
     (destructor)StaticTuple_dealloc,             /* tp_dealloc */

=== modified file 'bzrlib/_static_tuple_c.pxd'
--- bzrlib/_static_tuple_c.pxd	2009-10-07 15:57:25 +0000
+++ bzrlib/_static_tuple_c.pxd	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,5 +36,9 @@
 
     # Steals a reference and val must be a valid type, no checking is done
     void StaticTuple_SET_ITEM(StaticTuple key, Py_ssize_t offset, object val)
-    object StaticTuple_GET_ITEM(StaticTuple key, Py_ssize_t offset)
+    # We would normally use PyObject * here. However it seems that cython/pyrex
+    # treat the PyObject defined in this header as something different than one
+    # defined in a .pyx file. And since we don't INCREF, we need a raw pointer,
+    # not an 'object' return value.
+    void *StaticTuple_GET_ITEM(StaticTuple key, Py_ssize_t offset)
     int StaticTuple_CheckExact(object)

=== modified file 'bzrlib/_static_tuple_py.py'
--- bzrlib/_static_tuple_py.py	2009-10-22 08:22:27 +0000
+++ bzrlib/_static_tuple_py.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,6 +24,8 @@
 class StaticTuple(tuple):
     """A static type, similar to a tuple of strings."""
 
+    __slots__ = ()
+
     def __new__(cls, *args):
         # Make the empty StaticTuple a singleton
         if not args and _empty_tuple is not None:
@@ -48,12 +50,15 @@
     def __repr__(self):
         return '%s%s' % (self.__class__.__name__, tuple.__repr__(self))
 
+    def __reduce__(self):
+        return (StaticTuple, tuple(self))
+
     def __add__(self, other):
         """Concatenate self with other"""
         return StaticTuple.from_sequence(tuple.__add__(self,other))
 
     def as_tuple(self):
-        return self
+        return tuple(self)
 
     def intern(self):
         return _interned_tuples.setdefault(self, self)

=== modified file 'bzrlib/_walkdirs_win32.pyx'
--- bzrlib/_walkdirs_win32.pyx	2009-03-23 14:59:43 +0000
+++ bzrlib/_walkdirs_win32.pyx	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -109,7 +109,7 @@
                                  wcslen(data.cFileName))
 
 
-cdef int _get_mode_bits(WIN32_FIND_DATAW *data):
+cdef int _get_mode_bits(WIN32_FIND_DATAW *data): # cannot_raise
     cdef int mode_bits
 
     mode_bits = 0100666 # writeable file, the most common
@@ -121,13 +121,13 @@
     return mode_bits
 
 
-cdef __int64 _get_size(WIN32_FIND_DATAW *data):
+cdef __int64 _get_size(WIN32_FIND_DATAW *data): # cannot_raise
     # Pyrex casts a DWORD into a PyLong anyway, so it is safe to do << 32
     # on a DWORD
     return ((<__int64>data.nFileSizeHigh) << 32) + data.nFileSizeLow
 
 
-cdef double _ftime_to_timestamp(FILETIME *ft):
+cdef double _ftime_to_timestamp(FILETIME *ft): # cannot_raise
     """Convert from a FILETIME struct into a floating point timestamp.
 
     The fields of a FILETIME structure are the hi and lo part
@@ -147,7 +147,7 @@
     return (val * 1.0e-7) - 11644473600.0
 
 
-cdef int _should_skip(WIN32_FIND_DATAW *data):
+cdef int _should_skip(WIN32_FIND_DATAW *data): # cannot_raise
     """Is this '.' or '..' so we should skip it?"""
     if (data.cFileName[0] != c'.'):
         return 0

=== modified file 'bzrlib/benchmarks/bench_dirstate.py'
--- bzrlib/benchmarks/bench_dirstate.py	2009-06-22 15:39:42 +0000
+++ bzrlib/benchmarks/bench_dirstate.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,7 +26,7 @@
     tests,
     )
 from bzrlib.tests.test__dirstate_helpers import (
-    CompiledDirstateHelpersFeature,
+    compiled_dirstate_helpers_feature,
     )
 
 
@@ -206,7 +206,7 @@
             state.unlock()
 
     def test__read_dirblocks_20k_tree_0_parents_pyx(self):
-        self.requireFeature(CompiledDirstateHelpersFeature)
+        self.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import _read_dirblocks
         state = self.build_20k_dirstate()
         state.lock_read()
@@ -231,7 +231,7 @@
             state.unlock()
 
     def test__read_dirblocks_20k_tree_1_parent_pyx(self):
-        self.requireFeature(CompiledDirstateHelpersFeature)
+        self.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import _read_dirblocks
         state = self.build_20k_dirstate_with_parents(1)
         state.lock_read()
@@ -256,7 +256,7 @@
             state.unlock()
 
     def test__read_dirblocks_20k_tree_2_parents_pyx(self):
-        self.requireFeature(CompiledDirstateHelpersFeature)
+        self.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import _read_dirblocks
         state = self.build_20k_dirstate_with_parents(2)
         state.lock_read()
@@ -337,7 +337,7 @@
             state.unlock()
 
     def test_bisect_dirblock_pyx(self):
-        self.requireFeature(CompiledDirstateHelpersFeature)
+        self.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import bisect_dirblock
         state = self.build_10k_dirstate_dirs()
         state.lock_read()
@@ -420,7 +420,7 @@
                              [(3, 1), (3, 1), (3, 1), (3, 2)])
 
     def test_cmp_by_dirs_pyrex(self):
-        self.requireFeature(CompiledDirstateHelpersFeature)
+        self.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import cmp_by_dirs
         self.compareAllPaths(cmp_by_dirs,
                              [(3, 1), (3, 1), (3, 1), (3, 2)])

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2009-10-08 08:16:35 +0000
+++ bzrlib/branch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -503,12 +503,25 @@
                 left_parent = stop_rev.parent_ids[0]
             else:
                 left_parent = _mod_revision.NULL_REVISION
+            # left_parent is the actual revision we want to stop logging at,
+            # since we want to show the merged revisions after the stop_rev too
+            reached_stop_revision_id = False
+            revision_id_whitelist = []
             for node in rev_iter:
                 rev_id = node.key[-1]
                 if rev_id == left_parent:
+                    # reached the left parent after the stop_revision
                     return
-                yield (rev_id, node.merge_depth, node.revno,
+                if (not reached_stop_revision_id or
+                        rev_id in revision_id_whitelist):
+                    yield (rev_id, node.merge_depth, node.revno,
                        node.end_of_merge)
+                    if reached_stop_revision_id or rev_id == stop_revision_id:
+                        # only do the merged revs of rev_id from now on
+                        rev = self.repository.get_revision(rev_id)
+                        if rev.parent_ids:
+                            reached_stop_revision_id = True
+                            revision_id_whitelist.extend(rev.parent_ids)
         else:
             raise ValueError('invalid stop_rule %r' % stop_rule)
 
@@ -1090,15 +1103,7 @@
         params = ChangeBranchTipParams(
             self, old_revno, new_revno, old_revid, new_revid)
         for hook in hooks:
-            try:
-                hook(params)
-            except errors.TipChangeRejected:
-                raise
-            except Exception:
-                exc_info = sys.exc_info()
-                hook_name = Branch.hooks.get_hook_name(hook)
-                raise errors.HookFailed(
-                    'pre_change_branch_tip', hook_name, exc_info)
+            hook(params)
 
     @needs_write_lock
     def update(self):
@@ -1285,16 +1290,9 @@
         # clone call. Or something. 20090224 RBC/spiv.
         if revision_id is None:
             revision_id = self.last_revision()
-        try:
-            dir_to = self.bzrdir.clone_on_transport(to_transport,
-                revision_id=revision_id, stacked_on=stacked_on,
-                create_prefix=create_prefix, use_existing_dir=use_existing_dir)
-        except errors.FileExists:
-            if not use_existing_dir:
-                raise
-        except errors.NoSuchFile:
-            if not create_prefix:
-                raise
+        dir_to = self.bzrdir.clone_on_transport(to_transport,
+            revision_id=revision_id, stacked_on=stacked_on,
+            create_prefix=create_prefix, use_existing_dir=use_existing_dir)
         return dir_to.open_branch()
 
     def create_checkout(self, to_location, revision_id=None,
@@ -1440,10 +1438,10 @@
         """Return the format for the branch object in a_bzrdir."""
         try:
             transport = a_bzrdir.get_branch_transport(None)
-            format_string = transport.get("format").read()
+            format_string = transport.get_bytes("format")
             return klass._formats[format_string]
         except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base)
+            raise errors.NotBranchError(path=transport.base, bzrdir=a_bzrdir)
         except KeyError:
             raise errors.UnknownFormatError(format=format_string, kind='branch')
 
@@ -1798,7 +1796,7 @@
                               _repository=a_bzrdir.find_repository(),
                               ignore_fallbacks=ignore_fallbacks)
         except errors.NoSuchFile:
-            raise errors.NotBranchError(path=transport.base)
+            raise errors.NotBranchError(path=transport.base, bzrdir=a_bzrdir)
 
     def __init__(self):
         super(BranchFormatMetadir, self).__init__()
@@ -1979,7 +1977,7 @@
     def get_reference(self, a_bzrdir):
         """See BranchFormat.get_reference()."""
         transport = a_bzrdir.get_branch_transport(None)
-        return transport.get('location').read()
+        return transport.get_bytes('location')
 
     def set_reference(self, a_bzrdir, to_branch):
         """See BranchFormat.set_reference()."""
@@ -2137,6 +2135,7 @@
         # All-in-one needs to always unlock/lock.
         repo_control = getattr(self.repository, 'control_files', None)
         if self.control_files == repo_control or not self.is_locked():
+            self.repository._warn_if_deprecated(self)
             self.repository.lock_write()
             took_lock = True
         else:
@@ -2154,6 +2153,7 @@
         # All-in-one needs to always unlock/lock.
         repo_control = getattr(self.repository, 'control_files', None)
         if self.control_files == repo_control or not self.is_locked():
+            self.repository._warn_if_deprecated(self)
             self.repository.lock_read()
             took_lock = True
         else:

=== modified file 'bzrlib/btree_index.py'
--- bzrlib/btree_index.py	2009-10-19 15:39:25 +0000
+++ bzrlib/btree_index.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,6 +31,7 @@
     index,
     lru_cache,
     osutils,
+    static_tuple,
     trace,
     )
 from bzrlib.index import _OPTION_NODE_REFS, _OPTION_KEY_ELEMENTS, _OPTION_LEN
@@ -159,16 +160,16 @@
         :param value: The value to associate with the key. It may be any
             bytes as long as it does not contain \0 or \n.
         """
+        # Ensure that 'key' is a StaticTuple
+        key = static_tuple.StaticTuple.from_sequence(key).intern()
         # we don't care about absent_references
         node_refs, _ = self._check_key_ref_value(key, references, value)
         if key in self._nodes:
             raise errors.BadIndexDuplicateKey(key, self)
-        # TODO: StaticTuple
-        self._nodes[key] = (node_refs, value)
-        self._keys.add(key)
+        self._nodes[key] = static_tuple.StaticTuple(node_refs, value)
         if self._nodes_by_key is not None and self._key_length > 1:
             self._update_nodes_by_key(key, value, node_refs)
-        if len(self._keys) < self._spill_at:
+        if len(self._nodes) < self._spill_at:
             return
         self._spill_mem_keys_to_disk()
 
@@ -203,7 +204,6 @@
                 self._backing_indices[backing_pos] = None
         else:
             self._backing_indices.append(new_backing)
-        self._keys = set()
         self._nodes = {}
         self._nodes_by_key = None
 
@@ -411,7 +411,8 @@
             # Special case the first node as it may be prefixed
             node = row.spool.read(_PAGE_SIZE)
             result.write(node[reserved:])
-            result.write("\x00" * (reserved - position))
+            if len(node) == _PAGE_SIZE:
+                result.write("\x00" * (reserved - position))
             position = 0 # Only the root row actually has an offset
             copied_len = osutils.pumpfile(row.spool, result)
             if copied_len != (row.nodes - 1) * _PAGE_SIZE:
@@ -462,14 +463,22 @@
             efficient order for the index (keys iteration order in this case).
         """
         keys = set(keys)
-        local_keys = keys.intersection(self._keys)
+        # Note: We don't use keys.intersection() here. If you read the C api,
+        #       set.intersection(other) special cases when other is a set and
+        #       will iterate the smaller of the two and lookup in the other.
+        #       It does *not* do this for any other type (even dict, unlike
+        #       some other set functions.) Since we expect keys is generally <<
+        #       self._nodes, it is faster to iterate over it in a list
+        #       comprehension
+        nodes = self._nodes
+        local_keys = [key for key in keys if key in nodes]
         if self.reference_lists:
             for key in local_keys:
-                node = self._nodes[key]
+                node = nodes[key]
                 yield self, key, node[1], node[0]
         else:
             for key in local_keys:
-                node = self._nodes[key]
+                node = nodes[key]
                 yield self, key, node[1]
         # Find things that are in backing indices that have not been handled
         # yet.
@@ -585,7 +594,7 @@
 
         For InMemoryGraphIndex the estimate is exact.
         """
-        return len(self._keys) + sum(backing.key_count() for backing in
+        return len(self._nodes) + sum(backing.key_count() for backing in
             self._backing_indices if backing is not None)
 
     def validate(self):
@@ -623,11 +632,11 @@
     def _parse_lines(self, lines):
         nodes = []
         self.offset = int(lines[1][7:])
+        as_st = static_tuple.StaticTuple.from_sequence
         for line in lines[2:]:
             if line == '':
                 break
-            # TODO: Switch to StaticTuple here.
-            nodes.append(tuple(map(intern, line.split('\0'))))
+            nodes.append(as_st(map(intern, line.split('\0'))).intern())
         return nodes
 
 

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2009-06-10 03:31:01 +0000
+++ bzrlib/bugtracker.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,12 +39,12 @@
 
 _bugs_help = \
 """When making a commit, metadata about bugs fixed by that change can be
-recorded by using the --fixes option. For each bug marked as fixed, an
+recorded by using the ``--fixes`` option. For each bug marked as fixed, an
 entry is included in the 'bugs' revision property stating '<url> <status>'.
 (The only ``status`` value currently supported is ``fixed.``)
 
-The --fixes option allows you to specify a bug tracker and a bug identifier
-rather than a full URL. This looks like
+The ``--fixes`` option allows you to specify a bug tracker and a bug identifier
+rather than a full URL. This looks like::
 
     bzr commit --fixes <tracker>:<id>
 
@@ -56,10 +56,13 @@
 use this feature, you just need to know the tracker identifier to use.
 These are the bugtrackers that are built in:
 
-     URL                          | Abbreviation | Example
-     https://bugs.launchpad.net/  | lp           | lp:12345
-     http://bugs.debian.org/      | deb          | deb:12345
-     http://bugzilla.gnome.org/   | gnome        | gnome:12345
+  ============================ ============ ============
+  URL                          Abbreviation Example
+  ============================ ============ ============
+  https://bugs.launchpad.net/  lp           lp:12345
+  http://bugs.debian.org/      deb          deb:12345
+  http://bugzilla.gnome.org/   gnome        gnome:12345
+  ============================ ============ ============
 
 For the bug trackers not listed above configuration is required.
 Support for generating the URLs for any project using Bugzilla or Trac
@@ -82,11 +85,11 @@
 
 Use ``bzr commit --fixes lp:2`` to record that this commit fixes bug 2.
 
-bugzilla_<tracker_abbreviation>_url
------------------------------------
+bugzilla_<tracker>_url
+----------------------
 
 If present, the location of the Bugzilla bug tracker referred to by
-<tracker_abbreviation>. This option can then be used together with ``bzr commit
+<tracker>. This option can then be used together with ``bzr commit
 --fixes`` to mark bugs in that tracker as being fixed by that commit. For
 example::
 
@@ -95,11 +98,11 @@
 would allow ``bzr commit --fixes squid:1234`` to mark Squid's bug 1234 as
 fixed.
 
-trac_<tracker_abbrevation>_url
-------------------------------
+trac_<tracker>_url
+------------------
 
 If present, the location of the Trac instance referred to by
-<tracker_abbreviation>. This option can then be used together with ``bzr commit
+<tracker>. This option can then be used together with ``bzr commit
 --fixes`` to mark bugs in that tracker as being fixed by that commit. For
 example::
 
@@ -108,11 +111,11 @@
 would allow ``bzr commit --fixes twisted:1234`` to mark Twisted's bug 1234 as
 fixed.
 
-bugtracker_<tracker_abbrevation>_url
-------------------------------------
+bugtracker_<tracker>_url
+------------------------
 
 If present, the location of a generic bug tracker instance referred to by
-<tracker_abbreviation>. The location must contain an ``{id}`` placeholder,
+<tracker>. The location must contain an ``{id}`` placeholder,
 which will be replaced by a specific bug ID. This option can then be used
 together with ``bzr commit --fixes`` to mark bugs in that tracker as being
 fixed by that commit. For example::

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2009-10-12 22:09:19 +0000
+++ bzrlib/builtins.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,6 +31,7 @@
     bundle,
     btree_index,
     bzrdir,
+    directory_service,
     delta,
     config,
     errors,
@@ -43,7 +44,9 @@
     reconfigure,
     rename_map,
     revision as _mod_revision,
+    static_tuple,
     symbol_versioning,
+    timestamp,
     transport,
     ui,
     urlutils,
@@ -257,6 +260,10 @@
     unknown
         Not versioned and not matching an ignore pattern.
 
+    Additionally for directories, symlinks and files with an executable
+    bit, Bazaar indicates their type using a trailing character: '/', '@'
+    or '*' respectively.
+
     To see ignored files use 'bzr ignored'.  For details on the
     changes to file texts, use 'bzr diff'.
 
@@ -431,8 +438,7 @@
         for node in bt.iter_all_entries():
             # Node is made up of:
             # (index, key, value, [references])
-            refs_as_tuples = tuple([tuple([tuple(ref) for ref in ref_list])
-                                   for ref_list in node[3]])
+            refs_as_tuples = static_tuple.as_tuples(node[3])
             as_tuple = (tuple(node[1]), node[2], refs_as_tuples)
             self.outf.write('%s\n' % (as_tuple,))
 
@@ -496,23 +502,19 @@
                 wt.lock_read()
             except (errors.NoWorkingTree, errors.NotLocalUrl):
                 raise errors.NoWorkingTree(location)
+            self.add_cleanup(wt.unlock)
+            revid = wt.last_revision()
             try:
-                revid = wt.last_revision()
-                try:
-                    revno_t = wt.branch.revision_id_to_dotted_revno(revid)
-                except errors.NoSuchRevision:
-                    revno_t = ('???',)
-                revno = ".".join(str(n) for n in revno_t)
-            finally:
-                wt.unlock()
+                revno_t = wt.branch.revision_id_to_dotted_revno(revid)
+            except errors.NoSuchRevision:
+                revno_t = ('???',)
+            revno = ".".join(str(n) for n in revno_t)
         else:
             b = Branch.open_containing(location)[0]
             b.lock_read()
-            try:
-                revno = b.revno()
-            finally:
-                b.unlock()
-
+            self.add_cleanup(b.unlock)
+            revno = b.revno()
+        self.cleanup_now()
         self.outf.write(str(revno) + '\n')
 
 
@@ -540,43 +542,40 @@
             wt = WorkingTree.open_containing(directory)[0]
             b = wt.branch
             wt.lock_read()
+            self.add_cleanup(wt.unlock)
         except (errors.NoWorkingTree, errors.NotLocalUrl):
             wt = None
             b = Branch.open_containing(directory)[0]
             b.lock_read()
-        try:
-            revision_ids = []
-            if revision is not None:
-                revision_ids.extend(rev.as_revision_id(b) for rev in revision)
-            if revision_info_list is not None:
-                for rev_str in revision_info_list:
-                    rev_spec = RevisionSpec.from_string(rev_str)
-                    revision_ids.append(rev_spec.as_revision_id(b))
-            # No arguments supplied, default to the last revision
-            if len(revision_ids) == 0:
-                if tree:
-                    if wt is None:
-                        raise errors.NoWorkingTree(directory)
-                    revision_ids.append(wt.last_revision())
-                else:
-                    revision_ids.append(b.last_revision())
-
-            revinfos = []
-            maxlen = 0
-            for revision_id in revision_ids:
-                try:
-                    dotted_revno = b.revision_id_to_dotted_revno(revision_id)
-                    revno = '.'.join(str(i) for i in dotted_revno)
-                except errors.NoSuchRevision:
-                    revno = '???'
-                maxlen = max(maxlen, len(revno))
-                revinfos.append([revno, revision_id])
-        finally:
-            if wt is None:
-                b.unlock()
+            self.add_cleanup(b.unlock)
+        revision_ids = []
+        if revision is not None:
+            revision_ids.extend(rev.as_revision_id(b) for rev in revision)
+        if revision_info_list is not None:
+            for rev_str in revision_info_list:
+                rev_spec = RevisionSpec.from_string(rev_str)
+                revision_ids.append(rev_spec.as_revision_id(b))
+        # No arguments supplied, default to the last revision
+        if len(revision_ids) == 0:
+            if tree:
+                if wt is None:
+                    raise errors.NoWorkingTree(directory)
+                revision_ids.append(wt.last_revision())
             else:
-                wt.unlock()
-
+                revision_ids.append(b.last_revision())
+
+        revinfos = []
+        maxlen = 0
+        for revision_id in revision_ids:
+            try:
+                dotted_revno = b.revision_id_to_dotted_revno(revision_id)
+                revno = '.'.join(str(i) for i in dotted_revno)
+            except errors.NoSuchRevision:
+                revno = '???'
+            maxlen = max(maxlen, len(revno))
+            revinfos.append([revno, revision_id])
+
+        self.cleanup_now()
         for ri in revinfos:
             self.outf.write('%*s %s\n' % (maxlen, ri[0], ri[1]))
 
@@ -654,14 +653,11 @@
 
         if base_tree:
             base_tree.lock_read()
-        try:
-            file_list = self._maybe_expand_globs(file_list)
-            tree, file_list = tree_files_for_add(file_list)
-            added, ignored = tree.smart_add(file_list, not
-                no_recurse, action=action, save=not dry_run)
-        finally:
-            if base_tree is not None:
-                base_tree.unlock()
+            self.add_cleanup(base_tree.unlock)
+        tree, file_list = tree_files_for_add(file_list)
+        added, ignored = tree.smart_add(file_list, not
+            no_recurse, action=action, save=not dry_run)
+        self.cleanup_now()
         if len(ignored) > 0:
             if verbose:
                 for glob in sorted(ignored.keys()):
@@ -731,30 +727,28 @@
         revision = _get_one_revision('inventory', revision)
         work_tree, file_list = tree_files(file_list)
         work_tree.lock_read()
-        try:
-            if revision is not None:
-                tree = revision.as_tree(work_tree.branch)
-
-                extra_trees = [work_tree]
-                tree.lock_read()
-            else:
-                tree = work_tree
-                extra_trees = []
-
-            if file_list is not None:
-                file_ids = tree.paths2ids(file_list, trees=extra_trees,
-                                          require_versioned=True)
-                # find_ids_across_trees may include some paths that don't
-                # exist in 'tree'.
-                entries = sorted((tree.id2path(file_id), tree.inventory[file_id])
-                                 for file_id in file_ids if file_id in tree)
-            else:
-                entries = tree.inventory.entries()
-        finally:
-            tree.unlock()
-            if tree is not work_tree:
-                work_tree.unlock()
-
+        self.add_cleanup(work_tree.unlock)
+        if revision is not None:
+            tree = revision.as_tree(work_tree.branch)
+
+            extra_trees = [work_tree]
+            tree.lock_read()
+            self.add_cleanup(tree.unlock)
+        else:
+            tree = work_tree
+            extra_trees = []
+
+        if file_list is not None:
+            file_ids = tree.paths2ids(file_list, trees=extra_trees,
+                                      require_versioned=True)
+            # find_ids_across_trees may include some paths that don't
+            # exist in 'tree'.
+            entries = sorted((tree.id2path(file_id), tree.inventory[file_id])
+                             for file_id in file_ids if file_id in tree)
+        else:
+            entries = tree.inventory.entries()
+
+        self.cleanup_now()
         for path, entry in entries:
             if kind and kind != entry.kind:
                 continue
@@ -806,10 +800,8 @@
             raise errors.BzrCommandError("missing file argument")
         tree, rel_names = tree_files(names_list, canonicalize=False)
         tree.lock_tree_write()
-        try:
-            self._run(tree, names_list, rel_names, after)
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        self._run(tree, names_list, rel_names, after)
 
     def run_auto(self, names_list, after, dry_run):
         if names_list is not None and len(names_list) > 1:
@@ -820,10 +812,8 @@
                                          ' --auto.')
         work_tree, file_list = tree_files(names_list, default_branch='.')
         work_tree.lock_tree_write()
-        try:
-            rename_map.RenameMap.guess_renames(work_tree, dry_run)
-        finally:
-            work_tree.unlock()
+        self.add_cleanup(work_tree.unlock)
+        rename_map.RenameMap.guess_renames(work_tree, dry_run)
 
     def _run(self, tree, names_list, rel_names, after):
         into_existing = osutils.isdir(names_list[-1])
@@ -850,8 +840,9 @@
             # All entries reference existing inventory items, so fix them up
             # for cicp file-systems.
             rel_names = tree.get_canonical_inventory_paths(rel_names)
-            for pair in tree.move(rel_names[:-1], rel_names[-1], after=after):
-                self.outf.write("%s => %s\n" % pair)
+            for src, dest in tree.move(rel_names[:-1], rel_names[-1], after=after):
+                if not is_quiet():
+                    self.outf.write("%s => %s\n" % (src, dest))
         else:
             if len(names_list) != 2:
                 raise errors.BzrCommandError('to mv multiple files the'
@@ -901,22 +892,25 @@
             dest = osutils.pathjoin(dest_parent, dest_tail)
             mutter("attempting to move %s => %s", src, dest)
             tree.rename_one(src, dest, after=after)
-            self.outf.write("%s => %s\n" % (src, dest))
+            if not is_quiet():
+                self.outf.write("%s => %s\n" % (src, dest))
 
 
 class cmd_pull(Command):
     """Turn this branch into a mirror of another branch.
 
-    This command only works on branches that have not diverged.  Branches are
-    considered diverged if the destination branch's most recent commit is one
-    that has not been merged (directly or indirectly) into the parent.
+    By default, this command only works on branches that have not diverged.
+    Branches are considered diverged if the destination branch's most recent 
+    commit is one that has not been merged (directly or indirectly) into the 
+    parent.
 
     If branches have diverged, you can use 'bzr merge' to integrate the changes
     from one into the other.  Once one branch has merged, the other should
     be able to pull it again.
 
-    If you want to forget your local changes and just update your branch to
-    match the remote one, use pull --overwrite.
+    If you want to replace your local changes and just want your branch to
+    match the remote one, use pull --overwrite. This will work even if the two
+    branches have diverged.
 
     If there is no default location set, the first pull will set it.  After
     that, you can omit the location to use the default.  To change the
@@ -1003,34 +997,29 @@
 
         if branch_from is not branch_to:
             branch_from.lock_read()
-        try:
-            if revision is not None:
-                revision_id = revision.as_revision_id(branch_from)
-
-            branch_to.lock_write()
-            try:
-                if tree_to is not None:
-                    view_info = _get_view_info_for_change_reporter(tree_to)
-                    change_reporter = delta._ChangeReporter(
-                        unversioned_filter=tree_to.is_ignored,
-                        view_info=view_info)
-                    result = tree_to.pull(
-                        branch_from, overwrite, revision_id, change_reporter,
-                        possible_transports=possible_transports, local=local)
-                else:
-                    result = branch_to.pull(
-                        branch_from, overwrite, revision_id, local=local)
-
-                result.report(self.outf)
-                if verbose and result.old_revid != result.new_revid:
-                    log.show_branch_change(
-                        branch_to, self.outf, result.old_revno,
-                        result.old_revid)
-            finally:
-                branch_to.unlock()
-        finally:
-            if branch_from is not branch_to:
-                branch_from.unlock()
+            self.add_cleanup(branch_from.unlock)
+        if revision is not None:
+            revision_id = revision.as_revision_id(branch_from)
+
+        branch_to.lock_write()
+        self.add_cleanup(branch_to.unlock)
+        if tree_to is not None:
+            view_info = _get_view_info_for_change_reporter(tree_to)
+            change_reporter = delta._ChangeReporter(
+                unversioned_filter=tree_to.is_ignored,
+                view_info=view_info)
+            result = tree_to.pull(
+                branch_from, overwrite, revision_id, change_reporter,
+                possible_transports=possible_transports, local=local)
+        else:
+            result = branch_to.pull(
+                branch_from, overwrite, revision_id, local=local)
+
+        result.report(self.outf)
+        if verbose and result.old_revid != result.new_revid:
+            log.show_branch_change(
+                branch_to, self.outf, result.old_revno,
+                result.old_revid)
 
 
 class cmd_push(Command):
@@ -1191,81 +1180,83 @@
                     ' directory exists, but does not already'
                     ' have a control directory.  This flag will'
                     ' allow branch to proceed.'),
+        Option('bind',
+            help="Bind new branch to from location."),
         ]
     aliases = ['get', 'clone']
 
     def run(self, from_location, to_location=None, revision=None,
             hardlink=False, stacked=False, standalone=False, no_tree=False,
-            use_existing_dir=False, switch=False):
+            use_existing_dir=False, switch=False, bind=False):
         from bzrlib import switch as _mod_switch
         from bzrlib.tag import _merge_tags_if_possible
         accelerator_tree, br_from = bzrdir.BzrDir.open_tree_or_branch(
             from_location)
-        if (accelerator_tree is not None and
-            accelerator_tree.supports_content_filtering()):
-            accelerator_tree = None
         revision = _get_one_revision('branch', revision)
         br_from.lock_read()
+        self.add_cleanup(br_from.unlock)
+        if revision is not None:
+            revision_id = revision.as_revision_id(br_from)
+        else:
+            # FIXME - wt.last_revision, fallback to branch, fall back to
+            # None or perhaps NULL_REVISION to mean copy nothing
+            # RBC 20060209
+            revision_id = br_from.last_revision()
+        if to_location is None:
+            to_location = urlutils.derive_to_location(from_location)
+        to_transport = transport.get_transport(to_location)
         try:
-            if revision is not None:
-                revision_id = revision.as_revision_id(br_from)
+            to_transport.mkdir('.')
+        except errors.FileExists:
+            if not use_existing_dir:
+                raise errors.BzrCommandError('Target directory "%s" '
+                    'already exists.' % to_location)
             else:
-                # FIXME - wt.last_revision, fallback to branch, fall back to
-                # None or perhaps NULL_REVISION to mean copy nothing
-                # RBC 20060209
-                revision_id = br_from.last_revision()
-            if to_location is None:
-                to_location = urlutils.derive_to_location(from_location)
-            to_transport = transport.get_transport(to_location)
-            try:
-                to_transport.mkdir('.')
-            except errors.FileExists:
-                if not use_existing_dir:
-                    raise errors.BzrCommandError('Target directory "%s" '
-                        'already exists.' % to_location)
+                try:
+                    bzrdir.BzrDir.open_from_transport(to_transport)
+                except errors.NotBranchError:
+                    pass
                 else:
-                    try:
-                        bzrdir.BzrDir.open_from_transport(to_transport)
-                    except errors.NotBranchError:
-                        pass
-                    else:
-                        raise errors.AlreadyBranchError(to_location)
-            except errors.NoSuchFile:
-                raise errors.BzrCommandError('Parent of "%s" does not exist.'
-                                             % to_location)
-            try:
-                # preserve whatever source format we have.
-                dir = br_from.bzrdir.sprout(to_transport.base, revision_id,
-                                            possible_transports=[to_transport],
-                                            accelerator_tree=accelerator_tree,
-                                            hardlink=hardlink, stacked=stacked,
-                                            force_new_repo=standalone,
-                                            create_tree_if_local=not no_tree,
-                                            source_branch=br_from)
-                branch = dir.open_branch()
-            except errors.NoSuchRevision:
-                to_transport.delete_tree('.')
-                msg = "The branch %s has no revision %s." % (from_location,
-                    revision)
-                raise errors.BzrCommandError(msg)
-            _merge_tags_if_possible(br_from, branch)
-            # If the source branch is stacked, the new branch may
-            # be stacked whether we asked for that explicitly or not.
-            # We therefore need a try/except here and not just 'if stacked:'
-            try:
-                note('Created new stacked branch referring to %s.' %
-                    branch.get_stacked_on_url())
-            except (errors.NotStacked, errors.UnstackableBranchFormat,
-                errors.UnstackableRepositoryFormat), e:
-                note('Branched %d revision(s).' % branch.revno())
-            if switch:
-                # Switch to the new branch
-                wt, _ = WorkingTree.open_containing('.')
-                _mod_switch.switch(wt.bzrdir, branch)
-                note('Switched to branch: %s',
-                    urlutils.unescape_for_display(branch.base, 'utf-8'))
-        finally:
-            br_from.unlock()
+                    raise errors.AlreadyBranchError(to_location)
+        except errors.NoSuchFile:
+            raise errors.BzrCommandError('Parent of "%s" does not exist.'
+                                         % to_location)
+        try:
+            # preserve whatever source format we have.
+            dir = br_from.bzrdir.sprout(to_transport.base, revision_id,
+                                        possible_transports=[to_transport],
+                                        accelerator_tree=accelerator_tree,
+                                        hardlink=hardlink, stacked=stacked,
+                                        force_new_repo=standalone,
+                                        create_tree_if_local=not no_tree,
+                                        source_branch=br_from)
+            branch = dir.open_branch()
+        except errors.NoSuchRevision:
+            to_transport.delete_tree('.')
+            msg = "The branch %s has no revision %s." % (from_location,
+                revision)
+            raise errors.BzrCommandError(msg)
+        _merge_tags_if_possible(br_from, branch)
+        # If the source branch is stacked, the new branch may
+        # be stacked whether we asked for that explicitly or not.
+        # We therefore need a try/except here and not just 'if stacked:'
+        try:
+            note('Created new stacked branch referring to %s.' %
+                branch.get_stacked_on_url())
+        except (errors.NotStacked, errors.UnstackableBranchFormat,
+            errors.UnstackableRepositoryFormat), e:
+            note('Branched %d revision(s).' % branch.revno())
+        if bind:
+            # Bind to the parent
+            parent_branch = Branch.open(from_location)
+            branch.bind(parent_branch)
+            note('New branch bound to %s' % from_location)
+        if switch:
+            # Switch to the new branch
+            wt, _ = WorkingTree.open_containing('.')
+            _mod_switch.switch(wt.bzrdir, branch)
+            note('Switched to branch: %s',
+                urlutils.unescape_for_display(branch.base, 'utf-8'))
 
 
 class cmd_checkout(Command):
@@ -1350,27 +1341,23 @@
     def run(self, dir=u'.'):
         tree = WorkingTree.open_containing(dir)[0]
         tree.lock_read()
-        try:
-            new_inv = tree.inventory
-            old_tree = tree.basis_tree()
-            old_tree.lock_read()
-            try:
-                old_inv = old_tree.inventory
-                renames = []
-                iterator = tree.iter_changes(old_tree, include_unchanged=True)
-                for f, paths, c, v, p, n, k, e in iterator:
-                    if paths[0] == paths[1]:
-                        continue
-                    if None in (paths):
-                        continue
-                    renames.append(paths)
-                renames.sort()
-                for old_name, new_name in renames:
-                    self.outf.write("%s => %s\n" % (old_name, new_name))
-            finally:
-                old_tree.unlock()
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        new_inv = tree.inventory
+        old_tree = tree.basis_tree()
+        old_tree.lock_read()
+        self.add_cleanup(old_tree.unlock)
+        old_inv = old_tree.inventory
+        renames = []
+        iterator = tree.iter_changes(old_tree, include_unchanged=True)
+        for f, paths, c, v, p, n, k, e in iterator:
+            if paths[0] == paths[1]:
+                continue
+            if None in (paths):
+                continue
+            renames.append(paths)
+        renames.sort()
+        for old_name, new_name in renames:
+            self.outf.write("%s => %s\n" % (old_name, new_name))
 
 
 class cmd_update(Command):
@@ -1382,48 +1369,79 @@
 
     If you want to discard your local changes, you can just do a
     'bzr revert' instead of 'bzr commit' after the update.
+
+    If the tree's branch is bound to a master branch, it will also update
+    the branch from the master.
     """
 
     _see_also = ['pull', 'working-trees', 'status-flags']
     takes_args = ['dir?']
+    takes_options = ['revision']
     aliases = ['up']
 
-    def run(self, dir='.'):
+    def run(self, dir='.', revision=None):
+        if revision is not None and len(revision) != 1:
+            raise errors.BzrCommandError(
+                        "bzr update --revision takes exactly one revision")
         tree = WorkingTree.open_containing(dir)[0]
+        branch = tree.branch
         possible_transports = []
-        master = tree.branch.get_master_branch(
+        master = branch.get_master_branch(
             possible_transports=possible_transports)
         if master is not None:
             tree.lock_write()
+            branch_location = master.base
         else:
             tree.lock_tree_write()
+            branch_location = tree.branch.base
+        self.add_cleanup(tree.unlock)
+        # get rid of the final '/' and be ready for display
+        branch_location = urlutils.unescape_for_display(branch_location[:-1],
+                                                        self.outf.encoding)
+        existing_pending_merges = tree.get_parent_ids()[1:]
+        if master is None:
+            old_tip = None
+        else:
+            # may need to fetch data into a heavyweight checkout
+            # XXX: this may take some time, maybe we should display a
+            # message
+            old_tip = branch.update(possible_transports)
+        if revision is not None:
+            revision_id = revision[0].as_revision_id(branch)
+        else:
+            revision_id = branch.last_revision()
+        if revision_id == _mod_revision.ensure_null(tree.last_revision()):
+            revno = branch.revision_id_to_revno(revision_id)
+            note("Tree is up to date at revision %d of branch %s" %
+                (revno, branch_location))
+            return 0
+        view_info = _get_view_info_for_change_reporter(tree)
+        change_reporter = delta._ChangeReporter(
+            unversioned_filter=tree.is_ignored,
+            view_info=view_info)
         try:
-            existing_pending_merges = tree.get_parent_ids()[1:]
-            last_rev = _mod_revision.ensure_null(tree.last_revision())
-            if last_rev == _mod_revision.ensure_null(
-                tree.branch.last_revision()):
-                # may be up to date, check master too.
-                if master is None or last_rev == _mod_revision.ensure_null(
-                    master.last_revision()):
-                    revno = tree.branch.revision_id_to_revno(last_rev)
-                    note("Tree is up to date at revision %d." % (revno,))
-                    return 0
-            view_info = _get_view_info_for_change_reporter(tree)
             conflicts = tree.update(
-                delta._ChangeReporter(unversioned_filter=tree.is_ignored,
-                view_info=view_info), possible_transports=possible_transports)
-            revno = tree.branch.revision_id_to_revno(
-                _mod_revision.ensure_null(tree.last_revision()))
-            note('Updated to revision %d.' % (revno,))
-            if tree.get_parent_ids()[1:] != existing_pending_merges:
-                note('Your local commits will now show as pending merges with '
-                     "'bzr status', and can be committed with 'bzr commit'.")
-            if conflicts != 0:
-                return 1
-            else:
-                return 0
-        finally:
-            tree.unlock()
+                change_reporter,
+                possible_transports=possible_transports,
+                revision=revision_id,
+                old_tip=old_tip)
+        except errors.NoSuchRevision, e:
+            raise errors.BzrCommandError(
+                                  "branch has no revision %s\n"
+                                  "bzr update --revision only works"
+                                  " for a revision in the branch history"
+                                  % (e.revision))
+        revno = tree.branch.revision_id_to_revno(
+            _mod_revision.ensure_null(tree.last_revision()))
+        note('Updated to revision %d of branch %s' %
+             (revno, branch_location))
+        if tree.get_parent_ids()[1:] != existing_pending_merges:
+            note('Your local commits will now show as pending merges with '
+                 "'bzr status', and can be committed with 'bzr commit'.")
+        if conflicts != 0:
+            return 1
+        else:
+            return 0
 
 
 class cmd_info(Command):
@@ -1500,30 +1518,28 @@
             file_list = [f for f in file_list]
 
         tree.lock_write()
-        try:
-            # Heuristics should probably all move into tree.remove_smart or
-            # some such?
-            if new:
-                added = tree.changes_from(tree.basis_tree(),
-                    specific_files=file_list).added
-                file_list = sorted([f[0] for f in added], reverse=True)
-                if len(file_list) == 0:
-                    raise errors.BzrCommandError('No matching files.')
-            elif file_list is None:
-                # missing files show up in iter_changes(basis) as
-                # versioned-with-no-kind.
-                missing = []
-                for change in tree.iter_changes(tree.basis_tree()):
-                    # Find paths in the working tree that have no kind:
-                    if change[1][1] is not None and change[6][1] is None:
-                        missing.append(change[1][1])
-                file_list = sorted(missing, reverse=True)
-                file_deletion_strategy = 'keep'
-            tree.remove(file_list, verbose=verbose, to_file=self.outf,
-                keep_files=file_deletion_strategy=='keep',
-                force=file_deletion_strategy=='force')
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        # Heuristics should probably all move into tree.remove_smart or
+        # some such?
+        if new:
+            added = tree.changes_from(tree.basis_tree(),
+                specific_files=file_list).added
+            file_list = sorted([f[0] for f in added], reverse=True)
+            if len(file_list) == 0:
+                raise errors.BzrCommandError('No matching files.')
+        elif file_list is None:
+            # missing files show up in iter_changes(basis) as
+            # versioned-with-no-kind.
+            missing = []
+            for change in tree.iter_changes(tree.basis_tree()):
+                # Find paths in the working tree that have no kind:
+                if change[1][1] is not None and change[6][1] is None:
+                    missing.append(change[1][1])
+            file_list = sorted(missing, reverse=True)
+            file_deletion_strategy = 'keep'
+        tree.remove(file_list, verbose=verbose, to_file=self.outf,
+            keep_files=file_deletion_strategy=='keep',
+            force=file_deletion_strategy=='force')
 
 
 class cmd_file_id(Command):
@@ -1749,16 +1765,22 @@
 
 
 class cmd_init_repository(Command):
-    """Create a shared repository to hold branches.
+    """Create a shared repository for branches to share storage space.
 
     New branches created under the repository directory will store their
-    revisions in the repository, not in the branch directory.
+    revisions in the repository, not in the branch directory.  For branches
+    with shared history, this reduces the amount of storage needed and 
+    speeds up the creation of new branches.
 
-    If the --no-trees option is used then the branches in the repository
-    will not have working trees by default.
+    If the --no-trees option is given then the branches in the repository
+    will not have working trees by default.  They will still exist as 
+    directories on disk, but they will not have separate copies of the 
+    files at a certain revision.  This can be useful for repositories that
+    store branches which are interacted with through checkouts or remote
+    branches, such as on a server.
 
     :Examples:
-        Create a shared repositories holding just branches::
+        Create a shared repository holding just branches::
 
             bzr init-repo --no-trees repo
             bzr init repo/trunk
@@ -1830,13 +1852,27 @@
 
             bzr diff -r1
 
-        Difference between revision 2 and revision 1::
-
-            bzr diff -r1..2
-
-        Difference between revision 2 and revision 1 for branch xxx::
-
-            bzr diff -r1..2 xxx
+        Difference between revision 3 and revision 1::
+
+            bzr diff -r1..3
+
+        Difference between revision 3 and revision 1 for branch xxx::
+
+            bzr diff -r1..3 xxx
+
+        To see the changes introduced in revision X::
+        
+            bzr diff -cX
+
+        Note that in the case of a merge, the -c option shows the changes
+        compared to the left hand parent. To see the changes against
+        another parent, use::
+
+            bzr diff -r<chosen_parent>..X
+
+        The changes introduced by revision 2 (equivalent to -r1..2)::
+
+            bzr diff -c2
 
         Show just the differences for file NEWS::
 
@@ -1935,21 +1971,17 @@
     def run(self, show_ids=False):
         tree = WorkingTree.open_containing(u'.')[0]
         tree.lock_read()
-        try:
-            old = tree.basis_tree()
-            old.lock_read()
-            try:
-                for path, ie in old.inventory.iter_entries():
-                    if not tree.has_id(ie.file_id):
-                        self.outf.write(path)
-                        if show_ids:
-                            self.outf.write(' ')
-                            self.outf.write(ie.file_id)
-                        self.outf.write('\n')
-            finally:
-                old.unlock()
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        old = tree.basis_tree()
+        old.lock_read()
+        self.add_cleanup(old.unlock)
+        for path, ie in old.inventory.iter_entries():
+            if not tree.has_id(ie.file_id):
+                self.outf.write(path)
+                if show_ids:
+                    self.outf.write(' ')
+                    self.outf.write(ie.file_id)
+                self.outf.write('\n')
 
 
 class cmd_modified(Command):
@@ -1991,28 +2023,24 @@
     def run(self, null=False):
         wt = WorkingTree.open_containing(u'.')[0]
         wt.lock_read()
-        try:
-            basis = wt.basis_tree()
-            basis.lock_read()
-            try:
-                basis_inv = basis.inventory
-                inv = wt.inventory
-                for file_id in inv:
-                    if file_id in basis_inv:
-                        continue
-                    if inv.is_root(file_id) and len(basis_inv) == 0:
-                        continue
-                    path = inv.id2path(file_id)
-                    if not os.access(osutils.abspath(path), os.F_OK):
-                        continue
-                    if null:
-                        self.outf.write(path + '\0')
-                    else:
-                        self.outf.write(osutils.quotefn(path) + '\n')
-            finally:
-                basis.unlock()
-        finally:
-            wt.unlock()
+        self.add_cleanup(wt.unlock)
+        basis = wt.basis_tree()
+        basis.lock_read()
+        self.add_cleanup(basis.unlock)
+        basis_inv = basis.inventory
+        inv = wt.inventory
+        for file_id in inv:
+            if file_id in basis_inv:
+                continue
+            if inv.is_root(file_id) and len(basis_inv) == 0:
+                continue
+            path = inv.id2path(file_id)
+            if not os.access(osutils.abspath(path), os.F_OK):
+                continue
+            if null:
+                self.outf.write(path + '\0')
+            else:
+                self.outf.write(osutils.quotefn(path) + '\n')
 
 
 class cmd_root(Command):
@@ -2278,8 +2306,9 @@
         filter_by_dir = False
         if file_list:
             # find the file ids to log and check for directory filtering
-            b, file_info_list, rev1, rev2 = _get_info_for_log_files(revision,
-                file_list)
+            b, file_info_list, rev1, rev2 = _get_info_for_log_files(
+                revision, file_list)
+            self.add_cleanup(b.unlock)
             for relpath, file_id, kind in file_info_list:
                 if file_id is None:
                     raise errors.BzrCommandError(
@@ -2303,6 +2332,8 @@
                 location = '.'
             dir, relpath = bzrdir.BzrDir.open_containing(location)
             b = dir.open_branch()
+            b.lock_read()
+            self.add_cleanup(b.unlock)
             rev1, rev2 = _get_revision_range(revision, b, self.name())
 
         # Decide on the type of delta & diff filtering to use
@@ -2318,44 +2349,43 @@
         else:
             diff_type = 'full'
 
-        b.lock_read()
-        try:
-            # Build the log formatter
-            if log_format is None:
-                log_format = log.log_formatter_registry.get_default(b)
-            lf = log_format(show_ids=show_ids, to_file=self.outf,
-                            show_timezone=timezone,
-                            delta_format=get_verbosity_level(),
-                            levels=levels,
-                            show_advice=levels is None)
-
-            # Choose the algorithm for doing the logging. It's annoying
-            # having multiple code paths like this but necessary until
-            # the underlying repository format is faster at generating
-            # deltas or can provide everything we need from the indices.
-            # The default algorithm - match-using-deltas - works for
-            # multiple files and directories and is faster for small
-            # amounts of history (200 revisions say). However, it's too
-            # slow for logging a single file in a repository with deep
-            # history, i.e. > 10K revisions. In the spirit of "do no
-            # evil when adding features", we continue to use the
-            # original algorithm - per-file-graph - for the "single
-            # file that isn't a directory without showing a delta" case.
-            partial_history = revision and b.repository._format.supports_chks
-            match_using_deltas = (len(file_ids) != 1 or filter_by_dir
-                or delta_type or partial_history)
-
-            # Build the LogRequest and execute it
-            if len(file_ids) == 0:
-                file_ids = None
-            rqst = make_log_request_dict(
-                direction=direction, specific_fileids=file_ids,
-                start_revision=rev1, end_revision=rev2, limit=limit,
-                message_search=message, delta_type=delta_type,
-                diff_type=diff_type, _match_using_deltas=match_using_deltas)
-            Logger(b, rqst).show(lf)
-        finally:
-            b.unlock()
+        # Build the log formatter
+        if log_format is None:
+            log_format = log.log_formatter_registry.get_default(b)
+        # Make a non-encoding output to include the diffs - bug 328007
+        unencoded_output = ui.ui_factory.make_output_stream(encoding_type='exact')
+        lf = log_format(show_ids=show_ids, to_file=self.outf,
+                        to_exact_file=unencoded_output,
+                        show_timezone=timezone,
+                        delta_format=get_verbosity_level(),
+                        levels=levels,
+                        show_advice=levels is None)
+
+        # Choose the algorithm for doing the logging. It's annoying
+        # having multiple code paths like this but necessary until
+        # the underlying repository format is faster at generating
+        # deltas or can provide everything we need from the indices.
+        # The default algorithm - match-using-deltas - works for
+        # multiple files and directories and is faster for small
+        # amounts of history (200 revisions say). However, it's too
+        # slow for logging a single file in a repository with deep
+        # history, i.e. > 10K revisions. In the spirit of "do no
+        # evil when adding features", we continue to use the
+        # original algorithm - per-file-graph - for the "single
+        # file that isn't a directory without showing a delta" case.
+        partial_history = revision and b.repository._format.supports_chks
+        match_using_deltas = (len(file_ids) != 1 or filter_by_dir
+            or delta_type or partial_history)
+
+        # Build the LogRequest and execute it
+        if len(file_ids) == 0:
+            file_ids = None
+        rqst = make_log_request_dict(
+            direction=direction, specific_fileids=file_ids,
+            start_revision=rev1, end_revision=rev2, limit=limit,
+            message_search=message, delta_type=delta_type,
+            diff_type=diff_type, _match_using_deltas=match_using_deltas)
+        Logger(b, rqst).show(lf)
 
 
 def _get_revision_range(revisionspec_list, branch, command_name):
@@ -2425,9 +2455,12 @@
     @display_command
     def run(self, filename):
         tree, relpath = WorkingTree.open_containing(filename)
+        file_id = tree.path2id(relpath)
         b = tree.branch
-        file_id = tree.path2id(relpath)
-        for revno, revision_id, what in log.find_touching_revisions(b, file_id):
+        b.lock_read()
+        self.add_cleanup(b.unlock)
+        touching_revs = log.find_touching_revisions(b, file_id)
+        for revno, revision_id, what in touching_revs:
             self.outf.write("%6d %s\n" % (revno, what))
 
 
@@ -2486,7 +2519,7 @@
         if from_root:
             if relpath:
                 prefix = relpath + '/'
-        elif fs_path != '.':
+        elif fs_path != '.' and not fs_path.endswith('/'):
             prefix = fs_path + '/'
 
         if revision is not None or tree is None:
@@ -2501,53 +2534,51 @@
                 note("Ignoring files outside view. View is %s" % view_str)
 
         tree.lock_read()
-        try:
-            for fp, fc, fkind, fid, entry in tree.list_files(include_root=False,
-                from_dir=relpath, recursive=recursive):
-                # Apply additional masking
-                if not all and not selection[fc]:
-                    continue
-                if kind is not None and fkind != kind:
-                    continue
-                if apply_view:
-                    try:
-                        if relpath:
-                            fullpath = osutils.pathjoin(relpath, fp)
-                        else:
-                            fullpath = fp
-                        views.check_path_in_view(tree, fullpath)
-                    except errors.FileOutsideView:
-                        continue
+        self.add_cleanup(tree.unlock)
+        for fp, fc, fkind, fid, entry in tree.list_files(include_root=False,
+            from_dir=relpath, recursive=recursive):
+            # Apply additional masking
+            if not all and not selection[fc]:
+                continue
+            if kind is not None and fkind != kind:
+                continue
+            if apply_view:
+                try:
+                    if relpath:
+                        fullpath = osutils.pathjoin(relpath, fp)
+                    else:
+                        fullpath = fp
+                    views.check_path_in_view(tree, fullpath)
+                except errors.FileOutsideView:
+                    continue
 
-                # Output the entry
-                if prefix:
-                    fp = osutils.pathjoin(prefix, fp)
-                kindch = entry.kind_character()
-                outstring = fp + kindch
-                ui.ui_factory.clear_term()
-                if verbose:
-                    outstring = '%-8s %s' % (fc, outstring)
-                    if show_ids and fid is not None:
-                        outstring = "%-50s %s" % (outstring, fid)
+            # Output the entry
+            if prefix:
+                fp = osutils.pathjoin(prefix, fp)
+            kindch = entry.kind_character()
+            outstring = fp + kindch
+            ui.ui_factory.clear_term()
+            if verbose:
+                outstring = '%-8s %s' % (fc, outstring)
+                if show_ids and fid is not None:
+                    outstring = "%-50s %s" % (outstring, fid)
+                self.outf.write(outstring + '\n')
+            elif null:
+                self.outf.write(fp + '\0')
+                if show_ids:
+                    if fid is not None:
+                        self.outf.write(fid)
+                    self.outf.write('\0')
+                self.outf.flush()
+            else:
+                if show_ids:
+                    if fid is not None:
+                        my_id = fid
+                    else:
+                        my_id = ''
+                    self.outf.write('%-50s %s\n' % (outstring, my_id))
+                else:
                     self.outf.write(outstring + '\n')
-                elif null:
-                    self.outf.write(fp + '\0')
-                    if show_ids:
-                        if fid is not None:
-                            self.outf.write(fid)
-                        self.outf.write('\0')
-                    self.outf.flush()
-                else:
-                    if show_ids:
-                        if fid is not None:
-                            my_id = fid
-                        else:
-                            my_id = ''
-                        self.outf.write('%-50s %s\n' % (outstring, my_id))
-                    else:
-                        self.outf.write(outstring + '\n')
-        finally:
-            tree.unlock()
 
 
 class cmd_unknowns(Command):
@@ -2568,10 +2599,23 @@
 
     See ``bzr help patterns`` for details on the syntax of patterns.
 
+    If a .bzrignore file does not exist, the ignore command
+    will create one and add the specified files or patterns to the newly
+    created file. The ignore command will also automatically add the 
+    .bzrignore file to be versioned. Creating a .bzrignore file without
+    the use of the ignore command will require an explicit add command.
+
     To remove patterns from the ignore list, edit the .bzrignore file.
     After adding, editing or deleting that file either indirectly by
     using this command or directly by using an editor, be sure to commit
     it.
+    
+    Patterns prefixed with '!' are exceptions to ignore patterns and take
+    precedence over regular ignores.  Such exceptions are used to specify
+    files that should be versioned which would otherwise be ignored.
+    
+    Patterns prefixed with '!!' act as regular ignore patterns, but have
+    precedence over the '!' exception patterns.
 
     Note: ignore patterns containing shell wildcards must be quoted from
     the shell on Unix.
@@ -2581,10 +2625,14 @@
 
             bzr ignore ./Makefile
 
-        Ignore class files in all directories::
+        Ignore .class files in all directories...::
 
             bzr ignore "*.class"
 
+        ...but do not ignore "special.class"::
+
+            bzr ignore "!special.class"
+
         Ignore .o files under the lib directory::
 
             bzr ignore "lib/**/*.o"
@@ -2596,6 +2644,13 @@
         Ignore everything but the "debian" toplevel directory::
 
             bzr ignore "RE:(?!debian/).*"
+        
+        Ignore everything except the "local" toplevel directory,
+        but always ignore "*~" autosave files, even under local/::
+        
+            bzr ignore "*"
+            bzr ignore "!./local"
+            bzr ignore "!!*~"
     """
 
     _see_also = ['status', 'ignored', 'patterns']
@@ -2659,15 +2714,13 @@
     def run(self):
         tree = WorkingTree.open_containing(u'.')[0]
         tree.lock_read()
-        try:
-            for path, file_class, kind, file_id, entry in tree.list_files():
-                if file_class != 'I':
-                    continue
-                ## XXX: Slightly inefficient since this was already calculated
-                pat = tree.is_ignored(path)
-                self.outf.write('%-50s %s\n' % (path, pat))
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        for path, file_class, kind, file_id, entry in tree.list_files():
+            if file_class != 'I':
+                continue
+            ## XXX: Slightly inefficient since this was already calculated
+            pat = tree.is_ignored(path)
+            self.outf.write('%-50s %s\n' % (path, pat))
 
 
 class cmd_lookup_revision(Command):
@@ -2776,17 +2829,17 @@
         tree, branch, relpath = \
             bzrdir.BzrDir.open_containing_tree_or_branch(filename)
         branch.lock_read()
-        try:
-            return self._run(tree, branch, relpath, filename, revision,
-                             name_from_revision, filters)
-        finally:
-            branch.unlock()
+        self.add_cleanup(branch.unlock)
+        return self._run(tree, branch, relpath, filename, revision,
+                         name_from_revision, filters)
 
     def _run(self, tree, b, relpath, filename, revision, name_from_revision,
         filtered):
         if tree is None:
             tree = b.basis_tree()
         rev_tree = _get_one_revision_tree('cat', revision, branch=b)
+        rev_tree.lock_read()
+        self.add_cleanup(rev_tree.unlock)
 
         old_file_id = rev_tree.path2id(relpath)
 
@@ -2827,8 +2880,10 @@
             chunks = content.splitlines(True)
             content = filtered_output_bytes(chunks, filters,
                 ContentFilterContext(relpath, rev_tree))
+            self.cleanup_now()
             self.outf.writelines(content)
         else:
+            self.cleanup_now()
             self.outf.write(content)
 
 
@@ -2941,6 +2996,9 @@
              Option('strict',
                     help="Refuse to commit if there are unknown "
                     "files in the working tree."),
+             Option('commit-time', type=str,
+                    help="Manually set a commit time using commit date "
+                    "format, e.g. '2009-10-10 08:00:00 +0100'."),
              ListOption('fixes', type=str,
                     help="Mark a bug as being fixed by this revision "
                          "(see \"bzr help bugs\")."),
@@ -2953,9 +3011,9 @@
                          "the master branch until a normal commit "
                          "is performed."
                     ),
-              Option('show-diff',
-                     help='When no message is supplied, show the diff along'
-                     ' with the status summary in the message editor.'),
+             Option('show-diff',
+                    help='When no message is supplied, show the diff along'
+                    ' with the status summary in the message editor.'),
              ]
     aliases = ['ci', 'checkin']
 
@@ -2980,7 +3038,7 @@
 
     def run(self, message=None, file=None, verbose=False, selected_list=None,
             unchanged=False, strict=False, local=False, fixes=None,
-            author=None, show_diff=False, exclude=None):
+            author=None, show_diff=False, exclude=None, commit_time=None):
         from bzrlib.errors import (
             PointlessCommit,
             ConflictsInTree,
@@ -2992,6 +3050,14 @@
             make_commit_message_template_encoded
         )
 
+        commit_stamp = offset = None
+        if commit_time is not None:
+            try:
+                commit_stamp, offset = timestamp.parse_patch_date(commit_time)
+            except ValueError, e:
+                raise errors.BzrCommandError(
+                    "Could not parse --commit-time: " + str(e))
+
         # TODO: Need a blackbox test for invoking the external editor; may be
         # slightly problematic to run this cross-platform.
 
@@ -3017,9 +3083,27 @@
         if local and not tree.branch.get_bound_location():
             raise errors.LocalRequiresBoundBranch()
 
+        if message is not None:
+            try:
+                file_exists = osutils.lexists(message)
+            except UnicodeError:
+                # The commit message contains unicode characters that can't be
+                # represented in the filesystem encoding, so that can't be a
+                # file.
+                file_exists = False
+            if file_exists:
+                warning_msg = (
+                    'The commit message is a file name: "%(f)s".\n'
+                    '(use --file "%(f)s" to take commit message from that file)'
+                    % { 'f': message })
+                ui.ui_factory.show_warning(warning_msg)
+
         def get_message(commit_obj):
             """Callback to get commit message"""
             my_message = message
+            if my_message is not None and '\r' in my_message:
+                my_message = my_message.replace('\r\n', '\n')
+                my_message = my_message.replace('\r', '\n')
             if my_message is None and not file:
                 t = make_commit_message_template_encoded(tree,
                         selected_list, diff=show_diff,
@@ -3049,7 +3133,8 @@
                         specific_files=selected_list,
                         allow_pointless=unchanged, strict=strict, local=local,
                         reporter=None, verbose=verbose, revprops=properties,
-                        authors=author,
+                        authors=author, timestamp=commit_stamp,
+                        timezone=offset,
                         exclude=safe_relpath_files(tree, exclude))
         except PointlessCommit:
             # FIXME: This should really happen before the file is read in;
@@ -3359,8 +3444,8 @@
     def get_transport_type(typestring):
         """Parse and return a transport specifier."""
         if typestring == "sftp":
-            from bzrlib.transport.sftp import SFTPAbsoluteServer
-            return SFTPAbsoluteServer
+            from bzrlib.tests import stub_sftp
+            return stub_sftp.SFTPAbsoluteServer
         if typestring == "memory":
             from bzrlib.transport.memory import MemoryServer
             return MemoryServer
@@ -3465,32 +3550,29 @@
             verbose = not is_quiet()
             # TODO: should possibly lock the history file...
             benchfile = open(".perf_history", "at", buffering=1)
+            self.add_cleanup(benchfile.close)
         else:
             test_suite_factory = None
             benchfile = None
-        try:
-            selftest_kwargs = {"verbose": verbose,
-                              "pattern": pattern,
-                              "stop_on_failure": one,
-                              "transport": transport,
-                              "test_suite_factory": test_suite_factory,
-                              "lsprof_timed": lsprof_timed,
-                              "lsprof_tests": lsprof_tests,
-                              "bench_history": benchfile,
-                              "matching_tests_first": first,
-                              "list_only": list_only,
-                              "random_seed": randomize,
-                              "exclude_pattern": exclude,
-                              "strict": strict,
-                              "load_list": load_list,
-                              "debug_flags": debugflag,
-                              "starting_with": starting_with
-                              }
-            selftest_kwargs.update(self.additional_selftest_args)
-            result = selftest(**selftest_kwargs)
-        finally:
-            if benchfile is not None:
-                benchfile.close()
+        selftest_kwargs = {"verbose": verbose,
+                          "pattern": pattern,
+                          "stop_on_failure": one,
+                          "transport": transport,
+                          "test_suite_factory": test_suite_factory,
+                          "lsprof_timed": lsprof_timed,
+                          "lsprof_tests": lsprof_tests,
+                          "bench_history": benchfile,
+                          "matching_tests_first": first,
+                          "list_only": list_only,
+                          "random_seed": randomize,
+                          "exclude_pattern": exclude,
+                          "strict": strict,
+                          "load_list": load_list,
+                          "debug_flags": debugflag,
+                          "starting_with": starting_with
+                          }
+        selftest_kwargs.update(self.additional_selftest_args)
+        result = selftest(**selftest_kwargs)
         return int(not result)
 
 
@@ -3535,20 +3617,16 @@
         branch1 = Branch.open_containing(branch)[0]
         branch2 = Branch.open_containing(other)[0]
         branch1.lock_read()
-        try:
-            branch2.lock_read()
-            try:
-                last1 = ensure_null(branch1.last_revision())
-                last2 = ensure_null(branch2.last_revision())
-
-                graph = branch1.repository.get_graph(branch2.repository)
-                base_rev_id = graph.find_unique_lca(last1, last2)
-
-                print 'merge base is revision %s' % base_rev_id
-            finally:
-                branch2.unlock()
-        finally:
-            branch1.unlock()
+        self.add_cleanup(branch1.unlock)
+        branch2.lock_read()
+        self.add_cleanup(branch2.unlock)
+        last1 = ensure_null(branch1.last_revision())
+        last2 = ensure_null(branch2.last_revision())
+
+        graph = branch1.repository.get_graph(branch2.repository)
+        base_rev_id = graph.find_unique_lca(last1, last2)
+
+        print 'merge base is revision %s' % base_rev_id
 
 
 class cmd_merge(Command):
@@ -3587,7 +3665,12 @@
     committed to record the result of the merge.
 
     merge refuses to run if there are any uncommitted changes, unless
-    --force is given.
+    --force is given. The --force option can also be used to create a
+    merge revision which has more than two parents.
+
+    If one would like to merge changes from the working tree of the other
+    branch without merging any committed revisions, the --uncommitted option
+    can be given.
 
     To select only some changes to merge, use "merge -i", which will prompt
     you to apply each diff hunk and file change, similar to "shelve".
@@ -3605,9 +3688,16 @@
 
             bzr merge -r 81..82 ../bzr.dev
 
-        To apply a merge directive contained in /tmp/merge:
+        To apply a merge directive contained in /tmp/merge::
 
             bzr merge /tmp/merge
+
+        To create a merge revision with three parents from two branches
+        feature1a and feature1b:
+
+            bzr merge ../feature1a
+            bzr merge ../feature1b --force
+            bzr commit -m 'revision with three parents'
     """
 
     encoding_type = 'exact'
@@ -3671,82 +3761,76 @@
         view_info = _get_view_info_for_change_reporter(tree)
         change_reporter = delta._ChangeReporter(
             unversioned_filter=tree.is_ignored, view_info=view_info)
-        cleanups = []
-        try:
-            pb = ui.ui_factory.nested_progress_bar()
-            cleanups.append(pb.finished)
-            tree.lock_write()
-            cleanups.append(tree.unlock)
-            if location is not None:
-                try:
-                    mergeable = bundle.read_mergeable_from_url(location,
-                        possible_transports=possible_transports)
-                except errors.NotABundle:
-                    mergeable = None
-                else:
-                    if uncommitted:
-                        raise errors.BzrCommandError('Cannot use --uncommitted'
-                            ' with bundles or merge directives.')
-
-                    if revision is not None:
-                        raise errors.BzrCommandError(
-                            'Cannot use -r with merge directives or bundles')
-                    merger, verified = _mod_merge.Merger.from_mergeable(tree,
-                       mergeable, pb)
-
-            if merger is None and uncommitted:
-                if revision is not None and len(revision) > 0:
-                    raise errors.BzrCommandError('Cannot use --uncommitted and'
-                        ' --revision at the same time.')
-                merger = self.get_merger_from_uncommitted(tree, location, pb,
-                                                          cleanups)
-                allow_pending = False
-
-            if merger is None:
-                merger, allow_pending = self._get_merger_from_branch(tree,
-                    location, revision, remember, possible_transports, pb)
-
-            merger.merge_type = merge_type
-            merger.reprocess = reprocess
-            merger.show_base = show_base
-            self.sanity_check_merger(merger)
-            if (merger.base_rev_id == merger.other_rev_id and
-                merger.other_rev_id is not None):
-                note('Nothing to do.')
+        pb = ui.ui_factory.nested_progress_bar()
+        self.add_cleanup(pb.finished)
+        tree.lock_write()
+        self.add_cleanup(tree.unlock)
+        if location is not None:
+            try:
+                mergeable = bundle.read_mergeable_from_url(location,
+                    possible_transports=possible_transports)
+            except errors.NotABundle:
+                mergeable = None
+            else:
+                if uncommitted:
+                    raise errors.BzrCommandError('Cannot use --uncommitted'
+                        ' with bundles or merge directives.')
+
+                if revision is not None:
+                    raise errors.BzrCommandError(
+                        'Cannot use -r with merge directives or bundles')
+                merger, verified = _mod_merge.Merger.from_mergeable(tree,
+                   mergeable, pb)
+
+        if merger is None and uncommitted:
+            if revision is not None and len(revision) > 0:
+                raise errors.BzrCommandError('Cannot use --uncommitted and'
+                    ' --revision at the same time.')
+            merger = self.get_merger_from_uncommitted(tree, location, pb)
+            allow_pending = False
+
+        if merger is None:
+            merger, allow_pending = self._get_merger_from_branch(tree,
+                location, revision, remember, possible_transports, pb)
+
+        merger.merge_type = merge_type
+        merger.reprocess = reprocess
+        merger.show_base = show_base
+        self.sanity_check_merger(merger)
+        if (merger.base_rev_id == merger.other_rev_id and
+            merger.other_rev_id is not None):
+            note('Nothing to do.')
+            return 0
+        if pull:
+            if merger.interesting_files is not None:
+                raise errors.BzrCommandError('Cannot pull individual files')
+            if (merger.base_rev_id == tree.last_revision()):
+                result = tree.pull(merger.other_branch, False,
+                                   merger.other_rev_id)
+                result.report(self.outf)
                 return 0
-            if pull:
-                if merger.interesting_files is not None:
-                    raise errors.BzrCommandError('Cannot pull individual files')
-                if (merger.base_rev_id == tree.last_revision()):
-                    result = tree.pull(merger.other_branch, False,
-                                       merger.other_rev_id)
-                    result.report(self.outf)
-                    return 0
-            if merger.this_basis is None:
-                raise errors.BzrCommandError(
-                    "This branch has no commits."
-                    " (perhaps you would prefer 'bzr pull')")
-            if preview:
-                return self._do_preview(merger, cleanups)
-            elif interactive:
-                return self._do_interactive(merger, cleanups)
-            else:
-                return self._do_merge(merger, change_reporter, allow_pending,
-                                      verified)
-        finally:
-            for cleanup in reversed(cleanups):
-                cleanup()
+        if merger.this_basis is None:
+            raise errors.BzrCommandError(
+                "This branch has no commits."
+                " (perhaps you would prefer 'bzr pull')")
+        if preview:
+            return self._do_preview(merger)
+        elif interactive:
+            return self._do_interactive(merger)
+        else:
+            return self._do_merge(merger, change_reporter, allow_pending,
+                                  verified)
 
-    def _get_preview(self, merger, cleanups):
+    def _get_preview(self, merger):
         tree_merger = merger.make_merger()
         tt = tree_merger.make_preview_transform()
-        cleanups.append(tt.finalize)
+        self.add_cleanup(tt.finalize)
         result_tree = tt.get_preview_tree()
         return result_tree
 
-    def _do_preview(self, merger, cleanups):
+    def _do_preview(self, merger):
         from bzrlib.diff import show_diff_trees
-        result_tree = self._get_preview(merger, cleanups)
+        result_tree = self._get_preview(merger)
         show_diff_trees(merger.this_tree, result_tree, self.outf,
                         old_label='', new_label='')
 
@@ -3762,7 +3846,7 @@
         else:
             return 0
 
-    def _do_interactive(self, merger, cleanups):
+    def _do_interactive(self, merger):
         """Perform an interactive merge.
 
         This works by generating a preview tree of the merge, then using
@@ -3770,12 +3854,15 @@
         and the preview tree.
         """
         from bzrlib import shelf_ui
-        result_tree = self._get_preview(merger, cleanups)
+        result_tree = self._get_preview(merger)
         writer = bzrlib.option.diff_writer_registry.get()
         shelver = shelf_ui.Shelver(merger.this_tree, result_tree, destroy=True,
                                    reporter=shelf_ui.ApplyReporter(),
                                    diff_writer=writer(sys.stdout))
-        shelver.run()
+        try:
+            shelver.run()
+        finally:
+            shelver.finalize()
 
     def sanity_check_merger(self, merger):
         if (merger.show_base and
@@ -3841,14 +3928,12 @@
             allow_pending = True
         return merger, allow_pending
 
-    def get_merger_from_uncommitted(self, tree, location, pb, cleanups):
+    def get_merger_from_uncommitted(self, tree, location, pb):
         """Get a merger for uncommitted changes.
 
         :param tree: The tree the merger should apply to.
         :param location: The location containing uncommitted changes.
         :param pb: The progress bar to use for showing progress.
-        :param cleanups: A list of operations to perform to clean up the
-            temporary directories, unfinalized objects, etc.
         """
         location = self._select_branch_location(tree, location)[0]
         other_tree, other_path = WorkingTree.open_containing(location)
@@ -3941,63 +4026,61 @@
             merge_type = _mod_merge.Merge3Merger
         tree, file_list = tree_files(file_list)
         tree.lock_write()
-        try:
-            parents = tree.get_parent_ids()
-            if len(parents) != 2:
-                raise errors.BzrCommandError("Sorry, remerge only works after normal"
-                                             " merges.  Not cherrypicking or"
-                                             " multi-merges.")
-            repository = tree.branch.repository
-            interesting_ids = None
-            new_conflicts = []
-            conflicts = tree.conflicts()
-            if file_list is not None:
-                interesting_ids = set()
-                for filename in file_list:
-                    file_id = tree.path2id(filename)
-                    if file_id is None:
-                        raise errors.NotVersionedError(filename)
-                    interesting_ids.add(file_id)
-                    if tree.kind(file_id) != "directory":
-                        continue
+        self.add_cleanup(tree.unlock)
+        parents = tree.get_parent_ids()
+        if len(parents) != 2:
+            raise errors.BzrCommandError("Sorry, remerge only works after normal"
+                                         " merges.  Not cherrypicking or"
+                                         " multi-merges.")
+        repository = tree.branch.repository
+        interesting_ids = None
+        new_conflicts = []
+        conflicts = tree.conflicts()
+        if file_list is not None:
+            interesting_ids = set()
+            for filename in file_list:
+                file_id = tree.path2id(filename)
+                if file_id is None:
+                    raise errors.NotVersionedError(filename)
+                interesting_ids.add(file_id)
+                if tree.kind(file_id) != "directory":
+                    continue
 
-                    for name, ie in tree.inventory.iter_entries(file_id):
-                        interesting_ids.add(ie.file_id)
-                new_conflicts = conflicts.select_conflicts(tree, file_list)[0]
-            else:
-                # Remerge only supports resolving contents conflicts
-                allowed_conflicts = ('text conflict', 'contents conflict')
-                restore_files = [c.path for c in conflicts
-                                 if c.typestring in allowed_conflicts]
-            _mod_merge.transform_tree(tree, tree.basis_tree(), interesting_ids)
-            tree.set_conflicts(ConflictList(new_conflicts))
-            if file_list is not None:
-                restore_files = file_list
-            for filename in restore_files:
-                try:
-                    restore(tree.abspath(filename))
-                except errors.NotConflicted:
-                    pass
-            # Disable pending merges, because the file texts we are remerging
-            # have not had those merges performed.  If we use the wrong parents
-            # list, we imply that the working tree text has seen and rejected
-            # all the changes from the other tree, when in fact those changes
-            # have not yet been seen.
-            pb = ui.ui_factory.nested_progress_bar()
-            tree.set_parent_ids(parents[:1])
+                for name, ie in tree.inventory.iter_entries(file_id):
+                    interesting_ids.add(ie.file_id)
+            new_conflicts = conflicts.select_conflicts(tree, file_list)[0]
+        else:
+            # Remerge only supports resolving contents conflicts
+            allowed_conflicts = ('text conflict', 'contents conflict')
+            restore_files = [c.path for c in conflicts
+                             if c.typestring in allowed_conflicts]
+        _mod_merge.transform_tree(tree, tree.basis_tree(), interesting_ids)
+        tree.set_conflicts(ConflictList(new_conflicts))
+        if file_list is not None:
+            restore_files = file_list
+        for filename in restore_files:
             try:
-                merger = _mod_merge.Merger.from_revision_ids(pb,
-                                                             tree, parents[1])
-                merger.interesting_ids = interesting_ids
-                merger.merge_type = merge_type
-                merger.show_base = show_base
-                merger.reprocess = reprocess
-                conflicts = merger.do_merge()
-            finally:
-                tree.set_parent_ids(parents)
-                pb.finished()
+                restore(tree.abspath(filename))
+            except errors.NotConflicted:
+                pass
+        # Disable pending merges, because the file texts we are remerging
+        # have not had those merges performed.  If we use the wrong parents
+        # list, we imply that the working tree text has seen and rejected
+        # all the changes from the other tree, when in fact those changes
+        # have not yet been seen.
+        pb = ui.ui_factory.nested_progress_bar()
+        tree.set_parent_ids(parents[:1])
+        try:
+            merger = _mod_merge.Merger.from_revision_ids(pb,
+                                                         tree, parents[1])
+            merger.interesting_ids = interesting_ids
+            merger.merge_type = merge_type
+            merger.show_base = show_base
+            merger.reprocess = reprocess
+            conflicts = merger.do_merge()
         finally:
-            tree.unlock()
+            tree.set_parent_ids(parents)
+            pb.finished()
         if conflicts > 0:
             return 1
         else:
@@ -4025,17 +4108,29 @@
     name.  If you name a directory, all the contents of that directory will be
     reverted.
 
-    Any files that have been newly added since that revision will be deleted,
-    with a backup kept if appropriate.  Directories containing unknown files
-    will not be deleted.
+    If you have newly added files since the target revision, they will be
+    removed.  If the files to be removed have been changed, backups will be
+    created as above.  Directories containing unknown files will not be
+    deleted.
 
-    The working tree contains a list of pending merged revisions, which will
-    be included as parents in the next commit.  Normally, revert clears that
-    list as well as reverting the files.  If any files are specified, revert
-    leaves the pending merge list alone and reverts only the files.  Use "bzr
-    revert ." in the tree root to revert all files but keep the merge record,
-    and "bzr revert --forget-merges" to clear the pending merge list without
+    The working tree contains a list of revisions that have been merged but
+    not yet committed. These revisions will be included as additional parents
+    of the next commit.  Normally, using revert clears that list as well as
+    reverting the files.  If any files are specified, revert leaves the list
+    of uncommitted merges alone and reverts only the files.  Use ``bzr revert
+    .`` in the tree root to revert all files but keep the recorded merges,
+    and ``bzr revert --forget-merges`` to clear the pending merge list without
     reverting any files.
+
+    Using "bzr revert --forget-merges", it is possible to apply all of the
+    changes from a branch in a single revision.  To do this, perform the merge
+    as desired.  Then doing revert with the "--forget-merges" option will keep
+    the content of the tree as it was, but it will clear the list of pending
+    merges.  The next commit will then contain all of the changes that are
+    present in the other branch, but without any other parent revisions.
+    Because this technique forgets where these changes originated, it may
+    cause additional conflicts on later merges involving the same source and
+    target branches.
     """
 
     _see_also = ['cat', 'export']
@@ -4051,13 +4146,11 @@
             forget_merges=None):
         tree, file_list = tree_files(file_list)
         tree.lock_write()
-        try:
-            if forget_merges:
-                tree.set_parent_ids(tree.get_parent_ids()[:1])
-            else:
-                self._revert_tree_to_revision(tree, revision, file_list, no_backup)
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        if forget_merges:
+            tree.set_parent_ids(tree.get_parent_ids()[:1])
+        else:
+            self._revert_tree_to_revision(tree, revision, file_list, no_backup)
 
     @staticmethod
     def _revert_tree_to_revision(tree, revision, file_list, no_backup):
@@ -4122,6 +4215,10 @@
     To filter on a range of revisions, you can use the command -r begin..end
     -r revision requests a specific revision, -r ..end or -r begin.. are
     also valid.
+            
+    :Exit values:
+        1 - some missing revisions
+        0 - no missing revisions
 
     :Examples:
 
@@ -4210,79 +4307,74 @@
         if remote_branch.base == local_branch.base:
             remote_branch = local_branch
 
+        local_branch.lock_read()
+        self.add_cleanup(local_branch.unlock)
         local_revid_range = _revision_range_to_revid_range(
             _get_revision_range(my_revision, local_branch,
                 self.name()))
 
+        remote_branch.lock_read()
+        self.add_cleanup(remote_branch.unlock)
         remote_revid_range = _revision_range_to_revid_range(
             _get_revision_range(revision,
                 remote_branch, self.name()))
 
-        local_branch.lock_read()
-        try:
-            remote_branch.lock_read()
-            try:
-                local_extra, remote_extra = find_unmerged(
-                    local_branch, remote_branch, restrict,
-                    backward=not reverse,
-                    include_merges=include_merges,
-                    local_revid_range=local_revid_range,
-                    remote_revid_range=remote_revid_range)
-
-                if log_format is None:
-                    registry = log.log_formatter_registry
-                    log_format = registry.get_default(local_branch)
-                lf = log_format(to_file=self.outf,
-                                show_ids=show_ids,
-                                show_timezone='original')
-
-                status_code = 0
-                if local_extra and not theirs_only:
-                    message("You have %d extra revision(s):\n" %
-                        len(local_extra))
-                    for revision in iter_log_revisions(local_extra,
-                                        local_branch.repository,
-                                        verbose):
-                        lf.log_revision(revision)
-                    printed_local = True
-                    status_code = 1
-                else:
-                    printed_local = False
-
-                if remote_extra and not mine_only:
-                    if printed_local is True:
-                        message("\n\n\n")
-                    message("You are missing %d revision(s):\n" %
-                        len(remote_extra))
-                    for revision in iter_log_revisions(remote_extra,
-                                        remote_branch.repository,
-                                        verbose):
-                        lf.log_revision(revision)
-                    status_code = 1
-
-                if mine_only and not local_extra:
-                    # We checked local, and found nothing extra
-                    message('This branch is up to date.\n')
-                elif theirs_only and not remote_extra:
-                    # We checked remote, and found nothing extra
-                    message('Other branch is up to date.\n')
-                elif not (mine_only or theirs_only or local_extra or
-                          remote_extra):
-                    # We checked both branches, and neither one had extra
-                    # revisions
-                    message("Branches are up to date.\n")
-            finally:
-                remote_branch.unlock()
-        finally:
-            local_branch.unlock()
+        local_extra, remote_extra = find_unmerged(
+            local_branch, remote_branch, restrict,
+            backward=not reverse,
+            include_merges=include_merges,
+            local_revid_range=local_revid_range,
+            remote_revid_range=remote_revid_range)
+
+        if log_format is None:
+            registry = log.log_formatter_registry
+            log_format = registry.get_default(local_branch)
+        lf = log_format(to_file=self.outf,
+                        show_ids=show_ids,
+                        show_timezone='original')
+
+        status_code = 0
+        if local_extra and not theirs_only:
+            message("You have %d extra revision(s):\n" %
+                len(local_extra))
+            for revision in iter_log_revisions(local_extra,
+                                local_branch.repository,
+                                verbose):
+                lf.log_revision(revision)
+            printed_local = True
+            status_code = 1
+        else:
+            printed_local = False
+
+        if remote_extra and not mine_only:
+            if printed_local is True:
+                message("\n\n\n")
+            message("You are missing %d revision(s):\n" %
+                len(remote_extra))
+            for revision in iter_log_revisions(remote_extra,
+                                remote_branch.repository,
+                                verbose):
+                lf.log_revision(revision)
+            status_code = 1
+
+        if mine_only and not local_extra:
+            # We checked local, and found nothing extra
+            message('This branch is up to date.\n')
+        elif theirs_only and not remote_extra:
+            # We checked remote, and found nothing extra
+            message('Other branch is up to date.\n')
+        elif not (mine_only or theirs_only or local_extra or
+                  remote_extra):
+            # We checked both branches, and neither one had extra
+            # revisions
+            message("Branches are up to date.\n")
+        self.cleanup_now()
         if not status_code and parent is None and other_branch is not None:
             local_branch.lock_write()
-            try:
-                # handle race conditions - a parent might be set while we run.
-                if local_branch.get_parent() is None:
-                    local_branch.set_parent(remote_branch.base)
-            finally:
-                local_branch.unlock()
+            self.add_cleanup(local_branch.unlock)
+            # handle race conditions - a parent might be set while we run.
+            if local_branch.get_parent() is None:
+                local_branch.set_parent(remote_branch.base)
         return status_code
 
 
@@ -4367,18 +4459,16 @@
         else:
             b = Branch.open(branch)
         b.lock_read()
-        try:
-            if revision is None:
-                rev_id = b.last_revision()
-            else:
-                rev_id = revision[0].as_revision_id(b)
-            t = testament_class.from_revision(b.repository, rev_id)
-            if long:
-                sys.stdout.writelines(t.as_text_lines())
-            else:
-                sys.stdout.write(t.as_short_text())
-        finally:
-            b.unlock()
+        self.add_cleanup(b.unlock)
+        if revision is None:
+            rev_id = b.last_revision()
+        else:
+            rev_id = revision[0].as_revision_id(b)
+        t = testament_class.from_revision(b.repository, rev_id)
+        if long:
+            sys.stdout.writelines(t.as_text_lines())
+        else:
+            sys.stdout.write(t.as_short_text())
 
 
 class cmd_annotate(Command):
@@ -4410,30 +4500,28 @@
             bzrdir.BzrDir.open_containing_tree_or_branch(filename)
         if wt is not None:
             wt.lock_read()
+            self.add_cleanup(wt.unlock)
         else:
             branch.lock_read()
-        try:
-            tree = _get_one_revision_tree('annotate', revision, branch=branch)
-            if wt is not None:
-                file_id = wt.path2id(relpath)
-            else:
-                file_id = tree.path2id(relpath)
-            if file_id is None:
-                raise errors.NotVersionedError(filename)
-            file_version = tree.inventory[file_id].revision
-            if wt is not None and revision is None:
-                # If there is a tree and we're not annotating historical
-                # versions, annotate the working tree's content.
-                annotate_file_tree(wt, file_id, self.outf, long, all,
-                    show_ids=show_ids)
-            else:
-                annotate_file(branch, file_version, file_id, long, all, self.outf,
-                              show_ids=show_ids)
-        finally:
-            if wt is not None:
-                wt.unlock()
-            else:
-                branch.unlock()
+            self.add_cleanup(branch.unlock)
+        tree = _get_one_revision_tree('annotate', revision, branch=branch)
+        tree.lock_read()
+        self.add_cleanup(tree.unlock)
+        if wt is not None:
+            file_id = wt.path2id(relpath)
+        else:
+            file_id = tree.path2id(relpath)
+        if file_id is None:
+            raise errors.NotVersionedError(filename)
+        file_version = tree.inventory[file_id].revision
+        if wt is not None and revision is None:
+            # If there is a tree and we're not annotating historical
+            # versions, annotate the working tree's content.
+            annotate_file_tree(wt, file_id, self.outf, long, all,
+                show_ids=show_ids)
+        else:
+            annotate_file(branch, file_version, file_id, long, all, self.outf,
+                          show_ids=show_ids)
 
 
 class cmd_re_sign(Command):
@@ -4451,10 +4539,8 @@
             raise errors.BzrCommandError('You must supply either --revision or a revision_id')
         b = WorkingTree.open_containing(u'.')[0].branch
         b.lock_write()
-        try:
-            return self._run(b, revision_id_list, revision)
-        finally:
-            b.unlock()
+        self.add_cleanup(b.unlock)
+        return self._run(b, revision_id_list, revision)
 
     def _run(self, b, revision_id_list, revision):
         import bzrlib.gpg as gpg
@@ -4511,7 +4597,7 @@
     before they will be applied to the local branch.
 
     Bound branches use the nickname of its master branch unless it is set
-    locally, in which case binding will update the the local nickname to be
+    locally, in which case binding will update the local nickname to be
     that of the master.
     """
 
@@ -4606,16 +4692,11 @@
 
         if tree is not None:
             tree.lock_write()
+            self.add_cleanup(tree.unlock)
         else:
             b.lock_write()
-        try:
-            return self._run(b, tree, dry_run, verbose, revision, force,
-                             local=local)
-        finally:
-            if tree is not None:
-                tree.unlock()
-            else:
-                b.unlock()
+            self.add_cleanup(b.unlock)
+        return self._run(b, tree, dry_run, verbose, revision, force, local=local)
 
     def _run(self, b, tree, dry_run, verbose, revision, force, local=False):
         from bzrlib.log import log_formatter, show_log
@@ -4678,10 +4759,12 @@
     CAUTION: Locks should only be broken when you are sure that the process
     holding the lock has been stopped.
 
-    You can get information on what locks are open via the 'bzr info' command.
+    You can get information on what locks are open via the 'bzr info
+    [location]' command.
 
     :Examples:
         bzr break-lock
+        bzr break-lock bzr+ssh://example.com/bzr/foo
     """
     takes_args = ['location?']
 
@@ -4717,8 +4800,8 @@
     takes_options = [
         Option('inet',
                help='Serve on stdin/out for use from inetd or sshd.'),
-        RegistryOption('protocol', 
-               help="Protocol to serve.", 
+        RegistryOption('protocol',
+               help="Protocol to serve.",
                lazy_registry=('bzrlib.transport', 'transport_server_registry'),
                value_switches=True),
         Option('port',
@@ -4733,7 +4816,11 @@
         Option('allow-writes',
                help='By default the server is a readonly server.  Supplying '
                     '--allow-writes enables write access to the contents of '
-                    'the served directory and below.'
+                    'the served directory and below.  Note that ``bzr serve`` '
+                    'does not perform authentication, so unless some form of '
+                    'external authentication is arranged supplying this '
+                    'option leads to global uncontrolled write access to your '
+                    'file system.'
                 ),
         ]
 
@@ -4955,18 +5042,32 @@
       directly from the merge directive, without retrieving data from a
       branch.
 
-    If --no-bundle is specified, then public_branch is needed (and must be
-    up-to-date), so that the receiver can perform the merge using the
-    public_branch.  The public_branch is always included if known, so that
-    people can check it later.
-
-    The submit branch defaults to the parent, but can be overridden.  Both
-    submit branch and public branch will be remembered if supplied.
-
-    If a public_branch is known for the submit_branch, that public submit
-    branch is used in the merge instructions.  This means that a local mirror
-    can be used as your actual submit branch, once you have set public_branch
-    for that mirror.
+    `bzr send` creates a compact data set that, when applied using bzr
+    merge, has the same effect as merging from the source branch.  
+    
+    By default the merge directive is self-contained and can be applied to any
+    branch containing submit_branch in its ancestory without needing access to
+    the source branch.
+    
+    If --no-bundle is specified, then Bazaar doesn't send the contents of the
+    revisions, but only a structured request to merge from the
+    public_location.  In that case the public_branch is needed and it must be
+    up-to-date and accessible to the recipient.  The public_branch is always
+    included if known, so that people can check it later.
+
+    The submit branch defaults to the parent of the source branch, but can be
+    overridden.  Both submit branch and public branch will be remembered in
+    branch.conf the first time they are used for a particular branch.  The
+    source branch defaults to that containing the working directory, but can
+    be changed using --from.
+
+    In order to calculate those changes, bzr must analyse the submit branch.
+    Therefore it is most efficient for the submit branch to be a local mirror.
+    If a public location is known for the submit_branch, that location is used
+    in the merge directive.
+
+    The default behaviour is to send the merge directive by mail, unless -o is
+    given, in which case it is sent to a file.
 
     Mail is sent using your preferred mail program.  This should be transparent
     on Windows (it uses MAPI).  On Linux, it requires the xdg-email utility.
@@ -4992,6 +5093,10 @@
 
     The merge directives created by bzr send may be applied using bzr merge or
     bzr pull by specifying a file containing a merge directive as the location.
+
+    bzr send makes extensive use of public locations to map local locations into
+    URLs that can be used by other people.  See `bzr help configuration` to
+    set them, and use `bzr info` to display them.
     """
 
     encoding_type = 'exact'
@@ -5156,25 +5261,23 @@
             ):
         branch, relpath = Branch.open_containing(directory)
         branch.lock_write()
-        try:
-            if delete:
-                branch.tags.delete_tag(tag_name)
-                self.outf.write('Deleted tag %s.\n' % tag_name)
+        self.add_cleanup(branch.unlock)
+        if delete:
+            branch.tags.delete_tag(tag_name)
+            self.outf.write('Deleted tag %s.\n' % tag_name)
+        else:
+            if revision:
+                if len(revision) != 1:
+                    raise errors.BzrCommandError(
+                        "Tags can only be placed on a single revision, "
+                        "not on a range")
+                revision_id = revision[0].as_revision_id(branch)
             else:
-                if revision:
-                    if len(revision) != 1:
-                        raise errors.BzrCommandError(
-                            "Tags can only be placed on a single revision, "
-                            "not on a range")
-                    revision_id = revision[0].as_revision_id(branch)
-                else:
-                    revision_id = branch.last_revision()
-                if (not force) and branch.tags.has_tag(tag_name):
-                    raise errors.TagAlreadyExists(tag_name)
-                branch.tags.set_tag(tag_name, revision_id)
-                self.outf.write('Created tag %s.\n' % tag_name)
-        finally:
-            branch.unlock()
+                revision_id = branch.last_revision()
+            if (not force) and branch.tags.has_tag(tag_name):
+                raise errors.TagAlreadyExists(tag_name)
+            branch.tags.set_tag(tag_name, revision_id)
+            self.outf.write('Created tag %s.\n' % tag_name)
 
 
 class cmd_tags(Command):
@@ -5213,41 +5316,40 @@
             return
 
         branch.lock_read()
-        try:
-            if revision:
-                graph = branch.repository.get_graph()
-                rev1, rev2 = _get_revision_range(revision, branch, self.name())
-                revid1, revid2 = rev1.rev_id, rev2.rev_id
-                # only show revisions between revid1 and revid2 (inclusive)
-                tags = [(tag, revid) for tag, revid in tags if
-                    graph.is_between(revid, revid1, revid2)]
-            if sort == 'alpha':
-                tags.sort()
-            elif sort == 'time':
-                timestamps = {}
-                for tag, revid in tags:
-                    try:
-                        revobj = branch.repository.get_revision(revid)
-                    except errors.NoSuchRevision:
-                        timestamp = sys.maxint # place them at the end
-                    else:
-                        timestamp = revobj.timestamp
-                    timestamps[revid] = timestamp
-                tags.sort(key=lambda x: timestamps[x[1]])
-            if not show_ids:
-                # [ (tag, revid), ... ] -> [ (tag, dotted_revno), ... ]
-                for index, (tag, revid) in enumerate(tags):
-                    try:
-                        revno = branch.revision_id_to_dotted_revno(revid)
-                        if isinstance(revno, tuple):
-                            revno = '.'.join(map(str, revno))
-                    except errors.NoSuchRevision:
-                        # Bad tag data/merges can lead to tagged revisions
-                        # which are not in this branch. Fail gracefully ...
-                        revno = '?'
-                    tags[index] = (tag, revno)
-        finally:
-            branch.unlock()
+        self.add_cleanup(branch.unlock)
+        if revision:
+            graph = branch.repository.get_graph()
+            rev1, rev2 = _get_revision_range(revision, branch, self.name())
+            revid1, revid2 = rev1.rev_id, rev2.rev_id
+            # only show revisions between revid1 and revid2 (inclusive)
+            tags = [(tag, revid) for tag, revid in tags if
+                graph.is_between(revid, revid1, revid2)]
+        if sort == 'alpha':
+            tags.sort()
+        elif sort == 'time':
+            timestamps = {}
+            for tag, revid in tags:
+                try:
+                    revobj = branch.repository.get_revision(revid)
+                except errors.NoSuchRevision:
+                    timestamp = sys.maxint # place them at the end
+                else:
+                    timestamp = revobj.timestamp
+                timestamps[revid] = timestamp
+            tags.sort(key=lambda x: timestamps[x[1]])
+        if not show_ids:
+            # [ (tag, revid), ... ] -> [ (tag, dotted_revno), ... ]
+            for index, (tag, revid) in enumerate(tags):
+                try:
+                    revno = branch.revision_id_to_dotted_revno(revid)
+                    if isinstance(revno, tuple):
+                        revno = '.'.join(map(str, revno))
+                except errors.NoSuchRevision:
+                    # Bad tag data/merges can lead to tagged revisions
+                    # which are not in this branch. Fail gracefully ...
+                    revno = '?'
+                tags[index] = (tag, revno)
+        self.cleanup_now()
         for tag, revspec in tags:
             self.outf.write('%-20s %s\n' % (tag, revspec))
 
@@ -5362,22 +5464,30 @@
     /path/to/newbranch.
 
     Bound branches use the nickname of its master branch unless it is set
-    locally, in which case switching will update the the local nickname to be
+    locally, in which case switching will update the local nickname to be
     that of the master.
     """
 
-    takes_args = ['to_location']
+    takes_args = ['to_location?']
     takes_options = [Option('force',
                         help='Switch even if local commits will be lost.'),
+                     'revision',
                      Option('create-branch', short_name='b',
                         help='Create the target branch from this one before'
                              ' switching to it.'),
-                     ]
+                    ]
 
-    def run(self, to_location, force=False, create_branch=False):
+    def run(self, to_location=None, force=False, create_branch=False,
+            revision=None):
         from bzrlib import switch
         tree_location = '.'
+        revision = _get_one_revision('switch', revision)
         control_dir = bzrdir.BzrDir.open_containing(tree_location)[0]
+        if to_location is None:
+            if revision is None:
+                raise errors.BzrCommandError('You must supply either a'
+                                             ' revision or a location')
+            to_location = '.'
         try:
             branch = control_dir.open_branch()
             had_explicit_nick = branch.get_config().has_explicit_nickname()
@@ -5388,6 +5498,8 @@
             if branch is None:
                 raise errors.BzrCommandError('cannot create branch without'
                                              ' source branch')
+            to_location = directory_service.directories.dereference(
+                              to_location)
             if '/' not in to_location and '\\' not in to_location:
                 # This path is meant to be relative to the existing branch
                 this_url = self._get_branch_location(control_dir)
@@ -5395,13 +5507,6 @@
             to_branch = branch.bzrdir.sprout(to_location,
                                  possible_transports=[branch.bzrdir.root_transport],
                                  source_branch=branch).open_branch()
-            # try:
-            #     from_branch = control_dir.open_branch()
-            # except errors.NotBranchError:
-            #     raise BzrCommandError('Cannot create a branch from this'
-            #         ' location when we cannot open this branch')
-            # from_branch.bzrdir.sprout(
-            pass
         else:
             try:
                 to_branch = Branch.open(to_location)
@@ -5409,7 +5514,9 @@
                 this_url = self._get_branch_location(control_dir)
                 to_branch = Branch.open(
                     urlutils.join(this_url, '..', to_location))
-        switch.switch(control_dir, to_branch, force)
+        if revision is not None:
+            revision = revision.as_revision_id(to_branch)
+        switch.switch(control_dir, to_branch, force, revision_id=revision)
         if had_explicit_nick:
             branch = control_dir.open_branch() #get the new branch!
             branch.nick = to_branch.nick
@@ -5662,27 +5769,25 @@
             try:
                 shelver.run()
             finally:
-                shelver.work_tree.unlock()
+                shelver.finalize()
         except errors.UserAbort:
             return 0
 
     def run_for_list(self):
         tree = WorkingTree.open_containing('.')[0]
         tree.lock_read()
-        try:
-            manager = tree.get_shelf_manager()
-            shelves = manager.active_shelves()
-            if len(shelves) == 0:
-                note('No shelved changes.')
-                return 0
-            for shelf_id in reversed(shelves):
-                message = manager.get_metadata(shelf_id).get('message')
-                if message is None:
-                    message = '<no message>'
-                self.outf.write('%3d: %s\n' % (shelf_id, message))
-            return 1
-        finally:
-            tree.unlock()
+        self.add_cleanup(tree.unlock)
+        manager = tree.get_shelf_manager()
+        shelves = manager.active_shelves()
+        if len(shelves) == 0:
+            note('No shelved changes.')
+            return 0
+        for shelf_id in reversed(shelves):
+            message = manager.get_metadata(shelf_id).get('message')
+            if message is None:
+                message = '<no message>'
+            self.outf.write('%3d: %s\n' % (shelf_id, message))
+        return 1
 
 
 class cmd_unshelve(Command):
@@ -5700,7 +5805,10 @@
             enum_switch=False, value_switches=True,
             apply="Apply changes and remove from the shelf.",
             dry_run="Show changes, but do not apply or remove them.",
-            delete_only="Delete changes without applying them."
+            preview="Instead of unshelving the changes, show the diff that "
+                    "would result from unshelving.",
+            delete_only="Delete changes without applying them.",
+            keep="Apply changes but don't delete them.",
         )
     ]
     _see_also = ['shelve']

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2009-07-20 02:04:21 +0000
+++ bzrlib/bundle/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from cStringIO import StringIO
+
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -22,6 +24,7 @@
     urlutils,
     )
 from bzrlib.bundle import serializer as _serializer
+from bzrlib.merge_directive import MergeDirective
 from bzrlib.transport import (
     do_catching_redirections,
     get_transport,
@@ -51,33 +54,22 @@
 
 
 def read_mergeable_from_transport(transport, filename, _do_directive=True):
-    # All of this must be in the try/except
-    # Some transports cannot detect that we are trying to read a
-    # directory until we actually issue read() on the handle.
+    def get_bundle(transport):
+        return StringIO(transport.get_bytes(filename)), transport
+
+    def redirected_transport(transport, exception, redirection_notice):
+        note(redirection_notice)
+        url, filename = urlutils.split(exception.target,
+                                       exclude_trailing_slash=False)
+        if not filename:
+            raise errors.NotABundle('A directory cannot be a bundle')
+        return get_transport(url)
+
     try:
-        def get_bundle(transport):
-            return transport.get(filename), transport
-
-        def redirected_transport(transport, exception, redirection_notice):
-            note(redirection_notice)
-            url, filename = urlutils.split(exception.target,
-                                           exclude_trailing_slash=False)
-            if not filename:
-                raise errors.NotABundle('A directory cannot be a bundle')
-            return get_transport(url)
-
-        try:
-            f, transport = do_catching_redirections(get_bundle, transport,
+        bytef, transport = do_catching_redirections(get_bundle, transport,
                                                     redirected_transport)
-        except errors.TooManyRedirections:
-            raise errors.NotABundle(transport.clone(filename).base)
-
-        if _do_directive:
-            from bzrlib.merge_directive import MergeDirective
-            directive = MergeDirective.from_lines(f.readlines())
-            return directive, transport
-        else:
-            return _serializer.read_bundle(f), transport
+    except errors.TooManyRedirections:
+        raise errors.NotABundle(transport.clone(filename).base)
     except (errors.ConnectionReset, errors.ConnectionError), e:
         raise
     except (errors.TransportError, errors.PathError), e:
@@ -91,6 +83,11 @@
         # StubSFTPServer does fail during get() (because of prefetch)
         # so it has an opportunity to translate the error.
         raise errors.NotABundle(str(e))
-    except errors.NotAMergeDirective:
-        f.seek(0)
-        return _serializer.read_bundle(f), transport
+
+    if _do_directive:
+        try:
+            return MergeDirective.from_lines(bytef), transport
+        except errors.NotAMergeDirective:
+            bytef.seek(0)
+
+    return _serializer.read_bundle(bytef), transport

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2009-09-24 09:45:23 +0000
+++ bzrlib/bzrdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1827,7 +1827,7 @@
     def probe_transport(klass, transport):
         """Return the .bzrdir style format present in a directory."""
         try:
-            format_string = transport.get(".bzr/branch-format").read()
+            format_string = transport.get_bytes(".bzr/branch-format")
         except errors.NoSuchFile:
             raise errors.NotBranchError(path=transport.base)
 
@@ -3108,9 +3108,20 @@
 
     def __init__(self):
         BzrDirMetaFormat1.__init__(self)
+        # XXX: It's a bit ugly that the network name is here, because we'd
+        # like to believe that format objects are stateless or at least
+        # immutable,  However, we do at least avoid mutating the name after
+        # it's returned.  See <https://bugs.edge.launchpad.net/bzr/+bug/504102>
         self._network_name = None
 
+    def __repr__(self):
+        return "%s(_network_name=%r)" % (self.__class__.__name__,
+            self._network_name)
+
     def get_format_description(self):
+        if self._network_name:
+            real_format = network_format_registry.get(self._network_name)
+            return 'Remote: ' + real_format.get_format_description()
         return 'bzr remote bzrdir'
 
     def get_format_string(self):
@@ -3249,12 +3260,11 @@
         args.append(self._serialize_NoneString(repo_format_name))
         args.append(self._serialize_NoneTrueFalse(make_working_trees))
         args.append(self._serialize_NoneTrueFalse(shared_repo))
-        if self._network_name is None:
-            self._network_name = \
+        request_network_name = self._network_name or \
             BzrDirFormat.get_default_format().network_name()
         try:
             response = client.call('BzrDirFormat.initialize_ex_1.16',
-                self.network_name(), path, *args)
+                request_network_name, path, *args)
         except errors.UnknownSmartMethod:
             client._medium._remember_remote_is_before((1,16))
             local_dir_format = BzrDirMetaFormat1()
@@ -3510,7 +3520,7 @@
                 experimental_pairs.append((key, help))
             else:
                 output += wrapped(key, help, info)
-        output += "\nSee ``bzr help formats`` for more about storage formats."
+        output += "\nSee :doc:`formats-help` for more about storage formats."
         other_output = ""
         if len(experimental_pairs) > 0:
             other_output += "Experimental formats are shown below.\n\n"
@@ -3529,7 +3539,7 @@
             other_output += \
                 "\nNo deprecated formats are available.\n\n"
         other_output += \
-            "\nSee ``bzr help formats`` for more about storage formats."
+                "\nSee :doc:`formats-help` for more about storage formats."
 
         if topic == 'other-formats':
             return other_output
@@ -3704,18 +3714,21 @@
 format_registry.register('weave', BzrDirFormat6,
     'Pre-0.8 format.  Slower than knit and does not'
     ' support checkouts or shared repositories.',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('metaweave',
     'bzrlib.repofmt.weaverepo.RepositoryFormat7',
     'Transitional format in 0.8.  Slower than knit.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('knit',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
     'Format using knits.  Recommended for interoperation with bzr <= 0.14.',
     branch_format='bzrlib.branch.BzrBranchFormat5',
     tree_format='bzrlib.workingtree.WorkingTreeFormat3',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3725,6 +3738,7 @@
     # this uses bzrlib.workingtree.WorkingTreeFormat4 because importing
     # directly from workingtree_4 triggers a circular import.
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-tags',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit1',
@@ -3733,6 +3747,7 @@
         ' Incompatible with bzr < 0.15.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('rich-root',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit4',
@@ -3740,6 +3755,7 @@
         ' bzr < 1.0.',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     deprecated=True)
 format_registry.register_metadir('dirstate-with-subtree',
     'bzrlib.repofmt.knitrepo.RepositoryFormatKnit3',
@@ -3781,6 +3797,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat6',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.6',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5',
@@ -3789,6 +3806,7 @@
          'not present locally.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.6.1-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack5RichRoot',
@@ -3796,6 +3814,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.9',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3804,6 +3823,7 @@
          'performance for most operations.',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.9-rich-root',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6RichRoot',
@@ -3811,6 +3831,7 @@
          '(needed for bzr-svn and bzr-git).',
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat4',
+    hidden=True,
     )
 format_registry.register_metadir('1.14',
     'bzrlib.repofmt.pack_repo.RepositoryFormatKnitPack6',
@@ -3838,6 +3859,7 @@
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
     alias=True,
+    hidden=True,
     )
 format_registry.register_metadir('development-subtree',
     'bzrlib.repofmt.pack_repo.RepositoryFormatPackDevelopment2Subtree',
@@ -3850,6 +3872,7 @@
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     experimental=True,
+    hidden=True,
     alias=False, # Restore to being an alias when an actual development subtree format is added
                  # This current non-alias status is simply because we did not introduce a
                  # chk based subtree format.
@@ -3899,6 +3922,7 @@
     branch_format='bzrlib.branch.BzrBranchFormat7',
     tree_format='bzrlib.workingtree.WorkingTreeFormat6',
     alias=True,
+    hidden=True,
     help='Same as 2a.')
 
 # The current format that is made on 'bzr init'.

=== modified file 'bzrlib/chk_map.py'
--- bzrlib/chk_map.py	2009-10-20 20:30:21 +0000
+++ bzrlib/chk_map.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,6 +38,7 @@
 """
 
 import heapq
+import threading
 
 from bzrlib import lazy_import
 lazy_import.lazy_import(globals(), """
@@ -50,18 +51,40 @@
     lru_cache,
     osutils,
     registry,
+    static_tuple,
     trace,
     )
+from bzrlib.static_tuple import StaticTuple
 
 # approx 4MB
 # If each line is 50 bytes, and you have 255 internal pages, with 255-way fan
 # out, it takes 3.1MB to cache the layer.
 _PAGE_CACHE_SIZE = 4*1024*1024
-# We are caching bytes so len(value) is perfectly accurate
-_page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
+# Per thread caches for 2 reasons:
+# - in the server we may be serving very different content, so we get less
+#   cache thrashing.
+# - we avoid locking on every cache lookup.
+_thread_caches = threading.local()
+# The page cache.
+_thread_caches.page_cache = None
+
+def _get_cache():
+    """Get the per-thread page cache.
+
+    We need a function to do this because in a new thread the _thread_caches
+    threading.local object does not have the cache initialized yet.
+    """
+    page_cache = getattr(_thread_caches, 'page_cache', None)
+    if page_cache is None:
+        # We are caching bytes so len(value) is perfectly accurate
+        page_cache = lru_cache.LRUSizeCache(_PAGE_CACHE_SIZE)
+        _thread_caches.page_cache = page_cache
+    return page_cache
+
 
 def clear_cache():
-    _page_cache.clear()
+    _get_cache().clear()
+
 
 # If a ChildNode falls below this many bytes, we check for a remap
 _INTERESTING_NEW_SIZE = 50
@@ -114,8 +137,9 @@
         """
         delete_count = 0
         # Check preconditions first.
-        new_items = set([key for (old, key, value) in delta if key is not None
-            and old is None])
+        as_st = StaticTuple.from_sequence
+        new_items = set([as_st(key) for (old, key, value) in delta
+                         if key is not None and old is None])
         existing_new = list(self.iteritems(key_filter=new_items))
         if existing_new:
             raise errors.InconsistentDeltaDelta(delta,
@@ -135,7 +159,7 @@
 
     def _ensure_root(self):
         """Ensure that the root node is an object not a key."""
-        if type(self._root_node) is tuple:
+        if type(self._root_node) is StaticTuple:
             # Demand-load the root
             self._root_node = self._get_node(self._root_node)
 
@@ -149,7 +173,7 @@
         :param node: A tuple key or node object.
         :return: A node object.
         """
-        if type(node) is tuple:
+        if type(node) is StaticTuple:
             bytes = self._read_bytes(node)
             return _deserialise(bytes, node,
                 search_key_func=self._search_key_func)
@@ -158,11 +182,11 @@
 
     def _read_bytes(self, key):
         try:
-            return _page_cache[key]
+            return _get_cache()[key]
         except KeyError:
             stream = self._store.get_record_stream([key], 'unordered', True)
             bytes = stream.next().get_bytes_as('fulltext')
-            _page_cache[key] = bytes
+            _get_cache()[key] = bytes
             return bytes
 
     def _dump_tree(self, include_keys=False):
@@ -196,7 +220,7 @@
             for key, value in sorted(node._items.iteritems()):
                 # Don't use prefix nor indent here to line up when used in
                 # tests in conjunction with assertEqualDiff
-                result.append('      %r %r' % (key, value))
+                result.append('      %r %r' % (tuple(key), value))
         return result
 
     @classmethod
@@ -220,6 +244,9 @@
         root_key = klass._create_directly(store, initial_value,
             maximum_size=maximum_size, key_width=key_width,
             search_key_func=search_key_func)
+        if type(root_key) is not StaticTuple:
+            raise AssertionError('we got a %s instead of a StaticTuple'
+                                 % (type(root_key),))
         return root_key
 
     @classmethod
@@ -240,9 +267,11 @@
         node = LeafNode(search_key_func=search_key_func)
         node.set_maximum_size(maximum_size)
         node._key_width = key_width
-        node._items = dict(initial_value)
+        as_st = StaticTuple.from_sequence
+        node._items = dict([(as_st(key), val) for key, val
+                                               in initial_value.iteritems()])
         node._raw_size = sum([node._key_value_len(key, value)
-                              for key,value in initial_value.iteritems()])
+                              for key,value in node._items.iteritems()])
         node._len = len(node._items)
         node._compute_search_prefix()
         node._compute_serialised_prefix()
@@ -484,11 +513,14 @@
     def iteritems(self, key_filter=None):
         """Iterate over the entire CHKMap's contents."""
         self._ensure_root()
+        if key_filter is not None:
+            as_st = StaticTuple.from_sequence
+            key_filter = [as_st(key) for key in key_filter]
         return self._root_node.iteritems(self._store, key_filter=key_filter)
 
     def key(self):
         """Return the key for this map."""
-        if type(self._root_node) is tuple:
+        if type(self._root_node) is StaticTuple:
             return self._root_node
         else:
             return self._root_node._key
@@ -503,6 +535,7 @@
         :param key: A key to map.
         :param value: The value to assign to key.
         """
+        key = StaticTuple.from_sequence(key)
         # Need a root object.
         self._ensure_root()
         prefix, node_details = self._root_node.map(self._store, key, value)
@@ -519,12 +552,15 @@
     def _node_key(self, node):
         """Get the key for a node whether it's a tuple or node."""
         if type(node) is tuple:
+            node = StaticTuple.from_sequence(node)
+        if type(node) is StaticTuple:
             return node
         else:
             return node._key
 
     def unmap(self, key, check_remap=True):
         """remove key from the map."""
+        key = StaticTuple.from_sequence(key)
         self._ensure_root()
         if type(self._root_node) is InternalNode:
             unmapped = self._root_node.unmap(self._store, key,
@@ -544,7 +580,7 @@
 
         :return: The key of the root node.
         """
-        if type(self._root_node) is tuple:
+        if type(self._root_node) is StaticTuple:
             # Already saved.
             return self._root_node
         keys = list(self._root_node.serialise(self._store))
@@ -706,6 +742,7 @@
         :param bytes: The bytes of the node.
         :param key: The key that the serialised node has.
         """
+        key = static_tuple.expect_static_tuple(key)
         return _deserialise_leaf_node(bytes, key,
                                       search_key_func=search_key_func)
 
@@ -881,11 +918,11 @@
             lines.append(serialized[prefix_len:])
             lines.extend(value_lines)
         sha1, _, _ = store.add_lines((None,), (), lines)
-        self._key = ("sha1:" + sha1,)
+        self._key = StaticTuple("sha1:" + sha1,).intern()
         bytes = ''.join(lines)
         if len(bytes) != self._current_size():
             raise AssertionError('Invalid _current_size')
-        _page_cache.add(self._key, bytes)
+        _get_cache().add(self._key, bytes)
         return [self._key]
 
     def refs(self):
@@ -1004,6 +1041,7 @@
         :param key: The key that the serialised node has.
         :return: An InternalNode instance.
         """
+        key = static_tuple.expect_static_tuple(key)
         return _deserialise_internal_node(bytes, key,
                                           search_key_func=search_key_func)
 
@@ -1034,7 +1072,7 @@
             # for whatever we are missing
             shortcut = True
             for prefix, node in self._items.iteritems():
-                if node.__class__ is tuple:
+                if node.__class__ is StaticTuple:
                     keys[node] = (prefix, None)
                 else:
                     yield node, None
@@ -1069,7 +1107,7 @@
                     # A given key can only match 1 child node, if it isn't
                     # there, then we can just return nothing
                     return
-                if node.__class__ is tuple:
+                if node.__class__ is StaticTuple:
                     keys[node] = (search_prefix, [key])
                 else:
                     # This is loaded, and the only thing that can match,
@@ -1102,7 +1140,7 @@
                         # We can ignore this one
                         continue
                     node_key_filter = prefix_to_keys[search_prefix]
-                    if node.__class__ is tuple:
+                    if node.__class__ is StaticTuple:
                         keys[node] = (search_prefix, node_key_filter)
                     else:
                         yield node, node_key_filter
@@ -1117,7 +1155,7 @@
                         if sub_prefix in length_filter:
                             node_key_filter.extend(prefix_to_keys[sub_prefix])
                     if node_key_filter: # this key matched something, yield it
-                        if node.__class__ is tuple:
+                        if node.__class__ is StaticTuple:
                             keys[node] = (prefix, node_key_filter)
                         else:
                             yield node, node_key_filter
@@ -1126,7 +1164,7 @@
             found_keys = set()
             for key in keys:
                 try:
-                    bytes = _page_cache[key]
+                    bytes = _get_cache()[key]
                 except KeyError:
                     continue
                 else:
@@ -1157,7 +1195,7 @@
                     prefix, node_key_filter = keys[record.key]
                     node_and_filters.append((node, node_key_filter))
                     self._items[prefix] = node
-                    _page_cache.add(record.key, bytes)
+                    _get_cache().add(record.key, bytes)
                 for info in node_and_filters:
                     yield info
 
@@ -1255,7 +1293,7 @@
         :return: An iterable of the keys inserted by this operation.
         """
         for node in self._items.itervalues():
-            if type(node) is tuple:
+            if type(node) is StaticTuple:
                 # Never deserialised.
                 continue
             if node._key is not None:
@@ -1272,7 +1310,7 @@
         lines.append('%s\n' % (self._search_prefix,))
         prefix_len = len(self._search_prefix)
         for prefix, node in sorted(self._items.items()):
-            if type(node) is tuple:
+            if type(node) is StaticTuple:
                 key = node[0]
             else:
                 key = node._key[0]
@@ -1282,8 +1320,8 @@
                     % (serialised, self._search_prefix))
             lines.append(serialised[prefix_len:])
         sha1, _, _ = store.add_lines((None,), (), lines)
-        self._key = ("sha1:" + sha1,)
-        _page_cache.add(self._key, ''.join(lines))
+        self._key = StaticTuple("sha1:" + sha1,).intern()
+        _get_cache().add(self._key, ''.join(lines))
         yield self._key
 
     def _search_key(self, key):
@@ -1317,7 +1355,7 @@
             raise AssertionError("unserialised nodes have no refs.")
         refs = []
         for value in self._items.itervalues():
-            if type(value) is tuple:
+            if type(value) is StaticTuple:
                 refs.append(value)
             else:
                 refs.append(value.key())
@@ -1437,6 +1475,12 @@
 
     def __init__(self, store, new_root_keys, old_root_keys,
                  search_key_func, pb=None):
+        # TODO: Should we add a StaticTuple barrier here? It would be nice to
+        #       force callers to use StaticTuple, because there will often be
+        #       lots of keys passed in here. And even if we cast it locally,
+        #       that just meanst that we will have *both* a StaticTuple and a
+        #       tuple() in memory, referring to the same object. (so a net
+        #       increase in memory, not a decrease.)
         self._store = store
         self._new_root_keys = new_root_keys
         self._old_root_keys = old_root_keys
@@ -1444,11 +1488,16 @@
         # All uninteresting chks that we have seen. By the time they are added
         # here, they should be either fully ignored, or queued up for
         # processing
+        # TODO: This might grow to a large size if there are lots of merge
+        #       parents, etc. However, it probably doesn't scale to O(history)
+        #       like _processed_new_refs does.
         self._all_old_chks = set(self._old_root_keys)
         # All items that we have seen from the old_root_keys
         self._all_old_items = set()
         # These are interesting items which were either read, or already in the
         # interesting queue (so we don't need to walk them again)
+        # TODO: processed_new_refs becomes O(all_chks), consider switching to
+        #       SimpleSet here.
         self._processed_new_refs = set()
         self._search_key_func = search_key_func
 
@@ -1461,11 +1510,12 @@
         self._state = None
 
     def _read_nodes_from_store(self, keys):
-        # We chose not to use _page_cache, because we think in terms of records
-        # to be yielded. Also, we expect to touch each page only 1 time during
-        # this code. (We may want to evaluate saving the raw bytes into the
-        # page cache, which would allow a working tree update after the fetch
-        # to not have to read the bytes again.)
+        # We chose not to use _get_cache(), because we think in
+        # terms of records to be yielded. Also, we expect to touch each page
+        # only 1 time during this code. (We may want to evaluate saving the
+        # raw bytes into the page cache, which would allow a working tree
+        # update after the fetch to not have to read the bytes again.)
+        as_st = StaticTuple.from_sequence
         stream = self._store.get_record_stream(keys, 'unordered', True)
         for record in stream:
             if self._pb is not None:
@@ -1478,10 +1528,18 @@
             if type(node) is InternalNode:
                 # Note we don't have to do node.refs() because we know that
                 # there are no children that have been pushed into this node
+                # Note: Using as_st() here seemed to save 1.2MB, which would
+                #       indicate that we keep 100k prefix_refs around while
+                #       processing. They *should* be shorter lived than that...
+                #       It does cost us ~10s of processing time
+                #prefix_refs = [as_st(item) for item in node._items.iteritems()]
                 prefix_refs = node._items.items()
                 items = []
             else:
                 prefix_refs = []
+                # Note: We don't use a StaticTuple here. Profiling showed a
+                #       minor memory improvement (0.8MB out of 335MB peak 0.2%)
+                #       But a significant slowdown (15s / 145s, or 10%)
                 items = node._items.items()
             yield record, node, prefix_refs, items
 
@@ -1495,6 +1553,10 @@
                                 if p_r[1] not in all_old_chks]
             new_refs = [p_r[1] for p_r in prefix_refs]
             all_old_chks.update(new_refs)
+            # TODO: This might be a good time to turn items into StaticTuple
+            #       instances and possibly intern them. However, this does not
+            #       impact 'initial branch' performance, so I'm not worrying
+            #       about this yet
             self._all_old_items.update(items)
             # Queue up the uninteresting references
             # Don't actually put them in the 'to-read' queue until we have
@@ -1553,6 +1615,9 @@
             #       current design allows for this, as callers will do the work
             #       to make the results unique. We might profile whether we
             #       gain anything by ensuring unique return values for items
+            # TODO: This might be a good time to cast to StaticTuple, as
+            #       self._new_item_queue will hold the contents of multiple
+            #       records for an extended lifetime
             new_items = [item for item in items
                                if item not in self._all_old_items]
             self._new_item_queue.extend(new_items)
@@ -1583,16 +1648,31 @@
         if new_items:
             yield None, new_items
         refs = refs.difference(all_old_chks)
+        processed_new_refs.update(refs)
         while refs:
+            # TODO: Using a SimpleSet for self._processed_new_refs and
+            #       saved as much as 10MB of peak memory. However, it requires
+            #       implementing a non-pyrex version.
             next_refs = set()
             next_refs_update = next_refs.update
             # Inlining _read_nodes_from_store improves 'bzr branch bzr.dev'
             # from 1m54s to 1m51s. Consider it.
             for record, _, p_refs, items in self._read_nodes_from_store(refs):
-                items = [item for item in items
-                         if item not in all_old_items]
+                if all_old_items:
+                    # using the 'if' check saves about 145s => 141s, when
+                    # streaming initial branch of Launchpad data.
+                    items = [item for item in items
+                             if item not in all_old_items]
                 yield record, items
                 next_refs_update([p_r[1] for p_r in p_refs])
+                del p_refs
+            # set1.difference(set/dict) walks all of set1, and checks if it
+            # exists in 'other'.
+            # set1.difference(iterable) walks all of iterable, and does a
+            # 'difference_update' on a clone of set1. Pick wisely based on the
+            # expected sizes of objects.
+            # in our case it is expected that 'new_refs' will always be quite
+            # small.
             next_refs = next_refs.difference(all_old_chks)
             next_refs = next_refs.difference(processed_new_refs)
             processed_new_refs.update(next_refs)
@@ -1605,6 +1685,7 @@
         self._old_queue = []
         all_old_chks = self._all_old_chks
         for record, _, prefix_refs, items in self._read_nodes_from_store(refs):
+            # TODO: Use StaticTuple here?
             self._all_old_items.update(items)
             refs = [r for _,r in prefix_refs if r not in all_old_chks]
             self._old_queue.extend(refs)
@@ -1660,3 +1741,22 @@
         )
 search_key_registry.register('hash-16-way', _search_key_16)
 search_key_registry.register('hash-255-way', _search_key_255)
+
+
+def _check_key(key):
+    """Helper function to assert that a key is properly formatted.
+
+    This generally shouldn't be used in production code, but it can be helpful
+    to debug problems.
+    """
+    if type(key) is not StaticTuple:
+        raise TypeError('key %r is not StaticTuple but %s' % (key, type(key)))
+    if len(key) != 1:
+        raise ValueError('key %r should have length 1, not %d' % (key, len(key),))
+    if type(key[0]) is not str:
+        raise TypeError('key %r should hold a str, not %r'
+                        % (key, type(key[0])))
+    if not key[0].startswith('sha1:'):
+        raise ValueError('key %r should point to a sha1:' % (key,))
+
+

=== modified file 'bzrlib/chk_serializer.py'
--- bzrlib/chk_serializer.py	2009-07-22 20:22:21 +0000
+++ bzrlib/chk_serializer.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -139,7 +139,7 @@
     revision_format_num = None
     support_altered_by_hack = False
 
-    def _unpack_entry(self, elt):
+    def _unpack_entry(self, elt, entry_cache=None, return_from_cache=False):
         kind = elt.tag
         if not kind in self.supported_kinds:
             raise AssertionError('unsupported entry kind %s' % kind)
@@ -152,7 +152,8 @@
             return inventory.TreeReference(file_id, name, parent_id, revision,
                                            reference_revision)
         else:
-            return xml7.Serializer_v7._unpack_entry(self, elt)
+            return xml7.Serializer_v7._unpack_entry(self, elt,
+                entry_cache=entry_cache, return_from_cache=return_from_cache)
 
     def __init__(self, node_size, search_key_name):
         self.maximum_size = node_size

=== added file 'bzrlib/cleanup.py'
--- bzrlib/cleanup.py	1970-01-01 00:00:00 +0000
+++ bzrlib/cleanup.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,186 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Helpers for managing cleanup functions and the errors they might raise.
+
+The usual way to run cleanup code in Python is::
+
+    try:
+        do_something()
+    finally:
+        cleanup_something()
+
+However if both `do_something` and `cleanup_something` raise an exception
+Python will forget the original exception and propagate the one from
+cleanup_something.  Unfortunately, this is almost always much less useful than
+the original exception.
+
+If you want to be certain that the first, and only the first, error is raised,
+then use::
+
+    operation = OperationWithCleanups(do_something)
+    operation.add_cleanup(cleanup_something)
+    operation.run_simple()
+
+This is more inconvenient (because you need to make every try block a
+function), but will ensure that the first error encountered is the one raised,
+while also ensuring all cleanups are run.  See OperationWithCleanups for more
+details.
+"""
+
+
+from collections import deque
+import sys
+from bzrlib import (
+    debug,
+    trace,
+    )
+
+def _log_cleanup_error(exc):
+    trace.mutter('Cleanup failed:')
+    trace.log_exception_quietly()
+    if 'cleanup' in debug.debug_flags:
+        trace.warning('bzr: warning: Cleanup failed: %s', exc)
+
+
+def _run_cleanup(func, *args, **kwargs):
+    """Run func(*args, **kwargs), logging but not propagating any error it
+    raises.
+
+    :returns: True if func raised no errors, else False.
+    """
+    try:
+        func(*args, **kwargs)
+    except KeyboardInterrupt:
+        raise
+    except Exception, exc:
+        _log_cleanup_error(exc)
+        return False
+    return True
+
+
+def _run_cleanups(funcs):
+    """Run a series of cleanup functions."""
+    for func, args, kwargs in funcs:
+        _run_cleanup(func, *args, **kwargs)
+
+
+class OperationWithCleanups(object):
+    """A way to run some code with a dynamic cleanup list.
+
+    This provides a way to add cleanups while the function-with-cleanups is
+    running.
+
+    Typical use::
+
+        operation = OperationWithCleanups(some_func)
+        operation.run(args...)
+
+    where `some_func` is::
+
+        def some_func(operation, args, ...):
+            do_something()
+            operation.add_cleanup(something)
+            # etc
+
+    Note that the first argument passed to `some_func` will be the
+    OperationWithCleanups object.  To invoke `some_func` without that, use
+    `run_simple` instead of `run`.
+    """
+
+    def __init__(self, func):
+        self.func = func
+        self.cleanups = deque()
+
+    def add_cleanup(self, cleanup_func, *args, **kwargs):
+        """Add a cleanup to run.
+
+        Cleanups may be added at any time before or during the execution of
+        self.func.  Cleanups will be executed in LIFO order.
+        """
+        self.cleanups.appendleft((cleanup_func, args, kwargs))
+
+    def run(self, *args, **kwargs):
+        return _do_with_cleanups(
+            self.cleanups, self.func, self, *args, **kwargs)
+
+    def run_simple(self, *args, **kwargs):
+        return _do_with_cleanups(
+            self.cleanups, self.func, *args, **kwargs)
+
+    def cleanup_now(self):
+        _run_cleanups(self.cleanups)
+        self.cleanups.clear()
+
+
+def _do_with_cleanups(cleanup_funcs, func, *args, **kwargs):
+    """Run `func`, then call all the cleanup_funcs.
+
+    All the cleanup_funcs are guaranteed to be run.  The first exception raised
+    by func or any of the cleanup_funcs is the one that will be propagted by
+    this function (subsequent errors are caught and logged).
+
+    Conceptually similar to::
+
+        try:
+            return func(*args, **kwargs)
+        finally:
+            for cleanup, cargs, ckwargs in cleanup_funcs:
+                cleanup(*cargs, **ckwargs)
+
+    It avoids several problems with using try/finally directly:
+     * an exception from func will not be obscured by a subsequent exception
+       from a cleanup.
+     * an exception from a cleanup will not prevent other cleanups from
+       running (but the first exception encountered is still the one
+       propagated).
+
+    Unike `_run_cleanup`, `_do_with_cleanups` can propagate an exception from a
+    cleanup, but only if there is no exception from func.
+    """
+    # As correct as Python 2.4 allows.
+    try:
+        result = func(*args, **kwargs)
+    except:
+        # We have an exception from func already, so suppress cleanup errors.
+        _run_cleanups(cleanup_funcs)
+        raise
+    else:
+        # No exception from func, so allow the first exception from
+        # cleanup_funcs to propagate if one occurs (but only after running all
+        # of them).
+        exc_info = None
+        for cleanup, c_args, c_kwargs in cleanup_funcs:
+            # XXX: Hmm, if KeyboardInterrupt arrives at exactly this line, we
+            # won't run all cleanups... perhaps we should temporarily install a
+            # SIGINT handler?
+            if exc_info is None:
+                try:
+                    cleanup(*c_args, **c_kwargs)
+                except:
+                    # This is the first cleanup to fail, so remember its
+                    # details.
+                    exc_info = sys.exc_info()
+            else:
+                # We already have an exception to propagate, so log any errors
+                # but don't propagate them.
+                _run_cleanup(cleanup, *c_args, **kwargs)
+        if exc_info is not None:
+            raise exc_info[0], exc_info[1], exc_info[2]
+        # No error, so we can return the result
+        return result
+
+

=== modified file 'bzrlib/cmd_version_info.py'
--- bzrlib/cmd_version_info.py	2009-03-23 14:59:43 +0000
+++ bzrlib/cmd_version_info.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,14 +17,17 @@
 """Commands for generating snapshot information about a bzr tree."""
 
 from bzrlib.lazy_import import lazy_import
+
 lazy_import(globals(), """
 from bzrlib import (
     branch,
     errors,
+    ui,
+    version_info_formats,
     workingtree,
-    version_info_formats,
     )
 """)
+
 from bzrlib.commands import Command
 from bzrlib.option import Option, RegistryOption
 
@@ -113,4 +116,4 @@
                 include_revision_history=include_history,
                 include_file_revisions=include_file_revisions,
                 template=template)
-        builder.generate(self.outf)
+        builder.generate(ui.ui_factory.make_output_stream())

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2009-10-14 20:02:28 +0000
+++ bzrlib/commands.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,11 +40,13 @@
 
 import bzrlib
 from bzrlib import (
+    cleanup,
     debug,
     errors,
     option,
     osutils,
     trace,
+    ui,
     win32utils,
     )
 """)
@@ -56,6 +58,7 @@
 from bzrlib.symbol_versioning import (
     deprecated_function,
     deprecated_in,
+    deprecated_method,
     suppress_deprecation_warnings,
     )
 
@@ -382,19 +385,40 @@
             warn("No help message set for %r" % self)
         # List of standard options directly supported
         self.supported_std_options = []
-
+        self._operation = cleanup.OperationWithCleanups(self.run)
+    
+    def add_cleanup(self, cleanup_func, *args, **kwargs):
+        """Register a function to call after self.run returns or raises.
+
+        Functions will be called in LIFO order.
+        """
+        self._operation.add_cleanup(cleanup_func, *args, **kwargs)
+
+    def cleanup_now(self):
+        """Execute and empty pending cleanup functions immediately.
+
+        After cleanup_now all registered cleanups are forgotten.  add_cleanup
+        may be called again after cleanup_now; these cleanups will be called
+        after self.run returns or raises (or when cleanup_now is next called).
+
+        This is useful for releasing expensive or contentious resources (such
+        as write locks) before doing further work that does not require those
+        resources (such as writing results to self.outf).
+        """
+        self._operation.cleanup_now()
+        
+    @deprecated_method(deprecated_in((2, 1, 0)))
     def _maybe_expand_globs(self, file_list):
         """Glob expand file_list if the platform does not do that itself.
 
+        Not used anymore, now that the bzr command-line parser globs on
+        Windows.
+
         :return: A possibly empty list of unicode paths.
 
         Introduced in bzrlib 0.18.
         """
-        if not file_list:
-            file_list = []
-        if sys.platform == 'win32':
-            file_list = win32utils.glob_expand(file_list)
-        return list(file_list)
+        return file_list
 
     def _usage(self):
         """Return single-line grammar for this command.
@@ -509,8 +533,9 @@
                         # so don't create a real link
                         see_also_links.append(item)
                     else:
-                        # Use a reST link for this entry
-                        see_also_links.append("`%s`_" % (item,))
+                        # Use a Sphinx link for this entry
+                        link_text = ":doc:`%s <%s-help>`" % (item, item)
+                        see_also_links.append(link_text)
                 see_also = see_also_links
             result += ':See also: '
             result += ', '.join(see_also) + '\n'
@@ -594,26 +619,8 @@
 
     def _setup_outf(self):
         """Return a file linked to stdout, which has proper encoding."""
-        # Originally I was using self.stdout, but that looks
-        # *way* too much like sys.stdout
-        if self.encoding_type == 'exact':
-            # force sys.stdout to be binary stream on win32
-            if sys.platform == 'win32':
-                fileno = getattr(sys.stdout, 'fileno', None)
-                if fileno:
-                    import msvcrt
-                    msvcrt.setmode(fileno(), os.O_BINARY)
-            self.outf = sys.stdout
-            return
-
-        output_encoding = osutils.get_terminal_encoding()
-
-        self.outf = codecs.getwriter(output_encoding)(sys.stdout,
-                        errors=self.encoding_type)
-        # For whatever reason codecs.getwriter() does not advertise its encoding
-        # it just returns the encoding of the wrapped file, which is completely
-        # bogus. So set the attribute, so we can find the correct encoding later.
-        self.outf.encoding = output_encoding
+        self.outf = ui.ui_factory.make_output_stream(
+            encoding_type=self.encoding_type)
 
     def run_argv_aliases(self, argv, alias_argv=None):
         """Parse the command line and run with extra aliases in alias_argv."""
@@ -651,7 +658,11 @@
 
         self._setup_outf()
 
-        return self.run(**all_cmd_args)
+        return self.run_direct(**all_cmd_args)
+
+    def run_direct(self, *args, **kwargs):
+        """Call run directly with objects (without parsing an argv list)."""
+        return self._operation.run_simple(*args, **kwargs)
 
     def run(self):
         """Actually run the command.
@@ -939,7 +950,11 @@
 
     --coverage
         Generate line coverage report in the specified directory.
+
+    --concurrency
+        Specify the number of processes that can be run concurrently (selftest).
     """
+    trace.mutter("bazaar version: " + bzrlib.__version__)
     argv = list(argv)
     trace.mutter("bzr arguments: %r", argv)
 
@@ -969,6 +984,9 @@
             opt_no_aliases = True
         elif a == '--builtin':
             opt_builtin = True
+        elif a == '--concurrency':
+            os.environ['BZR_CONCURRENCY'] = argv[i + 1]
+            i += 1
         elif a == '--coverage':
             opt_coverage_dir = argv[i + 1]
             i += 1
@@ -1113,6 +1131,8 @@
             raise errors.BzrError("argv should be list of unicode strings.")
         argv = new_argv
     ret = run_bzr_catch_errors(argv)
+    bzrlib.ui.ui_factory.log_transport_activity(
+        display=('bytes' in debug.debug_flags))
     trace.mutter("return code %d", ret)
     osutils.report_extension_load_failures()
     return ret

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2009-08-28 05:00:33 +0000
+++ bzrlib/commit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -65,6 +65,7 @@
     xml_serializer,
     )
 from bzrlib.branch import Branch
+from bzrlib.cleanup import OperationWithCleanups
 import bzrlib.config
 from bzrlib.errors import (BzrError, PointlessCommit,
                            ConflictsInTree,
@@ -234,6 +235,31 @@
             commit. Pending changes to excluded files will be ignored by the
             commit.
         """
+        operation = OperationWithCleanups(self._commit)
+        return operation.run(
+               message=message,
+               timestamp=timestamp,
+               timezone=timezone,
+               committer=committer,
+               specific_files=specific_files,
+               rev_id=rev_id,
+               allow_pointless=allow_pointless,
+               strict=strict,
+               verbose=verbose,
+               revprops=revprops,
+               working_tree=working_tree,
+               local=local,
+               reporter=reporter,
+               config=config,
+               message_callback=message_callback,
+               recursive=recursive,
+               exclude=exclude,
+               possible_master_transports=possible_master_transports)
+
+    def _commit(self, operation, message, timestamp, timezone, committer,
+            specific_files, rev_id, allow_pointless, strict, verbose, revprops,
+            working_tree, local, reporter, config, message_callback, recursive,
+            exclude, possible_master_transports):
         mutter('preparing to commit')
 
         if working_tree is None:
@@ -262,7 +288,6 @@
             self.exclude = []
         self.local = local
         self.master_branch = None
-        self.master_locked = False
         self.recursive = recursive
         self.rev_id = None
         # self.specific_files is None to indicate no filter, or any iterable to
@@ -283,6 +308,7 @@
         self.verbose = verbose
 
         self.work_tree.lock_write()
+        operation.add_cleanup(self.work_tree.unlock)
         self.parents = self.work_tree.get_parent_ids()
         # We can use record_iter_changes IFF iter_changes is compatible with
         # the command line parameters, and the repository has fast delta
@@ -293,119 +319,118 @@
             (self.branch.repository._format.fast_deltas or
              len(self.parents) < 2))
         self.pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        operation.add_cleanup(self.pb.finished)
         self.basis_revid = self.work_tree.last_revision()
         self.basis_tree = self.work_tree.basis_tree()
         self.basis_tree.lock_read()
+        operation.add_cleanup(self.basis_tree.unlock)
+        # Cannot commit with conflicts present.
+        if len(self.work_tree.conflicts()) > 0:
+            raise ConflictsInTree
+
+        # Setup the bound branch variables as needed.
+        self._check_bound_branch(operation, possible_master_transports)
+
+        # Check that the working tree is up to date
+        old_revno, new_revno = self._check_out_of_date_tree()
+
+        # Complete configuration setup
+        if reporter is not None:
+            self.reporter = reporter
+        elif self.reporter is None:
+            self.reporter = self._select_reporter()
+        if self.config is None:
+            self.config = self.branch.get_config()
+
+        self._set_specific_file_ids()
+
+        # Setup the progress bar. As the number of files that need to be
+        # committed in unknown, progress is reported as stages.
+        # We keep track of entries separately though and include that
+        # information in the progress bar during the relevant stages.
+        self.pb_stage_name = ""
+        self.pb_stage_count = 0
+        self.pb_stage_total = 5
+        if self.bound_branch:
+            self.pb_stage_total += 1
+        self.pb.show_pct = False
+        self.pb.show_spinner = False
+        self.pb.show_eta = False
+        self.pb.show_count = True
+        self.pb.show_bar = True
+
+        self._gather_parents()
+        # After a merge, a selected file commit is not supported.
+        # See 'bzr help merge' for an explanation as to why.
+        if len(self.parents) > 1 and self.specific_files is not None:
+            raise errors.CannotCommitSelectedFileMerge(self.specific_files)
+        # Excludes are a form of selected file commit.
+        if len(self.parents) > 1 and self.exclude:
+            raise errors.CannotCommitSelectedFileMerge(self.exclude)
+
+        # Collect the changes
+        self._set_progress_stage("Collecting changes", counter=True)
+        self.builder = self.branch.get_commit_builder(self.parents,
+            self.config, timestamp, timezone, committer, revprops, rev_id)
+
         try:
-            # Cannot commit with conflicts present.
-            if len(self.work_tree.conflicts()) > 0:
-                raise ConflictsInTree
-
-            # Setup the bound branch variables as needed.
-            self._check_bound_branch(possible_master_transports)
-
-            # Check that the working tree is up to date
-            old_revno, new_revno = self._check_out_of_date_tree()
-
-            # Complete configuration setup
-            if reporter is not None:
-                self.reporter = reporter
-            elif self.reporter is None:
-                self.reporter = self._select_reporter()
-            if self.config is None:
-                self.config = self.branch.get_config()
-
-            self._set_specific_file_ids()
-
-            # Setup the progress bar. As the number of files that need to be
-            # committed in unknown, progress is reported as stages.
-            # We keep track of entries separately though and include that
-            # information in the progress bar during the relevant stages.
-            self.pb_stage_name = ""
-            self.pb_stage_count = 0
-            self.pb_stage_total = 5
-            if self.bound_branch:
-                self.pb_stage_total += 1
-            self.pb.show_pct = False
-            self.pb.show_spinner = False
-            self.pb.show_eta = False
-            self.pb.show_count = True
-            self.pb.show_bar = True
-
-            self._gather_parents()
-            # After a merge, a selected file commit is not supported.
-            # See 'bzr help merge' for an explanation as to why.
-            if len(self.parents) > 1 and self.specific_files is not None:
-                raise errors.CannotCommitSelectedFileMerge(self.specific_files)
-            # Excludes are a form of selected file commit.
-            if len(self.parents) > 1 and self.exclude:
-                raise errors.CannotCommitSelectedFileMerge(self.exclude)
-
-            # Collect the changes
-            self._set_progress_stage("Collecting changes", counter=True)
-            self.builder = self.branch.get_commit_builder(self.parents,
-                self.config, timestamp, timezone, committer, revprops, rev_id)
-
-            try:
-                self.builder.will_record_deletes()
-                # find the location being committed to
-                if self.bound_branch:
-                    master_location = self.master_branch.base
-                else:
-                    master_location = self.branch.base
-
-                # report the start of the commit
-                self.reporter.started(new_revno, self.rev_id, master_location)
-
-                self._update_builder_with_changes()
-                self._check_pointless()
-
-                # TODO: Now the new inventory is known, check for conflicts.
-                # ADHB 2006-08-08: If this is done, populate_new_inv should not add
-                # weave lines, because nothing should be recorded until it is known
-                # that commit will succeed.
-                self._set_progress_stage("Saving data locally")
-                self.builder.finish_inventory()
-
-                # Prompt the user for a commit message if none provided
-                message = message_callback(self)
-                self.message = message
-
-                # Add revision data to the local branch
-                self.rev_id = self.builder.commit(self.message)
-
-            except Exception, e:
-                mutter("aborting commit write group because of exception:")
-                trace.log_exception_quietly()
-                note("aborting commit write group: %r" % (e,))
-                self.builder.abort()
-                raise
-
-            self._process_pre_hooks(old_revno, new_revno)
-
-            # Upload revision data to the master.
-            # this will propagate merged revisions too if needed.
-            if self.bound_branch:
-                self._set_progress_stage("Uploading data to master branch")
-                # 'commit' to the master first so a timeout here causes the
-                # local branch to be out of date
-                self.master_branch.import_last_revision_info(
-                    self.branch.repository, new_revno, self.rev_id)
-
-            # and now do the commit locally.
-            self.branch.set_last_revision_info(new_revno, self.rev_id)
-
-            # Make the working tree be up to date with the branch. This
-            # includes automatic changes scheduled to be made to the tree, such
-            # as updating its basis and unversioning paths that were missing.
-            self.work_tree.unversion(self.deleted_ids)
-            self._set_progress_stage("Updating the working tree")
-            self.work_tree.update_basis_by_delta(self.rev_id,
-                 self.builder.get_basis_delta())
-            self.reporter.completed(new_revno, self.rev_id)
-            self._process_post_hooks(old_revno, new_revno)
-        finally:
-            self._cleanup()
+            self.builder.will_record_deletes()
+            # find the location being committed to
+            if self.bound_branch:
+                master_location = self.master_branch.base
+            else:
+                master_location = self.branch.base
+
+            # report the start of the commit
+            self.reporter.started(new_revno, self.rev_id, master_location)
+
+            self._update_builder_with_changes()
+            self._check_pointless()
+
+            # TODO: Now the new inventory is known, check for conflicts.
+            # ADHB 2006-08-08: If this is done, populate_new_inv should not add
+            # weave lines, because nothing should be recorded until it is known
+            # that commit will succeed.
+            self._set_progress_stage("Saving data locally")
+            self.builder.finish_inventory()
+
+            # Prompt the user for a commit message if none provided
+            message = message_callback(self)
+            self.message = message
+
+            # Add revision data to the local branch
+            self.rev_id = self.builder.commit(self.message)
+
+        except Exception, e:
+            mutter("aborting commit write group because of exception:")
+            trace.log_exception_quietly()
+            note("aborting commit write group: %r" % (e,))
+            self.builder.abort()
+            raise
+
+        self._process_pre_hooks(old_revno, new_revno)
+
+        # Upload revision data to the master.
+        # this will propagate merged revisions too if needed.
+        if self.bound_branch:
+            self._set_progress_stage("Uploading data to master branch")
+            # 'commit' to the master first so a timeout here causes the
+            # local branch to be out of date
+            self.master_branch.import_last_revision_info(
+                self.branch.repository, new_revno, self.rev_id)
+
+        # and now do the commit locally.
+        self.branch.set_last_revision_info(new_revno, self.rev_id)
+
+        # Make the working tree be up to date with the branch. This
+        # includes automatic changes scheduled to be made to the tree, such
+        # as updating its basis and unversioning paths that were missing.
+        self.work_tree.unversion(self.deleted_ids)
+        self._set_progress_stage("Updating the working tree")
+        self.work_tree.update_basis_by_delta(self.rev_id,
+             self.builder.get_basis_delta())
+        self.reporter.completed(new_revno, self.rev_id)
+        self._process_post_hooks(old_revno, new_revno)
         return self.rev_id
 
     def _select_reporter(self):
@@ -433,7 +458,7 @@
             return
         raise PointlessCommit()
 
-    def _check_bound_branch(self, possible_master_transports=None):
+    def _check_bound_branch(self, operation, possible_master_transports=None):
         """Check to see if the local branch is bound.
 
         If it is bound, then most of the commit will actually be
@@ -474,7 +499,7 @@
         # so grab the lock
         self.bound_branch = self.branch
         self.master_branch.lock_write()
-        self.master_locked = True
+        operation.add_cleanup(self.master_branch.unlock)
 
     def _check_out_of_date_tree(self):
         """Check that the working tree is up to date.
@@ -565,42 +590,6 @@
                      old_revno, old_revid, new_revno, self.rev_id,
                      tree_delta, future_tree)
 
-    def _cleanup(self):
-        """Cleanup any open locks, progress bars etc."""
-        cleanups = [self._cleanup_bound_branch,
-                    self.basis_tree.unlock,
-                    self.work_tree.unlock,
-                    self.pb.finished]
-        found_exception = None
-        for cleanup in cleanups:
-            try:
-                cleanup()
-            # we want every cleanup to run no matter what.
-            # so we have a catchall here, but we will raise the
-            # last encountered exception up the stack: and
-            # typically this will be useful enough.
-            except Exception, e:
-                found_exception = e
-        if found_exception is not None:
-            # don't do a plan raise, because the last exception may have been
-            # trashed, e is our sure-to-work exception even though it loses the
-            # full traceback. XXX: RBC 20060421 perhaps we could check the
-            # exc_info and if its the same one do a plain raise otherwise
-            # 'raise e' as we do now.
-            raise e
-
-    def _cleanup_bound_branch(self):
-        """Executed at the end of a try/finally to cleanup a bound branch.
-
-        If the branch wasn't bound, this is a no-op.
-        If it was, it resents self.branch to the local branch, instead
-        of being the master.
-        """
-        if not self.bound_branch:
-            return
-        if self.master_locked:
-            self.master_branch.unlock()
-
     def _gather_parents(self):
         """Record the parents of a merge for merge detection."""
         # TODO: Make sure that this list doesn't contain duplicate

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2009-08-20 04:53:23 +0000
+++ bzrlib/config.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
 #            and others
 #
@@ -153,6 +153,15 @@
         """Get the users pop up editor."""
         raise NotImplementedError
 
+    def get_change_editor(self, old_tree, new_tree):
+        from bzrlib import diff
+        cmd = self._get_change_editor()
+        if cmd is None:
+            return None
+        return diff.DiffFromTool.from_string(cmd, old_tree, new_tree,
+                                             sys.stdout)
+
+
     def get_mail_client(self):
         """Get a mail client to use"""
         selected_client = self.get_user_option('mail_client')
@@ -181,11 +190,23 @@
         """Get a generic option as a boolean - no special process, no default.
 
         :return None if the option doesn't exist or its value can't be
-            interpreted as a boolean. Returns True or False ortherwise.
+            interpreted as a boolean. Returns True or False otherwise.
         """
         s = self._get_user_option(option_name)
         return ui.bool_from_string(s)
 
+    def get_user_option_as_list(self, option_name):
+        """Get a generic option as a list - no special process, no default.
+
+        :return None if the option doesn't exist. Returns the value as a list
+            otherwise.
+        """
+        l = self._get_user_option(option_name)
+        if isinstance(l, (str, unicode)):
+            # A single value, most probably the user forgot the final ','
+            l = [l]
+        return l
+
     def gpg_signing_command(self):
         """What program should be used to sign signatures?"""
         result = self._gpg_signing_command()
@@ -304,6 +325,19 @@
                 path = 'bzr'
             return path
 
+    def suppress_warning(self, warning):
+        """Should the warning be suppressed or emitted.
+
+        :param warning: The name of the warning being tested.
+
+        :returns: True if the warning should be suppressed, False otherwise.
+        """
+        warnings = self.get_user_option_as_list('suppress_warnings')
+        if warnings is None or warning not in warnings:
+            return False
+        else:
+            return True
+
 
 class IniBasedConfig(Config):
     """A configuration policy that draws from ini files."""
@@ -346,6 +380,9 @@
         """Return the policy for the given (section, option_name) pair."""
         return POLICY_NONE
 
+    def _get_change_editor(self):
+        return self.get_user_option('change_editor')
+
     def _get_signature_checking(self):
         """See Config._get_signature_checking."""
         policy = self._get_user_option('check_signatures')
@@ -679,6 +716,9 @@
 
         return self._get_best_value('_get_user_id')
 
+    def _get_change_editor(self):
+        return self._get_best_value('_get_change_editor')
+
     def _get_signature_checking(self):
         """See Config._get_signature_checking."""
         return self._get_best_value('_get_signature_checking')
@@ -1457,7 +1497,7 @@
 
     def _get_config_file(self):
         try:
-            return self._transport.get(self._filename)
+            return StringIO(self._transport.get_bytes(self._filename))
         except errors.NoSuchFile:
             return StringIO()
 

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2009-03-23 14:59:43 +0000
+++ bzrlib/conflicts.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -53,13 +53,12 @@
     instead.  (This is useful for editing all files with text conflicts.)
 
     Use bzr resolve when you have fixed a problem.
-
-    See also bzr resolve.
     """
     takes_options = [
             Option('text',
                    help='List paths of files with text conflicts.'),
         ]
+    _see_also = ['resolve', 'conflict-types']
 
     def run(self, text=False):
         from bzrlib.workingtree import WorkingTree
@@ -82,16 +81,15 @@
     before you should commit.
 
     Once you have fixed a problem, use "bzr resolve" to automatically mark
-    text conflicts as fixed, resolve FILE to mark a specific conflict as
+    text conflicts as fixed, "bzr resolve FILE" to mark a specific conflict as
     resolved, or "bzr resolve --all" to mark all conflicts as resolved.
-
-    See also bzr conflicts.
     """
     aliases = ['resolved']
     takes_args = ['file*']
     takes_options = [
             Option('all', help='Resolve all conflicts in this tree.'),
             ]
+    _see_also = ['conflicts']
     def run(self, file_list=None, all=False):
         from bzrlib.workingtree import WorkingTree
         if all:
@@ -150,9 +148,9 @@
 
 
 def restore(filename):
-    """\
-    Restore a conflicted file to the state it was in before merging.
-    Only text restoration supported at present.
+    """Restore a conflicted file to the state it was in before merging.
+
+    Only text restoration is supported at present.
     """
     conflicted = False
     try:
@@ -480,7 +478,7 @@
 
 
 class UnversionedParent(HandledConflict):
-    """An attempt to version an file whose parent directory is not versioned.
+    """An attempt to version a file whose parent directory is not versioned.
     Typically, the result of a merge where one tree unversioned the directory
     and the other added a versioned file to it.
     """

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2009-10-02 06:12:20 +0000
+++ bzrlib/decorators.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -253,3 +253,80 @@
     global needs_read_lock, needs_write_lock
     needs_read_lock = _pretty_needs_read_lock
     needs_write_lock = _pretty_needs_write_lock
+
+
+# This implementation of cachedproperty is copied from Launchpad's
+# canonical.launchpad.cachedproperty module (with permission from flacoste)
+# -- spiv & vila 100120
+def cachedproperty(attrname_or_fn):
+    """A decorator for methods that makes them properties with their return
+    value cached.
+
+    The value is cached on the instance, using the attribute name provided.
+
+    If you don't provide a name, the mangled name of the property is used.
+
+    >>> class CachedPropertyTest(object):
+    ...
+    ...     @cachedproperty('_foo_cache')
+    ...     def foo(self):
+    ...         print 'foo computed'
+    ...         return 23
+    ...
+    ...     @cachedproperty
+    ...     def bar(self):
+    ...         print 'bar computed'
+    ...         return 69
+
+    >>> cpt = CachedPropertyTest()
+    >>> getattr(cpt, '_foo_cache', None) is None
+    True
+    >>> cpt.foo
+    foo computed
+    23
+    >>> cpt.foo
+    23
+    >>> cpt._foo_cache
+    23
+    >>> cpt.bar
+    bar computed
+    69
+    >>> cpt._bar_cached_value
+    69
+
+    """
+    if isinstance(attrname_or_fn, basestring):
+        attrname = attrname_or_fn
+        return _CachedPropertyForAttr(attrname)
+    else:
+        fn = attrname_or_fn
+        attrname = '_%s_cached_value' % fn.__name__
+        return _CachedProperty(attrname, fn)
+
+
+class _CachedPropertyForAttr(object):
+
+    def __init__(self, attrname):
+        self.attrname = attrname
+
+    def __call__(self, fn):
+        return _CachedProperty(self.attrname, fn)
+
+
+class _CachedProperty(object):
+
+    def __init__(self, attrname, fn):
+        self.fn = fn
+        self.attrname = attrname
+        self.marker = object()
+
+    def __get__(self, inst, cls=None):
+        if inst is None:
+            return self
+        cachedresult = getattr(inst, self.attrname, self.marker)
+        if cachedresult is self.marker:
+            result = self.fn(inst)
+            setattr(inst, self.attrname, result)
+            return result
+        else:
+            return cachedresult

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2009-03-23 14:59:43 +0000
+++ bzrlib/delta.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -47,7 +47,7 @@
 
     Files that are both modified and renamed are listed only in
     renamed, with the text_modified flag true. The text_modified
-    applies either to the the content of the file or the target of the
+    applies either to the content of the file or the target of the
     symbolic link, depending of the kind of file.
 
     Files are only considered renamed if their name has changed or

=== modified file 'bzrlib/diff-delta.c'
--- bzrlib/diff-delta.c	2009-08-03 16:54:36 +0000
+++ bzrlib/diff-delta.c	2009-12-14 15:54:42 +0000
@@ -688,7 +688,7 @@
     const unsigned char *data, *buffer, *top;
     unsigned char cmd;
     struct delta_index *new_index;
-    struct index_entry *entry, *entries, *old_entry;
+    struct index_entry *entry, *entries;
 
     if (!src->buf || !src->size)
         return NULL;
@@ -789,6 +789,7 @@
     entry = entries;
     num_inserted = 0;
     for (; num_entries > 0; --num_entries, ++entry) {
+        struct index_entry *next_bucket_entry, *cur_entry, *bucket_first_entry;
         hash_offset = (entry->val & old_index->hash_mask);
         /* The basic structure is a hash => packed_entries that fit in that
          * hash bucket. Things are structured such that the hash-pointers are
@@ -797,15 +798,19 @@
          * forward. If there are no NULL targets, then we know because
          * entry->ptr will not be NULL.
          */
-        old_entry = old_index->hash[hash_offset + 1];
-        old_entry--;
-        while (old_entry->ptr == NULL
-               && old_entry >= old_index->hash[hash_offset]) {
-            old_entry--;
+        // The start of the next bucket, this may point past the end of the
+        // entry table if hash_offset is the last bucket.
+        next_bucket_entry = old_index->hash[hash_offset + 1];
+        // First entry in this bucket
+        bucket_first_entry = old_index->hash[hash_offset];
+        cur_entry = next_bucket_entry - 1;
+        while (cur_entry->ptr == NULL && cur_entry >= bucket_first_entry) {
+            cur_entry--;
         }
-        old_entry++;
-        if (old_entry->ptr != NULL
-            || old_entry >= old_index->hash[hash_offset + 1]) {
+        // cur_entry now either points at the first NULL, or it points to
+        // next_bucket_entry if there were no blank spots.
+        cur_entry++;
+        if (cur_entry >= next_bucket_entry || cur_entry->ptr != NULL) {
             /* There is no room for this entry, we have to resize */
             // char buff[128];
             // get_text(buff, entry->ptr);
@@ -822,7 +827,7 @@
             break;
         }
         num_inserted++;
-        *old_entry = *entry;
+        *cur_entry = *entry;
         /* For entries which we *do* manage to insert into old_index, we don't
          * want them double copied into the final output.
          */

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2009-10-13 13:05:16 +0000
+++ bzrlib/diff.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd.
+# Copyright (C) 2005-2010 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 import os
 import re
 import shutil
+import string
 import sys
 
 from bzrlib.lazy_import import lazy_import
@@ -38,6 +39,8 @@
     timestamp,
     views,
     )
+
+from bzrlib.workingtree import WorkingTree
 """)
 
 from bzrlib.symbol_versioning import (
@@ -46,6 +49,12 @@
 from bzrlib.trace import mutter, note, warning
 
 
+class AtTemplate(string.Template):
+    """Templating class that uses @ instead of $."""
+
+    delimiter = '@'
+
+
 # TODO: Rather than building a changeset object, we should probably
 # invoke callbacks on an object.  That object can either accumulate a
 # list, write them out directly, etc etc.
@@ -444,7 +453,10 @@
 
 def _patch_header_date(tree, file_id, path):
     """Returns a timestamp suitable for use in a patch header."""
-    mtime = tree.get_file_mtime(file_id, path)
+    try:
+        mtime = tree.get_file_mtime(file_id, path)
+    except errors.FileTimestampUnavailable:
+        mtime = 0
     return timestamp.format_patch_date(mtime)
 
 
@@ -672,7 +684,8 @@
     def from_string(klass, command_string, old_tree, new_tree, to_file,
                     path_encoding='utf-8'):
         command_template = commands.shlex_split_unicode(command_string)
-        command_template.extend(['%(old_path)s', '%(new_path)s'])
+        if '@' not in command_string:
+            command_template.extend(['@old_path', '@new_path'])
         return klass(command_template, old_tree, new_tree, to_file,
                      path_encoding)
 
@@ -685,7 +698,8 @@
 
     def _get_command(self, old_path, new_path):
         my_map = {'old_path': old_path, 'new_path': new_path}
-        return [t % my_map for t in self.command_template]
+        return [AtTemplate(t).substitute(my_map) for t in
+                self.command_template]
 
     def _execute(self, old_path, new_path):
         command = self._get_command(old_path, new_path)
@@ -711,9 +725,13 @@
                 raise
         return True
 
-    def _write_file(self, file_id, tree, prefix, relpath):
+    def _write_file(self, file_id, tree, prefix, relpath, force_temp=False,
+                    allow_write=False):
+        if not force_temp and isinstance(tree, WorkingTree):
+            return tree.abspath(tree.id2path(file_id))
+        
         full_path = osutils.pathjoin(self._root, prefix, relpath)
-        if self._try_symlink_root(tree, prefix):
+        if not force_temp and self._try_symlink_root(tree, prefix):
             return full_path
         parent_dir = osutils.dirname(full_path)
         try:
@@ -730,16 +748,22 @@
                 target.close()
         finally:
             source.close()
-        osutils.make_readonly(full_path)
-        mtime = tree.get_file_mtime(file_id)
+        if not allow_write:
+            osutils.make_readonly(full_path)
+        try:
+            mtime = tree.get_file_mtime(file_id)
+        except errors.FileTimestampUnavailable:
+            mtime = 0
         os.utime(full_path, (mtime, mtime))
         return full_path
 
-    def _prepare_files(self, file_id, old_path, new_path):
+    def _prepare_files(self, file_id, old_path, new_path, force_temp=False,
+                       allow_write_new=False):
         old_disk_path = self._write_file(file_id, self.old_tree, 'old',
-                                         old_path)
+                                         old_path, force_temp)
         new_disk_path = self._write_file(file_id, self.new_tree, 'new',
-                                         new_path)
+                                         new_path, force_temp,
+                                         allow_write=allow_write_new)
         return old_disk_path, new_disk_path
 
     def finish(self):
@@ -753,9 +777,32 @@
     def diff(self, file_id, old_path, new_path, old_kind, new_kind):
         if (old_kind, new_kind) != ('file', 'file'):
             return DiffPath.CANNOT_DIFF
-        self._prepare_files(file_id, old_path, new_path)
-        self._execute(osutils.pathjoin('old', old_path),
-                      osutils.pathjoin('new', new_path))
+        (old_disk_path, new_disk_path) = self._prepare_files(
+                                                file_id, old_path, new_path)
+        self._execute(old_disk_path, new_disk_path)
+
+    def edit_file(self, file_id):
+        """Use this tool to edit a file.
+
+        A temporary copy will be edited, and the new contents will be
+        returned.
+
+        :param file_id: The id of the file to edit.
+        :return: The new contents of the file.
+        """
+        old_path = self.old_tree.id2path(file_id)
+        new_path = self.new_tree.id2path(file_id)
+        new_abs_path = self._prepare_files(file_id, old_path, new_path,
+                                           allow_write_new=True,
+                                           force_temp=True)[1]
+        command = self._get_command(osutils.pathjoin('old', old_path),
+                                    osutils.pathjoin('new', new_path))
+        subprocess.call(command, cwd=self._root)
+        new_file = open(new_abs_path, 'r')
+        try:
+            return new_file.read()
+        finally:
+            new_file.close()
 
 
 class DiffTree(object):

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2009-10-02 05:43:41 +0000
+++ bzrlib/dirstate.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1339,14 +1339,14 @@
                     minikind = child[1][0][0]
                     fingerprint = child[1][0][4]
                     executable = child[1][0][3]
-                    old_child_path = osutils.pathjoin(child[0][0],
-                                                      child[0][1])
+                    old_child_path = osutils.pathjoin(child_dirname,
+                                                      child_basename)
                     removals[child[0][2]] = old_child_path
                     child_suffix = child_dirname[len(old_path):]
                     new_child_dirname = (new_path + child_suffix)
                     key = (new_child_dirname, child_basename, child[0][2])
-                    new_child_path = os.path.join(new_child_dirname,
-                                                  child_basename)
+                    new_child_path = osutils.pathjoin(new_child_dirname,
+                                                      child_basename)
                     insertions[child[0][2]] = (key, minikind, executable,
                                                fingerprint, new_child_path)
         self._check_delta_ids_absent(new_ids, delta, 0)
@@ -1997,6 +1997,8 @@
                 entry_index, present = self._find_entry_index(key, block)
                 if present:
                     entry = self._dirblocks[block_index][1][entry_index]
+                    # TODO: We might want to assert that entry[0][2] ==
+                    #       fileid_utf8.
                     if entry[1][tree_index][0] in 'fdlt':
                         # this is the result we are looking for: the
                         # real home of this file_id in this tree.
@@ -2354,8 +2356,6 @@
         self.update_minimal(('', '', new_id), 'd',
             path_utf8='', packed_stat=entry[1][0][4])
         self._dirblock_state = DirState.IN_MEMORY_MODIFIED
-        if self._id_index is not None:
-            self._id_index.setdefault(new_id, set()).add(entry[0])
 
     def set_parent_trees(self, trees, ghosts):
         """Set the parent trees for the dirstate.
@@ -3013,6 +3013,13 @@
             if absent_positions == tree_count:
                 raise AssertionError(
                     "entry %r has no data for any tree." % (entry,))
+        if self._id_index is not None:
+            for file_id, entry_keys in self._id_index.iteritems():
+                for entry_key in entry_keys:
+                    if entry_key[2] != file_id:
+                        raise AssertionError(
+                            'file_id %r did not match entry key %s'
+                            % (file_id, entry_key))
 
     def _wipe_state(self):
         """Forget all state information about the dirstate."""

=== modified file 'bzrlib/doc_generate/autodoc_man.py'
--- bzrlib/doc_generate/autodoc_man.py	2009-06-19 10:00:56 +0000
+++ bzrlib/doc_generate/autodoc_man.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -171,7 +171,7 @@
 man_head = """\
 .TH bzr 1 "%(datestamp)s" "%(version)s" "Bazaar"
 .SH "NAME"
-Bazaar (%(bzrcmd)s) - next-generation distributed version control
+%(bzrcmd)s - Bazaar next-generation distributed version control
 .SH "SYNOPSIS"
 .B "%(bzrcmd)s"
 .I "command"

=== modified file 'bzrlib/doc_generate/autodoc_rstx.py'
--- bzrlib/doc_generate/autodoc_rstx.py	2009-09-09 14:35:26 +0000
+++ bzrlib/doc_generate/autodoc_rstx.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Generate ReStructuredText source for the User Reference Manual.
+"""Generate reStructuredText source for the User Reference Manual.
 Loosely based on the manpage generator autodoc_man.py.
 
 Written by the Bazaar community.
@@ -31,14 +31,6 @@
 import bzrlib.osutils
 
 
-# Set this to True to generate a file per topic.
-# This probably ought to be an option. The files probably
-# ought to be prefixed with their section name as well so
-# there's zero risk of clashing with a standard sphinx
-# topic (like search.html).
-FILE_PER_TOPIC = False
-
-
 def get_filename(options):
     """Provides name of manual"""
     return "%s_man.txt" % (options.bzr_name)
@@ -74,8 +66,7 @@
         output_dir=topic_dir))
     result.append(_get_section(registry, SECT_LIST, "Lists",
         output_dir=topic_dir))
-    result.append(_get_commands_section(registry))
-    #result.append(_get_section(registry, SECT_PLUGIN, "Standard Plug-ins"))
+    result.append(_get_commands_section(registry, output_dir=topic_dir))
     return "\n".join(result)
 
 
@@ -86,72 +77,65 @@
     If output_dir is not None, topics are dumped into text files there
     during processing, as well as being included in the return result.
     """
+    file_per_topic = output_dir is not None
+    lines = [title, hdg_level1 * len(title), ""]
+    if file_per_topic:
+        lines.extend([".. toctree::", "   :maxdepth: 1", ""])
+
     topics = sorted(registry.get_topics_for_section(section))
-    lines = [title, hdg_level1 * len(title), ""]
-
-    # docutils treats section heading as implicit link target.
-    # But in some cases topic and heading are different, e.g.:
-    #
-    # `bugs' vs. `Bug Trackers'
-    # `working-tree' vs. `Working Trees'
-    #
-    # So for building proper cross-reference between topic names
-    # and corresponding sections in document, we need provide
-    # simple glue in the form:
-    #
-    # .. _topic: `heading`_
-    links_glue = []
-
     for topic in topics:
         help = registry.get_detail(topic)
-        heading,text = help.split("\n", 1)
-        lines.append(heading)
+        heading, text = help.split("\n", 1)
         if not text.startswith(hdg_level2):
-            lines.append(hdg_level2 * len(heading))
-        lines.append(text)
-        lines.append('')
-        # check that topic match heading
-        if topic != heading.lower():
-            links_glue.append((topic, heading))
-        # dump the text if requested
-        if output_dir is not None:
-            out_file = bzrlib.osutils.pathjoin(output_dir, topic + ".txt")
-            _dump_text(out_file, help)
-
-    # provide links glue for topics that don't match headings
-    lines.extend([".. _%s: `%s`_" % i for i in links_glue])
-    lines.append('')
+            underline = hdg_level2 * len(heading)
+            help = "%s\n%s\n\n%s\n\n" % (heading, underline, text)
+        else:
+            help = "%s\n%s\n\n" % (heading, text)
+        if file_per_topic:
+            topic_id = _dump_text(output_dir, topic, help)
+            lines.append("   %s" % topic_id)
+        else:
+            lines.append(help)
 
     return "\n" + "\n".join(lines) + "\n"
 
 
-def _dump_text(filename, text):
-    """Dump text to filename."""
-    if not FILE_PER_TOPIC:
-        return
-    f =  open(filename, "w")
-    f.writelines(text)
-    f.close()
-
-
 def _get_commands_section(registry, title="Commands", hdg_level1="#",
-                          hdg_level2="="):
+        hdg_level2="=", output_dir=None):
     """Build the commands reference section of the manual."""
+    file_per_topic = output_dir is not None
     lines = [title, hdg_level1 * len(title), ""]
+    if file_per_topic:
+        lines.extend([".. toctree::", "   :maxdepth: 1", ""])
+
     cmds = sorted(bzrlib.commands.builtin_command_names())
     for cmd_name in cmds:
         cmd_object = bzrlib.commands.get_cmd_object(cmd_name)
         if cmd_object.hidden:
             continue
         heading = cmd_name
+        underline = hdg_level2 * len(heading)
         text = cmd_object.get_help_text(plain=False, see_also_as_links=True)
-        lines.append(heading)
-        lines.append(hdg_level2 * len(heading))
-        lines.append(text)
-        lines.append('')
+        help = "%s\n%s\n\n%s\n\n" % (heading, underline, text)
+        if file_per_topic:
+            topic_id = _dump_text(output_dir, cmd_name, help)
+            lines.append("   %s" % topic_id)
+        else:
+            lines.append(help)
+
     return "\n" + "\n".join(lines) + "\n"
 
 
+def _dump_text(output_dir, topic, text):
+    """Dump text for a topic to a file."""
+    topic_id = "%s-%s" % (topic, "help")
+    filename = bzrlib.osutils.pathjoin(output_dir, topic_id + ".txt")
+    f =  open(filename, "w")
+    f.writelines(text)
+    f.close()
+    return topic_id
+
+
 ##
 # TEMPLATES
 
@@ -194,8 +178,8 @@
 
 The following web sites provide further information on Bazaar:
 
-:Home page:                     http://www.bazaar-vcs.org/
-:Official docs:                 http://doc.bazaar-vcs.org/
+:Home page:                     http://bazaar.canonical.com/
+:Official docs:                 http://doc.bazaar.canonical.com/
 :Launchpad:                     https://launchpad.net/bzr/
 """
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2009-08-30 21:34:42 +0000
+++ bzrlib/errors.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -702,11 +702,32 @@
 # TODO: Probably this behavior of should be a common superclass
 class NotBranchError(PathError):
 
-    _fmt = 'Not a branch: "%(path)s".'
+    _fmt = 'Not a branch: "%(path)s"%(detail)s.'
 
-    def __init__(self, path):
+    def __init__(self, path, detail=None, bzrdir=None):
        import bzrlib.urlutils as urlutils
-       self.path = urlutils.unescape_for_display(path, 'ascii')
+       path = urlutils.unescape_for_display(path, 'ascii')
+       if detail is not None:
+           detail = ': ' + detail
+       self.detail = detail
+       self.bzrdir = bzrdir
+       PathError.__init__(self, path=path)
+
+    def _format(self):
+        # XXX: Ideally self.detail would be a property, but Exceptions in
+        # Python 2.4 have to be old-style classes so properties don't work.
+        # Instead we override _format.
+        if self.detail is None:
+            if self.bzrdir is not None:
+                try:
+                    self.bzrdir.open_repository()
+                except NoRepositoryPresent:
+                    self.detail = ''
+                else:
+                    self.detail = ': location is a repository'
+            else:
+                self.detail = ''
+        return PathError._format(self)
 
 
 class NoSubmitBranch(PathError):
@@ -1247,8 +1268,8 @@
 class AmbiguousBase(BzrError):
 
     def __init__(self, bases):
-        warn("BzrError AmbiguousBase has been deprecated as of bzrlib 0.8.",
-                DeprecationWarning)
+        symbol_versioning.warn("BzrError AmbiguousBase has been deprecated "
+            "as of bzrlib 0.8.", DeprecationWarning, stacklevel=2)
         msg = ("The correct base is unclear, because %s are all equally close"
                 % ", ".join(bases))
         BzrError.__init__(self, msg)
@@ -2942,12 +2963,18 @@
 class HookFailed(BzrError):
     """Raised when a pre_change_branch_tip hook function fails anything other
     than TipChangeRejected.
+
+    Note that this exception is no longer raised, and the import is only left
+    to be nice to code which might catch it in a plugin.
     """
 
     _fmt = ("Hook '%(hook_name)s' during %(hook_stage)s failed:\n"
             "%(traceback_text)s%(exc_value)s")
 
-    def __init__(self, hook_stage, hook_name, exc_info):
+    def __init__(self, hook_stage, hook_name, exc_info, warn=True):
+        if warn:
+            symbol_versioning.warn("BzrError HookFailed has been deprecated "
+                "as of bzrlib 2.1.", DeprecationWarning, stacklevel=2)
         import traceback
         self.hook_stage = hook_stage
         self.hook_name = hook_name
@@ -3075,3 +3102,25 @@
     def __init__(self, source_branch, target_branch):
         self.source_branch = source_branch
         self.target_branch = target_branch
+
+
+class NoRoundtrippingSupport(BzrError):
+
+    _fmt = ("Roundtripping is not supported between %(source_branch)r and "
+            "%(target_branch)r.")
+
+    internal_error = True
+
+    def __init__(self, source_branch, target_branch):
+        self.source_branch = source_branch
+        self.target_branch = target_branch
+
+
+class FileTimestampUnavailable(BzrError):
+
+    _fmt = "The filestamp for %(path)s is not available."
+
+    internal_error = True
+
+    def __init__(self, path):
+        self.path = path

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2009-07-29 13:46:55 +0000
+++ bzrlib/export/dir_exporter.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -52,21 +52,17 @@
                 raise errors.BzrError("Can't export tree to non-empty directory.")
         else:
             raise
+    # Iterate everything, building up the files we will want to export, and
+    # creating the directories and symlinks that we need.
+    # This tracks (file_id, (destination_path, executable))
+    # This matches the api that tree.iter_files_bytes() wants
+    # Note in the case of revision trees, this does trigger a double inventory
+    # lookup, hopefully it isn't too expensive.
+    to_fetch = []
     for dp, ie in _export_iter_entries(tree, subdir):
         fullpath = osutils.pathjoin(dest, dp)
         if ie.kind == "file":
-            if filtered:
-                chunks = tree.get_file_lines(ie.file_id)
-                filters = tree._content_filter_stack(dp)
-                context = ContentFilterContext(dp, tree, ie)
-                contents = filtered_output_bytes(chunks, filters, context)
-                content = ''.join(contents)
-                fileobj = StringIO.StringIO(content)
-            else:
-                fileobj = tree.get_file(ie.file_id)
-            osutils.pumpfile(fileobj, file(fullpath, 'wb'))
-            if tree.is_executable(ie.file_id):
-                os.chmod(fullpath, 0755)
+            to_fetch.append((ie.file_id, (dp, tree.is_executable(ie.file_id))))
         elif ie.kind == "directory":
             os.mkdir(fullpath)
         elif ie.kind == "symlink":
@@ -80,3 +76,21 @@
         else:
             raise errors.BzrError("don't know how to export {%s} of kind %r" %
                (ie.file_id, ie.kind))
+    # The data returned here can be in any order, but we've already created all
+    # the directories
+    flags = os.O_CREAT | os.O_TRUNC | os.O_WRONLY | getattr(os, 'O_BINARY', 0)
+    for (relpath, executable), chunks in tree.iter_files_bytes(to_fetch):
+        if filtered:
+            filters = tree._content_filter_stack(relpath)
+            context = ContentFilterContext(relpath, tree, ie)
+            chunks = filtered_output_bytes(chunks, filters, context)
+        fullpath = osutils.pathjoin(dest, relpath)
+        # We set the mode and let the umask sort out the file info
+        mode = 0666
+        if executable:
+            mode = 0777
+        out = os.fdopen(os.open(fullpath, flags, mode), 'wb')
+        try:
+            out.writelines(chunks)
+        finally:
+            out.close()

=== modified file 'bzrlib/export/zip_exporter.py'
--- bzrlib/export/zip_exporter.py	2009-03-23 14:59:43 +0000
+++ bzrlib/export/zip_exporter.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,8 +36,9 @@
 # Windows expects this bit to be set in the 'external_attr' section
 # Or it won't consider the entry a directory
 ZIP_DIRECTORY_BIT = (1 << 4)
+FILE_PERMISSIONS = (0644 << 16)
 
-_FILE_ATTR = stat.S_IFREG
+_FILE_ATTR = stat.S_IFREG | FILE_PERMISSIONS
 _DIR_ATTR = stat.S_IFDIR | ZIP_DIRECTORY_BIT
 
 

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2009-08-07 04:29:36 +0000
+++ bzrlib/fetch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,6 +28,8 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
+    graph as _mod_graph,
+    static_tuple,
     tsort,
     versionedfile,
     )
@@ -36,10 +38,10 @@
 from bzrlib import (
     errors,
     symbol_versioning,
+    ui,
     )
 from bzrlib.revision import NULL_REVISION
 from bzrlib.trace import mutter
-import bzrlib.ui
 
 
 class RepoFetcher(object):
@@ -96,7 +98,7 @@
         # assert not missing
         self.count_total = 0
         self.file_ids_names = {}
-        pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        pb = ui.ui_factory.nested_progress_bar()
         pb.show_pct = pb.show_count = False
         try:
             pb.update("Finding revisions", 0, 2)
@@ -123,7 +125,7 @@
             raise errors.IncompatibleRepositories(
                 self.from_repository, self.to_repository,
                 "different rich-root support")
-        pb = bzrlib.ui.ui_factory.nested_progress_bar()
+        pb = ui.ui_factory.nested_progress_bar()
         try:
             pb.update("Get stream source")
             source = self.from_repository._get_source(
@@ -251,13 +253,24 @@
         # yet, and are unlikely to in non-rich-root environments anyway.
         root_id_order.sort(key=operator.itemgetter(0))
         # Create a record stream containing the roots to create.
-        from bzrlib.graph import FrozenHeadsCache
-        graph = FrozenHeadsCache(graph)
+        if len(revs) > 100:
+            # XXX: not covered by tests, should have a flag to always run
+            # this. -- mbp 20100129
+            graph = _get_rich_root_heads_graph(self.source, revs)
         new_roots_stream = _new_root_data_stream(
             root_id_order, rev_id_to_root_id, parent_map, self.source, graph)
         return [('texts', new_roots_stream)]
 
 
+def _get_rich_root_heads_graph(source_repo, revision_ids):
+    """Get a Graph object suitable for asking heads() for new rich roots."""
+    st = static_tuple.StaticTuple
+    revision_keys = [st(r_id).intern() for r_id in revision_ids]
+    known_graph = source_repo.revisions.get_known_graph_ancestry(
+                    revision_keys)
+    return _mod_graph.GraphThunkIdsToKeys(known_graph)
+
+
 def _new_root_data_stream(
     root_keys_to_create, rev_id_to_root_id_map, parent_map, repo, graph=None):
     """Generate a texts substream of synthesised root entries.

=== modified file 'bzrlib/foreign.py'
--- bzrlib/foreign.py	2009-10-20 10:43:50 +0000
+++ bzrlib/foreign.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -124,6 +124,8 @@
 
     branch_format = None
 
+    repository_format = None
+
     def __init__(self, mapping_registry, abbreviation=None):
         """Create a new foreign vcs instance.
 

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2009-03-23 14:59:43 +0000
+++ bzrlib/globbing.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -215,6 +215,40 @@
                 return patterns[match.lastindex -1]
         return None
 
+class ExceptionGlobster(object):
+    """A Globster that supports exception patterns.
+    
+    Exceptions are ignore patterns prefixed with '!'.  Exception
+    patterns take precedence over regular patterns and cause a 
+    matching filename to return None from the match() function.  
+    Patterns using a '!!' prefix are highest precedence, and act 
+    as regular ignores. '!!' patterns are useful to establish ignores
+    that apply under paths specified by '!' exception patterns.
+    """
+    
+    def __init__(self,patterns):
+        ignores = [[], [], []]
+        for p in patterns:
+            if p.startswith(u'!!'):
+                ignores[2].append(p[2:])
+            elif p.startswith(u'!'):
+                ignores[1].append(p[1:])
+            else:
+                ignores[0].append(p)
+        self._ignores = [Globster(i) for i in ignores]
+        
+    def match(self, filename):
+        """Searches for a pattern that matches the given filename.
+
+        :return A matching pattern or None if there is no matching pattern.
+        """
+        double_neg = self._ignores[2].match(filename)
+        if double_neg:
+            return "!!%s" % double_neg
+        elif self._ignores[1].match(filename):
+            return None
+        else:
+            return self._ignores[0].match(filename)
 
 class _OrderedGlobster(Globster):
     """A Globster that keeps pattern order."""
@@ -238,11 +272,14 @@
                     prefix=r'(?:.*/)?(?!.*/)')
 
 
+_slashes = re.compile(r'[\\/]+')
 def normalize_pattern(pattern):
     """Converts backslashes in path patterns to forward slashes.
 
     Doesn't normalize regular expressions - they may contain escapes.
     """
-    if not pattern.startswith('RE:'):
-        pattern = pattern.replace('\\','/')
-    return pattern.rstrip('/')
+    if not (pattern.startswith('RE:') or pattern.startswith('!RE:')):
+        pattern = _slashes.sub('/', pattern)
+    if len(pattern) > 1:
+        pattern = pattern.rstrip('/')
+    return pattern

=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2009-09-14 01:48:28 +0000
+++ bzrlib/graph.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1679,6 +1679,19 @@
     return result
 
 
+class GraphThunkIdsToKeys(object):
+    """Forwards calls about 'ids' to be about keys internally."""
+
+    def __init__(self, graph):
+        self._graph = graph
+
+    def heads(self, ids):
+        """See Graph.heads()"""
+        as_keys = [(i,) for i in ids]
+        head_keys = self._graph.heads(as_keys)
+        return set([h[0] for h in head_keys])
+
+
 _counters = [0,0,0,0,0,0,0]
 try:
     from bzrlib._known_graph_pyx import KnownGraph

=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2009-10-19 15:45:10 +0000
+++ bzrlib/groupcompress.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,6 +31,7 @@
     knit,
     osutils,
     pack,
+    static_tuple,
     trace,
     )
 from bzrlib.btree_index import BTreeBuilder
@@ -1269,6 +1270,7 @@
         """See VersionedFiles.clear_cache()"""
         self._group_cache.clear()
         self._index._graph_index.clear_cache()
+        self._index._int_cache.clear()
 
     def _check_add(self, key, lines, random_id, check_content):
         """check that version_id and lines are safe to add."""
@@ -1745,8 +1747,13 @@
                 key = record.key
             self._unadded_refs[key] = record.parents
             yield found_sha1
-            keys_to_add.append((key, '%d %d' % (start_point, end_point),
-                (record.parents,)))
+            as_st = static_tuple.StaticTuple.from_sequence
+            if record.parents is not None:
+                parents = as_st([as_st(p) for p in record.parents])
+            else:
+                parents = None
+            refs = static_tuple.StaticTuple(parents)
+            keys_to_add.append((key, '%d %d' % (start_point, end_point), refs))
         if len(keys_to_add):
             flush()
         self._compressor = None
@@ -1832,6 +1839,9 @@
         self.has_graph = parents
         self._is_locked = is_locked
         self._inconsistency_fatal = inconsistency_fatal
+        # GroupCompress records tend to have the same 'group' start + offset
+        # repeated over and over, this creates a surplus of ints
+        self._int_cache = {}
         if track_external_parent_refs:
             self._key_dependencies = knit._KeyRefs(
                 track_new_keys=track_new_keys)
@@ -1873,8 +1883,11 @@
         if not random_id:
             present_nodes = self._get_entries(keys)
             for (index, key, value, node_refs) in present_nodes:
-                if node_refs != keys[key][1]:
-                    details = '%s %s %s' % (key, (value, node_refs), keys[key])
+                # Sometimes these are passed as a list rather than a tuple
+                node_refs = static_tuple.as_tuples(node_refs)
+                passed = static_tuple.as_tuples(keys[key])
+                if node_refs != passed[1]:
+                    details = '%s %s %s' % (key, (value, node_refs), passed)
                     if self._inconsistency_fatal:
                         raise errors.KnitCorrupt(self, "inconsistent details"
                                                  " in add_records: %s" %
@@ -2013,11 +2026,24 @@
         """Convert an index value to position details."""
         bits = node[2].split(' ')
         # It would be nice not to read the entire gzip.
+        # start and stop are put into _int_cache because they are very common.
+        # They define the 'group' that an entry is in, and many groups can have
+        # thousands of objects.
+        # Branching Launchpad, for example, saves ~600k integers, at 12 bytes
+        # each, or about 7MB. Note that it might be even more when you consider
+        # how PyInt is allocated in separate slabs. And you can't return a slab
+        # to the OS if even 1 int on it is in use. Note though that Python uses
+        # a LIFO when re-using PyInt slots, which probably causes more
+        # fragmentation.
         start = int(bits[0])
+        start = self._int_cache.setdefault(start, start)
         stop = int(bits[1])
+        stop = self._int_cache.setdefault(stop, stop)
         basis_end = int(bits[2])
         delta_end = int(bits[3])
-        return node[0], start, stop, basis_end, delta_end
+        # We can't use StaticTuple here, because node[0] is a BTreeGraphIndex
+        # instance...
+        return (node[0], start, stop, basis_end, delta_end)
 
     def scan_unvalidated_index(self, graph_index):
         """Inform this _GCGraphIndex that there is an unvalidated index.

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2009-06-19 09:06:56 +0000
+++ bzrlib/help.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -78,7 +78,11 @@
     shown_commands = [(n, o) for n, o in commands if o.hidden == hidden]
     max_name = max(len(n) for n, o in shown_commands)
     indent = ' ' * (max_name + 1)
-    width = osutils.terminal_width() - 1
+    width = osutils.terminal_width()
+    if width is None:
+        width = osutils.default_terminal_width
+    # we need one extra space for terminals that wrap on last char
+    width = width - 1
 
     for cmd_name, cmd_object in sorted(shown_commands):
         plugin_name = cmd_object.plugin_name()

=== modified file 'bzrlib/help_topics/__init__.py'
--- bzrlib/help_topics/__init__.py	2009-10-13 20:15:45 +0000
+++ bzrlib/help_topics/__init__.py	2010-02-16 16:08:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -152,10 +152,16 @@
     out.append(
 """Revision Identifiers
 
-A revision identifier refers to a specific state of a branch's history. It can
-be a revision number, or a keyword followed by ':' and often other
-parameters. Some examples of identifiers are '3', 'last:1', 'before:yesterday'
-and 'submit:'.
+A revision identifier refers to a specific state of a branch's history.  It
+can be expressed in several ways.  It can begin with a keyword to
+unambiguously specify a given lookup type; some examples are 'last:1',
+'before:yesterday' and 'submit:'.
+
+Alternately, it can be given without a keyword, in which case it will be
+checked as a revision number, a tag, a revision id, a date specification, or a
+branch specification, in that order.  For example, 'date:today' could be
+written as simply 'today', though if you have a tag called 'today' that will
+be found first.
 
 If 'REV1' and 'REV2' are revision identifiers, then 'REV1..REV2' denotes a
 revision range. Examples: '3647..3649', 'date:yesterday..-1' and
@@ -245,6 +251,29 @@
         out += "\nSupported modifiers::\n\n  " + \
             '  '.join(decl)
 
+    out += """\
+\nBazaar supports all of the standard parts within the URL::
+
+  <protocol>://[user[:password]@]host[:port]/[path]
+
+allowing URLs such as::
+
+  http://bzruser:BadPass@bzr.example.com:8080/bzr/trunk
+
+For bzr+ssh:// and sftp:// URLs, Bazaar also supports paths that begin
+with '~' as meaning that the rest of the path should be interpreted
+relative to the remote user's home directory.  For example if the user
+``remote`` has a  home directory of ``/home/remote`` on the server
+shell.example.com, then::
+
+  bzr+ssh://remote@shell.example.com/~/myproject/trunk
+
+would refer to ``/home/remote/myproject/trunk``.
+
+Many commands that accept URLs also accept location aliases too.  See
+::doc:`location-alias-help`.
+"""
+
     return out
 
 
@@ -280,13 +309,14 @@
 """Global Options
 
 These options may be used with any command, and may appear in front of any
-command.  (e.g. "bzr --profile help").
+command.  (e.g. ``bzr --profile help``).
 
 --version      Print the version number. Must be supplied before the command.
 --no-aliases   Do not process command aliases when running this command.
 --builtin      Use the built-in version of a command, not the plugin version.
                This does not suppress other plugin effects.
 --no-plugins   Do not process any plugins.
+--concurrency  Number of processes that can be run concurrently (selftest).
 
 --profile      Profile execution using the hotshot profiler.
 --lsprof       Profile execution using the lsprof profiler.
@@ -298,9 +328,11 @@
                will be a pickle.
 --coverage     Generate line coverage report in the specified directory.
 
-See doc/developers/profiling.txt for more information on profiling.
+See http://doc.bazaar.canonical.com/developers/profiling.html for more
+information on profiling.
+
 A number of debug flags are also available to assist troubleshooting and
-development.  See `bzr help debug-flags`.
+development.  See :doc:`debug-flags-help`.
 """
 
 _standard_options = \
@@ -378,7 +410,9 @@
 bind"). This will change the location that the commits are sent to. The bind
 command can also be used to turn a branch into a heavy checkout. If you
 would like to convert your heavy checkout into a normal branch so that every
-commit is local, you can use the "unbind" command.
+commit is local, you can use the "unbind" command. To see whether or not a
+branch is bound or not you can use the "info" command. If the branch is bound
+it will tell you the location of the bound branch.
 
 Related commands::
 
@@ -392,6 +426,8 @@
               be sent to
   unbind      Turn a heavy checkout into a standalone branch so that any
               commits are only made locally
+  info        Displays whether a branch is bound or unbound. If the branch is
+              bound, then it will also display the location of the bound branch
 """
 
 _repositories = \
@@ -487,11 +523,19 @@
 branch history is stored), but multiple branches may share the same
 repository (a shared repository). Branches can be copied and merged.
 
+In addition, one branch may be bound to another one.  Binding to another
+branch indicates that commits which happen in this branch must also 
+happen in the other branch.  Bazaar ensures consistency by not allowing 
+commits when the two branches are out of date.  In order for a commit 
+to succeed, it may be necessary to update the current branch using 
+``bzr update``.
+
 Related commands::
 
   init    Change a directory into a versioned branch.
   branch  Create a new branch that is a copy of an existing branch.
   merge   Perform a three-way merge.
+  bind    Bind a branch to another one.
 """
 
 
@@ -555,9 +599,11 @@
 BZR_HOME         Directory holding .bazaar config dir. Overrides HOME.
 BZR_HOME (Win32) Directory holding bazaar config dir. Overrides APPDATA and HOME.
 BZR_REMOTE_PATH  Full name of remote 'bzr' command (for bzr+ssh:// URLs).
-BZR_SSH          SSH client: paramiko (default), openssh, ssh, plink.
+BZR_SSH          Path to SSH client, or one of paramiko, openssh, sshcorp, plink.
 BZR_LOG          Location of .bzr.log (use '/dev/null' to suppress log).
 BZR_LOG (Win32)  Location of .bzr.log (use 'NUL' to suppress log).
+BZR_COLUMNS      Override implicit terminal width.
+BZR_CONCURRENCY  Number of processes that can be run concurrently (selftest).
 ================ =================================================================
 """
 
@@ -614,7 +660,7 @@
 differences.
 """
 
-_branches_out_of_sync = """Branches out of sync
+_branches_out_of_sync = """Branches Out of Sync
 
 When reconfiguring a checkout, tree or branch into a lightweight checkout,
 a local branch must be destroyed.  (For checkouts, this is the local branch
@@ -649,18 +695,20 @@
 project owner to upgrade.
 
 
-Note: Some of the older formats have two variants:
-a plain one and a rich-root one. The latter include an additional
-field about the root of the tree. There is no performance cost
-for using a rich-root format but you cannot easily merge changes
-from a rich-root format into a plain format. As a consequence,
-moving a project to a rich-root format takes some co-ordination
-in that all contributors need to upgrade their repositories
-around the same time. 2a and all future formats will be
-implicitly rich-root.
-
-See ``bzr help current-formats`` for the complete list of
-currently supported formats. See ``bzr help other-formats`` for
+.. note::
+
+   Some of the older formats have two variants:
+   a plain one and a rich-root one. The latter include an additional
+   field about the root of the tree. There is no performance cost
+   for using a rich-root format but you cannot easily merge changes
+   from a rich-root format into a plain format. As a consequence,
+   moving a project to a rich-root format takes some co-ordination
+   in that all contributors need to upgrade their repositories
+   around the same time. 2a and all future formats will be
+   implicitly rich-root.
+
+See :doc:`current-formats-help` for the complete list of
+currently supported formats. See :doc:`other-formats-help` for
 descriptions of any available experimental and deprecated formats.
 """
 
@@ -709,14 +757,14 @@
                         'Information on configuring authentication')
 topic_registry.register('configuration', _load_from_file,
                         'Details on the configuration settings available')
-topic_registry.register('conflicts', _load_from_file,
+topic_registry.register('conflict-types', _load_from_file,
                         'Types of conflicts and what to do about them')
 topic_registry.register('debug-flags', _load_from_file,
                         'Options to show or record debug information')
+topic_registry.register('location-alias', _load_from_file,
+                        'Aliases for remembered locations')
 topic_registry.register('log-formats', _load_from_file,
                         'Details on the logging formats available')
-topic_registry.register('diverged-branches', _load_from_file,
-                        'How to fix diverged branches')
 
 
 # Register concept topics.
@@ -730,6 +778,9 @@
 topic_registry.register('content-filters', _load_from_file,
                         'Conversion of content into/from working trees',
                         SECT_CONCEPT)
+topic_registry.register('diverged-branches', _load_from_file,
+                        'How to fix diverged branches',
+                        SECT_CONCEPT)
 topic_registry.register('eol', _load_from_file,
                         'Information on end-of-line handling',
                         SECT_CONCEPT)
@@ -823,6 +874,7 @@
 
 def help_as_plain_text(text):
     """Minimal converter of reStructuredText to plain text."""
+    import re
     lines = text.splitlines()
     result = []
     for line in lines:
@@ -830,5 +882,7 @@
             line = line[1:]
         elif line.endswith('::'):
             line = line[:-1]
+        # Map :doc:`xxx-help` to ``bzr help xxx``
+        line = re.sub(":doc:`(.+)-help`", r'``bzr help \1``', line)
         result.append(line)
     return "\n".join(result) + "\n"

=== modified file 'bzrlib/help_topics/en/authentication.txt'
--- bzrlib/help_topics/en/authentication.txt	2008-05-09 16:40:21 +0000
+++ bzrlib/help_topics/en/authentication.txt	2010-01-03 03:33:10 +0000
@@ -110,10 +110,8 @@
 File format
 -----------
 
-The general rules for `configuration files`_ apply except for the variable
-policies.
-
-.. _configuration files: #configuration-settings
+The general rules for :doc:`configuration files <configuration-help>`
+apply except for the variable policies.
 
 Each section describes an authentication definition.
 

=== modified file 'bzrlib/help_topics/en/configuration.txt'
--- bzrlib/help_topics/en/configuration.txt	2009-10-02 09:11:43 +0000
+++ bzrlib/help_topics/en/configuration.txt	2010-01-03 03:33:10 +0000
@@ -272,7 +272,7 @@
 variable policies which don't apply.
 
 For more information on the possible uses of the authentication configuration
-file see `Authentication Settings`_.
+file see :doc:`authentication-help`.
 
 
 Common variable options
@@ -428,6 +428,18 @@
 A publically-accessible version of this branch (implying that this version is
 not publically-accessible).  Used (and set) by ``bzr send``.
 
+suppress_warnings
+~~~~~~~~~~~~~~~~~
+
+A list of strings, each string represent a warning that can be emitted by
+bzr. Mentioning a warning in this list tells bzr to not emit it.
+
+Valid values:
+
+* ``format_deprecation``:
+    whether the format deprecation warning is shown on repositories that are
+    using deprecated formats.
+
 
 Branch type specific options
 ----------------------------

=== renamed file 'bzrlib/help_topics/en/conflicts.txt' => 'bzrlib/help_topics/en/conflict-types.txt'
--- bzrlib/help_topics/en/conflicts.txt	2007-12-25 04:17:50 +0000
+++ bzrlib/help_topics/en/conflict-types.txt	2010-01-08 07:37:25 +0000
@@ -1,5 +1,5 @@
-Conflicts Types
-===============
+Conflict Types
+==============
 
 Some operations, like merge, revert and pull, modify the contents of your
 working tree.  These modifications are programmatically generated, and so they
@@ -79,6 +79,29 @@
 FILE".  Bazaar cannot auto-detect when conflicts of this kind have been
 resolved.
 
+Tag conflicts
+-------------
+
+Typical message::
+
+  Conflicting tags:
+      version-0.1
+
+When pulling from or pushing to another branch, Bazaar informs you about tags
+that conflict between the two branches; that is the same tag points to two
+different revisions.  You need not resolve these conflicts, but subsequent
+uses of pull or push will result in the same message.
+
+To resolve the conflict, you must apply the correct tags to either the target
+branch or the source branch as appropriate.  Use "bzr tags --show-ids -d
+SOURCE_URL" to see the tags in the source branch.  If you want to make the
+target branch's tags match the source branch, then in the target branch do 
+``bzr tag --force -r revid:REVISION_ID CONFLICTING_TAG`` for each of the
+CONFLICTING_TAGs, where REVISION_ID comes from the list of tags in the source
+branch.  You need not call "bzr resolve" after doing this.  To resolve in favor of the target branch, you need to similarly use ``tag --force`` in the source
+branch.  (Note that pulling or pushing using --overwrite will overwrite all
+tags as well.)
+
 Duplicate paths
 ---------------
 
@@ -181,7 +204,7 @@
   Conflict: FILE.new is not a directory, but has files in it.
   Created directory.
 
-This happens when one side has added files to a directory, and the othe side
+This happens when one side has added files to a directory, and the other side
 has changed the directory into a file or symlink.  For example::
 
   $ bzr init

=== modified file 'bzrlib/help_topics/en/content-filters.txt'
--- bzrlib/help_topics/en/content-filters.txt	2009-02-25 06:41:51 +0000
+++ bzrlib/help_topics/en/content-filters.txt	2010-01-03 03:33:10 +0000
@@ -65,8 +65,8 @@
 Note: ``bzr commit`` does not implicitly apply write converters after
 comitting files. If this makes sense for a given plugin providing
 a content filter, the plugin can usually achieve this effect by using a
-``start_commit`` or ``post_commit`` hook say. See ``bzr help hooks`` and
-`Using hooks`_ in the Bazaar User Guide for more information on hooks.
+``start_commit`` or ``post_commit`` hook say. See :doc:`hooks-help`
+for more information on hooks.
 
 
 Refreshing your working tree

=== modified file 'bzrlib/help_topics/en/debug-flags.txt'
--- bzrlib/help_topics/en/debug-flags.txt	2009-10-07 08:19:19 +0000
+++ bzrlib/help_topics/en/debug-flags.txt	2010-01-05 04:30:07 +0000
@@ -5,6 +5,7 @@
 prefix) put in the ``debug_flags`` variable in ``bazaar.conf``.
 
 -Dauth            Trace authentication sections used.
+-Dbytes           Print out how many bytes were transferred
 -Ddirstate        Trace dirstate activity (verbose!)
 -Derror           Instead of normal error handling, always print a traceback
                   on error.
@@ -26,10 +27,12 @@
 -Dprogress        Trace progress bar operations.
 -Dmerge           Emit information for debugging merges.
 -Dno_apport       Don't use apport to report crashes.
+-Dno_activity 	  Don't show transport activity indicator in progress bar.
 -Dpack            Emit information about pack operations.
 -Drelock          Emit a message every time a branch or repository object is
                   unlocked then relocked the same way.
 -Dsftp            Trace SFTP internals.
+-Dstatic_tuple    Error when a tuple is used where a StaticTuple is expected
 -Dstream          Trace fetch streams.
 -Dstrict_locks    Trace when OS locks are potentially used in a non-portable
                   manner.

=== added file 'bzrlib/help_topics/en/location-alias.txt'
--- bzrlib/help_topics/en/location-alias.txt	1970-01-01 00:00:00 +0000
+++ bzrlib/help_topics/en/location-alias.txt	2010-02-11 07:18:20 +0000
@@ -0,0 +1,19 @@
+Location aliases
+================
+
+Bazaar defines several aliases for locations associated with a branch.  These
+can be used with most commands that expect a location, such as `bzr push`.
+
+The aliases are::
+
+  :parent    the parent of this branch
+  :submit    the submit branch for this branch
+  :public    the public location of this branch
+  :bound     the branch this branch is bound to, for bound branches
+  :push      the saved location used for `bzr push` with no arguments
+  :this      this branch
+
+For example, to push to the parent location::
+
+    bzr push :parent
+

=== modified file 'bzrlib/help_topics/en/log-formats.txt'
--- bzrlib/help_topics/en/log-formats.txt	2009-02-09 08:19:18 +0000
+++ bzrlib/help_topics/en/log-formats.txt	2010-01-03 01:41:00 +0000
@@ -1,4 +1,4 @@
-Log formats
+Log Formats
 ===========
 
 A log format controls how information about each revision is displayed.

=== modified file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2008-06-25 07:17:14 +0000
+++ bzrlib/help_topics/en/patterns.txt	2010-01-02 07:36:36 +0000
@@ -23,3 +23,6 @@
 patterns are identified by a 'RE:' prefix followed by the regular
 expression.  Regular expression patterns may not include named or
 numbered groups.
+
+Ignore patterns may be prefixed with '!', which means that a filename
+matched by that pattern will not be ignored.

=== modified file 'bzrlib/help_topics/en/rules.txt'
--- bzrlib/help_topics/en/rules.txt	2009-04-26 03:04:30 +0000
+++ bzrlib/help_topics/en/rules.txt	2010-01-03 03:33:10 +0000
@@ -16,8 +16,9 @@
 
 Preferences like these are useful for commands and plugins wishing to
 provide custom behaviour for selected files.  For more information on 
-end of line conversion see ``bzr help eol``.  Keyword support is provided
-by the bzr-keywords plugin (http://launchpad.net/bzr-keywords).
+end of line conversion see :doc:`eol-help`.
+Keyword support is provided by the `keywords plugin
+<http://doc.bazaar.canonical.com/plugins/en/keywords-plugin.html>`_.
 
 Files
 -----
@@ -31,7 +32,9 @@
 Patterns are ordered and searching stops as soon as one matches.
 As a consequence, more explicit patterns should be placed towards
 the top of the file. Rule patterns use exactly the same conventions
-as ignore patterns. See ``bzr help patterns`` for details.
-
-Note: Patterns containing square brackets or spaces should be
-surrounded in quotes to ensure they are correctly parsed.
+as ignore patterns. See :doc:`patterns-help` for details.
+
+.. note::
+
+   Patterns containing square brackets or spaces should be
+   surrounded in quotes to ensure they are correctly parsed.

=== added directory 'bzrlib/help_topics/es'
=== renamed file 'doc/es/user-guide/resolving_conflicts.txt' => 'bzrlib/help_topics/es/conflicts.txt'
--- doc/es/user-guide/resolving_conflicts.txt	2008-05-12 00:59:13 +0000
+++ bzrlib/help_topics/es/conflicts.txt	2010-01-04 14:30:17 +0000
@@ -5,7 +5,7 @@
 Algunas operaciones, como merge, revert y pull, modifican el contenido de su
 working tree. Estas modificaciones son generadas automaticamente, con lo cual
 pueden tener conflictos con el estado actual de su working tree.  Muchos tipos
-de cambios pueden ser combinados automaticamentem pero a veces solo algunos 
+de cambios pueden ser combinados automaticamentem pero a veces solo algunos
 humanos pueden determinar la decision correcta a tomar.  Cuando esto sucede,
 Bazaar lo informara que hay un conflict y pedira que lo resuelva. El comando
 para resolverlo es ``resolve``, pero debe realizar alguna accion antes de
@@ -25,7 +25,7 @@
 reconciliado entre dos cambios. Bazaar emitira archivos para cada version con
 extensiones THIS, OTHER, y BASE.  THIS es la version del archivo del tree
 de destino, por ejemplo, el tree al que estan unificando los cambios. OTHER
-es la version que estan uniendo al tree de destino. BASE es la version 
+es la version que estan uniendo al tree de destino. BASE es la version
 anterior que es usado como base para la comparacion.
 
 En la copia principal del archivo, Bazaar incluira los cambios que puede
@@ -33,7 +33,7 @@
 "herringbone" como ``<<<<<<<``.
 
 Digamos que el texto inicial es "El lider del proyecto lo lanzo.", y THIS lo
-modifica a "Martin Pool lo lanzo.", mientras que OTHER lo modifica a "El lider 
+modifica a "Martin Pool lo lanzo.", mientras que OTHER lo modifica a "El lider
 del proyecto lanzo Bazaar."  Un conflicto se veria asi::
 
   <<<<<<< TREE
@@ -45,16 +45,16 @@
 La resulucion correcta seria "Martin Pool lanzo Bazaar."
 
 Puede manejar conflictos de texto o editando la copia principal del archivo,
-o invocando herramientas externas on las versiones THIS, OTHER y BASE. Vale 
+o invocando herramientas externas on las versiones THIS, OTHER y BASE. Vale
 la pena mencionar que resolver conflictos de texto rara vez involucra elegir
-un conjunto de cambios u otros. Los mas comun es que tenga que combinar 
+un conjunto de cambios u otros. Los mas comun es que tenga que combinar
 inteligentemente.
 
 Si modifica la copia principal, asegurese de sacar los marcadores "herringbone".
-Cuando termino de modificar, el archivo debe estar como si nunca hubiese estado 
+Cuando termino de modificar, el archivo debe estar como si nunca hubiese estado
 con conflictos, y estar listo para hacer commit.
 
-Cuando resolvio los conflictos de texto, solo ejecute "bzr resolve", y Bazaar 
+Cuando resolvio los conflictos de texto, solo ejecute "bzr resolve", y Bazaar
 detectera automaticamente que resolvio.
 
 
@@ -64,19 +64,19 @@
 
   Contents conflict in ARCHIVO
 
-Este conflicto sucede cuando hay cambios que crean conflictos en el tree de 
-destino y el fuente a unificar, pero los items con conflictos no son archivos 
-de texto.  Pueden ser archivos binarios, symlinks o directorios.  Pueden suceder 
+Este conflicto sucede cuando hay cambios que crean conflictos en el tree de
+destino y el fuente a unificar, pero los items con conflictos no son archivos
+de texto.  Pueden ser archivos binarios, symlinks o directorios.  Pueden suceder
 con archivos que fueron eliminados en un lado, y modificados en el otro.
 
 Como los conflictos de texto, Bazaar creara archivos THIS, OTHER y BASE.
-(pueden ser archivos normales, symlinks o directorios).  Esto no incluira 
-la "copia principal" del archivo con marcadores "herringbone".  Parecera que la 
+(pueden ser archivos normales, symlinks o directorios).  Esto no incluira
+la "copia principal" del archivo con marcadores "herringbone".  Parecera que la
 "copia principal" fue renombrado a THIS o OTHER.
 
-Para resolver esto, utilice "bzr mv" para renombrar el archivo a su nombre 
-original, y combine los cambios manualmente. Cuando este satisfecho, ejecute 
-"bzr resolve ARCHIVO".  Bazaar no puede detectar cuando cambios de este tipo 
+Para resolver esto, utilice "bzr mv" para renombrar el archivo a su nombre
+original, y combine los cambios manualmente. Cuando este satisfecho, ejecute
+"bzr resolve ARCHIVO".  Bazaar no puede detectar cuando cambios de este tipo
 fueron resueltos.
 
 
@@ -87,9 +87,9 @@
   Conflict adding file ARCHIVO.  Moved existing file to ARCHIVO.moved.
 
 Bazaar a veces intentara crear un archivo usando la ruta que ya fue usada.
-El archivo existente ser renombrado a "ARCHIVO.moved".  Si lo desea, puede 
-renombrar cualquiera de estos archivos, o combinar su contenido. Cuando 
-este satisfecho, puede ejecutar "bzr resolve ARCHIVO" para marcar que el 
+El archivo existente ser renombrado a "ARCHIVO.moved".  Si lo desea, puede
+renombrar cualquiera de estos archivos, o combinar su contenido. Cuando
+este satisfecho, puede ejecutar "bzr resolve ARCHIVO" para marcar que el
 conflicto fue resuelto.
 
 
@@ -99,12 +99,12 @@
 
     Conflict because ARCHIVO no esta versionado, pero tiene hijos versionados.
 
-A veces Bazaar intentara crear un archivo cuyo directorio padre no esta 
-versionado. Esto sucede cuando el directorio fue eliminado en el destino, 
-pero tiene un hijo nuevo en origen, o vice versa. En esta situacion, Bazaar 
-versionara al directorio padre tambien.  Resolver este tema depende mucho 
-en el escenario particular.  Puede que quiera renombrar o eliminar o renombrar 
-cualquier archivo o directorio.  Cuando esta satisfecho, puede ejecutar "bzr 
+A veces Bazaar intentara crear un archivo cuyo directorio padre no esta
+versionado. Esto sucede cuando el directorio fue eliminado en el destino,
+pero tiene un hijo nuevo en origen, o vice versa. En esta situacion, Bazaar
+versionara al directorio padre tambien.  Resolver este tema depende mucho
+en el escenario particular.  Puede que quiera renombrar o eliminar o renombrar
+cualquier archivo o directorio.  Cuando esta satisfecho, puede ejecutar "bzr
 resolve ARCHIVO" para marcar el conflicto como resuelto.
 
 
@@ -114,12 +114,12 @@
 
   Conflict adding files to ARCHIVO.  Created directory.
 
-Esto sucede cuando un archivo fue eliminado en el destino, pero tiene hijos 
-en el origen.  Esto es similar al conflicto "Padre sin versionar", excepto 
-que el directorio padre *no existe*, en vez de no estar versionado. En esta 
-situacion, Bazaar creara al padre faltante.  Resolver estos temas depende 
-mucho de cada caso particular. Usted puede querer renombrar o eliminar 
-cualquiera de los archivos o directorios.  Cuando este satisfecho, puede 
+Esto sucede cuando un archivo fue eliminado en el destino, pero tiene hijos
+en el origen.  Esto es similar al conflicto "Padre sin versionar", excepto
+que el directorio padre *no existe*, en vez de no estar versionado. En esta
+situacion, Bazaar creara al padre faltante.  Resolver estos temas depende
+mucho de cada caso particular. Usted puede querer renombrar o eliminar
+cualquiera de los archivos o directorios.  Cuando este satisfecho, puede
 ejecutar "bzr resolve ARCHIVO" para marcar al archivo resuelto.
 
 
@@ -129,11 +129,11 @@
 
   Conflict: can't delete ARCHIVO because it is not empty.  Not deleting.
 
-Esto es el opuesto a "Padre faltante".  Un directorio es eliminado en el 
+Esto es el opuesto a "Padre faltante".  Un directorio es eliminado en el
 origen, pero tiene hijos en el destino.  Bazaar mantiene el directorio.
-Resolver este tema depende mucho de cada escenario particular.  Quizas quiera 
-renombrar o eliminar cualquiera de los archivos o directorios.  Cuando esta 
-satisfecho, puede ejecutar "bzr resolver ARCHIVO" para marcar al conflicto 
+Resolver este tema depende mucho de cada escenario particular.  Quizas quiera
+renombrar o eliminar cualquiera de los archivos o directorios.  Cuando esta
+satisfecho, puede ejecutar "bzr resolver ARCHIVO" para marcar al conflicto
 como resuelto.
 
 
@@ -143,9 +143,9 @@
 
   Path conflict: RUTA1 / RUTA2
 
-Esto sucede cuando en el origen y el destino han sido modificados el nombre 
-o directorio padre de un archivo. Bazaar usara la ruta de los elementos del 
-origen. Puede renombrar el archivo, y una vez que lo ha hecho, ejecutar 
+Esto sucede cuando en el origen y el destino han sido modificados el nombre
+o directorio padre de un archivo. Bazaar usara la ruta de los elementos del
+origen. Puede renombrar el archivo, y una vez que lo ha hecho, ejecutar
 "bzr resolve ARCHIVO" para marcarl el conflicto como resuelto.
 
 
@@ -155,8 +155,8 @@
 
   Conflict moving ARCHIVO into DIRECTORIO.  Cancelled move.
 
-Esto sucede cuando en el origen y el destino se han movido directorios, de 
-tal forma que, si se aplicaran los cambios, el directorios se contendria a 
+Esto sucede cuando en el origen y el destino se han movido directorios, de
+tal forma que, si se aplicaran los cambios, el directorios se contendria a
 si mismo.
 Por ejemplo::
 
@@ -172,14 +172,14 @@
   $ bzr merge ../other
 
 En esta situacion, Bazaar cancelara el movimiento, y dejara "a" en "b".
-Puede renombrar los directorios como desee, y una vez que lo ha hecho, 
+Puede renombrar los directorios como desee, y una vez que lo ha hecho,
 ejecute "bzr resolve ARCHIVO" para marcar el conflicto como resuelto.
 
 
 MalformedTransform
 ==================
 Es posible (aunque muy raro) que Bazaar de una excepcion MalformedTransform.
-Esto quiere decir que Bazaar encontro un conflicto en el sistema de archivos 
-que no le fue posible resolver.  Esto usualmente indica un bug.  Por favor 
-haganoslo saber si se encuentra en esta situacion. Nuestro sistema de bugs 
+Esto quiere decir que Bazaar encontro un conflicto en el sistema de archivos
+que no le fue posible resolver.  Esto usualmente indica un bug.  Por favor
+haganoslo saber si se encuentra en esta situacion. Nuestro sistema de bugs
 se encuentra en https://launchpad.net/bzr/+bugs

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2009-09-01 12:29:54 +0000
+++ bzrlib/hooks.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -45,6 +45,8 @@
     'bzrlib.info', 'InfoHooks')
 known_hooks.register_lazy(('bzrlib.lock', 'Lock.hooks'), 'bzrlib.lock',
     'LockHooks')
+known_hooks.register_lazy(('bzrlib.merge', 'Merger.hooks'), 'bzrlib.merge',
+    'MergeHooks')
 known_hooks.register_lazy(('bzrlib.msgeditor', 'hooks'), 'bzrlib.msgeditor',
     'MessageEditorHooks')
 known_hooks.register_lazy(('bzrlib.mutabletree', 'MutableTree.hooks'),
@@ -277,7 +279,7 @@
 
 See `Using hooks`_ in the User Guide for examples.
 
-.. _Using hooks: ../user-guide/index.html#using-hooks
+.. _Using hooks: ../user-guide/hooks.html
 
 The class that contains each hook is given before the hooks it supplies. For
 instance, BranchHooks as the class is the hooks class for

=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2009-10-19 15:45:10 +0000
+++ bzrlib/index.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -93,9 +93,10 @@
         :param key_elements: The number of bytestrings in each key.
         """
         self.reference_lists = reference_lists
-        self._keys = set()
         # A dict of {key: (absent, ref_lists, value)}
         self._nodes = {}
+        # Keys that are referenced but not actually present in this index
+        self._absent_keys = set()
         self._nodes_by_key = None
         self._key_length = key_elements
         self._optimize_for_size = False
@@ -165,9 +166,9 @@
             return
         key_dict = self._nodes_by_key
         if self.reference_lists:
-            key_value = key, value, node_refs
+            key_value = StaticTuple(key, value, node_refs)
         else:
-            key_value = key, value
+            key_value = StaticTuple(key, value)
         for subkey in key[:-1]:
             key_dict = key_dict.setdefault(subkey, {})
         key_dict[key[-1]] = key_value
@@ -189,6 +190,7 @@
                                 This may contain duplicates if the same key is
                                 referenced in multiple lists.
         """
+        as_st = StaticTuple.from_sequence
         self._check_key(key)
         if _newline_null_re.search(value) is not None:
             raise errors.BadIndexValue(value)
@@ -203,10 +205,10 @@
                 if reference not in self._nodes:
                     self._check_key(reference)
                     absent_references.append(reference)
-            # TODO: StaticTuple
-            node_refs.append(tuple(reference_list))
-        # TODO: StaticTuple
-        return tuple(node_refs), absent_references
+            reference_list = as_st([as_st(ref).intern()
+                                    for ref in reference_list])
+            node_refs.append(reference_list)
+        return as_st(node_refs), absent_references
 
     def add_node(self, key, value, references=()):
         """Add a node to the index.
@@ -227,8 +229,9 @@
             # There may be duplicates, but I don't think it is worth worrying
             # about
             self._nodes[reference] = ('a', (), '')
+        self._absent_keys.update(absent_references)
+        self._absent_keys.discard(key)
         self._nodes[key] = ('', node_refs, value)
-        self._keys.add(key)
         if self._nodes_by_key is not None and self._key_length > 1:
             self._update_nodes_by_key(key, value, node_refs)
 
@@ -243,7 +246,8 @@
         lines = [_SIGNATURE]
         lines.append(_OPTION_NODE_REFS + str(self.reference_lists) + '\n')
         lines.append(_OPTION_KEY_ELEMENTS + str(self._key_length) + '\n')
-        lines.append(_OPTION_LEN + str(len(self._keys)) + '\n')
+        key_count = len(self._nodes) - len(self._absent_keys)
+        lines.append(_OPTION_LEN + str(key_count) + '\n')
         prefix_length = sum(len(x) for x in lines)
         # references are byte offsets. To avoid having to do nasty
         # polynomial work to resolve offsets (references to later in the
@@ -451,6 +455,7 @@
         trailers = 0
         pos = stream.tell()
         lines = stream.read().split('\n')
+        stream.close()
         del lines[-1]
         _, _, _, trailers = self._parse_lines(lines, pos)
         for key, absent, references, value in self._keys_by_offset.itervalues():
@@ -463,7 +468,6 @@
                 node_value = value
             self._nodes[key] = node_value
         # cache the keys for quick set intersections
-        self._keys = set(self._nodes)
         if trailers != 1:
             # there must be one line - the empty trailer line.
             raise errors.BadIndexData(self)
@@ -484,10 +488,11 @@
             raise ValueError('No ref list %d, index has %d ref lists'
                 % (ref_list_num, self.node_ref_lists))
         refs = set()
-        for key, (value, ref_lists) in self._nodes.iteritems():
+        nodes = self._nodes
+        for key, (value, ref_lists) in nodes.iteritems():
             ref_list = ref_lists[ref_list_num]
-            refs.update(ref_list)
-        return refs - self._keys
+            refs.update([ref for ref in ref_list if ref not in nodes])
+        return refs
 
     def _get_nodes_by_key(self):
         if self._nodes_by_key is None:
@@ -620,14 +625,17 @@
 
     def _iter_entries_from_total_buffer(self, keys):
         """Iterate over keys when the entire index is parsed."""
-        keys = keys.intersection(self._keys)
+        # Note: See the note in BTreeBuilder.iter_entries for why we don't use
+        #       .intersection() here
+        nodes = self._nodes
+        keys = [key for key in keys if key in nodes]
         if self.node_ref_lists:
             for key in keys:
-                value, node_refs = self._nodes[key]
+                value, node_refs = nodes[key]
                 yield self, key, value, node_refs
         else:
             for key in keys:
-                yield self, key, self._nodes[key]
+                yield self, key, nodes[key]
 
     def iter_entries(self, keys):
         """Iterate over keys within the index.
@@ -1170,7 +1178,7 @@
             self._parsed_key_map.insert(index + 1, new_key)
 
     def _read_and_parse(self, readv_ranges):
-        """Read the the ranges and parse the resulting data.
+        """Read the ranges and parse the resulting data.
 
         :param readv_ranges: A prepared readv range list.
         """
@@ -1507,15 +1515,18 @@
             defined order for the result iteration - it will be in the most
             efficient order for the index (keys iteration order in this case).
         """
-        keys = set(keys)
+        # Note: See BTreeBuilder.iter_entries for an explanation of why we
+        #       aren't using set().intersection() here
+        nodes = self._nodes
+        keys = [key for key in keys if key in nodes]
         if self.reference_lists:
-            for key in keys.intersection(self._keys):
-                node = self._nodes[key]
+            for key in keys:
+                node = nodes[key]
                 if not node[0]:
                     yield self, key, node[2], node[1]
         else:
-            for key in keys.intersection(self._keys):
-                node = self._nodes[key]
+            for key in keys:
+                node = nodes[key]
                 if not node[0]:
                     yield self, key, node[2]
 
@@ -1595,7 +1606,7 @@
 
         For InMemoryGraphIndex the estimate is exact.
         """
-        return len(self._keys)
+        return len(self._nodes) - len(self._absent_keys)
 
     def validate(self):
         """In memory index's have no known corruption at the moment."""

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2009-05-01 14:29:06 +0000
+++ bzrlib/info.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -484,6 +484,7 @@
     """Hooks for the info command."""
 
     def __init__(self):
+        super(InfoHooks, self).__init__()
         self.create_hook(_mod_hooks.HookPoint('repository',
             "Invoked when displaying the statistics for a repository. "
             "repository is called with a statistics dictionary as returned "

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2009-10-20 20:29:11 +0000
+++ bzrlib/inventory.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -51,6 +51,7 @@
     )
 from bzrlib.symbol_versioning import deprecated_in, deprecated_method
 from bzrlib.trace import mutter
+from bzrlib.static_tuple import StaticTuple
 
 
 class InventoryEntry(object):
@@ -1599,8 +1600,6 @@
         interesting.add(None) # this will auto-filter it in the loop
         remaining_parents.discard(None) 
         while remaining_parents:
-            if None in remaining_parents:
-                import pdb; pdb.set_trace()
             next_parents = set()
             for entry in self._getitems(remaining_parents):
                 next_parents.add(entry.parent_id)
@@ -1615,7 +1614,7 @@
         while directories_to_expand:
             # Expand directories by looking in the
             # parent_id_basename_to_file_id map
-            keys = [(f,) for f in directories_to_expand]
+            keys = [StaticTuple(f,).intern() for f in directories_to_expand]
             directories_to_expand = set()
             items = self.parent_id_basename_to_file_id.iteritems(keys)
             next_file_ids = set([item[1] for item in items])
@@ -1678,7 +1677,7 @@
         # to filter out empty names because of non rich-root...
         sections = bytes.split('\n')
         kind, file_id = sections[0].split(': ')
-        return (sections[2], file_id, sections[3])
+        return (sections[2], intern(file_id), intern(sections[3]))
 
     def _bytes_to_entry(self, bytes):
         """Deserialise a serialised entry."""
@@ -1706,7 +1705,8 @@
             result.reference_revision = sections[4]
         else:
             raise ValueError("Not a serialised entry %r" % bytes)
-        result.revision = sections[3]
+        result.file_id = intern(result.file_id)
+        result.revision = intern(sections[3])
         if result.parent_id == '':
             result.parent_id = None
         self._fileid_to_entry_cache[result.file_id] = result
@@ -1810,7 +1810,7 @@
                         pass
                 deletes.add(file_id)
             else:
-                new_key = (file_id,)
+                new_key = StaticTuple(file_id,)
                 new_value = result._entry_to_bytes(entry)
                 # Update caches. It's worth doing this whether
                 # we're propagating the old caches or not.
@@ -1819,13 +1819,13 @@
             if old_path is None:
                 old_key = None
             else:
-                old_key = (file_id,)
+                old_key = StaticTuple(file_id,)
                 if self.id2path(file_id) != old_path:
                     raise errors.InconsistentDelta(old_path, file_id,
                         "Entry was at wrong other path %r." %
                         self.id2path(file_id))
                 altered.add(file_id)
-            id_to_entry_delta.append((old_key, new_key, new_value))
+            id_to_entry_delta.append(StaticTuple(old_key, new_key, new_value))
             if result.parent_id_basename_to_file_id is not None:
                 # parent_id, basename changes
                 if old_path is None:
@@ -1923,7 +1923,13 @@
         search_key_name = intern(info.get('search_key_name', 'plain'))
         parent_id_basename_to_file_id = intern(info.get(
             'parent_id_basename_to_file_id', None))
+        if not parent_id_basename_to_file_id.startswith('sha1:'):
+            raise ValueError('parent_id_basename_to_file_id should be a sha1'
+                             ' key not %r' % (parent_id_basename_to_file_id,))
         id_to_entry = info['id_to_entry']
+        if not id_to_entry.startswith('sha1:'):
+            raise ValueError('id_to_entry should be a sha1'
+                             ' key not %r' % (id_to_entry,))
 
         result = CHKInventory(search_key_name)
         result.revision_id = revision_id
@@ -1932,12 +1938,13 @@
                             result._search_key_name)
         if parent_id_basename_to_file_id is not None:
             result.parent_id_basename_to_file_id = chk_map.CHKMap(
-                chk_store, (parent_id_basename_to_file_id,),
+                chk_store, StaticTuple(parent_id_basename_to_file_id,),
                 search_key_func=search_key_func)
         else:
             result.parent_id_basename_to_file_id = None
 
-        result.id_to_entry = chk_map.CHKMap(chk_store, (id_to_entry,),
+        result.id_to_entry = chk_map.CHKMap(chk_store,
+                                            StaticTuple(id_to_entry,),
                                             search_key_func=search_key_func)
         if (result.revision_id,) != expected_revision_id:
             raise ValueError("Mismatched revision id and expected: %r, %r" %
@@ -1965,7 +1972,8 @@
         id_to_entry_dict = {}
         parent_id_basename_dict = {}
         for path, entry in inventory.iter_entries():
-            id_to_entry_dict[(entry.file_id,)] = entry_to_bytes(entry)
+            key = StaticTuple(entry.file_id,).intern()
+            id_to_entry_dict[key] = entry_to_bytes(entry)
             p_id_key = parent_id_basename_key(entry)
             parent_id_basename_dict[p_id_key] = entry.file_id
 
@@ -1994,7 +2002,7 @@
             parent_id = entry.parent_id
         else:
             parent_id = ''
-        return parent_id, entry.name.encode('utf8')
+        return StaticTuple(parent_id, entry.name.encode('utf8')).intern()
 
     def __getitem__(self, file_id):
         """map a single file_id -> InventoryEntry."""
@@ -2005,7 +2013,7 @@
             return result
         try:
             return self._bytes_to_entry(
-                self.id_to_entry.iteritems([(file_id,)]).next()[1])
+                self.id_to_entry.iteritems([StaticTuple(file_id,)]).next()[1])
         except StopIteration:
             # really we're passing an inventory, not a tree...
             raise errors.NoSuchId(self, file_id)
@@ -2024,7 +2032,7 @@
                 remaining.append(file_id)
             else:
                 result.append(entry)
-        file_keys = [(f,) for f in remaining]
+        file_keys = [StaticTuple(f,).intern() for f in remaining]
         for file_key, value in self.id_to_entry.iteritems(file_keys):
             entry = self._bytes_to_entry(value)
             result.append(entry)
@@ -2035,7 +2043,8 @@
         # Perhaps have an explicit 'contains' method on CHKMap ?
         if self._fileid_to_entry_cache.get(file_id, None) is not None:
             return True
-        return len(list(self.id_to_entry.iteritems([(file_id,)]))) == 1
+        return len(list(
+            self.id_to_entry.iteritems([StaticTuple(file_id,)]))) == 1
 
     def is_root(self, file_id):
         return file_id == self.root_id
@@ -2193,7 +2202,7 @@
             basename_utf8 = basename.encode('utf8')
             file_id = self._path_to_fileid_cache.get(cur_path, None)
             if file_id is None:
-                key_filter = [(current_id, basename_utf8)]
+                key_filter = [StaticTuple(current_id, basename_utf8)]
                 items = parent_id_index.iteritems(key_filter)
                 for (parent_id, name_utf8), file_id in items:
                     if parent_id != current_id or name_utf8 != basename_utf8:
@@ -2215,16 +2224,16 @@
             lines.append('search_key_name: %s\n' % (self._search_key_name,))
             lines.append("root_id: %s\n" % self.root_id)
             lines.append('parent_id_basename_to_file_id: %s\n' %
-                self.parent_id_basename_to_file_id.key())
+                (self.parent_id_basename_to_file_id.key()[0],))
             lines.append("revision_id: %s\n" % self.revision_id)
-            lines.append("id_to_entry: %s\n" % self.id_to_entry.key())
+            lines.append("id_to_entry: %s\n" % (self.id_to_entry.key()[0],))
         else:
             lines.append("revision_id: %s\n" % self.revision_id)
             lines.append("root_id: %s\n" % self.root_id)
             if self.parent_id_basename_to_file_id is not None:
                 lines.append('parent_id_basename_to_file_id: %s\n' %
-                    self.parent_id_basename_to_file_id.key())
-            lines.append("id_to_entry: %s\n" % self.id_to_entry.key())
+                    (self.parent_id_basename_to_file_id.key()[0],))
+            lines.append("id_to_entry: %s\n" % (self.id_to_entry.key()[0],))
         return lines
 
     @property
@@ -2271,8 +2280,8 @@
         parent_id_index = self._chk_inventory.parent_id_basename_to_file_id
         child_keys = set()
         for (parent_id, name_utf8), file_id in parent_id_index.iteritems(
-            key_filter=[(self.file_id,)]):
-            child_keys.add((file_id,))
+            key_filter=[StaticTuple(self.file_id,)]):
+            child_keys.add(StaticTuple(file_id,))
         cached = set()
         for file_id_key in child_keys:
             entry = self._chk_inventory._fileid_to_entry_cache.get(

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2009-09-15 02:57:23 +0000
+++ bzrlib/knit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -69,6 +69,7 @@
     lru_cache,
     pack,
     progress,
+    static_tuple,
     trace,
     tsort,
     tuned_gzip,
@@ -1710,10 +1711,12 @@
             # There were index entries buffered at the end of the stream,
             # So these need to be added (if the index supports holding such
             # entries for later insertion)
+            all_entries = []
             for key in buffered_index_entries:
                 index_entries = buffered_index_entries[key]
-                self._index.add_records(index_entries,
-                    missing_compression_parents=True)
+                all_entries.extend(index_entries)
+            self._index.add_records(
+                all_entries, missing_compression_parents=True)
 
     def get_missing_compression_parent_keys(self):
         """Return an iterable of keys of missing compression parents.
@@ -2365,7 +2368,7 @@
     FLAGS is a comma separated list of flags about the record. Values include
         no-eol, line-delta, fulltext.
     BYTE_OFFSET is the ascii representation of the byte offset in the data file
-        that the the compressed data starts at.
+        that the compressed data starts at.
     LENGTH is the ascii representation of the length of the data file.
     PARENT_ID a utf-8 revision id prefixed by a '.' that is a parent of
         REVISION_ID.
@@ -2942,10 +2945,15 @@
         if not random_id:
             present_nodes = self._get_entries(keys)
             for (index, key, value, node_refs) in present_nodes:
+                parents = node_refs[:1]
+                # Sometimes these are passed as a list rather than a tuple
+                passed = static_tuple.as_tuples(keys[key])
+                passed_parents = passed[1][:1]
                 if (value[0] != keys[key][0][0] or
-                    node_refs[:1] != keys[key][1][:1]):
+                    parents != passed_parents):
+                    node_refs = static_tuple.as_tuples(node_refs)
                     raise KnitCorrupt(self, "inconsistent details in add_records"
-                        ": %s %s" % ((value, node_refs), keys[key]))
+                        ": %s %s" % ((value, node_refs), passed))
                 del keys[key]
         result = []
         if self._parents:

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2009-09-30 07:02:41 +0000
+++ bzrlib/lockdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -110,6 +110,7 @@
     debug,
     errors,
     lock,
+    osutils,
     )
 import bzrlib.config
 from bzrlib.decorators import only_raises
@@ -241,8 +242,16 @@
         # incorrect.  It's possible some other servers or filesystems will
         # have a similar bug allowing someone to think they got the lock
         # when it's already held.
+        #
+        # See <https://bugs.edge.launchpad.net/bzr/+bug/498378> for one case.
+        #
+        # Strictly the check is unnecessary and a waste of time for most
+        # people, but probably worth trapping if something is wrong.
         info = self.peek()
         self._trace("after locking, info=%r", info)
+        if info is None:
+            raise LockFailed(self, "lock was renamed into place, but "
+                "now is missing!")
         if info['nonce'] != self.nonce:
             self._trace("rename succeeded, "
                 "but lock is still held by someone else")
@@ -416,7 +425,7 @@
 
         peek() reads the info file of the lock holder, if any.
         """
-        return self._parse_info(self.transport.get(path))
+        return self._parse_info(self.transport.get_bytes(path))
 
     def peek(self):
         """Check if the lock is held by anyone.
@@ -449,8 +458,9 @@
                    )
         return s.to_string()
 
-    def _parse_info(self, info_file):
-        return rio.read_stanza(info_file.readlines()).as_dict()
+    def _parse_info(self, info_bytes):
+        # TODO: Handle if info_bytes is empty
+        return rio.read_stanza(osutils.split_lines(info_bytes)).as_dict()
 
     def attempt_lock(self):
         """Take the lock; fail if it's already held.
@@ -524,19 +534,22 @@
                     deadline_str = time.strftime('%H:%M:%S',
                                                  time.localtime(deadline))
                 lock_url = self.transport.abspath(self.path)
+                # See <https://bugs.edge.launchpad.net/bzr/+bug/250451>
+                # the URL here is sometimes not one that is useful to the
+                # user, perhaps being wrapped in a lp-%d or chroot decorator,
+                # especially if this error is issued from the server.
                 self._report_function('%s %s\n'
-                                      '%s\n' # held by
-                                      '%s\n' # locked ... ago
-                                      'Will continue to try until %s, unless '
-                                      'you press Ctrl-C\n'
-                                      'If you\'re sure that it\'s not being '
-                                      'modified, use bzr break-lock %s',
-                                      start,
-                                      formatted_info[0],
-                                      formatted_info[1],
-                                      formatted_info[2],
-                                      deadline_str,
-                                      lock_url)
+                    '%s\n' # held by
+                    '%s\n' # locked ... ago
+                    'Will continue to try until %s, unless '
+                    'you press Ctrl-C.\n'
+                    'See "bzr help break-lock" for more.',
+                    start,
+                    formatted_info[0],
+                    formatted_info[1],
+                    formatted_info[2],
+                    deadline_str,
+                    )
 
             if (max_attempts is not None) and (attempt_count >= max_attempts):
                 self._trace("exceeded %d attempts")

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2009-06-10 03:56:49 +0000
+++ bzrlib/log.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -83,6 +83,7 @@
     )
 from bzrlib.osutils import (
     format_date,
+    format_date_with_offset_in_original_timezone,
     get_terminal_encoding,
     re_compile_checked,
     terminal_width,
@@ -384,27 +385,28 @@
         :return: An iterator yielding LogRevision objects.
         """
         rqst = self.rqst
+        levels = rqst.get('levels')
+        limit = rqst.get('limit')
+        diff_type = rqst.get('diff_type')
         log_count = 0
         revision_iterator = self._create_log_revision_iterator()
         for revs in revision_iterator:
             for (rev_id, revno, merge_depth), rev, delta in revs:
                 # 0 levels means show everything; merge_depth counts from 0
-                levels = rqst.get('levels')
                 if levels != 0 and merge_depth >= levels:
                     continue
-                diff = self._format_diff(rev, rev_id)
+                if diff_type is None:
+                    diff = None
+                else:
+                    diff = self._format_diff(rev, rev_id, diff_type)
                 yield LogRevision(rev, revno, merge_depth, delta,
                     self.rev_tag_dict.get(rev_id), diff)
-                limit = rqst.get('limit')
                 if limit:
                     log_count += 1
                     if log_count >= limit:
                         return
 
-    def _format_diff(self, rev, rev_id):
-        diff_type = self.rqst.get('diff_type')
-        if diff_type is None:
-            return None
+    def _format_diff(self, rev, rev_id, diff_type):
         repo = self.branch.repository
         if len(rev.parent_ids) == 0:
             ancestor_id = _mod_revision.NULL_REVISION
@@ -1291,10 +1293,13 @@
     preferred_levels = 0
 
     def __init__(self, to_file, show_ids=False, show_timezone='original',
-                 delta_format=None, levels=None, show_advice=False):
+            delta_format=None, levels=None, show_advice=False,
+            to_exact_file=None):
         """Create a LogFormatter.
 
         :param to_file: the file to output to
+        :param to_exact_file: if set, gives an output stream to which 
+             non-Unicode diffs are written.
         :param show_ids: if True, revision-ids are to be displayed
         :param show_timezone: the timezone to use
         :param delta_format: the level of delta information to display
@@ -1307,7 +1312,13 @@
         self.to_file = to_file
         # 'exact' stream used to show diff, it should print content 'as is'
         # and should not try to decode/encode it to unicode to avoid bug #328007
-        self.to_exact_file = getattr(to_file, 'stream', to_file)
+        if to_exact_file is not None:
+            self.to_exact_file = to_exact_file
+        else:
+            # XXX: somewhat hacky; this assumes it's a codec writer; it's better
+            # for code that expects to get diffs to pass in the exact file
+            # stream
+            self.to_exact_file = getattr(to_file, 'stream', to_file)
         self.show_ids = show_ids
         self.show_timezone = show_timezone
         if delta_format is None:
@@ -1367,48 +1378,64 @@
         else:
             return ''
 
-    def show_foreign_info(self, rev, indent):
+    def show_properties(self, revision, indent):
+        """Displays the custom properties returned by each registered handler.
+
+        If a registered handler raises an error it is propagated.
+        """
+        for line in self.custom_properties(revision):
+            self.to_file.write("%s%s\n" % (indent, line))
+
+    def custom_properties(self, revision):
+        """Format the custom properties returned by each registered handler.
+
+        If a registered handler raises an error it is propagated.
+
+        :return: a list of formatted lines (excluding trailing newlines)
+        """
+        lines = self._foreign_info_properties(revision)
+        for key, handler in properties_handler_registry.iteritems():
+            lines.extend(self._format_properties(handler(revision)))
+        return lines
+
+    def _foreign_info_properties(self, rev):
         """Custom log displayer for foreign revision identifiers.
 
         :param rev: Revision object.
         """
         # Revision comes directly from a foreign repository
         if isinstance(rev, foreign.ForeignRevision):
-            self._write_properties(indent, rev.mapping.vcs.show_foreign_revid(
-                rev.foreign_revid))
-            return
+            return self._format_properties(rev.mapping.vcs.show_foreign_revid(rev.foreign_revid))
 
         # Imported foreign revision revision ids always contain :
         if not ":" in rev.revision_id:
-            return
+            return []
 
         # Revision was once imported from a foreign repository
         try:
             foreign_revid, mapping = \
                 foreign.foreign_vcs_registry.parse_revision_id(rev.revision_id)
         except errors.InvalidRevisionId:
-            return
+            return []
 
-        self._write_properties(indent, 
+        return self._format_properties(
             mapping.vcs.show_foreign_revid(foreign_revid))
 
-    def show_properties(self, revision, indent):
-        """Displays the custom properties returned by each registered handler.
-
-        If a registered handler raises an error it is propagated.
-        """
-        for key, handler in properties_handler_registry.iteritems():
-            self._write_properties(indent, handler(revision))
-
-    def _write_properties(self, indent, properties):
+    def _format_properties(self, properties):
+        lines = []
         for key, value in properties.items():
-            self.to_file.write(indent + key + ': ' + value + '\n')
+            lines.append(key + ': ' + value)
+        return lines
 
     def show_diff(self, to_file, diff, indent):
         for l in diff.rstrip().split('\n'):
             to_file.write(indent + '%s\n' % (l,))
 
 
+# Separator between revisions in long format
+_LONG_SEP = '-' * 60
+
+
 class LongLogFormatter(LogFormatter):
 
     supports_merge_revisions = True
@@ -1417,55 +1444,70 @@
     supports_tags = True
     supports_diff = True
 
+    def __init__(self, *args, **kwargs):
+        super(LongLogFormatter, self).__init__(*args, **kwargs)
+        if self.show_timezone == 'original':
+            self.date_string = self._date_string_original_timezone
+        else:
+            self.date_string = self._date_string_with_timezone
+
+    def _date_string_with_timezone(self, rev):
+        return format_date(rev.timestamp, rev.timezone or 0,
+                           self.show_timezone)
+
+    def _date_string_original_timezone(self, rev):
+        return format_date_with_offset_in_original_timezone(rev.timestamp,
+            rev.timezone or 0)
+
     def log_revision(self, revision):
         """Log a revision, either merged or not."""
         indent = '    ' * revision.merge_depth
-        to_file = self.to_file
-        to_file.write(indent + '-' * 60 + '\n')
+        lines = [_LONG_SEP]
         if revision.revno is not None:
-            to_file.write(indent + 'revno: %s%s\n' % (revision.revno,
+            lines.append('revno: %s%s' % (revision.revno,
                 self.merge_marker(revision)))
         if revision.tags:
-            to_file.write(indent + 'tags: %s\n' % (', '.join(revision.tags)))
+            lines.append('tags: %s' % (', '.join(revision.tags)))
         if self.show_ids:
-            to_file.write(indent + 'revision-id: ' + revision.rev.revision_id)
-            to_file.write('\n')
+            lines.append('revision-id: %s' % (revision.rev.revision_id,))
             for parent_id in revision.rev.parent_ids:
-                to_file.write(indent + 'parent: %s\n' % (parent_id,))
-        self.show_foreign_info(revision.rev, indent)
-        self.show_properties(revision.rev, indent)
+                lines.append('parent: %s' % (parent_id,))
+        lines.extend(self.custom_properties(revision.rev))
 
         committer = revision.rev.committer
         authors = revision.rev.get_apparent_authors()
         if authors != [committer]:
-            to_file.write(indent + 'author: %s\n' % (", ".join(authors),))
-        to_file.write(indent + 'committer: %s\n' % (committer,))
+            lines.append('author: %s' % (", ".join(authors),))
+        lines.append('committer: %s' % (committer,))
 
         branch_nick = revision.rev.properties.get('branch-nick', None)
         if branch_nick is not None:
-            to_file.write(indent + 'branch nick: %s\n' % (branch_nick,))
-
-        date_str = format_date(revision.rev.timestamp,
-                               revision.rev.timezone or 0,
-                               self.show_timezone)
-        to_file.write(indent + 'timestamp: %s\n' % (date_str,))
-
-        to_file.write(indent + 'message:\n')
+            lines.append('branch nick: %s' % (branch_nick,))
+
+        lines.append('timestamp: %s' % (self.date_string(revision.rev),))
+
+        lines.append('message:')
         if not revision.rev.message:
-            to_file.write(indent + '  (no message)\n')
+            lines.append('  (no message)')
         else:
             message = revision.rev.message.rstrip('\r\n')
             for l in message.split('\n'):
-                to_file.write(indent + '  %s\n' % (l,))
+                lines.append('  %s' % (l,))
+
+        # Dump the output, appending the delta and diff if requested
+        to_file = self.to_file
+        to_file.write("%s%s\n" % (indent, ('\n' + indent).join(lines)))
         if revision.delta is not None:
             # We don't respect delta_format for compatibility
             revision.delta.show(to_file, self.show_ids, indent=indent,
                                 short_status=False)
         if revision.diff is not None:
             to_file.write(indent + 'diff:\n')
+            to_file.flush()
             # Note: we explicitly don't indent the diff (relative to the
             # revision information) so that the output can be fed to patch -p0
             self.show_diff(self.to_exact_file, revision.diff, indent)
+            self.to_exact_file.flush()
 
     def get_advice_separator(self):
         """Get the text separating the log from the closing advice."""
@@ -1515,7 +1557,6 @@
                             self.show_timezone, date_fmt="%Y-%m-%d",
                             show_offset=False),
                 tags, self.merge_marker(revision)))
-        self.show_foreign_info(revision.rev, indent+offset)
         self.show_properties(revision.rev, indent+offset)
         if self.show_ids:
             to_file.write(indent + offset + 'revision-id:%s\n'
@@ -1543,12 +1584,16 @@
 
     def __init__(self, *args, **kwargs):
         super(LineLogFormatter, self).__init__(*args, **kwargs)
-        self._max_chars = terminal_width() - 1
+        width = terminal_width()
+        if width is not None:
+            # we need one extra space for terminals that wrap on last char
+            width = width - 1
+        self._max_chars = width
 
     def truncate(self, str, max_len):
-        if len(str) <= max_len:
+        if max_len is None or len(str) <= max_len:
             return str
-        return str[:max_len-3]+'...'
+        return str[:max_len-3] + '...'
 
     def date_string(self, rev):
         return format_date(rev.timestamp, rev.timezone or 0,
@@ -1846,9 +1891,11 @@
     :return: (branch, info_list, start_rev_info, end_rev_info) where
       info_list is a list of (relative_path, file_id, kind) tuples where
       kind is one of values 'directory', 'file', 'symlink', 'tree-reference'.
+      branch will be read-locked.
     """
     from builtins import _get_revision_range, safe_relpath_files
     tree, b, path = bzrdir.BzrDir.open_containing_tree_or_branch(file_list[0])
+    b.lock_read()
     # XXX: It's damn messy converting a list of paths to relative paths when
     # those paths might be deleted ones, they might be on a case-insensitive
     # filesystem and/or they might be in silly locations (like another branch).
@@ -1933,6 +1980,21 @@
 
 properties_handler_registry = registry.Registry()
 
+# Use the properties handlers to print out bug information if available
+def _bugs_properties_handler(revision):
+    if revision.properties.has_key('bugs'):
+        bug_lines = revision.properties['bugs'].split('\n')
+        bug_rows = [line.split(' ', 1) for line in bug_lines]
+        fixed_bug_urls = [row[0] for row in bug_rows if
+                          len(row) > 1 and row[1] == 'fixed']
+        
+        if fixed_bug_urls:
+            return {'fixes bug(s)': ' '.join(fixed_bug_urls)}
+    return {}
+
+properties_handler_registry.register('bugs_properties_handler',
+                                     _bugs_properties_handler)
+
 
 # adapters which revision ids to log are filtered. When log is called, the
 # log_rev_iterator is adapted through each of these factory methods.

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2009-10-06 14:40:37 +0000
+++ bzrlib/merge.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,13 +19,14 @@
     branch as _mod_branch,
     conflicts as _mod_conflicts,
     debug,
+    decorators,
     errors,
     graph as _mod_graph,
+    hooks,
     merge3,
     osutils,
     patiencediff,
     progress,
-    registry,
     revision as _mod_revision,
     textfile,
     trace,
@@ -35,6 +36,7 @@
     ui,
     versionedfile
     )
+from bzrlib.cleanup import OperationWithCleanups
 from bzrlib.symbol_versioning import (
     deprecated_in,
     deprecated_method,
@@ -44,14 +46,177 @@
 
 def transform_tree(from_tree, to_tree, interesting_ids=None):
     from_tree.lock_tree_write()
-    try:
-        merge_inner(from_tree.branch, to_tree, from_tree, ignore_zero=True,
-                    interesting_ids=interesting_ids, this_tree=from_tree)
-    finally:
-        from_tree.unlock()
+    operation = OperationWithCleanups(merge_inner)
+    operation.add_cleanup(from_tree.unlock)
+    operation.run_simple(from_tree.branch, to_tree, from_tree,
+        ignore_zero=True, interesting_ids=interesting_ids, this_tree=from_tree)
+
+
+class MergeHooks(hooks.Hooks):
+
+    def __init__(self):
+        hooks.Hooks.__init__(self)
+        self.create_hook(hooks.HookPoint('merge_file_content',
+            "Called with a bzrlib.merge.Merger object to create a per file "
+            "merge object when starting a merge. "
+            "Should return either None or a subclass of "
+            "``bzrlib.merge.AbstractPerFileMerger``. "
+            "Such objects will then be called per file "
+            "that needs to be merged (including when one "
+            "side has deleted the file and the other has changed it). "
+            "See the AbstractPerFileMerger API docs for details on how it is "
+            "used by merge.",
+            (2, 1), None))
+
+
+class AbstractPerFileMerger(object):
+    """PerFileMerger objects are used by plugins extending merge for bzrlib.
+
+    See ``bzrlib.plugins.news_merge.news_merge`` for an example concrete class.
+    
+    :ivar merger: The Merge3Merger performing the merge.
+    """
+
+    def __init__(self, merger):
+        """Create a PerFileMerger for use with merger."""
+        self.merger = merger
+
+    def merge_contents(self, merge_params):
+        """Attempt to merge the contents of a single file.
+        
+        :param merge_params: A bzrlib.merge.MergeHookParams
+        :return : A tuple of (status, chunks), where status is one of
+            'not_applicable', 'success', 'conflicted', or 'delete'.  If status
+            is 'success' or 'conflicted', then chunks should be an iterable of
+            strings for the new file contents.
+        """
+        return ('not applicable', None)
+
+
+class ConfigurableFileMerger(AbstractPerFileMerger):
+    """Merge individual files when configured via a .conf file.
+
+    This is a base class for concrete custom file merging logic. Concrete
+    classes should implement ``merge_text``.
+
+    See ``bzrlib.plugins.news_merge.news_merge`` for an example concrete class.
+    
+    :ivar affected_files: The configured file paths to merge.
+
+    :cvar name_prefix: The prefix to use when looking up configuration
+        details. <name_prefix>_merge_files describes the files targeted by the
+        hook for example.
+        
+    :cvar default_files: The default file paths to merge when no configuration
+        is present.
+    """
+
+    name_prefix = None
+    default_files = None
+
+    def __init__(self, merger):
+        super(ConfigurableFileMerger, self).__init__(merger)
+        self.affected_files = None
+        self.default_files = self.__class__.default_files or []
+        self.name_prefix = self.__class__.name_prefix
+        if self.name_prefix is None:
+            raise ValueError("name_prefix must be set.")
+
+    def filename_matches_config(self, params):
+        """Check whether the file should call the merge hook.
+
+        <name_prefix>_merge_files configuration variable is a list of files
+        that should use the hook.
+        """
+        affected_files = self.affected_files
+        if affected_files is None:
+            config = self.merger.this_tree.branch.get_config()
+            # Until bzr provides a better policy for caching the config, we
+            # just add the part we're interested in to the params to avoid
+            # reading the config files repeatedly (bazaar.conf, location.conf,
+            # branch.conf).
+            config_key = self.name_prefix + '_merge_files'
+            affected_files = config.get_user_option_as_list(config_key)
+            if affected_files is None:
+                # If nothing was specified in the config, use the default.
+                affected_files = self.default_files
+            self.affected_files = affected_files
+        if affected_files:
+            filename = self.merger.this_tree.id2path(params.file_id)
+            if filename in affected_files:
+                return True
+        return False
+
+    def merge_contents(self, params):
+        """Merge the contents of a single file."""
+        # First, check whether this custom merge logic should be used.  We
+        # expect most files should not be merged by this handler.
+        if (
+            # OTHER is a straight winner, rely on default merge.
+            params.winner == 'other' or
+            # THIS and OTHER aren't both files.
+            not params.is_file_merge() or
+            # The filename isn't listed in the 'NAME_merge_files' config
+            # option.
+            not self.filename_matches_config(params)):
+            return 'not_applicable', None
+        return self.merge_text(params)
+
+    def merge_text(self, params):
+        """Merge the byte contents of a single file.
+
+        This is called after checking that the merge should be performed in
+        merge_contents, and it should behave as per
+        ``bzrlib.merge.AbstractPerFileMerger.merge_contents``.
+        """
+        raise NotImplementedError(self.merge_text)
+
+
+class MergeHookParams(object):
+    """Object holding parameters passed to merge_file_content hooks.
+
+    There are some fields hooks can access:
+
+    :ivar file_id: the file ID of the file being merged
+    :ivar trans_id: the transform ID for the merge of this file
+    :ivar this_kind: kind of file_id in 'this' tree
+    :ivar other_kind: kind of file_id in 'other' tree
+    :ivar winner: one of 'this', 'other', 'conflict'
+    """
+
+    def __init__(self, merger, file_id, trans_id, this_kind, other_kind,
+            winner):
+        self._merger = merger
+        self.file_id = file_id
+        self.trans_id = trans_id
+        self.this_kind = this_kind
+        self.other_kind = other_kind
+        self.winner = winner
+
+    def is_file_merge(self):
+        """True if this_kind and other_kind are both 'file'."""
+        return self.this_kind == 'file' and self.other_kind == 'file'
+
+    @decorators.cachedproperty
+    def base_lines(self):
+        """The lines of the 'base' version of the file."""
+        return self._merger.get_lines(self._merger.base_tree, self.file_id)
+
+    @decorators.cachedproperty
+    def this_lines(self):
+        """The lines of the 'this' version of the file."""
+        return self._merger.get_lines(self._merger.this_tree, self.file_id)
+
+    @decorators.cachedproperty
+    def other_lines(self):
+        """The lines of the 'other' version of the file."""
+        return self._merger.get_lines(self._merger.other_tree, self.file_id)
 
 
 class Merger(object):
+
+    hooks = MergeHooks()
+
     def __init__(self, this_branch, other_tree=None, base_tree=None,
                  this_tree=None, pb=None, change_reporter=None,
                  recurse='down', revision_graph=None):
@@ -240,7 +405,7 @@
         if self.other_rev_id is None:
             other_basis_tree = self.revision_tree(self.other_basis)
             if other_basis_tree.has_changes(self.other_tree):
-                raise WorkingTreeNotRevision(self.this_tree)
+                raise errors.WorkingTreeNotRevision(self.this_tree)
             other_rev_id = self.other_basis
             self.other_tree = other_basis_tree
 
@@ -290,6 +455,7 @@
     def _add_parent(self):
         new_parents = self.this_tree.get_parent_ids() + [self.other_rev_id]
         new_parent_trees = []
+        operation = OperationWithCleanups(self.this_tree.set_parent_trees)
         for revision_id in new_parents:
             try:
                 tree = self.revision_tree(revision_id)
@@ -297,14 +463,9 @@
                 tree = None
             else:
                 tree.lock_read()
+                operation.add_cleanup(tree.unlock)
             new_parent_trees.append((revision_id, tree))
-        try:
-            self.this_tree.set_parent_trees(new_parent_trees,
-                                            allow_leftmost_as_ghost=True)
-        finally:
-            for _revision_id, tree in new_parent_trees:
-                if tree is not None:
-                    tree.unlock()
+        operation.run_simple(new_parent_trees, allow_leftmost_as_ghost=True)
 
     def set_other(self, other_revision, possible_transports=None):
         """Set the revision and tree to merge from.
@@ -433,7 +594,7 @@
                   'other_tree': self.other_tree,
                   'interesting_ids': self.interesting_ids,
                   'interesting_files': self.interesting_files,
-                  'pp': self.pp,
+                  'pp': self.pp, 'this_branch': self.this_branch,
                   'do_merge': False}
         if self.merge_type.requires_base:
             kwargs['base_tree'] = self.base_tree
@@ -461,7 +622,8 @@
                                change_reporter=self.change_reporter,
                                **kwargs)
 
-    def _do_merge_to(self, merge):
+    def _do_merge_to(self):
+        merge = self.make_merger()
         if self.other_branch is not None:
             self.other_branch.update_references(self.this_branch)
         merge.do_merge()
@@ -481,26 +643,19 @@
                     sub_tree.branch.repository.revision_tree(base_revision)
                 sub_merge.base_rev_id = base_revision
                 sub_merge.do_merge()
+        return merge
 
     def do_merge(self):
+        operation = OperationWithCleanups(self._do_merge_to)
         self.this_tree.lock_tree_write()
-        try:
-            if self.base_tree is not None:
-                self.base_tree.lock_read()
-            try:
-                if self.other_tree is not None:
-                    self.other_tree.lock_read()
-                try:
-                    merge = self.make_merger()
-                    self._do_merge_to(merge)
-                finally:
-                    if self.other_tree is not None:
-                        self.other_tree.unlock()
-            finally:
-                if self.base_tree is not None:
-                    self.base_tree.unlock()
-        finally:
-            self.this_tree.unlock()
+        operation.add_cleanup(self.this_tree.unlock)
+        if self.base_tree is not None:
+            self.base_tree.lock_read()
+            operation.add_cleanup(self.base_tree.unlock)
+        if self.other_tree is not None:
+            self.other_tree.lock_read()
+            operation.add_cleanup(self.other_tree.unlock)
+        merge = operation.run_simple()
         if len(merge.cooked_conflicts) == 0:
             if not self.ignore_zero and not trace.is_quiet():
                 trace.note("All changes applied successfully.")
@@ -543,13 +698,14 @@
                  interesting_ids=None, reprocess=False, show_base=False,
                  pb=progress.DummyProgress(), pp=None, change_reporter=None,
                  interesting_files=None, do_merge=True,
-                 cherrypick=False, lca_trees=None):
+                 cherrypick=False, lca_trees=None, this_branch=None):
         """Initialize the merger object and perform the merge.
 
         :param working_tree: The working tree to apply the merge to
         :param this_tree: The local tree in the merge operation
         :param base_tree: The common tree in the merge operation
         :param other_tree: The other tree to merge changes from
+        :param this_branch: The branch associated with this_tree
         :param interesting_ids: The file_ids of files that should be
             participate in the merge.  May not be combined with
             interesting_files.
@@ -578,6 +734,7 @@
         self.this_tree = working_tree
         self.base_tree = base_tree
         self.other_tree = other_tree
+        self.this_branch = this_branch
         self._raw_conflicts = []
         self.cooked_conflicts = []
         self.reprocess = reprocess
@@ -598,41 +755,43 @@
             self.do_merge()
 
     def do_merge(self):
+        operation = OperationWithCleanups(self._do_merge)
+        operation.add_cleanup(self.pb.clear)
         self.this_tree.lock_tree_write()
+        operation.add_cleanup(self.this_tree.unlock)
         self.base_tree.lock_read()
+        operation.add_cleanup(self.base_tree.unlock)
         self.other_tree.lock_read()
+        operation.add_cleanup(self.other_tree.unlock)
+        operation.run()
+
+    def _do_merge(self, operation):
+        self.tt = transform.TreeTransform(self.this_tree, self.pb)
+        operation.add_cleanup(self.tt.finalize)
+        self.pp.next_phase()
+        self._compute_transform()
+        self.pp.next_phase()
+        results = self.tt.apply(no_conflicts=True)
+        self.write_modified(results)
         try:
-            self.tt = transform.TreeTransform(self.this_tree, self.pb)
-            try:
-                self.pp.next_phase()
-                self._compute_transform()
-                self.pp.next_phase()
-                results = self.tt.apply(no_conflicts=True)
-                self.write_modified(results)
-                try:
-                    self.this_tree.add_conflicts(self.cooked_conflicts)
-                except errors.UnsupportedOperation:
-                    pass
-            finally:
-                self.tt.finalize()
-        finally:
-            self.other_tree.unlock()
-            self.base_tree.unlock()
-            self.this_tree.unlock()
-            self.pb.clear()
+            self.this_tree.add_conflicts(self.cooked_conflicts)
+        except errors.UnsupportedOperation:
+            pass
 
     def make_preview_transform(self):
+        operation = OperationWithCleanups(self._make_preview_transform)
+        operation.add_cleanup(self.pb.clear)
         self.base_tree.lock_read()
+        operation.add_cleanup(self.base_tree.unlock)
         self.other_tree.lock_read()
+        operation.add_cleanup(self.other_tree.unlock)
+        return operation.run_simple()
+
+    def _make_preview_transform(self):
         self.tt = transform.TransformPreview(self.this_tree)
-        try:
-            self.pp.next_phase()
-            self._compute_transform()
-            self.pp.next_phase()
-        finally:
-            self.other_tree.unlock()
-            self.base_tree.unlock()
-            self.pb.clear()
+        self.pp.next_phase()
+        self._compute_transform()
+        self.pp.next_phase()
         return self.tt
 
     def _compute_transform(self):
@@ -644,12 +803,15 @@
             resolver = self._lca_multi_way
         child_pb = ui.ui_factory.nested_progress_bar()
         try:
+            factories = Merger.hooks['merge_file_content']
+            hooks = [factory(self) for factory in factories] + [self]
+            self.active_hooks = [hook for hook in hooks if hook is not None]
             for num, (file_id, changed, parents3, names3,
                       executable3) in enumerate(entries):
                 child_pb.update('Preparing file merge', num, len(entries))
                 self._merge_names(file_id, parents3, names3, resolver=resolver)
                 if changed:
-                    file_status = self.merge_contents(file_id)
+                    file_status = self._do_merge_contents(file_id)
                 else:
                     file_status = 'unmodified'
                 self._merge_executable(file_id,
@@ -893,7 +1055,7 @@
             self.tt.final_kind(other_root)
         except errors.NoSuchFile:
             return
-        if self.other_tree.inventory.root.file_id in self.this_tree.inventory:
+        if self.this_tree.has_id(self.other_tree.inventory.root.file_id):
             # the other tree's root is a non-root in the current tree
             return
         self.reparent_children(self.other_tree.inventory.root, self.tt.root)
@@ -941,7 +1103,7 @@
     @staticmethod
     def executable(tree, file_id):
         """Determine the executability of a file-id (used as a key method)."""
-        if file_id not in tree:
+        if not tree.has_id(file_id):
             return None
         if tree.kind(file_id) != "file":
             return False
@@ -950,7 +1112,7 @@
     @staticmethod
     def kind(tree, file_id):
         """Determine the kind of a file-id (used as a key method)."""
-        if file_id not in tree:
+        if not tree.has_id(file_id):
             return None
         return tree.kind(file_id)
 
@@ -1039,7 +1201,7 @@
 
     def merge_names(self, file_id):
         def get_entry(tree):
-            if file_id in tree.inventory:
+            if tree.has_id(file_id):
                 return tree.inventory[file_id]
             else:
                 return None
@@ -1094,7 +1256,7 @@
             self.tt.adjust_path(names[self.winner_idx[name_winner]],
                                 parent_trans_id, trans_id)
 
-    def merge_contents(self, file_id):
+    def _do_merge_contents(self, file_id):
         """Performs a merge on file_id contents."""
         def contents_pair(tree):
             if file_id not in tree:
@@ -1108,18 +1270,6 @@
                 contents = None
             return kind, contents
 
-        def contents_conflict():
-            trans_id = self.tt.trans_id_file_id(file_id)
-            name = self.tt.final_name(trans_id)
-            parent_id = self.tt.final_parent(trans_id)
-            if file_id in self.this_tree.inventory:
-                self.tt.unversion_file(trans_id)
-                if file_id in self.this_tree:
-                    self.tt.delete_contents(trans_id)
-            file_group = self._dump_conflicts(name, parent_id, file_id,
-                                              set_version=True)
-            self._raw_conflicts.append(('contents conflict', file_group))
-
         # See SPOT run.  run, SPOT, run.
         # So we're not QUITE repeating ourselves; we do tricky things with
         # file kind...
@@ -1141,49 +1291,115 @@
         if winner == 'this':
             # No interesting changes introduced by OTHER
             return "unmodified"
+        # We have a hypothetical conflict, but if we have files, then we
+        # can try to merge the content
         trans_id = self.tt.trans_id_file_id(file_id)
-        if winner == 'other':
+        params = MergeHookParams(self, file_id, trans_id, this_pair[0],
+            other_pair[0], winner)
+        hooks = self.active_hooks
+        hook_status = 'not_applicable'
+        for hook in hooks:
+            hook_status, lines = hook.merge_contents(params)
+            if hook_status != 'not_applicable':
+                # Don't try any more hooks, this one applies.
+                break
+        result = "modified"
+        if hook_status == 'not_applicable':
+            # This is a contents conflict, because none of the available
+            # functions could merge it.
+            result = None
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            if self.this_tree.has_id(file_id):
+                self.tt.unversion_file(trans_id)
+            file_group = self._dump_conflicts(name, parent_id, file_id,
+                                              set_version=True)
+            self._raw_conflicts.append(('contents conflict', file_group))
+        elif hook_status == 'success':
+            self.tt.create_file(lines, trans_id)
+        elif hook_status == 'conflicted':
+            # XXX: perhaps the hook should be able to provide
+            # the BASE/THIS/OTHER files?
+            self.tt.create_file(lines, trans_id)
+            self._raw_conflicts.append(('text conflict', trans_id))
+            name = self.tt.final_name(trans_id)
+            parent_id = self.tt.final_parent(trans_id)
+            self._dump_conflicts(name, parent_id, file_id)
+        elif hook_status == 'delete':
+            self.tt.unversion_file(trans_id)
+            result = "deleted"
+        elif hook_status == 'done':
+            # The hook function did whatever it needs to do directly, no
+            # further action needed here.
+            pass
+        else:
+            raise AssertionError('unknown hook_status: %r' % (hook_status,))
+        if not self.this_tree.has_id(file_id) and result == "modified":
+            self.tt.version_file(file_id, trans_id)
+        # The merge has been performed, so the old contents should not be
+        # retained.
+        try:
+            self.tt.delete_contents(trans_id)
+        except errors.NoSuchFile:
+            pass
+        return result
+
+    def _default_other_winner_merge(self, merge_hook_params):
+        """Replace this contents with other."""
+        file_id = merge_hook_params.file_id
+        trans_id = merge_hook_params.trans_id
+        file_in_this = self.this_tree.has_id(file_id)
+        if self.other_tree.has_id(file_id):
+            # OTHER changed the file
+            wt = self.this_tree
+            if wt.supports_content_filtering():
+                # We get the path from the working tree if it exists.
+                # That fails though when OTHER is adding a file, so
+                # we fall back to the other tree to find the path if
+                # it doesn't exist locally.
+                try:
+                    filter_tree_path = wt.id2path(file_id)
+                except errors.NoSuchId:
+                    filter_tree_path = self.other_tree.id2path(file_id)
+            else:
+                # Skip the id2path lookup for older formats
+                filter_tree_path = None
+            transform.create_from_tree(self.tt, trans_id,
+                             self.other_tree, file_id,
+                             filter_tree_path=filter_tree_path)
+            return 'done', None
+        elif file_in_this:
+            # OTHER deleted the file
+            return 'delete', None
+        else:
+            raise AssertionError(
+                'winner is OTHER, but file_id %r not in THIS or OTHER tree'
+                % (file_id,))
+
+    def merge_contents(self, merge_hook_params):
+        """Fallback merge logic after user installed hooks."""
+        # This function is used in merge hooks as the fallback instance.
+        # Perhaps making this function and the functions it calls be a 
+        # a separate class would be better.
+        if merge_hook_params.winner == 'other':
             # OTHER is a straight winner, so replace this contents with other
-            file_in_this = file_id in self.this_tree
-            if file_in_this:
-                # Remove any existing contents
-                self.tt.delete_contents(trans_id)
-            if file_id in self.other_tree:
-                # OTHER changed the file
-                transform.create_from_tree(self.tt, trans_id,
-                                           self.other_tree, file_id)
-                if not file_in_this:
-                    self.tt.version_file(file_id, trans_id)
-                return "modified"
-            elif file_in_this:
-                # OTHER deleted the file
-                self.tt.unversion_file(trans_id)
-                return "deleted"
+            return self._default_other_winner_merge(merge_hook_params)
+        elif merge_hook_params.is_file_merge():
+            # THIS and OTHER are both files, so text merge.  Either
+            # BASE is a file, or both converted to files, so at least we
+            # have agreement that output should be a file.
+            try:
+                self.text_merge(merge_hook_params.file_id,
+                    merge_hook_params.trans_id)
+            except errors.BinaryFile:
+                return 'not_applicable', None
+            return 'done', None
         else:
-            # We have a hypothetical conflict, but if we have files, then we
-            # can try to merge the content
-            if this_pair[0] == 'file' and other_pair[0] == 'file':
-                # THIS and OTHER are both files, so text merge.  Either
-                # BASE is a file, or both converted to files, so at least we
-                # have agreement that output should be a file.
-                try:
-                    self.text_merge(file_id, trans_id)
-                except errors.BinaryFile:
-                    return contents_conflict()
-                if file_id not in self.this_tree:
-                    self.tt.version_file(file_id, trans_id)
-                try:
-                    self.tt.tree_kind(trans_id)
-                    self.tt.delete_contents(trans_id)
-                except errors.NoSuchFile:
-                    pass
-                return "modified"
-            else:
-                return contents_conflict()
+            return 'not_applicable', None
 
     def get_lines(self, tree, file_id):
         """Return the lines in a file, or an empty list."""
-        if file_id in tree:
+        if tree.has_id(file_id):
             return tree.get_file(file_id).readlines()
         else:
             return []
@@ -1192,7 +1408,7 @@
         """Perform a three-way text merge on a file_id"""
         # it's possible that we got here with base as a different type.
         # if so, we just want two-way text conflicts.
-        if file_id in self.base_tree and \
+        if self.base_tree.has_id(file_id) and \
             self.base_tree.kind(file_id) == "file":
             base_lines = self.get_lines(self.base_tree, file_id)
         else:
@@ -1244,12 +1460,26 @@
                 ('THIS', self.this_tree, this_lines)]
         if not no_base:
             data.append(('BASE', self.base_tree, base_lines))
+
+        # We need to use the actual path in the working tree of the file here,
+        # ignoring the conflict suffixes
+        wt = self.this_tree
+        if wt.supports_content_filtering():
+            try:
+                filter_tree_path = wt.id2path(file_id)
+            except errors.NoSuchId:
+                # file has been deleted
+                filter_tree_path = None
+        else:
+            # Skip the id2path lookup for older formats
+            filter_tree_path = None
+
         versioned = False
         file_group = []
         for suffix, tree, lines in data:
-            if file_id in tree:
+            if tree.has_id(file_id):
                 trans_id = self._conflict_file(name, parent_id, tree, file_id,
-                                               suffix, lines)
+                                               suffix, lines, filter_tree_path)
                 file_group.append(trans_id)
                 if set_version and not versioned:
                     self.tt.version_file(file_id, trans_id)
@@ -1257,11 +1487,12 @@
         return file_group
 
     def _conflict_file(self, name, parent_id, tree, file_id, suffix,
-                       lines=None):
+                       lines=None, filter_tree_path=None):
         """Emit a single conflict file."""
         name = name + '.' + suffix
         trans_id = self.tt.create_path(name, parent_id)
-        transform.create_from_tree(self.tt, trans_id, tree, file_id, lines)
+        transform.create_from_tree(self.tt, trans_id, tree, file_id, lines,
+            filter_tree_path)
         return trans_id
 
     def merge_executable(self, file_id, file_status):
@@ -1296,11 +1527,11 @@
         if winner == "this":
             executability = this_executable
         else:
-            if file_id in self.other_tree:
+            if self.other_tree.has_id(file_id):
                 executability = other_executable
-            elif file_id in self.this_tree:
+            elif self.this_tree.has_id(file_id):
                 executability = this_executable
-            elif file_id in self.base_tree:
+            elif self.base_tree_has_id(file_id):
                 executability = base_executable
         if executability is not None:
             trans_id = self.tt.trans_id_file_id(file_id)
@@ -1378,70 +1609,62 @@
     supports_reverse_cherrypick = False
     history_based = True
 
-    def _merged_lines(self, file_id):
-        """Generate the merged lines.
-        There is no distinction between lines that are meant to contain <<<<<<<
-        and conflicts.
-        """
-        if self.cherrypick:
-            base = self.base_tree
-        else:
-            base = None
-        plan = self.this_tree.plan_file_merge(file_id, self.other_tree,
+    def _generate_merge_plan(self, file_id, base):
+        return self.this_tree.plan_file_merge(file_id, self.other_tree,
                                               base=base)
+
+    def _merged_lines(self, file_id):
+        """Generate the merged lines.
+        There is no distinction between lines that are meant to contain <<<<<<<
+        and conflicts.
+        """
+        if self.cherrypick:
+            base = self.base_tree
+        else:
+            base = None
+        plan = self._generate_merge_plan(file_id, base)
         if 'merge' in debug.debug_flags:
             plan = list(plan)
             trans_id = self.tt.trans_id_file_id(file_id)
             name = self.tt.final_name(trans_id) + '.plan'
-            contents = ('%10s|%s' % l for l in plan)
+            contents = ('%11s|%s' % l for l in plan)
             self.tt.new_file(name, self.tt.final_parent(trans_id), contents)
         textmerge = versionedfile.PlanWeaveMerge(plan, '<<<<<<< TREE\n',
                                                  '>>>>>>> MERGE-SOURCE\n')
-        return textmerge.merge_lines(self.reprocess)
+        lines, conflicts = textmerge.merge_lines(self.reprocess)
+        if conflicts:
+            base_lines = textmerge.base_from_plan()
+        else:
+            base_lines = None
+        return lines, base_lines
 
     def text_merge(self, file_id, trans_id):
         """Perform a (weave) text merge for a given file and file-id.
         If conflicts are encountered, .THIS and .OTHER files will be emitted,
         and a conflict will be noted.
         """
-        lines, conflicts = self._merged_lines(file_id)
+        lines, base_lines = self._merged_lines(file_id)
         lines = list(lines)
         # Note we're checking whether the OUTPUT is binary in this case,
         # because we don't want to get into weave merge guts.
         textfile.check_text_lines(lines)
         self.tt.create_file(lines, trans_id)
-        if conflicts:
+        if base_lines is not None:
+            # Conflict
             self._raw_conflicts.append(('text conflict', trans_id))
             name = self.tt.final_name(trans_id)
             parent_id = self.tt.final_parent(trans_id)
             file_group = self._dump_conflicts(name, parent_id, file_id,
-                                              no_base=True)
+                                              no_base=False,
+                                              base_lines=base_lines)
             file_group.append(trans_id)
 
 
 class LCAMerger(WeaveMerger):
 
-    def _merged_lines(self, file_id):
-        """Generate the merged lines.
-        There is no distinction between lines that are meant to contain <<<<<<<
-        and conflicts.
-        """
-        if self.cherrypick:
-            base = self.base_tree
-        else:
-            base = None
-        plan = self.this_tree.plan_file_lca_merge(file_id, self.other_tree,
+    def _generate_merge_plan(self, file_id, base):
+        return self.this_tree.plan_file_lca_merge(file_id, self.other_tree,
                                                   base=base)
-        if 'merge' in debug.debug_flags:
-            plan = list(plan)
-            trans_id = self.tt.trans_id_file_id(file_id)
-            name = self.tt.final_name(trans_id) + '.plan'
-            contents = ('%10s|%s' % l for l in plan)
-            self.tt.new_file(name, self.tt.final_parent(trans_id), contents)
-        textmerge = versionedfile.PlanWeaveMerge(plan, '<<<<<<< TREE\n',
-                                                 '>>>>>>> MERGE-SOURCE\n')
-        return textmerge.merge_lines(self.reprocess)
-
 
 class Diff3Merger(Merge3Merger):
     """Three-way merger using external diff3 for text merging"""

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2009-05-11 19:11:14 +0000
+++ bzrlib/merge_directive.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -371,15 +371,13 @@
         :return: a MergeRequest
         """
         line_iter = iter(lines)
+        firstline = ""
         for line in line_iter:
             if line.startswith('# Bazaar merge directive format '):
-                break
-        else:
-            if len(lines) > 0:
-                raise errors.NotAMergeDirective(lines[0])
-            else:
-                raise errors.NotAMergeDirective('')
-        return _format_registry.get(line[2:].rstrip())._from_lines(line_iter)
+                return _format_registry.get(line[2:].rstrip())._from_lines(
+                    line_iter)
+            firstline = firstline or line.strip()
+        raise errors.NotAMergeDirective(firstline)
 
     @classmethod
     def _from_lines(klass, line_iter):
@@ -582,11 +580,13 @@
                     revision_id):
                     raise errors.PublicBranchOutOfDate(public_branch,
                                                        revision_id)
+            testament_sha1 = t.as_sha1()
         finally:
             for entry in reversed(locked):
                 entry.unlock()
-        return klass(revision_id, t.as_sha1(), time, timezone, target_branch,
-            patch, public_branch, message, bundle, base_revision_id)
+        return klass(revision_id, testament_sha1, time, timezone,
+            target_branch, patch, public_branch, message, bundle,
+            base_revision_id)
 
     def _verify_patch(self, repository):
         calculated_patch = self._generate_diff(repository, self.revision_id,

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2009-03-23 14:59:43 +0000
+++ bzrlib/msgeditor.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,16 +63,14 @@
             ## mutter("trying editor: %r", (edargs +[filename]))
             x = call(edargs + [filename])
         except OSError, e:
-            # We're searching for an editor, so catch safe errors and continue
-            if e.errno in (errno.ENOENT, errno.EACCES):
-                if candidate_source is not None:
-                    # We tried this editor because some user configuration (an
-                    # environment variable or config file) said to try it.  Let
-                    # the user know their configuration is broken.
-                    trace.warning(
-                        'Could not start editor "%s" (specified by %s): %s\n'
-                        % (candidate, candidate_source, str(e)))
-                continue
+            if candidate_source is not None:
+                # We tried this editor because some user configuration (an
+                # environment variable or config file) said to try it.  Let
+                # the user know their configuration is broken.
+                trace.warning(
+                    'Could not start editor "%s" (specified by %s): %s\n'
+                    % (candidate, candidate_source, str(e)))
+            continue
             raise
         if x == 0:
             return True

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2009-04-03 20:05:25 +0000
+++ bzrlib/option.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -40,25 +40,25 @@
     each revision specifier supplied.
 
     >>> _parse_revision_str('234')
-    [<RevisionSpec_revno 234>]
+    [<RevisionSpec_dwim 234>]
     >>> _parse_revision_str('234..567')
-    [<RevisionSpec_revno 234>, <RevisionSpec_revno 567>]
+    [<RevisionSpec_dwim 234>, <RevisionSpec_dwim 567>]
     >>> _parse_revision_str('..')
     [<RevisionSpec None>, <RevisionSpec None>]
     >>> _parse_revision_str('..234')
-    [<RevisionSpec None>, <RevisionSpec_revno 234>]
+    [<RevisionSpec None>, <RevisionSpec_dwim 234>]
     >>> _parse_revision_str('234..')
-    [<RevisionSpec_revno 234>, <RevisionSpec None>]
+    [<RevisionSpec_dwim 234>, <RevisionSpec None>]
     >>> _parse_revision_str('234..456..789') # Maybe this should be an error
-    [<RevisionSpec_revno 234>, <RevisionSpec_revno 456>, <RevisionSpec_revno 789>]
+    [<RevisionSpec_dwim 234>, <RevisionSpec_dwim 456>, <RevisionSpec_dwim 789>]
     >>> _parse_revision_str('234....789') #Error ?
-    [<RevisionSpec_revno 234>, <RevisionSpec None>, <RevisionSpec_revno 789>]
+    [<RevisionSpec_dwim 234>, <RevisionSpec None>, <RevisionSpec_dwim 789>]
     >>> _parse_revision_str('revid:test@other.com-234234')
     [<RevisionSpec_revid revid:test@other.com-234234>]
     >>> _parse_revision_str('revid:test@other.com-234234..revid:test@other.com-234235')
     [<RevisionSpec_revid revid:test@other.com-234234>, <RevisionSpec_revid revid:test@other.com-234235>]
     >>> _parse_revision_str('revid:test@other.com-234234..23')
-    [<RevisionSpec_revid revid:test@other.com-234234>, <RevisionSpec_revno 23>]
+    [<RevisionSpec_revid revid:test@other.com-234234>, <RevisionSpec_dwim 23>]
     >>> _parse_revision_str('date:2005-04-12')
     [<RevisionSpec_date date:2005-04-12>]
     >>> _parse_revision_str('date:2005-04-12 12:24:33')
@@ -68,27 +68,23 @@
     >>> _parse_revision_str('date:2005-04-12,12:24:33')
     [<RevisionSpec_date date:2005-04-12,12:24:33>]
     >>> _parse_revision_str('-5..23')
-    [<RevisionSpec_revno -5>, <RevisionSpec_revno 23>]
+    [<RevisionSpec_dwim -5>, <RevisionSpec_dwim 23>]
     >>> _parse_revision_str('-5')
-    [<RevisionSpec_revno -5>]
+    [<RevisionSpec_dwim -5>]
     >>> _parse_revision_str('123a')
-    Traceback (most recent call last):
-      ...
-    NoSuchRevisionSpec: No namespace registered for string: '123a'
+    [<RevisionSpec_dwim 123a>]
     >>> _parse_revision_str('abc')
-    Traceback (most recent call last):
-      ...
-    NoSuchRevisionSpec: No namespace registered for string: 'abc'
+    [<RevisionSpec_dwim abc>]
     >>> _parse_revision_str('branch:../branch2')
     [<RevisionSpec_branch branch:../branch2>]
     >>> _parse_revision_str('branch:../../branch2')
     [<RevisionSpec_branch branch:../../branch2>]
     >>> _parse_revision_str('branch:../../branch2..23')
-    [<RevisionSpec_branch branch:../../branch2>, <RevisionSpec_revno 23>]
+    [<RevisionSpec_branch branch:../../branch2>, <RevisionSpec_dwim 23>]
     >>> _parse_revision_str('branch:..\\\\branch2')
     [<RevisionSpec_branch branch:..\\branch2>]
     >>> _parse_revision_str('branch:..\\\\..\\\\branch2..23')
-    [<RevisionSpec_branch branch:..\\..\\branch2>, <RevisionSpec_revno 23>]
+    [<RevisionSpec_branch branch:..\\..\\branch2>, <RevisionSpec_dwim 23>]
     """
     # TODO: Maybe move this into revisionspec.py
     revs = []
@@ -104,7 +100,7 @@
     parent of the revision.
 
     >>> _parse_change_str('123')
-    (<RevisionSpec_before before:123>, <RevisionSpec_revno 123>)
+    (<RevisionSpec_before before:123>, <RevisionSpec_dwim 123>)
     >>> _parse_change_str('123..124')
     Traceback (most recent call last):
       ...

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2009-10-15 04:01:26 +0000
+++ bzrlib/osutils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,6 +39,7 @@
 from shutil import (
     rmtree,
     )
+import signal
 import subprocess
 import tempfile
 from tempfile import (
@@ -71,6 +72,15 @@
 from bzrlib import symbol_versioning
 
 
+# Cross platform wall-clock time functionality with decent resolution.
+# On Linux ``time.clock`` returns only CPU time. On Windows, ``time.time()``
+# only has a resolution of ~15ms. Note that ``time.clock()`` is not
+# synchronized with ``time.time()``, this is only meant to be used to find
+# delta times by subtracting from another call to this function.
+timer_func = time.time
+if sys.platform == 'win32':
+    timer_func = time.clock
+
 # On win32, O_BINARY is used to indicate the file should
 # be opened in binary mode, rather than text mode.
 # On other platforms, O_BINARY doesn't exist, because
@@ -192,13 +202,17 @@
     :param old: The old path, to rename from
     :param new: The new path, to rename to
     :param rename_func: The potentially non-atomic rename function
-    :param unlink_func: A way to delete the target file if the full rename succeeds
+    :param unlink_func: A way to delete the target file if the full rename
+        succeeds
     """
-
     # sftp rename doesn't allow overwriting, so play tricks:
     base = os.path.basename(new)
     dirname = os.path.dirname(new)
-    tmp_name = u'tmp.%s.%.9f.%d.%s' % (base, time.time(), os.getpid(), rand_chars(10))
+    # callers use different encodings for the paths so the following MUST
+    # respect that. We rely on python upcasting to unicode if new is unicode
+    # and keeping a str if not.
+    tmp_name = 'tmp.%s.%.9f.%d.%s' % (base, time.time(),
+                                      os.getpid(), rand_chars(10))
     tmp_name = pathjoin(dirname, tmp_name)
 
     # Rename the file out of the way, but keep track if it didn't exist
@@ -224,6 +238,7 @@
     else:
         file_existed = True
 
+    failure_exc = None
     success = False
     try:
         try:
@@ -235,8 +250,12 @@
             # source and target may be aliases of each other (e.g. on a
             # case-insensitive filesystem), so we may have accidentally renamed
             # source by when we tried to rename target
-            if not (file_existed and e.errno in (None, errno.ENOENT)):
-                raise
+            failure_exc = sys.exc_info()
+            if (file_existed and e.errno in (None, errno.ENOENT)
+                and old.lower() == new.lower()):
+                # source and target are the same file on a case-insensitive
+                # filesystem, so we don't generate an exception
+                failure_exc = None
     finally:
         if file_existed:
             # If the file used to exist, rename it back into place
@@ -245,6 +264,8 @@
                 unlink_func(tmp_name)
             else:
                 rename_func(tmp_name, new)
+    if failure_exc is not None:
+        raise failure_exc[0], failure_exc[1], failure_exc[2]
 
 
 # In Python 2.4.2 and older, os.path.abspath and os.path.realpath
@@ -688,6 +709,8 @@
     return offset.days * 86400 + offset.seconds
 
 weekdays = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
+_default_format_by_weekday_num = [wd + " %Y-%m-%d %H:%M:%S" for wd in weekdays]
+
 
 def format_date(t, offset=0, timezone='original', date_fmt=None,
                 show_offset=True):
@@ -707,6 +730,32 @@
     date_str = time.strftime(date_fmt, tt)
     return date_str + offset_str
 
+
+# Cache of formatted offset strings
+_offset_cache = {}
+
+
+def format_date_with_offset_in_original_timezone(t, offset=0,
+    _cache=_offset_cache):
+    """Return a formatted date string in the original timezone.
+
+    This routine may be faster then format_date.
+
+    :param t: Seconds since the epoch.
+    :param offset: Timezone offset in seconds east of utc.
+    """
+    if offset is None:
+        offset = 0
+    tt = time.gmtime(t + offset)
+    date_fmt = _default_format_by_weekday_num[tt[6]]
+    date_str = time.strftime(date_fmt, tt)
+    offset_str = _cache.get(offset, None)
+    if offset_str is None:
+        offset_str = ' %+03d%02d' % (offset / 3600, (offset / 60) % 60)
+        _cache[offset] = offset_str
+    return date_str + offset_str
+
+
 def format_local_date(t, offset=0, timezone='original', date_fmt=None,
                       show_offset=True):
     """Return an unicode date string formatted according to the current locale.
@@ -726,6 +775,7 @@
         date_str = date_str.decode(get_user_encoding(), 'replace')
     return date_str + offset_str
 
+
 def _format_date(t, offset, timezone, date_fmt, show_offset):
     if timezone == 'utc':
         tt = time.gmtime(t)
@@ -1294,27 +1344,115 @@
     normalized_filename = _inaccessible_normalized_filename
 
 
+default_terminal_width = 80
+"""The default terminal width for ttys.
+
+This is defined so that higher levels can share a common fallback value when
+terminal_width() returns None.
+"""
+
+
 def terminal_width():
-    """Return estimated terminal width."""
-    if sys.platform == 'win32':
-        return win32utils.get_console_size()[0]
-    width = 0
+    """Return terminal width.
+
+    None is returned if the width can't established precisely.
+
+    The rules are:
+    - if BZR_COLUMNS is set, returns its value
+    - if there is no controlling terminal, returns None
+    - if COLUMNS is set, returns its value,
+
+    From there, we need to query the OS to get the size of the controlling
+    terminal.
+
+    Unices:
+    - get termios.TIOCGWINSZ
+    - if an error occurs or a negative value is obtained, returns None
+
+    Windows:
+    
+    - win32utils.get_console_size() decides,
+    - returns None on error (provided default value)
+    """
+
+    # If BZR_COLUMNS is set, take it, user is always right
+    try:
+        return int(os.environ['BZR_COLUMNS'])
+    except (KeyError, ValueError):
+        pass
+
+    isatty = getattr(sys.stdout, 'isatty', None)
+    if  isatty is None or not isatty():
+        # Don't guess, setting BZR_COLUMNS is the recommended way to override.
+        return None
+
+    # If COLUMNS is set, take it, the terminal knows better (even inside a
+    # given terminal, the application can decide to set COLUMNS to a lower
+    # value (splitted screen) or a bigger value (scroll bars))
+    try:
+        return int(os.environ['COLUMNS'])
+    except (KeyError, ValueError):
+        pass
+
+    width, height = _terminal_size(None, None)
+    if width <= 0:
+        # Consider invalid values as meaning no width
+        return None
+
+    return width
+
+
+def _win32_terminal_size(width, height):
+    width, height = win32utils.get_console_size(defaultx=width, defaulty=height)
+    return width, height
+
+
+def _ioctl_terminal_size(width, height):
     try:
         import struct, fcntl, termios
         s = struct.pack('HHHH', 0, 0, 0, 0)
         x = fcntl.ioctl(1, termios.TIOCGWINSZ, s)
-        width = struct.unpack('HHHH', x)[1]
-    except IOError:
+        height, width = struct.unpack('HHHH', x)[0:2]
+    except (IOError, AttributeError):
         pass
-    if width <= 0:
-        try:
-            width = int(os.environ['COLUMNS'])
-        except:
+    return width, height
+
+_terminal_size = None
+"""Returns the terminal size as (width, height).
+
+:param width: Default value for width.
+:param height: Default value for height.
+
+This is defined specifically for each OS and query the size of the controlling
+terminal. If any error occurs, the provided default values should be returned.
+"""
+if sys.platform == 'win32':
+    _terminal_size = _win32_terminal_size
+else:
+    _terminal_size = _ioctl_terminal_size
+
+
+def _terminal_size_changed(signum, frame):
+    """Set COLUMNS upon receiving a SIGnal for WINdow size CHange."""
+    width, height = _terminal_size(None, None)
+    if width is not None:
+        os.environ['COLUMNS'] = str(width)
+
+
+_registered_sigwinch = False
+
+def watch_sigwinch():
+    """Register for SIGWINCH, once and only once."""
+    global _registered_sigwinch
+    if not _registered_sigwinch:
+        if sys.platform == 'win32':
+            # Martin (gz) mentioned WINDOW_BUFFER_SIZE_RECORD from
+            # ReadConsoleInput but I've no idea how to plug that in
+            # the current design -- vila 20091216
             pass
-    if width <= 0:
-        width = 80
-
-    return width
+        else:
+            signal.signal(signal.SIGWINCH, _terminal_size_changed)
+        _registered_sigwinch = True
 
 
 def supports_executable():
@@ -1945,13 +2083,16 @@
     anything goes wrong.
     """
     global _cached_local_concurrency
+
     if _cached_local_concurrency is not None and use_cache:
         return _cached_local_concurrency
 
-    try:
-        concurrency = _local_concurrency()
-    except (OSError, IOError):
-        concurrency = None
+    concurrency = os.environ.get('BZR_CONCURRENCY', None)
+    if concurrency is None:
+        try:
+            concurrency = _local_concurrency()
+        except (OSError, IOError):
+            pass
     try:
         concurrency = int(concurrency)
     except (TypeError, ValueError):
@@ -1959,3 +2100,18 @@
     if use_cache:
         _cached_concurrency = concurrency
     return concurrency
+
+
+class UnicodeOrBytesToBytesWriter(codecs.StreamWriter):
+    """A stream writer that doesn't decode str arguments."""
+
+    def __init__(self, encode, stream, errors='strict'):
+        codecs.StreamWriter.__init__(self, stream, errors)
+        self.encode = encode
+
+    def write(self, object):
+        if type(object) is str:
+            self.stream.write(object)
+        else:
+            data, _ = self.encode(object, self.errors)
+            self.stream.write(data)

=== modified file 'bzrlib/patches.py'
--- bzrlib/patches.py	2009-03-23 14:59:43 +0000
+++ bzrlib/patches.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004 - 2006, 2008 Aaron Bentley, Canonical Ltd
+# Copyright (C) 2005-2010 Aaron Bentley, Canonical Ltd
 # <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -14,6 +14,18 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+import re
+
+
+binary_files_re = 'Binary files (.*) and (.*) differ\n'
+
+
+class BinaryFiles(Exception):
+
+    def __init__(self, orig_name, mod_name):
+        self.orig_name = orig_name
+        self.mod_name = mod_name
+        Exception.__init__(self, 'Binary files section encountered.')
 
 
 class PatchSyntax(Exception):
@@ -57,6 +69,9 @@
 def get_patch_names(iter_lines):
     try:
         line = iter_lines.next()
+        match = re.match(binary_files_re, line)
+        if match is not None:
+            raise BinaryFiles(match.group(1), match.group(2))
         if not line.startswith("--- "):
             raise MalformedPatchHeader("No orig name", line)
         else:
@@ -259,10 +274,19 @@
         yield hunk
 
 
-class Patch:
+class BinaryPatch(object):
     def __init__(self, oldname, newname):
         self.oldname = oldname
         self.newname = newname
+
+    def __str__(self):
+        return 'Binary files %s and %s differ\n' % (self.oldname, self.newname)
+
+
+class Patch(BinaryPatch):
+
+    def __init__(self, oldname, newname):
+        BinaryPatch.__init__(self, oldname, newname)
         self.hunks = []
 
     def __str__(self):
@@ -317,14 +341,19 @@
 
 def parse_patch(iter_lines):
     iter_lines = iter_lines_handle_nl(iter_lines)
-    (orig_name, mod_name) = get_patch_names(iter_lines)
-    patch = Patch(orig_name, mod_name)
-    for hunk in iter_hunks(iter_lines):
-        patch.hunks.append(hunk)
-    return patch
+    try:
+        (orig_name, mod_name) = get_patch_names(iter_lines)
+    except BinaryFiles, e:
+        return BinaryPatch(e.orig_name, e.mod_name)
+    else:
+        patch = Patch(orig_name, mod_name)
+        for hunk in iter_hunks(iter_lines):
+            patch.hunks.append(hunk)
+        return patch
 
 
 def iter_file_patch(iter_lines):
+    regex = re.compile(binary_files_re)
     saved_lines = []
     orig_range = 0
     for line in iter_lines:
@@ -335,7 +364,7 @@
         elif orig_range > 0:
             if line.startswith('-') or line.startswith(' '):
                 orig_range -= 1
-        elif line.startswith('--- '):
+        elif line.startswith('--- ') or regex.match(line):
             if len(saved_lines) > 0:
                 yield saved_lines
             saved_lines = []

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2009-07-06 13:00:23 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 - 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,15 +36,12 @@
 from bzrlib.directory_service import directories
 from bzrlib.errors import (
     BzrCommandError,
+    DependencyNotPresent,
     InvalidURL,
     NoPublicBranch,
     NotBranchError,
     )
 from bzrlib.help_topics import topic_registry
-from bzrlib.plugins.launchpad.lp_registration import (
-    LaunchpadService,
-    NotLaunchpadBranch,
-    )
 
 
 class cmd_register_branch(Command):
@@ -111,8 +108,8 @@
             link_bug=None,
             dry_run=False):
         from bzrlib.plugins.launchpad.lp_registration import (
-            LaunchpadService, BranchRegistrationRequest, BranchBugLinkRequest,
-            DryRunLaunchpadService)
+            BranchRegistrationRequest, BranchBugLinkRequest,
+            DryRunLaunchpadService, LaunchpadService)
         if public_url is None:
             try:
                 b = _mod_branch.Branch.open_containing('.')[0]
@@ -147,9 +144,9 @@
             # Run on service entirely in memory
             service = DryRunLaunchpadService()
         service.gather_user_credentials()
-        branch_object_url = rego.submit(service)
+        rego.submit(service)
         if link_bug:
-            link_bug_url = linko.submit(service)
+            linko.submit(service)
         print 'Branch registered.'
 
 register_command(cmd_register_branch)
@@ -170,7 +167,7 @@
         """Yield possible external locations for the branch at 'location'."""
         yield location
         try:
-            branch = _mod_branch.Branch.open(location)
+            branch = _mod_branch.Branch.open_containing(location)[0]
         except NotBranchError:
             return
         branch_url = branch.get_public_branch()
@@ -181,6 +178,8 @@
             yield branch_url
 
     def _get_web_url(self, service, location):
+        from bzrlib.plugins.launchpad.lp_registration import (
+            NotLaunchpadBranch)
         for branch_url in self._possible_locations(location):
             try:
                 return service.get_web_url_from_branch_url(branch_url)
@@ -189,6 +188,8 @@
         raise NotLaunchpadBranch(branch_url)
 
     def run(self, location=None, dry_run=False):
+        from bzrlib.plugins.launchpad.lp_registration import (
+            LaunchpadService)
         if location is None:
             location = u'.'
         web_url = self._get_web_url(LaunchpadService(), location)
@@ -226,6 +227,7 @@
         ]
 
     def run(self, name=None, no_check=False, verbose=False):
+        # This is totally separate from any launchpadlib login system.
         from bzrlib.plugins.launchpad import account
         check_account = not no_check
 
@@ -255,6 +257,26 @@
 register_command(cmd_launchpad_login)
 
 
+# XXX: cmd_launchpad_mirror is untested
+class cmd_launchpad_mirror(Command):
+    """Ask Launchpad to mirror a branch now."""
+
+    aliases = ['lp-mirror']
+    takes_args = ['location?']
+
+    def run(self, location='.'):
+        from bzrlib.plugins.launchpad import lp_api
+        from bzrlib.plugins.launchpad.lp_registration import LaunchpadService
+        branch = _mod_branch.Branch.open(location)
+        service = LaunchpadService()
+        launchpad = lp_api.login(service)
+        lp_branch = lp_api.load_branch(launchpad, branch)
+        lp_branch.requestMirror()
+
+
+register_command(cmd_launchpad_mirror)
+
+
 def _register_directory():
     directories.register_lazy('lp:', 'bzrlib.plugins.launchpad.lp_directory',
                               'LaunchpadDirectory',
@@ -262,30 +284,20 @@
 _register_directory()
 
 
-def test_suite():
-    """Called by bzrlib to fetch tests for this plugin"""
-    from unittest import TestSuite, TestLoader
-    from bzrlib.plugins.launchpad import (
-        test_account,
-        test_lp_directory,
-        test_lp_login,
-        test_lp_open,
-        test_lp_service,
-        test_register,
-        )
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'test_account',
+        'test_register',
+        'test_lp_api',
+        'test_lp_directory',
+        'test_lp_login',
+        'test_lp_open',
+        'test_lp_service',
+        ]
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests
 
-    loader = TestLoader()
-    suite = TestSuite()
-    for module in [
-        test_account,
-        test_register,
-        test_lp_directory,
-        test_lp_login,
-        test_lp_open,
-        test_lp_service,
-        ]:
-        suite.addTests(loader.loadTestsFromModule(module))
-    return suite
 
 _launchpad_help = """Integration with Launchpad.net
 

=== added file 'bzrlib/plugins/launchpad/lp_api.py'
--- bzrlib/plugins/launchpad/lp_api.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/launchpad/lp_api.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,135 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tools for dealing with the Launchpad API."""
+
+# Importing this module will be expensive, since it imports launchpadlib and
+# its dependencies. However, our plan is to only load this module when it is
+# needed by a command that uses it.
+
+
+import os
+
+from bzrlib import (
+    config,
+    errors,
+    osutils,
+    )
+from bzrlib.plugins.launchpad.lp_registration import (
+    InvalidLaunchpadInstance,
+    NotLaunchpadBranch,
+    )
+
+try:
+    import launchpadlib
+except ImportError, e:
+    raise errors.DependencyNotPresent('launchpadlib', e)
+
+from launchpadlib.launchpad import (
+    EDGE_SERVICE_ROOT,
+    STAGING_SERVICE_ROOT,
+    Launchpad,
+    )
+
+
+# Declare the minimum version of launchpadlib that we need in order to work.
+# 1.5.1 is the version of launchpadlib packaged in Ubuntu 9.10, the most
+# recent Ubuntu release at the time of writing.
+MINIMUM_LAUNCHPADLIB_VERSION = (1, 5, 1)
+
+
+def get_cache_directory():
+    """Return the directory to cache launchpadlib objects in."""
+    return osutils.pathjoin(config.config_dir(), 'launchpad')
+
+
+def parse_launchpadlib_version(version_number):
+    """Parse a version number of the style used by launchpadlib."""
+    return tuple(map(int, version_number.split('.')))
+
+
+def check_launchpadlib_compatibility():
+    """Raise an error if launchpadlib has the wrong version number."""
+    installed_version = parse_launchpadlib_version(launchpadlib.__version__)
+    if installed_version < MINIMUM_LAUNCHPADLIB_VERSION:
+        raise errors.IncompatibleAPI(
+            'launchpadlib', MINIMUM_LAUNCHPADLIB_VERSION,
+            installed_version, installed_version)
+
+
+LAUNCHPAD_API_URLS = {
+    'production': 'https://api.launchpad.net/beta/',
+    'edge': EDGE_SERVICE_ROOT,
+    'staging': STAGING_SERVICE_ROOT,
+    'dev': 'https://api.launchpad.dev/beta/',
+    }
+
+
+def _get_api_url(service):
+    """Return the root URL of the Launchpad API.
+
+    e.g. For the 'edge' Launchpad service, this function returns
+    launchpadlib.launchpad.EDGE_SERVICE_ROOT.
+
+    :param service: A `LaunchpadService` object.
+    :return: A URL as a string.
+    """
+    if service._lp_instance is None:
+        lp_instance = service.DEFAULT_INSTANCE
+    else:
+        lp_instance = service._lp_instance
+    try:
+        return LAUNCHPAD_API_URLS[lp_instance]
+    except KeyError:
+        raise InvalidLaunchpadInstance(lp_instance)
+
+
+def login(service, timeout=None, proxy_info=None):
+    """Log in to the Launchpad API.
+
+    :return: The root `Launchpad` object from launchpadlib.
+    """
+    cache_directory = get_cache_directory()
+    launchpad = Launchpad.login_with(
+        'bzr', _get_api_url(service), cache_directory, timeout=timeout,
+        proxy_info=proxy_info)
+    # XXX: Work-around a minor security bug in launchpadlib 1.5.1, which would
+    # create this directory with default umask.
+    os.chmod(cache_directory, 0700)
+    return launchpad
+
+
+def load_branch(launchpad, branch):
+    """Return the launchpadlib Branch object corresponding to 'branch'.
+
+    :param launchpad: The root `Launchpad` object from launchpadlib.
+    :param branch: A `bzrlib.branch.Branch`.
+    :raise NotLaunchpadBranch: If we cannot determine the Launchpad URL of
+        `branch`.
+    :return: A launchpadlib Branch object.
+    """
+    # XXX: This duplicates the "What are possible URLs for the branch that
+    # Launchpad might recognize" logic found in cmd_lp_open.
+
+    # XXX: This makes multiple roundtrips to Launchpad for what is
+    # conceptually a single operation -- get me the branches that match these
+    # URLs. Unfortunately, Launchpad's support for such operations is poor, so
+    # we have to allow multiple roundtrips.
+    for url in branch.get_public_branch(), branch.get_push_location():
+        lp_branch = launchpad.branches.getByUrl(url=url)
+        if lp_branch:
+            return lp_branch
+    raise NotLaunchpadBranch(url)

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2009-03-23 14:59:43 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,15 +63,9 @@
                  _request_factory=ResolveLaunchpadPathRequest,
                  _lp_login=None):
         """Resolve the base URL for this transport."""
+        service = LaunchpadService.for_url(url)
         result = urlsplit(url)
-        # Perform an XMLRPC request to resolve the path
-        lp_instance = result[1]
-        if lp_instance == '':
-            lp_instance = None
-        elif lp_instance not in LaunchpadService.LAUNCHPAD_INSTANCE:
-            raise errors.InvalidURL(path=url)
         resolve = _request_factory(result[2].strip('/'))
-        service = LaunchpadService(lp_instance=lp_instance)
         try:
             result = resolve.submit(service)
         except xmlrpclib.Fault, fault:
@@ -79,7 +73,7 @@
                 path=url, extra=fault.faultString)
 
         if 'launchpad' in debug.debug_flags:
-            trace.mutter("resolve_lp_path(%r) == %r", path, result)
+            trace.mutter("resolve_lp_path(%r) == %r", url, result)
 
         if _lp_login is None:
             _lp_login = get_lp_login()

=== modified file 'bzrlib/plugins/launchpad/lp_registration.py'
--- bzrlib/plugins/launchpad/lp_registration.py	2009-07-04 16:22:16 +0000
+++ bzrlib/plugins/launchpad/lp_registration.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,16 +21,14 @@
 import urllib
 import xmlrpclib
 
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-from bzrlib import urlutils
-""")
-
 from bzrlib import (
     config,
     errors,
+    urlutils,
     __version__ as _bzrlib_version,
     )
+from bzrlib.transport.http import _urllib2_wrappers
+
 
 # for testing, do
 '''
@@ -53,6 +51,33 @@
         errors.BzrError.__init__(self, url=url)
 
 
+class XMLRPCTransport(xmlrpclib.Transport):
+
+    def __init__(self, scheme):
+        # In python2.4 xmlrpclib.Transport is a old-style class, and does not
+        # define __init__, so we check first
+        init = getattr(xmlrpclib.Transport, '__init__', None)
+        if init is not None:
+            init(self)
+        self._scheme = scheme
+        self._opener = _urllib2_wrappers.Opener()
+        self.verbose = 0
+
+    def request(self, host, handler, request_body, verbose=0):
+        self.verbose = verbose
+        url = self._scheme + "://" + host + handler
+        request = _urllib2_wrappers.Request("POST", url, request_body)
+        # FIXME: _urllib2_wrappers will override user-agent with its own
+        # request.add_header("User-Agent", self.user_agent)
+        request.add_header("Content-Type", "text/xml")
+
+        response = self._opener.open(request)
+        if response.code != 200:
+            raise xmlrpclib.ProtocolError(host + handler, response.code,
+                                          response.msg, response.info())
+        return self.parse_response(response)
+
+
 class LaunchpadService(object):
     """A service to talk to Launchpad via XMLRPC.
 
@@ -90,15 +115,11 @@
         self._lp_instance = lp_instance
         if transport is None:
             uri_type = urllib.splittype(self.service_url)[0]
-            if uri_type == 'https':
-                transport = xmlrpclib.SafeTransport()
-            else:
-                transport = xmlrpclib.Transport()
+            transport = XMLRPCTransport(uri_type)
             transport.user_agent = 'bzr/%s (xmlrpclib/%s)' \
                     % (_bzrlib_version, xmlrpclib.__version__)
         self.transport = transport
 
-
     @property
     def service_url(self):
         """Return the http or https url for the xmlrpc server.
@@ -116,6 +137,17 @@
         else:
             return self.DEFAULT_SERVICE_URL
 
+    @classmethod
+    def for_url(cls, url, **kwargs):
+        """Return the Launchpad service corresponding to the given URL."""
+        result = urlsplit(url)
+        lp_instance = result[1]
+        if lp_instance == '':
+            lp_instance = None
+        elif lp_instance not in cls.LAUNCHPAD_INSTANCE:
+            raise errors.InvalidURL(path=url)
+        return cls(lp_instance=lp_instance, **kwargs)
+
     def get_proxy(self, authenticated):
         """Return the proxy for XMLRPC requests."""
         if authenticated:
@@ -191,13 +223,7 @@
             instance = self._lp_instance
         return self.LAUNCHPAD_DOMAINS[instance]
 
-    def get_web_url_from_branch_url(self, branch_url, _request_factory=None):
-        """Get the Launchpad web URL for the given branch URL.
-
-        :raise errors.InvalidURL: if 'branch_url' cannot be identified as a
-            Launchpad branch URL.
-        :return: The URL of the branch on Launchpad.
-        """
+    def _guess_branch_path(self, branch_url, _request_factory=None):
         scheme, hostinfo, path = urlsplit(branch_url)[:3]
         if _request_factory is None:
             _request_factory = ResolveLaunchpadPathRequest
@@ -215,6 +241,16 @@
                 for domain in self.LAUNCHPAD_DOMAINS.itervalues())
             if hostinfo not in domains:
                 raise NotLaunchpadBranch(branch_url)
+        return path.lstrip('/')
+
+    def get_web_url_from_branch_url(self, branch_url, _request_factory=None):
+        """Get the Launchpad web URL for the given branch URL.
+
+        :raise errors.InvalidURL: if 'branch_url' cannot be identified as a
+            Launchpad branch URL.
+        :return: The URL of the branch on Launchpad.
+        """
+        path = self._guess_branch_path(branch_url, _request_factory)
         return urlutils.join('https://code.%s' % self.domain, path)
 
 

=== added file 'bzrlib/plugins/launchpad/test_lp_api.py'
--- bzrlib/plugins/launchpad/test_lp_api.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/launchpad/test_lp_api.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,101 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+from bzrlib import commands, config, errors, osutils
+from bzrlib.plugins.launchpad import cmd_launchpad_mirror
+from bzrlib.tests import (
+    ModuleAvailableFeature,
+    TestCase,
+    TestCaseWithTransport,
+    )
+
+
+launchpadlib_feature = ModuleAvailableFeature('launchpadlib')
+
+
+class TestDependencyManagement(TestCase):
+    """Tests for managing the dependency on launchpadlib."""
+
+    _test_needs_features = [launchpadlib_feature]
+
+    def setUp(self):
+        TestCase.setUp(self)
+        from bzrlib.plugins.launchpad import lp_api
+        self.lp_api = lp_api
+
+    def patch(self, obj, name, value):
+        """Temporarily set the 'name' attribute of 'obj' to 'value'."""
+        real_value = getattr(obj, name)
+        setattr(obj, name, value)
+        self.addCleanup(setattr, obj, name, real_value)
+
+    def test_get_launchpadlib_version(self):
+        # parse_launchpadlib_version returns a tuple of a version number of
+        # the style used by launchpadlib.
+        version_info = self.lp_api.parse_launchpadlib_version('1.5.1')
+        self.assertEqual((1, 5, 1), version_info)
+
+    def test_supported_launchpadlib_version(self):
+        # If the installed version of launchpadlib is greater than the minimum
+        # required version of launchpadlib, check_launchpadlib_compatibility
+        # doesn't raise an error.
+        launchpadlib = launchpadlib_feature.module
+        self.patch(launchpadlib, '__version__', '1.5.1')
+        self.lp_api.MINIMUM_LAUNCHPADLIB_VERSION = (1, 5, 1)
+        # Doesn't raise an exception.
+        self.lp_api.check_launchpadlib_compatibility()
+
+    def test_unsupported_launchpadlib_version(self):
+        # If the installed version of launchpadlib is less than the minimum
+        # required version of launchpadlib, check_launchpadlib_compatibility
+        # raises an IncompatibleAPI error.
+        launchpadlib = launchpadlib_feature.module
+        self.patch(launchpadlib, '__version__', '1.5.0')
+        self.lp_api.MINIMUM_LAUNCHPADLIB_VERSION = (1, 5, 1)
+        self.assertRaises(
+            errors.IncompatibleAPI,
+            self.lp_api.check_launchpadlib_compatibility)
+
+
+class TestCacheDirectory(TestCase):
+    """Tests for get_cache_directory."""
+
+    _test_needs_features = [launchpadlib_feature]
+
+    def test_get_cache_directory(self):
+        # get_cache_directory returns the path to a directory inside the
+        # Bazaar configuration directory.
+        from bzrlib.plugins.launchpad import lp_api
+        expected_path = osutils.pathjoin(config.config_dir(), 'launchpad')
+        self.assertEqual(expected_path, lp_api.get_cache_directory())
+
+
+class TestLaunchpadMirror(TestCaseWithTransport):
+    """Tests for the 'bzr lp-mirror' command."""
+
+    # Testing the lp-mirror command is quite hard, since it must talk to a
+    # Launchpad server. Here, we just test that the command exists.
+
+    _test_needs_features = [launchpadlib_feature]
+
+    def test_command_exists(self):
+        out, err = self.run_bzr(['launchpad-mirror', '--help'], retcode=0)
+        self.assertEqual('', err)
+
+    def test_alias_exists(self):
+        out, err = self.run_bzr(['lp-mirror', '--help'], retcode=0)
+        self.assertEqual('', err)

=== modified file 'bzrlib/plugins/launchpad/test_lp_directory.py'
--- bzrlib/plugins/launchpad/test_lp_directory.py	2009-03-23 14:59:43 +0000
+++ bzrlib/plugins/launchpad/test_lp_directory.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,10 +16,12 @@
 
 """Tests for directory lookup through Launchpad.net"""
 
+import os
 import xmlrpclib
 
 from bzrlib import (
     errors,
+    tests,
     )
 from bzrlib.branch import Branch
 from bzrlib.directory_service import directories
@@ -28,10 +30,38 @@
     TestCaseWithMemoryTransport
 )
 from bzrlib.transport import get_transport
-from bzrlib.plugins.launchpad import _register_directory
+from bzrlib.plugins.launchpad import (
+    _register_directory,
+    lp_registration,
+    )
 from bzrlib.plugins.launchpad.lp_directory import (
     LaunchpadDirectory)
 from bzrlib.plugins.launchpad.account import get_lp_login
+from bzrlib.tests import (
+    http_server,
+    http_utils,
+    )
+
+
+def load_tests(standard_tests, module, loader):
+    result = loader.suiteClass()
+    t_tests, remaining_tests = tests.split_suite_by_condition(
+        standard_tests, tests.condition_isinstance((
+                TestXMLRPCTransport,
+                )))
+    transport_scenarios = [
+        ('http', dict(server_class=PreCannedHTTPServer,)),
+        ]
+    if tests.HTTPSServerFeature.available():
+        transport_scenarios.append(
+            ('https', dict(server_class=PreCannedHTTPSServer,)),
+            )
+    tests.multiply_tests(t_tests, transport_scenarios, result)
+
+    # No parametrization for the remaining tests
+    result.addTests(remaining_tests)
+
+    return result
 
 
 class FakeResolveFactory(object):
@@ -190,3 +220,116 @@
         transport = get_transport('lp:///apt')
         branch = Branch.open_from_transport(transport)
         self.assertEqual(target_branch.base, branch.base)
+
+
+class PredefinedRequestHandler(http_server.TestingHTTPRequestHandler):
+    """Request handler for a unique and pre-defined request.
+
+    The only thing we care about here is that we receive a connection. But
+    since we want to dialog with a real http client, we have to send it correct
+    responses.
+
+    We expect to receive a *single* request nothing more (and we won't even
+    check what request it is), the tests will recognize us from our response.
+    """
+
+    def handle_one_request(self):
+        tcs = self.server.test_case_server
+        requestline = self.rfile.readline()
+        headers = self.MessageClass(self.rfile, 0)
+        if requestline.startswith('POST'):
+            # The body should be a single line (or we don't know where it ends
+            # and we don't want to issue a blocking read)
+            body = self.rfile.readline()
+
+        self.wfile.write(tcs.canned_response)
+
+
+class PreCannedServerMixin(object):
+
+    def __init__(self):
+        super(PreCannedServerMixin, self).__init__(
+            request_handler=PredefinedRequestHandler)
+        # Bytes read and written by the server
+        self.bytes_read = 0
+        self.bytes_written = 0
+        self.canned_response = None
+
+
+class PreCannedHTTPServer(PreCannedServerMixin, http_server.HttpServer):
+    pass
+
+
+if tests.HTTPSServerFeature.available():
+    from bzrlib.tests import https_server
+    class PreCannedHTTPSServer(PreCannedServerMixin, https_server.HTTPSServer):
+        pass
+
+
+class TestXMLRPCTransport(tests.TestCase):
+
+    # set by load_tests
+    server_class = None
+
+    def setUp(self):
+        tests.TestCase.setUp(self)
+        self.server = self.server_class()
+        self.server.start_server()
+        # Ensure we don't clobber env
+        self._captureVar('BZR_LP_XMLRPC_URL', None)
+
+    def tearDown(self):
+        self.server.stop_server()
+        tests.TestCase.tearDown(self)
+
+    def set_canned_response(self, server, path):
+        response_format = '''HTTP/1.1 200 OK\r
+Date: Tue, 11 Jul 2006 04:32:56 GMT\r
+Server: Apache/2.0.54 (Fedora)\r
+Last-Modified: Sun, 23 Apr 2006 19:35:20 GMT\r
+ETag: "56691-23-38e9ae00"\r
+Accept-Ranges: bytes\r
+Content-Length: %(length)d\r
+Connection: close\r
+Content-Type: text/plain; charset=UTF-8\r
+\r
+<?xml version='1.0'?>
+<methodResponse>
+<params>
+<param>
+<value><struct>
+<member>
+<name>urls</name>
+<value><array><data>
+<value><string>bzr+ssh://bazaar.launchpad.net/%(path)s</string></value>
+<value><string>http://bazaar.launchpad.net/%(path)s</string></value>
+</data></array></value>
+</member>
+</struct></value>
+</param>
+</params>
+</methodResponse>
+'''
+        length = 334 + 2 * len(path)
+        server.canned_response = response_format % dict(length=length,
+                                                        path=path)
+
+    def do_request(self, server_url):
+        os.environ['BZR_LP_XMLRPC_URL'] = self.server.get_url()
+        service = lp_registration.LaunchpadService()
+        resolve = lp_registration.ResolveLaunchpadPathRequest('bzr')
+        result = resolve.submit(service)
+        return result
+
+    def test_direct_request(self):
+        self.set_canned_response(self.server, '~bzr-pqm/bzr/bzr.dev')
+        result = self.do_request(self.server.get_url())
+        urls = result.get('urls', None)
+        self.assertIsNot(None, urls)
+        self.assertEquals(
+            ['bzr+ssh://bazaar.launchpad.net/~bzr-pqm/bzr/bzr.dev',
+             'http://bazaar.launchpad.net/~bzr-pqm/bzr/bzr.dev'],
+            urls)
+    # FIXME: we need to test with a real proxy, I can't find a way so simulate
+    # CONNECT without leaving one server hanging the test :-/ Since that maybe
+    # related to the leaking tests problems, I'll punt for now -- vila 20091030

=== modified file 'bzrlib/plugins/launchpad/test_lp_open.py'
--- bzrlib/plugins/launchpad/test_lp_open.py	2009-03-23 14:59:43 +0000
+++ bzrlib/plugins/launchpad/test_lp_open.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,9 +21,10 @@
 
 class TestLaunchpadOpen(TestCaseWithTransport):
 
-    def run_open(self, location, retcode=0):
-        out, err = self.run_bzr(
-            ['launchpad-open', '--dry-run', location], retcode=retcode)
+    def run_open(self, location, retcode=0, working_dir='.'):
+        out, err = self.run_bzr(['launchpad-open', '--dry-run', location],
+                                retcode=retcode,
+                                working_dir=working_dir)
         return err.splitlines()
 
     def test_non_branch(self):
@@ -87,3 +88,14 @@
             ['Opening https://code.edge.launchpad.net/~foo/bar/baz in web '
              'browser'],
             self.run_open('bzr+ssh://bazaar.launchpad.net/~foo/bar/baz'))
+
+    def test_launchpad_branch_subdirectory(self):
+        # lp-open in a subdirectory of a registered branch should work
+        wt = self.make_branch_and_tree('lp')
+        wt.branch.set_push_location(
+            'bzr+ssh://bazaar.launchpad.net/~foo/bar/baz')
+        self.build_tree(['lp/a/'])
+        self.assertEqual(
+            ['Opening https://code.edge.launchpad.net/~foo/bar/baz in web '
+             'browser'],
+            self.run_open('.', working_dir='lp/a'))

=== added directory 'bzrlib/plugins/news_merge'
=== added file 'bzrlib/plugins/news_merge/README'
--- bzrlib/plugins/news_merge/README	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/README	2010-01-20 16:05:28 +0000
@@ -0,0 +1,7 @@
+A plugin for merging bzr's NEWS file.
+
+This plugin is activated via configuration variables, see 'bzr help news_merge'.
+
+This hook can resolve conflicts where both sides add entries at the same place.
+If it encounters a more difficult conflict it gives up and bzr will fallback to
+the default merge algorithm.

=== added file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/__init__.py	2010-01-28 17:27:16 +0000
@@ -0,0 +1,66 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Merge hook for bzr's NEWS file.
+
+To enable this plugin, add a section to your branch.conf or location.conf
+like::
+
+    [/home/user/code/bzr]
+    news_merge_files = NEWS
+    news_merge_files:policy = recurse
+
+The news_merge_files config option takes a list of file paths, separated by
+commas.
+
+Limitations:
+
+* if there's a conflict in more than just bullet points, this doesn't yet know
+  how to resolve that, so bzr will fallback to the default line-based merge.
+"""
+
+# Since we are a built-in plugin we share the bzrlib version
+from bzrlib import version_info
+
+# Put most of the code in a separate module that we lazy-import to keep the
+# overhead of this plugin as minimal as possible.
+from bzrlib.lazy_import import lazy_import
+lazy_import(globals(), """
+from bzrlib.plugins.news_merge import news_merge as _mod_news_merge
+""")
+
+from bzrlib.merge import Merger
+
+
+def news_merge_hook(merger):
+    """Merger.merge_file_content hook for bzr-format NEWS files."""
+    return _mod_news_merge.NewsMerger(merger)
+
+
+def install_hook():
+    Merger.hooks.install_named_hook(
+        'merge_file_content', news_merge_hook, 'NEWS file merge')
+install_hook()
+
+
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'tests',
+        ]
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests
+

=== added file 'bzrlib/plugins/news_merge/news_merge.py'
--- bzrlib/plugins/news_merge/news_merge.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/news_merge.py	2010-01-28 18:05:44 +0000
@@ -0,0 +1,94 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Merge logic for news_merge plugin."""
+
+
+from bzrlib.plugins.news_merge.parser import simple_parse
+from bzrlib import merge, merge3
+
+
+magic_marker = '|NEWS-MERGE-MAGIC-MARKER|'
+
+
+class NewsMerger(merge.ConfigurableFileMerger):
+    """Merge bzr NEWS files."""
+
+    name_prefix = "news"
+
+    def merge_text(self, params):
+        """Perform a simple 3-way merge of a bzr NEWS file.
+        
+        Each section of a bzr NEWS file is essentially an ordered set of bullet
+        points, so we can simply take a set of bullet points, determine which
+        bullets to add and which to remove, sort, and reserialize.
+        """
+        # Transform the different versions of the NEWS file into a bunch of
+        # text lines where each line matches one part of the overall
+        # structure, e.g. a heading or bullet.
+        def munge(lines):
+            return list(blocks_to_fakelines(simple_parse(''.join(lines))))
+        this_lines = munge(params.this_lines)
+        other_lines = munge(params.other_lines)
+        base_lines = munge(params.base_lines)
+        m3 = merge3.Merge3(base_lines, this_lines, other_lines)
+        result_lines = []
+        for group in m3.merge_groups():
+            if group[0] == 'conflict':
+                _, base, a, b = group
+                # Are all the conflicting lines bullets?  If so, we can merge
+                # this.
+                for line_set in [base, a, b]:
+                    for line in line_set:
+                        if not line.startswith('bullet'):
+                            # Something else :(
+                            # Maybe the default merge can cope.
+                            return 'not_applicable', None
+                # Calculate additions and deletions.
+                new_in_a = set(a).difference(base)
+                new_in_b = set(b).difference(base)
+                all_new = new_in_a.union(new_in_b)
+                deleted_in_a = set(base).difference(a)
+                deleted_in_b = set(base).difference(b)
+                # Combine into the final set of bullet points.
+                final = all_new.difference(deleted_in_a).difference(
+                    deleted_in_b)
+                # Sort, and emit.
+                final = sorted(final, key=sort_key)
+                result_lines.extend(final)
+            else:
+                result_lines.extend(group[1])
+        # Transform the merged elements back into real blocks of lines.
+        return 'success', list(fakelines_to_blocks(result_lines))
+
+
+def blocks_to_fakelines(blocks):
+    for kind, text in blocks:
+        yield '%s%s%s' % (kind, magic_marker, text)
+
+
+def fakelines_to_blocks(fakelines):
+    fakelines = list(fakelines)
+    # Strip out the magic_marker, and reinstate the \n\n between blocks
+    for fakeline in fakelines[:-1]:
+        yield fakeline.split(magic_marker, 1)[1] + '\n\n'
+    # The final block doesn't have a trailing \n\n.
+    for fakeline in fakelines[-1:]:
+        yield fakeline.split(magic_marker, 1)[1]
+
+
+def sort_key(s):
+    return s.replace('`', '').lower()

=== added file 'bzrlib/plugins/news_merge/parser.py'
--- bzrlib/plugins/news_merge/parser.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/parser.py	2010-01-18 07:00:11 +0000
@@ -0,0 +1,62 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Simple parser for bzr's NEWS file.
+
+Simple as this is, it's a bit over-powered for news_merge's needs, which only
+cares about 'bullet' and 'everything else'.
+
+This module can be run as a standalone Python program; pass it a filename and
+it will print the parsed form of a file (a series of 2-tuples, see
+simple_parse's docstring).
+"""
+
+
+def simple_parse(content):
+    """Returns blocks, where each block is a 2-tuple (kind, text).
+    
+    :kind: one of 'heading', 'release', 'section', 'empty' or 'text'.
+    :text: a str, including newlines.
+    """
+    blocks = content.split('\n\n')
+    for block in blocks:
+        if block.startswith('###'):
+            # First line is ###...: Top heading
+            yield 'heading', block
+            continue
+        last_line = block.rsplit('\n', 1)[-1]
+        if last_line.startswith('###'):
+            # last line is ###...: 2nd-level heading
+            yield 'release', block
+        elif last_line.startswith('***'):
+            # last line is ***...: 3rd-level heading
+            yield 'section', block
+        elif block.startswith('* '):
+            # bullet
+            yield 'bullet', block
+        elif block.strip() == '':
+            # empty
+            yield 'empty', block
+        else:
+            # plain text
+            yield 'text', block
+
+
+if __name__ == '__main__':
+    import sys
+    content = open(sys.argv[1], 'rb').read()
+    for result in simple_parse(content):
+        print result

=== added directory 'bzrlib/plugins/news_merge/tests'
=== added file 'bzrlib/plugins/news_merge/tests/__init__.py'
--- bzrlib/plugins/news_merge/tests/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/tests/__init__.py	2010-01-20 16:05:28 +0000
@@ -0,0 +1,23 @@
+# Copyright (C) 2010 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'test_news_merge',
+        ]
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests

=== added file 'bzrlib/plugins/news_merge/tests/test_news_merge.py'
--- bzrlib/plugins/news_merge/tests/test_news_merge.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/news_merge/tests/test_news_merge.py	2010-01-28 18:01:03 +0000
@@ -0,0 +1,29 @@
+# Copyright (C) 2010 by Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+# FIXME: This is totally incomplete but I'm only the patch pilot :-)
+# -- vila 100120
+# Note that the single test from this file is now in
+# test_merge.TestConfigurableFileMerger -- rbc 20100129.
+
+from bzrlib import (
+    option,
+    tests,
+    )
+from bzrlib.merge import Merger
+from bzrlib.plugins import news_merge
+import bzrlib.plugins.news_merge.news_merge
+from bzrlib.tests import test_merge_core

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2009-07-18 21:09:00 +0000
+++ bzrlib/push.py	2010-02-16 16:08:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -90,12 +90,19 @@
             br_to = br_from.create_clone_on_transport(to_transport,
                 revision_id=revision_id, stacked_on=stacked_on,
                 create_prefix=create_prefix, use_existing_dir=use_existing_dir)
-        except errors.FileExists:
+        except errors.FileExists, err:
+            if err.path.endswith('/.bzr'):
+                raise errors.BzrCommandError(
+                    "Target directory %s already contains a .bzr directory, "
+                    "but it is not valid." % (location,))
             if not use_existing_dir:
                 raise errors.BzrCommandError("Target directory %s"
-                     " already exists, but does not have a valid .bzr"
+                     " already exists, but does not have a .bzr"
                      " directory. Supply --use-existing-dir to push"
                      " there anyway." % location)
+            # This shouldn't occur, but if it does the FileExists error will be
+            # more informative than an UnboundLocalError for br_to.
+            raise
         except errors.NoSuchFile:
             if not create_prefix:
                 raise errors.BzrCommandError("Parent directory of %s"
@@ -103,6 +110,12 @@
                     "\nYou may supply --create-prefix to create all"
                     " leading parent directories."
                     % location)
+            # This shouldn't occur (because create_prefix is true, so
+            # create_clone_on_transport should be catching NoSuchFile and
+            # creating the missing directories) but if it does the original
+            # NoSuchFile error will be more informative than an
+            # UnboundLocalError for br_to.
+            raise
         except errors.TooManyRedirections:
             raise errors.BzrCommandError("Too many redirections trying "
                                          "to make %s." % location)
@@ -130,6 +143,10 @@
             raise errors.BzrCommandError('These branches have diverged.'
                                     '  See "bzr help diverged-branches"'
                                     ' for more information.')
+        except errors.NoRoundtrippingSupport, e:
+            raise errors.BzrCommandError("It is not possible to losslessly "
+                "push to %s. You may want to use dpush instead." % 
+                    e.target_branch.mapping.vcs.abbreviation)
         except errors.NoRepositoryPresent:
             # we have a bzrdir but no branch or repository
             # XXX: Figure out what to do other than complain.

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2009-09-24 04:54:19 +0000
+++ bzrlib/reconcile.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,12 +27,12 @@
 
 
 from bzrlib import (
+    cleanup,
     errors,
     ui,
     repository,
-    repofmt,
     )
-from bzrlib.trace import mutter, note
+from bzrlib.trace import mutter
 from bzrlib.tsort import topo_sort
 from bzrlib.versionedfile import AdapterFactory, FulltextContentFactory
 
@@ -120,15 +120,16 @@
         self.branch = a_branch
 
     def reconcile(self):
+        operation = cleanup.OperationWithCleanups(self._reconcile)
+        self.add_cleanup = operation.add_cleanup
+        operation.run_simple()
+
+    def _reconcile(self):
         self.branch.lock_write()
-        try:
-            self.pb = ui.ui_factory.nested_progress_bar()
-            try:
-                self._reconcile_steps()
-            finally:
-                self.pb.finished()
-        finally:
-            self.branch.unlock()
+        self.add_cleanup(self.branch.unlock)
+        self.pb = ui.ui_factory.nested_progress_bar()
+        self.add_cleanup(self.pb.finished)
+        self._reconcile_steps()
 
     def _reconcile_steps(self):
         self._reconcile_revision_history()
@@ -192,15 +193,16 @@
         garbage_inventories: The number of inventory objects without revisions
                              that were garbage collected.
         """
+        operation = cleanup.OperationWithCleanups(self._reconcile)
+        self.add_cleanup = operation.add_cleanup
+        operation.run_simple()
+
+    def _reconcile(self):
         self.repo.lock_write()
-        try:
-            self.pb = ui.ui_factory.nested_progress_bar()
-            try:
-                self._reconcile_steps()
-            finally:
-                self.pb.finished()
-        finally:
-            self.repo.unlock()
+        self.add_cleanup(self.repo.unlock)
+        self.pb = ui.ui_factory.nested_progress_bar()
+        self.add_cleanup(self.pb.finished)
+        self._reconcile_steps()
 
     def _reconcile_steps(self):
         """Perform the steps to reconcile this repository."""
@@ -502,23 +504,21 @@
         collection = self.repo._pack_collection
         collection.ensure_loaded()
         collection.lock_names()
-        try:
-            packs = collection.all_packs()
-            all_revisions = self.repo.all_revision_ids()
-            total_inventories = len(list(
-                collection.inventory_index.combined_index.iter_all_entries()))
-            if len(all_revisions):
-                new_pack =  self.repo._reconcile_pack(collection, packs,
-                    ".reconcile", all_revisions, self.pb)
-                if new_pack is not None:
-                    self._discard_and_save(packs)
-            else:
-                # only make a new pack when there is data to copy.
+        self.add_cleanup(collection._unlock_names)
+        packs = collection.all_packs()
+        all_revisions = self.repo.all_revision_ids()
+        total_inventories = len(list(
+            collection.inventory_index.combined_index.iter_all_entries()))
+        if len(all_revisions):
+            new_pack =  self.repo._reconcile_pack(collection, packs,
+                ".reconcile", all_revisions, self.pb)
+            if new_pack is not None:
                 self._discard_and_save(packs)
-            self.garbage_inventories = total_inventories - len(list(
-                collection.inventory_index.combined_index.iter_all_entries()))
-        finally:
-            collection._unlock_names()
+        else:
+            # only make a new pack when there is data to copy.
+            self._discard_and_save(packs)
+        self.garbage_inventories = total_inventories - len(list(
+            collection.inventory_index.combined_index.iter_all_entries()))
 
     def _discard_and_save(self, packs):
         """Discard some packs from the repository.

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2009-10-15 04:01:26 +0000
+++ bzrlib/remote.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -114,6 +114,9 @@
 
         self._probe_bzrdir()
 
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__, self._client)
+
     def _probe_bzrdir(self):
         medium = self._client._medium
         path = self._path_for_remote_call(self._client)
@@ -154,6 +157,10 @@
         Used before calls to self._real_bzrdir.
         """
         if not self._real_bzrdir:
+            if 'hpssvfs' in debug.debug_flags:
+                import traceback
+                warning('VFS BzrDir access triggered\n%s',
+                    ''.join(traceback.format_stack()))
             self._real_bzrdir = BzrDir.open_from_transport(
                 self.root_transport, _server_formats=False)
             self._format._network_name = \
@@ -280,21 +287,32 @@
     def _get_branch_reference(self):
         path = self._path_for_remote_call(self._client)
         medium = self._client._medium
-        if not medium._is_remote_before((1, 13)):
+        candidate_calls = [
+            ('BzrDir.open_branchV3', (2, 1)),
+            ('BzrDir.open_branchV2', (1, 13)),
+            ('BzrDir.open_branch', None),
+            ]
+        for verb, required_version in candidate_calls:
+            if required_version and medium._is_remote_before(required_version):
+                continue
             try:
-                response = self._call('BzrDir.open_branchV2', path)
-                if response[0] not in ('ref', 'branch'):
-                    raise errors.UnexpectedSmartServerResponse(response)
-                return response
+                response = self._call(verb, path)
             except errors.UnknownSmartMethod:
-                medium._remember_remote_is_before((1, 13))
-        response = self._call('BzrDir.open_branch', path)
-        if response[0] != 'ok':
+                if required_version is None:
+                    raise
+                medium._remember_remote_is_before(required_version)
+            else:
+                break
+        if verb == 'BzrDir.open_branch':
+            if response[0] != 'ok':
+                raise errors.UnexpectedSmartServerResponse(response)
+            if response[1] != '':
+                return ('ref', response[1])
+            else:
+                return ('branch', '')
+        if response[0] not in ('ref', 'branch'):
             raise errors.UnexpectedSmartServerResponse(response)
-        if response[1] != '':
-            return ('ref', response[1])
-        else:
-            return ('branch', '')
+        return response
 
     def _get_tree_branch(self):
         """See BzrDir._get_tree_branch()."""
@@ -597,7 +615,8 @@
         return self._custom_format._fetch_reconcile
 
     def get_format_description(self):
-        return 'bzr remote repository'
+        self._ensure_real()
+        return 'Remote: ' + self._custom_format.get_format_description()
 
     def __eq__(self, other):
         return self.__class__ is other.__class__
@@ -946,6 +965,11 @@
     def is_write_locked(self):
         return self._lock_mode == 'w'
 
+    def _warn_if_deprecated(self, branch=None):
+        # If we have a real repository, the check will be done there, if we
+        # don't the check will be done remotely.
+        pass
+
     def lock_read(self):
         # wrong eventually - want a local lock cache context
         if not self._lock_mode:
@@ -1995,7 +2019,8 @@
                 self._network_name)
 
     def get_format_description(self):
-        return 'Remote BZR Branch'
+        self._ensure_real()
+        return 'Remote: ' + self._custom_format.get_format_description()
 
     def network_name(self):
         return self._network_name
@@ -2812,8 +2837,13 @@
         raise NoSuchRevision(find('branch'), err.error_args[0])
     elif err.error_verb == 'nosuchrevision':
         raise NoSuchRevision(find('repository'), err.error_args[0])
-    elif err.error_tuple == ('nobranch',):
-        raise errors.NotBranchError(path=find('bzrdir').root_transport.base)
+    elif err.error_verb == 'nobranch':
+        if len(err.error_args) >= 1:
+            extra = err.error_args[0]
+        else:
+            extra = None
+        raise errors.NotBranchError(path=find('bzrdir').root_transport.base,
+            detail=extra)
     elif err.error_verb == 'norepository':
         raise errors.NoRepositoryPresent(find('bzrdir'))
     elif err.error_verb == 'LockContention':

=== modified file 'bzrlib/repofmt/groupcompress_repo.py'
--- bzrlib/repofmt/groupcompress_repo.py	2009-10-19 16:21:20 +0000
+++ bzrlib/repofmt/groupcompress_repo.py	2010-01-21 21:13:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -53,6 +53,7 @@
     ResumedPack,
     Packer,
     )
+from bzrlib.static_tuple import StaticTuple
 
 
 class GCPack(NewPack):
@@ -352,7 +353,8 @@
         """Build a VersionedFiles instance on top of this group of packs."""
         index_name = index_name + '_index'
         index_to_pack = {}
-        access = knit._DirectPackAccess(index_to_pack)
+        access = knit._DirectPackAccess(index_to_pack,
+                                        reload_func=self._reload_func)
         if for_write:
             # Use new_pack
             if self.new_pack is None:
@@ -703,10 +705,11 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        result = self._save_pack_names(clear_obsolete_packs=True)
-        # Move the old packs out of the way now they are no longer referenced.
-        for revision_count, packs in pack_operations:
-            self._obsolete_packs(packs)
+        to_be_obsoleted = []
+        for _, packs in pack_operations:
+            to_be_obsoleted.extend(packs)
+        result = self._save_pack_names(clear_obsolete_packs=True,
+                                       obsolete_packs=to_be_obsoleted)
         return result
 
 
@@ -814,14 +817,16 @@
                                  ' no new_path %r' % (file_id,))
             if new_path == '':
                 new_inv.root_id = file_id
-                parent_id_basename_key = ('', '')
+                parent_id_basename_key = StaticTuple('', '').intern()
             else:
                 utf8_entry_name = entry.name.encode('utf-8')
-                parent_id_basename_key = (entry.parent_id, utf8_entry_name)
+                parent_id_basename_key = StaticTuple(entry.parent_id,
+                                                     utf8_entry_name).intern()
             new_value = entry_to_bytes(entry)
             # Populate Caches?
             # new_inv._path_to_fileid_cache[new_path] = file_id
-            id_to_entry_dict[(file_id,)] = new_value
+            key = StaticTuple(file_id).intern()
+            id_to_entry_dict[key] = new_value
             parent_id_basename_dict[parent_id_basename_key] = file_id
 
         new_inv._populate_from_dicts(self.chk_bytes, id_to_entry_dict,
@@ -949,6 +954,10 @@
                         pb=pb):
                 for name, bytes in items:
                     (name_utf8, file_id, revision_id) = bytes_to_info(bytes)
+                    # TODO: consider interning file_id, revision_id here, or
+                    #       pushing that intern() into bytes_to_info()
+                    # TODO: rich_root should always be True here, for all
+                    #       repositories that support chk_bytes
                     if not rich_root and name_utf8 == '':
                         continue
                     try:
@@ -1189,7 +1198,9 @@
             # are always rich-root, so there are no synthesised root records to
             # ignore.
             _, file_id, revision_id = bytes_to_info(bytes)
-            text_keys.add((file_id, revision_id))
+            file_id = intern(file_id)
+            revision_id = intern(revision_id)
+            text_keys.add(StaticTuple(file_id, revision_id).intern())
         yield record
 
 

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2009-10-21 03:50:26 +0000
+++ bzrlib/repofmt/pack_repo.py	2010-02-05 07:58:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,6 +24,7 @@
 
 from bzrlib import (
     chk_map,
+    cleanup,
     debug,
     graph,
     osutils,
@@ -646,11 +647,10 @@
         del self.combined_index._indices[:]
         self.add_callback = None
 
-    def remove_index(self, index, pack):
+    def remove_index(self, index):
         """Remove index from the indices used to answer queries.
 
         :param index: An index from the pack parameter.
-        :param pack: A Pack instance.
         """
         del self.index_to_pack[index]
         self.combined_index._indices.remove(index)
@@ -1117,7 +1117,7 @@
             iterator is a tuple with:
             index, readv_vector, node_vector. readv_vector is a list ready to
             hand to the transport readv method, and node_vector is a list of
-            (key, eol_flag, references) for the the node retrieved by the
+            (key, eol_flag, references) for the node retrieved by the
             matching readv_vector.
         """
         # group by pack so we do one readv per pack
@@ -1423,6 +1423,9 @@
         # resumed packs
         self._resumed_packs = []
 
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__, self.repo)
+
     def add_pack_to_memory(self, pack):
         """Make a Pack object available to the repository to satisfy queries.
 
@@ -1542,10 +1545,11 @@
                 self._remove_pack_from_memory(pack)
         # record the newly available packs and stop advertising the old
         # packs
-        result = self._save_pack_names(clear_obsolete_packs=True)
-        # Move the old packs out of the way now they are no longer referenced.
-        for revision_count, packs in pack_operations:
-            self._obsolete_packs(packs)
+        to_be_obsoleted = []
+        for _, packs in pack_operations:
+            to_be_obsoleted.extend(packs)
+        result = self._save_pack_names(clear_obsolete_packs=True,
+                                       obsolete_packs=to_be_obsoleted)
         return result
 
     def _flush_new_pack(self):
@@ -1785,8 +1789,13 @@
         :param return: None.
         """
         for pack in packs:
-            pack.pack_transport.rename(pack.file_name(),
-                '../obsolete_packs/' + pack.file_name())
+            try:
+                pack.pack_transport.rename(pack.file_name(),
+                    '../obsolete_packs/' + pack.file_name())
+            except (errors.PathError, errors.TransportError), e:
+                # TODO: Should these be warnings or mutters?
+                mutter("couldn't rename obsolete pack, skipping it:\n%s"
+                       % (e,))
             # TODO: Probably needs to know all possible indices for this pack
             # - or maybe list the directory and move all indices matching this
             # name whether we recognize it or not?
@@ -1794,8 +1803,12 @@
             if self.chk_index is not None:
                 suffixes.append('.cix')
             for suffix in suffixes:
-                self._index_transport.rename(pack.name + suffix,
-                    '../obsolete_packs/' + pack.name + suffix)
+                try:
+                    self._index_transport.rename(pack.name + suffix,
+                        '../obsolete_packs/' + pack.name + suffix)
+                except (errors.PathError, errors.TransportError), e:
+                    mutter("couldn't rename obsolete index, skipping it:\n%s"
+                           % (e,))
 
     def pack_distribution(self, total_revisions):
         """Generate a list of the number of revisions to put in each pack.
@@ -1827,14 +1840,22 @@
         self._remove_pack_indices(pack)
         self.packs.remove(pack)
 
-    def _remove_pack_indices(self, pack):
-        """Remove the indices for pack from the aggregated indices."""
-        self.revision_index.remove_index(pack.revision_index, pack)
-        self.inventory_index.remove_index(pack.inventory_index, pack)
-        self.text_index.remove_index(pack.text_index, pack)
-        self.signature_index.remove_index(pack.signature_index, pack)
-        if self.chk_index is not None:
-            self.chk_index.remove_index(pack.chk_index, pack)
+    def _remove_pack_indices(self, pack, ignore_missing=False):
+        """Remove the indices for pack from the aggregated indices.
+        
+        :param ignore_missing: Suppress KeyErrors from calling remove_index.
+        """
+        for index_type in Pack.index_definitions.keys():
+            attr_name = index_type + '_index'
+            aggregate_index = getattr(self, attr_name)
+            if aggregate_index is not None:
+                pack_index = getattr(pack, attr_name)
+                try:
+                    aggregate_index.remove_index(pack_index)
+                except KeyError:
+                    if ignore_missing:
+                        continue
+                    raise
 
     def reset(self):
         """Clear all cached data."""
@@ -1873,6 +1894,7 @@
         disk_nodes = set()
         for index, key, value in self._iter_disk_pack_index():
             disk_nodes.add((key, value))
+        orig_disk_nodes = set(disk_nodes)
 
         # do a two-way diff against our original content
         current_nodes = set()
@@ -1891,7 +1913,7 @@
         disk_nodes.difference_update(deleted_nodes)
         disk_nodes.update(new_nodes)
 
-        return disk_nodes, deleted_nodes, new_nodes
+        return disk_nodes, deleted_nodes, new_nodes, orig_disk_nodes
 
     def _syncronize_pack_names_from_disk_nodes(self, disk_nodes):
         """Given the correct set of pack files, update our saved info.
@@ -1937,7 +1959,7 @@
                 added.append(name)
         return removed, added, modified
 
-    def _save_pack_names(self, clear_obsolete_packs=False):
+    def _save_pack_names(self, clear_obsolete_packs=False, obsolete_packs=None):
         """Save the list of packs.
 
         This will take out the mutex around the pack names list for the
@@ -1947,12 +1969,16 @@
 
         :param clear_obsolete_packs: If True, clear out the contents of the
             obsolete_packs directory.
+        :param obsolete_packs: Packs that are obsolete once the new pack-names
+            file has been written.
         :return: A list of the names saved that were not previously on disk.
         """
+        already_obsolete = []
         self.lock_names()
         try:
             builder = self._index_builder_class()
-            disk_nodes, deleted_nodes, new_nodes = self._diff_pack_names()
+            (disk_nodes, deleted_nodes, new_nodes,
+             orig_disk_nodes) = self._diff_pack_names()
             # TODO: handle same-name, index-size-changes here -
             # e.g. use the value from disk, not ours, *unless* we're the one
             # changing it.
@@ -1960,14 +1986,25 @@
                 builder.add_node(key, value)
             self.transport.put_file('pack-names', builder.finish(),
                 mode=self.repo.bzrdir._get_file_mode())
-            # move the baseline forward
             self._packs_at_load = disk_nodes
             if clear_obsolete_packs:
-                self._clear_obsolete_packs()
+                to_preserve = None
+                if obsolete_packs:
+                    to_preserve = set([o.name for o in obsolete_packs])
+                already_obsolete = self._clear_obsolete_packs(to_preserve)
         finally:
             self._unlock_names()
         # synchronise the memory packs list with what we just wrote:
         self._syncronize_pack_names_from_disk_nodes(disk_nodes)
+        if obsolete_packs:
+            # TODO: We could add one more condition here. "if o.name not in
+            #       orig_disk_nodes and o != the new_pack we haven't written to
+            #       disk yet. However, the new pack object is not easily
+            #       accessible here (it would have to be passed through the
+            #       autopacking code, etc.)
+            obsolete_packs = [o for o in obsolete_packs
+                              if o.name not in already_obsolete]
+            self._obsolete_packs(obsolete_packs)
         return [new_node[0][0] for new_node in new_nodes]
 
     def reload_pack_names(self):
@@ -1988,8 +2025,12 @@
         if first_read:
             return True
         # out the new value.
-        disk_nodes, _, _ = self._diff_pack_names()
-        self._packs_at_load = disk_nodes
+        (disk_nodes, deleted_nodes, new_nodes,
+         orig_disk_nodes) = self._diff_pack_names()
+        # _packs_at_load is meant to be the explicit list of names in
+        # 'pack-names' at then start. As such, it should not contain any
+        # pending names that haven't been written out yet.
+        self._packs_at_load = orig_disk_nodes
         (removed, added,
          modified) = self._syncronize_pack_names_from_disk_nodes(disk_nodes)
         if removed or added or modified:
@@ -2004,15 +2045,28 @@
             raise
         raise errors.RetryAutopack(self.repo, False, sys.exc_info())
 
-    def _clear_obsolete_packs(self):
+    def _clear_obsolete_packs(self, preserve=None):
         """Delete everything from the obsolete-packs directory.
+
+        :return: A list of pack identifiers (the filename without '.pack') that
+            were found in obsolete_packs.
         """
+        found = []
         obsolete_pack_transport = self.transport.clone('obsolete_packs')
+        if preserve is None:
+            preserve = set()
         for filename in obsolete_pack_transport.list_dir('.'):
+            name, ext = osutils.splitext(filename)
+            if ext == '.pack':
+                found.append(name)
+            if name in preserve:
+                continue
             try:
                 obsolete_pack_transport.delete(filename)
             except (errors.PathError, errors.TransportError), e:
-                warning("couldn't delete obsolete pack, skipping it:\n%s" % (e,))
+                warning("couldn't delete obsolete pack, skipping it:\n%s"
+                        % (e,))
+        return found
 
     def _start_write_group(self):
         # Do not permit preparation for writing if we're not in a 'write lock'.
@@ -2045,24 +2099,21 @@
         # FIXME: just drop the transient index.
         # forget what names there are
         if self._new_pack is not None:
-            try:
-                self._new_pack.abort()
-            finally:
-                # XXX: If we aborted while in the middle of finishing the write
-                # group, _remove_pack_indices can fail because the indexes are
-                # already gone.  If they're not there we shouldn't fail in this
-                # case.  -- mbp 20081113
-                self._remove_pack_indices(self._new_pack)
-                self._new_pack = None
+            operation = cleanup.OperationWithCleanups(self._new_pack.abort)
+            operation.add_cleanup(setattr, self, '_new_pack', None)
+            # If we aborted while in the middle of finishing the write
+            # group, _remove_pack_indices could fail because the indexes are
+            # already gone.  But they're not there we shouldn't fail in this
+            # case, so we pass ignore_missing=True.
+            operation.add_cleanup(self._remove_pack_indices, self._new_pack,
+                ignore_missing=True)
+            operation.run_simple()
         for resumed_pack in self._resumed_packs:
-            try:
-                resumed_pack.abort()
-            finally:
-                # See comment in previous finally block.
-                try:
-                    self._remove_pack_indices(resumed_pack)
-                except KeyError:
-                    pass
+            operation = cleanup.OperationWithCleanups(resumed_pack.abort)
+            # See comment in previous finally block.
+            operation.add_cleanup(self._remove_pack_indices, resumed_pack,
+                ignore_missing=True)
+            operation.run_simple()
         del self._resumed_packs[:]
 
     def _remove_resumed_pack_indices(self):
@@ -2234,16 +2285,10 @@
         self._reconcile_fixes_text_parents = True
         self._reconcile_backsup_inventory = False
 
-    def _warn_if_deprecated(self):
+    def _warn_if_deprecated(self, branch=None):
         # This class isn't deprecated, but one sub-format is
         if isinstance(self._format, RepositoryFormatKnitPack5RichRootBroken):
-            from bzrlib import repository
-            if repository._deprecation_warning_done:
-                return
-            repository._deprecation_warning_done = True
-            warning("Format %s for %s is deprecated - please use"
-                    " 'bzr upgrade --1.6.1-rich-root'"
-                    % (self._format, self.bzrdir.transport.base))
+            super(KnitPackRepository, self)._warn_if_deprecated(branch)
 
     def _abort_write_group(self):
         self.revisions._index._key_dependencies.clear()

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2009-10-12 22:04:23 +0000
+++ bzrlib/repository.py	2010-01-15 07:00:49 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,8 +24,10 @@
     bzrdir,
     check,
     chk_map,
+    config,
     debug,
     errors,
+    fetch as _mod_fetch,
     fifo_cache,
     generate_ids,
     gpg,
@@ -39,6 +41,7 @@
     osutils,
     revision as _mod_revision,
     symbol_versioning,
+    trace,
     tsort,
     ui,
     versionedfile,
@@ -50,7 +53,6 @@
 """)
 
 from bzrlib.decorators import needs_read_lock, needs_write_lock, only_raises
-from bzrlib.lock import _RelockDebugMixin
 from bzrlib.inter import InterObject
 from bzrlib.inventory import (
     Inventory,
@@ -58,6 +60,7 @@
     ROOT_ID,
     entry_factory,
     )
+from bzrlib.lock import _RelockDebugMixin
 from bzrlib import registry
 from bzrlib.trace import (
     log_exception_quietly, note, mutter, mutter_callsite, warning)
@@ -206,7 +209,10 @@
             # an inventory delta was accumulated without creating a new
             # inventory.
             basis_id = self.basis_delta_revision
-            self.inv_sha1 = self.repository.add_inventory_by_delta(
+            # We ignore the 'inventory' returned by add_inventory_by_delta
+            # because self.new_inventory is used to hint to the rest of the
+            # system what code path was taken
+            self.inv_sha1, _ = self.repository.add_inventory_by_delta(
                 basis_id, self._basis_delta, self._new_revision_id,
                 self.parents)
         else:
@@ -1300,16 +1306,14 @@
         self._reconcile_does_inventory_gc = True
         self._reconcile_fixes_text_parents = False
         self._reconcile_backsup_inventory = True
-        # not right yet - should be more semantically clear ?
-        #
-        # TODO: make sure to construct the right store classes, etc, depending
-        # on whether escaping is required.
-        self._warn_if_deprecated()
         self._write_group = None
         # Additional places to query for data.
         self._fallback_repositories = []
         # An InventoryEntry cache, used during deserialization
         self._inventory_entry_cache = fifo_cache.FIFOCache(10*1024)
+        # Is it safe to return inventory entries directly from the entry cache,
+        # rather copying them?
+        self._safe_to_return_from_cache = False
 
     def __repr__(self):
         if self._fallback_repositories:
@@ -1382,6 +1386,7 @@
         locked = self.is_locked()
         result = self.control_files.lock_write(token=token)
         if not locked:
+            self._warn_if_deprecated()
             self._note_lock('w')
             for repo in self._fallback_repositories:
                 # Writes don't affect fallback repos
@@ -1393,6 +1398,7 @@
         locked = self.is_locked()
         self.control_files.lock_read()
         if not locked:
+            self._warn_if_deprecated()
             self._note_lock('r')
             for repo in self._fallback_repositories:
                 repo.lock_read()
@@ -2427,7 +2433,8 @@
         :param xml: A serialised inventory.
         """
         result = self._serializer.read_inventory_from_string(xml, revision_id,
-                    entry_cache=self._inventory_entry_cache)
+                    entry_cache=self._inventory_entry_cache,
+                    return_from_cache=self._safe_to_return_from_cache)
         if result.revision_id != revision_id:
             raise AssertionError('revision id mismatch %s != %s' % (
                 result.revision_id, revision_id))
@@ -2665,8 +2672,8 @@
         for ((revision_id,), parent_keys) in \
                 self.revisions.get_parent_map(query_keys).iteritems():
             if parent_keys:
-                result[revision_id] = tuple(parent_revid
-                    for (parent_revid,) in parent_keys)
+                result[revision_id] = tuple([parent_revid
+                    for (parent_revid,) in parent_keys])
             else:
                 result[revision_id] = (_mod_revision.NULL_REVISION,)
         return result
@@ -2774,13 +2781,22 @@
         result.check(callback_refs)
         return result
 
-    def _warn_if_deprecated(self):
+    def _warn_if_deprecated(self, branch=None):
         global _deprecation_warning_done
         if _deprecation_warning_done:
             return
-        _deprecation_warning_done = True
-        warning("Format %s for %s is deprecated - please use 'bzr upgrade' to get better performance"
-                % (self._format, self.bzrdir.transport.base))
+        try:
+            if branch is None:
+                conf = config.GlobalConfig()
+            else:
+                conf = branch.get_config()
+            if conf.suppress_warning('format_deprecation'):
+                return
+            warning("Format %s for %s is deprecated -"
+                    " please use 'bzr upgrade' to get better performance"
+                    % (self._format, self.bzrdir.transport.base))
+        finally:
+            _deprecation_warning_done = True
 
     def supports_rich_root(self):
         return self._format.rich_root_data
@@ -3090,7 +3106,7 @@
         """
         try:
             transport = a_bzrdir.get_repository_transport(None)
-            format_string = transport.get("format").read()
+            format_string = transport.get_bytes("format")
             return format_registry.get(format_string)
         except errors.NoSuchFile:
             raise errors.NoRepositoryPresent(a_bzrdir)
@@ -3409,8 +3425,7 @@
                    provided a default one will be created.
         :return: None.
         """
-        from bzrlib.fetch import RepoFetcher
-        f = RepoFetcher(to_repository=self.target,
+        f = _mod_fetch.RepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
                                fetch_spec=fetch_spec,
@@ -3816,13 +3831,15 @@
                 basis_id, delta, current_revision_id, parents_parents)
             cache[current_revision_id] = parent_tree
 
-    def _fetch_batch(self, revision_ids, basis_id, cache):
+    def _fetch_batch(self, revision_ids, basis_id, cache, a_graph=None):
         """Fetch across a few revisions.
 
         :param revision_ids: The revisions to copy
         :param basis_id: The revision_id of a tree that must be in cache, used
             as a basis for delta when no other base is available
         :param cache: A cache of RevisionTrees that we can use.
+        :param a_graph: A Graph object to determine the heads() of the
+            rich-root data stream.
         :return: The revision_id of the last converted tree. The RevisionTree
             for it will be in cache
         """
@@ -3835,6 +3852,7 @@
         pending_revisions = []
         parent_map = self.source.get_parent_map(revision_ids)
         self._fetch_parent_invs_for_stacking(parent_map, cache)
+        self.source._safe_to_return_from_cache = True
         for tree in self.source.revision_trees(revision_ids):
             # Find a inventory delta for this revision.
             # Find text entries that need to be copied, too.
@@ -3888,14 +3906,14 @@
             pending_revisions.append(revision)
             cache[current_revision_id] = tree
             basis_id = current_revision_id
+        self.source._safe_to_return_from_cache = False
         # Copy file texts
         from_texts = self.source.texts
         to_texts = self.target.texts
         if root_keys_to_create:
-            from bzrlib.fetch import _new_root_data_stream
-            root_stream = _new_root_data_stream(
+            root_stream = _mod_fetch._new_root_data_stream(
                 root_keys_to_create, self._revision_id_to_root_id, parent_map,
-                self.source)
+                self.source, graph=a_graph)
             to_texts.insert_record_stream(root_stream)
         to_texts.insert_record_stream(from_texts.get_record_stream(
             text_keys, self.target._format._fetch_order,
@@ -3958,14 +3976,22 @@
         cache[basis_id] = basis_tree
         del basis_tree # We don't want to hang on to it here
         hints = []
+        if self._converting_to_rich_root and len(revision_ids) > 100:
+            a_graph = _mod_fetch._get_rich_root_heads_graph(self.source,
+                                                            revision_ids)
+        else:
+            a_graph = None
+
         for offset in range(0, len(revision_ids), batch_size):
             self.target.start_write_group()
             try:
                 pb.update('Transferring revisions', offset,
                           len(revision_ids))
                 batch = revision_ids[offset:offset+batch_size]
-                basis_id = self._fetch_batch(batch, basis_id, cache)
+                basis_id = self._fetch_batch(batch, basis_id, cache,
+                                             a_graph=a_graph)
             except:
+                self.source._safe_to_return_from_cache = False
                 self.target.abort_write_group()
                 raise
             else:
@@ -3983,6 +4009,12 @@
         """See InterRepository.fetch()."""
         if fetch_spec is not None:
             raise AssertionError("Not implemented yet...")
+        # See <https://launchpad.net/bugs/456077> asking for a warning here
+        #
+        # nb this is only active for local-local fetches; other things using
+        # streaming.
+        ui.ui_factory.warn_cross_format_fetch(self.source._format,
+            self.target._format)
         if (not self.source.supports_rich_root()
             and self.target.supports_rich_root()):
             self._converting_to_rich_root = True
@@ -4281,6 +4313,8 @@
                     self._extract_and_insert_inventories(
                         substream, src_serializer)
             elif substream_type == 'inventory-deltas':
+                ui.ui_factory.warn_cross_format_fetch(src_format,
+                    self.target_repo._format)
                 self._extract_and_insert_inventory_deltas(
                     substream, src_serializer)
             elif substream_type == 'chk_bytes':
@@ -4443,8 +4477,7 @@
         fetching the inventory weave.
         """
         if self._rich_root_upgrade():
-            import bzrlib.fetch
-            return bzrlib.fetch.Inter1and2Helper(
+            return _mod_fetch.Inter1and2Helper(
                 self.from_repository).generate_root_texts(revs)
         else:
             return []
@@ -4592,8 +4625,10 @@
 
     def _get_convertable_inventory_stream(self, revision_ids,
                                           delta_versus_null=False):
-        # The source is using CHKs, but the target either doesn't or it has a
-        # different serializer.  The StreamSink code expects to be able to
+        # The two formats are sufficiently different that there is no fast
+        # path, so we need to send just inventorydeltas, which any
+        # sufficiently modern client can insert into any repository.
+        # The StreamSink code expects to be able to
         # convert on the target, so we need to put bytes-on-the-wire that can
         # be converted.  That means inventory deltas (if the remote is <1.19,
         # RemoteStreamSink will fallback to VFS to insert the deltas).

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2009-09-01 12:39:21 +0000
+++ bzrlib/revision.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,8 +54,11 @@
 
     def __init__(self, revision_id, properties=None, **args):
         self.revision_id = revision_id
-        self.properties = properties or {}
-        self._check_properties()
+        if properties is None:
+            self.properties = {}
+        else:
+            self.properties = properties
+            self._check_properties()
         self.committer = None
         self.parent_ids = []
         self.parent_sha1s = []

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2009-07-25 08:26:42 +0000
+++ bzrlib/revisionspec.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -113,8 +113,6 @@
         return RevisionInfo(branch, revno, revision_id)
 
 
-# classes in this list should have a "prefix" attribute, against which
-# string specs are matched
 _revno_regex = None
 
 
@@ -123,10 +121,10 @@
 
     help_txt = """A parsed revision specification.
 
-    A revision specification can be an integer, in which case it is
-    assumed to be a revno (though this will translate negative values
-    into positive ones); or it can be a string, in which case it is
-    parsed for something like 'date:' or 'revid:' etc.
+    A revision specification is a string, which may be unambiguous about
+    what it represents by giving a prefix like 'date:' or 'revid:' etc,
+    or it may have no prefix, in which case it's tried against several
+    specifier types in sequence to determine what the user meant.
 
     Revision specs are an UI element, and they have been moved out
     of the branch class to leave "back-end" classes unaware of such
@@ -139,6 +137,14 @@
 
     prefix = None
     wants_revision_history = True
+    dwim_catchable_exceptions = (errors.InvalidRevisionSpec,)
+    """Exceptions that RevisionSpec_dwim._match_on will catch.
+
+    If the revspec is part of ``dwim_revspecs``, it may be tried with an
+    invalid revspec and raises some exception. The exceptions mentioned here
+    will not be reported to the user but simply ignored without stopping the
+    dwim processing.
+    """
 
     @staticmethod
     def from_string(spec):
@@ -165,17 +171,9 @@
                     trace.mutter('Returning RevisionSpec %s for %s',
                                  spectype.__name__, spec)
                     return spectype(spec, _internal=True)
-            # RevisionSpec_revno is special cased, because it is the only
-            # one that directly handles plain integers
-            # TODO: This should not be special cased rather it should be
-            # a method invocation on spectype.canparse()
-            global _revno_regex
-            if _revno_regex is None:
-                _revno_regex = re.compile(r'^(?:(\d+(\.\d+)*)|-\d+)(:.*)?$')
-            if _revno_regex.match(spec) is not None:
-                return RevisionSpec_revno(spec, _internal=True)
-
-            raise errors.NoSuchRevisionSpec(spec)
+            # Otherwise treat it as a DWIM, build the RevisionSpec object and
+            # wait for _match_on to be called.
+            return RevisionSpec_dwim(spec, _internal=True)
 
     def __init__(self, spec, _internal=False):
         """Create a RevisionSpec referring to the Null revision.
@@ -290,16 +288,62 @@
 
 # private API
 
+class RevisionSpec_dwim(RevisionSpec):
+    """Provides a DWIMish revision specifier lookup.
+
+    Note that this does not go in the revspec_registry because by definition
+    there is no prefix to identify it.  It's solely called from
+    RevisionSpec.from_string() because the DWIMification happen when _match_on
+    is called so the string describing the revision is kept here until needed.
+    """
+
+    help_txt = None
+    # We don't need to build the revision history ourself, that's delegated to
+    # each revspec we try.
+    wants_revision_history = False
+
+    def _try_spectype(self, rstype, branch):
+        rs = rstype(self.spec, _internal=True)
+        # Hit in_history to find out if it exists, or we need to try the
+        # next type.
+        return rs.in_history(branch)
+
+    def _match_on(self, branch, revs):
+        """Run the lookup and see what we can get."""
+
+        # First, see if it's a revno
+        global _revno_regex
+        if _revno_regex is None:
+            _revno_regex = re.compile(r'^(?:(\d+(\.\d+)*)|-\d+)(:.*)?$')
+        if _revno_regex.match(self.spec) is not None:
+            try:
+                return self._try_spectype(RevisionSpec_revno, branch)
+            except RevisionSpec_revno.dwim_catchable_exceptions:
+                pass
+
+        # Next see what has been registered
+        for rs_class in dwim_revspecs:
+            try:
+                return self._try_spectype(rs_class, branch)
+            except rs_class.dwim_catchable_exceptions:
+                pass
+
+        # Well, I dunno what it is. Note that we don't try to keep track of the
+        # first of last exception raised during the DWIM tries as none seems
+        # really relevant.
+        raise errors.InvalidRevisionSpec(self.spec, branch)
+
+
 class RevisionSpec_revno(RevisionSpec):
     """Selects a revision using a number."""
 
     help_txt = """Selects a revision using a number.
 
     Use an integer to specify a revision in the history of the branch.
-    Optionally a branch can be specified. The 'revno:' prefix is optional.
-    A negative number will count from the end of the branch (-1 is the
-    last revision, -2 the previous one). If the negative number is larger
-    than the branch's history, the first revision is returned.
+    Optionally a branch can be specified.  A negative number will count
+    from the end of the branch (-1 is the last revision, -2 the previous
+    one). If the negative number is larger than the branch's history, the
+    first revision is returned.
     Examples::
 
       revno:1                   -> return the first revision of this branch
@@ -561,6 +605,7 @@
     """
 
     prefix = 'tag:'
+    dwim_catchable_exceptions = (errors.NoSuchTag, errors.TagsNotSupported)
 
     def _match_on(self, branch, revs):
         # Can raise tags not supported, NoSuchTag, etc
@@ -760,6 +805,7 @@
       branch:/path/to/branch
     """
     prefix = 'branch:'
+    dwim_catchable_exceptions = (errors.NotBranchError,)
 
     def _match_on(self, branch, revs):
         from bzrlib.branch import Branch
@@ -838,6 +884,17 @@
             self._get_submit_location(context_branch))
 
 
+# The order in which we want to DWIM a revision spec without any prefix.
+# revno is always tried first and isn't listed here, this is used by
+# RevisionSpec_dwim._match_on
+dwim_revspecs = [
+    RevisionSpec_tag, # Let's try for a tag
+    RevisionSpec_revid, # Maybe it's a revid?
+    RevisionSpec_date, # Perhaps a date?
+    RevisionSpec_branch, # OK, last try, maybe it's a branch
+    ]
+
+
 revspec_registry = registry.Registry()
 def _register_revspec(revspec):
     revspec_registry.register(revspec.prefix, revspec)
@@ -852,5 +909,7 @@
 _register_revspec(RevisionSpec_branch)
 _register_revspec(RevisionSpec_submit)
 
+# classes in this list should have a "prefix" attribute, against which
+# string specs are matched
 SPEC_TYPES = symbol_versioning.deprecated_list(
     symbol_versioning.deprecated_in((1, 12, 0)), "SPEC_TYPES", [])

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2009-08-28 05:00:33 +0000
+++ bzrlib/revisiontree.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -103,7 +103,10 @@
 
     def get_file_mtime(self, file_id, path=None):
         ie = self._inventory[file_id]
-        revision = self._repository.get_revision(ie.revision)
+        try:
+            revision = self._repository.get_revision(ie.revision)
+        except errors.NoSuchRevision:
+            raise errors.FileTimestampUnavailable(self.id2path(file_id))
         return revision.timestamp
 
     def is_executable(self, file_id, path=None):

=== modified file 'bzrlib/serializer.py'
--- bzrlib/serializer.py	2009-07-29 17:44:34 +0000
+++ bzrlib/serializer.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -50,7 +50,7 @@
         raise NotImplementedError(self.write_inventory_to_string)
 
     def read_inventory_from_string(self, string, revision_id=None,
-                                   entry_cache=None):
+                                   entry_cache=None, return_from_cache=False):
         """Read string into an inventory object.
 
         :param string: The serialized inventory to read.
@@ -64,6 +64,10 @@
         :param entry_cache: An optional cache of InventoryEntry objects. If
             supplied we will look up entries via (file_id, revision_id) which
             should map to a valid InventoryEntry (File/Directory/etc) object.
+        :param return_from_cache: Return entries directly from the cache,
+            rather than copying them first. This is only safe if the caller
+            promises not to mutate the returned inventory entries, but it can
+            make some operations significantly faster.
         """
         raise NotImplementedError(self.read_inventory_from_string)
 

=== modified file 'bzrlib/shelf_ui.py'
--- bzrlib/shelf_ui.py	2009-09-11 07:55:48 +0000
+++ bzrlib/shelf_ui.py	2010-01-12 22:51:31 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
     errors,
     osutils,
     patches,
+    patiencediff,
     shelf,
     textfile,
     trace,
@@ -35,6 +36,10 @@
 )
 
 
+class UseEditor(Exception):
+    """Use an editor instead of selecting hunks."""
+
+
 class ShelfReporter(object):
 
     vocab = {'add file': 'Shelve adding file "%(path)s"?',
@@ -143,6 +148,9 @@
         if reporter is None:
             reporter = ShelfReporter()
         self.reporter = reporter
+        config = self.work_tree.branch.get_config()
+        self.change_editor = config.get_change_editor(target_tree, work_tree)
+        self.work_tree.lock_tree_write()
 
     @classmethod
     def from_args(klass, diff_writer, revision=None, all=False, file_list=None,
@@ -168,11 +176,10 @@
             target_tree = builtins._get_one_revision_tree('shelf2', revision,
                 tree.branch, tree)
             files = builtins.safe_relpath_files(tree, file_list)
-        except:
+            return klass(tree, target_tree, diff_writer, all, all, files,
+                         message, destroy)
+        finally:
             tree.unlock()
-            raise
-        return klass(tree, target_tree, diff_writer, all, all, files, message,
-                     destroy)
 
     def run(self):
         """Interactively shelve the changes."""
@@ -211,6 +218,12 @@
             shutil.rmtree(self.tempdir)
             creator.finalize()
 
+    def finalize(self):
+        if self.change_editor is not None:
+            self.change_editor.finish()
+        self.work_tree.unlock()
+
+
     def get_parsed_patch(self, file_id, invert=False):
         """Return a parsed version of a file's patch.
 
@@ -239,13 +252,19 @@
         :param message: The message to prompt a user with.
         :return: A character.
         """
+        if not sys.stdin.isatty():
+            # Since there is no controlling terminal we will hang when trying
+            # to prompt the user, better abort now.  See
+            # https://code.launchpad.net/~bialix/bzr/shelve-no-tty/+merge/14905
+            # for more context.
+            raise errors.BzrError("You need a controlling terminal.")
         sys.stdout.write(message)
         char = osutils.getchar()
         sys.stdout.write("\r" + ' ' * len(message) + '\r')
         sys.stdout.flush()
         return char
 
-    def prompt_bool(self, question, long=False):
+    def prompt_bool(self, question, long=False, allow_editor=False):
         """Prompt the user with a yes/no question.
 
         This may be overridden by self.auto.  It may also *set* self.auto.  It
@@ -255,13 +274,20 @@
         """
         if self.auto:
             return True
+        editor_string = ''
         if long:
-            prompt = ' [(y)es, (N)o, (f)inish, or (q)uit]'
+            if allow_editor:
+                editor_string = '(E)dit manually, '
+            prompt = ' [(y)es, (N)o, %s(f)inish, or (q)uit]' % editor_string
         else:
-            prompt = ' [yNfq?]'
+            if allow_editor:
+                editor_string = 'e'
+            prompt = ' [yN%sfq?]' % editor_string
         char = self.prompt(question + prompt)
         if char == 'y':
             return True
+        elif char == 'e' and allow_editor:
+            raise UseEditor
         elif char == 'f':
             self.auto = True
             return True
@@ -273,6 +299,23 @@
             return False
 
     def handle_modify_text(self, creator, file_id):
+        """Handle modified text, by using hunk selection or file editing.
+
+        :param creator: A ShelfCreator.
+        :param file_id: The id of the file that was modified.
+        :return: The number of changes.
+        """
+        work_tree_lines = self.work_tree.get_file_lines(file_id)
+        try:
+            lines, change_count = self._select_hunks(creator, file_id,
+                                                     work_tree_lines)
+        except UseEditor:
+            lines, change_count = self._edit_file(file_id, work_tree_lines)
+        if change_count != 0:
+            creator.shelve_lines(file_id, lines)
+        return change_count
+
+    def _select_hunks(self, creator, file_id, work_tree_lines):
         """Provide diff hunk selection for modified text.
 
         If self.reporter.invert_diff is True, the diff is inverted so that
@@ -280,13 +323,14 @@
 
         :param creator: a ShelfCreator
         :param file_id: The id of the file to shelve.
+        :param work_tree_lines: Line contents of the file in the working tree.
         :return: number of shelved hunks.
         """
         if self.reporter.invert_diff:
-            target_lines = self.work_tree.get_file_lines(file_id)
+            target_lines = work_tree_lines
         else:
             target_lines = self.target_tree.get_file_lines(file_id)
-        textfile.check_text_lines(self.work_tree.get_file_lines(file_id))
+        textfile.check_text_lines(work_tree_lines)
         textfile.check_text_lines(target_lines)
         parsed = self.get_parsed_patch(file_id, self.reporter.invert_diff)
         final_hunks = []
@@ -295,7 +339,9 @@
             self.diff_writer.write(parsed.get_header())
             for hunk in parsed.hunks:
                 self.diff_writer.write(str(hunk))
-                selected = self.prompt_bool(self.reporter.vocab['hunk'])
+                selected = self.prompt_bool(self.reporter.vocab['hunk'],
+                                            allow_editor=(self.change_editor
+                                                          is not None))
                 if not self.reporter.invert_diff:
                     selected = (not selected)
                 if selected:
@@ -304,32 +350,50 @@
                 else:
                     offset -= (hunk.mod_range - hunk.orig_range)
         sys.stdout.flush()
-        if not self.reporter.invert_diff and (
-            len(parsed.hunks) == len(final_hunks)):
-            return 0
-        if self.reporter.invert_diff and len(final_hunks) == 0:
-            return 0
-        patched = patches.iter_patched_from_hunks(target_lines, final_hunks)
-        creator.shelve_lines(file_id, list(patched))
         if self.reporter.invert_diff:
-            return len(final_hunks)
-        return len(parsed.hunks) - len(final_hunks)
+            change_count = len(final_hunks)
+        else:
+            change_count = len(parsed.hunks) - len(final_hunks)
+        patched = patches.iter_patched_from_hunks(target_lines,
+                                                  final_hunks)
+        lines = list(patched)
+        return lines, change_count
+
+    def _edit_file(self, file_id, work_tree_lines):
+        """
+        :param file_id: id of the file to edit.
+        :param work_tree_lines: Line contents of the file in the working tree.
+        :return: (lines, change_region_count), where lines is the new line
+            content of the file, and change_region_count is the number of
+            changed regions.
+        """
+        lines = osutils.split_lines(self.change_editor.edit_file(file_id))
+        return lines, self._count_changed_regions(work_tree_lines, lines)
+
+    @staticmethod
+    def _count_changed_regions(old_lines, new_lines):
+        matcher = patiencediff.PatienceSequenceMatcher(None, old_lines,
+                                                       new_lines)
+        blocks = matcher.get_matching_blocks()
+        return len(blocks) - 2
 
 
 class Unshelver(object):
     """Unshelve changes into a working tree."""
 
     @classmethod
-    def from_args(klass, shelf_id=None, action='apply', directory='.'):
+    def from_args(klass, shelf_id=None, action='apply', directory='.',
+                  write_diff_to=None):
         """Create an unshelver from commandline arguments.
 
-        The returned shelver wil have a tree that is locked and should
+        The returned shelver will have a tree that is locked and should
         be unlocked.
 
         :param shelf_id: Integer id of the shelf, as a string.
         :param action: action to perform.  May be 'apply', 'dry-run',
-            'delete'.
+            'delete', 'preview'.
         :param directory: The directory to unshelve changes into.
+        :param write_diff_to: See Unshelver.__init__().
         """
         tree, path = workingtree.WorkingTree.open_containing(directory)
         tree.lock_tree_write()
@@ -344,24 +408,32 @@
                 shelf_id = manager.last_shelf()
                 if shelf_id is None:
                     raise errors.BzrCommandError('No changes are shelved.')
-                trace.note('Unshelving changes with id "%d".' % shelf_id)
             apply_changes = True
             delete_shelf = True
             read_shelf = True
+            show_diff = False
             if action == 'dry-run':
                 apply_changes = False
                 delete_shelf = False
-            if action == 'delete-only':
+            elif action == 'preview':
+                apply_changes = False
+                delete_shelf = False
+                show_diff = True
+            elif action == 'delete-only':
                 apply_changes = False
                 read_shelf = False
+            elif action == 'keep':
+                apply_changes = True
+                delete_shelf = False
         except:
             tree.unlock()
             raise
         return klass(tree, manager, shelf_id, apply_changes, delete_shelf,
-                     read_shelf)
+                     read_shelf, show_diff, write_diff_to)
 
     def __init__(self, tree, manager, shelf_id, apply_changes=True,
-                 delete_shelf=True, read_shelf=True):
+                 delete_shelf=True, read_shelf=True, show_diff=False,
+                 write_diff_to=None):
         """Constructor.
 
         :param tree: The working tree to unshelve into.
@@ -371,6 +443,11 @@
             working tree.
         :param delete_shelf: If True, delete the changes from the shelf.
         :param read_shelf: If True, read the changes from the shelf.
+        :param show_diff: If True, show the diff that would result from
+            unshelving the changes.
+        :param write_diff_to: A file-like object where the diff will be
+            written to. If None, ui.ui_factory.make_output_stream() will
+            be used.
         """
         self.tree = tree
         manager = tree.get_shelf_manager()
@@ -379,6 +456,8 @@
         self.apply_changes = apply_changes
         self.delete_shelf = delete_shelf
         self.read_shelf = read_shelf
+        self.show_diff = show_diff
+        self.write_diff_to = write_diff_to
 
     def run(self):
         """Perform the unshelving operation."""
@@ -386,6 +465,7 @@
         cleanups = [self.tree.unlock]
         try:
             if self.read_shelf:
+                trace.note('Using changes with id "%d".' % self.shelf_id)
                 unshelver = self.manager.get_unshelver(self.shelf_id)
                 cleanups.append(unshelver.finalize)
                 if unshelver.message is not None:
@@ -397,16 +477,29 @@
                     merger.change_reporter = change_reporter
                     if self.apply_changes:
                         merger.do_merge()
+                    elif self.show_diff:
+                        self.write_diff(merger)
                     else:
                         self.show_changes(merger)
                 finally:
                     task.finished()
             if self.delete_shelf:
                 self.manager.delete_shelf(self.shelf_id)
+                trace.note('Deleted changes with id "%d".' % self.shelf_id)
         finally:
             for cleanup in reversed(cleanups):
                 cleanup()
 
+    def write_diff(self, merger):
+        """Write this operation's diff to self.write_diff_to."""
+        tree_merger = merger.make_merger()
+        tt = tree_merger.make_preview_transform()
+        new_tree = tt.get_preview_tree()
+        if self.write_diff_to is None:
+            self.write_diff_to = ui.ui_factory.make_output_stream()
+        diff.show_diff_trees(merger.this_tree, new_tree, self.write_diff_to)
+        tt.finalize()
+
     def show_changes(self, merger):
         """Show the changes that this operation specifies."""
         tree_merger = merger.make_merger()

=== modified file 'bzrlib/shellcomplete.py'
--- bzrlib/shellcomplete.py	2009-06-15 11:05:33 +0000
+++ bzrlib/shellcomplete.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -47,9 +47,10 @@
 
 def shellcomplete_on_options(options, outfile=None):
     for opt in options:
-        if opt.short_name:
+        short_name = opt.short_name()
+        if short_name:
             outfile.write('"(--%s -%s)"{--%s,-%s}\n'
-                    % (opt.name, opt.short_name(), opt.name, opt.short_name()))
+                    % (opt.name, short_name, opt.name, short_name))
         else:
             outfile.write('--%s\n' % opt.name)
 

=== modified file 'bzrlib/smart/bzrdir.py'
--- bzrlib/smart/bzrdir.py	2009-09-22 00:34:10 +0000
+++ bzrlib/smart/bzrdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -88,8 +88,8 @@
         try:
             self._bzrdir = BzrDir.open_from_transport(
                 self.transport_from_client_path(path))
-        except errors.NotBranchError:
-            return FailedSmartServerResponse(('nobranch', ))
+        except errors.NotBranchError, e:
+            return FailedSmartServerResponse(('nobranch',))
         return self.do_bzrdir_request(*args)
 
     def _boolean_to_yes_no(self, a_boolean):
@@ -465,8 +465,8 @@
                 return SuccessfulSmartServerResponse(('ok', ''))
             else:
                 return SuccessfulSmartServerResponse(('ok', reference_url))
-        except errors.NotBranchError:
-            return FailedSmartServerResponse(('nobranch', ))
+        except errors.NotBranchError, e:
+            return FailedSmartServerResponse(('nobranch',))
 
 
 class SmartServerRequestOpenBranchV2(SmartServerRequestBzrDir):
@@ -481,5 +481,39 @@
                 return SuccessfulSmartServerResponse(('branch', format))
             else:
                 return SuccessfulSmartServerResponse(('ref', reference_url))
-        except errors.NotBranchError:
-            return FailedSmartServerResponse(('nobranch', ))
+        except errors.NotBranchError, e:
+            return FailedSmartServerResponse(('nobranch',))
+
+
+class SmartServerRequestOpenBranchV3(SmartServerRequestBzrDir):
+
+    def do_bzrdir_request(self):
+        """Open a branch at path and return the reference or format.
+        
+        This version introduced in 2.1.
+
+        Differences to SmartServerRequestOpenBranchV2:
+          * can return 2-element ('nobranch', extra), where 'extra' is a string
+            with an explanation like 'location is a repository'.  Previously
+            a 'nobranch' response would never have more than one element.
+        """
+        try:
+            reference_url = self._bzrdir.get_branch_reference()
+            if reference_url is None:
+                br = self._bzrdir.open_branch(ignore_fallbacks=True)
+                format = br._format.network_name()
+                return SuccessfulSmartServerResponse(('branch', format))
+            else:
+                return SuccessfulSmartServerResponse(('ref', reference_url))
+        except errors.NotBranchError, e:
+            # Stringify the exception so that its .detail attribute will be
+            # filled out.
+            str(e)
+            resp = ('nobranch',)
+            detail = e.detail
+            if detail:
+                if detail.startswith(': '):
+                    detail = detail[2:]
+                resp += (detail,)
+            return FailedSmartServerResponse(resp)
+

=== modified file 'bzrlib/smart/client.py'
--- bzrlib/smart/client.py	2009-03-23 14:59:43 +0000
+++ bzrlib/smart/client.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,6 +36,9 @@
         else:
             self._headers = dict(headers)
 
+    def __repr__(self):
+        return '%s(%r)' % (self.__class__.__name__, self._medium)
+
     def _send_request(self, protocol_version, method, args, body=None,
                       readv_body=None, body_stream=None):
         encoder, response_handler = self._construct_protocol(

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2009-09-01 07:47:36 +0000
+++ bzrlib/smart/medium.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,7 +33,9 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import atexit
+import thread
 import weakref
+
 from bzrlib import (
     debug,
     errors,
@@ -295,7 +297,13 @@
         self.finished = True
 
     def _write_out(self, bytes):
+        tstart = osutils.timer_func()
         osutils.send_all(self.socket, bytes, self._report_activity)
+        if 'hpss' in debug.debug_flags:
+            thread_id = thread.get_ident()
+            trace.mutter('%12s: [%s] %d bytes to the socket in %.3fs'
+                         % ('wrote', thread_id, len(bytes),
+                            osutils.timer_func() - tstart))
 
 
 class SmartServerPipeStreamMedium(SmartServerStreamMedium):
@@ -741,6 +749,9 @@
         self._password = password
         self._port = port
         self._username = username
+        # for the benefit of progress making a short description of this
+        # transport
+        self._scheme = 'bzr+ssh'
         # SmartClientStreamMedium stores the repr of this object in its
         # _DebugCounter so we have to store all the values used in our repr
         # method before calling the super init.
@@ -750,17 +761,18 @@
         self._vendor = vendor
         self._write_to = None
         self._bzr_remote_path = bzr_remote_path
-        # for the benefit of progress making a short description of this
-        # transport
-        self._scheme = 'bzr+ssh'
 
     def __repr__(self):
-        return "%s(connected=%r, username=%r, host=%r, port=%r)" % (
+        if self._port is None:
+            maybe_port = ''
+        else:
+            maybe_port = ':%s' % self._port
+        return "%s(%s://%s@%s%s/)" % (
             self.__class__.__name__,
-            self._connected,
+            self._scheme,
             self._username,
             self._host,
-            self._port)
+            maybe_port)
 
     def _accept_bytes(self, bytes):
         """See SmartClientStreamMedium.accept_bytes."""

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2009-10-21 06:05:49 +0000
+++ bzrlib/smart/protocol.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,11 +22,16 @@
 from cStringIO import StringIO
 import struct
 import sys
+import thread
+import threading
 import time
 
 import bzrlib
-from bzrlib import debug
-from bzrlib import errors
+from bzrlib import (
+    debug,
+    errors,
+    osutils,
+    )
 from bzrlib.smart import message, request
 from bzrlib.trace import log_exception_quietly, mutter
 from bzrlib.bencode import bdecode_as_tuple, bencode
@@ -615,7 +620,7 @@
             mutter('hpss call:   %s', repr(args)[1:-1])
             if getattr(self._request._medium, 'base', None) is not None:
                 mutter('             (to %s)', self._request._medium.base)
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_args(args)
         self._request.finished_writing()
         self._last_verb = args[0]
@@ -630,7 +635,7 @@
             if getattr(self._request._medium, '_path', None) is not None:
                 mutter('                  (to %s)', self._request._medium._path)
             mutter('              %d bytes', len(body))
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
             if 'hpssdetail' in debug.debug_flags:
                 mutter('hpss body content: %s', body)
         self._write_args(args)
@@ -649,7 +654,7 @@
             mutter('hpss call w/readv: %s', repr(args)[1:-1])
             if getattr(self._request._medium, '_path', None) is not None:
                 mutter('                  (to %s)', self._request._medium._path)
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_args(args)
         readv_bytes = self._serialise_offsets(body)
         bytes = self._encode_bulk_data(readv_bytes)
@@ -681,7 +686,7 @@
         if 'hpss' in debug.debug_flags:
             if self._request_start_time is not None:
                 mutter('   result:   %6.3fs  %s',
-                       time.time() - self._request_start_time,
+                       osutils.timer_func() - self._request_start_time,
                        repr(result)[1:-1])
                 self._request_start_time = None
             else:
@@ -1062,20 +1067,32 @@
 class _ProtocolThreeEncoder(object):
 
     response_marker = request_marker = MESSAGE_VERSION_THREE
+    BUFFER_SIZE = 1024*1024 # 1 MiB buffer before flushing
 
     def __init__(self, write_func):
         self._buf = []
+        self._buf_len = 0
         self._real_write_func = write_func
 
     def _write_func(self, bytes):
+        # TODO: It is probably more appropriate to use sum(map(len, _buf))
+        #       for total number of bytes to write, rather than buffer based on
+        #       the number of write() calls
+        # TODO: Another possibility would be to turn this into an async model.
+        #       Where we let another thread know that we have some bytes if
+        #       they want it, but we don't actually block for it
+        #       Note that osutils.send_all always sends 64kB chunks anyway, so
+        #       we might just push out smaller bits at a time?
         self._buf.append(bytes)
-        if len(self._buf) > 100:
+        self._buf_len += len(bytes)
+        if self._buf_len > self.BUFFER_SIZE:
             self.flush()
 
     def flush(self):
         if self._buf:
             self._real_write_func(''.join(self._buf))
             del self._buf[:]
+            self._buf_len = 0
 
     def _serialise_offsets(self, offsets):
         """Serialise a readv offset list."""
@@ -1130,6 +1147,25 @@
         _ProtocolThreeEncoder.__init__(self, write_func)
         self.response_sent = False
         self._headers = {'Software version': bzrlib.__version__}
+        if 'hpss' in debug.debug_flags:
+            self._thread_id = thread.get_ident()
+            self._response_start_time = None
+
+    def _trace(self, action, message, extra_bytes=None, include_time=False):
+        if self._response_start_time is None:
+            self._response_start_time = osutils.timer_func()
+        if include_time:
+            t = '%5.3fs ' % (time.clock() - self._response_start_time)
+        else:
+            t = ''
+        if extra_bytes is None:
+            extra = ''
+        else:
+            extra = ' ' + repr(extra_bytes[:40])
+            if len(extra) > 33:
+                extra = extra[:29] + extra[-1] + '...'
+        mutter('%12s: [%s] %s%s%s'
+               % (action, self._thread_id, t, message, extra))
 
     def send_error(self, exception):
         if self.response_sent:
@@ -1141,6 +1177,8 @@
                 ('UnknownMethod', exception.verb))
             self.send_response(failure)
             return
+        if 'hpss' in debug.debug_flags:
+            self._trace('error', str(exception))
         self.response_sent = True
         self._write_protocol_version()
         self._write_headers(self._headers)
@@ -1160,11 +1198,19 @@
             self._write_success_status()
         else:
             self._write_error_status()
+        if 'hpss' in debug.debug_flags:
+            self._trace('response', repr(response.args))
         self._write_structure(response.args)
         if response.body is not None:
             self._write_prefixed_body(response.body)
+            if 'hpss' in debug.debug_flags:
+                self._trace('body', '%d bytes' % (len(response.body),),
+                            response.body, include_time=True)
         elif response.body_stream is not None:
+            count = num_bytes = 0
+            first_chunk = None
             for exc_info, chunk in _iter_with_errors(response.body_stream):
+                count += 1
                 if exc_info is not None:
                     self._write_error_status()
                     error_struct = request._translate_error(exc_info[1])
@@ -1175,8 +1221,23 @@
                         self._write_error_status()
                         self._write_structure(chunk.args)
                         break
+                    num_bytes += len(chunk)
+                    if first_chunk is None:
+                        first_chunk = chunk
                     self._write_prefixed_body(chunk)
+                    if 'hpssdetail' in debug.debug_flags:
+                        # Not worth timing separately, as _write_func is
+                        # actually buffered
+                        self._trace('body chunk',
+                                    '%d bytes' % (len(chunk),),
+                                    chunk, suppress_time=True)
+            if 'hpss' in debug.debug_flags:
+                self._trace('body stream',
+                            '%d bytes %d chunks' % (num_bytes, count),
+                            first_chunk)
         self._write_end()
+        if 'hpss' in debug.debug_flags:
+            self._trace('response end', '', include_time=True)
 
 
 def _iter_with_errors(iterable):
@@ -1234,7 +1295,7 @@
             base = getattr(self._medium_request._medium, 'base', None)
             if base is not None:
                 mutter('             (to %s)', base)
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_protocol_version()
         self._write_headers(self._headers)
         self._write_structure(args)
@@ -1252,7 +1313,7 @@
             if path is not None:
                 mutter('                  (to %s)', path)
             mutter('              %d bytes', len(body))
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_protocol_version()
         self._write_headers(self._headers)
         self._write_structure(args)
@@ -1271,7 +1332,7 @@
             path = getattr(self._medium_request._medium, '_path', None)
             if path is not None:
                 mutter('                  (to %s)', path)
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_protocol_version()
         self._write_headers(self._headers)
         self._write_structure(args)
@@ -1288,7 +1349,7 @@
             path = getattr(self._medium_request._medium, '_path', None)
             if path is not None:
                 mutter('                  (to %s)', path)
-            self._request_start_time = time.time()
+            self._request_start_time = osutils.timer_func()
         self._write_protocol_version()
         self._write_headers(self._headers)
         self._write_structure(args)

=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2009-09-03 00:33:35 +0000
+++ bzrlib/smart/repository.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,6 +30,7 @@
     graph,
     osutils,
     pack,
+    ui,
     versionedfile,
     )
 from bzrlib.bzrdir import BzrDir
@@ -502,6 +503,13 @@
     yield pack_writer.begin()
     yield pack_writer.bytes_record(src_format.network_name(), '')
     for substream_type, substream in stream:
+        if substream_type == 'inventory-deltas':
+            # This doesn't feel like the ideal place to issue this warning;
+            # however we don't want to do it in the Repository that's
+            # generating the stream, because that might be on the server.
+            # Instead we try to observe it as the stream goes by.
+            ui.ui_factory.warn_cross_format_fetch(src_format,
+                '(remote)')
         for record in substream:
             if record.storage_kind in ('chunked', 'fulltext'):
                 serialised = record_to_fulltext_bytes(record)

=== modified file 'bzrlib/smart/request.py'
--- bzrlib/smart/request.py	2009-10-22 06:53:08 +0000
+++ bzrlib/smart/request.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -32,11 +32,14 @@
 
 
 import tempfile
+import thread
 import threading
 
 from bzrlib import (
     bzrdir,
+    debug,
     errors,
+    osutils,
     registry,
     revision,
     trace,
@@ -188,7 +191,7 @@
             relpath = urlutils.joinpath('/', path)
             if not relpath.startswith('/'):
                 raise ValueError(relpath)
-            return '.' + relpath
+            return urlutils.escape('.' + relpath)
         else:
             raise errors.PathNotChild(client_path, self._root_client_path)
 
@@ -287,6 +290,27 @@
         self.response = None
         self.finished_reading = False
         self._command = None
+        if 'hpss' in debug.debug_flags:
+            self._request_start_time = osutils.timer_func()
+            self._thread_id = thread.get_ident()
+
+    def _trace(self, action, message, extra_bytes=None, include_time=False):
+        # It is a bit of a shame that this functionality overlaps with that of 
+        # ProtocolThreeRequester._trace. However, there is enough difference
+        # that just putting it in a helper doesn't help a lot. And some state
+        # is taken from the instance.
+        if include_time:
+            t = '%5.3fs ' % (osutils.timer_func() - self._request_start_time)
+        else:
+            t = ''
+        if extra_bytes is None:
+            extra = ''
+        else:
+            extra = ' ' + repr(extra_bytes[:40])
+            if len(extra) > 33:
+                extra = extra[:29] + extra[-1] + '...'
+        trace.mutter('%12s: [%s] %s%s%s'
+                     % (action, self._thread_id, t, message, extra))
 
     def accept_body(self, bytes):
         """Accept body data."""
@@ -294,12 +318,17 @@
             # no active command object, so ignore the event.
             return
         self._run_handler_code(self._command.do_chunk, (bytes,), {})
+        if 'hpss' in debug.debug_flags:
+            self._trace('accept body',
+                        '%d bytes' % (len(bytes),), bytes)
 
     def end_of_body(self):
         """No more body data will be received."""
         self._run_handler_code(self._command.do_end, (), {})
         # cannot read after this.
         self.finished_reading = True
+        if 'hpss' in debug.debug_flags:
+            self._trace('end of body', '', include_time=True)
 
     def _run_handler_code(self, callable, args, kwargs):
         """Run some handler specific code 'callable'.
@@ -334,7 +363,8 @@
 
     def headers_received(self, headers):
         # Just a no-op at the moment.
-        pass
+        if 'hpss' in debug.debug_flags:
+            self._trace('headers', repr(headers))
 
     def args_received(self, args):
         cmd = args[0]
@@ -342,7 +372,18 @@
         try:
             command = self._commands.get(cmd)
         except LookupError:
+            if 'hpss' in debug.debug_flags:
+                self._trace('hpss unknown request', 
+                            cmd, repr(args)[1:-1])
             raise errors.UnknownSmartMethod(cmd)
+        if 'hpss' in debug.debug_flags:
+            from bzrlib.smart import vfs
+            if issubclass(command, vfs.VfsRequest):
+                action = 'hpss vfs req'
+            else:
+                action = 'hpss request'
+            self._trace(action, 
+                        '%s %s' % (cmd, repr(args)[1:-1]))
         self._command = command(
             self._backing_transport, self._root_client_path, self._jail_root)
         self._run_handler_code(self._command.execute, args, {})
@@ -352,6 +393,8 @@
             # no active command object, so ignore the event.
             return
         self._run_handler_code(self._command.do_end, (), {})
+        if 'hpss' in debug.debug_flags:
+            self._trace('end', '', include_time=True)
 
     def post_body_error_received(self, error_args):
         # Just a no-op at the moment.
@@ -518,6 +561,9 @@
     'BzrDir.open_branchV2', 'bzrlib.smart.bzrdir',
     'SmartServerRequestOpenBranchV2')
 request_handlers.register_lazy(
+    'BzrDir.open_branchV3', 'bzrlib.smart.bzrdir',
+    'SmartServerRequestOpenBranchV3')
+request_handlers.register_lazy(
     'delete', 'bzrlib.smart.vfs', 'DeleteRequest')
 request_handlers.register_lazy(
     'get', 'bzrlib.smart.vfs', 'GetRequest')

=== modified file 'bzrlib/smart/server.py'
--- bzrlib/smart/server.py	2009-09-23 06:54:14 +0000
+++ bzrlib/smart/server.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -251,7 +251,7 @@
         """Get a backing transport from a server we are decorating."""
         return transport.get_transport(backing_transport_server.get_url())
 
-    def setUp(self, backing_transport_server=None,
+    def start_server(self, backing_transport_server=None,
               client_path_extra='/extra/'):
         """Set up server for testing.
 
@@ -273,15 +273,15 @@
             backing_transport_server = LocalURLServer()
         self.chroot_server = ChrootServer(
             self.get_backing_transport(backing_transport_server))
-        self.chroot_server.setUp()
+        self.chroot_server.start_server()
         self.backing_transport = transport.get_transport(
             self.chroot_server.get_url())
         self.root_client_path = self.client_path_extra = client_path_extra
         self.start_background_thread(self.thread_name_suffix)
 
-    def tearDown(self):
+    def stop_server(self):
         self.stop_background_thread()
-        self.chroot_server.tearDown()
+        self.chroot_server.stop_server()
 
     def get_url(self):
         url = super(SmartTCPServer_for_testing, self).get_url()
@@ -386,15 +386,15 @@
         """Chroot transport, and decorate with userdir expander."""
         self.base_path = self.get_base_path(transport)
         chroot_server = chroot.ChrootServer(transport)
-        chroot_server.setUp()
-        self.cleanups.append(chroot_server.tearDown)
+        chroot_server.start_server()
+        self.cleanups.append(chroot_server.stop_server)
         transport = get_transport(chroot_server.get_url())
         if self.base_path is not None:
             # Decorate the server's backing transport with a filter that can
             # expand homedirs.
             expand_userdirs = self._make_expand_userdirs_filter(transport)
-            expand_userdirs.setUp()
-            self.cleanups.append(expand_userdirs.tearDown)
+            expand_userdirs.start_server()
+            self.cleanups.append(expand_userdirs.stop_server)
             transport = get_transport(expand_userdirs.get_url())
         self.transport = transport
 

=== modified file 'bzrlib/smart/vfs.py'
--- bzrlib/smart/vfs.py	2009-03-23 14:59:43 +0000
+++ bzrlib/smart/vfs.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
 import os
 
 from bzrlib import errors
+from bzrlib import urlutils
 from bzrlib.smart import request
 
 
@@ -59,6 +60,14 @@
         if not vfs_enabled():
             raise errors.DisabledMethod(self.__class__.__name__)
 
+    def translate_client_path(self, relpath):
+        # VFS requests are made with escaped paths so the escaping done in
+        # SmartServerRequest.translate_client_path leads to double escaping.
+        # Remove it here -- the fact that the result is still escaped means
+        # that the str() will not fail on valid input.
+        x = request.SmartServerRequest.translate_client_path(self, relpath)
+        return str(urlutils.unescape(x))
+
 
 class HasRequest(VfsRequest):
 

=== modified file 'bzrlib/static_tuple.py'
--- bzrlib/static_tuple.py	2009-10-12 20:02:27 +0000
+++ bzrlib/static_tuple.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,6 +16,8 @@
 
 """Interface thunk for a StaticTuple implementation."""
 
+from bzrlib import debug
+
 try:
     from bzrlib._static_tuple_c import StaticTuple
 except ImportError, e:
@@ -23,3 +25,32 @@
     osutils.failed_to_load_extension(e)
     from bzrlib._static_tuple_py import StaticTuple
 
+
+def expect_static_tuple(obj):
+    """Check if the passed object is a StaticTuple.
+
+    Cast it if necessary, but if the 'static_tuple' debug flag is set, raise an
+    error instead.
+
+    As apis are improved, we will probably eventually stop calling this as it
+    adds overhead we shouldn't need.
+    """
+    if 'static_tuple' not in debug.debug_flags:
+        return StaticTuple.from_sequence(obj)
+    if type(obj) is not StaticTuple:
+        raise TypeError('We expected a StaticTuple not a %s' % (type(obj),))
+    return obj
+
+
+def as_tuples(obj):
+    """Ensure that the object and any referenced objects are plain tuples.
+
+    :param obj: a list, tuple or StaticTuple
+    :return: a plain tuple instance, with all children also being tuples.
+    """
+    result = []
+    for item in obj:
+        if isinstance(item, (tuple, list, StaticTuple)):
+            item = as_tuples(item)
+        result.append(item)
+    return tuple(result)

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2009-08-06 05:07:12 +0000
+++ bzrlib/status.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -197,8 +197,10 @@
     if len(parents) < 2:
         return
 
-    # we need one extra space for terminals that wrap on last char
-    term_width = osutils.terminal_width() - 1
+    term_width = osutils.terminal_width()
+    if term_width is not None:
+        # we need one extra space for terminals that wrap on last char
+        term_width = term_width - 1
     if short:
         first_prefix = 'P   '
         sub_prefix = 'P.   '
@@ -206,6 +208,14 @@
         first_prefix = '  '
         sub_prefix = '    '
 
+    def show_log_message(rev, prefix):
+        if term_width is None:
+            width = term_width
+        else:
+            width = term_width - len(prefix)
+        log_message = log_formatter.log_string(None, rev, width, prefix=prefix)
+        to_file.write(log_message + '\n')
+
     pending = parents[1:]
     branch = new.branch
     last_revision = parents[0]
@@ -213,7 +223,8 @@
         if verbose:
             to_file.write('pending merges:\n')
         else:
-            to_file.write('pending merge tips: (use -v to see all merge revisions)\n')
+            to_file.write('pending merge tips:'
+                          ' (use -v to see all merge revisions)\n')
     graph = branch.repository.get_graph()
     other_revisions = [last_revision]
     log_formatter = log.LineLogFormatter(to_file)
@@ -227,9 +238,7 @@
             continue
 
         # Log the merge, as it gets a slightly different formatting
-        log_message = log_formatter.log_string(None, rev,
-                        term_width - len(first_prefix))
-        to_file.write(first_prefix + log_message + '\n')
+        show_log_message(rev, first_prefix)
         if not verbose:
             continue
 
@@ -267,10 +276,7 @@
             if rev is None:
                 to_file.write(sub_prefix + '(ghost) ' + sub_merge + '\n')
                 continue
-            log_message = log_formatter.log_string(None,
-                            revisions[sub_merge],
-                            term_width - len(sub_prefix))
-            to_file.write(sub_prefix + log_message + '\n')
+            show_log_message(revisions[sub_merge], sub_prefix)
 
 
 def _filter_nonexistent(orig_paths, old_tree, new_tree):

=== modified file 'bzrlib/switch.py'
--- bzrlib/switch.py	2009-06-19 21:16:31 +0000
+++ bzrlib/switch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd.
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,12 +22,13 @@
 from bzrlib.trace import note
 
 
-def switch(control_dir, to_branch, force=False, quiet=False):
+def switch(control_dir, to_branch, force=False, quiet=False, revision_id=None):
     """Switch the branch associated with a checkout.
 
     :param control_dir: BzrDir of the checkout to change
     :param to_branch: branch that the checkout is to reference
     :param force: skip the check for local commits in a heavy checkout
+    :param revision_id: revision ID to switch to.
     """
     _check_pending_merges(control_dir, force)
     try:
@@ -36,7 +37,7 @@
         source_repository = to_branch.repository
     _set_branch_location(control_dir, to_branch, force)
     tree = control_dir.open_workingtree()
-    _update(tree, source_repository, quiet)
+    _update(tree, source_repository, quiet, revision_id)
 
 
 def _check_pending_merges(control, force=False):
@@ -118,7 +119,7 @@
     return False
 
 
-def _update(tree, source_repository, quiet=False):
+def _update(tree, source_repository, quiet=False, revision_id=None):
     """Update a working tree to the latest revision of its branch.
 
     :param tree: the working tree
@@ -127,12 +128,14 @@
     tree.lock_tree_write()
     try:
         to_branch = tree.branch
-        if tree.last_revision() == to_branch.last_revision():
+        if revision_id is None:
+            revision_id = to_branch.last_revision()
+        if tree.last_revision() == revision_id:
             if not quiet:
                 note("Tree is up to date at revision %d.", to_branch.revno())
             return
         base_tree = source_repository.revision_tree(tree.last_revision())
-        merge.Merge3Merger(tree, tree, base_tree, to_branch.basis_tree())
+        merge.Merge3Merger(tree, tree, base_tree, to_branch.repository.revision_tree(revision_id))
         tree.set_last_revision(to_branch.last_revision())
         if not quiet:
             note('Updated to revision %d.' % to_branch.revno())

=== modified file 'bzrlib/tests/TestUtil.py'
--- bzrlib/tests/TestUtil.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/TestUtil.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #       Author: Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -72,6 +72,18 @@
         visitor.visitSuite(self)
         visitTests(self, visitor)
 
+    def run(self, result):
+        """Run the tests in the suite, discarding references after running."""
+        tests = list(self)
+        tests.reverse()
+        self._tests = []
+        while tests:
+            if result.shouldStop:
+                self._tests = reversed(tests)
+                break
+            tests.pop().run(result)
+        return result
+
 
 class TestLoader(unittest.TestLoader):
     """Custom TestLoader to extend the stock python one."""

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2009-10-19 10:59:16 +0000
+++ bzrlib/tests/__init__.py	2010-02-16 16:08:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -46,13 +46,22 @@
 import tempfile
 import threading
 import time
+import traceback
 import unittest
 import warnings
 
+import testtools
+# nb: check this before importing anything else from within it
+_testtools_version = getattr(testtools, '__version__', ())
+if _testtools_version < (0, 9, 2):
+    raise ImportError("need at least testtools 0.9.2: %s is %r"
+        % (testtools.__file__, _testtools_version))
+from testtools import content
 
 from bzrlib import (
     branchbuilder,
     bzrdir,
+    chk_map,
     config,
     debug,
     errors,
@@ -87,6 +96,7 @@
 from bzrlib.symbol_versioning import (
     DEPRECATED_PARAMETER,
     deprecated_function,
+    deprecated_in,
     deprecated_method,
     deprecated_passed,
     )
@@ -227,8 +237,13 @@
                 '%d non-main threads were left active in the end.\n'
                 % (TestCase._active_threads - 1))
 
-    def _extractBenchmarkTime(self, testCase):
+    def getDescription(self, test):
+        return test.id()
+
+    def _extractBenchmarkTime(self, testCase, details=None):
         """Add a benchmark time for the current test case."""
+        if details and 'benchtime' in details:
+            return float(''.join(details['benchtime'].iter_bytes()))
         return getattr(testCase, "_benchtime", None)
 
     def _elapsedTestTimeString(self):
@@ -268,7 +283,7 @@
         else:
             bzr_path = sys.executable
         self.stream.write(
-            'testing: %s\n' % (bzr_path,))
+            'bzr selftest: %s\n' % (bzr_path,))
         self.stream.write(
             '   %s\n' % (
                     bzrlib.__path__[0],))
@@ -297,19 +312,13 @@
         Called from the TestCase run() method when the test
         fails with an unexpected error.
         """
-        self._testConcluded(test)
-        if isinstance(err[1], TestNotApplicable):
-            return self._addNotApplicable(test, err)
-        elif isinstance(err[1], UnavailableFeature):
-            return self.addNotSupported(test, err[1].args[0])
-        else:
-            self._post_mortem()
-            unittest.TestResult.addError(self, test, err)
-            self.error_count += 1
-            self.report_error(test, err)
-            if self.stop_early:
-                self.stop()
-            self._cleanupLogFile(test)
+        self._post_mortem()
+        unittest.TestResult.addError(self, test, err)
+        self.error_count += 1
+        self.report_error(test, err)
+        if self.stop_early:
+            self.stop()
+        self._cleanupLogFile(test)
 
     def addFailure(self, test, err):
         """Tell result that test failed.
@@ -317,26 +326,21 @@
         Called from the TestCase run() method when the test
         fails because e.g. an assert() method failed.
         """
-        self._testConcluded(test)
-        if isinstance(err[1], KnownFailure):
-            return self._addKnownFailure(test, err)
-        else:
-            self._post_mortem()
-            unittest.TestResult.addFailure(self, test, err)
-            self.failure_count += 1
-            self.report_failure(test, err)
-            if self.stop_early:
-                self.stop()
-            self._cleanupLogFile(test)
+        self._post_mortem()
+        unittest.TestResult.addFailure(self, test, err)
+        self.failure_count += 1
+        self.report_failure(test, err)
+        if self.stop_early:
+            self.stop()
+        self._cleanupLogFile(test)
 
-    def addSuccess(self, test):
+    def addSuccess(self, test, details=None):
         """Tell result that test completed successfully.
 
         Called from the TestCase run()
         """
-        self._testConcluded(test)
         if self._bench_history is not None:
-            benchmark_time = self._extractBenchmarkTime(test)
+            benchmark_time = self._extractBenchmarkTime(test, details)
             if benchmark_time is not None:
                 self._bench_history.write("%s %s\n" % (
                     self._formatTime(benchmark_time),
@@ -346,14 +350,7 @@
         unittest.TestResult.addSuccess(self, test)
         test._log_contents = ''
 
-    def _testConcluded(self, test):
-        """Common code when a test has finished.
-
-        Called regardless of whether it succeded, failed, etc.
-        """
-        pass
-
-    def _addKnownFailure(self, test, err):
+    def addExpectedFailure(self, test, err):
         self.known_failure_count += 1
         self.report_known_failure(test, err)
 
@@ -361,11 +358,11 @@
         """The test will not be run because of a missing feature.
         """
         # this can be called in two different ways: it may be that the
-        # test started running, and then raised (through addError)
+        # test started running, and then raised (through requireFeature)
         # UnavailableFeature.  Alternatively this method can be called
-        # while probing for features before running the tests; in that
-        # case we will see startTest and stopTest, but the test will never
-        # actually run.
+        # while probing for features before running the test code proper; in
+        # that case we will see startTest and stopTest, but the test will
+        # never actually run.
         self.unsupported.setdefault(str(feature), 0)
         self.unsupported[str(feature)] += 1
         self.report_unsupported(test, feature)
@@ -375,41 +372,9 @@
         self.skip_count += 1
         self.report_skip(test, reason)
 
-    def _addNotApplicable(self, test, skip_excinfo):
-        if isinstance(skip_excinfo[1], TestNotApplicable):
-            self.not_applicable_count += 1
-            self.report_not_applicable(test, skip_excinfo)
-        try:
-            test.tearDown()
-        except KeyboardInterrupt:
-            raise
-        except:
-            self.addError(test, test.exc_info())
-        else:
-            # seems best to treat this as success from point-of-view of unittest
-            # -- it actually does nothing so it barely matters :)
-            unittest.TestResult.addSuccess(self, test)
-            test._log_contents = ''
-
-    def printErrorList(self, flavour, errors):
-        for test, err in errors:
-            self.stream.writeln(self.separator1)
-            self.stream.write("%s: " % flavour)
-            self.stream.writeln(self.getDescription(test))
-            if getattr(test, '_get_log', None) is not None:
-                log_contents = test._get_log()
-                if log_contents:
-                    self.stream.write('\n')
-                    self.stream.write(
-                            ('vvvv[log from %s]' % test.id()).ljust(78,'-'))
-                    self.stream.write('\n')
-                    self.stream.write(log_contents)
-                    self.stream.write('\n')
-                    self.stream.write(
-                            ('^^^^[log from %s]' % test.id()).ljust(78,'-'))
-                    self.stream.write('\n')
-            self.stream.writeln(self.separator2)
-            self.stream.writeln("%s" % err)
+    def addNotApplicable(self, test, reason):
+        self.not_applicable_count += 1
+        self.report_not_applicable(test, reason)
 
     def _post_mortem(self):
         """Start a PDB post mortem session."""
@@ -496,10 +461,9 @@
             a += '%dm%ds' % (runtime / 60, runtime % 60)
         else:
             a += '%ds' % runtime
-        if self.error_count:
-            a += ', %d err' % self.error_count
-        if self.failure_count:
-            a += ', %d fail' % self.failure_count
+        total_fail_count = self.error_count + self.failure_count
+        if total_fail_count:
+            a += ', %d failed' % total_fail_count
         # if self.unsupported:
         #     a += ', %d missing' % len(self.unsupported)
         a += ']'
@@ -528,13 +492,12 @@
             ))
 
     def report_known_failure(self, test, err):
-        ui.ui_factory.note('XFAIL: %s\n%s\n' % (
-            self._test_description(test), err[1]))
+        pass
 
     def report_skip(self, test, reason):
         pass
 
-    def report_not_applicable(self, test, skip_excinfo):
+    def report_not_applicable(self, test, reason):
         pass
 
     def report_unsupported(self, test, feature):
@@ -562,11 +525,15 @@
     def report_test_start(self, test):
         self.count += 1
         name = self._shortened_test_description(test)
-        # width needs space for 6 char status, plus 1 for slash, plus an
-        # 11-char time string, plus a trailing blank
-        # when NUMBERED_DIRS: plus 5 chars on test number, plus 1 char on space
-        self.stream.write(self._ellipsize_to_right(name,
-                          osutils.terminal_width()-18))
+        width = osutils.terminal_width()
+        if width is not None:
+            # width needs space for 6 char status, plus 1 for slash, plus an
+            # 11-char time string, plus a trailing blank
+            # when NUMBERED_DIRS: plus 5 chars on test number, plus 1 char on
+            # space
+            self.stream.write(self._ellipsize_to_right(name, width-18))
+        else:
+            self.stream.write(name)
         self.stream.flush()
 
     def _error_summary(self, err):
@@ -601,10 +568,9 @@
         self.stream.writeln(' SKIP %s\n%s'
                 % (self._testTimeString(test), reason))
 
-    def report_not_applicable(self, test, skip_excinfo):
-        self.stream.writeln('  N/A %s\n%s'
-                % (self._testTimeString(test),
-                   self._error_summary(skip_excinfo)))
+    def report_not_applicable(self, test, reason):
+        self.stream.writeln('  N/A %s\n    %s'
+                % (self._testTimeString(test), reason))
 
     def report_unsupported(self, test, feature):
         """test cannot be run because feature is missing."""
@@ -630,6 +596,19 @@
             applied left to right - the first element in the list is the 
             innermost decorator.
         """
+        # stream may know claim to know to write unicode strings, but in older
+        # pythons this goes sufficiently wrong that it is a bad idea. (
+        # specifically a built in file with encoding 'UTF-8' will still try
+        # to encode using ascii.
+        new_encoding = osutils.get_terminal_encoding()
+        codec = codecs.lookup(new_encoding)
+        if type(codec) is tuple:
+            # Python 2.4
+            encode = codec[0]
+        else:
+            encode = codec.encode
+        stream = osutils.UnicodeOrBytesToBytesWriter(encode, stream)
+        stream.encoding = new_encoding
         self.stream = unittest._WritelnDecorator(stream)
         self.descriptions = descriptions
         self.verbosity = verbosity
@@ -655,14 +634,6 @@
         for decorator in self._result_decorators:
             result = decorator(result)
             result.stop_early = self.stop_on_failure
-        try:
-            import testtools
-        except ImportError:
-            pass
-        else:
-            if isinstance(test, testtools.ConcurrentTestSuite):
-                # We need to catch bzr specific behaviors
-                result = BZRTransformingResult(result)
         result.startTestRun()
         try:
             test.run(result)
@@ -686,8 +657,7 @@
                         % (type(suite), suite))
 
 
-class TestSkipped(Exception):
-    """Indicates that a test was intentionally skipped, rather than failing."""
+TestSkipped = testtools.testcase.TestSkipped
 
 
 class TestNotApplicable(TestSkipped):
@@ -699,19 +669,30 @@
     """
 
 
-class KnownFailure(AssertionError):
-    """Indicates that a test failed in a precisely expected manner.
-
-    Such failures dont block the whole test suite from passing because they are
-    indicators of partially completed code or of future work. We have an
-    explicit error for them so that we can ensure that they are always visible:
-    KnownFailures are always shown in the output of bzr selftest.
-    """
+# traceback._some_str fails to format exceptions that have the default
+# __str__ which does an implicit ascii conversion. However, repr() on those
+# objects works, for all that its not quite what the doctor may have ordered.
+def _clever_some_str(value):
+    try:
+        return str(value)
+    except:
+        try:
+            return repr(value).replace('\\n', '\n')
+        except:
+            return '<unprintable %s object>' % type(value).__name__
+
+traceback._some_str = _clever_some_str
+
+
+# deprecated - use self.knownFailure(), or self.expectFailure.
+KnownFailure = testtools.testcase._ExpectedFailure
 
 
 class UnavailableFeature(Exception):
     """A feature required for this test was not available.
 
+    This can be considered a specialised form of SkippedTest.
+
     The feature should be used to construct the exception.
     """
 
@@ -786,7 +767,7 @@
         return NullProgressView()
 
 
-class TestCase(unittest.TestCase):
+class TestCase(testtools.TestCase):
     """Base class for bzr unit tests.
 
     Tests that need access to disk resources should subclass
@@ -811,24 +792,26 @@
     _leaking_threads_tests = 0
     _first_thread_leaker_id = None
     _log_file_name = None
-    _log_contents = ''
-    _keep_log_file = False
     # record lsprof data when performing benchmark calls.
     _gather_lsprof_in_benchmarks = False
-    attrs_to_keep = ('id', '_testMethodName', '_testMethodDoc',
-                     '_log_contents', '_log_file_name', '_benchtime',
-                     '_TestCase__testMethodName', '_TestCase__testMethodDoc',)
 
     def __init__(self, methodName='testMethod'):
         super(TestCase, self).__init__(methodName)
         self._cleanups = []
-        self._bzr_test_setUp_run = False
-        self._bzr_test_tearDown_run = False
         self._directory_isolation = True
+        self.exception_handlers.insert(0,
+            (UnavailableFeature, self._do_unsupported_or_skip))
+        self.exception_handlers.insert(0,
+            (TestNotApplicable, self._do_not_applicable))
 
     def setUp(self):
-        unittest.TestCase.setUp(self)
-        self._bzr_test_setUp_run = True
+        super(TestCase, self).setUp()
+        for feature in getattr(self, '_test_needs_features', []):
+            self.requireFeature(feature)
+        self._log_contents = None
+        self.addDetail("log", content.Content(content.ContentType("text",
+            "plain", {"charset": "utf8"}),
+            lambda:[self._get_log(keep_log_file=True)]))
         self._cleanEnvironment()
         self._silenceUI()
         self._startLogFile()
@@ -938,7 +921,7 @@
             self._lock_check_thorough = False
         else:
             self._lock_check_thorough = True
-            
+
         self.addCleanup(self._check_locks)
         _mod_lock.Lock.hooks.install_named_hook('lock_acquired',
                                                 self._lock_acquired, None)
@@ -1037,10 +1020,10 @@
         server's urls to be used.
         """
         if backing_server is None:
-            transport_server.setUp()
+            transport_server.start_server()
         else:
-            transport_server.setUp(backing_server)
-        self.addCleanup(transport_server.tearDown)
+            transport_server.start_server(backing_server)
+        self.addCleanup(transport_server.stop_server)
         # Obtain a real transport because if the server supplies a password, it
         # will be hidden from the base on the client side.
         t = get_transport(transport_server.get_url())
@@ -1143,12 +1126,23 @@
         :raises AssertionError: If the expected and actual stat values differ
             other than by atime.
         """
-        self.assertEqual(expected.st_size, actual.st_size)
-        self.assertEqual(expected.st_mtime, actual.st_mtime)
-        self.assertEqual(expected.st_ctime, actual.st_ctime)
-        self.assertEqual(expected.st_dev, actual.st_dev)
-        self.assertEqual(expected.st_ino, actual.st_ino)
-        self.assertEqual(expected.st_mode, actual.st_mode)
+        self.assertEqual(expected.st_size, actual.st_size,
+                         'st_size did not match')
+        self.assertEqual(expected.st_mtime, actual.st_mtime,
+                         'st_mtime did not match')
+        self.assertEqual(expected.st_ctime, actual.st_ctime,
+                         'st_ctime did not match')
+        if sys.platform != 'win32':
+            # On Win32 both 'dev' and 'ino' cannot be trusted. In python2.4 it
+            # is 'dev' that varies, in python 2.5 (6?) it is st_ino that is
+            # odd. Regardless we shouldn't actually try to assert anything
+            # about their values
+            self.assertEqual(expected.st_dev, actual.st_dev,
+                             'st_dev did not match')
+            self.assertEqual(expected.st_ino, actual.st_ino,
+                             'st_ino did not match')
+        self.assertEqual(expected.st_mode, actual.st_mode,
+                         'st_mode did not match')
 
     def assertLength(self, length, obj_with_len):
         """Assert that obj_with_len is of length length."""
@@ -1302,41 +1296,6 @@
                 m += ": " + msg
             self.fail(m)
 
-    def expectFailure(self, reason, assertion, *args, **kwargs):
-        """Invoke a test, expecting it to fail for the given reason.
-
-        This is for assertions that ought to succeed, but currently fail.
-        (The failure is *expected* but not *wanted*.)  Please be very precise
-        about the failure you're expecting.  If a new bug is introduced,
-        AssertionError should be raised, not KnownFailure.
-
-        Frequently, expectFailure should be followed by an opposite assertion.
-        See example below.
-
-        Intended to be used with a callable that raises AssertionError as the
-        'assertion' parameter.  args and kwargs are passed to the 'assertion'.
-
-        Raises KnownFailure if the test fails.  Raises AssertionError if the
-        test succeeds.
-
-        example usage::
-
-          self.expectFailure('Math is broken', self.assertNotEqual, 54,
-                             dynamic_val)
-          self.assertEqual(42, dynamic_val)
-
-          This means that a dynamic_val of 54 will cause the test to raise
-          a KnownFailure.  Once math is fixed and the expectFailure is removed,
-          only a dynamic_val of 42 will allow the test to pass.  Anything other
-          than 54 or 42 will cause an AssertionError.
-        """
-        try:
-            assertion(*args, **kwargs)
-        except AssertionError:
-            raise KnownFailure(reason)
-        else:
-            self.fail('Unexpected success.  Should have failed: %s' % reason)
-
     def assertFileEqual(self, content, path):
         """Fail if path does not contain 'content'."""
         self.failUnlessExists(path)
@@ -1492,18 +1451,12 @@
 
         Close the file and delete it, unless setKeepLogfile was called.
         """
-        if self._log_file is None:
-            return
+        if bzrlib.trace._trace_file:
+            # flush the log file, to get all content
+            bzrlib.trace._trace_file.flush()
         bzrlib.trace.pop_log_file(self._log_memento)
-        self._log_file.close()
-        self._log_file = None
-        if not self._keep_log_file:
-            os.remove(self._log_file_name)
-            self._log_file_name = None
-
-    def setKeepLogfile(self):
-        """Make the logfile not be deleted when _finishLogFile is called."""
-        self._keep_log_file = True
+        # Cache the log result and delete the file on disk
+        self._get_log(False)
 
     def thisFailsStrictLockCheck(self):
         """It is known that this test would fail with -Dstrict_locks.
@@ -1541,6 +1494,7 @@
             'BZR_PROGRESS_BAR': None,
             'BZR_LOG': None,
             'BZR_PLUGIN_PATH': None,
+            'BZR_CONCURRENCY': None,
             # Make sure that any text ui tests are consistent regardless of
             # the environment the test case is run in; you may want tests that
             # test other combinations.  'dumb' is a reasonable guess for tests
@@ -1548,6 +1502,7 @@
             'TERM': 'dumb',
             'LINES': '25',
             'COLUMNS': '80',
+            'BZR_COLUMNS': '80',
             # SSH Agent
             'SSH_AUTH_SOCK': None,
             # Proxies
@@ -1594,104 +1549,39 @@
     def _do_skip(self, result, reason):
         addSkip = getattr(result, 'addSkip', None)
         if not callable(addSkip):
-            result.addError(self, sys.exc_info())
+            result.addSuccess(result)
         else:
             addSkip(self, reason)
 
-    def run(self, result=None):
-        if result is None: result = self.defaultTestResult()
-        for feature in getattr(self, '_test_needs_features', []):
-            if not feature.available():
-                result.startTest(self)
-                if getattr(result, 'addNotSupported', None):
-                    result.addNotSupported(self, feature)
-                else:
-                    result.addSuccess(self)
-                result.stopTest(self)
-                return result
-        try:
-            try:
-                result.startTest(self)
-                absent_attr = object()
-                # Python 2.5
-                method_name = getattr(self, '_testMethodName', absent_attr)
-                if method_name is absent_attr:
-                    # Python 2.4
-                    method_name = getattr(self, '_TestCase__testMethodName')
-                testMethod = getattr(self, method_name)
-                try:
-                    try:
-                        self.setUp()
-                        if not self._bzr_test_setUp_run:
-                            self.fail(
-                                "test setUp did not invoke "
-                                "bzrlib.tests.TestCase's setUp")
-                    except KeyboardInterrupt:
-                        self._runCleanups()
-                        raise
-                    except TestSkipped, e:
-                        self._do_skip(result, e.args[0])
-                        self.tearDown()
-                        return result
-                    except:
-                        result.addError(self, sys.exc_info())
-                        self._runCleanups()
-                        return result
-
-                    ok = False
-                    try:
-                        testMethod()
-                        ok = True
-                    except self.failureException:
-                        result.addFailure(self, sys.exc_info())
-                    except TestSkipped, e:
-                        if not e.args:
-                            reason = "No reason given."
-                        else:
-                            reason = e.args[0]
-                        self._do_skip(result, reason)
-                    except KeyboardInterrupt:
-                        self._runCleanups()
-                        raise
-                    except:
-                        result.addError(self, sys.exc_info())
-
-                    try:
-                        self.tearDown()
-                        if not self._bzr_test_tearDown_run:
-                            self.fail(
-                                "test tearDown did not invoke "
-                                "bzrlib.tests.TestCase's tearDown")
-                    except KeyboardInterrupt:
-                        self._runCleanups()
-                        raise
-                    except:
-                        result.addError(self, sys.exc_info())
-                        self._runCleanups()
-                        ok = False
-                    if ok: result.addSuccess(self)
-                finally:
-                    result.stopTest(self)
-                return result
-            except TestNotApplicable:
-                # Not moved from the result [yet].
-                self._runCleanups()
-                raise
-            except KeyboardInterrupt:
-                self._runCleanups()
-                raise
-        finally:
-            saved_attrs = {}
-            for attr_name in self.attrs_to_keep:
-                if attr_name in self.__dict__:
-                    saved_attrs[attr_name] = self.__dict__[attr_name]
-            self.__dict__ = saved_attrs
-
-    def tearDown(self):
-        self._runCleanups()
-        self._log_contents = ''
-        self._bzr_test_tearDown_run = True
-        unittest.TestCase.tearDown(self)
+    @staticmethod
+    def _do_known_failure(self, result, e):
+        err = sys.exc_info()
+        addExpectedFailure = getattr(result, 'addExpectedFailure', None)
+        if addExpectedFailure is not None:
+            addExpectedFailure(self, err)
+        else:
+            result.addSuccess(self)
+
+    @staticmethod
+    def _do_not_applicable(self, result, e):
+        if not e.args:
+            reason = 'No reason given'
+        else:
+            reason = e.args[0]
+        addNotApplicable = getattr(result, 'addNotApplicable', None)
+        if addNotApplicable is not None:
+            result.addNotApplicable(self, reason)
+        else:
+            self._do_skip(result, reason)
+
+    @staticmethod
+    def _do_unsupported_or_skip(self, result, e):
+        reason = e.args[0]
+        addNotSupported = getattr(result, 'addNotSupported', None)
+        if addNotSupported is not None:
+            result.addNotSupported(self, reason)
+        else:
+            self._do_skip(result, reason)
 
     def time(self, callable, *args, **kwargs):
         """Run callable and accrue the time it takes to the benchmark time.
@@ -1701,6 +1591,8 @@
         self._benchcalls.
         """
         if self._benchtime is None:
+            self.addDetail('benchtime', content.Content(content.ContentType(
+                "text", "plain"), lambda:[str(self._benchtime)]))
             self._benchtime = 0
         start = time.time()
         try:
@@ -1715,25 +1607,14 @@
         finally:
             self._benchtime += time.time() - start
 
-    def _runCleanups(self):
-        """Run registered cleanup functions.
-
-        This should only be called from TestCase.tearDown.
-        """
-        # TODO: Perhaps this should keep running cleanups even if
-        # one of them fails?
-
-        # Actually pop the cleanups from the list so tearDown running
-        # twice is safe (this happens for skipped tests).
-        while self._cleanups:
-            cleanup, args, kwargs = self._cleanups.pop()
-            cleanup(*args, **kwargs)
-
     def log(self, *args):
         mutter(*args)
 
     def _get_log(self, keep_log_file=False):
-        """Get the log from bzrlib.trace calls from this test.
+        """Internal helper to get the log from bzrlib.trace for this test.
+
+        Please use self.getDetails, or self.get_log to access this in test case
+        code.
 
         :param keep_log_file: When True, if the log is still a file on disk
             leave it as a file on disk. When False, if the log is still a file
@@ -1741,21 +1622,33 @@
             self._log_contents.
         :return: A string containing the log.
         """
-        # flush the log file, to get all content
+        if self._log_contents is not None:
+            try:
+                self._log_contents.decode('utf8')
+            except UnicodeDecodeError:
+                unicodestr = self._log_contents.decode('utf8', 'replace')
+                self._log_contents = unicodestr.encode('utf8')
+            return self._log_contents
         import bzrlib.trace
         if bzrlib.trace._trace_file:
+            # flush the log file, to get all content
             bzrlib.trace._trace_file.flush()
-        if self._log_contents:
-            # XXX: this can hardly contain the content flushed above --vila
-            # 20080128
-            return self._log_contents
         if self._log_file_name is not None:
             logfile = open(self._log_file_name)
             try:
                 log_contents = logfile.read()
             finally:
                 logfile.close()
+            try:
+                log_contents.decode('utf8')
+            except UnicodeDecodeError:
+                unicodestr = log_contents.decode('utf8', 'replace')
+                log_contents = unicodestr.encode('utf8')
             if not keep_log_file:
+                self._log_file.close()
+                self._log_file = None
+                # Permit multiple calls to get_log until we clean it up in
+                # finishLogFile
                 self._log_contents = log_contents
                 try:
                     os.remove(self._log_file_name)
@@ -1765,9 +1658,17 @@
                                              ' %r\n' % self._log_file_name))
                     else:
                         raise
+                self._log_file_name = None
             return log_contents
         else:
-            return "DELETED log file to reduce memory footprint"
+            return "No log file content and no log file name."
+
+    def get_log(self):
+        """Get a unicode string containing the log from bzrlib.trace.
+
+        Undecodable characters are replaced.
+        """
+        return u"".join(self.getDetails()['log'].iter_text())
 
     def requireFeature(self, feature):
         """This test requires a specific feature is available.
@@ -1790,6 +1691,9 @@
 
     def _run_bzr_core(self, args, retcode, encoding, stdin,
             working_dir):
+        # Clear chk_map page cache, because the contents are likely to mask
+        # locking errors.
+        chk_map.clear_cache()
         if encoding is None:
             encoding = osutils.get_user_encoding()
         stdout = StringIOWrapper()
@@ -1812,10 +1716,22 @@
             os.chdir(working_dir)
 
         try:
-            result = self.apply_redirected(ui.ui_factory.stdin,
-                stdout, stderr,
-                bzrlib.commands.run_bzr_catch_user_errors,
-                args)
+            try:
+                result = self.apply_redirected(ui.ui_factory.stdin,
+                    stdout, stderr,
+                    bzrlib.commands.run_bzr_catch_user_errors,
+                    args)
+            except KeyboardInterrupt:
+                # Reraise KeyboardInterrupt with contents of redirected stdout
+                # and stderr as arguments, for tests which are interested in
+                # stdout and stderr and are expecting the exception.
+                out = stdout.getvalue()
+                err = stderr.getvalue()
+                if out:
+                    self.log('output:\n%r', out)
+                if err:
+                    self.log('errors:\n%r', err)
+                raise KeyboardInterrupt(out, err)
         finally:
             logger.removeHandler(handler)
             ui.ui_factory = old_ui_factory
@@ -2369,7 +2285,7 @@
             # recreate a new one or all the followng tests will fail.
             # If you need to inspect its content uncomment the following line
             # import pdb; pdb.set_trace()
-            _rmtree_temp_dir(root + '/.bzr')
+            _rmtree_temp_dir(root + '/.bzr', test_id=self.id())
             self._create_safety_net()
             raise AssertionError('%s/.bzr should not be modified' % root)
 
@@ -2451,8 +2367,11 @@
         return branchbuilder.BranchBuilder(branch=branch)
 
     def overrideEnvironmentForTesting(self):
-        os.environ['HOME'] = self.test_home_dir
-        os.environ['BZR_HOME'] = self.test_home_dir
+        test_home_dir = self.test_home_dir
+        if isinstance(test_home_dir, unicode):
+            test_home_dir = test_home_dir.encode(sys.getfilesystemencoding())
+        os.environ['HOME'] = test_home_dir
+        os.environ['BZR_HOME'] = test_home_dir
 
     def setUp(self):
         super(TestCaseWithMemoryTransport, self).setUp()
@@ -2564,7 +2483,7 @@
 
     def deleteTestDir(self):
         os.chdir(TestCaseWithMemoryTransport.TEST_ROOT)
-        _rmtree_temp_dir(self.test_base_dir)
+        _rmtree_temp_dir(self.test_base_dir, test_id=self.id())
 
     def build_tree(self, shape, line_endings='binary', transport=None):
         """Build a test tree according to a pattern.
@@ -3174,7 +3093,7 @@
         if self.randomised:
             return iter(self._tests)
         self.randomised = True
-        self.stream.writeln("Randomizing test order using seed %s\n" %
+        self.stream.write("Randomizing test order using seed %s\n\n" %
             (self.actual_seed()))
         # Initialise the random number generator.
         random.seed(self.actual_seed())
@@ -3237,10 +3156,7 @@
     concurrency = osutils.local_concurrency()
     result = []
     from subunit import TestProtocolClient, ProtocolTestCase
-    try:
-        from subunit.test_results import AutoTimingTestResultDecorator
-    except ImportError:
-        AutoTimingTestResultDecorator = lambda x:x
+    from subunit.test_results import AutoTimingTestResultDecorator
     class TestInOtherProcess(ProtocolTestCase):
         # Should be in subunit, I think. RBC.
         def __init__(self, stream, pid):
@@ -3312,13 +3228,17 @@
         if not os.path.isfile(bzr_path):
             # We are probably installed. Assume sys.argv is the right file
             bzr_path = sys.argv[0]
+        bzr_path = [bzr_path]
+        if sys.platform == "win32":
+            # if we're on windows, we can't execute the bzr script directly
+            bzr_path = [sys.executable] + bzr_path
         fd, test_list_file_name = tempfile.mkstemp()
         test_list_file = os.fdopen(fd, 'wb', 1)
         for test in process_tests:
             test_list_file.write(test.id() + '\n')
         test_list_file.close()
         try:
-            argv = [bzr_path, 'selftest', '--load-list', test_list_file_name,
+            argv = bzr_path + ['selftest', '--load-list', test_list_file_name,
                 '--subunit']
             if '--no-plugins' in sys.argv:
                 argv.append('--no-plugins')
@@ -3363,40 +3283,7 @@
 
     def addFailure(self, test, err):
         self.result.addFailure(test, err)
-
-
-class BZRTransformingResult(ForwardingResult):
-
-    def addError(self, test, err):
-        feature = self._error_looks_like('UnavailableFeature: ', err)
-        if feature is not None:
-            self.result.addNotSupported(test, feature)
-        else:
-            self.result.addError(test, err)
-
-    def addFailure(self, test, err):
-        known = self._error_looks_like('KnownFailure: ', err)
-        if known is not None:
-            self.result._addKnownFailure(test, [KnownFailure,
-                                                KnownFailure(known), None])
-        else:
-            self.result.addFailure(test, err)
-
-    def _error_looks_like(self, prefix, err):
-        """Deserialize exception and returns the stringify value."""
-        import subunit
-        value = None
-        typ, exc, _ = err
-        if isinstance(exc, subunit.RemoteException):
-            # stringify the exception gives access to the remote traceback
-            # We search the last line for 'prefix'
-            lines = str(exc).split('\n')
-            while lines and not lines[-1]:
-                lines.pop(-1)
-            if lines:
-                if lines[-1].startswith(prefix):
-                    value = lines[-1][len(prefix):]
-        return value
+ForwardingResult = testtools.ExtendedToOriginalDecorator
 
 
 class ProfileResult(ForwardingResult):
@@ -3685,6 +3572,7 @@
         'bzrlib.tests.per_inventory',
         'bzrlib.tests.per_interbranch',
         'bzrlib.tests.per_lock',
+        'bzrlib.tests.per_merger',
         'bzrlib.tests.per_transport',
         'bzrlib.tests.per_tree',
         'bzrlib.tests.per_pack_repository',
@@ -3695,6 +3583,7 @@
         'bzrlib.tests.per_versionedfile',
         'bzrlib.tests.per_workingtree',
         'bzrlib.tests.test__annotator',
+        'bzrlib.tests.test__bencode',
         'bzrlib.tests.test__chk_map',
         'bzrlib.tests.test__dirstate_helpers',
         'bzrlib.tests.test__groupcompress',
@@ -3708,7 +3597,6 @@
         'bzrlib.tests.test_api',
         'bzrlib.tests.test_atomicfile',
         'bzrlib.tests.test_bad_files',
-        'bzrlib.tests.test_bencode',
         'bzrlib.tests.test_bisect_multi',
         'bzrlib.tests.test_branch',
         'bzrlib.tests.test_branchbuilder',
@@ -3722,6 +3610,7 @@
         'bzrlib.tests.test_chk_serializer',
         'bzrlib.tests.test_chunk_writer',
         'bzrlib.tests.test_clean_tree',
+        'bzrlib.tests.test_cleanup',
         'bzrlib.tests.test_commands',
         'bzrlib.tests.test_commit',
         'bzrlib.tests.test_commit_merge',
@@ -3863,6 +3752,7 @@
     return [
         'bzrlib',
         'bzrlib.branchbuilder',
+        'bzrlib.decorators',
         'bzrlib.export',
         'bzrlib.inventory',
         'bzrlib.iterablefile',
@@ -4075,7 +3965,48 @@
     return new_test
 
 
-def _rmtree_temp_dir(dirname):
+def permute_tests_for_extension(standard_tests, loader, py_module_name,
+                                ext_module_name):
+    """Helper for permutating tests against an extension module.
+
+    This is meant to be used inside a modules 'load_tests()' function. It will
+    create 2 scenarios, and cause all tests in the 'standard_tests' to be run
+    against both implementations. Setting 'test.module' to the appropriate
+    module. See bzrlib.tests.test__chk_map.load_tests as an example.
+
+    :param standard_tests: A test suite to permute
+    :param loader: A TestLoader
+    :param py_module_name: The python path to a python module that can always
+        be loaded, and will be considered the 'python' implementation. (eg
+        'bzrlib._chk_map_py')
+    :param ext_module_name: The python path to an extension module. If the
+        module cannot be loaded, a single test will be added, which notes that
+        the module is not available. If it can be loaded, all standard_tests
+        will be run against that module.
+    :return: (suite, feature) suite is a test-suite that has all the permuted
+        tests. feature is the Feature object that can be used to determine if
+        the module is available.
+    """
+
+    py_module = __import__(py_module_name, {}, {}, ['NO_SUCH_ATTRIB'])
+    scenarios = [
+        ('python', {'module': py_module}),
+    ]
+    suite = loader.suiteClass()
+    feature = ModuleAvailableFeature(ext_module_name)
+    if feature.available():
+        scenarios.append(('C', {'module': feature.module}))
+    else:
+        # the compiled module isn't available, so we add a failing test
+        class FailWithoutFeature(TestCase):
+            def test_fail(self):
+                self.requireFeature(feature)
+        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
+    result = multiply_tests(standard_tests, scenarios, suite)
+    return result, feature
+
+
+def _rmtree_temp_dir(dirname, test_id=None):
     # If LANG=C we probably have created some bogus paths
     # which rmtree(unicode) will fail to delete
     # so make sure we are using rmtree(str) to delete everything
@@ -4093,6 +4024,9 @@
         # We don't want to fail here because some useful display will be lost
         # otherwise. Polluting the tmp dir is bad, but not giving all the
         # possible info to the test runner is even worse.
+        if test_id != None:
+            ui.ui_factory.clear_term()
+            sys.stderr.write('\nWhile running: %s\n' % (test_id,))
         sys.stderr.write('Unable to remove testing dir %s\n%s'
                          % (os.path.basename(dirname), e))
 
@@ -4182,6 +4116,70 @@
 UnicodeFilenameFeature = _UnicodeFilenameFeature()
 
 
+class _CompatabilityThunkFeature(Feature):
+    """This feature is just a thunk to another feature.
+
+    It issues a deprecation warning if it is accessed, to let you know that you
+    should really use a different feature.
+    """
+
+    def __init__(self, module, name, this_name, dep_version):
+        super(_CompatabilityThunkFeature, self).__init__()
+        self._module = module
+        self._name = name
+        self._this_name = this_name
+        self._dep_version = dep_version
+        self._feature = None
+
+    def _ensure(self):
+        if self._feature is None:
+            msg = (self._dep_version % self._this_name) + (
+                   ' Use %s.%s instead.' % (self._module, self._name))
+            symbol_versioning.warn(msg, DeprecationWarning)
+            mod = __import__(self._module, {}, {}, [self._name])
+            self._feature = getattr(mod, self._name)
+
+    def _probe(self):
+        self._ensure()
+        return self._feature._probe()
+
+
+class ModuleAvailableFeature(Feature):
+    """This is a feature than describes a module we want to be available.
+
+    Declare the name of the module in __init__(), and then after probing, the
+    module will be available as 'self.module'.
+
+    :ivar module: The module if it is available, else None.
+    """
+
+    def __init__(self, module_name):
+        super(ModuleAvailableFeature, self).__init__()
+        self.module_name = module_name
+
+    def _probe(self):
+        try:
+            self._module = __import__(self.module_name, {}, {}, [''])
+            return True
+        except ImportError:
+            return False
+
+    @property
+    def module(self):
+        if self.available(): # Make sure the probe has been done
+            return self._module
+        return None
+    
+    def feature_name(self):
+        return self.module_name
+
+
+# This is kept here for compatibility, it is recommended to use
+# 'bzrlib.tests.feature.paramiko' instead
+ParamikoFeature = _CompatabilityThunkFeature('bzrlib.tests.features',
+    'paramiko', 'bzrlib.tests.ParamikoFeature', deprecated_in((2,1,0)))
+
+
 def probe_unicode_in_user_encoding():
     """Try to encode several unicode strings to use in unicode-aware tests.
     Return first successfull match.
@@ -4236,23 +4234,6 @@
 HTTPSServerFeature = _HTTPSServerFeature()
 
 
-class _ParamikoFeature(Feature):
-    """Is paramiko available?"""
-
-    def _probe(self):
-        try:
-            from bzrlib.transport.sftp import SFTPAbsoluteServer
-            return True
-        except errors.ParamikoNotPresent:
-            return False
-
-    def feature_name(self):
-        return "Paramiko"
-
-
-ParamikoFeature = _ParamikoFeature()
-
-
 class _UnicodeFilename(Feature):
     """Does the filesystem support Unicode filenames?"""
 
@@ -4295,7 +4276,9 @@
             # Windows doesn't have os.kill, and we catch the SIGBREAK signal.
             # We trigger SIGBREAK via a Console api so we need ctypes to
             # access the function
-            if not have_ctypes:
+            try:
+                import ctypes
+            except OSError:
                 return False
         return True
 
@@ -4361,27 +4344,30 @@
 CaseInsensitiveFilesystemFeature = _CaseInsensitiveFilesystemFeature()
 
 
-class _SubUnitFeature(Feature):
-    """Check if subunit is available."""
+class _CaseSensitiveFilesystemFeature(Feature):
 
     def _probe(self):
-        try:
-            import subunit
+        if CaseInsCasePresFilenameFeature.available():
+            return False
+        elif CaseInsensitiveFilesystemFeature.available():
+            return False
+        else:
             return True
-        except ImportError:
-            return False
 
     def feature_name(self):
-        return 'subunit'
-
-SubUnitFeature = _SubUnitFeature()
+        return 'case-sensitive filesystem'
+
+# new coding style is for feature instances to be lowercase
+case_sensitive_filesystem_feature = _CaseSensitiveFilesystemFeature()
+
+
+# Kept for compatibility, use bzrlib.tests.features.subunit instead
+SubUnitFeature = _CompatabilityThunkFeature('bzrlib.tests.features', 'subunit',
+    'bzrlib.tests.SubUnitFeature', deprecated_in((2,1,0)))
 # Only define SubUnitBzrRunner if subunit is available.
 try:
     from subunit import TestProtocolClient
-    try:
-        from subunit.test_results import AutoTimingTestResultDecorator
-    except ImportError:
-        AutoTimingTestResultDecorator = lambda x:x
+    from subunit.test_results import AutoTimingTestResultDecorator
     class SubUnitBzrRunner(TextTestRunner):
         def run(self, test):
             result = AutoTimingTestResultDecorator(

=== modified file 'bzrlib/tests/blackbox/test_add.py'
--- bzrlib/tests/blackbox/test_add.py	2009-08-10 08:25:05 +0000
+++ bzrlib/tests/blackbox/test_add.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,7 +27,6 @@
     SymlinkFeature
     )
 from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.tests.test_win32utils import NeedsGlobExpansionFeature
 
 
 def load_tests(standard_tests, module, loader):
@@ -211,20 +210,6 @@
         err = self.run_bzr('add .bzr/crescent', retcode=3)[1]
         self.assertContainsRe(err, r'ERROR:.*\.bzr.*control file')
 
-    def test_add_with_wildcards(self):
-        self.requireFeature(NeedsGlobExpansionFeature)
-        self.make_branch_and_tree('.')
-        self.build_tree(['a1', 'a2', 'b', 'c33'])
-        self.run_bzr(['add', 'a?', 'c*'])
-        self.assertEquals(self.run_bzr('unknowns')[0], 'b\n')
-
-    def test_add_with_wildcards_unicode(self):
-        self.requireFeature(NeedsGlobExpansionFeature)
-        self.make_branch_and_tree('.')
-        self.build_tree([u'\u1234A', u'\u1235A', u'\u1235AA', 'cc'])
-        self.run_bzr(['add', u'\u1234?', u'\u1235*'])
-        self.assertEquals(self.run_bzr('unknowns')[0], 'cc\n')
-
     def test_add_via_symlink(self):
         self.requireFeature(SymlinkFeature)
         self.make_branch_and_tree('source')

=== modified file 'bzrlib/tests/blackbox/test_annotate.py'
--- bzrlib/tests/blackbox/test_annotate.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_annotate.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -29,6 +29,7 @@
 from bzrlib.branch import Branch
 from bzrlib.config import extract_email_address
 from bzrlib.tests import TestCaseWithTransport
+from bzrlib.urlutils import joinpath
 
 
 class TestAnnotate(TestCaseWithTransport):
@@ -153,14 +154,27 @@
 class TestSimpleAnnotate(TestCaseWithTransport):
     """Annotate tests with no complex setup."""
 
-    def _setup_edited_file(self):
+    def _setup_edited_file(self, relpath='.'):
         """Create a tree with a locally edited file."""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree_contents([('file', 'foo\ngam\n')])
+        tree = self.make_branch_and_tree(relpath)
+        file_relpath = joinpath(relpath, 'file')
+        self.build_tree_contents([(file_relpath, 'foo\ngam\n')])
         tree.add('file')
         tree.commit('add file', committer="test@host", rev_id="rev1")
-        self.build_tree_contents([('file', 'foo\nbar\ngam\n')])
+        self.build_tree_contents([(file_relpath, 'foo\nbar\ngam\n')])
         tree.branch.get_config().set_user_option('email', 'current@host2')
+        return tree
+
+    def test_annotate_cmd_revspec_branch(self):
+        tree = self._setup_edited_file('trunk')
+        tree.branch.create_checkout(self.get_url('work'), lightweight=True)
+        os.chdir('work')
+        out, err = self.run_bzr('annotate file -r branch:../trunk')
+        self.assertEqual('', err)
+        self.assertEqual(
+            '1   test@ho | foo\n'
+            '            | gam\n',
+            out)
 
     def test_annotate_edited_file(self):
         tree = self._setup_edited_file()

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2009-08-20 12:30:49 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -171,15 +171,7 @@
         out, err = self.run_bzr(['branch', 'source', 'target', '--hardlink'])
         source_stat = os.stat('source/file1')
         target_stat = os.stat('target/file1')
-        same_file = (source_stat == target_stat)
-        if same_file:
-            pass
-        else:
-            # https://bugs.edge.launchpad.net/bzr/+bug/408193
-            self.assertContainsRe(err, "hardlinking working copy files is "
-                "not currently supported")
-            raise KnownFailure("--hardlink doesn't work in formats "
-                "that support content filtering (#408193)")
+        self.assertEqual(source_stat, target_stat)
 
     def test_branch_standalone(self):
         shared_repo = self.make_repository('repo', shared=True)
@@ -217,6 +209,13 @@
         self.assertEqual('', out)
         self.assertEqual('bzr: ERROR: Already a branch: "b".\n', err)
 
+    def test_branch_bind(self):
+        self.example_branch('a')
+        out, err = self.run_bzr('branch a b --bind')
+        self.assertEndsWith(err, "New branch bound to a\n")
+        b = branch.Branch.open('b')
+        self.assertEndsWith(b.get_bound_location(), '/a/')
+
 
 class TestBranchStacked(ExternalBase):
     """Tests for branch --stacked"""

=== modified file 'bzrlib/tests/blackbox/test_cat.py'
--- bzrlib/tests/blackbox/test_cat.py	2009-09-18 09:09:36 +0000
+++ bzrlib/tests/blackbox/test_cat.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -20,7 +20,6 @@
 """
 
 import os
-import sys
 
 from bzrlib import tests
 
@@ -128,6 +127,18 @@
         out, err = self.run_bzr_subprocess(['cat', url])
         self.assertEqual('contents of README\n', out)
 
+    def test_cat_branch_revspec(self):
+        wt = self.make_branch_and_tree('a')
+        self.build_tree(['a/README'])
+        wt.add('README')
+        wt.commit('Making sure there is a basis_tree available')
+        wt = self.make_branch_and_tree('b')
+        os.chdir('b')
+
+        out, err = self.run_bzr_subprocess(
+            ['cat', '-r', 'branch:../a', 'README'])
+        self.assertEqual('contents of a/README\n', out)
+
     def test_cat_filters(self):
         wt = self.make_branch_and_tree('.')
         self.build_tree(['README'])

=== modified file 'bzrlib/tests/blackbox/test_checkout.py'
--- bzrlib/tests/blackbox/test_checkout.py	2009-08-03 04:19:03 +0000
+++ bzrlib/tests/blackbox/test_checkout.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2009 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -160,12 +160,4 @@
             '--hardlink'])
         source_stat = os.stat('source/file1')
         target_stat = os.stat('target/file1')
-        same_file = (source_stat == target_stat)
-        if same_file:
-            pass
-        else:
-            # https://bugs.edge.launchpad.net/bzr/+bug/408193
-            self.assertContainsRe(err, "hardlinking working copy files is "
-                "not currently supported")
-            raise KnownFailure("--hardlink doesn't work in formats "
-                "that support content filtering (#408193)")
+        self.assertEqual(source_stat, target_stat)

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2009-08-28 05:00:33 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,6 +25,7 @@
     ignores,
     msgeditor,
     osutils,
+    tests,
     )
 from bzrlib.bzrdir import BzrDir
 from bzrlib.tests import (
@@ -106,6 +107,14 @@
                               'modified hello\.txt\n'
                               'Committed revision 2\.\n$')
 
+    def test_warn_about_forgotten_commit_message(self):
+        """Test that the lack of -m parameter is caught"""
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['one', 'two'])
+        wt.add(['two'])
+        out, err = self.run_bzr('commit -m one two')
+        self.assertContainsRe(err, "The commit message is a file name")
+
     def test_verbose_commit_renamed(self):
         # Verbose commit of renamed file should say so
         wt = self.prepare_simple_history()
@@ -170,6 +179,24 @@
         self.assertEqual(err, 'Committing to: %s\n'
                          'Committed revision 2.\n' % expected)
 
+    def test_commit_sanitizes_CR_in_message(self):
+        # See bug #433779, basically Emacs likes to pass '\r\n' style line
+        # endings to 'bzr commit -m ""' which breaks because we don't allow
+        # '\r' in commit messages. (Mostly because of issues where XML style
+        # formats arbitrarily strip it out of the data while parsing.)
+        # To make life easier for users, we just always translate '\r\n' =>
+        # '\n'. And '\r' => '\n'.
+        a_tree = self.make_branch_and_tree('a')
+        self.build_tree(['a/b'])
+        a_tree.add('b')
+        self.run_bzr(['commit',
+                      '-m', 'a string\r\n\r\nwith mixed\r\rendings\n'],
+                     working_dir='a')
+        rev_id = a_tree.branch.last_revision()
+        rev = a_tree.branch.repository.get_revision(rev_id)
+        self.assertEqualDiff('a string\n\nwith mixed\n\nendings\n',
+                             rev.message)
+
     def test_commit_merge_reports_all_modified_files(self):
         # the commit command should show all the files that are shown by
         # bzr diff or bzr status when committing, even when they were not
@@ -245,6 +272,9 @@
         self.run_bzr('commit -m ""', retcode=3)
 
     def test_unsupported_encoding_commit_message(self):
+        if sys.platform == 'win32':
+            raise tests.TestNotApplicable('Win32 parses arguments directly'
+                ' as Unicode, so we can\'t pass invalid non-ascii')
         tree = self.make_branch_and_tree('.')
         self.build_tree_contents([('foo.c', 'int main() {}')])
         tree.add('foo.c')
@@ -255,10 +285,6 @@
         if char is None:
             raise TestSkipped('Cannot find suitable non-ascii character'
                 'for user_encoding (%s)' % osutils.get_user_encoding())
-        # TODO: jam 2009-07-23 This test seems to fail on Windows now. My best
-        #       guess is that the change to use Unicode command lines means
-        #       that we no longer pay any attention to LANG=C when decoding the
-        #       commandline arguments.
         out,err = self.run_bzr_subprocess('commit -m "%s"' % char,
                                           retcode=1,
                                           env_changes={'LANG': 'C'})
@@ -590,6 +616,26 @@
         properties = last_rev.properties
         self.assertEqual('John Doe\nJane Rey', properties['authors'])
 
+    def test_commit_time(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/hello.txt'])
+        tree.add('hello.txt')
+        out, err = self.run_bzr("commit -m hello "
+            "--commit-time='2009-10-10 08:00:00 +0100' tree/hello.txt")
+        last_rev = tree.branch.repository.get_revision(tree.last_revision())
+        self.assertEqual(
+            'Sat 2009-10-10 08:00:00 +0100',
+            osutils.format_date(last_rev.timestamp, last_rev.timezone))
+        
+    def test_commit_time_bad_time(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/hello.txt'])
+        tree.add('hello.txt')
+        out, err = self.run_bzr("commit -m hello "
+            "--commit-time='NOT A TIME' tree/hello.txt", retcode=3)
+        self.assertStartsWith(
+            err, "bzr: ERROR: Could not parse --commit-time:")
+
     def test_partial_commit_with_renames_in_tree(self):
         # this test illustrates bug #140419
         t = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/blackbox/test_debug.py'
--- bzrlib/tests/blackbox/test_debug.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_debug.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,5 +38,4 @@
     def test_dash_dlock(self):
         # With -Dlock, locking and unlocking is recorded into the log
         self.run_bzr("-Dlock init foo")
-        trace_messages = self._get_log(keep_log_file=True)
-        self.assertContainsRe(trace_messages, "lock_write")
+        self.assertContainsRe(self.get_log(), "lock_write")

=== modified file 'bzrlib/tests/blackbox/test_exceptions.py'
--- bzrlib/tests/blackbox/test_exceptions.py	2009-08-20 06:25:02 +0000
+++ bzrlib/tests/blackbox/test_exceptions.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,8 +22,11 @@
 
 from bzrlib import (
     bzrdir,
+    config,
     errors,
+    osutils,
     repository,
+    tests,
     trace,
     )
 
@@ -45,18 +48,69 @@
         self.assertContainsRe(err, r'Bazaar has encountered an internal error')
 
 
-class TestDeprecationWarning(TestCaseInTempDir):
+class TestDeprecationWarning(tests.TestCaseWithTransport):
+    """The deprecation warning is controlled via a global variable:
+    repository._deprecation_warning_done. As such, it can be emitted only once
+    during a bzr invocation, no matter how many repositories are involved.
+
+    It would be better if it was a repo attribute instead but that's far more
+    work than I want to do right now -- vila 20091215.
+    """
+
+    def setUp(self):
+        super(TestDeprecationWarning, self).setUp()
+        self.disable_deprecation_warning()
+
+    def enable_deprecation_warning(self, repo=None):
+        """repo is not used yet since _deprecation_warning_done is a global"""
+        repository._deprecation_warning_done = False
+
+    def disable_deprecation_warning(self, repo=None):
+        """repo is not used yet since _deprecation_warning_done is a global"""
+        repository._deprecation_warning_done = True
+
+    def make_obsolete_repo(self, path):
+        # We don't want the deprecation raising during the repo creation
+        tree = self.make_branch_and_tree(path, format=bzrdir.BzrDirFormat5())
+        return tree
+
+    def check_warning(self, present):
+        if present:
+            check = self.assertContainsRe
+        else:
+            check = self.assertNotContainsRe
+        check(self._get_log(keep_log_file=True), 'WARNING.*bzr upgrade')
 
     def test_repository_deprecation_warning(self):
         """Old formats give a warning"""
-        # the warning's normally off for testing but we reenable it
-        repository._deprecation_warning_done = False
-        try:
-            os.mkdir('foo')
-            bzrdir.BzrDirFormat5().initialize('foo')
-            out, err = self.run_bzr("status foo")
-            self.assertContainsRe(self._get_log(keep_log_file=True),
-                                  "bzr upgrade")
-        finally:
-            repository._deprecation_warning_done = True
-
+        self.make_obsolete_repo('foo')
+        self.enable_deprecation_warning()
+        out, err = self.run_bzr('status', working_dir='foo')
+        self.check_warning(True)
+
+    def test_repository_deprecation_warning_suppressed_global(self):
+        """Old formats give a warning"""
+        conf = config.GlobalConfig()
+        conf.set_user_option('suppress_warnings', 'format_deprecation')
+        self.make_obsolete_repo('foo')
+        self.enable_deprecation_warning()
+        out, err = self.run_bzr('status', working_dir='foo')
+        self.check_warning(False)
+
+    def test_repository_deprecation_warning_suppressed_locations(self):
+        """Old formats give a warning"""
+        self.make_obsolete_repo('foo')
+        conf = config.LocationConfig(osutils.pathjoin(self.test_dir, 'foo'))
+        conf.set_user_option('suppress_warnings', 'format_deprecation')
+        self.enable_deprecation_warning()
+        out, err = self.run_bzr('status', working_dir='foo')
+        self.check_warning(False)
+
+    def test_repository_deprecation_warning_suppressed_branch(self):
+        """Old formats give a warning"""
+        tree = self.make_obsolete_repo('foo')
+        conf = tree.branch.get_config()
+        conf.set_user_option('suppress_warnings', 'format_deprecation')
+        self.enable_deprecation_warning()
+        out, err = self.run_bzr('status', working_dir='foo')
+        self.check_warning(False)

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2009-06-10 03:56:49 +0000
+++ bzrlib/tests/blackbox/test_export.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -141,7 +141,7 @@
         # forward slashes
         self.assertEqual(['test/a', 'test/b/', 'test/b/c', 'test/d/'], names)
 
-        file_attr = stat.S_IFREG
+        file_attr = stat.S_IFREG | export.zip_exporter.FILE_PERMISSIONS
         dir_attr = stat.S_IFDIR | export.zip_exporter.ZIP_DIRECTORY_BIT
 
         a_info = zfile.getinfo(names[0])

=== modified file 'bzrlib/tests/blackbox/test_filtered_view_ops.py'
--- bzrlib/tests/blackbox/test_filtered_view_ops.py	2009-04-08 03:34:31 +0000
+++ bzrlib/tests/blackbox/test_filtered_view_ops.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,19 +18,20 @@
 
 import os
 
-from bzrlib import bzrdir
-from bzrlib.tests import TestCaseWithTransport
-from bzrlib.workingtree import WorkingTree
-
-
-class TestViewFileOperations(TestCaseWithTransport):
+from bzrlib import (
+    bzrdir,
+    osutils,
+    tests,
+    )
+
+
+class TestViewFileOperations(tests.TestCaseWithTransport):
 
     def make_abc_tree_with_ab_view(self):
         # we need to use a specific format because the default format
         # doesn't support views yet
         format = bzrdir.format_registry.make_bzrdir('development6-rich-root')
-        wt = TestCaseWithTransport.make_branch_and_tree(self, '.',
-            format=format)
+        wt = self.make_branch_and_tree( '.', format=format)
         self.build_tree(['a', 'b', 'c'])
         wt.views.set_view('my', ['a', 'b'])
         return wt
@@ -152,15 +153,14 @@
         self.assertEquals('b', out_lines[1])
 
 
-class TestViewTreeOperationss(TestCaseWithTransport):
+class TestViewTreeOperations(tests.TestCaseWithTransport):
 
     def make_abc_tree_and_clone_with_ab_view(self):
         # we need to use a specific format because the default format
         # doesn't support views yet
         format = bzrdir.format_registry.make_bzrdir('development6-rich-root')
         # Build the first tree
-        wt1 = TestCaseWithTransport.make_branch_and_tree(self, 'tree_1',
-            format=format)
+        wt1 = self.make_branch_and_tree('tree_1', format=format)
         self.build_tree(['tree_1/a', 'tree_1/b', 'tree_1/c'])
         wt1.add(['a', 'b', 'c'])
         wt1.commit("adding a b c")
@@ -186,15 +186,16 @@
 
     def test_view_on_update(self):
         tree_1, tree_2 = self.make_abc_tree_and_clone_with_ab_view()
-        os.chdir("tree_2")
-        self.run_bzr("bind ../tree_1")
-        out, err = self.run_bzr('update')
+        self.run_bzr("bind ../tree_1", working_dir='tree_2')
+        out, err = self.run_bzr('update', working_dir='tree_2')
         self.assertEqualDiff(
-            "Operating on whole tree but only reporting on 'my' view.\n"
-            " M  a\n"
-            "All changes applied successfully.\n"
-            "Updated to revision 2.\n", err)
-        self.assertEqualDiff("", out)
+            """Operating on whole tree but only reporting on 'my' view.
+ M  a
+All changes applied successfully.
+Updated to revision 2 of branch %s
+""" % osutils.pathjoin(self.test_dir, 'tree_1'),
+            err)
+        self.assertEqual("", out)
 
     def test_view_on_merge(self):
         tree_1, tree_2 = self.make_abc_tree_and_clone_with_ab_view()
@@ -203,4 +204,4 @@
             "Operating on whole tree but only reporting on 'my' view.\n"
             " M  a\n"
             "All changes applied successfully.\n", err)
-        self.assertEqualDiff("", out)
+        self.assertEqual("", out)

=== modified file 'bzrlib/tests/blackbox/test_help.py'
--- bzrlib/tests/blackbox/test_help.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_help.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -105,8 +105,23 @@
         self.assertEquals(dash_help, qmark_cmds)
 
     def test_hidden(self):
-        commands = self.run_bzr('help commands')[0]
-        hidden = self.run_bzr('help hidden-commands')[0]
+        help_commands = self.run_bzr('help commands')[0]
+        help_hidden = self.run_bzr('help hidden-commands')[0]
+
+        def extract_cmd_names(help_output):
+            # keep only the command names to avoid matching on help text (there
+            # is a high risk to fail a test when a plugin get installed
+            # otherwise)
+            cmds = []
+            for line in help_output.split('\n'):
+                if line.startswith(' '):
+                    continue # help on more than one line
+                cmd = line.split(' ')[0]
+                if line:
+                    cmds.append(cmd)
+            return cmds
+        commands = extract_cmd_names(help_commands)
+        hidden = extract_cmd_names(help_hidden)
         self.assertTrue('commit' in commands)
         self.assertTrue('commit' not in hidden)
         self.assertTrue('rocks' in hidden)

=== modified file 'bzrlib/tests/blackbox/test_ignore.py'
--- bzrlib/tests/blackbox/test_ignore.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_ignore.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -32,7 +32,6 @@
 from bzrlib.errors import BzrCommandError
 from bzrlib.osutils import (
     pathjoin,
-    terminal_width,
     )
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.tests.blackbox import ExternalBase

=== modified file 'bzrlib/tests/blackbox/test_info.py'
--- bzrlib/tests/blackbox/test_info.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/blackbox/test_info.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,7 +37,7 @@
 
     def setUp(self):
         ExternalBase.setUp(self)
-        self._repo_strings = "2a or development-subtree"
+        self._repo_strings = "2a"
 
     def test_info_non_existing(self):
         self.vfs_transport_factory = MemoryServer

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2009-08-12 22:16:29 +0000
+++ bzrlib/tests/blackbox/test_init.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,6 +22,7 @@
 
 from bzrlib import (
     branch as _mod_branch,
+    osutils,
     urlutils,
     )
 from bzrlib.bzrdir import BzrDirMetaFormat1
@@ -74,8 +75,8 @@
 Using shared repository: %s
 """ % (self._default_label, urlutils.local_path_from_url(
             repo.bzrdir.root_transport.external_url())), out)
-        self.assertEndsWith(out, "bzrlib.tests.blackbox.test_init.TestInit."
-            "test_init_at_repository_root/work/repo/\n")
+        cwd = osutils.getcwd()
+        self.assertEndsWith(out, cwd + '/repo/\n')
         self.assertEqual('', err)
         newdir.open_branch()
         newdir.open_workingtree()

=== modified file 'bzrlib/tests/blackbox/test_log.py'
--- bzrlib/tests/blackbox/test_log.py	2009-06-10 03:56:49 +0000
+++ bzrlib/tests/blackbox/test_log.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -536,6 +536,21 @@
 """
         self.check_log(expected, ['-n0', '-r1.1.1..1.1.2'])
 
+    def test_merges_partial_range_ignore_before_lower_bound(self):
+        """Dont show revisions before the lower bound's merged revs"""
+        expected = """\
+    2 Lorem Ipsum\t2005-11-22 [merge]
+      merge branch level1
+
+          1.1.2 Lorem Ipsum\t2005-11-22 [merge]
+                merge branch level2
+
+              1.2.1 Lorem Ipsum\t2005-11-22
+                    in branch level2
+
+"""
+        self.check_log(expected, ['--short', '-n0', '-r1.1.2..2'])
+
 
 class TestLogDiff(TestLog):
 

=== modified file 'bzrlib/tests/blackbox/test_ls.py'
--- bzrlib/tests/blackbox/test_ls.py	2009-05-18 07:48:02 +0000
+++ bzrlib/tests/blackbox/test_ls.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -54,6 +54,7 @@
     def test_ls_basic(self):
         """Test the abilities of 'bzr ls'"""
         self.ls_equals('.bzrignore\na\n')
+        self.ls_equals('.bzrignore\na\n', './')
         self.ls_equals('?        .bzrignore\n'
                        '?        a\n',
                        '--verbose')

=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2009-10-06 14:40:37 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -211,6 +211,22 @@
         self.failUnlessExists('sub/a.txt.OTHER')
         self.failUnlessExists('sub/a.txt.BASE')
 
+    def test_conflict_leaves_base_this_other_files(self):
+        tree, other = self.create_conflicting_branches()
+        self.run_bzr('merge ../other', working_dir='tree',
+                     retcode=1)
+        self.assertFileEqual('a\nb\nc\n', 'tree/fname.BASE')
+        self.assertFileEqual('a\nB\nD\n', 'tree/fname.OTHER')
+        self.assertFileEqual('a\nB\nC\n', 'tree/fname.THIS')
+
+    def test_weave_conflict_leaves_base_this_other_files(self):
+        tree, other = self.create_conflicting_branches()
+        self.run_bzr('merge ../other --weave', working_dir='tree',
+                     retcode=1)
+        self.assertFileEqual('a\nb\nc\n', 'tree/fname.BASE')
+        self.assertFileEqual('a\nB\nD\n', 'tree/fname.OTHER')
+        self.assertFileEqual('a\nB\nC\n', 'tree/fname.THIS')
+
     def test_merge_remember(self):
         """Merge changes from one branch to another, test submit location."""
         tree_a = self.make_branch_and_tree('branch_a')
@@ -589,6 +605,26 @@
         self.run_bzr('merge -d this other -r0..')
         self.failUnlessExists('this/other_file')
 
+    def test_merge_interactive_unlocks_branch(self):
+        this = self.make_branch_and_tree('this')
+        other = self.make_branch_and_tree('other')
+        other.commit('empty commit')
+        self.run_bzr('merge -i -d this other')
+        this.lock_write()
+        this.unlock()
+
+    def test_merge_reversed_revision_range(self):
+        tree = self.make_branch_and_tree(".")
+        for f in ("a", "b"):
+            self.build_tree([f])
+            tree.add(f)
+            tree.commit("added "+f)
+        for context in (".", "", "a"):
+            self.run_bzr("merge -r 1..0 " + context)
+            self.failIfExists("a")
+            tree.revert()
+            self.failUnlessExists("a")
+
 
 class TestMergeForce(tests.TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/blackbox/test_mv.py'
--- bzrlib/tests/blackbox/test_mv.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/blackbox/test_mv.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -487,6 +487,14 @@
         self.assertEqual('bzr: ERROR: --after cannot be specified with'
                          ' --auto.\n', err)
 
+    def test_mv_quiet(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['aaa'])
+        tree.add(['aaa'])
+        out, err = self.run_bzr('mv --quiet aaa bbb')
+        self.assertEqual(out, '')
+        self.assertEqual(err, '')
+
     def test_mv_readonly_lightweight_checkout(self):
         branch = self.make_branch('foo')
         branch = bzrlib.branch.Branch.open(self.get_readonly_url('foo'))

=== modified file 'bzrlib/tests/blackbox/test_non_ascii.py'
--- bzrlib/tests/blackbox/test_non_ascii.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/blackbox/test_non_ascii.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,17 +38,15 @@
 
     def setUp(self):
         super(TestNonAscii, self).setUp()
-        self._orig_encoding = osutils._cached_user_encoding
+        self._check_can_encode_paths()
 
+        self.addCleanup(setattr, osutils, "_cached_user_encoding",
+            osutils._cached_user_encoding)
         osutils._cached_user_encoding = self.encoding
         email = self.info['committer'] + ' <joe@foo.com>'
         os.environ['BZR_EMAIL'] = email.encode(osutils.get_user_encoding())
         self.create_base()
 
-    def tearDown(self):
-        osutils._cached_user_encoding = self._orig_encoding
-        super(TestNonAscii, self).tearDown()
-
     def run_bzr_decode(self, args, encoding=None, fail=False, retcode=None,
                        working_dir=None):
         """Run bzr and decode the output into a particular encoding.
@@ -98,7 +96,7 @@
                     ' using encoding "%s"'
                     % (path, fs_enc))
 
-    def create_base(self):
+    def _check_can_encode_paths(self):
         fs_enc = osutils._fs_enc
         terminal_enc = osutils.get_terminal_encoding()
         fname = self.info['filename']
@@ -118,6 +116,7 @@
                     ' (even though it is valid in filesystem encoding "%s")'
                     % (thing, terminal_enc, fs_enc))
 
+    def create_base(self):
         wt = self.make_branch_and_tree('.')
         self.build_tree_contents([('a', 'foo\n')])
         wt.add('a')
@@ -128,6 +127,7 @@
         wt.add('b')
         wt.commit(self.info['message'])
 
+        fname = self.info['filename']
         self.build_tree_contents([(fname, 'unicode filename\n')])
         wt.add(fname)
         wt.commit(u'And a unicode file\n')

=== modified file 'bzrlib/tests/blackbox/test_pull.py'
--- bzrlib/tests/blackbox/test_pull.py	2009-06-15 06:47:14 +0000
+++ bzrlib/tests/blackbox/test_pull.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,13 +20,18 @@
 import os
 import sys
 
+from bzrlib import (
+    debug,
+    remote,
+    urlutils,
+    )
+
 from bzrlib.branch import Branch
 from bzrlib.directory_service import directories
 from bzrlib.osutils import pathjoin
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.uncommit import uncommit
 from bzrlib.workingtree import WorkingTree
-from bzrlib import urlutils
 
 
 class TestPull(ExternalBase):
@@ -390,4 +395,41 @@
         self.assertLength(18, self.hpss_calls)
         remote = Branch.open('stacked')
         self.assertEndsWith(remote.get_stacked_on_url(), '/parent')
-
+    
+    def test_pull_cross_format_warning(self):
+        """You get a warning for probably slow cross-format pulls.
+        """
+        # this is assumed to be going through InterDifferingSerializer
+        from_tree = self.make_branch_and_tree('from', format='2a')
+        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
+        from_tree.commit(message='first commit')
+        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
+        self.assertContainsRe(err,
+            "(?m)Doing on-the-fly conversion")
+
+    def test_pull_cross_format_warning_no_IDS(self):
+        """You get a warning for probably slow cross-format pulls.
+        """
+        # this simulates what would happen across the network, where
+        # interdifferingserializer is not active
+
+        debug.debug_flags.add('IDS_never')
+        # TestCase take care of restoring them
+
+        from_tree = self.make_branch_and_tree('from', format='2a')
+        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
+        from_tree.commit(message='first commit')
+        out, err = self.run_bzr(['pull', '-d', 'to', 'from'])
+        self.assertContainsRe(err,
+            "(?m)Doing on-the-fly conversion")
+
+    def test_pull_cross_format_from_network(self):
+        self.setup_smart_server_with_call_log()
+        from_tree = self.make_branch_and_tree('from', format='2a')
+        to_tree = self.make_branch_and_tree('to', format='1.14-rich-root')
+        self.assertIsInstance(from_tree.branch, remote.RemoteBranch)
+        from_tree.commit(message='first commit')
+        out, err = self.run_bzr(['pull', '-d', 'to',
+            from_tree.branch.bzrdir.root_transport.base])
+        self.assertContainsRe(err,
+            "(?m)Doing on-the-fly conversion")

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2009-10-02 11:35:02 +0000
+++ bzrlib/tests/blackbox/test_push.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,7 +31,11 @@
     workingtree
     )
 from bzrlib.repofmt import knitrepo
-from bzrlib.tests import http_server
+from bzrlib.tests import (
+    blackbox,
+    http_server,
+    test_foreign,
+    )
 from bzrlib.transport import memory
 
 
@@ -335,6 +339,17 @@
         # The push should have created target/a
         self.failUnlessExists('target/a')
 
+    def test_push_use_existing_into_empty_bzrdir(self):
+        """'bzr push --use-existing-dir' into a dir with an empty .bzr dir
+        fails.
+        """
+        tree = self.create_simple_tree()
+        self.build_tree(['target/', 'target/.bzr/'])
+        self.run_bzr_error(
+            ['Target directory ../target already contains a .bzr directory, '
+             'but it is not valid.'],
+            'push ../target --use-existing-dir', working_dir='tree')
+
     def test_push_onto_repo(self):
         """We should be able to 'bzr push' into an existing bzrdir."""
         tree = self.create_simple_tree()
@@ -569,7 +584,7 @@
 
 class RedirectingMemoryServer(memory.MemoryServer):
 
-    def setUp(self):
+    def start_server(self):
         self._dirs = {'/': None}
         self._files = {}
         self._locks = {}
@@ -583,7 +598,7 @@
         result._locks = self._locks
         return result
 
-    def tearDown(self):
+    def stop_server(self):
         transport.unregister_transport(self._scheme, self._memory_factory)
 
 
@@ -757,3 +772,26 @@
         self.set_config_push_strict('oFF')
         self.assertPushFails(['--strict'])
         self.assertPushSucceeds([])
+
+
+class TestPushForeign(blackbox.ExternalBase):
+
+    def setUp(self):
+        super(TestPushForeign, self).setUp()
+        test_foreign.register_dummy_foreign_for_test(self)
+
+    def make_dummy_builder(self, relpath):
+        builder = self.make_branch_builder(
+            relpath, format=test_foreign.DummyForeignVcsDirFormat())
+        builder.build_snapshot('revid', None,
+            [('add', ('', 'TREE_ROOT', 'directory', None)),
+             ('add', ('foo', 'fooid', 'file', 'bar'))])
+        return builder
+
+    def test_no_roundtripping(self):
+        target_branch = self.make_dummy_builder('dp').get_branch()
+        source_tree = self.make_branch_and_tree("dc")
+        output, error = self.run_bzr("push -d dc dp", retcode=3)
+        self.assertEquals("", output)
+        self.assertEquals(error, "bzr: ERROR: It is not possible to losslessly"
+            " push to dummy. You may want to use dpush instead.\n")

=== modified file 'bzrlib/tests/blackbox/test_remerge.py'
--- bzrlib/tests/blackbox/test_remerge.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_remerge.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -85,7 +85,7 @@
                            'remerge --merge-type weave', retcode=1)
 
         self.failUnlessExists('hello.OTHER')
-        self.failIfExists('hello.BASE')
+        self.failUnless('hello.BASE')
         self.assertFalse('|||||||' in conflict_text)
         self.assertFalse('hi world' in conflict_text)
 

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2009-08-24 22:32:53 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,18 +16,14 @@
 
 """UI tests for the test framework."""
 
-import bzrlib.transport
 from bzrlib import (
     benchmarks,
     tests,
     )
-from bzrlib.errors import ParamikoNotPresent
 from bzrlib.tests import (
-                          SubUnitFeature,
-                          TestCase,
-                          TestCaseInTempDir,
-                          TestSkipped,
-                          )
+    features,
+    stub_sftp,
+    )
 
 
 class SelfTestPatch:
@@ -51,7 +47,7 @@
             tests.selftest = original_selftest
 
 
-class TestOptionsWritingToDisk(TestCaseInTempDir, SelfTestPatch):
+class TestOptionsWritingToDisk(tests.TestCaseInTempDir, SelfTestPatch):
 
     def test_benchmark_runs_benchmark_tests(self):
         """selftest --benchmark should change the suite factory."""
@@ -69,7 +65,7 @@
         self.assertEqual(0, len(lines))
 
 
-class TestOptions(TestCase, SelfTestPatch):
+class TestOptions(tests.TestCase, SelfTestPatch):
 
     def test_load_list(self):
         params = self.get_params_passed_to_core('selftest --load-list foo')
@@ -78,12 +74,9 @@
     def test_transport_set_to_sftp(self):
         # Test that we can pass a transport to the selftest core - sftp
         # version.
-        try:
-            import bzrlib.transport.sftp
-        except ParamikoNotPresent:
-            raise TestSkipped("Paramiko not present")
+        self.requireFeature(features.paramiko)
         params = self.get_params_passed_to_core('selftest --transport=sftp')
-        self.assertEqual(bzrlib.transport.sftp.SFTPAbsoluteServer,
+        self.assertEqual(stub_sftp.SFTPAbsoluteServer,
             params[1]["transport"])
 
     def test_transport_set_to_memory(self):
@@ -116,7 +109,7 @@
         self.assertEqual(['foo', 'bar'], params[1]['starting_with'])
 
     def test_subunit(self):
-        self.requireFeature(SubUnitFeature)
+        self.requireFeature(features.subunit)
         params = self.get_params_passed_to_core('selftest --subunit')
         self.assertEqual(tests.SubUnitBzrRunner, params[1]['runner_class'])
 

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2009-10-02 07:24:29 +0000
+++ bzrlib/tests/blackbox/test_send.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 # Authors: Aaron Bentley
 #
 # This program is free software; you can redistribute it and/or modify
@@ -67,7 +67,7 @@
 
     def get_MD(self, args, cmd=None, wd='branch'):
         out = StringIO(self.run_send(args, cmd=cmd, wd=wd)[0])
-        return merge_directive.MergeDirective.from_lines(out.readlines())
+        return merge_directive.MergeDirective.from_lines(out)
 
     def assertBundleContains(self, revs, args, cmd=None, wd='branch'):
         md = self.get_MD(args, cmd=cmd, wd=wd)
@@ -322,8 +322,7 @@
         out, err = self.run_send(args)
         self.assertEquals(
             'Bundling %d revision(s).\n' % len(revs), err)
-        md = merge_directive.MergeDirective.from_lines(
-                StringIO(out).readlines())
+        md = merge_directive.MergeDirective.from_lines(StringIO(out))
         self.assertEqual('parent', md.base_revision_id)
         br = serializer.read_bundle(StringIO(md.get_raw_bundle()))
         self.assertEqual(set(revs), set(r.revision_id for r in br.revisions))

=== modified file 'bzrlib/tests/blackbox/test_serve.py'
--- bzrlib/tests/blackbox/test_serve.py	2009-09-22 04:25:05 +0000
+++ bzrlib/tests/blackbox/test_serve.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,16 +27,17 @@
 
 from bzrlib import (
     builtins,
+    debug,
     errors,
     osutils,
     revision as _mod_revision,
+    urlutils,
     )
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
 from bzrlib.smart import client, medium
 from bzrlib.smart.server import BzrServerFactory, SmartTCPServer
 from bzrlib.tests import (
-    ParamikoFeature,
     TestCaseWithMemoryTransport,
     TestCaseWithTransport,
     TestSkipped,
@@ -45,7 +46,49 @@
 from bzrlib.transport import get_transport, remote
 
 
-class TestBzrServe(TestCaseWithTransport):
+class TestBzrServeBase(TestCaseWithTransport):
+
+    def run_bzr_serve_then_func(self, serve_args, retcode=0, func=None,
+                                *func_args, **func_kwargs):
+        """Run 'bzr serve', and run the given func in a thread once the server
+        has started.
+        
+        When 'func' terminates, the server will be terminated too.
+        
+        Returns stdout and stderr.
+        """
+        # install hook
+        def on_server_start(backing_urls, tcp_server):
+            t = threading.Thread(
+                target=on_server_start_thread, args=(tcp_server,))
+            t.start()
+        def on_server_start_thread(tcp_server):
+            try:
+                # Run func if set
+                self.tcp_server = tcp_server
+                if not func is None:
+                    try:
+                        func(*func_args, **func_kwargs)
+                    except Exception, e:
+                        # Log errors to make some test failures a little less
+                        # mysterious.
+                        mutter('func broke: %r', e)
+            finally:
+                # Then stop the server
+                mutter('interrupting...')
+                thread.interrupt_main()
+        SmartTCPServer.hooks.install_named_hook(
+            'server_started_ex', on_server_start,
+            'run_bzr_serve_then_func hook')
+        # start a TCP server
+        try:
+            out, err = self.run_bzr(['serve'] + list(serve_args))
+        except KeyboardInterrupt, e:
+            out, err = e.args
+        return out, err
+
+
+class TestBzrServe(TestBzrServeBase):
 
     def setUp(self):
         super(TestBzrServe, self).setUp()
@@ -88,7 +131,9 @@
             finish_bzr_subprocess, a client for the server, and a transport.
         """
         # Serve from the current directory
-        process = self.start_bzr_subprocess(['serve', '--inet'])
+        args = ['serve', '--inet']
+        args.extend(extra_options)
+        process = self.start_bzr_subprocess(args)
 
         # Connect to the server
         # We use this url because while this is no valid URL to connect to this
@@ -118,6 +163,13 @@
         url = 'bzr://localhost:%d/' % port
         self.permit_url(url)
         return process, url
+    
+    def test_bzr_serve_quiet(self):
+        self.make_branch('.')
+        args = ['--port', 'localhost:0', '--quiet']
+        out, err = self.run_bzr_serve_then_func(args, retcode=3)
+        self.assertEqual('', out)
+        self.assertEqual('', err)
 
     def test_bzr_serve_inet_readonly(self):
         """bzr server should provide a read only filesystem by default."""
@@ -131,9 +183,10 @@
 
         process, transport = self.start_server_inet(['--allow-writes'])
 
-        # We get a working branch
+        # We get a working branch, and can create a directory
         branch = BzrDir.open_from_transport(transport).open_branch()
         self.make_read_requests(branch)
+        transport.mkdir('adir')
         self.assertInetServerShutsdownCleanly(process)
 
     def test_bzr_serve_port_readonly(self):
@@ -166,8 +219,23 @@
         self.make_read_requests(branch)
         self.assertServerFinishesCleanly(process)
 
-
-class TestCmdServeChrooting(TestCaseWithTransport):
+    def test_bzr_serve_dhpss(self):
+        # This is a smoke test that the server doesn't crash when run with
+        # -Dhpss, and does drop some hpss logging to the file.
+        self.make_branch('.')
+        log_fname = os.getcwd() + '/server.log'
+        self._captureVar('BZR_LOG', log_fname)
+        process, transport = self.start_server_inet(['-Dhpss'])
+        branch = BzrDir.open_from_transport(transport).open_branch()
+        self.make_read_requests(branch)
+        self.assertInetServerShutsdownCleanly(process)
+        f = open(log_fname, 'rb')
+        content = f.read()
+        f.close()
+        self.assertContainsRe(content, r'hpss request: \[[0-9-]+\]')
+
+
+class TestCmdServeChrooting(TestBzrServeBase):
 
     def test_serve_tcp(self):
         """'bzr serve' wraps the given --directory in a ChrootServer.
@@ -182,47 +250,12 @@
             ['--port', '127.0.0.1:0',
              '--directory', t.local_abspath('server-root'),
              '--allow-writes'],
-            self.when_server_started)
+            func=self.when_server_started)
         # The when_server_started method issued a find_repositoryV3 that should
         # fail with 'norepository' because there are no repositories inside the
         # --directory.
         self.assertEqual(('norepository',), self.client_resp)
 
-    def run_bzr_serve_then_func(self, serve_args, func, *func_args,
-            **func_kwargs):
-        """Run 'bzr serve', and run the given func in a thread once the server
-        has started.
-        
-        When 'func' terminates, the server will be terminated too.
-        """
-        # install hook
-        def on_server_start(backing_urls, tcp_server):
-            t = threading.Thread(
-                target=on_server_start_thread, args=(tcp_server,))
-            t.start()
-        def on_server_start_thread(tcp_server):
-            try:
-                # Run func
-                self.tcp_server = tcp_server
-                try:
-                    func(*func_args, **func_kwargs)
-                except Exception, e:
-                    # Log errors to make some test failures a little less
-                    # mysterious.
-                    mutter('func broke: %r', e)
-            finally:
-                # Then stop the server
-                mutter('interrupting...')
-                thread.interrupt_main()
-        SmartTCPServer.hooks.install_named_hook(
-            'server_started_ex', on_server_start,
-            'run_bzr_serve_then_func hook')
-        # start a TCP server
-        try:
-            self.run_bzr(['serve'] + list(serve_args))
-        except KeyboardInterrupt:
-            pass
-
     def when_server_started(self):
         # Connect to the TCP server and issue some requests and see what comes
         # back.
@@ -254,7 +287,7 @@
         return path
 
     def make_test_server(self, base_path='/'):
-        """Make and setUp a BzrServerFactory, backed by a memory transport, and
+        """Make and start a BzrServerFactory, backed by a memory transport, and
         creat '/home/user' in that transport.
         """
         bzr_server = BzrServerFactory(
@@ -278,23 +311,26 @@
         (optionally decorated with 'readonly+').  BzrServerFactory can
         determine the original --directory from that transport.
         """
+        # URLs always include the trailing slash, and get_base_path returns it
+        base_dir = osutils.abspath('/a/b/c') + '/'
+        base_url = urlutils.local_path_to_url(base_dir) + '/'
         # Define a fake 'protocol' to capture the transport that cmd_serve
         # passes to serve_bzr.
         def capture_transport(transport, host, port, inet):
             self.bzr_serve_transport = transport
         cmd = builtins.cmd_serve()
         # Read-only
-        cmd.run(directory='/a/b/c', protocol=capture_transport)
+        cmd.run(directory=base_dir, protocol=capture_transport)
         server_maker = BzrServerFactory()
         self.assertEqual(
-            'readonly+file:///a/b/c/', self.bzr_serve_transport.base)
+            'readonly+%s' % base_url, self.bzr_serve_transport.base)
         self.assertEqual(
-            u'/a/b/c/', server_maker.get_base_path(self.bzr_serve_transport))
+            base_dir, server_maker.get_base_path(self.bzr_serve_transport))
         # Read-write
-        cmd.run(directory='/a/b/c', protocol=capture_transport,
+        cmd.run(directory=base_dir, protocol=capture_transport,
             allow_writes=True)
         server_maker = BzrServerFactory()
-        self.assertEqual('file:///a/b/c/', self.bzr_serve_transport.base)
-        self.assertEqual(
-            u'/a/b/c/', server_maker.get_base_path(self.bzr_serve_transport))
+        self.assertEqual(base_url, self.bzr_serve_transport.base)
+        self.assertEqual(base_dir,
+            server_maker.get_base_path(self.bzr_serve_transport))
 

=== modified file 'bzrlib/tests/blackbox/test_shared_repository.py'
--- bzrlib/tests/blackbox/test_shared_repository.py	2009-09-23 23:58:10 +0000
+++ bzrlib/tests/blackbox/test_shared_repository.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 import os
 
-from bzrlib.bzrdir import BzrDir
+from bzrlib.bzrdir import BzrDir, BzrDirMetaFormat1
 import bzrlib.errors as errors
 from bzrlib.tests import TestCaseInTempDir
 
@@ -120,3 +120,21 @@
         # become necessary for this use case. Please do not adjust this number
         # upwards without agreement from bzr's network support maintainers.
         self.assertLength(15, self.hpss_calls)
+
+    def test_notification_on_branch_from_repository(self):
+        out, err = self.run_bzr("init-repository -q a")
+        self.assertEqual(out, "")
+        self.assertEqual(err, "")
+        dir = BzrDir.open('a')
+        dir.open_repository() # there is a repository there
+        e = self.assertRaises(errors.NotBranchError, dir.open_branch)
+        self.assertContainsRe(str(e), "location is a repository")
+
+    def test_notification_on_branch_from_nonrepository(self):
+        fmt = BzrDirMetaFormat1()
+        t = self.get_transport()
+        t.mkdir('a')
+        dir = fmt.initialize_on_transport(t.clone('a'))
+        self.assertRaises(errors.NoRepositoryPresent, dir.open_repository)
+        e = self.assertRaises(errors.NotBranchError, dir.open_branch)
+        self.assertNotContainsRe(str(e), "location is a repository")

=== modified file 'bzrlib/tests/blackbox/test_shelve.py'
--- bzrlib/tests/blackbox/test_shelve.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_shelve.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,8 @@
 
 from bzrlib import shelf
 from bzrlib.tests import TestCaseWithTransport
+from bzrlib.tests.script import ScriptRunner
+
 
 class TestShelveList(TestCaseWithTransport):
 
@@ -65,6 +67,27 @@
         self.failIfExists('file')
         self.assertIs(None, tree.get_shelf_manager().last_shelf())
 
+    def test_unshelve_keep(self):
+        # https://bugs.edge.launchpad.net/bzr/+bug/492091
+        tree = self.make_branch_and_tree('.')
+        # shelve apparently unhappy working with a tree with no root yet
+        tree.commit('make root')
+        self.build_tree(['file'])
+
+        sr = ScriptRunner()
+        sr.run_script(self, '''
+$ bzr add file
+$ bzr shelve --all -m Foo
+$ bzr shelve --list
+  1: Foo
+$ bzr unshelve --keep
+$ bzr shelve --list
+  1: Foo
+$ cat file
+contents of file
+''')
+
+
 
 class TestShelveRelpath(TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/blackbox/test_switch.py'
--- bzrlib/tests/blackbox/test_switch.py	2009-07-09 15:18:57 +0000
+++ bzrlib/tests/blackbox/test_switch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -22,10 +22,20 @@
 
 from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.blackbox import ExternalBase
+from bzrlib.directory_service import directories
 
 
 class TestSwitch(ExternalBase):
 
+    def _create_sample_tree(self):
+        tree = self.make_branch_and_tree('branch-1')
+        self.build_tree(['branch-1/file-1', 'branch-1/file-2'])
+        tree.add('file-1')
+        tree.commit('rev1')
+        tree.add('file-2')
+        tree.commit('rev2')
+        return tree
+
     def test_switch_up_to_date_light_checkout(self):
         self.make_branch_and_tree('branch')
         self.run_bzr('branch branch branch2')
@@ -134,6 +144,26 @@
         self.assertEqual(branchb_id, checkout.last_revision())
         self.assertEqual(tree2.branch.base, checkout.branch.get_bound_location())
 
+    def test_switch_revision(self):
+        tree = self._create_sample_tree()
+        checkout = tree.branch.create_checkout('checkout', lightweight=True)
+        self.run_bzr(['switch', 'branch-1', '-r1'], working_dir='checkout')
+        self.failUnlessExists('checkout/file-1')
+        self.failIfExists('checkout/file-2')
+
+    def test_switch_only_revision(self):
+        tree = self._create_sample_tree()
+        checkout = tree.branch.create_checkout('checkout', lightweight=True)
+        self.failUnlessExists('checkout/file-1')
+        self.failUnlessExists('checkout/file-2')
+        self.run_bzr(['switch', '-r1'], working_dir='checkout')
+        self.failUnlessExists('checkout/file-1')
+        self.failIfExists('checkout/file-2')
+        # Check that we don't accept a range
+        self.run_bzr_error(
+            ['bzr switch --revision takes exactly one revision identifier'],
+            ['switch', '-r0..2'], working_dir='checkout')
+
     def prepare_lightweight_switch(self):
         branch = self.make_branch('branch')
         branch.create_checkout('tree', lightweight=True)
@@ -183,3 +213,15 @@
         # The new branch should have been created at the same level as
         # 'branch', because we did not have a '/' segment
         self.assertEqual(branch.base[:-1] + '2/', tree.branch.base)
+
+    def test_create_branch_directory_services(self):
+        branch = self.make_branch('branch')
+        tree = branch.create_checkout('tree', lightweight=True)
+        class FooLookup(object):
+            def look_up(self, name, url):
+                return 'foo-'+name
+        directories.register('foo:', FooLookup, 'Create branches named foo-')
+        self.addCleanup(directories.remove, 'foo:')
+        self.run_bzr('switch -b foo:branch2', working_dir='tree')
+        tree = WorkingTree.open('tree')
+        self.assertEndsWith(tree.branch.base, 'foo-branch2/')

=== modified file 'bzrlib/tests/blackbox/test_too_much.py'
--- bzrlib/tests/blackbox/test_too_much.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/blackbox/test_too_much.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -44,11 +44,6 @@
     )
 from bzrlib.branch import Branch
 from bzrlib.errors import BzrCommandError
-from bzrlib.osutils import (
-    has_symlinks,
-    pathjoin,
-    terminal_width,
-    )
 from bzrlib.tests.http_utils import TestCaseWithWebserver
 from bzrlib.tests.test_sftp_transport import TestCaseWithSFTPServer
 from bzrlib.tests.blackbox import ExternalBase
@@ -87,7 +82,7 @@
         os.rmdir('revertdir')
         self.run_bzr('revert')
 
-        if has_symlinks():
+        if osutils.has_symlinks():
             os.symlink('/unlikely/to/exist', 'symlink')
             self.run_bzr('add symlink')
             self.run_bzr('commit -m f')
@@ -374,7 +369,7 @@
         self.run_bzr('init')
 
         self.assertIsSameRealPath(self.run_bzr('root')[0].rstrip(),
-                                  pathjoin(self.test_dir, 'branch1'))
+                                  osutils.pathjoin(self.test_dir, 'branch1'))
 
         progress("status of new file")
 
@@ -443,9 +438,10 @@
 
         log_out = self.run_bzr('log --line')[0]
         # determine the widest line we want
-        max_width = terminal_width() - 1
-        for line in log_out.splitlines():
-            self.assert_(len(line) <= max_width, len(line))
+        max_width = osutils.terminal_width()
+        if max_width is not None:
+            for line in log_out.splitlines():
+                self.assert_(len(line) <= max_width - 1, len(line))
         self.assert_("this is my new commit and" not in log_out)
         self.assert_("this is my new commit" in log_out)
 
@@ -462,7 +458,7 @@
 
         self.run_bzr('info')
 
-        if has_symlinks():
+        if osutils.has_symlinks():
             progress("symlinks")
             mkdir('symlinks')
             chdir('symlinks')

=== modified file 'bzrlib/tests/blackbox/test_update.py'
--- bzrlib/tests/blackbox/test_update.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/blackbox/test_update.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -19,39 +19,60 @@
 """Tests for the update command of bzr."""
 
 import os
-
-from bzrlib import branch, bzrdir
-from bzrlib.tests.blackbox import ExternalBase
-from bzrlib.workingtree import WorkingTree
-
-
-class TestUpdate(ExternalBase):
+import re
+
+from bzrlib import (
+    branch,
+    bzrdir,
+    osutils,
+    tests,
+    urlutils,
+    workingtree,
+    )
+from bzrlib.tests.script import ScriptRunner
+
+
+class TestUpdate(tests.TestCaseWithTransport):
 
     def test_update_standalone_trivial(self):
         self.make_branch_and_tree('.')
         out, err = self.run_bzr('update')
-        self.assertEqual('Tree is up to date at revision 0.\n', err)
+        self.assertEqual(
+            'Tree is up to date at revision 0 of branch %s\n' % self.test_dir,
+            err)
+        self.assertEqual('', out)
+
+    def test_update_quiet(self):
+        self.make_branch_and_tree('.')
+        out, err = self.run_bzr('update --quiet')
+        self.assertEqual('', err)
         self.assertEqual('', out)
 
     def test_update_standalone_trivial_with_alias_up(self):
         self.make_branch_and_tree('.')
         out, err = self.run_bzr('up')
-        self.assertEqual('Tree is up to date at revision 0.\n', err)
+        self.assertEqual('Tree is up to date at revision 0 of branch %s\n'
+                         % self.test_dir,
+                         err)
         self.assertEqual('', out)
 
     def test_update_up_to_date_light_checkout(self):
         self.make_branch_and_tree('branch')
         self.run_bzr('checkout --lightweight branch checkout')
         out, err = self.run_bzr('update checkout')
-        self.assertEqual('Tree is up to date at revision 0.\n', err)
+        self.assertEqual('Tree is up to date at revision 0 of branch %s\n'
+                         % osutils.pathjoin(self.test_dir, 'branch'),
+                         err)
         self.assertEqual('', out)
 
     def test_update_up_to_date_checkout(self):
         self.make_branch_and_tree('branch')
         self.run_bzr('checkout branch checkout')
-        out, err = self.run_bzr('update checkout')
-        self.assertEqual('Tree is up to date at revision 0.\n', err)
-        self.assertEqual('', out)
+        sr = ScriptRunner()
+        sr.run_script(self, '''
+$ bzr update checkout
+2>Tree is up to date at revision 0 of branch .../branch
+''')
 
     def test_update_out_of_date_standalone_tree(self):
         # FIXME the default format has to change for this to pass
@@ -65,9 +86,11 @@
         # now branch should be out of date
         out,err = self.run_bzr('update branch')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '\+N  file')
-        self.assertEndsWith(err, 'All changes applied successfully.\n'
-                         'Updated to revision 1.\n')
+        self.assertEqualDiff("""+N  file
+All changes applied successfully.
+Updated to revision 1 of branch %s
+""" % osutils.pathjoin(self.test_dir, 'branch',),
+                         err)
         self.failUnlessExists('branch/file')
 
     def test_update_out_of_date_light_checkout(self):
@@ -80,9 +103,11 @@
         self.run_bzr('commit -m add-file checkout')
         # now checkout2 should be out of date
         out,err = self.run_bzr('update checkout2')
-        self.assertContainsRe(err, '\+N  file')
-        self.assertEndsWith(err, 'All changes applied successfully.\n'
-                         'Updated to revision 1.\n')
+        self.assertEqualDiff('''+N  file
+All changes applied successfully.
+Updated to revision 1 of branch %s
+''' % osutils.pathjoin(self.test_dir, 'branch',),
+                         err)
         self.assertEqual('', out)
 
     def test_update_conflicts_returns_2(self):
@@ -104,11 +129,12 @@
         a_file.write('Bar')
         a_file.close()
         out,err = self.run_bzr('update checkout2', retcode=1)
-        self.assertContainsRe(err, 'M  file')
-        self.assertEqual(['1 conflicts encountered.',
-                          'Updated to revision 2.'],
-                         err.split('\n')[-3:-1])
-        self.assertContainsRe(err, 'Text conflict in file\n')
+        self.assertEqualDiff(''' M  file
+Text conflict in file
+1 conflicts encountered.
+Updated to revision 2 of branch %s
+''' % osutils.pathjoin(self.test_dir, 'branch',),
+                         err)
         self.assertEqual('', out)
 
     def test_smoke_update_checkout_bound_branch_local_commits(self):
@@ -118,11 +144,11 @@
         # make a bound branch
         self.run_bzr('checkout master child')
         # get an object form of child
-        child = WorkingTree.open('child')
+        child = workingtree.WorkingTree.open('child')
         # check that out
         self.run_bzr('checkout --lightweight child checkout')
         # get an object form of the checkout to manipulate
-        wt = WorkingTree.open('checkout')
+        wt = workingtree.WorkingTree.open('checkout')
         # change master
         a_file = file('master/file', 'wt')
         a_file.write('Foo')
@@ -145,11 +171,14 @@
         # get all three files and a pending merge.
         out, err = self.run_bzr('update checkout')
         self.assertEqual('', out)
-        self.assertContainsRe(err, '\+N  file')
-        self.assertContainsRe(err, '\+N  file_b')
-        self.assertContainsRe(err, 'Updated to revision 1.\n'
-                                   'Your local commits will now show as'
-                                   ' pending merges')
+        self.assertEqualDiff("""+N  file
+All changes applied successfully.
++N  file_b
+All changes applied successfully.
+Updated to revision 1 of branch %s
+Your local commits will now show as pending merges with 'bzr status', and can be committed with 'bzr commit'.
+""" % osutils.pathjoin(self.test_dir, 'master',),
+                         err)
         self.assertEqual([master_tip, child_tip], wt.get_parent_ids())
         self.failUnlessExists('checkout/file')
         self.failUnlessExists('checkout/file_b')
@@ -195,9 +224,11 @@
         # merges, because they were real merges
         out, err = self.run_bzr('update')
         self.assertEqual('', out)
-        self.assertEndsWith(err, 'All changes applied successfully.\n'
-                         'Updated to revision 2.\n')
-        self.assertContainsRe(err, r'\+N  file3')
+        self.assertEqualDiff('''+N  file3
+All changes applied successfully.
+Updated to revision 2 of branch %s
+''' % osutils.pathjoin(self.test_dir, 'master',),
+                         err)
         # The pending merges should still be there
         self.assertEqual(['o2'], checkout1.get_parent_ids()[1:])
 
@@ -209,3 +240,78 @@
                                                    lightweight=True)
         tree.commit('empty commit')
         self.run_bzr('update checkout')
+
+    def test_update_dash_r(self):
+        # Test that 'bzr update' works correctly when you have
+        # an update in the master tree, and a lightweight checkout
+        # which has merged another branch
+        master = self.make_branch_and_tree('master')
+        os.chdir('master')
+        self.build_tree(['./file1'])
+        master.add(['file1'])
+        master.commit('one', rev_id='m1')
+        self.build_tree(['./file2'])
+        master.add(['file2'])
+        master.commit('two', rev_id='m2')
+
+        sr = ScriptRunner()
+        sr.run_script(self, '''
+$ bzr update -r 1
+2>-D  file2
+2>All changes applied successfully.
+2>Updated to revision 1 of .../master
+''')
+        self.failUnlessExists('./file1')
+        self.failIfExists('./file2')
+        self.assertEquals(['m1'], master.get_parent_ids())
+
+    def test_update_dash_r_outside_history(self):
+        # Test that 'bzr update' works correctly when you have
+        # an update in the master tree, and a lightweight checkout
+        # which has merged another branch
+        master = self.make_branch_and_tree('master')
+        self.build_tree(['master/file1'])
+        master.add(['file1'])
+        master.commit('one', rev_id='m1')
+
+        # Create a second branch, with an extra commit
+        other = master.bzrdir.sprout('other').open_workingtree()
+        self.build_tree(['other/file2'])
+        other.add(['file2'])
+        other.commit('other2', rev_id='o2')
+
+        os.chdir('master')
+        self.run_bzr('merge ../other')
+        master.commit('merge', rev_id='merge')
+
+        out, err = self.run_bzr('update -r revid:o2',
+                                retcode=3)
+        self.assertEqual('', out)
+        self.assertEqual('bzr: ERROR: branch has no revision o2\n'
+                         'bzr update --revision only works'
+                         ' for a revision in the branch history\n',
+                         err)
+
+    def test_update_dash_r_in_master(self):
+        # Test that 'bzr update' works correctly when you have
+        # an update in the master tree,
+        master = self.make_branch_and_tree('master')
+        self.build_tree(['master/file1'])
+        master.add(['file1'])
+        master.commit('one', rev_id='m1')
+
+        self.run_bzr('checkout master checkout')
+
+        # add a revision in the master.
+        self.build_tree(['master/file2'])
+        master.add(['file2'])
+        master.commit('two', rev_id='m2')
+
+        os.chdir('checkout')
+        sr = ScriptRunner()
+        sr.run_script(self, '''
+$ bzr update -r revid:m2
+2>+N  file2
+2>All changes applied successfully.
+2>Updated to revision 2 of branch .../master
+''')

=== modified file 'bzrlib/tests/commands/test_branch.py'
--- bzrlib/tests/commands/test_branch.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_branch.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,16 +28,16 @@
 
     def test_branch_remote_local(self):
         cmd = cmd_branch()
-        cmd.run(self.get_url('branch'), 'local')
+        cmd.run_direct(self.get_url('branch'), 'local')
         self.assertEquals(1, len(self.connections))
 
     def test_branch_local_remote(self):
         cmd = cmd_branch()
-        cmd.run('branch', self.get_url('remote'))
+        cmd.run_direct('branch', self.get_url('remote'))
         self.assertEquals(1, len(self.connections))
 
     def test_branch_remote_remote(self):
         cmd = cmd_branch()
-        cmd.run(self.get_url('branch'), self.get_url('remote'))
+        cmd.run_direct(self.get_url('branch'), self.get_url('remote'))
         self.assertEquals(2, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_cat.py'
--- bzrlib/tests/commands/test_cat.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_cat.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -50,7 +50,7 @@
         self.start_logging_connections()
 
         cmd = cmd_cat()
-        cmd.run(self.get_url('branch/foo'))
+        cmd.run_direct(self.get_url('branch/foo'))
         self.assertEquals(1, len(self.connections))
         self.assertEquals('foo', self.outf.getvalue())
 

=== modified file 'bzrlib/tests/commands/test_checkout.py'
--- bzrlib/tests/commands/test_checkout.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_checkout.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,7 +27,7 @@
         self.start_logging_connections()
 
         cmd = cmd_checkout()
-        cmd.run(self.get_url('branch1'), 'local')
+        cmd.run_direct(self.get_url('branch1'), 'local')
         self.assertEquals(1, len(self.connections))
 
     def test_checkout_lightweight(self):
@@ -36,6 +36,6 @@
         self.start_logging_connections()
 
         cmd = cmd_checkout()
-        cmd.run(self.get_url('branch1'), 'local', lightweight=True)
+        cmd.run_direct(self.get_url('branch1'), 'local', lightweight=True)
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_commit.py'
--- bzrlib/tests/commands/test_commit.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_commit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -42,7 +42,7 @@
         # commit do not provide a directory parameter, we have to change dir
         # manually
         os.chdir('local')
-        commit.run(message=u'empty commit', unchanged=True)
+        commit.run_direct(message=u'empty commit', unchanged=True)
         self.assertEquals(1, len(self.connections))
 
     def test_commit_both_modified(self):

=== modified file 'bzrlib/tests/commands/test_init.py'
--- bzrlib/tests/commands/test_init.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_init.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,6 +30,6 @@
         cmd = cmd_init()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = tests.StringIOWrapper()
-        cmd.run(self.get_url())
+        cmd.run_direct(self.get_url())
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_init_repository.py'
--- bzrlib/tests/commands/test_init_repository.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_init_repository.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,6 +30,6 @@
         cmd = cmd_init_repository()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = tests.StringIOWrapper()
-        cmd.run(self.get_url())
+        cmd.run_direct(self.get_url())
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_merge.py'
--- bzrlib/tests/commands/test_merge.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_merge.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -34,6 +34,6 @@
         cmd = cmd_merge()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = StringIOWrapper()
-        cmd.run(self.get_url('branch1'), directory='branch2')
+        cmd.run_direct(self.get_url('branch1'), directory='branch2')
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_missing.py'
--- bzrlib/tests/commands/test_missing.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_missing.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -33,6 +33,6 @@
         cmd = cmd_missing()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = self.make_utf8_encoded_stringio()
-        cmd.run(self.get_url('branch2'))
+        cmd.run_direct(self.get_url('branch2'))
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_pull.py'
--- bzrlib/tests/commands/test_pull.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_pull.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -35,7 +35,7 @@
         cmd = builtins.cmd_pull()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = tests.StringIOWrapper()
-        cmd.run(self.get_url('branch1'), directory='branch2')
+        cmd.run_direct(self.get_url('branch1'), directory='branch2')
         self.assertEquals(1, len(self.connections))
 
     def test_pull_with_bound_branch(self):
@@ -53,6 +53,6 @@
         pull = builtins.cmd_pull()
         # We don't care about the ouput but 'outf' should be defined
         pull.outf = tests.StringIOWrapper()
-        pull.run(self.get_url('remote'), directory='local')
+        pull.run_direct(self.get_url('remote'), directory='local')
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/commands/test_push.py'
--- bzrlib/tests/commands/test_push.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_push.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,7 +30,7 @@
         cmd = cmd_push()
         # We don't care about the ouput but 'outf' should be defined
         cmd.outf = tests.StringIOWrapper()
-        cmd.run(self.get_url('remote'), directory='branch')
+        cmd.run_direct(self.get_url('remote'), directory='branch')
         self.assertEquals(1, len(self.connections))
 
     def test_push_onto_stacked(self):
@@ -41,6 +41,6 @@
 
         cmd = cmd_push()
         cmd.outf = tests.StringIOWrapper()
-        cmd.run(self.get_url('remote'), directory='source',
+        cmd.run_direct(self.get_url('remote'), directory='source',
                 stacked_on=self.get_url('base'))
         self.assertEqual(1, len(self.connections))

=== modified file 'bzrlib/tests/commands/test_update.py'
--- bzrlib/tests/commands/test_update.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/commands/test_update.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 from bzrlib import (
     branch,
     builtins,
+    tests,
     )
 from bzrlib.tests import transport_util
 
@@ -36,7 +37,9 @@
         self.start_logging_connections()
 
         update = builtins.cmd_update()
+        # update needs the encoding from outf to print URLs
+        update.outf = tests.StringIOWrapper()
         # update calls it 'dir' where other commands calls it 'directory'
-        update.run(dir='local')
+        update.run_direct(dir='local')
         self.assertEquals(1, len(self.connections))
 

=== modified file 'bzrlib/tests/features.py'
--- bzrlib/tests/features.py	2009-08-20 04:57:58 +0000
+++ bzrlib/tests/features.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,21 +15,13 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-from bzrlib.tests import Feature
-
-
-class _ApportFeature(Feature):
-    
-    def _probe(self):
-        try:
-            import apport
-        except ImportError, e:
-            return False
-        else:
-            return True
-
-    def feature_name(self):
-        return 'apport'
-
-
-ApportFeature = _ApportFeature()
+from bzrlib import tests
+from bzrlib.symbol_versioning import deprecated_in
+
+
+apport = tests.ModuleAvailableFeature('apport')
+ApportFeature = tests._CompatabilityThunkFeature('bzrlib.tests.features',
+    'ApportFeature', 'bzrlib.tests.features.apport', deprecated_in((2,1,0)))
+paramiko = tests.ModuleAvailableFeature('paramiko')
+pycurl = tests.ModuleAvailableFeature('pycurl')
+subunit = tests.ModuleAvailableFeature('subunit')

=== modified file 'bzrlib/tests/ftp_server/__init__.py'
--- bzrlib/tests/ftp_server/__init__.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/ftp_server/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -66,10 +66,10 @@
     never called).
     """
 
-    def setUp(self, vfs_server=None):
+    def start_server(self, vfs_server=None):
         pass
 
-    def tearDown(self):
+    def stop_server(self):
         pass
 
     def get_url(self):

=== modified file 'bzrlib/tests/ftp_server/medusa_based.py'
--- bzrlib/tests/ftp_server/medusa_based.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/ftp_server/medusa_based.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -213,6 +213,8 @@
 class FTPTestServer(transport.Server):
     """Common code for FTP server facilities."""
 
+    no_unicode_support = True
+
     def __init__(self):
         self._root = None
         self._ftp_server = None
@@ -233,7 +235,7 @@
         """This is used by medusa.ftp_server to log connections, etc."""
         self.logs.append(message)
 
-    def setUp(self, vfs_server=None):
+    def start_server(self, vfs_server=None):
         from bzrlib.transport.local import LocalURLServer
         if not (vfs_server is None or isinstance(vfs_server, LocalURLServer)):
             raise AssertionError(
@@ -255,8 +257,7 @@
         self._async_thread.setDaemon(True)
         self._async_thread.start()
 
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
+    def stop_server(self):
         self._ftp_server.close()
         asyncore.close_all()
         self._async_thread.join()

=== modified file 'bzrlib/tests/ftp_server/pyftpdlib_based.py'
--- bzrlib/tests/ftp_server/pyftpdlib_based.py	2009-10-06 08:24:14 +0000
+++ bzrlib/tests/ftp_server/pyftpdlib_based.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -50,14 +50,15 @@
 
     def listdir(self, path):
         """List the content of a directory."""
-        # FIXME: need tests with unicode paths
         return [osutils.safe_utf8(s) for s in os.listdir(path)]
 
     def fs2ftp(self, fspath):
-        p = ftpserver.AbstractedFS.fs2ftp(self, fspath)
-        # FIXME: need tests with unicode paths
+        p = ftpserver.AbstractedFS.fs2ftp(self, osutils.safe_unicode(fspath))
         return osutils.safe_utf8(p)
 
+    def ftp2fs(self, ftppath):
+        p = osutils.safe_unicode(ftppath)
+        return ftpserver.AbstractedFS.ftp2fs(self, p)
 
 class BzrConformingFTPHandler(ftpserver.FTPHandler):
 
@@ -156,7 +157,7 @@
         """This is used by ftp_server to log connections, etc."""
         self.logs.append(message)
 
-    def setUp(self, vfs_server=None):
+    def start_server(self, vfs_server=None):
         from bzrlib.transport.local import LocalURLServer
         if not (vfs_server is None or isinstance(vfs_server, LocalURLServer)):
             raise AssertionError(
@@ -186,8 +187,8 @@
         self._ftpd_starting.acquire()
         self._ftpd_starting.release()
 
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
+    def stop_server(self):
+        """See bzrlib.transport.Server.stop_server."""
         # Tell the server to stop, but also close the server socket for tests
         # that start the server but never initiate a connection. Closing the
         # socket should be done first though, to avoid further connections.
@@ -196,7 +197,7 @@
         self._ftpd_thread.join()
 
     def _run_server(self):
-        """Run the server until tearDown is called, shut it down properly then.
+        """Run the server until stop_server is called, shut it down properly then.
         """
         self._ftpd_running = True
         self._ftpd_starting.release()

=== modified file 'bzrlib/tests/http_server.py'
--- bzrlib/tests/http_server.py	2009-07-08 15:24:31 +0000
+++ bzrlib/tests/http_server.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -318,7 +318,7 @@
         self.test_case_server = test_case_server
         self._home_dir = test_case_server._home_dir
 
-    def tearDown(self):
+    def stop_server(self):
          """Called to clean-up the server.
 
          Since the server may be (surely is, even) in a blocking listen, we
@@ -347,7 +347,7 @@
              # 'Socket is not connected' can also occur on OSX, with a
              # "regular" ENOTCONN (when something went wrong during test case
              # setup leading to self.setUp() *not* being called but
-             # self.tearDown() still being called -- vila20081106
+             # self.stop_server() still being called -- vila20081106
              if not len(e.args) or e.args[0] not in (errno.ENOTCONN, 10057):
                  raise
          # Let the server properly close the socket
@@ -462,7 +462,7 @@
                 raise httplib.UnknownProtocol(proto_vers)
             else:
                 self._httpd = self.create_httpd(serv_cls, rhandler)
-            host, self.port = self._httpd.socket.getsockname()
+            self.host, self.port = self._httpd.socket.getsockname()
         return self._httpd
 
     def _http_start(self):
@@ -494,13 +494,16 @@
             except socket.timeout:
                 pass
             except (socket.error, select.error), e:
-               if e[0] == errno.EBADF:
-                   # Starting with python-2.6, handle_request may raise socket
-                   # or select exceptions when the server is shut down (as we
-                   # do).
-                   pass
-               else:
-                   raise
+                if (e[0] == errno.EBADF
+                    or (sys.platform == 'win32' and e[0] == 10038)):
+                    # Starting with python-2.6, handle_request may raise socket
+                    # or select exceptions when the server is shut down (as we
+                    # do).
+                    # 10038 = WSAENOTSOCK
+                    # http://msdn.microsoft.com/en-us/library/ms740668%28VS.85%29.aspx
+                    pass
+                else:
+                    raise
 
     def _get_remote_url(self, path):
         path_parts = path.split(os.path.sep)
@@ -518,8 +521,8 @@
         """Capture Server log output."""
         self.logs.append(format % args)
 
-    def setUp(self, backing_transport_server=None):
-        """See bzrlib.transport.Server.setUp.
+    def start_server(self, backing_transport_server=None):
+        """See bzrlib.transport.Server.start_server.
 
         :param backing_transport_server: The transport that requests over this
             protocol should be forwarded to. Note that this is currently not
@@ -554,9 +557,8 @@
         self._http_starting.release()
         self.logs = []
 
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
-        self._httpd.tearDown()
+    def stop_server(self):
+        self._httpd.stop_server()
         self._http_running = False
         # We don't need to 'self._http_thread.join()' here since the thread is
         # a daemonic one and will be garbage collected anyway. Joining just

=== modified file 'bzrlib/tests/http_utils.py'
--- bzrlib/tests/http_utils.py	2009-08-27 22:17:35 +0000
+++ bzrlib/tests/http_utils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -58,12 +58,12 @@
         """Hand the request off to a smart server instance."""
         backing = get_transport(self.server.test_case_server._home_dir)
         chroot_server = chroot.ChrootServer(backing)
-        chroot_server.setUp()
+        chroot_server.start_server()
         try:
             t = get_transport(chroot_server.get_url())
             self.do_POST_inner(t)
         finally:
-            chroot_server.tearDown()
+            chroot_server.stop_server()
 
     def do_POST_inner(self, chrooted_transport):
         self.send_response(200)

=== modified file 'bzrlib/tests/per_branch/test_hooks.py'
--- bzrlib/tests/per_branch/test_hooks.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/per_branch/test_hooks.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -208,10 +208,7 @@
         branch.set_last_revision_info(0, NULL_REVISION)
 
     def test_hook_failure_prevents_change(self):
-        """If a hook raises an exception, the change does not take effect.
-
-        Also, a HookFailed exception will be raised.
-        """
+        """If a hook raises an exception, the change does not take effect."""
         branch = self.make_branch_with_revision_ids(
             'one-\xc2\xb5', 'two-\xc2\xb5')
         class PearShapedError(Exception):
@@ -221,8 +218,7 @@
         Branch.hooks.install_named_hook(
             'pre_change_branch_tip', hook_that_raises, None)
         hook_failed_exc = self.assertRaises(
-            HookFailed, branch.set_last_revision_info, 0, NULL_REVISION)
-        self.assertIsInstance(hook_failed_exc.exc_value, PearShapedError)
+            PearShapedError, branch.set_last_revision_info, 0, NULL_REVISION)
         # The revision info is unchanged.
         self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
 

=== modified file 'bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py'
--- bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2009-07-10 05:49:34 +0000
+++ bzrlib/tests/per_branch/test_iter_merge_sorted_revisions.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -84,6 +84,28 @@
             ], list(the_branch.iter_merge_sorted_revisions(
                 stop_revision_id='rev-3', stop_rule='with-merges')))
 
+    def test_merge_sorted_range_stop_with_merges_can_show_non_parents(self):
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        # rev-1.1.1 gets logged before the end revision is reached.
+        # so it is returned even though rev-1.1.1 is not a parent of rev-2.
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ('rev-2', 0, (2,), False),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-2', stop_rule='with-merges')))
+
+    def test_merge_sorted_range_stop_with_merges_ignore_non_parents(self):
+        tree = self.create_tree_with_merge()
+        the_branch = tree.bzrdir.open_branch()
+        # rev-2 is not a parent of rev-1.1.1 so it must not be returned
+        self.assertEqual([
+            ('rev-3', 0, (3,), False),
+            ('rev-1.1.1', 1, (1,1,1), True),
+            ], list(the_branch.iter_merge_sorted_revisions(
+                stop_revision_id='rev-1.1.1', stop_rule='with-merges')))
+
     def test_merge_sorted_single_stop_exclude(self):
         # from X..X exclusive is an empty result
         tree = self.create_tree_with_merge()

=== modified file 'bzrlib/tests/per_branch/test_parent.py'
--- bzrlib/tests/per_branch/test_parent.py	2009-04-15 03:45:24 +0000
+++ bzrlib/tests/per_branch/test_parent.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -96,11 +96,11 @@
         if sys.platform != 'win32':
             raise TestSkipped('windows-specific test')
         b = self.make_branch('.')
-        base_url = b.abspath('.')
+        base_url = b.bzrdir.transport.abspath('.')
         if not base_url.startswith('file:///'):
             raise TestNotApplicable('this test should be run with local base')
         base = urlutils.local_path_from_url(base_url)
-        other = 'file:///B:/path'
+        other = 'file:///D:/path'
         if base[0] != 'C':
             other = 'file:///C:/path'
         b.set_parent(other)

=== modified file 'bzrlib/tests/per_branch/test_push.py'
--- bzrlib/tests/per_branch/test_push.py	2009-09-24 05:31:23 +0000
+++ bzrlib/tests/per_branch/test_push.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -414,7 +414,7 @@
         self.empty_branch.push(target)
         self.assertEqual(
             ['BzrDir.open_2.1',
-             'BzrDir.open_branchV2',
+             'BzrDir.open_branchV3',
              'BzrDir.find_repositoryV3',
              'Branch.get_stacked_on_url',
              'Branch.lock_write',

=== modified file 'bzrlib/tests/per_bzrdir/test_bzrdir.py'
--- bzrlib/tests/per_bzrdir/test_bzrdir.py	2009-09-18 17:19:15 +0000
+++ bzrlib/tests/per_bzrdir/test_bzrdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -778,13 +778,16 @@
                                      './.bzr/repository/inventory.knit',
                                      ])
         try:
+            local_inventory = dir.transport.local_abspath('inventory')
+        except errors.NotLocalUrl:
+            return
+        try:
             # If we happen to have a tree, we'll guarantee everything
             # except for the tree root is the same.
-            inventory_f = file(dir.transport.base+'inventory', 'rb')
+            inventory_f = file(local_inventory, 'rb')
+            self.addCleanup(inventory_f.close)
             self.assertContainsRe(inventory_f.read(),
-                                  '<inventory file_id="TREE_ROOT[^"]*"'
-                                  ' format="5">\n</inventory>\n')
-            inventory_f.close()
+                                  '<inventory format="5">\n</inventory>\n')
         except IOError, e:
             if e.errno != errno.ENOENT:
                 raise
@@ -1173,6 +1176,13 @@
             # because the default open will not open them and
             # they may not be initializable.
             return
+        # for remote formats, there must be no prior assumption about the
+        # network name to use - it's possible that this may somehow have got
+        # in through an unisolated test though - see
+        # <https://bugs.edge.launchpad.net/bzr/+bug/504102>
+        self.assertEquals(getattr(self.bzrdir_format,
+            '_network_name', None),
+            None)
         # supported formats must be able to init and open
         t = get_transport(self.get_url())
         readonly_t = get_transport(self.get_readonly_url())
@@ -1232,9 +1242,6 @@
             return
         self.assertNotEqual(repo.bzrdir.root_transport.base,
             made_repo.bzrdir.root_transport.base)
-        # New repositories are write locked.
-        self.assertTrue(made_repo.is_write_locked())
-        made_repo.unlock()
 
     def test_format_initialize_on_transport_ex_force_new_repo_False(self):
         t = self.get_transport('repo')
@@ -1267,9 +1274,6 @@
             # uninitialisable format
             return
         self.assertLength(1, repo._fallback_repositories)
-        # New repositories are write locked.
-        self.assertTrue(repo.is_write_locked())
-        repo.unlock()
 
     def test_format_initialize_on_transport_ex_default_stack_on(self):
         # When initialize_on_transport_ex uses a stacked-on branch because of
@@ -1292,6 +1296,7 @@
         repo_name = repo_fmt.repository_format.network_name()
         repo, control = self.assertInitializeEx(
             t, need_meta=True, repo_format_name=repo_name, stacked_on=None)
+        # self.addCleanup(repo.unlock)
         if control is None:
             # uninitialisable format
             return
@@ -1323,9 +1328,6 @@
             # must stay with the all-in-one-format.
             repo_name = self.bzrdir_format.network_name()
         self.assertEqual(repo_name, repo._format.network_name())
-        # New repositories are write locked.
-        self.assertTrue(repo.is_write_locked())
-        repo.unlock()
 
     def assertInitializeEx(self, t, need_meta=False, **kwargs):
         """Execute initialize_on_transport_ex and check it succeeded correctly.
@@ -1343,6 +1345,10 @@
             return None, None
         repo, control, require_stacking, repo_policy = \
             self.bzrdir_format.initialize_on_transport_ex(t, **kwargs)
+        if repo is not None:
+            # Repositories are open write-locked
+            self.assertTrue(repo.is_write_locked())
+            self.addCleanup(repo.unlock)
         self.assertIsInstance(control, bzrdir.BzrDir)
         opened = bzrdir.BzrDir.open(t.base)
         expected_format = self.bzrdir_format

=== modified file 'bzrlib/tests/per_foreign_vcs/__init__.py'
--- bzrlib/tests/per_foreign_vcs/__init__.py	2009-10-11 01:02:28 +0000
+++ bzrlib/tests/per_foreign_vcs/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,7 +30,9 @@
     for name, vcs in foreign.foreign_vcs_registry.iteritems():
         scenarios.append((vcs.__class__.__name__, {
             "branch_factory": vcs.branch_format.get_foreign_tests_branch_factory(),
+            "repository_factory": vcs.repository_format.get_foreign_tests_repository_factory(),
             "branch_format": vcs.branch_format,
+            "repository_format": vcs.repository_format,
             }))
     return scenarios
 
@@ -39,6 +41,7 @@
     result = loader.suiteClass()
     per_vcs_mod_names = [
         'branch',
+        'repository',
         ]
     sub_tests = loader.loadTestsFromModuleNames(
         ['bzrlib.tests.per_foreign_vcs.test_' + name

=== added file 'bzrlib/tests/per_foreign_vcs/test_repository.py'
--- bzrlib/tests/per_foreign_vcs/test_repository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_foreign_vcs/test_repository.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,88 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Tests specific to Repository implementations that use foreign VCS'es."""
+
+
+from bzrlib.tests import (
+    TestCase,
+    TestCaseWithTransport,
+    )
+
+
+class TestRepositoryFormat(TestCase):
+
+    def test_format_string(self):
+        self.assertRaises(NotImplementedError,
+            self.repository_format.get_format_string)
+
+    def test_network_name(self):
+        self.assertIsInstance(self.repository_format.network_name(),
+            str)
+
+    def test_format_description(self):
+        self.assertIsInstance(self.repository_format.get_format_description(),
+            str)
+
+
+class ForeignRepositoryFactory(object):
+    """Factory of repository for ForeignRepositoryTests."""
+
+    def make_repository(self, transport):
+        """Create a new, valid, repository. May or may not contain
+        data."""
+        raise NotImplementedError(self.make_repository)
+
+
+class ForeignRepositoryTests(TestCaseWithTransport):
+    """Basic tests for foreign repository implementations.
+
+    These tests mainly make sure that the implementation covers the required
+    bits of the API and returns semi-reasonable values, that are
+    at least of the expected types and in the expected ranges.
+    """
+
+    # XXX: Some of these tests could be moved into a common testcase for
+    # both native and foreign repositories.
+
+    repository_factory = None # Set to an instance of ForeignRepositoryFactory by the scenario
+
+    def make_repository(self):
+        return self.repository_factory.make_repository(self.get_transport())
+
+    def test_make_working_trees(self):
+        """Test that Repository.make_working_trees() returns a boolean."""
+        repo = self.make_repository()
+        self.assertIsInstance(repo.make_working_trees(), bool)
+
+    def test_get_physical_lock_status(self):
+        """Test that a new repository is not locked by default."""
+        repo = self.make_repository()
+        self.assertFalse(repo.get_physical_lock_status())
+
+    def test_is_shared(self):
+        """Test that is_shared() returns a bool."""
+        repo = self.make_repository()
+        self.assertIsInstance(repo.is_shared(), bool)
+
+    def test_gather_stats(self):
+        """Test that gather_stats() will at least return a dictionary
+        with the required keys."""
+        repo = self.make_repository()
+        stats = repo.gather_stats()
+        self.assertIsInstance(stats, dict)
+        self.assertTrue(stats.has_key("revisions"))

=== modified file 'bzrlib/tests/per_interbranch/test_push.py'
--- bzrlib/tests/per_interbranch/test_push.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/per_interbranch/test_push.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2007, 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -255,7 +255,6 @@
         builder.build_snapshot('third', ['second'], [])
         builder.build_snapshot('fourth', ['third'], [])
         builder.finish_series()
-        local = builder.get_branch()
         local = branch.Branch.open(self.get_vfs_only_url('local'))
         # Initial push of three revisions
         remote_bzrdir = local.bzrdir.sprout(

=== modified file 'bzrlib/tests/per_intertree/__init__.py'
--- bzrlib/tests/per_intertree/__init__.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_intertree/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -163,7 +163,8 @@
                  optimiser._matching_from_tree_format,
                  optimiser._matching_to_tree_format,
                  optimiser.make_source_parent_tree_python_dirstate))
-        else:
+        elif (optimiser._matching_from_tree_format is not None and 
+              optimiser._matching_to_tree_format is not None):
             test_intertree_permutations.append(
                 (optimiser.__name__,
                  optimiser,

=== added file 'bzrlib/tests/per_merger.py'
--- bzrlib/tests/per_merger.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_merger.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,403 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Implementation tests for bzrlib.merge.Merger."""
+
+import os
+
+from bzrlib.conflicts import TextConflict
+from bzrlib import (
+    errors,
+    merge as _mod_merge,
+    option,
+    progress,
+    )
+from bzrlib.tests import (
+    multiply_tests,
+    TestCaseWithTransport,
+    )
+from bzrlib.tests.test_merge_core import MergeBuilder
+from bzrlib.transform import TreeTransform
+
+
+
+def load_tests(standard_tests, module, loader):
+    """Multiply tests for tranport implementations."""
+    result = loader.suiteClass()
+    scenarios = [
+        (name, {'merge_type': merger})
+        for name, merger in option._merge_type_registry.items()]
+    return multiply_tests(standard_tests, scenarios, result)
+
+
+class TestMergeImplementation(TestCaseWithTransport):
+
+    def do_merge(self, target_tree, source_tree, **kwargs):
+        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
+            target_tree, source_tree.last_revision(),
+            other_branch=source_tree.branch)
+        merger.merge_type=self.merge_type
+        for name, value in kwargs.items():
+            setattr(merger, name, value)
+        merger.do_merge()
+
+    def test_merge_specific_file(self):
+        this_tree = self.make_branch_and_tree('this')
+        this_tree.lock_write()
+        self.addCleanup(this_tree.unlock)
+        self.build_tree_contents([
+            ('this/file1', 'a\nb\n'),
+            ('this/file2', 'a\nb\n')
+        ])
+        this_tree.add(['file1', 'file2'])
+        this_tree.commit('Added files')
+        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
+        self.build_tree_contents([
+            ('other/file1', 'a\nb\nc\n'),
+            ('other/file2', 'a\nb\nc\n')
+        ])
+        other_tree.commit('modified both')
+        self.build_tree_contents([
+            ('this/file1', 'd\na\nb\n'),
+            ('this/file2', 'd\na\nb\n')
+        ])
+        this_tree.commit('modified both')
+        self.do_merge(this_tree, other_tree, interesting_files=['file1'])
+        self.assertFileEqual('d\na\nb\nc\n', 'this/file1')
+        self.assertFileEqual('d\na\nb\n', 'this/file2')
+
+    def test_merge_move_and_change(self):
+        this_tree = self.make_branch_and_tree('this')
+        this_tree.lock_write()
+        self.addCleanup(this_tree.unlock)
+        self.build_tree_contents([
+            ('this/file1', 'line 1\nline 2\nline 3\nline 4\n'),
+        ])
+        this_tree.add('file1',)
+        this_tree.commit('Added file')
+        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
+        self.build_tree_contents([
+            ('other/file1', 'line 1\nline 2 to 2.1\nline 3\nline 4\n'),
+        ])
+        other_tree.commit('Changed 2 to 2.1')
+        self.build_tree_contents([
+            ('this/file1', 'line 1\nline 3\nline 2\nline 4\n'),
+        ])
+        this_tree.commit('Swapped 2 & 3')
+        self.do_merge(this_tree, other_tree)
+        if self.merge_type is _mod_merge.LCAMerger:
+            self.expectFailure(
+                "lca merge doesn't conflict for move and change",
+                self.assertFileEqual,
+                'line 1\n'
+                '<<<<<<< TREE\n'
+                'line 3\n'
+                'line 2\n'
+                '=======\n'
+                'line 2 to 2.1\n'
+                'line 3\n'
+                '>>>>>>> MERGE-SOURCE\n'
+                'line 4\n', 'this/file1')
+        else:
+            self.assertFileEqual('line 1\n'
+                '<<<<<<< TREE\n'
+                'line 3\n'
+                'line 2\n'
+                '=======\n'
+                'line 2 to 2.1\n'
+                'line 3\n'
+                '>>>>>>> MERGE-SOURCE\n'
+                'line 4\n', 'this/file1')
+
+    def test_modify_conflicts_with_delete(self):
+        # If one side deletes a line, and the other modifies that line, then
+        # the modification should be considered a conflict
+        builder = self.make_branch_builder('test')
+        builder.start_series()
+        builder.build_snapshot('BASE-id', None,
+            [('add', ('', None, 'directory', None)),
+             ('add', ('foo', 'foo-id', 'file', 'a\nb\nc\nd\ne\n')),
+            ])
+        # Delete 'b\n'
+        builder.build_snapshot('OTHER-id', ['BASE-id'],
+            [('modify', ('foo-id', 'a\nc\nd\ne\n'))])
+        # Modify 'b\n', add 'X\n'
+        builder.build_snapshot('THIS-id', ['BASE-id'],
+            [('modify', ('foo-id', 'a\nb2\nc\nd\nX\ne\n'))])
+        builder.finish_series()
+        branch = builder.get_branch()
+        this_tree = branch.bzrdir.create_workingtree()
+        this_tree.lock_write()
+        self.addCleanup(this_tree.unlock)
+        other_tree = this_tree.bzrdir.sprout('other',
+                                             'OTHER-id').open_workingtree()
+        self.do_merge(this_tree, other_tree)
+        if self.merge_type is _mod_merge.LCAMerger:
+            self.expectFailure("lca merge doesn't track deleted lines",
+                self.assertFileEqual,
+                    'a\n'
+                    '<<<<<<< TREE\n'
+                    'b2\n'
+                    '=======\n'
+                    '>>>>>>> MERGE-SOURCE\n'
+                    'c\n'
+                    'd\n'
+                    'X\n'
+                    'e\n', 'test/foo')
+        else:
+            self.assertFileEqual(
+                'a\n'
+                '<<<<<<< TREE\n'
+                'b2\n'
+                '=======\n'
+                '>>>>>>> MERGE-SOURCE\n'
+                'c\n'
+                'd\n'
+                'X\n'
+                'e\n', 'test/foo')
+
+    def get_limbodir_deletiondir(self, wt):
+        transform = TreeTransform(wt)
+        limbodir = transform._limbodir
+        deletiondir = transform._deletiondir
+        transform.finalize()
+        return (limbodir, deletiondir)
+
+    def test_merge_with_existing_limbo(self):
+        wt = self.make_branch_and_tree('this')
+        (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
+        os.mkdir(limbodir)
+        self.assertRaises(errors.ExistingLimbo, self.do_merge, wt, wt)
+        self.assertRaises(errors.LockError, wt.unlock)
+
+    def test_merge_with_pending_deletion(self):
+        wt = self.make_branch_and_tree('this')
+        (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
+        os.mkdir(deletiondir)
+        self.assertRaises(errors.ExistingPendingDeletion, self.do_merge, wt, wt)
+        self.assertRaises(errors.LockError, wt.unlock)
+
+
+class TestHookMergeFileContent(TestCaseWithTransport):
+    """Tests that the 'merge_file_content' hook is invoked."""
+
+    def setUp(self):
+        TestCaseWithTransport.setUp(self)
+        self.hook_log = []
+
+    def install_hook_inactive(self):
+        def inactive_factory(merger):
+            # This hook is never active
+            self.hook_log.append(('inactive',))
+            return None
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', inactive_factory, 'test hook (inactive)')
+
+    def install_hook_noop(self):
+        test = self
+        class HookNA(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                # This hook unconditionally does nothing.
+                test.hook_log.append(('no-op',))
+                return 'not_applicable', None
+        def hook_na_factory(merger):
+            return HookNA(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_na_factory, 'test hook (no-op)')
+
+    def install_hook_success(self):
+        test = self
+        class HookSuccess(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('success',))
+                if merge_params.file_id == '1':
+                    return 'success', ['text-merged-by-hook']
+                return 'not_applicable', None
+        def hook_success_factory(merger):
+            return HookSuccess(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_success_factory, 'test hook (success)')
+
+    def install_hook_conflict(self):
+        test = self
+        class HookConflict(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('conflict',))
+                if merge_params.file_id == '1':
+                    return ('conflicted',
+                        ['text-with-conflict-markers-from-hook'])
+                return 'not_applicable', None
+        def hook_conflict_factory(merger):
+            return HookConflict(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_conflict_factory, 'test hook (delete)')
+
+    def install_hook_delete(self):
+        test = self
+        class HookDelete(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append(('delete',))
+                if merge_params.file_id == '1':
+                    return 'delete', None
+                return 'not_applicable', None
+        def hook_delete_factory(merger):
+            return HookDelete(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_delete_factory, 'test hook (delete)')
+
+    def install_hook_log_lines(self):
+        """Install a hook that saves the get_lines for the this, base and other
+        versions of the file.
+        """
+        test = self
+        class HookLogLines(_mod_merge.AbstractPerFileMerger):
+            def merge_contents(self, merge_params):
+                test.hook_log.append((
+                    'log_lines',
+                    merge_params.this_lines,
+                    merge_params.other_lines,
+                    merge_params.base_lines,
+                    ))
+                return 'not_applicable', None
+        def hook_log_lines_factory(merger):
+            return HookLogLines(merger)
+        _mod_merge.Merger.hooks.install_named_hook(
+            'merge_file_content', hook_log_lines_factory,
+            'test hook (log_lines)')
+
+    def make_merge_builder(self):
+        builder = MergeBuilder(self.test_base_dir)
+        self.addCleanup(builder.cleanup)
+        return builder
+
+    def create_file_needing_contents_merge(self, builder, file_id):
+        builder.add_file(file_id, builder.tree_root, "name1", "text1", True)
+        builder.change_contents(file_id, other="text4", this="text3")
+
+    def test_change_vs_change(self):
+        """Hook is used for (changed, changed)"""
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", other="text4", this="text3")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+
+    def test_change_vs_deleted(self):
+        """Hook is used for (changed, deleted)"""
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", this="text2")
+        builder.remove_file("1", other=True)
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+
+    def test_result_can_be_delete(self):
+        """A hook's result can be the deletion of a file."""
+        self.install_hook_delete()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertRaises(errors.NoSuchId, builder.this.id2path, '1')
+        self.assertEqual([], list(builder.this.list_files()))
+
+    def test_result_can_be_conflict(self):
+        """A hook's result can be a conflict."""
+        self.install_hook_conflict()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [TextConflict('name1', file_id='1')])
+        # The hook still gets to set the file contents in this case, so that it
+        # can insert custom conflict markers.
+        self.assertEqual(
+            builder.this.get_file('1').read(),
+            'text-with-conflict-markers-from-hook')
+
+    def test_can_access_this_other_and_base_versions(self):
+        """The hook function can call params.merger.get_lines to access the
+        THIS/OTHER/BASE versions of the file.
+        """
+        self.install_hook_log_lines()
+        builder = self.make_merge_builder()
+        builder.add_file("1", builder.tree_root, "name1", "text1", True)
+        builder.change_contents("1", this="text2", other="text3")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(
+            [('log_lines', ['text2'], ['text3'], ['text1'])], self.hook_log)
+
+    def test_chain_when_not_active(self):
+        """When a hook function returns None, merging still works."""
+        self.install_hook_inactive()
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+        self.assertEqual([('inactive',), ('success',)], self.hook_log)
+
+    def test_chain_when_not_applicable(self):
+        """When a hook function returns not_applicable, the next function is
+        tried (when one exists).
+        """
+        self.install_hook_noop()
+        self.install_hook_success()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual(conflicts, [])
+        self.assertEqual(
+            builder.this.get_file('1').read(), 'text-merged-by-hook')
+        self.assertEqual([('no-op',), ('success',)], self.hook_log)
+
+    def test_chain_stops_after_success(self):
+        """When a hook function returns success, no later functions are tried.
+        """
+        self.install_hook_success()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('success',)], self.hook_log)
+
+    def test_chain_stops_after_conflict(self):
+        """When a hook function returns conflict, no later functions are tried.
+        """
+        self.install_hook_conflict()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('conflict',)], self.hook_log)
+
+    def test_chain_stops_after_delete(self):
+        """When a hook function returns delete, no later functions are tried.
+        """
+        self.install_hook_delete()
+        self.install_hook_noop()
+        builder = self.make_merge_builder()
+        self.create_file_needing_contents_merge(builder, "1")
+        conflicts = builder.merge(self.merge_type)
+        self.assertEqual([('delete',)], self.hook_log)
+

=== modified file 'bzrlib/tests/per_pack_repository.py'
--- bzrlib/tests/per_pack_repository.py	2009-09-07 03:35:06 +0000
+++ bzrlib/tests/per_pack_repository.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -545,6 +545,42 @@
         finally:
             tree.unlock()
 
+    def test_concurrent_pack_during_autopack(self):
+        tree = self.make_branch_and_tree('tree')
+        tree.lock_write()
+        try:
+            for i in xrange(9):
+                tree.commit('rev %d' % (i,))
+            r2 = repository.Repository.open('tree')
+            r2.lock_write()
+            try:
+                # Monkey patch so that pack occurs while the other repo is
+                # autopacking. This is slightly bad, but all current pack
+                # repository implementations have a _pack_collection, and we
+                # test that it gets triggered. So if a future format changes
+                # things, the test will fail rather than succeed accidentally.
+                autopack_count = [0]
+                r1 = tree.branch.repository
+                orig = r1._pack_collection.pack_distribution
+                def trigger_during_auto(*args, **kwargs):
+                    ret = orig(*args, **kwargs)
+                    if not autopack_count[0]:
+                        r2.pack()
+                    autopack_count[0] += 1
+                    return ret
+                r1._pack_collection.pack_distribution = trigger_during_auto
+                tree.commit('autopack-rev')
+                # This triggers 2 autopacks. The first one causes r2.pack() to
+                # fire, but r2 doesn't see the new pack file yet. The
+                # autopack restarts and sees there are 2 files and there
+                # should be only 1 for 10 commits. So it goes ahead and
+                # finishes autopacking.
+                self.assertEqual([2], autopack_count)
+            finally:
+                r2.unlock()
+        finally:
+            tree.unlock()
+
     def test_lock_write_does_not_physically_lock(self):
         repo = self.make_repository('.', format=self.get_format())
         repo.lock_write()
@@ -687,9 +723,9 @@
         # abort_write_group will not raise an error
         self.assertEqual(None, repo.abort_write_group(suppress_errors=True))
         # But it does log an error
-        log_file = self._get_log(keep_log_file=True)
-        self.assertContainsRe(log_file, 'abort_write_group failed')
-        self.assertContainsRe(log_file, r'INFO  bzr: ERROR \(ignored\):')
+        log = self.get_log()
+        self.assertContainsRe(log, 'abort_write_group failed')
+        self.assertContainsRe(log, r'INFO  bzr: ERROR \(ignored\):')
         if token is not None:
             repo.leave_lock_in_place()
 

=== modified file 'bzrlib/tests/per_repository/test_check.py'
--- bzrlib/tests/per_repository/test_check.py	2009-08-30 23:51:10 +0000
+++ bzrlib/tests/per_repository/test_check.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -46,8 +46,7 @@
         revid2 = tree.commit('2')
         check_object = tree.branch.repository.check([revid1, revid2])
         check_object.report_results(verbose=True)
-        log = self._get_log(keep_log_file=True)
-        self.assertContainsRe(log, "0 unreferenced text versions")
+        self.assertContainsRe(self.get_log(), "0 unreferenced text versions")
 
 
 class TestFindInconsistentRevisionParents(TestCaseWithBrokenRevisionIndex):
@@ -90,13 +89,11 @@
         # contents of it!
         check_object = repo.check(['ignored'])
         check_object.report_results(verbose=False)
-        log = self._get_log(keep_log_file=True)
-        self.assertContainsRe(
-            log, '1 revisions have incorrect parents in the revision index')
+        self.assertContainsRe(self.get_log(),
+            '1 revisions have incorrect parents in the revision index')
         check_object.report_results(verbose=True)
-        log = self._get_log(keep_log_file=True)
         self.assertContainsRe(
-            log,
+            self.get_log(),
             "revision-id has wrong parents in index: "
             r"\('incorrect-parent',\) should be \(\)")
 
@@ -147,5 +144,5 @@
         rev_id = builder.commit('first post')
         result = repo.check(None, check_repo=True)
         result.report_results(True)
-        log = self._get_log(keep_log_file=True)
+        log = self.get_log()
         self.assertFalse('Missing' in log, "Something was missing in %r" % log)

=== modified file 'bzrlib/tests/per_repository/test_check_reconcile.py'
--- bzrlib/tests/per_repository/test_check_reconcile.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/per_repository/test_check_reconcile.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -198,10 +198,9 @@
         repo, scenario = self.prepare_test_repository()
         check_result = repo.check()
         check_result.report_results(verbose=True)
+        log = self.get_log()
         for pattern in scenario.check_regexes(repo):
-            self.assertContainsRe(
-                self._get_log(keep_log_file=True),
-                pattern)
+            self.assertContainsRe(log, pattern)
 
     def test_find_text_key_references(self):
         """Test that find_text_key_references finds erroneous references."""

=== modified file 'bzrlib/tests/per_repository/test_commit_builder.py'
--- bzrlib/tests/per_repository/test_commit_builder.py	2009-08-11 02:45:36 +0000
+++ bzrlib/tests/per_repository/test_commit_builder.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -894,7 +894,13 @@
                 self.assertTrue(version_recorded)
             else:
                 self.assertFalse(version_recorded)
+            self.assertIs(None, builder.new_inventory)
             builder.finish_inventory()
+            inv_key = (builder._new_revision_id,)
+            inv_sha1 = tree.branch.repository.inventories.get_sha1s(
+                            [inv_key])[inv_key]
+            self.assertEqual(inv_sha1, builder.inv_sha1)
+            self.assertIs(None, builder.new_inventory)
             new_inventory = builder.revision_tree().inventory
             new_entry = new_inventory[file_id]
             if delta_against_basis:

=== modified file 'bzrlib/tests/per_repository/test_repository.py'
--- bzrlib/tests/per_repository/test_repository.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/per_repository/test_repository.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -77,11 +77,11 @@
         self.assertSubset([getattr(repo._format, attribute)], allowed_values)
 
     def test_attribute__fetch_order(self):
-        """Test the the _fetch_order attribute."""
+        """Test the _fetch_order attribute."""
         self.assertFormatAttribute('_fetch_order', ('topological', 'unordered'))
 
     def test_attribute__fetch_uses_deltas(self):
-        """Test the the _fetch_uses_deltas attribute."""
+        """Test the _fetch_uses_deltas attribute."""
         self.assertFormatAttribute('_fetch_uses_deltas', (True, False))
 
     def test_attribute_fast_deltas(self):
@@ -89,7 +89,7 @@
         self.assertFormatAttribute('fast_deltas', (True, False))
 
     def test_attribute__fetch_reconcile(self):
-        """Test the the _fetch_reconcile attribute."""
+        """Test the _fetch_reconcile attribute."""
         self.assertFormatAttribute('_fetch_reconcile', (True, False))
 
     def test_attribute_format_pack_compresses(self):
@@ -604,11 +604,11 @@
 
     def test_upgrade_from_format4(self):
         from bzrlib.tests.test_upgrade import _upgrade_dir_template
+        if isinstance(self.repository_format, remote.RemoteRepositoryFormat):
+            return # local conversion to/from RemoteObjects is irrelevant.
         if self.repository_format.get_format_description() \
             == "Repository format 4":
             raise TestSkipped('Cannot convert format-4 to itself')
-        if isinstance(self.repository_format, remote.RemoteRepositoryFormat):
-            return # local conversion to/from RemoteObjects is irrelevant.
         self.build_tree_contents(_upgrade_dir_template)
         old_repodir = bzrlib.bzrdir.BzrDir.open_unsupported('.')
         old_repo_format = old_repodir.open_repository()._format

=== modified file 'bzrlib/tests/per_repository_reference/test_check.py'
--- bzrlib/tests/per_repository_reference/test_check.py	2009-08-11 05:26:57 +0000
+++ bzrlib/tests/per_repository_reference/test_check.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,5 +39,4 @@
         check_result = referring.branch.repository.check(
             referring.branch.repository.all_revision_ids())
         check_result.report_results(verbose=False)
-        log = self._get_log(keep_log_file=True)
-        self.assertFalse("inconsistent parents" in log)
+        self.assertFalse("inconsistent parents" in self.get_log())

=== modified file 'bzrlib/tests/per_transport.py'
--- bzrlib/tests/per_transport.py	2009-10-05 12:50:34 +0000
+++ bzrlib/tests/per_transport.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1497,6 +1497,10 @@
                  u'\u65e5', # Kanji person
                 ]
 
+        no_unicode_support = getattr(self._server, 'no_unicode_support', False)
+        if no_unicode_support:
+            raise tests.KnownFailure("test server cannot handle unicode paths")
+
         try:
             self.build_tree(files, transport=t, line_endings='binary')
         except UnicodeError:

=== modified file 'bzrlib/tests/per_tree/test_get_file_with_stat.py'
--- bzrlib/tests/per_tree/test_get_file_with_stat.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_tree/test_get_file_with_stat.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,6 +21,7 @@
 from bzrlib.tests.per_tree import TestCaseWithTree
 
 
+
 class TestGetFileWithStat(TestCaseWithTree):
 
     def test_get_file_with_stat_id_only(self):
@@ -31,6 +32,7 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         file_obj, statvalue = tree.get_file_with_stat('foo-id')
+        self.addCleanup(file_obj.close)
         if statvalue is not None:
             expected = os.lstat('foo')
             self.assertEqualStat(expected, statvalue)
@@ -44,7 +46,7 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         file_obj, statvalue = tree.get_file_with_stat('foo-id', 'foo')
-        expected = os.lstat('foo')
+        self.addCleanup(file_obj.close)
         if statvalue is not None:
             expected = os.lstat('foo')
             self.assertEqualStat(expected, statvalue)

=== modified file 'bzrlib/tests/per_tree/test_inv.py'
--- bzrlib/tests/per_tree/test_inv.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_tree/test_inv.py	2010-02-16 16:08:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,7 +23,10 @@
 from bzrlib import (
     tests,
     )
-from bzrlib.tests import per_tree
+from bzrlib.tests import (
+    features,
+    per_tree,
+    )
 from bzrlib.mutabletree import MutableTree
 from bzrlib.tests import SymlinkFeature, TestSkipped
 from bzrlib.transform import _PreviewTree
@@ -131,6 +134,8 @@
         work_tree.add(['dir', 'dir/file'])
         if commit:
             work_tree.commit('commit 1')
+        # XXX: this isn't actually guaranteed to return the class we want to
+        # test -- mbp 2010-02-12
         return work_tree
 
     def test_canonical_path(self):
@@ -163,3 +168,21 @@
         work_tree = self._make_canonical_test_tree()
         self.assertEqual('dir/None',
                          work_tree.get_canonical_inventory_path('Dir/None'))
+
+    def test_canonical_tree_name_mismatch(self):
+        # see <https://bugs.edge.launchpad.net/bzr/+bug/368931>
+        # some of the trees we want to use can only exist on a disk, not in
+        # memory - therefore we can only test this if the filesystem is
+        # case-sensitive.
+        self.requireFeature(tests.case_sensitive_filesystem_feature)
+        work_tree = self.make_branch_and_tree('.')
+        self.build_tree(['test/', 'test/file', 'Test'])
+        work_tree.add(['test/', 'test/file', 'Test'])
+
+        test_tree = self._convert_tree(work_tree)
+        test_tree.lock_read()
+        self.addCleanup(test_tree.unlock)
+
+        self.assertEqual(['test', 'test/file', 'Test', 'test/foo', 'Test/foo'],
+            test_tree.get_canonical_inventory_paths(
+                ['test', 'test/file', 'Test', 'test/foo', 'Test/foo']))

=== modified file 'bzrlib/tests/per_tree/test_iter_search_rules.py'
--- bzrlib/tests/per_tree/test_iter_search_rules.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_tree/test_iter_search_rules.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,6 @@
 
 from bzrlib import (
     rules,
-    tests,
     )
 from bzrlib.tests.per_tree import TestCaseWithTree
 

=== modified file 'bzrlib/tests/per_tree/test_path_content_summary.py'
--- bzrlib/tests/per_tree/test_path_content_summary.py	2009-08-26 05:34:10 +0000
+++ bzrlib/tests/per_tree/test_path_content_summary.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,6 +21,7 @@
 from bzrlib import (
     osutils,
     tests,
+    transform,
     )
 
 from bzrlib.tests import per_tree
@@ -78,13 +79,13 @@
         self.assertEqual(('missing', None, None, None), summary)
 
     def test_file_content_summary_executable(self):
-        if not osutils.supports_executable():
-            raise tests.TestNotApplicable()
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/path'])
         tree.add(['path'])
-        current_mode = os.stat('tree/path').st_mode
-        os.chmod('tree/path', current_mode | 0100)
+        tt = transform.TreeTransform(tree)
+        self.addCleanup(tt.finalize)
+        tt.set_executability(True, tt.trans_id_tree_path('path'))
+        tt.apply()
         summary = self._convert_tree(tree).path_content_summary('path')
         self.assertEqual(4, len(summary))
         self.assertEqual('file', summary[0])
@@ -95,6 +96,28 @@
         self.assertSubset((summary[3],),
             (None, '0c352290ae1c26ca7f97d5b2906c4624784abd60'))
 
+    def test_file_content_summary_not_versioned(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/path'])
+        tree = self._convert_tree(tree)
+        summary = tree.path_content_summary('path')
+        self.assertEqual(4, len(summary))
+        if isinstance(tree, (per_tree.DirStateRevisionTree,
+                             per_tree.RevisionTree)):
+            self.assertEqual('missing', summary[0])
+            self.assertIs(None, summary[2])
+            self.assertIs(None, summary[3])
+        elif isinstance(tree, transform._PreviewTree):
+            self.expectFailure('PreviewTree returns "missing" for unversioned'
+                'files', self.assertEqual, 'file', summary[0])
+            self.assertEqual('file', summary[0])
+        else:
+            self.assertEqual('file', summary[0])
+            self.check_content_summary_size(tree, summary, 22)
+            self.assertEqual(False, summary[2])
+        self.assertSubset((summary[3],),
+            (None, '0c352290ae1c26ca7f97d5b2906c4624784abd60'))
+
     def test_file_content_summary_non_exec(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/path'])

=== modified file 'bzrlib/tests/per_uifactory/__init__.py'
--- bzrlib/tests/per_uifactory/__init__.py	2009-09-23 06:29:46 +0000
+++ bzrlib/tests/per_uifactory/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -39,6 +39,7 @@
 
 from bzrlib import (
     tests,
+    transport,
     ui,
     )
 
@@ -55,6 +56,12 @@
     the concrete subclasses should be.
     """
 
+    def test_be_quiet(self):
+        self.factory.be_quiet(True)
+        self.assertEquals(True, self.factory.is_quiet())
+        self.factory.be_quiet(False)
+        self.assertEquals(False, self.factory.is_quiet())
+
     def test_note(self):
         self.factory.note("a note to the user")
         self._check_note("a note to the user")
@@ -74,6 +81,30 @@
         self.factory.show_warning(msg)
         self._check_show_warning(msg)
 
+    def test_make_output_stream(self):
+        # All UIs must now be able to at least accept output, even if they
+        # just discard it.
+        output_stream = self.factory.make_output_stream()
+        output_stream.write('hello!')
+
+    def test_transport_activity(self):
+        # It doesn't matter what the implementation does, we just want to make
+        # sure the interface is there
+        t = transport.get_transport('memory:///')
+        self.factory.report_transport_activity(t, 1000, 'write')
+        self.factory.report_transport_activity(t, 2000, 'read')
+        self.factory.report_transport_activity(t, 4000, None)
+        self.factory.log_transport_activity()
+        self._check_log_transport_activity_noarg()
+        self.factory.log_transport_activity(display=True)
+        self._check_log_transport_activity_display()
+
+    def test_no_transport_activity(self):
+        # No activity to report
+        t = transport.get_transport('memory:///')
+        self.factory.log_transport_activity(display=True)
+        self._check_log_transport_activity_display_no_bytes()
+
 
 class TestTextUIFactory(tests.TestCase, UIFactoryTestMixin):
 
@@ -104,6 +135,62 @@
             self.stderr.getvalue())
         self.assertEquals("", self.stdout.getvalue())
 
+    def _check_log_transport_activity_noarg(self):
+        self.assertEqual('', self.stdout.getvalue())
+        self.assertContainsRe(self.stderr.getvalue(), r'\d+KB\s+\dKB/s |')
+        self.assertNotContainsRe(self.stderr.getvalue(), r'Transferred:')
+
+    def _check_log_transport_activity_display(self):
+        self.assertEqual('', self.stdout.getvalue())
+        # Without a TTY, we shouldn't display anything
+        self.assertEqual('', self.stderr.getvalue())
+
+    def _check_log_transport_activity_display_no_bytes(self):
+        self.assertEqual('', self.stdout.getvalue())
+        # Without a TTY, we shouldn't display anything
+        self.assertEqual('', self.stderr.getvalue())
+
+
+class TestTTYTextUIFactory(TestTextUIFactory):
+
+    def setUp(self):
+        super(TestTTYTextUIFactory, self).setUp()
+
+        class TTYStringIO(object):
+            """Thunk over to StringIO() for everything but 'isatty'"""
+
+            def __init__(self):
+                self.__dict__['_sio'] = StringIO()
+
+            def isatty(self):
+                return True
+
+            def __getattr__(self, name):
+                return getattr(self._sio, name)
+
+            def __setattr__(self, name, value):
+                return setattr(self._sio, name, value)
+                
+        # Remove 'TERM' == 'dumb' which causes us to *not* treat output as a
+        # real terminal, even though isatty returns True
+        self._captureVar('TERM', None)
+        self.stderr = TTYStringIO()
+        self.stdout = TTYStringIO()
+        self.factory = ui.text.TextUIFactory(self.stdin, self.stdout,
+            self.stderr)
+
+    def _check_log_transport_activity_display(self):
+        self.assertEqual('', self.stdout.getvalue())
+        # Displaying the result should write to the progress stream
+        self.assertContainsRe(self.stderr.getvalue(),
+            r'Transferred: 7KiB'
+            r' \(\d+\.\dK/s r:2K w:1K u:4K\)')
+
+    def _check_log_transport_activity_display_no_bytes(self):
+        self.assertEqual('', self.stdout.getvalue())
+        # Without actual bytes transferred, we should report nothing
+        self.assertEqual('', self.stderr.getvalue())
+
 
 class TestSilentUIFactory(tests.TestCase, UIFactoryTestMixin):
     # discards output, therefore tests for output expect nothing
@@ -125,6 +212,15 @@
     def _check_show_warning(self, msg):
         pass
 
+    def _check_log_transport_activity_noarg(self):
+        pass
+
+    def _check_log_transport_activity_display(self):
+        pass
+
+    def _check_log_transport_activity_display_no_bytes(self):
+        pass
+
 
 class TestCannedInputUIFactory(tests.TestCase, UIFactoryTestMixin):
     # discards output, reads input from variables
@@ -145,4 +241,11 @@
     def _check_show_warning(self, msg):
         pass
 
-
+    def _check_log_transport_activity_noarg(self):
+        pass
+
+    def _check_log_transport_activity_display(self):
+        pass
+
+    def _check_log_transport_activity_display_no_bytes(self):
+        pass

=== modified file 'bzrlib/tests/per_versionedfile.py'
--- bzrlib/tests/per_versionedfile.py	2009-10-19 15:06:58 +0000
+++ bzrlib/tests/per_versionedfile.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # Authors:
 #   Johan Rydberg <jrydberg@gnu.org>
@@ -2438,6 +2438,43 @@
         else:
             self.assertIdenticalVersionedFile(source, files)
 
+    def test_insert_record_stream_long_parent_chain_out_of_order(self):
+        """An out of order stream can either error or work."""
+        if not self.graph:
+            raise TestNotApplicable('ancestry info only relevant with graph.')
+        # Create a reasonably long chain of records based on each other, where
+        # most will be deltas.
+        source = self.get_versionedfiles('source')
+        parents = ()
+        keys = []
+        content = [('same same %d\n' % n) for n in range(500)]
+        for letter in 'abcdefghijklmnopqrstuvwxyz':
+            key = ('key-' + letter,)
+            if self.key_length == 2:
+                key = ('prefix',) + key
+            content.append('content for ' + letter + '\n')
+            source.add_lines(key, parents, content)
+            keys.append(key)
+            parents = (key,)
+        # Create a stream of these records, excluding the first record that the
+        # rest ultimately depend upon, and insert it into a new vf.
+        streams = []
+        for key in reversed(keys):
+            streams.append(source.get_record_stream([key], 'unordered', False))
+        deltas = chain(*streams[:-1])
+        files = self.get_versionedfiles()
+        try:
+            files.insert_record_stream(deltas)
+        except RevisionNotPresent:
+            # Must not have corrupted the file.
+            files.check()
+        else:
+            # Must only report either just the first key as a missing parent,
+            # no key as missing (for nodelta scenarios).
+            missing = set(files.get_missing_compression_parent_keys())
+            missing.discard(keys[0])
+            self.assertEqual(set(), missing)
+
     def get_knit_delta_source(self):
         """Get a source that can produce a stream with knit delta records,
         regardless of this test's scenario.

=== modified file 'bzrlib/tests/per_workingtree/test_content_filters.py'
--- bzrlib/tests/per_workingtree/test_content_filters.py	2009-08-25 04:43:21 +0000
+++ bzrlib/tests/per_workingtree/test_content_filters.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,11 @@
 
 """Tests for content filtering conformance"""
 
+import os
+
+from bzrlib.bzrdir import BzrDir
 from bzrlib.filters import ContentFilter
+from bzrlib.switch import switch
 from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
 
@@ -81,6 +85,65 @@
         bin_fileid = tree.path2id('file2.bin')
         return tree, txt_fileid, bin_fileid
 
+    def create_cf_tree_with_two_revisions(self, txt_reader, txt_writer,
+        dir='.'):
+        tree = self.make_branch_and_tree(dir)
+        def _content_filter_stack(path=None, file_id=None):
+            if path.endswith('.txt'):
+                return [ContentFilter(txt_reader, txt_writer)]
+            else:
+                return []
+        tree._content_filter_stack = _content_filter_stack
+        self.build_tree_contents([
+            (dir + '/file1.txt', 'Foo Txt'),
+            (dir + '/file2.bin', 'Foo Bin'),
+            (dir + '/file3.txt', 'Bar Txt'),
+            ])
+        tree.add(['file1.txt', 'file2.bin', 'file3.txt'])
+        tree.commit('commit raw content')
+        fileid_1 = tree.path2id('file1.txt')
+        fileid_2 = tree.path2id('file2.bin')
+        fileid_3 = tree.path2id('file3.txt')
+        # Commit another revision with various changes. We make sure
+        # the change includes a modification, an addition and a deletion.
+        # Renames are more complex and need a separate set of tests later.
+        self.build_tree_contents([
+            (dir + '/file1.txt', 'Foo ROCKS!'),
+            (dir + '/file4.txt', 'Hello World'),
+            ])
+        tree.add(['file4.txt'])
+        tree.remove(['file3.txt'], keep_files=False)
+        tree.commit("change, add and rename stuff")
+        fileid_4 = tree.path2id('file4.txt')
+        return tree, fileid_1, fileid_2, fileid_3, fileid_4
+
+    def patch_in_content_filter(self):
+        # Patch in a custom, symmetric content filter stack. It's pretty gross
+        # that we need to monkey-patch a class method to do this, bit it's
+        # the easiest way currently given we don't have easy access to the
+        # WorkingTree after it is created but before the filter stack is used
+        # to populate content.
+        self.real_content_filter_stack = WorkingTree._content_filter_stack
+        def restore_real_content_filter_stack():
+            WorkingTree._content_filter_stack = self.real_content_filter_stack
+        self.addCleanup(restore_real_content_filter_stack)
+        def _content_filter_stack(tree, path=None, file_id=None):
+            if path.endswith('.txt'):
+                return [ContentFilter(_swapcase, _swapcase)]
+            else:
+                return []
+        WorkingTree._content_filter_stack = _content_filter_stack
+
+    def assert_basis_content(self, expected_content, branch, file_id):
+        # Note: We need to use try/finally here instead of addCleanup()
+        # as the latter leaves the read lock in place too long
+        basis = branch.basis_tree()
+        basis.lock_read()
+        try:
+            self.assertEqual(expected_content, basis.get_file_text(file_id))
+        finally:
+            basis.unlock()
+
     def test_symmetric_content_filtering(self):
         # test handling when read then write gives back the initial content
         tree, txt_fileid, bin_fileid = self.create_cf_tree(
@@ -132,10 +195,7 @@
         if not source.supports_content_filtering():
             return
         self.assertFileEqual("Foo Txt", 'source/file1.txt')
-        basis = source.basis_tree()
-        basis.lock_read()
-        self.addCleanup(basis.unlock)
-        self.assertEqual("FOO TXT", basis.get_file_text(txt_fileid))
+        self.assert_basis_content("FOO TXT", source, txt_fileid)
 
         # Now branch it
         self.run_bzr('branch source target')
@@ -153,24 +213,10 @@
         if not source.supports_content_filtering():
             return
         self.assertFileEqual("Foo Txt", 'source/file1.txt')
-        basis = source.basis_tree()
-        basis.lock_read()
-        self.addCleanup(basis.unlock)
-        self.assertEqual("Foo Txt", basis.get_file_text(txt_fileid))
-
-        # Patch in a custom, symmetric content filter stack
-        self.real_content_filter_stack = WorkingTree._content_filter_stack
-        def restore_real_content_filter_stack():
-            WorkingTree._content_filter_stack = self.real_content_filter_stack
-        self.addCleanup(restore_real_content_filter_stack)
-        def _content_filter_stack(tree, path=None, file_id=None):
-            if path.endswith('.txt'):
-                return [ContentFilter(_swapcase, _swapcase)]
-            else:
-                return []
-        WorkingTree._content_filter_stack = _content_filter_stack
-
-        # Now branch it
+        self.assert_basis_content("Foo Txt", source, txt_fileid)
+
+        # Now patch in content filtering and branch the source
+        self.patch_in_content_filter()
         self.run_bzr('branch source target')
         target = WorkingTree.open('target')
         # Even though the content in source and target are different
@@ -209,3 +255,127 @@
         # we could give back the length of the canonical form, but in general
         # that will be expensive to compute, so it's acceptable to just return
         # None.
+
+    def test_content_filtering_applied_on_pull(self):
+        # Create a source branch with two revisions
+        source, fileid_1, fileid_2, fileid_3, fileid_4 = \
+            self.create_cf_tree_with_two_revisions(txt_reader=None,
+            txt_writer=None, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assertFileEqual("Foo ROCKS!", 'source/file1.txt')
+        self.assert_basis_content("Foo ROCKS!", source, fileid_1)
+
+        # Now patch in content filtering and branch from revision 1
+        self.patch_in_content_filter()
+        self.run_bzr('branch -r1 source target')
+        target = WorkingTree.open('target')
+        self.assert_basis_content("Foo Txt", target, fileid_1)
+        self.assertFileEqual("fOO tXT", 'target/file1.txt')
+        self.assert_basis_content("Foo Bin", target, fileid_2)
+        self.assertFileEqual("Foo Bin", 'target/file2.bin')
+        self.assert_basis_content("Bar Txt", target, fileid_3)
+        self.assertFileEqual("bAR tXT", 'target/file3.txt')
+
+        # Pull the latter change and check the target tree is updated
+        self.run_bzr('pull -d target')
+        self.assert_basis_content("Foo ROCKS!", target, fileid_1)
+        self.assertFileEqual("fOO rocks!", 'target/file1.txt')
+        self.assert_basis_content("Foo Bin", target, fileid_2)
+        self.assert_basis_content("Hello World", target, fileid_4)
+        self.assertFileEqual("hELLO wORLD", 'target/file4.txt')
+
+    def test_content_filtering_applied_on_merge(self):
+        # Create a source branch with two revisions
+        source, fileid_1, fileid_2, fileid_3, fileid_4 = \
+            self.create_cf_tree_with_two_revisions(txt_reader=None,
+            txt_writer=None, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assert_basis_content("Foo ROCKS!", source, fileid_1)
+        self.assertFileEqual("Foo ROCKS!", 'source/file1.txt')
+        self.assert_basis_content("Foo Bin", source, fileid_2)
+        self.assert_basis_content("Hello World", source, fileid_4)
+        self.assertFileEqual("Hello World", 'source/file4.txt')
+
+        # Now patch in content filtering and branch from revision 1
+        self.patch_in_content_filter()
+        self.run_bzr('branch -r1 source target')
+        target = WorkingTree.open('target')
+        self.assert_basis_content("Foo Txt", target, fileid_1)
+        self.assertFileEqual("fOO tXT", 'target/file1.txt')
+        self.assertFileEqual("Foo Bin", 'target/file2.bin')
+        self.assertFileEqual("bAR tXT", 'target/file3.txt')
+
+        # Merge the latter change and check the target tree is updated
+        self.run_bzr('merge -d target source')
+        self.assertFileEqual("fOO rocks!", 'target/file1.txt')
+        self.assertFileEqual("hELLO wORLD", 'target/file4.txt')
+
+        # Commit the merge and check the right content is stored
+        target.commit("merge file1.txt changes from source")
+        self.assert_basis_content("Foo ROCKS!", target, fileid_1)
+        self.assert_basis_content("Hello World", target, fileid_4)
+
+    def test_content_filtering_applied_on_switch(self):
+        # Create a source branch with two revisions
+        source, fileid_1, fileid_2, fileid_3, fileid_4 = \
+            self.create_cf_tree_with_two_revisions(txt_reader=None,
+            txt_writer=None, dir='branch-a')
+        if not source.supports_content_filtering():
+            return
+
+        # Now patch in content filtering and branch from revision 1
+        self.patch_in_content_filter()
+        self.run_bzr('branch -r1 branch-a branch-b')
+
+        # Now create a lightweight checkout referring to branch-b
+        self.run_bzr('checkout --lightweight branch-b checkout')
+        self.assertFileEqual("fOO tXT", 'checkout/file1.txt')
+
+        # Switch it to branch-b and check the tree is updated
+        checkout_control_dir = BzrDir.open_containing('checkout')[0]
+        switch(checkout_control_dir, source.branch)
+        self.assertFileEqual("fOO rocks!", 'checkout/file1.txt')
+        self.assertFileEqual("hELLO wORLD", 'checkout/file4.txt')
+
+    def test_content_filtering_applied_on_revert_delete(self):
+        # Create a source branch with content filtering
+        source, txt_fileid, bin_fileid = self.create_cf_tree(
+            txt_reader=_uppercase, txt_writer=_lowercase, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assertFileEqual("Foo Txt", 'source/file1.txt')
+        self.assert_basis_content("FOO TXT", source, txt_fileid)
+
+        # Now delete the file, revert it and check the content
+        os.unlink('source/file1.txt')
+        self.assertFalse(os.path.exists('source/file1.txt'))
+        source.revert(['file1.txt'])
+        self.assertTrue(os.path.exists('source/file1.txt'))
+        # Note: we don't get back exactly what was in the tree
+        # previously because lower(upper(text)) is a lossy transformation
+        self.assertFileEqual("foo txt", 'source/file1.txt')
+
+    def test_content_filtering_applied_on_revert_rename(self):
+        # Create a source branch with content filtering
+        source, txt_fileid, bin_fileid = self.create_cf_tree(
+            txt_reader=_uppercase, txt_writer=_lowercase, dir='source')
+        if not source.supports_content_filtering():
+            return
+        self.assertFileEqual("Foo Txt", 'source/file1.txt')
+        self.assert_basis_content("FOO TXT", source, txt_fileid)
+
+        # Now modify & rename a file, revert it and check the content
+        self.build_tree_contents([
+            ('source/file1.txt', 'Foo Txt with new content')])
+        source.rename_one('file1.txt', 'file1.bin')
+        self.assertTrue(os.path.exists('source/file1.bin'))
+        self.assertFalse(os.path.exists('source/file1.txt'))
+        self.assertFileEqual("Foo Txt with new content", 'source/file1.bin')
+        source.revert(['file1.bin'])
+        self.assertFalse(os.path.exists('source/file1.bin'))
+        self.assertTrue(os.path.exists('source/file1.txt'))
+        # Note: we don't get back exactly what was in the tree
+        # previously because lower(upper(text)) is a lossy transformation
+        self.assertFileEqual("foo txt", 'source/file1.txt')

=== modified file 'bzrlib/tests/per_workingtree/test_is_ignored.py'
--- bzrlib/tests/per_workingtree/test_is_ignored.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_is_ignored.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -31,11 +31,15 @@
             ('.bzrignore', './rootdir\n'
                            'randomfile*\n'
                            '*bar\n'
+                           '!bazbar\n'
                            '?foo\n'
                            '*.~*\n'
                            'dir1/*f1\n'
                            'dir1/?f2\n'
+                           'RE:dir2/.*\.wombat\n'
                            'path/from/ro?t\n'
+                           '**/piffle.py\n'
+                           '!b/piffle.py\n'
                            'unicode\xc2\xb5\n' # u'\xb5'.encode('utf8')
                            'dos\r\n'
                            '\n' # empty line
@@ -58,6 +62,12 @@
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/root'))
         self.assertEqual("path/from/ro?t", tree.is_ignored('path/from/roat'))
         self.assertEqual(None, tree.is_ignored('roat'))
+        
+        self.assertEqual('**/piffle.py', tree.is_ignored('piffle.py'))
+        self.assertEqual('**/piffle.py', tree.is_ignored('a/piffle.py'))
+        self.assertEqual(None, tree.is_ignored('b/piffle.py')) # exclusion
+        self.assertEqual('**/piffle.py', tree.is_ignored('foo/bar/piffle.py'))
+        self.assertEqual(None, tree.is_ignored('p/iffle.py'))
 
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'unicode\xb5'))
         self.assertEqual(u'unicode\xb5', tree.is_ignored(u'subdir/unicode\xb5'))
@@ -72,6 +82,8 @@
         self.assertEqual('*bar', tree.is_ignored(r'foo\nbar'))
         self.assertEqual('*bar', tree.is_ignored('bar'))
         self.assertEqual('*bar', tree.is_ignored('.bar'))
+        
+        self.assertEqual(None, tree.is_ignored('bazbar')) # exclusion
 
         self.assertEqual('?foo', tree.is_ignored('afoo'))
         self.assertEqual('?foo', tree.is_ignored('.foo'))
@@ -84,6 +96,9 @@
 
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/ff2'))
         self.assertEqual('dir1/?f2', tree.is_ignored('dir1/.f2'))
+        
+        self.assertEqual('RE:dir2/.*\.wombat', tree.is_ignored('dir2/foo.wombat'))
+        self.assertEqual(None, tree.is_ignored('dir2/foo'))
 
         # Blank lines and comments should be ignored
         self.assertEqual(None, tree.is_ignored(''))

=== modified file 'bzrlib/tests/per_workingtree/test_pull.py'
--- bzrlib/tests/per_workingtree/test_pull.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_pull.py	2010-01-11 23:02:32 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -56,3 +56,15 @@
         tree_b.pull(tree_a.branch)
         self.assertFileEqual('contents of from/file\n', 'to/file')
 
+    def test_pull_changes_root_id(self):
+        tree = self.make_branch_and_tree('from')
+        tree.set_root_id('first_root_id')
+        self.build_tree(['from/file'])
+        tree.add(['file'])
+        tree.commit('first')
+        to_tree = tree.bzrdir.sprout('to').open_workingtree()
+        self.assertEqual('first_root_id', to_tree.get_root_id())
+        tree.set_root_id('second_root_id')
+        tree.commit('second')
+        to_tree.pull(tree.branch)
+        self.assertEqual('second_root_id', to_tree.get_root_id())

=== modified file 'bzrlib/tests/per_workingtree/test_set_root_id.py'
--- bzrlib/tests/per_workingtree/test_set_root_id.py	2009-09-11 07:55:48 +0000
+++ bzrlib/tests/per_workingtree/test_set_root_id.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,7 +18,7 @@
 
 import sys
 
-from bzrlib import inventory
+from bzrlib import errors, inventory
 from bzrlib.tests import TestSkipped
 from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
 
@@ -53,3 +53,19 @@
         # should still be retained
         tree = tree.bzrdir.open_workingtree()
         self.assertEqual(root_id, tree.get_root_id())
+        tree._validate()
+
+    def test_set_root_id(self):
+        tree = self.make_branch_and_tree('.')
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        orig_root_id = tree.get_root_id()
+        self.assertNotEqual('custom-root-id', orig_root_id)
+        self.assertEqual('', tree.id2path(orig_root_id))
+        self.assertRaises(errors.NoSuchId, tree.id2path, 'custom-root-id')
+        tree.set_root_id('custom-root-id')
+        self.assertEqual('custom-root-id', tree.get_root_id())
+        self.assertEqual('custom-root-id', tree.path2id(''))
+        self.assertEqual('', tree.id2path('custom-root-id'))
+        self.assertRaises(errors.NoSuchId, tree.id2path, orig_root_id)
+        tree._validate()

=== modified file 'bzrlib/tests/per_workingtree/test_smart_add.py'
--- bzrlib/tests/per_workingtree/test_smart_add.py	2009-09-28 02:02:30 +0000
+++ bzrlib/tests/per_workingtree/test_smart_add.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 """Test that we can use smart_add on all Tree implementations."""
 
 from cStringIO import StringIO
+import sys
 
 from bzrlib import (
     add,
@@ -53,7 +54,12 @@
 
     def assertFilenameSkipped(self, filename):
         tree = self.make_branch_and_tree('tree')
-        self.build_tree(['tree/'+filename])
+        try:
+            self.build_tree(['tree/'+filename])
+        except errors.NoSuchFile:
+            if sys.platform == 'win32':
+                raise tests.TestNotApplicable('Cannot create files named %r on'
+                    ' win32' % (filename,))
         tree.smart_add(['tree'])
         self.assertEqual(None, tree.path2id(filename))
 

=== modified file 'bzrlib/tests/per_workingtree/test_workingtree.py'
--- bzrlib/tests/per_workingtree/test_workingtree.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/per_workingtree/test_workingtree.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #           and others
 #
@@ -478,6 +478,20 @@
         self.assertEqual(wt.get_root_id(), checkout.get_root_id())
         self.assertNotEqual(None, wt.get_root_id())
 
+    def test_update_sets_updated_root_id(self):
+        wt = self.make_branch_and_tree('tree')
+        wt.set_root_id('first_root_id')
+        self.assertEqual('first_root_id', wt.get_root_id())
+        self.build_tree(['tree/file'])
+        wt.add(['file'])
+        wt.commit('first')
+        co = wt.branch.create_checkout('checkout')
+        wt.set_root_id('second_root_id')
+        wt.commit('second')
+        self.assertEqual('second_root_id', wt.get_root_id())
+        self.assertEqual(0, co.update())
+        self.assertEqual('second_root_id', co.get_root_id())
+
     def test_update_returns_conflict_count(self):
         # working tree formats from the meta-dir format and newer support
         # setting the last revision on a tree independently of that on the
@@ -513,30 +527,37 @@
 
     def test_merge_revert(self):
         from bzrlib.merge import merge_inner
-        self.thisFailsStrictLockCheck()
         this = self.make_branch_and_tree('b1')
-        open('b1/a', 'wb').write('a test\n')
-        this.add('a')
-        open('b1/b', 'wb').write('b test\n')
-        this.add('b')
+        self.build_tree_contents([('b1/a', 'a test\n'), ('b1/b', 'b test\n')])
+        this.add(['a', 'b'])
         this.commit(message='')
         base = this.bzrdir.clone('b2').open_workingtree()
-        open('b2/a', 'wb').write('b test\n')
+        self.build_tree_contents([('b2/a', 'b test\n')])
         other = this.bzrdir.clone('b3').open_workingtree()
-        open('b3/a', 'wb').write('c test\n')
-        open('b3/c', 'wb').write('c test\n')
+        self.build_tree_contents([('b3/a', 'c test\n'), ('b3/c', 'c test\n')])
         other.add('c')
 
-        open('b1/b', 'wb').write('q test\n')
-        open('b1/d', 'wb').write('d test\n')
+        self.build_tree_contents([('b1/b', 'q test\n'), ('b1/d', 'd test\n')])
+        # Note: If we don't lock this before calling merge_inner, then we get a
+        #       lock-contention failure. This probably indicates something
+        #       weird going on inside merge_inner. Probably something about
+        #       calling bt = this_tree.basis_tree() in one lock, and then
+        #       locking both this_tree and bt separately, causing a dirstate
+        #       locking race.
+        this.lock_write()
+        self.addCleanup(this.unlock)
         merge_inner(this.branch, other, base, this_tree=this)
-        self.assertNotEqual(open('b1/a', 'rb').read(), 'a test\n')
+        a = open('b1/a', 'rb')
+        try:
+            self.assertNotEqual(a.read(), 'a test\n')
+        finally:
+            a.close()
         this.revert()
-        self.assertEqual(open('b1/a', 'rb').read(), 'a test\n')
-        self.assertIs(os.path.exists('b1/b.~1~'), True)
-        self.assertIs(os.path.exists('b1/c'), False)
-        self.assertIs(os.path.exists('b1/a.~1~'), False)
-        self.assertIs(os.path.exists('b1/d'), True)
+        self.assertFileEqual('a test\n', 'b1/a')
+        self.failUnlessExists('b1/b.~1~')
+        self.failIfExists('b1/c')
+        self.failIfExists('b1/a.~1~')
+        self.failUnlessExists('b1/d')
 
     def test_update_updates_bound_branch_no_local_commits(self):
         # doing an update in a tree updates the branch its bound to too.
@@ -583,6 +604,20 @@
         self.assertEqual(master_tree.branch.revision_history(),
             tree.branch.revision_history())
 
+    def test_update_takes_revision_parameter(self):
+        wt = self.make_branch_and_tree('wt')
+        self.build_tree_contents([('wt/a', 'old content')])
+        wt.add(['a'])
+        rev1 = wt.commit('first master commit')
+        self.build_tree_contents([('wt/a', 'new content')])
+        rev2 = wt.commit('second master commit')
+        # https://bugs.edge.launchpad.net/bzr/+bug/45719/comments/20
+        # when adding 'update -r' we should make sure all wt formats support
+        # it
+        conflicts = wt.update(revision=rev1)
+        self.assertFileEqual('old content', 'wt/a')
+        self.assertEqual([rev1], wt.get_parent_ids())
+
     def test_merge_modified_detects_corruption(self):
         # FIXME: This doesn't really test that it works; also this is not
         # implementation-independent. mbp 20070226

=== modified file 'bzrlib/tests/script.py'
--- bzrlib/tests/script.py	2009-09-24 06:53:43 +0000
+++ bzrlib/tests/script.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -107,9 +107,11 @@
                 error = []
             error.append(line[2:] + '\n')
         else:
+            # can happen if the first line is not recognized as a command, eg
+            # if the prompt has leading whitespace
             if output is None:
                 if cmd_cur is None:
-                    raise SyntaxError('No command for that output',
+                    raise SyntaxError('No command for line %r' % (line,),
                                       (file_name, lineno, 1, orig))
                 output = []
             output.append(line + '\n')
@@ -217,7 +219,8 @@
             # Specifying None means: any output is accepted
             return
         if actual is None:
-            test_case.fail('Unexpected: %s' % actual)
+            test_case.fail('We expected output: %r, but found None'
+                           % (expected,))
         matching = self.output_checker.check_output(
             expected, actual, self.check_options)
         if not matching:
@@ -289,30 +292,31 @@
             try:
                 inputs.append(self._read_input(None, in_name))
             except IOError, e:
-                if e.errno == errno.ENOENT:
+                # Some filenames are illegal on Windows and generate EINVAL
+                # rather than just saying the filename doesn't exist
+                if e.errno in (errno.ENOENT, errno.EINVAL):
                     return (1, None,
                             '%s: No such file or directory\n' % (in_name,))
+                raise
         # Basically cat copy input to output
         output = ''.join(inputs)
         # Handle output redirections
         try:
             output = self._write_output(output, out_name, out_mode)
         except IOError, e:
-            if e.errno == errno.ENOENT:
+            # If out_name cannot be created, we may get 'ENOENT', however if
+            # out_name is something like '', we can get EINVAL
+            if e.errno in (errno.ENOENT, errno.EINVAL):
                 return 1, None, '%s: No such file or directory\n' % (out_name,)
+            raise
         return 0, output, None
 
     def do_echo(self, test_case, input, args):
         (in_name, out_name, out_mode, args) = _scan_redirection_options(args)
-        if input and args:
-                raise SyntaxError('Specify parameters OR use redirection')
+        if input or in_name:
+            raise SyntaxError('echo doesn\'t read from stdin')
         if args:
             input = ' '.join(args)
-        try:
-            input = self._read_input(input, in_name)
-        except IOError, e:
-            if e.errno == errno.ENOENT:
-                return 1, None, '%s: No such file or directory\n' % (in_name,)
         # Always append a \n'
         input += '\n'
         # Process output
@@ -321,8 +325,9 @@
         try:
             output = self._write_output(output, out_name, out_mode)
         except IOError, e:
-            if e.errno == errno.ENOENT:
+            if e.errno in (errno.ENOENT, errno.EINVAL):
                 return 1, None, '%s: No such file or directory\n' % (out_name,)
+            raise
         return 0, output, None
 
     def _get_jail_root(self, test_case):
@@ -397,6 +402,31 @@
             retcode = 0
         return retcode, None, err
 
+    def do_mv(self, test_case, input, args):
+        err = None
+        def error(msg, src, dst):
+            return "mv: cannot move %s to %s: %s\n" % (src, dst, msg)
+
+        if not args or len(args) != 2:
+            raise SyntaxError("Usage: mv path1 path2")
+        src, dst = args
+        try:
+            real_dst = dst
+            if os.path.isdir(dst):
+                real_dst = os.path.join(dst, os.path.basename(src))
+            os.rename(src, real_dst)
+        except OSError, e:
+            if e.errno == errno.ENOENT:
+                err = error('No such file or directory', src, dst)
+            else:
+                raise
+        if err:
+            retcode = 1
+        else:
+            retcode = 0
+        return retcode, None, err
+
+
 
 class TestCaseWithMemoryTransportAndScript(tests.TestCaseWithMemoryTransport):
     """Helper class to experiment shell-like test and memory fs.

=== modified file 'bzrlib/tests/ssl_certs/create_ssls.py'
--- bzrlib/tests/ssl_certs/create_ssls.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/ssl_certs/create_ssls.py	2009-11-26 14:17:19 +0000
@@ -46,6 +46,13 @@
     Popen,
     PIPE,
     )
+import sys
+
+# We want to use the right bzrlib: the one we are part of
+# FIXME: The fllowing is correct but looks a bit ugly 
+_dir = os.path.dirname
+our_bzr = _dir(_dir(_dir(_dir(os.path.realpath(__file__)))))
+sys.path.insert(0, our_bzr)
 
 from bzrlib import (
     osutils,
@@ -105,7 +112,7 @@
     server_locality='LocalHost',
     server_organization='Testing Ltd',
     server_section='https server',
-    server_name='localhost', # Always accessed under that name
+    server_name='127.0.0.1', # Always accessed under that name
     server_email='https_server@locahost',
     server_optional_company_name='',
     )

=== modified file 'bzrlib/tests/ssl_certs/server.crt'
--- bzrlib/tests/ssl_certs/server.crt	2008-01-05 22:09:47 +0000
+++ bzrlib/tests/ssl_certs/server.crt	2009-11-26 14:17:19 +0000
@@ -2,32 +2,32 @@
 MIIFpDCCA4wCAQEwDQYJKoZIhvcNAQEFBQAwgZMxCzAJBgNVBAYTAkJaMREwDwYD
 VQQIEwhJbnRlcm5ldDEPMA0GA1UEBxMGQmF6YWFyMRQwEgYDVQQKEwtEaXN0cmli
 dXRlZDEMMAoGA1UECxMDVkNTMR8wHQYDVQQDExZNYXN0ZXIgb2YgY2VydGlmaWNh
-dGVzMRswGQYJKoZIhvcNAQkBFgxjZXJ0QG5vLnNwYW0wHhcNMDgwMTA1MjIwNjQ1
-WhcNMTgwMTAyMjIwNjQ1WjCBmzELMAkGA1UEBhMCTEgxETAPBgNVBAgTCEludGVy
+dGVzMRswGQYJKoZIhvcNAQkBFgxjZXJ0QG5vLnNwYW0wHhcNMDkxMTI2MTMyMjE4
+WhcNMTkxMTI0MTMyMjE4WjCBmzELMAkGA1UEBhMCTEgxETAPBgNVBAgTCEludGVy
 bmV0MRIwEAYDVQQHEwlMb2NhbEhvc3QxFDASBgNVBAoTC1Rlc3RpbmcgTHRkMRUw
-EwYDVQQLEwxodHRwcyBzZXJ2ZXIxEjAQBgNVBAMTCWxvY2FsaG9zdDEkMCIGCSqG
+EwYDVQQLEwxodHRwcyBzZXJ2ZXIxEjAQBgNVBAMTCTEyNy4wLjAuMTEkMCIGCSqG
 SIb3DQEJARYVaHR0cHNfc2VydmVyQGxvY2Fob3N0MIICIjANBgkqhkiG9w0BAQEF
-AAOCAg8AMIICCgKCAgEAsvSNdobG/oO97vhO7xcHpQfpx2QHwYOn+Im0FMTXbTPd
-Bre4wkjEC2KxOjH6MGBEQM02h8SUAWCcvX+HyLBkZRtgeueZZaf2iqc+Tr24ueMa
-f8elqz1tuaua7zyuR+uUgZyxX7rgbuVDUYNt5qVN8uXUSbCtVgxHa3extD7fbvD8
-t9P/QUItx5EBBEeWVhtVffgI35OWMwsJhiwK68ka0kTLJJhZyqAQujKnZf0uHyAv
-Vkai1fYtjklBVLnxwvJZOwnQto3RF1AmuMgj7T6RwDjTR43DioHtTJotrPZfQaAF
-3tVC30Vy8pm0ojFdxUdKPgEMOLBWizXWc3lzWn02CE0awHxwIYNVNLODX3sU/ou8
-OqOIMDRK451xE5S5WOXciWLknY/ene2r4g/pPFYNrwc/9eZ0AYIhE7Jm7b+D3WvL
-z3CrhYul/XmPsXBHBnxkrjvtrj0yDZyHZnMpygqL7Cr9/2V9FwMFPNTNY5Sifmcx
-l6orvx8oe6Q98XwGD575wWU6BwIrpriSa2HWrVIDwwbSCeZ8NULXe8fnC8zInckj
-tzz8osqRv4af+XXoht5zJtt8fUc7o4Xiq4Yyzlj3lJMHWcP+GqzCbJ0c/OY6C/ml
-C6YbMeCwv+/gAs3Xw1eSzimDqxh/kIw6SgBUGoQVffOzaJo917cMyYycLDDN9/8C
-AwEAATANBgkqhkiG9w0BAQUFAAOCAgEAmPprAO6iZZaruR2qeekooeCINXbiGY92
-0Er+jLU2fulOWwDDh7nGMjNM8jz0NKxcjRJ26GLHsQS4lLrD6B6fQb2vBm47oMFX
-pzyeQotvO0uqvMZMNls8tJxKEy7+NVMf+UI/gVTiqIUgnl6hJ3pO2FoDoIG2rwGO
-mAZAc0Xu1w8B0F77umFhlzcK0jKyTGXRIqO8lFYdRpXcIT8wATGxTTyGApWw2nh9
-CWZviX9Fsz6l7qr85ckcrvtzb4e/qtY/oV/y469FtoI2Tz1Iq94Et0zpZMsCfgbd
-TI9IxnPkLd59WbwMghlBtMv7tbXSGCSnSKieZVbf/hGfwVK30dCGS3X0hsF60ADd
-/wh01QgxfXgAktOvCnsMUrfMcElEvE1lgCSqtYw5AL5+nDf3FUwJbr47l8BCk589
-OAN0ijrnUPHNHL83eLuxb26V8B7LRt61HfQOAXBcpwTHyewnOXq0zj5lzkgAU8Sj
-55FObSd2/gvOVw9rr3eC0evgMpDAsOfeupE2BB/VwTRrbRrETiqskWa8EnvqKPkM
-ESIRsstLlUIKbxhSHHaRrtY6FbcN5nXEz4kOXz/tYKuxuPnZz9Wih5YBWcboKxut
-OMrdjUeDnckLAw1rJI+H8+jPkyOqCpcOpLI9xJxmuYJhufjbB/B8ddNT1/pjceze
-uR7coWvplKU=
+AAOCAg8AMIICCgKCAgEAq2uwbT6Zs/gC5ytKiAZfXGNVMQyGLuetgUrfQTbOL+/p
+4sK97hhWk/qbJRQVy8qQ5o4JKmTwAmf/exGxh94E3eacC9EEIdI3A0I2dbno9qAu
+zBXXacjqcKT/PczIN9U1/+S0e5vOssCtvVFWzdbG7vTg3Shs5BG8y1Ue8CDUtczB
+8gGjbQWkugzAqK8IogeMKkCGmiWFzRubHwL9HH5tYm1w5EHJzx/avepOyTKKBQpF
+A0sza0IYwEIuREMWcN64YPqs/OkLFmGCfpMCZvOmsmwGTxf+MoDNiqBco67xBuaK
+e4pSUf1f1PrbgHpEJq68QuCsRgWFYig0jRkh06ox5beyV9n/bQ/bA7W60JT/NUo9
+uNtFgC2ui2yHA5c3ozW+Muk7tS42r9Sde3gW/81c+kZbVS87EM42XQFMP1stAR8W
+XMwzlVnjrbQ/ERwt+OoGbOt9woHeEKpi9chmFtDR5irY3uJoP9/+9D51glxRGQql
+kpNc/FL4VYbmCZY8QCeEXHaxl1MeuZCI6ovGHojpUvFNQK+7qFOhbK0G8me7o+ly
+P/qCbjTTvom/Kvg9kFtAvwuz6ErWYKh0xZQxNhFl3uGtxycAti0+5O6l/lLUQwv8
+n79IWawWDTy4s8kYfWBiH8NNQBLib6tlllzt7LXtcPJjTkZ1finT5YFqweQCiR8C
+AwEAATANBgkqhkiG9w0BAQUFAAOCAgEAutvkG9R7oxOiRNHhMnDtcMFS92PdgrFU
+eAANojT2eC359K+vzIG19EReq6OEk8pLjbzehVW808hxtdMaMOQc3Np4AHl9Z4Sp
+YEMpRsfIbjwgM02aT7Ig5ZztRjKq78G5WzQq71Q5tzK9gCotGYH5B9QEbEpEjnb0
+UGaGi4bB+/WJsAuxKt5UyvN1h4n6oJYY4/Dy20H0LfnzjGOayuOoRaZt8cBFS0XQ
+8Gp6WAJwl8CJms84XL8IN6Zj6fYCWPP4fT6kiu7VHof+/zK99ajkEKaykl7mkyEk
+NfpaGIgVsPgd6BkWDavbW7DJg0LNlPry+Mh5MNAcHNaGUpJ5mYoazLBDw9rd70ss
+70TgT1te7WyB2yHbKLHdKDtRshfemXZaScVxoWsRrlDJQQn+1CiBWAmuVgZNiAIY
+gqM5kcFiLPP8hjw1GzPcSwjg8uxyM1lY6m1KLwdO2hW+iZCj1vhz//lBBHmYYTqk
+8EwtbWJ7XVQaLVRhAc1HIIA6TSAPiP7Dgn2rhQHcqODYSmfieXPQetlFhXNJG508
+voSrJMpsKQOId+2Ua00Wi6ajsje00vklG7IzvLY7MdeiSxNrXLNGlSjHI9/+ea0E
+lHJQbJUjR/kXNT/2WBnjBkSVclsz5Xx2dAf3kU0AlUA+b962Y/fxlma5wd8PIHx6
+tW5I+uMneHg=
 -----END CERTIFICATE-----

=== modified file 'bzrlib/tests/ssl_certs/server.csr'
--- bzrlib/tests/ssl_certs/server.csr	2008-01-05 22:09:47 +0000
+++ bzrlib/tests/ssl_certs/server.csr	2009-11-26 14:17:19 +0000
@@ -1,29 +1,29 @@
 -----BEGIN CERTIFICATE REQUEST-----
 MIIFBjCCAu4CAQAwgZsxCzAJBgNVBAYTAkxIMREwDwYDVQQIEwhJbnRlcm5ldDES
 MBAGA1UEBxMJTG9jYWxIb3N0MRQwEgYDVQQKEwtUZXN0aW5nIEx0ZDEVMBMGA1UE
-CxMMaHR0cHMgc2VydmVyMRIwEAYDVQQDEwlsb2NhbGhvc3QxJDAiBgkqhkiG9w0B
+CxMMaHR0cHMgc2VydmVyMRIwEAYDVQQDEwkxMjcuMC4wLjExJDAiBgkqhkiG9w0B
 CQEWFWh0dHBzX3NlcnZlckBsb2NhaG9zdDCCAiIwDQYJKoZIhvcNAQEBBQADggIP
-ADCCAgoCggIBALL0jXaGxv6Dve74Tu8XB6UH6cdkB8GDp/iJtBTE120z3Qa3uMJI
-xAtisTox+jBgREDNNofElAFgnL1/h8iwZGUbYHrnmWWn9oqnPk69uLnjGn/Hpas9
-bbmrmu88rkfrlIGcsV+64G7lQ1GDbealTfLl1EmwrVYMR2t3sbQ+327w/LfT/0FC
-LceRAQRHllYbVX34CN+TljMLCYYsCuvJGtJEyySYWcqgELoyp2X9Lh8gL1ZGotX2
-LY5JQVS58cLyWTsJ0LaN0RdQJrjII+0+kcA400eNw4qB7UyaLaz2X0GgBd7VQt9F
-cvKZtKIxXcVHSj4BDDiwVos11nN5c1p9NghNGsB8cCGDVTSzg197FP6LvDqjiDA0
-SuOdcROUuVjl3Ili5J2P3p3tq+IP6TxWDa8HP/XmdAGCIROyZu2/g91ry89wq4WL
-pf15j7FwRwZ8ZK477a49Mg2ch2ZzKcoKi+wq/f9lfRcDBTzUzWOUon5nMZeqK78f
-KHukPfF8Bg+e+cFlOgcCK6a4kmth1q1SA8MG0gnmfDVC13vH5wvMyJ3JI7c8/KLK
-kb+Gn/l16IbecybbfH1HO6OF4quGMs5Y95STB1nD/hqswmydHPzmOgv5pQumGzHg
-sL/v4ALN18NXks4pg6sYf5CMOkoAVBqEFX3zs2iaPde3DMmMnCwwzff/AgMBAAGg
+ADCCAgoCggIBAKtrsG0+mbP4AucrSogGX1xjVTEMhi7nrYFK30E2zi/v6eLCve4Y
+VpP6myUUFcvKkOaOCSpk8AJn/3sRsYfeBN3mnAvRBCHSNwNCNnW56PagLswV12nI
+6nCk/z3MyDfVNf/ktHubzrLArb1RVs3Wxu704N0obOQRvMtVHvAg1LXMwfIBo20F
+pLoMwKivCKIHjCpAhpolhc0bmx8C/Rx+bWJtcORByc8f2r3qTskyigUKRQNLM2tC
+GMBCLkRDFnDeuGD6rPzpCxZhgn6TAmbzprJsBk8X/jKAzYqgXKOu8QbminuKUlH9
+X9T624B6RCauvELgrEYFhWIoNI0ZIdOqMeW3slfZ/20P2wO1utCU/zVKPbjbRYAt
+rotshwOXN6M1vjLpO7UuNq/UnXt4Fv/NXPpGW1UvOxDONl0BTD9bLQEfFlzMM5VZ
+4620PxEcLfjqBmzrfcKB3hCqYvXIZhbQ0eYq2N7iaD/f/vQ+dYJcURkKpZKTXPxS
++FWG5gmWPEAnhFx2sZdTHrmQiOqLxh6I6VLxTUCvu6hToWytBvJnu6Ppcj/6gm40
+076Jvyr4PZBbQL8Ls+hK1mCodMWUMTYRZd7hrccnALYtPuTupf5S1EML/J+/SFms
+Fg08uLPJGH1gYh/DTUAS4m+rZZZc7ey17XDyY05GdX4p0+WBasHkAokfAgMBAAGg
 JTAjBgkqhkiG9w0BCQcxFhMUQ2hhbGxlbmdlIGZvciB0aGUgQ0EwDQYJKoZIhvcN
-AQEFBQADggIBAKMiuMHoAeRVk/wC5Mize0EYf5E8xYwLAkx/nTOIkNcBSmbejHsW
-kwI86+FSiUlo+ndK6UYSiFhtb8kTw299hKt5PQqkz2/FYozOvS2YEXpzJDXOHmXL
-u5vNHq0TkjgkT5F+4m6nlgLSCssQWDsyoCF5gB58D9BMyG02NKnJ9M6/Matsvz6m
-7BnQwclVPSvpYiF5FSwnYdiZAbftt+BFqgHaKqYhLnMUtX8tLjSNCBgdaItSb+Vc
-icGJuIOTqTFSH8PATd50WNXqnJxZsFZmcRKmJ8h6mNqmv6tcJ4iLPFfMLuMFskG/
-L9O4FC9vLtfhCuAGtoaWRJPQ6oYC/3HL97fn3SudwAY+u5tp7CqAzFvMkMJ0gQeI
-8xIkwFkajUCHqV0Gug9Bx+B24YTNPzYiiJ0yIlyTh4R7D9PFv3a9RMOq6bvCwexJ
-02soRu9jijTwklD6jECa/gm40s8ChFo+c3YAF2MjFk1zjd7xT+jW8Pp0uEP9ig6H
-4n+gakpvSRFz2l1DZq3rfofyqBFOdVJRJ3IWc+n79K/E7zCTSA68vfYutMj+wuzW
-mSs0vBFu+2BQDHaCwq9R9vAhh2YLJZ9v6mID5PvqFGCJ2drNaTktR9xLfpmve6oC
-mn8mlI+pUaCd52XdgpYCTlXsnieaPOEWycSxnML8UxwoFk05K+oumg6F
+AQEFBQADggIBAGeE6ml7EshJvPvOv+I8DrcjzHiAO4+0w/weknWfS/ndAafkLBa7
+5TMFhnBFHQ9/XbvctyNCc5u5OQfRxQwJccV4OUiTPPXqN4UWWSzxIw8zVM/8MdiH
+yaVFYqr2gyAKlcCvKavWNKMXVdeoOFnAwA7rfgtA2mMNM0ZoSJr/PISkzN6ZFyh2
+VSCrVdBZ1pTMslIKqWkRgqeqlrRhEVXZIljrG5+vVVnzfxycPjeN3VD5US8Pr9B0
+im6sbDTn2z5pRTkVWc/cL1F7spxsa67KVqwwHx9GNojo7SY/NNeWQTaTe3uVa/Hp
+VXRAcutovboGVcMhu92Udz+bpn2XpbNZnWJGRkRZRLWG2Z+k/REGhMk+5LuMh/+N
+uumIThiNtCPeg3/esVxlAqDokteqnoE0XHtcBUTacvedgmxASV98Wu+Rx7MnVgTf
+29wGb132ZSRMEzoB0hSm9tjB2DVI/O1+YOcPDhoLHpfkUE+qXQTWPKCvrZCspJp9
+UYkWVTfbRJavXOOi8tRHvt0AfxEnyq3o1H7veqDxL0NMuXvNAL2fEt0Av1zfyHyS
+Ch+NpByF9m2BMG0TUrrMhtb83X+Rb7VOC6sbs8H+ste9DOwh2930T1eFsb0/32R8
+ix0EMI5Yi60RLcL9WOjdQ1JAMeO6+dywL8WpjyAyUegeMxwlzZCMRSvv
 -----END CERTIFICATE REQUEST-----

=== modified file 'bzrlib/tests/ssl_certs/server_with_pass.key'
--- bzrlib/tests/ssl_certs/server_with_pass.key	2008-01-05 22:09:47 +0000
+++ bzrlib/tests/ssl_certs/server_with_pass.key	2009-11-26 14:17:19 +0000
@@ -1,54 +1,54 @@
 -----BEGIN RSA PRIVATE KEY-----
 Proc-Type: 4,ENCRYPTED
-DEK-Info: DES-EDE3-CBC,F62A242FE077370D
+DEK-Info: DES-EDE3-CBC,60937C843264DF9B
 
-VzZiKGEsk27MopuxsH8hHDK1RPC6JBv2r/6936HAeOtVZu94ws9u2MAQ8E/tH1vD
-ggilBOPV4elonv3IzdoIxWFsvnuUvuf8rkXIrE/pP8FxunhihXnpz/fMK62jSYXe
-T46xTA6hEqG2EVs9mtGyfeFN8ZA7D5yciuK1t3bstWrIwH1n0h5fOztsWmP1w99D
-aHz2VtfJS4/+G1wMI3cwj4pdsGbHvEYRbxMhgsZ+e9qFmugm1jk1l1rV4C/fO5wL
-bclNDYX5EcYTkYEIqHo223wFNIlsOmod5bIsa7lv0tz+Vct0R7BLNkGlqE3G3ofu
-5Ek32YH3nvGkHhGUuY6n0FhSJJLjh9+2GrMimr+8tCPVAemM35Xe/VyN87kOWhuG
-UjfEms0//HbkO0jyoD/x0SpBuX2+cjMAyqCob6HkNXtWC9X7ZO6L36gBHs7DYKTz
-cX7Y9ram2PRb1Z1np5NigZ/Cestviy7uG1obfQbhPII/kovEV1K494Nbkmw5YvLK
-Np9zAay1eZZW+THn6kC8OhwnOQtRpj7SLpjclFMNj9uhfB6Dxo53q2dV0lwc+T1b
-aBCjy3A6R12meTCoPbGg2MqBA2aURPSRGKlYu09WvreX3tiM3GFOBfVIDiBulPT1
-RSWFM4IoXOg7WKHd1pXdO7WNV88Yi2iwFx4KASPOUMSvm8wq5NbE6TZ0oSuKiCNh
-szMTGsF2l7JZamW7MK19xom/ZxuZc0UzRzTD2Rp41EeRaX0GdPYz183AT1r/aT9S
-kzKRMG22tJBx7WIhs6T+/KqTQO2jI14G2XcaclhGG5u320ghm8UgEwg6hMFiPuhC
-dSO9wknjfunF6W/gyKbf36XSn9n4Yvx8YECuEQd5BligKyuUtIg0zn6Mwg2J1qYq
-N3yeZhNDcC7DZDLd8Lhu1NfWfzxiSoHeOUVGRApnUMMLtKoLPJpwz5qXTc6tLBky
-czlUAckRDS6f2lb9xPQm95pLg3wGmgvLcWn3ut5Rh+QwZ2GhJu3lbeQLd9rEtTHc
-+qg2B/tLxOfjPNcaWCkDCi7P1B7I8U2E6teNxVEEHRiK5zIeC/g0WXehaVnjzwkt
-L6fuxRiuBwe9m0cwVJuI33+1Y4CuWKsaBqlg/dHXCH3Ij3Iv9DU0Yary9uEkon7D
-BSDFZWJLvFpjnW/g0la0ow5Y6KTw2QyI8F8NbzKZIp647loclYeoN95RzF/rfB7I
-JJhvvuH7sT3EoN6fi8Dlq5IBVLMONN2BKFSheRI0Gui5bIY0+REijcgqZiwryGIk
-298pnfHSxeP39wQQvXfwMIl3r3XWxSWt9jDz5T3X4fxDJcp2GsW+Z5KZ158lX6g6
-I41JMHp6cKeg7NGdK52EW6ejD1blLL3vXt4MvRcnqvhDvJMbMSFhDhD0rFcPRERx
-q1Hw9Wc6V+isqmUcmmjULU3i/D7ksCuaHFsf7A/8EICbJG2jercRktBIm1CxzEvo
-IRnI53O5xINHb/JHIW6Vv9nyC5Bmc+dVojRpd3FOcxyuSLULo7VcDSWhU3j3dr+t
-TpF1Cm0dWGOeCHy1dVmMIEGd04WZdYguSlBkRSkvuZV14Y9DddRtsS/XiFm3ek3q
-tY0h3u6sx363Ap+pSz4XMy+P6nHRMr1ucBpAAy87vL8Oce6tUAwV2OR9laVBOafS
-kG2FSXY4ievLBT4qsBEnDIkiYxA3uA2bF5nnIlSE4Mv7BgKWjRqPnY6JTKR3eFd6
-YVXLd79z03iPJlnCCPga3RUWhjWDc3BvUCAv2yvzdARRCQga/Gtsi3aHAoSDMxgf
-YnUKmik1mboR50uvMfC6tstgI9yZ+ackYQQnuewDa/lN17Aq7HqGo5sf6rLMa82B
-x2UtEsYoTN477AGYOTzpQEoyb2uWpxw4qumLqsbSXzyw9jJzQ+/1c2jePzoatSdO
-QNE8tVRylusboL45fXtYetFV4EoqNdDgAsXLa75ooLInS+oh+gHeuxtJJXxa3deJ
-JXoqkP1TMExsRpVNnvN93FG6JEvYSbaUS9TZGc8+mZcQ7WWfkJnZjnOGtczkHG5a
-b1X8N28MGBkw00mdoCxJ573fvl4NmYeJC6clX8vU/nzG7u3duhjYGqacPktuX5/X
-/eKRJJ6OyLJm/S+cWNmFoaRCy95WDPbyZyUby/+aV57prbXMFar3+NTTBK+y0pmI
-/6q832eqj6IIHsL6VgFq2+l3abXcS2h6MIJjYLmURWAnWDednCDauEFrzzp6jo68
-2sZZOiW5drULi5tirtC3+mC4ERlcylcHZIfdCDyXifKvKJ3Ch/kDR/zvAMVIwicJ
-iMT/n8/5PidW217rtZlz5gjd3EunpdRQuNnNa8Ap2v4ddfUSeGI2UAOEt2rtfteu
-7pJF6wkP9QkYhJWKOBHbL8RxdATnhyVSMWo1iYM/zthOP8+IpZVDzl5uwr1gi4zf
-NQAQy7dxZKRO91GSeUX+BMxgAmDzwh24sbzpw/dTCGbiKTkujWchhAcJXXoq+LFb
-o9zWQ7/zz5g6L6yW6iuDGVJ/87mHX851/QVJfyP5lNURqkSOfsGMqjoz04bLOuxc
-znuAs/R6gc2jwwfF0rhDHJyLJQsuAFCxbAV7qc0kqcihhh34kqDujq9tQEdP65M5
-E6qfBjVoaPHFXeR+XaCPyMygJDHv5eaU2qojvq12CehcOKL66wMXt20A59C2ZDZp
-9cWg8KEej7vlfsA8JzkwcIYMWnHDUDViGqM/ifwQ95uSjEy+7HZVrQFFpcr1f/XF
-tJe/nArOxGf9d4VVbShKOleg2139fed6mfobJklHlFkzL2T5DgNCFc6iYSI3c2DQ
-Lh3mdwwjsVWh5kE5r0PCYSkhlg41DfrZTHx0pbRdix63jD4AsuMZ1+vT9taxUSYZ
-mTc4ELu8kH2I/Qm/8tVPnkjUxxApL7PIpvlnF3SbYNkd3AIbgtSWz782KpghKPmk
-SnIYXWQXlOtiliU2Wek+ntr5oguSKo5HmIfkF8Ad9SsEN8GxkmmQKOM9cO1ueDch
-7MP6KTE8wumSXl82hbiZK1GaErXGLenKKTrw0fqKY8mUiB/ciCqyLzgOtgVfAkPj
-T2/YQQp42Ppw1r3sJwObi0gvuHT+KQSBGTOmBCxKCi0s61T/Yolosy7b5eoUQEKR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 -----END RSA PRIVATE KEY-----

=== modified file 'bzrlib/tests/ssl_certs/server_without_pass.key'
--- bzrlib/tests/ssl_certs/server_without_pass.key	2008-01-05 22:09:47 +0000
+++ bzrlib/tests/ssl_certs/server_without_pass.key	2009-11-26 14:17:19 +0000
@@ -1,51 +1,51 @@
 -----BEGIN RSA PRIVATE KEY-----
-MIIJJwIBAAKCAgEAsvSNdobG/oO97vhO7xcHpQfpx2QHwYOn+Im0FMTXbTPdBre4
-wkjEC2KxOjH6MGBEQM02h8SUAWCcvX+HyLBkZRtgeueZZaf2iqc+Tr24ueMaf8el
-qz1tuaua7zyuR+uUgZyxX7rgbuVDUYNt5qVN8uXUSbCtVgxHa3extD7fbvD8t9P/
-QUItx5EBBEeWVhtVffgI35OWMwsJhiwK68ka0kTLJJhZyqAQujKnZf0uHyAvVkai
-1fYtjklBVLnxwvJZOwnQto3RF1AmuMgj7T6RwDjTR43DioHtTJotrPZfQaAF3tVC
-30Vy8pm0ojFdxUdKPgEMOLBWizXWc3lzWn02CE0awHxwIYNVNLODX3sU/ou8OqOI
-MDRK451xE5S5WOXciWLknY/ene2r4g/pPFYNrwc/9eZ0AYIhE7Jm7b+D3WvLz3Cr
-hYul/XmPsXBHBnxkrjvtrj0yDZyHZnMpygqL7Cr9/2V9FwMFPNTNY5Sifmcxl6or
-vx8oe6Q98XwGD575wWU6BwIrpriSa2HWrVIDwwbSCeZ8NULXe8fnC8zInckjtzz8
-osqRv4af+XXoht5zJtt8fUc7o4Xiq4Yyzlj3lJMHWcP+GqzCbJ0c/OY6C/mlC6Yb
-MeCwv+/gAs3Xw1eSzimDqxh/kIw6SgBUGoQVffOzaJo917cMyYycLDDN9/8CAwEA
-AQKCAgBbtFaJ1qdC5d//Bd/tRa/1Mgjq1Kfk0sLQ6kAOJJEAtQMe3icf6IoOC5Um
-bVX4VFylmIPJL0NpMUkhEqlSfpHz/gOC+AvzvA7rHqkfULnJCEgcEwMirWf9LaNH
-1aC52k9P3CxJEkrQiUvmCaPX/f3j60LOQGuTHNe8iqnV5CI7h+L5kPnNR0yOaBBN
-USIJHhjBZMmnSMo/ffhzeT5fdb744af4KNpaq4vm3u5JpWRtLuETJT9sxaqyr3d7
-I45wiCCR0IXUBviPKdOt/WHrwZSPHI+oq0z5PXuNNbUSXW6TAp3/gumx4LT2/S1D
-sGiNH+s7uu24XyT6UayDoEkspd15qCTfoqZX6CSgFAzu06NB5S7OBuFYG3Y33Fi7
-1LrlQiAjo0GrvJMAGOwGsYJxxCn4M6avrl+8eTLSQ7U4gz2AmnwbFsX5FaGThin8
-myZlwUk0mCTXoDr4AO+WG9HhLworsdZsBn82liQWHLBt+Xv4NVbnt7pPvmf+VqER
-q9KWGxSCbm3vQMVJPrtfBcEpCmYdZZZYFJbmcdz/homh9QRZY4rto+CK/Cza0SPe
-aN/OIVDmCCoe8dSeNYOfGe79K8lMalhrwjxsBD6x5Og9AyfFczeSHASBgQ3QC2JJ
-qcB19eaQRIqw+VMjYqmPdRN0A25KAWekQpUfKDidR1IBn0w2gQKCAQEA2T+Bfgt1
-7Mz8TTHEGr0NBaypDBPLXY0sKyu0aCkqV1HKxyMEPuNMqbE+6raYz6QCoDfn1d4/
-wwPCdUzPI+JAVjEjEFtRJYJdT6OCj9dW94gBKx/lF6/nAMt8i0U5foVJt/TAjyDK
-zIx1EM9vGMKj3wfENJOj6WCdKbtBlHkotZHxGkSF/262Lbo02/maUdQAbY1j3Tly
-M583U0as78oUczUT575TG1RYwofN0YF/gzQJpPoYIhg75wWCvog+sbJonp3FslMn
-3ifdK6eZI7fTTr8SrNNulf8Iwonbdz/a09yJnuPL7tI0Ea5tqrgeNwTHKxW/Jf3o
-cMjlGq74VShNbQKCAQEA0uBuYUJwsQZEaGo4tDzyjpfG2JZt43Afdgwb3rMb61CG
-PFdBRcVQMu8NwnXQuQ9TobQ9trPrwW/rt0Bx2BQ6uLGPU743XA6UB8q+goCCdMVW
-GImcObwFOMOqZfEHFn04+1/a+Sf/dRRPv40uGMPKDpK8im8xGNEKhIQWYIFNAy5E
-IpYljGZFCC/r34E+0bmkBM+U///XmrgS6WWkRTl06GBrmuXlmhScz5GmHiKN33Yv
-cDJVUh2M3SxHKtYrcJTfdM1rX8iZR/9BPNC5qCDUVJJD9BuCXXtPzfGeKQYqNDf9
-OwVsuyXDfjp+zJ90BB0seum5Ozi5wMdTjb1TMUgTmwKCAQAQlMJDZoiHnFWdZrD7
-AXbe+gClBVW+PCok2V8ZnBq5M2rwrAGE80BEq1yL+YfMQU5aACpXrnDbZ4wN++DL
-cldKvNFaTD3zSPHqRCaQ5/ShS+Ya7oJDvo85Bk7pKk1rFK09txaDVhNkbUv6DnsC
-PsjXGvaktKgMBe2446vrsxuiUBNA1/4KMt8AuneSWoimujGWKvZ2Sg4nVn2Yg4pr
-etb4vBJa27HoIhXsMwVIekPLNcuOpe/1mjfoOAl0lV2DnoRRpuUR6Trfv9cnn9EW
-Ys9j8T1xp2mHVUHL502y2lLPXMO8NtK31Z9XwiJop0jXFixFY5GFSs3U3eBumvAl
-P8A5AoIBABW7b2Syli6IONCR8doRVeYAGkwD5LtFuNhPkye2SbBMkijxzRZFqWg2
-XrKltab8v1+w1ZNYo3lB8YbnK1RbcVnLYrv8pHPmRLcw28VTPR6Pn7nTpLgGentJ
-Hux2lIZqzU6KqGR5DMiiGT3ibNe8hbxOvwN9RhAKqwzRGAVGDgu/3uG5m5EGkSKw
-3ZwhE7pFaXPdeLuRQET/p2NKSE2iCDxSg4RpIOpqKWby2a3NXdWjtmvXpBdcWEIK
-6CKwA7YMgaLl8KTkZXeYBL8hu6BqEbfNgxdLJno/1Q+iUOxlaEANbRmCC5yV3bnK
-iXrJDAnIf+cC40YJKIuHf0LiOgqgJPUCggEANq8cFcQSuqa3k3Xr1RUJN2sbWKvW
-oR1KqfF61gm5AJ+0lLLtLpr7asQctlAqDAktk6cBdcZ2PhYduF9YHX5anCdMRCvJ
-FK+u6AvrEo0g2C9Z7AqZ/zcV5XOJ9C+yqIig/FZmCfx1EZvBQgs6Bivl13uZfZHX
-kYRa9sTMURf5vgbEsK+P1aQ4fHikhv45xFGA0nFyIUAjaaxrwoRzJtO3doFu7Fhg
-frLDYzU4djn73Qw7NofOWfRK7IF8yCmtF9IeDe11HGtj5Si5RqEhVGtCyHUQw8uu
-z3Cc2xf2HPtiqNO4cnXFA1r9ay6KMNVs1MGF2WoGgDk+EXAmjD+W7i/BeQ==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==
 -----END RSA PRIVATE KEY-----

=== modified file 'bzrlib/tests/stub_sftp.py'
--- bzrlib/tests/stub_sftp.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/stub_sftp.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Robey Pointer <robey@lag.net>, Canonical Ltd
+# Copyright (C) 2005, 2006, 2008, 2009, 2010 Robey Pointer <robey@lag.net>, Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,51 +20,63 @@
 """
 
 import os
-from paramiko import ServerInterface, SFTPServerInterface, SFTPServer, SFTPAttributes, \
-    SFTPHandle, SFTP_OK, AUTH_SUCCESSFUL, OPEN_SUCCEEDED
+import paramiko
+import select
+import socket
 import sys
-
-from bzrlib.osutils import pathjoin
-from bzrlib.trace import mutter
-
-
-class StubServer (ServerInterface):
+import threading
+import time
+
+from bzrlib import (
+    osutils,
+    trace,
+    urlutils,
+    )
+from bzrlib.transport import (
+    local,
+    Server,
+    ssh,
+    )
+
+class StubServer (paramiko.ServerInterface):
 
     def __init__(self, test_case):
-        ServerInterface.__init__(self)
+        paramiko.ServerInterface.__init__(self)
         self._test_case = test_case
 
     def check_auth_password(self, username, password):
         # all are allowed
         self._test_case.log('sftpserver - authorizing: %s' % (username,))
-        return AUTH_SUCCESSFUL
+        return paramiko.AUTH_SUCCESSFUL
 
     def check_channel_request(self, kind, chanid):
-        self._test_case.log('sftpserver - channel request: %s, %s' % (kind, chanid))
-        return OPEN_SUCCEEDED
-
-
-class StubSFTPHandle (SFTPHandle):
+        self._test_case.log(
+            'sftpserver - channel request: %s, %s' % (kind, chanid))
+        return paramiko.OPEN_SUCCEEDED
+
+
+class StubSFTPHandle (paramiko.SFTPHandle):
     def stat(self):
         try:
-            return SFTPAttributes.from_stat(os.fstat(self.readfile.fileno()))
+            return paramiko.SFTPAttributes.from_stat(
+                os.fstat(self.readfile.fileno()))
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
 
     def chattr(self, attr):
         # python doesn't have equivalents to fchown or fchmod, so we have to
         # use the stored filename
-        mutter('Changing permissions on %s to %s', self.filename, attr)
+        trace.mutter('Changing permissions on %s to %s', self.filename, attr)
         try:
-            SFTPServer.set_file_attr(self.filename, attr)
+            paramiko.SFTPServer.set_file_attr(self.filename, attr)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-
-
-class StubSFTPServer (SFTPServerInterface):
+            return paramiko.SFTPServer.convert_errno(e.errno)
+
+
+class StubSFTPServer (paramiko.SFTPServerInterface):
 
     def __init__(self, server, root, home=None):
-        SFTPServerInterface.__init__(self, server)
+        paramiko.SFTPServerInterface.__init__(self, server)
         # All paths are actually relative to 'root'.
         # this is like implementing chroot().
         self.root = root
@@ -113,10 +125,10 @@
 
     def chattr(self, path, attr):
         try:
-            SFTPServer.set_file_attr(path, attr)
+            paramiko.SFTPServer.set_file_attr(path, attr)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-        return SFTP_OK
+            return paramiko.SFTPServer.convert_errno(e.errno)
+        return paramiko.SFTP_OK
 
     def list_folder(self, path):
         path = self._realpath(path)
@@ -130,26 +142,27 @@
             else:
                 flist = os.listdir(path)
             for fname in flist:
-                attr = SFTPAttributes.from_stat(os.stat(pathjoin(path, fname)))
+                attr = paramiko.SFTPAttributes.from_stat(
+                    os.stat(osutils.pathjoin(path, fname)))
                 attr.filename = fname
                 out.append(attr)
             return out
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
 
     def stat(self, path):
         path = self._realpath(path)
         try:
-            return SFTPAttributes.from_stat(os.stat(path))
+            return paramiko.SFTPAttributes.from_stat(os.stat(path))
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
 
     def lstat(self, path):
         path = self._realpath(path)
         try:
-            return SFTPAttributes.from_stat(os.lstat(path))
+            return paramiko.SFTPAttributes.from_stat(os.lstat(path))
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
 
     def open(self, path, flags, attr):
         path = self._realpath(path)
@@ -162,11 +175,11 @@
                 # an odd default mode for files
                 fd = os.open(path, flags, 0666)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
 
         if (flags & os.O_CREAT) and (attr is not None):
             attr._flags &= ~attr.FLAG_PERMISSIONS
-            SFTPServer.set_file_attr(path, attr)
+            paramiko.SFTPServer.set_file_attr(path, attr)
         if flags & os.O_WRONLY:
             fstr = 'wb'
         elif flags & os.O_RDWR:
@@ -177,7 +190,7 @@
         try:
             f = os.fdopen(fd, fstr)
         except (IOError, OSError), e:
-            return SFTPServer.convert_errno(e.errno)
+            return paramiko.SFTPServer.convert_errno(e.errno)
         fobj = StubSFTPHandle()
         fobj.filename = path
         fobj.readfile = f
@@ -189,8 +202,8 @@
         try:
             os.remove(path)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-        return SFTP_OK
+            return paramiko.SFTPServer.convert_errno(e.errno)
+        return paramiko.SFTP_OK
 
     def rename(self, oldpath, newpath):
         oldpath = self._realpath(oldpath)
@@ -198,8 +211,8 @@
         try:
             os.rename(oldpath, newpath)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-        return SFTP_OK
+            return paramiko.SFTPServer.convert_errno(e.errno)
+        return paramiko.SFTP_OK
 
     def mkdir(self, path, attr):
         path = self._realpath(path)
@@ -212,18 +225,338 @@
                 os.mkdir(path)
             if attr is not None:
                 attr._flags &= ~attr.FLAG_PERMISSIONS
-                SFTPServer.set_file_attr(path, attr)
+                paramiko.SFTPServer.set_file_attr(path, attr)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-        return SFTP_OK
+            return paramiko.SFTPServer.convert_errno(e.errno)
+        return paramiko.SFTP_OK
 
     def rmdir(self, path):
         path = self._realpath(path)
         try:
             os.rmdir(path)
         except OSError, e:
-            return SFTPServer.convert_errno(e.errno)
-        return SFTP_OK
+            return paramiko.SFTPServer.convert_errno(e.errno)
+        return paramiko.SFTP_OK
 
     # removed: chattr, symlink, readlink
     # (nothing in bzr's sftp transport uses those)
+
+# ------------- server test implementation --------------
+
+STUB_SERVER_KEY = """
+-----BEGIN RSA PRIVATE KEY-----
+MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
+oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
+d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
+gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
+EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
+soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
+tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
+avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
+4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
+H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
+qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
+HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
+nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
+-----END RSA PRIVATE KEY-----
+"""
+
+
+class SocketListener(threading.Thread):
+
+    def __init__(self, callback):
+        threading.Thread.__init__(self)
+        self._callback = callback
+        self._socket = socket.socket()
+        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
+        self._socket.bind(('localhost', 0))
+        self._socket.listen(1)
+        self.host, self.port = self._socket.getsockname()[:2]
+        self._stop_event = threading.Event()
+
+    def stop(self):
+        # called from outside this thread
+        self._stop_event.set()
+        # use a timeout here, because if the test fails, the server thread may
+        # never notice the stop_event.
+        self.join(5.0)
+        self._socket.close()
+
+    def run(self):
+        while True:
+            readable, writable_unused, exception_unused = \
+                select.select([self._socket], [], [], 0.1)
+            if self._stop_event.isSet():
+                return
+            if len(readable) == 0:
+                continue
+            try:
+                s, addr_unused = self._socket.accept()
+                # because the loopback socket is inline, and transports are
+                # never explicitly closed, best to launch a new thread.
+                threading.Thread(target=self._callback, args=(s,)).start()
+            except socket.error, x:
+                sys.excepthook(*sys.exc_info())
+                warning('Socket error during accept() within unit test server'
+                        ' thread: %r' % x)
+            except Exception, x:
+                # probably a failed test; unit test thread will log the
+                # failure/error
+                sys.excepthook(*sys.exc_info())
+                warning('Exception from within unit test server thread: %r' %
+                        x)
+
+
+class SocketDelay(object):
+    """A socket decorator to make TCP appear slower.
+
+    This changes recv, send, and sendall to add a fixed latency to each python
+    call if a new roundtrip is detected. That is, when a recv is called and the
+    flag new_roundtrip is set, latency is charged. Every send and send_all
+    sets this flag.
+
+    In addition every send, sendall and recv sleeps a bit per character send to
+    simulate bandwidth.
+
+    Not all methods are implemented, this is deliberate as this class is not a
+    replacement for the builtin sockets layer. fileno is not implemented to
+    prevent the proxy being bypassed.
+    """
+
+    simulated_time = 0
+    _proxied_arguments = dict.fromkeys([
+        "close", "getpeername", "getsockname", "getsockopt", "gettimeout",
+        "setblocking", "setsockopt", "settimeout", "shutdown"])
+
+    def __init__(self, sock, latency, bandwidth=1.0,
+                 really_sleep=True):
+        """
+        :param bandwith: simulated bandwith (MegaBit)
+        :param really_sleep: If set to false, the SocketDelay will just
+        increase a counter, instead of calling time.sleep. This is useful for
+        unittesting the SocketDelay.
+        """
+        self.sock = sock
+        self.latency = latency
+        self.really_sleep = really_sleep
+        self.time_per_byte = 1 / (bandwidth / 8.0 * 1024 * 1024)
+        self.new_roundtrip = False
+
+    def sleep(self, s):
+        if self.really_sleep:
+            time.sleep(s)
+        else:
+            SocketDelay.simulated_time += s
+
+    def __getattr__(self, attr):
+        if attr in SocketDelay._proxied_arguments:
+            return getattr(self.sock, attr)
+        raise AttributeError("'SocketDelay' object has no attribute %r" %
+                             attr)
+
+    def dup(self):
+        return SocketDelay(self.sock.dup(), self.latency, self.time_per_byte,
+                           self._sleep)
+
+    def recv(self, *args):
+        data = self.sock.recv(*args)
+        if data and self.new_roundtrip:
+            self.new_roundtrip = False
+            self.sleep(self.latency)
+        self.sleep(len(data) * self.time_per_byte)
+        return data
+
+    def sendall(self, data, flags=0):
+        if not self.new_roundtrip:
+            self.new_roundtrip = True
+            self.sleep(self.latency)
+        self.sleep(len(data) * self.time_per_byte)
+        return self.sock.sendall(data, flags)
+
+    def send(self, data, flags=0):
+        if not self.new_roundtrip:
+            self.new_roundtrip = True
+            self.sleep(self.latency)
+        bytes_sent = self.sock.send(data, flags)
+        self.sleep(bytes_sent * self.time_per_byte)
+        return bytes_sent
+
+
+class SFTPServer(Server):
+    """Common code for SFTP server facilities."""
+
+    def __init__(self, server_interface=StubServer):
+        self._original_vendor = None
+        self._homedir = None
+        self._server_homedir = None
+        self._listener = None
+        self._root = None
+        self._vendor = ssh.ParamikoVendor()
+        self._server_interface = server_interface
+        # sftp server logs
+        self.logs = []
+        self.add_latency = 0
+
+    def _get_sftp_url(self, path):
+        """Calculate an sftp url to this server for path."""
+        return 'sftp://foo:bar@%s:%d/%s' % (self._listener.host,
+                                            self._listener.port, path)
+
+    def log(self, message):
+        """StubServer uses this to log when a new server is created."""
+        self.logs.append(message)
+
+    def _run_server_entry(self, sock):
+        """Entry point for all implementations of _run_server.
+
+        If self.add_latency is > 0.000001 then sock is given a latency adding
+        decorator.
+        """
+        if self.add_latency > 0.000001:
+            sock = SocketDelay(sock, self.add_latency)
+        return self._run_server(sock)
+
+    def _run_server(self, s):
+        ssh_server = paramiko.Transport(s)
+        key_file = osutils.pathjoin(self._homedir, 'test_rsa.key')
+        f = open(key_file, 'w')
+        f.write(STUB_SERVER_KEY)
+        f.close()
+        host_key = paramiko.RSAKey.from_private_key_file(key_file)
+        ssh_server.add_server_key(host_key)
+        server = self._server_interface(self)
+        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer,
+                                         StubSFTPServer, root=self._root,
+                                         home=self._server_homedir)
+        event = threading.Event()
+        ssh_server.start_server(event, server)
+        event.wait(5.0)
+
+    def start_server(self, backing_server=None):
+        # XXX: TODO: make sftpserver back onto backing_server rather than local
+        # disk.
+        if not (backing_server is None or
+                isinstance(backing_server, local.LocalURLServer)):
+            raise AssertionError(
+                "backing_server should not be %r, because this can only serve the "
+                "local current working directory." % (backing_server,))
+        self._original_vendor = ssh._ssh_vendor_manager._cached_ssh_vendor
+        ssh._ssh_vendor_manager._cached_ssh_vendor = self._vendor
+        if sys.platform == 'win32':
+            # Win32 needs to use the UNICODE api
+            self._homedir = getcwd()
+        else:
+            # But Linux SFTP servers should just deal in bytestreams
+            self._homedir = os.getcwd()
+        if self._server_homedir is None:
+            self._server_homedir = self._homedir
+        self._root = '/'
+        if sys.platform == 'win32':
+            self._root = ''
+        self._listener = SocketListener(self._run_server_entry)
+        self._listener.setDaemon(True)
+        self._listener.start()
+
+    def stop_server(self):
+        self._listener.stop()
+        ssh._ssh_vendor_manager._cached_ssh_vendor = self._original_vendor
+
+    def get_bogus_url(self):
+        """See bzrlib.transport.Server.get_bogus_url."""
+        # this is chosen to try to prevent trouble with proxies, wierd dns, etc
+        # we bind a random socket, so that we get a guaranteed unused port
+        # we just never listen on that port
+        s = socket.socket()
+        s.bind(('localhost', 0))
+        return 'sftp://%s:%s/' % s.getsockname()
+
+
+class SFTPFullAbsoluteServer(SFTPServer):
+    """A test server for sftp transports, using absolute urls and ssh."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        homedir = self._homedir
+        if sys.platform != 'win32':
+            # Remove the initial '/' on all platforms but win32
+            homedir = homedir[1:]
+        return self._get_sftp_url(urlutils.escape(homedir))
+
+
+class SFTPServerWithoutSSH(SFTPServer):
+    """An SFTP server that uses a simple TCP socket pair rather than SSH."""
+
+    def __init__(self):
+        super(SFTPServerWithoutSSH, self).__init__()
+        self._vendor = ssh.LoopbackVendor()
+
+    def _run_server(self, sock):
+        # Re-import these as locals, so that they're still accessible during
+        # interpreter shutdown (when all module globals get set to None, leading
+        # to confusing errors like "'NoneType' object has no attribute 'error'".
+        class FakeChannel(object):
+            def get_transport(self):
+                return self
+            def get_log_channel(self):
+                return 'paramiko'
+            def get_name(self):
+                return '1'
+            def get_hexdump(self):
+                return False
+            def close(self):
+                pass
+
+        server = paramiko.SFTPServer(
+            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
+            root=self._root, home=self._server_homedir)
+        try:
+            server.start_subsystem(
+                'sftp', None, ssh.SocketAsChannelAdapter(sock))
+        except socket.error, e:
+            if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
+                # it's okay for the client to disconnect abruptly
+                # (bug in paramiko 1.6: it should absorb this exception)
+                pass
+            else:
+                raise
+        except Exception, e:
+            # This typically seems to happen during interpreter shutdown, so
+            # most of the useful ways to report this error are won't work.
+            # Writing the exception type, and then the text of the exception,
+            # seems to be the best we can do.
+            import sys
+            sys.stderr.write('\nEXCEPTION %r: ' % (e.__class__,))
+            sys.stderr.write('%s\n\n' % (e,))
+        server.finish_subsystem()
+
+
+class SFTPAbsoluteServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using absolute urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        homedir = self._homedir
+        if sys.platform != 'win32':
+            # Remove the initial '/' on all platforms but win32
+            homedir = homedir[1:]
+        return self._get_sftp_url(urlutils.escape(homedir))
+
+
+class SFTPHomeDirServer(SFTPServerWithoutSSH):
+    """A test server for sftp transports, using homedir relative urls."""
+
+    def get_url(self):
+        """See bzrlib.transport.Server.get_url."""
+        return self._get_sftp_url("~/")
+
+
+class SFTPSiblingAbsoluteServer(SFTPAbsoluteServer):
+    """A test server for sftp transports where only absolute paths will work.
+
+    It does this by serving from a deeply-nested directory that doesn't exist.
+    """
+
+    def start_server(self, backing_server=None):
+        self._server_homedir = '/dev/noone/runs/tests/here'
+        super(SFTPSiblingAbsoluteServer, self).start_server(backing_server)
+

=== modified file 'bzrlib/tests/test__annotator.py'
--- bzrlib/tests/test__annotator.py	2009-07-08 17:09:03 +0000
+++ bzrlib/tests/test__annotator.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,36 +28,9 @@
 
 def load_tests(standard_tests, module, loader):
     """Parameterize tests for all versions of groupcompress."""
-    scenarios = [
-        ('python', {'module': _annotator_py}),
-    ]
-    suite = loader.suiteClass()
-    if CompiledAnnotator.available():
-        from bzrlib import _annotator_pyx
-        scenarios.append(('C', {'module': _annotator_pyx}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledAnnotator)
-        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
-    result = tests.multiply_tests(standard_tests, scenarios, suite)
-    return result
-
-
-class _CompiledAnnotator(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._annotator_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._annotator_pyx'
-
-CompiledAnnotator = _CompiledAnnotator()
+    suite, _ = tests.permute_tests_for_extension(standard_tests, loader,
+        'bzrlib._annotator_py', 'bzrlib._annotator_pyx')
+    return suite
 
 
 class TestAnnotator(tests.TestCaseWithMemoryTransport):

=== renamed file 'bzrlib/tests/test_bencode.py' => 'bzrlib/tests/test__bencode.py'
--- bzrlib/tests/test_bencode.py	2009-06-04 17:12:29 +0000
+++ bzrlib/tests/test__bencode.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,48 +19,21 @@
 from bzrlib import tests
 
 def load_tests(standard_tests, module, loader):
-    # parameterize all tests in this module
-    suite = loader.suiteClass()
-    import bzrlib.util._bencode_py as py_module
-    scenarios = [('python', {'bencode': py_module})]
-    if CompiledBencodeFeature.available():
-        import bzrlib._bencode_pyx as c_module
-        scenarios.append(('C', {'bencode': c_module}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledBencodeFeature)
-        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
-    tests.multiply_tests(standard_tests, scenarios, suite)
+    suite, _ = tests.permute_tests_for_extension(standard_tests, loader,
+        'bzrlib.util._bencode_py', 'bzrlib._bencode_pyx')
     return suite
 
 
-class _CompiledBencodeFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._bencode_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._bencode_pyx'
-
-CompiledBencodeFeature = _CompiledBencodeFeature()
-
-
 class TestBencodeDecode(tests.TestCase):
 
-    bencode = None
+    module = None
 
     def _check(self, expected, source):
-        self.assertEquals(expected, self.bencode.bdecode(source))
+        self.assertEquals(expected, self.module.bdecode(source))
 
     def _run_check_error(self, exc, bad):
         """Check that bdecoding a string raises a particular exception."""
-        self.assertRaises(exc, self.bencode.bdecode, bad)
+        self.assertRaises(exc, self.module.bdecode, bad)
 
     def test_int(self):
         self._check(0, 'i0e')
@@ -91,7 +64,7 @@
         self._check('1234567890', '10:1234567890')
 
     def test_large_string(self):
-        self.assertRaises(ValueError, self.bencode.bdecode, "2147483639:foo")
+        self.assertRaises(ValueError, self.module.bdecode, "2147483639:foo")
 
     def test_malformed_string(self):
         self._run_check_error(ValueError, '10:x')
@@ -146,7 +119,7 @@
         self._run_check_error(ValueError, 'd432432432432432432:e')
 
     def test_empty_string(self):
-        self.assertRaises(ValueError, self.bencode.bdecode, '')
+        self.assertRaises(ValueError, self.module.bdecode, '')
 
     def test_junk(self):
         self._run_check_error(ValueError, 'i6easd')
@@ -155,7 +128,7 @@
         self._run_check_error(ValueError, 'leanfdldjfh')
 
     def test_unknown_object(self):
-        self.assertRaises(ValueError, self.bencode.bdecode, 'relwjhrlewjh')
+        self.assertRaises(ValueError, self.module.bdecode, 'relwjhrlewjh')
 
     def test_unsupported_type(self):
         self._run_check_error(TypeError, float(1.5))
@@ -165,15 +138,15 @@
         self._run_check_error(TypeError, u"ie")
 
     def test_decoder_type_error(self):
-        self.assertRaises(TypeError, self.bencode.bdecode, 1)
+        self.assertRaises(TypeError, self.module.bdecode, 1)
 
 
 class TestBencodeEncode(tests.TestCase):
 
-    bencode = None
+    module = None
 
     def _check(self, expected, source):
-        self.assertEquals(expected, self.bencode.bencode(source))
+        self.assertEquals(expected, self.module.bencode(source))
 
     def test_int(self):
         self._check('i4e', 4)
@@ -205,7 +178,7 @@
         for i in range(10000):
             l.append([])
             l = l[0]
-        self.assertRaises(RuntimeError, self.bencode.bencode, 
+        self.assertRaises(RuntimeError, self.module.bencode, 
             top)
 
     def test_dict(self):
@@ -220,14 +193,14 @@
         for i in range(10000):
             d[''] = {}
             d = d['']
-        self.assertRaises(RuntimeError, self.bencode.bencode, 
+        self.assertRaises(RuntimeError, self.module.bencode, 
             top)
 
     def test_bencached(self):
-        self._check('i3e', self.bencode.Bencached(self.bencode.bencode(3)))
+        self._check('i3e', self.module.Bencached(self.module.bencode(3)))
 
     def test_invalid_dict(self):
-        self.assertRaises(TypeError, self.bencode.bencode, {1:"foo"})
+        self.assertRaises(TypeError, self.module.bencode, {1:"foo"})
 
     def test_bool(self):
         self._check('i1e', True)

=== modified file 'bzrlib/tests/test__chk_map.py'
--- bzrlib/tests/test__chk_map.py	2009-04-09 20:23:07 +0000
+++ bzrlib/tests/test__chk_map.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,41 +20,16 @@
     chk_map,
     tests,
     )
+from bzrlib.static_tuple import StaticTuple
+stuple = StaticTuple
 
 
 def load_tests(standard_tests, module, loader):
-    # parameterize all tests in this module
-    suite = loader.suiteClass()
-    import bzrlib._chk_map_py as py_module
-    scenarios = [('python', {'module': py_module})]
-    if CompiledChkMapFeature.available():
-        import bzrlib._chk_map_pyx as c_module
-        scenarios.append(('C', {'module': c_module}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledChkMapFeature)
-        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
-    tests.multiply_tests(standard_tests, scenarios, suite)
+    suite, _ = tests.permute_tests_for_extension(standard_tests, loader,
+        'bzrlib._chk_map_py', 'bzrlib._chk_map_pyx')
     return suite
 
 
-class _CompiledChkMapFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._chk_map_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._chk_map_pyx'
-
-CompiledChkMapFeature = _CompiledChkMapFeature()
-
-
 class TestSearchKeys(tests.TestCase):
 
     module = None # Filled in by test parameterization
@@ -67,25 +42,25 @@
         self.assertEqual(expected, actual, 'actual: %r' % (actual,))
 
     def test_simple_16(self):
-        self.assertSearchKey16('8C736521', ('foo',))
-        self.assertSearchKey16('8C736521\x008C736521', ('foo', 'foo'))
-        self.assertSearchKey16('8C736521\x0076FF8CAA', ('foo', 'bar'))
-        self.assertSearchKey16('ED82CD11', ('abcd',))
+        self.assertSearchKey16('8C736521', stuple('foo',))
+        self.assertSearchKey16('8C736521\x008C736521', stuple('foo', 'foo'))
+        self.assertSearchKey16('8C736521\x0076FF8CAA', stuple('foo', 'bar'))
+        self.assertSearchKey16('ED82CD11', stuple('abcd',))
 
     def test_simple_255(self):
-        self.assertSearchKey255('\x8cse!', ('foo',))
-        self.assertSearchKey255('\x8cse!\x00\x8cse!', ('foo', 'foo'))
-        self.assertSearchKey255('\x8cse!\x00v\xff\x8c\xaa', ('foo', 'bar'))
+        self.assertSearchKey255('\x8cse!', stuple('foo',))
+        self.assertSearchKey255('\x8cse!\x00\x8cse!', stuple('foo', 'foo'))
+        self.assertSearchKey255('\x8cse!\x00v\xff\x8c\xaa', stuple('foo', 'bar'))
         # The standard mapping for these would include '\n', so it should be
         # mapped to '_'
-        self.assertSearchKey255('\xfdm\x93_\x00P_\x1bL', ('<', 'V'))
+        self.assertSearchKey255('\xfdm\x93_\x00P_\x1bL', stuple('<', 'V'))
 
     def test_255_does_not_include_newline(self):
         # When mapping via _search_key_255, we should never have the '\n'
         # character, but all other 255 values should be present
         chars_used = set()
         for char_in in range(256):
-            search_key = self.module._search_key_255((chr(char_in),))
+            search_key = self.module._search_key_255(stuple(chr(char_in),))
             chars_used.update(search_key)
         all_chars = set([chr(x) for x in range(256)])
         unused_chars = all_chars.symmetric_difference(chars_used)
@@ -113,10 +88,11 @@
 
     def test_deserialise_empty(self):
         node = self.module._deserialise_leaf_node(
-            "chkleaf:\n10\n1\n0\n\n", ("sha1:1234",))
+            "chkleaf:\n10\n1\n0\n\n", stuple("sha1:1234",))
         self.assertEqual(0, len(node))
         self.assertEqual(10, node.maximum_size)
         self.assertEqual(("sha1:1234",), node.key())
+        self.assertIsInstance(node.key(), StaticTuple)
         self.assertIs(None, node._search_prefix)
         self.assertIs(None, node._common_serialised_prefix)
 
@@ -194,7 +170,8 @@
 
     def assertDeserialiseErrors(self, text):
         self.assertRaises((ValueError, IndexError),
-            self.module._deserialise_internal_node, text, 'not-a-real-sha')
+            self.module._deserialise_internal_node, text,
+                stuple('not-a-real-sha',))
 
     def test_raises_on_non_internal(self):
         self.assertDeserialiseErrors('')
@@ -211,7 +188,7 @@
 
     def test_deserialise_one(self):
         node = self.module._deserialise_internal_node(
-            "chknode:\n10\n1\n1\n\na\x00sha1:abcd\n", ('sha1:1234',))
+            "chknode:\n10\n1\n1\n\na\x00sha1:abcd\n", stuple('sha1:1234',))
         self.assertIsInstance(node, chk_map.InternalNode)
         self.assertEqual(1, len(node))
         self.assertEqual(10, node.maximum_size)
@@ -221,7 +198,7 @@
 
     def test_deserialise_with_prefix(self):
         node = self.module._deserialise_internal_node(
-            "chknode:\n10\n1\n1\npref\na\x00sha1:abcd\n", ('sha1:1234',))
+            "chknode:\n10\n1\n1\npref\na\x00sha1:abcd\n", stuple('sha1:1234',))
         self.assertIsInstance(node, chk_map.InternalNode)
         self.assertEqual(1, len(node))
         self.assertEqual(10, node.maximum_size)
@@ -230,7 +207,7 @@
         self.assertEqual({'prefa': ('sha1:abcd',)}, node._items)
 
         node = self.module._deserialise_internal_node(
-            "chknode:\n10\n1\n1\npref\n\x00sha1:abcd\n", ('sha1:1234',))
+            "chknode:\n10\n1\n1\npref\n\x00sha1:abcd\n", stuple('sha1:1234',))
         self.assertIsInstance(node, chk_map.InternalNode)
         self.assertEqual(1, len(node))
         self.assertEqual(10, node.maximum_size)
@@ -240,7 +217,8 @@
 
     def test_deserialise_pref_with_null(self):
         node = self.module._deserialise_internal_node(
-            "chknode:\n10\n1\n1\npref\x00fo\n\x00sha1:abcd\n", ('sha1:1234',))
+            "chknode:\n10\n1\n1\npref\x00fo\n\x00sha1:abcd\n",
+            stuple('sha1:1234',))
         self.assertIsInstance(node, chk_map.InternalNode)
         self.assertEqual(1, len(node))
         self.assertEqual(10, node.maximum_size)
@@ -250,7 +228,8 @@
 
     def test_deserialise_with_null_pref(self):
         node = self.module._deserialise_internal_node(
-            "chknode:\n10\n1\n1\npref\x00fo\n\x00\x00sha1:abcd\n", ('sha1:1234',))
+            "chknode:\n10\n1\n1\npref\x00fo\n\x00\x00sha1:abcd\n",
+            stuple('sha1:1234',))
         self.assertIsInstance(node, chk_map.InternalNode)
         self.assertEqual(1, len(node))
         self.assertEqual(10, node.maximum_size)

=== modified file 'bzrlib/tests/test__chunks_to_lines.py'
--- bzrlib/tests/test__chunks_to_lines.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test__chunks_to_lines.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,34 +21,16 @@
 
 
 def load_tests(standard_tests, module, loader):
-    # parameterize all tests in this module
-    import bzrlib._chunks_to_lines_py as py_module
-    scenarios = [('python', {'module': py_module})]
-    if CompiledChunksToLinesFeature.available():
-        import bzrlib._chunks_to_lines_pyx as c_module
-        scenarios.append(('C', {'module': c_module}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledChunksToLinesFeature)
-        standard_tests.addTest(FailWithoutFeature("test_fail"))
-    return tests.multiply_tests(standard_tests, scenarios, loader.suiteClass())
-
-
-class _CompiledChunksToLinesFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._chunks_to_lines_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._chunks_to_lines_pyx'
-
-CompiledChunksToLinesFeature = _CompiledChunksToLinesFeature()
+    suite, _ = tests.permute_tests_for_extension(
+        standard_tests, loader, 'bzrlib._chunks_to_lines_py',
+        'bzrlib._chunks_to_lines_pyx')
+    return suite
+
+# test_osutils depends on this feature being around. We can't just use the one
+# generated by load_tests, because if we only load osutils but not this module,
+# then that code never gets run
+compiled_chunkstolines_feature = tests.ModuleAvailableFeature(
+                                    'bzrlib._chunks_to_lines_pyx')
 
 
 class TestChunksToLines(tests.TestCase):

=== modified file 'bzrlib/tests/test__dirstate_helpers.py'
--- bzrlib/tests/test__dirstate_helpers.py	2009-06-22 15:39:42 +0000
+++ bzrlib/tests/test__dirstate_helpers.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -38,13 +38,8 @@
     has_dirstate_helpers_pyx = False
 
 
-class _CompiledDirstateHelpersFeature(tests.Feature):
-    def _probe(self):
-        return has_dirstate_helpers_pyx
-
-    def feature_name(self):
-        return 'bzrlib._dirstate_helpers_pyx'
-CompiledDirstateHelpersFeature = _CompiledDirstateHelpersFeature()
+compiled_dirstate_helpers_feature = tests.ModuleAvailableFeature(
+                                'bzrlib._dirstate_helpers_pyx')
 
 
 def load_tests(basic_tests, module, loader):
@@ -56,9 +51,9 @@
 
     ue_scenarios = [('dirstate_Python',
                      {'update_entry': dirstate.py_update_entry})]
-    if has_dirstate_helpers_pyx:
-        pyrex_scenario = ('dirstate_Pyrex',
-                          {'update_entry': _dirstate_helpers_pyx.update_entry})
+    if compiled_dirstate_helpers_feature.available():
+        update_entry = compiled_dirstate_helpers_feature.module.update_entry
+        pyrex_scenario = ('dirstate_Pyrex', {'update_entry': update_entry})
         ue_scenarios.append(pyrex_scenario)
     process_entry_tests, remaining_tests = tests.split_suite_by_condition(
         remaining_tests, tests.condition_isinstance(TestUpdateEntry))
@@ -69,10 +64,9 @@
 
     pe_scenarios = [('dirstate_Python',
                      {'_process_entry': dirstate.ProcessEntryPython})]
-    if has_dirstate_helpers_pyx:
-        pyrex_scenario = (
-            'dirstate_Pyrex',
-            {'_process_entry': _dirstate_helpers_pyx.ProcessEntryC})
+    if compiled_dirstate_helpers_feature.available():
+        process_entry = compiled_dirstate_helpers_feature.module.ProcessEntryC
+        pyrex_scenario = ('dirstate_Pyrex', {'_process_entry': process_entry})
         pe_scenarios.append(pyrex_scenario)
     process_entry_tests, remaining_tests = tests.split_suite_by_condition(
         remaining_tests, tests.condition_isinstance(TestProcessEntry))
@@ -259,7 +253,7 @@
 class TestCompiledBisectPathLeft(TestBisectPathLeft):
     """Run all Bisect Path tests against _bisect_path_lect"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_bisect_path(self):
         from bzrlib._dirstate_helpers_pyx import _bisect_path_left
@@ -280,7 +274,7 @@
 class TestCompiledBisectPathRight(TestBisectPathRight):
     """Run all Bisect Path tests against _bisect_path_right"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_bisect_path(self):
         from bzrlib._dirstate_helpers_pyx import _bisect_path_right
@@ -392,7 +386,7 @@
     compiled version.
     """
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_bisect_dirblock(self):
         from bzrlib._dirstate_helpers_pyx import bisect_dirblock
@@ -514,7 +508,7 @@
 class TestCompiledCmpByDirs(TestCmpByDirs):
     """Test the pyrex implementation of cmp_by_dirs"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_cmp_by_dirs(self):
         from bzrlib._dirstate_helpers_pyx import cmp_by_dirs
@@ -665,7 +659,7 @@
 class TestCompiledCmpPathByDirblock(TestCmpPathByDirblock):
     """Test the pyrex implementation of _cmp_path_by_dirblock"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_cmp_by_dirs(self):
         from bzrlib._dirstate_helpers_pyx import _cmp_path_by_dirblock
@@ -675,7 +669,7 @@
 class TestMemRChr(tests.TestCase):
     """Test memrchr functionality"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def assertMemRChr(self, expected, s, c):
         from bzrlib._dirstate_helpers_pyx import _py_memrchr
@@ -743,13 +737,17 @@
 
     def test_trailing_garbage(self):
         tree, state, expected = self.create_basic_dirstate()
-        # We can modify the file as long as it hasn't been read yet.
+        # On Linux, we can write extra data as long as we haven't read yet, but
+        # on Win32, if you've opened the file with FILE_SHARE_READ, trying to
+        # open it in append mode will fail.
+        state.unlock()
         f = open('dirstate', 'ab')
         try:
             # Add bogus trailing garbage
             f.write('bogus\n')
         finally:
             f.close()
+            state.lock_read()
         e = self.assertRaises(errors.DirstateCorrupt,
                               state._read_dirblocks_if_needed)
         # Make sure we mention the bogus characters in the error
@@ -759,7 +757,7 @@
 class TestCompiledReadDirblocks(TestReadDirblocks):
     """Test the pyrex implementation of _read_dirblocks"""
 
-    _test_needs_features = [CompiledDirstateHelpersFeature]
+    _test_needs_features = [compiled_dirstate_helpers_feature]
 
     def get_read_dirblocks(self):
         from bzrlib._dirstate_helpers_pyx import _read_dirblocks
@@ -775,49 +773,49 @@
     """
 
     def test_bisect_dirblock(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import bisect_dirblock
         else:
             from bzrlib._dirstate_helpers_py import bisect_dirblock
         self.assertIs(bisect_dirblock, dirstate.bisect_dirblock)
 
     def test__bisect_path_left(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import _bisect_path_left
         else:
             from bzrlib._dirstate_helpers_py import _bisect_path_left
         self.assertIs(_bisect_path_left, dirstate._bisect_path_left)
 
     def test__bisect_path_right(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import _bisect_path_right
         else:
             from bzrlib._dirstate_helpers_py import _bisect_path_right
         self.assertIs(_bisect_path_right, dirstate._bisect_path_right)
 
     def test_cmp_by_dirs(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import cmp_by_dirs
         else:
             from bzrlib._dirstate_helpers_py import cmp_by_dirs
         self.assertIs(cmp_by_dirs, dirstate.cmp_by_dirs)
 
     def test__read_dirblocks(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import _read_dirblocks
         else:
             from bzrlib._dirstate_helpers_py import _read_dirblocks
         self.assertIs(_read_dirblocks, dirstate._read_dirblocks)
 
     def test_update_entry(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import update_entry
         else:
             from bzrlib.dirstate import update_entry
         self.assertIs(update_entry, dirstate.update_entry)
 
     def test_process_entry(self):
-        if CompiledDirstateHelpersFeature.available():
+        if compiled_dirstate_helpers_feature.available():
             from bzrlib._dirstate_helpers_pyx import ProcessEntryC
             self.assertIs(ProcessEntryC, dirstate._process_entry)
         else:
@@ -1295,6 +1293,25 @@
             tree.unlock()
         self.assertEqual(sorted(expected), sorted(file_ids))
 
+    def test_exceptions_raised(self):
+        # This is a direct test of bug #495023, it relies on osutils.is_inside
+        # getting called in an inner function. Which makes it a bit brittle,
+        # but at least it does reproduce the bug.
+        def is_inside_raises(*args, **kwargs):
+            raise RuntimeError('stop this')
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/file', 'tree/dir/', 'tree/dir/sub',
+                         'tree/dir2/', 'tree/dir2/sub2'])
+        tree.add(['file', 'dir', 'dir/sub', 'dir2', 'dir2/sub2'])
+        tree.commit('first commit')
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        basis_tree = tree.basis_tree()
+        orig = osutils.is_inside
+        self.addCleanup(setattr, osutils, 'is_inside', orig)
+        osutils.is_inside = is_inside_raises
+        self.assertListRaises(RuntimeError, tree.iter_changes, basis_tree)
+
     def test_simple_changes(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/file'])

=== modified file 'bzrlib/tests/test__groupcompress.py'
--- bzrlib/tests/test__groupcompress.py	2009-06-10 03:56:49 +0000
+++ bzrlib/tests/test__groupcompress.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -32,16 +32,16 @@
     scenarios = [
         ('python', {'_gc_module': _groupcompress_py}),
         ]
-    if CompiledGroupCompressFeature.available():
-        from bzrlib import _groupcompress_pyx
+    if compiled_groupcompress_feature.available():
+        gc_module = compiled_groupcompress_feature.module
         scenarios.append(('C',
-            {'_gc_module': _groupcompress_pyx}))
+            {'_gc_module': gc_module}))
         two_way_scenarios.extend([
-            ('CC', {'make_delta': _groupcompress_pyx.make_delta,
-                    'apply_delta': _groupcompress_pyx.apply_delta}),
+            ('CC', {'make_delta': gc_module.make_delta,
+                    'apply_delta': gc_module.apply_delta}),
             ('PC', {'make_delta': _groupcompress_py.make_delta,
-                    'apply_delta': _groupcompress_pyx.apply_delta}),
-            ('CP', {'make_delta': _groupcompress_pyx.make_delta,
+                    'apply_delta': gc_module.apply_delta}),
+            ('CP', {'make_delta': gc_module.make_delta,
                     'apply_delta': _groupcompress_py.apply_delta}),
             ])
     to_adapt, result = tests.split_suite_by_condition(
@@ -54,21 +54,8 @@
     return result
 
 
-class _CompiledGroupCompressFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._groupcompress_pyx
-        except ImportError:
-            return False
-        else:
-            return True
-
-    def feature_name(self):
-        return 'bzrlib._groupcompress_pyx'
-
-
-CompiledGroupCompressFeature = _CompiledGroupCompressFeature()
+compiled_groupcompress_feature = tests.ModuleAvailableFeature(
+                                    'bzrlib._groupcompress_pyx')
 
 _text1 = """\
 This is a bit
@@ -264,9 +251,8 @@
         # This test isn't multiplied, because we only have DeltaIndex for the
         # compiled form
         # We call this here, because _test_needs_features happens after setUp
-        self.requireFeature(CompiledGroupCompressFeature)
-        from bzrlib import _groupcompress_pyx
-        self._gc_module = _groupcompress_pyx
+        self.requireFeature(compiled_groupcompress_feature)
+        self._gc_module = compiled_groupcompress_feature.module
 
     def test_repr(self):
         di = self._gc_module.DeltaIndex('test text\n')

=== modified file 'bzrlib/tests/test__known_graph.py'
--- bzrlib/tests/test__known_graph.py	2009-09-07 14:19:05 +0000
+++ bzrlib/tests/test__known_graph.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -37,16 +37,17 @@
         ('python-nocache', {'module': _known_graph_py, 'do_cache': False}),
     ]
     suite = loader.suiteClass()
-    if CompiledKnownGraphFeature.available():
-        from bzrlib import _known_graph_pyx
-        scenarios.append(('C', {'module': _known_graph_pyx, 'do_cache': True}))
-        caching_scenarios.append(('C-nocache',
-                          {'module': _known_graph_pyx, 'do_cache': False}))
+    if compiled_known_graph_feature.available():
+        scenarios.append(('C', {'module': compiled_known_graph_feature.module,
+                                'do_cache': True}))
+        caching_scenarios.append(
+            ('C-nocache', {'module': compiled_known_graph_feature.module,
+                           'do_cache': False}))
     else:
         # the compiled module isn't available, so we add a failing test
         class FailWithoutFeature(tests.TestCase):
             def test_fail(self):
-                self.requireFeature(CompiledKnownGraphFeature)
+                self.requireFeature(compiled_known_graph_feature)
         suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
     # TestKnownGraphHeads needs to be permutated with and without caching.
     # All other TestKnownGraph tests only need to be tested across module
@@ -58,19 +59,8 @@
     return suite
 
 
-class _CompiledKnownGraphFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._known_graph_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._known_graph_pyx'
-
-CompiledKnownGraphFeature = _CompiledKnownGraphFeature()
+compiled_known_graph_feature = tests.ModuleAvailableFeature(
+                                    'bzrlib._known_graph_pyx')
 
 
 #  a
@@ -154,6 +144,73 @@
         self.assertGDFO(graph, 'a', 5)
         self.assertGDFO(graph, 'c', 5)
 
+    def test_add_existing_node(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        # Add a node that already exists with identical content
+        # This is a 'no-op'
+        self.assertGDFO(graph, 'rev4', 5)
+        graph.add_node('rev4', ['rev3', 'rev2b'])
+        self.assertGDFO(graph, 'rev4', 5)
+        # This also works if we use a tuple rather than a list
+        graph.add_node('rev4', ('rev3', 'rev2b'))
+
+    def test_add_existing_node_mismatched_parents(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertRaises(ValueError, graph.add_node, 'rev4',
+                          ['rev2b', 'rev3'])
+
+    def test_add_node_with_ghost_parent(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        graph.add_node('rev5', ['rev2b', 'revGhost'])
+        self.assertGDFO(graph, 'rev5', 4)
+        self.assertGDFO(graph, 'revGhost', 1)
+
+    def test_add_new_root(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        graph.add_node('rev5', [])
+        self.assertGDFO(graph, 'rev5', 1)
+
+    def test_add_with_all_ghost_parents(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        graph.add_node('rev5', ['ghost'])
+        self.assertGDFO(graph, 'rev5', 2)
+        self.assertGDFO(graph, 'ghost', 1)
+
+    def test_gdfo_after_add_node(self):
+        graph = self.make_known_graph(test_graph.ancestry_1)
+        self.assertEqual([], graph.get_child_keys('rev4'))
+        graph.add_node('rev5', ['rev4'])
+        self.assertEqual(['rev4'], graph.get_parent_keys('rev5'))
+        self.assertEqual(['rev5'], graph.get_child_keys('rev4'))
+        self.assertEqual([], graph.get_child_keys('rev5'))
+        self.assertGDFO(graph, 'rev5', 6)
+        graph.add_node('rev6', ['rev2b'])
+        graph.add_node('rev7', ['rev6'])
+        graph.add_node('rev8', ['rev7', 'rev5'])
+        self.assertGDFO(graph, 'rev5', 6)
+        self.assertGDFO(graph, 'rev6', 4)
+        self.assertGDFO(graph, 'rev7', 5)
+        self.assertGDFO(graph, 'rev8', 7)
+
+    def test_fill_in_ghost(self):
+        graph = self.make_known_graph(test_graph.with_ghost)
+        # Add in a couple nodes and then fill in the 'ghost' so that it should
+        # cause renumbering of children nodes
+        graph.add_node('x', [])
+        graph.add_node('y', ['x'])
+        graph.add_node('z', ['y'])
+        graph.add_node('g', ['z'])
+        self.assertGDFO(graph, 'f', 2)
+        self.assertGDFO(graph, 'e', 3)
+        self.assertGDFO(graph, 'x', 1)
+        self.assertGDFO(graph, 'y', 2)
+        self.assertGDFO(graph, 'z', 3)
+        self.assertGDFO(graph, 'g', 4)
+        self.assertGDFO(graph, 'b', 4)
+        self.assertGDFO(graph, 'd', 5)
+        self.assertGDFO(graph, 'a', 5)
+        self.assertGDFO(graph, 'c', 6)
+
 
 class TestKnownGraphHeads(TestCaseWithKnownGraph):
 
@@ -260,6 +317,14 @@
         self.assertEqual(set(['a', 'c']), graph.heads(['a', 'c', 'e', 'g']))
         self.assertEqual(set(['a', 'c']), graph.heads(['a', 'c', 'f']))
 
+    def test_filling_in_ghosts_resets_head_cache(self):
+        graph = self.make_known_graph(test_graph.with_ghost)
+        self.assertEqual(set(['e', 'g']), graph.heads(['e', 'g']))
+        # 'g' is filled in, and decends from 'e', so the heads result is now
+        # different
+        graph.add_node('g', ['e'])
+        self.assertEqual(set(['g']), graph.heads(['e', 'g']))
+
 
 class TestKnownGraphTopoSort(TestCaseWithKnownGraph):
 

=== modified file 'bzrlib/tests/test__rio.py'
--- bzrlib/tests/test__rio.py	2009-05-14 21:29:57 +0000
+++ bzrlib/tests/test__rio.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,38 +23,11 @@
 
 
 def load_tests(standard_tests, module, loader):
-    # parameterize all tests in this module
-    suite = loader.suiteClass()
-    import bzrlib._rio_py as py_module
-    scenarios = [('python', {'module': py_module})]
-    if CompiledRioFeature.available():
-        import bzrlib._rio_pyx as c_module
-        scenarios.append(('C', {'module': c_module}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledRioFeature)
-        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
-    tests.multiply_tests(standard_tests, scenarios, suite)
+    suite, _ = tests.permute_tests_for_extension(standard_tests, loader,
+        'bzrlib._rio_py', 'bzrlib._rio_pyx')
     return suite
 
 
-class _CompiledRioFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._rio_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._rio_pyx'
-
-CompiledRioFeature = _CompiledRioFeature()
-
-
 class TestValidTag(tests.TestCase):
 
     module = None # Filled in by test parameterization

=== modified file 'bzrlib/tests/test__simple_set.py'
--- bzrlib/tests/test__simple_set.py	2009-10-14 15:53:34 +0000
+++ bzrlib/tests/test__simple_set.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -77,23 +77,13 @@
 
 # Even though this is an extension, we don't permute the tests for a python
 # version. As the plain python version is just a dict or set
-
-class _CompiledSimpleSet(tests.Feature):
-
-    def _probe(self):
-        if _simple_set_pyx is None:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._simple_set_pyx'
-
-CompiledSimpleSet = _CompiledSimpleSet()
+compiled_simpleset_feature = tests.ModuleAvailableFeature(
+                                'bzrlib._simple_set_pyx')
 
 
 class TestSimpleSet(tests.TestCase):
 
-    _test_needs_features = [CompiledSimpleSet]
+    _test_needs_features = [compiled_simpleset_feature]
     module = _simple_set_pyx
 
     def assertIn(self, obj, container):

=== modified file 'bzrlib/tests/test__static_tuple.py'
--- bzrlib/tests/test__static_tuple.py	2009-10-22 08:23:31 +0000
+++ bzrlib/tests/test__static_tuple.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,11 +16,13 @@
 
 """Tests for the StaticTuple type."""
 
+import cPickle
 import gc
 import sys
 
 from bzrlib import (
     _static_tuple_py,
+    debug,
     errors,
     osutils,
     static_tuple,
@@ -30,36 +32,11 @@
 
 def load_tests(standard_tests, module, loader):
     """Parameterize tests for all versions of groupcompress."""
-    scenarios = [
-        ('python', {'module': _static_tuple_py}),
-    ]
-    suite = loader.suiteClass()
-    if CompiledStaticTuple.available():
-        from bzrlib import _static_tuple_c
-        scenarios.append(('C', {'module': _static_tuple_c}))
-    else:
-        # the compiled module isn't available, so we add a failing test
-        class FailWithoutFeature(tests.TestCase):
-            def test_fail(self):
-                self.requireFeature(CompiledStaticTuple)
-        suite.addTest(loader.loadTestsFromTestCase(FailWithoutFeature))
-    result = tests.multiply_tests(standard_tests, scenarios, suite)
-    return result
-
-
-class _CompiledStaticTuple(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._static_tuple_c
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._static_tuple_c'
-
-CompiledStaticTuple = _CompiledStaticTuple()
+    global compiled_static_tuple_feature
+    suite, compiled_static_tuple_feature = tests.permute_tests_for_extension(
+        standard_tests, loader, 'bzrlib._static_tuple_py',
+        'bzrlib._static_tuple_c')
+    return suite
 
 
 class _Meliae(tests.Feature):
@@ -146,9 +123,34 @@
         k = self.module.StaticTuple('foo')
         t = k.as_tuple()
         self.assertEqual(('foo',), t)
+        self.assertIsInstance(t, tuple)
+        self.assertFalse(isinstance(t, self.module.StaticTuple))
         k = self.module.StaticTuple('foo', 'bar')
         t = k.as_tuple()
         self.assertEqual(('foo', 'bar'), t)
+        k2 = self.module.StaticTuple(1, k)
+        t = k2.as_tuple()
+        self.assertIsInstance(t, tuple)
+        # For pickling to work, we need to keep the sub-items as StaticTuple so
+        # that it knows that they also need to be converted.
+        self.assertIsInstance(t[1], self.module.StaticTuple)
+        self.assertEqual((1, ('foo', 'bar')), t)
+
+    def test_as_tuples(self):
+        k1 = self.module.StaticTuple('foo', 'bar')
+        t = static_tuple.as_tuples(k1)
+        self.assertIsInstance(t, tuple)
+        self.assertEqual(('foo', 'bar'), t)
+        k2 = self.module.StaticTuple(1, k1)
+        t = static_tuple.as_tuples(k2)
+        self.assertIsInstance(t, tuple)
+        self.assertIsInstance(t[1], tuple)
+        self.assertEqual((1, ('foo', 'bar')), t)
+        mixed = (1, k1)
+        t = static_tuple.as_tuples(mixed)
+        self.assertIsInstance(t, tuple)
+        self.assertIsInstance(t[1], tuple)
+        self.assertEqual((1, ('foo', 'bar')), t)
 
     def test_len(self):
         k = self.module.StaticTuple()
@@ -570,6 +572,8 @@
     def test_from_sequence_not_sequence(self):
         self.assertRaises(TypeError,
                           self.module.StaticTuple.from_sequence, object())
+        self.assertRaises(TypeError,
+                          self.module.StaticTuple.from_sequence, 10)
 
     def test_from_sequence_incorrect_args(self):
         self.assertRaises(TypeError,
@@ -577,12 +581,68 @@
         self.assertRaises(TypeError,
                           self.module.StaticTuple.from_sequence, foo='a')
 
+    def test_from_sequence_iterable(self):
+        st = self.module.StaticTuple.from_sequence(iter(['foo', 'bar']))
+        self.assertIsInstance(st, self.module.StaticTuple)
+        self.assertEqual(('foo', 'bar'), st)
+
+    def test_from_sequence_generator(self):
+        def generate_tuple():
+            yield 'foo'
+            yield 'bar'
+        st = self.module.StaticTuple.from_sequence(generate_tuple())
+        self.assertIsInstance(st, self.module.StaticTuple)
+        self.assertEqual(('foo', 'bar'), st)
+
+    def test_pickle(self):
+        st = self.module.StaticTuple('foo', 'bar')
+        pickled = cPickle.dumps(st)
+        unpickled = cPickle.loads(pickled)
+        self.assertEqual(unpickled, st)
+
+    def test_pickle_empty(self):
+        st = self.module.StaticTuple()
+        pickled = cPickle.dumps(st)
+        unpickled = cPickle.loads(pickled)
+        self.assertIs(st, unpickled)
+
+    def test_pickle_nested(self):
+        st = self.module.StaticTuple('foo', self.module.StaticTuple('bar'))
+        pickled = cPickle.dumps(st)
+        unpickled = cPickle.loads(pickled)
+        self.assertEqual(unpickled, st)
+
     def test_static_tuple_thunk(self):
         # Make sure the right implementation is available from
         # bzrlib.static_tuple.StaticTuple.
         if self.module is _static_tuple_py:
-            if CompiledStaticTuple.available():
+            if compiled_static_tuple_feature.available():
                 # We will be using the C version
                 return
         self.assertIs(static_tuple.StaticTuple,
                       self.module.StaticTuple)
+
+
+class TestEnsureStaticTuple(tests.TestCase):
+
+    def test_is_static_tuple(self):
+        st = static_tuple.StaticTuple('foo')
+        st2 = static_tuple.expect_static_tuple(st)
+        self.assertIs(st, st2)
+
+    def test_is_tuple(self):
+        t = ('foo',)
+        st = static_tuple.expect_static_tuple(t)
+        self.assertIsInstance(st, static_tuple.StaticTuple)
+        self.assertEqual(t, st)
+
+    def test_flagged_is_static_tuple(self):
+        debug.debug_flags.add('static_tuple')
+        st = static_tuple.StaticTuple('foo')
+        st2 = static_tuple.expect_static_tuple(st)
+        self.assertIs(st, st2)
+
+    def test_flagged_is_tuple(self):
+        debug.debug_flags.add('static_tuple')
+        t = ('foo',)
+        self.assertRaises(TypeError, static_tuple.expect_static_tuple, t)

=== modified file 'bzrlib/tests/test__walkdirs_win32.py'
--- bzrlib/tests/test__walkdirs_win32.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test__walkdirs_win32.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,25 +24,12 @@
     )
 
 
-class _Win32ReadDirFeature(tests.Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._walkdirs_win32
-        except ImportError:
-            return False
-        else:
-            return True
-
-    def feature_name(self):
-        return 'bzrlib._Win32ReadDir'
-
-Win32ReadDirFeature = _Win32ReadDirFeature()
+win32_readdir_feature = tests.ModuleAvailableFeature('bzrlib._walkdirs_win32')
 
 
 class TestWin32Finder(tests.TestCaseInTempDir):
 
-    _test_needs_features = [Win32ReadDirFeature]
+    _test_needs_features = [win32_readdir_feature]
 
     def setUp(self):
         super(TestWin32Finder, self).setUp()

=== modified file 'bzrlib/tests/test_btree_index.py'
--- bzrlib/tests/test_btree_index.py	2009-10-20 04:25:27 +0000
+++ bzrlib/tests/test_btree_index.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -43,26 +43,14 @@
         condition_isinstance(TestBTreeNodes))
     import bzrlib._btree_serializer_py as py_module
     scenarios = [('python', {'parse_btree': py_module})]
-    if CompiledBtreeParserFeature.available():
-        # Is there a way to do this that gets missing feature failures rather
-        # than no indication to the user?
-        import bzrlib._btree_serializer_pyx as c_module
-        scenarios.append(('C', {'parse_btree': c_module}))
+    if compiled_btreeparser_feature.available():
+        scenarios.append(('C', {'parse_btree':
+                                compiled_btreeparser_feature.module}))
     return multiply_tests(node_tests, scenarios, others)
 
 
-class _CompiledBtreeParserFeature(tests.Feature):
-    def _probe(self):
-        try:
-            import bzrlib._btree_serializer_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._btree_serializer_pyx'
-
-CompiledBtreeParserFeature = _CompiledBtreeParserFeature()
+compiled_btreeparser_feature = tests.ModuleAvailableFeature(
+                                'bzrlib._btree_serializer_pyx')
 
 
 class BTreeTestCase(TestCaseWithTransport):
@@ -161,7 +149,7 @@
         temp_file = builder.finish()
         content = temp_file.read()
         del temp_file
-        self.assertEqual(158, len(content))
+        self.assertEqual(131, len(content))
         self.assertEqual(
             "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=5\n"
             "row_lengths=1\n",
@@ -185,7 +173,7 @@
         temp_file = builder.finish()
         content = temp_file.read()
         del temp_file
-        self.assertEqual(264, len(content))
+        self.assertEqual(238, len(content))
         self.assertEqual(
             "B+Tree Graph Index 2\nnode_ref_lists=2\nkey_elements=2\nlen=10\n"
             "row_lengths=1\n",
@@ -251,7 +239,7 @@
         temp_file = builder.finish()
         content = temp_file.read()
         del temp_file
-        self.assertEqual(181, len(content))
+        self.assertEqual(155, len(content))
         self.assertEqual(
             "B+Tree Graph Index 2\nnode_ref_lists=0\nkey_elements=1\nlen=10\n"
             "row_lengths=1\n",
@@ -359,23 +347,19 @@
         # Test the parts of the index that take up memory are doing so
         # predictably.
         self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         builder.add_node(*nodes[1])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(1, len(builder._backing_indices))
         self.assertEqual(2, builder._backing_indices[0].key_count())
         # now back to memory
         builder.add_node(*nodes[2])
         self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         # And spills to a second backing index combing all
         builder.add_node(*nodes[3])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(2, len(builder._backing_indices))
         self.assertEqual(None, builder._backing_indices[0])
@@ -384,7 +368,6 @@
         builder.add_node(*nodes[4])
         builder.add_node(*nodes[5])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(2, len(builder._backing_indices))
         self.assertEqual(2, builder._backing_indices[0].key_count())
@@ -448,23 +431,19 @@
         # Test the parts of the index that take up memory are doing so
         # predictably.
         self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         builder.add_node(*nodes[1])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(1, len(builder._backing_indices))
         self.assertEqual(2, builder._backing_indices[0].key_count())
         # now back to memory
         builder.add_node(*nodes[2])
         self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         # And spills to a second backing index but doesn't combine
         builder.add_node(*nodes[3])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(2, len(builder._backing_indices))
         for backing_index in builder._backing_indices:
@@ -473,7 +452,6 @@
         builder.add_node(*nodes[4])
         builder.add_node(*nodes[5])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(3, len(builder._backing_indices))
         for backing_index in builder._backing_indices:
@@ -538,11 +516,9 @@
         builder.add_node(*nodes[0])
         # Test the parts of the index that take up memory are doing so
         # predictably.
-        self.assertEqual(1, len(builder._keys))
         self.assertEqual(1, len(builder._nodes))
         self.assertIs(None, builder._nodes_by_key)
         builder.add_node(*nodes[1])
-        self.assertEqual(0, len(builder._keys))
         self.assertEqual(0, len(builder._nodes))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(1, len(builder._backing_indices))
@@ -551,7 +527,6 @@
         old = dict(builder._get_nodes_by_key()) #Build up the nodes by key dict
         builder.add_node(*nodes[2])
         self.assertEqual(1, len(builder._nodes))
-        self.assertEqual(1, len(builder._keys))
         self.assertIsNot(None, builder._nodes_by_key)
         self.assertNotEqual({}, builder._nodes_by_key)
         # We should have a new entry
@@ -559,7 +534,6 @@
         # And spills to a second backing index combing all
         builder.add_node(*nodes[3])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(2, len(builder._backing_indices))
         self.assertEqual(None, builder._backing_indices[0])
@@ -568,7 +542,6 @@
         builder.add_node(*nodes[4])
         builder.add_node(*nodes[5])
         self.assertEqual(0, len(builder._nodes))
-        self.assertEqual(0, len(builder._keys))
         self.assertIs(None, builder._nodes_by_key)
         self.assertEqual(2, len(builder._backing_indices))
         self.assertEqual(2, builder._backing_indices[0].key_count())
@@ -718,7 +691,7 @@
         # The entire index should have been read, as it is one page long.
         self.assertEqual([('readv', 'index', [(0, size)], False, None)],
             transport._activity)
-        self.assertEqual(1199, size)
+        self.assertEqual(1173, size)
 
     def test__read_nodes_no_size_one_page_reads_once(self):
         self.make_index(nodes=[(('key',), 'value', ())])
@@ -772,7 +745,7 @@
         # The entire index should have been read linearly.
         self.assertEqual([('readv', 'index', [(0, size)], False, None)],
             transport._activity)
-        self.assertEqual(1514, size)
+        self.assertEqual(1488, size)
 
     def test_validate_two_pages(self):
         builder = btree_index.BTreeBuilder(key_elements=2, reference_lists=2)
@@ -1308,7 +1281,7 @@
     def test_exists(self):
         # This is just to let the user know if they don't have the feature
         # available
-        self.requireFeature(CompiledBtreeParserFeature)
+        self.requireFeature(compiled_btreeparser_feature)
 
 
 class TestMultiBisectRight(tests.TestCase):

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2009-08-27 22:17:35 +0000
+++ bzrlib/tests/test_bundle.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1850,7 +1850,7 @@
 class _DisconnectingTCPServer(object):
     """A TCP server that immediately closes any connection made to it."""
 
-    def setUp(self):
+    def start_server(self):
         self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         self.sock.bind(('127.0.0.1', 0))
         self.sock.listen(1)
@@ -1868,7 +1868,7 @@
     def get_url(self):
         return 'bzr://127.0.0.1:%d/' % (self.port,)
 
-    def tearDown(self):
+    def stop_server(self):
         try:
             # make sure the thread dies by connecting to the listening socket,
             # just in case the test failed to do so.
@@ -1879,4 +1879,3 @@
             pass
         self.sock.close()
         self.thread.join()
-

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/test_bzrdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -145,7 +145,7 @@
         new = topics.get_detail('current-formats')
         rest = topics.get_detail('other-formats')
         experimental, deprecated = rest.split('Deprecated formats')
-        self.assertContainsRe(new, 'bzr help formats')
+        self.assertContainsRe(new, 'formats-help')
         self.assertContainsRe(new,
                 ':knit:\n    \(native\) \(default\) Format using knits\n')
         self.assertContainsRe(experimental,

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2009-10-08 04:35:01 +0000
+++ bzrlib/tests/test_chk_map.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -31,6 +31,7 @@
     LeafNode,
     Node,
     )
+from bzrlib.static_tuple import StaticTuple
 
 
 class TestNode(tests.TestCase):
@@ -831,13 +832,13 @@
         # 'ab' and 'ac' nodes
         chkmap.map(('aad',), 'v')
         self.assertIsInstance(chkmap._root_node._items['aa'], InternalNode)
-        self.assertIsInstance(chkmap._root_node._items['ab'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['ac'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['ab'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['ac'], StaticTuple)
         # Unmapping 'acd' can notice that 'aa' is an InternalNode and not have
         # to map in 'ab'
         chkmap.unmap(('acd',))
         self.assertIsInstance(chkmap._root_node._items['aa'], InternalNode)
-        self.assertIsInstance(chkmap._root_node._items['ab'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['ab'], StaticTuple)
 
     def test_unmap_without_fitting_doesnt_page_in(self):
         store = self.get_chk_bytes()
@@ -860,8 +861,8 @@
         chkmap.map(('aaf',), 'v')
         # At this point, the previous nodes should not be paged in, but the
         # newly added nodes would be
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aac'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aad'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aae'], LeafNode)
@@ -869,8 +870,8 @@
         # Now unmapping one of the new nodes will use only the already-paged-in
         # nodes to determine that we don't need to do more.
         chkmap.unmap(('aaf',))
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aac'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aad'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aae'], LeafNode)
@@ -897,14 +898,14 @@
         chkmap.map(('aad',), 'v')
         # At this point, the previous nodes should not be paged in, but the
         # newly added node would be
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aac'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aac'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aad'], LeafNode)
         # Unmapping the new node will check the existing nodes to see if they
         # would fit.
         # Clear the page cache so we ensure we have to read all the children
-        chk_map._page_cache.clear()
+        chk_map.clear_cache()
         chkmap.unmap(('aad',))
         self.assertIsInstance(chkmap._root_node._items['aaa'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aab'], LeafNode)
@@ -937,24 +938,24 @@
         chkmap.map(('aad',), 'v')
         # At this point, the previous nodes should not be paged in, but the
         # newly added node would be
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aac'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aac'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aad'], LeafNode)
         # Now clear the page cache, and only include 2 of the children in the
         # cache
         aab_key = chkmap._root_node._items['aab']
-        aab_bytes = chk_map._page_cache[aab_key]
+        aab_bytes = chk_map._get_cache()[aab_key]
         aac_key = chkmap._root_node._items['aac']
-        aac_bytes = chk_map._page_cache[aac_key]
-        chk_map._page_cache.clear()
-        chk_map._page_cache[aab_key] = aab_bytes
-        chk_map._page_cache[aac_key] = aac_bytes
+        aac_bytes = chk_map._get_cache()[aac_key]
+        chk_map.clear_cache()
+        chk_map._get_cache()[aab_key] = aab_bytes
+        chk_map._get_cache()[aac_key] = aac_bytes
 
         # Unmapping the new node will check the nodes from the page cache
         # first, and not have to read in 'aaa'
         chkmap.unmap(('aad',))
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aab'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aac'], LeafNode)
 
@@ -974,9 +975,9 @@
         chkmap.map(('aaf',), 'val')
         # At this point, the previous nodes should not be paged in, but the
         # newly added node would be
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aac'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aac'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aad'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aae'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aaf'], LeafNode)
@@ -984,9 +985,9 @@
         # Unmapping a new node will see the other nodes that are already in
         # memory, and not need to page in anything else
         chkmap.unmap(('aad',))
-        self.assertIsInstance(chkmap._root_node._items['aaa'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aab'], tuple)
-        self.assertIsInstance(chkmap._root_node._items['aac'], tuple)
+        self.assertIsInstance(chkmap._root_node._items['aaa'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aab'], StaticTuple)
+        self.assertIsInstance(chkmap._root_node._items['aac'], StaticTuple)
         self.assertIsInstance(chkmap._root_node._items['aae'], LeafNode)
         self.assertIsInstance(chkmap._root_node._items['aaf'], LeafNode)
 
@@ -1031,8 +1032,8 @@
             {('a',): 'content here', ('b',): 'more content'},
             chk_bytes=basis._store, maximum_size=10)
         list(target.iter_changes(basis))
-        self.assertIsInstance(target._root_node, tuple)
-        self.assertIsInstance(basis._root_node, tuple)
+        self.assertIsInstance(target._root_node, StaticTuple)
+        self.assertIsInstance(basis._root_node, StaticTuple)
 
     def test_iter_changes_ab_ab_changed_values_shown(self):
         basis = self._get_map({('a',): 'content here', ('b',): 'more content'},
@@ -1144,9 +1145,12 @@
 
     def test_iteritems_keys_prefixed_by_2_width_nodes_hashed(self):
         search_key_func = chk_map.search_key_registry.get('hash-16-way')
-        self.assertEqual('E8B7BE43\x00E8B7BE43', search_key_func(('a', 'a')))
-        self.assertEqual('E8B7BE43\x0071BEEFF9', search_key_func(('a', 'b')))
-        self.assertEqual('71BEEFF9\x0000000000', search_key_func(('b', '')))
+        self.assertEqual('E8B7BE43\x00E8B7BE43',
+                         search_key_func(StaticTuple('a', 'a')))
+        self.assertEqual('E8B7BE43\x0071BEEFF9',
+                         search_key_func(StaticTuple('a', 'b')))
+        self.assertEqual('71BEEFF9\x0000000000',
+                         search_key_func(StaticTuple('b', '')))
         chkmap = self._get_map(
             {("a","a"):"content here", ("a", "b",):"more content",
              ("b", ""): 'boring content'},
@@ -1449,41 +1453,6 @@
                              , chkmap._dump_tree())
 
 
-class TestSearchKeyFuncs(tests.TestCase):
-
-    def assertSearchKey16(self, expected, key):
-        self.assertEqual(expected, chk_map._search_key_16(key))
-
-    def assertSearchKey255(self, expected, key):
-        actual = chk_map._search_key_255(key)
-        self.assertEqual(expected, actual, 'actual: %r' % (actual,))
-
-    def test_simple_16(self):
-        self.assertSearchKey16('8C736521', ('foo',))
-        self.assertSearchKey16('8C736521\x008C736521', ('foo', 'foo'))
-        self.assertSearchKey16('8C736521\x0076FF8CAA', ('foo', 'bar'))
-        self.assertSearchKey16('ED82CD11', ('abcd',))
-
-    def test_simple_255(self):
-        self.assertSearchKey255('\x8cse!', ('foo',))
-        self.assertSearchKey255('\x8cse!\x00\x8cse!', ('foo', 'foo'))
-        self.assertSearchKey255('\x8cse!\x00v\xff\x8c\xaa', ('foo', 'bar'))
-        # The standard mapping for these would include '\n', so it should be
-        # mapped to '_'
-        self.assertSearchKey255('\xfdm\x93_\x00P_\x1bL', ('<', 'V'))
-
-    def test_255_does_not_include_newline(self):
-        # When mapping via _search_key_255, we should never have the '\n'
-        # character, but all other 255 values should be present
-        chars_used = set()
-        for char_in in range(256):
-            search_key = chk_map._search_key_255((chr(char_in),))
-            chars_used.update(search_key)
-        all_chars = set([chr(x) for x in range(256)])
-        unused_chars = all_chars.symmetric_difference(chars_used)
-        self.assertEqual(set('\n'), unused_chars)
-
-
 class TestLeafNode(TestCaseWithStore):
 
     def test_current_size_empty(self):
@@ -1908,18 +1877,19 @@
         search_key_func = chk_map.search_key_registry.get('hash-255-way')
         node = InternalNode(search_key_func=search_key_func)
         leaf1 = LeafNode(search_key_func=search_key_func)
-        leaf1.map(None, ('foo bar',), 'quux')
+        leaf1.map(None, StaticTuple('foo bar',), 'quux')
         leaf2 = LeafNode(search_key_func=search_key_func)
-        leaf2.map(None, ('strange',), 'beast')
-        self.assertEqual('\xbeF\x014', search_key_func(('foo bar',)))
-        self.assertEqual('\x85\xfa\xf7K', search_key_func(('strange',)))
+        leaf2.map(None, StaticTuple('strange',), 'beast')
+        self.assertEqual('\xbeF\x014', search_key_func(StaticTuple('foo bar',)))
+        self.assertEqual('\x85\xfa\xf7K', search_key_func(StaticTuple('strange',)))
         node.add_node("\xbe", leaf1)
         # This sets up a path that should not be followed - it will error if
         # the code tries to.
         node._items['\xbe'] = None
         node.add_node("\x85", leaf2)
         self.assertEqual([(('strange',), 'beast')],
-            sorted(node.iteritems(None, [('strange',), ('weird',)])))
+            sorted(node.iteritems(None, [StaticTuple('strange',),
+                                         StaticTuple('weird',)])))
 
     def test_iteritems_partial_empty(self):
         node = InternalNode()
@@ -1932,7 +1902,7 @@
         # Ensure test validity: nothing paged in below the root.
         self.assertEqual(2,
             len([value for value in node._items.values()
-                if type(value) == tuple]))
+                if type(value) is StaticTuple]))
         # now, mapping to k3 should add a k3 leaf
         prefix, nodes = node.map(None, ('k3',), 'quux')
         self.assertEqual("k", prefix)
@@ -1971,7 +1941,7 @@
         # Ensure test validity: nothing paged in below the root.
         self.assertEqual(2,
             len([value for value in node._items.values()
-                if type(value) == tuple]))
+                if type(value) is StaticTuple]))
         # now, mapping to k23 causes k22 ('k2' in node) to split into k22 and
         # k23, which for simplicity in the current implementation generates
         # a new internal node between node, and k22/k23.
@@ -2016,9 +1986,12 @@
         node = InternalNode(search_key_func=search_key_func)
         node._key_width = 2
         node._node_width = 4
-        self.assertEqual('E8B7BE43\x0071BEEFF9', search_key_func(('a', 'b')))
-        self.assertEqual('E8B7', node._search_prefix_filter(('a', 'b')))
-        self.assertEqual('E8B7', node._search_prefix_filter(('a',)))
+        self.assertEqual('E8B7BE43\x0071BEEFF9', search_key_func(
+            StaticTuple('a', 'b')))
+        self.assertEqual('E8B7', node._search_prefix_filter(
+            StaticTuple('a', 'b')))
+        self.assertEqual('E8B7', node._search_prefix_filter(
+            StaticTuple('a',)))
 
     def test_unmap_k23_from_k1_k22_k23_gives_k1_k22_tree_new(self):
         chkmap = self._get_map(

=== added file 'bzrlib/tests/test_cleanup.py'
--- bzrlib/tests/test_cleanup.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_cleanup.py	2010-02-17 17:11:16 +0000
@@ -0,0 +1,278 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+from cStringIO import StringIO
+import re
+
+from bzrlib.cleanup import (
+    _do_with_cleanups,
+    _run_cleanup,
+    OperationWithCleanups,
+    )
+from bzrlib.tests import TestCase
+from bzrlib import (
+    debug,
+    trace,
+    )
+
+
+class CleanupsTestCase(TestCase):
+
+    def setUp(self):
+        super(CleanupsTestCase, self).setUp()
+        self.call_log = []
+
+    def no_op_cleanup(self):
+        self.call_log.append('no_op_cleanup')
+
+    def assertLogContains(self, regex):
+        self.assertContainsRe(self.get_log(), regex, re.DOTALL)
+
+    def failing_cleanup(self):
+        self.call_log.append('failing_cleanup')
+        raise Exception("failing_cleanup goes boom!")
+
+
+class TestRunCleanup(CleanupsTestCase):
+
+    def test_no_errors(self):
+        """The function passed to _run_cleanup is run."""
+        self.assertTrue(_run_cleanup(self.no_op_cleanup))
+        self.assertEqual(['no_op_cleanup'], self.call_log)
+
+    def test_cleanup_with_args_kwargs(self):
+        def func_taking_args_kwargs(*args, **kwargs):
+            self.call_log.append(('func', args, kwargs))
+        _run_cleanup(func_taking_args_kwargs, 'an arg', kwarg='foo')
+        self.assertEqual(
+            [('func', ('an arg',), {'kwarg': 'foo'})], self.call_log)
+
+    def test_cleanup_error(self):
+        """An error from the cleanup function is logged by _run_cleanup, but not
+        propagated.
+
+        This is there's no way for _run_cleanup to know if there's an existing
+        exception in this situation::
+            try:
+              some_func()
+            finally:
+              _run_cleanup(cleanup_func)
+        So, the best _run_cleanup can do is always log errors but never raise
+        them.
+        """
+        self.assertFalse(_run_cleanup(self.failing_cleanup))
+        self.assertLogContains('Cleanup failed:.*failing_cleanup goes boom')
+
+    def test_cleanup_error_debug_flag(self):
+        """The -Dcleanup debug flag causes cleanup errors to be reported to the
+        user.
+        """
+        log = StringIO()
+        trace.push_log_file(log)
+        debug.debug_flags.add('cleanup')
+        self.assertFalse(_run_cleanup(self.failing_cleanup))
+        self.assertContainsRe(
+            log.getvalue(),
+            "bzr: warning: Cleanup failed:.*failing_cleanup goes boom")
+
+    def test_prior_error_cleanup_succeeds(self):
+        """Calling _run_cleanup from a finally block will not interfere with an
+        exception from the try block.
+        """
+        def failing_operation():
+            try:
+                1/0
+            finally:
+                _run_cleanup(self.no_op_cleanup)
+        self.assertRaises(ZeroDivisionError, failing_operation)
+        self.assertEqual(['no_op_cleanup'], self.call_log)
+
+    def test_prior_error_cleanup_fails(self):
+        """Calling _run_cleanup from a finally block will not interfere with an
+        exception from the try block even when the cleanup itself raises an
+        exception.
+
+        The cleanup exception will be logged.
+        """
+        def failing_operation():
+            try:
+                1/0
+            finally:
+                _run_cleanup(self.failing_cleanup)
+        self.assertRaises(ZeroDivisionError, failing_operation)
+        self.assertLogContains('Cleanup failed:.*failing_cleanup goes boom')
+
+
+class TestDoWithCleanups(CleanupsTestCase):
+
+    def trivial_func(self):
+        self.call_log.append('trivial_func')
+        return 'trivial result'
+
+    def test_runs_func(self):
+        """_do_with_cleanups runs the function it is given, and returns the
+        result.
+        """
+        result = _do_with_cleanups([], self.trivial_func)
+        self.assertEqual('trivial result', result)
+
+    def test_runs_cleanups(self):
+        """Cleanup functions are run (in the given order)."""
+        cleanup_func_1 = (self.call_log.append, ('cleanup 1',), {})
+        cleanup_func_2 = (self.call_log.append, ('cleanup 2',), {})
+        _do_with_cleanups([cleanup_func_1, cleanup_func_2], self.trivial_func)
+        self.assertEqual(
+            ['trivial_func', 'cleanup 1', 'cleanup 2'], self.call_log)
+
+    def failing_func(self):
+        self.call_log.append('failing_func')
+        1/0
+
+    def test_func_error_propagates(self):
+        """Errors from the main function are propagated (after running
+        cleanups).
+        """
+        self.assertRaises(
+            ZeroDivisionError, _do_with_cleanups,
+            [(self.no_op_cleanup, (), {})], self.failing_func)
+        self.assertEqual(['failing_func', 'no_op_cleanup'], self.call_log)
+
+    def test_func_error_trumps_cleanup_error(self):
+        """Errors from the main function a propagated even if a cleanup raises
+        an error.
+
+        The cleanup error is be logged.
+        """
+        self.assertRaises(
+            ZeroDivisionError, _do_with_cleanups,
+            [(self.failing_cleanup, (), {})], self.failing_func)
+        self.assertLogContains('Cleanup failed:.*failing_cleanup goes boom')
+
+    def test_func_passes_and_error_from_cleanup(self):
+        """An error from a cleanup is propagated when the main function doesn't
+        raise an error.  Later cleanups are still executed.
+        """
+        exc = self.assertRaises(
+            Exception, _do_with_cleanups,
+            [(self.failing_cleanup, (), {}), (self.no_op_cleanup, (), {})],
+            self.trivial_func)
+        self.assertEqual('failing_cleanup goes boom!', exc.args[0])
+        self.assertEqual(
+            ['trivial_func', 'failing_cleanup', 'no_op_cleanup'],
+            self.call_log)
+
+    def test_multiple_cleanup_failures(self):
+        """When multiple cleanups fail (as tends to happen when something has
+        gone wrong), the first error is propagated, and subsequent errors are
+        logged.
+        """
+        cleanups = self.make_two_failing_cleanup_funcs()
+        self.assertRaises(ErrorA, _do_with_cleanups, cleanups,
+            self.trivial_func)
+        self.assertLogContains('Cleanup failed:.*ErrorB')
+        self.assertFalse('ErrorA' in self.get_log())
+
+    def make_two_failing_cleanup_funcs(self):
+        def raise_a():
+            raise ErrorA('Error A')
+        def raise_b():
+            raise ErrorB('Error B')
+        return [(raise_a, (), {}), (raise_b, (), {})]
+
+    def test_multiple_cleanup_failures_debug_flag(self):
+        log = StringIO()
+        trace.push_log_file(log)
+        debug.debug_flags.add('cleanup')
+        cleanups = self.make_two_failing_cleanup_funcs()
+        self.assertRaises(ErrorA, _do_with_cleanups, cleanups,
+            self.trivial_func)
+        self.assertContainsRe(
+            log.getvalue(), "bzr: warning: Cleanup failed:.*Error B\n")
+        self.assertEqual(1, log.getvalue().count('bzr: warning:'),
+                log.getvalue())
+
+    def test_func_and_cleanup_errors_debug_flag(self):
+        log = StringIO()
+        trace.push_log_file(log)
+        debug.debug_flags.add('cleanup')
+        cleanups = self.make_two_failing_cleanup_funcs()
+        self.assertRaises(ZeroDivisionError, _do_with_cleanups, cleanups,
+            self.failing_func)
+        self.assertContainsRe(
+            log.getvalue(), "bzr: warning: Cleanup failed:.*Error A\n")
+        self.assertContainsRe(
+            log.getvalue(), "bzr: warning: Cleanup failed:.*Error B\n")
+        self.assertEqual(2, log.getvalue().count('bzr: warning:'))
+
+    def test_func_may_mutate_cleanups(self):
+        """The main func may mutate the cleanups before it returns.
+        
+        This allows a function to gradually add cleanups as it acquires
+        resources, rather than planning all the cleanups up-front.  The
+        OperationWithCleanups helper relies on this working.
+        """
+        cleanups_list = []
+        def func_that_adds_cleanups():
+            self.call_log.append('func_that_adds_cleanups')
+            cleanups_list.append((self.no_op_cleanup, (), {}))
+            return 'result'
+        result = _do_with_cleanups(cleanups_list, func_that_adds_cleanups)
+        self.assertEqual('result', result)
+        self.assertEqual(
+            ['func_that_adds_cleanups', 'no_op_cleanup'], self.call_log)
+
+    def test_cleanup_error_debug_flag(self):
+        """The -Dcleanup debug flag causes cleanup errors to be reported to the
+        user.
+        """
+        log = StringIO()
+        trace.push_log_file(log)
+        debug.debug_flags.add('cleanup')
+        self.assertRaises(ZeroDivisionError, _do_with_cleanups,
+            [(self.failing_cleanup, (), {})], self.failing_func)
+        self.assertContainsRe(
+            log.getvalue(),
+            "bzr: warning: Cleanup failed:.*failing_cleanup goes boom")
+        self.assertEqual(1, log.getvalue().count('bzr: warning:'))
+
+
+class ErrorA(Exception): pass
+class ErrorB(Exception): pass
+
+
+class TestOperationWithCleanups(CleanupsTestCase):
+
+    def test_cleanup_ordering(self):
+        """Cleanups are added in LIFO order.
+
+        So cleanups added before run is called are run last, and the last
+        cleanup added during the func is run first.
+        """
+        call_log = []
+        def func(op, foo):
+            call_log.append(('func called', foo))
+            op.add_cleanup(call_log.append, 'cleanup 2')
+            op.add_cleanup(call_log.append, 'cleanup 1')
+            return 'result'
+        owc = OperationWithCleanups(func)
+        owc.add_cleanup(call_log.append, 'cleanup 4')
+        owc.add_cleanup(call_log.append, 'cleanup 3')
+        result = owc.run('foo')
+        self.assertEqual('result', result)
+        self.assertEqual(
+            [('func called', 'foo'), 'cleanup 1', 'cleanup 2', 'cleanup 3',
+            'cleanup 4'], call_log)
+

=== modified file 'bzrlib/tests/test_commit.py'
--- bzrlib/tests/test_commit.py	2009-08-17 03:58:18 +0000
+++ bzrlib/tests/test_commit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -484,7 +484,7 @@
         other_bzrdir = master_branch.bzrdir.sprout('other')
         other_tree = other_bzrdir.open_workingtree()
 
-        # do a commit to the the other branch changing the content file so
+        # do a commit to the other branch changing the content file so
         # that our commit after merging will have a merged revision in the
         # content file history.
         self.build_tree_contents([('other/content_file', 'change in other\n')])

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2009-08-20 04:53:23 +0000
+++ bzrlib/tests/test_config.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -25,6 +25,7 @@
     branch,
     bzrdir,
     config,
+    diff,
     errors,
     osutils,
     mail_client,
@@ -42,6 +43,7 @@
 [DEFAULT]
 email=Erik B\u00e5gfors <erik@bagfors.nu>
 editor=vim
+change_editor=vimdiff -of @new_path @old_path
 gpg_signing_command=gnome-gpg
 log_format=short
 user_global_option=something
@@ -208,6 +210,10 @@
         self._calls.append('_get_signature_checking')
         return self._signatures
 
+    def _get_change_editor(self):
+        self._calls.append('_get_change_editor')
+        return 'vimdiff -fo @new_path @old_path'
+
 
 bool_config = """[DEFAULT]
 active = true
@@ -314,6 +320,14 @@
         my_config = config.Config()
         self.assertEqual('long', my_config.log_format())
 
+    def test_get_change_editor(self):
+        my_config = InstrumentedConfig()
+        change_editor = my_config.get_change_editor('old_tree', 'new_tree')
+        self.assertEqual(['_get_change_editor'], my_config._calls)
+        self.assertIs(diff.DiffFromTool, change_editor.__class__)
+        self.assertEqual(['vimdiff', '-fo', '@new_path', '@old_path'],
+                         change_editor.command_template)
+
 
 class TestConfigPath(tests.TestCase):
 
@@ -355,6 +369,14 @@
 
 class TestIniConfig(tests.TestCase):
 
+    def make_config_parser(self, s):
+        conf = config.IniBasedConfig(None)
+        parser = conf._get_parser(file=StringIO(s.encode('utf-8')))
+        return conf, parser
+
+
+class TestIniConfigBuilding(TestIniConfig):
+
     def test_contructs(self):
         my_config = config.IniBasedConfig("nothing")
 
@@ -371,20 +393,53 @@
         parser = my_config._get_parser(file=config_file)
         self.failUnless(my_config._get_parser() is parser)
 
+
+class TestGetUserOptionAs(TestIniConfig):
+
     def test_get_user_option_as_bool(self):
-        config_file = StringIO("""
+        conf, parser = self.make_config_parser("""
 a_true_bool = true
 a_false_bool = 0
 an_invalid_bool = maybe
-a_list = hmm, who knows ? # This interpreted as a list !
-""".encode('utf-8'))
-        my_config = config.IniBasedConfig(None)
-        parser = my_config._get_parser(file=config_file)
-        get_option = my_config.get_user_option_as_bool
-        self.assertEqual(True, get_option('a_true_bool'))
-        self.assertEqual(False, get_option('a_false_bool'))
-        self.assertIs(None, get_option('an_invalid_bool'))
-        self.assertIs(None, get_option('not_defined_in_this_config'))
+a_list = hmm, who knows ? # This is interpreted as a list !
+""")
+        get_bool = conf.get_user_option_as_bool
+        self.assertEqual(True, get_bool('a_true_bool'))
+        self.assertEqual(False, get_bool('a_false_bool'))
+        self.assertIs(None, get_bool('an_invalid_bool'))
+        self.assertIs(None, get_bool('not_defined_in_this_config'))
+
+
+    def test_get_user_option_as_list(self):
+        conf, parser = self.make_config_parser("""
+a_list = a,b,c
+length_1 = 1,
+one_item = x
+""")
+        get_list = conf.get_user_option_as_list
+        self.assertEqual(['a', 'b', 'c'], get_list('a_list'))
+        self.assertEqual(['1'], get_list('length_1'))
+        self.assertEqual('x', conf.get_user_option('one_item'))
+        # automatically cast to list
+        self.assertEqual(['x'], get_list('one_item'))
+
+
+class TestSupressWarning(TestIniConfig):
+
+    def make_warnings_config(self, s):
+        conf, parser = self.make_config_parser(s)
+        return conf.suppress_warning
+
+    def test_suppress_warning_unknown(self):
+        suppress_warning = self.make_warnings_config('')
+        self.assertEqual(False, suppress_warning('unknown_warning'))
+
+    def test_suppress_warning_known(self):
+        suppress_warning = self.make_warnings_config('suppress_warnings=a,b')
+        self.assertEqual(False, suppress_warning('c'))
+        self.assertEqual(True, suppress_warning('a'))
+        self.assertEqual(True, suppress_warning('b'))
+
 
 class TestGetConfig(tests.TestCase):
 
@@ -625,6 +680,18 @@
         my_config = self._get_sample_config()
         self.assertEqual(sample_long_alias, my_config.get_alias('ll'))
 
+    def test_get_change_editor(self):
+        my_config = self._get_sample_config()
+        change_editor = my_config.get_change_editor('old', 'new')
+        self.assertIs(diff.DiffFromTool, change_editor.__class__)
+        self.assertEqual('vimdiff -of @new_path @old_path',
+                         ' '.join(change_editor.command_template))
+
+    def test_get_no_change_editor(self):
+        my_config = self._get_empty_config()
+        change_editor = my_config.get_change_editor('old', 'new')
+        self.assertIs(None, change_editor)
+
 
 class TestGlobalConfigSavingOptions(tests.TestCaseInTempDir):
 
@@ -1574,7 +1641,7 @@
         self.assertEquals(entered_password,
                           conf.get_password('ssh', 'bar.org', user='jim'))
         self.assertContainsRe(
-            self._get_log(keep_log_file=True),
+            self.get_log(),
             'password ignored in section \[ssh with password\]')
 
     def test_ssh_without_password_doesnt_emit_warning(self):
@@ -1599,7 +1666,7 @@
         # No warning shoud be emitted since there is no password. We are only
         # providing "user".
         self.assertNotContainsRe(
-            self._get_log(keep_log_file=True),
+            self.get_log(),
             'password ignored in section \[ssh with password\]')
 
     def test_uses_fallback_stores(self):

=== modified file 'bzrlib/tests/test_conflicts.py'
--- bzrlib/tests/test_conflicts.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_conflicts.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,24 +17,12 @@
 
 import os
 
-from bzrlib import bzrdir
-from bzrlib.tests import TestCaseWithTransport, TestCase
-from bzrlib.branch import Branch
-from bzrlib.conflicts import (
-    ConflictList,
-    ContentsConflict,
-    DuplicateID,
-    DuplicateEntry,
-    MissingParent,
-    NonDirectoryParent,
-    ParentLoop,
-    PathConflict,
-    TextConflict,
-    UnversionedParent,
-    resolve,
-    restore,
+from bzrlib import (
+    bzrdir,
+    conflicts,
+    errors,
+    tests,
     )
-from bzrlib.errors import NotConflicted
 
 
 # TODO: Test commit with some added, and added-but-missing files
@@ -44,107 +32,118 @@
 # be a sorted list.
 # u'\xe5' == a with circle
 # '\xc3\xae' == u'\xee' == i with hat
-# So these are u'pathg' and 'idg' only with a circle and a hat. (shappo?)
-example_conflicts = ConflictList([
-    MissingParent('Not deleting', u'p\xe5thg', '\xc3\xaedg'),
-    ContentsConflict(u'p\xe5tha', None, '\xc3\xaeda'),
-    TextConflict(u'p\xe5tha'),
-    PathConflict(u'p\xe5thb', u'p\xe5thc', '\xc3\xaedb'),
-    DuplicateID('Unversioned existing file', u'p\xe5thc', u'p\xe5thc2',
-                '\xc3\xaedc', '\xc3\xaedc'),
-    DuplicateEntry('Moved existing file to',  u'p\xe5thdd.moved', u'p\xe5thd',
-                   '\xc3\xaedd', None),
-    ParentLoop('Cancelled move', u'p\xe5the', u'p\xe5th2e',
-               None, '\xc3\xaed2e'),
-    UnversionedParent('Versioned directory', u'p\xe5thf', '\xc3\xaedf'),
-    NonDirectoryParent('Created directory', u'p\xe5thg', '\xc3\xaedg'),
+# So these are u'path' and 'id' only with a circle and a hat. (shappo?)
+example_conflicts = conflicts.ConflictList(
+    [conflicts.MissingParent('Not deleting', u'p\xe5thg', '\xc3\xaedg'),
+     conflicts.ContentsConflict(u'p\xe5tha', None, '\xc3\xaeda'),
+     conflicts.TextConflict(u'p\xe5tha'),
+     conflicts.PathConflict(u'p\xe5thb', u'p\xe5thc', '\xc3\xaedb'),
+     conflicts.DuplicateID('Unversioned existing file',
+                           u'p\xe5thc', u'p\xe5thc2',
+                           '\xc3\xaedc', '\xc3\xaedc'),
+    conflicts.DuplicateEntry('Moved existing file to',
+                             u'p\xe5thdd.moved', u'p\xe5thd',
+                             '\xc3\xaedd', None),
+    conflicts.ParentLoop('Cancelled move', u'p\xe5the', u'p\xe5th2e',
+                         None, '\xc3\xaed2e'),
+    conflicts.UnversionedParent('Versioned directory',
+                                u'p\xe5thf', '\xc3\xaedf'),
+    conflicts.NonDirectoryParent('Created directory',
+                                 u'p\xe5thg', '\xc3\xaedg'),
 ])
 
 
-class TestConflicts(TestCaseWithTransport):
+class TestConflicts(tests.TestCaseWithTransport):
 
     def test_conflicts(self):
         """Conflicts are detected properly"""
-        tree = self.make_branch_and_tree('.',
-            format=bzrdir.BzrDirFormat6())
-        b = tree.branch
-        file('hello', 'w').write('hello world4')
-        file('hello.THIS', 'w').write('hello world2')
-        file('hello.BASE', 'w').write('hello world1')
-        file('hello.OTHER', 'w').write('hello world3')
-        file('hello.sploo.BASE', 'w').write('yellow world')
-        file('hello.sploo.OTHER', 'w').write('yellow world2')
+        # Use BzrDirFormat6 so we can fake conflicts
+        tree = self.make_branch_and_tree('.', format=bzrdir.BzrDirFormat6())
+        self.build_tree_contents([('hello', 'hello world4'),
+                                  ('hello.THIS', 'hello world2'),
+                                  ('hello.BASE', 'hello world1'),
+                                  ('hello.OTHER', 'hello world3'),
+                                  ('hello.sploo.BASE', 'yellowworld'),
+                                  ('hello.sploo.OTHER', 'yellowworld2'),
+                                  ])
         tree.lock_read()
-        self.assertEqual(len(list(tree.list_files())), 6)
+        self.assertEqual(6, len(list(tree.list_files())))
         tree.unlock()
-        conflicts = tree.conflicts()
-        self.assertEqual(len(conflicts), 2)
-        self.assert_('hello' in conflicts[0].path)
-        self.assert_('hello.sploo' in conflicts[1].path)
-        restore('hello')
-        restore('hello.sploo')
-        self.assertEqual(len(tree.conflicts()), 0)
+        tree_conflicts = tree.conflicts()
+        self.assertEqual(2, len(tree_conflicts))
+        self.assertTrue('hello' in tree_conflicts[0].path)
+        self.assertTrue('hello.sploo' in tree_conflicts[1].path)
+        conflicts.restore('hello')
+        conflicts.restore('hello.sploo')
+        self.assertEqual(0, len(tree.conflicts()))
         self.assertFileEqual('hello world2', 'hello')
         self.assertFalse(os.path.lexists('hello.sploo'))
-        self.assertRaises(NotConflicted, restore, 'hello')
-        self.assertRaises(NotConflicted, restore, 'hello.sploo')
+        self.assertRaises(errors.NotConflicted, conflicts.restore, 'hello')
+        self.assertRaises(errors.NotConflicted,
+                          conflicts.restore, 'hello.sploo')
 
     def test_resolve_conflict_dir(self):
         tree = self.make_branch_and_tree('.')
-        b = tree.branch
-        file('hello', 'w').write('hello world4')
+        self.build_tree_contents([('hello', 'hello world4'),
+                                  ('hello.THIS', 'hello world2'),
+                                  ('hello.BASE', 'hello world1'),
+                                  ])
+        os.mkdir('hello.OTHER')
         tree.add('hello', 'q')
-        file('hello.THIS', 'w').write('hello world2')
-        file('hello.BASE', 'w').write('hello world1')
-        os.mkdir('hello.OTHER')
-        l = ConflictList([TextConflict('hello')])
+        l = conflicts.ConflictList([conflicts.TextConflict('hello')])
         l.remove_files(tree)
 
     def test_select_conflicts(self):
         tree = self.make_branch_and_tree('.')
-        tree_conflicts = ConflictList([ContentsConflict('foo'),
-                                       ContentsConflict('bar')])
-        self.assertEqual((ConflictList([ContentsConflict('bar')]),
-                          ConflictList([ContentsConflict('foo')])),
-                         tree_conflicts.select_conflicts(tree, ['foo']))
-        self.assertEqual((ConflictList(), tree_conflicts),
-                         tree_conflicts.select_conflicts(tree, [''],
-                         ignore_misses=True, recurse=True))
-        tree_conflicts = ConflictList([ContentsConflict('foo/baz'),
-                                       ContentsConflict('bar')])
-        self.assertEqual((ConflictList([ContentsConflict('bar')]),
-                          ConflictList([ContentsConflict('foo/baz')])),
-                         tree_conflicts.select_conflicts(tree, ['foo'],
-                                                         recurse=True,
-                                                         ignore_misses=True))
-        tree_conflicts = ConflictList([PathConflict('qux', 'foo/baz')])
-        self.assertEqual((ConflictList(), tree_conflicts),
-                         tree_conflicts.select_conflicts(tree, ['foo'],
-                                                         recurse=True,
-                                                         ignore_misses=True))
-        self.assertEqual((tree_conflicts, ConflictList()),
-                         tree_conflicts.select_conflicts(tree, ['foo'],
-                                                         ignore_misses=True))
+        clist = conflicts.ConflictList
+
+        def check_select(not_selected, selected, paths, **kwargs):
+            self.assertEqual(
+                (not_selected, selected),
+                tree_conflicts.select_conflicts(tree, paths, **kwargs))
+
+        foo = conflicts.ContentsConflict('foo')
+        bar = conflicts.ContentsConflict('bar')
+        tree_conflicts = clist([foo, bar])
+
+        check_select(clist([bar]), clist([foo]), ['foo'])
+        check_select(clist(), tree_conflicts,
+                     [''], ignore_misses=True, recurse=True)
+
+        foobaz  = conflicts.ContentsConflict('foo/baz')
+        tree_conflicts = clist([foobaz, bar])
+
+        check_select(clist([bar]), clist([foobaz]),
+                     ['foo'], ignore_misses=True, recurse=True)
+
+        qux = conflicts.PathConflict('qux', 'foo/baz')
+        tree_conflicts = clist([qux])
+
+        check_select(clist(), tree_conflicts,
+                     ['foo'], ignore_misses=True, recurse=True)
+        check_select (tree_conflicts, clist(), ['foo'], ignore_misses=True)
 
     def test_resolve_conflicts_recursive(self):
         tree = self.make_branch_and_tree('.')
         self.build_tree(['dir/', 'dir/hello'])
         tree.add(['dir', 'dir/hello'])
-        tree.set_conflicts(ConflictList([TextConflict('dir/hello')]))
-        resolve(tree, ['dir'], recursive=False, ignore_misses=True)
-        self.assertEqual(ConflictList([TextConflict('dir/hello')]),
-                         tree.conflicts())
-        resolve(tree, ['dir'], recursive=True, ignore_misses=True)
-        self.assertEqual(ConflictList([]),
-                         tree.conflicts())
-
-
-class TestConflictStanzas(TestCase):
+
+        dirhello = conflicts.ConflictList([conflicts.TextConflict('dir/hello')])
+        tree.set_conflicts(dirhello)
+
+        conflicts.resolve(tree, ['dir'], recursive=False, ignore_misses=True)
+        self.assertEqual(dirhello, tree.conflicts())
+
+        conflicts.resolve(tree, ['dir'], recursive=True, ignore_misses=True)
+        self.assertEqual(conflicts.ConflictList([]), tree.conflicts())
+
+
+class TestConflictStanzas(tests.TestCase):
 
     def test_stanza_roundtrip(self):
         # write and read our example stanza.
         stanza_iter = example_conflicts.to_stanzas()
-        processed = ConflictList.from_stanzas(stanza_iter)
+        processed = conflicts.ConflictList.from_stanzas(stanza_iter)
         for o, p in zip(processed, example_conflicts):
             self.assertEqual(o, p)
 
@@ -171,3 +170,4 @@
                 self.assertStartsWith(stanza['conflict_path'], u'p\xe5th')
             if 'conflict_file_id' in stanza:
                 self.assertStartsWith(stanza['conflict_file_id'], u'\xeed')
+

=== modified file 'bzrlib/tests/test_crash.py'
--- bzrlib/tests/test_crash.py	2009-08-28 12:38:01 +0000
+++ bzrlib/tests/test_crash.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,7 @@
 
 class TestApportReporting(tests.TestCase):
 
-    _test_needs_features = [features.ApportFeature]
+    _test_needs_features = [features.apport]
 
     def test_apport_report_contents(self):
         try:

=== modified file 'bzrlib/tests/test_diff.py'
--- bzrlib/tests/test_diff.py	2009-10-08 16:32:43 +0000
+++ bzrlib/tests/test_diff.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,19 +63,8 @@
 AttribFeature = _AttribFeature()
 
 
-class _CompiledPatienceDiffFeature(Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._patiencediff_c
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._patiencediff_c'
-
-CompiledPatienceDiffFeature = _CompiledPatienceDiffFeature()
+compiled_patiencediff_feature = tests.ModuleAvailableFeature(
+                                    'bzrlib._patiencediff_c')
 
 
 def udiff_lines(old, new, allow_binary=False):
@@ -1156,7 +1145,7 @@
 
 class TestPatienceDiffLib_c(TestPatienceDiffLib):
 
-    _test_needs_features = [CompiledPatienceDiffFeature]
+    _test_needs_features = [compiled_patiencediff_feature]
 
     def setUp(self):
         super(TestPatienceDiffLib_c, self).setUp()
@@ -1252,7 +1241,7 @@
 
 class TestPatienceDiffLibFiles_c(TestPatienceDiffLibFiles):
 
-    _test_needs_features = [CompiledPatienceDiffFeature]
+    _test_needs_features = [compiled_patiencediff_feature]
 
     def setUp(self):
         super(TestPatienceDiffLibFiles_c, self).setUp()
@@ -1264,7 +1253,7 @@
 class TestUsingCompiledIfAvailable(TestCase):
 
     def test_PatienceSequenceMatcher(self):
-        if CompiledPatienceDiffFeature.available():
+        if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import PatienceSequenceMatcher_c
             self.assertIs(PatienceSequenceMatcher_c,
                           bzrlib.patiencediff.PatienceSequenceMatcher)
@@ -1274,7 +1263,7 @@
                           bzrlib.patiencediff.PatienceSequenceMatcher)
 
     def test_unique_lcs(self):
-        if CompiledPatienceDiffFeature.available():
+        if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import unique_lcs_c
             self.assertIs(unique_lcs_c,
                           bzrlib.patiencediff.unique_lcs)
@@ -1284,7 +1273,7 @@
                           bzrlib.patiencediff.unique_lcs)
 
     def test_recurse_matches(self):
-        if CompiledPatienceDiffFeature.available():
+        if compiled_patiencediff_feature.available():
             from bzrlib._patiencediff_c import recurse_matches_c
             self.assertIs(recurse_matches_c,
                           bzrlib.patiencediff.recurse_matches)
@@ -1299,13 +1288,13 @@
     def test_from_string(self):
         diff_obj = DiffFromTool.from_string('diff', None, None, None)
         self.addCleanup(diff_obj.finish)
-        self.assertEqual(['diff', '%(old_path)s', '%(new_path)s'],
+        self.assertEqual(['diff', '@old_path', '@new_path'],
             diff_obj.command_template)
 
     def test_from_string_u5(self):
         diff_obj = DiffFromTool.from_string('diff -u\\ 5', None, None, None)
         self.addCleanup(diff_obj.finish)
-        self.assertEqual(['diff', '-u 5', '%(old_path)s', '%(new_path)s'],
+        self.assertEqual(['diff', '-u 5', '@old_path', '@new_path'],
                          diff_obj.command_template)
         self.assertEqual(['diff', '-u 5', 'old-path', 'new-path'],
                          diff_obj._get_command('old-path', 'new-path'))
@@ -1313,7 +1302,7 @@
     def test_execute(self):
         output = StringIO()
         diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
+                                 'print "@old_path @new_path"'],
                                 None, None, output)
         self.addCleanup(diff_obj.finish)
         diff_obj._execute('old', 'new')
@@ -1337,20 +1326,26 @@
         tree.commit('old tree')
         tree.lock_read()
         self.addCleanup(tree.unlock)
+        basis_tree = tree.basis_tree()
+        basis_tree.lock_read()
+        self.addCleanup(basis_tree.unlock)
         diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
-                                tree, tree, output)
+                                 'print "@old_path @new_path"'],
+                                basis_tree, tree, output)
         diff_obj._prepare_files('file-id', 'file', 'file')
-        self.assertReadableByAttrib(diff_obj._root, 'old\\file', r'old\\file')
-        self.assertReadableByAttrib(diff_obj._root, 'new\\file', r'new\\file')
+        # The old content should be readonly
+        self.assertReadableByAttrib(diff_obj._root, 'old\\file',
+                                    r'R.*old\\file$')
+        # The new content should use the tree object, not a 'new' file anymore
+        self.assertEndsWith(tree.basedir, 'work/tree')
+        self.assertReadableByAttrib(tree.basedir, 'file', r'work\\tree\\file$')
 
     def assertReadableByAttrib(self, cwd, relpath, regex):
         proc = subprocess.Popen(['attrib', relpath],
                                 stdout=subprocess.PIPE,
                                 cwd=cwd)
-        proc.wait()
-        result = proc.stdout.read()
-        self.assertContainsRe(result, regex)
+        (result, err) = proc.communicate()
+        self.assertContainsRe(result.replace('\r\n', '\n'), regex)
 
     def test_prepare_files(self):
         output = StringIO()
@@ -1370,7 +1365,7 @@
         tree.lock_read()
         self.addCleanup(tree.unlock)
         diff_obj = DiffFromTool(['python', '-c',
-                                 'print "%(old_path)s %(new_path)s"'],
+                                 'print "@old_path @new_path"'],
                                 old_tree, tree, output)
         self.addCleanup(diff_obj.finish)
         self.assertContainsRe(diff_obj._root, 'bzr-diff-[^/]*')
@@ -1378,7 +1373,7 @@
                                                      'newname')
         self.assertContainsRe(old_path, 'old/oldname$')
         self.assertEqual(0, os.stat(old_path).st_mtime)
-        self.assertContainsRe(new_path, 'new/newname$')
+        self.assertContainsRe(new_path, 'tree/newname$')
         self.assertFileEqual('oldcontent', old_path)
         self.assertFileEqual('newcontent', new_path)
         if osutils.host_os_dereferences_symlinks():

=== modified file 'bzrlib/tests/test_directory_service.py'
--- bzrlib/tests/test_directory_service.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_directory_service.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,18 +16,23 @@
 
 """Test directory service implementation"""
 
-from bzrlib import errors
+from bzrlib import (
+    errors,
+    urlutils,
+    )
 from bzrlib.directory_service import DirectoryServiceRegistry, directories
 from bzrlib.tests import TestCase, TestCaseWithTransport
 from bzrlib.transport import get_transport
-from bzrlib import urlutils
 
 
 class FooService(object):
     """A directory service that maps the name to a FILE url"""
 
+    # eg 'file:///foo' on Linux, or 'file:///C:/foo' on Windows
+    base = urlutils.local_path_to_url('/foo')
+
     def look_up(self, name, url):
-        return 'file:///foo' + name
+        return self.base + name
 
 
 class TestDirectoryLookup(TestCase):
@@ -43,14 +48,15 @@
         self.assertEqual('bar', suffix)
 
     def test_dereference(self):
-        self.assertEqual('file:///foobar',
+        self.assertEqual(FooService.base + 'bar',
                          self.registry.dereference('foo:bar'))
         self.assertEqual('baz:qux', self.registry.dereference('baz:qux'))
 
     def test_get_transport(self):
         directories.register('foo:', FooService, 'Map foo URLs to http urls')
         self.addCleanup(lambda: directories.remove('foo:'))
-        self.assertEqual('file:///foobar/', get_transport('foo:bar').base)
+        self.assertEqual(FooService.base + 'bar/',
+                         get_transport('foo:bar').base)
 
 
 class TestAliasDirectory(TestCaseWithTransport):

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2009-08-17 03:33:56 +0000
+++ bzrlib/tests/test_dirstate.py	2010-01-12 20:51:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -873,15 +873,23 @@
         state = dirstate.DirState.initialize('dirstate')
         try:
             # check precondition to be sure the state does change appropriately.
-            self.assertEqual(
-                [(('', '', 'TREE_ROOT'), [('d', '', 0, False,
-                   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')])],
-                list(state._iter_entries()))
-            state.set_path_id('', 'foobarbaz')
-            expected_rows = [
-                (('', '', 'foobarbaz'), [('d', '', 0, False,
-                   'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx')])]
+            root_entry = (('', '', 'TREE_ROOT'), [('d', '', 0, False, 'x'*32)])
+            self.assertEqual([root_entry], list(state._iter_entries()))
+            self.assertEqual(root_entry, state._get_entry(0, path_utf8=''))
+            self.assertEqual(root_entry,
+                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
+            self.assertEqual((None, None),
+                             state._get_entry(0, fileid_utf8='second-root-id'))
+            state.set_path_id('', 'second-root-id')
+            new_root_entry = (('', '', 'second-root-id'),
+                              [('d', '', 0, False, 'x'*32)])
+            expected_rows = [new_root_entry]
             self.assertEqual(expected_rows, list(state._iter_entries()))
+            self.assertEqual(new_root_entry, state._get_entry(0, path_utf8=''))
+            self.assertEqual(new_root_entry, 
+                             state._get_entry(0, fileid_utf8='second-root-id'))
+            self.assertEqual((None, None),
+                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
             # should work across save too
             state.save()
         finally:
@@ -905,21 +913,36 @@
         state._validate()
         try:
             state.set_parent_trees([('parent-revid', rt)], ghosts=[])
-            state.set_path_id('', 'foobarbaz')
+            root_entry = (('', '', 'TREE_ROOT'),
+                          [('d', '', 0, False, 'x'*32),
+                           ('d', '', 0, False, 'parent-revid')])
+            self.assertEqual(root_entry, state._get_entry(0, path_utf8=''))
+            self.assertEqual(root_entry,
+                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
+            self.assertEqual((None, None),
+                             state._get_entry(0, fileid_utf8='Asecond-root-id'))
+            state.set_path_id('', 'Asecond-root-id')
             state._validate()
             # now see that it is what we expected
-            expected_rows = [
-                (('', '', 'TREE_ROOT'),
-                    [('a', '', 0, False, ''),
-                     ('d', '', 0, False, 'parent-revid'),
-                     ]),
-                (('', '', 'foobarbaz'),
-                    [('d', '', 0, False, ''),
-                     ('a', '', 0, False, ''),
-                     ]),
-                ]
+            old_root_entry = (('', '', 'TREE_ROOT'),
+                              [('a', '', 0, False, ''),
+                               ('d', '', 0, False, 'parent-revid')])
+            new_root_entry = (('', '', 'Asecond-root-id'),
+                              [('d', '', 0, False, ''),
+                               ('a', '', 0, False, '')])
+            expected_rows = [new_root_entry, old_root_entry]
             state._validate()
             self.assertEqual(expected_rows, list(state._iter_entries()))
+            self.assertEqual(new_root_entry, state._get_entry(0, path_utf8=''))
+            self.assertEqual(old_root_entry, state._get_entry(1, path_utf8=''))
+            self.assertEqual((None, None),
+                             state._get_entry(0, fileid_utf8='TREE_ROOT'))
+            self.assertEqual(old_root_entry,
+                             state._get_entry(1, fileid_utf8='TREE_ROOT'))
+            self.assertEqual(new_root_entry,
+                             state._get_entry(0, fileid_utf8='Asecond-root-id'))
+            self.assertEqual((None, None),
+                             state._get_entry(1, fileid_utf8='Asecond-root-id'))
             # should work across save too
             state.save()
         finally:

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2009-08-21 02:37:18 +0000
+++ bzrlib/tests/test_errors.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -542,7 +542,7 @@
             1/0
         except ZeroDivisionError:
             exc_info = sys.exc_info()
-        err = errors.HookFailed('hook stage', 'hook name', exc_info)
+        err = errors.HookFailed('hook stage', 'hook name', exc_info, warn=False)
         self.assertStartsWith(
             str(err), 'Hook \'hook name\' during hook stage failed:\n')
         self.assertEndsWith(
@@ -623,6 +623,38 @@
         self.assertEqual(
             'Repository dummy repo cannot suspend a write group.', str(err))
 
+    def test_not_branch_no_args(self):
+        err = errors.NotBranchError('path')
+        self.assertEqual('Not a branch: "path".', str(err))
+
+    def test_not_branch_bzrdir_with_repo(self):
+        bzrdir = self.make_repository('repo').bzrdir
+        err = errors.NotBranchError('path', bzrdir=bzrdir)
+        self.assertEqual(
+            'Not a branch: "path": location is a repository.', str(err))
+
+    def test_not_branch_bzrdir_without_repo(self):
+        bzrdir = self.make_bzrdir('bzrdir')
+        err = errors.NotBranchError('path', bzrdir=bzrdir)
+        self.assertEqual('Not a branch: "path".', str(err))
+
+    def test_not_branch_laziness(self):
+        real_bzrdir = self.make_bzrdir('path')
+        class FakeBzrDir(object):
+            def __init__(self):
+                self.calls = []
+            def open_repository(self):
+                self.calls.append('open_repository')
+                raise errors.NoRepositoryPresent(real_bzrdir)
+        fake_bzrdir = FakeBzrDir()
+        err = errors.NotBranchError('path', bzrdir=fake_bzrdir)
+        self.assertEqual([], fake_bzrdir.calls)
+        str(err)
+        self.assertEqual(['open_repository'], fake_bzrdir.calls)
+        # Stringifying twice doesn't try to open a repository twice.
+        str(err)
+        self.assertEqual(['open_repository'], fake_bzrdir.calls)
+
 
 class PassThroughError(errors.BzrError):
 
@@ -676,3 +708,8 @@
             socket.error(13, 'Permission denied'))
         self.assertContainsRe(str(e),
             r'Cannot bind address "example\.com:22":.*Permission denied')
+
+    def test_file_timestamp_unavailable(self):            
+        e = errors.FileTimestampUnavailable("/path/foo")
+        self.assertEquals("The filestamp for /path/foo is not available.",
+            str(e))

=== modified file 'bzrlib/tests/test_foreign.py'
--- bzrlib/tests/test_foreign.py	2009-10-19 00:54:12 +0000
+++ bzrlib/tests/test_foreign.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -103,6 +103,9 @@
     def is_compatible(source, target):
         return isinstance(target, DummyForeignVcsBranch)
 
+    def push(self, overwrite=False, stop_revision=None):
+        raise errors.NoRoundtrippingSupport(self.source, self.target)
+
     def lossy_push(self, stop_revision=None):
         result = branch.BranchPushResult()
         result.source_branch = self.source
@@ -351,6 +354,13 @@
         self.assertNotEquals("A Dummy VCS Dir",
                              newdir._format.get_format_string())
 
+    def test_push_not_supported(self):
+        source_tree = self.make_branch_and_tree("source")
+        target_tree = self.make_branch_and_tree("target", 
+            format=DummyForeignVcsDirFormat())
+        self.assertRaises(errors.NoRoundtrippingSupport, 
+            source_tree.branch.push, target_tree.branch)
+
     def test_lossy_push_empty(self):
         source_tree = self.make_branch_and_tree("source")
         target_tree = self.make_branch_and_tree("target", 

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_globbing.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 # -*- coding: utf-8 -*-
 #
 # This program is free software; you can redistribute it and/or modify
@@ -17,7 +17,9 @@
 
 from bzrlib.globbing import (
     Globster,
+    ExceptionGlobster,
     _OrderedGlobster,
+    normalize_pattern
     )
 from bzrlib.tests import (
     TestCase,
@@ -306,6 +308,30 @@
             self.assertEqual(patterns[x],globster.match(filename))
         self.assertEqual(None,globster.match('foobar.300'))
 
+class TestExceptionGlobster(TestCase):
+
+    def test_exclusion_patterns(self):
+        """test that exception patterns are not matched"""
+        patterns = [ u'*', u'!./local', u'!./local/**/*', u'!RE:\.z.*',u'!!./.zcompdump' ]
+        globster = ExceptionGlobster(patterns)
+        self.assertEqual(u'*', globster.match('tmp/foo.txt'))
+        self.assertEqual(None, globster.match('local'))
+        self.assertEqual(None, globster.match('local/bin/wombat'))
+        self.assertEqual(None, globster.match('.zshrc'))
+        self.assertEqual(None, globster.match('.zfunctions/fiddle/flam'))
+        self.assertEqual(u'!!./.zcompdump', globster.match('.zcompdump'))
+
+    def test_exclusion_order(self):
+        """test that ordering of exclusion patterns does not matter"""
+        patterns = [ u'static/**/*.html', u'!static/**/versionable.html']
+        globster = ExceptionGlobster(patterns)
+        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
+        self.assertEqual(None, globster.match('static/versionable.html'))
+        self.assertEqual(None, globster.match('static/bar/versionable.html'))
+        globster = ExceptionGlobster(reversed(patterns))
+        self.assertEqual(u'static/**/*.html', globster.match('static/foo.html'))
+        self.assertEqual(None, globster.match('static/versionable.html'))
+        self.assertEqual(None, globster.match('static/bar/versionable.html'))
 
 class TestOrderedGlobster(TestCase):
 
@@ -318,3 +344,30 @@
         globster = _OrderedGlobster(reversed(patterns))
         self.assertEqual(u'bar.*', globster.match('bar.foo'))
         self.assertEqual(None, globster.match('foo.bar'))
+
+
+class TestNormalizePattern(TestCase):
+
+    def test_backslashes(self):
+        """tests that backslashes are converted to forward slashes, multiple
+        backslashes are collapsed to single forward slashes and trailing
+        backslashes are removed"""
+        self.assertEqual(u'/', normalize_pattern(u'\\'))
+        self.assertEqual(u'/', normalize_pattern(u'\\\\'))
+        self.assertEqual(u'/foo/bar', normalize_pattern(u'\\foo\\bar'))
+        self.assertEqual(u'foo/bar', normalize_pattern(u'foo\\bar\\'))
+        self.assertEqual(u'/foo/bar', normalize_pattern(u'\\\\foo\\\\bar\\\\'))
+
+    def test_forward_slashes(self):
+        """tests that multiple foward slashes are collapsed to single forward
+        slashes and trailing forward slashes are removed"""
+        self.assertEqual(u'/', normalize_pattern(u'/'))
+        self.assertEqual(u'/', normalize_pattern(u'//'))
+        self.assertEqual(u'/foo/bar', normalize_pattern(u'/foo/bar'))
+        self.assertEqual(u'foo/bar', normalize_pattern(u'foo/bar/'))
+        self.assertEqual(u'/foo/bar', normalize_pattern(u'//foo//bar//'))
+
+    def test_mixed_slashes(self):
+        """tests that multiple mixed slashes are collapsed to single forward
+        slashes and trailing mixed slashes are removed"""
+        self.assertEqual(u'/foo/bar', normalize_pattern(u'\\/\\foo//\\///bar/\\\\/'))

=== modified file 'bzrlib/tests/test_graph.py'
--- bzrlib/tests/test_graph.py	2009-08-04 04:36:34 +0000
+++ bzrlib/tests/test_graph.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1582,6 +1582,24 @@
         self.assertCollapsed(d, d)
 
 
+class TestGraphThunkIdsToKeys(tests.TestCase):
+
+    def test_heads(self):
+        # A
+        # |\
+        # B C
+        # |/
+        # D
+        d = {('D',): [('B',), ('C',)], ('C',):[('A',)],
+             ('B',): [('A',)], ('A',): []}
+        g = _mod_graph.Graph(_mod_graph.DictParentsProvider(d))
+        graph_thunk = _mod_graph.GraphThunkIdsToKeys(g)
+        self.assertEqual(['D'], sorted(graph_thunk.heads(['D', 'A'])))
+        self.assertEqual(['D'], sorted(graph_thunk.heads(['D', 'B'])))
+        self.assertEqual(['D'], sorted(graph_thunk.heads(['D', 'C'])))
+        self.assertEqual(['B', 'C'], sorted(graph_thunk.heads(['B', 'C'])))
+
+
 class TestPendingAncestryResultGetKeys(TestCaseWithMemoryTransport):
     """Tests for bzrlib.graph.PendingAncestryResult."""
 

=== modified file 'bzrlib/tests/test_groupcompress.py'
--- bzrlib/tests/test_groupcompress.py	2009-10-19 15:06:58 +0000
+++ bzrlib/tests/test_groupcompress.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,7 +29,7 @@
     versionedfile,
     )
 from bzrlib.osutils import sha_string
-from bzrlib.tests.test__groupcompress import CompiledGroupCompressFeature
+from bzrlib.tests.test__groupcompress import compiled_groupcompress_feature
 
 
 def load_tests(standard_tests, module, loader):
@@ -39,7 +39,7 @@
     scenarios = [
         ('python', {'compressor': groupcompress.PythonGroupCompressor}),
         ]
-    if CompiledGroupCompressFeature.available():
+    if compiled_groupcompress_feature.available():
         scenarios.append(('C',
             {'compressor': groupcompress.PyrexGroupCompressor}))
     return tests.multiply_tests(to_adapt, scenarios, result)
@@ -135,7 +135,7 @@
 
 class TestPyrexGroupCompressor(TestGroupCompressor):
 
-    _test_needs_features = [CompiledGroupCompressFeature]
+    _test_needs_features = [compiled_groupcompress_feature]
     compressor = groupcompress.PyrexGroupCompressor
 
     def test_stats(self):

=== modified file 'bzrlib/tests/test_hooks.py'
--- bzrlib/tests/test_hooks.py	2009-09-01 12:29:54 +0000
+++ bzrlib/tests/test_hooks.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,11 @@
 
 """Tests for the core Hooks logic."""
 
-from bzrlib import branch, errors
+from bzrlib import (
+    branch,
+    errors,
+    tests,
+    )
 from bzrlib.hooks import (
     HookPoint,
     Hooks,
@@ -24,14 +28,9 @@
     known_hooks_key_to_object,
     known_hooks_key_to_parent_and_attribute,
     )
-from bzrlib.errors import (
-    UnknownHook,
-    )
-
-from bzrlib.tests import TestCase
-
-
-class TestHooks(TestCase):
+
+
+class TestHooks(tests.TestCase):
 
     def test_create_hook_first(self):
         hooks = Hooks()
@@ -95,7 +94,7 @@
 
     def test_install_named_hook_raises_unknown_hook(self):
         hooks = Hooks()
-        self.assertRaises(UnknownHook, hooks.install_named_hook, 'silly',
+        self.assertRaises(errors.UnknownHook, hooks.install_named_hook, 'silly',
                           None, "")
 
     def test_install_named_hook_appends_known_hook(self):
@@ -111,7 +110,7 @@
         self.assertEqual("demo", hooks.get_hook_name(None))
 
 
-class TestHook(TestCase):
+class TestHook(tests.TestCase):
 
     def test___init__(self):
         doc = ("Invoked after changing the tip of a branch object. Called with"
@@ -154,7 +153,7 @@
             callback_repr, repr(hook))
 
 
-class TestHookRegistry(TestCase):
+class TestHookRegistry(tests.TestCase):
 
     def test_items_are_reasonable_keys(self):
         # All the items in the known_hooks registry need to map from
@@ -170,6 +169,7 @@
             new_hooks = factory()
             self.assertIsInstance(obj, Hooks)
             self.assertEqual(type(obj), type(new_hooks))
+            self.assertEqual("No hook name", new_hooks.get_hook_name(None))
 
     def test_known_hooks_key_to_object(self):
         self.assertIs(branch.Branch.hooks,

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/test_http.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -48,6 +48,7 @@
     deprecated_in,
     )
 from bzrlib.tests import (
+    features,
     http_server,
     http_utils,
     )
@@ -61,11 +62,8 @@
     )
 
 
-try:
+if features.pycurl.available():
     from bzrlib.transport.http._pycurl import PyCurlTransport
-    pycurl_present = True
-except errors.DependencyNotPresent:
-    pycurl_present = False
 
 
 def load_tests(standard_tests, module, loader):
@@ -84,7 +82,7 @@
                         _server=http_server.HttpServer_urllib,
                         _qualified_prefix='http+urllib',)),
         ]
-    if pycurl_present:
+    if features.pycurl.available():
         transport_scenarios.append(
             ('pycurl', dict(_transport=PyCurlTransport,
                             _server=http_server.HttpServer_PyCurl,
@@ -156,7 +154,7 @@
         activity_scenarios.append(
             ('urllib,https', dict(_activity_server=ActivityHTTPSServer,
                                   _transport=_urllib.HttpTransport_urllib,)),)
-    if pycurl_present:
+    if features.pycurl.available():
         activity_scenarios.append(
             ('pycurl,http', dict(_activity_server=ActivityHTTPServer,
                                  _transport=PyCurlTransport,)),)
@@ -220,7 +218,7 @@
     def get_url(self):
         return '%s://%s:%s/' % (self.scheme, self.host, self.port)
 
-    def setUp(self):
+    def start_server(self):
         self._sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
         self._sock.bind(('127.0.0.1', 0))
         self.host, self.port = self._sock.getsockname()
@@ -249,7 +247,7 @@
             # The client may have already closed the socket.
             pass
 
-    def tearDown(self):
+    def stop_server(self):
         try:
             self._sock.close()
         except socket.error:
@@ -269,19 +267,19 @@
 
     def test_empty_header(self):
         scheme, remainder = self.parse_header('')
-        self.assertEquals('', scheme)
+        self.assertEqual('', scheme)
         self.assertIs(None, remainder)
 
     def test_negotiate_header(self):
         scheme, remainder = self.parse_header('Negotiate')
-        self.assertEquals('negotiate', scheme)
+        self.assertEqual('negotiate', scheme)
         self.assertIs(None, remainder)
 
     def test_basic_header(self):
         scheme, remainder = self.parse_header(
             'Basic realm="Thou should not pass"')
-        self.assertEquals('basic', scheme)
-        self.assertEquals('realm="Thou should not pass"', remainder)
+        self.assertEqual('basic', scheme)
+        self.assertEqual('realm="Thou should not pass"', remainder)
 
     def test_basic_extract_realm(self):
         scheme, remainder = self.parse_header(
@@ -289,13 +287,13 @@
             _urllib2_wrappers.BasicAuthHandler)
         match, realm = self.auth_handler.extract_realm(remainder)
         self.assertTrue(match is not None)
-        self.assertEquals('Thou should not pass', realm)
+        self.assertEqual('Thou should not pass', realm)
 
     def test_digest_header(self):
         scheme, remainder = self.parse_header(
             'Digest realm="Thou should not pass"')
-        self.assertEquals('digest', scheme)
-        self.assertEquals('realm="Thou should not pass"', remainder)
+        self.assertEqual('digest', scheme)
+        self.assertEqual('realm="Thou should not pass"', remainder)
 
 
 class TestHTTPServer(tests.TestCase):
@@ -308,26 +306,26 @@
 
         server = http_server.HttpServer(BogusRequestHandler)
         try:
-            self.assertRaises(httplib.UnknownProtocol, server.setUp)
+            self.assertRaises(httplib.UnknownProtocol, server.start_server)
         except:
-            server.tearDown()
+            server.stop_server()
             self.fail('HTTP Server creation did not raise UnknownProtocol')
 
     def test_force_invalid_protocol(self):
         server = http_server.HttpServer(protocol_version='HTTP/0.1')
         try:
-            self.assertRaises(httplib.UnknownProtocol, server.setUp)
+            self.assertRaises(httplib.UnknownProtocol, server.start_server)
         except:
-            server.tearDown()
+            server.stop_server()
             self.fail('HTTP Server creation did not raise UnknownProtocol')
 
     def test_server_start_and_stop(self):
         server = http_server.HttpServer()
-        server.setUp()
+        server.start_server()
         try:
             self.assertTrue(server._http_running)
         finally:
-            server.tearDown()
+            server.stop_server()
         self.assertFalse(server._http_running)
 
     def test_create_http_server_one_zero(self):
@@ -376,11 +374,8 @@
     """Test case to inherit from if pycurl is present"""
 
     def _get_pycurl_maybe(self):
-        try:
-            from bzrlib.transport.http._pycurl import PyCurlTransport
-            return PyCurlTransport
-        except errors.DependencyNotPresent:
-            raise tests.TestSkipped('pycurl not present')
+        self.requireFeature(features.pycurl)
+        return PyCurlTransport
 
     _transport = property(_get_pycurl_maybe)
 
@@ -393,14 +388,14 @@
     def test_url_parsing(self):
         f = FakeManager()
         url = http.extract_auth('http://example.com', f)
-        self.assertEquals('http://example.com', url)
-        self.assertEquals(0, len(f.credentials))
+        self.assertEqual('http://example.com', url)
+        self.assertEqual(0, len(f.credentials))
         url = http.extract_auth(
             'http://user:pass@www.bazaar-vcs.org/bzr/bzr.dev', f)
-        self.assertEquals('http://www.bazaar-vcs.org/bzr/bzr.dev', url)
-        self.assertEquals(1, len(f.credentials))
-        self.assertEquals([None, 'www.bazaar-vcs.org', 'user', 'pass'],
-                          f.credentials[0])
+        self.assertEqual('http://www.bazaar-vcs.org/bzr/bzr.dev', url)
+        self.assertEqual(1, len(f.credentials))
+        self.assertEqual([None, 'www.bazaar-vcs.org', 'user', 'pass'],
+                         f.credentials[0])
 
 
 class TestHttpTransportUrls(tests.TestCase):
@@ -433,12 +428,12 @@
     def test_http_impl_urls(self):
         """There are servers which ask for particular clients to connect"""
         server = self._server()
-        server.setUp()
+        server.start_server()
         try:
             url = server.get_url()
             self.assertTrue(url.startswith('%s://' % self._qualified_prefix))
         finally:
-            server.tearDown()
+            server.stop_server()
 
 
 class TestHttps_pycurl(TestWithTransport_pycurl, tests.TestCase):
@@ -453,34 +448,32 @@
         https by supplying a fake version_info that do not
         support it.
         """
-        try:
-            import pycurl
-        except ImportError:
-            raise tests.TestSkipped('pycurl not present')
+        self.requireFeature(features.pycurl)
+        # Import the module locally now that we now it's available.
+        pycurl = features.pycurl.module
 
         version_info_orig = pycurl.version_info
-        try:
-            # Now that we have pycurl imported, we can fake its version_info
-            # This was taken from a windows pycurl without SSL
-            # (thanks to bialix)
-            pycurl.version_info = lambda : (2,
-                                            '7.13.2',
-                                            462082,
-                                            'i386-pc-win32',
-                                            2576,
-                                            None,
-                                            0,
-                                            None,
-                                            ('ftp', 'gopher', 'telnet',
-                                             'dict', 'ldap', 'http', 'file'),
-                                            None,
-                                            0,
-                                            None)
-            self.assertRaises(errors.DependencyNotPresent, self._transport,
-                              'https://launchpad.net')
-        finally:
-            # Restore the right function
+        def restore():
             pycurl.version_info = version_info_orig
+        self.addCleanup(restore)
+
+        # Fake the pycurl version_info This was taken from a windows pycurl
+        # without SSL (thanks to bialix)
+        pycurl.version_info = lambda : (2,
+                                        '7.13.2',
+                                        462082,
+                                        'i386-pc-win32',
+                                        2576,
+                                        None,
+                                        0,
+                                        None,
+                                        ('ftp', 'gopher', 'telnet',
+                                         'dict', 'ldap', 'http', 'file'),
+                                        None,
+                                        0,
+                                        None)
+        self.assertRaises(errors.DependencyNotPresent, self._transport,
+                          'https://launchpad.net')
 
 
 class TestHTTPConnections(http_utils.TestCaseWithWebserver):
@@ -603,7 +596,9 @@
                                       protocol_version=self._protocol_version)
 
     def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
+        # TODO: This is duplicated for lots of the classes in this file
+        return (features.pycurl.available()
+                and self._transport == PyCurlTransport)
 
 
 class WallRequestHandler(http_server.TestingHTTPRequestHandler):
@@ -718,7 +713,7 @@
     _req_handler_class = BadProtocolRequestHandler
 
     def setUp(self):
-        if pycurl_present and self._transport == PyCurlTransport:
+        if self._testing_pycurl():
             raise tests.TestNotApplicable(
                 "pycurl doesn't check the protocol version")
         super(TestBadProtocolServer, self).setUp()
@@ -768,14 +763,14 @@
         self.assertEqual(None, server.host)
         self.assertEqual(None, server.port)
 
-    def test_setUp_and_tearDown(self):
+    def test_setUp_and_stop(self):
         server = RecordingServer(expect_body_tail=None)
-        server.setUp()
+        server.start_server()
         try:
             self.assertNotEqual(None, server.host)
             self.assertNotEqual(None, server.port)
         finally:
-            server.tearDown()
+            server.stop_server()
         self.assertEqual(None, server.host)
         self.assertEqual(None, server.port)
 
@@ -1178,7 +1173,7 @@
         if self._testing_pycurl():
             # Oh my ! pycurl does not check for the port as part of
             # no_proxy :-( So we just test the host part
-            self.no_proxy_host = 'localhost'
+            self.no_proxy_host = self.server.host
         else:
             self.no_proxy_host = self.proxy_address
         # The secondary server is the proxy
@@ -1187,7 +1182,9 @@
         self._old_env = {}
 
     def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
+        # TODO: This is duplicated for lots of the classes in this file
+        return (features.pycurl.available()
+                and self._transport == PyCurlTransport)
 
     def create_transport_secondary_server(self):
         """Creates an http server that will serve files with
@@ -1366,6 +1363,14 @@
         self.follow_redirections = True
 
 
+def install_redirected_request(test):
+    test.original_class = _urllib2_wrappers.Request
+    def restore():
+        _urllib2_wrappers.Request = test.original_class
+    _urllib2_wrappers.Request = RedirectedRequest
+    test.addCleanup(restore)
+
+
 class TestHTTPSilentRedirections(http_utils.TestCaseWithRedirectedWebserver):
     """Test redirections.
 
@@ -1381,12 +1386,12 @@
     """
 
     def setUp(self):
-        if pycurl_present and self._transport == PyCurlTransport:
+        if (features.pycurl.available()
+            and self._transport == PyCurlTransport):
             raise tests.TestNotApplicable(
                 "pycurl doesn't redirect silently annymore")
         super(TestHTTPSilentRedirections, self).setUp()
-        self.setup_redirected_request()
-        self.addCleanup(self.cleanup_redirected_request)
+        install_redirected_request(self)
         self.build_tree_contents([('a','a'),
                                   ('1/',),
                                   ('1/a', 'redirected once'),
@@ -1402,13 +1407,6 @@
 
         self.old_transport = self._transport(self.old_server.get_url())
 
-    def setup_redirected_request(self):
-        self.original_class = _urllib2_wrappers.Request
-        _urllib2_wrappers.Request = RedirectedRequest
-
-    def cleanup_redirected_request(self):
-        _urllib2_wrappers.Request = self.original_class
-
     def create_transport_secondary_server(self):
         """Create the secondary server, redirections are defined in the tests"""
         return http_utils.HTTPServerRedirecting(
@@ -1418,18 +1416,16 @@
         t = self.old_transport
 
         req = RedirectedRequest('GET', t.abspath('a'))
-        req.follow_redirections = True
         new_prefix = 'http://%s:%s' % (self.new_server.host,
                                        self.new_server.port)
         self.old_server.redirections = \
             [('(.*)', r'%s/1\1' % (new_prefix), 301),]
-        self.assertEquals('redirected once',t._perform(req).read())
+        self.assertEqual('redirected once',t._perform(req).read())
 
     def test_five_redirections(self):
         t = self.old_transport
 
         req = RedirectedRequest('GET', t.abspath('a'))
-        req.follow_redirections = True
         old_prefix = 'http://%s:%s' % (self.old_server.host,
                                        self.old_server.port)
         new_prefix = 'http://%s:%s' % (self.new_server.host,
@@ -1441,7 +1437,7 @@
             ('/4(.*)', r'%s/5\1' % (new_prefix), 301),
             ('(/[^/]+)', r'%s/1\1' % (old_prefix), 301),
             ]
-        self.assertEquals('redirected 5 times',t._perform(req).read())
+        self.assertEqual('redirected 5 times',t._perform(req).read())
 
 
 class TestDoCatchRedirections(http_utils.TestCaseWithRedirectedWebserver):
@@ -1460,8 +1456,8 @@
         t = self._transport(self.new_server.get_url())
 
         # We use None for redirected so that we fail if redirected
-        self.assertEquals('0123456789',
-                          transport.do_catching_redirections(
+        self.assertEqual('0123456789',
+                         transport.do_catching_redirections(
                 self.get_a, t, None).read())
 
     def test_one_redirection(self):
@@ -1472,10 +1468,10 @@
             dir, file = urlutils.split(exception.target)
             return self._transport(dir)
 
-        self.assertEquals('0123456789',
-                          transport.do_catching_redirections(
+        self.assertEqual('0123456789',
+                         transport.do_catching_redirections(
                 self.get_a, self.old_transport, redirected).read())
-        self.assertEquals(1, self.redirections)
+        self.assertEqual(1, self.redirections)
 
     def test_redirection_loop(self):
 
@@ -1509,7 +1505,9 @@
         return self._auth_server(protocol_version=self._protocol_version)
 
     def _testing_pycurl(self):
-        return pycurl_present and self._transport == PyCurlTransport
+        # TODO: This is duplicated for lots of the classes in this file
+        return (features.pycurl.available()
+                and self._transport == PyCurlTransport)
 
     def get_user_url(self, user, password):
         """Build an url embedding user and password"""
@@ -1580,8 +1578,8 @@
         self.assertEqual('', ui.ui_factory.stdin.readline())
         stderr.seek(0)
         expected_prompt = self._expected_username_prompt(t._unqualified_scheme)
-        self.assertEquals(expected_prompt, stderr.read(len(expected_prompt)))
-        self.assertEquals('', stdout.getvalue())
+        self.assertEqual(expected_prompt, stderr.read(len(expected_prompt)))
+        self.assertEqual('', stdout.getvalue())
         self._check_password_prompt(t._unqualified_scheme, 'joe',
                                     stderr.readline())
 
@@ -1602,7 +1600,7 @@
         self.assertEqual('', ui.ui_factory.stdin.readline())
         self._check_password_prompt(t._unqualified_scheme, 'joe',
                                     stderr.getvalue())
-        self.assertEquals('', stdout.getvalue())
+        self.assertEqual('', stdout.getvalue())
         # And we shouldn't prompt again for a different request
         # against the same transport.
         self.assertEqual('contents of b\n',t.get('b').read())
@@ -1618,7 +1616,7 @@
                               % (scheme.upper(),
                                  user, self.server.host, self.server.port,
                                  self.server.auth_realm)))
-        self.assertEquals(expected_prompt, actual_prompt)
+        self.assertEqual(expected_prompt, actual_prompt)
 
     def _expected_username_prompt(self, scheme):
         return (self._username_prompt_prefix
@@ -1638,7 +1636,7 @@
         self.server.add_user(user, password)
         t = self.get_user_transport(user, None)
         ui.ui_factory = tests.TestUIFactory(stdin=stdin_content,
-                                            stdout=tests.StringIOWrapper())
+                                            stderr=tests.StringIOWrapper())
         # Create a minimal config file with the right password
         conf = config.AuthenticationConfig()
         conf._get_config().update(
@@ -1856,7 +1854,7 @@
                              'http://www.example.com/foo/subdir')
         self.assertIsInstance(r, type(t))
         # Both transports share the some connection
-        self.assertEquals(t._get_connection(), r._get_connection())
+        self.assertEqual(t._get_connection(), r._get_connection())
 
     def test_redirected_to_self_with_slash(self):
         t = self._transport('http://www.example.com/foo')
@@ -1866,7 +1864,7 @@
         # Both transports share the some connection (one can argue that we
         # should return the exact same transport here, but that seems
         # overkill).
-        self.assertEquals(t._get_connection(), r._get_connection())
+        self.assertEqual(t._get_connection(), r._get_connection())
 
     def test_redirected_to_host(self):
         t = self._transport('http://www.example.com/foo')
@@ -1891,7 +1889,7 @@
         r = t._redirected_to('http://www.example.com/foo',
                              'https://foo.example.com/foo')
         self.assertIsInstance(r, type(t))
-        self.assertEquals(t._user, r._user)
+        self.assertEqual(t._user, r._user)
 
 
 class PredefinedRequestHandler(http_server.TestingHTTPRequestHandler):
@@ -1956,7 +1954,7 @@
         pass
 
 
-class TestActivity(tests.TestCase):
+class TestActivityMixin(object):
     """Test socket activity reporting.
 
     We use a special purpose server to control the bytes sent and received and
@@ -1966,7 +1964,7 @@
     def setUp(self):
         tests.TestCase.setUp(self)
         self.server = self._activity_server(self._protocol_version)
-        self.server.setUp()
+        self.server.start_server()
         self.activities = {}
         def report_activity(t, bytes, direction):
             count = self.activities.get(direction, 0)
@@ -1981,7 +1979,7 @@
 
     def tearDown(self):
         self._transport._report_activity = self.orig_report_activity
-        self.server.tearDown()
+        self.server.stop_server()
         tests.TestCase.tearDown(self)
 
     def get_transport(self):
@@ -2100,3 +2098,135 @@
         code, f = t._post('abc def end-of-body\n')
         self.assertEqual('lalala whatever as long as itsssss\n', f.read())
         self.assertActivitiesMatch()
+
+
+class TestActivity(tests.TestCase, TestActivityMixin):
+
+    def setUp(self):
+        tests.TestCase.setUp(self)
+        self.server = self._activity_server(self._protocol_version)
+        self.server.start_server()
+        self.activities = {}
+        def report_activity(t, bytes, direction):
+            count = self.activities.get(direction, 0)
+            count += bytes
+            self.activities[direction] = count
+
+        # We override at class level because constructors may propagate the
+        # bound method and render instance overriding ineffective (an
+        # alternative would be to define a specific ui factory instead...)
+        self.orig_report_activity = self._transport._report_activity
+        self._transport._report_activity = report_activity
+
+    def tearDown(self):
+        self._transport._report_activity = self.orig_report_activity
+        self.server.stop_server()
+        tests.TestCase.tearDown(self)
+
+
+class TestNoReportActivity(tests.TestCase, TestActivityMixin):
+
+    def setUp(self):
+        tests.TestCase.setUp(self)
+        # Unlike TestActivity, we are really testing ReportingFileSocket and
+        # ReportingSocket, so we don't need all the parametrization. Since
+        # ReportingFileSocket and ReportingSocket are wrappers, it's easier to
+        # test them through their use by the transport than directly (that's a
+        # bit less clean but far more simpler and effective).
+        self.server = ActivityHTTPServer('HTTP/1.1')
+        self._transport=_urllib.HttpTransport_urllib
+
+        self.server.start_server()
+
+        # We override at class level because constructors may propagate the
+        # bound method and render instance overriding ineffective (an
+        # alternative would be to define a specific ui factory instead...)
+        self.orig_report_activity = self._transport._report_activity
+        self._transport._report_activity = None
+
+    def tearDown(self):
+        self._transport._report_activity = self.orig_report_activity
+        self.server.stop_server()
+        tests.TestCase.tearDown(self)
+
+    def assertActivitiesMatch(self):
+        # Nothing to check here
+        pass
+
+
+class TestAuthOnRedirected(http_utils.TestCaseWithRedirectedWebserver):
+    """Test authentication on the redirected http server."""
+
+    _auth_header = 'Authorization'
+    _password_prompt_prefix = ''
+    _username_prompt_prefix = ''
+    _auth_server = http_utils.HTTPBasicAuthServer
+    _transport = _urllib.HttpTransport_urllib
+
+    def create_transport_readonly_server(self):
+        return self._auth_server()
+
+    def create_transport_secondary_server(self):
+        """Create the secondary server redirecting to the primary server"""
+        new = self.get_readonly_server()
+
+        redirecting = http_utils.HTTPServerRedirecting()
+        redirecting.redirect_to(new.host, new.port)
+        return redirecting
+
+    def setUp(self):
+        super(TestAuthOnRedirected, self).setUp()
+        self.build_tree_contents([('a','a'),
+                                  ('1/',),
+                                  ('1/a', 'redirected once'),
+                                  ],)
+        new_prefix = 'http://%s:%s' % (self.new_server.host,
+                                       self.new_server.port)
+        self.old_server.redirections = [
+            ('(.*)', r'%s/1\1' % (new_prefix), 301),]
+        self.old_transport = self._transport(self.old_server.get_url())
+        self.new_server.add_user('joe', 'foo')
+
+    def get_a(self, transport):
+        return transport.get('a')
+
+    def test_auth_on_redirected_via_do_catching_redirections(self):
+        self.redirections = 0
+
+        def redirected(transport, exception, redirection_notice):
+            self.redirections += 1
+            dir, file = urlutils.split(exception.target)
+            return self._transport(dir)
+
+        stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
+        ui.ui_factory = tests.TestUIFactory(stdin='joe\nfoo\n',
+                                            stdout=stdout, stderr=stderr)
+        self.assertEqual('redirected once',
+                         transport.do_catching_redirections(
+                self.get_a, self.old_transport, redirected).read())
+        self.assertEqual(1, self.redirections)
+        # stdin should be empty
+        self.assertEqual('', ui.ui_factory.stdin.readline())
+        # stdout should be empty, stderr will contains the prompts
+        self.assertEqual('', stdout.getvalue())
+
+    def test_auth_on_redirected_via_following_redirections(self):
+        self.new_server.add_user('joe', 'foo')
+        stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
+        ui.ui_factory = tests.TestUIFactory(stdin='joe\nfoo\n',
+                                            stdout=stdout, stderr=stderr)
+        t = self.old_transport
+        req = RedirectedRequest('GET', t.abspath('a'))
+        new_prefix = 'http://%s:%s' % (self.new_server.host,
+                                       self.new_server.port)
+        self.old_server.redirections = [
+            ('(.*)', r'%s/1\1' % (new_prefix), 301),]
+        self.assertEqual('redirected once',t._perform(req).read())
+        # stdin should be empty
+        self.assertEqual('', ui.ui_factory.stdin.readline())
+        # stdout should be empty, stderr will contains the prompts
+        self.assertEqual('', stdout.getvalue())
+
+

=== modified file 'bzrlib/tests/test_http_response.py'
--- bzrlib/tests/test_http_response.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_http_response.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -96,8 +96,7 @@
         # Override the thresold to force the warning emission
         conn._range_warning_thresold = 6 # There are 7 bytes pending
         conn.cleanup_pipe()
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              'Got a 200 response when asking')
+        self.assertContainsRe(self.get_log(), 'Got a 200 response when asking')
 
 
 class TestRangeFileMixin(object):

=== modified file 'bzrlib/tests/test_ignores.py'
--- bzrlib/tests/test_ignores.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_ignores.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -34,6 +34,8 @@
                 '\n' # empty line
                 '#comment\n'
                 ' xx \n' # whitespace
+                '!RE:^\.z.*\n'
+                '!!./.zcompdump\n'
                 ))
         self.assertEqual(set(['./rootdir',
                           'randomfile*',
@@ -41,6 +43,8 @@
                           u'unicode\xb5',
                           'dos',
                           ' xx ',
+                          '!RE:^\.z.*',
+                          '!!./.zcompdump',
                          ]), ignored)
 
     def test_parse_empty(self):

=== modified file 'bzrlib/tests/test_index.py'
--- bzrlib/tests/test_index.py	2009-10-19 15:45:10 +0000
+++ bzrlib/tests/test_index.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -235,7 +235,7 @@
         builder.add_node(('2-key', ), '', (references, ))
         stream = builder.finish()
         contents = stream.read()
-        self.assertEqual(
+        self.assertEqualDiff(
             "Bazaar Graph Index 1\nnode_ref_lists=1\nkey_elements=1\nlen=1\n"
             "0\x00a\x00\x00\n"
             "1\x00a\x00\x00\n"

=== modified file 'bzrlib/tests/test_info.py'
--- bzrlib/tests/test_info.py	2009-04-08 16:33:19 +0000
+++ bzrlib/tests/test_info.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -143,15 +143,11 @@
                 # We don't require that experimental formats support checkouts
                 # or describe correctly in the UI.
                 continue
+            if bzrdir.format_registry.get_info(key).hidden:
+                continue
             expected = None
-            if key in ('dirstate', 'dirstate-tags', 'dirstate-with-subtree',
-                'pack-0.92', 'pack-0.92-subtree', 'rich-root',
-                'rich-root-pack', '1.6', '1.6.1-rich-root',
-                '1.9', '1.9-rich-root'):
-                expected = '1.6 or 1.6.1-rich-root or ' \
-                    '1.9 or 1.9-rich-root or ' \
-                    'dirstate or dirstate-tags or pack-0.92 or'\
-                    ' rich-root or rich-root-pack'
+            if key in ('pack-0.92',):
+                expected = 'pack-0.92'
             elif key in ('knit', 'metaweave'):
                 expected = 'knit or metaweave'
             elif key in ('1.14', '1.14-rich-root'):
@@ -167,10 +163,10 @@
             expected = None
             if key in ('dirstate', 'knit'):
                 expected = 'dirstate or knit'
-            elif key in ('1.9', '1.14'):
-                expected = '1.14 or 1.9'
-            elif key in ('1.9-rich-root', '1.14-rich-root'):
-                expected = '1.14-rich-root or 1.9-rich-root'
+            elif key in ('1.14',):
+                expected = '1.14'
+            elif key in ('1.14-rich-root',):
+                expected = '1.14-rich-root'
             self.assertBranchDescription(key, expected)
 
     def test_describe_repo_format(self):
@@ -182,10 +178,10 @@
             expected = None
             if key in ('dirstate', 'knit', 'dirstate-tags'):
                 expected = 'dirstate or dirstate-tags or knit'
-            elif key in ('1.9', '1.14'):
-                expected = '1.14 or 1.9'
-            elif key in ('1.9-rich-root', '1.14-rich-root'):
-                expected = '1.14-rich-root or 1.9-rich-root'
+            elif key in ('1.14',):
+                expected = '1.14'
+            elif key in ('1.14-rich-root',):
+                expected = '1.14-rich-root'
             self.assertRepoDescription(key, expected)
 
         format = bzrdir.format_registry.make_bzrdir('metaweave')

=== modified file 'bzrlib/tests/test_knit.py'
--- bzrlib/tests/test_knit.py	2009-08-28 04:13:16 +0000
+++ bzrlib/tests/test_knit.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,6 +28,7 @@
     multiparent,
     osutils,
     pack,
+    tests,
     )
 from bzrlib.errors import (
     RevisionAlreadyPresent,
@@ -69,19 +70,8 @@
     )
 
 
-class _CompiledKnitFeature(Feature):
-
-    def _probe(self):
-        try:
-            import bzrlib._knit_load_data_pyx
-        except ImportError:
-            return False
-        return True
-
-    def feature_name(self):
-        return 'bzrlib._knit_load_data_pyx'
-
-CompiledKnitFeature = _CompiledKnitFeature()
+compiled_knit_feature = tests.ModuleAvailableFeature(
+                            'bzrlib._knit_load_data_pyx')
 
 
 class KnitContentTestsMixin(object):
@@ -1308,7 +1298,7 @@
 
 class LowLevelKnitIndexTests_c(LowLevelKnitIndexTests):
 
-    _test_needs_features = [CompiledKnitFeature]
+    _test_needs_features = [compiled_knit_feature]
 
     def get_knit_index(self, transport, name, mode):
         mapper = ConstantMapper(name)

=== modified file 'bzrlib/tests/test_lockable_files.py'
--- bzrlib/tests/test_lockable_files.py	2009-07-27 05:38:00 +0000
+++ bzrlib/tests/test_lockable_files.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -285,8 +285,8 @@
         self.lockable = self.get_lockable()
         self.lockable.create_lock()
 
-    def tearDown(self):
-        super(TestLockableFiles_TransportLock, self).tearDown()
+    def stop_server(self):
+        super(TestLockableFiles_TransportLock, self).stop_server()
         # free the subtransport so that we do not get a 5 second
         # timeout due to the SFTP connection cache.
         try:

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2009-06-23 08:43:05 +0000
+++ bzrlib/tests/test_lockdir.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -197,9 +197,8 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'you press Ctrl-C.\n'
+                         'See "bzr help break-lock" for more.',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -420,9 +419,8 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'you press Ctrl-C.\n'
+                         'See "bzr help break-lock" for more.',
                          self._logged_reports[0][0])
         args = self._logged_reports[0][1]
         self.assertEqual('Unable to obtain', args[0])
@@ -435,9 +433,8 @@
         self.assertEqual('%s %s\n'
                          '%s\n%s\n'
                          'Will continue to try until %s, unless '
-                         'you press Ctrl-C\n'
-                         'If you\'re sure that it\'s not being '
-                         'modified, use bzr break-lock %s',
+                         'you press Ctrl-C.\n'
+                         'See "bzr help break-lock" for more.',
                          self._logged_reports[1][0])
         args = self._logged_reports[1][1]
         self.assertEqual('Lock owner changed for', args[0])

=== modified file 'bzrlib/tests/test_log.py'
--- bzrlib/tests/test_log.py	2009-08-19 01:44:41 +0000
+++ bzrlib/tests/test_log.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,10 +27,10 @@
     )
 
 
-class TestCaseWithoutPropsHandler(tests.TestCaseWithTransport):
+class TestCaseForLogFormatter(tests.TestCaseWithTransport):
 
     def setUp(self):
-        super(TestCaseWithoutPropsHandler, self).setUp()
+        super(TestCaseForLogFormatter, self).setUp()
         # keep a reference to the "current" custom prop. handler registry
         self.properties_handler_registry = log.properties_handler_registry
         # Use a clean registry for log
@@ -40,6 +40,65 @@
             log.properties_handler_registry = self.properties_handler_registry
         self.addCleanup(restore)
 
+    def assertFormatterResult(self, result, branch, formatter_class,
+                              formatter_kwargs=None, show_log_kwargs=None,
+                              normalize=False):
+        logfile = self.make_utf8_encoded_stringio()
+        if formatter_kwargs is None:
+            formatter_kwargs = {}
+        formatter = formatter_class(to_file=logfile, **formatter_kwargs)
+        if show_log_kwargs is None:
+            show_log_kwargs = {}
+        log.show_log(branch, formatter, **show_log_kwargs)
+        log_content = logfile.getvalue()
+        if normalize:
+            log_content = normalize_log(log_content)
+        self.assertEqualDiff(result, log_content)
+
+    def make_standard_commit(self, branch_nick, **kwargs):
+        wt = self.make_branch_and_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        self.build_tree(['a'])
+        wt.add(['a'])
+        wt.branch.nick = branch_nick
+        kwargs = dict(kwargs)
+        kwargs.setdefault('message', 'add a')
+        kwargs.setdefault('timestamp', 1132711707)
+        kwargs.setdefault('timezone', 36000)
+        kwargs.setdefault('committer', 'Lorem Ipsum <test@example.com>')
+        kwargs.setdefault('authors', ['John Doe <jdoe@example.com>'])
+        wt.commit(**kwargs)
+        return wt
+
+    def _prepare_tree_with_merges(self, with_tags=False):
+        wt = self.make_branch_and_memory_tree('.')
+        wt.lock_write()
+        self.addCleanup(wt.unlock)
+        wt.add('')
+        wt.commit('rev-1', rev_id='rev-1',
+                  timestamp=1132586655, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.commit('rev-merged', rev_id='rev-2a',
+                  timestamp=1132586700, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        wt.set_parent_ids(['rev-1', 'rev-2a'])
+        wt.branch.set_last_revision_info(1, 'rev-1')
+        wt.commit('rev-2', rev_id='rev-2b',
+                  timestamp=1132586800, timezone=36000,
+                  committer='Joe Foo <joe@foo.com>')
+        if with_tags:
+            branch = wt.branch
+            branch.tags.set_tag('v0.2', 'rev-2b')
+            wt.commit('rev-3', rev_id='rev-3',
+                      timestamp=1132586900, timezone=36000,
+                      committer='Jane Foo <jane@foo.com>')
+            branch.tags.set_tag('v1.0rc1', 'rev-3')
+            branch.tags.set_tag('v1.0', 'rev-3')
+        return wt
+
+        
+
 
 class LogCatcher(log.LogFormatter):
     """Pull log messages into a list rather than displaying them.
@@ -242,15 +301,12 @@
     return ''.join(lines)
 
 
-class TestShortLogFormatter(tests.TestCaseWithTransport):
+class TestShortLogFormatter(TestCaseForLogFormatter):
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
         b = make_commits_with_trailing_newlines(wt)
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.ShortLogFormatter(to_file=sio)
-        log.show_log(b, lf)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     3 Joe Foo\t2005-11-21
       single line with trailing newline
 
@@ -263,40 +319,11 @@
       simple log message
 
 """,
-                             sio.getvalue())
-
-    def _prepare_tree_with_merges(self, with_tags=False):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        if with_tags:
-            branch = wt.branch
-            branch.tags.set_tag('v0.2', 'rev-2b')
-            wt.commit('rev-3', rev_id='rev-3',
-                      timestamp=1132586900, timezone=36000,
-                      committer='Jane Foo <jane@foo.com>')
-            branch.tags.set_tag('v1.0rc1', 'rev-3')
-            branch.tags.set_tag('v1.0', 'rev-3')
-        return wt
+            b, log.ShortLogFormatter)
 
     def test_short_log_with_merges(self):
         wt = self._prepare_tree_with_merges()
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile)
-        log.show_log(wt.branch, formatter)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     2 Joe Foo\t2005-11-22 [merge]
       rev-2
 
@@ -304,15 +331,11 @@
       rev-1
 
 """,
-                             logfile.getvalue())
+            wt.branch, log.ShortLogFormatter)
 
     def test_short_log_with_merges_and_advice(self):
         wt = self._prepare_tree_with_merges()
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile,
-            show_advice=True)
-        log.show_log(wt.branch, formatter)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     2 Joe Foo\t2005-11-22 [merge]
       rev-2
 
@@ -321,7 +344,8 @@
 
 Use --include-merges or -n0 to see merged revisions.
 """,
-                             logfile.getvalue())
+            wt.branch, log.ShortLogFormatter,
+            formatter_kwargs=dict(show_advice=True))
 
     def test_short_log_with_merges_and_range(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -347,11 +371,7 @@
         wt.commit('rev-3b', rev_id='rev-3b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile)
-        log.show_log(wt.branch, formatter,
-            start_revision=2, end_revision=3)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     3 Joe Foo\t2005-11-22 [merge]
       rev-3b
 
@@ -359,14 +379,12 @@
       rev-2b
 
 """,
-                             logfile.getvalue())
+            wt.branch, log.ShortLogFormatter,
+            show_log_kwargs=dict(start_revision=2, end_revision=3))
 
     def test_short_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile)
-        log.show_log(wt.branch, formatter)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     3 Jane Foo\t2005-11-22 {v1.0, v1.0rc1}
       rev-3
 
@@ -377,7 +395,7 @@
       rev-1
 
 """,
-                             logfile.getvalue())
+            wt.branch, log.ShortLogFormatter)
 
     def test_short_log_single_merge_revision(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -395,21 +413,18 @@
         wt.commit('rev-2', rev_id='rev-2b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile)
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
-        wtb = wt.branch
-        rev = revspec.in_history(wtb)
-        log.show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-        self.assertEqualDiff("""\
+        rev = revspec.in_history(wt.branch)
+        self.assertFormatterResult("""\
       1.1.1 Joe Foo\t2005-11-22
             rev-merged
 
 """,
-                             logfile.getvalue())
-
-
-class TestShortLogFormatterWithMergeRevisions(tests.TestCaseWithTransport):
+            wt.branch, log.ShortLogFormatter,
+            show_log_kwargs=dict(start_revision=rev, end_revision=rev))
+
+
+class TestShortLogFormatterWithMergeRevisions(TestCaseForLogFormatter):
 
     def test_short_merge_revs_log_with_merges(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -427,13 +442,10 @@
         wt.commit('rev-2', rev_id='rev-2b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile, levels=0)
-        log.show_log(wt.branch, formatter)
         # Note that the 1.1.1 indenting is in fact correct given that
         # the revision numbers are right justified within 5 characters
         # for mainline revnos and 9 characters for dotted revnos.
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
     2 Joe Foo\t2005-11-22 [merge]
       rev-2
 
@@ -444,7 +456,8 @@
       rev-1
 
 """,
-                             logfile.getvalue())
+            wt.branch, log.ShortLogFormatter,
+            formatter_kwargs=dict(levels=0))
 
     def test_short_merge_revs_log_single_merge_revision(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -462,44 +475,27 @@
         wt.commit('rev-2', rev_id='rev-2b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.ShortLogFormatter(to_file=logfile, levels=0)
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
-        wtb = wt.branch
-        rev = revspec.in_history(wtb)
-        log.show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-        self.assertEqualDiff("""\
+        rev = revspec.in_history(wt.branch)
+        self.assertFormatterResult("""\
       1.1.1 Joe Foo\t2005-11-22
             rev-merged
 
 """,
-                             logfile.getvalue())
-
-
-class TestLongLogFormatter(TestCaseWithoutPropsHandler):
+            wt.branch, log.ShortLogFormatter,
+            formatter_kwargs=dict(levels=0),
+            show_log_kwargs=dict(start_revision=rev, end_revision=rev))
+
+
+class TestLongLogFormatter(TestCaseForLogFormatter):
 
     def test_verbose_log(self):
         """Verbose log includes changed files
 
         bug #4676
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        # XXX: why does a longer nick show up?
-        b.nick = 'test_verbose_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>')
-        logfile = file('out.tmp', 'w+')
-        formatter = log.LongLogFormatter(to_file=logfile)
-        log.show_log(b, formatter, verbose=True)
-        logfile.flush()
-        logfile.seek(0)
-        log_contents = logfile.read()
-        self.assertEqualDiff('''\
+        wt = self.make_standard_commit('test_verbose_log', authors=[])
+        self.assertFormatterResult('''\
 ------------------------------------------------------------
 revno: 1
 committer: Lorem Ipsum <test@example.com>
@@ -510,7 +506,8 @@
 added:
   a
 ''',
-                             log_contents)
+            wt.branch, log.LongLogFormatter,
+            show_log_kwargs=dict(verbose=True))
 
     def test_merges_are_indented_by_level(self):
         wt = self.make_branch_and_tree('parent')
@@ -526,12 +523,7 @@
         os.chdir('../parent')
         self.run_bzr('merge ../child')
         wt.commit('merge branch 1')
-        b = wt.branch
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LongLogFormatter(to_file=sio, levels=0)
-        log.show_log(b, lf, verbose=True)
-        the_log = normalize_log(sio.getvalue())
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
 committer: Lorem Ipsum <test@example.com>
@@ -568,7 +560,10 @@
 message:
   first post
 """,
-                             the_log)
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=0),
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_verbose_merge_revisions_contain_deltas(self):
         wt = self.make_branch_and_tree('parent')
@@ -583,12 +578,7 @@
         os.chdir('parent')
         self.run_bzr('merge ../child')
         wt.commit('merge branch 1')
-        b = wt.branch
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LongLogFormatter(to_file=sio, levels=0)
-        log.show_log(b, lf, verbose=True)
-        the_log = normalize_log(sio.getvalue())
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
 committer: Lorem Ipsum <test@example.com>
@@ -622,15 +612,15 @@
   f1
   f2
 """,
-                             the_log)
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=0),
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
         b = make_commits_with_trailing_newlines(wt)
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LongLogFormatter(to_file=sio)
-        log.show_log(b, lf)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
@@ -656,27 +646,16 @@
 message:
   simple log message
 """,
-                             sio.getvalue())
+        b, log.LongLogFormatter)
 
     def test_author_in_log(self):
         """Log includes the author name if it's set in
         the revision properties
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>',
-                           'Jane Rey <jrey@example.com>'])
-        sio = StringIO()
-        formatter = log.LongLogFormatter(to_file=sio)
-        log.show_log(b, formatter)
-        self.assertEqualDiff('''\
+        wt = self.make_standard_commit('test_author_log',
+            authors=['John Doe <jdoe@example.com>',
+                     'Jane Rey <jrey@example.com>'])
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 1
 author: John Doe <jdoe@example.com>, Jane Rey <jrey@example.com>
@@ -685,37 +664,22 @@
 timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
-''',
-                             sio.getvalue())
+""",
+        wt.branch, log.LongLogFormatter)
 
     def test_properties_in_log(self):
         """Log includes the custom properties returned by the registered
         handlers.
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_properties_in_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'])
-        sio = StringIO()
-        formatter = log.LongLogFormatter(to_file=sio)
-        try:
-            def trivial_custom_prop_handler(revision):
-                return {'test_prop':'test_value'}
+        wt = self.make_standard_commit('test_properties_in_log')
+        def trivial_custom_prop_handler(revision):
+            return {'test_prop':'test_value'}
 
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler',
-                trivial_custom_prop_handler)
-            log.show_log(b, formatter)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
-            self.assertEqualDiff('''\
+        # Cleaned up in setUp()
+        log.properties_handler_registry.register(
+            'trivial_custom_prop_handler',
+            trivial_custom_prop_handler)
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 1
 test_prop: test_value
@@ -725,162 +689,100 @@
 timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
-''',
-                                 sio.getvalue())
+""",
+            wt.branch, log.LongLogFormatter)
 
     def test_properties_in_short_log(self):
         """Log includes the custom properties returned by the registered
         handlers.
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_properties_in_short_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'])
-        sio = StringIO()
-        formatter = log.ShortLogFormatter(to_file=sio)
-        try:
-            def trivial_custom_prop_handler(revision):
-                return {'test_prop':'test_value'}
+        wt = self.make_standard_commit('test_properties_in_short_log')
+        def trivial_custom_prop_handler(revision):
+            return {'test_prop':'test_value'}
 
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler',
-                trivial_custom_prop_handler)
-            log.show_log(b, formatter)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
-            self.assertEqualDiff('''\
+        log.properties_handler_registry.register(
+            'trivial_custom_prop_handler',
+            trivial_custom_prop_handler)
+        self.assertFormatterResult("""\
     1 John Doe\t2005-11-23
       test_prop: test_value
       add a
 
-''',
-                                 sio.getvalue())
+""",
+            wt.branch, log.ShortLogFormatter)
 
     def test_error_in_properties_handler(self):
         """Log includes the custom properties returned by the registered
         handlers.
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'],
-                  revprops={'first_prop':'first_value'})
-        sio = StringIO()
+        wt = self.make_standard_commit('error_in_properties_handler',
+            revprops={'first_prop':'first_value'})
+        sio = self.make_utf8_encoded_stringio()
         formatter = log.LongLogFormatter(to_file=sio)
-        try:
-            def trivial_custom_prop_handler(revision):
-                raise StandardError("a test error")
+        def trivial_custom_prop_handler(revision):
+            raise StandardError("a test error")
 
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler',
-                trivial_custom_prop_handler)
-            self.assertRaises(StandardError, log.show_log, b, formatter,)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
+        log.properties_handler_registry.register(
+            'trivial_custom_prop_handler',
+            trivial_custom_prop_handler)
+        self.assertRaises(StandardError, log.show_log, wt.branch, formatter,)
 
     def test_properties_handler_bad_argument(self):
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'],
-                  revprops={'a_prop':'test_value'})
-        sio = StringIO()
+        wt = self.make_standard_commit('bad_argument',
+              revprops={'a_prop':'test_value'})
+        sio = self.make_utf8_encoded_stringio()
         formatter = log.LongLogFormatter(to_file=sio)
-        try:
-            def bad_argument_prop_handler(revision):
-                return {'custom_prop_name':revision.properties['a_prop']}
-
-            log.properties_handler_registry.register(
-                'bad_argument_prop_handler',
-                bad_argument_prop_handler)
-
-            self.assertRaises(AttributeError, formatter.show_properties,
-                              'a revision', '')
-
-            revision = b.repository.get_revision(b.last_revision())
-            formatter.show_properties(revision, '')
-            self.assertEqualDiff('''custom_prop_name: test_value\n''',
-                                 sio.getvalue())
-        finally:
-            log.properties_handler_registry.remove(
-                'bad_argument_prop_handler')
-
-
-class TestLongLogFormatterWithoutMergeRevisions(TestCaseWithoutPropsHandler):
+        def bad_argument_prop_handler(revision):
+            return {'custom_prop_name':revision.properties['a_prop']}
+
+        log.properties_handler_registry.register(
+            'bad_argument_prop_handler',
+            bad_argument_prop_handler)
+
+        self.assertRaises(AttributeError, formatter.show_properties,
+                          'a revision', '')
+
+        revision = wt.branch.repository.get_revision(wt.branch.last_revision())
+        formatter.show_properties(revision, '')
+        self.assertEqualDiff('''custom_prop_name: test_value\n''',
+                             sio.getvalue())
+
+
+class TestLongLogFormatterWithoutMergeRevisions(TestCaseForLogFormatter):
 
     def test_long_verbose_log(self):
         """Verbose log includes changed files
 
         bug #4676
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        # XXX: why does a longer nick show up?
-        b.nick = 'test_verbose_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>')
-        logfile = file('out.tmp', 'w+')
-        formatter = log.LongLogFormatter(to_file=logfile, levels=1)
-        log.show_log(b, formatter, verbose=True)
-        logfile.flush()
-        logfile.seek(0)
-        log_contents = logfile.read()
-        self.assertEqualDiff('''\
+        wt = self.make_standard_commit('test_long_verbose_log', authors=[])
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 1
 committer: Lorem Ipsum <test@example.com>
-branch nick: test_verbose_log
+branch nick: test_long_verbose_log
 timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
 added:
   a
-''',
-                             log_contents)
+""",
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=1),
+            show_log_kwargs=dict(verbose=True))
 
     def test_long_verbose_contain_deltas(self):
         wt = self.make_branch_and_tree('parent')
         self.build_tree(['parent/f1', 'parent/f2'])
         wt.add(['f1','f2'])
         wt.commit('first post')
-        self.run_bzr('branch parent child')
+        child_wt = wt.bzrdir.sprout('child').open_workingtree()
         os.unlink('child/f1')
-        file('child/f2', 'wb').write('hello\n')
-        self.run_bzr(['commit', '-m', 'removed f1 and modified f2',
-            'child'])
-        os.chdir('parent')
-        self.run_bzr('merge ../child')
+        self.build_tree_contents([('child/f2', 'hello\n')])
+        child_wt.commit('removed f1 and modified f2')
+        wt.merge_from_branch(child_wt.branch)
         wt.commit('merge branch 1')
-        b = wt.branch
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LongLogFormatter(to_file=sio, levels=1)
-        log.show_log(b, lf, verbose=True)
-        the_log = normalize_log(sio.getvalue())
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 2 [merge]
 committer: Lorem Ipsum <test@example.com>
@@ -903,15 +805,15 @@
   f1
   f2
 """,
-                             the_log)
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=1),
+            show_log_kwargs=dict(verbose=True),
+            normalize=True)
 
     def test_long_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
         b = make_commits_with_trailing_newlines(wt)
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LongLogFormatter(to_file=sio, levels=1)
-        log.show_log(b, lf)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 3
 committer: Joe Foo <joe@foo.com>
@@ -937,26 +839,15 @@
 message:
   simple log message
 """,
-                             sio.getvalue())
+        b, log.LongLogFormatter,
+        formatter_kwargs=dict(levels=1))
 
     def test_long_author_in_log(self):
         """Log includes the author name if it's set in
         the revision properties
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_author_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'])
-        sio = StringIO()
-        formatter = log.LongLogFormatter(to_file=sio, levels=1)
-        log.show_log(b, formatter)
-        self.assertEqualDiff('''\
+        wt = self.make_standard_commit('test_author_log')
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 1
 author: John Doe <jdoe@example.com>
@@ -965,37 +856,22 @@
 timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
-''',
-                             sio.getvalue())
+""",
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=1))
 
     def test_long_properties_in_log(self):
         """Log includes the custom properties returned by the registered
         handlers.
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test_properties_in_log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Lorem Ipsum <test@example.com>',
-                  authors=['John Doe <jdoe@example.com>'])
-        sio = StringIO()
-        formatter = log.LongLogFormatter(to_file=sio, levels=1)
-        try:
-            def trivial_custom_prop_handler(revision):
-                return {'test_prop':'test_value'}
+        wt = self.make_standard_commit('test_properties_in_log')
+        def trivial_custom_prop_handler(revision):
+            return {'test_prop':'test_value'}
 
-            log.properties_handler_registry.register(
-                'trivial_custom_prop_handler',
-                trivial_custom_prop_handler)
-            log.show_log(b, formatter)
-        finally:
-            log.properties_handler_registry.remove(
-                'trivial_custom_prop_handler')
-            self.assertEqualDiff('''\
+        log.properties_handler_registry.register(
+            'trivial_custom_prop_handler',
+            trivial_custom_prop_handler)
+        self.assertFormatterResult("""\
 ------------------------------------------------------------
 revno: 1
 test_prop: test_value
@@ -1005,123 +881,70 @@
 timestamp: Wed 2005-11-23 12:08:27 +1000
 message:
   add a
-''',
-                                 sio.getvalue())
-
-
-class TestLineLogFormatter(tests.TestCaseWithTransport):
+""",
+            wt.branch, log.LongLogFormatter,
+            formatter_kwargs=dict(levels=1))
+
+
+class TestLineLogFormatter(TestCaseForLogFormatter):
 
     def test_line_log(self):
         """Line log should show revno
 
         bug #5162
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test-line-log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Line-Log-Formatter Tester <test@line.log>')
-        logfile = file('out.tmp', 'w+')
-        formatter = log.LineLogFormatter(to_file=logfile)
-        log.show_log(b, formatter)
-        logfile.flush()
-        logfile.seek(0)
-        log_contents = logfile.read()
-        self.assertEqualDiff('1: Line-Log-Formatte... 2005-11-23 add a\n',
-                             log_contents)
+        wt = self.make_standard_commit('test-line-log',
+                committer='Line-Log-Formatter Tester <test@line.log>',
+                authors=[])
+        self.assertFormatterResult("""\
+1: Line-Log-Formatte... 2005-11-23 add a
+""",
+            wt.branch, log.LineLogFormatter)
 
     def test_trailing_newlines(self):
         wt = self.make_branch_and_tree('.')
         b = make_commits_with_trailing_newlines(wt)
-        sio = self.make_utf8_encoded_stringio()
-        lf = log.LineLogFormatter(to_file=sio)
-        log.show_log(b, lf)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 3: Joe Foo 2005-11-21 single line with trailing newline
 2: Joe Bar 2005-11-21 multiline
 1: Joe Foo 2005-11-21 simple log message
 """,
-                             sio.getvalue())
-
-    def _prepare_tree_with_merges(self, with_tags=False):
-        wt = self.make_branch_and_memory_tree('.')
-        wt.lock_write()
-        self.addCleanup(wt.unlock)
-        wt.add('')
-        wt.commit('rev-1', rev_id='rev-1',
-                  timestamp=1132586655, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.commit('rev-merged', rev_id='rev-2a',
-                  timestamp=1132586700, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        wt.set_parent_ids(['rev-1', 'rev-2a'])
-        wt.branch.set_last_revision_info(1, 'rev-1')
-        wt.commit('rev-2', rev_id='rev-2b',
-                  timestamp=1132586800, timezone=36000,
-                  committer='Joe Foo <joe@foo.com>')
-        if with_tags:
-            branch = wt.branch
-            branch.tags.set_tag('v0.2', 'rev-2b')
-            wt.commit('rev-3', rev_id='rev-3',
-                      timestamp=1132586900, timezone=36000,
-                      committer='Jane Foo <jane@foo.com>')
-            branch.tags.set_tag('v1.0rc1', 'rev-3')
-            branch.tags.set_tag('v1.0', 'rev-3')
-        return wt
+            b, log.LineLogFormatter)
 
     def test_line_log_single_merge_revision(self):
         wt = self._prepare_tree_with_merges()
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.LineLogFormatter(to_file=logfile)
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
-        wtb = wt.branch
-        rev = revspec.in_history(wtb)
-        log.show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-        self.assertEqualDiff("""\
+        rev = revspec.in_history(wt.branch)
+        self.assertFormatterResult("""\
 1.1.1: Joe Foo 2005-11-22 rev-merged
 """,
-                             logfile.getvalue())
+            wt.branch, log.LineLogFormatter,
+            show_log_kwargs=dict(start_revision=rev, end_revision=rev))
 
     def test_line_log_with_tags(self):
         wt = self._prepare_tree_with_merges(with_tags=True)
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.LineLogFormatter(to_file=logfile)
-        log.show_log(wt.branch, formatter)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 3: Jane Foo 2005-11-22 {v1.0, v1.0rc1} rev-3
 2: Joe Foo 2005-11-22 [merge] {v0.2} rev-2
 1: Joe Foo 2005-11-22 rev-1
 """,
-                             logfile.getvalue())
-
-class TestLineLogFormatterWithMergeRevisions(tests.TestCaseWithTransport):
+            wt.branch, log.LineLogFormatter)
+
+
+class TestLineLogFormatterWithMergeRevisions(TestCaseForLogFormatter):
 
     def test_line_merge_revs_log(self):
         """Line log should show revno
 
         bug #5162
         """
-        wt = self.make_branch_and_tree('.')
-        b = wt.branch
-        self.build_tree(['a'])
-        wt.add('a')
-        b.nick = 'test-line-log'
-        wt.commit(message='add a',
-                  timestamp=1132711707,
-                  timezone=36000,
-                  committer='Line-Log-Formatter Tester <test@line.log>')
-        logfile = file('out.tmp', 'w+')
-        formatter = log.LineLogFormatter(to_file=logfile, levels=0)
-        log.show_log(b, formatter)
-        logfile.flush()
-        logfile.seek(0)
-        log_contents = logfile.read()
-        self.assertEqualDiff('1: Line-Log-Formatte... 2005-11-23 add a\n',
-                             log_contents)
+        wt = self.make_standard_commit('test-line-log',
+                committer='Line-Log-Formatter Tester <test@line.log>',
+                authors=[])
+        self.assertFormatterResult("""\
+1: Line-Log-Formatte... 2005-11-23 add a
+""",
+            wt.branch, log.LineLogFormatter)
 
     def test_line_merge_revs_log_single_merge_revision(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -1139,16 +962,14 @@
         wt.commit('rev-2', rev_id='rev-2b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.LineLogFormatter(to_file=logfile, levels=0)
         revspec = revisionspec.RevisionSpec.from_string('1.1.1')
-        wtb = wt.branch
-        rev = revspec.in_history(wtb)
-        log.show_log(wtb, formatter, start_revision=rev, end_revision=rev)
-        self.assertEqualDiff("""\
+        rev = revspec.in_history(wt.branch)
+        self.assertFormatterResult("""\
 1.1.1: Joe Foo 2005-11-22 rev-merged
 """,
-                             logfile.getvalue())
+            wt.branch, log.LineLogFormatter,
+            formatter_kwargs=dict(levels=0),
+            show_log_kwargs=dict(start_revision=rev, end_revision=rev))
 
     def test_line_merge_revs_log_with_merges(self):
         wt = self.make_branch_and_memory_tree('.')
@@ -1166,15 +987,14 @@
         wt.commit('rev-2', rev_id='rev-2b',
                   timestamp=1132586800, timezone=36000,
                   committer='Joe Foo <joe@foo.com>')
-        logfile = self.make_utf8_encoded_stringio()
-        formatter = log.LineLogFormatter(to_file=logfile, levels=0)
-        log.show_log(wt.branch, formatter)
-        self.assertEqualDiff("""\
+        self.assertFormatterResult("""\
 2: Joe Foo 2005-11-22 [merge] rev-2
   1.1.1: Joe Foo 2005-11-22 rev-merged
 1: Joe Foo 2005-11-22 rev-1
 """,
-                             logfile.getvalue())
+            wt.branch, log.LineLogFormatter,
+            formatter_kwargs=dict(levels=0))
+
 
 class TestGetViewRevisions(tests.TestCaseWithTransport):
 
@@ -1707,3 +1527,90 @@
         log.show_branch_change(tree.branch, s, 3, '3b')
         self.assertContainsRe(s.getvalue(), 'Removed Revisions:')
         self.assertNotContainsRe(s.getvalue(), 'Added Revisions:')
+
+
+
+class TestLogWithBugs(TestCaseForLogFormatter):
+
+    def setUp(self):
+        TestCaseForLogFormatter.setUp(self)
+        log.properties_handler_registry.register(
+            'bugs_properties_handler',
+            log._bugs_properties_handler)
+
+    def make_commits_with_bugs(self):
+        """Helper method for LogFormatter tests"""
+        tree = self.make_branch_and_tree(u'.')
+        self.build_tree(['a', 'b'])
+        tree.add('a')
+        tree.commit('simple log message', rev_id='a1',
+                    timestamp=1132586655.459960938, timezone=-6*3600,
+                    committer='Joe Foo <joe@foo.com>',
+                    revprops={'bugs': 'test://bug/id fixed'})
+        tree.add('b')
+        tree.commit('multiline\nlog\nmessage\n', rev_id='a2',
+                    timestamp=1132586842.411175966, timezone=-6*3600,
+                    committer='Joe Foo <joe@foo.com>',
+                    authors=['Joe Bar <joe@bar.com>'],
+                    revprops={'bugs': 'test://bug/id fixed\n'
+                                      'test://bug/2 fixed'})
+        return tree
+
+
+    def test_long_bugs(self):
+        tree = self.make_commits_with_bugs()
+        self.assertFormatterResult("""\
+------------------------------------------------------------
+revno: 2
+fixes bug(s): test://bug/id test://bug/2
+author: Joe Bar <joe@bar.com>
+committer: Joe Foo <joe@foo.com>
+branch nick: work
+timestamp: Mon 2005-11-21 09:27:22 -0600
+message:
+  multiline
+  log
+  message
+------------------------------------------------------------
+revno: 1
+fixes bug(s): test://bug/id
+committer: Joe Foo <joe@foo.com>
+branch nick: work
+timestamp: Mon 2005-11-21 09:24:15 -0600
+message:
+  simple log message
+""",
+            tree.branch, log.LongLogFormatter)
+
+    def test_short_bugs(self):
+        tree = self.make_commits_with_bugs()
+        self.assertFormatterResult("""\
+    2 Joe Bar\t2005-11-21
+      fixes bug(s): test://bug/id test://bug/2
+      multiline
+      log
+      message
+
+    1 Joe Foo\t2005-11-21
+      fixes bug(s): test://bug/id
+      simple log message
+
+""",
+            tree.branch, log.ShortLogFormatter)
+
+    def test_wrong_bugs_property(self):
+        tree = self.make_branch_and_tree(u'.')
+        self.build_tree(['foo'])
+        tree.commit('simple log message', rev_id='a1',
+              timestamp=1132586655.459960938, timezone=-6*3600,
+              committer='Joe Foo <joe@foo.com>',
+              revprops={'bugs': 'test://bug/id invalid_value'})
+        self.assertFormatterResult("""\
+    1 Joe Foo\t2005-11-21
+      simple log message
+
+""",
+            tree.branch, log.ShortLogFormatter)
+
+    def test_bugs_handler_present(self):
+        self.properties_handler_registry.get('bugs_properties_handler')

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2009-09-19 00:32:14 +0000
+++ bzrlib/tests/test_merge.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -29,14 +29,17 @@
     transform,
     versionedfile,
     )
-from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList, TextConflict
-from bzrlib.errors import UnrelatedBranches, NoCommits, BzrCommandError
+from bzrlib.errors import UnrelatedBranches, NoCommits
 from bzrlib.merge import transform_tree, merge_inner, _PlanMerge
 from bzrlib.osutils import pathjoin, file_kind
-from bzrlib.tests import TestCaseWithTransport, TestCaseWithMemoryTransport
+from bzrlib.tests import (
+    TestCaseWithMemoryTransport,
+    TestCaseWithTransport,
+    test_merge_core,
+    )
 from bzrlib.workingtree import WorkingTree
-from bzrlib.transform import TreeTransform
+
 
 class TestMerge(TestCaseWithTransport):
     """Test appending more than one revision"""
@@ -151,13 +154,12 @@
         log = StringIO()
         merge_inner(tree_b.branch, tree_a, tree_b.basis_tree(),
                     this_tree=tree_b, ignore_zero=True)
-        log = self._get_log(keep_log_file=True)
-        self.failUnless('All changes applied successfully.\n' not in log)
+        self.failUnless('All changes applied successfully.\n' not in
+            self.get_log())
         tree_b.revert()
         merge_inner(tree_b.branch, tree_a, tree_b.basis_tree(),
                     this_tree=tree_b, ignore_zero=False)
-        log = self._get_log(keep_log_file=True)
-        self.failUnless('All changes applied successfully.\n' in log)
+        self.failUnless('All changes applied successfully.\n' in self.get_log())
 
     def test_merge_inner_conflicts(self):
         tree_a = self.make_branch_and_tree('a')
@@ -524,6 +526,12 @@
         self.add_uncommitted_version(('root', 'C:'), [('root', 'A')], 'fabg')
         return _PlanMerge('B:', 'C:', self.plan_merge_vf, ('root',))
 
+    def test_base_from_plan(self):
+        self.setup_plan_merge()
+        plan = self.plan_merge_vf.plan_merge('B', 'C')
+        pwm = versionedfile.PlanWeaveMerge(plan)
+        self.assertEqual(['a\n', 'b\n', 'c\n'], pwm.base_from_plan())
+
     def test_unique_lines(self):
         plan = self.setup_plan_merge()
         self.assertEqual(plan._unique_lines(
@@ -827,6 +835,111 @@
                           ('unchanged', 'f\n'),
                           ('unchanged', 'g\n')],
                          list(plan))
+        plan = self.plan_merge_vf.plan_lca_merge('F', 'G')
+        # This is one of the main differences between plan_merge and
+        # plan_lca_merge. plan_lca_merge generates a conflict for 'x => z',
+        # because 'x' was not present in one of the bases. However, in this
+        # case it is spurious because 'x' does not exist in the global base A.
+        self.assertEqual([
+                          ('unchanged', 'h\n'),
+                          ('unchanged', 'a\n'),
+                          ('conflicted-a', 'x\n'),
+                          ('new-b', 'z\n'),
+                          ('unchanged', 'c\n'),
+                          ('unchanged', 'd\n'),
+                          ('unchanged', 'y\n'),
+                          ('unchanged', 'f\n'),
+                          ('unchanged', 'g\n')],
+                         list(plan))
+
+    def test_criss_cross_flip_flop(self):
+        # This is specificly trying to trigger problems when using limited
+        # ancestry and weaves. The ancestry graph looks like:
+        #       XX      unused ancestor, should not show up in the weave
+        #       |
+        #       A       Unique LCA
+        #      / \  
+        #     B   C     B & C both introduce a new line
+        #     |\ /|  
+        #     | X |  
+        #     |/ \| 
+        #     D   E     B & C are both merged, so both are common ancestors
+        #               In the process of merging, both sides order the new
+        #               lines differently
+        #
+        self.add_rev('root', 'XX', [], 'qrs')
+        self.add_rev('root', 'A', ['XX'], 'abcdef')
+        self.add_rev('root', 'B', ['A'], 'abcdgef')
+        self.add_rev('root', 'C', ['A'], 'abcdhef')
+        self.add_rev('root', 'D', ['B', 'C'], 'abcdghef')
+        self.add_rev('root', 'E', ['C', 'B'], 'abcdhgef')
+        plan = list(self.plan_merge_vf.plan_merge('D', 'E'))
+        self.assertEqual([
+                          ('unchanged', 'a\n'),
+                          ('unchanged', 'b\n'),
+                          ('unchanged', 'c\n'),
+                          ('unchanged', 'd\n'),
+                          ('new-b', 'h\n'),
+                          ('unchanged', 'g\n'),
+                          ('killed-b', 'h\n'),
+                          ('unchanged', 'e\n'),
+                          ('unchanged', 'f\n'),
+                         ], plan)
+        pwm = versionedfile.PlanWeaveMerge(plan)
+        self.assertEqualDiff('\n'.join('abcdghef') + '\n',
+                             ''.join(pwm.base_from_plan()))
+        # Reversing the order reverses the merge plan, and final order of 'hg'
+        # => 'gh'
+        plan = list(self.plan_merge_vf.plan_merge('E', 'D'))
+        self.assertEqual([
+                          ('unchanged', 'a\n'),
+                          ('unchanged', 'b\n'),
+                          ('unchanged', 'c\n'),
+                          ('unchanged', 'd\n'),
+                          ('new-b', 'g\n'),
+                          ('unchanged', 'h\n'),
+                          ('killed-b', 'g\n'),
+                          ('unchanged', 'e\n'),
+                          ('unchanged', 'f\n'),
+                         ], plan)
+        pwm = versionedfile.PlanWeaveMerge(plan)
+        self.assertEqualDiff('\n'.join('abcdhgef') + '\n',
+                             ''.join(pwm.base_from_plan()))
+        # This is where lca differs, in that it (fairly correctly) determines
+        # that there is a conflict because both sides resolved the merge
+        # differently
+        plan = list(self.plan_merge_vf.plan_lca_merge('D', 'E'))
+        self.assertEqual([
+                          ('unchanged', 'a\n'),
+                          ('unchanged', 'b\n'),
+                          ('unchanged', 'c\n'),
+                          ('unchanged', 'd\n'),
+                          ('conflicted-b', 'h\n'),
+                          ('unchanged', 'g\n'),
+                          ('conflicted-a', 'h\n'),
+                          ('unchanged', 'e\n'),
+                          ('unchanged', 'f\n'),
+                         ], plan)
+        pwm = versionedfile.PlanWeaveMerge(plan)
+        self.assertEqualDiff('\n'.join('abcdgef') + '\n',
+                             ''.join(pwm.base_from_plan()))
+        # Reversing it changes what line is doubled, but still gives a
+        # double-conflict
+        plan = list(self.plan_merge_vf.plan_lca_merge('E', 'D'))
+        self.assertEqual([
+                          ('unchanged', 'a\n'),
+                          ('unchanged', 'b\n'),
+                          ('unchanged', 'c\n'),
+                          ('unchanged', 'd\n'),
+                          ('conflicted-b', 'g\n'),
+                          ('unchanged', 'h\n'),
+                          ('conflicted-a', 'g\n'),
+                          ('unchanged', 'e\n'),
+                          ('unchanged', 'f\n'),
+                         ], plan)
+        pwm = versionedfile.PlanWeaveMerge(plan)
+        self.assertEqualDiff('\n'.join('abcdhef') + '\n',
+                             ''.join(pwm.base_from_plan()))
 
     def assertRemoveExternalReferences(self, filtered_parent_map,
                                        child_map, tails, parent_map):
@@ -1032,158 +1145,6 @@
                          ], list(plan))
 
 
-class TestMergeImplementation(object):
-
-    def do_merge(self, target_tree, source_tree, **kwargs):
-        merger = _mod_merge.Merger.from_revision_ids(progress.DummyProgress(),
-            target_tree, source_tree.last_revision(),
-            other_branch=source_tree.branch)
-        merger.merge_type=self.merge_type
-        for name, value in kwargs.items():
-            setattr(merger, name, value)
-        merger.do_merge()
-
-    def test_merge_specific_file(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        self.build_tree_contents([
-            ('this/file1', 'a\nb\n'),
-            ('this/file2', 'a\nb\n')
-        ])
-        this_tree.add(['file1', 'file2'])
-        this_tree.commit('Added files')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([
-            ('other/file1', 'a\nb\nc\n'),
-            ('other/file2', 'a\nb\nc\n')
-        ])
-        other_tree.commit('modified both')
-        self.build_tree_contents([
-            ('this/file1', 'd\na\nb\n'),
-            ('this/file2', 'd\na\nb\n')
-        ])
-        this_tree.commit('modified both')
-        self.do_merge(this_tree, other_tree, interesting_files=['file1'])
-        self.assertFileEqual('d\na\nb\nc\n', 'this/file1')
-        self.assertFileEqual('d\na\nb\n', 'this/file2')
-
-    def test_merge_move_and_change(self):
-        this_tree = self.make_branch_and_tree('this')
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        self.build_tree_contents([
-            ('this/file1', 'line 1\nline 2\nline 3\nline 4\n'),
-        ])
-        this_tree.add('file1',)
-        this_tree.commit('Added file')
-        other_tree = this_tree.bzrdir.sprout('other').open_workingtree()
-        self.build_tree_contents([
-            ('other/file1', 'line 1\nline 2 to 2.1\nline 3\nline 4\n'),
-        ])
-        other_tree.commit('Changed 2 to 2.1')
-        self.build_tree_contents([
-            ('this/file1', 'line 1\nline 3\nline 2\nline 4\n'),
-        ])
-        this_tree.commit('Swapped 2 & 3')
-        self.do_merge(this_tree, other_tree)
-        self.assertFileEqual('line 1\n'
-            '<<<<<<< TREE\n'
-            'line 3\n'
-            'line 2\n'
-            '=======\n'
-            'line 2 to 2.1\n'
-            'line 3\n'
-            '>>>>>>> MERGE-SOURCE\n'
-            'line 4\n', 'this/file1')
-
-    def test_modify_conflicts_with_delete(self):
-        # If one side deletes a line, and the other modifies that line, then
-        # the modification should be considered a conflict
-        builder = self.make_branch_builder('test')
-        builder.start_series()
-        builder.build_snapshot('BASE-id', None,
-            [('add', ('', None, 'directory', None)),
-             ('add', ('foo', 'foo-id', 'file', 'a\nb\nc\nd\ne\n')),
-            ])
-        # Delete 'b\n'
-        builder.build_snapshot('OTHER-id', ['BASE-id'],
-            [('modify', ('foo-id', 'a\nc\nd\ne\n'))])
-        # Modify 'b\n', add 'X\n'
-        builder.build_snapshot('THIS-id', ['BASE-id'],
-            [('modify', ('foo-id', 'a\nb2\nc\nd\nX\ne\n'))])
-        builder.finish_series()
-        branch = builder.get_branch()
-        this_tree = branch.bzrdir.create_workingtree()
-        this_tree.lock_write()
-        self.addCleanup(this_tree.unlock)
-        other_tree = this_tree.bzrdir.sprout('other', 'OTHER-id').open_workingtree()
-        self.do_merge(this_tree, other_tree)
-        if self.merge_type is _mod_merge.LCAMerger:
-            self.expectFailure("lca merge doesn't track deleted lines",
-                self.assertFileEqual,
-                    'a\n'
-                    '<<<<<<< TREE\n'
-                    'b2\n'
-                    '=======\n'
-                    '>>>>>>> MERGE-SOURCE\n'
-                    'c\n'
-                    'd\n'
-                    'X\n'
-                    'e\n', 'test/foo')
-        else:
-            self.assertFileEqual(
-                'a\n'
-                '<<<<<<< TREE\n'
-                'b2\n'
-                '=======\n'
-                '>>>>>>> MERGE-SOURCE\n'
-                'c\n'
-                'd\n'
-                'X\n'
-                'e\n', 'test/foo')
-
-    def get_limbodir_deletiondir(self, wt):
-        transform = TreeTransform(wt)
-        limbodir = transform._limbodir
-        deletiondir = transform._deletiondir
-        transform.finalize()
-        return (limbodir, deletiondir)
-    
-    def test_merge_with_existing_limbo(self):
-        wt = self.make_branch_and_tree('this')
-        (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
-        os.mkdir(limbodir)
-        self.assertRaises(errors.ExistingLimbo, self.do_merge, wt, wt)
-        self.assertRaises(errors.LockError, wt.unlock)
-
-    def test_merge_with_pending_deletion(self):
-        wt = self.make_branch_and_tree('this')
-        (limbodir, deletiondir) =  self.get_limbodir_deletiondir(wt)
-        os.mkdir(deletiondir)
-        self.assertRaises(errors.ExistingPendingDeletion, self.do_merge, wt, wt)
-        self.assertRaises(errors.LockError, wt.unlock)
-
-
-class TestMerge3Merge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.Merge3Merger
-
-
-class TestWeaveMerge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.WeaveMerger
-
-
-class TestLCAMerge(TestCaseWithTransport, TestMergeImplementation):
-
-    merge_type = _mod_merge.LCAMerger
-
-    def test_merge_move_and_change(self):
-        self.expectFailure("lca merge doesn't conflict for move and change",
-            super(TestLCAMerge, self).test_merge_move_and_change)
-
-
 class LoggingMerger(object):
     # These seem to be the required attributes
     requires_base = False
@@ -2876,3 +2837,85 @@
             'bval', ['lca1val', 'lca2val', 'lca2val'], 'oval', 'tval')
         self.assertLCAMultiWay('conflict',
             'bval', ['lca1val', 'lca2val', 'lca3val'], 'oval', 'tval')
+
+
+class TestConfigurableFileMerger(tests.TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestConfigurableFileMerger, self).setUp()
+        self.calls = []
+
+    def get_merger_factory(self):
+        # Allows  the inner methods to access the test attributes
+        test = self
+
+        class FooMerger(_mod_merge.ConfigurableFileMerger):
+            name_prefix = "foo"
+            default_files = ['bar']
+
+            def merge_text(self, params):
+                test.calls.append('merge_text')
+                return ('not_applicable', None)
+
+        def factory(merger):
+            result = FooMerger(merger)
+            # Make sure we start with a clean slate
+            self.assertEqual(None, result.affected_files)
+            # Track the original merger
+            self.merger = result
+            return result
+
+        return factory
+
+    def _install_hook(self, factory):
+        _mod_merge.Merger.hooks.install_named_hook('merge_file_content',
+                                                   factory, 'test factory')
+
+    def make_builder(self):
+        builder = test_merge_core.MergeBuilder(self.test_base_dir)
+        self.addCleanup(builder.cleanup)
+        return builder
+
+    def make_text_conflict(self, file_name='bar'):
+        factory = self.get_merger_factory()
+        self._install_hook(factory)
+        builder = self.make_builder()
+        builder.add_file('bar-id', builder.tree_root, file_name, 'text1', True)
+        builder.change_contents('bar-id', other='text4', this='text3')
+        return builder
+
+    def make_kind_change(self):
+        factory = self.get_merger_factory()
+        self._install_hook(factory)
+        builder = self.make_builder()
+        builder.add_file('bar-id', builder.tree_root, 'bar', 'text1', True,
+                         this=False)
+        builder.add_dir('bar-dir', builder.tree_root, 'bar-id',
+                        base=False, other=False)
+        return builder
+
+    def test_affected_files_cached(self):
+        """Ensures that the config variable is cached"""
+        builder = self.make_text_conflict()
+        conflicts = builder.merge()
+        # The hook should set the variable
+        self.assertEqual(['bar'], self.merger.affected_files)
+        self.assertEqual(1, len(conflicts))
+
+    def test_hook_called_for_text_conflicts(self):
+        builder = self.make_text_conflict()
+        conflicts = builder.merge()
+        # The hook should call the merge_text() method
+        self.assertEqual(['merge_text'], self.calls)
+
+    def test_hook_not_called_for_kind_change(self):
+        builder = self.make_kind_change()
+        conflicts = builder.merge()
+        # The hook should not call the merge_text() method
+        self.assertEqual([], self.calls)
+
+    def test_hook_not_called_for_other_files(self):
+        builder = self.make_text_conflict('foobar')
+        conflicts = builder.merge()
+        # The hook should not call the merge_text() method
+        self.assertEqual([], self.calls)

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2009-08-20 04:09:58 +0000
+++ bzrlib/tests/test_merge_core.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,32 +15,26 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import os
-import stat
 import sys
 
 import bzrlib
 from bzrlib import (
+    errors,
     generate_ids,
     merge_directive,
     osutils,
     )
 from bzrlib.conflicts import ContentsConflict, TextConflict, PathConflict
-from bzrlib import errors
-from bzrlib.errors import (NotBranchError, NotVersionedError,
-                           WorkingTreeNotRevision, BzrCommandError, NoDiff3)
-from bzrlib import  inventory
 from bzrlib.merge import (
     Merge3Merger,
     Diff3Merger,
     WeaveMerger,
     Merger,
     )
-from bzrlib.osutils import (file_kind, getcwd, pathjoin, rename,
-                            sha_file,
-                            )
+from bzrlib.osutils import getcwd, pathjoin
 from bzrlib import progress
 from bzrlib.transform import TreeTransform
-from bzrlib.tests import TestCaseWithTransport, TestCase, TestSkipped
+from bzrlib.tests import TestCaseWithTransport, TestSkipped
 from bzrlib.workingtree import WorkingTree
 
 
@@ -120,10 +114,11 @@
                 tt.cancel_versioning(trans_id)
                 tt.set_executability(None, trans_id)
 
-    def add_dir(self, file_id, parent, name):
-        for tt in self.list_transforms():
-            parent_id = tt.trans_id_file_id(parent)
-            tt.new_directory(name, parent_id, file_id)
+    def add_dir(self, file_id, parent, name, this=True, base=True, other=True):
+        for option, tt in self.selected_transforms(this, base, other):
+            if option is True:
+                parent_id = tt.trans_id_file_id(parent)
+                tt.new_directory(name, parent_id, file_id)
 
     def change_name(self, id, base=None, this=None, other=None):
         for val, tt in ((base, self.base_tt), (this, self.this_tt),
@@ -277,7 +272,7 @@
                               " and therefore always fails on win32")
         try:
             self.do_contents_test(Diff3Merger)
-        except NoDiff3:
+        except errors.NoDiff3:
             raise TestSkipped("diff3 not available")
 
     def test_contents_merge3(self):
@@ -434,6 +429,7 @@
         self.assertEqual('text2', builder.this.get_file('1').read())
         builder.cleanup()
 
+
 class FunctionalMergeTest(TestCaseWithTransport):
 
     def test_trivial_star_merge(self):
@@ -467,30 +463,61 @@
         self.assertEqual("Mary\n", open("original/file2", "rt").read())
 
     def test_conflicts(self):
-        os.mkdir('a')
         wta = self.make_branch_and_tree('a')
-        a = wta.branch
-        file('a/file', 'wb').write('contents\n')
+        self.build_tree_contents([('a/file', 'contents\n')])
         wta.add('file')
         wta.commit('base revision', allow_pointless=False)
-        d_b = a.bzrdir.clone('b')
-        b = d_b.open_branch()
-        file('a/file', 'wb').write('other contents\n')
+        d_b = wta.branch.bzrdir.clone('b')
+        self.build_tree_contents([('a/file', 'other contents\n')])
         wta.commit('other revision', allow_pointless=False)
-        file('b/file', 'wb').write('this contents contents\n')
+        self.build_tree_contents([('b/file', 'this contents contents\n')])
         wtb = d_b.open_workingtree()
         wtb.commit('this revision', allow_pointless=False)
         self.assertEqual(1, wtb.merge_from_branch(wta.branch))
-        self.assert_(os.path.lexists('b/file.THIS'))
-        self.assert_(os.path.lexists('b/file.BASE'))
-        self.assert_(os.path.lexists('b/file.OTHER'))
+        self.failUnlessExists('b/file.THIS')
+        self.failUnlessExists('b/file.BASE')
+        self.failUnlessExists('b/file.OTHER')
         wtb.revert()
         self.assertEqual(1, wtb.merge_from_branch(wta.branch,
                                                   merge_type=WeaveMerger))
-        self.assert_(os.path.lexists('b/file'))
-        self.assert_(os.path.lexists('b/file.THIS'))
-        self.assert_(not os.path.lexists('b/file.BASE'))
-        self.assert_(os.path.lexists('b/file.OTHER'))
+        self.failUnlessExists('b/file')
+        self.failUnlessExists('b/file.THIS')
+        self.failUnlessExists('b/file.BASE')
+        self.failUnlessExists('b/file.OTHER')
+
+    def test_weave_conflicts_not_in_base(self):
+        builder = self.make_branch_builder('source')
+        builder.start_series()
+        # See bug #494197
+        #  A        base revision (before criss-cross)
+        #  |\
+        #  B C      B does nothing, C adds 'foo'
+        #  |X|
+        #  D E      D and E modify foo in incompatible ways
+        #
+        # Merging will conflict, with C as a clean base text. However, the
+        # current code uses A as the global base and 'foo' doesn't exist there.
+        # It isn't trivial to create foo.BASE because it tries to look up
+        # attributes like 'executable' in A.
+        builder.build_snapshot('A-id', None, [
+            ('add', ('', 'TREE_ROOT', 'directory', None))])
+        builder.build_snapshot('B-id', ['A-id'], [])
+        builder.build_snapshot('C-id', ['A-id'], [
+            ('add', ('foo', 'foo-id', 'file', 'orig\ncontents\n'))])
+        builder.build_snapshot('D-id', ['B-id', 'C-id'], [
+            ('add', ('foo', 'foo-id', 'file', 'orig\ncontents\nand D\n'))])
+        builder.build_snapshot('E-id', ['C-id', 'B-id'], [
+            ('modify', ('foo-id', 'orig\ncontents\nand E\n'))])
+        builder.finish_series()
+        tree = builder.get_branch().create_checkout('tree', lightweight=True)
+        self.assertEqual(1, tree.merge_from_branch(tree.branch,
+                                                   to_revision='D-id',
+                                                   merge_type=WeaveMerger))
+        self.failUnlessExists('tree/foo.THIS')
+        self.failUnlessExists('tree/foo.OTHER')
+        self.expectFailure('fail to create .BASE in some criss-cross merges',
+            self.failUnlessExists, 'tree/foo.BASE')
+        self.failUnlessExists('tree/foo.BASE')
 
     def test_merge_unrelated(self):
         """Sucessfully merges unrelated branches with no common names"""

=== modified file 'bzrlib/tests/test_msgeditor.py'
--- bzrlib/tests/test_msgeditor.py	2009-10-06 14:40:37 +0000
+++ bzrlib/tests/test_msgeditor.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -35,6 +35,7 @@
     edit_commit_message_encoded
 )
 from bzrlib.tests import (
+    TestCaseInTempDir,
     TestCaseWithTransport,
     TestNotApplicable,
     TestSkipped,
@@ -290,7 +291,10 @@
         # Call _run_editor, capturing mutter.warning calls.
         warnings = []
         def warning(*args):
-            warnings.append(args[0] % args[1:])
+            if len(args) > 1:
+                warnings.append(args[0] % args[1:])
+            else:
+                warnings.append(args[0])
         _warning = trace.warning
         trace.warning = warning
         try:
@@ -364,3 +368,24 @@
         commit_obj = commit.Commit()
         self.assertEquals("save me some typing\n",
             msgeditor.generate_commit_message_template(commit_obj))
+
+
+# GZ 2009-11-17: This wants moving to osutils when the errno checking code is
+class TestPlatformErrnoWorkarounds(TestCaseInTempDir):
+    """Ensuring workarounds enshrined in code actually serve a purpose"""
+
+    def test_subprocess_call_bad_file(self):
+        if sys.platform != "win32":
+            raise TestNotApplicable("Workarounds for windows only")
+        import subprocess, errno
+        ERROR_BAD_EXE_FORMAT = 193
+        file("textfile.txt", "w").close()
+        e = self.assertRaises(WindowsError, subprocess.call, "textfile.txt")
+        # Python2.4 used the 'winerror' as the errno, which confuses a lot of
+        # our error trapping code. Make sure that we understand the mapping
+        # correctly.
+        if sys.version_info >= (2, 5):
+            self.assertEqual(e.errno, errno.ENOEXEC)
+            self.assertEqual(e.winerror, ERROR_BAD_EXE_FORMAT)
+        else:
+            self.assertEqual(e.errno, ERROR_BAD_EXE_FORMAT)

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2009-10-15 04:01:26 +0000
+++ bzrlib/tests/test_osutils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -53,15 +53,13 @@
 
 UTF8DirReaderFeature = _UTF8DirReaderFeature()
 
+term_ios_feature = tests.ModuleAvailableFeature('termios')
+
 
 def _already_unicode(s):
     return s
 
 
-def _fs_enc_to_unicode(s):
-    return s.decode(osutils._fs_enc)
-
-
 def _utf8_to_unicode(s):
     return s.decode('UTF-8')
 
@@ -84,15 +82,13 @@
                           dict(_dir_reader_class=_readdir_pyx.UTF8DirReader,
                                _native_to_unicode=_utf8_to_unicode)))
 
-    if test__walkdirs_win32.Win32ReadDirFeature.available():
+    if test__walkdirs_win32.win32_readdir_feature.available():
         try:
             from bzrlib import _walkdirs_win32
-            # TODO: check on windows, it may be that we need to use/add
-            # safe_unicode instead of _fs_enc_to_unicode
             scenarios.append(
                 ('win32',
                  dict(_dir_reader_class=_walkdirs_win32.Win32ReadDir,
-                      _native_to_unicode=_fs_enc_to_unicode)))
+                      _native_to_unicode=_already_unicode)))
         except ImportError:
             pass
     return scenarios
@@ -126,33 +122,51 @@
 
 class TestRename(tests.TestCaseInTempDir):
 
+    def create_file(self, filename, content):
+        f = open(filename, 'wb')
+        try:
+            f.write(content)
+        finally:
+            f.close()
+
+    def _fancy_rename(self, a, b):
+        osutils.fancy_rename(a, b, rename_func=os.rename,
+                             unlink_func=os.unlink)
+
     def test_fancy_rename(self):
         # This should work everywhere
-        def rename(a, b):
-            osutils.fancy_rename(a, b,
-                    rename_func=os.rename,
-                    unlink_func=os.unlink)
-
-        open('a', 'wb').write('something in a\n')
-        rename('a', 'b')
+        self.create_file('a', 'something in a\n')
+        self._fancy_rename('a', 'b')
         self.failIfExists('a')
         self.failUnlessExists('b')
         self.check_file_contents('b', 'something in a\n')
 
-        open('a', 'wb').write('new something in a\n')
-        rename('b', 'a')
+        self.create_file('a', 'new something in a\n')
+        self._fancy_rename('b', 'a')
 
         self.check_file_contents('a', 'something in a\n')
 
+    def test_fancy_rename_fails_source_missing(self):
+        # An exception should be raised, and the target should be left in place
+        self.create_file('target', 'data in target\n')
+        self.assertRaises((IOError, OSError), self._fancy_rename,
+                          'missingsource', 'target')
+        self.failUnlessExists('target')
+        self.check_file_contents('target', 'data in target\n')
+
+    def test_fancy_rename_fails_if_source_and_target_missing(self):
+        self.assertRaises((IOError, OSError), self._fancy_rename,
+                          'missingsource', 'missingtarget')
+
     def test_rename(self):
         # Rename should be semi-atomic on all platforms
-        open('a', 'wb').write('something in a\n')
+        self.create_file('a', 'something in a\n')
         osutils.rename('a', 'b')
         self.failIfExists('a')
         self.failUnlessExists('b')
         self.check_file_contents('b', 'something in a\n')
 
-        open('a', 'wb').write('new something in a\n')
+        self.create_file('a', 'new something in a\n')
         osutils.rename('b', 'a')
 
         self.check_file_contents('a', 'something in a\n')
@@ -366,6 +380,14 @@
         # Instead blackbox.test_locale should check for localized
         # dates once they do occur in output strings.
 
+    def test_format_date_with_offset_in_original_timezone(self):
+        self.assertEqual("Thu 1970-01-01 00:00:00 +0000",
+            osutils.format_date_with_offset_in_original_timezone(0))
+        self.assertEqual("Fri 1970-01-02 03:46:40 +0000",
+            osutils.format_date_with_offset_in_original_timezone(100000))
+        self.assertEqual("Fri 1970-01-02 05:46:40 +0200",
+            osutils.format_date_with_offset_in_original_timezone(100000, 7200))
+
     def test_local_time_offset(self):
         """Test that local_time_offset() returns a sane value."""
         offset = osutils.local_time_offset()
@@ -967,7 +989,7 @@
 
     def test_osutils_binding(self):
         from bzrlib.tests import test__chunks_to_lines
-        if test__chunks_to_lines.CompiledChunksToLinesFeature.available():
+        if test__chunks_to_lines.compiled_chunkstolines_feature.available():
             from bzrlib._chunks_to_lines_pyx import chunks_to_lines
         else:
             from bzrlib._chunks_to_lines_py import chunks_to_lines
@@ -1159,14 +1181,14 @@
 
     def test_force_walkdirs_utf8_nt(self):
         # Disabled because the thunk of the whole walkdirs api is disabled.
-        self.requireFeature(test__walkdirs_win32.Win32ReadDirFeature)
+        self.requireFeature(test__walkdirs_win32.win32_readdir_feature)
         self._save_platform_info()
         win32utils.winver = 'Windows NT'
         from bzrlib._walkdirs_win32 import Win32ReadDir
         self.assertDirReaderIs(Win32ReadDir)
 
     def test_force_walkdirs_utf8_98(self):
-        self.requireFeature(test__walkdirs_win32.Win32ReadDirFeature)
+        self.requireFeature(test__walkdirs_win32.win32_readdir_feature)
         self._save_platform_info()
         win32utils.winver = 'Windows 98'
         self.assertDirReaderIs(osutils.UnicodeDirReader)
@@ -1323,7 +1345,7 @@
         self.assertEqual(expected_dirblocks, result)
 
     def test__walkdirs_utf8_win32readdir(self):
-        self.requireFeature(test__walkdirs_win32.Win32ReadDirFeature)
+        self.requireFeature(test__walkdirs_win32.win32_readdir_feature)
         self.requireFeature(tests.UnicodeFilenameFeature)
         from bzrlib._walkdirs_win32 import Win32ReadDir
         self._save_platform_info()
@@ -1380,7 +1402,7 @@
 
     def test__walkdirs_utf_win32_find_file_stat_file(self):
         """make sure our Stat values are valid"""
-        self.requireFeature(test__walkdirs_win32.Win32ReadDirFeature)
+        self.requireFeature(test__walkdirs_win32.win32_readdir_feature)
         self.requireFeature(tests.UnicodeFilenameFeature)
         from bzrlib._walkdirs_win32 import Win32ReadDir
         name0u = u'0file-\xb6'
@@ -1404,7 +1426,7 @@
 
     def test__walkdirs_utf_win32_find_file_stat_directory(self):
         """make sure our Stat values are valid"""
-        self.requireFeature(test__walkdirs_win32.Win32ReadDirFeature)
+        self.requireFeature(test__walkdirs_win32.win32_readdir_feature)
         self.requireFeature(tests.UnicodeFilenameFeature)
         from bzrlib._walkdirs_win32 import Win32ReadDir
         name0u = u'0dir-\u062c\u0648'
@@ -1613,7 +1635,7 @@
         text = 'test\r\nwith\nall\rpossible line endings\r\n'
         self.build_tree_contents([('foo', text)])
         expected_sha = osutils.sha_string(text)
-        f = open('foo')
+        f = open('foo', 'rb')
         self.addCleanup(f.close)
         size, sha = osutils.size_sha_file(f)
         self.assertEqual(38, size)
@@ -1835,10 +1857,32 @@
 
 class TestConcurrency(tests.TestCase):
 
+    def setUp(self):
+        super(TestConcurrency, self).setUp()
+        orig = osutils._cached_local_concurrency
+        def restore():
+            osutils._cached_local_concurrency = orig
+        self.addCleanup(restore)
+
     def test_local_concurrency(self):
         concurrency = osutils.local_concurrency()
         self.assertIsInstance(concurrency, int)
 
+    def test_local_concurrency_environment_variable(self):
+        os.environ['BZR_CONCURRENCY'] = '2'
+        self.assertEqual(2, osutils.local_concurrency(use_cache=False))
+        os.environ['BZR_CONCURRENCY'] = '3'
+        self.assertEqual(3, osutils.local_concurrency(use_cache=False))
+        os.environ['BZR_CONCURRENCY'] = 'foo'
+        self.assertEqual(1, osutils.local_concurrency(use_cache=False))
+
+    def test_option_concurrency(self):
+        os.environ['BZR_CONCURRENCY'] = '1'
+        self.run_bzr('rocks --concurrency 42')
+        # Command line overrides envrionment variable
+        self.assertEquals('42', os.environ['BZR_CONCURRENCY'])
+        self.assertEquals(42, osutils.local_concurrency(use_cache=False))
+
 
 class TestFailedToLoadExtension(tests.TestCase):
 
@@ -1880,3 +1924,83 @@
             r"bzr: warning: some compiled extensions could not be loaded; "
             "see <https://answers\.launchpad\.net/bzr/\+faq/703>\n"
             )
+
+
+class TestTerminalWidth(tests.TestCase):
+
+    def replace_stdout(self, new):
+        orig_stdout = sys.stdout
+        def restore():
+            sys.stdout = orig_stdout
+        self.addCleanup(restore)
+        sys.stdout = new
+
+    def replace__terminal_size(self, new):
+        orig__terminal_size = osutils._terminal_size
+        def restore():
+            osutils._terminal_size = orig__terminal_size
+        self.addCleanup(restore)
+        osutils._terminal_size = new
+
+    def set_fake_tty(self):
+
+        class I_am_a_tty(object):
+            def isatty(self):
+                return True
+
+        self.replace_stdout(I_am_a_tty())
+
+    def test_default_values(self):
+        self.assertEqual(80, osutils.default_terminal_width)
+
+    def test_defaults_to_BZR_COLUMNS(self):
+        # BZR_COLUMNS is set by the test framework
+        self.assertNotEqual('12', os.environ['BZR_COLUMNS'])
+        os.environ['BZR_COLUMNS'] = '12'
+        self.assertEqual(12, osutils.terminal_width())
+
+    def test_falls_back_to_COLUMNS(self):
+        del os.environ['BZR_COLUMNS']
+        self.assertNotEqual('42', os.environ['COLUMNS'])
+        self.set_fake_tty()
+        os.environ['COLUMNS'] = '42'
+        self.assertEqual(42, osutils.terminal_width())
+
+    def test_tty_default_without_columns(self):
+        del os.environ['BZR_COLUMNS']
+        del os.environ['COLUMNS']
+
+        def terminal_size(w, h):
+            return 42, 42
+
+        self.set_fake_tty()
+        # We need to override the osutils definition as it depends on the
+        # running environment that we can't control (PQM running without a
+        # controlling terminal is one example).
+        self.replace__terminal_size(terminal_size)
+        self.assertEqual(42, osutils.terminal_width())
+
+    def test_non_tty_default_without_columns(self):
+        del os.environ['BZR_COLUMNS']
+        del os.environ['COLUMNS']
+        self.replace_stdout(None)
+        self.assertEqual(None, osutils.terminal_width())
+
+    def test_no_TIOCGWINSZ(self):
+        self.requireFeature(term_ios_feature)
+        termios = term_ios_feature.module
+        # bug 63539 is about a termios without TIOCGWINSZ attribute
+        try:
+            orig = termios.TIOCGWINSZ
+        except AttributeError:
+            # We won't remove TIOCGWINSZ, because it doesn't exist anyway :)
+            pass
+        else:
+            def restore():
+                termios.TIOCGWINSZ = orig
+            self.addCleanup(restore)
+            del termios.TIOCGWINSZ
+        del os.environ['BZR_COLUMNS']
+        del os.environ['COLUMNS']
+        # Whatever the result is, if we don't raise an exception, it's ok.
+        osutils.terminal_width()

=== modified file 'bzrlib/tests/test_patches.py'
--- bzrlib/tests/test_patches.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_patches.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004 - 2008 Aaron Bentley, Canonical Ltd
+# Copyright (C) 2005-2010 Aaron Bentley, Canonical Ltd
 # <aaron.bentley@utoronto.ca>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -24,6 +24,9 @@
 from bzrlib.patches import (MalformedLine,
                             MalformedHunkHeader,
                             MalformedPatchHeader,
+                            BinaryPatch,
+                            BinaryFiles,
+                            Patch,
                             ContextLine,
                             InsertLine,
                             RemoveLine,
@@ -45,6 +48,13 @@
                                  "test_patches_data", filename)
         return file(data_path, "rb")
 
+    def data_lines(self, filename):
+        datafile = self.datafile(filename)
+        try:
+            return datafile.readlines()
+        finally:
+            datafile.close()
+
     def testValidPatchHeader(self):
         """Parse a valid patch header"""
         lines = "--- orig/commands.py\n+++ mod/dommands.py\n".split('\n')
@@ -136,6 +146,30 @@
         patchtext = self.datafile("patchtext.patch").read()
         self.compare_parsed(patchtext)
 
+    def test_parse_binary(self):
+        """Test parsing a whole patch"""
+        patches = parse_patches(self.data_lines("binary.patch"))
+        self.assertIs(BinaryPatch, patches[0].__class__)
+        self.assertIs(Patch, patches[1].__class__)
+        self.assertContainsRe(patches[0].oldname, '^bar\t')
+        self.assertContainsRe(patches[0].newname, '^qux\t')
+        self.assertContainsRe(str(patches[0]),
+                                  'Binary files bar\t.* and qux\t.* differ\n')
+
+    def test_parse_binary_after_normal(self):
+        patches = parse_patches(self.data_lines("binary-after-normal.patch"))
+        self.assertIs(BinaryPatch, patches[1].__class__)
+        self.assertIs(Patch, patches[0].__class__)
+        self.assertContainsRe(patches[1].oldname, '^bar\t')
+        self.assertContainsRe(patches[1].newname, '^qux\t')
+        self.assertContainsRe(str(patches[1]),
+                                  'Binary files bar\t.* and qux\t.* differ\n')
+
+    def test_roundtrip_binary(self):
+        patchtext = ''.join(self.data_lines("binary.patch"))
+        patches = parse_patches(patchtext.splitlines(True))
+        self.assertEqual(patchtext, ''.join(str(p) for p in patches))
+
     def testInit(self):
         """Handle patches missing half the position, range tuple"""
         patchtext = \
@@ -194,6 +228,11 @@
                 count += 1
             self.assertEqual(count, len(mod_lines))
 
+    def test_iter_patched_binary(self):
+        binary_lines = self.data_lines('binary.patch')
+        e = self.assertRaises(BinaryFiles, iter_patched, [], binary_lines)
+
+
     def test_iter_patched_from_hunks(self):
         """Test a few patch files, and make sure they work."""
         files = [

=== added file 'bzrlib/tests/test_patches_data/binary-after-normal.patch'
--- bzrlib/tests/test_patches_data/binary-after-normal.patch	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_patches_data/binary-after-normal.patch	2009-11-03 15:45:56 +0000
@@ -0,0 +1,6 @@
+--- baz	2009-10-14 19:49:59 +0000
++++ quxx	2009-10-14 19:51:00 +0000
+@@ -1 +1 @@
+-hello
++goodbye
+Binary files bar	2009-10-14 19:49:59 +0000 and qux	2009-10-14 19:50:35 +0000 differ

=== added file 'bzrlib/tests/test_patches_data/binary.patch'
--- bzrlib/tests/test_patches_data/binary.patch	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_patches_data/binary.patch	2009-10-14 22:08:45 +0000
@@ -0,0 +1,6 @@
+Binary files bar	2009-10-14 19:49:59 +0000 and qux	2009-10-14 19:50:35 +0000 differ
+--- baz	2009-10-14 19:49:59 +0000
++++ quxx	2009-10-14 19:51:00 +0000
+@@ -1 +1 @@
+-hello
++goodbye

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2009-06-19 07:28:41 +0000
+++ bzrlib/tests/test_progress.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -70,9 +70,20 @@
         task.total_cnt = total
         return task
 
+    def test_render_progress_no_bar(self):
+        """The default view now has a spinner but no bar."""
+        out, view = self.make_view()
+        # view.enable_bar = False
+        task = self.make_task(None, view, 'reticulating splines', 5, 20)
+        view.show_progress(task)
+        self.assertEqual(
+'\r/ reticulating splines 5/20                                                    \r'
+            , out.getvalue())
+
     def test_render_progress_easy(self):
         """Just one task and one quarter done"""
         out, view = self.make_view()
+        view.enable_bar = True
         task = self.make_task(None, view, 'reticulating splines', 5, 20)
         view.show_progress(task)
         self.assertEqual(
@@ -85,6 +96,7 @@
         task = self.make_task(None, view, 'reticulating splines', 0, 2)
         task2 = self.make_task(task, view, 'stage2', 1, 2)
         view.show_progress(task2)
+        view.enable_bar = True
         # so we're in the first half of the main task, and half way through
         # that
         self.assertEqual(
@@ -100,6 +112,7 @@
     def test_render_progress_sub_nested(self):
         """Intermediate tasks don't mess up calculation."""
         out, view = self.make_view()
+        view.enable_bar = True
         task_a = ProgressTask(None, progress_view=view)
         task_a.update('a', 0, 2)
         task_b = ProgressTask(task_a, progress_view=view)

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2009-10-15 04:01:26 +0000
+++ bzrlib/tests/test_remote.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
 from cStringIO import StringIO
 
 from bzrlib import (
+    branch,
     bzrdir,
     config,
     errors,
@@ -36,7 +37,6 @@
     pack,
     remote,
     repository,
-    smart,
     tests,
     treebuilder,
     urlutils,
@@ -61,9 +61,8 @@
     condition_isinstance,
     split_suite_by_condition,
     multiply_tests,
-    KnownFailure,
     )
-from bzrlib.transport import get_transport, http
+from bzrlib.transport import get_transport
 from bzrlib.transport.memory import MemoryTransport
 from bzrlib.transport.remote import (
     RemoteTransport,
@@ -135,6 +134,10 @@
         b = BzrDir.open_from_transport(self.transport).open_branch()
         self.assertStartsWith(str(b), 'RemoteBranch(')
 
+    def test_remote_bzrdir_repr(self):
+        b = BzrDir.open_from_transport(self.transport)
+        self.assertStartsWith(str(b), 'RemoteBzrDir(')
+
     def test_remote_branch_format_supports_stacking(self):
         t = self.transport
         self.make_branch('unstackable', format='pack-0.92')
@@ -441,7 +444,7 @@
             'BzrDir.cloning_metadir', ('quack/', 'False'),
             'error', ('BranchReference',)),
         client.add_expected_call(
-            'BzrDir.open_branchV2', ('quack/',),
+            'BzrDir.open_branchV3', ('quack/',),
             'success', ('ref', self.get_url('referenced'))),
         a_bzrdir = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
             _client=client)
@@ -532,7 +535,7 @@
         self.make_branch('.')
         a_dir = BzrDir.open(self.get_url('.'))
         self.reset_smart_call_log()
-        verb = 'BzrDir.open_branchV2'
+        verb = 'BzrDir.open_branchV3'
         self.disable_verb(verb)
         format = a_dir.open_branch()
         call_count = len([call for call in self.hpss_calls if
@@ -548,7 +551,7 @@
         transport = transport.clone('quack')
         client = FakeClient(transport.base)
         client.add_expected_call(
-            'BzrDir.open_branchV2', ('quack/',),
+            'BzrDir.open_branchV3', ('quack/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('quack/',),
@@ -573,7 +576,7 @@
             _client=client)
         self.assertRaises(errors.NotBranchError, bzrdir.open_branch)
         self.assertEqual(
-            [('call', 'BzrDir.open_branchV2', ('quack/',))],
+            [('call', 'BzrDir.open_branchV3', ('quack/',))],
             client._calls)
 
     def test__get_tree_branch(self):
@@ -603,7 +606,7 @@
         network_name = reference_format.network_name()
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV2', ('~hello/',),
+            'BzrDir.open_branchV3', ('~hello/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('~hello/',),
@@ -1191,7 +1194,7 @@
         client = FakeClient(self.get_url())
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV2', ('stacked/',),
+            'BzrDir.open_branchV3', ('stacked/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('stacked/',),
@@ -1227,7 +1230,7 @@
         client = FakeClient(self.get_url())
         branch_network_name = self.get_branch_format().network_name()
         client.add_expected_call(
-            'BzrDir.open_branchV2', ('stacked/',),
+            'BzrDir.open_branchV3', ('stacked/',),
             'success', ('branch', branch_network_name))
         client.add_expected_call(
             'BzrDir.find_repositoryV3', ('stacked/',),
@@ -1782,6 +1785,20 @@
         return repo, client
 
 
+def remoted_description(format):
+    return 'Remote: ' + format.get_format_description()
+
+
+class TestBranchFormat(tests.TestCase):
+
+    def test_get_format_description(self):
+        remote_format = RemoteBranchFormat()
+        real_format = branch.BranchFormat.get_default_format()
+        remote_format._network_name = real_format.network_name()
+        self.assertEqual(remoted_description(real_format),
+            remote_format.get_format_description())
+
+
 class TestRepositoryFormat(TestRemoteRepository):
 
     def test_fast_delta(self):
@@ -1794,6 +1811,13 @@
         false_format._network_name = false_name
         self.assertEqual(False, false_format.fast_deltas)
 
+    def test_get_format_description(self):
+        remote_repo_format = RemoteRepositoryFormat()
+        real_format = repository.RepositoryFormat.get_default_format()
+        remote_repo_format._network_name = real_format.network_name()
+        self.assertEqual(remoted_description(real_format),
+            remote_repo_format.get_format_description())
+
 
 class TestRepositoryGatherStats(TestRemoteRepository):
 
@@ -2755,6 +2779,15 @@
         expected_error = errors.NotBranchError(path=bzrdir.root_transport.base)
         self.assertEqual(expected_error, translated_error)
 
+    def test_nobranch_one_arg(self):
+        bzrdir = self.make_bzrdir('')
+        translated_error = self.translateTuple(
+            ('nobranch', 'extra detail'), bzrdir=bzrdir)
+        expected_error = errors.NotBranchError(
+            path=bzrdir.root_transport.base,
+            detail='extra detail')
+        self.assertEqual(expected_error, translated_error)
+
     def test_LockContention(self):
         translated_error = self.translateTuple(('LockContention',))
         expected_error = errors.LockContention('(remote lock)')
@@ -2873,7 +2906,7 @@
         # In addition to re-raising ErrorFromSmartServer, some debug info has
         # been muttered to the log file for developer to look at.
         self.assertContainsRe(
-            self._get_log(keep_log_file=True),
+            self.get_log(),
             "Missing key 'branch' in context")
 
     def test_path_missing(self):
@@ -2887,8 +2920,7 @@
         self.assertEqual(server_error, translated_error)
         # In addition to re-raising ErrorFromSmartServer, some debug info has
         # been muttered to the log file for developer to look at.
-        self.assertContainsRe(
-            self._get_log(keep_log_file=True), "Missing key 'path' in context")
+        self.assertContainsRe(self.get_log(), "Missing key 'path' in context")
 
 
 class TestStacking(tests.TestCaseWithTransport):
@@ -3022,6 +3054,7 @@
             local_tree.commit('more local changes are better')
             branch = Branch.open(self.get_url('tree3'))
             branch.lock_read()
+            self.addCleanup(branch.unlock)
             return None, branch
         rev_ord, expected_revs = self.get_ordered_revs('1.9', 'unordered',
             branch_factory=make_stacked_stacked)

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2009-09-15 01:52:34 +0000
+++ bzrlib/tests/test_repository.py	2010-01-21 21:13:09 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -24,6 +24,7 @@
 
 from stat import S_ISDIR
 from StringIO import StringIO
+import sys
 
 import bzrlib
 from bzrlib.errors import (NotBranchError,
@@ -62,6 +63,7 @@
     revision as _mod_revision,
     symbol_versioning,
     upgrade,
+    versionedfile,
     workingtree,
     )
 from bzrlib.repofmt import (
@@ -252,7 +254,14 @@
         tree = control.create_workingtree()
         tree.add(['foo'], ['Foo:Bar'], ['file'])
         tree.put_file_bytes_non_atomic('Foo:Bar', 'content\n')
-        tree.commit('first post', rev_id='first')
+        try:
+            tree.commit('first post', rev_id='first')
+        except errors.IllegalPath:
+            if sys.platform != 'win32':
+                raise
+            self.knownFailure('Foo:Bar cannot be used as a file-id on windows'
+                              ' in repo format 7')
+            return
         self.assertEqualDiff(
             '# bzr weave file v5\n'
             'i\n'
@@ -1135,6 +1144,31 @@
         packs.ensure_loaded()
         return tree, r, packs, [rev1, rev2, rev3]
 
+    def test__clear_obsolete_packs(self):
+        packs = self.get_packs()
+        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
+        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
+        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
+        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
+        res = packs._clear_obsolete_packs()
+        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
+        self.assertEqual([], obsolete_pack_trans.list_dir('.'))
+
+    def test__clear_obsolete_packs_preserve(self):
+        packs = self.get_packs()
+        obsolete_pack_trans = packs.transport.clone('obsolete_packs')
+        obsolete_pack_trans.put_bytes('a-pack.pack', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.rix', 'content\n')
+        obsolete_pack_trans.put_bytes('a-pack.iix', 'content\n')
+        obsolete_pack_trans.put_bytes('another-pack.pack', 'foo\n')
+        obsolete_pack_trans.put_bytes('not-a-pack.rix', 'foo\n')
+        res = packs._clear_obsolete_packs(preserve=set(['a-pack']))
+        self.assertEqual(['a-pack', 'another-pack'], sorted(res))
+        self.assertEqual(['a-pack.iix', 'a-pack.pack', 'a-pack.rix'],
+                         sorted(obsolete_pack_trans.list_dir('.')))
+
     def test__max_pack_count(self):
         """The maximum pack count is a function of the number of revisions."""
         # no revisions - one pack, so that we can have a revision free repo
@@ -1160,6 +1194,33 @@
         # check some arbitrary big numbers
         self.assertEqual(25, packs._max_pack_count(112894))
 
+    def test_repr(self):
+        packs = self.get_packs()
+        self.assertContainsRe(repr(packs),
+            'RepositoryPackCollection(.*Repository(.*))')
+
+    def test__obsolete_packs(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        # Schedule this one for removal
+        packs._remove_pack_from_memory(pack)
+        # Simulate a concurrent update by renaming the .pack file and one of
+        # the indices
+        packs.transport.rename('packs/%s.pack' % (names[0],),
+                               'obsolete_packs/%s.pack' % (names[0],))
+        packs.transport.rename('indices/%s.iix' % (names[0],),
+                               'obsolete_packs/%s.iix' % (names[0],))
+        # Now trigger the obsoletion, and ensure that all the remaining files
+        # are still renamed
+        packs._obsolete_packs([pack])
+        self.assertEqual([n + '.pack' for n in names[1:]],
+                         sorted(packs._pack_transport.list_dir('.')))
+        # names[0] should not be present in the index anymore
+        self.assertEqual(names[1:],
+            sorted(set([osutils.splitext(n)[0] for n in
+                        packs._index_transport.list_dir('.')])))
+
     def test_pack_distribution_zero(self):
         packs = self.get_packs()
         self.assertEqual([0], packs.pack_distribution(0))
@@ -1333,6 +1394,60 @@
         self.assertEqual({revs[-1]:(revs[-2],)}, r.get_parent_map([revs[-1]]))
         self.assertFalse(packs.reload_pack_names())
 
+    def test_reload_pack_names_preserves_pending(self):
+        # TODO: Update this to also test for pending-deleted names
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        # We will add one pack (via start_write_group + insert_record_stream),
+        # and remove another pack (via _remove_pack_from_memory)
+        orig_names = packs.names()
+        orig_at_load = packs._packs_at_load
+        to_remove_name = iter(orig_names).next()
+        r.start_write_group()
+        self.addCleanup(r.abort_write_group)
+        r.texts.insert_record_stream([versionedfile.FulltextContentFactory(
+            ('text', 'rev'), (), None, 'content\n')])
+        new_pack = packs._new_pack
+        self.assertTrue(new_pack.data_inserted())
+        new_pack.finish()
+        packs.allocate(new_pack)
+        packs._new_pack = None
+        removed_pack = packs.get_pack_by_name(to_remove_name)
+        packs._remove_pack_from_memory(removed_pack)
+        names = packs.names()
+        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
+        new_names = set([x[0][0] for x in new_nodes])
+        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
+        self.assertEqual(set(names) - set(orig_names), new_names)
+        self.assertEqual(set([new_pack.name]), new_names)
+        self.assertEqual([to_remove_name],
+                         sorted([x[0][0] for x in deleted_nodes]))
+        packs.reload_pack_names()
+        reloaded_names = packs.names()
+        self.assertEqual(orig_at_load, packs._packs_at_load)
+        self.assertEqual(names, reloaded_names)
+        all_nodes, deleted_nodes, new_nodes, _ = packs._diff_pack_names()
+        new_names = set([x[0][0] for x in new_nodes])
+        self.assertEqual(names, sorted([x[0][0] for x in all_nodes]))
+        self.assertEqual(set(names) - set(orig_names), new_names)
+        self.assertEqual(set([new_pack.name]), new_names)
+        self.assertEqual([to_remove_name],
+                         sorted([x[0][0] for x in deleted_nodes]))
+
+    def test_autopack_obsoletes_new_pack(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        packs._max_pack_count = lambda x: 1
+        packs.pack_distribution = lambda x: [10]
+        r.start_write_group()
+        r.revisions.insert_record_stream([versionedfile.FulltextContentFactory(
+            ('bogus-rev',), (), None, 'bogus-content\n')])
+        # This should trigger an autopack, which will combine everything into a
+        # single pack file.
+        new_names = r.commit_write_group()
+        names = packs.names()
+        self.assertEqual(1, len(names))
+        self.assertEqual([names[0] + '.pack'],
+                         packs._pack_transport.list_dir('.'))
+
     def test_autopack_reloads_and_stops(self):
         tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
         # After we have determined what needs to be autopacked, trigger a
@@ -1350,6 +1465,38 @@
         self.assertEqual(tree.branch.repository._pack_collection.names(),
                          packs.names())
 
+    def test__save_pack_names(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        packs._remove_pack_from_memory(pack)
+        packs._save_pack_names(obsolete_packs=[pack])
+        cur_packs = packs._pack_transport.list_dir('.')
+        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
+        # obsolete_packs will also have stuff like .rix and .iix present.
+        obsolete_packs = packs.transport.list_dir('obsolete_packs')
+        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
+        self.assertEqual([pack.name], sorted(obsolete_names))
+
+    def test__save_pack_names_already_obsoleted(self):
+        tree, r, packs, revs = self.make_packs_and_alt_repo(write_lock=True)
+        names = packs.names()
+        pack = packs.get_pack_by_name(names[0])
+        packs._remove_pack_from_memory(pack)
+        # We are going to simulate a concurrent autopack by manually obsoleting
+        # the pack directly.
+        packs._obsolete_packs([pack])
+        packs._save_pack_names(clear_obsolete_packs=True,
+                               obsolete_packs=[pack])
+        cur_packs = packs._pack_transport.list_dir('.')
+        self.assertEqual([n + '.pack' for n in names[1:]], sorted(cur_packs))
+        # Note that while we set clear_obsolete_packs=True, it should not
+        # delete a pack file that we have also scheduled for obsoletion.
+        obsolete_packs = packs.transport.list_dir('obsolete_packs')
+        obsolete_names = set([osutils.splitext(n)[0] for n in obsolete_packs])
+        self.assertEqual([pack.name], sorted(obsolete_names))
+
+
 
 class TestPack(TestCaseWithTransport):
     """Tests for the Pack object."""
@@ -1419,6 +1566,7 @@
             index_class=BTreeGraphIndex,
             use_chk_index=False)
         pack = pack_repo.NewPack(collection)
+        self.addCleanup(pack.abort) # Make sure the write stream gets closed
         self.assertIsInstance(pack.revision_index, BTreeBuilder)
         self.assertIsInstance(pack.inventory_index, BTreeBuilder)
         self.assertIsInstance(pack._hash, type(osutils.md5()))
@@ -1477,6 +1625,7 @@
         packer = pack_repo.OptimisingPacker(self.get_pack_collection(),
                                             [], '.test')
         new_pack = packer.open_pack()
+        self.addCleanup(new_pack.abort) # ensure cleanup
         self.assertIsInstance(new_pack, pack_repo.NewPack)
         self.assertTrue(new_pack.revision_index._optimize_for_size)
         self.assertTrue(new_pack.inventory_index._optimize_for_size)

=== modified file 'bzrlib/tests/test_revert.py'
--- bzrlib/tests/test_revert.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_revert.py	2010-01-11 22:27:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -157,3 +157,14 @@
         self.failUnlessExists('dir/file1')
         self.failIfExists('dir/file2')
         self.assertEqual('dir-id', tree.path2id('dir'))
+
+    def test_revert_root_id_change(self):
+        tree = self.make_branch_and_tree('.')
+        tree.set_root_id('initial-root-id')
+        self.build_tree(['file1'])
+        tree.add(['file1'])
+        tree.commit('first')
+        tree.set_root_id('temp-root-id')
+        self.assertEqual('temp-root-id', tree.get_root_id())
+        tree.revert()
+        self.assertEqual('initial-root-id', tree.get_root_id())

=== modified file 'bzrlib/tests/test_revisionspec.py'
--- bzrlib/tests/test_revisionspec.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_revisionspec.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -146,24 +146,49 @@
     def test_object(self):
         self.assertRaises(TypeError, RevisionSpec.from_string, object())
 
-    def test_unregistered_spec(self):
-        self.assertRaises(errors.NoSuchRevisionSpec,
-                          RevisionSpec.from_string, 'foo')
-        self.assertRaises(errors.NoSuchRevisionSpec,
-                          RevisionSpec.from_string, '123a')
-
-
-
-class TestRevnoFromString(TestCase):
-
-    def test_from_string_dotted_decimal(self):
-        self.assertRaises(errors.NoSuchRevisionSpec, RevisionSpec.from_string, '-1.1')
-        self.assertRaises(errors.NoSuchRevisionSpec, RevisionSpec.from_string, '.1')
-        self.assertRaises(errors.NoSuchRevisionSpec, RevisionSpec.from_string, '1..1')
-        self.assertRaises(errors.NoSuchRevisionSpec, RevisionSpec.from_string, '1.2..1')
-        self.assertRaises(errors.NoSuchRevisionSpec, RevisionSpec.from_string, '1.')
-        self.assertIsInstance(RevisionSpec.from_string('1.1'), RevisionSpec_revno)
-        self.assertIsInstance(RevisionSpec.from_string('1.1.3'), RevisionSpec_revno)
+
+class TestRevisionSpec_dwim(TestRevisionSpec):
+
+    # Don't need to test revno's explicitly since TRS_revno already
+    # covers that well for us
+    def test_dwim_spec_revno(self):
+        self.assertInHistoryIs(2, 'r2', '2')
+        self.assertAsRevisionId('alt_r2', '1.1.1')
+
+    def test_dwim_spec_revid(self):
+        self.assertInHistoryIs(2, 'r2', 'r2')
+
+    def test_dwim_spec_tag(self):
+        self.tree.branch.tags.set_tag('footag', 'r1')
+        self.assertAsRevisionId('r1', 'footag')
+        self.tree.branch.tags.delete_tag('footag')
+        self.assertRaises(errors.InvalidRevisionSpec,
+                          self.get_in_history, 'footag')
+
+    def test_dwim_spec_tag_that_looks_like_revno(self):
+        # Test that we slip past revno with things that look like revnos,
+        # but aren't.  Tags are convenient for testing this since we can
+        # make them look however we want.
+        self.tree.branch.tags.set_tag('3', 'r2')
+        self.assertAsRevisionId('r2', '3')
+        self.build_tree(['tree/b'])
+        self.tree.add(['b'])
+        self.tree.commit('b', rev_id='r3')
+        self.assertAsRevisionId('r3', '3')
+
+    def test_dwim_spec_date(self):
+        self.assertAsRevisionId('r1', 'today')
+
+    def test_dwim_spec_branch(self):
+        self.assertInHistoryIs(None, 'alt_r2', 'tree2')
+
+    def test_dwim_spec_nonexistent(self):
+        self.assertInvalid('somethingrandom', invalid_as_revision_id=False)
+        self.assertInvalid('-1.1', invalid_as_revision_id=False)
+        self.assertInvalid('.1', invalid_as_revision_id=False)
+        self.assertInvalid('1..1', invalid_as_revision_id=False)
+        self.assertInvalid('1.2..1', invalid_as_revision_id=False)
+        self.assertInvalid('1.', invalid_as_revision_id=False)
 
 
 class TestRevisionSpec_revno(TestRevisionSpec):

=== modified file 'bzrlib/tests/test_revisiontree.py'
--- bzrlib/tests/test_revisiontree.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_revisiontree.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2008, 2009, 2010 Canonical Ltd
 # Authors:  Robert Collins <robert.collins@canonical.com>
 #
 # This program is free software; you can redistribute it and/or modify
@@ -18,9 +18,11 @@
 """Tests for the RevisionTree class."""
 
 from bzrlib import (
+    errors,
     revision,
     )
 import bzrlib
+from bzrlib.inventory import ROOT_ID
 from bzrlib.tests import TestCaseWithTransport
 
 
@@ -59,3 +61,9 @@
         null_tree = self.t.branch.repository.revision_tree(
             revision.NULL_REVISION)
         self.assertIs(None, null_tree.inventory.root)
+
+    def test_get_file_mtime_ghost(self):
+        file_id = iter(self.rev_tree).next()
+        self.rev_tree.inventory[file_id].revision = 'ghostrev'
+        self.assertRaises(errors.FileTimestampUnavailable, 
+            self.rev_tree.get_file_mtime, file_id)

=== modified file 'bzrlib/tests/test_script.py'
--- bzrlib/tests/test_script.py	2009-09-17 14:15:15 +0000
+++ bzrlib/tests/test_script.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -262,14 +262,6 @@
 2>: No such file or directory
 """)
 
-    def test_echo_bogus_input_file(self):
-        # We need a backing file sysytem for that test so it can't be in
-        # TestEcho
-        self.run_script("""
-$ echo <file
-2>file: No such file or directory
-""")
-
     def test_echo_bogus_output_file(self):
         # We need a backing file sysytem for that test so it can't be in
         # TestEcho
@@ -338,6 +330,11 @@
 """
         self.assertRaises(SyntaxError, self.run_script, story)
 
+    def test_echo_input(self):
+        self.assertRaises(SyntaxError, self.run_script, """
+            $ echo <foo
+            """)
+
     def test_echo_to_output(self):
         retcode, out, err = self.run_command(['echo'], None, '\n', None)
         self.assertEquals('\n', out)
@@ -410,3 +407,43 @@
 $ rm -r dir
 """)
         self.failIfExists('dir')
+
+
+class TestMv(script.TestCaseWithTransportAndScript):
+
+    def test_usage(self):
+        self.assertRaises(SyntaxError, self.run_script, '$ mv')
+        self.assertRaises(SyntaxError, self.run_script, '$ mv f')
+        self.assertRaises(SyntaxError, self.run_script, '$ mv f1 f2 f3')
+
+    def test_move_file(self):
+        self.run_script('$ echo content >file')
+        self.failUnlessExists('file')
+        self.run_script('$ mv file new_name')
+        self.failIfExists('file')
+        self.failUnlessExists('new_name')
+
+    def test_move_unknown_file(self):
+        self.assertRaises(AssertionError,
+                          self.run_script, '$ mv unknown does-not-exist')
+
+    def test_move_dir(self):
+        self.run_script("""
+$ mkdir dir
+$ echo content >dir/file
+""")
+        self.run_script('$ mv dir new_name')
+        self.failIfExists('dir')
+        self.failUnlessExists('new_name')
+        self.failUnlessExists('new_name/file')
+
+    def test_move_file_into_dir(self):
+        self.run_script("""
+$ mkdir dir
+$ echo content > file
+""")
+        self.run_script('$ mv file dir')
+        self.failUnlessExists('dir')
+        self.failIfExists('file')
+        self.failUnlessExists('dir/file')
+

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2009-10-05 12:50:34 +0000
+++ bzrlib/tests/test_selftest.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 """Tests for the test framework."""
 
 from cStringIO import StringIO
+from doctest import ELLIPSIS
 import os
 import signal
 import sys
@@ -24,6 +25,14 @@
 import unittest
 import warnings
 
+from testtools import MultiTestResult
+from testtools.content_type import ContentType
+from testtools.matchers import (
+    DocTestMatches,
+    Equals,
+    )
+import testtools.tests.helpers
+
 import bzrlib
 from bzrlib import (
     branchbuilder,
@@ -52,7 +61,8 @@
     deprecated_method,
     )
 from bzrlib.tests import (
-    SubUnitFeature,
+    features,
+    stub_sftp,
     test_lsprof,
     test_sftp_transport,
     TestUtil,
@@ -78,14 +88,19 @@
                           TestUtil._load_module_by_name,
                           'bzrlib.no-name-yet')
 
+
 class MetaTestLog(tests.TestCase):
 
     def test_logging(self):
         """Test logs are captured when a test fails."""
         self.log('a test message')
-        self._log_file.flush()
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              'a test message\n')
+        details = self.getDetails()
+        log = details['log']
+        self.assertThat(log.content_type, Equals(ContentType(
+            "text", "plain", {"charset": "utf8"})))
+        self.assertThat(u"".join(log.iter_text()), Equals(self.get_log()))
+        self.assertThat(self.get_log(),
+            DocTestMatches(u"...a test message\n", ELLIPSIS))
 
 
 class TestUnicodeFilename(tests.TestCase):
@@ -490,9 +505,9 @@
         self.assertEqualStat(real, fake)
 
     def test_assertEqualStat_notequal(self):
-        self.build_tree(["foo", "bar"])
+        self.build_tree(["foo", "longname"])
         self.assertRaises(AssertionError, self.assertEqualStat,
-            os.lstat("foo"), os.lstat("bar"))
+            os.lstat("foo"), os.lstat("longname"))
 
 
 class TestTestCaseWithMemoryTransport(tests.TestCaseWithMemoryTransport):
@@ -516,6 +531,14 @@
         cwd = osutils.getcwd()
         self.assertIsSameRealPath(self.test_dir, cwd)
 
+    def test_BZR_HOME_and_HOME_are_bytestrings(self):
+        """The $BZR_HOME and $HOME environment variables should not be unicode.
+
+        See https://bugs.launchpad.net/bzr/+bug/464174
+        """
+        self.assertIsInstance(os.environ['BZR_HOME'], str)
+        self.assertIsInstance(os.environ['HOME'], str)
+
     def test_make_branch_and_memory_tree(self):
         """In TestCaseWithMemoryTransport we should not make the branch on disk.
 
@@ -679,7 +702,7 @@
 
     def test_profiles_tests(self):
         self.requireFeature(test_lsprof.LSProfFeature)
-        terminal = unittest.TestResult()
+        terminal = testtools.tests.helpers.ExtendedTestResult()
         result = tests.ProfileResult(terminal)
         class Sample(tests.TestCase):
             def a(self):
@@ -687,11 +710,11 @@
             def sample_function(self):
                 pass
         test = Sample("a")
-        test.attrs_to_keep = test.attrs_to_keep + ('_benchcalls',)
         test.run(result)
-        self.assertLength(1, test._benchcalls)
+        case = terminal._events[0][1]
+        self.assertLength(1, case._benchcalls)
         # We must be able to unpack it as the test reporting code wants
-        (_, _, _), stats = test._benchcalls[0]
+        (_, _, _), stats = case._benchcalls[0]
         self.assertTrue(callable(stats.pprint))
 
 
@@ -702,8 +725,10 @@
                 descriptions=0,
                 verbosity=1,
                 )
-        test_case.run(result)
-        timed_string = result._testTimeString(test_case)
+        capture = testtools.tests.helpers.ExtendedTestResult()
+        test_case.run(MultiTestResult(result, capture))
+        run_case = capture._events[0][1]
+        timed_string = result._testTimeString(run_case)
         self.assertContainsRe(timed_string, expected_re)
 
     def test_test_reporting(self):
@@ -824,18 +849,18 @@
             def stopTestRun(self): pass
             def startTests(self): pass
             def report_test_start(self, test): pass
-            def report_known_failure(self, test, err):
-                self._call = test, err
+            def report_known_failure(self, test, err=None, details=None):
+                self._call = test, 'known failure'
         result = InstrumentedTestResult(None, None, None, None)
-        def test_function():
-            raise tests.KnownFailure('failed!')
-        test = unittest.FunctionTestCase(test_function)
+        class Test(tests.TestCase):
+            def test_function(self):
+                raise tests.KnownFailure('failed!')
+        test = Test("test_function")
         test.run(result)
         # it should invoke 'report_known_failure'.
         self.assertEqual(2, len(result._call))
-        self.assertEqual(test, result._call[0])
-        self.assertEqual(tests.KnownFailure, result._call[1][0])
-        self.assertIsInstance(result._call[1][1], tests.KnownFailure)
+        self.assertEqual(test.id(), result._call[0].id())
+        self.assertEqual('known failure', result._call[1])
         # we dont introspec the traceback, if the rest is ok, it would be
         # exceptional for it not to be.
         # it should update the known_failure_count on the object.
@@ -913,8 +938,10 @@
         result.report_unsupported(test, feature)
         output = result_stream.getvalue()[prefix:]
         lines = output.splitlines()
-        self.assertEqual(lines, ['NODEP        0ms',
-                                 "    The feature 'Feature' is not available."])
+        # We don't check for the final '0ms' since it may fail on slow hosts
+        self.assertStartsWith(lines[0], 'NODEP')
+        self.assertEqual(lines[1],
+                         "    The feature 'Feature' is not available.")
 
     def test_unavailable_exception(self):
         """An UnavailableFeature being raised should invoke addNotSupported."""
@@ -926,13 +953,14 @@
                 self._call = test, feature
         result = InstrumentedTestResult(None, None, None, None)
         feature = tests.Feature()
-        def test_function():
-            raise tests.UnavailableFeature(feature)
-        test = unittest.FunctionTestCase(test_function)
+        class Test(tests.TestCase):
+            def test_function(self):
+                raise tests.UnavailableFeature(feature)
+        test = Test("test_function")
         test.run(result)
         # it should invoke 'addNotSupported'.
         self.assertEqual(2, len(result._call))
-        self.assertEqual(test, result._call[0])
+        self.assertEqual(test.id(), result._call[0].id())
         self.assertEqual(feature, result._call[1])
         # and not count as an error
         self.assertEqual(0, result.error_count)
@@ -951,7 +979,7 @@
                                              verbosity=1)
         test = self.get_passing_test()
         err = (tests.KnownFailure, tests.KnownFailure('foo'), None)
-        result._addKnownFailure(test, err)
+        result.addExpectedFailure(test, err)
         self.assertFalse(result.wasStrictlySuccessful())
         self.assertEqual(None, result._extractBenchmarkTime(test))
 
@@ -1014,26 +1042,27 @@
     def test_known_failure_failed_run(self):
         # run a test that generates a known failure which should be printed in
         # the final output when real failures occur.
-        def known_failure_test():
-            raise tests.KnownFailure('failed')
+        class Test(tests.TestCase):
+            def known_failure_test(self):
+                self.expectFailure('failed', self.assertTrue, False)
         test = unittest.TestSuite()
-        test.addTest(unittest.FunctionTestCase(known_failure_test))
+        test.addTest(Test("known_failure_test"))
         def failing_test():
-            raise AssertionError('foo')
+            self.fail('foo')
         test.addTest(unittest.FunctionTestCase(failing_test))
         stream = StringIO()
         runner = tests.TextTestRunner(stream=stream)
         result = self.run_test_runner(runner, test)
         lines = stream.getvalue().splitlines()
         self.assertContainsRe(stream.getvalue(),
-            '(?sm)^testing.*$'
+            '(?sm)^bzr selftest.*$'
             '.*'
             '^======================================================================\n'
-            '^FAIL: unittest.FunctionTestCase \\(failing_test\\)\n'
+            '^FAIL: failing_test\n'
             '^----------------------------------------------------------------------\n'
             'Traceback \\(most recent call last\\):\n'
             '  .*' # File .*, line .*, in failing_test' - but maybe not from .pyc
-            '    raise AssertionError\\(\'foo\'\\)\n'
+            '    self.fail\\(\'foo\'\\)\n'
             '.*'
             '^----------------------------------------------------------------------\n'
             '.*'
@@ -1041,10 +1070,12 @@
             )
 
     def test_known_failure_ok_run(self):
-        # run a test that generates a known failure which should be printed in the final output.
-        def known_failure_test():
-            raise tests.KnownFailure('failed')
-        test = unittest.FunctionTestCase(known_failure_test)
+        # run a test that generates a known failure which should be printed in
+        # the final output.
+        class Test(tests.TestCase):
+            def known_failure_test(self):
+                self.expectFailure('failed', self.assertTrue, False)
+        test = Test("known_failure_test")
         stream = StringIO()
         runner = tests.TextTestRunner(stream=stream)
         result = self.run_test_runner(runner, test)
@@ -1127,11 +1158,12 @@
 
     def test_not_applicable(self):
         # run a test that is skipped because it's not applicable
-        def not_applicable_test():
-            raise tests.TestNotApplicable('this test never runs')
+        class Test(tests.TestCase):
+            def not_applicable_test(self):
+                raise tests.TestNotApplicable('this test never runs')
         out = StringIO()
         runner = tests.TextTestRunner(stream=out, verbosity=2)
-        test = unittest.FunctionTestCase(not_applicable_test)
+        test = Test("not_applicable_test")
         result = self.run_test_runner(runner, test)
         self._log_file.write(out.getvalue())
         self.assertTrue(result.wasSuccessful())
@@ -1193,119 +1225,6 @@
         self.assertContainsRe(output_string, "--date [0-9.]+")
         self.assertLength(1, self._get_source_tree_calls)
 
-    def assertLogDeleted(self, test):
-        log = test._get_log()
-        self.assertEqual("DELETED log file to reduce memory footprint", log)
-        self.assertEqual('', test._log_contents)
-        self.assertIs(None, test._log_file_name)
-
-    def test_success_log_deleted(self):
-        """Successful tests have their log deleted"""
-
-        class LogTester(tests.TestCase):
-
-            def test_success(self):
-                self.log('this will be removed\n')
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_success')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_skipped_log_deleted(self):
-        """Skipped tests have their log deleted"""
-
-        class LogTester(tests.TestCase):
-
-            def test_skipped(self):
-                self.log('this will be removed\n')
-                raise tests.TestSkipped()
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_skipped')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_not_aplicable_log_deleted(self):
-        """Not applicable tests have their log deleted"""
-
-        class LogTester(tests.TestCase):
-
-            def test_not_applicable(self):
-                self.log('this will be removed\n')
-                raise tests.TestNotApplicable()
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_not_applicable')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_known_failure_log_deleted(self):
-        """Know failure tests have their log deleted"""
-
-        class LogTester(tests.TestCase):
-
-            def test_known_failure(self):
-                self.log('this will be removed\n')
-                raise tests.KnownFailure()
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_known_failure')
-        result = self.run_test_runner(runner, test)
-
-        self.assertLogDeleted(test)
-
-    def test_fail_log_kept(self):
-        """Failed tests have their log kept"""
-
-        class LogTester(tests.TestCase):
-
-            def test_fail(self):
-                self.log('this will be kept\n')
-                self.fail('this test fails')
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_fail')
-        result = self.run_test_runner(runner, test)
-
-        text = sio.getvalue()
-        self.assertContainsRe(text, 'this will be kept')
-        self.assertContainsRe(text, 'this test fails')
-
-        log = test._get_log()
-        self.assertContainsRe(log, 'this will be kept')
-        self.assertEqual(log, test._log_contents)
-
-    def test_error_log_kept(self):
-        """Tests with errors have their log kept"""
-
-        class LogTester(tests.TestCase):
-
-            def test_error(self):
-                self.log('this will be kept\n')
-                raise ValueError('random exception raised')
-
-        sio = StringIO()
-        runner = tests.TextTestRunner(stream=sio)
-        test = LogTester('test_error')
-        result = self.run_test_runner(runner, test)
-
-        text = sio.getvalue()
-        self.assertContainsRe(text, 'this will be kept')
-        self.assertContainsRe(text, 'random exception raised')
-
-        log = test._get_log()
-        self.assertContainsRe(log, 'this will be kept')
-        self.assertEqual(log, test._log_contents)
-
     def test_startTestRun(self):
         """run should call result.startTestRun()"""
         calls = []
@@ -1475,6 +1394,7 @@
         self.assertEqual(set(['original-state']), bzrlib.debug.debug_flags)
 
     def make_test_result(self):
+        """Get a test result that writes to the test log file."""
         return tests.TextTestResult(self._log_file, descriptions=0, verbosity=1)
 
     def inner_test(self):
@@ -1488,6 +1408,7 @@
         result = self.make_test_result()
         self.inner_test.run(result)
         note("outer finish")
+        self.addCleanup(osutils.delete_any, self._log_file_name)
 
     def test_trace_nesting(self):
         # this tests that each test case nests its trace facility correctly.
@@ -1505,7 +1426,6 @@
         outer_test = TestTestCase("outer_child")
         result = self.make_test_result()
         outer_test.run(result)
-        self.addCleanup(osutils.delete_any, outer_test._log_file_name)
         self.assertEqual(original_trace, bzrlib.trace._trace_file)
 
     def method_that_times_a_bit_twice(self):
@@ -1566,8 +1486,8 @@
         # Manually set one up (TestCase doesn't and shouldn't provide magic
         # machinery)
         transport_server = MemoryServer()
-        transport_server.setUp()
-        self.addCleanup(transport_server.tearDown)
+        transport_server.start_server()
+        self.addCleanup(transport_server.stop_server)
         t = transport.get_transport(transport_server.get_url())
         bzrdir.BzrDir.create(t.base)
         self.assertRaises(errors.BzrError,
@@ -1626,6 +1546,8 @@
         """Test disabled tests behaviour with support aware results."""
         test = SampleTestCase('_test_pass')
         class DisabledFeature(object):
+            def __eq__(self, other):
+                return isinstance(other, DisabledFeature)
             def available(self):
                 return False
         the_feature = DisabledFeature()
@@ -1642,10 +1564,11 @@
                 self.calls.append(('addNotSupported', test, feature))
         result = InstrumentedTestResult()
         test.run(result)
+        case = result.calls[0][1]
         self.assertEqual([
-            ('startTest', test),
-            ('addNotSupported', test, the_feature),
-            ('stopTest', test),
+            ('startTest', case),
+            ('addNotSupported', case, the_feature),
+            ('stopTest', case),
             ],
             result.calls)
 
@@ -1966,7 +1889,7 @@
         self.assertEqual(expected.getvalue(), repeated.getvalue())
 
     def test_runner_class(self):
-        self.requireFeature(SubUnitFeature)
+        self.requireFeature(features.subunit)
         from subunit import ProtocolTestCase
         stream = self.run_selftest(runner_class=tests.SubUnitBzrRunner,
             test_suite_factory=self.factory)
@@ -2004,11 +1927,8 @@
         self.assertEqual(transport_server, captured_transport[0])
 
     def test_transport_sftp(self):
-        try:
-            import bzrlib.transport.sftp
-        except errors.ParamikoNotPresent:
-            raise tests.TestSkipped("Paramiko not present")
-        self.check_transport_set(bzrlib.transport.sftp.SFTPAbsoluteServer)
+        self.requireFeature(features.paramiko)
+        self.check_transport_set(stub_sftp.SFTPAbsoluteServer)
 
     def test_transport_memory(self):
         self.check_transport_set(bzrlib.transport.memory.MemoryServer)
@@ -2418,28 +2338,6 @@
         self.assertEqual('bzr: interrupted\n', result[1])
 
 
-class TestKnownFailure(tests.TestCase):
-
-    def test_known_failure(self):
-        """Check that KnownFailure is defined appropriately."""
-        # a KnownFailure is an assertion error for compatability with unaware
-        # runners.
-        self.assertIsInstance(tests.KnownFailure(""), AssertionError)
-
-    def test_expect_failure(self):
-        try:
-            self.expectFailure("Doomed to failure", self.assertTrue, False)
-        except tests.KnownFailure, e:
-            self.assertEqual('Doomed to failure', e.args[0])
-        try:
-            self.expectFailure("Doomed to failure", self.assertTrue, True)
-        except AssertionError, e:
-            self.assertEqual('Unexpected success.  Should have failed:'
-                             ' Doomed to failure', e.args[0])
-        else:
-            self.fail('Assertion not raised')
-
-
 class TestFeature(tests.TestCase):
 
     def test_caching(self):
@@ -2481,6 +2379,37 @@
         self.assertIs(feature, exception.args[0])
 
 
+simple_thunk_feature = tests._CompatabilityThunkFeature(
+    'bzrlib.tests', 'UnicodeFilename',
+    'bzrlib.tests.test_selftest.simple_thunk_feature',
+    deprecated_in((2,1,0)))
+
+class Test_CompatibilityFeature(tests.TestCase):
+
+    def test_does_thunk(self):
+        res = self.callDeprecated(
+            ['bzrlib.tests.test_selftest.simple_thunk_feature was deprecated'
+             ' in version 2.1.0. Use bzrlib.tests.UnicodeFilename instead.'],
+            simple_thunk_feature.available)
+        self.assertEqual(tests.UnicodeFilename.available(), res)
+
+        
+class TestModuleAvailableFeature(tests.TestCase):
+
+    def test_available_module(self):
+        feature = tests.ModuleAvailableFeature('bzrlib.tests')
+        self.assertEqual('bzrlib.tests', feature.module_name)
+        self.assertEqual('bzrlib.tests', str(feature))
+        self.assertTrue(feature.available())
+        self.assertIs(tests, feature.module)
+
+    def test_unavailable_module(self):
+        feature = tests.ModuleAvailableFeature('bzrlib.no_such_module_exists')
+        self.assertEqual('bzrlib.no_such_module_exists', str(feature))
+        self.assertFalse(feature.available())
+        self.assertIs(None, feature.module)
+
+
 class TestSelftestFiltering(tests.TestCase):
 
     def setUp(self):
@@ -2665,16 +2594,15 @@
         # the test framework
         self.assertEquals('always fails', str(e))
         # check that there's no traceback in the test log
-        self.assertNotContainsRe(self._get_log(keep_log_file=True),
-            r'Traceback')
+        self.assertNotContainsRe(self.get_log(), r'Traceback')
 
     def test_run_bzr_user_error_caught(self):
         # Running bzr in blackbox mode, normal/expected/user errors should be
         # caught in the regular way and turned into an error message plus exit
         # code.
         transport_server = MemoryServer()
-        transport_server.setUp()
-        self.addCleanup(transport_server.tearDown)
+        transport_server.start_server()
+        self.addCleanup(transport_server.stop_server)
         url = transport_server.get_url()
         self.permit_url(url)
         out, err = self.run_bzr(["log", "%s/nonexistantpath" % url], retcode=3)
@@ -2925,14 +2853,12 @@
     def test_load_tests(self):
         test_list = ['bzrlib.tests.test_sampler.DemoTest.test_nothing']
         loader = self._create_loader(test_list)
-
         suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
         self.assertEquals(test_list, _test_ids(suite))
 
     def test_exclude_tests(self):
         test_list = ['bogus']
         loader = self._create_loader(test_list)
-
         suite = loader.loadTestsFromModuleName('bzrlib.tests.test_sampler')
         self.assertEquals([], _test_ids(suite))
 
@@ -2983,8 +2909,8 @@
         tpr.register('bar', 'bbb.aaa.rrr')
         tpr.register('bar', 'bBB.aAA.rRR')
         self.assertEquals('bbb.aaa.rrr', tpr.get('bar'))
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              r'.*bar.*bbb.aaa.rrr.*bBB.aAA.rRR')
+        self.assertThat(self.get_log(),
+            DocTestMatches("...bar...bbb.aaa.rrr...BB.aAA.rRR", ELLIPSIS))
 
     def test_get_unknown_prefix(self):
         tpr = self._get_registry()

=== modified file 'bzrlib/tests/test_sftp_transport.py'
--- bzrlib/tests/test_sftp_transport.py	2009-04-27 16:10:10 +0000
+++ bzrlib/tests/test_sftp_transport.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Robey Pointer <robey@lag.net>
+# Copyright (C) 2005-2010 Robey Pointer <robey@lag.net>
 # Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
@@ -21,12 +21,6 @@
 import threading
 import time
 
-try:
-    import paramiko
-    paramiko_loaded = True
-except ImportError:
-    paramiko_loaded = False
-
 from bzrlib import (
     bzrdir,
     config,
@@ -41,6 +35,7 @@
     set_or_unset_env,
     )
 from bzrlib.tests import (
+    features,
     TestCaseWithTransport,
     TestCase,
     TestSkipped,
@@ -49,13 +44,9 @@
 from bzrlib.transport import get_transport
 import bzrlib.transport.http
 
-if paramiko_loaded:
+if features.paramiko.available():
     from bzrlib.transport import sftp as _mod_sftp
-    from bzrlib.transport.sftp import (
-        SFTPAbsoluteServer,
-        SFTPHomeDirServer,
-        SFTPTransport,
-        )
+    from bzrlib.tests import stub_sftp
 
 from bzrlib.workingtree import WorkingTree
 
@@ -65,9 +56,9 @@
     if getattr(testcase, '_get_remote_is_absolute', None) is None:
         testcase._get_remote_is_absolute = True
     if testcase._get_remote_is_absolute:
-        testcase.transport_server = SFTPAbsoluteServer
+        testcase.transport_server = stub_sftp.SFTPAbsoluteServer
     else:
-        testcase.transport_server = SFTPHomeDirServer
+        testcase.transport_server = stub_sftp.SFTPHomeDirServer
     testcase.transport_readonly_server = HttpServer
 
 
@@ -76,8 +67,7 @@
 
     def setUp(self):
         super(TestCaseWithSFTPServer, self).setUp()
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
         set_test_transport_to_sftp(self)
 
 
@@ -165,11 +155,11 @@
 class SFTPNonServerTest(TestCase):
     def setUp(self):
         TestCase.setUp(self)
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
 
     def test_parse_url_with_home_dir(self):
-        s = SFTPTransport('sftp://ro%62ey:h%40t@example.com:2222/~/relative')
+        s = _mod_sftp.SFTPTransport(
+            'sftp://ro%62ey:h%40t@example.com:2222/~/relative')
         self.assertEquals(s._host, 'example.com')
         self.assertEquals(s._port, 2222)
         self.assertEquals(s._user, 'robey')
@@ -177,7 +167,7 @@
         self.assertEquals(s._path, '/~/relative/')
 
     def test_relpath(self):
-        s = SFTPTransport('sftp://user@host.com/abs/path')
+        s = _mod_sftp.SFTPTransport('sftp://user@host.com/abs/path')
         self.assertRaises(errors.PathNotChild, s.relpath,
                           'sftp://user@host.com/~/rel/path/sub')
 
@@ -197,16 +187,15 @@
             ssh._ssh_vendor_manager._cached_ssh_vendor = orig_vendor
 
     def test_abspath_root_sibling_server(self):
-        from bzrlib.transport.sftp import SFTPSiblingAbsoluteServer
-        server = SFTPSiblingAbsoluteServer()
-        server.setUp()
+        server = stub_sftp.SFTPSiblingAbsoluteServer()
+        server.start_server()
         try:
             transport = get_transport(server.get_url())
             self.assertFalse(transport.abspath('/').endswith('/~/'))
             self.assertTrue(transport.abspath('/').endswith('/'))
             del transport
         finally:
-            server.tearDown()
+            server.stop_server()
 
 
 class SFTPBranchTest(TestCaseWithSFTPServer):
@@ -262,14 +251,13 @@
 
     def setUp(self):
         super(SSHVendorConnection, self).setUp()
-        from bzrlib.transport.sftp import SFTPFullAbsoluteServer
 
         def create_server():
             """Just a wrapper so that when created, it will set _vendor"""
             # SFTPFullAbsoluteServer can handle any vendor,
             # it just needs to be set between the time it is instantiated
             # and the time .setUp() is called
-            server = SFTPFullAbsoluteServer()
+            server = stub_sftp.SFTPFullAbsoluteServer()
             server._vendor = self._test_vendor
             return server
         self._test_vendor = 'loopback'
@@ -307,8 +295,7 @@
     """
 
     def setUp(self):
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
         super(SSHVendorBadConnection, self).setUp()
         import bzrlib.transport.ssh
 
@@ -420,25 +407,23 @@
 
     def setUp(self):
         TestCase.setUp(self)
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
 
     def test_delay(self):
-        from bzrlib.transport.sftp import SocketDelay
         sending = FakeSocket()
-        receiving = SocketDelay(sending, 0.1, bandwidth=1000000,
-                                really_sleep=False)
+        receiving = stub_sftp.SocketDelay(sending, 0.1, bandwidth=1000000,
+                                          really_sleep=False)
         # check that simulated time is charged only per round-trip:
-        t1 = SocketDelay.simulated_time
+        t1 = stub_sftp.SocketDelay.simulated_time
         receiving.send("connect1")
         self.assertEqual(sending.recv(1024), "connect1")
-        t2 = SocketDelay.simulated_time
+        t2 = stub_sftp.SocketDelay.simulated_time
         self.assertAlmostEqual(t2 - t1, 0.1)
         receiving.send("connect2")
         self.assertEqual(sending.recv(1024), "connect2")
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
-        t3 = SocketDelay.simulated_time
+        t3 = stub_sftp.SocketDelay.simulated_time
         self.assertAlmostEqual(t3 - t2, 0.1)
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
@@ -446,21 +431,20 @@
         self.assertEqual(receiving.recv(1024), "hello")
         sending.send("hello")
         self.assertEqual(receiving.recv(1024), "hello")
-        t4 = SocketDelay.simulated_time
+        t4 = stub_sftp.SocketDelay.simulated_time
         self.assertAlmostEqual(t4, t3)
 
     def test_bandwidth(self):
-        from bzrlib.transport.sftp import SocketDelay
         sending = FakeSocket()
-        receiving = SocketDelay(sending, 0, bandwidth=8.0/(1024*1024),
-                                really_sleep=False)
+        receiving = stub_sftp.SocketDelay(sending, 0, bandwidth=8.0/(1024*1024),
+                                          really_sleep=False)
         # check that simulated time is charged only per round-trip:
-        t1 = SocketDelay.simulated_time
+        t1 = stub_sftp.SocketDelay.simulated_time
         receiving.send("connect")
         self.assertEqual(sending.recv(1024), "connect")
         sending.send("a" * 100)
         self.assertEqual(receiving.recv(1024), "a" * 100)
-        t2 = SocketDelay.simulated_time
+        t2 = stub_sftp.SocketDelay.simulated_time
         self.assertAlmostEqual(t2 - t1, 100 + 7)
 
 
@@ -482,8 +466,7 @@
 class Test_SFTPReadvHelper(tests.TestCase):
 
     def checkGetRequests(self, expected_requests, offsets):
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
         helper = _mod_sftp._SFTPReadvHelper(offsets, 'artificial_test',
             _null_report_activity)
         self.assertEqual(expected_requests, helper._get_requests())
@@ -503,8 +486,7 @@
                                (42000, 24000)])
 
     def checkRequestAndYield(self, expected, data, offsets):
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
+        self.requireFeature(features.paramiko)
         helper = _mod_sftp._SFTPReadvHelper(offsets, 'artificial_test',
             _null_report_activity)
         data_f = ReadvFile(data)

=== modified file 'bzrlib/tests/test_shelf.py'
--- bzrlib/tests/test_shelf.py	2009-09-11 07:55:48 +0000
+++ bzrlib/tests/test_shelf.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -108,6 +108,29 @@
         creator.shelve_change(('rename', 'baz-id', 'foo/baz', 'bar/baz'))
         self.check_shelve_move(creator, tree)
 
+    def test_shelve_changed_root_id(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['foo'])
+        tree.set_root_id('first-root-id')
+        tree.add(['foo'], ['foo-id'])
+        tree.commit('foo')
+        tree.set_root_id('second-root-id')
+        tree.lock_tree_write()
+        self.addCleanup(tree.unlock)
+        creator = shelf.ShelfCreator(tree, tree.basis_tree())
+        self.addCleanup(creator.finalize)
+        self.expectFailure('shelf doesn\'t support shelving root changes yet',
+            self.assertEqual, [
+                ('delete file', 'first-root-id', 'directory', ''),
+                ('add file', 'second-root-id', 'directory', ''),
+                ('rename', 'foo-id', u'foo', u'foo'),
+                ], list(creator.iter_shelvable()))
+
+        self.assertEqual([('delete file', 'first-root-id', 'directory', ''),
+                          ('add file', 'second-root-id', 'directory', ''),
+                          ('rename', 'foo-id', u'foo', u'foo'),
+                         ], list(creator.iter_shelvable()))
+
     def assertShelvedFileEqual(self, expected_content, creator, file_id):
         s_trans_id = creator.shelf_transform.trans_id_file_id(file_id)
         shelf_file = creator.shelf_transform._limbo_name(s_trans_id)

=== modified file 'bzrlib/tests/test_shelf_ui.py'
--- bzrlib/tests/test_shelf_ui.py	2009-09-11 07:55:48 +0000
+++ bzrlib/tests/test_shelf_ui.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 from cStringIO import StringIO
 import os
 import sys
+from textwrap import dedent
 
 from bzrlib import (
     errors,
@@ -25,6 +26,7 @@
     revision,
     tests,
 )
+from bzrlib.tests import script
 
 
 class ExpectShelver(shelf_ui.Shelver):
@@ -76,6 +78,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         e = self.assertRaises(AssertionError, shelver.run)
         self.assertEqual('Unexpected prompt: Shelve? [yNfq?]', str(e))
 
@@ -84,6 +87,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('foo', 'y')
         e = self.assertRaises(AssertionError, shelver.run)
         self.assertEqual('Wrong prompt: Shelve? [yNfq?]', str(e))
@@ -93,6 +97,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'n')
         shelver.expect('Shelve? [yNfq?]', 'n')
         # No final shelving prompt because no changes were selected
@@ -104,6 +109,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve 2 change(s)? [yNfq?]', 'n')
@@ -115,6 +121,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve 2 change(s)? [yNfq?]', 'y')
@@ -126,6 +133,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve? [yNfq?]', 'n')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
@@ -138,6 +146,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve binary changes? [yNfq?]', 'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -149,6 +158,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve renaming "foo" => "bar"? [yNfq?]', 'y')
         shelver.expect('Shelve? [yNfq?]', 'y')
         shelver.expect('Shelve? [yNfq?]', 'y')
@@ -162,6 +172,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve removing file "foo"? [yNfq?]', 'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -175,6 +186,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve adding file "foo"? [yNfq?]', 'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -187,6 +199,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve changing "foo" from file to directory? [yNfq?]',
                        'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
@@ -202,6 +215,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve changing target of "baz" from "bar" to '
                 '"vax"? [yNfq?]', 'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
@@ -213,6 +227,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'f')
         shelver.expect('Shelve 2 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -223,6 +238,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', 'q')
         self.assertRaises(errors.UserAbort, shelver.run)
         self.assertFileEqual(LINES_ZY, 'tree/foo')
@@ -234,7 +250,7 @@
         try:
             shelver.run()
         finally:
-            shelver.work_tree.unlock()
+            shelver.finalize()
         self.assertFileEqual(LINES_AJ, 'tree/foo')
 
     def test_shelve_filename(self):
@@ -244,6 +260,7 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(), file_list=['bar'])
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve adding file "bar"? [yNfq?]', 'y')
         shelver.expect('Shelve 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -253,19 +270,18 @@
         tree.lock_tree_write()
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Shelve? [yNfq?]', '?')
         shelver.expect('Shelve? [(y)es, (N)o, (f)inish, or (q)uit]', 'f')
         shelver.expect('Shelve 2 change(s)? [yNfq?]', 'y')
         shelver.run()
 
-    def test_shelve_distroy(self):
+    def test_shelve_destroy(self):
         tree = self.create_shelvable_tree()
         shelver = shelf_ui.Shelver.from_args(sys.stdout, all=True,
                                              directory='tree', destroy=True)
-        try:
-            shelver.run()
-        finally:
-            shelver.work_tree.unlock()
+        self.addCleanup(shelver.finalize)
+        shelver.run()
         self.assertIs(None, tree.get_shelf_manager().last_shelf())
         self.assertFileEqual(LINES_AJ, 'tree/foo')
 
@@ -276,7 +292,10 @@
             target = tree.branch.repository.revision_tree(target_revision_id)
             shelver = shelf_ui.Shelver(tree, target, auto=True,
                                        auto_apply=True)
-            shelver.run()
+            try:
+                shelver.run()
+            finally:
+                shelver.finalize()
         finally:
             tree.unlock()
 
@@ -316,6 +335,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Apply change? [yNfq?]', 'n')
         shelver.expect('Apply change? [yNfq?]', 'n')
         # No final shelving prompt because no changes were selected
@@ -328,6 +348,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Apply change? [yNfq?]', 'y')
         shelver.expect('Apply change? [yNfq?]', 'y')
         shelver.expect('Apply 2 change(s)? [yNfq?]', 'n')
@@ -340,6 +361,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Apply change? [yNfq?]', 'y')
         shelver.expect('Apply change? [yNfq?]', 'y')
         shelver.expect('Apply 2 change(s)? [yNfq?]', 'y')
@@ -353,6 +375,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Apply binary changes? [yNfq?]', 'y')
         shelver.expect('Apply 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -365,6 +388,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Rename "bar" => "foo"? [yNfq?]', 'y')
         shelver.expect('Apply change? [yNfq?]', 'y')
         shelver.expect('Apply change? [yNfq?]', 'y')
@@ -379,6 +403,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Add file "foo"? [yNfq?]', 'y')
         shelver.expect('Apply 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -393,6 +418,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Delete file "foo"? [yNfq?]', 'y')
         shelver.expect('Apply 1 change(s)? [yNfq?]', 'y')
         shelver.run()
@@ -406,6 +432,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Change "foo" from directory to a file? [yNfq?]', 'y')
         shelver.expect('Apply 1 change(s)? [yNfq?]', 'y')
 
@@ -421,6 +448,7 @@
         self.addCleanup(tree.unlock)
         shelver = ExpectShelver(tree, tree.basis_tree(),
                                 reporter=shelf_ui.ApplyReporter())
+        self.addCleanup(shelver.finalize)
         shelver.expect('Change target of "baz" from "vax" to "bar"? [yNfq?]',
                        'y')
         shelver.expect('Apply 1 change(s)? [yNfq?]', 'y')
@@ -438,8 +466,12 @@
             tree.add('foo', 'foo-id')
             tree.commit('added foo')
             self.build_tree_contents([('tree/foo', LINES_ZY)])
-            shelf_ui.Shelver(tree, tree.basis_tree(), auto_apply=True,
-                             auto=True).run()
+            shelver = shelf_ui.Shelver(tree, tree.basis_tree(),
+                                       auto_apply=True, auto=True)
+            try:
+                shelver.run()
+            finally:
+                shelver.finalize()
         finally:
             tree.unlock()
         return tree
@@ -473,6 +505,38 @@
         self.assertFileEqual(LINES_AJ, 'tree/foo')
         self.assertEqual(1, tree.get_shelf_manager().last_shelf())
 
+    def test_unshelve_args_preview(self):
+        tree = self.create_tree_with_shelf()
+        write_diff_to = StringIO()
+        unshelver = shelf_ui.Unshelver.from_args(
+            directory='tree', action='preview', write_diff_to=write_diff_to)
+        try:
+            unshelver.run()
+        finally:
+            unshelver.tree.unlock()
+        # The changes were not unshelved.
+        self.assertFileEqual(LINES_AJ, 'tree/foo')
+        self.assertEqual(1, tree.get_shelf_manager().last_shelf())
+
+        # But the diff was written to write_diff_to.
+        diff = write_diff_to.getvalue()
+        expected = dedent("""\
+            @@ -1,4 +1,4 @@
+            -a
+            +z
+             b
+             c
+             d
+            @@ -7,4 +7,4 @@
+             g
+             h
+             i
+            -j
+            +y
+
+            """)
+        self.assertEqualDiff(expected, diff[-len(expected):])
+
     def test_unshelve_args_delete_only(self):
         tree = self.make_branch_and_tree('tree')
         manager = tree.get_shelf_manager()
@@ -500,3 +564,45 @@
         self.assertRaises(errors.InvalidShelfId,
             shelf_ui.Unshelver.from_args, directory='tree',
             action='delete-only', shelf_id='foo')
+
+
+class TestUnshelveScripts(TestUnshelver, 
+                          script.TestCaseWithTransportAndScript): 
+
+    def test_unshelve_messages_keep(self):
+        self.create_tree_with_shelf()
+        self.run_script("""
+$ cd tree
+$ bzr unshelve --keep
+2>Using changes with id "1".
+2> M  foo
+2>All changes applied successfully.
+""")
+
+    def test_unshelve_messages_delete(self):
+        self.create_tree_with_shelf()
+        self.run_script("""
+$ cd tree
+$ bzr unshelve --delete-only
+2>Deleted changes with id "1".
+""")
+
+    def test_unshelve_messages_apply(self):
+        self.create_tree_with_shelf()
+        self.run_script("""
+$ cd tree
+$ bzr unshelve --apply
+2>Using changes with id "1".
+2> M  foo
+2>All changes applied successfully.
+2>Deleted changes with id "1".
+""")
+
+    def test_unshelve_messages_dry_run(self):
+        self.create_tree_with_shelf()
+        self.run_script("""
+$ cd tree
+$ bzr unshelve --dry-run
+2>Using changes with id "1".
+2> M  foo
+""")

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2009-09-24 05:31:23 +0000
+++ bzrlib/tests/test_smart.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -43,6 +43,7 @@
 import bzrlib.smart.bzrdir, bzrlib.smart.bzrdir as smart_dir
 import bzrlib.smart.packrepository
 import bzrlib.smart.repository
+import bzrlib.smart.vfs
 from bzrlib.smart.request import (
     FailedSmartServerResponse,
     SmartServerRequest,
@@ -170,6 +171,18 @@
         self.assertRaises(
             errors.PathNotChild, request.translate_client_path, 'bar/')
         self.assertEqual('./baz', request.translate_client_path('foo/baz'))
+        e_acute = u'\N{LATIN SMALL LETTER E WITH ACUTE}'.encode('utf-8')
+        self.assertEqual('./' + urlutils.escape(e_acute),
+                         request.translate_client_path('foo/' + e_acute))
+
+    def test_translate_client_path_vfs(self):
+        """VfsRequests receive escaped paths rather than raw UTF-8."""
+        transport = self.get_transport()
+        request = smart.vfs.VfsRequest(transport, 'foo/')
+        e_acute = u'\N{LATIN SMALL LETTER E WITH ACUTE}'.encode('utf-8')
+        escaped = urlutils.escape('foo/' + e_acute)
+        self.assertEqual('./' + urlutils.escape(e_acute),
+                         request.translate_client_path(escaped))
 
     def test_transport_from_client_path(self):
         transport = self.get_transport()
@@ -511,6 +524,14 @@
         self.assertEqual(SmartServerResponse(('ok', reference_url)),
             request.execute('reference'))
 
+    def test_notification_on_branch_from_repository(self):
+        """When there is a repository, the error should return details."""
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranch(backing)
+        repo = self.make_repository('.')
+        self.assertEqual(SmartServerResponse(('nobranch',)),
+            request.execute(''))
+
 
 class TestSmartServerRequestOpenBranchV2(TestCaseWithChrootedTransport):
 
@@ -562,6 +583,74 @@
             response)
         self.assertLength(1, opened_branches)
 
+    def test_notification_on_branch_from_repository(self):
+        """When there is a repository, the error should return details."""
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV2(backing)
+        repo = self.make_repository('.')
+        self.assertEqual(SmartServerResponse(('nobranch',)),
+            request.execute(''))
+
+
+class TestSmartServerRequestOpenBranchV3(TestCaseWithChrootedTransport):
+
+    def test_no_branch(self):
+        """When there is no branch, ('nobranch', ) is returned."""
+        backing = self.get_transport()
+        self.make_bzrdir('.')
+        request = smart.bzrdir.SmartServerRequestOpenBranchV3(backing)
+        self.assertEqual(SmartServerResponse(('nobranch',)),
+            request.execute(''))
+
+    def test_branch(self):
+        """When there is a branch, 'ok' is returned."""
+        backing = self.get_transport()
+        expected = self.make_branch('.')._format.network_name()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV3(backing)
+        self.assertEqual(SuccessfulSmartServerResponse(('branch', expected)),
+            request.execute(''))
+
+    def test_branch_reference(self):
+        """When there is a branch reference, the reference URL is returned."""
+        self.vfs_transport_factory = local.LocalURLServer
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV3(backing)
+        branch = self.make_branch('branch')
+        checkout = branch.create_checkout('reference',lightweight=True)
+        reference_url = BranchReferenceFormat().get_reference(checkout.bzrdir)
+        self.assertFileEqual(reference_url, 'reference/.bzr/branch/location')
+        self.assertEqual(SuccessfulSmartServerResponse(('ref', reference_url)),
+            request.execute('reference'))
+
+    def test_stacked_branch(self):
+        """Opening a stacked branch does not open the stacked-on branch."""
+        trunk = self.make_branch('trunk')
+        feature = self.make_branch('feature')
+        feature.set_stacked_on_url(trunk.base)
+        opened_branches = []
+        Branch.hooks.install_named_hook('open', opened_branches.append, None)
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV3(backing)
+        request.setup_jail()
+        try:
+            response = request.execute('feature')
+        finally:
+            request.teardown_jail()
+        expected_format = feature._format.network_name()
+        self.assertEqual(
+            SuccessfulSmartServerResponse(('branch', expected_format)),
+            response)
+        self.assertLength(1, opened_branches)
+
+    def test_notification_on_branch_from_repository(self):
+        """When there is a repository, the error should return details."""
+        backing = self.get_transport()
+        request = smart.bzrdir.SmartServerRequestOpenBranchV3(backing)
+        repo = self.make_repository('.')
+        self.assertEqual(
+            SmartServerResponse(('nobranch', 'location is a repository')),
+            request.execute(''))
+
 
 class TestSmartServerRequestRevisionHistory(tests.TestCaseWithMemoryTransport):
 
@@ -1690,6 +1779,19 @@
         self.assertEqual(SmartServerResponse(('ok',)), response)
 
 
+class TestSmartServerVfsGet(tests.TestCaseWithMemoryTransport):
+
+    def test_unicode_path(self):
+        """VFS requests expect unicode paths to be escaped."""
+        filename = u'foo\N{INTERROBANG}'
+        filename_escaped = urlutils.escape(filename)
+        backing = self.get_transport()
+        request = smart.vfs.GetRequest(backing)
+        backing.put_bytes_non_atomic(filename_escaped, 'contents')
+        self.assertEqual(SmartServerResponse(('ok', ), 'contents'),
+            request.execute(filename_escaped))
+
+
 class TestHandlers(tests.TestCase):
     """Tests for the request.request_handlers object."""
 
@@ -1745,6 +1847,8 @@
             smart.bzrdir.SmartServerRequestOpenBranch)
         self.assertHandlerEqual('BzrDir.open_branchV2',
             smart.bzrdir.SmartServerRequestOpenBranchV2)
+        self.assertHandlerEqual('BzrDir.open_branchV3',
+            smart.bzrdir.SmartServerRequestOpenBranchV3)
         self.assertHandlerEqual('PackRepository.autopack',
             smart.packrepository.SmartServerPackRepositoryAutopack)
         self.assertHandlerEqual('Repository.gather_stats',

=== modified file 'bzrlib/tests/test_smart_transport.py'
--- bzrlib/tests/test_smart_transport.py	2009-09-24 05:31:23 +0000
+++ bzrlib/tests/test_smart_transport.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -657,8 +657,10 @@
         # wire-to-wire, using the whole stack, with a UTF-8 filename.
         transport = memory.MemoryTransport('memory:///')
         utf8_filename = u'testfile\N{INTERROBANG}'.encode('utf-8')
+        # VFS requests use filenames, not raw UTF-8.
+        hpss_path = urlutils.escape(utf8_filename)
         transport.put_bytes(utf8_filename, 'contents\nof\nfile\n')
-        to_server = StringIO('get\001' + utf8_filename + '\n')
+        to_server = StringIO('get\001' + hpss_path + '\n')
         from_server = StringIO()
         server = medium.SmartServerPipeStreamMedium(
             to_server, from_server, transport)
@@ -985,10 +987,10 @@
     All of these tests are run with a server running on another thread serving
     a MemoryTransport, and a connection to it already open.
 
-    the server is obtained by calling self.setUpServer(readonly=False).
+    the server is obtained by calling self.start_server(readonly=False).
     """
 
-    def setUpServer(self, readonly=False, backing_transport=None):
+    def start_server(self, readonly=False, backing_transport=None):
         """Setup the server.
 
         :param readonly: Create a readonly server.
@@ -998,8 +1000,8 @@
         # self.vfs_transport_factory etc.
         if not backing_transport:
             mem_server = memory.MemoryServer()
-            mem_server.setUp()
-            self.addCleanup(mem_server.tearDown)
+            mem_server.start_server()
+            self.addCleanup(mem_server.stop_server)
             self.permit_url(mem_server.get_url())
             self.backing_transport = get_transport(mem_server.get_url())
         else:
@@ -1019,6 +1021,7 @@
             del self.transport
         if getattr(self, 'server', None):
             self.server.stop_background_thread()
+            # XXX: why not .stop_server() -- mbp 20100106
             del self.server
 
 
@@ -1026,7 +1029,7 @@
 
     def test_server_setup_teardown(self):
         """It should be safe to teardown the server with no requests."""
-        self.setUpServer()
+        self.start_server()
         server = self.server
         transport = remote.RemoteTCPTransport(self.server.get_url())
         self.tearDownServer()
@@ -1034,7 +1037,7 @@
 
     def test_server_closes_listening_sock_on_shutdown_after_request(self):
         """The server should close its listening socket when it's stopped."""
-        self.setUpServer()
+        self.start_server()
         server = self.server
         self.transport.has('.')
         self.tearDownServer()
@@ -1049,7 +1052,7 @@
 
     def setUp(self):
         super(WritableEndToEndTests, self).setUp()
-        self.setUpServer()
+        self.start_server()
 
     def test_start_tcp_server(self):
         url = self.server.get_url()
@@ -1128,7 +1131,7 @@
     def test_mkdir_error_readonly(self):
         """TransportNotPossible should be preserved from the backing transport."""
         self._captureVar('BZR_NO_SMART_VFS', None)
-        self.setUpServer(readonly=True)
+        self.start_server(readonly=True)
         self.assertRaises(errors.TransportNotPossible, self.transport.mkdir,
             'foo')
 
@@ -1144,7 +1147,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_started',
             self.capture_server_call, None)
-        self.setUpServer()
+        self.start_server()
         # at this point, the server will be starting a thread up.
         # there is no indicator at the moment, so bodge it by doing a request.
         self.transport.has('.')
@@ -1158,7 +1161,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_started',
             self.capture_server_call, None)
-        self.setUpServer(backing_transport=get_transport("."))
+        self.start_server(backing_transport=get_transport("."))
         # at this point, the server will be starting a thread up.
         # there is no indicator at the moment, so bodge it by doing a request.
         self.transport.has('.')
@@ -1174,7 +1177,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_stopped',
             self.capture_server_call, None)
-        self.setUpServer()
+        self.start_server()
         result = [([self.backing_transport.base], self.transport.base)]
         # check the stopping message isn't emitted up front.
         self.assertEqual([], self.hook_calls)
@@ -1191,7 +1194,7 @@
         self.hook_calls = []
         server.SmartTCPServer.hooks.install_named_hook('server_stopped',
             self.capture_server_call, None)
-        self.setUpServer(backing_transport=get_transport("."))
+        self.start_server(backing_transport=get_transport("."))
         result = [(
             [self.backing_transport.base, self.backing_transport.external_url()]
             , self.transport.base)]
@@ -2890,18 +2893,16 @@
         self.assertWriteCount(1)
 
     def test_send_response_with_body_stream_flushes_buffers_sometimes(self):
-        """When there are many chunks (>100), multiple writes will occur rather
+        """When there are many bytes (>1MB), multiple writes will occur rather
         than buffering indefinitely.
         """
-        # Construct a response with stream with 40 chunks in it.  Every chunk
-        # triggers 3 buffered writes, so we expect > 100 buffered writes, but <
-        # 200.
-        body_stream = ['chunk %d' % count for count in range(40)]
+        # Construct a response with stream with ~1.5MB in it. This should
+        # trigger 2 writes, but not 3
+        onekib = '12345678' * 128
+        body_stream = [onekib] * (1024 + 512)
         response = _mod_request.SuccessfulSmartServerResponse(
             ('arg', 'arg'), body_stream=body_stream)
         self.responder.send_response(response)
-        # The write buffer is flushed every 100 buffered writes, so we expect 2
-        # actual writes.
         self.assertWriteCount(2)
 
 

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2009-09-17 19:16:58 +0000
+++ bzrlib/tests/test_source.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -372,3 +372,53 @@
             self.fail(
                 "these files contain an assert statement and should not:\n%s"
                 % '\n'.join(badfiles))
+
+    def test_extension_exceptions(self):
+        """Extension functions should propagate exceptions.
+
+        Either they should return an object, have an 'except' clause, or have a
+        "# cannot_raise" to indicate that we've audited them and defined them as not
+        raising exceptions.
+        """
+        both_exc_and_no_exc = []
+        missing_except = []
+        class_re = re.compile(r'^(cdef\s+)?(public\s+)?(api\s+)?class (\w+).*:',
+                              re.MULTILINE)
+        except_re = re.compile(r'cdef\s+' # start with cdef
+                               r'([\w *]*?)\s*' # this is the return signature
+                               r'(\w+)\s*\(' # the function name
+                               r'[^)]*\)\s*' # parameters
+                               r'(.*)\s*:' # the except clause
+                               r'\s*(#\s*cannot[- _]raise)?' # cannot raise comment
+                              )
+        for fname, text in self.get_source_file_contents(
+                extensions=('.pyx',)):
+            known_classes = set([m[-1] for m in class_re.findall(text)])
+            cdefs = except_re.findall(text)
+            for sig, func, exc_clause, no_exc_comment in cdefs:
+                if sig.startswith('api '):
+                    sig = sig[4:]
+                if not sig or sig in known_classes:
+                    sig = 'object'
+                if 'nogil' in exc_clause:
+                    exc_clause = exc_clause.replace('nogil', '').strip()
+                if exc_clause and no_exc_comment:
+                    both_exc_and_no_exc.append((fname, func))
+                if sig != 'object' and not (exc_clause or no_exc_comment):
+                    missing_except.append((fname, func))
+        error_msg = []
+        if both_exc_and_no_exc:
+            error_msg.append('The following functions had "cannot raise" comments'
+                             ' but did have an except clause set:')
+            for fname, func in both_exc_and_no_exc:
+                error_msg.append('%s:%s' % (fname, func))
+            error_msg.extend(('', ''))
+        if missing_except:
+            error_msg.append('The following functions have fixed return types,'
+                             ' but no except clause.')
+            error_msg.append('Either add an except or append "# cannot_raise".')
+            for fname, func in missing_except:
+                error_msg.append('%s:%s' % (fname, func))
+            error_msg.extend(('', ''))
+        if error_msg:
+            self.fail('\n'.join(error_msg))

=== modified file 'bzrlib/tests/test_ssh_transport.py'
--- bzrlib/tests/test_ssh_transport.py	2009-08-28 05:00:33 +0000
+++ bzrlib/tests/test_ssh_transport.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -132,6 +132,25 @@
         # Last cached value always checked first
         self.assertIs(manager.get_vendor({}), vendor)
 
+    def test_get_vendor_from_path_win32_plink(self):
+        manager = TestSSHVendorManager()
+        manager.set_ssh_version_string("plink: Release 0.60")
+        plink_path = "C:/Program Files/PuTTY/plink.exe"
+        vendor = manager.get_vendor({"BZR_SSH": plink_path})
+        self.assertIsInstance(vendor, PLinkSubprocessVendor)
+        args = vendor._get_vendor_specific_argv("user", "host", 22, ["bzr"])
+        self.assertEqual(args[0], plink_path)
+
+    def test_get_vendor_from_path_nix_openssh(self):
+        manager = TestSSHVendorManager()
+        manager.set_ssh_version_string(
+            "OpenSSH_5.1p1 Debian-5, OpenSSL, 0.9.8g 19 Oct 2007")
+        openssh_path = "/usr/bin/ssh"
+        vendor = manager.get_vendor({"BZR_SSH": openssh_path})
+        self.assertIsInstance(vendor, OpenSSHSubprocessVendor)
+        args = vendor._get_vendor_specific_argv("user", "host", 22, ["bzr"])
+        self.assertEqual(args[0], openssh_path)
+
 
 class SubprocessVendorsTests(TestCase):
 

=== modified file 'bzrlib/tests/test_switch.py'
--- bzrlib/tests/test_switch.py	2009-05-07 05:08:46 +0000
+++ bzrlib/tests/test_switch.py	2010-01-15 04:05:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -100,6 +100,35 @@
         self.assertContainsRe(str(err),
             "Pending merges must be committed or reverted before using switch")
 
+    def test_switch_with_revision(self):
+        """Test switch when a revision is given."""
+        # Create a tree with 2 revisions
+        tree = self.make_branch_and_tree('branch-1')
+        self.build_tree(['branch-1/file-1'])
+        tree.add('file-1')
+        tree.commit(rev_id='rev1', message='rev1')
+        self.build_tree(['branch-1/file-2'])
+        tree.add('file-2')
+        tree.commit(rev_id='rev2', message='rev2')
+        # Check it out and switch to revision 1
+        checkout = tree.branch.create_checkout('checkout',
+            lightweight=self.lightweight)
+        switch.switch(checkout.bzrdir, tree.branch, revision_id="rev1")
+        self.failUnlessExists('checkout/file-1')
+        self.failIfExists('checkout/file-2')
+
+    def test_switch_changing_root_id(self):
+        tree = self._setup_tree()
+        tree2 = self.make_branch_and_tree('tree-2')
+        tree2.set_root_id('custom-root-id')
+        self.build_tree(['tree-2/file-2'])
+        tree2.add(['file-2'])
+        tree2.commit('rev1b')
+        checkout = tree.branch.create_checkout('checkout',
+            lightweight=self.lightweight)
+        switch.switch(checkout.bzrdir, tree2.branch)
+        self.assertEqual('custom-root-id', tree2.get_root_id())
+
 
 class TestSwitchHeavyweight(TestSwitch):
 

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2009-09-03 02:59:56 +0000
+++ bzrlib/tests/test_trace.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,7 @@
 
 from bzrlib import (
     errors,
+    trace,
     )
 from bzrlib.tests import TestCaseInTempDir, TestCase
 from bzrlib.trace import (
@@ -84,11 +85,12 @@
     def test_format_os_error(self):
         try:
             os.rmdir('nosuchfile22222')
-        except OSError:
-            pass
+        except OSError, e:
+            e_str = str(e)
         msg = _format_exception()
-        self.assertContainsRe(msg,
-            r'^bzr: ERROR: \[Errno .*\] No such file.*nosuchfile22222')
+        # Linux seems to give "No such file" but Windows gives "The system
+        # cannot find the file specified".
+        self.assertEqual('bzr: ERROR: %s\n' % (e_str,), msg)
 
     def test_format_io_error(self):
         try:
@@ -96,7 +98,10 @@
         except IOError:
             pass
         msg = _format_exception()
-        self.assertContainsRe(msg, r'^bzr: ERROR: \[Errno .*\] No such file.*nosuchfile')
+        # Even though Windows and Linux differ for 'os.rmdir', they both give
+        # 'No such file' for open()
+        self.assertContainsRe(msg,
+            r'^bzr: ERROR: \[Errno .*\] No such file.*nosuchfile')
 
     def test_format_unicode_error(self):
         try:
@@ -140,21 +145,21 @@
     def test_trace_unicode(self):
         """Write Unicode to trace log"""
         self.log(u'the unicode character for benzene is \N{BENZENE RING}')
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              "the unicode character for benzene is")
+        log = self.get_log()
+        self.assertContainsRe(log, "the unicode character for benzene is")
 
     def test_trace_argument_unicode(self):
         """Write a Unicode argument to the trace log"""
         mutter(u'the unicode character for benzene is %s', u'\N{BENZENE RING}')
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              'the unicode character')
+        log = self.get_log()
+        self.assertContainsRe(log, 'the unicode character')
 
     def test_trace_argument_utf8(self):
         """Write a Unicode argument to the trace log"""
         mutter(u'the unicode character for benzene is %s',
                u'\N{BENZENE RING}'.encode('utf-8'))
-        self.assertContainsRe(self._get_log(keep_log_file=True),
-                              'the unicode character')
+        log = self.get_log()
+        self.assertContainsRe(log, 'the unicode character')
 
     def test_report_broken_pipe(self):
         try:
@@ -173,7 +178,7 @@
     def test_mutter_callsite_1(self):
         """mutter_callsite can capture 1 level of stack frame."""
         mutter_callsite(1, "foo %s", "a string")
-        log = self._get_log(keep_log_file=True)
+        log = self.get_log()
         # begin with the message
         self.assertLogStartsWith(log, 'foo a string\nCalled from:\n')
         # should show two frame: this frame and the one above
@@ -185,7 +190,7 @@
     def test_mutter_callsite_2(self):
         """mutter_callsite can capture 2 levels of stack frame."""
         mutter_callsite(2, "foo %s", "a string")
-        log = self._get_log(keep_log_file=True)
+        log = self.get_log()
         # begin with the message
         self.assertLogStartsWith(log, 'foo a string\nCalled from:\n')
         # should show two frame: this frame and the one above
@@ -197,13 +202,19 @@
     def test_mutter_never_fails(self):
         # Even if the decode/encode stage fails, mutter should not
         # raise an exception
+        # This test checks that mutter doesn't fail; the current behaviour
+        # is that it doesn't fail *and writes non-utf8*.
         mutter(u'Writing a greek mu (\xb5) works in a unicode string')
         mutter('But fails in an ascii string \xb5')
         mutter('and in an ascii argument: %s', '\xb5')
-        log = self._get_log(keep_log_file=True)
+        log = self.get_log()
         self.assertContainsRe(log, 'Writing a greek mu')
         self.assertContainsRe(log, "But fails in an ascii string")
-        self.assertContainsRe(log, u"ascii argument: \xb5")
+        # However, the log content object does unicode replacement on reading
+        # to let it get unicode back where good data has been written. So we
+        # have to do a replaceent here as well.
+        self.assertContainsRe(log, "ascii argument: \xb5".decode('utf8',
+            'replace'))
 
     def test_push_log_file(self):
         """Can push and pop log file, and this catches mutter messages.
@@ -238,6 +249,20 @@
             tmp1.close()
             tmp2.close()
 
+    def test__open_bzr_log_uses_stderr_for_failures(self):
+        # If _open_bzr_log cannot open the file, then we should write the
+        # warning to stderr. Since this is normally happening before logging is
+        # set up.
+        self.addCleanup(setattr, sys, 'stderr', sys.stderr)
+        self.addCleanup(setattr, trace, '_bzr_log_filename',
+                        trace._bzr_log_filename)
+        sys.stderr = StringIO()
+        # Set the log file to something that cannot exist
+        os.environ['BZR_LOG'] = os.getcwd() + '/no-dir/bzr.log'
+        logf = trace._open_bzr_log()
+        self.assertIs(None, logf)
+        self.assertContainsRe(sys.stderr.getvalue(),
+                              'failed to open trace file: .*/no-dir/bzr.log')
 
 class TestVerbosityLevel(TestCase):
 
@@ -268,7 +293,7 @@
     def test_log_rollover(self):
         temp_log_name = 'test-log'
         trace_file = open(temp_log_name, 'at')
-        trace_file.write('test_log_rollover padding\n' * 1000000)
+        trace_file.writelines(['test_log_rollover padding\n'] * 200000)
         trace_file.close()
         _rollover_trace_maybe(temp_log_name)
         # should have been rolled over

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2009-10-16 15:25:24 +0000
+++ bzrlib/tests/test_transform.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,18 +15,19 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import os
-import stat
 from StringIO import StringIO
 import sys
+import time
 
 from bzrlib import (
     bencode,
     errors,
+    filters,
     generate_ids,
     osutils,
     progress,
     revision as _mod_revision,
-    symbol_versioning,
+    rules,
     tests,
     urlutils,
     )
@@ -136,6 +137,59 @@
         transform.finalize()
         transform.finalize()
 
+    def test_create_files_same_timestamp(self):
+        transform, root = self.get_transform()
+        self.wt.lock_tree_write()
+        self.addCleanup(self.wt.unlock)
+        # Roll back the clock, so that we know everything is being set to the
+        # exact time
+        transform._creation_mtime = creation_mtime = time.time() - 20.0
+        transform.create_file('content-one',
+                              transform.create_path('one', root))
+        time.sleep(1) # *ugly*
+        transform.create_file('content-two',
+                              transform.create_path('two', root))
+        transform.apply()
+        fo, st1 = self.wt.get_file_with_stat(None, path='one', filtered=False)
+        fo.close()
+        fo, st2 = self.wt.get_file_with_stat(None, path='two', filtered=False)
+        fo.close()
+        # We only guarantee 2s resolution
+        self.assertTrue(abs(creation_mtime - st1.st_mtime) < 2.0,
+            "%s != %s within 2 seconds" % (creation_mtime, st1.st_mtime))
+        # But if we have more than that, all files should get the same result
+        self.assertEqual(st1.st_mtime, st2.st_mtime)
+
+    def test_change_root_id(self):
+        transform, root = self.get_transform()
+        self.assertNotEqual('new-root-id', self.wt.get_root_id())
+        transform.new_directory('', ROOT_PARENT, 'new-root-id')
+        transform.delete_contents(root)
+        transform.unversion_file(root)
+        transform.fixup_new_roots()
+        transform.apply()
+        self.assertEqual('new-root-id', self.wt.get_root_id())
+
+    def test_change_root_id_add_files(self):
+        transform, root = self.get_transform()
+        self.assertNotEqual('new-root-id', self.wt.get_root_id())
+        new_trans_id = transform.new_directory('', ROOT_PARENT, 'new-root-id')
+        transform.new_file('file', new_trans_id, ['new-contents\n'],
+                           'new-file-id')
+        transform.delete_contents(root)
+        transform.unversion_file(root)
+        transform.fixup_new_roots()
+        transform.apply()
+        self.assertEqual('new-root-id', self.wt.get_root_id())
+        self.assertEqual('new-file-id', self.wt.path2id('file'))
+        self.assertFileEqual('new-contents\n', self.wt.abspath('file'))
+
+    def test_add_two_roots(self):
+        transform, root = self.get_transform()
+        new_trans_id = transform.new_directory('', ROOT_PARENT, 'new-root-id')
+        new_trans_id = transform.new_directory('', ROOT_PARENT, 'alt-root-id')
+        self.assertRaises(ValueError, transform.fixup_new_roots)
+
     def test_hardlink(self):
         self.requireFeature(HardlinkFeature)
         transform, root = self.get_transform()
@@ -758,7 +812,7 @@
         create.apply()
         transform, root = self.get_transform()
         transform.adjust_root_path('oldroot', fun)
-        new_root=transform.trans_id_tree_path('')
+        new_root = transform.trans_id_tree_path('')
         transform.version_file('new-root', new_root)
         transform.apply()
 
@@ -1868,6 +1922,49 @@
         self.assertEqual([], list(target.iter_changes(revision_tree)))
         self.assertTrue(source.is_executable('file1-id'))
 
+    def install_rot13_content_filter(self, pattern):
+        original_registry = filters._reset_registry()
+        def restore_registry():
+            filters._reset_registry(original_registry)
+        self.addCleanup(restore_registry)
+        def rot13(chunks, context=None):
+            return [''.join(chunks).encode('rot13')]
+        rot13filter = filters.ContentFilter(rot13, rot13)
+        filters.register_filter_stack_map('rot13', {'yes': [rot13filter]}.get)
+        os.mkdir(self.test_home_dir + '/.bazaar')
+        rules_filename = self.test_home_dir + '/.bazaar/rules'
+        f = open(rules_filename, 'wb')
+        f.write('[name %s]\nrot13=yes\n' % (pattern,))
+        f.close()
+        def uninstall_rules():
+            os.remove(rules_filename)
+            rules.reset_rules()
+        self.addCleanup(uninstall_rules)
+        rules.reset_rules()
+
+    def test_build_tree_content_filtered_files_are_not_hardlinked(self):
+        """build_tree will not hardlink files that have content filtering rules
+        applied to them (but will still hardlink other files from the same tree
+        if it can).
+        """
+        self.requireFeature(HardlinkFeature)
+        self.install_rot13_content_filter('file1')
+        source = self.create_ab_tree()
+        target = self.make_branch_and_tree('target')
+        revision_tree = source.basis_tree()
+        revision_tree.lock_read()
+        self.addCleanup(revision_tree.unlock)
+        build_tree(revision_tree, target, source, hardlink=True)
+        target.lock_read()
+        self.addCleanup(target.unlock)
+        self.assertEqual([], list(target.iter_changes(revision_tree)))
+        source_stat = os.stat('source/file1')
+        target_stat = os.stat('target/file1')
+        self.assertNotEqual(source_stat, target_stat)
+        source_stat = os.stat('source/file2')
+        target_stat = os.stat('target/file2')
+        self.assertEqualStat(source_stat, target_stat)
+
     def test_case_insensitive_build_tree_inventory(self):
         if (tests.CaseInsensitiveFilesystemFeature.available()
             or tests.CaseInsCasePresFilenameFeature.available()):
@@ -1951,14 +2048,16 @@
         branch, tt = self.get_branch_and_transform()
         tt.new_file('file', tt.root, 'contents', 'file-id')
         trans_id = tt.new_directory('dir', tt.root, 'dir-id')
-        tt.new_symlink('symlink', trans_id, 'target', 'symlink-id')
+        if SymlinkFeature.available():
+            tt.new_symlink('symlink', trans_id, 'target', 'symlink-id')
         rev = tt.commit(branch, 'message')
         tree = branch.basis_tree()
         self.assertEqual('file', tree.id2path('file-id'))
         self.assertEqual('contents', tree.get_file_text('file-id'))
         self.assertEqual('dir', tree.id2path('dir-id'))
-        self.assertEqual('dir/symlink', tree.id2path('symlink-id'))
-        self.assertEqual('target', tree.get_symlink_target('symlink-id'))
+        if SymlinkFeature.available():
+            self.assertEqual('dir/symlink', tree.id2path('symlink-id'))
+            self.assertEqual('target', tree.get_symlink_target('symlink-id'))
 
     def test_add_unversioned(self):
         branch, tt = self.get_branch_and_transform()
@@ -2454,8 +2553,6 @@
         self.assertEqual(('missing', None, None, None), summary)
 
     def test_file_content_summary_executable(self):
-        if not osutils.supports_executable():
-            raise TestNotApplicable()
         preview = self.get_empty_preview()
         path_id = preview.new_file('path', preview.root, 'contents', 'path-id')
         preview.set_executability(True, path_id)
@@ -2470,8 +2567,6 @@
         self.assertIs(None, summary[3])
 
     def test_change_executability(self):
-        if not osutils.supports_executable():
-            raise TestNotApplicable()
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/path'])
         tree.add('path')
@@ -2491,10 +2586,7 @@
         # size must be known
         self.assertEqual(len('contents'), summary[1])
         # not executable
-        if osutils.supports_executable():
-            self.assertEqual(False, summary[2])
-        else:
-            self.assertEqual(None, summary[2])
+        self.assertEqual(False, summary[2])
         # will not have hash (not cheap to determine)
         self.assertIs(None, summary[3])
 
@@ -2643,7 +2735,7 @@
         preview = self.get_empty_preview()
         root = preview.new_directory('', ROOT_PARENT, 'tree-root')
         # FIXME: new_directory should mark root.
-        preview.adjust_path('', ROOT_PARENT, root)
+        preview.fixup_new_roots()
         preview_tree = preview.get_preview_tree()
         file_trans_id = preview.new_file('a', preview.root, 'contents',
                                          'a-id')
@@ -2754,6 +2846,17 @@
         rev2_tree = tree.branch.repository.revision_tree(rev2_id)
         self.assertEqual('contents', rev2_tree.get_file_text('file_id'))
 
+    def test_ascii_limbo_paths(self):
+        self.requireFeature(tests.UnicodeFilenameFeature)
+        branch = self.make_branch('any')
+        tree = branch.repository.revision_tree(_mod_revision.NULL_REVISION)
+        tt = TransformPreview(tree)
+        self.addCleanup(tt.finalize)
+        foo_id = tt.new_directory('', ROOT_PARENT)
+        bar_id = tt.new_file(u'\u1234bar', foo_id, 'contents')
+        limbo_path = tt._limbo_name(bar_id)
+        self.assertEqual(limbo_path.encode('ascii', 'replace'), limbo_path)
+
 
 class FakeSerializer(object):
     """Serializer implementation that simply returns the input.

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2009-09-22 04:25:05 +0000
+++ bzrlib/tests/test_transport.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,13 +21,18 @@
 import sys
 import threading
 
-import bzrlib
 from bzrlib import (
     errors,
     osutils,
     tests,
+    transport as _mod_transport,
     urlutils,
     )
+from bzrlib.transport import (
+    fakenfs,
+    memory,
+    readonly,
+    )
 from bzrlib.errors import (DependencyNotPresent,
                            FileExists,
                            InvalidURLJoin,
@@ -36,7 +41,7 @@
                            ReadError,
                            UnsupportedProtocol,
                            )
-from bzrlib.tests import ParamikoFeature, TestCase, TestCaseInTempDir
+from bzrlib.tests import features, TestCase, TestCaseInTempDir
 from bzrlib.transport import (_clear_protocol_handlers,
                               _CoalescedOffset,
                               ConnectedTransport,
@@ -50,7 +55,6 @@
                               Transport,
                               )
 from bzrlib.transport.chroot import ChrootServer
-from bzrlib.transport.memory import MemoryTransport
 from bzrlib.transport.local import (LocalTransport,
                                     EmulatedWin32LocalTransport)
 from bzrlib.transport.pathfilter import PathFilteringServer
@@ -166,7 +170,7 @@
 
     def test_local_abspath_non_local_transport(self):
         # the base implementation should throw
-        t = MemoryTransport()
+        t = memory.MemoryTransport()
         e = self.assertRaises(errors.NotLocalUrl, t.local_abspath, 't')
         self.assertEqual('memory:///t is not a local path.', str(e))
 
@@ -256,68 +260,83 @@
                    max_size=1*1024*1024*1024)
 
 
+class TestMemoryServer(TestCase):
+
+    def test_create_server(self):
+        server = memory.MemoryServer()
+        server.start_server()
+        url = server.get_url()
+        self.assertTrue(url in _mod_transport.transport_list_registry)
+        t = _mod_transport.get_transport(url)
+        del t
+        server.stop_server()
+        self.assertFalse(url in _mod_transport.transport_list_registry)
+        self.assertRaises(errors.UnsupportedProtocol,
+                          _mod_transport.get_transport, url)
+
+
 class TestMemoryTransport(TestCase):
 
     def test_get_transport(self):
-        MemoryTransport()
+        memory.MemoryTransport()
 
     def test_clone(self):
-        transport = MemoryTransport()
-        self.assertTrue(isinstance(transport, MemoryTransport))
+        transport = memory.MemoryTransport()
+        self.assertTrue(isinstance(transport, memory.MemoryTransport))
         self.assertEqual("memory:///", transport.clone("/").base)
 
     def test_abspath(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertEqual("memory:///relpath", transport.abspath('relpath'))
 
     def test_abspath_of_root(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertEqual("memory:///", transport.base)
         self.assertEqual("memory:///", transport.abspath('/'))
 
     def test_abspath_of_relpath_starting_at_root(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertEqual("memory:///foo", transport.abspath('/foo'))
 
     def test_append_and_get(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.append_bytes('path', 'content')
         self.assertEqual(transport.get('path').read(), 'content')
         transport.append_file('path', StringIO('content'))
         self.assertEqual(transport.get('path').read(), 'contentcontent')
 
     def test_put_and_get(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.put_file('path', StringIO('content'))
         self.assertEqual(transport.get('path').read(), 'content')
         transport.put_bytes('path', 'content')
         self.assertEqual(transport.get('path').read(), 'content')
 
     def test_append_without_dir_fails(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertRaises(NoSuchFile,
                           transport.append_bytes, 'dir/path', 'content')
 
     def test_put_without_dir_fails(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertRaises(NoSuchFile,
                           transport.put_file, 'dir/path', StringIO('content'))
 
     def test_get_missing(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertRaises(NoSuchFile, transport.get, 'foo')
 
     def test_has_missing(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertEquals(False, transport.has('foo'))
 
     def test_has_present(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.append_bytes('foo', 'content')
         self.assertEquals(True, transport.has('foo'))
 
     def test_list_dir(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.put_bytes('foo', 'content')
         transport.mkdir('dir')
         transport.put_bytes('dir/subfoo', 'content')
@@ -327,28 +346,28 @@
         self.assertEquals(['subfoo'], sorted(transport.list_dir('dir')))
 
     def test_mkdir(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.mkdir('dir')
         transport.append_bytes('dir/path', 'content')
         self.assertEqual(transport.get('dir/path').read(), 'content')
 
     def test_mkdir_missing_parent(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertRaises(NoSuchFile,
                           transport.mkdir, 'dir/dir')
 
     def test_mkdir_twice(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.mkdir('dir')
         self.assertRaises(FileExists, transport.mkdir, 'dir')
 
     def test_parameters(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         self.assertEqual(True, transport.listable())
         self.assertEqual(False, transport.is_readonly())
 
     def test_iter_files_recursive(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.mkdir('dir')
         transport.put_bytes('dir/foo', 'content')
         transport.put_bytes('dir/bar', 'content')
@@ -357,7 +376,7 @@
         self.assertEqual(set(['dir/foo', 'dir/bar', 'bar']), paths)
 
     def test_stat(self):
-        transport = MemoryTransport()
+        transport = memory.MemoryTransport()
         transport.put_bytes('foo', 'content')
         transport.put_bytes('bar', 'phowar')
         self.assertEqual(7, transport.stat('foo').st_size)
@@ -423,34 +442,34 @@
 class ChrootServerTest(TestCase):
 
     def test_construct(self):
-        backing_transport = MemoryTransport()
+        backing_transport = memory.MemoryTransport()
         server = ChrootServer(backing_transport)
         self.assertEqual(backing_transport, server.backing_transport)
 
     def test_setUp(self):
-        backing_transport = MemoryTransport()
+        backing_transport = memory.MemoryTransport()
         server = ChrootServer(backing_transport)
-        server.setUp()
+        server.start_server()
         try:
             self.assertTrue(server.scheme in _get_protocol_handlers().keys())
         finally:
-            server.tearDown()
+            server.stop_server()
 
-    def test_tearDown(self):
-        backing_transport = MemoryTransport()
+    def test_stop_server(self):
+        backing_transport = memory.MemoryTransport()
         server = ChrootServer(backing_transport)
-        server.setUp()
-        server.tearDown()
+        server.start_server()
+        server.stop_server()
         self.assertFalse(server.scheme in _get_protocol_handlers().keys())
 
     def test_get_url(self):
-        backing_transport = MemoryTransport()
+        backing_transport = memory.MemoryTransport()
         server = ChrootServer(backing_transport)
-        server.setUp()
+        server.start_server()
         try:
             self.assertEqual('chroot-%d:///' % id(server), server.get_url())
         finally:
-            server.tearDown()
+            server.stop_server()
 
 
 class PathFilteringDecoratorTransportTest(TestCase):
@@ -460,13 +479,13 @@
         # The abspath is always relative to the base of the backing transport.
         server = PathFilteringServer(get_transport('memory:///foo/bar/'),
             lambda x: x)
-        server.setUp()
+        server.start_server()
         transport = get_transport(server.get_url())
         self.assertEqual(server.get_url(), transport.abspath('/'))
 
         subdir_transport = transport.clone('subdir')
         self.assertEqual(server.get_url(), subdir_transport.abspath('/'))
-        server.tearDown()
+        server.stop_server()
 
     def make_pf_transport(self, filter_func=None):
         """Make a PathFilteringTransport backed by a MemoryTransport.
@@ -477,8 +496,8 @@
             filter_func = lambda x: x
         server = PathFilteringServer(
             get_transport('memory:///foo/bar/'), filter_func)
-        server.setUp()
-        self.addCleanup(server.tearDown)
+        server.start_server()
+        self.addCleanup(server.stop_server)
         return get_transport(server.get_url())
 
     def test__filter(self):
@@ -541,7 +560,6 @@
     """Readonly decoration specific tests."""
 
     def test_local_parameters(self):
-        import bzrlib.transport.readonly as readonly
         # connect to . in readonly mode
         transport = readonly.ReadonlyTransportDecorator('readonly+.')
         self.assertEqual(True, transport.listable())
@@ -549,7 +567,6 @@
 
     def test_http_parameters(self):
         from bzrlib.tests.http_server import HttpServer
-        import bzrlib.transport.readonly as readonly
         # connect to '.' via http which is not listable
         server = HttpServer()
         self.start_server(server)
@@ -564,7 +581,6 @@
     """NFS decorator specific tests."""
 
     def get_nfs_transport(self, url):
-        import bzrlib.transport.fakenfs as fakenfs
         # connect to url with nfs decoration
         return fakenfs.FakeNFSTransportDecorator('fakenfs+' + url)
 
@@ -584,13 +600,12 @@
         self.start_server(server)
         transport = self.get_nfs_transport(server.get_url())
         self.assertIsInstance(
-            transport, bzrlib.transport.fakenfs.FakeNFSTransportDecorator)
+            transport, fakenfs.FakeNFSTransportDecorator)
         self.assertEqual(False, transport.listable())
         self.assertEqual(True, transport.is_readonly())
 
     def test_fakenfs_server_default(self):
         # a FakeNFSServer() should bring up a local relpath server for itself
-        import bzrlib.transport.fakenfs as fakenfs
         server = fakenfs.FakeNFSServer()
         self.start_server(server)
         # the url should be decorated appropriately
@@ -895,12 +910,11 @@
         # A reasonable evolution for this would be to simply check inside
         # check_channel_exec_request that the command is appropriate, and then
         # satisfy requests in-process.
-        self.requireFeature(ParamikoFeature)
+        self.requireFeature(features.paramiko)
         # SFTPFullAbsoluteServer has a get_url method, and doesn't
         # override the interface (doesn't change self._vendor).
         # Note that this does encryption, so can be slow.
-        from bzrlib.transport.sftp import SFTPFullAbsoluteServer
-        from bzrlib.tests.stub_sftp import StubServer
+        from bzrlib.tests import stub_sftp
 
         # Start an SSH server
         self.command_executed = []
@@ -908,7 +922,8 @@
         # executes commands, and manage the hooking up of stdin/out/err to the
         # SSH channel ourselves.  Surely this has already been implemented
         # elsewhere?
-        class StubSSHServer(StubServer):
+        started = []
+        class StubSSHServer(stub_sftp.StubServer):
 
             test = self
 
@@ -933,14 +948,16 @@
                     (channel.recv, proc.stdin.write, proc.stdin.close),
                     (proc.stdout.read, channel.sendall, channel.close),
                     (proc.stderr.read, channel.sendall_stderr, channel.close)]
+                started.append(proc)
                 for read, write, close in file_functions:
                     t = threading.Thread(
                         target=ferry_bytes, args=(read, write, close))
                     t.start()
+                    started.append(t)
 
                 return True
 
-        ssh_server = SFTPFullAbsoluteServer(StubSSHServer)
+        ssh_server = stub_sftp.SFTPFullAbsoluteServer(StubSSHServer)
         # We *don't* want to override the default SSH vendor: the detected one
         # is the one to use.
         self.start_server(ssh_server)
@@ -967,3 +984,13 @@
         self.assertEqual(
             ['%s serve --inet --directory=/ --allow-writes' % bzr_remote_path],
             self.command_executed)
+        # Make sure to disconnect, so that the remote process can stop, and we
+        # can cleanup. Then pause the test until everything is shutdown
+        t._client._medium.disconnect()
+        if not started:
+            return
+        # First wait for the subprocess
+        started[0].wait()
+        # And the rest are threads
+        for t in started[1:]:
+            t.join()

=== modified file 'bzrlib/tests/test_transport_log.py'
--- bzrlib/tests/test_transport_log.py	2009-07-01 07:04:47 +0000
+++ bzrlib/tests/test_transport_log.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -36,10 +36,9 @@
         # operations such as mkdir are logged
         mutter('where are you?')
         logging_transport.mkdir('subdir')
-        self.assertContainsRe(self._get_log(True),
-            r'mkdir memory\+\d+://.*subdir')
-        self.assertContainsRe(self._get_log(True),
-            '  --> None')
+        log = self.get_log()
+        self.assertContainsRe(log, r'mkdir memory\+\d+://.*subdir')
+        self.assertContainsRe(log, '  --> None')
         # they have the expected effect
         self.assertTrue(logging_transport.has('subdir'))
         # and they operate on the underlying transport

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2009-10-15 20:04:37 +0000
+++ bzrlib/tests/test_ui.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,9 +18,7 @@
 """
 
 import os
-from StringIO import StringIO
 import re
-import sys
 import time
 
 from bzrlib import (
@@ -31,26 +29,8 @@
 from bzrlib.symbol_versioning import (
     deprecated_in,
     )
-from bzrlib.tests import (
-    TestCase,
-    TestUIFactory,
-    StringIOWrapper,
-    )
-from bzrlib.tests.test_progress import (
-    _NonTTYStringIO,
-    _TTYStringIO,
-    )
-from bzrlib.ui import (
-    CannedInputUIFactory,
-    SilentUIFactory,
-    UIFactory,
-    make_ui_for_terminal,
-    )
-from bzrlib.ui.text import (
-    NullProgressView,
-    TextProgressView,
-    TextUIFactory,
-    )
+from bzrlib.tests import test_progress
+from bzrlib.ui import text as _mod_ui_text
 
 
 class TestTextUIFactory(tests.TestCase):
@@ -100,11 +80,11 @@
             pb.finished()
 
     def test_progress_note(self):
-        stderr = StringIO()
-        stdout = StringIO()
-        ui_factory = TextUIFactory(stdin=StringIO(''),
-            stderr=stderr,
-            stdout=stdout)
+        stderr = tests.StringIOWrapper()
+        stdout = tests.StringIOWrapper()
+        ui_factory = _mod_ui_text.TextUIFactory(stdin=tests.StringIOWrapper(''),
+                                                stderr=stderr,
+                                                stdout=stdout)
         pb = ui_factory.nested_progress_bar()
         try:
             result = self.applyDeprecated(deprecated_in((2, 1, 0)),
@@ -120,15 +100,15 @@
             pb.finished()
 
     def test_progress_note_clears(self):
-        stderr = _TTYStringIO()
-        stdout = _TTYStringIO()
+        stderr = test_progress._TTYStringIO()
+        stdout = test_progress._TTYStringIO()
         # so that we get a TextProgressBar
         os.environ['TERM'] = 'xterm'
-        ui_factory = TextUIFactory(
-            stdin=StringIO(''),
+        ui_factory = _mod_ui_text.TextUIFactory(
+            stdin=tests.StringIOWrapper(''),
             stdout=stdout, stderr=stderr)
         self.assertIsInstance(ui_factory._progress_view,
-            TextProgressView)
+                              _mod_ui_text.TextProgressView)
         pb = ui_factory.nested_progress_bar()
         try:
             # Create a progress update that isn't throttled
@@ -146,7 +126,7 @@
 
     def test_progress_nested(self):
         # test factory based nested and popping.
-        ui = TextUIFactory(None, None, None)
+        ui = _mod_ui_text.TextUIFactory(None, None, None)
         pb1 = ui.nested_progress_bar()
         pb2 = ui.nested_progress_bar()
         # You do get a warning if the outermost progress bar wasn't finished
@@ -159,16 +139,16 @@
         pb1.finished()
 
     def test_text_ui_get_boolean(self):
-        stdin = StringIO("y\n" # True
-                         "n\n" # False
-                         "yes with garbage\nY\n" # True
-                         "not an answer\nno\n" # False
-                         "I'm sure!\nyes\n" # True
-                         "NO\n" # False
-                         "foo\n")
-        stdout = StringIO()
-        stderr = StringIO()
-        factory = TextUIFactory(stdin, stdout, stderr)
+        stdin = tests.StringIOWrapper("y\n" # True
+                                      "n\n" # False
+                                      "yes with garbage\nY\n" # True
+                                      "not an answer\nno\n" # False
+                                      "I'm sure!\nyes\n" # True
+                                      "NO\n" # False
+                                      "foo\n")
+        stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
+        factory = _mod_ui_text.TextUIFactory(stdin, stdout, stderr)
         self.assertEqual(True, factory.get_boolean(""))
         self.assertEqual(False, factory.get_boolean(""))
         self.assertEqual(True, factory.get_boolean(""))
@@ -179,18 +159,33 @@
         # stdin should be empty
         self.assertEqual('', factory.stdin.readline())
 
+    def test_text_ui_get_integer(self):
+        stdin = tests.StringIOWrapper(
+            "1\n"
+            "  -2  \n"
+            "hmmm\nwhat else ?\nCome on\nok 42\n4.24\n42\n")
+        stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
+        factory = _mod_ui_text.TextUIFactory(stdin, stdout, stderr)
+        self.assertEqual(1, factory.get_integer(""))
+        self.assertEqual(-2, factory.get_integer(""))
+        self.assertEqual(42, factory.get_integer(""))
+
     def test_text_factory_prompt(self):
         # see <https://launchpad.net/bugs/365891>
-        factory = TextUIFactory(StringIO(), StringIO(), StringIO())
+        StringIO = tests.StringIOWrapper
+        factory = _mod_ui_text.TextUIFactory(StringIO(), StringIO(), StringIO())
         factory.prompt('foo %2e')
         self.assertEqual('', factory.stdout.getvalue())
         self.assertEqual('foo %2e', factory.stderr.getvalue())
 
     def test_text_factory_prompts_and_clears(self):
         # a get_boolean call should clear the pb before prompting
-        out = _TTYStringIO()
+        out = test_progress._TTYStringIO()
         os.environ['TERM'] = 'xterm'
-        factory = TextUIFactory(stdin=StringIO("yada\ny\n"), stdout=out, stderr=out)
+        factory = _mod_ui_text.TextUIFactory(
+            stdin=tests.StringIOWrapper("yada\ny\n"),
+            stdout=out, stderr=out)
         pb = factory.nested_progress_bar()
         pb.show_bar = False
         pb.show_spinner = False
@@ -210,7 +205,8 @@
         self.assertEqual('', factory.stdin.readline())
 
     def test_text_tick_after_update(self):
-        ui_factory = TextUIFactory(stdout=StringIO(), stderr=StringIO())
+        ui_factory = _mod_ui_text.TextUIFactory(stdout=tests.StringIOWrapper(),
+                                                stderr=tests.StringIOWrapper())
         pb = ui_factory.nested_progress_bar()
         try:
             pb.update('task', 0, 3)
@@ -221,10 +217,10 @@
             pb.finished()
 
     def test_text_ui_getusername(self):
-        factory = TextUIFactory(None, None, None)
-        factory.stdin = StringIO("someuser\n\n")
-        factory.stdout = StringIO()
-        factory.stderr = StringIO()
+        factory = _mod_ui_text.TextUIFactory(None, None, None)
+        factory.stdin = tests.StringIOWrapper("someuser\n\n")
+        factory.stdout = tests.StringIOWrapper()
+        factory.stderr = tests.StringIOWrapper()
         factory.stdout.encoding = "utf8"
         # there is no output from the base factory
         self.assertEqual("someuser",
@@ -252,28 +248,67 @@
         finally:
             pb.finished()
 
+    def test_quietness(self):
+        os.environ['BZR_PROGRESS_BAR'] = 'text'
+        ui_factory = _mod_ui_text.TextUIFactory(None,
+            test_progress._TTYStringIO(),
+            test_progress._TTYStringIO())
+        self.assertIsInstance(ui_factory._progress_view,
+            _mod_ui_text.TextProgressView)
+        ui_factory.be_quiet(True)
+        self.assertIsInstance(ui_factory._progress_view,
+            _mod_ui_text.NullProgressView)
+
+
+class TestTextUIOutputStream(tests.TestCase):
+    """Tests for output stream that synchronizes with progress bar."""
+
+    def test_output_clears_terminal(self):
+        stdout = tests.StringIOWrapper()
+        stderr = tests.StringIOWrapper()
+        clear_calls = []
+
+        uif =  _mod_ui_text.TextUIFactory(None, stdout, stderr)
+        uif.clear_term = lambda: clear_calls.append('clear')
+
+        stream = _mod_ui_text.TextUIOutputStream(uif, uif.stdout)
+        stream.write("Hello world!\n")
+        stream.write("there's more...\n")
+        stream.writelines(["1\n", "2\n", "3\n"])
+
+        self.assertEqual(stdout.getvalue(),
+            "Hello world!\n"
+            "there's more...\n"
+            "1\n2\n3\n")
+        self.assertEqual(['clear', 'clear', 'clear'],
+            clear_calls)
+
+        stream.flush()
+
 
 class UITests(tests.TestCase):
 
     def test_progress_construction(self):
         """TextUIFactory constructs the right progress view.
         """
+        TTYStringIO = test_progress._TTYStringIO
+        FileStringIO = tests.StringIOWrapper
         for (file_class, term, pb, expected_pb_class) in (
             # on an xterm, either use them or not as the user requests,
             # otherwise default on
-            (_TTYStringIO, 'xterm', 'none', NullProgressView),
-            (_TTYStringIO, 'xterm', 'text', TextProgressView),
-            (_TTYStringIO, 'xterm', None, TextProgressView),
+            (TTYStringIO, 'xterm', 'none', _mod_ui_text.NullProgressView),
+            (TTYStringIO, 'xterm', 'text', _mod_ui_text.TextProgressView),
+            (TTYStringIO, 'xterm', None, _mod_ui_text.TextProgressView),
             # on a dumb terminal, again if there's explicit configuration do
             # it, otherwise default off
-            (_TTYStringIO, 'dumb', 'none', NullProgressView),
-            (_TTYStringIO, 'dumb', 'text', TextProgressView),
-            (_TTYStringIO, 'dumb', None, NullProgressView),
+            (TTYStringIO, 'dumb', 'none', _mod_ui_text.NullProgressView),
+            (TTYStringIO, 'dumb', 'text', _mod_ui_text.TextProgressView),
+            (TTYStringIO, 'dumb', None, _mod_ui_text.NullProgressView),
             # on a non-tty terminal, it's null regardless of $TERM
-            (StringIO, 'xterm', None, NullProgressView),
-            (StringIO, 'dumb', None, NullProgressView),
+            (FileStringIO, 'xterm', None, _mod_ui_text.NullProgressView),
+            (FileStringIO, 'dumb', None, _mod_ui_text.NullProgressView),
             # however, it can still be forced on
-            (StringIO, 'dumb', 'text', TextProgressView),
+            (FileStringIO, 'dumb', 'text', _mod_ui_text.TextProgressView),
             ):
             os.environ['TERM'] = term
             if pb is None:
@@ -284,8 +319,8 @@
             stdin = file_class('')
             stderr = file_class()
             stdout = file_class()
-            uif = make_ui_for_terminal(stdin, stdout, stderr)
-            self.assertIsInstance(uif, TextUIFactory,
+            uif = _mod_ui.make_ui_for_terminal(stdin, stdout, stderr)
+            self.assertIsInstance(uif, _mod_ui_text.TextUIFactory,
                 "TERM=%s BZR_PROGRESS_BAR=%s uif=%r" % (term, pb, uif,))
             self.assertIsInstance(uif.make_progress_view(),
                 expected_pb_class,
@@ -293,27 +328,27 @@
 
     def test_text_ui_non_terminal(self):
         """Even on non-ttys, make_ui_for_terminal gives a text ui."""
-        stdin = _NonTTYStringIO('')
-        stderr = _NonTTYStringIO()
-        stdout = _NonTTYStringIO()
+        stdin = test_progress._NonTTYStringIO('')
+        stderr = test_progress._NonTTYStringIO()
+        stdout = test_progress._NonTTYStringIO()
         for term_type in ['dumb', None, 'xterm']:
             if term_type is None:
                 del os.environ['TERM']
             else:
                 os.environ['TERM'] = term_type
-            uif = make_ui_for_terminal(stdin, stdout, stderr)
-            self.assertIsInstance(uif, TextUIFactory,
+            uif = _mod_ui.make_ui_for_terminal(stdin, stdout, stderr)
+            self.assertIsInstance(uif, _mod_ui_text.TextUIFactory,
                 'TERM=%r' % (term_type,))
 
 
-class SilentUITests(TestCase):
+class SilentUITests(tests.TestCase):
 
     def test_silent_factory_get_password(self):
         # A silent factory that can't do user interaction can't get a
         # password.  Possibly it should raise a more specific error but it
         # can't succeed.
-        ui = SilentUIFactory()
-        stdout = StringIO()
+        ui = _mod_ui.SilentUIFactory()
+        stdout = tests.StringIOWrapper()
         self.assertRaises(
             NotImplementedError,
             self.apply_redirected,
@@ -322,34 +357,36 @@
         self.assertEqual('', stdout.getvalue())
 
     def test_silent_ui_getbool(self):
-        factory = SilentUIFactory()
-        stdout = StringIO()
+        factory = _mod_ui.SilentUIFactory()
+        stdout = tests.StringIOWrapper()
         self.assertRaises(
             NotImplementedError,
             self.apply_redirected,
             None, stdout, stdout, factory.get_boolean, "foo")
 
 
-class TestUIFactoryTests(TestCase):
+class TestUIFactoryTests(tests.TestCase):
 
     def test_test_ui_factory_progress(self):
         # there's no output; we just want to make sure this doesn't crash -
         # see https://bugs.edge.launchpad.net/bzr/+bug/408201
-        ui = TestUIFactory()
+        ui = tests.TestUIFactory()
         pb = ui.nested_progress_bar()
         pb.update('hello')
         pb.tick()
         pb.finished()
 
 
-class CannedInputUIFactoryTests(TestCase):
-    
+class CannedInputUIFactoryTests(tests.TestCase):
+
     def test_canned_input_get_input(self):
-        uif = CannedInputUIFactory([True, 'mbp', 'password'])
-        self.assertEqual(uif.get_boolean('Extra cheese?'), True)
-        self.assertEqual(uif.get_username('Enter your user name'), 'mbp')
-        self.assertEqual(uif.get_password('Password for %(host)s', host='example.com'),
-            'password')
+        uif = _mod_ui.CannedInputUIFactory([True, 'mbp', 'password', 42])
+        self.assertEqual(True, uif.get_boolean('Extra cheese?'))
+        self.assertEqual('mbp', uif.get_username('Enter your user name'))
+        self.assertEqual('password',
+                         uif.get_password('Password for %(host)s',
+                                          host='example.com'))
+        self.assertEqual(42, uif.get_integer('And all that jazz ?'))
 
 
 class TestBoolFromString(tests.TestCase):

=== modified file 'bzrlib/tests/test_urlutils.py'
--- bzrlib/tests/test_urlutils.py	2009-04-04 01:45:09 +0000
+++ bzrlib/tests/test_urlutils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,6 @@
 """Tests for the urlutils wrapper."""
 
 import os
-import re
 import sys
 
 from bzrlib import osutils, urlutils, win32utils
@@ -300,8 +299,13 @@
             from_url('file:///path/to/r%C3%A4ksm%C3%B6rg%C3%A5s'))
         self.assertEqual(u'/path/to/r\xe4ksm\xf6rg\xe5s',
             from_url('file:///path/to/r%c3%a4ksm%c3%b6rg%c3%a5s'))
+        self.assertEqual(u'/path/to/r\xe4ksm\xf6rg\xe5s',
+            from_url('file://localhost/path/to/r%c3%a4ksm%c3%b6rg%c3%a5s'))
 
         self.assertRaises(InvalidURL, from_url, '/path/to/foo')
+        self.assertRaises(
+            InvalidURL, from_url,
+            'file://remotehost/path/to/r%c3%a4ksm%c3%b6rg%c3%a5s')
 
     def test_win32_local_path_to_url(self):
         to_url = urlutils._win32_local_path_to_url

=== modified file 'bzrlib/tests/test_version.py'
--- bzrlib/tests/test_version.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/test_version.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2006, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,9 +14,12 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-
 """Tests for versioning of bzrlib."""
 
+from cStringIO import StringIO
+import os
+import re
+
 from bzrlib import version, workingtree
 from bzrlib.tests import TestCase, TestSkipped
 
@@ -35,3 +38,13 @@
         else:
             # ensure that what we got was in fact a working tree instance.
             self.assertIsInstance(src_tree, workingtree.WorkingTree)
+
+    def test_python_binary_path(self):
+        self.permit_source_tree_branch_repo()
+        sio = StringIO()
+        version.show_version(show_config=False, show_copyright=False,
+            to_file=sio)
+        out = sio.getvalue()
+        m = re.search(r"Python interpreter: (.*) [0-9]", out)
+        self.assertIsNot(m, None)
+        self.failUnlessExists(m.group(1))

=== modified file 'bzrlib/tests/test_win32utils.py'
--- bzrlib/tests/test_win32utils.py	2009-07-03 14:26:34 +0000
+++ bzrlib/tests/test_win32utils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,7 +17,11 @@
 import os
 import sys
 
-from bzrlib import osutils
+from bzrlib import (
+    osutils,
+    tests,
+    win32utils,
+    )
 from bzrlib.tests import (
     Feature,
     TestCase,
@@ -26,21 +30,22 @@
     UnicodeFilenameFeature,
     )
 from bzrlib.win32utils import glob_expand, get_app_path
-from bzrlib import win32utils
-
-
-# Features
-# --------
-
-class _NeedsGlobExpansionFeature(Feature):
+
+
+class _BackslashDirSeparatorFeature(tests.Feature):
 
     def _probe(self):
-        return sys.platform == 'win32'
+        try:
+            os.lstat(os.getcwd() + '\\')
+        except OSError:
+            return False
+        else:
+            return True
 
     def feature_name(self):
-        return 'Internally performed glob expansion'
+        return "Filesystem treats '\\' as a directory separator."
 
-NeedsGlobExpansionFeature = _NeedsGlobExpansionFeature()
+BackslashDirSeparatorFeature = _BackslashDirSeparatorFeature()
 
 
 class _RequiredModuleFeature(Feature):
@@ -67,19 +72,9 @@
 # Tests
 # -----
 
-class TestNeedsGlobExpansionFeature(TestCase):
-
-    def test_available(self):
-        self.assertEqual(sys.platform == 'win32',
-                         NeedsGlobExpansionFeature.available())
-
-    def test_str(self):
-        self.assertTrue("performed" in str(NeedsGlobExpansionFeature))
-
-
 class TestWin32UtilsGlobExpand(TestCaseInTempDir):
 
-    _test_needs_features = [NeedsGlobExpansionFeature]
+    _test_needs_features = []
 
     def test_empty_tree(self):
         self.build_tree([])
@@ -89,22 +84,28 @@
             [['*'], ['*']],
             [['a', 'a'], ['a', 'a']]])
 
-    def test_tree_ascii(self):
-        """Checks the glob expansion and path separation char
-        normalization"""
+    def build_ascii_tree(self):
         self.build_tree(['a', 'a1', 'a2', 'a11', 'a.1',
                          'b', 'b1', 'b2', 'b3',
                          'c/', 'c/c1', 'c/c2',
                          'd/', 'd/d1', 'd/d2', 'd/e/', 'd/e/e1'])
+
+    def build_unicode_tree(self):
+        self.requireFeature(UnicodeFilenameFeature)
+        self.build_tree([u'\u1234', u'\u1234\u1234', u'\u1235/',
+                         u'\u1235/\u1235'])
+
+    def test_tree_ascii(self):
+        """Checks the glob expansion and path separation char
+        normalization"""
+        self.build_ascii_tree()
         self._run_testset([
             # no wildcards
             [[u'a'], [u'a']],
             [[u'a', u'a' ], [u'a', u'a']],
-            [[u'A'], [u'A']],
 
             [[u'd'], [u'd']],
             [[u'd/'], [u'd/']],
-            [[u'd\\'], [u'd/']],
 
             # wildcards
             [[u'a*'], [u'a', u'a1', u'a2', u'a11', u'a.1']],
@@ -112,18 +113,35 @@
             [[u'a?'], [u'a1', u'a2']],
             [[u'a??'], [u'a11', u'a.1']],
             [[u'b[1-2]'], [u'b1', u'b2']],
-            [[u'A?'], [u'a1', u'a2']],
 
             [[u'd/*'], [u'd/d1', u'd/d2', u'd/e']],
+            [[u'?/*'], [u'c/c1', u'c/c2', u'd/d1', u'd/d2', u'd/e']],
+            [[u'*/*'], [u'c/c1', u'c/c2', u'd/d1', u'd/d2', u'd/e']],
+            [[u'*/'], [u'c/', u'd/']],
+            ])
+
+    def test_backslash_globbing(self):
+        self.requireFeature(BackslashDirSeparatorFeature)
+        self.build_ascii_tree()
+        self._run_testset([
+            [[u'd\\'], [u'd/']],
             [[u'd\\*'], [u'd/d1', u'd/d2', u'd/e']],
             [[u'?\\*'], [u'c/c1', u'c/c2', u'd/d1', u'd/d2', u'd/e']],
             [[u'*\\*'], [u'c/c1', u'c/c2', u'd/d1', u'd/d2', u'd/e']],
-            [[u'*/'], [u'c/', u'd/']],
-            [[u'*\\'], [u'c/', u'd/']]])
+            [[u'*\\'], [u'c/', u'd/']],
+            ])
+
+    def test_case_insensitive_globbing(self):
+        self.requireFeature(tests.CaseInsCasePresFilenameFeature)
+        self.build_ascii_tree()
+        self._run_testset([
+            [[u'A'], [u'A']],
+            [[u'A?'], [u'a1', u'a2']],
+            ])
 
     def test_tree_unicode(self):
         """Checks behaviour with non-ascii filenames"""
-        self.build_tree([u'\u1234', u'\u1234\u1234', u'\u1235/', u'\u1235/\u1235'])
+        self.build_unicode_tree()
         self._run_testset([
             # no wildcards
             [[u'\u1234'], [u'\u1234']],
@@ -139,16 +157,26 @@
 
             [[u'\u1235/?'], [u'\u1235/\u1235']],
             [[u'\u1235/*'], [u'\u1235/\u1235']],
+            [[u'?/'], [u'\u1235/']],
+            [[u'*/'], [u'\u1235/']],
+            [[u'?/?'], [u'\u1235/\u1235']],
+            [[u'*/*'], [u'\u1235/\u1235']],
+            ])
+
+    def test_unicode_backslashes(self):
+        self.requireFeature(BackslashDirSeparatorFeature)
+        self.build_unicode_tree()
+        self._run_testset([
+            # no wildcards
+            [[u'\u1235\\'], [u'\u1235/']],
+            [[u'\u1235\\\u1235'], [u'\u1235/\u1235']],
             [[u'\u1235\\?'], [u'\u1235/\u1235']],
             [[u'\u1235\\*'], [u'\u1235/\u1235']],
-            [[u'?/'], [u'\u1235/']],
-            [[u'*/'], [u'\u1235/']],
             [[u'?\\'], [u'\u1235/']],
             [[u'*\\'], [u'\u1235/']],
-            [[u'?/?'], [u'\u1235/\u1235']],
-            [[u'*/*'], [u'\u1235/\u1235']],
             [[u'?\\?'], [u'\u1235/\u1235']],
-            [[u'*\\*'], [u'\u1235/\u1235']]])
+            [[u'*\\*'], [u'\u1235/\u1235']],
+            ])
 
     def _run_testset(self, testset):
         for pattern, expected in testset:
@@ -261,3 +289,108 @@
         os.makedirs(u'\u1234\\.bzr')
         path = osutils.abspath(u'\u1234\\.bzr')
         win32utils.set_file_attr_hidden(path)
+
+
+
+class TestUnicodeShlex(tests.TestCase):
+
+    def assertAsTokens(self, expected, line):
+        s = win32utils.UnicodeShlex(line)
+        self.assertEqual(expected, list(s))
+
+    def test_simple(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar'), (False, u'baz')],
+                            u'foo bar baz')
+
+    def test_ignore_multiple_spaces(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo  bar')
+
+    def test_ignore_leading_space(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'  foo bar')
+
+    def test_ignore_trailing_space(self):
+        self.assertAsTokens([(False, u'foo'), (False, u'bar')], u'foo bar  ')
+
+    def test_posix_quotations(self):
+        self.assertAsTokens([(True, u'foo bar')], u'"foo bar"')
+        self.assertAsTokens([(False, u"'fo''o"), (False, u"b''ar'")],
+            u"'fo''o b''ar'")
+        self.assertAsTokens([(True, u'foo bar')], u'"fo""o b""ar"')
+        self.assertAsTokens([(True, u"fo'o"), (True, u"b'ar")],
+            u'"fo"\'o b\'"ar"')
+
+    def test_nested_quotations(self):
+        self.assertAsTokens([(True, u'foo"" bar')], u"\"foo\\\"\\\" bar\"")
+        self.assertAsTokens([(True, u'foo\'\' bar')], u"\"foo'' bar\"")
+
+    def test_empty_result(self):
+        self.assertAsTokens([], u'')
+        self.assertAsTokens([], u'    ')
+
+    def test_quoted_empty(self):
+        self.assertAsTokens([(True, '')], u'""')
+        self.assertAsTokens([(False, u"''")], u"''")
+
+    def test_unicode_chars(self):
+        self.assertAsTokens([(False, u'f\xb5\xee'), (False, u'\u1234\u3456')],
+                             u'f\xb5\xee \u1234\u3456')
+
+    def test_newline_in_quoted_section(self):
+        self.assertAsTokens([(True, u'foo\nbar\nbaz\n')], u'"foo\nbar\nbaz\n"')
+
+    def test_escape_chars(self):
+        self.assertAsTokens([(False, u'foo\\bar')], u'foo\\bar')
+
+    def test_escape_quote(self):
+        self.assertAsTokens([(True, u'foo"bar')], u'"foo\\"bar"')
+
+    def test_double_escape(self):
+        self.assertAsTokens([(True, u'foo\\bar')], u'"foo\\\\bar"')
+        self.assertAsTokens([(False, u'foo\\\\bar')], u"foo\\\\bar")
+
+
+class Test_CommandLineToArgv(tests.TestCaseInTempDir):
+
+    def assertCommandLine(self, expected, line):
+        # Strictly speaking we should respect parameter order versus glob
+        # expansions, but it's not really worth the effort here
+        self.assertEqual(expected,
+                         sorted(win32utils._command_line_to_argv(line)))
+
+    def test_glob_paths(self):
+        self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
+        self.assertCommandLine([u'a/b.c', u'a/c.c'], 'a/*.c')
+        self.build_tree(['b/', 'b/b.c', 'b/d.c', 'b/d.h'])
+        self.assertCommandLine([u'a/b.c', u'b/b.c'], '*/b.c')
+        self.assertCommandLine([u'a/b.c', u'a/c.c', u'b/b.c', u'b/d.c'],
+                               '*/*.c')
+        # Bash style, just pass through the argument if nothing matches
+        self.assertCommandLine([u'*/*.qqq'], '*/*.qqq')
+
+    def test_quoted_globs(self):
+        self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
+        self.assertCommandLine([u'a/*.c'], '"a/*.c"')
+        self.assertCommandLine([u"'a/*.c'"], "'a/*.c'")
+
+    def test_slashes_changed(self):
+        # Quoting doesn't change the supplied args
+        self.assertCommandLine([u'a\\*.c'], '"a\\*.c"')
+        # Expands the glob, but nothing matches, swaps slashes
+        self.assertCommandLine([u'a/*.c'], 'a\\*.c')
+        self.assertCommandLine([u'a/?.c'], 'a\\?.c')
+        # No glob, doesn't touch slashes
+        self.assertCommandLine([u'a\\foo.c'], 'a\\foo.c')
+
+    def test_no_single_quote_supported(self):
+        self.assertCommandLine(["add", "let's-do-it.txt"],
+            "add let's-do-it.txt")
+
+    def test_case_insensitive_globs(self):
+        self.requireFeature(tests.CaseInsCasePresFilenameFeature)
+        self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
+        self.assertCommandLine([u'A/b.c'], 'A/B*')
+
+    def test_backslashes(self):
+        self.requireFeature(BackslashDirSeparatorFeature)
+        self.build_tree(['a/', 'a/b.c', 'a/c.c', 'a/c.h'])
+        self.assertCommandLine([u'a/b.c'], 'a\\b*')

=== modified file 'bzrlib/tests/test_xml.py'
--- bzrlib/tests/test_xml.py	2009-07-15 06:39:07 +0000
+++ bzrlib/tests/test_xml.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 
 from bzrlib import (
     errors,
+    fifo_cache,
     inventory,
     xml6,
     xml7,
@@ -290,6 +291,38 @@
                 _inventory_v5a, revision_id='test-rev-id')
         self.assertEqual('test-rev-id', inv.root.revision)
 
+    def test_unpack_inventory_5a_cache_and_copy(self):
+        # Passing an entry_cache should get populated with the objects
+        # But the returned objects should be copies if return_from_cache is
+        # False
+        entry_cache = fifo_cache.FIFOCache()
+        inv = bzrlib.xml5.serializer_v5.read_inventory_from_string(
+            _inventory_v5a, revision_id='test-rev-id',
+            entry_cache=entry_cache, return_from_cache=False)
+        for entry in inv.iter_just_entries():
+            key = (entry.file_id, entry.revision)
+            if entry.file_id is inv.root.file_id:
+                # The root id is inferred for xml v5
+                self.assertFalse(key in entry_cache)
+            else:
+                self.assertIsNot(entry, entry_cache[key])
+
+    def test_unpack_inventory_5a_cache_no_copy(self):
+        # Passing an entry_cache should get populated with the objects
+        # The returned objects should be exact if return_from_cache is
+        # True
+        entry_cache = fifo_cache.FIFOCache()
+        inv = bzrlib.xml5.serializer_v5.read_inventory_from_string(
+            _inventory_v5a, revision_id='test-rev-id',
+            entry_cache=entry_cache, return_from_cache=True)
+        for entry in inv.iter_just_entries():
+            key = (entry.file_id, entry.revision)
+            if entry.file_id is inv.root.file_id:
+                # The root id is inferred for xml v5
+                self.assertFalse(key in entry_cache)
+            else:
+                self.assertIs(entry, entry_cache[key])
+
     def test_unpack_inventory_5b(self):
         inv = bzrlib.xml5.serializer_v5.read_inventory_from_string(
                 _inventory_v5b, revision_id='test-rev-id')

=== modified file 'bzrlib/tests/transport_util.py'
--- bzrlib/tests/transport_util.py	2009-09-17 11:54:41 +0000
+++ bzrlib/tests/transport_util.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -15,11 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 import bzrlib.hooks
+from bzrlib.tests import features
 
 # SFTPTransport offers better performances but relies on paramiko, if paramiko
 # is not available, we fallback to FtpTransport
-from bzrlib.tests import test_sftp_transport
-if test_sftp_transport.paramiko_loaded:
+if features.paramiko.available():
+    from bzrlib.tests import test_sftp_transport
     from bzrlib.transport import sftp
     _backing_scheme = 'sftp'
     _backing_transport_class = sftp.SFTPTransport

=== removed file 'bzrlib/textui.py'
--- bzrlib/textui.py	2009-03-23 14:59:43 +0000
+++ bzrlib/textui.py	1970-01-01 00:00:00 +0000
@@ -1,40 +0,0 @@
-# Bazaar -- distributed version control
-#
-# Copyright (C) 2005, 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-import sys
-
-
-def show_status(state, kind, name, to_file=None):
-    if kind == 'directory':
-        # use this even on windows?
-        kind_ch = '/'
-    elif kind == 'symlink':
-        kind_ch = '->'
-    elif kind == 'file':
-        kind_ch = ''
-    else:
-        raise ValueError(kind)
-
-    if len(state) != 1:
-        raise ValueError(state)
-
-    if to_file is None:
-        to_file = sys.stdout
-
-    to_file.write(state + '       ' + name + kind_ch + '\n')
-

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2009-09-23 06:01:45 +0000
+++ bzrlib/trace.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-"""Messages and logging for bazaar-ng.
+"""Messages and logging.
 
 Messages are supplied by callers as a string-formatting template, plus values
 to be inserted into it.  The actual %-formatting is deferred to the log
@@ -33,8 +33,7 @@
 
 Output to stderr depends on the mode chosen by the user.  By default, messages
 of info and above are sent out, which results in progress messages such as the
-list of files processed by add and commit.  In quiet mode, only warnings and
-above are shown.  In debug mode, stderr gets debug messages too.
+list of files processed by add and commit.  In debug mode, stderr gets debug messages too.
 
 Errors that terminate an operation are generally passed back as exceptions;
 others may be just emitted as messages.
@@ -83,6 +82,7 @@
     osutils,
     plugin,
     symbol_versioning,
+    ui,
     )
 """)
 
@@ -153,13 +153,11 @@
     _bzr_logger.error(*args, **kwargs)
 
 
-_last_mutter_flush_time = None
-
-
 def mutter(fmt, *args):
-    global _last_mutter_flush_time
     if _trace_file is None:
         return
+    # XXX: Don't check this every time; instead anyone who closes the file
+    # ought to deregister it.  We can tolerate None.
     if (getattr(_trace_file, 'closed', None) is not None) and _trace_file.closed:
         return
 
@@ -182,15 +180,7 @@
     timestamp = '%0.3f  ' % (now - _bzr_log_start_time,)
     out = timestamp + out + '\n'
     _trace_file.write(out)
-    # We flush if we haven't flushed for a few seconds. We don't want to flush
-    # on every mutter, but when a command takes a while, it can be nice to see
-    # updates in the debug log.
-    if (_last_mutter_flush_time is None
-        or (now - _last_mutter_flush_time) > 2.0):
-        flush = getattr(_trace_file, 'flush', None)
-        if flush is not None:
-            flush()
-        _last_mutter_flush_time = now
+    # there's no explicit flushing; the file is typically line buffered.
 
 
 def mutter_callsite(stacklevel, fmt, *args):
@@ -251,7 +241,7 @@
     _bzr_log_filename = _get_bzr_log_filename()
     _rollover_trace_maybe(_bzr_log_filename)
     try:
-        bzr_log_file = open(_bzr_log_filename, 'at', 1) # line buffered
+        bzr_log_file = open(_bzr_log_filename, 'at', buffering=0) # unbuffered
         # bzr_log_file.tell() on windows always return 0 until some writing done
         bzr_log_file.write('\n')
         if bzr_log_file.tell() <= 2:
@@ -260,7 +250,12 @@
             bzr_log_file.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
         return bzr_log_file
     except IOError, e:
-        warning("failed to open trace file: %s" % (e))
+        # If we are failing to open the log, then most likely logging has not
+        # been set up yet. So we just write to stderr rather than using
+        # 'warning()'. If we using warning(), users get the unhelpful 'no
+        # handlers registered for "bzr"' when something goes wrong on the
+        # server. (bug #503886)
+        sys.stderr.write("failed to open trace file: %s\n" % (e,))
     # TODO: What should happen if we fail to open the trace file?  Maybe the
     # objects should be pointed at /dev/null or the equivalent?  Currently
     # returns None which will cause failures later.
@@ -370,6 +365,7 @@
     global _verbosity_level
     _verbosity_level = level
     _update_logging_level(level < 0)
+    ui.ui_factory.be_quiet(level < 0)
 
 
 def get_verbosity_level():
@@ -381,7 +377,6 @@
 
 
 def be_quiet(quiet=True):
-    # Perhaps this could be deprecated now ...
     if quiet:
         set_verbosity_level(-1)
     else:
@@ -445,9 +440,12 @@
 
     :return: The appropriate exit code for this error.
     """
-    exc_type, exc_object, exc_tb = exc_info
     # Log the full traceback to ~/.bzr.log
     log_exception_quietly()
+    if 'error' in debug.debug_flags:
+        print_exception(exc_info, err_file)
+        return errors.EXIT_ERROR
+    exc_type, exc_object, exc_tb = exc_info
     if (isinstance(exc_object, IOError)
         and getattr(exc_object, 'errno', None) == errno.EPIPE):
         err_file.write("bzr: broken pipe\n")
@@ -494,9 +492,6 @@
     :param advice: Extra advice to the user to be printed following the
         exception.
     """
-    if 'error' in debug.debug_flags:
-        print_exception(exc_info, err_file)
-        return
     err_file.write("bzr: ERROR: %s\n" % (exc_info[1],))
     if advice:
         err_file.write("%s\n" % (advice,))

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2009-10-16 15:29:50 +0000
+++ bzrlib/transform.py	2010-01-13 23:06:42 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,6 +17,7 @@
 import os
 import errno
 from stat import S_ISREG, S_IEXEC
+import time
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -161,14 +162,12 @@
 
     def adjust_path(self, name, parent, trans_id):
         """Change the path that is assigned to a transaction id."""
+        if parent is None:
+            raise ValueError("Parent trans-id may not be None")
         if trans_id == self._new_root:
             raise CantMoveRoot
         self._new_name[trans_id] = name
         self._new_parent[trans_id] = parent
-        if parent == ROOT_PARENT:
-            if self._new_root is not None:
-                raise ValueError("Cannot have multiple roots.")
-            self._new_root = trans_id
 
     def adjust_root_path(self, name, parent):
         """Emulate moving the root by moving all children, instead.
@@ -202,6 +201,67 @@
         self.version_file(old_root_file_id, old_root)
         self.unversion_file(self._new_root)
 
+    def fixup_new_roots(self):
+        """Reinterpret requests to change the root directory
+
+        Instead of creating a root directory, or moving an existing directory,
+        all the attributes and children of the new root are applied to the
+        existing root directory.
+
+        This means that the old root trans-id becomes obsolete, so it is
+        recommended only to invoke this after the root trans-id has become
+        irrelevant.
+        """
+        new_roots = [k for k, v in self._new_parent.iteritems() if v is
+                     ROOT_PARENT]
+        if len(new_roots) < 1:
+            return
+        if len(new_roots) != 1:
+            raise ValueError('A tree cannot have two roots!')
+        if self._new_root is None:
+            self._new_root = new_roots[0]
+            return
+        old_new_root = new_roots[0]
+        # TODO: What to do if a old_new_root is present, but self._new_root is
+        #       not listed as being removed? This code explicitly unversions
+        #       the old root and versions it with the new file_id. Though that
+        #       seems like an incomplete delta
+
+        # unversion the new root's directory.
+        file_id = self.final_file_id(old_new_root)
+        if old_new_root in self._new_id:
+            self.cancel_versioning(old_new_root)
+        else:
+            self.unversion_file(old_new_root)
+        # if, at this stage, root still has an old file_id, zap it so we can
+        # stick a new one in.
+        if (self.tree_file_id(self._new_root) is not None and
+            self._new_root not in self._removed_id):
+            self.unversion_file(self._new_root)
+        self.version_file(file_id, self._new_root)
+
+        # Now move children of new root into old root directory.
+        # Ensure all children are registered with the transaction, but don't
+        # use directly-- some tree children have new parents
+        list(self.iter_tree_children(old_new_root))
+        # Move all children of new root into old root directory.
+        for child in self.by_parent().get(old_new_root, []):
+            self.adjust_path(self.final_name(child), self._new_root, child)
+
+        # Ensure old_new_root has no directory.
+        if old_new_root in self._new_contents:
+            self.cancel_creation(old_new_root)
+        else:
+            self.delete_contents(old_new_root)
+
+        # prevent deletion of root directory.
+        if self._new_root in self._removed_contents:
+            self.cancel_deletion(self._new_root)
+
+        # destroy path info for old_new_root.
+        del self._new_parent[old_new_root]
+        del self._new_name[old_new_root]
+
     def trans_id_tree_file_id(self, inventory_id):
         """Determine the transaction id of a working tree file.
 
@@ -253,6 +313,8 @@
 
     def delete_contents(self, trans_id):
         """Schedule the contents of a path entry for deletion"""
+        # Ensure that the object exists in the WorkingTree, this will raise an
+        # exception if there is a problem
         self.tree_kind(trans_id)
         self._removed_contents.add(trans_id)
 
@@ -1023,6 +1085,7 @@
         self._limbo_children_names = {}
         # List of transform ids that need to be renamed from limbo into place
         self._needs_rename = set()
+        self._creation_mtime = None
 
     def finalize(self):
         """Release the working tree lock, if held, clean up limbo dir.
@@ -1054,47 +1117,20 @@
     def _limbo_name(self, trans_id):
         """Generate the limbo name of a file"""
         limbo_name = self._limbo_files.get(trans_id)
-        if limbo_name is not None:
-            return limbo_name
-        parent = self._new_parent.get(trans_id)
-        # if the parent directory is already in limbo (e.g. when building a
-        # tree), choose a limbo name inside the parent, to reduce further
-        # renames.
-        use_direct_path = False
-        if self._new_contents.get(parent) == 'directory':
-            filename = self._new_name.get(trans_id)
-            if filename is not None:
-                if parent not in self._limbo_children:
-                    self._limbo_children[parent] = set()
-                    self._limbo_children_names[parent] = {}
-                    use_direct_path = True
-                # the direct path can only be used if no other file has
-                # already taken this pathname, i.e. if the name is unused, or
-                # if it is already associated with this trans_id.
-                elif self._case_sensitive_target:
-                    if (self._limbo_children_names[parent].get(filename)
-                        in (trans_id, None)):
-                        use_direct_path = True
-                else:
-                    for l_filename, l_trans_id in\
-                        self._limbo_children_names[parent].iteritems():
-                        if l_trans_id == trans_id:
-                            continue
-                        if l_filename.lower() == filename.lower():
-                            break
-                    else:
-                        use_direct_path = True
-
-        if use_direct_path:
-            limbo_name = pathjoin(self._limbo_files[parent], filename)
-            self._limbo_children[parent].add(trans_id)
-            self._limbo_children_names[parent][filename] = trans_id
-        else:
-            limbo_name = pathjoin(self._limbodir, trans_id)
-            self._needs_rename.add(trans_id)
-        self._limbo_files[trans_id] = limbo_name
+        if limbo_name is None:
+            limbo_name = self._generate_limbo_path(trans_id)
+            self._limbo_files[trans_id] = limbo_name
         return limbo_name
 
+    def _generate_limbo_path(self, trans_id):
+        """Generate a limbo path using the trans_id as the relative path.
+
+        This is suitable as a fallback, and when the transform should not be
+        sensitive to the path encoding of the limbo directory.
+        """
+        self._needs_rename.add(trans_id)
+        return pathjoin(self._limbodir, trans_id)
+
     def adjust_path(self, name, parent, trans_id):
         previous_parent = self._new_parent.get(trans_id)
         previous_name = self._new_name.get(trans_id)
@@ -1102,8 +1138,10 @@
         if (trans_id in self._limbo_files and
             trans_id not in self._needs_rename):
             self._rename_in_limbo([trans_id])
-            self._limbo_children[previous_parent].remove(trans_id)
-            del self._limbo_children_names[previous_parent][previous_name]
+            if previous_parent != parent:
+                self._limbo_children[previous_parent].remove(trans_id)
+            if previous_parent != parent or previous_name != name:
+                del self._limbo_children_names[previous_parent][previous_name]
 
     def _rename_in_limbo(self, trans_ids):
         """Fix limbo names so that the right final path is produced.
@@ -1160,6 +1198,7 @@
             f.writelines(contents)
         finally:
             f.close()
+        self._set_mtime(name)
         self._set_mode(trans_id, mode_id, S_ISREG)
 
     def _read_file_chunks(self, trans_id):
@@ -1172,6 +1211,15 @@
     def _read_symlink_target(self, trans_id):
         return os.readlink(self._limbo_name(trans_id))
 
+    def _set_mtime(self, path):
+        """All files that are created get the same mtime.
+
+        This time is set by the first object to be created.
+        """
+        if self._creation_mtime is None:
+            self._creation_mtime = time.time()
+        os.utime(path, (self._creation_mtime, self._creation_mtime))
+
     def create_hardlink(self, path, trans_id):
         """Schedule creation of a hard link"""
         name = self._limbo_name(trans_id)
@@ -1407,6 +1455,54 @@
                 continue
             yield self.trans_id_tree_path(childpath)
 
+    def _generate_limbo_path(self, trans_id):
+        """Generate a limbo path using the final path if possible.
+
+        This optimizes the performance of applying the tree transform by
+        avoiding renames.  These renames can be avoided only when the parent
+        directory is already scheduled for creation.
+
+        If the final path cannot be used, falls back to using the trans_id as
+        the relpath.
+        """
+        parent = self._new_parent.get(trans_id)
+        # if the parent directory is already in limbo (e.g. when building a
+        # tree), choose a limbo name inside the parent, to reduce further
+        # renames.
+        use_direct_path = False
+        if self._new_contents.get(parent) == 'directory':
+            filename = self._new_name.get(trans_id)
+            if filename is not None:
+                if parent not in self._limbo_children:
+                    self._limbo_children[parent] = set()
+                    self._limbo_children_names[parent] = {}
+                    use_direct_path = True
+                # the direct path can only be used if no other file has
+                # already taken this pathname, i.e. if the name is unused, or
+                # if it is already associated with this trans_id.
+                elif self._case_sensitive_target:
+                    if (self._limbo_children_names[parent].get(filename)
+                        in (trans_id, None)):
+                        use_direct_path = True
+                else:
+                    for l_filename, l_trans_id in\
+                        self._limbo_children_names[parent].iteritems():
+                        if l_trans_id == trans_id:
+                            continue
+                        if l_filename.lower() == filename.lower():
+                            break
+                    else:
+                        use_direct_path = True
+
+        if not use_direct_path:
+            return DiskTreeTransform._generate_limbo_path(self, trans_id)
+
+        limbo_name = pathjoin(self._limbo_files[parent], filename)
+        self._limbo_children[parent].add(trans_id)
+        self._limbo_children_names[parent][filename] = trans_id
+        return limbo_name
+
+
     def apply(self, no_conflicts=False, precomputed_delta=None, _mover=None):
         """Apply all changes to the inventory and filesystem.
 
@@ -1532,10 +1628,10 @@
                 child_pb.update('removing file', num, len(tree_paths))
                 full_path = self._tree.abspath(path)
                 if trans_id in self._removed_contents:
-                    mover.pre_delete(full_path, os.path.join(self._deletiondir,
-                                     trans_id))
-                elif trans_id in self._new_name or trans_id in \
-                    self._new_parent:
+                    delete_path = os.path.join(self._deletiondir, trans_id)
+                    mover.pre_delete(full_path, delete_path)
+                elif (trans_id in self._new_name
+                      or trans_id in self._new_parent):
                     try:
                         mover.rename(full_path, self._limbo_name(trans_id))
                     except OSError, e:
@@ -1952,7 +2048,7 @@
                 statval = os.lstat(limbo_name)
                 size = statval.st_size
                 if not supports_executable():
-                    executable = None
+                    executable = False
                 else:
                     executable = statval.st_mode & S_IEXEC
             else:
@@ -1960,8 +2056,7 @@
                 executable = None
             if kind == 'symlink':
                 link_or_sha1 = os.readlink(limbo_name).decode(osutils._fs_enc)
-        if supports_executable():
-            executable = tt._new_executability.get(trans_id, executable)
+        executable = tt._new_executability.get(trans_id, executable)
         return kind, size, executable, link_or_sha1
 
     def iter_changes(self, from_tree, include_unchanged=False,
@@ -2280,8 +2375,12 @@
         new_desired_files = desired_files
     else:
         iter = accelerator_tree.iter_changes(tree, include_unchanged=True)
-        unchanged = dict((f, p[1]) for (f, p, c, v, d, n, k, e)
-                         in iter if not (c or e[0] != e[1]))
+        unchanged = [(f, p[1]) for (f, p, c, v, d, n, k, e)
+                     in iter if not (c or e[0] != e[1])]
+        if accelerator_tree.supports_content_filtering():
+            unchanged = [(f, p) for (f, p) in unchanged
+                         if not accelerator_tree.iter_search_rules([p]).next()]
+        unchanged = dict(unchanged)
         new_desired_files = []
         count = 0
         for file_id, (trans_id, tree_path) in desired_files:
@@ -2410,8 +2509,14 @@
         tt.create_directory(trans_id)
 
 
-def create_from_tree(tt, trans_id, tree, file_id, bytes=None):
-    """Create new file contents according to tree contents."""
+def create_from_tree(tt, trans_id, tree, file_id, bytes=None,
+    filter_tree_path=None):
+    """Create new file contents according to tree contents.
+    
+    :param filter_tree_path: the tree path to use to lookup
+      content filters to apply to the bytes output in the working tree.
+      This only applies if the working tree supports content filtering.
+    """
     kind = tree.kind(file_id)
     if kind == 'directory':
         tt.create_directory(trans_id)
@@ -2422,6 +2527,11 @@
                 bytes = tree_file.readlines()
             finally:
                 tree_file.close()
+        wt = tt._tree
+        if wt.supports_content_filtering() and filter_tree_path is not None:
+            filters = wt._content_filter_stack(filter_tree_path)
+            bytes = filtered_output_bytes(bytes, filters,
+                ContentFilterContext(filter_tree_path, tree))
         tt.create_file(bytes, trans_id)
     elif kind == "symlink":
         tt.create_symlink(tree.get_symlink_target(file_id), trans_id)
@@ -2615,12 +2725,29 @@
                     parent_trans = ROOT_PARENT
                 else:
                     parent_trans = tt.trans_id_file_id(parent[1])
-                tt.adjust_path(name[1], parent_trans, trans_id)
+                if parent[0] is None and versioned[0]:
+                    tt.adjust_root_path(name[1], parent_trans)
+                else:
+                    tt.adjust_path(name[1], parent_trans, trans_id)
             if executable[0] != executable[1] and kind[1] == "file":
                 tt.set_executability(executable[1], trans_id)
-        for (trans_id, mode_id), bytes in target_tree.iter_files_bytes(
-            deferred_files):
-            tt.create_file(bytes, trans_id, mode_id)
+        if working_tree.supports_content_filtering():
+            for index, ((trans_id, mode_id), bytes) in enumerate(
+                target_tree.iter_files_bytes(deferred_files)):
+                file_id = deferred_files[index][0]
+                # We're reverting a tree to the target tree so using the
+                # target tree to find the file path seems the best choice
+                # here IMO - Ian C 27/Oct/2009
+                filter_tree_path = target_tree.id2path(file_id)
+                filters = working_tree._content_filter_stack(filter_tree_path)
+                bytes = filtered_output_bytes(bytes, filters,
+                    ContentFilterContext(filter_tree_path, working_tree))
+                tt.create_file(bytes, trans_id, mode_id)
+        else:
+            for (trans_id, mode_id), bytes in target_tree.iter_files_bytes(
+                deferred_files):
+                tt.create_file(bytes, trans_id, mode_id)
+        tt.fixup_new_roots()
     finally:
         if basis_tree is not None:
             basis_tree.unlock()

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2009-09-14 05:39:09 +0000
+++ bzrlib/transport/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -108,7 +108,7 @@
     register_transport_provider( ) ( and the "lazy" variant )
 
     This is needed because:
-    a) a single provider can support multple protcol ( like the ftp
+    a) a single provider can support multiple protocols ( like the ftp
     provider which supports both the ftp:// and the aftp:// protocols )
     b) a single protocol can have multiple providers ( like the http://
     protocol which is supported by both the urllib and pycurl provider )
@@ -1666,16 +1666,16 @@
     The Server interface provides a server for a given transport. We use
     these servers as loopback testing tools. For any given transport the
     Servers it provides must either allow writing, or serve the contents
-    of os.getcwdu() at the time setUp is called.
+    of os.getcwdu() at the time start_server is called.
 
     Note that these are real servers - they must implement all the things
     that we want bzr transports to take advantage of.
     """
 
-    def setUp(self):
+    def start_server(self):
         """Setup the server to service requests."""
 
-    def tearDown(self):
+    def stop_server(self):
         """Remove the server and cleanup any resources it owns."""
 
     def get_url(self):
@@ -1685,7 +1685,7 @@
         a database like svn, or a memory only transport, it should return
         a connection to a newly established resource for this Server.
         Otherwise it should return a url that will provide access to the path
-        that was os.getcwdu() when setUp() was called.
+        that was os.getcwdu() when start_server() was called.
 
         Subsequent calls will return the same resource.
         """

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2009-09-16 04:37:33 +0000
+++ bzrlib/transport/chroot.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006-2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -48,7 +48,7 @@
     def _factory(self, url):
         return ChrootTransport(self, url)
 
-    def setUp(self):
+    def start_server(self):
         self.scheme = 'chroot-%d:///' % id(self)
         register_transport(self.scheme, self._factory)
 
@@ -68,16 +68,16 @@
 class TestingChrootServer(ChrootServer):
 
     def __init__(self):
-        """TestingChrootServer is not usable until setUp is called."""
+        """TestingChrootServer is not usable until start_server is called."""
         ChrootServer.__init__(self, None)
 
-    def setUp(self, backing_server=None):
+    def start_server(self, backing_server=None):
         """Setup the Chroot on backing_server."""
         if backing_server is not None:
             self.backing_transport = get_transport(backing_server.get_url())
         else:
             self.backing_transport = get_transport('.')
-        ChrootServer.setUp(self)
+        ChrootServer.start_server(self)
 
 
 def get_test_permutations():

=== modified file 'bzrlib/transport/decorator.py'
--- bzrlib/transport/decorator.py	2009-03-23 14:59:43 +0000
+++ bzrlib/transport/decorator.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -184,8 +184,8 @@
     get_decorator_class method.
     """
 
-    def setUp(self, server=None):
-        """See bzrlib.transport.Server.setUp.
+    def start_server(self, server=None):
+        """See bzrlib.transport.Server.start_server.
 
         :server: decorate the urls given by server. If not provided a
         LocalServer is created.
@@ -197,12 +197,11 @@
             from bzrlib.transport.local import LocalURLServer
             self._made_server = True
             self._server = LocalURLServer()
-            self._server.setUp()
+            self._server.start_server()
 
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
+    def stop_server(self):
         if self._made_server:
-            self._server.tearDown()
+            self._server.stop_server()
 
     def get_decorator_class(self):
         """Return the class of the decorators we should be constructing."""

=== modified file 'bzrlib/transport/ftp/__init__.py'
--- bzrlib/transport/ftp/__init__.py	2009-10-06 08:24:14 +0000
+++ bzrlib/transport/ftp/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -205,17 +205,6 @@
         #raise TransportError(msg='Error for path: %s' % (path,), orig_error=e)
         raise
 
-    def _remote_path(self, relpath):
-        # XXX: It seems that ftplib does not handle Unicode paths
-        # at the same time, medusa won't handle utf8 paths So if
-        # we .encode(utf8) here (see ConnectedTransport
-        # implementation), then we get a Server failure.  while
-        # if we use str(), we get a UnicodeError, and the test
-        # suite just skips testing UnicodePaths.
-        relative = str(urlutils.unescape(relpath))
-        remote_path = self._combine_paths(self._path, relative)
-        return remote_path
-
     def has(self, relpath):
         """Does the target location exist?"""
         # FIXME jam 20060516 We *do* ask about directories in the test suite

=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2009-08-19 16:33:39 +0000
+++ bzrlib/transport/http/__init__.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -154,7 +154,7 @@
                                  None, None, self._host, self._port, path)
 
     def _create_auth(self):
-        """Returns a dict returning the credentials provided at build time."""
+        """Returns a dict containing the credentials provided at build time."""
         auth = dict(host=self._host, port=self._port,
                     user=self._user, password=self._password,
                     protocol=self._unqualified_scheme,

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2009-03-23 14:59:43 +0000
+++ bzrlib/transport/http/_urllib.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -87,8 +87,8 @@
             self._update_credentials((request.auth, request.proxy_auth))
 
         code = response.code
-        if request.follow_redirections is False \
-                and code in (301, 302, 303, 307):
+        if (request.follow_redirections is False
+            and code in (301, 302, 303, 307)):
             raise errors.RedirectRequested(request.get_full_url(),
                                            request.redirected_to,
                                            is_permanent=(code == 301))

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2009-08-19 16:33:39 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -71,6 +71,7 @@
     trace,
     transport,
     ui,
+    urlutils,
     )
 
 
@@ -80,10 +81,13 @@
         self.filesock = filesock
         self._report_activity = report_activity
 
+    def report_activity(self, size, direction):
+        if self._report_activity:
+            self._report_activity(size, direction)
 
     def read(self, size=1):
         s = self.filesock.read(size)
-        self._report_activity(len(s), 'read')
+        self.report_activity(len(s), 'read')
         return s
 
     def readline(self):
@@ -93,7 +97,7 @@
         #  don't *need* the size parameter we'll stay with readline(self)
         #  --  vila 20090209
         s = self.filesock.readline()
-        self._report_activity(len(s), 'read')
+        self.report_activity(len(s), 'read')
         return s
 
     def __getattr__(self, name):
@@ -106,13 +110,17 @@
         self.sock = sock
         self._report_activity = report_activity
 
+    def report_activity(self, size, direction):
+        if self._report_activity:
+            self._report_activity(size, direction)
+
     def sendall(self, s, *args):
         self.sock.sendall(s, *args)
-        self._report_activity(len(s), 'write')
+        self.report_activity(len(s), 'write')
 
     def recv(self, *args):
         s = self.sock.recv(*args)
-        self._report_activity(len(s), 'read')
+        self.report_activity(len(s), 'read')
         return s
 
     def makefile(self, mode='r', bufsize=-1):
@@ -219,8 +227,7 @@
     # we want to warn. But not below a given thresold.
     _range_warning_thresold = 1024 * 1024
 
-    def __init__(self,
-                 report_activity=None):
+    def __init__(self, report_activity=None):
         self._response = None
         self._report_activity = report_activity
         self._ranges_received_whole_file = None
@@ -360,7 +367,16 @@
 
     def set_proxy(self, proxy, type):
         """Set the proxy and remember the proxied host."""
-        self.proxied_host = self.get_host()
+        host, port = urllib.splitport(self.get_host())
+        if port is None:
+            # We need to set the default port ourselves way before it gets set
+            # in the HTTP[S]Connection object at build time.
+            if self.type == 'https':
+                conn_class = HTTPSConnection
+            else:
+                conn_class = HTTPConnection
+            port = conn_class.default_port
+        self.proxied_host = '%s:%s' % (host, port)
         urllib2.Request.set_proxy(self, proxy, type)
 
 
@@ -1051,6 +1067,14 @@
 
         auth = self.get_auth(request)
         auth['modified'] = False
+        # Put some common info in auth if the caller didn't
+        if auth.get('path', None) is None:
+            (protocol, _, _,
+             host, port, path) = urlutils.parse_url(request.get_full_url())
+            self.update_auth(auth, 'protocol', protocol)
+            self.update_auth(auth, 'host', host)
+            self.update_auth(auth, 'port', port)
+            self.update_auth(auth, 'path', path)
         # FIXME: the auth handler should be selected at a single place instead
         # of letting all handlers try to match all headers, but the current
         # design doesn't allow a simple implementation.
@@ -1152,8 +1176,8 @@
             and then during dialog with the server).
         """
         auth_conf = config.AuthenticationConfig()
-        user = auth['user']
-        password = auth['password']
+        user = auth.get('user', None)
+        password = auth.get('password', None)
         realm = auth['realm']
 
         if user is None:
@@ -1293,7 +1317,8 @@
             # Put useful info into auth
             self.update_auth(auth, 'scheme', scheme)
             self.update_auth(auth, 'realm', realm)
-            if auth['user'] is None or auth['password'] is None:
+            if (auth.get('user', None) is None
+                or auth.get('password', None) is None):
                 user, password = self.get_user_password(auth)
                 self.update_auth(auth, 'user', user)
                 self.update_auth(auth, 'password', password)
@@ -1358,7 +1383,7 @@
         # Put useful info into auth
         self.update_auth(auth, 'scheme', scheme)
         self.update_auth(auth, 'realm', realm)
-        if auth['user'] is None or auth['password'] is None:
+        if auth.get('user', None) is None or auth.get('password', None) is None:
             user, password = self.get_user_password(auth)
             self.update_auth(auth, 'user', user)
             self.update_auth(auth, 'password', password)

=== modified file 'bzrlib/transport/http/wsgi.py'
--- bzrlib/transport/http/wsgi.py	2009-10-21 06:05:49 +0000
+++ bzrlib/transport/http/wsgi.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -106,7 +106,7 @@
         # e.g. consider a smart server request for "get /etc/passwd" or
         # something.
         self.chroot_server = chroot.ChrootServer(backing_transport)
-        self.chroot_server.setUp()
+        self.chroot_server.start_server()
         self.backing_transport = get_transport(self.chroot_server.get_url())
         self.root_client_path = root_client_path
         # While the chroot server can technically be torn down at this point,
@@ -114,7 +114,7 @@
         # protocol dictionary, we don't *just in case* there are parts of
         # bzrlib that will invoke 'get_transport' on urls rather than cloning
         # around the existing transport.
-        #self.chroot_server.tearDown()
+        #self.chroot_server.stop_server()
 
     def __call__(self, environ, start_response):
         """WSGI application callable."""

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2009-06-23 01:59:20 +0000
+++ bzrlib/transport/local.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -561,11 +561,8 @@
     this just exists to tell the test code how to get to it.
     """
 
-    def setUp(self):
-        """Setup the server to service requests.
-
-        :param decorated_transport: ignored by this implementation.
-        """
+    def start_server(self):
+        pass
 
     def get_url(self):
         """See Transport.Server.get_url."""

=== modified file 'bzrlib/transport/memory.py'
--- bzrlib/transport/memory.py	2009-07-20 04:26:55 +0000
+++ bzrlib/transport/memory.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -27,6 +27,9 @@
 from cStringIO import StringIO
 import warnings
 
+from bzrlib import (
+    urlutils,
+    )
 from bzrlib.errors import (
     FileExists,
     LockError,
@@ -42,8 +45,8 @@
     register_transport,
     Server,
     Transport,
+    unregister_transport,
     )
-import bzrlib.urlutils as urlutils
 
 
 
@@ -303,8 +306,7 @@
 class MemoryServer(Server):
     """Server for the MemoryTransport for testing with."""
 
-    def setUp(self):
-        """See bzrlib.transport.Server.setUp."""
+    def start_server(self):
         self._dirs = {'/':None}
         self._files = {}
         self._locks = {}
@@ -315,11 +317,12 @@
             result._files = self._files
             result._locks = self._locks
             return result
-        register_transport(self._scheme, memory_factory)
+        self._memory_factory = memory_factory
+        register_transport(self._scheme, self._memory_factory)
 
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
+    def stop_server(self):
         # unregister this server
+        unregister_transport(self._scheme, self._memory_factory)
 
     def get_url(self):
         """See bzrlib.transport.Server.get_url."""

=== modified file 'bzrlib/transport/pathfilter.py'
--- bzrlib/transport/pathfilter.py	2009-09-16 05:00:54 +0000
+++ bzrlib/transport/pathfilter.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2009 Canonical Ltd
+# Copyright (C) 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -59,11 +59,11 @@
     def get_url(self):
         return self.scheme
 
-    def setUp(self):
+    def start_server(self):
         self.scheme = 'filtered-%d:///' % id(self)
         register_transport(self.scheme, self._factory)
 
-    def tearDown(self):
+    def stop_server(self):
         unregister_transport(self.scheme, self._factory)
 
 
@@ -177,9 +177,9 @@
 class TestingPathFilteringServer(PathFilteringServer):
 
     def __init__(self):
-        """TestingChrootServer is not usable until setUp is called."""
+        """TestingChrootServer is not usable until start_server is called."""
 
-    def setUp(self, backing_server=None):
+    def start_server(self, backing_server=None):
         """Setup the Chroot on backing_server."""
         if backing_server is not None:
             self.backing_transport = get_transport(backing_server.get_url())
@@ -187,7 +187,7 @@
             self.backing_transport = get_transport('.')
         self.backing_transport.clone('added-by-filter').ensure_base()
         self.filter_func = lambda x: 'added-by-filter/' + x
-        PathFilteringServer.setUp(self)
+        PathFilteringServer.start_server(self)
 
 
 def get_test_permutations():

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2009-06-10 03:56:49 +0000
+++ bzrlib/transport/sftp.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,8 +28,6 @@
 import itertools
 import os
 import random
-import select
-import socket
 import stat
 import sys
 import time
@@ -884,332 +882,11 @@
         else:
             return True
 
-# ------------- server test implementation --------------
-import threading
-
-from bzrlib.tests.stub_sftp import StubServer, StubSFTPServer
-
-STUB_SERVER_KEY = """
------BEGIN RSA PRIVATE KEY-----
-MIICWgIBAAKBgQDTj1bqB4WmayWNPB+8jVSYpZYk80Ujvj680pOTh2bORBjbIAyz
-oWGW+GUjzKxTiiPvVmxFgx5wdsFvF03v34lEVVhMpouqPAYQ15N37K/ir5XY+9m/
-d8ufMCkjeXsQkKqFbAlQcnWMCRnOoPHS3I4vi6hmnDDeeYTSRvfLbW0fhwIBIwKB
-gBIiOqZYaoqbeD9OS9z2K9KR2atlTxGxOJPXiP4ESqP3NVScWNwyZ3NXHpyrJLa0
-EbVtzsQhLn6rF+TzXnOlcipFvjsem3iYzCpuChfGQ6SovTcOjHV9z+hnpXvQ/fon
-soVRZY65wKnF7IAoUwTmJS9opqgrN6kRgCd3DASAMd1bAkEA96SBVWFt/fJBNJ9H
-tYnBKZGw0VeHOYmVYbvMSstssn8un+pQpUm9vlG/bp7Oxd/m+b9KWEh2xPfv6zqU
-avNwHwJBANqzGZa/EpzF4J8pGti7oIAPUIDGMtfIcmqNXVMckrmzQ2vTfqtkEZsA
-4rE1IERRyiJQx6EJsz21wJmGV9WJQ5kCQQDwkS0uXqVdFzgHO6S++tjmjYcxwr3g
-H0CoFYSgbddOT6miqRskOQF3DZVkJT3kyuBgU2zKygz52ukQZMqxCb1fAkASvuTv
-qfpH87Qq5kQhNKdbbwbmd2NxlNabazPijWuphGTdW0VfJdWfklyS2Kr+iqrs/5wV
-HhathJt636Eg7oIjAkA8ht3MQ+XSl9yIJIS8gVpbPxSw5OMfw0PjVE7tBdQruiSc
-nvuQES5C9BMHjF39LZiGH1iLQy7FgdHyoP+eodI7
------END RSA PRIVATE KEY-----
-"""
-
-
-class SocketListener(threading.Thread):
-
-    def __init__(self, callback):
-        threading.Thread.__init__(self)
-        self._callback = callback
-        self._socket = socket.socket()
-        self._socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
-        self._socket.bind(('localhost', 0))
-        self._socket.listen(1)
-        self.port = self._socket.getsockname()[1]
-        self._stop_event = threading.Event()
-
-    def stop(self):
-        # called from outside this thread
-        self._stop_event.set()
-        # use a timeout here, because if the test fails, the server thread may
-        # never notice the stop_event.
-        self.join(5.0)
-        self._socket.close()
-
-    def run(self):
-        while True:
-            readable, writable_unused, exception_unused = \
-                select.select([self._socket], [], [], 0.1)
-            if self._stop_event.isSet():
-                return
-            if len(readable) == 0:
-                continue
-            try:
-                s, addr_unused = self._socket.accept()
-                # because the loopback socket is inline, and transports are
-                # never explicitly closed, best to launch a new thread.
-                threading.Thread(target=self._callback, args=(s,)).start()
-            except socket.error, x:
-                sys.excepthook(*sys.exc_info())
-                warning('Socket error during accept() within unit test server'
-                        ' thread: %r' % x)
-            except Exception, x:
-                # probably a failed test; unit test thread will log the
-                # failure/error
-                sys.excepthook(*sys.exc_info())
-                warning('Exception from within unit test server thread: %r' %
-                        x)
-
-
-class SocketDelay(object):
-    """A socket decorator to make TCP appear slower.
-
-    This changes recv, send, and sendall to add a fixed latency to each python
-    call if a new roundtrip is detected. That is, when a recv is called and the
-    flag new_roundtrip is set, latency is charged. Every send and send_all
-    sets this flag.
-
-    In addition every send, sendall and recv sleeps a bit per character send to
-    simulate bandwidth.
-
-    Not all methods are implemented, this is deliberate as this class is not a
-    replacement for the builtin sockets layer. fileno is not implemented to
-    prevent the proxy being bypassed.
-    """
-
-    simulated_time = 0
-    _proxied_arguments = dict.fromkeys([
-        "close", "getpeername", "getsockname", "getsockopt", "gettimeout",
-        "setblocking", "setsockopt", "settimeout", "shutdown"])
-
-    def __init__(self, sock, latency, bandwidth=1.0,
-                 really_sleep=True):
-        """
-        :param bandwith: simulated bandwith (MegaBit)
-        :param really_sleep: If set to false, the SocketDelay will just
-        increase a counter, instead of calling time.sleep. This is useful for
-        unittesting the SocketDelay.
-        """
-        self.sock = sock
-        self.latency = latency
-        self.really_sleep = really_sleep
-        self.time_per_byte = 1 / (bandwidth / 8.0 * 1024 * 1024)
-        self.new_roundtrip = False
-
-    def sleep(self, s):
-        if self.really_sleep:
-            time.sleep(s)
-        else:
-            SocketDelay.simulated_time += s
-
-    def __getattr__(self, attr):
-        if attr in SocketDelay._proxied_arguments:
-            return getattr(self.sock, attr)
-        raise AttributeError("'SocketDelay' object has no attribute %r" %
-                             attr)
-
-    def dup(self):
-        return SocketDelay(self.sock.dup(), self.latency, self.time_per_byte,
-                           self._sleep)
-
-    def recv(self, *args):
-        data = self.sock.recv(*args)
-        if data and self.new_roundtrip:
-            self.new_roundtrip = False
-            self.sleep(self.latency)
-        self.sleep(len(data) * self.time_per_byte)
-        return data
-
-    def sendall(self, data, flags=0):
-        if not self.new_roundtrip:
-            self.new_roundtrip = True
-            self.sleep(self.latency)
-        self.sleep(len(data) * self.time_per_byte)
-        return self.sock.sendall(data, flags)
-
-    def send(self, data, flags=0):
-        if not self.new_roundtrip:
-            self.new_roundtrip = True
-            self.sleep(self.latency)
-        bytes_sent = self.sock.send(data, flags)
-        self.sleep(bytes_sent * self.time_per_byte)
-        return bytes_sent
-
-
-class SFTPServer(Server):
-    """Common code for SFTP server facilities."""
-
-    def __init__(self, server_interface=StubServer):
-        self._original_vendor = None
-        self._homedir = None
-        self._server_homedir = None
-        self._listener = None
-        self._root = None
-        self._vendor = ssh.ParamikoVendor()
-        self._server_interface = server_interface
-        # sftp server logs
-        self.logs = []
-        self.add_latency = 0
-
-    def _get_sftp_url(self, path):
-        """Calculate an sftp url to this server for path."""
-        return 'sftp://foo:bar@localhost:%d/%s' % (self._listener.port, path)
-
-    def log(self, message):
-        """StubServer uses this to log when a new server is created."""
-        self.logs.append(message)
-
-    def _run_server_entry(self, sock):
-        """Entry point for all implementations of _run_server.
-
-        If self.add_latency is > 0.000001 then sock is given a latency adding
-        decorator.
-        """
-        if self.add_latency > 0.000001:
-            sock = SocketDelay(sock, self.add_latency)
-        return self._run_server(sock)
-
-    def _run_server(self, s):
-        ssh_server = paramiko.Transport(s)
-        key_file = pathjoin(self._homedir, 'test_rsa.key')
-        f = open(key_file, 'w')
-        f.write(STUB_SERVER_KEY)
-        f.close()
-        host_key = paramiko.RSAKey.from_private_key_file(key_file)
-        ssh_server.add_server_key(host_key)
-        server = self._server_interface(self)
-        ssh_server.set_subsystem_handler('sftp', paramiko.SFTPServer,
-                                         StubSFTPServer, root=self._root,
-                                         home=self._server_homedir)
-        event = threading.Event()
-        ssh_server.start_server(event, server)
-        event.wait(5.0)
-
-    def setUp(self, backing_server=None):
-        # XXX: TODO: make sftpserver back onto backing_server rather than local
-        # disk.
-        if not (backing_server is None or
-                isinstance(backing_server, local.LocalURLServer)):
-            raise AssertionError(
-                "backing_server should not be %r, because this can only serve the "
-                "local current working directory." % (backing_server,))
-        self._original_vendor = ssh._ssh_vendor_manager._cached_ssh_vendor
-        ssh._ssh_vendor_manager._cached_ssh_vendor = self._vendor
-        if sys.platform == 'win32':
-            # Win32 needs to use the UNICODE api
-            self._homedir = getcwd()
-        else:
-            # But Linux SFTP servers should just deal in bytestreams
-            self._homedir = os.getcwd()
-        if self._server_homedir is None:
-            self._server_homedir = self._homedir
-        self._root = '/'
-        if sys.platform == 'win32':
-            self._root = ''
-        self._listener = SocketListener(self._run_server_entry)
-        self._listener.setDaemon(True)
-        self._listener.start()
-
-    def tearDown(self):
-        """See bzrlib.transport.Server.tearDown."""
-        self._listener.stop()
-        ssh._ssh_vendor_manager._cached_ssh_vendor = self._original_vendor
-
-    def get_bogus_url(self):
-        """See bzrlib.transport.Server.get_bogus_url."""
-        # this is chosen to try to prevent trouble with proxies, wierd dns, etc
-        # we bind a random socket, so that we get a guaranteed unused port
-        # we just never listen on that port
-        s = socket.socket()
-        s.bind(('localhost', 0))
-        return 'sftp://%s:%s/' % s.getsockname()
-
-
-class SFTPFullAbsoluteServer(SFTPServer):
-    """A test server for sftp transports, using absolute urls and ssh."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        homedir = self._homedir
-        if sys.platform != 'win32':
-            # Remove the initial '/' on all platforms but win32
-            homedir = homedir[1:]
-        return self._get_sftp_url(urlutils.escape(homedir))
-
-
-class SFTPServerWithoutSSH(SFTPServer):
-    """An SFTP server that uses a simple TCP socket pair rather than SSH."""
-
-    def __init__(self):
-        super(SFTPServerWithoutSSH, self).__init__()
-        self._vendor = ssh.LoopbackVendor()
-
-    def _run_server(self, sock):
-        # Re-import these as locals, so that they're still accessible during
-        # interpreter shutdown (when all module globals get set to None, leading
-        # to confusing errors like "'NoneType' object has no attribute 'error'".
-        class FakeChannel(object):
-            def get_transport(self):
-                return self
-            def get_log_channel(self):
-                return 'paramiko'
-            def get_name(self):
-                return '1'
-            def get_hexdump(self):
-                return False
-            def close(self):
-                pass
-
-        server = paramiko.SFTPServer(
-            FakeChannel(), 'sftp', StubServer(self), StubSFTPServer,
-            root=self._root, home=self._server_homedir)
-        try:
-            server.start_subsystem(
-                'sftp', None, ssh.SocketAsChannelAdapter(sock))
-        except socket.error, e:
-            if (len(e.args) > 0) and (e.args[0] == errno.EPIPE):
-                # it's okay for the client to disconnect abruptly
-                # (bug in paramiko 1.6: it should absorb this exception)
-                pass
-            else:
-                raise
-        except Exception, e:
-            # This typically seems to happen during interpreter shutdown, so
-            # most of the useful ways to report this error are won't work.
-            # Writing the exception type, and then the text of the exception,
-            # seems to be the best we can do.
-            import sys
-            sys.stderr.write('\nEXCEPTION %r: ' % (e.__class__,))
-            sys.stderr.write('%s\n\n' % (e,))
-        server.finish_subsystem()
-
-
-class SFTPAbsoluteServer(SFTPServerWithoutSSH):
-    """A test server for sftp transports, using absolute urls."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        homedir = self._homedir
-        if sys.platform != 'win32':
-            # Remove the initial '/' on all platforms but win32
-            homedir = homedir[1:]
-        return self._get_sftp_url(urlutils.escape(homedir))
-
-
-class SFTPHomeDirServer(SFTPServerWithoutSSH):
-    """A test server for sftp transports, using homedir relative urls."""
-
-    def get_url(self):
-        """See bzrlib.transport.Server.get_url."""
-        return self._get_sftp_url("~/")
-
-
-class SFTPSiblingAbsoluteServer(SFTPAbsoluteServer):
-    """A test server for sftp transports where only absolute paths will work.
-
-    It does this by serving from a deeply-nested directory that doesn't exist.
-    """
-
-    def setUp(self, backing_server=None):
-        self._server_homedir = '/dev/noone/runs/tests/here'
-        super(SFTPSiblingAbsoluteServer, self).setUp(backing_server)
-
 
 def get_test_permutations():
     """Return the permutations to be used in testing."""
-    return [(SFTPTransport, SFTPAbsoluteServer),
-            (SFTPTransport, SFTPHomeDirServer),
-            (SFTPTransport, SFTPSiblingAbsoluteServer),
+    from bzrlib.tests import stub_sftp
+    return [(SFTPTransport, stub_sftp.SFTPAbsoluteServer),
+            (SFTPTransport, stub_sftp.SFTPHomeDirServer),
+            (SFTPTransport, stub_sftp.SFTPSiblingAbsoluteServer),
             ]

=== modified file 'bzrlib/transport/ssh.py'
--- bzrlib/transport/ssh.py	2009-10-02 05:43:41 +0000
+++ bzrlib/transport/ssh.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Robey Pointer <robey@lag.net>
+# Copyright (C) 2006-2010 Robey Pointer <robey@lag.net>
 # Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
@@ -94,7 +94,10 @@
             try:
                 vendor = self._ssh_vendors[vendor_name]
             except KeyError:
-                raise errors.UnknownSSH(vendor_name)
+                vendor = self._get_vendor_from_path(vendor_name)
+                if vendor is None:
+                    raise errors.UnknownSSH(vendor_name)
+                vendor.executable_path = vendor_name
             return vendor
         return None
 
@@ -110,7 +113,7 @@
             stdout = stderr = ''
         return stdout + stderr
 
-    def _get_vendor_by_version_string(self, version, args):
+    def _get_vendor_by_version_string(self, version, progname):
         """Return the vendor or None based on output from the subprocess.
 
         :param version: The output of 'ssh -V' like command.
@@ -123,25 +126,27 @@
         elif 'SSH Secure Shell' in version:
             trace.mutter('ssh implementation is SSH Corp.')
             vendor = SSHCorpSubprocessVendor()
-        # Auto-detect of plink vendor disabled, on Windows recommended
-        # default ssh-client is paramiko
-        # see https://bugs.launchpad.net/bugs/414743
-        #~elif 'plink' in version and args[0] == 'plink':
-        #~    # Checking if "plink" was the executed argument as Windows
-        #~    # sometimes reports 'ssh -V' incorrectly with 'plink' in it's
-        #~    # version.  See https://bugs.launchpad.net/bzr/+bug/107155
-        #~    trace.mutter("ssh implementation is Putty's plink.")
-        #~    vendor = PLinkSubprocessVendor()
+        # As plink user prompts are not handled currently, don't auto-detect
+        # it by inspection below, but keep this vendor detection for if a path
+        # is given in BZR_SSH. See https://bugs.launchpad.net/bugs/414743
+        elif 'plink' in version and progname == 'plink':
+            # Checking if "plink" was the executed argument as Windows
+            # sometimes reports 'ssh -V' incorrectly with 'plink' in it's
+            # version.  See https://bugs.launchpad.net/bzr/+bug/107155
+            trace.mutter("ssh implementation is Putty's plink.")
+            vendor = PLinkSubprocessVendor()
         return vendor
 
     def _get_vendor_by_inspection(self):
         """Return the vendor or None by checking for known SSH implementations."""
-        for args in (['ssh', '-V'], ['plink', '-V']):
-            version = self._get_ssh_version_string(args)
-            vendor = self._get_vendor_by_version_string(version, args)
-            if vendor is not None:
-                return vendor
-        return None
+        version = self._get_ssh_version_string(['ssh', '-V'])
+        return self._get_vendor_by_version_string(version, "ssh")
+
+    def _get_vendor_from_path(self, path):
+        """Return the vendor or None using the program at the given path"""
+        version = self._get_ssh_version_string([path, '-V'])
+        return self._get_vendor_by_version_string(version, 
+            os.path.splitext(os.path.basename(path))[0])
 
     def get_vendor(self, environment=None):
         """Find out what version of SSH is on the system.
@@ -404,9 +409,11 @@
 class OpenSSHSubprocessVendor(SubprocessVendor):
     """SSH vendor that uses the 'ssh' executable from OpenSSH."""
 
+    executable_path = 'ssh'
+
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
-        args = ['ssh',
+        args = [self.executable_path,
                 '-oForwardX11=no', '-oForwardAgent=no',
                 '-oClearAllForwardings=yes', '-oProtocol=2',
                 '-oNoHostAuthenticationForLocalhost=yes']
@@ -426,9 +433,11 @@
 class SSHCorpSubprocessVendor(SubprocessVendor):
     """SSH vendor that uses the 'ssh' executable from SSH Corporation."""
 
+    executable_path = 'ssh'
+
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
-        args = ['ssh', '-x']
+        args = [self.executable_path, '-x']
         if port is not None:
             args.extend(['-p', str(port)])
         if username is not None:
@@ -439,15 +448,17 @@
             args.extend([host] + command)
         return args
 
-register_ssh_vendor('ssh', SSHCorpSubprocessVendor())
+register_ssh_vendor('sshcorp', SSHCorpSubprocessVendor())
 
 
 class PLinkSubprocessVendor(SubprocessVendor):
     """SSH vendor that uses the 'plink' executable from Putty."""
 
+    executable_path = 'plink'
+
     def _get_vendor_specific_argv(self, username, host, port, subsystem=None,
                                   command=None):
-        args = ['plink', '-x', '-a', '-ssh', '-2', '-batch']
+        args = [self.executable_path, '-x', '-a', '-ssh', '-2', '-batch']
         if port is not None:
             args.extend(['-P', str(port)])
         if username is not None:
@@ -627,12 +638,28 @@
                 'close_fds': True,
                 }
 
+import weakref
+_subproc_weakrefs = set()
+
+def _close_ssh_proc(proc):
+    for func in [proc.stdin.close, proc.stdout.close, proc.wait]:
+        try:
+            func()
+        except OSError:
+            pass
+
 
 class SSHSubprocess(object):
     """A socket-like object that talks to an ssh subprocess via pipes."""
 
     def __init__(self, proc):
         self.proc = proc
+        # Add a weakref to proc that will attempt to do the same as self.close
+        # to avoid leaving processes lingering indefinitely.
+        def terminate(ref):
+            _subproc_weakrefs.remove(ref)
+            _close_ssh_proc(proc)
+        _subproc_weakrefs.add(weakref.ref(self, terminate))
 
     def send(self, data):
         return os.write(self.proc.stdin.fileno(), data)
@@ -641,9 +668,7 @@
         return os.read(self.proc.stdout.fileno(), count)
 
     def close(self):
-        self.proc.stdin.close()
-        self.proc.stdout.close()
-        self.proc.wait()
+        _close_ssh_proc(self.proc)
 
     def get_filelike_channels(self):
         return (self.proc.stdout, self.proc.stdin)

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2009-08-28 05:00:33 +0000
+++ bzrlib/tree.py	2010-02-16 16:08:40 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -404,16 +404,34 @@
             bit_iter = iter(path.split("/"))
             for elt in bit_iter:
                 lelt = elt.lower()
+                new_path = None
                 for child in self.iter_children(cur_id):
                     try:
+                        # XXX: it seem like if the child is known to be in the
+                        # tree, we shouldn't need to go from its id back to
+                        # its path -- mbp 2010-02-11
+                        #
+                        # XXX: it seems like we could be more efficient
+                        # by just directly looking up the original name and
+                        # only then searching all children; also by not
+                        # chopping paths so much. -- mbp 2010-02-11
                         child_base = os.path.basename(self.id2path(child))
-                        if child_base.lower() == lelt:
+                        if (child_base == elt):
+                            # if we found an exact match, we can stop now; if
+                            # we found an approximate match we need to keep
+                            # searching because there might be an exact match
+                            # later.  
                             cur_id = child
-                            cur_path = osutils.pathjoin(cur_path, child_base)
+                            new_path = osutils.pathjoin(cur_path, child_base)
                             break
+                        elif child_base.lower() == lelt:
+                            cur_id = child
+                            new_path = osutils.pathjoin(cur_path, child_base)
                     except NoSuchId:
                         # before a change is committed we can see this error...
                         continue
+                if new_path:
+                    cur_path = new_path
                 else:
                     # got to the end of this directory and no entries matched.
                     # Return what matched so far, plus the rest as specified.
@@ -697,7 +715,6 @@
                 for path in path_names:
                     yield searcher.get_items(path)
 
-    @needs_read_lock
     def _get_rules_searcher(self, default_searcher):
         """Get the RulesSearcher for this tree given the default one."""
         searcher = default_searcher
@@ -852,6 +869,12 @@
     will pass through to InterTree as appropriate.
     """
 
+    # Formats that will be used to test this InterTree. If both are
+    # None, this InterTree will not be tested (e.g. because a complex
+    # setup is required)
+    _matching_from_tree_format = None
+    _matching_to_tree_format = None
+
     _optimisers = []
 
     def _changes_from_entries(self, source_entry, target_entry,
@@ -954,8 +977,6 @@
             a PathsNotVersionedError will be thrown.
         :param want_unversioned: Scan for unversioned paths.
         """
-        # NB: show_status depends on being able to pass in non-versioned files
-        # and report them as unknown
         trees = (self.source,)
         if extra_trees is not None:
             trees = trees + tuple(extra_trees)

=== modified file 'bzrlib/ui/__init__.py'
--- bzrlib/ui/__init__.py	2009-10-15 20:04:37 +0000
+++ bzrlib/ui/__init__.py	2010-01-15 08:18:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -109,6 +109,15 @@
 
     def __init__(self):
         self._task_stack = []
+        self._quiet = False
+
+    def be_quiet(self, state):
+        """Tell the UI to be more quiet, or not.
+
+        Typically this suppresses progress bars; the application may also look
+        at ui_factory.is_quiet().
+        """
+        self._quiet = state
 
     def get_password(self, prompt='', **kwargs):
         """Prompt the user for a password.
@@ -125,6 +134,37 @@
         """
         raise NotImplementedError(self.get_password)
 
+    def is_quiet(self):
+        return self._quiet
+
+    def make_output_stream(self, encoding=None, encoding_type=None):
+        """Get a stream for sending out bulk text data.
+
+        This is used for commands that produce bulk text, such as log or diff
+        output, as opposed to user interaction.  This should work even for
+        non-interactive user interfaces.  Typically this goes to a decorated
+        version of stdout, but in a GUI it might be appropriate to send it to a 
+        window displaying the text.
+     
+        :param encoding: Unicode encoding for output; default is the 
+            terminal encoding, which may be different from the user encoding.
+            (See get_terminal_encoding.)
+
+        :param encoding_type: How to handle encoding errors:
+            replace/strict/escape/exact.  Default is replace.
+        """
+        # XXX: is the caller supposed to close the resulting object?
+        if encoding is None:
+            encoding = osutils.get_terminal_encoding()
+        if encoding_type is None:
+            encoding_type = 'replace'
+        out_stream = self._make_output_stream_explicit(encoding, encoding_type)
+        return out_stream
+
+    def _make_output_stream_explicit(self, encoding, encoding_type):
+        raise NotImplementedError("%s doesn't support make_output_stream"
+            % (self.__class__.__name__))
+
     def nested_progress_bar(self):
         """Return a nested progress bar.
 
@@ -179,6 +219,16 @@
         """
         raise NotImplementedError(self.get_boolean)
 
+    def get_integer(self, prompt):
+        """Get an integer from the user.
+
+        :param prompt: a message to prompt the user with. Could be a multi-line
+            prompt but without a terminating \n.
+
+        :return: A signed integer.
+        """
+        raise NotImplementedError(self.get_integer)
+
     def make_progress_view(self):
         """Construct a new ProgressView object for this UI.
 
@@ -208,11 +258,24 @@
         """
         pass
 
+    def log_transport_activity(self, display=False):
+        """Write out whatever transport activity has been measured.
+
+        Implementations are allowed to do nothing, but it is useful if they can
+        write a line to the log file.
+
+        :param display: If False, only log to disk, if True also try to display
+            a message to the user.
+        :return: None
+        """
+        # Default implementation just does nothing
+        pass
+
     def show_error(self, msg):
         """Show an error message (not an exception) to the user.
         
         The message should not have an error prefix or trailing newline.  That
-        will be added by the factory if appropriate. 
+        will be added by the factory if appropriate.
         """
         raise NotImplementedError(self.show_error)
 
@@ -224,6 +287,13 @@
         """Show a warning to the user."""
         raise NotImplementedError(self.show_warning)
 
+    def warn_cross_format_fetch(self, from_format, to_format):
+        """Warn about a potentially slow cross-format transfer"""
+        # See <https://launchpad.net/bugs/456077> asking for a warning here
+        trace.warning("Doing on-the-fly conversion from %s to %s.\n"
+            "This may take some time. Upgrade the repositories to the "
+            "same format for better performance.\n" %
+            (from_format, to_format))
 
 
 class SilentUIFactory(UIFactory):
@@ -245,6 +315,9 @@
     def get_username(self, prompt, **kwargs):
         return None
 
+    def _make_output_stream_explicit(self, encoding, encoding_type):
+        return NullOutputStream(encoding)
+
     def show_error(self, msg):
         pass
 
@@ -267,12 +340,15 @@
     def get_boolean(self, prompt):
         return self.responses.pop(0)
 
+    def get_integer(self, prompt):
+        return self.responses.pop(0)
+
     def get_password(self, prompt='', **kwargs):
         return self.responses.pop(0)
 
     def get_username(self, prompt, **kwargs):
         return self.responses.pop(0)
-    
+
     def assert_all_input_consumed(self):
         if self.responses:
             raise AssertionError("expected all input in %r to be consumed"
@@ -304,3 +380,22 @@
 
     def show_transport_activity(self, transport, direction, byte_count):
         pass
+
+    def log_transport_activity(self, display=False):
+        pass
+
+
+class NullOutputStream(object):
+    """Acts like a file, but discard all output."""
+
+    def __init__(self, encoding):
+        self.encoding = encoding
+
+    def write(self, data):
+        pass
+
+    def writelines(self, data):
+        pass
+
+    def close(self):
+        pass

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2009-09-23 06:29:46 +0000
+++ bzrlib/ui/text.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,6 +18,7 @@
 """Text UI, write output to the console.
 """
 
+import codecs
 import getpass
 import os
 import sys
@@ -31,10 +32,13 @@
     progress,
     osutils,
     symbol_versioning,
+    trace,
     )
 
 """)
 
+from bzrlib.osutils import watch_sigwinch
+
 from bzrlib.ui import (
     UIFactory,
     NullProgressView,
@@ -58,7 +62,15 @@
         self.stderr = stderr
         # paints progress, network activity, etc
         self._progress_view = self.make_progress_view()
-        
+        # hook up the signals to watch for terminal size changes
+        watch_sigwinch()
+
+    def be_quiet(self, state):
+        if state and not self._quiet:
+            self.clear_term()
+        UIFactory.be_quiet(self, state)
+        self._progress_view = self.make_progress_view()
+
     def clear_term(self):
         """Prepare the terminal for output.
 
@@ -82,6 +94,15 @@
                 # end-of-file; possibly should raise an error here instead
                 return None
 
+    def get_integer(self, prompt):
+        while True:
+            self.prompt(prompt)
+            line = self.stdin.readline()
+            try:
+                return int(line)
+            except ValueError:
+                pass
+
     def get_non_echoed_password(self):
         isatty = getattr(self.stdin, 'isatty', None)
         if isatty is not None and isatty():
@@ -135,9 +156,13 @@
     def make_progress_view(self):
         """Construct and return a new ProgressView subclass for this UI.
         """
-        # if the user specifically requests either text or no progress bars,
-        # always do that.  otherwise, guess based on $TERM and tty presence.
-        if os.environ.get('BZR_PROGRESS_BAR') == 'text':
+        # with --quiet, never any progress view
+        # <https://bugs.edge.launchpad.net/bzr/+bug/320035>.  Otherwise if the
+        # user specifically requests either text or no progress bars, always
+        # do that.  otherwise, guess based on $TERM and tty presence.
+        if self.is_quiet():
+            return NullProgressView()
+        elif os.environ.get('BZR_PROGRESS_BAR') == 'text':
             return TextProgressView(self.stderr)
         elif os.environ.get('BZR_PROGRESS_BAR') == 'none':
             return NullProgressView()
@@ -146,6 +171,26 @@
         else:
             return NullProgressView()
 
+    def _make_output_stream_explicit(self, encoding, encoding_type):
+        if encoding_type == 'exact':
+            # force sys.stdout to be binary stream on win32; 
+            # NB: this leaves the file set in that mode; may cause problems if
+            # one process tries to do binary and then text output
+            if sys.platform == 'win32':
+                fileno = getattr(self.stdout, 'fileno', None)
+                if fileno:
+                    import msvcrt
+                    msvcrt.setmode(fileno(), os.O_BINARY)
+            return TextUIOutputStream(self, self.stdout)
+        else:
+            encoded_stdout = codecs.getwriter(encoding)(self.stdout,
+                errors=encoding_type)
+            # For whatever reason codecs.getwriter() does not advertise its encoding
+            # it just returns the encoding of the wrapped file, which is completely
+            # bogus. So set the attribute, so we can find the correct encoding later.
+            encoded_stdout.encoding = encoding
+            return TextUIOutputStream(self, encoded_stdout)
+
     def note(self, msg):
         """Write an already-formatted message, clearing the progress bar if necessary."""
         self.clear_term()
@@ -173,6 +218,12 @@
         self._progress_view.show_transport_activity(transport,
             direction, byte_count)
 
+    def log_transport_activity(self, display=False):
+        """See UIFactory.log_transport_activity()"""
+        log = getattr(self._progress_view, 'log_transport_activity', None)
+        if log is not None:
+            log(display=display)
+
     def show_error(self, msg):
         self.clear_term()
         self.stderr.write("bzr: error: %s\n" % msg)
@@ -218,9 +269,6 @@
         self._term_file = term_file
         # true when there's output on the screen we may need to clear
         self._have_output = False
-        # XXX: We could listen for SIGWINCH and update the terminal width...
-        # https://launchpad.net/bugs/316357
-        self._width = osutils.terminal_width()
         self._last_transport_msg = ''
         self._spin_pos = 0
         # time we last repainted the screen
@@ -230,12 +278,21 @@
         self._last_task = None
         self._total_byte_count = 0
         self._bytes_since_update = 0
+        self._bytes_by_direction = {'unknown': 0, 'read': 0, 'write': 0}
+        self._first_byte_time = None
         self._fraction = 0
+        # force the progress bar to be off, as at the moment it doesn't 
+        # correspond reliably to overall command progress
+        self.enable_bar = False
 
     def _show_line(self, s):
         # sys.stderr.write("progress %r\n" % s)
-        n = self._width - 1
-        self._term_file.write('\r%-*.*s\r' % (n, n, s))
+        width = osutils.terminal_width()
+        if width is not None:
+            # we need one extra space for terminals that wrap on last char
+            width = width - 1
+            s = '%-*.*s' % (width, width, s)
+        self._term_file.write('\r' + s + '\r')
 
     def clear(self):
         if self._have_output:
@@ -244,7 +301,8 @@
 
     def _render_bar(self):
         # return a string for the progress bar itself
-        if (self._last_task is None) or self._last_task.show_bar:
+        if self.enable_bar and (
+            (self._last_task is None) or self._last_task.show_bar):
             # If there's no task object, we show space for the bar anyhow.
             # That's because most invocations of bzr will end showing progress
             # at some point, though perhaps only after doing some initial IO.
@@ -266,7 +324,7 @@
             markers = int(round(float(cols) * completion_fraction)) - 1
             bar_str = '[' + ('#' * markers + spin_str).ljust(cols) + '] '
             return bar_str
-        elif self._last_task.show_spinner:
+        elif (self._last_task is None) or self._last_task.show_spinner:
             # The last task wanted just a spinner, no bar
             spin_str =  r'/-\|'[self._spin_pos % 4]
             self._spin_pos += 1
@@ -334,19 +392,25 @@
         This may update a progress bar, spinner, or similar display.
         By default it does nothing.
         """
-        # XXX: Probably there should be a transport activity model, and that
-        # too should be seen by the progress view, rather than being poked in
-        # here.
-        if not self._have_output:
-            # As a workaround for <https://launchpad.net/bugs/321935> we only
-            # show transport activity when there's already a progress bar
-            # shown, which time the application code is expected to know to
-            # clear off the progress bar when it's going to send some other
-            # output.  Eventually it would be nice to have that automatically
-            # synchronized.
-            return
+        # XXX: there should be a transport activity model, and that too should
+        #      be seen by the progress view, rather than being poked in here.
         self._total_byte_count += byte_count
         self._bytes_since_update += byte_count
+        if self._first_byte_time is None:
+            # Note that this isn't great, as technically it should be the time
+            # when the bytes started transferring, not when they completed.
+            # However, we usually start with a small request anyway.
+            self._first_byte_time = time.time()
+        if direction in self._bytes_by_direction:
+            self._bytes_by_direction[direction] += byte_count
+        else:
+            self._bytes_by_direction['unknown'] += byte_count
+        if 'no_activity' in debug.debug_flags:
+            # Can be used as a workaround if
+            # <https://launchpad.net/bugs/321935> reappears and transport
+            # activity is cluttering other output.  However, thanks to
+            # TextUIOutputStream this shouldn't be a problem any more.
+            return
         now = time.time()
         if self._total_byte_count < 2000:
             # a little resistance at first, so it doesn't stay stuck at 0
@@ -365,3 +429,68 @@
             self._bytes_since_update = 0
             self._last_transport_msg = msg
             self._repaint()
+
+    def _format_bytes_by_direction(self):
+        if self._first_byte_time is None:
+            bps = 0.0
+        else:
+            transfer_time = time.time() - self._first_byte_time
+            if transfer_time < 0.001:
+                transfer_time = 0.001
+            bps = self._total_byte_count / transfer_time
+
+        msg = ('Transferred: %.0fKiB'
+               ' (%.1fK/s r:%.0fK w:%.0fK'
+               % (self._total_byte_count / 1024.,
+                  bps / 1024.,
+                  self._bytes_by_direction['read'] / 1024.,
+                  self._bytes_by_direction['write'] / 1024.,
+                 ))
+        if self._bytes_by_direction['unknown'] > 0:
+            msg += ' u:%.0fK)' % (
+                self._bytes_by_direction['unknown'] / 1024.
+                )
+        else:
+            msg += ')'
+        return msg
+
+    def log_transport_activity(self, display=False):
+        msg = self._format_bytes_by_direction()
+        trace.mutter(msg)
+        if display and self._total_byte_count > 0:
+            self.clear()
+            self._term_file.write(msg + '\n')
+
+
+class TextUIOutputStream(object):
+    """Decorates an output stream so that the terminal is cleared before writing.
+
+    This is supposed to ensure that the progress bar does not conflict with bulk
+    text output.
+    """
+    # XXX: this does not handle the case of writing part of a line, then doing
+    # progress bar output: the progress bar will probably write over it.
+    # one option is just to buffer that text until we have a full line;
+    # another is to save and restore it
+
+    # XXX: might need to wrap more methods
+
+    def __init__(self, ui_factory, wrapped_stream):
+        self.ui_factory = ui_factory
+        self.wrapped_stream = wrapped_stream
+        # this does no transcoding, but it must expose the underlying encoding
+        # because some callers need to know what can be written - see for
+        # example unescape_for_display.
+        self.encoding = getattr(wrapped_stream, 'encoding', None)
+
+    def flush(self):
+        self.ui_factory.clear_term()
+        self.wrapped_stream.flush()
+
+    def write(self, to_write):
+        self.ui_factory.clear_term()
+        self.wrapped_stream.write(to_write)
+
+    def writelines(self, lines):
+        self.ui_factory.clear_term()
+        self.wrapped_stream.writelines(lines)

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2009-07-16 07:10:45 +0000
+++ bzrlib/urlutils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -217,10 +217,16 @@
 # jam 20060502 Sorted to 'l' because the final target is 'local_path_from_url'
 def _posix_local_path_from_url(url):
     """Convert a url like file:///path/to/foo into /path/to/foo"""
-    if not url.startswith('file:///'):
-        raise errors.InvalidURL(url, 'local urls must start with file:///')
+    file_localhost_prefix = 'file://localhost/'
+    if url.startswith(file_localhost_prefix):
+        path = url[len(file_localhost_prefix) - 1:]
+    elif not url.startswith('file:///'):
+        raise errors.InvalidURL(
+            url, 'local urls must start with file:/// or file://localhost/')
+    else:
+        path = url[len('file://'):]
     # We only strip off 2 slashes
-    return unescape(url[len('file://'):])
+    return unescape(path)
 
 
 def _posix_local_path_to_url(path):

=== modified file 'bzrlib/util/_bencode_py.py'
--- bzrlib/util/_bencode_py.py	2009-10-13 14:36:50 +0000
+++ bzrlib/util/_bencode_py.py	2009-12-01 19:44:12 +0000
@@ -154,6 +154,8 @@
         encode_int(int(x), r)
     encode_func[BooleanType] = encode_bool
 
+from bzrlib._static_tuple_py import StaticTuple
+encode_func[StaticTuple] = encode_list
 try:
     from bzrlib._static_tuple_c import StaticTuple
 except ImportError:

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2009-08-14 12:08:08 +0000
+++ bzrlib/version.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006, 2007, 2009 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -50,8 +50,9 @@
     # show path to python interpreter
     # (bzr.exe use python interpreter from pythonXY.dll
     # but sys.executable point to bzr.exe itself)
-    if not hasattr(sys, 'frozen'):  # check for bzr.exe
-        # python executable
+    # however, sys.frozen exists if running from bzr.exe
+    # see http://www.py2exe.org/index.cgi/Py2exeEnvironment
+    if getattr(sys, 'frozen', None) is None: # if not bzr.exe
         to_file.write(sys.executable + ' ')
     else:
         # pythonXY.dll
@@ -87,6 +88,8 @@
         to_file.write("bzr comes with ABSOLUTELY NO WARRANTY.  bzr is free software, and\n")
         to_file.write("you may use, modify and redistribute it under the terms of the GNU\n")
         to_file.write("General Public License version 2 or later.\n")
+        to_file.write("\nBazaar is part of the GNU Project to produce a free operating "
+                "system.\n")
     to_file.write('\n')
 
 

=== modified file 'bzrlib/version_info_formats/format_rio.py'
--- bzrlib/version_info_formats/format_rio.py	2009-04-06 02:54:48 +0000
+++ bzrlib/version_info_formats/format_rio.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -84,6 +84,7 @@
     """Hooks for rio-formatted version-info output."""
 
     def __init__(self):
+        super(RioVersionInfoBuilderHooks, self).__init__()
         self.create_hook(hooks.HookPoint('revision',
             "Invoked when adding information about a revision to the"
             " RIO stanza that is printed. revision is called with a"

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2009-10-19 15:06:58 +0000
+++ bzrlib/versionedfile.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # Authors:
 #   Johan Rydberg <jrydberg@gnu.org>
@@ -1426,7 +1426,7 @@
     def __init__(self, plan, a_marker=TextMerge.A_MARKER,
                  b_marker=TextMerge.B_MARKER):
         TextMerge.__init__(self, a_marker, b_marker)
-        self.plan = plan
+        self.plan = list(plan)
 
     def _merge_struct(self):
         lines_a = []
@@ -1490,6 +1490,60 @@
         for struct in outstanding_struct():
             yield struct
 
+    def base_from_plan(self):
+        """Construct a BASE file from the plan text."""
+        base_lines = []
+        for state, line in self.plan:
+            if state in ('killed-a', 'killed-b', 'killed-both', 'unchanged'):
+                # If unchanged, then this line is straight from base. If a or b
+                # or both killed the line, then it *used* to be in base.
+                base_lines.append(line)
+            else:
+                if state not in ('killed-base', 'irrelevant',
+                                 'ghost-a', 'ghost-b',
+                                 'new-a', 'new-b',
+                                 'conflicted-a', 'conflicted-b'):
+                    # killed-base, irrelevant means it doesn't apply
+                    # ghost-a/ghost-b are harder to say for sure, but they
+                    # aren't in the 'inc_c' which means they aren't in the
+                    # shared base of a & b. So we don't include them.  And
+                    # obviously if the line is newly inserted, it isn't in base
+
+                    # If 'conflicted-a' or b, then it is new vs one base, but
+                    # old versus another base. However, if we make it present
+                    # in the base, it will be deleted from the target, and it
+                    # seems better to get a line doubled in the merge result,
+                    # rather than have it deleted entirely.
+                    # Example, each node is the 'text' at that point:
+                    #           MN
+                    #          /   \
+                    #        MaN   MbN
+                    #         |  X  |
+                    #        MabN MbaN
+                    #          \   /
+                    #           ???
+                    # There was a criss-cross conflict merge. Both sides
+                    # include the other, but put themselves first.
+                    # Weave marks this as a 'clean' merge, picking OTHER over
+                    # THIS. (Though the details depend on order inserted into
+                    # weave, etc.)
+                    # LCA generates a plan:
+                    # [('unchanged', M),
+                    #  ('conflicted-b', b),
+                    #  ('unchanged', a),
+                    #  ('conflicted-a', b),
+                    #  ('unchanged', N)]
+                    # If you mark 'conflicted-*' as part of BASE, then a 3-way
+                    # merge tool will cleanly generate "MaN" (as BASE vs THIS
+                    # removes one 'b', and BASE vs OTHER removes the other)
+                    # If you include neither, 3-way creates a clean "MbabN" as
+                    # THIS adds one 'b', and OTHER does too.
+                    # It seems that having the line 2 times is better than
+                    # having it omitted. (Easier to manually delete than notice
+                    # it needs to be added.)
+                    raise AssertionError('Unknown state: %s' % (state,))
+        return base_lines
+
 
 class WeaveMerge(PlanWeaveMerge):
     """Weave merge that takes a VersionedFile and two versions as its input."""

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2009-07-08 14:37:25 +0000
+++ bzrlib/win32utils.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,7 +19,9 @@
 Only one dependency: ctypes should be installed.
 """
 
+import glob
 import os
+import re
 import struct
 import sys
 
@@ -178,7 +180,7 @@
         return (defaultx, defaulty)
 
     # To avoid problem with redirecting output via pipe
-    # need to use stderr instead of stdout
+    # we need to use stderr instead of stdout
     h = ctypes.windll.kernel32.GetStdHandle(WIN32_STDERR_HANDLE)
     csbi = ctypes.create_string_buffer(22)
     res = ctypes.windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
@@ -388,7 +390,6 @@
 
 
 def _ensure_unicode(s):
-    from bzrlib import osutils
     if s and type(s) != unicode:
         from bzrlib import osutils
         s = s.decode(osutils.get_user_encoding())
@@ -422,6 +423,26 @@
 
 
 
+def glob_one(possible_glob):
+    """Same as glob.glob().
+
+    work around bugs in glob.glob()
+    - Python bug #1001604 ("glob doesn't return unicode with ...")
+    - failing expansion for */* with non-iso-8859-* chars
+    """
+    corrected_glob, corrected = _ensure_with_dir(possible_glob)
+    glob_files = glob.glob(corrected_glob)
+
+    if not glob_files:
+        # special case to let the normal code path handle
+        # files that do not exist, etc.
+        glob_files = [possible_glob]
+    elif corrected:
+        glob_files = [_undo_ensure_with_dir(elem, corrected)
+                      for elem in glob_files]
+    return [elem.replace(u'\\', u'/') for elem in glob_files]
+
+
 def glob_expand(file_list):
     """Replacement for glob expansion by the shell.
 
@@ -435,25 +456,10 @@
     """
     if not file_list:
         return []
-    import glob
     expanded_file_list = []
     for possible_glob in file_list:
-        # work around bugs in glob.glob()
-        # - Python bug #1001604 ("glob doesn't return unicode with ...")
-        # - failing expansion for */* with non-iso-8859-* chars
-        possible_glob, corrected = _ensure_with_dir(possible_glob)
-        glob_files = glob.glob(possible_glob)
-
-        if glob_files == []:
-            # special case to let the normal code path handle
-            # files that do not exists
-            expanded_file_list.append(
-                _undo_ensure_with_dir(possible_glob, corrected))
-        else:
-            glob_files = [_undo_ensure_with_dir(elem, corrected) for elem in glob_files]
-            expanded_file_list += glob_files
-
-    return [elem.replace(u'\\', u'/') for elem in expanded_file_list]
+        expanded_file_list.extend(glob_one(possible_glob))
+    return expanded_file_list
 
 
 def get_app_path(appname):
@@ -511,6 +517,123 @@
             trace.mutter('Unable to set hidden attribute on %r: %s', path, e)
 
 
+
+class UnicodeShlex(object):
+    """This is a very simplified version of shlex.shlex.
+
+    The main change is that it supports non-ascii input streams. The internal
+    structure is quite simplified relative to shlex.shlex, since we aren't
+    trying to handle multiple input streams, etc. In fact, we don't use a
+    file-like api either.
+    """
+
+    def __init__(self, uni_string):
+        self._input = uni_string
+        self._input_iter = iter(self._input)
+        self._whitespace_match = re.compile(u'\s').match
+        self._word_match = re.compile(u'\S').match
+        self._quote_chars = u'"'
+        # self._quote_match = re.compile(u'[\'"]').match
+        self._escape_match = lambda x: None # Never matches
+        self._escape = '\\'
+        # State can be
+        #   ' ' - after whitespace, starting a new token
+        #   'a' - after text, currently working on a token
+        #   '"' - after ", currently in a "-delimited quoted section
+        #   "\" - after '\', checking the next char
+        self._state = ' '
+        self._token = [] # Current token being parsed
+
+    def _get_token(self):
+        # Were there quote chars as part of this token?
+        quoted = False
+        quoted_state = None
+        for nextchar in self._input_iter:
+            if self._state == ' ':
+                if self._whitespace_match(nextchar):
+                    # if self._token: return token
+                    continue
+                elif nextchar in self._quote_chars:
+                    self._state = nextchar # quoted state
+                elif self._word_match(nextchar):
+                    self._token.append(nextchar)
+                    self._state = 'a'
+                else:
+                    raise AssertionError('wtttf?')
+            elif self._state in self._quote_chars:
+                quoted = True
+                if nextchar == self._state: # End of quote
+                    self._state = 'a' # posix allows 'foo'bar to translate to
+                                      # foobar
+                elif self._state == '"' and nextchar == self._escape:
+                    quoted_state = self._state
+                    self._state = nextchar
+                else:
+                    self._token.append(nextchar)
+            elif self._state == self._escape:
+                if nextchar == '\\':
+                    self._token.append('\\')
+                elif nextchar == '"':
+                    self._token.append(nextchar)
+                else:
+                    self._token.append('\\' + nextchar)
+                self._state = quoted_state
+            elif self._state == 'a':
+                if self._whitespace_match(nextchar):
+                    if self._token:
+                        break # emit this token
+                    else:
+                        continue # no token to emit
+                elif nextchar in self._quote_chars:
+                    # Start a new quoted section
+                    self._state = nextchar
+                # escape?
+                elif (self._word_match(nextchar)
+                      or nextchar in self._quote_chars
+                      # or whitespace_split?
+                      ):
+                    self._token.append(nextchar)
+                else:
+                    raise AssertionError('state == "a", char: %r'
+                                         % (nextchar,))
+            else:
+                raise AssertionError('unknown state: %r' % (self._state,))
+        result = ''.join(self._token)
+        self._token = []
+        if not quoted and result == '':
+            result = None
+        return quoted, result
+
+    def __iter__(self):
+        return self
+
+    def next(self):
+        quoted, token = self._get_token()
+        if token is None:
+            raise StopIteration
+        return quoted, token
+
+
+def _command_line_to_argv(command_line):
+    """Convert a Unicode command line into a set of argv arguments.
+
+    This does wildcard expansion, etc. It is intended to make wildcards act
+    closer to how they work in posix shells, versus how they work by default on
+    Windows.
+    """
+    s = UnicodeShlex(command_line)
+    # Now that we've split the content, expand globs
+    # TODO: Use 'globbing' instead of 'glob.glob', this gives us stuff like
+    #       '**/' style globs
+    args = []
+    for is_quoted, arg in s:
+        if is_quoted or not glob.has_magic(arg):
+            args.append(arg)
+        else:
+            args.extend(glob_one(arg))
+    return args
+
+
 if has_ctypes and winver != 'Windows 98':
     def get_unicode_argv():
         LPCWSTR = ctypes.c_wchar_p
@@ -520,21 +643,19 @@
         GetCommandLine = prototype(("GetCommandLineW",
                                     ctypes.windll.kernel32))
         prototype = ctypes.WINFUNCTYPE(POINTER(LPCWSTR), LPCWSTR, POINTER(INT))
-        CommandLineToArgv = prototype(("CommandLineToArgvW",
-                                       ctypes.windll.shell32))
-        c = INT(0)
-        pargv = CommandLineToArgv(GetCommandLine(), ctypes.byref(c))
+        command_line = GetCommandLine()
         # Skip the first argument, since we only care about parameters
-        argv = [pargv[i] for i in range(1, c.value)]
+        argv = _command_line_to_argv(command_line)[1:]
         if getattr(sys, 'frozen', None) is None:
             # Invoked via 'python.exe' which takes the form:
             #   python.exe [PYTHON_OPTIONS] C:\Path\bzr [BZR_OPTIONS]
             # we need to get only BZR_OPTIONS part,
-            # so let's using sys.argv[1:] as reference to get the tail
-            # of unicode argv
-            tail_len = len(sys.argv[1:])
-            ix = len(argv) - tail_len
-            argv = argv[ix:]
+            # We already removed 'python.exe' so we remove everything up to and
+            # including the first non-option ('-') argument.
+            for idx in xrange(len(argv)):
+                if argv[idx][:1] != '-':
+                    break
+            argv = argv[idx+1:]
         return argv
 else:
     get_unicode_argv = None

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2009-10-06 14:40:37 +0000
+++ bzrlib/workingtree.py	2010-01-21 17:54:58 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -65,7 +65,6 @@
     merge,
     revision as _mod_revision,
     revisiontree,
-    textui,
     trace,
     transform,
     ui,
@@ -544,11 +543,11 @@
         else:
             parents = [last_rev]
         try:
-            merges_file = self._transport.get('pending-merges')
+            merges_bytes = self._transport.get_bytes('pending-merges')
         except errors.NoSuchFile:
             pass
         else:
-            for l in merges_file.readlines():
+            for l in osutils.split_lines(merges_bytes):
                 revision_id = l.rstrip('\n')
                 parents.append(revision_id)
         return parents
@@ -636,6 +635,10 @@
 
     def _is_executable_from_path_and_stat_from_basis(self, path, stat_result):
         file_id = self.path2id(path)
+        if file_id is None:
+            # For unversioned files on win32, we just assume they are not
+            # executable
+            return False
         return self._inventory[file_id].executable
 
     def _is_executable_from_path_and_stat_from_stat(self, path, stat_result):
@@ -1624,9 +1627,10 @@
                                 this_tree=self,
                                 pb=pb,
                                 change_reporter=change_reporter)
-                    if (basis_tree.inventory.root is None and
-                        new_basis_tree.inventory.root is not None):
-                        self.set_root_id(new_basis_tree.get_root_id())
+                    basis_root_id = basis_tree.get_root_id()
+                    new_root_id = new_basis_tree.get_root_id()
+                    if basis_root_id != new_root_id:
+                        self.set_root_id(new_root_id)
                 finally:
                     pb.finished()
                     basis_tree.unlock()
@@ -1738,13 +1742,15 @@
         r"""Check whether the filename matches an ignore pattern.
 
         Patterns containing '/' or '\' need to match the whole path;
-        others match against only the last component.
+        others match against only the last component.  Patterns starting
+        with '!' are ignore exceptions.  Exceptions take precedence
+        over regular patterns and cause the filename to not be ignored.
 
         If the file is ignored, returns the pattern which caused it to
         be ignored, otherwise None.  So this can simply be used as a
         boolean if desired."""
         if getattr(self, '_ignoreglobster', None) is None:
-            self._ignoreglobster = globbing.Globster(self.get_ignore_list())
+            self._ignoreglobster = globbing.ExceptionGlobster(self.get_ignore_list())
         return self._ignoreglobster.match(filename)
 
     def kind(self, file_id):
@@ -1841,7 +1847,11 @@
     def _reset_data(self):
         """Reset transient data that cannot be revalidated."""
         self._inventory_is_modified = False
-        result = self._deserialize(self._transport.get('inventory'))
+        f = self._transport.get('inventory')
+        try:
+            result = self._deserialize(f)
+        finally:
+            f.close()
         self._set_inventory(result, dirty=False)
 
     @needs_tree_write_lock
@@ -1923,7 +1933,11 @@
         # binary.
         if self._inventory_is_modified:
             raise errors.InventoryModified(self)
-        result = self._deserialize(self._transport.get('inventory'))
+        f = self._transport.get('inventory')
+        try:
+            result = self._deserialize(f)
+        finally:
+            f.close()
         self._set_inventory(result, dirty=False)
         return result
 
@@ -1944,6 +1958,8 @@
 
         new_files=set()
         unknown_nested_files=set()
+        if to_file is None:
+            to_file = sys.stdout
 
         def recurse_directory_to_add_files(directory):
             # Recurse directory and add all files
@@ -2019,8 +2035,9 @@
                         new_status = 'I'
                     else:
                         new_status = '?'
-                    textui.show_status(new_status, self.kind(fid), f,
-                                       to_file=to_file)
+                    # XXX: Really should be a more abstract reporter interface
+                    kind_ch = osutils.kind_marker(self.kind(fid))
+                    to_file.write(new_status + '       ' + f + kind_ch + '\n')
                 # Unversion file
                 inv_delta.append((f, None, fid, None))
                 message = "removed %s" % (f,)
@@ -2177,7 +2194,10 @@
         """
         raise NotImplementedError(self.unlock)
 
-    def update(self, change_reporter=None, possible_transports=None):
+    _marker = object()
+
+    def update(self, change_reporter=None, possible_transports=None,
+               revision=None, old_tip=_marker):
         """Update a working tree along its branch.
 
         This will update the branch if its bound too, which means we have
@@ -2201,10 +2221,16 @@
         - Merge current state -> basis tree of the master w.r.t. the old tree
           basis.
         - Do a 'normal' merge of the old branch basis if it is relevant.
+
+        :param revision: The target revision to update to. Must be in the
+            revision history.
+        :param old_tip: If branch.update() has already been run, the value it
+            returned (old tip of the branch or None). _marker is used
+            otherwise.
         """
         if self.branch.get_bound_location() is not None:
             self.lock_write()
-            update_branch = True
+            update_branch = (old_tip is self._marker)
         else:
             self.lock_tree_write()
             update_branch = False
@@ -2212,13 +2238,14 @@
             if update_branch:
                 old_tip = self.branch.update(possible_transports)
             else:
-                old_tip = None
-            return self._update_tree(old_tip, change_reporter)
+                if old_tip is self._marker:
+                    old_tip = None
+            return self._update_tree(old_tip, change_reporter, revision)
         finally:
             self.unlock()
 
     @needs_tree_write_lock
-    def _update_tree(self, old_tip=None, change_reporter=None):
+    def _update_tree(self, old_tip=None, change_reporter=None, revision=None):
         """Update a tree to the master branch.
 
         :param old_tip: if supplied, the previous tip revision the branch,
@@ -2239,14 +2266,21 @@
             last_rev = self.get_parent_ids()[0]
         except IndexError:
             last_rev = _mod_revision.NULL_REVISION
-        if last_rev != _mod_revision.ensure_null(self.branch.last_revision()):
-            # merge tree state up to new branch tip.
+        if revision is None:
+            revision = self.branch.last_revision()
+        else:
+            if revision not in self.branch.revision_history():
+                raise errors.NoSuchRevision(self.branch, revision)
+        if last_rev != _mod_revision.ensure_null(revision):
+            # merge tree state up to specified revision.
             basis = self.basis_tree()
             basis.lock_read()
             try:
-                to_tree = self.branch.basis_tree()
-                if basis.inventory.root is None:
-                    self.set_root_id(to_tree.get_root_id())
+                to_tree = self.branch.repository.revision_tree(revision)
+                to_root_id = to_tree.get_root_id()
+                if (basis.inventory.root is None
+                    or basis.inventory.root.file_id != to_root_id):
+                    self.set_root_id(to_root_id)
                     self.flush()
                 result += merge.merge_inner(
                                       self.branch,
@@ -2254,11 +2288,12 @@
                                       basis,
                                       this_tree=self,
                                       change_reporter=change_reporter)
+                self.set_last_revision(revision)
             finally:
                 basis.unlock()
             # TODO - dedup parents list with things merged by pull ?
             # reuse the tree we've updated to to set the basis:
-            parent_trees = [(self.branch.last_revision(), to_tree)]
+            parent_trees = [(revision, to_tree)]
             merges = self.get_parent_ids()[1:]
             # Ideally we ask the tree for the trees here, that way the working
             # tree can decide whether to give us the entire tree or give us a
@@ -2294,8 +2329,7 @@
             #       should be able to remove this extra flush.
             self.flush()
             graph = self.branch.repository.get_graph()
-            base_rev_id = graph.find_unique_lca(self.branch.last_revision(),
-                                                old_tip)
+            base_rev_id = graph.find_unique_lca(revision, old_tip)
             base_tree = self.branch.repository.revision_tree(base_rev_id)
             other_tree = self.branch.repository.revision_tree(old_tip)
             result += merge.merge_inner(
@@ -2580,7 +2614,6 @@
         """
         return
 
-    @needs_read_lock
     def _get_rules_searcher(self, default_searcher):
         """See Tree._get_rules_searcher."""
         if self._rules_searcher is None:
@@ -2765,7 +2798,7 @@
         """Return the format for the working tree object in a_bzrdir."""
         try:
             transport = a_bzrdir.get_workingtree_transport(None)
-            format_string = transport.get("format").read()
+            format_string = transport.get_bytes("format")
             return klass._formats[format_string]
         except errors.NoSuchFile:
             raise errors.NoWorkingTree(base=transport.base)

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2009-09-30 21:38:49 +0000
+++ bzrlib/workingtree_4.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008, 2009 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1447,21 +1447,10 @@
                 if basis_root_id is not None:
                     wt._set_root_id(basis_root_id)
                     wt.flush()
-                # If content filtering is supported, do not use the accelerator
-                # tree - the cost of transforming the content both ways and
-                # checking for changed content can outweight the gains it gives.
-                # Note: do NOT move this logic up higher - using the basis from
-                # the accelerator tree is still desirable because that can save
-                # a minute or more of processing on large trees!
-                # The original tree may not have the same content filters
-                # applied so we can't safely build the inventory delta from
-                # the source tree.
                 if wt.supports_content_filtering():
-                    if hardlink:
-                        # see https://bugs.edge.launchpad.net/bzr/+bug/408193
-                        trace.warning("hardlinking working copy files is not currently "
-                            "supported in %r" % (wt,))
-                    accelerator_tree = None
+                    # The original tree may not have the same content filters
+                    # applied so we can't safely build the inventory delta from
+                    # the source tree.
                     delta_from_tree = False
                 else:
                     delta_from_tree = True
@@ -1766,7 +1755,11 @@
             return None
         parent_index = self._get_parent_index()
         last_changed_revision = entry[1][parent_index][4]
-        return self._repository.get_revision(last_changed_revision).timestamp
+        try:
+            rev = self._repository.get_revision(last_changed_revision)
+        except errors.NoSuchRevision:
+            raise errors.FileTimestampUnavailable(self.id2path(file_id))
+        return rev.timestamp
 
     def get_file_sha1(self, file_id, path=None, stat_value=None):
         entry = self._get_entry(file_id=file_id, path=path)
@@ -1985,12 +1978,11 @@
         return result
 
     @classmethod
-    def make_source_parent_tree_compiled_dirstate(klass, test_case, source, target):
+    def make_source_parent_tree_compiled_dirstate(klass, test_case, source,
+                                                  target):
         from bzrlib.tests.test__dirstate_helpers import \
-            CompiledDirstateHelpersFeature
-        if not CompiledDirstateHelpersFeature.available():
-            from bzrlib.tests import UnavailableFeature
-            raise UnavailableFeature(CompiledDirstateHelpersFeature)
+            compiled_dirstate_helpers_feature
+        test_case.requireFeature(compiled_dirstate_helpers_feature)
         from bzrlib._dirstate_helpers_pyx import ProcessEntryC
         result = klass.make_source_parent_tree(source, target)
         result[1]._iter_changes = ProcessEntryC
@@ -2027,8 +2019,6 @@
             output. An unversioned file is defined as one with (False, False)
             for the versioned pair.
         """
-        # NB: show_status depends on being able to pass in non-versioned files
-        # and report them as unknown
         # TODO: handle extra trees in the dirstate.
         if (extra_trees or specific_files == []):
             # we can't fast-path these cases (yet)

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2009-06-09 00:59:51 +0000
+++ bzrlib/xml4.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -63,7 +63,8 @@
         return e
 
 
-    def _unpack_inventory(self, elt, revision_id=None, entry_cache=None):
+    def _unpack_inventory(self, elt, revision_id=None, entry_cache=None,
+                          return_from_cache=False):
         """Construct from XML Element
 
         :param revision_id: Ignored parameter used by xml5.
@@ -71,14 +72,15 @@
         root_id = elt.get('file_id') or ROOT_ID
         inv = Inventory(root_id)
         for e in elt:
-            ie = self._unpack_entry(e, entry_cache=entry_cache)
+            ie = self._unpack_entry(e, entry_cache=entry_cache,
+                                    return_from_cache=return_from_cache)
             if ie.parent_id == ROOT_ID:
                 ie.parent_id = root_id
             inv.add(ie)
         return inv
 
 
-    def _unpack_entry(self, elt, entry_cache=None):
+    def _unpack_entry(self, elt, entry_cache=None, return_from_cache=False):
         ## original format inventories don't have a parent_id for
         ## nodes in the root directory, but it's cleaner to use one
         ## internally.

=== modified file 'bzrlib/xml5.py'
--- bzrlib/xml5.py	2009-07-15 06:39:26 +0000
+++ bzrlib/xml5.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2008, 2009, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,7 +30,8 @@
     format_num = '5'
     root_id = inventory.ROOT_ID
 
-    def _unpack_inventory(self, elt, revision_id, entry_cache=None):
+    def _unpack_inventory(self, elt, revision_id, entry_cache=None,
+                          return_from_cache=False):
         """Construct from XML Element
         """
         root_id = elt.get('file_id') or inventory.ROOT_ID
@@ -54,7 +55,8 @@
         unpack_entry = self._unpack_entry
         byid = inv._byid
         for e in elt:
-            ie = unpack_entry(e, entry_cache=entry_cache)
+            ie = unpack_entry(e, entry_cache=entry_cache,
+                              return_from_cache=return_from_cache)
             parent_id = ie.parent_id
             if parent_id is None:
                 ie.parent_id = parent_id = root_id

=== modified file 'bzrlib/xml7.py'
--- bzrlib/xml7.py	2009-03-23 14:59:43 +0000
+++ bzrlib/xml7.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,7 @@
     supported_kinds = set(['file', 'directory', 'symlink', 'tree-reference'])
     format_num = '7'
 
-    def _unpack_entry(self, elt, entry_cache=None):
+    def _unpack_entry(self, elt, entry_cache=None, return_from_cache=False):
         kind = elt.tag
         if not kind in self.supported_kinds:
             raise AssertionError('unsupported entry kind %s' % kind)
@@ -41,6 +41,7 @@
             return inventory.TreeReference(file_id, name, parent_id, revision,
                                            reference_revision)
         else:
-            return xml6.Serializer_v6._unpack_entry(self, elt)
+            return xml6.Serializer_v6._unpack_entry(self, elt,
+                entry_cache=entry_cache, return_from_cache=return_from_cache)
 
 serializer_v7 = Serializer_v7()

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2009-07-07 04:32:13 +0000
+++ bzrlib/xml8.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -371,7 +371,8 @@
             prop_elt.tail = '\n'
         top_elt.tail = '\n'
 
-    def _unpack_inventory(self, elt, revision_id=None, entry_cache=None):
+    def _unpack_inventory(self, elt, revision_id=None, entry_cache=None,
+                          return_from_cache=False):
         """Construct from XML Element"""
         if elt.tag != 'inventory':
             raise errors.UnexpectedInventoryFormat('Root tag is %r' % elt.tag)
@@ -384,12 +385,13 @@
             revision_id = cache_utf8.encode(revision_id)
         inv = inventory.Inventory(root_id=None, revision_id=revision_id)
         for e in elt:
-            ie = self._unpack_entry(e, entry_cache=entry_cache)
+            ie = self._unpack_entry(e, entry_cache=entry_cache,
+                                    return_from_cache=return_from_cache)
             inv.add(ie)
         self._check_cache_size(len(inv), entry_cache)
         return inv
 
-    def _unpack_entry(self, elt, entry_cache=None):
+    def _unpack_entry(self, elt, entry_cache=None, return_from_cache=False):
         elt_get = elt.get
         file_id = elt_get('file_id')
         revision = elt_get('revision')
@@ -433,9 +435,10 @@
                 pass
             else:
                 # Only copying directory entries drops us 2.85s => 2.35s
-                # if cached_ie.kind == 'directory':
-                #     return cached_ie.copy()
-                # return cached_ie
+                if return_from_cache:
+                    if cached_ie.kind == 'directory':
+                        return cached_ie.copy()
+                    return cached_ie
                 return cached_ie.copy()
 
         kind = elt.tag

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2009-06-09 00:59:51 +0000
+++ bzrlib/xml_serializer.py	2010-02-17 17:11:16 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -55,7 +55,7 @@
     squashes_xml_invalid_characters = True
 
     def read_inventory_from_string(self, xml_string, revision_id=None,
-                                   entry_cache=None):
+                                   entry_cache=None, return_from_cache=False):
         """Read xml_string into an inventory object.
 
         :param xml_string: The xml to read.
@@ -69,10 +69,15 @@
         :param entry_cache: An optional cache of InventoryEntry objects. If
             supplied we will look up entries via (file_id, revision_id) which
             should map to a valid InventoryEntry (File/Directory/etc) object.
+        :param return_from_cache: Return entries directly from the cache,
+            rather than copying them first. This is only safe if the caller
+            promises not to mutate the returned inventory entries, but it can
+            make some operations significantly faster.
         """
         try:
             return self._unpack_inventory(fromstring(xml_string), revision_id,
-                                          entry_cache=entry_cache)
+                                          entry_cache=entry_cache,
+                                          return_from_cache=return_from_cache)
         except ParseError, e:
             raise errors.UnexpectedInventoryFormat(e)
 

=== added directory 'contrib/debian'
=== added file 'contrib/debian/default'
--- contrib/debian/default	1970-01-01 00:00:00 +0000
+++ contrib/debian/default	2009-09-03 00:36:15 +0000
@@ -0,0 +1,20 @@
+# Specify startup options for bzr --serve
+
+# WARNING
+# When bazaar runs in serve mode there is no authentication. You will
+# be publishing your tree as readable or potentially writeable to everyone
+
+# You need to uncomment the line below to enable this service
+#ENABLED=1
+
+# Specify a user and group to run as
+#USER=bzr
+#GROUP=bzr
+
+# Specify the path to the repository
+#REPO=/srv/bzr
+
+# Other arguments
+# Add --allow-writes for RW access
+# Example config listens on localhost
+DAEMON_ARGS="--port=127.0.0.1:4155"

=== added file 'contrib/debian/init.d'
--- contrib/debian/init.d	1970-01-01 00:00:00 +0000
+++ contrib/debian/init.d	2009-09-02 23:55:18 +0000
@@ -0,0 +1,135 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides:          bzr
+# Required-Start:    $local_fs $remote_fs
+# Required-Stop:     $local_fs $remote_fs
+# Default-Start:     2 3 4 5
+# Default-Stop:      S 0 1 6
+# Short-Description: bazaar Smart Server
+# Description:       bazaar Smart Server
+### END INIT INFO
+
+# Author: John Ferlito <johnf@inodes.org>
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/usr/sbin:/usr/bin:/sbin:/bin
+DESC="Bazaar Smart Server"
+NAME=bzr
+DAEMON=/usr/bin/$NAME
+DAEMON_ARGS=""
+PIDFILE=/var/run/$NAME.pid
+SCRIPTNAME=/etc/init.d/$NAME
+
+USER=bzr
+GROUP=bzr
+REPO=/srv/bzr
+ENABLED=0
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+[ -f /etc/default/rcS ] && . /etc/default/rcS
+
+test "$ENABLED" != "0" || exit 0
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+	# Return
+	#   0 if daemon has been started
+	#   1 if daemon was already running
+	#   2 if daemon could not be started
+	start-stop-daemon --start --quiet --make-pidfile --pidfile $PIDFILE \
+		--chuid $USER:$GROUP --background --exec $DAEMON --test > /dev/null \
+		|| return 1
+	start-stop-daemon --start --quiet --make-pidfile --pidfile $PIDFILE \
+		--chuid $USER:$GROUP --background --exec $DAEMON -- \
+		serve $DAEMON_ARGS --directory $REPO \
+		|| return 2
+	# Add code here, if necessary, that waits for the process to be ready
+	# to handle requests from services started subsequently which depend
+	# on this one.  As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+	# Return
+	#   0 if daemon has been stopped
+	#   1 if daemon was already stopped
+	#   2 if daemon could not be stopped
+	#   other if a failure occurred
+	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
+	RETVAL="$?"
+	[ "$RETVAL" = 2 ] && return 2
+	# Wait for children to finish too if this is a daemon that forks
+	# and if the daemon is only ever run from this initscript.
+	# If the above conditions are not satisfied then add some other code
+	# that waits for the process to drop all resources that could be
+	# needed by services started subsequently.  A last resort is to
+	# sleep for some time.
+	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+	[ "$?" = 2 ] && return 2
+	# Many daemons don't delete their pidfiles when they exit.
+	rm -f $PIDFILE
+	return "$RETVAL"
+}
+
+case "$1" in
+  start)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+	do_start
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  stop)
+	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+	do_stop
+	case "$?" in
+		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+	esac
+	;;
+  restart|force-reload)
+	#
+	# If the "reload" option is implemented then remove the
+	# 'force-reload' alias
+	#
+	log_daemon_msg "Restarting $DESC" "$NAME"
+	do_stop
+	case "$?" in
+	  0|1)
+		do_start
+		case "$?" in
+			0) log_end_msg 0 ;;
+			1) log_end_msg 1 ;; # Old process is still running
+			*) log_end_msg 1 ;; # Failed to start
+		esac
+		;;
+	  *)
+	  	# Failed to stop
+		log_end_msg 1
+		;;
+	esac
+	;;
+  *)
+	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
+	exit 3
+	;;
+esac
+
+:

=== modified file 'doc/default.css'
--- doc/default.css	2009-09-10 02:09:26 +0000
+++ doc/default.css	2009-12-02 20:34:07 +0000
@@ -51,7 +51,7 @@
   }
 
 h1 {
-  color: #b52b2b; 
+  color: #b52b2b;
   /* DKREDcolor: #966b72; */
   /* GREY color: #444444; */
   font-size: 1.5em;
@@ -60,7 +60,7 @@
 h1 a:link {
   color: inherit;
   }
-  
+
 h1 a:hover {
   color: inherit;
   }
@@ -89,7 +89,7 @@
   }
 
 h3 {
-  color: #966b72; 
+  color: #966b72;
   /* color: #966b72; */
   }
 
@@ -114,7 +114,7 @@
   padding: 1ex;
   background: #7777FF;
         }
-dt:hover 
+dt:hover
   {
   background-color: black;
   }

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2009-10-08 01:50:30 +0000
+++ doc/developers/HACKING.txt	2009-12-29 14:29:08 +0000
@@ -2,7 +2,7 @@
 Bazaar Developer Guide
 ======================
 
-This document describes the Bazaar internals and the development process.  
+This document describes the Bazaar internals and the development process.
 It's meant for people interested in developing Bazaar, and some parts will
 also be useful to people developing Bazaar plugins.
 
@@ -62,9 +62,9 @@
 to involving the community before you spend much time on a change.
 These include:
 
-* you get to build on the wisdom on others, saving time
+* you get to build on the wisdom of others, saving time
 
-* if others can direct you to similar code, it minimises the work to be done 
+* if others can direct you to similar code, it minimises the work to be done
 
 * it assists everyone in coordinating direction, priorities and effort.
 
@@ -87,7 +87,7 @@
 -----------------
 
 First, get a local copy of the development mainline (See `Why make a local
-copy of bzr.dev?`_.) 
+copy of bzr.dev?`_.)
 ::
 
  $ bzr init-repo ~/bzr
@@ -100,7 +100,7 @@
 
 This will give you a branch called "123456-my-bugfix" that you can work on
 and commit in. Here, you can study the code, make a fix or a new feature.
-Feel free to commit early and often (after all, it's your branch!). 
+Feel free to commit early and often (after all, it's your branch!).
 
 Documentation improvements are an easy place to get started giving back to the
 Bazaar project.  The documentation is in the `doc/` subdirectory of the Bazaar
@@ -133,14 +133,14 @@
 Making a local mirror of bzr.dev is not strictly necessary, but it means
 
 - You can use that copy of bzr.dev as your main bzr executable, and keep it
-  up-to-date using ``bzr pull``.  
+  up-to-date using ``bzr pull``.
 - Certain operations are faster, and can be done when offline.  For example:
 
   - ``bzr bundle``
   - ``bzr diff -r ancestor:...``
   - ``bzr merge``
 
-- When it's time to create your next branch, it's more convenient.  When you 
+- When it's time to create your next branch, it's more convenient.  When you
   have further contributions to make, you should do them in their own branch::
 
     $ cd ~/bzr
@@ -193,9 +193,9 @@
 
 * create a local copy of the main development branch (bzr.dev) by using
   this command::
-  
+
     bzr branch http://bazaar-vcs.org/bzr/bzr.dev/ bzr.dev
-   
+
 * keep your copy of bzr.dev pristine (by not developing in it) and keep
   it up to date (by using bzr pull)
 
@@ -222,10 +222,10 @@
 
 README
     This file covers a brief introduction to Bazaar and lists some of its
-    key features. 
+    key features.
 
 NEWS
-    Summary of changes in each Bazaar release that can affect users or 
+    Summary of changes in each Bazaar release that can affect users or
     plugin developers.
 
 setup.py
@@ -237,7 +237,7 @@
     with this but don't be confused by it. The build process puts a copy
     of the main code base into this build directory, along with some other
     files. You don't need to go in here for anything discussed in this
-    guide. 
+    guide.
 
 bzrlib
     Possibly the most exciting folder of all, bzrlib holds the main code
@@ -248,17 +248,17 @@
     Holds documentation on a whole range of things on Bazaar from the
     origination of ideas within the project to information on Bazaar
     features and use cases.  Within this directory there is a subdirectory
-    for each translation into a human language.  All the documentation 
+    for each translation into a human language.  All the documentation
     is in the ReStructuredText markup language.
 
-doc/developers 
+doc/developers
     Documentation specifically targeted at Bazaar and plugin developers.
     (Including this document.)
-    
-        
-
-Automatically-generated API reference information is available at 
-<http://starship.python.net/crew/mwh/bzrlibapi/>.  
+
+
+
+Automatically-generated API reference information is available at
+<http://starship.python.net/crew/mwh/bzrlibapi/>.
 
 See also the `Bazaar Architectural Overview
 <http://doc.bazaar-vcs.org/developers/overview.html>`_.
@@ -291,7 +291,7 @@
 
 * **how** this change achieves this purpose
 
-* anything else you may have fixed in passing 
+* anything else you may have fixed in passing
 
 * anything significant that you thought of doing, such as a more
   extensive fix or a different approach, but didn't or couldn't do now
@@ -336,7 +336,7 @@
 welcome that only cleanup the code without changing the external
 behaviour.  The core developers take care to keep the code quality high
 and understandable while recognising that perfect is sometimes the enemy
-of good. 
+of good.
 
 It is easy for reviews to make people notice other things which should be
 fixed but those things should not hold up the original fix being accepted.
@@ -378,7 +378,7 @@
 ====================
 
 From May 2009 on, we prefer people to propose code reviews through
-Launchpad.  
+Launchpad.
 
  * <https://launchpad.net/+tour/code-review>
 
@@ -403,7 +403,7 @@
 Then go to the branch's web page, which in this case would be
 <https://code.launchpad.net/~mbp/bzr/doc>.  You can simplify this step by just
 running ::
- 
+
   bzr lp-open
 
 You can then click "Propose for merging into another branch", and enter your
@@ -425,7 +425,7 @@
 You can generate a merge request like this::
 
   bzr send -o bug-1234.diff
-  
+
 ``bzr send`` can also send mail directly if you prefer; see the help.
 
 Reviewing changes
@@ -457,7 +457,7 @@
 You can generate a merge request like this::
 
   bzr send -o bug-1234.patch
-  
+
 A ``.patch`` extension is recommended instead of .bundle as many mail clients
 will send the latter as a binary file.
 
@@ -512,7 +512,7 @@
 Code layout
 ===========
 
-Please write PEP-8__ compliant code.  
+Please write PEP-8__ compliant code.
 
 __ http://www.python.org/peps/pep-0008.html
 
@@ -530,7 +530,7 @@
 Each file must have a newline at the end of it.
 
 Lines should be no more than 79 characters if at all possible.
-Lines that continue a long statement may be indented in either of 
+Lines that continue a long statement may be indented in either of
 two ways:
 
 within the parenthesis or other character that opens the block, e.g.::
@@ -623,7 +623,7 @@
 Functions, methods or members that are relatively private are given
 a leading underscore prefix.  Names without a leading underscore are
 public not just across modules but to programmers using bzrlib as an
-API. 
+API.
 
 We prefer class names to be concatenated capital words (``TestCase``)
 and variables, methods and functions to be lowercase words joined by
@@ -680,7 +680,7 @@
 ``only_raises`` decorator (from ``bzrlib.decorators``) for methods that
 are typically called in ``finally`` blocks, such as ``unlock`` methods.
 For example, ``@only_raises(LockNotHeld, LockBroken)``.  All errors that
-are unlikely to be a knock-on failure from an previous failure should be
+are unlikely to be a knock-on failure from a previous failure should be
 allowed.
 
 
@@ -702,8 +702,8 @@
 Registries
 ==========
 
-Several places in Bazaar use (or will use) a registry, which is a 
-mapping from names to objects or classes.  The registry allows for 
+Several places in Bazaar use (or will use) a registry, which is a
+mapping from names to objects or classes.  The registry allows for
 loading in registered code only when it's needed, and keeping
 associated information such as a help string or description.
 
@@ -713,13 +713,13 @@
 
 The ``InterObject`` provides for two-way `multiple dispatch`__: matching
 up for example a source and destination repository to find the right way
-to transfer data between them. 
+to transfer data between them.
 
 .. __: http://en.wikipedia.org/wiki/Multiple_dispatch
 
 There is a subclass ``InterObject`` classes for each type of object that is
 dispatched this way, e.g. ``InterRepository``.  Calling ``.get()`` on this
-class will return an ``InterObject`` instance providing the best match for 
+class will return an ``InterObject`` instance providing the best match for
 those parameters, and this instance then has methods for operations
 between the objects.
 
@@ -806,7 +806,7 @@
 
 If you add a new class you should generally add a ``__repr__`` method
 unless there is an adequate method in a parent class.  There should be a
-test for the repr.  
+test for the repr.
 
 Representations should typically look like Python constructor syntax, but
 they don't need to include every value in the object and they don't need
@@ -869,7 +869,7 @@
 way, you need to change its name as well. For instance, if I add an optional keyword
 parameter to branch.commit - that's fine. On the other hand, if I add a
 keyword parameter to branch.commit which is a *required* transaction
-object, I should rename the API - i.e. to 'branch.commit_transaction'. 
+object, I should rename the API - i.e. to 'branch.commit_transaction'.
 
   (Actually, that may break code that provides a new implementation of
   ``commit`` and doesn't expect to receive the parameter.)
@@ -1039,8 +1039,8 @@
 
     0. OK.
     1. Conflicts in merge-like operations, or changes are present in
-       diff-like operations. 
-    2. Unrepresentable diff changes (i.e. binary files that we cannot show 
+       diff-like operations.
+    2. Unrepresentable diff changes (i.e. binary files that we cannot show
        a diff of).
     3. An error or exception has occurred.
     4. An internal error occurred (one that shows a traceback.)
@@ -1077,13 +1077,13 @@
 format string.
 
 #. If it is something that a caller can recover from, a custom exception
-   is reasonable. 
+   is reasonable.
 
 #. If it is a data consistency issue, using a builtin like
-   ``ValueError``/``TypeError`` is reasonable. 
+   ``ValueError``/``TypeError`` is reasonable.
 
 #. If it is a programmer error (using an api incorrectly)
-   ``AssertionError`` is reasonable. 
+   ``AssertionError`` is reasonable.
 
 #. Otherwise, use ``BzrError`` or ``InternalBzrError``.
 
@@ -1142,7 +1142,7 @@
 Within each release, entries in the news file should have the most
 user-visible changes first.  So the order should be approximately:
 
- * changes to existing behaviour - the highest priority because the 
+ * changes to existing behaviour - the highest priority because the
    user's existing knowledge is incorrect
  * new features - should be brought to their attention
  * bug fixes - may be of interest if the bug was affecting them, and
@@ -1167,7 +1167,7 @@
 -----------------
 
 Functions, methods, classes and modules should have docstrings
-describing how they are used. 
+describing how they are used.
 
 The first line of the docstring should be a self-contained sentence.
 
@@ -1198,13 +1198,13 @@
     We had the problem that lots of our files were "Copyright Canonical
     Development Ltd" which is not a real company, and some other variations
     on this theme. Also, some files were missing the GPL statements.
-    
+
     I want to be clear about the intent of this patch, since copyright can
     be a little controversial.
-    
+
     1) The big motivation for this is not to shut out the community, but
     just to clean up all of the invalid copyright statements.
-    
+
     2) It has been the general policy for bzr that we want a single
     copyright holder for all of the core code. This is following the model
     set by the FSF, which makes it easier to update the code to a new
@@ -1217,15 +1217,15 @@
     I'm sure Canonical would do the same).
     As such, Canonical has requested copyright assignments from all of the
     major contributers.
-    
+
     3) If someone wants to add code and not attribute it to Canonical, there
     is a specific list of files that are excluded from this check. And the
     test failure indicates where that is, and how to update it.
-    
+
     4) If anyone feels that I changed a copyright statement incorrectly, just
     let me know, and I'll be happy to correct it. Whenever you have large
     mechanical changes like this, it is possible to make some mistakes.
-    
+
     Just to reiterate, this is a community project, and it is meant to stay
     that way. Core bzr code is copyright Canonical for legal reasons, and
     the tests are just there to help us maintain that.
@@ -1242,7 +1242,7 @@
 
 .. _pdb: http://docs.python.org/lib/debugger-commands.html
 
-If the ``BZR_PDB`` environment variable is set 
+If the ``BZR_PDB`` environment variable is set
 then bzr will go into pdb post-mortem mode when an unhandled exception
 occurs.
 
@@ -1310,7 +1310,7 @@
     for automated processing.
     For example: ``bzr log`` should not fail if one of the entries has text
     that cannot be displayed.
-  
+
   strict
     Attempting to print an unprintable character will cause a UnicodeError.
     This is for commands that are intended more as scripting support, rather
@@ -1320,7 +1320,7 @@
     printed a filename with a '?', the wrong file could be deleted. (At the
     very least, the correct file would not be deleted). An error is used to
     indicate that the requested action could not be performed.
-  
+
   exact
     Do not attempt to automatically convert Unicode strings. This is used
     for commands that must handle conversion themselves.
@@ -1374,16 +1374,16 @@
 
 To create an extension, add rules to setup.py for building it with pyrex,
 and with distutils. Now start with an empty .pyx file. At the top add
-"include 'yourmodule.py'". This will import the contents of foo.py into this 
+"include 'yourmodule.py'". This will import the contents of foo.py into this
 file at build time - remember that only one module will be loaded at
 runtime. Now you can subclass classes, or replace functions, and only your
 changes need to be present in the .pyx file.
 
 Note that pyrex does not support all 2.4 programming idioms, so some
-syntax changes may be required. I.e. 
+syntax changes may be required. I.e.
 
- - 'from foo import (bar, gam)' needs to change to not use the brackets. 
- - 'import foo.bar as bar' needs to be 'import foo.bar; bar = foo.bar' 
+ - 'from foo import (bar, gam)' needs to change to not use the brackets.
+ - 'import foo.bar as bar' needs to be 'import foo.bar; bar = foo.bar'
 
 If the changes are too dramatic, consider
 maintaining the python code twice - once in the .pyx, and once in the .py,
@@ -1666,7 +1666,7 @@
 .. note::
   As well as prioritizing bugs and nominating them against a
   target milestone, Launchpad lets core developers offer to mentor others in
-  fixing them. 
+  fixing them.
 
 
 ..

=== added file 'doc/developers/_static/bzr-doc.css'
--- doc/developers/_static/bzr-doc.css	1970-01-01 00:00:00 +0000
+++ doc/developers/_static/bzr-doc.css	2009-11-18 02:08:40 +0000
@@ -0,0 +1,4 @@
+
+ol.loweralpha {
+  list-style-type: lower-alpha;
+}

=== modified file 'doc/developers/_templates/layout.html'
--- doc/developers/_templates/layout.html	2009-09-07 07:44:36 +0000
+++ doc/developers/_templates/layout.html	2009-11-18 02:08:40 +0000
@@ -1,8 +1,32 @@
 {% extends "!layout.html" %}
 
+{% block linktags %}
+{{ super() }}
+<link rel="stylesheet" href="_static/bzr-doc.css" type="text/css" />
+{% endblock %}
+
 {% block rootrellink %}
 <li><a href="http://bazaar-vcs.org/">
     <img src="{{ pathto("_static/bzr icon 16.png", 1) }}" /> Home</a>&nbsp;|&nbsp;</li>
 <a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
+{{ super() }}
+{% endblock %}

=== modified file 'doc/developers/add.txt'
--- doc/developers/add.txt	2007-06-05 08:02:04 +0000
+++ doc/developers/add.txt	2009-12-02 20:34:07 +0000
@@ -28,7 +28,7 @@
 ------------------
 
 #. If the path is versioned, and it is a directory, push onto the recurse stack.
-#. If the path is supplied by the user or is not ignored, version it, and if a 
+#. If the path is supplied by the user or is not ignored, version it, and if a
    directory, push onto the recurse stack. Versioning the path may require
    versioning the paths parents.
 #. Output or otherwise record the ignored rule as per the user interface selected.

=== modified file 'doc/developers/api-versioning.txt'
--- doc/developers/api-versioning.txt	2009-01-23 18:44:10 +0000
+++ doc/developers/api-versioning.txt	2009-12-02 20:34:07 +0000
@@ -86,8 +86,8 @@
 with ``(0, 18, 0)``.
 
 +------------+---------------+
-| API        | Covers        | 
-+============+===============+ 
+| API        | Covers        |
++============+===============+
 | bzrlib     | All of bzrlib |
 +------------+---------------+
 

=== modified file 'doc/developers/apport.txt'
--- doc/developers/apport.txt	2009-08-13 14:31:20 +0000
+++ doc/developers/apport.txt	2009-12-02 20:34:07 +0000
@@ -37,7 +37,7 @@
 report to file later.  At the moment we just show them the filename and
 let them take it from there.
 
-The process is 
+The process is
 
 #. An exception reaches the top-level handler.
 
@@ -83,5 +83,5 @@
 
   Possibly these bugs are better reported in the next time bzr runs.
 
-.. 
+..
     vim: ft=rst

=== modified file 'doc/developers/authentication-ring.txt'
--- doc/developers/authentication-ring.txt	2009-01-08 16:57:10 +0000
+++ doc/developers/authentication-ring.txt	2009-12-02 20:34:07 +0000
@@ -88,7 +88,7 @@
 really needed is (``user``, ``password``, ``host``, ``path``). The ``realm``
 can be ignored [#ignored_realm]_ as long as it is still presented to the user
 when prompting for the password (unless someone found a way to declare two
-different realms for the same path). 
+different realms for the same path).
 
 ``HTTP proxy`` can be handled as ``HTTP`` (or ``HTTPS``) by explicitly
 specifying the appropriate port.
@@ -260,7 +260,7 @@
         host=r.hobby.net
         user=jim
         password=obvious1234
-        
+
         # Home server
         [home]
         scheme=https
@@ -269,11 +269,11 @@
         password='c2VjcmV0LXBhc3M='
         password_encoding=base64
         verify_certificates=no # Still searching a free certificate provider
-        
+
         [DEFAULT]
         # Our local user is barbaz, on all remote sites we're known as foobar
         user=foobar
-        
+
   * an HTTP server and a proxy::
 
         # development branches on dev server
@@ -283,7 +283,7 @@
         path=/dev
         user=user1
         password=pass1
-        
+
         # toy branches
         [localhost]
         scheme=http
@@ -291,7 +291,7 @@
         path=/
         user=user2
         password=pass2
-        
+
         # proxy
         [proxy]
         scheme=http

=== modified file 'doc/developers/bug-handling.txt'
--- doc/developers/bug-handling.txt	2009-09-15 05:16:50 +0000
+++ doc/developers/bug-handling.txt	2010-01-12 02:00:23 +0000
@@ -51,7 +51,7 @@
 report, but they generally care more about getting bugs fixed.
 
 The aim of investigating bugs before starting concentrated work on them is
-therefore only to: 
+therefore only to:
 
 * determine if they are critical or high priority (and
   should displace existing work)
@@ -76,7 +76,7 @@
  | One of the things you should not do often is to start asking
  | questions/for more debug info and then forget about the bug. It's just
  | a waste of the reporter's and your time, and will create frustration
- | on the reporter side. 
+ | on the reporter side.
 
 
 Priorities
@@ -85,7 +85,7 @@
 The suggested priorities for bug work are:
 
 1. Fix critical bugs.
-   
+
 2. Get existing fixes through review and landed.
 
 3. Fix bugs that are already in progress.
@@ -136,16 +136,26 @@
     yet.
 Incomplete
     The bug requires more information from the reporter to make progress.
+
+    Only set this state if it's impossible or uneconomical to make
+    progress on the bug without that information.  The bug will expire if
+    it remains in this state for two months.
 Confirmed
-    The bug report has been seen by a developer and we agree it's a bug.  
-    You don't have to reproduce the bug to mark it confirmed.  (Generally
+    The bug report has been seen by a developer and we agree it's a bug.
+    You don't have to reproduce the bug to mark it Confirmed.  (Generally
     it's not a good idea for a developer to spend time reproducing the bug
     until they're going to work on it.)
 Triaged
     We don't use this status.  If it is set, it means the same as
     Confirmed.
 In Progress
-    Someone has started working on this.
+    Someone has started working on this.  We can deliver the value of the
+    work already done by finishing and shipping the fix.  
+    
+    The bug keeps this state from the time someone does non-trivial
+    analysis, until the fix is merged to a release or trunk branch (when
+    it is Fix Released), or until they give up on it (back to New or
+    Confirmed) or decide it is Invalid or Incomplete.
 Won't Fix
     The behaviour complained about is intentional and we won't fix it.
     Needless to say, be thoughtful before using this status, and consider if
@@ -154,20 +164,25 @@
     The reporter was confused, and this is not actually a bug.
     Again, be sensitive in explaining this to the user.
 Fix Committed
-    A fix for this bug exists in a branch somewhere.  Ideally the bug will
-    be linked to the branch.
+    Don't use this.  If set on old bug, it probably means In Progress,
+    with the fix waiting for review.  See Launchpad `bug 163694`_.
 Fix Released
     The fix for this bug is now in the bzr branch that this task is for.
-    The branch for the default task on a bug is bzr.dev.  We use this value
-    even though the fix may not have been been included in a release yet
-    because all the developer activity around it is complete and we want to
-    both avoid bug spam when releases happen, and keep the list of bugs that
-    developers see when they look at the bug tracker trimmed to those that
-    require action. When setting a bug task to fix released, the bug target
-    milestone should be set to the release the fix will be included in (or
-    was included in, if you are updating an old bug). Don't spend too much time
-    updating this if you don't immediately know: its not critical that it be
-    set.
+    The branch for the default task on a bug is bzr.dev.  
+    
+    We use this value even though the fix may not have been been included
+    in a release yet because all the developer activity around it is
+    complete and we want to both avoid bug spam when releases happen, and
+    keep the list of bugs that developers see when they look at the bug
+    tracker trimmed to those that require action. 
+    
+    When setting a bug task to fix released, the bug target milestone
+    should be set to the release the fix will be included in (or was
+    included in, if you are updating an old bug). Don't spend too much
+    time updating this if you don't immediately know: its not critical
+    that it be set.
+
+.. _`bug 163694`: https://bugs.launchpad.net/malone/+bug/163694
 
 
 Bug Importance
@@ -256,53 +271,53 @@
 authentication
     authenticating to servers
 
-backport 
+backport
     candidate for backporting to an update of the previous release
 
-dirstate 
+dirstate
     WorkingTree4
 
-easy 
+easy
     should be possible to finish in an hour or two
 
-hpss 
+hpss
     bugs about the High-Performance Smart Server, i.e. bzr+ssh://, etc.
 
-hpssvfs 
+hpssvfs
     bugs for causes of VFS methods of the smart server
 
-launchpad 
+launchpad
     bugs about interactions with launchpad (typically this means bzrlib.plugins.launchpad).
 
-locale 
+locale
     problems using locales other than English
 
-memory 
+memory
     problems where we use too much memory for some reason
 
-newformat 
+newformat
     fixing this would need a new disk format
 
-performance 
+performance
     bugs about performance problems.
 
-test 
+test
     needs changes to the test framework
 
-transport 
+transport
     virtual filesystem for http, sftp, etc
 
-trivial 
+trivial
     should be very easy to fix (10-20 minutes) and easily landed: typically just spelling errors and the like
 
-ui 
+ui
     bugs relating to the bzr user interface, e.g. confusing error messages.
 
-win32 
-    bugs that mainly affects Windows. Also there is cygwin and win98 tags for marking specific bugs. 
+win32
+    bugs that mainly affects Windows. Also there is cygwin and win98 tags for marking specific bugs.
 
 You can see the full list of tags in use at
 <https://bugs.edge.launchpad.net/bzr/+bugs>.  As of September 2008 the
-list is on the right. 
+list is on the right.
 
 .. vim: ft=rst

=== modified file 'doc/developers/bundles.txt'
--- doc/developers/bundles.txt	2007-12-05 19:55:07 +0000
+++ doc/developers/bundles.txt	2009-12-02 20:34:07 +0000
@@ -1,5 +1,5 @@
 =======
-Bundles 
+Bundles
 =======
 
 Status

=== modified file 'doc/developers/case-insensitive-file-systems.txt'
--- doc/developers/case-insensitive-file-systems.txt	2008-12-23 04:20:49 +0000
+++ doc/developers/case-insensitive-file-systems.txt	2009-12-02 20:34:07 +0000
@@ -27,7 +27,7 @@
 * Case-insensitive: This is the file-system used by very old Windows versions
   and is rarely encountered "in the wild".  Two files that differ only by
   case is not allowed and the case used to create a file is not preserved.
-  
+
 As can be implied by the above descriptions, only the first two are considered
 relevant to a modern Bazaar.
 

=== modified file 'doc/developers/colocated-branches.txt'
--- doc/developers/colocated-branches.txt	2009-02-10 04:10:44 +0000
+++ doc/developers/colocated-branches.txt	2009-12-02 20:34:07 +0000
@@ -17,7 +17,7 @@
 Allowing multiple branches to live under the same directory in the file
 system means that it is possible to very easily share the same working
 tree and repository between those branches, without having a lot of fs
-infrastructure. 
+infrastructure.
 
 Git and Mercurial (can) store multiple branches under a single directory
 in the file system - per repository, so to speak. In order for this to
@@ -47,20 +47,20 @@
 ~~~~~~~~~~
 
 Bazaar URLs need to have some way to specify a colocated branch other
-than the current HEAD. Several options have been discussed, each with 
+than the current HEAD. Several options have been discussed, each with
 its own advantages and disadvantages: This was discussed on the mailing
 list, most notably the use of a ";branch=NAME" suffix as well as a special
-separation character (+, =, etc), but no final conclusion was reached. 
+separation character (+, =, etc), but no final conclusion was reached.
 
 https://lists.ubuntu.com/archives/bazaar/2008q4/050105.html
 
 Code Changes
 ~~~~~~~~~~~~
 
-BzrDir should support a BzrDir.supports_colocated_branches() call as well as 
+BzrDir should support a BzrDir.supports_colocated_branches() call as well as
 BzrDir.colocated_branches property that contains a colocated branch container,
-that can be used to add / remove colocated branches as well as change the 
-currently active colocated branch. 
+that can be used to add / remove colocated branches as well as change the
+currently active colocated branch.
 
 ::
 
@@ -87,11 +87,11 @@
 	   def destroy_branch(self, name):
 		 """Destroy the specified branch.
 			
-		This will remove the branch from disk.""" 
+		This will remove the branch from disk."""
 
 If the particular BzrDir implementation doesn't support colocated
 branches, it can just return a dummy container that just contains a
-HEAD branch. 
+HEAD branch.
 
 Looms can of course return a container with all their threads.
 
@@ -106,7 +106,7 @@
 feature in its own file formats.
 
 Eventually, Bazaar could easily support colocated branches by just
-creating a new branch transport for each colocated branch and have a 
+creating a new branch transport for each colocated branch and have a
 "regular" branch live there. This would require something like
 BzrDirMeta2 though.
 

=== modified file 'doc/developers/commit.txt'
--- doc/developers/commit.txt	2007-06-28 02:43:50 +0000
+++ doc/developers/commit.txt	2009-12-02 20:34:07 +0000
@@ -174,7 +174,7 @@
      happened several commits back. There are several edge cases to be
      handled here, like if both branches modified the same file, or if
      just one branch modified it.
-     
+
   b) The trickier case is when a file appears unmodified since last
      commit, but it was modified versus one of the merged branches. I
      believe there are a few ways this can happen, like if a merged
@@ -291,7 +291,7 @@
 It is desirable to avoid roundtrips to the Repository during commit,
 particularly because it may be remote.  If the WorkingTree can determine
 by itself that a text was in the parent and therefore should be in the
-Repository that avoids one roundtrip per file.  
+Repository that avoids one roundtrip per file.
 
 There is a possibility here that the parent revision is not stored, or not
 correctly stored, in the repository the tree is being committed into, and
@@ -311,9 +311,9 @@
 This creates a CommitBuilder object matched to the Branch, Repository and
 Tree.  It can vary depending on model differences or by knowledge of what
 is efficient with the Repository and Tree.  Model differences might
-include whether no-text-change merges need to be reported, and whether the 
+include whether no-text-change merges need to be reported, and whether the
 
-The basic CommitBuilder.commit structure can be 
+The basic CommitBuilder.commit structure can be
 
 1. Ask the branch if it is ready to commit (up to date with master if
    any.)
@@ -358,10 +358,10 @@
 
 * the working tree basis is up to date with the branch tip
 
-* the local branch is up to date with the master branch, if there 
+* the local branch is up to date with the master branch, if there
   is one and --local is not specified
 
-* an empty commit message is given, 
+* an empty commit message is given,
 
 * a hook flags an error
 
@@ -396,7 +396,7 @@
 * if there are tree references and recursing into them is enabled, then
   do so
 
-Commit needs to protect against duplicated file ids 
+Commit needs to protect against duplicated file ids
 
 
 Updates that need to be made in the working tree, either on conclusion
@@ -429,13 +429,13 @@
 * or an indication that it should be read interactively from the ui object;
 * a list of files to commit
 * an option for a dry-run commit
-* verbose option, or callback to indicate 
+* verbose option, or callback to indicate
 * timestamp, timezone, committer, chosen revision id
 * config (for what?)
 * option for local-only commit on a bound branch
 * option for strict commits (fail if there are unknown or missing files)
 * option to allow "pointless" commits (with no tree changes)
- 
+
 (This is rather a lot of options to pass individually and just for code tidyness maybe some of them should be combine into objects.)
 
 >>> Branch.commit(from_tree, message, files_to_commit, ...)
@@ -466,10 +466,10 @@
 This needs to collect a list of added/changed/removed files, each of which
 must have its text stored (if any) and containing directory updated.  This
 can be done by calling Tree._iter_changes on the source tree, asking for
-changes 
+changes
 
 In the 0.17 model the commit operation needs to know the per-file parents
-and per-file last-changed revision.  
+and per-file last-changed revision.
 
 (In this and other operations we must avoid having multiple layers walk
 over the tree separately.  For example, it is no good to have the Command
@@ -530,8 +530,8 @@
 The main things the tree needs to tell the Branch about are:
 
 * A file is modified from its parent revision (in text, permissions,
-  other), and so its text may need to be stored.  
-  
+  other), and so its text may need to be stored.
+
   Files should also be reported if they have more than one unique parent
   revision, for repositories that store per-file graphs or last-change
   revisions.  Perhaps this behaviour should be optional.
@@ -540,11 +540,11 @@
 
 * The complete contents of a modified directory, so that its inventory
   text may be stored.  This should be done after all the contained files
-  and directories have been reported.  If there are unmodified files, 
-  or unselected files carried through from 
+  and directories have been reported.  If there are unmodified files,
+  or unselected files carried through from
 
-  XXX: Actually perhaps not grouped by directory, but rather grouped 
-  appropriately for the shape of inventory storage in the repository. 
+  XXX: Actually perhaps not grouped by directory, but rather grouped
+  appropriately for the shape of inventory storage in the repository.
 
   In a zoomed-in checkout the workingtree may not have all the shape data
   for the entire tree.
@@ -577,7 +577,7 @@
 This might be construed as an enhanced version of ``set_parent_trees``.
 We can avoid a stat on each file by using the value that was observed when
 it was first read.
- 
+
 
 
 Selective commit
@@ -591,7 +591,7 @@
 However, the tree walking code does probably need to know about selected
 paths to avoid examining unselected files or directories.
 
-We never refuse selective file commits (except of merges).  
+We never refuse selective file commits (except of merges).
 
 
 

=== modified file 'doc/developers/container-format.txt'
--- doc/developers/container-format.txt	2009-02-22 16:54:02 +0000
+++ doc/developers/container-format.txt	2009-12-03 23:21:16 +0000
@@ -129,14 +129,14 @@
 ------------------
 
 There is a requirement that each object can be given an arbitrary name.
-Some revision control systems address all content by the SHA-1 digest of
+Some version control systems address all content by the SHA-1 digest of
 that content, but this scheme is unsatisfactory for Bazaar's revision
 objects.  We can still allow addressing by SHA-1 digest for those content
 types where it makes sense.
 
 Some proposed object names:
 
-  * to name a revision: "``revision:``\ *revision-id*".  e.g., 
+  * to name a revision: "``revision:``\ *revision-id*".  e.g.,
     `revision:pqm@pqm.ubuntu.com-20070531210833-8ptk86ocu822hjd5`.
   * to name an inventory delta: "``inventory.delta:``\ *revision-id*".  e.g.,
     `inventory.delta:pqm@pqm.ubuntu.com-20070531210833-8ptk86ocu822hjd5`.
@@ -155,7 +155,7 @@
 
   * a record's content could be self-describing in the context of a
     particular container, or
-  * a record could be accessed via an index based on SHA-1, or 
+  * a record could be accessed via an index based on SHA-1, or
   * when streaming, the first record could be treated specially.
 
 Reasonably cheap for small records
@@ -203,12 +203,12 @@
 A **Bytes** record:
 
   * has a kind marker of "``B``",
-  * followed by a mandatory **content length** [1]_: 
+  * followed by a mandatory **content length** [1]_:
     "*number*\ ``\n``", where *number* is in decimal, e.g::
 
       1234
 
-  * followed by zero or more optional **names**: 
+  * followed by zero or more optional **names**:
     "*name*\ ``\n``", e.g.::
 
       revision:pqm@pqm.ubuntu.com-20070531210833-8ptk86ocu822hjd5

=== modified file 'doc/developers/content-filtering.txt'
--- doc/developers/content-filtering.txt	2009-08-28 05:00:33 +0000
+++ doc/developers/content-filtering.txt	2009-12-02 20:34:07 +0000
@@ -106,7 +106,7 @@
 
 * In a future workingtree format, it might be better not to separately
   store the working-copy hash and size, but rather just a stat fingerprint
-  at which point it was known to have the same canonical form as the 
+  at which point it was known to have the same canonical form as the
   basis tree.
 
 * It may be worthwhile to have a virtual Tree-like object that does

=== added file 'doc/developers/contribution-quickstart.txt'
--- doc/developers/contribution-quickstart.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/contribution-quickstart.txt	2009-11-19 02:03:12 +0000
@@ -0,0 +1,59 @@
+Bazaar Contribution in Five Minutes
+===================================
+
+Contributing to Bazaar requires attention to quality.  To ensure
+high-quality commits, the "Bazaar process" involves you in our
+code review and improvement activities.
+
+In brief, a contribution should include:
+
+1.  A brief rationale, including expected audience and use cases,
+    for inclusion in Bazaar.
+
+2.  A branch registered as a branch on Launchpad, and submitted as
+    a merge proposal.
+
+3.  The branch should include:
+
+    a.  implementation of the feature,
+
+    b.  user documentation (if the feature is visible in the user
+        interface) and/or developer documentation (if new or
+        changed APIs are provided), and
+
+    c.  tests to ensure the specification is correctly
+        implemented.
+
+For more information, see the `Bazaar Developer Guide <HACKING.html>`_.
+
+If you are not an experienced Bazaar contributor, why not ask for
+mentoring?  When you submit your merge proposal on Launchpad, simply say
+"I'd like to be mentored, please" in your submission.  Or ask for help
+with your contribution on the IRC channel, mailing list, or on Launchpad
+(https://answers.launchpad.net/bzr).
+
+
+Current Bazaar Mentors
+----------------------
+
+See the roster at http://bazaar-vcs.org/PatchPilot, although other
+developers may help too!
+
+
+Bazaar Mentors FAQ
+------------------
+
+1.  Why is this "Bazaar process" in HACKING.txt so complicated?
+
+    Answer: If we knew *that*, we'd simplify it!  We are working
+    on streamlining many aspects, but quality comes first.
+
+1.  What sort of things can a mentor help with?
+
+    Anything that's getting in your way, time permitting.  This includes
+    guiding you through the ``bzrlib`` API, explaining how to use our test
+    infrastructure, discussing possible designs for your bug fix or
+    feature, and so on.
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'doc/developers/cycle.txt'
--- doc/developers/cycle.txt	2009-09-11 18:25:08 +0000
+++ doc/developers/cycle.txt	2010-01-08 00:44:26 +0000
@@ -2,7 +2,7 @@
 Bazaar Release Cycles
 *********************
 
-:status: Current policy, as of 2009-08. 
+:status: Current policy, as of 2009-08.
 :blueprint: <https://blueprints.launchpad.net/bzr/+spec/6m-cycle>
 
 
@@ -18,52 +18,9 @@
 
 * `Bazaar Developer Document Catalog <index.html>`_
 
-* `Releasing Bazaar <releasing.html>`_ -- the process for actually making 
+* `Releasing Bazaar <releasing.html>`_ -- the process for actually making
   a release or release candidate.
 
-The Problem Situation
-*********************
-
-Bazaar makes a release every month, preceded by a one-week
-release-candidate test.  
-
-In any release we may fix bugs, add formats, change the default format,
-improve performance, add new commands or change command line behaviour,
-change the network protocol, or deprecate APIs.  We sometimes also
-introduce new bugs, regress existing behaviour or performance, remove
-existing features or formats, or break behaviour or APIs depended upon by
-plugins, external programs or users.
-
-Some users are happy upgrading every month and consider the overall
-positive balance of changes is worth some amount of churn.  But there are
-some serious problems:
-
-* You cannot get bug fixes without also getting disruptive changes.
-
-* Bazaar is seen as unstable.
-
-* Many releases cause some plugin breakage.
-
-* One month is not a very long window for dependent programs or systems
-  to catch up to changes in Bazaar before the release goes out of date.
-
-* There's no clear indication to distributions which version they should
-  package.
-
-* If people (or their distributions) just pick an arbitrary version, they
-  may all be on different arbitrary versions, therefore they will have
-  different behaviour and different bugs, and sometimes interoperation
-  problems.
-
-* Any effort we, or distributors, wanted to put into backporting fixes
-  would be dissipated across many possible backport target releases.
-
-* When in the past we've tried either stalling releases for particular
-  features, or having trunk frozen for some weeks, it causes churn and
-  waste.  People rush features in, or already landed features wait a long
-  time to be released, or branches go out of date because they cannot
-  land.
-
 
 The Process
 ************
@@ -105,7 +62,7 @@
                                                         +-- 3.0.0beta1 ...
 
 
-Starting from the date of a major release: 
+Starting from the date of a major release:
 
 At four-week intervals we make a new beta release.  There will be no
 separate release candidate, but if a serious problem is discovered we may
@@ -121,7 +78,7 @@
 We will then make a release candidate for the next major release, and at
 this point create a release branch for it.  We will iterate release
 candidates at approximately weekly intervals until there are no bugs
-blocking the final major release. 
+blocking the final major release.
 
 Compared to the current process this has approximately the same amount of
 release-related work, because the extra releases from the stable branch
@@ -192,7 +149,7 @@
 Bug Work
 --------
 
-Bug fixes should normally be done first against the stable branch, 
+Bug fixes should normally be done first against the stable branch,
 reviewed against that branch, and then merged forward to trunk.
 
 It may not always be easy to do this, if fixing the bug requires large
@@ -240,7 +197,7 @@
 of bzrlib, which is an elusive target in Python.
 
 This may mean that in cases where today a plugin would keep running but
-give warnings, it will now fail altogether with an error.   
+give warnings, it will now fail altogether with an error.
 
 In return we expect more freedom to change and cleanup bzrlib code without
 needing to keep old code around, or write extra compatibility shims, or
@@ -252,7 +209,7 @@
 but that aren't technically plugins.  The same approach, though the
 technical considerations are different, should apply to other extensions
 such as programs that use bzr through the shell interface.
-  
+
 
 
 Data and Network Formats
@@ -296,7 +253,7 @@
 This can be handled in various ways either at the OS packaging or the
 Python level.  We don't propose to directly address it in the upstream
 source.  (For example, we will not change the bzrlib library name from one
-release to the next.)  
+release to the next.)
 
 The issue already exists with people who may want to use for example the
 previous bzr release and the trunk.  There is a related issue that plugins
@@ -350,7 +307,7 @@
 
 * Early communication about changing dependencies or defaults
 
-* Reminder re lifecycle and where we're up to right now, in particular the 
+* Reminder re lifecycle and where we're up to right now, in particular the
   dates for the next release and/or candidate.
 
 * Summary of recent successes and pending work.
@@ -364,11 +321,11 @@
 Questions
 *********
 
-Do users actually want this?  
+Do users actually want this?
     Apparently yes, because it's often requested and often raised as a
     problem.
 
-Would this confuse users?  
+Would this confuse users?
     It shouldn't, because it's a fairly standard scheme.
 
 Won't it take more time to fix bugs in multiple places?
@@ -388,7 +345,7 @@
     really rather not test them, forcing them is not helpful.
 
 Isn't this a step backwards to a slower, less-agile process?
-    No, our trunk stays releasable, and we ship every month.  We're just 
+    No, our trunk stays releasable, and we ship every month.  We're just
     cutting out things that hold us back (continuous rather than episodic
     API stability; RCs every month) and giving users what they demand.
 
@@ -406,7 +363,7 @@
   and stable releases, indicating that each has value.
 
 * API changes are easier or safer to make during beta periods, without
-  being held back by fears of compatibility or 
+  being held back by fears of compatibility or
 
 * The stable releases are actually stable and don't introduce regressions
   or break plugins.
@@ -421,11 +378,52 @@
 
 * Users like it.
 
+After doing this for the 2.0 cycle (September 2009 through to early
+2010), it seems to be going well.
+
+
+Reviewing for the Stable Branch
+*******************************
+
+These are guidelines and can be interpreted case-by-case.
+
+* All changes to the stable branch should fix a bug, even if you would not
+  normally file a bug for the change.  The bug description should if at
+  all possible explain how to manually verify the bug in a way that will
+  fail before and pass after the change.  (These are requirements for the
+  SRU process.)
+
+* The change should be reasonably small and conservative.  
+
+* Remember that the patch will be read during the SRU
+  process and so keeping the patch small is useful even beyond keeping the
+  logical changes small.  Avoid doing mechanical bulk changes on the
+  stable branch.
+
+* Use particular care for things that may behave differently across
+  platforms, encodings or locales.  It's harder to thoroughly test these
+  things before a release.
+
+* Generally speaking, just cleaning things up is not a sufficient reason
+  to make changes to the stable branch.  It has to actually fix a bug.
+
+* Changes to the stable branch should include tests as usual.  
+
+* Don't change or remove existing APIs that might be used by plugins, even
+  if they are underscore-prefixed.  Adding APIs that are also being added
+  to the trunk branch may make sense.
+
+* Keeping consistency with trunk is useful, but less important than
+  keeping the stable branch stable.
+
+* (more items welcome)
+
 References
 **********
 
-#. List thread "[rfc] six-month stable release cycles", July 2009.
+#. List thread "`[rfc] six-month stable release cycles`__", July 2009.
+
+.. __: https://lists.ubuntu.com/archives/bazaar/2009q3/060882.html
 
 ..
    vim: filetype=rst textwidth=74 ai shiftwidth=4
-

=== modified file 'doc/developers/development-repo.txt'
--- doc/developers/development-repo.txt	2009-04-09 20:23:07 +0000
+++ doc/developers/development-repo.txt	2009-12-02 20:34:07 +0000
@@ -28,7 +28,7 @@
 
 When a release of bzr is done, all the older numbered development
 formats will be removed from 'bzr.dev', so we will not be carrying the
-code for them around indefinately. 
+code for them around indefinately.
 
 Support for upgrade and migration
 ---------------------------------
@@ -40,7 +40,7 @@
  - users of a given development format can always get back onto regular
    formats by switching to the next bzr released version which is
    guaranteed to be able to upgrade from that development format.
- - users that routinely use bzr.dev should upgrade to the most recent 
+ - users that routinely use bzr.dev should upgrade to the most recent
    development version available before pulling in bzr.dev changes
    around release time, as that is when old format cleanups will occur.
 

=== modified file 'doc/developers/diff.txt'
--- doc/developers/diff.txt	2007-07-17 00:27:16 +0000
+++ doc/developers/diff.txt	2009-12-02 20:34:07 +0000
@@ -61,7 +61,7 @@
 that only certain files should be compared.
 
 Performance can be further improved by caching comparisons to avoid repeating
-them.  Caching could potentially be performed by ``diff`` and perhaps by 
+them.  Caching could potentially be performed by ``diff`` and perhaps by
 ``merge``.  Merge is aware of the relationship of a text merge's result to
 the THIS value, and the THIS value is generally the basis value.  So the
 comparison is latent, but present.  The only issue is extracting it.

=== modified file 'doc/developers/directory-fingerprints.txt'
--- doc/developers/directory-fingerprints.txt	2007-07-31 03:38:18 +0000
+++ doc/developers/directory-fingerprints.txt	2009-12-02 20:34:07 +0000
@@ -8,7 +8,7 @@
 
 The basic idea is that for a directory in a tree (committed or otherwise), we
 will have a single scalar value.  If these values are the same, the contents of
-the subtree under that directory are necessarily the same.  
+the subtree under that directory are necessarily the same.
 
 This is intended to help with these use cases, by allowing them to quickly skip
 over directories with no relevant changes, and to detect when a directory has
@@ -26,7 +26,7 @@
 
 Most of this will be hidden behind the Tree interface.  This should cover
 ``log -v``, ``diff``, ``status``, ``merge`` (and implicit merge during
-push, pull, update):: 
+push, pull, update)::
 
   tree.iter_changes(other_tree)
   tree.get_file_lines(file_id)   # and get_file, get_file_text
@@ -38,7 +38,7 @@
 compare to all the trees.  Commit currently needs to compare the working
 tree to all the parent trees, which is needed to update the last_modified
 field and would be unnecessary if we removed that field (for both files
-and directories) and did not store per-file graphs.  
+and directories) and did not store per-file graphs.
 This would potentially speed up commit after merge.
 
 Verbose commit also displays the merged files, which does
@@ -49,7 +49,7 @@
 ~~~~~~~
 
 Log is interested in two operations: finding the revisions that touched
-anything inside a directory, and getting the differences between 
+anything inside a directory, and getting the differences between
 consecutive revisions (possibly filtered to a directory)::
 
   find_touching_revisions(branch, file_id) # should be on Branch?
@@ -90,9 +90,9 @@
   Hashes converge: if you modify and then modify back, you get the same
   hash.  This is a pro because you can detect that there were ultimately
   no significant changes.  And also a con: you cannot use these hashes to form a graph
-  because they get cycles.  
-
-  
+  because they get cycles.
+
+
 * Are the values unique across the whole tree, or only when comparing
   different versions of the same object?
 
@@ -107,7 +107,7 @@
 
 
 * Is it reasonable to assume hashes won't collide?
-  
+
   The odds of SHA-1 hashes colliding "accidentally" are vanishingly small.
 
   It is possible that a `preimage attack`_ against SHA-1 may be discovered
@@ -132,7 +132,7 @@
 
   It is desirable that we have a hash that covers all data, to guard
   against bugs, transmission errors, or users trying to hand-hack files.
-  Since we need one hash of everything in the tree, perhaps we should also 
+  Since we need one hash of everything in the tree, perhaps we should also
   use it for the fingerprint.
 
   Testaments explicitly separate the form used for hashing/signing from
@@ -143,7 +143,7 @@
   stored data which is not protected by the signature: this data is less
   important, but corruption of it would still cause problems.
   We have encountered some specific problems with disagreement between
-  inventories as to the last-change of files, which is currently unsigned. 
+  inventories as to the last-change of files, which is currently unsigned.
   These problems can be introduced by ghosts.
 
   If we hash the representation, there is still a way to support old
@@ -156,16 +156,16 @@
 * Is hashing substantially slower than other possible approaches?
 
   We already hash all the plain files.  Except in unusual cases, the
-  directory metadata will be substantially smaller: perhaps 200:1 as a 
+  directory metadata will be substantially smaller: perhaps 200:1 as a
   rule of thumb.
 
   When building a bzr tree, we spend on the order of 100ms hashing all the
   source lines to validate them (about 13MB of source).
 
 
-* Can you calculate one from a directory in the working tree?  Without a basis?  
+* Can you calculate one from a directory in the working tree?  Without a basis?
 
-  This seems possible with either hashes or revision ids.  
+  This seems possible with either hashes or revision ids.
 
   Using last_changed means that calculating the fingerprint from a working
   tree necessarily requires reading the inventory for the basis
@@ -199,30 +199,30 @@
   This does rule out for example using ``last_modified=None`` or
   ``='current:'`` to mean "changed in the working tree."  Even if this is
   not supported there seems some risk that we would get the same
-  fingerprint for trees that are actually different.  
-  
-  We could assign a 
+  fingerprint for trees that are actually different.
+
+  We could assign a
   hypothetical revision id to the tree for uncommitted files.  In that
   case there is some risk that the not-yet-committed id would become
   visible or committed.
 
-  
+
 * Can we use an "approximate basis"?
 
   When using radix trees, you may need context beyond the specific
-  directory being compared.  
-
-
-* Can you get the fingerprint of parents directories with only selected file ids 
+  directory being compared.
+
+
+* Can you get the fingerprint of parents directories with only selected file ids
   taken from the working tree?
 
   With hashes, we'd want to carry through the unselected files and
-  directories from the values they had in the parent revision.  
-
-
-* Are unbalanced trees a significant problem?  Trees can be unbalanced by having 
-  many directories (deep or wide), or many files per directory.  
-  
+  directories from the values they had in the parent revision.
+
+
+* Are unbalanced trees a significant problem?  Trees can be unbalanced by having
+  many directories (deep or wide), or many files per directory.
+
   For small trees like bzr, 744 of 874 are in the bzrlib subtree.  In
   general, larger trees are more balanced, because humans, editors and
   other tools have trouble managing very unbalanced trees.  But there are
@@ -230,7 +230,7 @@
   entries in one directory.
 
 
-* Should we use a radix tree approach where fingerprints are calculated on a synthetic 
+* Should we use a radix tree approach where fingerprints are calculated on a synthetic
   tree that is by definition balanced, even when the actual tree is unbalanced?
 
 
@@ -268,10 +268,10 @@
      This has some consequences for how we can upgrade it in future: all
      the changed directories need to be rewritten up to the revision level.
 
-  1. If we address directories by hash we need hash-addressed 
+  1. If we address directories by hash we need hash-addressed
      storage.
 
-  1. If we address directories by hash then for consistency we'd probably 
+  1. If we address directories by hash then for consistency we'd probably
      (not necessarily) want to address file texts by hash.
 
   1. The per-file graph can't be indexed by hash because they can converge, so we
@@ -316,8 +316,8 @@
   If the version of a file or directory is identified by a hash, we can't
   use that to point into a per-file graph.  We can have a graph indexed by
   ``(file_id, hash, revision_id)``.  The last-modified could be stored as
-  part of this graph.  
-  
+  part of this graph.
+
   The graph would no longer be core data; it could be always present but
   might be rebuilt.  Treating it as non-core data may make some changes
   like shallow branches easier?
@@ -354,6 +354,6 @@
 -----------
 
 
-..  
+..
   vim: filetype=rst textwidth=78 expandtab spelllang=en spell
 

=== modified file 'doc/developers/ec2.txt'
--- doc/developers/ec2.txt	2009-03-23 00:25:27 +0000
+++ doc/developers/ec2.txt	2009-12-02 20:34:07 +0000
@@ -8,7 +8,7 @@
 but we aim to use it for the production Windows installer build of 1.13 in
 March.
 
-See also: 
+See also:
 
 * `Bazaar Developer Documentation Catalog <index.html>`_.
 
@@ -20,8 +20,8 @@
 =====
 
 * The instance is only running (and incurring charges) when it's needed
-  for testing or packaging.  
-  
+  for testing or packaging.
+
 * It can be started or stopped by anyone on the team using a
   straightforward script.
 
@@ -41,7 +41,7 @@
 ========
 
 The working disk and the AMI images are stored in one person's account for
-billing purposes.  
+billing purposes.
 
 Ideally we want to give other people access to run this machine without
 giving full access to the account.  I'm not sure if that's feasible.  If
@@ -76,7 +76,7 @@
 This is distinct from the account identifier - likely due to the different
 toolchains in use (the keypairs are used for unix ssh keys, and I (Robert)
 suspect a rather unix friendly core at Amazon).
-Once a custom image is made with a saved password, you can skip using 
+Once a custom image is made with a saved password, you can skip using
 ``ec2-get-password`` (which is only needed for Windows anyway).
 
 It would be nice if rdesktop could use private key authentication but
@@ -125,9 +125,9 @@
 * Install the rdesktop client, to actually access the machine.
 
 * Possibly read some of the `EC2 documentation`_ for background.
-   
-.. _`bug 330930`: https://bugs.edge.launchpad.net/ubuntu/+bug/330930 
-.. _`Amazon EC2 API tools`: 
+
+.. _`bug 330930`: https://bugs.edge.launchpad.net/ubuntu/+bug/330930
+.. _`Amazon EC2 API tools`:
      http://developer.amazonwebservices.com/connect/entry.jspa?externalID=368&categoryID=88
 .. _`EC2 documentation`: http://aws.amazon.com/
 .. _`ami-bdfe19d4`:
@@ -138,7 +138,7 @@
     ec2-add-group desolation-group -d 'bzr win32 build machine'
     ec2-authorize desolation-group -p 3389 -s 1.2.3.4/32
     ec2-authorize desolation-group -t -1:-1 -P icmp
-  
+
   Add your public IP there.  You can repeat that command to allow others
   in.
 
@@ -149,11 +149,11 @@
 1. Get the right AMI image ID from another developer.
 
 1. Start the instance::
-   
+
      ec2-run-instances $image_id -g desolation-group
 
    This will print out some information including the image id, something
-   like ``i-31a74258``.  
+   like ``i-31a74258``.
 
 1. Actually starting the machine will take a few minutes.  Once it's in
    the *running* state, get the machine's public IP with ::
@@ -171,18 +171,18 @@
 To save a system snapshot as an image
 -------------------------------------
 
-1. Bundle the current state.  *Doing this will reboot the machine.* 
+1. Bundle the current state.  *Doing this will reboot the machine.*
    You need to choose a unique s3 bucket name,
-   typically based on a domain or email address, which can contain 
+   typically based on a domain or email address, which can contain
    any number of images.  You also need a name unique within the bucket
-   for this image, like ``desolation-vs2008-20090219``.  And finally 
+   for this image, like ``desolation-vs2008-20090219``.  And finally
    it needs your AWS S3 access key and secret key, which should be set in
    ``~/.aws``::
-    
+
       ec2-bundle-instance -b ec2.sourcefrog.net \
           -p desolation-vs2008-2009021 \
           -o "$AWS_ACCESS_KEY_ID" \
-          -w "$AWS_SECRET_ACCESS_KEY" 
+          -w "$AWS_SECRET_ACCESS_KEY"
 
 1.  This will take several minutes:  You can check progress with ::
 

=== modified file 'doc/developers/improved_chk_index.txt'
--- doc/developers/improved_chk_index.txt	2009-03-24 16:35:22 +0000
+++ doc/developers/improved_chk_index.txt	2009-12-02 20:34:07 +0000
@@ -16,7 +16,7 @@
 per key, which is the same size as the binary representation of the hash. This
 means we could write an index format that gets approximately the same on-disk
 size, without having the overhead of ``zlib.decompress``. Some thought would
-still need to be put into how to efficiently access these records from remote. 
+still need to be put into how to efficiently access these records from remote.
 
 
 Required information
@@ -99,7 +99,7 @@
    offset + endpoint as a header in the group itself.)
 
 5. So for 1M keys, an ideal chk+group index would be:
-    
+
     a. 6-byte hash prefix
 
     b. 2-byte group number
@@ -149,13 +149,13 @@
       information to read the entire group block. For local ops, you could
       only read enough to get the header, and then only read enough to
       decompress just the content you want to get at.
-      
+
       Using an offset, you also don't need to decode the entire group header.
       If we assume that things are stored in fixed-size records, you can jump
       to exactly the entry that you care about, and read its 8-byte
       (start,length in uncompressed) info.  If we wanted more redundancy we
       could store the 20-byte hash, but the content can verify itself.
-      
+
    f. If the size of these mini headers becomes critical (8 bytes per record
       is 8% overhead for 100 byte records), we could also compress this mini
       header. Changing the number of bytes per entry is unlikely to be
@@ -172,7 +172,7 @@
       would also have the advantage that fixed width would be highly
       compressible itself. (Most nodes are going to have a length that fits
       1-2 bytes.)
-      
+
       An alternative form would be to use the base-128 encoding.  (If the MSB
       is set, then the next byte needs to be added to the current value
       shifted by 7*n bits.) This encodes 4GiB in 5 bytes, but stores 127B in 1
@@ -470,5 +470,5 @@
 group pointer, we can refer to 16.7M groups. It does add complexity, but it is
 likely necessary to allow for arbitrary cases.
 
-.. 
+..
   vim: ft=rst tw=78 ai

=== modified file 'doc/developers/incremental-push-pull.txt'
--- doc/developers/incremental-push-pull.txt	2009-02-22 16:54:02 +0000
+++ doc/developers/incremental-push-pull.txt	2009-12-02 20:34:07 +0000
@@ -94,8 +94,8 @@
       found to be a subset of the other, or a complete list of revisions to be
       transmitted is created.
 
- * Uncommon cases: 
-   
+ * Uncommon cases:
+
    1. Repositories with many projects or branches which are very old may
       require reading a lot of unrelated graph data.
 
@@ -109,7 +109,7 @@
  2. Determine one sided graph difference. To avoid obtaining a full graph over
     the wire this needs to be done without reference to the full graph, and
     with some logarthmic scaling algorithm. There are several already available
-    for this. 
+    for this.
 
 With ghost and new-signature detection:
 
@@ -219,7 +219,7 @@
 Data grouping:
 
 * File per full identifier (fileid:revisionid:meta|content): 104000
-* Delta-chain per object: object id count * constant overhead per object id 
+* Delta-chain per object: object id count * constant overhead per object id
   (26 -> 80006)
 * Collation/pack file: 1
 
@@ -251,7 +251,7 @@
 
  #. setup
 
-   look at graph of revisions for ~N comits to deretmine eligibility for 
+   look at graph of revisions for ~N comits to deretmine eligibility for
    if preserve mainline is on, check LH only
 
     identify objects to send that are not on the client repo

=== modified file 'doc/developers/index-plain.txt'
--- doc/developers/index-plain.txt	2009-09-09 12:57:43 +0000
+++ doc/developers/index-plain.txt	2009-12-02 20:34:07 +0000
@@ -11,7 +11,7 @@
 * `Architectural Overview <overview.html>`_ |--| describes some of the
   most important classes and concepts.
 
-* `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi/>`_ 
+* `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi/>`_
   (external link)
   |--| automatically generated API reference information
 
@@ -24,7 +24,7 @@
 
 * `Testing <testing.html>`_ |--| Guide to writing tests for Bazaar.
 
-* `Writing plugins <http://bazaar-vcs.org/WritingPlugins>`_ (wiki) 
+* `Writing plugins <http://bazaar-vcs.org/WritingPlugins>`_ (wiki)
   |--| specific advice on writing Bazaar plugins.
 
 Process
@@ -32,8 +32,8 @@
 
 * `The Bazaar Development Cycle <cycle.html>`_ |--| The monthly
   development cycle and how to run it.
-  
-* `Releasing Bazaar <releasing.html>`_ |--| 
+
+* `Releasing Bazaar <releasing.html>`_ |--|
   Checklist to make a release of Bazaar.
 
 * `Managing the Bazaar PPA <ppa.html>`_ |--| Packaging Bazaar for Ubuntu.
@@ -41,19 +41,19 @@
 * `Giving back <http://bazaar-vcs.org/BzrGivingBack>`_ (wiki) |--| How to get
   your changes to Bazaar integrated into a release.
 
-* `Profiling notes <profiling.html>`_ |--| Instructions on how to profile 
+* `Profiling notes <profiling.html>`_ |--| Instructions on how to profile
   bzr code and visualize the results.
 
-* `EC2 resources <ec2.html>`_ |--| A team resource for 
+* `EC2 resources <ec2.html>`_ |--| A team resource for
   Windows packaging and testing, and Ubuntu testing.
 
-* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug 
+* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug
   tracker.
 
 Plans
 =====
 
-* `Performance roadmap <performance-roadmap.html>`_ |--| The roadmap 
+* `Performance roadmap <performance-roadmap.html>`_ |--| The roadmap
   for fixing performance in bzr over the next few releases.
 
 * `Co-located branches <colocated-branches.html>`_ |--| Planned(?) support
@@ -114,7 +114,7 @@
 Data formats
 ============
 
-* `Knit pack repositories <packrepo.html>`_ |--| KnitPack repositories 
+* `Knit pack repositories <packrepo.html>`_ |--| KnitPack repositories
   (new in Bazaar 0.92).
 
 Implementation notes

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2009-09-11 07:55:48 +0000
+++ doc/developers/index.txt	2009-12-14 06:06:59 +0000
@@ -2,6 +2,16 @@
 Bazaar Developer Document Catalog
 =================================
 
+
+Introduction
+============
+
+.. toctree::
+   :maxdepth: 1
+
+   contribution-quickstart
+
+
 Enhancing Bazaar
 ================
 
@@ -24,9 +34,9 @@
    overview
    integration
 
-* `Writing plugins for Bazaar <http://bazaar-vcs.org/WritingPlugins>`_ (web link) 
+* `Writing plugins for Bazaar <http://bazaar-vcs.org/WritingPlugins>`_ (web link)
 
-* `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi/>`_ 
+* `bzrlib API reference <http://starship.python.net/crew/mwh/bzrlibapi/>`_
   (web link)
 
 
@@ -36,6 +46,7 @@
 .. toctree::
    :maxdepth: 1
 
+   principles
    plans
    specifications
    implementation-notes

=== modified file 'doc/developers/inventory.txt'
--- doc/developers/inventory.txt	2009-08-28 05:00:33 +0000
+++ doc/developers/inventory.txt	2009-12-02 20:34:07 +0000
@@ -49,7 +49,7 @@
 that an inventory is stored as. We have a number of goals we want to achieve:
 
  1. Allow commit to write less than the full tree's data in to the repository
-    in the general case. 
+    in the general case.
  2. Allow the data that is written to be calculated without examining every
     versioned path in the tree.
  3. Generate the exact same representation for a given inventory regardless of
@@ -83,7 +83,7 @@
 -----------------
 
 The xml based implementation we use today layers the inventory as a bytestring
-which is stored under a single key; the bytestring is then compressed as a 
+which is stored under a single key; the bytestring is then compressed as a
 delta against the bytestring of its left hand parent by the knit code.
 
 Gap analysis:
@@ -140,8 +140,8 @@
 -------------------------------------------------------------------------
 
  * Split up the logical document into smaller serialised fragements. For
-   instance hash buckets or nodes in a tree of some sort. By serialising in 
-   smaller units, we can increase the number of smaller units rather than 
+   instance hash buckets or nodes in a tree of some sort. By serialising in
+   smaller units, we can increase the number of smaller units rather than
    their size as the tree grows; as long as two similar trees have similar
    serialised forms, the amount of different content should be quite high.
 
@@ -166,7 +166,7 @@
 
  * Working tree to arbitrary history revision deltas/comparisons can be scaled
    up by doing a two-step (fixed at two!) delta combining - delta(tree, basis)
-   and then combine that with delta(basis, arbitrary_revision) using the 
+   and then combine that with delta(basis, arbitrary_revision) using the
    repositories ability to get a delta cheaply.
 
  * The key primitives we need seem to be:
@@ -263,7 +263,7 @@
 
 The path and content maps are populated simply by serialising every inventory
 entry and inserting them into both the path map and the content map. The maps
-start with just a single leaf node with an empty prefix. 
+start with just a single leaf node with an empty prefix.
 
 
 Apply
@@ -439,10 +439,10 @@
    formerly linked. (This will normally bubble down due to keeping densely
    packed nodes).
    To shrink the prefix of a leaf node, create an internal node with the same
-   prefix, then choose a width for the internal node such that the contents 
+   prefix, then choose a width for the internal node such that the contents
    of the leaf all fit into new leaves obeying the min_size and max_size rules.
    The largest prefix possible should be chosen, to obey the
-   higher-nodes-are-denser rule. That rule also gives room in leaf nodes for 
+   higher-nodes-are-denser rule. That rule also gives room in leaf nodes for
    growth without affecting the parent node packing.
 #. Update the CHK pointers - serialise every altered node to generate a CHK,
    and update the CHK placeholder in the nodes parent; then reserialise the
@@ -590,7 +590,7 @@
 
 Different trees can use different algorithms to expand the request as long as
 they produce consistent deltas. As part of getting a consistent UI we require
-that all trees expand the paths requested downwards. Beyond that as long as 
+that all trees expand the paths requested downwards. Beyond that as long as
 the delta is consistent it is up to the tree.
 
 Given two trees, source and target, and a set of selected file ids to check for
@@ -598,7 +598,7 @@
 the following rules, to get consistent deltas. The test for consistency is that
 if the resulting delta is applied to source, to create a third tree 'output',
 and the paths in the delta match the paths in source and output, only one file
-id is at each path in output, and no file ids are missing parents, then the 
+id is at each path in output, and no file ids are missing parents, then the
 delta is consistent.
 
 Firstly, the parent ids to the root for all of the file ids that have actually

=== modified file 'doc/developers/last-modified.txt'
--- doc/developers/last-modified.txt	2007-08-06 22:22:58 +0000
+++ doc/developers/last-modified.txt	2009-12-02 20:34:07 +0000
@@ -30,7 +30,7 @@
 If there is still more than one head, a new last_modified is assigned.
 This points to the merge point in the file graph.
 
-If the file text and properties are the same as the sole remaining head, 
+If the file text and properties are the same as the sole remaining head,
 its last_modified is inherited. Property changes include executable bit,
 filename, and containing directory.
 
@@ -53,7 +53,7 @@
 For the single-parent commit case, we just need to determine which files have
 changed compared to the parent.  If the file was changed, it gets the
 revision id of the new revision; otherwise it inherits the value from the
-parent tree.  
+parent tree.
 
 In the multi-parent commit case (commit of a merge), it can take the value
 from any of the parent trees, or of the new revision.
@@ -74,11 +74,11 @@
 in fact do this even when not using per-file graphs.  In the current
 dirstate format we need to store the full data for all trees because they
 can be extracted from the dirstate, but it could mark some parents as
-already merged.  
+already merged.
 
 Alternatively, we could change the dirstate to include
 only the base and current trees, and cache the merged-in parents
-elsewhere. 
+elsewhere.
 
 (Offtopic other dirstate changes: we could also omit the working-copy
 hash, and just have a stat-fingerprint of when it was last known equal to
@@ -89,7 +89,7 @@
 Generation during conversion
 ----------------------------
 
-Accessing a foreign branch requires synthesizing this information. 
+Accessing a foreign branch requires synthesizing this information.
 If last_modified is removed from a future bzr version, we will also need
 to synthesize it to pull back to earlier formats.
 
@@ -172,5 +172,5 @@
 For a single file, if I am different from all parents, 'new'. (Do not need
 to evaluate last modified).
 
-..   
+..
   vim: ft=rst tw=74

=== modified file 'doc/developers/network-protocol.txt'
--- doc/developers/network-protocol.txt	2009-09-17 03:21:14 +0000
+++ doc/developers/network-protocol.txt	2009-12-02 20:34:07 +0000
@@ -172,13 +172,13 @@
 
 An extension to version two allows streamed bodies.  A streamed body looks
 a lot like HTTP's chunked encoding::
- 
+
   STREAMED_BODY := "chunked" NEWLINE CHUNKS TERMINATOR
   CHUNKS := CHUNK [CHUNKS]
   CHUNK := HEX_LENGTH CHUNK_CONTENT
   HEX_LENGTH := HEX_DIGITS NEWLINE
   CHUNK_CONTENT := bytes
-  
+
   TERMINATOR := SUCCESS_TERMINATOR | ERROR_TERMINATOR
   SUCCESS_TERMINATOR := 'END' NEWLINE
   ERROR_TERMINATOR := 'ERR' NEWLINE CHUNKS SUCCESS_TERMINATOR
@@ -201,7 +201,7 @@
 -------------
 
 .. note::
-  
+
   For some discussion of the requirements that led to this new protocol
   version, see `bug #83935`_.
 
@@ -226,7 +226,7 @@
   HEADERS := LENGTH_PREFIX bencoded_dict
   END_MESSAGE := "e"
 
-  BODY := MESSAGE_PART+ 
+  BODY := MESSAGE_PART+
   MESSAGE_PART := ONE_BYTE | STRUCTURE | BYTES
   ONE_BYTE := "o" byte
   STRUCTURE := "s" LENGTH_PREFIX bencoded_structure
@@ -262,10 +262,10 @@
 Conventional requests will send a CONTENTS of ::
 
   CONV_REQ := ARGS SINGLE_OR_STREAMED_BODY?
-  SINGLE_OR_STREAMED_BODY := BYTES 
+  SINGLE_OR_STREAMED_BODY := BYTES
         | BYTES+ TRAILER
-         
-  ARGS := STRUCTURE(argument_tuple) 
+
+  ARGS := STRUCTURE(argument_tuple)
   TRAILER := SUCCESS_STATUS | ERROR
   SUCCESS_STATUS := ONE_BYTE("S")
   ERROR := ONE_BYTE("E") STRUCTURE(argument_tuple)
@@ -276,7 +276,7 @@
   RESP_STATUS := ONE_BYTE("S") | ONE_BYTE("E")
 
 If the RESP_STATUS is success ("S"), the arguments are the
-method-dependent result.  
+method-dependent result.
 
 For errors (where the Status byte of a response or a streamed body is
 "E"), the situation is analagous to requests.  The first item in the
@@ -287,7 +287,7 @@
 Note that the streamed body from version two is now just multiple
 BYTES parts.
 
-The end of the request or response is indicated by the lower-level 
+The end of the request or response is indicated by the lower-level
 END_MESSAGE.  If there's only one BYTES element in the body, the TRAILER
 may or may not be present, depending on whether it was sent as a single
 chunk or as a stream that happens to have one element.
@@ -304,7 +304,7 @@
   initial success and then another byte part with no intervening bytes.
   If we stop sending the final success message and only flag errors
   they'll only get one if the error is detected after streaming starts but
-  before any bytes are actually sent.  Possibly we should wait until at 
+  before any bytes are actually sent.  Possibly we should wait until at
   least the first chunk is ready before declaring success.
 
 For new methods, these sequences are just a convention and may be varied
@@ -320,12 +320,12 @@
   be preserved in the rpc from end to end.  This may be useful when
   there's an iterator on one side feeding in to an iterator on the other,
   if it avoids doing chunking and byte-counting at two levels, and if
-  those iterators are a natural place to get good granularity.  Also, for 
+  those iterators are a natural place to get good granularity.  Also, for
   cases like ``insert_record_stream`` the server can't do much with the
   data until it gets a whole chunk, and so it'll be natural and efficient
   for it to be called with one chunk at a time.
 
-  On the other hand, there may be times when we've got some bytes from the 
+  On the other hand, there may be times when we've got some bytes from the
   network but not a full chunk, and it might be worthwhile to pass it up.
   If we promise to preserve chunks, then to do this we'd need two separate
   streaming interfaces: "we got a chunk" and "we got some bytes but not
@@ -436,6 +436,9 @@
 using `bzrlib.transport.pathfilter` and `os.path.expanduser`, taking care
 to respect the virtual root.
 
+Paths in request arguments are UTF-8 encoded, except for the legacy VFS
+requests which expect escaped (`bzrlib.urlutils.escape`) paths.
+
 
 Requests
 ========

=== modified file 'doc/developers/overview.txt'
--- doc/developers/overview.txt	2009-09-08 01:11:40 +0000
+++ doc/developers/overview.txt	2009-12-02 20:34:07 +0000
@@ -12,7 +12,7 @@
 document, send a merge request or new text to the mailing list.
 
 The current version of this document is available in the file
-``doc/developers/overview.txt`` in the source tree, and available online 
+``doc/developers/overview.txt`` in the source tree, and available online
 within the developer documentation, <http://doc.bazaar-vcs.org/developers/>.
 
 
@@ -101,11 +101,11 @@
 store a full text of the inventory, and of every new file text.
 
 At runtime, repository stacking is actually configured by the branch, not
-the repository.  So doing ``a_bzrdir.open_repository()`` 
-gets you just the single physical repository, while 
-``a_bzrdir.open_branch().repository`` gets one configured with a stacking. 
+the repository.  So doing ``a_bzrdir.open_repository()``
+gets you just the single physical repository, while
+``a_bzrdir.open_branch().repository`` gets one configured with a stacking.
 Therefore, to permanently change the fallback repository stored on disk,
-you must use ``Branch.set_stacked_on_url``.  
+you must use ``Branch.set_stacked_on_url``.
 
 Changing away from an existing stacked-on URL will copy across any
 necessary history so that the repository remains usable.

=== modified file 'doc/developers/performance-use-case-analysis.txt'
--- doc/developers/performance-use-case-analysis.txt	2007-06-18 02:04:20 +0000
+++ doc/developers/performance-use-case-analysis.txt	2009-12-02 20:34:07 +0000
@@ -1,6 +1,6 @@
 .. This document describes _how_ to do use case analyses and what we want
 .. to get out of them; for the specific cases see the files referenced by
-.. performance-roadmap.txt 
+.. performance-roadmap.txt
 
 Analysing a specific use case
 =============================
@@ -55,7 +55,7 @@
 - scaling: how does performance change when any of the follow aspects
   of the system are ratcheted massively up or down:
 
-   - number of files/dirs/symlinks/subtrees in a tree (both working and 
+   - number of files/dirs/symlinks/subtrees in a tree (both working and
      revision trees)
    - size of any particular file
    - number of elements within a single directory
@@ -77,9 +77,9 @@
    - bandwidth when performing semantic operations.
 
 - locality of reference: If an operation requires data that is located
-  within a small region at any point, we often get better performance 
+  within a small region at any point, we often get better performance
   than with an implementation of the same operation that requires the
-  same amount of data but with a lower locality of reference. Its 
+  same amount of data but with a lower locality of reference. Its
   fairly tricky to add locality of reference after the fact, so I think
   its worth considering up front.
 
@@ -89,7 +89,7 @@
 measurements, in an ideal world there would be no more than one round
 trip for each semantic operation. What there must not be is one round
 trip per revision involved in the revisionid->dotted number mapping, nor
-per each revision id attributed to a line in the text. 
+per each revision id attributed to a line in the text.
 
 Not all the items mentioned above are created equal. The analysis should
 include the parameters considered and the common case values for each - the

=== modified file 'doc/developers/planned-change-integration.txt'
--- doc/developers/planned-change-integration.txt	2009-06-10 05:03:42 +0000
+++ doc/developers/planned-change-integration.txt	2009-12-02 20:34:07 +0000
@@ -37,7 +37,7 @@
    provide strong feedback to the design process for those things which are
    considered optional or removable, so these APIs should be implemented
    before removing or making optional existing data.
- 
+
  * Deprecating versioned files as a supported API: This collaborates with the
    Repository API but can probably be done by adding a replacement API for
    places where the versioned-file api is used. We may well want to keep a
@@ -54,7 +54,7 @@
    layer changes to inventories so while we can create a revision validator
    API, we cannot create the final one until we have the inventory structural
    changes completed.
- 
+
  * Annotation caching API: This API is a prerequisite for new repository
    formats. If written after they are introduced we may find that the
    repository is lacking in functionality, so the API should be implemented
@@ -87,7 +87,7 @@
    of the newer API for accessing data about a file over time. It can be a
    separate step easily; but as it's in the same area of the library should not
    be done in parallel.
-  
+
  * Repository stacking API: The key dependency/change required for this is that
    repositories must individually be happy with having partial data - e.g. many
    ghosts. However the way the API needs to be used should be driven from the
@@ -97,7 +97,7 @@
    On the data insertion side commit will want to generate new data. The
    commands pull, bundle, merge, push, possibly uncommit will want to copy
    existing data in a streaming fashion.
- 
+
  * New container format: Its hard to tell what the right way to structure the
    layering is. Probably having smooth layering down to the point that code
    wants to operate on the containers directly will make this more clear. As
@@ -129,7 +129,7 @@
  * Delta storage optimisation: This has a strict dependency on a new repository
    format. Optimisation takes many forms - we probably cannot complete the
    desired optimisations under knits though we could use xdelta within a
-   knit-variation. 
+   knit-variation.
 
  * Greatest distance from origin cache: The potential users of this exist
    today, it is likely able to be implemented immediately, but we are not sure

=== modified file 'doc/developers/planned-performance-changes.txt'
--- doc/developers/planned-performance-changes.txt	2009-04-04 02:57:47 +0000
+++ doc/developers/planned-performance-changes.txt	2009-12-02 20:34:07 +0000
@@ -93,7 +93,7 @@
  * New container format to allow single-file description of multiple named
    objects. This will provide the basis for transmission of revisions over the
    network, the new bundle format, and possibly a new repository format as
-   well. [Core implemented] 
+   well. [Core implemented]
 
  * Separate the annotation cache from the storage of actual file texts and make
    the annotation style, and when to do it, configurable. This will reduce data

=== modified file 'doc/developers/plans.txt'
--- doc/developers/plans.txt	2009-09-07 07:44:36 +0000
+++ doc/developers/plans.txt	2009-12-02 20:34:07 +0000
@@ -10,7 +10,7 @@
    improved_chk_index
 
 
-* `Performance roadmap <performance-roadmap.html>`_ |--| The roadmap 
+* `Performance roadmap <performance-roadmap.html>`_ |--| The roadmap
   for fixing performance in bzr over the next few releases.
 
 * `Co-located branches <colocated-branches.html>`_ |--| Planned(?) support

=== modified file 'doc/developers/plugin-api.txt'
--- doc/developers/plugin-api.txt	2009-08-03 11:37:53 +0000
+++ doc/developers/plugin-api.txt	2009-12-02 20:34:07 +0000
@@ -128,7 +128,7 @@
 
   # (look for a .hg directory)
   bzr_control_formats = {"Mercurial":{'.hg/': None}}
-  
+
   # (look for a file called .svn/format with contents 4\n).
   bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
 
@@ -137,15 +137,15 @@
 -------
 
 An example setup.py follows::
-  
+
   #!/usr/bin/env python2.4
   from distutils.core import setup
-  
+
   bzr_plugin_name = 'demo'
   bzr_commands = [
       'new-command',
       ]
-  
+
   bzr_branch_formats = {
       "Branch label on disk\n":"demo branch",
       }
@@ -153,10 +153,10 @@
   bzr_control_formats = {"Subversion":{'.svn/format': '4\n'}}
 
   bzr_transports = ["hg+ssh://"]
-  
+
   bzr_plugin_version = (1, 3, 0, 'dev', 0)
   bzr_minimum_version = (1, 0, 0)
-  
+
   if __name__ == 'main':
       setup(name="Demo",
             version="1.3.0dev0",

=== modified file 'doc/developers/ppa.txt'
--- doc/developers/ppa.txt	2009-09-02 10:41:30 +0000
+++ doc/developers/ppa.txt	2009-12-02 20:34:07 +0000
@@ -38,7 +38,7 @@
 versions it is also copied to the main PPA.
 
 The packaging information is kept in branches of bzr on Launchpad, named
-like 
+like
 <https://code.launchpad.net/~bzr/bzr/packaging-hardy>.
 or
 <lp:~bzr/bzr/packaging-hardy>.  These branches are intended to be used
@@ -46,8 +46,8 @@
 
 Preconditions
 -------------
-  
-* You must have a Launchpad account and be a member of the teams 
+
+* You must have a Launchpad account and be a member of the teams
   that own these PPAs (``~bzr``, ``~bzr-beta-ppa``).
 
 * You must have a GPG key registered to your Launchpad account.
@@ -75,7 +75,7 @@
 
     [DEFAULT]
     default_host_main = notspecified
-  
+
 * Configure ``bzr-builddeb`` to sign the package, which is required for
   Launchpad to build it.  Put this in ``~/.bazaar/builddeb.conf`` ::
 
@@ -189,7 +189,7 @@
       dch -v '1.17~rc1-1~bazaar1~hardy1' -D hardy
 
    dch will default to the distro you're working in and this isn't checked
-   against the version number (which is just our convention), so make sure 
+   against the version number (which is just our convention), so make sure
    to specify it.
 
    Make sure you have the correct email address for yourself (you may need
@@ -197,9 +197,9 @@
    distribution.  It should look something like this::
 
        bzr (1.17~rc1-1~bazaar1~hardy1) hardy; urgency=low
-     
+
         * New upstream release.
-     
+
        -- John Sample <sample@example.com>  Mon, 31 Mar 2008 12:36:27 +1100
 
    If you need to upload the package again to fix a problem, normally you
@@ -251,7 +251,7 @@
 Packaging bzr-svn
 ~~~~~~~~~~~~~~~~~
 
-bzr-svn uses a packaging branch that contains both the source 
+bzr-svn uses a packaging branch that contains both the source
 (including any changes against upstream) and the ``debian/`` directory.
 
 To build bzr-svn:

=== added file 'doc/developers/principles.txt'
--- doc/developers/principles.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/principles.txt	2009-12-14 04:58:08 +0000
@@ -0,0 +1,62 @@
+========================
+Bazaar Design Principles
+========================
+
+We have learned or adopted a few general principles for code in Bazaar.
+Generally we will try to follow them in future, either for consistency or
+because they've been proven to work well, or both.  
+
+We may need to depart from these principles in particular special cases,
+or modify them as we learn more, or we might be diverging for them for no
+very good reason but just because of bugs.  If in doubt, ask.  
+
+See also: `Bazaar Developer Document Catalog <index.html>`_.
+
+
+Testing
+-------
+
+Untested code is broken code.
+
+So if a function is removed from the normal flow of execution (perhaps
+because a new default format was introduced) we have to make sure we can
+still execute and test the old code -- or remove it altogether.
+
+
+
+Data formats
+------------
+
+Fixing code once it's released is easy; fixing a problematic data format
+once people have started using it is more difficult.  We should document
+and review formats separately from the code that implements them.
+
+Data formats should have clear format markers that allow us to support new
+formats in future.  It should be easy to read the format without reading
+the whole object.
+
+The format marker should be a string understandable by a user that names
+the format and gives the bzr release that introduced it.  If the bzr
+program doesn't understand that format, it can at least show that format
+marker to the user.
+
+Once we mark a format as supported, we'll continue supporting it for
+several future releases, and support upgrading from it
+forever.
+
+Once we've released a format, we normally don't change it.  Adding new
+optional elements can cause problems when older clients don't understand
+those changes, or don't propagate them properly.
+
+We clearly distinguish internal files from user files.  Files inside
+``.bzr/`` are only written to by bzr and we discourage users from editing
+them.  Within bzr, code addressing the abstract interface of the Branch,
+BzrDir, etc shouldn't know where or how the internal files are stored.  If
+anything else is written in there, it won't be propagated when pushing or
+pulling, and won't be converted when upgrading.  (This is not quite true
+though; there is a ``branch.conf``.)
+
+User files within the tree, by contrast, we always store and return
+verbatim.  It's OK for Bazaar to read and act on these files (as we do
+with ``.bzrignore``), and to update them (as ``bzr ignore`` does), but
+they remain clearly user files and can be directly edited.

=== modified file 'doc/developers/process.txt'
--- doc/developers/process.txt	2009-09-09 02:21:47 +0000
+++ doc/developers/process.txt	2009-12-02 20:34:07 +0000
@@ -14,8 +14,8 @@
 
 * `The Bazaar Development Cycle <cycle.html>`_ |--| The monthly
   development cycle and how to run it.
-  
-* `Releasing Bazaar <releasing.html>`_ |--| 
+
+* `Releasing Bazaar <releasing.html>`_ |--|
   Checklist to make a release of Bazaar.
 
 * `Managing the Bazaar PPA <ppa.html>`_ |--| Packaging Bazaar for Ubuntu.
@@ -23,13 +23,13 @@
 * `Giving back <http://bazaar-vcs.org/BzrGivingBack>`_ (wiki) |--| How to get
   your changes to Bazaar integrated into a release.
 
-* `Profiling notes <profiling.html>`_ |--| Instructions on how to profile 
+* `Profiling notes <profiling.html>`_ |--| Instructions on how to profile
   bzr code and visualize the results.
 
-* `EC2 resources <ec2.html>`_ |--| A team resource for 
+* `EC2 resources <ec2.html>`_ |--| A team resource for
   Windows packaging and testing, and Ubuntu testing.
 
-* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug 
+* `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug
   tracker.
 
 

=== modified file 'doc/developers/profiling.txt'
--- doc/developers/profiling.txt	2007-08-08 14:12:02 +0000
+++ doc/developers/profiling.txt	2009-12-02 20:34:07 +0000
@@ -50,7 +50,7 @@
 global option.
 
 This writes messages into ``~/.bzr.log``.
-At present this only logs actions relating to the on-disk lockdir.  It 
+At present this only logs actions relating to the on-disk lockdir.  It
 doesn't describe actions on in-memory lock counters, or OS locks (which
 are used for dirstate.)
 

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2009-10-15 04:01:26 +0000
+++ doc/developers/releasing.txt	2009-12-02 20:34:07 +0000
@@ -2,12 +2,19 @@
 ================
 
 This document describes the processes for making and announcing a Bazaar
-release, and managing the release process.  This is just one phase of the 
+release, and managing the release process.  This is just one phase of the
 `overall development cycle <http://doc.bazaar-vcs.org/developers/cycle.html>`_,
 but it's the most complex part.
 This document gives a checklist you can follow from start to end in one
 go.
 
+If you're helping the Release Manager (RM) for one reason or another, you
+may notice that he didn't follow that document scrupulously. He may have
+good reasons to do that but he may also have missed some parts.
+
+Follow the document yourself and don't hesitate to create the missing
+milestones for example (we tend to forget these ones a lot).
+
 .. contents::
 
 
@@ -35,7 +42,7 @@
    will be available for targeting or nominating bugs.
 
 #. We create a new pqm-controlled branch for this release series, by
-   asking a Canonical sysadmin.  
+   asking a Canonical sysadmin.
    This branch means that from the first release beta or candidate onwards,
    general development continues on the trunk, and only
    specifically-targeted fixes go into the release branch.
@@ -45,27 +52,16 @@
    and their expected dates.
 
 #. Update the version number in the ``bzr`` script, and the
-   ``bzrlib/__init__.py`` file.
+   ``bzrlib/__init__.py`` file. Make sure there is always a corresponding
+   milestone when you change that version number.
 
 #. Send mail to the list with the key dates, who will be the release
    manager, and the main themes or targeted bugs.  Ask people to nominate
    objectives, or point out any high-risk things that are best done early,
    or that interact with other changes. This is called the metronome mail
-   and as RM you're supposed to send other metronome mails at your rythm.
-
-
-Starting the release phase
---------------------------
-
-When it's time to make the first beta release or release candidate:
-
-#. Make a beta release or release candidate. The milestone for this
-   candidate will already exist (see Starting a cycle above).
-
-Preparing the tree for release
-------------------------------
-
-#. Make a local branch for preparing this release.  (Only for the first 
+   and is described in `Development cycles <cycle.html>`_.
+
+#. Make a local branch for preparing this release.  (Only for the first
    release in a series, otherwise you should already have a branch.) ::
 
      bzr branch trunk prepare-1.14
@@ -77,6 +73,7 @@
 	[/home/mbp/bzr/prepare-x.y]
 	pqm_email = Canonical PQM <pqm@bazaar-vcs.org>
 	submit_branch = http://bazaar.launchpad.net/~bzr-pqm/bzr/x.y
+	parent_branch = http://bazaar.launchpad.net/~bzr-pqm/bzr/x.y
 	public_branch = http://bazaar.example.com/prepare-x.y
 	submit_to = bazaar@lists.canonical.com
 	smtp_server = mail.example.com:25
@@ -85,6 +82,7 @@
     for more details on PQM
 
 #. In the release branch, update  ``version_info`` in ``./bzrlib/__init__.py``.
+   Make sure the corresponding milestone exists.
    Double check that ./bzr ``_script_version`` matches ``version_info``. Check
    the output of ``bzr --version``.
 
@@ -98,8 +96,21 @@
        version_info = (2, 0, 1, 'candidate', 1)
 
 
+Starting the release phase
+--------------------------
+
+#. Create a new milestone at <https://launchpad.net/bzr/x.y/+addmilestone>
+   for the beta release or release candidate if you haven't already.
+
 #. Add the date and release number to ``./NEWS``
 
+   Depending on whether you're doing a beta or a bugfix release, you'll
+   have to create a NEWS section for your release in the right
+   place. Most of the time, the new section is at the top of the file
+   (look what have been done for the various 2.0x and 2.1.0bx releases).
+   The rule is to keep the sections sorted by date. You'll need to be
+   cautious when merging back to trunk to respect that.
+
 #. To check that all bugs mentioned in ``./NEWS`` are actually marked as
    closed in Launchpad, you can run ``tools/check-newsbugs.py``::
 
@@ -112,18 +123,18 @@
 #. Summarize into one or two paragraphs what's new in this release.
 
 #. Commit these changes to the release branch, using a command like::
-    
-     bzr commit -m "Release 1.14." 
-   
+
+     bzr commit -m "Release 1.14."
+
    The diff before you commit will be something like::
 
      === modified file 'NEWS'
      --- NEWS        2008-09-17 23:09:18 +0000
      +++ NEWS        2008-09-23 16:14:54 +0000
      @@ -4,6 +4,23 @@
-     
+
       .. contents::
-     
+
      +bzr 1.7 2008-09-23
      +------------------
      +
@@ -136,21 +147,21 @@
      +
       bzr 1.7rc2 2008-09-17
       ---------------------
-     
-     
+
+
      === modified file 'bzrlib/__init__.py'
      --- bzrlib/__init__.py  2008-09-16 21:39:28 +0000
      +++ bzrlib/__init__.py  2008-09-23 16:14:54 +0000
      @@ -41,7 +41,7 @@
       # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
       # releaselevel of 'dev' for unreleased under-development code.
-     
+
      -version_info = (1, 7, 0, 'candidate', 2)
      +version_info = (1, 7, 0, 'final', 0)
-     
-     
+
+
       # API compatibility version: bzrlib is currently API compatible with 1.7.
-      
+
 #. Tag the new release::
 
      bzr tag bzr-1.14
@@ -159,7 +170,7 @@
    the Internet. PQM will pull from this repository when it attempts to merge
    your changes. Then submit those changes to PQM for merge into the
    appropriate release branch::
- 
+
      bzr push
      bzr pqm-submit -m "(mbp) prepare 1.14"
 
@@ -170,12 +181,12 @@
 -------------------------
 
 #. Change into the source directory and run ::
-  
+
      make dist
 
 #. Now we'll try expanding this tarball and running the test suite
    to check for packaging problems::
- 
+
      make check-dist-tarball
 
    You may encounter failures while running the test suite caused
@@ -248,28 +259,28 @@
    ``bazaar-announce`` list too.
 
    For final releases, it should also be cc'd to ``info-gnu@gnu.org``,
-   ``python-announce-list@python.org``, ``bug-directory@gnu.org``.  
+   ``python-announce-list@python.org``, ``bug-directory@gnu.org``.
 
    In all cases, it is good to set ``Reply-To: bazaar@lists.canonical.com``,
    so that people who reply to the announcement don't spam other lists.
 
    The announce mail will look something like this::
-   
+
       Subject: bzr x.yy released!
-      
+
       <<Summary paragraph from news>>
-     
-      The Bazaar team is happy to announce availability of a new 
+
+      The Bazaar team is happy to announce availability of a new
       release of the bzr adaptive version control system.
       Bazaar is part of the GNU system <http://gnu.org/>.
-     
+
       Thanks to everyone who contributed patches, suggestions, and
       feedback.
-      
-      Bazaar is now available for download from 
-      http://bazaar-vcs.org/Download as a source tarball; packages 
+
+      Bazaar is now available for download from
+      http://bazaar-vcs.org/Download as a source tarball; packages
       for various systems will be available soon.
-      
+
       <<NEWS section from this release back to the last major release>>
 
    Feel free to tweak this to your taste.
@@ -280,7 +291,7 @@
    ensuring the new topic text keeps the project name, web site link, etc.
 
 #. Announce on http://freshmeat.net/projects/bzr/
-   
+
    This should be done for beta releases, release candidates and final
    releases. If you do not have a Freshmeat account yet, ask one of the
    existing admins.
@@ -308,10 +319,29 @@
 the version number in ``bzr`` and ``bzrlib/__init__.py``.  Submit this
 back into pqm for bzr.dev.
 
+As soon as you change the version number in trunk, make sure you have
+created the corresponding milestone to ensure the continuity in bug
+targeting or nominating. Depending on the change, you may even have to
+create a new series (if your change the major or minor release number), in
+that case go to `Starting a cycle` and follow the instructions from there.
+
 You should also merge (not pull) the release branch into
 ``lp:~bzr/bzr/current``, so that branch contains the current released code
 at any time.
 
+Releases until the final one
+----------------------------
+
+Congratulations - you have made your first release.  Have a beer
+or fruit juice - it's on the house! If it was a beta, or
+candidate, you're not finished yet. Another beta or candidate or
+hopefully a final release is still to come.
+
+The process is the same as for the first release. Goto `Starting the
+release phase`_ and follow the instructions again. Some details change
+between beta, candidate and final releases, but they should be
+documented. If the instructions aren't clear enough, please fix them.
+
 
 See also
 --------

=== modified file 'doc/developers/repository-stream.txt'
--- doc/developers/repository-stream.txt	2008-04-16 04:07:40 +0000
+++ doc/developers/repository-stream.txt	2009-12-02 20:34:07 +0000
@@ -158,7 +158,7 @@
 record. Each item that the iterator yields is a factory which has metadata
 about the entry and the ability to return the compressed bytes. This
 factory can be decorated to allow obtaining different representations (for
-example from a compressed knit fulltext to a plain fulltext). 
+example from a compressed knit fulltext to a plain fulltext).
 
 In pseudocode::
 

=== modified file 'doc/developers/repository.txt'
--- doc/developers/repository.txt	2008-03-19 09:41:24 +0000
+++ doc/developers/repository.txt	2009-12-02 20:34:07 +0000
@@ -44,7 +44,7 @@
                     introduced by a set of revisions in some cheap form, insert
                     data from a stream, validate data during insertion.
 Garbage Collection  Exclusive lock the repository preventing readers.
-Revert              Delta from working tree to historical tree, and then 
+Revert              Delta from working tree to historical tree, and then
                     arbitrary file access to obtain the texts of differing
                     files.
 Uncommit            Revision graph access.
@@ -98,7 +98,7 @@
                      Scan the inventory data introduced during the selected
                      revisions, and grab the on disk data for the found
                      file texts, annotation region data, per-file-graph
-                     data, piling all this into a stream. 
+                     data, piling all this into a stream.
 Garbage Collection   Basically a mass fetch of all the revisions which
                      branches point at, then a bait and switch with the old
                      repository thus removing unreferenced data.
@@ -106,14 +106,14 @@
                      to, inventory extraction of that revision,
                      dirblock-order file text extract for files that were
                      different.
-Uncommit             Revision graph access to synthesise pending-merges 
+Uncommit             Revision graph access to synthesise pending-merges
                      linear access down left-hand-side, with is_ancestor
                      checks between all the found non-left-hand-side
                      parents.
 Status               Lookup the revisions added by pending merges and their
                      commit messages. Then an inventory difference between
                      the trees involved, which may include a working tree.
-                     If there is a working tree involved then the file 
+                     If there is a working tree involved then the file
                      fingerprint for cache-misses on files will be needed.
                      Note that dirstate caches most of this making
                      repository performance largely irrelevant: but if it
@@ -256,7 +256,7 @@
 delta-compressed ever. Likewise signatures do not need the parent pointers
 at all as there is no 'signature graph'.
 
-Data 
+Data
 ----
 
 Moving to pack based repositories
@@ -273,7 +273,7 @@
 hashing the full file. OTOH hashing the full file is a cheap way to detect
 bit-errors in transfer (such as windows corruption). Non-reused file names
 are required for data integrity, as clients having read an index will
-readv at arbitrary times later. 
+readv at arbitrary times later.
 
 Discovery of files
 ~~~~~~~~~~~~~~~~~~
@@ -304,7 +304,7 @@
 ============================
 
 Repositories try to provide a consistent view of the data within them
-within a 'lock context'. 
+within a 'lock context'.
 
 Locks
 -----
@@ -318,7 +318,7 @@
 write lock, and allow write_groups to be acquired. For some repositories
 the presence of a write lock is exclusive to a single client, for others
 which are lock free or use server side locks (e.g.  svn), the write lock
-simply provides the cache context. 
+simply provides the cache context.
 
 Write Groups
 ------------

=== modified file 'doc/developers/revert.txt'
--- doc/developers/revert.txt	2007-06-05 08:02:04 +0000
+++ doc/developers/revert.txt	2009-12-02 20:34:07 +0000
@@ -21,6 +21,6 @@
  1. Use the hash tree data to tune the work done in finding matching paths/ids which are different in the two trees.
 
 For each thing that needs to change - group by target directory?
- 
+
  1. Extract new content.
  1. Backup old content or replace-in-place (except windows where we move and replace).

=== modified file 'doc/developers/specifications.txt'
--- doc/developers/specifications.txt	2009-09-07 07:44:36 +0000
+++ doc/developers/specifications.txt	2009-12-02 20:34:07 +0000
@@ -67,7 +67,7 @@
   Contains instructions for those implementing new formats, of course,
   but also for (bleeding-edge) end users of those formats.
 
-* `Knit pack repositories <packrepo.html>`_ |--| KnitPack repositories 
+* `Knit pack repositories <packrepo.html>`_ |--| KnitPack repositories
   (new in Bazaar 0.92).
 
 

=== modified file 'doc/developers/status.txt'
--- doc/developers/status.txt	2007-07-02 07:11:25 +0000
+++ doc/developers/status.txt	2009-12-02 20:34:07 +0000
@@ -54,7 +54,7 @@
    our hash cache from the dirstate allows us to avoid reading the file in the
    common case. There are alternative ways to achieve this - we could record
    a pointer to a revision which contained this fileid with the current content
-   rather than storing the content's hash; but this seems to be a pointless 
+   rather than storing the content's hash; but this seems to be a pointless
    double-indirection unless we save enough storage in the working tree. A
    variation of this is to not record an explicit pointer but instead
    define an implicit pointer as being to the left-hand-parent tree.
@@ -92,7 +92,7 @@
   difference for the top level of the selected path) then we can gain a
   larger win. This strongly suggests that path expansion and tree
   difference generation should be linked in terms of API.
- 
+
 
 
 ..

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2009-09-18 08:55:12 +0000
+++ doc/developers/testing.txt	2009-12-23 05:04:12 +0000
@@ -154,7 +154,7 @@
     cmd_object.run() method directly. This is a lot faster than
     subprocesses and generates the same logging output as running it in a
     subprocess (which invoking the method directly does not).
- 
+
  3. Only test the one command in a single test script. Use the bzrlib
     library when setting up tests and when evaluating the side-effects of
     the command. We do this so that the library api has continual pressure
@@ -173,15 +173,21 @@
 
 Per-implementation tests are tests that are defined once and then run
 against multiple implementations of an interface.  For example,
-``test_transport_implementations.py`` defines tests that all Transport
-implementations (local filesystem, HTTP, and so on) must pass.
-
-They are found in ``bzrlib/tests/*_implementations/test_*.py``,
-``bzrlib/tests/per_*/*.py``, and
-``bzrlib/tests/test_*_implementations.py``.
+``per_transport.py`` defines tests that all Transport implementations
+(local filesystem, HTTP, and so on) must pass. They are found in
+``bzrlib/tests/per_*/*.py``, and ``bzrlib/tests/per_*.py``.
 
 These are really a sub-category of unit tests, but an important one.
 
+Along the same lines are tests for extension modules. We generally have
+both a pure-python and a compiled implementation for each module. As such,
+we want to run the same tests against both implementations. These can
+generally be found in ``bzrlib/tests/*__*.py`` since extension modules are
+usually prefixed with an underscore. Since there are only two
+implementations, we have a helper function
+``bzrlib.tests.permute_for_extension``, which can simplify the
+``load_tests`` implementation.
+
 
 Doctests
 ~~~~~~~~
@@ -198,7 +204,7 @@
 
 
 Shell-like tests
-~~~~~~~~~~~~~~~~
+----------------
 
 ``bzrlib/tests/script.py`` allows users to write tests in a syntax very close to a shell session,
 using a restricted and limited set of commands that should be enough to mimic
@@ -225,10 +231,10 @@
 the line.
 
 The execution stops as soon as an expected output or an expected error is not
-matched. 
+matched.
 
 When no output is specified, any ouput from the command is accepted
-and execution continue. 
+and execution continue.
 
 If an error occurs and no expected error is specified, the execution stops.
 
@@ -287,6 +293,24 @@
 
   $ cat file
 
+The actual use of ScriptRunner within a TestCase looks something like
+this::
+
+        def test_unshelve_keep(self):
+                # some setup here
+                sr = ScriptRunner()
+                sr.run_script(self, '''
+        $ bzr add file
+        $ bzr shelve --all -m Foo
+        $ bzr shelve --list
+        1: Foo
+        $ bzr unshelve --keep
+        $ bzr shelve --list
+        1: Foo
+        $ cat file
+        contents of file
+        ''')
+
 
 
 .. Effort tests
@@ -343,7 +367,7 @@
         The test exists but is known to fail, for example this might be
         appropriate to raise if you've committed a test for a bug but not
         the fix for it, or if something works on Unix but not on Windows.
-        
+
         Raising this allows you to distinguish these failures from the
         ones that are not expected to fail.  If the test would fail
         because of something we don't expect or intend to fix,
@@ -353,6 +377,21 @@
         KnownFailure should be used with care as we don't want a
         proliferation of quietly broken tests.
 
+ModuleAvailableFeature
+        A helper for handling running tests based on whether a python
+        module is available. This can handle 3rd-party dependencies (is
+        ``paramiko`` available?) as well as stdlib (``termios``) or
+        extension modules (``bzrlib._groupcompress_pyx``). You create a
+        new feature instance with::
+
+            MyModuleFeature = ModuleAvailableFeature('bzrlib.something')
+
+            ...
+            def test_something(self):
+                self.requireFeature(MyModuleFeature)
+                something = MyModuleFeature.module
+
+
 We plan to support three modes for running the test suite to control the
 interpretation of these results.  Strict mode is for use in situations
 like merges to the mainline and releases where we want to make sure that
@@ -369,7 +408,7 @@
 UnavailableFeature      fail    pass    pass
 KnownFailure            fail    pass    pass
 ======================= ======= ======= ========
-     
+
 
 Test feature dependencies
 -------------------------
@@ -416,13 +455,13 @@
 ``_probe`` and ``feature_name`` methods.  For example::
 
     class _SymlinkFeature(Feature):
-    
+
         def _probe(self):
             return osutils.has_symlinks()
-    
+
         def feature_name(self):
             return 'symlinks'
-    
+
     SymlinkFeature = _SymlinkFeature()
 
 

=== modified file 'doc/developers/tortoise-strategy.txt'
--- doc/developers/tortoise-strategy.txt	2008-05-21 06:33:35 +0000
+++ doc/developers/tortoise-strategy.txt	2009-12-02 20:34:07 +0000
@@ -42,15 +42,15 @@
 exist in a separate process - DLLs are the only option, and they are loaded
 into other processes which take advantage of the Windows shell (although
 obviously this DLL is free to do whatever it likes).
- 
+
 For the sake of this discussion, there are 2 categories of shell extensions:
- 
+
 * Ones that create a new "namespace". The file-system itself is an example of
   such a namespace, as is the "Recycle Bin". For a user-created example,
   picture a new tree under "My Computer" which allows you to browse a remote
   server - it creates a new, stand-alone tree that doesn't really interact
   with the existing namespaces.
- 
+
 * Ones that enhance existing namespaces, including the filesystem. An example
   would be an extension which uses Icon Overlays to modify how existing files
   on disk are displayed or add items to their context menu, for example.
@@ -71,7 +71,7 @@
 this illustration is contrived - the code from these DLLs are already in
 memory and there is no reason to suggest TSVN adds any other unreasonable
 burden - but the general point remains valid.)
- 
+
 This has wide-ranging implications. It means that such shell extensions
 should be developed using a tool which can never cause conflict with
 arbitrary processes. For this very reason, MS recommend against using .NET
@@ -113,7 +113,7 @@
 commands. The command-line to the app has even been documented for people who
 wish to automate tasks using that GUI. This GUI is also implemented in C++
 using Windows resource files.
- 
+
 TortoiseSvn has an option (enabled by default) which enabled a cache using a
 separate process, aptly named TSVNCache.exe. It uses a named pipe to accept
 connections from other processes for various operations. When enabled, TSVN
@@ -149,11 +149,11 @@
 application using the shell. The GUI in the external application is written
 in PyGTK, which may not offer the best Windows "look and feel", but that
 discussion is beyond the scope of this document.
- 
+
 It has a better story for logging and debugging for the developer - but not
 for diagnosing issues in the field - although again, much of the heavy
 lifting remains done by the external application.
- 
+
 It uses a rudimentary in-memory cache for the status of files and
 directories, the implementation of which isn't really suitable (ie, no
 theoretical upper bound on cache size), and also means that there is no
@@ -261,7 +261,7 @@
 We will also allow all of the above to be disabled via user preferences.
 Thus, Icon Overlays could be disabled if it did cause a problem for some
 people, for example.
- 
+
 RPC options
 ~~~~~~~~~~~
 
@@ -433,7 +433,7 @@
   version. We will fork the current TSVN sources, including its new
   support for sharing icon overlays (although advice on how to setup this
   fork is needed!)
- 
+
 * Implement property pages and context menus in C++. Expand RPC server as
   necessary.
 

=== modified file 'doc/developers/update.txt'
--- doc/developers/update.txt	2007-09-03 02:37:35 +0000
+++ doc/developers/update.txt	2009-12-02 20:34:07 +0000
@@ -1,7 +1,7 @@
 "bzr update" performance analysis
 =================================
 
-There are 5 different slightly different situations in which bzr update 
+There are 5 different slightly different situations in which bzr update
 can be used:
 
 * local only (no-op)
@@ -27,7 +27,7 @@
 
 potential issue w/ serialized is having 50k files in limbo/
 
-the limbo/ directory could be avoided in some cases, for example when 
+the limbo/ directory could be avoided in some cases, for example when
 adding new files in new directories.
 
 modifying in place: reduces fragmentation of fs, not atomic
@@ -36,9 +36,9 @@
 
 "local mod" is diff between disk and last commit, not merge base
 
-Detecting name conflicts should be O(siblings). Alternatively, conflicts 
-with existing files can be detected using stat() and conflicts with new files 
-can be detected by examining the pending transform. This changes 
+Detecting name conflicts should be O(siblings). Alternatively, conflicts
+with existing files can be detected using stat() and conflicts with new files
+can be detected by examining the pending transform. This changes
 complexity to O(changes).
 
 out of date heavyweight checkout, out of date w/master

=== added file 'doc/developers/win32_build_setup.txt'
--- doc/developers/win32_build_setup.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/win32_build_setup.txt	2009-12-18 16:13:54 +0000
@@ -0,0 +1,213 @@
+===============================
+Setting Up A Windows Build Host
+===============================
+
+This document describes the steps taken to set up a Windows build host. It is
+intended to be step-by-step instructions of what packages need to be installed,
+where they can be gotten from, and how they are configured.
+
+
+Baseline
+========
+
+This was written as a step-by-step as I set up the Amazon EC2 'desolation'
+instance. This was based on an Amazon Windows 2003 instance. Also note that for
+Amazon EC2, all programs were installed into the "C:" drive, as the "D:" drive
+is essentially ``/tmp`` and is not preserved between launched instances.
+
+
+Install Packages
+================
+
+1) Download cygwin's setup.exe from http://www.cygwin.com
+   At present the current version is 1.5.25-15. This is used primarily to
+   install the build scripts and gcc-mingw. Note that we explicitly *don't*
+   install cygwin's python or bzr package. As we are only interested in
+   running the native version of bzr. For information on running the cygwin
+   port of bzr, look elsewhere.
+
+   Probably not all of these packages are necessary, but they make life easier.
+
+   a) gcc-mingw32
+   b) make
+   c) openssh
+   d) rsync
+   e) vim
+   f) wget
+   g) zip
+   h) unzip
+   i) patch
+
+
+2) Download the supported versions of python from http://www.python.org
+
+   a) python 2.6.4
+   b) python 2.5.4 http://www.python.org/ftp/python/2.5.4/python-2.5.4.msi
+   c) python 2.4.4 (there is no Windows installer for 2.4.5 or 2.4.6)
+      http://www.python.org/ftp/python/2.4.4/python-2.4.4.msi
+
+   Note that for Amazon EC2, all of these were installed int
+
+3) Configure 'distutils' for the compiler that you will be using. For python
+   2.4 and 2.5 we use gcc-mingw32, for 2.6 we use Visual Studio 2008.
+
+   Edit ``D:\Python25\Lib\disutils\distutils.cfg`` (you have to create the
+   file). You want to add a section like::
+
+     [build]
+     compiler = mingw32
+
+   This also requires 'fixing' the cygwin gcc installation so that distutils
+   can find it. Specifically, it knows to look for ``gcc.exe`` however, the
+   latest versions of cygwin start using "alternatives" and making ``gcc`` just
+   a symlink.
+
+   You also need to add ``C:\cygwin\bin`` and ``C:\cygwin\lib`` into your
+   environment path. This is generally done with::
+
+        Right Click My Computer / Properties / Advanced / Environment Variables
+        System Variables / Select 'PATH' / Edit
+
+4) Download important python libraries. At the moment, the official Windows
+   all-in-one installer is built using python 2.5. We will likely soon switch
+   to python 2.6.
+
+   a) http://pypi.python.org/pypi/setuptools
+
+      Installing this first should make it easier to install some of the other
+      tools. To install something using easy install, it is generally best to
+      open up a ``cmd.exe`` shell (*not* a cygwin shell) and do::
+
+        cd C:\Python25
+        python.exe Scripts\easy_install-script.py -Z -O1 PACKAGE
+
+      The '-Z' tells it to install as a regular directory. This generally works
+      better with py2exe.
+
+   b) pywin32 http://sourceforge.net/projects/pywin32/files/
+   c) easy_install paramiko
+      This will also bring in PyCrypto and compile it, so it is important to
+      have configured step (3) correctly.
+   d) easy_install Pyrex    (or Cython)
+      Note, you should probably install pyrex for all versions of python. All
+      of them need to run 'setup.py bdist_wininst' and so it is good to have it
+      build automatically, rather than setting up an explicit build order based
+      on which one has pyrex.
+   e) easy_install cogapp
+   f) install py2exe (easy_install failed)
+      http://sourceforge.net/projects/py2exe/files/
+   g) easy_install docutils
+   h) Install PyQt
+      http://www.riverbankcomputing.co.uk/software/pyqt/download
+
+      Currently they only seem to offer PyQt 4.4.3 for python 2.5 and PyQt
+      4.6.1 for python 2.6. They generally don't make it easy to install old
+      versions of PyQt.
+   i) Install pyreadline
+      https://launchpad.net/pyreadline/+download
+   j) easy_install pygments
+   k) Patch pycrypto, so that it supports older Windows installs. (see bugs
+      #248522, #272791, #497733). The direct link to the patch is:
+      http://launchpadlibrarian.net/16133025/win32_clock.patch
+      This may not end up necessary w/ pycrypto 2.1, especially if paramiko can
+      be taught to use the new functionality (avoiding the warning).
+
+5) Get Pageant, not strictly necessary, but it is a pretty good ssh-agent for
+   Windows, and paramiko knows how to use keys from Pageant.
+
+   http://www.chiark.greenend.org.uk/~sgtatham/putty/download.html
+
+   Note that you probably want to set the environment variable
+   ``BZR_SSH=paramiko`` at this time. Otherwise it will try to use the
+   ``ssh.exe`` that it finds on your PATH (as configured in step 3), and
+   cygwin's openssh does *not* know how to access Pageant.
+
+   I usually get the 'all-in-one' installer, but only because it is easier. You
+   only really need ``pageant.exe`` and possibly ``puttygen.exe``.
+
+   If you do this, you'll probably also want to install a shortcut to
+   ``pageant.exe`` in Start / Programs / Startup so that it always starts when
+   you log in (though you still have to manually add your ssh keys.)
+
+   Note that on the Amazon EC2 machine, I'm having problems with temp files
+   being created without the permission for the current user to actually read
+   them. They seem to be owned by ``Administrator`` rather than by
+   ``Administrators``.
+
+6) Install bzr. Usually it is easiest to just get the latest all-in-one
+   installer from https://launchpad.net/bzr/+download
+
+7) Install INNOSetup from:
+   http://www.jrsoftware.org/isdl.php
+
+   After installing, you'll want to add ``C:\Program Files\Inno Setup 5`` to
+   your PATH.
+
+8) Fix distutils for the specific version of gcc. Distutils in python2.4.4 has
+   a bug where it assumes version strings have only 3 digits. The fix is to
+   just change one '?' in the regex into a '*'::
+
+        --- version.py	2009-11-05 14:41:47.497212900 -0800
+        +++ version.py	2009-11-05 14:39:57.684712900 -0800
+        @@ -97,7 +97,7 @@
+             in the distutils documentation.
+             """
+
+        -    version_re = re.compile(r'^(\d+) \. (\d+) (\. (\d+))? ([ab](\d+))?$',
+        +    version_re = re.compile(r'^(\d+) \. (\d+) (\. (\d+))* ([ab](\d+))?$',
+                                     re.VERBOSE)
+
+
+9) If you want to build in the source tree, you need the zlib dll and
+   associated libraries, put somewhere on your path. The buildout routines grab
+   this directly and add it to the build path, but that doesn't work for
+   ``setup.py``.
+   http://www.zlib.net/zlib123-dll.zip
+
+   I usually download and extract this to something like ``C:\local\`` so that
+   I end up with a ``C:\local\lib`` and ``C:\local\include`` directory. I then
+   modify the ``distutils.cfg`` file to tell the compiler where to find these
+   headers and libraries::
+
+      [build_ext]
+      include-dirs = C:/local/include
+      library-dirs = C:/local/lib
+
+   Note that you'll probably want to put the ``zlib1.dll`` into your path. You
+   can:
+
+     1) Add ``C:\local`` to your PATH variable in
+        "My Computer/Properties/Advanced/Environment Variables"
+     2) More logically, move ``zlib1.dll`` to either 'lib' or 'bin'
+        subdirectories and add that.
+     3) Copy it to ``C:\Windows\``.
+
+   I recommend 3, mostly because lots of apps will want to use zlib1.dll in the
+   long run. (You may already have it.)
+
+10) Install Visual Studio 2008 Professional
+    http://www.microsoft.com/downloads/details.aspx?FamilyId=83C3A1EC-ED72-4A79-8961-25635DB0192B&displaylang=en
+
+    This is a 3GB DVD iso image. You can mount it directly with Microsofts
+    iso mounting utility:
+    http://download.microsoft.com/download/7/b/6/7b6abd84-7841-4978-96f5-bd58df02efa2/winxpvirtualcdcontrolpanel_21.exe
+
+    You need at least Windows XP (which introduced direct iso support, I
+    believe.)
+
+    Note that there is a Service Pack 1 for Visual Studio. The ISO can be
+    downloaded here:
+    http://www.microsoft.com/downloads/thankyou.aspx?familyId=27673c47-b3b5-4c67-bd99-84e525b5ce61&displayLang=en
+
+    However, on EC2, there isn't enough room on C: to actually run the
+    installer. You need approx 6GB of free disk space. And EC2 only gives your
+    10GB and Windows itself takes up about 5GB. So we are currently running
+    stock VS 2008 with no service packs. (Even installing VS 2008 to a
+    different drive doesn't leave enough room on C: to run the upgrader.)
+
+    When installing on EC2, it seems their 2003 Server comes with a Visual
+    Studio key already supplied. There is also the possibility of using Visual
+    Studio Express Edition, but it is currently unable to compile TortoiseBzr.
+
+..
+   vim: ft=rst tw=79 et

=== modified file 'doc/en/_templates/index.html'
--- doc/en/_templates/index.html	2009-09-09 11:43:10 +0000
+++ doc/en/_templates/index.html	2010-01-08 00:27:40 +0000
@@ -26,6 +26,9 @@
       <p class="biglink"><a class="biglink" href="{{ pathto("user-reference/index") }}">User Reference</a><br/>
       <span class="linkdescr">all the gory details</span>
       </p>
+      <p class="biglink"><a class="biglink" href="{{ pathto("admin-guide/index") }}">System Admin Guide</a><br/>
+      <span class="linkdescr">security, backups, etc.</span>
+      </p>
     </td></tr>
   </table>
 
@@ -33,13 +36,17 @@
 
   <table class="contentstable" align="center" style="margin-left: 30px"><tr>
     <td width="50%">
-        <p class="biglink"><a class="biglink" href="https://answers.launchpad.net/bzr">FAQ</a><br/>
+        <p class="biglink"><a class="biglink" href="https://answers.launchpad.net/bzr/+faqs">FAQ</a><br/>
       <span class="linkdescr">frequently asked questions</span>
       </p>
       <p class="biglink"><a class="biglink" href="http://bazaar-vcs.org/BzrGlossary/">Glossary</a><br/>
       <span class="linkdescr">help with terminology</span>
       </p>
-    </td><td width="50%">
+      <p class="biglink"><a class="biglink" href="../developers/">Developer Docs</a><br/>
+        <span class="linkdescr">improving and extending bzr</span>
+      </p>
+    </td>
+    <td width="50%">
       <p class="biglink"><a class="biglink" href="http://doc.bazaar-vcs.org/migration/en/">Migration Docs</a><br/>
       <span class="linkdescr">for refugees of other tools</span>
       </p>
@@ -49,7 +56,4 @@
     </td></tr>
   </table>
 
-  <p>Keen to help? See the <a href="http://doc.bazaar-vcs.org/developers/">Developer Docs</a>
-      for policies and tools on contributing code, tests and documentation.</p>
-
 {% endblock %}

=== modified file 'doc/en/_templates/layout.html'
--- doc/en/_templates/layout.html	2009-09-03 00:21:59 +0000
+++ doc/en/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -6,3 +6,22 @@
 <a href="http://doc.bazaar-vcs.org/en/">Documentation</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
+{{ super() }}
+{% endblock %}

=== added file 'doc/en/admin-guide/advanced.txt'
--- doc/en/admin-guide/advanced.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/advanced.txt	2009-12-22 05:22:53 +0000
@@ -0,0 +1,164 @@
+Advanced Topics
+===============
+
+System Monitoring
+-----------------
+
+Capacity Planning Tips
+----------------------
+
+Clustering
+----------
+
+Multi-site Setups
+-----------------
+
+The "distributed" in distributed version control system should indicate that
+Bazaar is  well suited for multi-site development situations and indeed, that
+is the case.  The advantage comes from the ease and transparency of managing
+merges between branches with divergent history.  Note that there are many,
+many different ways to manage widely-flung development setups using Bazaar and
+its branching and merging capabilities.  These can be discovered and tested
+before being implemented as policy.  We will describe one such possible setup
+here.
+
+Consider ProjectX Corp's international expansion with a new branch office in
+Darwin, Australia, in addition to the company's headquarters in Austin, Texas,
+USA.  One of the difficulties of a far-flung multi-site development
+environment such as this is that the network connection between Australia and
+Texas is slow and unreliable.  So, each branch office would like the master
+branch to be local to them.  (In situations with good network connectivity, a
+local branch bound to the remote master may be all that is needed to support
+multi-site development.)
+
+Of course, with two master branches, there is always the question of which one
+is authoritative.  Given Bazaar's facility at managing multiple branches, we
+suggest that it is best not to privilege either the Texas or Australia
+branches, but to merge both of them into a separate master branch (which may
+reside at either site).  For definiteness, we will locate the master branch at
+the Texas site.  So, we will have three branches stored on two servers:
+trunk and texas-integration at the Texas site and australia-integration at the
+Darwin site.  These branches are named in terms of the sites where the 
+development takes place, but in many cases it may make more sense to name
+branches after the functional teams rather their geographical locations.
+Since we are trying illustrate the issues with multi-*site* development, we
+will persist in this naming scheme.
+
+Setup
+~~~~~
+
+Using our previous setup at the Texas site, we will simply rename the old
+trunk branch as trunk and branch a copy as texas-integration.
+
+::
+ 
+  $ cd /srv/bzr/projectx
+  $ mv trunk trunk              # can simply rename on the filesystem
+  $ bzr branch trunk texas-integration   # very fast in a shared repository
+
+In Australia, we need to set up the ``/srv/bzr/projectx`` directory and get a
+copy of the current trunk as australia-integration::
+
+  $ mkdir -p /srv/bzr
+  $ cd /srv/bzr
+  $ bzr init-repo --no-trees projectx
+  $ cd projectx
+  $ bzr branch bzr+ssh://server.example.com/srv/bzr/trunk
+  $ bzr branch trunk australia-integration
+
+Merging to master
+~~~~~~~~~~~~~~~~~
+
+Then, each office works with their local copy of the trunk.  At some point,
+sooner or later depending on the pace of development in the two locations, the
+two local trunks need to be merged.  (In general, sooner beats later when
+merging, since there is no penalty for multiple merges.)  In this example,
+Alice at the Texas office will do the merging on her local machine using
+branches on the server::
+
+  # Get a copy of the Australia branch in Texas.  After the initial branch
+  # command, use pull to keep the branch up to date.  With a slow network,
+  # this is the only slow part
+  $ bzr branch bzr+ssh://autralia.example.com/srv/bzr/projectx/australia-integration \
+    bzr+ssh://server.example.com/srv/bzr/projectx/australia-integration
+  
+  # Check out the master branch locally for doing the merge
+  $ cd ~/projectx
+  $ bzr checkout bzr+ssh://server.example.com/srv/bzr/projectx/trunk
+  $ cd trunk
+  $ bzr merge bzr+ssh://server.example.com/srv/bzr/projectx/texas-integration
+  # Run the test suite and resolve any conflicts
+  $ bzr commit -m "Merge Texas branch to master"
+  
+  # Now, merge from Australia using the local copy of that branch
+  $ bzr merge bzr+ssh://server.example.com/srv/bzr/projectx/australia-integration
+  # Run the test suite and resolve any conflicts between the two offices
+  $ bzr commit -m "Merge Australia branch to master"
+
+Note that Bazaar does not commit even cleanly applied merges by default.  This
+is because although a merge may apply cleanly, the merged state still needs to
+be checked before it is committed.  (Just because there are no text conflicts
+does not mean that everything will work after a merge.)  An alternative that 
+can pull when possible and merge otherwise is available with 
+``bzr merge --pull``.
+
+Merging back to local trunks
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Now the trunk branch is the most up-to-date version of the software and
+both of the local trunks need to reincorporate the changes from the master.
+If no new commits have been made to texas-integration, then that can happen using
+``bzr pull``::
+
+  $ cd ~/projectx
+  $ bzr checkout bzr+ssh://server.example.com/srv/bzr/projectx/texas-integration
+  $ cd texas-integration
+  $ bzr pull ../trunk  # Use trunk from the local disk
+                              # No need to commit
+
+If new changes have happened on texas-integration since the integration with
+trunk, then the above pull will produce an error suggesting to use
+merge::
+
+  $ bzr merge ../trunk
+  # Run test suite, resolve conflicts
+  $ bzr commit -m "Merging Australian changes"
+
+In Australia, they will need to update their local copy of trunk::
+
+  $ cd /srv/bzr/projectx/trunk
+  $ bzr pull     # parent location is used by default
+
+Then, they need to pull or merge the changes from trunk into the local trunk.
+This should be done by a developer with a checkout of australia-integration so
+that they can run the test suite::
+
+  $ cd ~/projectx
+  $ bzr co bzr+ssh://australia.example.com/srv/bzr/projectx/australia-integration
+  $ cd australia-integration
+  $ bzr merge bzr+ssh://australia.example.com/srv/bzr/projectx/trunk
+  # Run test suite and integrate Texan changes with only recent local
+  # development
+  $ bzr commit -m "Integrate work from Texas"
+
+
+Other Considerations
+~~~~~~~~~~~~~~~~~~~~
+
+Multi-site deployments can be complicated, due to the many possible variations
+of development velocity, divisions of labor, network connectivity, resources
+for integration, etc.  The preceding description is meant to be one possible
+way to do fairly symmetric multi-site development.  (Neither Texas or
+Australia is privileged in this structure.)  In a situation where there is one
+main site and other smaller sites, one of the local trunk branches can be
+eliminated and trunk can be used directly for development at the main
+site.
+
+It is also up to the particular situation how frequently the local trunks are
+integrated into the master trunk.  Given resources specifically for
+integration, it is conceivable that a developer may be constantly responsible
+for integrating changes from the two teams.  Alternatively, the two sites
+could work on well-separated, well-defined features and merge to the master
+trunk only when their respective features are complete.  Given the difficulty
+of resolving conflicts in very large merges and the ease of merge handling in
+Bazaar, we suggest that merges be done more frequently, rather than less.

=== added file 'doc/en/admin-guide/backup.txt'
--- doc/en/admin-guide/backup.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/backup.txt	2009-12-16 02:03:31 +0000
@@ -0,0 +1,204 @@
+Back-up and Restore
+===================
+
+Backing up Bazaar branches can be done in two different ways.  If an existing
+filesystem-based backup scheme already exists, then it can easily be used
+where the Bazaar branches reside.  Alternately, Bazaar itself can be used to
+mirror the desired branches to or from another location for backup purposes.
+
+Filesystem Backups
+------------------
+
+Bazaar transactions are atomic in the sense that the disk format is such that
+it is in a valid state at any instant in time.  However, for a backup process
+that takes a finite amount of time to complete, it is possible to have
+inconsistencies between different on-disk structures when backing up a live
+branch or repository.  (Bazaar itself manages this concurrency issue by only
+*reading* those structures in a well-defined order.)  Tools such as LVM that
+allow instantaneous snapshots of the contents of a disk can be used to take
+filesystem backups of live Bazaar branches and repositories.
+
+For other backup methods, it is necessary to take the branch or repository
+offline while the backup is being done in order to guarantee consistency
+between the various files that comprise a Bazaar branch's history.  This
+requirement can be alleviated by using Bazaar as its own backup client,
+since it follows an order for reading that is designed to manage concurrent
+access (see the next section for details).  Depending on the different
+access methods that are being used for a branch, there are different ways to
+take the branch "offline".  For ``bzr+ssh://`` access, it is possible to
+temporarily change the filesystem permissions to prevent write access from
+any users.  For ``http://`` access, changing permissions, shutting down
+the HTTP server or switching the server to a separate configuration that
+disallows access are all possible ways to take a branch offline for backup.  
+Finally, for direct filesystem access, it is necessary to make the branch
+directories un-writable.
+
+Because this sort of downtime can be very disruptive, we strongly encourage
+using Bazaar itself as a backup client, where branches are copied and
+updated using Bazaar directly.
+
+
+Bazaar as its own backup
+------------------------
+
+The features that make Bazaar a good distributed version control system also
+make it a good choice for backing itself up.  In particular, complete and
+consistent copies of any branch can easily be obtained with the ``branch`` and
+``pull`` commands.  As a result, a backup process can simply run ``bzr pull``
+on a copy of the main branch to fully update that copy.  If this backup
+process runs periodically, then the backups will be as current as the last
+time that ``pull`` was run.  (This is in addition to the fact
+that revisions are immutable in Bazaar so that a prior revision of a branch is
+always recoverable from that branch when the revision id is known.)
+
+As an example, consider a separate backup server that stores backups in
+``/var/backup``.  On that server, we could initially run
+
+::
+
+  $ cd /var/backup
+  $ bzr branch bzr+ssh://server.example.com/srv/bzr/trunk
+  $ bzr branch bzr+ssh://server.example.com/srv/bzr/feature-gui
+
+to create the branches on the backup server.  Then, we could regularly (for
+example from ``cron``) do
+
+::
+
+  $ cd /var/backup/trunk
+  $ bzr pull  # the location to pull from is remembered
+  $ cd ../var/backup/feature-gui
+  $ bzr pull  # again, the parent location is remembered
+
+The action of pulling from the parent for all branches in some directory is
+common enough that there is a plugin to do it.  The `bzrtools`_ plugin
+contains a ``multi-pull`` command that does a ``pull`` in all branches under a
+specified directory.
+
+.. _bzrtools: http://launchpad.net/bzrtools
+
+With this plugin installed, the above periodically run commands would be
+
+::
+
+  $ cd /var/backup
+  $ bzr multi-pull
+
+Note that ``multi-pull`` does a pull in *every* branch in the specified
+directory (the current directory by default) and care should be taken that
+this is the desired effect.  A simple script could also substitute for the
+multi-pull command while also offering greater flexibility.
+
+Bound Branch Backups
+~~~~~~~~~~~~~~~~~~~~
+
+When ``bzr pull`` is run regularly to keep a backup copy up to date, then it
+is possible that there are new revisions in the original branch that have not
+yet been pulled into the backup branch.  To alleviate this problem, we can set
+the branches up so that new revisions are *pushed* to the backup rather than
+periodically pulling.  One way to do this is using Bazaar's concept of bound
+branches, where a commit in one branch happens only when the same commit
+succeeds in the branch to which it is `bound`.  As a push-type technology, it
+is set up on the server itself rather than on the backup machine.  For each
+branch that should be backed up, you just need to use the ``bind`` command to
+set the URL for the backup branch.  In our example, we first need to create
+the branches on the backup server (we'll use ``bzr push``, but we could as
+easily have used ``bzr branch`` from the backup server)
+
+::
+
+  $ cd /srv/bzr/projectx/trunk
+  $ bzr push bzr+ssh://backup.example.com/var/backup/trunk
+  $ cd ../feature-gui
+  $ bzr push bzr+ssh://backup.example.com/var/backup/feature-gui
+
+and then we need to bind the main branches to their backups
+
+::
+
+  $ cd ../trunk
+  $ bzr bind bzr+ssh://backup.example.com/var/backup/trunk
+  $ cd ../feature-gui
+  $ bzr bind bzr+ssh://backup.example.com/var/backup/feature-gui
+
+A branch can only be bound to a single location, so multiple backups cannot
+be created using this method.  
+
+Using the `automirror`_ plugin mentioned under `Hooks and Plugins <hooks-plugins.html>`_, one can
+also make a push-type backup system that more naturally handles mutliple
+backups.  Simply set the ``post_commit_mirror`` option to multiple URLs
+separated by commas.  In order to backup to the backup server and a 
+remote location, one could do
+
+::
+
+  $ cd /srv/bzr/trunk
+  $ echo "post_commit_mirror=bzr+ssh://backup.example.com/var/backup/trunk,\
+  bzr+ssh://offsite.example.org/projectx-corp/backup/trunk" >> .bzr/branch/branch.conf
+  $ cd ../feature-gui
+  $ echo "post_commit_mirror=bzr+ssh://backup.example.com/var/backup/feature-gui,\
+  bzr+ssh://offsite.example.org/projectx-corp/backup/feature-gui" >> .bzr/branch/branch.conf
+
+.. _automirror: http://launchpad.net/bzr-automirror
+
+As for any push-type backup strategy that maintains consistency, the downside
+of this method is that all of the backup commits must succeed before the
+initial commit can succeed.  If there is a many mirror branches or if the bound
+branch has a slow network connection, then the delay in the original commit may
+be unacceptably long.  In this case, pull-type backups, or a mixed system may
+be preferable.
+
+
+Restoring from Backups
+----------------------
+
+Checking backup consistency
+~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Many a system administrator has been bitten by having a backup process,
+but when it came time to restore from backups, finding out that the backups
+themselves were flawed.  As such, it is important to check the quality of the
+backups periodically.  In Bazaar, there are two ways to do this: using the
+``bzr check`` command and by simply making a new branch from the backup.  The
+``bzr check`` command goes through all of the revisions in a branch and checks
+them for validity according to Bazaar's internal invariants.  Since it goes
+through every revision, it can be quite slow for large branches.  The other
+way to ensure that the backups can be restored from is to perform a test
+restoration.  This means performing the restoration process in a temporary
+directory.  After the restoration process, ``bzr check`` may again be relevant
+for testing the validity of the restored branches.  The following two sections
+present two restoration recipes.
+
+Restoring Filesystem Backups
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+There are many different backup tools with different ways of accessing the
+backup data, so we can't cover them all here.  What we will say is that
+restoring the contents of the ``/srv/bzr`` directory completely will restore
+all branches stored there to their state at the time of the backup (see
+`Filesystem Backups`_ for concerns on backing up live branches.)  For
+example, if the backups were mounted at ``/mnt/backup/bzr`` then we could
+restore using simply::
+ 
+  $ cd /srv
+  $ mv bzr bzr.old
+  $ cp -r /mnt/backup/bzr bzr
+
+Of course, to restore only a single branch from backup, it is sufficient to
+copy only that branch.  Until the restored backup has been successfully used
+in practice, we recommend keeping the original directory available.
+
+Restoring Bazaar-based Backups
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+In order to restore from backup branches, we can simply branch them into the
+appropriate location::
+
+  $ cd /srv
+  $ mv bzr bzr.old
+  $ cd bzr
+  $ bzr branch bzr+ssh://backup.example.com/var/backup/trunk
+  $ bzr branch bzr+ssh://backup.example.com/var/backup/feature-gui
+
+If there are multiple backups, then change the URL above to restore from the
+other backups.  

=== added file 'doc/en/admin-guide/code-browsing.txt'
--- doc/en/admin-guide/code-browsing.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/code-browsing.txt	2009-12-11 00:00:04 +0000
@@ -0,0 +1,128 @@
+Web-based code browsing
+=======================
+
+Browsing the history of a project online is an important part of version
+control, since it allows people to easily see what happens in a branch
+without having to have a local, up-to-date copy of that branch.  There are a
+number of possible choices for browsing Bazaar branches on the web, but we
+will cover one of them in particular detail and briefly mention the other
+choices where they differ.
+
+Loggerhead
+----------
+
+Loggerhead_ is a code browsing interface for Bazaar branches (now used in
+Launchpad).  To see an example of Loggerhead in action, browse to
+http://bazaar.launchpad.net/~bzr-pqm/bzr/bzr.dev/files which is the loggerhead
+view of Bazaar's trunk branch.  Loggerhead runs as a web application on the
+server which is accessed over HTTP via a RESTful interface.  It is possible to
+run this application on its own dedicated port as
+``http://www.example.com:8080`` or to proxy this location behind a separate web
+server, for example at ``http://www.example.com/loggerhead/``.  We will discuss
+both of these configurations below.
+
+.. _Loggerhead: http://launchpad.net/loggerhead
+
+Requirements
+~~~~~~~~~~~~
+
+Loggerhead depends on a number of other Python packages for the various Web
+technologies that it builds on.  Some of these must be installed to use
+loggerhead, although some of them are optional.  From the loggerhead `README`
+file, these are
+
+1) SimpleTAL for templating.
+   On Ubuntu, `sudo apt-get install python-simpletal`
+   or download from http://www.owlfish.com/software/simpleTAL/download.html
+2) simplejson for producing JSON data.
+   On Ubuntu, `sudo apt-get install python-simplejson`
+   or use `easy_install simplejson`.
+3) Paste for the server. (You need version 1.2 or newer of Paste.)
+   On Ubuntu, `sudo apt-get install python-paste`
+   or use `easy_install Paste`
+4) Paste Deploy  (optional, needed when proxying through Apache)
+   On Ubuntu, `sudo apt-get install python-pastedeploy`
+   or use `easy_install PasteDeploy`
+5) flup (optional, needed to use FastCGI, SCGI or AJP)
+   On Ubuntu, `sudo apt-get install python-flup`
+   or use `easy_install flup`
+
+Although directions for installing these on Ubuntu Linux are given, most other
+Linux distributions should package these dependencies, making installation
+easy.  For Windows and Mac OS X, they should all be ``easy_install``-able or at
+worst installable from the Python sources.
+
+Built-in Web Server
+~~~~~~~~~~~~~~~~~~~
+
+Loggerhead has a built-in web server and when started with the
+``serve-branches`` command, that web server is started on a default port
+listening on the localhost.  If port 8080 (the default) is accessible on
+``www.example.com``, then running
+
+::
+
+  $ serve-branches --host=www.example.com --port=8080 /srv/bzr
+
+will list all of the available branches under that directory on
+``http://www.example.com:8080/``, so that the ProjectX trunk could be browsed
+at ``http://www.example.com:8080/projectx/trunk``.  Note that loggerhead
+provides HTTP access to the underlying Bazaar branches (similar to that
+described in `Smart server over HTTP(S)
+<other-setups.html#smart-server-over-http-s>`_), so this command should be run
+as a user without write privileges in ``/srv/bzr``.  By default, loggerhead
+only listens on the localhost, not any external ports, unless specified as
+above.
+
+Behind a Proxy
+~~~~~~~~~~~~~~
+
+A more common and more safe way to run loggerhead is behind another web server
+which will proxy certain requests to the loggerhead server on the localhost.
+To do this, you need to have PasteDeploy installed (see `Requirements`_).
+Assuming that your server has Apache running, you need to add configuration
+such as this to set up the proxy
+
+::
+
+    <Location "/loggerhead/">
+        ProxyPass http://127.0.0.1:8080/
+        ProxyPassReverse http://127.0.0.1:8080/
+    </Location>
+
+If your proxy runs at some path within the server, then the ``serve-branches``
+command must be started with the ``--prefix`` option.  For this example, we
+could start loggerhead with the command
+
+::
+
+  $ serve-branches --prefix=/loggerhead /srv/bzr
+
+This would allow the trunk branch of ProjectX to be browsed at
+``http://www.example.com/loggerhead/projectx/trunk``.
+
+Loggerhead comes with a script allowing it to run as a service on init.d based
+Linux systems.  Contributions to do a similar thing on Windows servers would
+be welcomed at http://launchpad.net/loggerhead.
+  
+
+Other web interfaces
+--------------------
+
+There are a number of other web interfaces available for Bazaar branches (see
+the list at http://bazaar-vcs.org/WebInterfaces) and we will just mention a
+couple of them here for their advantages in particular situations.
+
+trac+bzr (http://launchpad.net/trac-bzr)
+  Trac is a popular web app that integrates a browser for branches, an issue
+  tracker and a wiki.  trac+bzr is a trac extension that allows for the
+  trac to be used with Bazaar.
+
+webbzr (http://thoughts.enseed.com/webbzr)
+  This is a notable solution because it is written in pure PHP for web hosts
+  that don't provide a way to run arbitrary Python applications such as Trac
+  or Loggerhead.
+
+Redmine (http://redmine.org/)
+  Like trac, Redmine is a full project management application using the Ruby
+  on Rails framework.  It includes support for Bazaar branches.

=== added file 'doc/en/admin-guide/hooks-plugins.txt'
--- doc/en/admin-guide/hooks-plugins.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/hooks-plugins.txt	2009-12-11 15:04:15 +0000
@@ -0,0 +1,310 @@
+Extending Bazaar with Hooks and Plugins
+=======================================
+
+Bazaar offers a powerful extension mechanism for adding capabilities.  In
+addition to offering full library API access to all of its structures, which
+can be useful for outside programs that would like to interact with Bazaar
+branches, Bazaar can also load *plugins* that perform specific tasks.  These
+specific tasks are specified by *hooks* that run during certain steps of the
+version control process.  
+
+For full documentation on the available hooks, see ``bzr help hooks``.  Among
+those, some of the most significant hooks from an administration
+standpoint are `pre_commit`, `post_commit` and `post_change_branch_tip`.
+A `pre_commit` hook can inspect a commit before it happens and cancel it if
+some criteria are not met.  This can be useful for enforcing policies about
+the code, such as line-endings or whitespace conventions.  A
+`post_commit` hook can take actions based on the commit that just happened,
+such as providing various types of notifications.  Finally, a
+`post_change_branch_tip` hook is a more general form of a `post_commit`
+hook which is used whenever the tip of a branch changes (which can happen in
+more ways than just committing).  This too can be used for notification
+purposes, as well as for backups and mirroring.
+
+Information on the whole range of Bazaar plugins is available at
+http://doc.bazaar-vcs.org/en/plugin-guide.  For purposes of installation,
+plugins are simply python packages.  They can be installed alongside Bazaar in
+the ``bzrlib.plugins`` package using each plugin's ``setup.py``.  They can
+also be installed in the plugin path which is the user's ``~/.bazaar/plugins``
+directory or can be specified with the ``BZR_PLUGIN_PATH`` environment
+variable.  See ``bzr help configuration`` for more on specifying the location
+of plugins.
+
+
+Email Notification
+------------------
+
+A common need is for every change made on a branch to send an email message to
+some address, most often a mailing list.  These plugins provide that capability
+in a number of different ways.  
+
+The `email` plugin sends email from each individual developer's computer.  This
+can be useful for situations that want to track what each individual developer
+is working on.  On the downside, it requires that every developer's branches be
+configured individually to use the same plugin.  
+
+The next two plugins `hookless-email` and `email-notifier` address this concern
+by running on a central server whenever changes happen on centrally stored
+branches.
+
+email
+~~~~~
+
+To configure this plugin, simply install the plugin and configure the
+``post_commit_to``  option for each branch.  This configuration can be done
+in the ``locations.conf`` file or individually in each branch's
+``branch.conf`` file.  The sender's email address can be specified as
+``post_commit_sender`` if it is different than the email address reported by
+``bzr whoami``.  The ``post_commit_mailer`` option specifies how the
+mail should be sent.  If it isn't set, email is sent via ``/usr/bin/mail``.
+It can also be configured to communicate directly with an SMTP server.
+For more details on configuring this plugin, see
+http://doc.bazaar-vcs.org/plugins/en/email-plugin.html.  As examples, consider
+the following two possible configurations.  A minimal one (uses
+``/usr/bin/mail``)
+
+::
+
+  [DEFAULT]
+  post_commit_to = projectx-commits@example.com
+
+and a more complicated one (using all of the options)
+
+::
+
+  [DEFAULT]
+  post_commit_url = http://www.example.com/code/projectx/trunk
+  post_commit_to = projectx-commits@example.com
+  post_commit_sender = donotreply@example.com
+  post_commit_mailer = smtplib
+  smtp_server = mail.example.com:587
+  smtp_username = bob
+  # smtp_password = 'not specified, will prompt'
+
+
+hookless-email
+~~~~~~~~~~~~~~
+
+This plugin is basically a server-side version of the `email` plugin.  It is
+a program that runs either from the command line or as a daemon that monitors
+the branches specified on the command line for any changes.  When a change
+occurs to any of the monitored branches, it will send an email to the
+specified address.  Using our simple example, the following command would send
+an email to ``projectx-commits@example.com`` on any of the branches under
+``/srv/bzr`` since the last time the command was run.  (This command could be
+set up to run at regular intervals, for example from ``cron``.)
+
+::
+
+  $ bzr_hookless_email.py --email=projectx-commits@example.com \
+  --recurse /srv/bzr
+
+email-notifier
+~~~~~~~~~~~~~~
+
+This is a more elaborate version of the `hookless-email` plugin that can send
+templated HTML emails, render wiki-style markup in commit messages and update
+working copies on the server (similar to `push_and_update`_).  It can also
+send emails reporting the creation of new branches or the removal of branches
+under a specified directory (here ``/srv/bzr/projectx``).  As it is more
+complicated, its configuration is also more complicated and we won't repeat
+its documentation here, but a simple configuration that will send emails on
+commits and creation/deletion of branches is
+
+::
+
+  [smtp]
+
+  server=smtp.example.com
+  # If user is not provided then no authentication will be performed.
+  user=bob
+  password=pAssW0rd
+
+  [commits]
+
+  # The address to send commit emails to. 
+  to=projctx-commits@example.com
+  from=$revision.committer
+
+  # A Cheetah template used to construct the subject of the email message.
+  subject=$relative_path: $revision_number $summary
+
+  [new-branches]
+  to=projectx-commits@example.com
+  from=donotreply@example.com
+  subject=$relative_path: New branch created
+
+  [removed-branches]
+  to=projectx-commits@example.com
+  from=donotreply@example.com
+  subject=$relative_path: Branch removed
+
+If this file is stored as ``/srv/bzr/email-notifier.conf``, then the command
+
+::
+ 
+  $ bzr-email-notifier.py --config=/srv/bzr/email-notifier.conf /srv/bzr/projectx
+
+will watch all branches under the given directory for commits, branch
+creations and branch deletions.
+  
+
+Feed Generation
+---------------
+
+A related concept to sending out emails when branches change is the generation
+of news feeds from changes on each branch.  Interested parties can then choose
+to follow those news feeds in order to see what is happening on a branch.
+
+branchfeed
+~~~~~~~~~~
+
+This plugin creates an ATOM feed for every branch on every branch change
+(commit, etc.).  It stores these files as ``.bzr/branch/branch.atom`` inside
+each branch.  Currently, it includes the 20 most recent changes in each feed.
+To use it, simply install the plugin and set your feed reader to follow the
+``branch.atom`` files.
+
+In addition, there are other tools that are not plugins for creating news
+feeds from Bazaar branches.  See http://bazaar-vcs.org/FeedGenerators for more
+on those tools.
+
+Mirroring
+---------
+
+Sometimes it is useful to ensure that one branch exists as an exact copy of
+another.  This can be used to provide simple backup facilities or redundancy
+(see `Back-up and restore <backup.html>`_ for more details on backups).  One
+way to do this using Bazaar's workflows is to make the branch where changes
+happen into a bound branch of the mirror branch.  Then, when commits happen on
+the working branch, they will also happen on the mirror branch.  Note that
+commits to bound branches do *not* update the mirror branch's working copy, so
+if the mirror branch is more than just a backup of the complete history of the
+branch, for example if it is being served as a web page, then additional
+plugins are necessary.
+
+push_and_update
+~~~~~~~~~~~~~~~
+
+This plugin updates Bazaar's ``push`` command to also update the remote
+working copy.  It can only work over connections that imply filesystem or SSH
+access to the remote working copy (``bzr+ssh://``, ``sftp://`` and
+``file://``).  Also, it is only useful when the remote branch is updated with
+an explicit ``push`` command.
+
+automirror
+~~~~~~~~~~
+
+This plugin is similar to `push_and_update` in that it updates the working
+copy of a remote branch.  The difference is that this plugin is designed to
+update the remote branch on every change to the working branch.  To configure
+this, set the ``post_commit_mirror = URL`` option on a branch.  This option
+can include multiple branch URLs separated by commas to create multiple
+mirrors.  For example, if we want to mirror our ``/srv/bzr/projectx/trunk``
+branch to the URL ``sftp://www.example.com/var/www/projectx`` (for example if
+ProjectX were a web project that we wanted to access at
+``http://www.example.com/projectx``), then we could include
+
+::
+ 
+  [DEFAULT]
+  post_commit_mirror = sftp://www.example.com/var/www/branches/trunk
+
+in the file ``/srv/bzr/projectx/trunk/.bzr/branch/branch.conf``.
+
+
+Other Useful Plugins
+--------------------
+
+pqm (plugin)
+~~~~~~~~~~~~
+
+Facilitating interaction with `PQM
+<integration.html#patch-queue-manager-pqm>`_, this plugin provides support for 
+submitting merge requests to a remote Patch Queue Manager.  PQM provides 
+a way to automatically run the test suite before merging changes to the
+trunk branch.
+
+testrunner
+~~~~~~~~~~
+
+Sometimes referred to as the poor man's PQM, this plugin runs a single command
+on the updated revision (in a temporary directory) and if the command returns
+0, then the revision can be committed to that branch.  For example, if the
+testsuite is run with the command ``nosetests`` in the root of the branch
+(which returns 0 if the test suite passes and 1 if it doesn't pass), then one
+can set 
+
+::
+
+  [DEFAULT]
+  pre_change_branch_tip_test_command = nosetests
+
+in ``.bzr/branch/branch.conf``.
+
+checkeol
+~~~~~~~~
+
+This plugin is an example of a `pre_commit` hook that checks the revision
+being committed for meeting some policy.  In this case, it checks that all of
+the files have the specified line endings.  It uses a configuration file
+``.bzreol`` in the root of the working tree (similar to the ``.bzrignore``
+file).  This configuration file has sections for line feed endings (LF),
+carriage return/line-feed endings (CRLF) and carriage return endings (CR).
+For an unusual example that specifies different line endings for different
+files, that file might look like
+
+:: 
+
+  [LF]
+  *.py
+  *.[ch]
+
+  [CRLF]
+  *.txt
+  *.ini
+
+  [CR]
+  foo.mac
+
+or if you simply want to enforce a single line ending convention on the branch
+you can use
+
+::
+  
+  [LF]
+  *
+
+This plugin needs to be installed on the server where the branch updates will
+happen, and the ``.bzreol`` file must be in each branch where line ending
+policies will be enforced.  (Adding it to the branch with ``bzr add .bzreol``
+is an easy way to ensure this, although it means that branches on the server
+must have working trees.)
+
+text_checker
+~~~~~~~~~~~~
+
+This plugin is a more advanced version of `checkeol` that can check such
+coding style guidelines such as trailing whitespace, long lines and files that
+don't end with a newline.  It is configured using Bazaar's built in rules
+specification in ``BZR_HOME/rules`` (see ``bzr help rules`` for more
+information.  For different types of undesired changes, you can specify
+different types of actions.  For example
+
+::
+
+  [name NEWS README]
+  trailing_whitespace=fail
+  long_lines=warn
+  newline_at_eof=ignore
+
+  [name *.py]
+  tabs=fail
+  long_line_length=78
+  long_lines=fail
+  trailing_whitespace=fail
+
+will prevent changes from adding new trailing whitespace to the specified
+files and keep all python source files free of tabs and lines over 78
+characters.  To commit while violating these rules, one can pass the
+``--text-check-warn-only`` option to commit.

=== added file 'doc/en/admin-guide/index-plain.txt'
--- doc/en/admin-guide/index-plain.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/index-plain.txt	2009-12-07 18:12:21 +0000
@@ -0,0 +1,23 @@
+###################################
+Bazaar System Administrator's Guide
+###################################
+
+.. Please mark sections in included files as following:
+..   level 1 ========
+..   level 2 --------
+..   level 3 ~~~~~~~~
+..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
+
+.. contents:: :depth: 3
+
+.. include:: introduction.txt
+.. include:: simple-setups.txt
+.. include:: other-setups.txt
+.. include:: migration.txt
+.. include:: hooks-plugins.txt
+.. include:: code-browsing.txt
+.. include:: integration.txt
+.. include:: security.txt
+.. include:: backup.txt
+.. include:: upgrade.txt
+.. include:: advanced.txt

=== modified file 'doc/en/admin-guide/index.txt'
--- doc/en/admin-guide/index.txt	2008-03-05 16:38:20 +0000
+++ doc/en/admin-guide/index.txt	2009-12-07 18:12:21 +0000
@@ -1,114 +1,25 @@
-==========================
-Bazaar Administrator Guide
-==========================
-
-Note: this is a work in progress!
-
-.. contents:: Table of contents
-   :depth: 2
-
-Introduction
-============
-
-Introduction to administering a Bazaar server installation.
-
-Scope of this guide
--------------------
-
-What you need to run a Bazaar server
-------------------------------------
-
-Platform requirements etc
-
-
-Simple setup
-============
-
-Smart server
-------------
-
-Recommended tools
------------------
-
-
-Migration
-=========
-
-Migrating from another VCS.
-
-Legacy VCS to bzr sync.
-
-
-Hooks
-=====
-
-
-Web-based code browsing
-=======================
-
-Loggerhead etc.
-
-
-Integration with other tools
-============================
-
-PQM
----
-
-Bug trackers
-------------
-
-Continuous integration tools
-----------------------------
-
-e.g. Cruise Control
-
-Bundle Buggy
-------------
-
-
-Security
-========
-
-Authentication
---------------
-
-ACLs
-----
-
-
-Back-up and restore
-===================
-
-
-Upgrades
-========
-
-Software upgrades
------------------
-
-Disk format upgrades
---------------------
-
-Plugin upgrades
----------------
-
-
-System monitoring
-=================
-
-
-Capacity planning tips
-======================
-
-Disk management etc.
-
-
-Advanced topics
-===============
-
-Clustering
-----------
-
-Multi-site setups
------------------
+###################################
+Bazaar System Administrator's Guide
+###################################
+
+.. Please mark sections in included files as following:
+..   level 1 ========
+..   level 2 --------
+..   level 3 ~~~~~~~~
+..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
+
+
+.. toctree::
+   :maxdepth: 2
+
+   introduction
+   simple-setups
+   other-setups
+   migration
+   hooks-plugins
+   code-browsing
+   integration
+   security
+   backup
+   upgrade
+   advanced

=== added file 'doc/en/admin-guide/integration.txt'
--- doc/en/admin-guide/integration.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/integration.txt	2009-12-07 18:12:21 +0000
@@ -0,0 +1,14 @@
+Integration with Other Tools
+============================
+
+Patch Queue Manager (PQM)
+-------------------------
+
+Bug Trackers
+------------
+
+Continuous Integration Tools
+----------------------------
+
+Bundle Buggy
+------------

=== added file 'doc/en/admin-guide/introduction.txt'
--- doc/en/admin-guide/introduction.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/introduction.txt	2009-12-07 21:51:01 +0000
@@ -0,0 +1,55 @@
+Introduction
+============
+
+Welcome to the Bazaar Version Control System's guide for system
+administrators.  Bazaar is a flexible system that provides many possible
+options for serving projects in ways that will hopefully meet your needs.  If
+you have requirements that are not met by the current state of the Bazaar
+ecosystem, please let us know at bazaar@lists.canonical.com or on Launchpad at
+https://launchpad.net/bzr.
+
+Scope of this guide
+-------------------
+
+In this guide, we will discuss various techniques for making Bazaar projects
+available, migrating from other Version Control Systems, browsing code over
+the Web and combining Bazaar with other tools.  In many of these categories,
+multiple options exist and we will try to explains the costs and benefits of
+the various options.
+
+The intended audience for this guide is the individuals who administer the
+computers that will do the serving.  Much of the configuration that we will
+discuss requires administrator privileges and we will not necessarily indicate
+every point that those privileges are needed.  That said, reading this guide
+can also be very helpful for those who are interested in communicating to the
+system administrators about the requirements for making full use of Bazaar.
+
+What you need to run a Bazaar server
+------------------------------------
+
+Where possible, we will discuss both Unix (including Linux) and Windows server
+environments.  For the purposes of this document, we will consider Mac OS X as
+a type of Unix.
+
+In general, Bazaar requires only Python_ 2.4 or greater and the cElementTree_
+package (included in Python 2.5 and later) to run.  If you would *optionally*
+like to be able to access branches using SFTP, you need `paramiko and
+pycrypto`_.
+
+.. _Python: http://www.python.org/
+.. _cElementTree: http://effbot.org/zone/element-index.htm
+.. _paramiko and pycrypto: http://www.lag.net/paramiko/
+
+For maximum performance, Bazaar can make use of compiled versions of some
+critical components of the code.  Pure Python alternatives exist for all of
+these components, but they may be considerably slower.  To compile these
+extensions, you need a C compiler and the relevant header files from the
+Python package.  On Linux, these may be in a separate package.  Other
+operating systems should have the required headers installed by default.
+
+If you are installing a development version of Bazaar, rather than a released
+version, you will need Pyrex_ to create the C extensions.  The release
+tarballs already have the Pyrex-created C files.
+
+.. _Pyrex: http://www.cosc.canterbury.ac.nz/greg.ewing/python/Pyrex/
+

=== added file 'doc/en/admin-guide/migration.txt'
--- doc/en/admin-guide/migration.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/migration.txt	2009-12-07 18:29:00 +0000
@@ -0,0 +1,73 @@
+Migration
+=========
+
+Migrating between version control systems can be a complicated process, and
+Bazaar has extensive documentation on the process at 
+http://doc.bazaar-vcs.org/migration/en and we won't attempt to repeat that
+here.  We will try to give a few motivating examples for conversion from
+Mercurial and Subversion.
+
+Fast Import
+-----------
+
+In many projects wishing to use Bazaar, there is pre-existing history for the
+codebase that should be taken into consideration.  Bazaar leverages an
+interchange format originally developed for Git called `fast-import` to
+provide migration strategies for many other version control systems.  To
+work with fast-import files, Bazaar needs the `fastimport`_ plugin.  This can
+be installed as with any Bazaar plugin.
+
+.. _fastimport: http://launchpad.net/bzr-fastimport
+
+The way that fast-import can be used for migration is to export the existing
+history into a fast-import file, then use the ``bzr fast-import`` command.
+The `fastimport` plugin includes exporters for Subversion, CVS, Git, Mercurial
+and darcs, accessible as the ``fast-export-from-XXX`` commands.  Note that
+``fast-import`` should not be used in a branch with existing history.
+
+Assuming that ProjectX was first developed in Mercurial before switching to
+Bazaar, and that the Mercurial repository is in ``/srv/hg/projectx``, the
+following commands will import that history into a newly created ``trunk``
+branch.  (Recall that in `Further Configuration
+<simple-setups.html#further-configuration>`_ we created the
+``/srv/bzr/projectx`` directory as a shared repository.)
+
+::
+
+  $ cd /srv/bzr/projectx
+  $ bzr fast-export-from-hg ../../hg/projectx projectx.fi
+  $ bzr init trunk
+  $ bzr fast-import projectx.fi trunk
+
+Subversion Conversion
+---------------------
+
+As the most common centralized version control system, migration from
+Subversion is particularly important for any *new* version control system.
+Bazaar's `svn`_ plugin provides tools for interaction with Subversion
+projects.  In fact, Bazaar can be used transparently with projects stored in
+Subversion, but that is beyond the scope of this document.  (See
+http://doc.bazaar-vcs.org/en/migration/foreign/bzr-on-svn-projects.html for
+more on that subject.)  What is relevant here is the ``svn-import`` command
+provided by that plugin.  This can import an entire subversion repository
+including tags and branches, particularly if they are stored in Subversion's
+recommended directory structure: ``/tags/``, ``/branches/`` and ``/trunk/``.
+
+This command has flexible ways to specify what paths within the Subversion
+repository contain branches and which contain tags.  For example, the
+recommended layout for Subversion projects (called ``trunk`` by the svn
+plugin) could be specified in ``~/.bazaar/subversion.conf`` as
+
+::
+
+  [203ae883-c723-44c9-aabd-cb56e4f81c9a]
+  branches = branches/*
+  tags = tags/*
+
+This allows substantially complicated Subversion repositories to be converted
+into a set of separate Bazaar branches.  After installing the svn plugin, see
+``bzr help svn-import`` and ``bzr help svn-layout``.
+
+.. _svn: http://launchpad.net/bzr-svn
+
+.. TODO: Legacy VCS to bzr sync.  Tailor?  Incremental conversions?

=== added file 'doc/en/admin-guide/other-setups.txt'
--- doc/en/admin-guide/other-setups.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/other-setups.txt	2009-12-07 21:51:01 +0000
@@ -0,0 +1,60 @@
+Other Setups
+============
+
+Dumb servers
+------------
+
+Bazaar can also serve branches over protocols that know nothing about Bazaar's
+specific needs.  These are called "dumb servers" to distinguish them from
+Bazaar's native protocol.  Currently HTTP, FTP, SFTP and HTTP+WebDAV can be
+used to read branches remotely.  FTP, SFTP and HTTP+WebDAV can be used for
+writing as well.  To use any of these protocols, it is just necessary to
+provide access to the server's filesystem under ``/srv/bzr``.
+
+For example, for Apache to provide read-only access to the branches
+in ``/srv/bzr`` the configuration may look like this::
+
+  Alias /code /srv/bzr
+  <Directory /srv/bzr>
+      Options Indexes
+      # ...
+  </Directory>
+
+and users could use the URL ``http://server.example.com/code/projectx/trunk``
+to refer to the trunk branch.
+
+Note that SFTP access is often available whenever there is SSH access and it
+may be a good choice when Bazaar cannot be installed on the server to allow
+``bzr+ssh://`` access.  Dumb servers are slower by their very nature than the
+native protocol, but they can be a good choice in situations where the
+software and protocols that can be used on the server or the network is
+limited.
+
+Smart server over HTTP(S)
+-------------------------
+
+Bazaar can use its native protocol with HTTP requests.  Since HTTP is a network
+protocol that is available on many networks, this can be a good option where
+SSH access is not possible.  Another benefit of this setup is that all of the
+authentication and access control methods available to the HTTP server (basic,
+LDAP, ActiveDirectory, etc.) are then available to control access to Bazaar
+branches.  More information about setting up this type of access using Apache
+and FastCGI or mod_python or WSGI is in the `smart server section of the User's
+Guide <../user-guide/http_smart_server.html>`_.
+
+Direct Smart Server Access
+--------------------------
+
+The built-in server that is used by ``bzr+ssh://`` access can also be used as a
+persistent server on a dedicated port.  Bazaar's official port is 4155,
+although the port used can be configured.  Further information on running the
+Bazaar smart server from inetd, or directly from the shell is in the `User's
+Guide <../user-guide/server.html#inetd>`_.  The dedicated Bazaar server does
+not currently perform any authentication, so this server by default provides
+read-only access.  It can be run with the ``--allow-writes`` option, but the
+smart server does not do any additional access control so this may allow
+undesired people to make changes to branches.  (Which of course can be
+reverted.)  If the user that runs the server has write access to the branches
+on the filesystem, then anyone with access to port 4155 on the server can make
+changes to the branches stored there. 
+

=== added file 'doc/en/admin-guide/security.txt'
--- doc/en/admin-guide/security.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/security.txt	2009-12-22 04:55:15 +0000
@@ -0,0 +1,116 @@
+Security
+========
+
+Authentication
+--------------
+
+Bazaar's philosophy on authentication is that it is best to reuse existing
+authentication technologies, rather than trying to reinvent potentially
+complicated methods for securely identifying users.  As such, we describe two
+such uses of existing software for authentication purposes.
+
+Using SSH
+~~~~~~~~~
+
+SSH is a very well tested and featureful technology for authenticating users.
+For situations where all of the developers have local accounts on the server,
+it is trivial to provide secure, authenticated ``bzr+ssh://`` access.  One
+concern with this method is that it may not be desirable to grant shell access
+to developers on the server machine.  In this case, Bazaar provides
+``bzr_ssh_path_limiter``, a script that runs the Bazaar smart server on the
+server machine at a specified path, and allows no other access.
+
+To set it up, specify::
+
+   command="/path/to/bzr_ssh_path_limiter <path>" <typical key line>
+
+in each user's ``~/.ssh/authorized_keys`` file on the server, where `<path>` is
+the path to limit access to (and its subdirectories).  For more documentation
+on the syntax of the ``authorized_keys`` file see the documentation of the SSH
+server.  This will only permit Bazaar access to the specified path and no other
+SSH access for that user.
+
+If it isn't desired to give each user an account on the server, multiple
+private/public key pairs can be included under one single SSH account (say
+sshuser) in the ``~sshuser/.ssh/authorized_keys`` file and then each developer
+can be given their own private key.  They can then use
+``bzr+ssh://sshuser@server.example.com/`` URLs to access the server.
+
+Using HTTP authentication methods
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+Access Control
+--------------
+
+Many projects need fine-grained access control on who may read and write to
+which branches.  Incorporating these controls into OS-level user accounts
+using groups and filesystem permissions can be difficult or even not permitted
+in some instances.  Bazaar provides a script called ``bzr_access`` that can be
+used to provide access control based on usernames, with authentication
+performed by SSH.  To do so, we need to set up private-key authentication in
+SSH.  This can be done using a single SSH user on the server, or one account
+per user.  The idea is to use the SSH's ``authorized_keys`` file to specify
+the ``bzr_access`` script as the only command that can be run by a user
+identified by a particular key pair.
+
+First, you will need to generate a private/public key pair for each user who
+will be accessing the repository.  The private key should be distributed to
+the user and the public key will be needed on the server to identify the user.
+On the server, in the SSH user's ``~/.ssh/authorized_keys`` file, use the
+following line for each repository user and the corresponding public key::
+
+  command="/path/to/bzr_access /path/to/bzr /path/to/repository <username>",no- port-forwarding,no-X11-forwarding,no-agent-forwarding ssh-<type> <key>
+
+where `<key>` is the (possibly very long) public key, `<type>` is the type of
+SSH key and `<username>` is the username to associate with that public key.
+
+The ``bzr_access`` script obtains its configuration information from the file
+``/path/to/repository/bzr_access.conf``.  This file should not be placed under
+version control in a branch located at ``/path/to/repository`` since that
+would allow anyone with access to the repository to change the access control
+rules.  The ``bzr_access.conf`` file is in a simple INI-style format with
+sections defined by ``[groups]`` and ``[/]``.  The options in the ``[groups]``
+section are the names of groups and the values of those options should be the
+usernames in that group.  Inside the ``[/]`` section, the options are
+usernames or group names (prefixed with ``@``) and the values are either
+``rw``, ``r`` or nothing, representing read-write access, read-only access or
+no access at all.  A sample of ``bzr_access.conf`` could be::
+
+   [groups]
+   admins = alpha
+   devels = beta, gamma, delta
+   
+   [/]
+   @admins = rw
+   @devels = r
+   upsilon = 
+
+where the user whose key is associated with `alpha` would have read-write
+access, the users `beta`, `gamma` and `delta` would have read-only access and
+user `upsilon` would not be able to access any branches under
+``/path/to/repository``.
+
+Additional Considerations with ``bzr_access``
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+As currently written, ``bzr_access`` only allows each public key to be
+associated with a single repository location.  This means that if developers
+need to access two or more different repositories, then each developer will
+need to have two or more private keys for SSH and be able to select between
+them (see ``man ssh`` for more information on configuring multiple private
+keys).
+
+Also, each repository can only have a single configuration file, with access
+configured for all branches in the repository.  This means that if different
+access rules are needed for different projects, then those projects must be in
+different repositories.  This then necessitates the use of multiple private
+keys as just described.
+
+Finally, as noted above under `Using SSH`_ all of the public keys may be
+included in the ``authorized_keys`` file of a single user on the server.  It
+is also possible to use a single private/public key pair for all of the
+developers, but this only allows a single username for access control to the
+repository (since the username is associated with the public key in
+``authorized_keys``.  While this is certainly possible it seems to defeat the
+purpose of fine-grained access control, although it does provide the same
+limited SSH access as that described above.

=== added file 'doc/en/admin-guide/simple-setups.txt'
--- doc/en/admin-guide/simple-setups.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/simple-setups.txt	2009-12-07 21:51:01 +0000
@@ -0,0 +1,93 @@
+Simple Setups
+=============
+
+Consider the following simple scenario where we will be serving Bazaar branches
+that live on a single server.  Those branches are in the subdirectories of
+``/srv/bzr`` (or ``C:\\bzr``) and they will all be related to a single project
+called "ProjectX".  ProjectX will have a trunk branch and at least one feature
+branch.  As we get further, we will consider other scenarios, but this will be
+a sufficiently motivating example.
+
+Smart server
+------------
+
+The simplest possible setup for providing outside access to the branches on
+the server uses Bazaar's built-in smart server tunneled over SSH_ so
+that people who can access your server using SSH can have read and write
+access to branches on the server.  This setup uses the authentication
+mechanisms of SSH including private keys, and the access control mechanisms of
+the server's operating system.  In particular, using groups on the server, it
+is possible to provide different access privileges to different groups of
+developers.
+
+.. _SSH: http://www.openssh.org/
+
+Setup
+~~~~~
+
+There is no setup required for this on the server, apart from having Bazaar
+installed and SSH access available to your developers.  Using SSH
+configuration options it is possible to restrict developers from using
+anything *but* Bazaar on the server via SSH, and to limit what part of the
+file system they can access.
+
+Client
+~~~~~~
+
+Clients can access the branches using URLs with the ``bzr+ssh://`` prefix.  For
+example, to get a local copy of the ProjectX trunk, a developer could do::
+
+  $ bzr branch bzr+ssh://server.example.com/srv/bzr/projectx/trunk projectx
+
+If the developers have write access to the ``/srv/bzr/projectx`` directory, then
+they can create new branches themselves using::
+  
+  $ bzr branch bzr+ssh://server.example.com/srv/bzr/projectx/trunk \
+  bzr+ssh://server.example.com/srv/bzr/projectx/feature-gui
+
+Of course, if this isn't desired, then developers should not have write access
+to the ``/srv/bzr/projectx`` directory.
+
+Further Configuration
+~~~~~~~~~~~~~~~~~~~~~
+
+For a project with multiple branches that are all related, it is best to use a
+shared repository to hold all of the branches.  To set this up, do::
+
+  $ cd /srv/bzr
+  $ bzr init-repo --no-trees projectx
+
+The ``--no-trees`` option saves space by not creating a copy of the working
+files on the server's filesystem.  Then, any branch created under
+``/srv/bzr/projectx`` (see `Migration <migration.html>`_ for some ways to do
+this) will share storage space, which is particularly helpful for branches that
+have many revisions in common, such as a project trunk and its feature
+branches.
+
+If Bazaar is not installed on the user's path or not specified in the SSH
+configuration, then a path can be specified from the client with the
+``BZR_REMOTE_PATH`` environment variable.  For example, if the Bazaar executable
+is installed in ``/usr/local/bzr-2.0/bin/bzr``, then a developer could use::
+
+  $ BZR_REMOTE_PATH=/usr/local/bzr-2.0/bin/bzr bzr info \
+  bzr+ssh://server.example.com/srv/bzr/proectx/trunk
+
+to get information about the trunk branch.  The remote path can also be
+specified in Bazaar's configuration files for a particular location.  See
+``bzr help configuration`` for more details.
+
+If developers have home directories on the server, they can use ``/~/`` in
+URLs to refer to their home directory.  They can also use ``/~username/`` to
+refer to the home directory of user ``username``.  For example, if there are two
+developers ``alice`` and ``bob``, then Bob could use::
+
+  $ bzr log bzr+ssh://server.example.com/~/fix-1023
+
+to refer to one of his bug fix branches and::
+
+  $ bzr log bzr+ssh://server.example.com/~alice/fix-2047
+  
+to refer to one of Alice's branches. [#]_
+
+.. [#] The version of Bazaar installed on the server must be at least 2.1.0b1 
+       or newer to support ``/~/`` in bzr+ssh URLs.

=== added file 'doc/en/admin-guide/upgrade.txt'
--- doc/en/admin-guide/upgrade.txt	1970-01-01 00:00:00 +0000
+++ doc/en/admin-guide/upgrade.txt	2009-12-18 10:09:49 +0000
@@ -0,0 +1,77 @@
+Upgrades
+========
+
+Bazaar has a strong commitment to inter-version compatibility both on disk and
+over the network.  Newer clients should be able to interact with older
+versions on the server (although perhaps not at optimal speed) and older
+clients should also be able to communicate with newer versions of Bazaar on
+the server.  Divergences from this rule are considered bugs and are fixed in
+later versions.
+
+That said, Bazaar is constantly improving and the most recent versions are the
+most featureful and have better performance.  In particular, the Bazaar
+versions 2.0 and later have significant advantages over earlier versions,
+including a more compact disk format, faster network operations and overall
+performance improvements.  With the 2.0 release, Bazaar has moved to a
+stable/development release model where the 2.x series is maintained with
+bugfixes releases for six months, while simultaneously the 2.(x+1) series is
+being developed with monthly beta releases that are suitable for everyday use.
+Bazaar development has a stable trunk with an extensive test suite, so there
+is no reason to fear using the development series for everyday use, it simply
+changes more often than the stable series.  Many users do run the development
+version of Bazaar and update it regularly, including most of the Bazaar
+developers themselves.
+
+
+Software upgrades
+-----------------
+
+Upgrading the Bazaar software is as simple as re-installing the Python package
+using either the latest binary package for Windows or Mac OS X, the binary
+package provided by your Linux distribution, or installing from the source
+release.  See http://bazaar-vcs.org/Downloads for the latest releases for all
+supported platforms.
+
+Bazaar's later versions support all of the earlier disk formats (back to the
+very first one), so there is no need to upgrade the branches on the disk when
+upgrading the software.  To make use of particular new features that might
+need updated versions on both the server and developer's machines, it does not
+matter if the clients or the servers are upgraded first.
+
+
+Disk format upgrades
+--------------------
+
+In its evolution, Bazaar has used a sequence of disk formats for improved
+storage efficiency and speed.  With the new disk format released in version
+2.0, there is a commitment to keep that disk format until version 3.0 is
+released, which has not even been planned yet.  (Bazaar 2.0 was released
+almost two years after Bazaar 1.0.)  As a result, disk format upgrades should
+be extremely infrequent.
+
+If there are existing branches in an older format that you would like to
+upgrade to the latest format, you can see the `2.0 Upgrade Guide
+<../upgrade-guide/index.html>`_ for more information.  From the system
+administration perspective, it is important to coordinate the timing of
+various upgrades in the process.  First, the central branches on the server
+should be upgraded.  Next, any local mirrors that developers have should be
+upgraded.  Finally, developers' local branches should be upgraded.  These
+upgrades will require an appropriate version of the software whenever they are
+performed.  (It is possible to upgrade branches remotely over the network, but
+it may be much slower.)
+
+
+Plugin upgrades
+---------------
+
+When Bazaar does update its version, plugins that use the Bazaar API may need
+to be upgraded to reflect changes in that API.  Some plugins have strict
+version dependencies on the version of the Bazaar API that they will accept.
+If this is the case, then you should ensure that the plugins you depend on
+have been updated *before* you upgrade your Bazaar version to avoid a
+situation where your plugins won't work with the installed version of Bazaar.
+If this does happen, then the solution is simply to reinstall the previous
+version of Bazaar that *did* work with the plugins.  For installations that
+depend on a large number of plugins, this sort of version upgrade should be
+tested in a safe sandbox to ensure that the entire collection of Bazaar and
+its plugins can all work together.

=== modified file 'doc/en/conf.py'
--- doc/en/conf.py	2009-09-09 13:34:08 +0000
+++ doc/en/conf.py	2009-12-07 21:51:01 +0000
@@ -73,8 +73,6 @@
 
 # List of documents that shouldn't be included in the build.
 unused_docs = [
-    # Placeholder for later
-    'admin-guide/index',
     # Subtopics that get included
     'upgrade-guide/overview',
     'upgrade-guide/data_migration',
@@ -83,6 +81,7 @@
     'release-notes/NEWS',
     'user-reference/bzr_man',
     'user-guide/index-plain',
+    'admin-guide/index-plain',
     # Miscellaneous
     'user-reference/readme',
 ]

=== modified file 'doc/en/index.txt'
--- doc/en/index.txt	2009-09-09 11:43:10 +0000
+++ doc/en/index.txt	2009-12-07 18:12:21 +0000
@@ -16,3 +16,4 @@
    release-notes/index
    upgrade-guide/index
    user-reference/index
+   admin-guide/index

=== modified file 'doc/en/mini-tutorial/index.txt'
--- doc/en/mini-tutorial/index.txt	2009-09-02 16:03:51 +0000
+++ doc/en/mini-tutorial/index.txt	2009-12-03 00:44:16 +0000
@@ -6,13 +6,13 @@
 ============
 
 Bazaar is a distributed version control system that makes it easier for
-people to work together on software projects. 
+people to work together on software projects.
 
 Over the next five minutes, you'll learn how to put your files under
 version control, how to record changes to them, examine your work, publish
 it and send your work for merger into a project's trunk.
 
-If you'd prefer a more detailed introduction, take a look at 
+If you'd prefer a more detailed introduction, take a look at
 `Learning More`_.
 
 
@@ -44,7 +44,7 @@
 Using your name and email address, instead of John Doe's, type::
 
   $ bzr whoami "John Doe <john.doe@gmail.com>"
-  
+
 Bazaar will now create or modify a configuration file, including your
 name and email address.
 
@@ -63,15 +63,15 @@
  $ cd myproject
  $ mkdir subdirectory
  $ touch test1.txt test2.txt test3.txt subdirectory/test4.txt
- 
+
 **Note for Windows users:** use Windows Explorer to create your
-directories, then right-click in those directories and select 
+directories, then right-click in those directories and select
 ``New file`` to create your files.
 
 Now get Bazaar to initialize itself in your project directory::
 
   $ bzr init
-  
+
 If it looks like nothing happened, don't worry. Bazaar has created a
 branch_ where it will store your files and their revision histories.
 
@@ -87,13 +87,13 @@
  added test3.txt
  added subdirectory/test4.txt
 
-Next, take a snapshot of your files by committing them to your branch. Add 
+Next, take a snapshot of your files by committing them to your branch. Add
 a message to explain why you made the commit::
 
   $ bzr commit -m "Initial import"
-  
-As Bazaar is a distributed version control system, it doesn't need to 
-connect to a central server to make the commit. Instead, Bazaar stores your 
+
+As Bazaar is a distributed version control system, it doesn't need to
+connect to a central server to make the commit. Instead, Bazaar stores your
 branch and all its commits inside the directory you're working with; look
 for the ``.bzr`` sub-directory.
 
@@ -156,14 +156,14 @@
 
  $ bzr push --create-prefix sftp://your.name@example.com/~/public_html/myproject
  2 revision(s) pushed.
- 
+
 Bazaar will create a ``myproject`` directory on the remote server and
 push your branch to it.
- 
+
 Now anyone can create their own copy of your branch by typing::
 
  $ bzr branch http://www.example.com/myproject
- 
+
 **Note:** to use sftp, you may need to install ``paramiko`` and
 ``pyCrypto``. See http://bazaar-vcs.org/InstallationFaq for details.
 
@@ -171,7 +171,7 @@
 Publishing your branch with Launchpad
 =====================================
 
-Launchpad is a suite of development and hosting tools for free 
+Launchpad is a suite of development and hosting tools for free
 software projects. You can use it to publish your branch.
 
 If you don't have a Launchpad account, follow the `account signup guide`_
@@ -180,17 +180,19 @@
 .. _account signup guide: https://help.launchpad.net/CreatingYourLaunchpadAccount
 .. _register an SSH key: https://launchpad.net/people/+me/+editsshkeys
 
-Replacing ``john.doe`` with your own Launchpad username, type::
-
- $ bzr push bzr+ssh://john.doe@bazaar.launchpad.net/~john.doe/+junk/myproject
+Replacing ``john.doe`` with your own Launchpad username, type [#]_::
+
+ $ bzr push lp:~john.doe/+junk/myproject
+
+.. [#] Use of the ``lp:`` URL scheme requires bzr 0.92 or later.
 
 **Note:** ``+junk`` means that this branch isn't associated with any particular
 project in Launchpad.
 
 Now, anyone can create their own copy of your branch by typing::
 
- $ bzr branch http://bazaar.launchpad.net/~john.doe/+junk/myproject
- 
+ $ bzr branch lp:~john.doe/+junk/myproject
+
 You can also see information about your branch, including its revision
 history, at https://code.launchpad.net/people/+me/+junk/myproject
 
@@ -198,18 +200,18 @@
 Creating your own copy of another branch
 ========================================
 
-To work with someone else's code, you can make your own copy of their 
+To work with someone else's code, you can make your own copy of their
 branch. Let's take a real-world example, Bazaar's GTK interface::
 
-  $ bzr branch http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk bzr-gtk.john
-  Branched 292 revision(s).                                                        
+  $ bzr branch lp:~bzr/bzr-gtk/trunk bzr-gtk.john
+  Branched 292 revision(s).
 
 Bazaar will download all the files and complete revision history from the
 bzr-gtk project's trunk branch and create a copy called bzr-gtk.john.
 
-Now, you have your own copy of the branch and can commit changes with 
-or without a net connection. You can share your branch at any time by 
-publishing it and, if the  bzr-gtk team want to use your work, Bazaar 
+Now, you have your own copy of the branch and can commit changes with
+or without a net connection. You can share your branch at any time by
+publishing it and, if the  bzr-gtk team want to use your work, Bazaar
 makes it easy for them to merge your branch back into their trunk branch.
 
 
@@ -225,11 +227,11 @@
   $ bzr merge
   Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
   All changes applied successfully.
-            
+
 Check what has changed::
 
   $ bzr diff
- 
+
 If you're happy with the changes, you can commit them to your personal
 branch::
 
@@ -244,20 +246,20 @@
 send your changes back upstream to the project. The easiest way is to
 use a merge directive.
 
-A merge directive is a machine-readable request to perform a 
-particular merge.  It usually contains a patch preview of the merge 
-and either contains the necessary revisions, or provides a branch 
+A merge directive is a machine-readable request to perform a
+particular merge.  It usually contains a patch preview of the merge
+and either contains the necessary revisions, or provides a branch
 where they can be found.
 
 Replacing ``mycode.patch``, create your merge directive::
 
  $ bzr send -o mycode.patch
  Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
- 
+
 You can now email the merge directive to the bzr-gtk project who, if
 they choose, can use it merge your work back into the parent branch.
- 
- 
+
+
 Learning more
 =============
 

=== modified file 'doc/en/tutorials/centralized_workflow.txt'
--- doc/en/tutorials/centralized_workflow.txt	2009-09-02 16:03:51 +0000
+++ doc/en/tutorials/centralized_workflow.txt	2009-12-03 23:21:16 +0000
@@ -38,7 +38,7 @@
 be accurate or unique, it will be used in log messages and
 annotations, so it is better to have something real.
 
-::  
+::
 
    % bzr whoami "John Doe <jdoe@organization.com>"
 
@@ -83,7 +83,7 @@
   % bzr init-repo --no-trees sftp://centralhost/srv/bzr/
 
 You can think of this step as similar to setting up a new cvsroot, or
-subversion repository.  The {{{--no-trees}}} option tells bzr to not
+subversion repository.  The ``--no-trees`` option tells bzr to not
 populate the directory with a working tree.  This is appropriate,
 since no one will be making changes directly in the branches within
 the central repository.
@@ -102,7 +102,7 @@
 
 .. _Tracking Upstream: http://bazaar-vcs.org/TrackingUpstream
 
-.. 
+..
    XXX: We really need a different document for discussing conversion of a
    project. Right now TrackingUpstream is the best we have, though.
 
@@ -282,7 +282,7 @@
 ::
 
   % bzr branch sftp://centralhost/srv/bzr/sigil/user-a \
-               sftp://centralhost/srv/bzr/sigil/user-a/feature 
+               sftp://centralhost/srv/bzr/sigil/user-a/feature
   % cd ~/work/sigil
   % bzr checkout sftp://centralhost/srv/bzr/sigil/user-a/feature myfeature
 
@@ -294,7 +294,7 @@
 -----------------
 
 Bazaar_ has the concept of a "Shared Repository". This is similar to
-the traditional concept of a repository in other RCSs like CVS and
+the traditional concept of a repository in other VCSs like CVS and
 Subversion. For example, in Subversion you have a remote repository,
 which is where all of the history is stored, and locally you don't
 have any history information, only a checkout of the working tree
@@ -310,5 +310,5 @@
 well share the storage as well.
 
 
-.. 
+..
    vim: tw=74 ft=rst spell spelllang=en_us

=== modified file 'doc/en/tutorials/tutorial.txt'
--- doc/en/tutorials/tutorial.txt	2009-09-02 16:03:51 +0000
+++ doc/en/tutorials/tutorial.txt	2009-12-04 06:21:36 +0000
@@ -2,7 +2,7 @@
 .. into HTML or text.  In the future we plan to extract the example commands
 .. and automatically test them.
 
-.. This text was previously on the wiki at 
+.. This text was previously on the wiki at
 .. http://bazaar.canonical.com/IntroductionToBzr
 .. but has been moved into the source tree so it can be kept in sync with
 .. the source and possibly automatically checked.
@@ -15,15 +15,15 @@
 Introduction
 ============
 
-If you are already familiar with decentralized revision control, then
+If you are already familiar with decentralized version control, then
 please feel free to skip ahead to "Introducing Yourself to Bazaar". If,
-on the other hand, you are familiar with revision control but not
-decentralized revision control, then please start at "How DRCS is
+on the other hand, you are familiar with version control but not
+decentralized version control, then please start at "How DVCS is
 different." Otherwise, get some coffee or tea, get comfortable and get
-ready to catch up. 
+ready to catch up.
 
-The purpose of revision control
-===============================
+The purpose of version control
+==============================
 
 Odds are that you have worked on some sort of textual data -- the sources
 to a program, web sites or the config files that Unix system
@@ -34,7 +34,7 @@
 important information that you would desperately like to get back. If this
 has ever happened to you, then you are probably ready for Bazaar.
 
-Revision control systems (which I'll henceforth call RCS) such as
+Version control systems (which I'll henceforth call VCS) such as
 Bazaar give you the ability to track changes for a directory by turning
 it into something slightly more complicated than a directory that we call
 a **branch**. The branch not only stores how the directory looks right
@@ -42,10 +42,10 @@
 do something you wish you hadn't, you can restore the directory to the way
 it looked at some point in the past.
 
-Revision control systems give users the ability to save changes to a
+Version control systems give users the ability to save changes to a
 branch by "committing a **revision**". The revision created is essentially
 a summary of the changes that were made since the last time the tree was
-saved. 
+saved.
 
 These revisions have other uses as well. For example, one can comment
 revisions to record what the recent set of changes meant by providing an
@@ -53,25 +53,25 @@
 the web template to close the table" and "Added sftp suppport. Fixes #595"
 	
 We keep these logs so that if later there is some sort of problem with
-sftp, we can figure out when the problem probably happened. 
+sftp, we can figure out when the problem probably happened.
 
-How DRCS is different
+How DVCS is different
 =====================
 
-Many Revision Control Systems (RCS) are stored on servers. If one wants to
-work on the code stored within an RCS, then one needs to connect to the
+Many Version Control Systems (VCS) are stored on servers. If one wants to
+work on the code stored within a VCS, then one needs to connect to the
 server and "checkout" the code. Doing so gives one a directory in which a
-person can make changes and then commit. The RCS client then connects to
-the RCS server and stores the changes. This method is known as the
-centralized model. 
+person can make changes and then commit. The VCS client then connects to
+the VCS server and stores the changes. This method is known as the
+centralized model.
 
-The centralized model can have some drawbacks. A centralized RCS requires
+The centralized model can have some drawbacks. A centralized VCS requires
 that one is able to connect to the server whenever one wants to do version
 control work. This can be a bit of a problem if your server is on some other
 machine on the internet and you are not. Or, worse yet, you **are** on the
 internet but the server is missing!
 
-Decentralized Revision Control Systems (which I'll call DRCS after this
+Decentralized Version Control Systems (which I'll call DVCS after this
 point) deal with this problem by keeping branches on the same machine as
 the client. In Bazaar's case, the branch is kept in the same place as
 the code that is being version controlled. This allows the user to save
@@ -79,15 +79,15 @@
 user only needs internet access when he wants to access the changes in
 someone else's branch that are somewhere else.
 
- 
+
 A common requirement that many people have is the need to keep track of
 the changes for a directory such as file and subdirectory changes.
 Performing this tracking by hand is a awkward process that over time
 becomes unwieldy. That is, until one considers version control tools such
 as Bazaar. These tools automate the process of storing data by creating
-a **revision** of the directory tree whenever the user asks. 
+a **revision** of the directory tree whenever the user asks.
 
-Revision control software such as Bazaar can do much more than just
+Version control software such as Bazaar can do much more than just
 storage and performing undo.  For example, with Bazaar a developer can
 take the modifications in one branch of software and apply them to a
 related branch -- even if those changes exist in a branch owned by
@@ -105,7 +105,7 @@
 ==============================
 
 Bazaar installs a single new command, **bzr**.  Everything else is a
-subcommand of this.  You can get some help with ``bzr help``. Some arguments 
+subcommand of this.  You can get some help with ``bzr help``. Some arguments
 are grouped in topics: ``bzr help topics`` to see which topics are available.
 
 One function of a version control system is to keep track of who changed
@@ -147,7 +147,7 @@
 
 .. [1] On Windows, the users configuration files can be found in the
    application data directory. So instead of ``~/.bazaar/branch.conf``
-   the configuration file can be found as: 
+   the configuration file can be found as:
    ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\branch.conf``.
    The same is true for ``locations.conf``, ``ignore``, and the
    ``plugins`` directory.
@@ -230,9 +230,9 @@
 its test suite before committing, to make sure that every revision is a
 known-good state.  You can also review your changes, to make sure you're
 committing what you intend to, and as a chance to rethink your work before
-you permanently record it. 
+you permanently record it.
 
-Two bzr commands are particularly useful here: **status** and **diff**.  
+Two bzr commands are particularly useful here: **status** and **diff**.
 
 bzr status
 ----------
@@ -277,7 +277,7 @@
 Some projects prefer patches to show a prefix at the start of the path
 for old and new files.  The ``--prefix`` option can be used to provide
 such a prefix.
-As a shortcut, ``bzr diff -p1`` produces a form that works with the 
+As a shortcut, ``bzr diff -p1`` produces a form that works with the
 command ``patch -p1``.
 
 
@@ -285,7 +285,7 @@
 ==================
 
 When the working tree state is satisfactory, it can be **committed** to
-the branch, creating a new revision holding a snapshot of that state.  
+the branch, creating a new revision holding a snapshot of that state.
 
 bzr commit
 ----------
@@ -330,6 +330,30 @@
 commit message when you have finished. If you would like parts to be
 included in the message you can copy and paste them above the separator.
 
+Marking bugs as fixed
+---------------------
+
+Many changes to a project are as a result of fixing bugs. Bazaar can keep
+metadata about bugs you fixed when you commit them. To do this you use the
+``--fixes`` option. This option takes an argument that looks like this::
+
+    % bzr commit --fixes <tracker>:<id>
+
+Where ``<tracker>`` is an identifier for a bug tracker and ``<id>`` is an
+identifier for a bug that is tracked in that bug tracker. ``<id>`` is usually
+a number. Bazaar already knows about a few popular bug trackers. They are 
+bugs.launchpad.net, bugs.debian.org, and bugzilla.gnome.org. These trackers
+have their own identifiers: lp, deb, and gnome respectively. For example,
+if you made a change to fix the bug #1234 on bugs.launchpad.net, you would
+use the following command to commit your fix::
+
+    % bzr commit -m "fixed my first bug" --fixes lp:1234
+
+For more information on this topic or for information on how to configure
+other bug trackers please read `Bug Tracker Settings`_.
+
+.. _Bug Tracker Settings: ../user-reference/index.html#bug-tracker-settings
+
 Selective commit
 ----------------
 
@@ -403,6 +427,26 @@
     % bzr commit -m "Add ignore patterns"
 
 
+bzr ignore
+----------
+
+As an alternative to editing the ``.bzrignore`` file, you can use the
+``bzr ignore`` command. The ``bzr ignore`` command takes filenames and/or
+patterns as arguments and then adds them to the ``.bzrignore`` file. If a
+``.bzrignore`` file does not exist the ``bzr ignore`` command will
+automatically create one for you, and implicitly add it to be versioned::
+
+    % bzr ignore tags
+    % bzr status
+    added:
+      .bzrignore
+
+Just like when editing the ``.bzrignore`` file on your own, you should
+commit the automatically created ``.bzrignore`` file::
+
+    % bzr commit -m "Added tags to ignore file"
+
+
 Global ignores
 --------------
 
@@ -435,7 +479,7 @@
 =================
 
 The ``bzr info`` command shows some summary information about the working
-tree and the branch history.  
+tree and the branch history.
 
 
 Versioning directories
@@ -464,7 +508,7 @@
 
 ``bzr remove`` makes the file un-versioned, but may or may not delete the
 working copy [2]_.  This is useful when you add the wrong file, or decide that
-a file should actually not be versioned. 
+a file should actually not be versioned.
 
 ::
 
@@ -491,7 +535,7 @@
 the existing branch.  Because this new copy is potentially a new branch,
 the command is called **branch**::
 
-    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev 
+    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev
     % cd bzr.dev
 
 This copies down the complete history of this branch, so we can do all
@@ -510,7 +554,7 @@
     % bzr pull
 
 After this change, the local directory will be a mirror of the source. This
-includes the ''revision-history'' - which is a list of the commits done in 
+includes the ''revision-history'' - which is a list of the commits done in
 this branch, rather than merged from other branches.
 
 This command only works if your local (destination) branch is either an
@@ -564,7 +608,7 @@
 
   ::
 
-    % bzr push sftp://servername.com/path/to/directory 
+    % bzr push sftp://servername.com/path/to/directory
 
   (The destination directory must already exist unless the
   ``--create-prefix`` option is used.)
@@ -578,7 +622,7 @@
   than using ``push``, but may be faster or easier in some situations.
 
 
-Moving changes between trees 
+Moving changes between trees
 ============================
 
 It happens to the best of us: sometimes you'll make changes in the wrong

=== modified file 'doc/en/tutorials/using_bazaar_with_launchpad.txt'
--- doc/en/tutorials/using_bazaar_with_launchpad.txt	2009-09-02 16:03:51 +0000
+++ doc/en/tutorials/using_bazaar_with_launchpad.txt	2009-12-02 20:34:07 +0000
@@ -423,7 +423,7 @@
 Summary
 =======
 
-The communities we join, whether off-line or on-line, 
+The communities we join, whether off-line or on-line,
 say a lot about the sort of people we are. The flip-side
 to this is that the tools you choose for your community - particularly
 the CDE and version control tool - can have a large impact on who

=== modified file 'doc/en/user-guide/adv_merging.txt'
--- doc/en/user-guide/adv_merging.txt	2009-04-04 02:50:01 +0000
+++ doc/en/user-guide/adv_merging.txt	2009-11-25 16:04:57 +0000
@@ -47,6 +47,29 @@
 be done at a later time. In other cases, additional conflicts will need
 to be resolved when the changes are merged again.
 
+Merging without parents
+-----------------------
+
+A related technique to cherrypicking, in that it makes changes without
+reference to the revisions that they came from is to perform a merge, but
+forget about the parent revisions before committing.  This has the effect of
+making all of the changes that would have been in the merge happen in a single
+commit.  After the merge and before the corresponding commit, you can do::
+
+  bzr revert --forget-merges
+
+to keep the changes in the working tree, but remove the record of the
+revisions where the changes originated.  The next commit would then record
+all of those changes without any record of the merged revisions.
+
+This is desired by some users to make their history "cleaner", but you should
+be careful that the loss of history does not outweigh the value of cleanliness,
+particularly given Bazaar's capabilities for progressively disclosing merged
+revisions.  In particular, because this will include the changes from the
+source branch, but without attribution to that branch, it can lead to
+additional conflicts on later merges that involve the same source and
+target branches.
+
 
 Reverse cherrypicking
 ---------------------

=== modified file 'doc/en/user-guide/branching_a_project.txt'
--- doc/en/user-guide/branching_a_project.txt	2009-10-11 10:06:41 +0000
+++ doc/en/user-guide/branching_a_project.txt	2009-12-02 20:34:07 +0000
@@ -92,7 +92,7 @@
 the latest version.
 
 As explained in later chapters, Bazaar also has support for
-`lightweight checkouts <using_checkouts.html#getting-a-lightweight-checkout>`_ 
+`lightweight checkouts <using_checkouts.html#getting-a-lightweight-checkout>`_
 of a branch, i.e. working trees with
 no local storage of history. Of course, disconnected usage
 is not available then but that's a tradeoff you can decide

=== modified file 'doc/en/user-guide/bug_trackers.txt'
--- doc/en/user-guide/bug_trackers.txt	2008-05-16 21:00:25 +0000
+++ doc/en/user-guide/bug_trackers.txt	2009-12-03 15:09:53 +0000
@@ -20,7 +20,7 @@
 to configure this for Bugzilla, Trac, Roundup and other bug/issue trackers,
 refer to `Bug Tracker Settings`_ in the Bazaar User Reference.
 
-.. _Bug Tracker Settings: ../user-reference/bzr_man.html#bug-tracker-settings
+.. _Bug Tracker Settings: ../user-reference/index.html#bug-tracker-settings
 
 Metadata recording vs bug tracker updating
 ------------------------------------------

=== modified file 'doc/en/user-guide/configuring_bazaar.txt'
--- doc/en/user-guide/configuring_bazaar.txt	2008-08-14 17:25:43 +0000
+++ doc/en/user-guide/configuring_bazaar.txt	2009-12-02 20:34:07 +0000
@@ -13,7 +13,7 @@
 identifier you want::
 
     % bzr whoami "Your Name <email@example.com>"
- 
+
 If ``whoami`` is used without an argument, the current value is displayed.
 
 Configuration files

=== modified file 'doc/en/user-guide/controlling_registration.txt'
--- doc/en/user-guide/controlling_registration.txt	2008-04-18 01:06:17 +0000
+++ doc/en/user-guide/controlling_registration.txt	2009-12-02 20:34:07 +0000
@@ -100,7 +100,7 @@
 
 .. [#] On Windows, the users configuration files can be found in the
    application data directory. So instead of ``~/.bazaar/branch.conf``
-   the configuration file can be found as: 
+   the configuration file can be found as:
    ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\branch.conf``.
    The same is true for ``locations.conf``, ``ignore``, and the
    ``plugins`` directory.

=== modified file 'doc/en/user-guide/distributed_intro.txt'
--- doc/en/user-guide/distributed_intro.txt	2008-05-06 14:34:57 +0000
+++ doc/en/user-guide/distributed_intro.txt	2009-12-02 20:34:07 +0000
@@ -19,5 +19,5 @@
 
 Other distributed workflows are explored later in this chapter.
 
-.. 
+..
    vim: tw=74 ft=rst

=== modified file 'doc/en/user-guide/filtered_views.txt'
--- doc/en/user-guide/filtered_views.txt	2009-03-31 14:12:27 +0000
+++ doc/en/user-guide/filtered_views.txt	2009-10-19 04:55:02 +0000
@@ -25,10 +25,8 @@
 a view implicitly so that it is clear that the operation or output is
 being masked accordingly.
 
-Note: Bazaar's default format does not yet support filtered views. That
-is likely to change in the near future. To use filtered views in the
-meantime, you currently need to upgrade to ``development-wt6`` (or
-``development-wt6-rich-root``) format first.
+Note: Filtered views are only supported in format 2a, the default in
+Bazaar 2.0, or later.
 
 
 Creating a view

=== modified file 'doc/en/user-guide/hooks.txt'
--- doc/en/user-guide/hooks.txt	2008-10-29 06:10:45 +0000
+++ doc/en/user-guide/hooks.txt	2010-01-03 03:49:07 +0000
@@ -8,18 +8,18 @@
 perform actions before or after certain Bazaar operations.  The operations
 include ``commit``, ``push``, ``pull``, and ``uncommit``.
 For a complete list of hooks and their parameters, see `Hooks
-<../user-reference/bzr_man.html#hooks>`_ in the User Reference.
+<../user-reference/hooks-help.html>`_ in the User Reference.
 
 Most hooks are run on the client, but a few are run on the server.  (Also
-see the `bzr-push-and-update`_ plugin that handles one special case of
+see the `push-and-update plugin`_ that handles one special case of
 server-side operations.)
 
-.. _bzr-push-and-update: https://launchpad.net/bzr-push-and-update/
+.. _push-and-update plugin: http://doc.bazaar.canonical.com/plugins/en/push-and-update-plugin.html
 
 Using hooks
 -----------
 
-To use a hook, you should `write a plugin <#writing-a-plugin>`_.  Instead of
+To use a hook, you should `write a plugin`_.  Instead of
 creating a new command, this plugin will define and install the hook.  Here's
 an example::
 
@@ -33,6 +33,8 @@
     branch.Branch.hooks.install_named_hook('post_push', post_push_hook,
                                      'My post_push hook')
 
+.. _write a plugin: http://doc.bazaar.canonical.com/plugins/en/plugin-development.html
+
 To use this example, create a file named ``push_hook.py``, and stick it in
 ``plugins`` subdirectory of your configuration directory.  (If you have never
 installed any plugins, you may need to create the ``plugins`` directory).

=== modified file 'doc/en/user-guide/http_smart_server.txt'
--- doc/en/user-guide/http_smart_server.txt	2008-10-20 09:26:03 +0000
+++ doc/en/user-guide/http_smart_server.txt	2009-12-02 20:34:07 +0000
@@ -30,7 +30,7 @@
 
     LoadModule fastcgi_module /usr/lib/apache2/modules/mod_fastcgi.so
     FastCgiIpcDir /var/lib/apache2/fastcgi
-    
+
 In our example, we're already serving `/srv/example.com/www/code` at
 `http://example.com/code`, so our existing Apache configuration would look
 like::
@@ -51,7 +51,7 @@
         RewriteBase /code
         RewriteRule ^(.*/|)\.bzr/smart$ /srv/example.com/scripts/bzr-smart.fcgi
     </Directory>
-    
+
     # bzr-smart.fcgi isn't under the DocumentRoot, so Alias it into the URL
     # namespace so it can be executed.
     Alias /srv/example.com/scripts/bzr-smart.fcgi /srv/example.com/scripts/bzr-smart.fcgi
@@ -61,7 +61,7 @@
             SetHandler fastcgi-script
         </Files>
     </Directory>
-    
+
 This instructs Apache to hand requests for any URL ending with `/.bzr/smart`
 inside `/code` to a Bazaar smart server via FastCGI.
 
@@ -136,11 +136,11 @@
         prefix='/code/',
         path_var='REQUEST_URI',
         readonly=True,
-        load_plugins=True, 
+        load_plugins=True,
         enable_logging=True)
 
     fcgi.WSGIServer(smart_server_app).run()
-        
+
 The `fcgi` module can be found at http://svn.saddi.com/py-lib/trunk/fcgi.py.  It
 is part of flup_.
 
@@ -162,14 +162,14 @@
         prefix='/code/',
         path_var='REQUEST_URI',
         readonly=True,
-        load_plugins=True, 
+        load_plugins=True,
         enable_logging=True)
 
     def handler(request):
         """Handle a single request."""
         wsgi_server = modpywsgi.WSGIServer(smart_server_app)
         return wsgi_server.run(request)
-        
+
 The `modpywsgi` module can be found at
 http://dev.pocoo.org/projects/pocoo/browser/pocoo/wrappers/modpy.py. It is
 part of pocoo_. You sould make sure you place modpywsgi.py in the same
@@ -232,5 +232,5 @@
 writable server, and plain HTTP allow read-only access.
 
 
-.. 
+..
    vim: ft=rst tw=74 et

=== modified file 'doc/en/user-guide/index-plain.txt'
--- doc/en/user-guide/index-plain.txt	2009-09-09 12:57:43 +0000
+++ doc/en/user-guide/index-plain.txt	2009-12-02 20:34:07 +0000
@@ -84,7 +84,7 @@
 .. include:: server.txt
 .. include:: hooks.txt
 .. include:: version_info.txt
- 
+
 
 A brief tour of some popular plugins
 ####################################

=== modified file 'doc/en/user-guide/index.txt'
--- doc/en/user-guide/index.txt	2009-09-02 16:03:51 +0000
+++ doc/en/user-guide/index.txt	2009-12-02 20:34:07 +0000
@@ -103,7 +103,7 @@
    server
    hooks
    version_info
- 
+
 
 A brief tour of some popular plugins
 ####################################

=== modified file 'doc/en/user-guide/introducing_bazaar.txt'
--- doc/en/user-guide/introducing_bazaar.txt	2009-06-01 22:45:06 +0000
+++ doc/en/user-guide/introducing_bazaar.txt	2010-01-04 02:25:11 +0000
@@ -18,7 +18,7 @@
 
 This guide takes you through installing Bazaar and how to use it,
 whether on your own or with a team of other people. If you're already
-familiar with distributed version control and want to dive straight in, 
+familiar with distributed version control and want to dive straight in,
 you may wish to skim this section and jump straight to
 `Learning more`_.
 
@@ -49,7 +49,7 @@
 To record or *commit* these changes, the user needs access to the central
 server and they need to ensure they have merged their work with the latest
 version stored before trying to commit. This approach is known as the
-centralized model. 
+centralized model.
 
 The centralized model has proven useful over time but it can have some notable
 drawbacks. Firstly, a centralized VCS requires that one is able to connect
@@ -87,7 +87,7 @@
      move them into the core
 
  * in companies, easier to work with distributed and outsourced teams.
-   
+
 For a detailed look at the advantages of distributed VCS tools over
 centralized VCS tools, see http://bazaar-vcs.org/BzrWhy.
 
@@ -135,7 +135,7 @@
 
 .. _Bazaar in five minutes: ../mini-tutorial/index.html
 .. _Bazaar Quick Start Card: ../quick-reference/quick-start-summary.svg
-.. _Bazaar User Reference: ../user-reference/bzr_man.html
+.. _Bazaar User Reference: ../user-reference/index.html
 
 We hope you find this manual useful. If you have suggestions on how it
 or the rest of Bazaar's documentation can be improved, please contact

=== modified file 'doc/en/user-guide/plugins.txt'
--- doc/en/user-guide/plugins.txt	2009-09-11 07:55:48 +0000
+++ doc/en/user-guide/plugins.txt	2009-12-02 20:34:07 +0000
@@ -15,7 +15,7 @@
 * adding new commands
 * providing additional network transports
 * customizing log output.
-  
+
 The sky is the limit for the customization that can be done through plugins.
 In fact, plugins often work as a way for developers to test new features for
 Bazaar prior to inclusion in the official codebase. Plugins are helpful
@@ -25,12 +25,12 @@
 Plugins are good for users, good for external developers and good for
 Bazaar itself.
 
-Where to find plugins 
+Where to find plugins
 ---------------------
 
 We keep our list of plugins on the http://bazaar-vcs.org/BzrPlugins page.
 
-How to install a plugin 
+How to install a plugin
 -----------------------
 
 Installing a plugin is very easy! If not already created, create a
@@ -42,7 +42,7 @@
 
 Plugins work particularly well with Bazaar branches. For example, to
 install the bzrtools plugins for your main user account on Linux,
-one can perform the following:: 
+one can perform the following::
 
     bzr branch http://panoramicfeedback.com/opensource/bzr/bzrtools
     ~/.bazaar/plugins/bzrtools

=== modified file 'doc/en/user-guide/publishing_a_branch.txt'
--- doc/en/user-guide/publishing_a_branch.txt	2009-09-09 15:06:00 +0000
+++ doc/en/user-guide/publishing_a_branch.txt	2009-12-02 11:03:35 +0000
@@ -55,7 +55,6 @@
   bzr add                (populate repository; start version control)
   bzr commit -m "Initial import"
                          (publish to central repository)
-  bzr push sftp://centralhost/srv/bzr/project/trunk
 
 Note that committing inside a working tree created using
 the ``checkout`` command implicitly commits the content to

=== modified file 'doc/en/user-guide/recording_changes.txt'
--- doc/en/user-guide/recording_changes.txt	2009-03-02 13:02:13 +0000
+++ doc/en/user-guide/recording_changes.txt	2009-12-02 20:34:07 +0000
@@ -5,7 +5,7 @@
 ----------
 
 When the working tree state is satisfactory, it can be **committed** to
-the branch, creating a new revision holding a snapshot of that state.  
+the branch, creating a new revision holding a snapshot of that state.
 
 The **commit** command takes a message describing the changes in the
 revision.  It also records your userid, the current time and timezone, and

=== modified file 'doc/en/user-guide/resolving_conflicts.txt'
--- doc/en/user-guide/resolving_conflicts.txt	2008-03-05 10:26:17 +0000
+++ doc/en/user-guide/resolving_conflicts.txt	2009-12-02 20:34:07 +0000
@@ -35,7 +35,7 @@
 each file in question, fixing the relevant areas and removing the
 conflict markers as you go.
 
-After fixing all the files in conflict, and removing the markers, 
+After fixing all the files in conflict, and removing the markers,
 ask Bazaar to mark them as resolved using the ``resolve`` command like this::
 
   bzr resolve

=== modified file 'doc/en/user-guide/reviewing_changes.txt'
--- doc/en/user-guide/reviewing_changes.txt	2007-11-21 07:39:16 +0000
+++ doc/en/user-guide/reviewing_changes.txt	2009-12-02 20:34:07 +0000
@@ -8,7 +8,7 @@
 prior to permanently recording it. This way, you can make sure you'll be
 committing what you intend to.
 
-Two bzr commands are particularly useful here: **status** and **diff**.  
+Two bzr commands are particularly useful here: **status** and **diff**.
 
 bzr status
 ----------
@@ -45,6 +45,14 @@
     % bzr diff -r 1000..          # everything since r1000
     % bzr diff -r 1000..1100      # changes from 1000 to 1100
 
+To see the changes introduced by a single revision, you can use the ``-c``
+option to diff.
+
+::
+
+    % bzr diff -c 1000            # changes from r1000
+                                  # identical to -r999..1000
+
 The ``--diff-options`` option causes bzr to run the external diff program,
 passing options.  For example::
 
@@ -53,6 +61,6 @@
 Some projects prefer patches to show a prefix at the start of the path
 for old and new files.  The ``--prefix`` option can be used to provide
 such a prefix.
-As a shortcut, ``bzr diff -p1`` produces a form that works with the 
+As a shortcut, ``bzr diff -p1`` produces a form that works with the
 command ``patch -p1``.
 

=== modified file 'doc/en/user-guide/sending_changes.txt'
--- doc/en/user-guide/sending_changes.txt	2008-04-24 01:27:26 +0000
+++ doc/en/user-guide/sending_changes.txt	2009-12-02 20:34:07 +0000
@@ -34,11 +34,11 @@
 Creating a merge directive
 --------------------------
 
-To create and optionally send a merge directive, use the ``send`` command. 
+To create and optionally send a merge directive, use the ``send`` command.
 
 By default, ``send`` will email the merge directive to the "submission
 address" for the branch, which is typically the lead developer or the
-development mailing list.  
+development mailing list.
 ``send`` without options will create a merge directive, fire up your email
 tool and attach it, ready for you to add the explanatory text bit.
 (See the online help for ``send`` and

=== modified file 'doc/en/user-guide/server.txt'
--- doc/en/user-guide/server.txt	2009-09-17 03:16:05 +0000
+++ doc/en/user-guide/server.txt	2009-12-02 20:34:07 +0000
@@ -98,7 +98,7 @@
 server::
 
     bzr serve --port=localhost:1234 --directory=/srv/bzr/repo
-    
+
 client::
 
     bzr log bzr://localhost:1234/branchname

=== modified file 'doc/en/user-guide/setting_up_email.txt'
--- doc/en/user-guide/setting_up_email.txt	2009-04-04 02:50:01 +0000
+++ doc/en/user-guide/setting_up_email.txt	2009-12-02 20:34:07 +0000
@@ -13,7 +13,7 @@
 the email address in a revision gives others a way to contact the
 author of a revision for credit and/or blame.  :)
 
-How to set up your email address 
+How to set up your email address
 --------------------------------
 
 Bazaar will try to guess an email address based on your username and the
@@ -44,7 +44,7 @@
 
     % bzr whoami
     Joe Cool <joe@example.com>
-    
+
 Setting email via the 'whoami' command
 --------------------------------------
 

=== modified file 'doc/en/user-guide/shared_repository_layouts.txt'
--- doc/en/user-guide/shared_repository_layouts.txt	2009-02-26 11:28:50 +0000
+++ doc/en/user-guide/shared_repository_layouts.txt	2009-12-02 20:34:07 +0000
@@ -1,7 +1,7 @@
 Advanced shared repository layouts
 ==================================
 
-Bazaar is designed to give you flexibility in how you layout branches inside a shared repository. 
+Bazaar is designed to give you flexibility in how you layout branches inside a shared repository.
 This flexibility allows users to tailor Bazaar to their workflow,
 but it also leads to questions about what is a "good" layout.
 We present some alternatives and give some discussion about the benefits of each.
@@ -15,7 +15,7 @@
 "SVN-Style" (``trunk/``, ``branches/``)
 ---------------------------------------
 
-Most people coming from SVN will be familiar with their "standard" project layout. 
+Most people coming from SVN will be familiar with their "standard" project layout.
 Which is to layout the repository as::
 
   repository/       # Overall repository
@@ -27,11 +27,11 @@
        +- release-X # A branch specific to mark a given release version
           ...
 
-With Bazaar, that is a perfectly reasonable layout. 
-It has the benefit of being familiar to people coming from SVN, 
+With Bazaar, that is a perfectly reasonable layout.
+It has the benefit of being familiar to people coming from SVN,
 and making it clear where the development focus is.
 
-When you have multiple projects in the same repository, 
+When you have multiple projects in the same repository,
 the SVN layout is a little unclear what to do.
 
 
@@ -52,8 +52,8 @@
        +- branches/      # Container for project2 branches
 
 
-This also works with Bazaar. 
-However, with Bazaar repositories are cheap to create 
+This also works with Bazaar.
+However, with Bazaar repositories are cheap to create
 (a simple ``bzr init-repo`` away), and their primary benefit is when the
 branches share a common ancestry.
 
@@ -64,7 +64,7 @@
      +- branches/      # A container directory
          +- foo/       # Branch for developing feature foo of project1
            ...
-    
+
     project2/          # A repository for project2
      +- trunk/         # Mainline for project2
      +- branches/      # Container for project2 branches
@@ -100,17 +100,17 @@
         +- project1-foo/  # Branch 'foo' of project1
         +- project2-bar/  # Branch 'bar' of project2
 
-I believe the reason for this in SVN, is so that someone 
+I believe the reason for this in SVN, is so that someone
 can checkout all of "``trunk/``" and get the all the mainlines for all projects.
 
 This layout can be used for Bazaar, but it is not generally recommended.
 
- 1) ``bzr branch/checkout/get`` is a single branch at a time. 
+ 1) ``bzr branch/checkout/get`` is a single branch at a time.
     So you don't get the benefit of getting all mainlines with a single command. [1]_
 
- 2) It is less obvious of whether ``repository/trunk/foo`` is the ``trunk`` of project 
+ 2) It is less obvious of whether ``repository/trunk/foo`` is the ``trunk`` of project
     ``foo`` or it is just the ``foo`` directory in the ``trunk`` branch.
-    Some of this confusion is due to SVN, because it uses the same "namespace" 
+    Some of this confusion is due to SVN, because it uses the same "namespace"
     for files in a project that it uses for branches of a project.
     In Bazaar, there is a clear distinction of what files make up a project, versus
     the location of the Branch. (After all, there is only one ``.bzr/`` directory per branch,
@@ -148,7 +148,7 @@
       +- 1.0/
           +- 1.1.1/
 
-The idea with this layout is that you are creating a hierarchical layout for branches. 
+The idea with this layout is that you are creating a hierarchical layout for branches.
 Where changes generally flow upwards in the namespace. It also gives people a little
 corner of the namespace to work on their stuff.
 One nice feature of this layout, is it makes branching "cheaper" because it gives you
@@ -162,7 +162,7 @@
   bzr branch http://host/repository/project/branches/joe-feature-foo-bugfix-10/
 
 Versus::
-  
+
   bzr branch http://host/project/joe/foo/bugfix-10
 
 
@@ -175,7 +175,7 @@
   joe-bugfix-13/
   joe-frizban/
 
-Versus having these broken out by developer. 
+Versus having these broken out by developer.
 If the number of branches are small, ``branches/`` has the nice advantage
 of being able to see all branches in a single view.
 If the number of branches is large, ``branches/`` has the distinct disadvantage
@@ -183,7 +183,7 @@
 branch you are interested in, when there are 100 branches to look through).
 
 Nested branching seems to scale better to larger number of branches.
-However, each individual branch is less discoverable. 
+However, each individual branch is less discoverable.
 (eg. "Is Joe working on bugfix 10 in his feature foo branch, or his feature bar branch?")
 
 One other small advantage is that you can do something like::
@@ -192,7 +192,7 @@
   or
    bzr branch http://host/project/release/1/1/2
 
-To indicate release 1.1.1 and 1.1.2. This again depends on how many releases you have 
+To indicate release 1.1.1 and 1.1.2. This again depends on how many releases you have
 and whether the gain of splitting things up outweighs the ability to see more at a glance.
 
 
@@ -217,7 +217,7 @@
 It lets you see what branches are actively being developed on, which is usually
 only a small number, versus the total number of branches ever created.
 Old branches are not lost (versus deleting them), but they are "filed away",
-such that the more likely you are to want a branch the easier it is to find. 
+such that the more likely you are to want a branch the easier it is to find.
 (Conversely, older branches are likely to be harder to find).
 
 The biggest disadvantage with this layout, is that branches move around.
@@ -237,7 +237,7 @@
 that could be changed.
 This is actually how `Launchpad`_ allows you to ``bzr checkout https://launchpad.net/bzr``.
 Effectively a ``BranchReference`` is a symlink, but it allows you to reference any other URL.
-If it is extended to support relative references, it would even work over http, sftp, 
+If it is extended to support relative references, it would even work over http, sftp,
 and local paths.
 
 .. _Launchpad: https://launchpad.net
@@ -247,7 +247,7 @@
 --------------------------------------------------------------------------
 
 Another method of allowing some scalability while also allowing the
-browsing of "current" branches. Basically, this works on the assumption 
+browsing of "current" branches. Basically, this works on the assumption
 that actively developed branches will be "new" branches, and older branches
 are either merged or abandoned.
 
@@ -292,8 +292,8 @@
 The general idea is that by targeting a release, you can look at what branches are
 waiting to be merged. It doesn't necessarily give you a good idea of what the
 state of the branch (is it in development or finished awaiting review).
-It also has a history-hiding effect, and otherwise has the same benefits 
-and deficits as a date-based sorting. 
+It also has a history-hiding effect, and otherwise has the same benefits
+and deficits as a date-based sorting.
 
 
 Simple developer naming (``project/joe/foo``, ``project/barry/bar``)

=== modified file 'doc/en/user-guide/shelving_changes.txt'
--- doc/en/user-guide/shelving_changes.txt	2009-03-12 06:04:54 +0000
+++ doc/en/user-guide/shelving_changes.txt	2009-12-02 20:34:07 +0000
@@ -15,7 +15,7 @@
   +++ description.txt
   @@ -2,7 +2,7 @@
    ===============
-   
+
    These plugins
   -by Michael Ellerman
   +written by Michael Ellerman
@@ -23,7 +23,7 @@
    fine-grained 'undo'
    facility
   @@ -11,6 +11,6 @@
-   This allows you to 
+   This allows you to
    undo some of
    your changes,
   -commit, and get
@@ -39,7 +39,7 @@
   +++ description.txt
   @@ -2,7 +2,7 @@
    ===============
-   
+
    These plugins
   -by Michael Ellerman
   +written by Michael Ellerman
@@ -51,7 +51,7 @@
   --- description.txt
   +++ description.txt
   @@ -11,6 +11,6 @@
-   This allows you to 
+   This allows you to
    undo some of
    your changes,
   -commit, and get
@@ -63,7 +63,7 @@
   Shelve 2 change(s)? [yNfrq?]', 'y'
   Selected changes:
    M  description.txt
-  Changes shelved with id "1".  
+  Changes shelved with id "1".
 
 If there are lots of changes in the working tree, you
 can provide the ``shelve`` command with a list of files
@@ -77,7 +77,7 @@
   +++ description.txt
   @@ -2,7 +2,7 @@
    ===============
-   
+
    These plugins
   -by Michael Ellerman
   +written by Michael Ellerman

=== modified file 'doc/en/user-guide/specifying_revisions.txt'
--- doc/en/user-guide/specifying_revisions.txt	2009-04-04 02:57:47 +0000
+++ doc/en/user-guide/specifying_revisions.txt	2009-12-02 23:09:40 +0000
@@ -36,17 +36,23 @@
  +----------------------+------------------------------------+
  | *number*             | revision number                    |
  +----------------------+------------------------------------+
- | **revno**:*number*   | positive revision number           |
+ | **revno**:*number*   | revision number                    |
  +----------------------+------------------------------------+
  | **last**:*number*    | negative revision number           |
  +----------------------+------------------------------------+
+ | *guid*               | globally unique revision id        |
+ +----------------------+------------------------------------+
  | **revid**:*guid*     | globally unique revision id        |
  +----------------------+------------------------------------+
  | **before**:*rev*     | leftmost parent of ''rev''         |
  +----------------------+------------------------------------+
- | **date**:*value*     | first entry after a given date     |
- +----------------------+------------------------------------+
- | **tag**:*value*      | revision matching a given tag      |
+ | *date-value*         | first entry after a given date     |
+ +----------------------+------------------------------------+
+ | **date**:*date-value*| first entry after a given date     |
+ +----------------------+------------------------------------+
+ | *tag-name*           | revision matching a given tag      |
+ +----------------------+------------------------------------+
+ | **tag**:*tag-name*   | revision matching a given tag      |
  +----------------------+------------------------------------+
  | **ancestor**:*path*  | last merged revision from a branch |
  +----------------------+------------------------------------+
@@ -81,7 +87,7 @@
 ~~~~~
 
 **revid** allows specifying a an internal revision ID, as shown by ``bzr
-log`` and some other commands.
+log --show-ids`` and some other commands.
 
 For example::
 
@@ -128,7 +134,7 @@
 ~~~~~~~~
 
 **ancestor**:*path*
-    specifies the common ancestor between the current branch and a 
+    specifies the common ancestor between the current branch and a
     different branch. This is the same ancestor that would be used for
     merging purposes.
 

=== modified file 'doc/en/user-guide/stacked.txt'
--- doc/en/user-guide/stacked.txt	2009-07-20 08:47:58 +0000
+++ doc/en/user-guide/stacked.txt	2009-12-02 20:34:07 +0000
@@ -18,7 +18,7 @@
   than leaving them in a shared repository).
 
 * Security is improved over shared repositories, because the stacked-on
-  repository can be physically readonly to developers committing to stacked 
+  repository can be physically readonly to developers committing to stacked
   branches.
 
 These benefits make stacked branches ideal for various scenarios

=== modified file 'doc/en/user-guide/undoing_mistakes.txt'
--- doc/en/user-guide/undoing_mistakes.txt	2009-09-09 15:06:00 +0000
+++ doc/en/user-guide/undoing_mistakes.txt	2009-11-23 15:29:24 +0000
@@ -134,7 +134,7 @@
 which is probably only what you want if you haven't made any new commits
 since then. If you have, the ``revert`` would wipe them out as well. In that
 case, you probably want to use `Reverse cherrypicking
-<advanced_merging.html#reverse-cherrypicking>`_ instead to
+<adv_merging.html#reverse-cherrypicking>`_ instead to
 back out the bad fix.
 
 Note: As an alternative to using an absolute revision number (like 19), you can

=== modified file 'doc/en/user-guide/version_info.txt'
--- doc/en/user-guide/version_info.txt	2008-03-13 18:51:13 +0000
+++ doc/en/user-guide/version_info.txt	2009-12-02 20:34:07 +0000
@@ -104,5 +104,5 @@
 set the ``clean`` flag in ``version_info``, as well as set entries in
 ``file_revisions`` as ``modified`` where appropriate.
 
-.. 
+..
    vim: tw=74 ft=rst spell spelllang=en_us

=== modified file 'doc/en/user-guide/web_browsing.txt'
--- doc/en/user-guide/web_browsing.txt	2009-03-21 02:00:59 +0000
+++ doc/en/user-guide/web_browsing.txt	2009-12-02 20:34:07 +0000
@@ -5,10 +5,10 @@
 --------
 
 There are a range of options available for providing a web view of a
-Bazaar repository, the main one being Loggerhead. The homepage of Loggerhead 
+Bazaar repository, the main one being Loggerhead. The homepage of Loggerhead
 can be found at https://launchpad.net/loggerhead.
 
-A list of alternative web viewers including download links can be found on 
+A list of alternative web viewers including download links can be found on
 http://bazaar-vcs.org/WebInterface.
 
 Note: If your project is hosted or mirrored on Launchpad,

=== modified file 'doc/en/user-guide/zen.txt'
--- doc/en/user-guide/zen.txt	2008-06-06 11:55:58 +0000
+++ doc/en/user-guide/zen.txt	2009-12-02 20:34:07 +0000
@@ -56,7 +56,7 @@
   102: Add code and tests for X
   101: Add tests for Y
   100: ...
-  
+
 Many teams use this approach because their tools make branching and merging
 difficult. As a consequence, developers update from and commit to the trunk
 frequently, minimizing integration pain by spreading it over every commit.

=== modified file 'doc/es/_templates/layout.html'
--- doc/es/_templates/layout.html	2009-09-07 06:12:15 +0000
+++ doc/es/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -6,3 +6,22 @@
 <a href="http://doc.bazaar-vcs.org/en/">Documentación</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
+{{ super() }}
+{% endblock %}

=== modified file 'doc/es/index.txt'
--- doc/es/index.txt	2009-09-09 02:30:32 +0000
+++ doc/es/index.txt	2009-12-02 20:34:07 +0000
@@ -24,7 +24,7 @@
 * `Guias de Migracion <http://doc.bazaar-vcs.org/migration/en/>`_
   - para equipos que mudan el historial de otros SCV
 
-* `Guias de Plugins <http://doc.bazaar-vcs.org/plugins/en/>`_ 
+* `Guias de Plugins <http://doc.bazaar-vcs.org/plugins/en/>`_
 
 Otros Documentos (enlances web):
 

=== modified file 'doc/es/mini-tutorial/index.txt'
--- doc/es/mini-tutorial/index.txt	2009-09-08 01:19:48 +0000
+++ doc/es/mini-tutorial/index.txt	2009-12-02 20:34:07 +0000
@@ -8,9 +8,9 @@
 Bazaar es un sistema de control de versiones distribuido que facilita que
 varias personas puedan trabajar de forma conjunta en proyectos de software.
 
-A lo largo de los próximos cinco minutos, aprenderá cómo poner sus archivos 
-bajo control de versiones, como registrar cambios en ellos, examinar su 
-trabajo, publicarlo y enviar su trabajo para que sea integrado en el trunk de 
+A lo largo de los próximos cinco minutos, aprenderá cómo poner sus archivos
+bajo control de versiones, como registrar cambios en ellos, examinar su
+trabajo, publicarlo y enviar su trabajo para que sea integrado en el trunk de
 un proyecto.
 
 Si prefiere una introducción más detallada, eche un vistazo a
@@ -39,14 +39,14 @@
 Preséntese
 ==========
 
-Antes de empezar a trabajar, es conveniente que le diga a Bazaar quién es 
-usted. De ese modo su trabajo será identificando correctamente en los logs 
+Antes de empezar a trabajar, es conveniente que le diga a Bazaar quién es
+usted. De ese modo su trabajo será identificando correctamente en los logs
 de revisión.
 
 Utilice su nombre y dirección de email en lugar de John Doe, teclee::
 
   $ bzr whoami "John Doe <john.doe@gmail.com>"
-  
+
 Bazaar creará o modificará ahora un archivo de configuración, incluyendo su
 nombre y dirección de email.
 
@@ -65,7 +65,7 @@
  $ cd miproyecto
  $ mkdir subdirectorio
  $ touch test1.txt test2.txt test3.txt subdirectorio/test4.txt
- 
+
 **Nota para usuarios de Windows:** utilice Windows Explorer para crear sus
 directorios, luego haga click derecho en dichos directorios y seleccione
 ``Nuevo archivo`` para crear sus archivos.
@@ -73,14 +73,14 @@
 Ahora vamos a hacer que Bazaar se inicialize en el directorio de su proyecto::
 
   $ bzr init
-  
+
 Si parece que no ha ocurrido nada no se preocupe. Bazaar ha creado un
 branch_ dónde guardará sus archivos y su histórico de revisiones.
 
 .. _branch: http://bazaar-vcs.org/Branch
 
 El siguiente paso es decirle a Bazaar a que archivos desea seguirles la pista.
-Ejecutando ``bzr add`` agregará recursivamente todos los elementos dentro del 
+Ejecutando ``bzr add`` agregará recursivamente todos los elementos dentro del
 proyecto::
 
  $ bzr add
@@ -90,11 +90,11 @@
  added test3.txt
  added subdirectorio/test4.txt
 
-A continuación tome una instantánea de sus archivos agregándolos a su branch. 
+A continuación tome una instantánea de sus archivos agregándolos a su branch.
 Agregue un mensaje para explicar por qué hace el commit::
 
   $ bzr commit -m "Importación inicial"
-  
+
 Como Bazaar es un sistema de control de versiones distribuido, no necesita
 conectar con un servidor central para hacer el commit. Bazaar guarda su
 branch y todos sus commits dentro del directorio con el que está trabajando,
@@ -158,14 +158,14 @@
 
  $ bzr push --create-prefix sftp://su.nombre@example.com/~/public_html/miproyecto
  2 revision(s) pushed.
- 
+
 Bazaar creará un directorio ``miproyecto`` en el servidor remoto e
 introducirá su branch en él.
- 
+
 Ahora cualquiera podrá crear su propia copia de su branch tecleando::
 
  $ bzr branch http://www.example.com/miproyecto
- 
+
 **Nota:** para utilizar sftp deberá instalar ``paramiko`` y
 ``pyCrypto``. Vea http://bazaar-vcs.org/InstallationFaq para más información.
 
@@ -186,13 +186,13 @@
 
  $ bzr push bzr+ssh://john.doe@bazaar.launchpad.net/~john.doe/+junk/miproyecto
 
-**Nota:** ``+junk`` significa que este branch no está asociado con ningún proyecto 
+**Nota:** ``+junk`` significa que este branch no está asociado con ningún proyecto
 concreto en Launchpad.
 
 Ahora cualquiera podrá crear su propia copia de su branch tecleando::
 
  $ bzr branch http://bazaar.launchpad.net/~john.doe/+junk/miproyecto
- 
+
 También puede ver información sobre su branch, histórico de revisiones
 incluido, en https://code.launchpad.net/people/+me/+junk/miproyecto
 
@@ -204,7 +204,7 @@
 copia de su branch. Vamos a coger un ejemplo real, la interfaz GTK de Bazaar::
 
   $ bzr branch http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk bzr-gtk.john
-  Branched 292 revision(s).                                                        
+  Branched 292 revision(s).
 
 Bazaar descargará todos los archivos y el histórico de revisiones completo
 del trunk branch del proyecto bzr-gtk y creará una copia llamada
@@ -228,11 +228,11 @@
   $ bzr merge
   Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
   All changes applied successfully.
-            
+
 Compruebe qué ha cambiado::
 
   $ bzr diff
- 
+
 Si está contento con los cambios puede añadirlos en su branch personal::
 
   $ bzr commit -m "Integración desde el branch principal"
@@ -255,12 +255,12 @@
 
  $ bzr send -o mycode.patch
  Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
- 
+
 Ahora puede enviar por email la instruccion merge al proyecto bzr-gtk
 quien, si así lo quieren, pueden utilizarla para integrar su trabajo
 dentro del branch principal.
- 
- 
+
+
 Aprendiendo más
 ===============
 

=== modified file 'doc/es/user-guide/index-plain.txt'
--- doc/es/user-guide/index-plain.txt	2009-09-09 12:57:43 +0000
+++ doc/es/user-guide/index-plain.txt	2010-01-04 14:33:22 +0000
@@ -50,7 +50,7 @@
 .. include later - partner_intro.txt
 .. include later - branching_a_project.txt
 .. include later - merging_changes.txt
-.. include:: resolving_conflicts.txt
+.. include later - resolving_conflicts.txt
 .. include later - annotating_changes.txt
 
 
@@ -100,7 +100,7 @@
 .. include later - server.txt
 .. include later - hooks.txt
 .. include:: version_info.txt
- 
+
 
 Apéndice
 ########

=== modified file 'doc/es/user-guide/index.txt'
--- doc/es/user-guide/index.txt	2009-09-08 01:19:48 +0000
+++ doc/es/user-guide/index.txt	2010-01-04 14:33:22 +0000
@@ -50,7 +50,7 @@
 .. include later - partner_intro.txt
 .. include later - branching_a_project.txt
 .. include later - merging_changes.txt
-.. include:: resolving_conflicts.txt
+.. include later - resolving_conflicts.txt
 .. include later - annotating_changes.txt
 
 
@@ -100,7 +100,7 @@
 .. include later - server.txt
 .. include later - hooks.txt
 .. include:: version_info.txt
- 
+
 
 Apéndice
 ########

=== modified file 'doc/es/user-guide/version_info.txt'
--- doc/es/user-guide/version_info.txt	2008-05-04 18:17:45 +0000
+++ doc/es/user-guide/version_info.txt	2009-12-02 20:34:07 +0000
@@ -5,7 +5,7 @@
 Repaso General
 ==============
 
-Este documento describe las formas de usar ``bzr version-info`` como 
+Este documento describe las formas de usar ``bzr version-info`` como
 parte del proceso de embeber la informacion de vesion a un proyecto.
 
 
@@ -14,7 +14,7 @@
 
 TODO: Figure out how to attach into ``setup.py``
 
-Si usa un archivo Makefile para construir su proyecto, puede generar un 
+Si usa un archivo Makefile para construir su proyecto, puede generar un
 archivo on la informacion de version tan simple como::
 
   library/_version.py:
@@ -25,29 +25,29 @@
   * `version_info`: Un diccionario conteniendo informacion basica sobre el
     estado actual
 
-  * `revisions`: Un diccionario listando todas las revisiones en 
-    el historial del tree, junto con los tiempos y los mensajes de 
-    los commits. Esto por defecto esta en blanco salvi que use ``--all`` 
-    o `--include-history`` es provisto. Esto es util si quiere seguir 
-    que bugs arregla el lanzamiento de esa version. Para muchos proyectos 
+  * `revisions`: Un diccionario listando todas las revisiones en
+    el historial del tree, junto con los tiempos y los mensajes de
+    los commits. Esto por defecto esta en blanco salvi que use ``--all``
+    o `--include-history`` es provisto. Esto es util si quiere seguir
+    que bugs arregla el lanzamiento de esa version. Para muchos proyectos
     es mas informacion de la que se va a necesitar.
 
   * `file_revisions`: Un diccionario listando la revision que modifico
-    por ultima vez todos los archivos del proyecto. Esto puede ser usado 
-    similarmente a como se usan las palabras claves ``$Id$`` en los 
-    archivos controlados en CVS. La ultima fecha de modificacion puede 
-    ser determinada mirando en el mapa de ``revisions``. Esto tambien 
+    por ultima vez todos los archivos del proyecto. Esto puede ser usado
+    similarmente a como se usan las palabras claves ``$Id$`` en los
+    archivos controlados en CVS. La ultima fecha de modificacion puede
+    ser determinada mirando en el mapa de ``revisions``. Esto tambien
     esta vacio por defecto, y habilitado solo por ``--all`` o
     ``--include-file-revisions``.
-    
+
 
 Check Clean
 ===========
 
-La mayoria de la informacion sobre el contenido del proyecto puede 
+La mayoria de la informacion sobre el contenido del proyecto puede
 ser determinada a muy bajo costo con solo leer las entradas de revisiones.
-Sin embargo, puede ser util si el working tree fue actualizado completamente 
-cuando fue empaquetado, o si hubo alguna modificacion local. Al proveer 
-``--all`` o ``--check-clean``, ``bzr`` va a inspeccionar el working tree, 
-y definir el ``clean`` flag en ``version_info``, al igual que definir 
+Sin embargo, puede ser util si el working tree fue actualizado completamente
+cuando fue empaquetado, o si hubo alguna modificacion local. Al proveer
+``--all`` o ``--check-clean``, ``bzr`` va a inspeccionar el working tree,
+y definir el ``clean`` flag en ``version_info``, al igual que definir
 entradas en ``file_revisions`` como ``modified`` donde es apropiado.

=== modified file 'doc/index.es.txt'
--- doc/index.es.txt	2009-09-09 12:57:43 +0000
+++ doc/index.es.txt	2009-12-02 20:34:07 +0000
@@ -8,13 +8,13 @@
 Documentacion Principal
 =======================
 
-* `Mini Tutorial <es/mini-tutorial/index.html>`_ 
+* `Mini Tutorial <es/mini-tutorial/index.html>`_
 
 * `Referencia Rapida <es/_static/es/bzr-es-quick-reference.svg>`_
 
-* `Guia de Usuario <es/user-guide/index-plain.html>`_ 
+* `Guia de Usuario <es/user-guide/index-plain.html>`_
 
-* `Referencia <en/user-reference/bzr_man.html>`_ 
+* `Referencia <en/user-reference/bzr_man.html>`_
 
 * `Notas sobre la Version <en/release-notes/NEWS.html>`_
 
@@ -26,7 +26,7 @@
 
 Mudandose a Bazaar (enlances web):
 
-* `Guias de Mudanzas <http://bazaar-vcs.org/BzrSwitching>`_ 
+* `Guias de Mudanzas <http://bazaar-vcs.org/BzrSwitching>`_
   - para los usuarios que se mudan de otros SCV
 
 * `Guias de Migracion <http://bazaar-vcs.org/BzrMigration>`_

=== added file 'doc/index.ja.txt'
--- doc/index.ja.txt	1970-01-01 00:00:00 +0000
+++ doc/index.ja.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,85 @@
+===========================
+Bazaarのメインドキュメント
+===========================
+
+これらのドキュメントの最新版はBazaarのドキュメントのサイト、 http://doc.bazaar-vcs.org/ から入手可能で、
+詳しい情報は http://bazaar-vcs.org/Documentation のページからリンクされています。
+
+
+コアドキュメント
+================
+
+* `ユーザーガイド <ja/user-guide/index.html>`_
+
+* `ユーザーリファレンス <ja/user-reference/bzr_man.html>`_
+
+* `クィックスタートカード(PNG) <http://gigo-ice.org/scm/bazaar/wiki/bzr-quickref.ja.png>`_
+  `(PDF) <http://gigo-ice.org/scm/bazaar/wiki/bzr-quickref.ja.pdf>`_
+
+* `リリースノート(英語) <en/release-notes/NEWS.html>`_
+
+* `2.0 Upgrade Guide (英語) <en/upgrade-guide/index.html>`_
+
+チュートリアル
+===============
+
+* `5分でBazaar <ja/mini-tutorial/index.html>`_
+
+* `A longer tutorial (英語) <en/tutorials/tutorial.html>`_
+
+* `Using Bazaar with Launchpad (英語) <en/tutorials/using_bazaar_with_launchpad.html>`_
+
+* `Centralized workflow (英語) <en/tutorials/centralized_workflow.html>`_
+
+
+Developer Documentation
+=======================
+
+* `Developer Document Catalog <developers/index-plain.html>`_ |--| for developers
+  of Bazaar and plugins
+
+
+ウェブリンク
+=============
+
+* `切り替えガイド <http://bazaar-vcs.org/BzrSwitching>`_
+  |--| 別のVCSツールから移ってきたユーザー用
+
+* `移行ガイド <http://bazaar-vcs.org/BzrMigration>`_
+  |--| 別のVCSツールから履歴を移行するチーム用
+
+* `用語 <http://bazaar-vcs.org/BzrGlossary>`_
+
+* `よく聞かれる質問 <http://bazaar-vcs.org/FAQ>`_
+
+
+TortoiseBzrをインストールするには？
+===================================
+
+https://launchpad.net/bzr/+download からbzr-setup-x.xxx.exeを入手し、
+ファイルをダブルクリックをしてインストールウィザードを起動させます。
+その後の作業はインストールウィザードに従います。
+インストールウィザードが終了した後で再起動します。
+
+最新バージョンでも正常に動作しないことがあるので、
+その場合は古いバージョンをインストールします。
+2009年1月時点で筆者はbzr-setup-1.9.exeの基本的な動作を確認しています。
+
+もしPythonインタープリタにbzrをインストールした場合、インストールしたディレクトリによって
+bzr.exe(デフォルトでは `C:\Program Files\Bazaar` )よりもbzr.bat(`C:\PythonXX\Scripts`)が
+優先されるので、コマンドプロンプトでbzrと入力したときにbzr.exeが実行されるようにするには、
+bzr.batをbzr.txtなどにリネームします。
+
+
+Other Languages
+===============
+
+* `Spanish Documentation <index.es.html>`_
+* `Russian Documentation <index.ru.html>`_ |--| документация на русском
+* `Japanese Documentation <index.ja.html>`_ |--| 日本語ドキュメント
+
+
+.. |--| unicode:: U+2014
+
+..
+   vim: ft=rst tw=74 ai

=== modified file 'doc/index.ru.txt'
--- doc/index.ru.txt	2009-09-09 12:57:43 +0000
+++ doc/index.ru.txt	2009-12-02 20:34:07 +0000
@@ -2,8 +2,8 @@
 Главный каталог документов Bazaar
 =================================
 
-Последняя версия этих документов доступа со страницы документации 
-на сайте Bazaar, <http://doc.bazaar-vcs.org/>. Еще больше информации 
+Последняя версия этих документов доступа со страницы документации
+на сайте Bazaar, <http://doc.bazaar-vcs.org/>. Еще больше информации
 можно получить по адресу <http://bazaar-vcs.org/Documentation>.
 
 Основная документация
@@ -19,7 +19,7 @@
 
 * `Список изменений <en/release-notes/NEWS.html>`_ (англ.)
 
-* `Каталог информации для разработчиков <developers/index-plain.html>`_ (англ.) |--| 
+* `Каталог информации для разработчиков <developers/index-plain.html>`_ (англ.) |--|
   для разработчиков Bazaar и плагинов
 
 Учебники
@@ -29,7 +29,7 @@
 
 * `Большой учебник <ru/tutorials/tutorial.html>`_
 
-* `Использование Bazaar с Launchpad 
+* `Использование Bazaar с Launchpad
   <ru/tutorials/using_bazaar_with_launchpad.html>`_
 
 * `Работа в централизованном стиле
@@ -44,9 +44,9 @@
 * `Руководство по миграции <http://bazaar-vcs.org/BzrMigration>`_
   |--| для команд переносящих историю с других систем контроля версий
 
-* `Словарь терминов <http://bazaar-vcs.org/BzrGlossary>`_ (англ.), 
-  см. также `русскую версию`__ 
-  
+* `Словарь терминов <http://bazaar-vcs.org/BzrGlossary>`_ (англ.),
+  см. также `русскую версию`__
+
 __  http://groups.google.com/group/ru_bzr/web/%D0%B3%D0%BB%D0%BE%D1%81%D1%81%D0%B0%D1%80%D0%B8%D0%B9
 
 * `Часто задаваемые вопросы <http://bazaar-vcs.org/FAQ>`_ (англ.)

=== modified file 'doc/index.txt'
--- doc/index.txt	2009-09-10 02:09:26 +0000
+++ doc/index.txt	2009-10-29 10:01:19 +0000
@@ -9,9 +9,9 @@
 Core Documentation
 ==================
 
-* `User Guide <en/user-guide/index-plain.html>`_ 
+* `User Guide <en/user-guide/index-plain.html>`_
 
-* `User Reference <en/user-reference/bzr_man.html>`_ 
+* `User Reference <en/user-reference/bzr_man.html>`_
 
 * `Quick Start Card <en/_static/en/bzr-en-quick-reference.svg>`_
   (`PDF <en/_static/en/bzr-en-quick-reference.pdf>`_,
@@ -19,19 +19,19 @@
 
 * `Release Notes <en/release-notes/NEWS.html>`_
 
-* `2.0 Upgrade Guide <en/upgrade-guide/index.html>`_ 
+* `2.0 Upgrade Guide <en/upgrade-guide/index.html>`_
 
 
 Tutorials
 =========
 
-* `Bazaar in five minutes <en/mini-tutorial/index.html>`_ 
-
-* `A longer tutorial <en/tutorials/tutorial.html>`_ 
-
-* `Using Bazaar with Launchpad <en/tutorials/using_bazaar_with_launchpad.html>`_ 
-
-* `Centralized workflow <en/tutorials/centralized_workflow.html>`_ 
+* `Bazaar in five minutes <en/mini-tutorial/index.html>`_
+
+* `A longer tutorial <en/tutorials/tutorial.html>`_
+
+* `Using Bazaar with Launchpad <en/tutorials/using_bazaar_with_launchpad.html>`_
+
+* `Centralized workflow <en/tutorials/centralized_workflow.html>`_
 
 
 Developer Documentation
@@ -43,7 +43,7 @@
 Web links
 =========
 
-* `Switching Guides <http://bazaar-vcs.org/BzrSwitching>`_ 
+* `Switching Guides <http://bazaar-vcs.org/BzrSwitching>`_
   |--| for users moving from another VCS tool
 
 * `Migration Guide <http://bazaar-vcs.org/BzrMigration>`_
@@ -59,6 +59,7 @@
 
 * `Spanish Documentation <index.es.html>`_
 * `Russian Documentation <index.ru.html>`_ |--| документация на русском
+* `Japanese Documentation <index.ja.html>`_ |--| 日本語のドキュメント
 
 .. |--| unicode:: U+2014
 

=== added directory 'doc/ja'
=== added directory 'doc/ja/_static'
=== added file 'doc/ja/_static/bzr icon 16.png'
Binary files doc/ja/_static/bzr icon 16.png and doc/ja/_static/bzr icon 16.png differ
=== added file 'doc/ja/_static/bzr.ico'
Binary files doc/ja/_static/bzr.ico and doc/ja/_static/bzr.ico differ
=== added directory 'doc/ja/_templates'
=== added file 'doc/ja/conf.py'
--- doc/ja/conf.py	1970-01-01 00:00:00 +0000
+++ doc/ja/conf.py	2009-11-18 06:18:14 +0000
@@ -0,0 +1,93 @@
+# -*- coding: utf-8 -*-
+#
+# Bazaar documentation build configuration file, created by
+# sphinx-quickstart on Tue Jul 21 17:04:52 2009.
+#
+# This file is execfile()d with the current directory set to its containing dir.
+
+import sys, os
+
+# If extensions (or modules to document with autodoc) are in another directory,
+# add these directories to sys.path here. If the directory is relative to the
+# documentation root, use os.path.abspath to make it absolute, like shown here.
+sys.path = [os.path.abspath('../..')] + sys.path
+
+# Most of the configuration for Bazaar docs is defined here ...
+from bzrlib.doc_generate.sphinx_conf import *
+
+
+## Configuration specific to this site ##
+
+# The locale code for this documentation set
+bzr_locale = 'ja'
+
+# Translations & supporting helper function
+bzr_titles = {
+        u'Table of Contents (%s)': u'目次 (%s)',
+        u'Bazaar User Guide': u'ユーザーガイド',
+        u'Bazaar User Reference': u'ユーザーリファレンス',
+        u'Bazaar Release Notes': u'リリースノート',
+        u'Bazaar Upgrade Guide': u'アップグレードガイド',
+        u'Bazaar in five minutes': u'5分でBazaar',
+        u'Bazaar Tutorial': u'チュートリアル',
+        u'Using Bazaar With Launchpad': None,
+        u'Centralized Workflow Tutorial': None,
+    }
+def bzr_title(s):
+    return bzr_titles.get(s) or s
+
+# The language for content autogenerated by Sphinx. Refer to documentation
+# for a list of supported languages.
+language = bzr_locale
+
+# A shorter title for the navigation bar.  Default is the same as html_title.
+html_short_title = bzr_title(u"Table of Contents (%s)") % (release,)
+
+# Additional templates that should be rendered to pages, maps page names to
+# template names.
+# html_additional_pages = {'index': 'index.html'}
+
+# Output file base name for HTML help builder.
+htmlhelp_basename = 'bzr-%s' % (bzr_locale,)
+
+# Grouping the document tree into LaTeX files. List of tuples
+# (source start file, target name, title, author, documentclass [howto/manual]).
+latex_documents = [
+  # Manuals
+  ('user-guide/index', 'bzr-%s-user-guide.tex' % (bzr_locale,),
+    bzr_title(u'Bazaar User Guide'), bzr_team, 'manual'),
+  ('user-reference/bzr_man', 'bzr-%s-user-reference.tex' % (bzr_locale,),
+    bzr_title(u'Bazaar User Reference'), bzr_team, 'manual'),
+  #('release-notes/NEWS', 'bzr-%s-release-notes.tex' % (bzr_locale,),
+  #  bzr_title(u'Bazaar Release Notes'), bzr_team, 'manual'),
+  #('upgrade-guide/index', 'bzr-%s-upgrade-guide.tex' % (bzr_locale,),
+  #  bzr_title(u'Bazaar Upgrade Guide'), bzr_team, 'manual'),
+  # Tutorials
+  ('mini-tutorial/index', 'bzr-%s-tutorial-mini.tex' % (bzr_locale,),
+    bzr_title(u'Bazaar in five minutes'), bzr_team, 'howto'),
+  #('tutorials/tutorial', 'bzr-%s-tutorial.tex' % (bzr_locale,),
+  #  bzr_title(u'Bazaar Tutorial'), bzr_team, 'howto'),
+  #('tutorials/using_bazaar_with_launchpad',
+  #  'bzr-%s-tutorial-with-launchpad.tex' % (bzr_locale,),
+  #  bzr_title(u'Using Bazaar With Launchpad'), bzr_team, 'howto'),
+  #('tutorials/centralized_workflow',
+  #  'bzr-%s-tutorial-centralized.tex' % (bzr_locale,),
+  #  bzr_title(u'Centralized Workflow Tutorial'), bzr_team, 'howto'),
+]
+
+# List of documents that shouldn't be included in the build.
+unused_docs = [
+    # Subtopics that get included
+    'upgrade-guide/overview',
+    'upgrade-guide/data_migration',
+    'upgrade-guide/tips_and_tricks',
+    #'user-guide/resolving_conflicts',
+    #'user-guide/version_info',
+    # Plain-style documentation generation stuff
+    'release-notes/NEWS',
+    'user-reference/bzr_man',
+    'user-guide/index-plain',
+    # Miscellaneous
+    'user-reference/readme',
+]
+

=== added file 'doc/ja/index.txt'
--- doc/ja/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/index.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,56 @@
+===========================
+Bazaarのメインドキュメント
+===========================
+
+これらのドキュメントの最新版はBazaarのドキュメントのサイト、 http://doc.bazaar-vcs.org/ から入手可能で、
+詳しい情報は http://bazaar-vcs.org/Documentation のページからリンクされています。
+
+
+目次
+=====
+
+.. toctree::
+   :maxdepth: 1
+
+   tutorials/index
+   user-guide/index
+   user-reference/bzr_man
+
+
+ウェブリンク
+=============
+
+* `切り替えガイド <http://bazaar-vcs.org/BzrSwitching>`_
+  |--| 別のVCSツールから移ってきたユーザー用
+
+* `移行ガイド <http://bazaar-vcs.org/BzrMigration>`_
+  |--| 別のVCSツールから履歴を移行するチーム用
+
+* `用語 <http://bazaar-vcs.org/BzrGlossary>`_
+
+* `よく聞かれる質問 <http://bazaar-vcs.org/FAQ>`_
+
+
+TortoiseBzrをインストールするには？
+===================================
+
+https://launchpad.net/bzr/+download からbzr-setup-x.xxx.exeを入手し、
+ファイルをダブルクリックをしてインストールウィザードを起動させます。
+その後の作業はインストールウィザードに従います。
+インストールウィザードが終了した後で再起動します。
+
+最新バージョンでも正常に動作しないことがあるので、
+その場合は古いバージョンをインストールします。
+2009年1月時点で筆者はbzr-setup-1.9.exeの基本的な動作を確認しています。
+
+もしPythonインタープリタにbzrをインストールした場合、インストールしたディレクトリによって
+bzr.exe(デフォルトでは ``C:\Program Files\Bazaar`` )よりもbzr.bat(``C:\PythonXX\Scripts``)が
+優先されるので、コマンドプロンプトでbzrと入力したときにbzr.exeが実行されるようにするには、
+bzr.batをbzr.txtなどにリネームします。
+
+
+
+.. |--| unicode:: U+2014
+
+..
+   vim: ft=rst tw=74 ai

=== added directory 'doc/ja/mini-tutorial'
=== added file 'doc/ja/mini-tutorial/index.txt'
--- doc/ja/mini-tutorial/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/mini-tutorial/index.txt	2009-10-29 16:52:18 +0000
@@ -0,0 +1,275 @@
+=================
+5分でわかるBazaar
+=================
+
+.. _introduction:
+
+イントロダクション
+===================
+
+Bazaarは分散型バージョン管理システムで、ソフトウェアプロジェクトの共同作業を楽にしてくれます。
+
+これから5分ほどで、ファイルをバージョン管理下に置き、変更をそれらに記録して、\
+作業内容を確認し、公開して作業内容をマージしてもらうためにプロジェクトのtrunkに\
+送る方法などを学びます。
+
+詳細な紹介内容を望むのであれば、 `さらに学ぶ`_ をご覧ください。
+
+
+インストール方法
+=================
+
+このガイドではBazaarをインストールする方法を説明しませんが、通常はとても簡単です。
+インストール方法の手引きは次の通りです:
+
+- **GNU/Linux:** おそらくBazaarはあなたのGNU/Linuxディストリビューションに含まれています。
+- **Windows:** `Windowsのためのインストールの手引き`_.
+- **Mac OS X:** `Mac OS Xのためのインストールの手引き`_.
+
+別のプラットフォームとソースコードからインストールする方法に関しては、 ダウンロード_
+と インストール方法_ のページを参照してください。
+
+.. _Windowsのためのインストールの手引き: http://bazaar-vcs.org/WindowsDownloads
+.. _Mac OS Xのためのインストールの手引き: http://bazaar-vcs.org/MacOSXBundle
+.. _ダウンロード: http://bazaar-vcs.org/Download
+.. _インストール方法: http://bazaar-vcs.org/InstallationFaq
+
+
+まずは自己紹介
+=================
+
+作業にとりかかる前に、まずあなたが誰なのかをBazaarに教えてあげましょう。
+そうすることで、履歴の中からあなたの作業を正確に識別することができます。
+
+次のように入力してください(もちろん、あなたの名前とEメールアドレスで)::
+
+  $ bzr whoami "John Doe <john.doe@gmail.com>"
+
+こうするとBazaarは、あなたの名前やEメールアドレスが入った設定ファイルを作成\
+もしくは修正します。
+
+名前とEメールアドレスが正しく登録されているか確認しましょう ::
+
+  $ bzr whoami
+  John Doe <john.doe@gmail.com>
+
+
+ファイルをバージョン管理する
+=============================
+
+Bazaarで扱うディレクトリといくつかのファイルを作りましょう::
+
+ $ mkdir myproject
+ $ cd myproject
+ $ mkdir subdirectory
+ $ touch test1.txt test2.txt test3.txt subdirectory/test4.txt
+
+**Windowsユーザーのための注意:** Windows Explorerを使ってディレクトリを作成し、\
+そのディレクトリの中で右クリックをして ``新規作成`` を選択し、ファイルを作成します。
+
+Bazaarにあなたのプロジェクトディレクトリを初期化させましょう::
+
+  $ bzr init
+
+何も起きていないように見えても心配しないでください。
+Bazaarはファイルとリビジョンの履歴を保存する branch_ を作りました。
+
+.. _branch: http://bazaar-vcs.org/Branch
+
+次のステップはBazaarに管理して欲しいファイルを教えることです。
+``bzr add`` を実行するとすべてのディレクトリとファイルがプロジェクトに\
+再帰的に追加されます::
+
+ $ bzr add
+ added subdirectory
+ added test1.txt
+ added test2.txt
+ added test3.txt
+ added subdirectory/test4.txt
+
+次に、これらをブランチにコミットしてスナップショットをとります。
+コミットを行った理由を説明するメッセージを追加します::
+
+  $ bzr commit -m "Initial import"
+
+Bazaarは分散型バージョン管理システムなので、コミットするために\
+サーバーに接続する必要はありません。
+代わりに、Bazaarはブランチとすべてのコミットをあなたが作業している\
+ディレクトリ内部に保存します;
+``.bzr`` というサブディレクトリをご覧ください。
+
+
+ファイルを変更する
+===================
+
+ファイルを変更してブランチにその変更をコミットしてみましょう。
+
+好きなエディタで ``test1.txt`` を編集し、何を行ったのかを確認します::
+
+ $ bzr diff
+ === modified file 'test1.txt'
+ --- test1.txt   2007-10-08 17:56:14 +0000
+ +++ test1.txt   2007-10-08 17:46:22 +0000
+ @@ -0,0 +1,1 @@
+ +test test test
+
+作業をBazaarのブランチにコミットします::
+
+  $ bzr commit -m "Added first line of text"
+  Committed revision 2.
+
+
+リビジョンのログを眺める
+=========================
+
+ログを閲覧することでブランチの履歴がわかります::
+
+  $ bzr log
+  ------------------------------------------------------------
+  revno: 2
+  committer: John Doe <john.doe@gmail.com>
+  branch nick: myproject
+  timestamp: Mon 2007-10-08 17:56:14 +0000
+  message:
+    Added first line of text
+  ------------------------------------------------------------
+  revno: 1
+  committer: John Doe <john.doe@gmail.com>
+  branch nick: myproject
+  timestamp: Mon 2006-10-08 17:46:22 +0000
+  message:
+    Initial import
+
+
+sftpでブランチを公開する
+=========================
+
+ブランチを公開する方法は複数あります。
+SFTPサーバーがすでにあるもしくは容易にセットアップできるのであれば、\
+ブランチをそこで公開できます。
+
+そうでなければ、このセクションをとばして、Bazaarのための無料ホスティング\
+サービスである、 Launchpad_ で公開しましょう。
+
+.. _Launchpad: https://launchpad.net/
+
+``www.example.com/myproject`` でブランチを公開することを前提とします::
+
+ $ bzr push --create-prefix sftp://your.name@example.com/~/public_html/myproject
+ 2 revision(s) pushed.
+
+Bazaarはリモートサーバー上で ``myproject`` ディレクトリを作りブランチを\
+そこにpushします。
+
+これで誰でも次のコマンドを入力すればあなたのブランチをコピーできます::
+
+ $ bzr branch http://www.example.com/myproject
+
+**注:** sftpを使うためには、 ``paramiko`` と ``pyCrypto`` をインストールする必要があります。
+詳細は http://bazaar-vcs.org/InstallationFaq を参照してください。
+
+
+Launchpadでブランチを公開する
+==============================
+
+Launchpadはフリーソフトウェアのための開発とホスティングのためのツールが\
+ひとまとめになったものです。これをブランチを公開するために利用できます。
+
+Launchpadのアカウントを持っていなければ、 `アカウントのサインアップのガイド`_
+に従ってアカウントを作り、 `SSHキーを登録`_ してください。
+
+.. _アカウントのサインアップのガイド: https://help.launchpad.net/CreatingYourLaunchpadAccount
+.. _SSHキーを登録: https://launchpad.net/people/+me/+editsshkeys
+
+次のコマンドを(``john.doe`` を自分のLaunchpadアカウント名に変更して)実行してください::
+
+ $ bzr push bzr+ssh://john.doe@bazaar.launchpad.net/~john.doe/+junk/myproject
+
+**注:** ``+junk`` はこのブランチがLaunchpad上の特定のプロジェクトに関連していないことを意味します。
+
+これで、誰でも次のコマンドを入力することでブランチのコピーを作ることができます::
+
+ $ bzr branch http://bazaar.launchpad.net/~john.doe/+junk/myproject
+
+ブランチとリビジョンの履歴に関する情報は https://code.launchpad.net/people/+me/+junk/myproject
+でも見ることができます。
+
+別のブランチから自分用のコピーを作る
+=====================================
+
+他人のコードに取り組むために、ブランチのコピーを作ることができます。
+実際の世界の例として、BazaarのGTKインターフェイスを見てみましょう::
+
+  $ bzr branch http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk bzr-gtk.john
+  Branched 292 revision(s).
+
+Bazaarはbzr-gtkのtrunkブランチからすべてのファイルをダウンロードして\
+リビジョンの履歴をそろえ、bzr-gtk.johnというコピーを作ります。
+
+これで、ブランチのコピーを手に入れたのでネットの接続のあるなしに\
+関わらず変更をコミットできます。
+ブランチはいつでも公開することで共有でき、bzr-gtkチームがあなたの作品を\
+使いたいと思ったときにBazaarは彼らがあなたのブランチから彼らのブランチに\
+マージし直す作業を簡単にしてくれます。
+
+
+メインのブランチから自分のブランチを更新する
+=============================================
+
+変更を自分のブランチにコミットする一方で、他の人がコードを親のブランチに\
+コミットしているということもよくあります。
+
+自分のブランチを最新に維持するには、親ブランチから自分のブランチへと変更を\
+マージします::
+
+  $ bzr merge
+  Merging from saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+  All changes applied successfully.
+
+何が変更されたのか確認します::
+
+  $ bzr diff
+
+変更に満足したら、それらを自分のブランチにコミットします::
+
+  $ bzr commit -m "Merge from main branch"
+  Committed revision 295.
+
+
+作業を親のブランチにマージする
+==============================
+
+bzr-gtkの個人ブランチに取り組んだ後で、あなたの変更を上流のプロジェクトに\
+戻したいことがあるかもしれません。
+最も簡単な方法はマージディレクティブを使うことです。
+
+マージディレクティブ(merge directive)とは、コンピュータに特定のマージを実行\
+させるためのリクエストです。
+マージディレクティブは大抵、マージをレビューするためのパッチと、マージを実行する\
+のに必要となるリビジョン、もしくはリビジョンを取得できるブランチを含みます。
+
+次のコマンドの ``mycode.patch`` を適当な名前に書き換えて、マージのディレクティブを作ります::
+
+ $ bzr send -o mycode.patch
+ Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
+
+これでbzr-gtkのプロジェクトにマージディレクティブをEメールで送ることが可能に\
+なりました。彼らが納得すれば、親ブランチにマージすることができます。
+
+
+さらに学ぶ
+==========
+
+Bazaarに関する詳細な内容は `Bazaarのユーザーガイド <../user-guide/index.html>`_ で調べることができます。
+
+コマンドラインでBazaarを学ぶには::
+
+  $ bzr help
+
+Bazaarのコマンドを学ぶには::
+
+  $ bzr help commands
+
+''foo'' トピックもしくはコマンドを学ぶには::
+
+  $ bzr help foo

=== added directory 'doc/ja/tutorials'
=== added file 'doc/ja/tutorials/centralized_workflow.txt'
--- doc/ja/tutorials/centralized_workflow.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/tutorials/centralized_workflow.txt	2009-10-29 16:52:18 +0000
@@ -0,0 +1,276 @@
+========================================
+集中型ワークフローのチュートリアル
+========================================
+
+
+概要
+====
+
+この文書では、 Bazaar_ を使用することで実現可能なワークフローについて説明します。
+つまり、分散バージョンコントロールシステムである Bazaar_ を、集中型のやり方で使用するためのワークフローです。 
+Bazaar_ は、非常にフレキシブルに設計されており、完全な分散型からほとんど集中型のワークフローまで、\
+いくつかの異なるワークフローを受け入れることができます。
+このワークフローは、初めてのユーザでも簡単に Bazaar_ を使いこなすことができ、\
+分散型と集中型のオペレーションを組み合わせた業務にも対応できるようになっています。
+
+基本的に、この文書はCVSやSubvresionのような集中型バージョンコントロールシステムの経験があるユーザ向けに書かれています。
+これらの環境では、一般的に、コードベースをホストする単一の中央サーバが存在し、複数の人々がこのコードベース上で作業して、\
+お互いの作業の同期をとることになります。 
+また、このワークフローは、一人の開発者が複数のマシーン上で作業をする場合にも適用できます。
+
+.. _Bazaar: http://bazaar-vcs.org
+
+
+初期セットアップ
+================
+
+Bazaar_ がうまく動くようにするための、まあまあ簡単なセットアップ手順があります。
+
+ユーザのEメールの設定
+---------------------
+
+ユーザIDは各コミットに保存されます。これは正確だったり一意だったりする必要はありませんが、\
+ログメッセージや注釈で使用されるため、何かしら実在する値を設定しておいた方がよいでしょう。
+
+::  
+
+   % bzr whoami "John Doe <jdoe@organization.com>"
+
+
+ローカルリポジトリのセットアップ
+--------------------------------
+
+Bazaar_ のブランチは、通常は履歴のコピーを持っています。そのおかげで分散型での作業ができるわけです。
+最適化の方法の一つとして、関連するブランチ同士の情報を統合して、\
+新しいブランチを作るたびに履歴情報を丸ごとコピーしなくてもいいようにすることができます。
+
+そのための一番いい方法は、 `共用リポジトリ`_ を作成することです。
+一般に、 `共用リポジトリ`_ のサブディレクトリ内に複数のブランチがある場合、お互いの記憶領域を共有します。
+ですので、ホームディレクトリに `共用リポジトリ`_ を作成するようにしましょう。
+そうすれば、その下に作成したすべてのブランチは、履歴情報の領域を共有することになります。
+
+::
+
+  % bzr init-repo --trees ~
+
+
+リモートリポジトリのセットアップ
+---------------------------------
+
+作業用の領域とは別に、データを蓄積しておく領域が欲しいというのはよくあることです。
+集中型のシステム(CVS/SVN)では、このようなワークフローが必要になります。
+たいていは、これらは別々のマシーンに分けて配置されます。(そうでないこともあります。)
+実際のところ、これは、特に職場ではとてもよい設定です。
+蓄積されたデータはバックアップを確実にとることができ、開発者のマシーンに何かトラブルが起こっても\
+コミットされたデータはけっして無くなりません。
+
+それでは、プロジェクト内で共有する ``centralhost`` というマシーンを用意しましょう。
+先ほども言いましたが、ディスクの使用量を節約するために、 `共用リポジトリ`_ を使用します。
+
+::
+
+  % bzr init-repo --no-trees sftp://centralhost/srv/bzr/
+
+この手順は、新しくcvsrootやSubversionのリポジトリを作るのと同じようなものだと考えることができます。
+{{{--no-tree}}} オプションの指定によって、ワーキングツリーを作らないようになります。
+中央リポジトリ内のブランチを直接変更することは無いので、このオプションを指定しておくとよいでしょう。
+
+
+既存のプロジェクトからの移行
+=============================
+
+リポジトリができましたので、プロジェクトの作成にかかりましょう。
+たいていの場合、 Bazaar_ でバージョン管理したい作業中のコードがすでにあるはずです。
+もし、そのコードがもともとソース管理されていたのであれば、履歴の情報を保ったまま Bazaar_ に\
+変換する方法がたくさんあります。
+しかしながら、それについてはここでは説明しません。詳しくは、 `Tracking Upstream`_ の\
+"Converting and keeping history"セクションを見てください。
+
+.. _Tracking Upstream: http://bazaar-vcs.org/TrackingUpstream
+
+.. 
+   XXX: プロジェクトの変換について話をするための別の文書が必要なのですが、\
+   今ある中ではTrackingUpstreamが一番よい文書です。
+
+
+Developer 1: 最初のリビジョンを作成する
+-----------------------------------------
+
+まず最初に、プロジェクトをホストするリモートリポジトリに、ブランチを作成したいと思います。
+仮に、"sigil"というプロジェクトをバージョン管理しようとしているとしましょう。
+
+::
+
+  % bzr init sftp://centralhost/srv/bzr/sigil
+
+これは、CVSで言うところの"HEAD"ブランチ、Subversionなら"trunk"にあたるものだと考えてかまいません。
+これを ``dev`` ブランチと呼ぶことにしましょう。
+
+他のファイルとの競合を避けるために、ホームディレクトリのサブディレクトリ内で作業するのが私の好みです。
+同じように、最終的にでき上がるすべてのブランチを格納できるプロジェクトディレクトリも欲しいですね。 
+::
+
+  % cd ~
+  % mkdir work
+  % cd work
+  % mkdir sigil
+  % cd sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil dev
+  % cd dev
+  % cp -ar ~/sigil/* .
+  % bzr add
+  % bzr commit -m "Initial import of Sigil"
+
+前のセクションでは、空のブランチ(``sigil`` ブランチ)を ``centralhost`` に作成して、\
+それをクライアント端末にチェックアウトしたあと、元々あったプロジェクトのファイルを追加しています。
+作業ディレクトリをセットアップするための方法はたくさんありますが、この方法を使うと機能追加用/バグフィックス用\
+のブランチを使った作業が簡単にできます。
+そして、複数のブランチをとてもうまく扱えるというのが、 Bazaar_ の長所の一つなのです。
+
+この場合、リモートブランチのチェックアウトを持っているので、 ``~/work/sigil/dev/`` に対してコミットした内容が、\
+ローカルと ``centralhost`` の両方に自動的に保存される訳です。
+
+
+Developer N: プロジェクトの作業コピーを取得する
+--------------------------------------------------
+
+プロジェクトの作成に関するすべての作業は1人目の開発者がしてしまっているので、\
+他のみんなは単にそのブランチをチェックアウトするだけです。
+**ただし、** `ユーザのEメールの設定`_ **と** `ローカルリポジトリのセットアップ`_ **は見ておいてください。**
+
+現在開発中のツリーのコピーを取得するためには::
+
+  % cd ~/work/sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil dev
+
+今、二人の人が ``sftp://centralhost/srv/bzr/sigil`` のチェックアウトを持っている状態なので、\
+片方のチェックアウトが最新のものより古くなってしまうタイミングが出てきます。
+コミットの時に、チェックアウトが古いければ Bazaar_ がエラーを返して、コミットは失敗します。
+チェックアウトを最新にするには、よそで変更されたツリーに対して ``bzr update`` を使用します。
+この時、もし同じファイルが変更されていれば、競合の解決が必要になるかもしれません。
+
+
+別ブランチでの開発
+====================
+
+ここまでは、全員が同じブランチで作業して、変更をコミットしていました。
+これはつまり、全員が適正かつ定期的にアップデートを行い、他の人の変更を取り扱う必要があると\
+いうことです。
+また、誰か一人が何かコードを壊すような変更をコミットして、それが同期されれば、\
+全員が問題を抱えることになります。
+
+たいていの場合、別のブランチ上で開発を行い、コードが安定してからメインのブランチに統合する\
+というやり方の方が優れています。これが、CVSやSVNとの一番大きな違いです。
+CVSやSVNも別ブランチでの開発はできますが、マージのアルゴリズムがかなり貧弱なので、\
+ブランチ間できちんと同期がとれた状態に保つのは難しいことです。
+Bazaar_ は、何がマージ済みかを記憶し、たとえファイルが変名されてる場合でもちゃんと変更を\
+適用することができます。
+
+
+新しいブランチを作成してそこで作業する
+---------------------------------------
+まだ変更が完了していない場合でも、他の人がその変更内容にアクセスできるようにしておきたいですよね。
+そこで、 ``centralhost`` 上に新しい公開ブランチを作成して、それを手元に持ってくることにしましょう。
+
+::
+
+  % cd ~/work/sigil
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/doodle-fixes
+  % bzr checkout sftp://centralhost/srv/bzr/sigil/doodle-fixes doodle-fixes
+  % cd doodle-fixes
+
+これで、 ``doodle`` に必要な修正を当てるための場所ができました。
+また、他の部分の修正をする人に邪魔されることもありません。
+チェックアウトを持っているため、 ``~/work/sigil/doodle-fixes/`` に対してコミットした内容は\
+``centralhost`` 上にも現れます。
+[#nestedbranches]_ ``dev`` ブランチと同じように、このようなブランチ上で二人の開発者が共同で\
+作業することもできます。
+[#cbranch]_
+
+.. [#nestedbranches] あるブランチのサブディレクトリに別のブランチがあるというのはおかしなこと\
+   に見えるかもしれませんが、これは何もおかしくありません。入れ子になったブランチは外側のブランチ\
+   から派生しているという点で、名前空間の階層と同じようなものだと考えることができます。
+
+.. [#cbranch] たくさんの独立したブランチを使っている場合、毎回フルURLを入力するのは大変です。
+   このURLの入力を簡単にするために、ブランチエイリアスなどたくさんの方法を検討しています。
+   今のところ、 bzrtools_ プラグインが ``bzr cbranch`` コマンドを提供しています。
+   これは、ベースとなるブランチを指定して、新しく公開ブランチを作成し、そのチェックアウトを作成する\
+   ことを少ない入力でできるように設計されています。
+   ``cbranch`` の使い方についてはこの文書の範囲外ですが、最後のコマンドについてはこんな感じです。:
+
+::
+
+   % bzr cbranch dev my-feature-branch
+
+.. _bzrtools: http://bazaar-vcs.org/BzrTools
+
+
+変更内容をマージする
+----------------------
+
+``doodle-fixes`` での変更内容をメインのブランチにマージすることになったら、単にこうするだけです。::
+
+  % cd ~/work/sigil/dev
+  % bzr merge ../doodle-fixes
+
+これで、変更内容は ``dev`` ブランチ上でもアクセスできるようになりますが、まだコミットはされていません。
+最終的な変更内容をレビューして、コードがちゃんとコンパイルでき、テストをパスすることを確認したいならこの時です。
+``bzr status`` コマンドと ``bzr diff`` コマンドがここで役立ちます。
+また、競合を解決するのもこの時です。Bazaar_ では、競合を解決するまではコミットできないようになっています。
+そのため、間違って競合マーカーをコミットしてしまうことはありません。
+``bzr status`` コマンドを使えば、他の変更内容と一緒に競合の情報も表示されます。
+``bzr conflicts`` なら、競合の情報だけが表示されます。
+競合を解決し終わったら、``bzr resolve file/name`` か ``bzr resolve --all`` を実行してください。
+[#resolve]_ もし、解決が特に難しい競合がある場合は、 ``bzr remerge`` コマンドを使いたいと思うかもしれません。
+このコマンドで、別のマージアルゴリズムを試してみることができ、さらに元のソース行を表示する\
+こともできます。(``--show-base``)
+
+.. [#resolve] マージ実行中に競合の解決をさせるシステムもあります。
+   私たちは、ファイルごとに競合を解決するよりも、ツリー全体を見ながら競合を解決する方がたいていは簡単である\
+   ことに気づきました。
+   そうすれば、よりたくさんの情報を得られますし、問題を解決したときにテストを実行することもできます。
+
+
+推奨のブランチ構成
+---------------------
+
+とても一般的なブランチ構成として、開発者ごとにひとつずつ専用のブランチを割り当て、中央サーバにも開発者ごとの\
+作業領域を用意するという方法があります。これは以下のコマンドでできます。::
+
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/user-a
+  % bzr branch sftp://centralhost/srv/bzr/sigil \
+               sftp://centralhost/srv/bzr/sigil/user-b
+
+これで、開発者ごとに専用の作業用ブランチを割り当てています。
+さらに、開発者自身で [#cbranch]_ を使用して新しく新機能開発用ブランチを作成することも簡単にできます。
+::
+
+  % bzr branch sftp://centralhost/srv/bzr/sigil/user-a \
+               sftp://centralhost/srv/bzr/sigil/user-a/feature 
+  % cd ~/work/sigil
+  % bzr checkout sftp://centralhost/srv/bzr/sigil/user-a/feature myfeature
+
+
+用語解説
+=========
+
+共用リポジトリ
+--------------
+
+Bazaar_ には、”共用リポジトリ”という概念があります。これは、CVSやSubversionのようなの他のRCSが持つ\
+旧来の概念に似ています。
+たとえば、Subversionでは、サーバ上のリポジトリにすべての履歴情報が保存されていて、手元には履歴情報は\
+全くなく、作業ツリーのファイルのチェックアウトがあるだけです。
+ここで言う”共用”というのは、ブランチ同士の間で共用するという意味であることに注意してください。
+開発者間でも共用される *かも知れません* が、開発者間での共用はスタンドアロンブランチでも可能です。
+
+Bazaar_ の用語では、"共用リポジトリ"とは複数のブランチが履歴情報を **共有** できる場所のことです。
+分散型のワークフローに対応するためには、それぞれのブランチが履歴情報を持っている必要があります。
+しかし、しばしばこれは非効率です。関連するブランチ同士は履歴を共有しており、ディスクも共有した方が\
+いいためです。
+
+
+.. 
+   vim: tw=74 ft=rst

=== added file 'doc/ja/tutorials/index.txt'
--- doc/ja/tutorials/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/tutorials/index.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,11 @@
+チュートリアル
+==============
+
+.. toctree::
+   :maxdepth: 1
+
+   ../mini-tutorial/index
+   tutorial
+   using_bazaar_with_launchpad
+   centralized_workflow
+

=== added file 'doc/ja/tutorials/tutorial.txt'
--- doc/ja/tutorials/tutorial.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/tutorials/tutorial.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,843 @@
+.. This file is in Python ReStructuredText format - it can be formatted
+.. into HTML or text.  In the future we plan to extract the example commands
+.. and automatically test them.
+
+.. This text was previously on the wiki at
+.. http://bazaar.canonical.com/IntroductionToBzr
+.. but has been moved into the source tree so it can be kept in sync with
+.. the source and possibly automatically checked.
+
+======================
+Bazaar チュートリアル
+======================
+
+
+.. Introduction
+
+はじめに
+============
+
+もし、もう分散型バージョン管理に慣れ親しんでいるなら、
+"Bazaarに自己紹介する" の節までとばしてください。
+もし、分散型でないバージョン管理に慣れ親しんでいるけれど分散型バージョン管理は\
+よくわからないのであれば、"分散バージョン管理と分散でないバージョン管理の違い"まで\
+とばしてください。
+それ以外の場合、コーヒーか紅茶(訳注:日本茶でもいいですよ)を用意して、\
+リラックスして読み始めてください。
+
+バージョン管理の目的
+====================
+
+なにかのテキストデータ(プログラムのソースコード、Webサイト、Unixシステムでの\
+設定ファイルなど)を扱う作業をしているとしましょう。
+なにかミスをして、重大なデグレードを引き起こしてしまうかもしれません。
+例えばメールサーバーの設定ファイルを消してしまったり、だいじなプロジェクトの\
+ソースコードを壊してしまったりすることがあります。
+だいじな情報を失って、何が何でも取り戻したいと思った経験があるのであれば、\
+きっとあなたはBazaarを使う準備ができています。
+
+Bazaarをはじめとするバージョン管理システムは、ディレクトリに起こった変更を\
+**ブランチ (branch)** というディレクトリよりも複雑なものの中に入れて\
+追跡します。
+ブランチはディレクトリの中に何が入っているかだけでなく、過去のいろいろな\
+時点でのディレクトリの中身を格納しています。
+なので、望まぬ変更をしてしまったときには過去の時点の状態に戻すことができます。
+
+バージョン管理システムは、ユーザーが "**リビジョン (revision)** をコミット"
+することで変更をブランチに保存します。
+このときに生成されるリビジョンとは、本質的にいって、前回保存したときからの\
+変更点になります。
+
+リビジョンはそれ以外のものも持っています(原文:These revisions have other
+uses as well.)
+たとえば、オプションのログメッセージをつけることで、変更が何を意味して\
+いるのかというコメントを残すことができます。
+実際に利用されるログメッセージは、 "Webテンプレートをテーブルを閉じるように\
+修正" とか "sftpに対応した。 #595 を修正。" といったものです。
+
+こういったログが保存されているおかげで、たとえば後になって sftp に問題が発生\
+したときに、問題が発生するようになったのがどの時点なのか目星をつけることが\
+できます。
+
+
+分散バージョン管理と分散でないバージョン管理の違い
+===================================================
+
+多くのバージョン管理システムはサーバーに配置されています。
+バージョン管理されているコードに対して作業をしたい場合、サーバーに接続して\
+コードを "チェックアウト (checkout)" する必要があります。
+そうすると、変更やコミットができるディレクトリができます。
+バージョン管理システムのクライアントは、バージョン管理システムのサーバーに\
+コミットされた変更を保存します。この方式は集中型として知られています。
+
+集中型にはいくつかの欠点があります。
+集中型バージョン管理システムは、動作するためにサーバーとの接続を要求します。
+このことは、サーバーがどこかインターネット上にあって、あなたのマシンが\
+インターネットに接続できないときに問題になります。
+もしくは、あなたのマシンがインターネットに接続できてもサーバーが落ちている\
+ときにもやはり問題になります。
+
+分散バージョン管理システムは、ブランチをクライアントと同じマシンに置くことで\
+この問題を解決しています。
+Bazaarの場合、ブランチはバージョン管理されているコードと同じディレクトリに\
+保存されます。
+これにより、ユーザーは(たとえオフラインであったとしても)好きなときに変更を保存\
+(**コミット (commit)**)することができます。
+インターネット接続が必要になるのは、どこか別の場所にあるブランチの変更にアクセス\
+するときだけです。
+
+.. TODO:
+.. Performing this tracking by hand is a awkward process that over time
+.. becomes unwieldy. の部分の訳が判らない。
+
+多くの人が必要としていることは、ディレクトリ内でおこったファイルやサブディレクトリ\
+の変更を追跡することです。
+この追跡を手でおこなうのは面倒で不恰好な作業です。
+これは、Bazaarのようなバージョン管理システムの目的のひとつです。
+バージョン管理システムはユーザーが指示したときにディレクトリツリーの
+**リビジョン (revision)** を作ることでこの作業を自動化します。
+
+バージョン管理システムは単に保存したりundoしたりするだけではありません。
+たとえばBazaarでは、ソフトウェアのあるブランチから変更を取り出して、\
+関連する別のブランチに適用することができます。このとき、変更を取り出す\
+ブランチは別の人のものであってもかまいません。これにより、開発者のグループは\
+お互いに書き込み権を与えることなく共同作業することができます。
+
+.. Bazaar remembers the ''ancestry'' of a revision: the previous revisions
+.. that it is based upon.  A single revision may have more than one direct
+.. descendant, each with different changes, representing a divergence in the
+.. evolution of the tree. By branching, Bazaar allows multiple people to
+.. cooperate on the evolution of a project, without all needing to work in
+.. strict lock-step.  Branching can be useful even for a single developer.
+
+Bazaarではリビジョンの ''親 (ancestry)'' 、つまりそのリビジョンの元になった\
+リビジョンを記録しています。
+ひとつのリビジョンは複数の、それぞれ別の変更を含む子供リビジョンを持つことが\
+あり、それはツリーの進化が分岐していることを意味しています。
+Bazaarではブランチを作ることによって、複数の人が厳しい lock-step をとらなくても\
+協力することができます。
+ブランチを作ることは個人での開発でも便利です。
+
+.. Introducing yourself to Bazaar
+
+Bazaarに自己紹介する
+=====================
+
+.. Bazaar installs a single new command, **bzr**.  Everything else is a
+   subcommand of this.  You can get some help with ``bzr help``. Some arguments
+   are grouped in topics: ``bzr help topics`` to see which topics are available.
+
+Bazaarは **bzr** という新しいコマンドをひとつインストールします。
+他の全ては bzr のサブコマンドになります。
+``bzr help`` コマンドでいくつかのヘルプを見られます。
+幾つかの話題は topic にまとめられていて、 ``bzr help topics`` で\
+利用可能なトピックの一覧を見られます。
+
+バージョン管理システムの一つの機能は、誰が何を変更したのかを追跡することです。
+分散型バージョン管理システムでは、各開発者がグローバルユニークなIDを持つ\
+必要があります。
+ほとんどの人はこのIDとして利用できる eメールアドレス を持っています。
+Bazaarはコンピュータのユーザー名とホスト名から自動でメールアドレスを\
+生成します。Bazaarが自動で作成したメールアドレス以外のものを使いたい\
+場合、３つの選択肢があります。
+
+1. ``bzr whoami`` を使ってメールアドレスを設定します。これはグローバルなIDを設定\
+   する最も簡単な方法です。グローバルなIDを設定するには::
+
+      % bzr whoami "Your Name <email@example.com>"
+
+   特定のブランチでべつのアドレスを使いたい場合、そのブランチのディレクトリの\
+   なかで次のコマンドを実行します::
+
+      % bzr whoami --branch "Your Name <email@example.com>"
+
+#. ``?/.bazaar/bazaar.conf`` [1]_ の中のメールアドレスを、以下のようにして\
+   設定します。 ``[DEFAULT]`` の部分が大文字と小文字を区別するので注意して\
+   ください::
+
+       [DEFAULT]
+       email=Your Name <email@isp.com>
+
+   特定のブランチにおける設定は、 ``?/.bazaar/locations.conf``
+   にブランチのセクションを作成して次のように書くことができます。 ::
+
+       [/the/path/to/the/branch]
+       email=Your Name <email@isp.com>
+
+
+#. 環境変数 ``$BZR_EMAIL`` もしくは ``$EMAIL`` (``$BZR_EMAIL`` の方が優先\
+   されます)にメールアドレスを設定することで、上の二つの方法で設定された\
+   オプションを上書きすることができます。
+
+.. [1] Windowsではユーザー設定ファイルはアプリケーションデータディレクトリに\
+   おかれます。なので、設定ファイルの場所は ``?/.bazaar/branch.conf`` ではなく\
+   ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\branch.conf``
+   になります。
+   同じことが ``locations.conf``, ``ignore``, ``plugins`` ディレクトリも\
+   同じです。
+
+ブランチを作る
+==============
+
+履歴はデフォルトではブランチの .bzr ディレクトリの中に保存されます。
+
+.. これは現行のバージョンでできるのでは？: In a
+   future version of Bazaar, there will be a facility to store it in a
+   separate repository, which may be remote.
+
+既存のディレクトリの中で ``bzr init`` をすると新しいブランチを作成できます::
+
+    % mkdir tutorial
+    % cd tutorial
+    % ls -a
+    ./  ../
+    % pwd
+    /home/mbp/work/bzr.test/tutorial
+    %
+    % bzr init
+    % ls -aF
+    ./  ../  .bzr/
+    %
+
+ファイルには３つのクラス、 unknown, ignored, versioned があります。
+**add** コマンドはファイルを versioned にし、そのファイルへの変更の記録を\
+開始します::
+
+    % echo 'hello world' > hello.txt
+    % bzr status
+    unknown:
+      hello.txt
+    % bzr add hello.txt
+    added hello.txt
+    % bzr status
+    added:
+      hello.txt
+
+もし間違えたファイルを add してしまった場合、そのファイルを unversioned
+状態に戻すために ``bzr remove`` してください。
+この場合の ``bzr remove`` は、ほかの場合 [2]_ とちがってファイルを削除\
+しません。
+
+.. [2] ``bzr remove`` はファイルがバージョン管理されていて何も変更されて\
+   いない場合に、そのファイルを削除します。 ``--keep`` オプションで常に\
+   ファイルを残すことができます。 ``--force`` オプションで常にファイルを\
+   削除することもできます。
+
+.. Branch locations
+
+ブランチの場所
+===============
+
+すべての履歴はブランチに格納されます。ブランチとは、管理用のファイルを\
+含んだただのディレクトリです。デフォルトでは、svnやsvkのような、分離した\
+リポジトリやデータベースはありません。分離したリポジトリを作成することも\
+できます(``bzr init-repo`` コマンドを参照してください)。大規模なブランチを\
+利用する場合や、中規模のブランチをたくさん利用する場合にはリポジトリを\
+分離するといいでしょう。
+
+自分のコンピュータのファイルシステム上にあるブランチを参照するときは\
+ブランチを格納しているディレクトリ名で指定できます。 bzr は http や ftp\
+経由でブランチにアクセスすることもできます。例::
+
+    % bzr log http://bazaar-vcs.org/bzr/bzr.dev/
+    % bzr log sftp://bazaar-vcs.org/bzr/bzr.dev/
+
+プラグインをインストールすれば、 rsync プロトコルを使ってブランチにアクセス\
+することもできます。
+
+ブランチを指定した場所に置く方法については、 `ブランチを公開する`_ 節を\
+ご覧ください。
+
+.. Reviewing changes
+
+変更をレビューする
+===================
+
+一仕事終えたら、それを履歴に **コミット (commit)** しましょう。
+新しい機能を追加したり、バグを直したり、コードやドキュメントを更新したら\
+いつでもコミットするのは良いことです。
+すべてのリビジョンが良い状態であるようにするために、コミットする前にコードを\
+コンパイルしたりテストスイートを実行するのも良い習慣です。
+コミットする前にコミットしようとしているものを確認するためにレビューすることが\
+できます。
+
+この目的で便利な二つのコマンドがあります。 **status** と **diff** です。
+
+bzr status
+----------
+
+**status** コマンドは、今の作業ツリーが最後のリビジョンからどのように\
+変更されたのかを教えてくれます::
+
+    % bzr status
+    modified:
+       foo
+
+``bzr status`` は変更が無かったり無視されているファイルを隠します。
+status コマンドはオプションとして、確認対象となる複数のファイル名やディレクトリ名を\
+渡すことができます。
+
+bzr diff
+--------
+
+**diff** コマンドは通常の unified diff フォーマットですべてのファイルの\
+テキストの変更を表示します。
+このコマンドの出力を pipe 経由で、''patch'', ''diffstat'', ''fileterdiff'',
+''colordiff'' といったコマンドに渡すことができます。 ::
+
+    % bzr diff
+    === added file 'hello.txt'
+    --- hello.txt   1970-01-01 00:00:00 +0000
+    +++ hello.txt   2005-10-18 14:23:29 +0000
+    @@ -0,0 +1,1 @@
+    +hello world
+
+
+``-r`` オプションをつけると、作業ツリーを古いリビジョンと比較したり、\
+二つのリビジョン間の差分を見ることができます。 ::
+
+    % bzr diff -r 1000..          # everything since r1000
+    % bzr diff -r 1000..1100      # changes from 1000 to 1100
+
+``--diff-options`` オプションをつけると、 bzr は外部の diff プログラムに\
+オプションをつけて起動します。 例::
+
+    % bzr diff --diff-options --side-by-side foo
+
+プロジェクトによっては二つのファイルに接頭辞がついた patch が好まれます。
+``--prefix`` オプションでそのような接頭辞をつけることができます。
+ショートカットとして、 ``bzr diff -p1`` は ``patch -p1`` コマンドが受け付ける\
+形で差分を出力します。
+
+
+.. Committing changes
+
+変更をコミットする
+==================
+
+作業ツリーの状態に満足したら、ブランチに **コミット (commit)** しましょう。
+コミットとは作業ツリーの状態のスナップショットを保持するリビジョンを新しく作ることです。
+
+bzr commit
+----------
+
+.. The **commit** command takes a message describing the changes in the
+.. revision.  It also records your userid, the current time and timezone, and
+.. the inventory and contents of the tree.  The commit message is specified
+.. by the ``-m`` or ``--message`` option. You can enter a multi-line commit
+.. message; in most shells you can enter this just by leaving the quotes open
+.. at the end of the line.
+
+**commit** コマンドはそのリビジョンの変更を説明するメッセージを受け取ります。
+また、あなたのユーザーID、今の時間とタイムゾーン、ツリーの内容をあわせて記録します。
+コミットメッセージは ``-m`` もしくは ``--message`` オプションで指定できます。
+複数行のコメントも利用できます。多くのシェルはクォートを開いたままで改行する\
+ことで複数行の入力が可能です。
+
+::
+
+    % bzr commit -m "added my first file"
+
+.. You can also use the ``-F`` option to take the message from a file.  Some
+.. people like to make notes for a commit message while they work, then
+.. review the diff to make sure they did what they said they did.  (This file
+.. can also be useful when you pick up your work after a break.)
+
+メッセージをファイルで渡すには ``-F`` オプションを使います。
+コミットメッセージを先に作成し、それとdiffを合わせてレビューすることで、
+コミットメッセージとコミット内容が一致していることを確認する人もいます。
+(このファイルは休憩から戻ってきて作業を思い出すときにも役に立つでしょう)
+
+.. Message from an editor
+
+エディタからメッセージを入力する
+----------------------------------
+
+.. If you use neither the ``-m`` nor the ``-F`` option then bzr will open an
+.. editor for you to enter a message.  The editor to run is controlled by
+.. your ``$VISUAL`` or ``$EDITOR`` environment variable, which can be overridden
+.. by the ``editor`` setting in ``?/.bazaar/bazaar.conf``; ``$BZR_EDITOR`` will
+.. override either of the above mentioned editor options.  If you quit the
+.. editor without making any changes, the commit will be cancelled.
+
+``-m`` オプションも ``-F`` オプションも指定しなかった場合、 bzr はメッセージを\
+入力するためにエディタを立ち上げます。
+このエディタは ``$VISUAL`` か ``$EDITOR`` 環境変数で制御することができます。
+この環境変数を `` /.bazaar/bazaar.conf`` 内の ``editor`` を設定して上書き\
+することができ、さらに ``$BZR_EDITOR`` 環境変数がそれらすべてを上書きします。
+もし何も変更せずにエディタを閉じたなら、コミットはキャンセルされます。
+
+.. The file that is opened in the editor contains a horizontal line. The part
+.. of the file below this line is included for information only, and will not
+.. form part of the commit message. Below the separator is shown the list of
+.. files that are changed in the commit. You should write your message above
+.. the line, and then save the file and exit.
+
+エディタで開かれるファイルには水平線が含まれています。この線より下の部分は\
+参考用であり、コミットメッセージには含まれません。
+水平線の下にはコミットで変更されるファイルのリストが表示されます。
+メッセージは水平線の上に書く必要があります。そうしたら、ファイルを保存して\
+エディタを終了してください。
+
+.. If you would like to see the diff that will be committed as you edit the
+.. message you can use the ``--show-diff`` option to ``commit``. This will include
+.. the diff in the editor when it is opened, below the separator and the
+.. information about the files that will be committed. This means that you can
+.. read it as you write the message, but the diff itself wont be seen in the
+.. commit message when you have finished. If you would like parts to be
+.. included in the message you can copy and paste them above the separator.
+
+``commit`` コマンドに ``--show-diff`` オプションをつけると、コミットされる\
+変更の diff を見ることができます。この diff はエディタが開いたときに水平線\
+やコミットされるファイルの情報よりも下に含まれます。
+なので、コミットメッセージを書くときに diff を見ることができますが、\
+コミットメッセージ自体には diff が含まれません。
+コミットメッセージに diff を含めたい場合は、水平線より上にコピーペースト\
+してください。
+
+.. Selective commit
+
+選択コミット
+----------------
+
+.. If you give file or directory names on the commit command line then only
+.. the changes to those files will be committed.  For example::
+
+commit コマンドにファイル名やディレクトリ名を渡したとき、それらのファイルの\
+変更だけがコミットされます。 例 ::
+
+    % bzr commit -m "documentation fix" commit.py
+
+.. By default bzr always commits all changes to the tree, even if run from a
+.. subdirectory.  To commit from only the current directory down, use::
+
+デフォルトでは bzr は、サブディレクトリから実行される場合でもすべての変更を\
+コミットします。
+カレントディレクトリ以下だけをコミットする場合は、次のようにします ::
+
+    % bzr commit .
+
+
+.. Removing uncommitted changes
+
+コミットされていない変更を削除する
+===================================
+
+.. If you've made some changes and don't want to keep them, use the
+.. **revert** command to go back to the previous head version.  It's a good
+.. idea to use ``bzr diff`` first to see what will be removed. By default the
+.. revert command reverts the whole tree; if file or directory names are
+.. given then only those ones will be affected. ``bzr revert`` also clears the
+.. list of pending merges revisions.
+
+不要な変更がある場合、 **revert** コマンドで最後のリビジョンの状態に戻る\
+ことができます。
+revert するまえに ``bzr diff`` で何が削除されるのかを確認しておくと良いでしょう。
+デフォルトでは revert コマンドはツリー全体を revert します。ファイル名や\
+ディレクトリ名が指定されている場合は、そのファイルだけが revert されます。
+``bzr revert`` はマージ待ちリビジョンのリストも削除します。
+
+
+.. Ignoring files
+
+ファイルを無視する
+===================
+
+.. The .bzrignore file
+
+.bzrignore ファイル
+-------------------
+
+.. Many source trees contain some files that do not need to be versioned,
+.. such as editor backups, object or bytecode files, and built programs.  You
+.. can simply not add them, but then they'll always crop up as unknown files.
+.. You can also tell bzr to ignore these files by adding them to a file
+.. called ``.bzrignore`` at the top of the tree.
+
+多くのソースツリーはバージョン管理する必要のないファイルをたくさん含んでいます。
+たとえば、エディタのバックアップファイルや、オブジェクトファイル、バイトコード、
+ビルドされたプログラムなどです。
+こういったファイルを単に add しないこともできますが、そうすると毎回 unknown file
+としてたびたび出現することになります。
+ツリートップにある ``.bzrignore`` とよばれるファイルにそれらのファイルを追加する\
+ことで、bzrにそれらのファイルを無視させることができます。
+
+.. This file contains a list of file wildcards (or "globs"), one per line.
+.. Typical contents are like this::
+
+このファイルは行ごとにワイルドカード (もしくは"glob") のリストを含みます。
+典型的な内容の例です::
+
+    *.o
+    *?
+    *.tmp
+    *.py[co]
+
+.. If a glob contains a slash, it is matched against the whole path from the
+.. top of the tree; otherwise it is matched against only the filename.  So
+.. the previous example ignores files with extension ``.o`` in all
+.. subdirectories, but this example ignores only ``config.h`` at the top level
+.. and HTML files in ``doc/``::
+
+glob がスラッシュを含む場合、ツリーのトップからのパス全体にマッチします。
+そうでない場合は、単にファイル名にマッチします。
+なので、上の例はすべてのサブディレクトリの ``.o`` 拡張子を持つファイルを無視\
+しますが、次の例ではツリーのトップにある ``config.h`` ファイルと、 ``doc/``
+ディレクトリ以下のHTMLファイルだけを無視します::
+
+    ./config.h
+    doc/*.html
+
+.. To get a list of which files are ignored and what pattern they matched,
+.. use ``bzr ignored``::
+
+どのファイルがどのパターンにマッチして無視されているのかを、 ``bzr ignored``
+コマンドで表示することができます::
+
+    % bzr ignored
+    config.h                 ./config.h
+    configure.in?            *?
+
+.. It is OK to have either an ignore pattern match a versioned file, or to
+.. add an ignored file.  Ignore patterns have no effect on versioned files;
+.. they only determine whether unversioned files are reported as unknown or
+.. ignored.
+
+バージョン管理されているファイルが無視パターンにマッチしたり無視リストに\
+入っていても大丈夫です。無視パターンはバージョン管理されたファイルには\
+影響しません。バージョン管理されていないファイルを 'unknown' として扱うか\
+'ignored' として扱うかを決めるためだけに使われます。
+
+
+.. The ``.bzrignore`` file should normally be versioned, so that new copies
+.. of the branch see the same patterns::
+
+``.bzrignore`` ファイルは普通はバージョン管理されます。なのでそのブランチの\
+コピーでも同じパターンが無視されます。 ::
+
+    % bzr add .bzrignore
+    % bzr commit -m "Add ignore patterns"
+
+
+.. Global ignores
+
+グローバルの無視設定
+---------------------
+
+.. There are some ignored files which are not project specific, but more user
+.. specific. Things like editor temporary files, or personal temporary files.
+.. Rather than add these ignores to every project, bzr supports a global
+.. ignore file in ``?/.bazaar/ignore`` [1]_. It has the same syntax as the
+.. per-project ignore file.
+
+エディタの一時ファイルや個人の一時ファイルなど、\
+幾つかの無視ファイルはプロジェクト依存ではなくてユーザー依存です。
+こういったファイルを全プロジェクトで無視設定するかわりに、グローバルの\
+無視設定ファイル ``~/.bazaar/ignore`` を利用できます。
+これはプロジェクトの ignore ファイルと同じ文法で記述します。
+
+
+.. Examining history
+
+履歴を閲覧する
+===============
+
+bzr log
+-------
+
+.. The ``bzr log`` command shows a list of previous revisions. The ``bzr log
+.. --forward`` command does the same in chronological order to get most
+.. recent revisions printed at last.
+
+``bzr log`` コマンドは過去のリビジョンのリストを表示します。
+``bzr log --forward`` コマンドは同じ内容を、時系列順で最新のものが最後に\
+くるように出力します。
+
+.. As with ``bzr diff``, ``bzr log`` supports the ``-r`` argument::
+
+``bzr diff`` と同じように、 ``bzr log`` も ``-r`` 引数をサポートします::
+
+    % bzr log -r 1000..          # リビジョン r1000 とそれ以降すべて
+    % bzr log -r ..1000          # r1000 とそれ以前のすべて
+    % bzr log -r 1000..1100      # r1000 から r1100 まで
+    % bzr log -r 1000            # リビジョン r1000 だけ
+
+..    % bzr log -r 1000..          # Revision 1000 and everything after it
+..    % bzr log -r ..1000          # Everything up to and including r1000
+..    % bzr log -r 1000..1100      # changes from 1000 to 1100
+..    % bzr log -r 1000            # The changes in only revision 1000
+
+
+.. Branch statistics
+
+ブランチの情報
+=================
+
+.. The ``bzr info`` command shows some summary information about the working
+.. tree and the branch history.
+
+``bzr info`` コマンドは作業ツリーとブランチの履歴に関する情報の要約を表示します。
+
+
+.. Versioning directories
+
+ディレクトリをバージョン管理する
+================================
+
+.. bzr versions files and directories in a way that can keep track of renames
+.. and intelligently merge them::
+
+bzr はファイルとディレクトリを、名前の変更を追跡して賢くマージできるように\
+バージョン管理します::
+
+    % mkdir src
+    % echo 'int main() {}' > src/simple.c
+    % bzr add src
+    added src
+    added src/simple.c
+    % bzr status
+    added:
+      src/
+      src/simple.c
+
+
+.. Deleting and removing files
+
+ファイルを削除する
+===================
+
+.. You can delete files or directories by just deleting them from the working
+.. directory.  This is a bit different to CVS, which requires that you also
+.. do ``cvs remove``.
+
+ファイルを削除するのは、単純に作業ツリーからファイルを削除するだけでできます。
+これは、 ``cvs remove`` が必要な CVS とは少し異なります。
+
+.. ``bzr remove`` makes the file un-versioned, but may or may not delete the
+.. working copy [2]_.  This is useful when you add the wrong file, or decide that
+.. a file should actually not be versioned.
+
+``bzr remove`` はファイルをバージョン管理対象からはずしますが、作業ツリーから\
+削除することも削除しないこともできます。 [2]_
+これは間違ったファイルを追加してしまったり、あるファイルをバージョン管理するのを\
+やめる場合に便利です。
+
+::
+
+    % rm -r src
+    % bzr remove -v hello.txt
+    ?       hello.txt
+    % bzr status
+    removed:
+      hello.txt
+      src/
+      src/simple.c
+    unknown:
+      hello.txt
+
+.. If you remove the wrong file by accident, you can use ``bzr revert`` to
+.. restore it.
+
+もし間違ってファイルを削除してしまった場合、 ``bzr revert`` でリストアできます。
+
+
+.. Branching
+
+ブランチを作る
+==============
+
+.. Often rather than starting your own project, you will want to submit a
+.. change to an existing project.  To do this, you'll need to get a copy of
+.. the existing branch.  Because this new copy is potentially a new branch,
+.. the command is called **branch**::
+
+自分でプロジェクトを始めるのではなく、既存のプロジェクトに変更を加えたい場合があります。
+この場合、既存のブランチのコピーを取得する必要があります。
+このコピーは新しいブランチになるので、このコマンドは **branch** という名前になっています::
+
+    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev
+    % cd bzr.dev
+
+.. This copies down the complete history of this branch, so we can do all
+.. operations on it locally: log, annotate, making and merging branches.
+.. There will be an option to get only part of the history if you wish.
+
+.. XXX: There will be の訳これでいい？
+
+これでブランチの完全な履歴をコピーできたので、すべての操作 (log, annotate,
+branch の作成とマージなど) をローカルで実行できます。
+履歴の一部だけを取得するオプションも追加される予定です。
+
+.. You can also get a copy of an existing branch by copying its directory,
+.. expanding a tarball, or by a remote copy using something like rsync.
+
+既存のブランチをコピーするには、普通にディレクトリをコピーしたり、tarballを\
+展開したり、リモートから rsync のような方法でコピーすることもできます。
+
+.. Following upstream changes
+
+上流の変更を追いかける
+==========================
+
+.. You can stay up-to-date with the parent branch by "pulling" in their
+   changes::
+
+変更を "pull" することで手元のブランチを上流のブランチに対して最新に保つことが\
+できます。
+
+    % bzr pull
+
+.. After this change, the local directory will be a mirror of the source. This
+.. includes the ''revision-history'' - which is a list of the commits done in
+.. this branch, rather than merged from other branches.
+
+.. XXX This includes～がわからない.
+
+このコマンドを実行した後、ローカルディレクトリはpull元のミラーになります。
+ミラーするものには、 ''revision-history'' を含みます。つまり、別のブランチから\
+マージするのではなくて、このブランチに対してコミットした履歴になります。
+
+.. This command only works if your local (destination) branch is either an
+.. older copy of the parent branch with no new commits of its own, or if the
+.. most recent commit in your local branch has been merged into the parent
+.. branch.
+
+このコマンドはローカルの(pull先)ブランチが親ブランチの古いコピーで独自の\
+あたらしいリビジョンを一切含まないか、ローカルブランチへの最新のコミットが\
+親ブランチにマージされているときにのみ成功します。
+
+.. Merging from related branches
+
+関連ブランチからマージする
+=============================
+
+.. If two branches have diverged (both have unique changes) then ``bzr
+.. merge`` is the appropriate command to use. Merge will automatically
+.. calculate the changes that exist in the branch you're merging from that
+.. are not in your branch and attempt to apply them in your branch.
+
+二つのブランチが分岐している(互いに異なる変更を持っている)とき、
+``bzr merge`` コマンドの出番です。
+merge はマージ元ブランチにあって手元のブランチにない変更を自動で探して、\
+その変更を手元に適用しようと試みます。
+
+::
+
+  % bzr merge URL
+
+
+.. If there is a conflict during a merge, 3 files with the same basename
+.. are created. The filename of the common base is appended with ".BASE",
+.. the filename of the file containing your changes is appended with
+.. ".THIS" and the filename with the changes from the other tree is
+.. appended with ".OTHER".  Using a program such as kdiff3, you can now
+.. comfortably merge them into one file.  In order to commit you have to
+.. rename the merged file (".THIS") to the original file name.  To
+.. complete the conflict resolution you must use the resolve command,
+.. which will remove the ".OTHER" and ".BASE" files.  As long as there
+.. exist files with .BASE, .THIS or .OTHER the commit command will
+.. report an error.
+
+マージ中に衝突(conflict)が発生した場合、同じ基本名(basename)をもつ\
+3つのファイルが作成されます。
+共通の祖先になるファイルのファイル名には ".BASE" が、
+手元のブランチの変更を含むファイル名には ".THIS" が、
+マージ元の変更を含むファイル名には ".OTHER" が末尾に追加されます。
+kdiff3 のようなプログラムを利用してこれらのファイルをひとつに\
+マージすることができます。
+コミットするには、マージされた ".THIS" ファイルを元のファイル名に\
+リネームします。
+衝突の解決を完了するには、 resolve コマンドを使います。
+このコマンドは ".OTHER" と ".BASE" ファイルを削除します。
+.BASE, .THIS, .OTHER ファイルが残っている場合、 commit コマンドは\
+エラーを報告します。
+
+::
+
+  % kdiff3 file.BASE file.OTHER file.THIS
+  % mv file.THIS file
+  % bzr resolve file
+
+[**TODO**: explain conflict markers within files]
+
+
+ブランチを公開する
+======================
+
+.. You don't need a special server to publish a bzr branch, just a normal web
+.. server.  Just mirror the files to your server, including the .bzr
+.. directory.  One can push a branch (or the changes for a branch) by one of
+.. the following three methods:
+
+bzrのブランチを公開するには特別なサーバーは必要ありません、普通のWebサーバーが\
+使えます。
+.bzr ディレクトリを含めてファイルをサーバーにミラーしてください。
+ブランチをpush(やブランチに対する操作)するのに以下の3つの方法があります。
+
+.. * The best method is to use bzr itself to do it.
+
+* 最良の方法は bzr 自体を使うことです。
+
+  ::
+
+    % bzr push sftp://servername.com/path/to/directory
+
+..   (The destination directory must already exist unless the
+..   ``--create-prefix`` option is used.)
+
+  (push先ディレクトリがすでに存在するか、 ``--create-prefix`` オプションを\
+  利用する必要があります。)
+
+.. * Another option is the ``rspush`` plugin that comes with BzrTools, which
+..   uses rsync to push the changes to the revision history and the working
+..   tree.
+
+* 別の選択肢は bzrtools に含まれる ``rspush`` プラグインを利用することです。
+  これはリモートの履歴と作業ツリーに変更を push するのに rsync を利用します。
+
+.. * You can also copy the files around manually, by sending a tarball, or using
+..   rsync, or other related file transfer methods.  This is usually less safe
+..   than using ``push``, but may be faster or easier in some situations.
+
+* 手動で、 tarball を送ったり rsync を使ったりほかの転送方法を利用してファイルを\
+  送ることで
+
+
+.. Moving changes between trees
+
+変更をツリー間で移動する
+============================
+
+.. It happens to the best of us: sometimes you'll make changes in the wrong
+.. tree.  Maybe because you've accidentally started work in the wrong directory,
+.. maybe because as you're working, the change turns out to be bigger than you
+.. expected, so you start a new branch for it.
+
+どんな人にでもありえることですが、適切ではないツリー上で変更してしまうことがあります。
+単純に作業するディレクトリを間違えたり、変更がよそうよりも大きくなってしまったりして、
+その変更のために新しいブランチを作りなおすことがあります。
+
+.. To move your changes from one tree to another, use
+
+変更をあるツリーから別のツリーに移動するには
+
+::
+
+  % cd NEWDIR
+  % bzr merge --uncommitted OLDDIR
+
+.. This will apply all of the uncommitted changes you made in OLDDIR to NEWDIR.
+.. It will not apply committed changes, even if they could be applied to NEWDIR
+.. with a regular merge.  The changes will remain in OLDDIR, but you can use ``bzr
+.. revert OLDDIR`` to remove them, once you're satisfied with NEWDIR.
+
+これですべてのコミットされていないOLDDIR上の変更がNEWDIRに適用されます。
+コミットされていない変更は、通常のmergeでNEWDIRに適用することができる場合でも適用されません。
+OLDDIR上の変更はそのまま残りますが、NEWDIRの状態に満足したら ``bzr revert OLDDIR``
+で削除することができます。
+
+.. NEWDIR does not have to be a copy of OLDDIR, but they should be related.
+.. The more different they are, the greater the chance of conflicts.
+
+NEWDIRはOLDDIRのコピーである必要はありませんが、関連しているべきです。
+両者の違いが大きければそれだけ衝突が起こる可能性が大きくなります。

=== added file 'doc/ja/tutorials/using_bazaar_with_launchpad.txt'
--- doc/ja/tutorials/using_bazaar_with_launchpad.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/tutorials/using_bazaar_with_launchpad.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,552 @@
+===========================
+LaunchpadでBazaarを使う
+===========================
+
+
+動機付け
+==========
+
+コミュニティはチームとは違う
+----------------------------------
+
+ソフトウェアの初回リリースをしなければならない人々のチームというのは、\
+一人から数千人まで、その規模は多岐に渡ります。
+その要求に応じて、技術的な課題、経営上の課題、その両方が非常に大きなもの\
+になる可能性があります。
+Bazaarユーザガイドで説明したように、"ふさわしい"プロセスを選択し、\
+それに見合ったワークフローをサポートするBazaarのようなツールを使うことは、\
+大きな手助けになるでしょう。
+
+.. The team of people required to create the initial release
+   of a piece of software may vary in size from one person
+   to several thousand people. Depending on the requirements,
+   the challenges involved, both technical and managerial,
+   can be immense. As explained in the Bazaar User Guide, selecting
+   "just right" processes and using tools like Bazaar to support
+   matching workflows can greatly help.
+
+しかし、ソフトウェアによる成功のためには、すばらしいチーム以上のものが\
+必要です。 - それは、健全で活発な *コミュニティ* です。
+このグループは、通常はチームよりもはるかに大きく、なぜならそのソフトウェアに\
+関心のあるすべての人 - 開発チーム、ユーザ、トレーニングパートナー、\
+サポートパートナー、サードパーティの開発者など - を含むからです。
+
+.. Success with software though requires more than a great team - it
+   requires a healthy, active *community*. This group is typically
+   far larger than the team as it includes everyone interested in
+   the software: the team, users, training partners, support partners,
+   third-party developers and so on.
+
+すばらしいコミュニティというものはオープンソースの世界では良く理解されています。
+しかし、その適用はオープンソースの世界を越えて広がっています。: もっとも成功している\
+商業ソフトウェアのベンダーは、そのフラッグシッププロダクトと共に成長するコミュニティ\
+を作り上げ、運営することがたくみなのです。
+
+.. Great communities are well understood in the open source world.
+   Their applicability extends well beyond that though: most
+   successful commercial software vendors are well skilled at
+   building and managing the communities that grow up around
+   their flagship products.
+
+すばらしいチームと同じように、すばらしいコミュニティも偶然できるものではありません。
+良いポリシーとガイドラインが、参加者同士の健全なコミュニケーションと正しい振る舞い\
+を育てるために不可欠です。
+この話題についてもっと深く知りたければ、Karl Fogelのすばらしい著書 - \
+`Producing Open Source Software <http://www.producingoss.com/>`_ - を見てください。
+
+.. Like great teams, great communities don't just happen.
+   Good policies and guidelines are essential for
+   fostering the right sort of behaviour and healthy
+   relationships between participants. For a deeper look at
+   this topic, see Karl Fogel's landmark book:
+   `Producing Open Source Software <http://www.producingoss.com/>`_.
+
+
+協調開発に必要なもの
+---------------------------------------------------
+
+コミュニティの情報とワークフローを追跡し、管理するためには、賢いツールセットが重要です。
+そのようなツールを、協調開発環境(Collaborative Development Environments : CDEs)と呼びます。
+一般的には、WEBベースでアナウンスや案件、バグを管理します。
+`Launchpad <https://launchpad.net>`_ 、
+`SourceForge <http://sourceforge.net>`_ 、
+`java.net <http://java.net>`_ 、
+`SAP Community Network <https://www.sdn.sap.com/irj/sdn>`_ などに、CDEsの例があります。
+
+.. An intelligent toolset is also important for tracking and managing
+   community information and workflows. These tools are called
+   Collaborative Development Environments (CDEs). These toolsets are
+   typically web-based and manage things such as announcements,
+   issues/bugs, questions and answers, downloads, documents and
+   source code. Some examples of CDEs include
+   `Launchpad <https://launchpad.net>`_,
+   `SourceForge <http://sourceforge.net>`_,
+   `java.net <http://java.net>`_ and
+   `SAP Community Network <https://www.sdn.sap.com/irj/sdn>`_.
+
+
+関係するコミュニティとの協調を助ける
+-------------------------------------------------
+
+多くの成功しているプロダクトは、その下流にそれを使うたくさんのプロダクトがあります。
+言いかえると、他のコミュニティとやりとりをして、自分の変更が彼らにどんな影響を与えるかを\
+理解することで、新しい挑戦が成功するのです。
+これは、以下のようなプロダクトで特に明白です。:
+
+* プログラム言語、たとえばPyhon、PHP、Ruby、Java、Perlなど
+* コンパイラ、たとえばgcc、JDKなど
+* ライブラリ、たとえばzlib、opensslなど
+* フレームワーク、たとえばZope、Ruby on Rails、Springなど
+
+.. XXX downstream dependenciesは、直訳だとわかりづらい気がするのでやや意訳
+   In other wordからの一文の訳がよくわからない
+
+.. Many successful products have a huge number of downstream dependencies.
+   In other words, a new challenge arises with success: dealing with other
+   communities and understanding how your changes will impact them. This is
+   most obvious for projects like:
+
+.. * software languages, e.g. Python, PHP, Ruby, Java, Perl, etc.
+   * compilers, e.g. gcc, JDK, etc.
+   * libraries, e.g. zlib, openssl, etc.
+   * frameworks, e.g. Zope, Ruby on Rails, Spring, etc.
+
+しかし、アドオン機能を持つメジャーなアプリケーション、たとえばFirefox、Thundervird、\
+OpenOffice.org、Drupal、Wordpress、Joomlaなどにも、このことはあてはまります。
+
+.. However it applies equally for popular applications on which add-ons are
+   built, e.g. Firefox, Thunderbird, OpenOffice.org, Drupal, Wordpress, Joomla,
+   etc.
+
+コミュニティの境界をこえて案件や障害修正の追跡と管理をするための作業をサポートして\
+くれるツールが必要です。
+そのようなツールは、両極端にいるどちらのユーザも助けてくれます。:
+
+* 自分のことばで問題を報告することができるユーザ。
+  たとえば、「オペレーションシステムX上のアプリケーションYで、Zタイプのイメージの\
+  レンダリングがおかしい」など
+
+* 変更や障害修正が下流のプロダクトに与える影響をよりよく評価できる開発者。
+  たとえば、「グラフィックライブラリのバグを修正することにより、これらの10個のOS上の\
+  5つのアプリケーションに恩恵がある」など
+
+.. Tools that assist communities work together to track and manage
+   issues and fixes across community boundaries are required. These
+   tools help people at both ends of the spectrum:
+
+.. * users can report problems in their terms, e.g. rendering of image
+     type X is broken in application Y on operating system Z
+
+.. * developers can better appreciate the downstream impact of making a
+     change or fix, e.g. fixing this bug in a graphics library will
+     make the users of these 5 applications on these 10 operating
+     systems happy.
+
+その間にいる人々は、 *点線をつなぎ* 、上流と下流との間のコミュニケーションを担うという\
+重要な役割を果たします。
+多くの場合、彼らはエンドユーザのためにバグを修正したり、パッチをリリースしたり、上流の\
+開発チームに修正内容を提示したりします。
+それらすべてを持続可能な方法で常に追跡しつづけることは、簡単なことではありません。
+
+.. People in the middle play the essential role of *joining the dots* and
+   communicating up and down the line. In many cases, they may also fix the
+   problem for end users, releasing a patch and pushing a suggested fix
+   to the upstream development team. Keeping track of all that over time
+   in a sustainable way is no easy task.
+
+
+Launchpad: 開発をもっと効果的に、摩擦は少なく
+-------------------------------------------------
+
+`Ubuntu <http://www.ubuntu.com>`_ の開発に出資しているのと同じように、Canonicalは\
+オープンソースコミュニティ向けの無料のサービスとしてLaunchpad(https:launchpad.net)も\
+提供しています。
+Launchpadは、以下の注目すべき理由から、もっともエキサイティングなCDEsのひとつです。:
+
+* トラッキング対象のたくさんのもの同士の関係を具体化しています。
+  たとえば、ソースコードのブランチをバグ修正に関連づけることができます。
+
+* これまでの資産を管理するのと同じように、ロードマップ、マイルストーン、ブループリントの\
+  機能によってこれからの開発の計画や追跡もできます。
+
+* 翻訳ツールやパッケージングサービスを提供することで、翻訳者やテスターがコミュニティに参加し、\
+  貢献するときの抵抗を少なくしています。
+
+* 違うコミュニティ同士が、関連する案件やロードマップに対してともに作業するための結びつきを\
+  提供します。
+
+.. As well as sponsoring `Ubuntu <http://www.ubuntu.com>`_ and
+   `Bazaar <http://bazaar-vcs.org>`_ development, Canonical
+   provides Launchpad, https://launchpad.net, as a free service
+   for the open source community. Launchpad is one of the most
+   exciting CDEs around for several notable reasons:
+
+.. * it models relationships between many of things tracked, e.g.
+     source code branches can be associated with bug fixes
+
+.. * as well are managing historical knowledge,
+     it supports future development planning and tracking by providing
+     features such as roadmaps, milestones and blueprints
+
+.. * it provides translation tools and packaging services so that
+     barriers are reduced for translators and testers wishing to
+     join your community and help out
+
+.. * it provides a nexus for different communities to work
+     together on related issues and roadmaps.
+
+言いかえると、Launchpadは、あなたのコミュニティの成長を助け、 *コミュニティ内* と\
+*コミュニティ間* との両方でワークフローの摩擦を減らすようにデザインされています。
+究極的には、機械的なタスクにつかう時間をなくし、興味ぶかい開発により多くの時間を\
+さけるようにすることを意味しています。
+
+.. In other words, Launchpad has been designed to help your
+   community grow and to reduce the workflow friction both
+   *within* your community and *between* communities. Ultimately,
+   that means less time on mechanical tasks and more time for
+   interesting development.
+
+
+Bazaar: Launchpadのバージョン管理クライアント
+---------------------------------------------
+
+このチュートリアルは、BazaarとLaunchpadがどのようにして一緒に使うことができ、\
+どれだけお互いを引き立てあうのかを考えます。
+以下のことは覚えておいてください。:
+
+1. BazaarはLaunchpadなしで使うこともできます。
+2. LaunchpadはBazaarなしで使うこともできます。
+
+それでも、別々に使うよりも一緒に使った方がよりパワフルになるよう設計されています。
+
+.. This tutorial looks at how Bazaar and Launchpad can be used together
+   and how they complement each other. It is important to remember that:
+
+.. 1. Bazaar can be used without Launchpad
+.. 2. Launchpad can be used without Bazaar.
+
+.. By design though, their sum is greater than the individual
+   parts.
+
+
+Finding and browsing branches using Launchpad
+=============================================
+
+Finding available branches
+--------------------------
+
+While there are many advantages in adopting distributed version
+control, one of the things that disappears is the all-knowing
+central server with knowledge about all available branches. Indeed
+in a distributed environment, interesting branches can literally
+exist in 100s of locations across the Internet (or within an
+Intranet for that matter).
+
+Launchpad fills this gap by providing a registry of branches.
+
+
+Registering branches
+--------------------
+
+Branches can be uploaded to Launchpad or simply registered
+as being available in an external location. Branches can also
+be given a Status such as *New*, *Development*, *Mature* or
+*Abandoned*.
+
+Note: External branches can even be hosted in legacy version control
+tools, i.e. CVS and Subversion. Code in these systems will be
+scanned and converted to Bazaar branches on a periodic basis.
+For maximum fidelity of course, it is preferable for external
+branches to be hosted in Bazaar.
+
+
+Browsing branches
+-----------------
+
+Branches can be listed, filtered and sorted by numerous
+attributes including Name, Registrant, Author, Status, Age and
+time of last commit. Browsing of branches is also provided making
+it easy to see things such as:
+
+* where the branch can be downloaded from
+* how to upload changes
+* recent commits and the changes made by each
+* the source code of individual files for a given version.
+
+
+Accessing code in Launchpad using Bazaar
+========================================
+
+Getting the code for an open source project
+-------------------------------------------
+
+As Launchpad keeps track of thousands of open source projects
+and their latest code whether it be managed by Bazaar, CVS or Subversion,
+Bazaar users can grab that code as easily as this::
+
+  bzr branch lp:project-name
+
+where `project-name` is the Launchpad project ID. Here are some examples::
+
+  bzr branch lp:inkscape
+  bzr branch lp:amarok
+  bzr branch lp:python
+  bzr branch lp:rails
+  bzr branch lp:java-gnome
+
+You can then browse the code locally using your favorite editor or IDE and
+change the code if you wish.
+
+If a project has multiple series registered (e.g. a development series and a
+maintenance series), the latest code for a given series can be fetched using::
+
+  bzr branch lp:project-name/series
+
+Publishing your changes
+-----------------------
+
+Having fixed that annoying bug or added that cool feature you've always
+wanted, it's time to impress your friends and make the world a better
+place by making your code available to others. As explained earlier,
+Launchpad is a free Bazaar code hosting service so you can push your
+branch to it and others can access your code from there. For example,
+assuming you are a member of the relevant team, login to launchpad like this::
+
+  bzr launchpad-login userid
+
+where `userid` is your Launchpad user ID.
+You can then push your changes to a team branch like this::
+
+  bzr push lp:~team-name/project-name/branch-name
+
+Others can then download your code like this::
+
+  bzr branch lp:~team-name/project-name/branch-name
+
+
+Personal branches
+-----------------
+
+Even if you are not a member of a team, Launchpad can be used to publish
+your changes. In this case, simply create a personal branch like this::
+
+  bzr push lp:~userid/project-name/branch-name
+
+Others can then download your code like this::
+
+  bzr branch lp:~userid/project-name/branch-name
+
+Note: Even when publishing to a personal branch, it is polite to notify the
+upstream developers about your branch so they can pull your changes from
+it if they are generally applicable to all users and meet the project's
+quality standards.
+
+
+Linking branches using Launchpad
+================================
+
+Associating a branch with a bug
+-------------------------------
+
+After registering a branch, you can associate it to a bug so that
+people interested in that bug can track and download the fix as
+it becomes available.
+
+To do this, the steps are:
+
+1. Navigate to the bug in question.
+
+2. Select `Add branch` under `Actions`.
+
+3. Select the branch.
+
+4. Optionally set the State of the relationship. This is
+   *Fix In Progress* by default but you may wish to set it
+   to another state such as *Fix Available* if the branch already
+   addresses the issue.
+
+If you wish, you can also provide some arbitrary comments about
+the relationship between the bug and the branch.
+
+
+Changing the state in Launchpad while committing in Bazaar
+----------------------------------------------------------
+
+Bazaar and Launchpad can work together to reduce some of
+the status housekeeping for you. When you commit using Bazaar,
+use the --fixes option like this::
+
+  bzr commit --fixes lp:1234 -m "..."
+
+where 1234 is the bug ID. This will changes the State of the
+bug-branch relationship to *Fix Available*. If the one commit
+fixes multiple issues, the --fixes option can be specified multiple
+times.
+
+One of the cool things about this feature is that Launchpad does
+not need to be accessible when making the commit. The ``--fixes``
+option works by storing metadata which Launchpad will detect next
+time the branch is pushed to it or scanned once online again.
+
+Note: Launchpad will not implicitly close a bug just because a
+branch is available that fixes it. There are several reasons for this.
+Firstly, the branch usually needs to be merged into the trunk
+(main development branch) before most teams consider it fixed.
+Secondly, many teams have a separate process for confirming
+bugs are fixed over and above a developer saying so.
+
+As explained later, merge control features are currently under
+development in Launchpad and automatically changing the status of
+bugs to *Fix Committed* will be more appropriate once those features
+are in place.
+
+
+Associating a branch with a blueprint
+-------------------------------------
+
+After registering a branch, you can associate it to a blueprint so that
+people interested in that blueprint can track and test the feature as
+it develops.
+
+To do this, the steps are:
+
+1. Navigate to the blueprint in question.
+
+2. Select `Link branch` under `Actions`.
+
+3. Select the branch.
+
+If you wish, you can also provide some arbitrary comments about
+the relationship between the blueprint and the branch.
+
+
+Managing releases using Launchpad
+=================================
+
+Integrating changes
+-------------------
+
+Once a branch has been developed and published, communities
+typically go through a rigorous process before those changes
+are integrated into the core product and rolled out to end users.
+Some of the steps involved may include:
+
+* peer review of the changes
+
+* deciding which releases to include the changes in, e.g. the
+  next maintenance release, the next major release, or both
+
+* running functional regression tests
+
+* benchmarking to ensure performance remains acceptable
+
+* packaging into early access releases for end user testing
+
+* documentation updates, e.g. Release Notes for the targeted
+  releases
+
+* translation of the user interface and documentation into
+  multiple languages.
+
+This section briefly looks at some of the features in Launchpad that
+help get good quality code into production. Strong integration with
+Bazaar is core to making this happen smoothly.
+
+Note: Where indicated, some of the features below are still under
+development. If one or more of these features interest you, please
+consider joining the Launchpad beta test team at this link:
+https://help.launchpad.net/JoiningLaunchpadBetaTesters. You can
+then get early access to features and provide feedback to the
+developers before wider roll-out.
+
+
+Branch merge proposals
+----------------------
+
+After navigating to a branch in Launchpad, one of the available actions
+is *Propose for merging*. This lets you nominate which branch this code
+ought to be merged into.
+
+Tracking the knowledge about which branches are proposed to be merged
+into a codeline helps Release Managers keep on top of what still needs
+to be completed, or can be completed, before a ship date. Using this
+information, they can ensure branches are merged after completing any
+necessary reviews. In the simple case, the Release Manager may manually
+merge branches. In more advanced cases, the merging could be automatically
+done by a robot (like `PQM`_) when the branch reaches the right state
+(e.g. *Review completed*).
+
+.. _PQM: https://launchpad.net/pqm
+
+
+Code review tracking
+--------------------
+
+A number of features are under development in Launchpad to track the
+states, conversations and outcomes of code reviews. These features are
+expected to be integrated with branch merge proposals and branch
+browsing features.
+
+
+Personal Package Archives (PPAs)
+--------------------------------
+
+PPAs help developers and development teams get custom builds into the
+hands of users for early testing and feedback. In other words, a PPA
+allows a developer to form a community of testers who are interested
+in their changes. The testing community can install the packages,
+run them for the test period and then remove them cleanly from their
+system.
+
+See https://help.launchpad.net/PPAQuickStart for further details.
+
+
+Translations
+------------
+
+The Translations module in Launchpad is designed to make it easy for
+anyone to get involved translating applications to languages they know.
+Translators are shielded from the low level details.
+
+Launchpad keeps track of the translations for each major version of a
+project separately, allowing translators to continue to improve the
+translations of your stable releases while others start work on newer
+versions that are still in development. Translation speed in reduced
+by sharing resources across projects. Automatic suggestions, from a
+library of 750,000 translated strings, and a community of 19,000
+registered translators can radically cut the time required to
+localise your project into many languages.
+
+
+Summary
+=======
+
+The communities we join, whether off-line or on-line,
+say a lot about the sort of people we are. The flip-side
+to this is that the tools you choose for your community - particularly
+the CDE and version control tool - can have a large impact on who
+joins and how easily they can contribute.
+
+In their own right, Launchpad and Bazaar are highly useful tools.
+Together, they can:
+
+* help your community track major assets such as source code and knowledge
+* help it grow by reducing barriers to entry
+* help it interact with related communities.
+
+In particular, Launchpad is a free code hosting service for your Bazaar
+branches, branches can be browsed online, branches can be linked to bugs
+and blueprints, and the status of bug-branch relationships can be
+automatically managed by mentioning the bug while committing in Bazaar.
+Further integration is under development with the aim of streamlining
+the process from *great idea* to *running code in the hands of end users*.
+
+If you have any feedback on how you'd like to see Bazaar and Launchpad
+further integrated, please contact us on the Bazaar mailing list,
+bazaar@lists.canonical.com.
+
+While designed as a free service to support open source projects,
+Canonical may make Launchpad available to commercial software developers
+depending on their requirements. We would be happy to hear from you
+if you think Launchpad would be useful for managing your community,
+open source or otherwise.

=== added directory 'doc/ja/upgrade-guide'
=== added file 'doc/ja/upgrade-guide/data_migration.txt'
--- doc/ja/upgrade-guide/data_migration.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/upgrade-guide/data_migration.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,130 @@
+データ移行
+###############
+
+データ移行の準備
+-------------------
+
+移行を開始する前に、最初におこなうべきことがあります。
+
+1. 完全にバックアップをとってください。
+
+2. 古いブランチを消去(purge)する時間をとってください。
+
+完全なバックアップはなにか悪いことがおきたときのセーフティネットとなります。
+
+古いブランチの消去は移行対象となるデータを減らすことができます。これをおこなうためのいくつかのコツを
+`Finding obsolete branches`_　でご覧ください。
+
+移行に関連するコマンドの紹介
+----------------------------------
+
+データ移行時には注意すべき3つの重要なコマンドがあります。
+
+* **check** - リポジトリ、ブランチやツリーのデータ完全性に関するエラーのチェック。
+
+* **reconcile** - データ完全性に関するエラーの修復。
+
+* **upgrade** - 異なるデータフォーマットへの移行。
+
+**reconcile** はめったに必要ではありませんが  **check** を **upgrade** の前後で行うことは良い習慣です。
+
+これらのコマンドの詳細なヘルプは `Bazaarユーザーリファレンス`_ をごらんください。
+
+.. _Bazaarユーザーリファレンス: ../user-reference/index.html
+
+
+あなたのコミュニティとのコミュニケーション
+---------------------------------------------------------
+
+新しいフォーマットへのスムーズな移行を可能にするためには、以下が必須です:
+
+1. trunkの移行を行う責任者を1人きめること。
+
+2. trunkの移行試験が成功すること。
+
+3. trunkを移行する時間の予定をたてることと、前もってあなたのコミュニティに知らせておくこと。
+
+事前に警告をしておくことによりコミュニティに所属する人々が 移行日より前に Bazaarや必要なpluginを移行するのに十分な余裕を持つことができるでしょう。
+
+さらに大きなコミュニティにおいては、移行それ自身に要する時間に配慮しましょう。
+試験移行の後でどのくらい移行に時間がかかるのかに関する良い案を持っておくべきです。移行を週末か金曜日に行うことで問題が発生したときにあなた自身が一息つける時間をとることができることは道理にかなっているでしょう。
+
+trunkが移行したら、あなたはコミュニティに対して適切にお知らせし、彼らに彼ら自身のローカルブランチの移行説明書を示す必要があります。後ほど説明書の例を示します。
+
+
+スタンドアロンブランチの移行
+------------------------------------
+
+作業手順は以下のとおりです。:
+
+1. **bzr check** を起動します。
+
+2. もしエラーが発生したら、**bzr reconcile** を使ってエラーの修復をこころみてください。もしこれが失敗したら問題を解決してあなたのtrunkをクリーンにするために私たちがお手伝いできるようバグの報告ください。もし成功したならクリーンなtrunkなうちにバックアップをとってください。
+
+3. **bzr upgrade --format** を実行してください。**format** は 2a またはそれ以降のことです。
+
+4. **bzr check** を起動して最終結果が正しいかどうかを確認してください。
+
+
+共用リポジトリ中のブランチを移行
+-----------------------------------------
+
+移行は以下の手順で行ってください:
+
+1. 共用リポジトリの移行。
+
+2. ブランチの移行。
+
+3. 軽量チェックアウトの移行。
+
+スタンドアロンブランチの例のように **check** を移行の前後に行って問題が存在していないか、あるいは問題がひきおこされていないかを確認してください。
+
+
+Launchpad上のブランチを移行
+-------------------------------
+
+公開ブランチとプライベートブランチを独立させるために、Launchpadでは共用リポジトリではなく、スタックブランチをディスク容量の効率化の中心技術として使用しています。したがってLaunchpadをコードホスティングに使用しているプロジェクトでは新しいフォーマットへの移行は個人や社内でしようしているとはことなります。
+
+手順は次のようになります:
+
+1. 指名された人がtrunkのコピーを持ち移行作業を実施します。
+
+2. Launchpadにおいては 現在のtrunkを開発の中心(focus)からはずします。(これは *必ず* 実施してください、そうしないとこの後の手順が期待通りになりません。)
+
+3. 移行した trunk をLaunchpadに push します。
+
+4. 開発の中心(focus)に設定します。
+
+5. 古い trunk に登録しているユーザに対して新しい trunk へ登録するよう依頼します。
+
+つまり、これらの手順の意味は　古い trunk がいぜんとして有効でスタックされたブランチが存在し続けるということです。しかしながら開発の中心は移行後の trunk に切り替わっており、以後のLaunchpadにpushされるあなたのプロジェクトの新しいブランチは(移行後のtrunkに)スタックされます。
+
+この時点であなたはあなたのコミュニティに対して 新しいtrunkが有効になったことを知らせ、彼らに彼らのローカルブランチを移行する説明する準備ができました。
+
+
+中央の trunk が移行した後のローカルブランチ移行
+-----------------------------------------------------------
+
+スタンドアロンブランチの移行手順:
+
+1. 中央リポジトリの場所から最新のブランチを新しいディレクトリに取得します。
+
+2. 既存のブランチの中のあなたが行った修正を新しいブランチへpullあるいはmergeします。
+
+ブランチを共用リポジトリに移行する手順:
+
+1. 新しい共用リポジトリを新フォーマット(2aあるいはそれ以降)で作成します。
+
+2. 中央リポジトリから最新のブランチを作成した共用リポジトリへ格納します。
+
+3. あなたのローカルブランチで移行したいものを決定します。(もし決定していなければ、もちろんバックアップした後、  `Finding obsolete branches`_　してそのブランチを消去するのによい時間です。)
+
+4. 各ローカルブランチの移行に関して2つ選択肢があります。
+
+ * 新しいリポジトリで1つ空のブランチを **init** して古いリポジトリからリビジョンを **pull** する。
+
+ * 新リポジトリにおいて、 trunkから新しいブランチに **branch** した後古いリポジトリにおいてあなたが行った変更を **merge** する。
+
+前者の方法は(リビジョンの履歴という意味において)古いブランチと同一のブランチを得ることができる一方、parentブランチは古いブランチを指してしまい、新しいtrunkをさしません。もしあなたがこの方法をとった場合、おそらく branch.conf ファイルの parentブランチに関する設定をしなおしたくなるでしょう。
+
+それに比較して後者の方法は parentブランチは正確に設定されます。しかし、もしあなたがすべての最新のリビジョンをtrunkからそのブランチにincludeする用意ができていない限り理想的な方法にはなりません。

=== added file 'doc/ja/upgrade-guide/index.txt'
--- doc/ja/upgrade-guide/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/upgrade-guide/index.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,13 @@
+###########################
+Bazaar 2.0 移行ガイド
+###########################
+
+.. Please mark sections in included files as following:
+..   level 1 ========
+..   level 2 --------
+..   level 3 ~~~~~~~~
+..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
+
+.. include:: overview.txt
+.. include:: data_migration.txt
+.. include:: tips_and_tricks.txt

=== added file 'doc/ja/upgrade-guide/overview.txt'
--- doc/ja/upgrade-guide/overview.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/upgrade-guide/overview.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,77 @@
+概要
+########
+
+移行手順の概要
+----------------
+
+Bazaar 2.xへのアップグレード作業は3段階あります:
+
+1. コアソフトウェアの移行
+
+2. 必要なプラグインの移行
+
+3. 新しいデフォルトフォーマットへのデータ移行
+
+Bazaar 2.xは以前のブランチのフォーマットをサポートしているので、厳密には3番目の手順は
+必要ありません。しかし、Bazaar 2.xの新しいデフォルトフォーマットはより効率よく領域を使用する、
+巨大なプロジェクトでより高速になる、さまざまな新しい特徴をそなえている、などの理由からほとんどのプロジェクトについて都合のよいときにでもアップグレードすることをおすすめします。
+
+ほとんどのユーザの方は2.xへのアップグレードと新しいフォーマットへの移行に苦労しません。
+しかしながら、大勢の開発者がいる(もしくは多くの開発者をようする)プロジェクトでは移行作業に手間がかかります。
+この場合、注意深く計画をたてることとよいコミュニケーションが必要不可欠となります。
+本文書はこの視点からの一般的なアドバイスを記載しています。
+不安な点がありましたら、メーリングリストやIRCチャンネルで私たちにおたずねください。
+
+
+コアソフトウェアの移行
+-----------------------
+
+コアソフトウェアの移行手順はオペレーティングシステムによって異なります。
+Bazaar 1.xからBazaar 1.yへの移行とBazaar 1.xからBazaar 2.0への移行には特に違いはありません。手順の概要は以下のようになります。
+
+Linuxでの移行手順:
+
+1. 必要なソフトウェアのソースに関してお使いのパッケージマネージャの設定をおこなう。
+       たとえばUbuntuの正式なリリースのPPAは https://launchpad.net/~bzr/+archive です。
+
+2. パッケージマネージャを使用して最新バージョンに移行する。
+
+Windowsでの移行手順:
+
+1. 「プログラムの追加と削除」で古いバージョンを削除する。
+
+2. 新しいバージョンのインストーラでインストールする。
+
+OS Xでの移行手順(インストーラを使用):
+
+1. 新しいバージョンのインストーラでインストールする。
+
+OS Xでの移行手順 (MacPortを使用):
+
+1. package metadataを更新する。 **sudo port selfupdate**
+
+2. 最新のバージョンに更新する。 **sudo port upgrade bzr**
+
+インストールや移行に関する詳しい情報については http://bazaar-vcs.org/Download
+をごらんください。	
+
+必要なプラグインの移行
+-----------------------
+
+多くのプラグインは特定のBazaarのバージョンに依存していないので、任意の作業です。
+他のプラグイン、特にbzrtoolsとbzr-svnはBazaarのAPIにかたく結びついているので、
+大体はコアソフトウェアとあわせて移行する必要があります。
+
+WindowsやOS Xをお使いのかたは、bzrtoolsとbzr-svnはインストーラに付属していますので
+移行にあたって特別な作業は必要ありません。LinuxやUNIXをお使いのかたは、bzrtools、bzr-svn
+や他の著名なプラグインをインストールしたり移行作業をお使いのプラットホームのパッケージマネージャ
+(たとえばUbuntuのSynaptic)でおこなうことができます。
+
+
+新しいデフォルトフォーマットへのデータ移行
+-------------------------------------------
+
+冒頭でも説明しましたように新しいフォーマットへの移行に伴う複雑さはいくつかの要因、特にプロジェクトの
+コミュニティの大きさに依存します。また、データがどのように保存されているかにも依存します。たとえば
+standaloneブランチとか、複数のブランチがshared repositoryに格納されているかとか、Launchpad上の
+stackedブランチかなどです。これらのシナリオについては次章で説明します。

=== added file 'doc/ja/upgrade-guide/tips_and_tricks.txt'
--- doc/ja/upgrade-guide/tips_and_tricks.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/upgrade-guide/tips_and_tricks.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,23 @@
+役立つヒントとコツ
+######################
+
+古いブランチを見つけるには
+-----------------------------
+
+もしあなたが開発における各変更や個々に行っている拡張のためにブランチの機能を使っている場合、いくつかのもう必要とされないブランチを持つことになるかもしれません。たいていの場合、関係のある変更は trunkにマージされているはずです。そのほかの場合ブランチは自分あるいは他人が行った別の変更の結果、古くなっているはずです。
+
+古いブランチをチェックするときには特に3つの点に注意があります。
+
+1. ワーキングツリーは変更の途中でないこと。
+
+2. ワーキングツリー内にはbzr shelveコマンドによって退避された変更をふくんでいないこと。
+
+3. どんなローカルでコミットされたリビジョンもparentブランチにマージされていること。
+
+ブランチのルートディレクトリに移動したあと、これらの点を個々にチェックするためのコマンドは以下です::
+
+  bzr status
+  bzr shelve --list
+  bzr missing --mine-only
+
+もしあなたのブランチがローカルの共用リポジトリに入っているならば、(revision 159またはそれ以降の)Bazaar Explorerのリポジトリビューの中の *Local Changed* タブがあなたが選択したブランチについて、いまのところはshelveコマンドによって退避された変更を除き、上記の情報の概要を表示するので有用です。

=== added directory 'doc/ja/user-guide'
=== added file 'doc/ja/user-guide/adv_merging.txt'
--- doc/ja/user-guide/adv_merging.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/adv_merging.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,105 @@
+疑似マージ
+===========
+
+チェリーピッキング
+------------------
+
+時々、ブランチの変更の全部ではなく一部だけを選んでマージすることが\
+便利であることがあります。
+これは一般的に *チェリーピッキング(cherrypicking)* として言及されます。
+
+チェリーピッキングが役に立ついくつかの事例:
+
+* メインの開発ブランチから修正の一部を取り出してリリースブランチに取り込む
+
+* 実験ブランチから改善内容を選別して機能ブランチに取り込む
+
+``foo`` ブランチのリビジョン Xによってなされた変更のみをマージするためには::
+
+  bzr merge -c X foo
+
+``foo`` ブランチのリビジョンXまでの変更のみをマージするためには::
+
+  bzr merge -r X foo
+
+``foo`` のリビジョンX以降の変更のみをマージするためには::
+
+  bzr merge -r X.. foo
+
+``foo`` ブランチのリビジョンXからリビジョンYまでの変更のみをマージするには::
+
+  bzr merge -r X..Y foo
+
+通常のマージと同じように、チェリーピックは明示的にコミットしなければなりません。
+これを行う前に、 ``bzr diff`` を利用した変更を見て何かあればテストスイートを\
+実行するとよいでしょう。
+
+通常のマージとは異なり、Bazaarは現在はチェリーピックを追跡しません。
+具体的に言うと、変更は通常のコミットと同じようになり、他のブランチから来た(内部の)変更履歴は失われます。
+上記のようなチェリーピックが役に立つ場面では、このことはたいてい重大な問題ではありません。
+フルマージが後で行われることはけっしてないと言える十分な理由があるからです。
+そうではない場面では、変更が再びマージされたときにまた衝突を解消する必要があります。
+
+.. _reverse-cherrypicking:
+
+リバースチェリーピッキング
+---------------------------
+
+チェリーピッキングは一連の変更を元に戻すことができます。この場合、リビジョン範囲の\
+上界(upper bound)が下界(lower bound)よりも *小さく* なります。
+たとえば、リビジョン10の変更を取り消すためのコマンドはこうなります::
+
+  bzr merge -r 10..9
+
+どこかから、すべてではない大半の変更を得たい場合通常のマージをした後に少しの\
+リバースチェリーピックを行うとよいでしょう。
+
+
+コミットされていない変更をマージする
+-------------------------------------
+
+複数のブランチを持っており、間違えて別のブランチを変更し始めた場合、訂正をとるステップは次のとおりです。
+ブランチ ``bar`` で作業したかったのに、ブランチ ``foo`` で作業を始めてしまったという場合を前提とします:
+
+1. ``bar`` ブランチに移動する
+2. ``bzr merge --uncommitted foo`` を実行する
+3. やってくる変更をチェックする (``bzr diff``)
+4. ``foo`` ブランチに変更する
+5. ``bzr revert`` を実行する
+
+.. TODO Selective file merging?
+
+
+リベースする
+--------------
+
+通常のマージの別のオプションは *リベース(rebase)* です。
+すなわち、現在のブランチが本来とは異なる地点をベースにするようにします。
+リベースは ``rebase`` プラグインによって提供される ``rebase`` コマンド\
+によってサポートされます。
+
+``rebase`` コマンドは現在の作業ディレクトリ内のリベースされるブランチ上で\
+別のブランチの位置をとります。
+ブランチが指定されないと親のブランチが使われ、通常これは望まれる結果です。
+
+最初のステップは現在のブランチのものであるが親のブランチではないリビジョンを\
+特定することです。
+現在のブランチはターゲットブランチと同じリビジョンに設定され、それぞれの\
+リビジョンはブランチのトップで再現されます。
+プロセスの終了時に現在のブランチがターゲットの最終リビジョンからブランチ\
+されたようになります。
+
+再現されるそれぞれのリビジョンがツリーの中で衝突を起こすことがあります。
+これが起きたらコマンドは停止してそれらを修正しなければなりません。
+``merge`` するためにコミットを解消し、それらが解消されたものとしてマークするために
+``bzr resolve`` を実行します。
+すべての衝突を解消したら、リベースオペレーションを続けるために ``bzr rebase-continue``
+を実行します。
+衝突に遭遇せず続けないことを決めたら、 ``bzr rebase-abort`` を実行できます。
+リプレイされるコミットの一覧を表示するために ``rebase-todo`` を利用することもできます。
+
+注: マージトラッキング機能が貧弱なVCSツールから来たユーザーの中にはリベースを好む人がいます。
+古いツールでの作業方法に似ている、もしくは"完璧にきれいな" 履歴が重要だからです。
+Bazaarでリベースする前に、通常のマージがベターな選択肢ではないのか考えてください。
+とりわけ、始める前にプライベートなブランチをリベースするのは大丈夫ですが、
+他の誰かとブランチを共有した後のリベースは **強く非推奨** です。

=== added file 'doc/ja/user-guide/annotating_changes.txt'
--- doc/ja/user-guide/annotating_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/annotating_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,34 @@
+変更に注釈を付ける
+===================
+
+内容の起源を探し出す
+--------------------
+
+複数の人がファイルに取り組むとき、
+誰が作ったのかもしくは最後に変更された内容を一度に見ることができるのは非常に便利です。
+これを行うためには、annotateコマンドを使います::
+
+  bzr annotate readme.txt
+
+悲観主義者もしくは楽観主義者のどちらかであるなら、
+``annotate`` の組み込みのエイリアスである ``blame`` もしくは ``praise``
+を使うことを好むかもしれません。
+どの方法であれ、次のような情報と一緒にファイルのそれぞれの行が表示されます:
+
+ * 最後に変更した人
+ * 最後に変更した時間
+ * コミットメッセージ
+
+GUIツール
+----------
+
+Bazaar用のさまざまなGUIは注釈の情報を閲覧するためのグラフィカルなツールを提供します。
+たとえば、bzr-gtkプラグインはこの機能を ``gannotate`` コマンドを使用して起動できる\
+GUIツールとして提供します::
+
+  bzr gannotate readme.txt
+
+GUIツールは関心のある情報をより豊かに表現するので
+(たとえばそれぞれのコミットのすべての変更内容)、\
+テキストベースよりも好ましいかもしれません。
+

=== added file 'doc/ja/user-guide/bazaar_workflows.txt'
--- doc/ja/user-guide/bazaar_workflows.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/bazaar_workflows.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,181 @@
+ワークフロー
+=============
+
+Bazaarはただのツール
+---------------------
+
+Bazaarは多くの異なる共同作業の方法を支援します。
+このことはあるワークフローで始めて状況が変われば別のワークフローを\
+採用できることを意味します。
+"唯一の正しい方法"は存在しませんし今後も現れることはりません。
+このセクションではBazaarによってサポートされる人気のあるいくつかの\
+ワークフローの手短な概要を提供します。
+
+これらのワークフローはBazaarの使い方の *一部* であることを念頭にお願いします。
+ここに記載されていないワークフローを利用したいのであれば、\
+下記に記載されているアイディアを足場にします。
+
+ソロ
+----
+
+ソフトウェアを開発する、ドキュメントを編集するもしくは設定ファイルを\
+変更するのであれ、簡単に使えるVCSは手助けになります。
+投稿者が1人であるプロジェクトを複数管理するために\
+単独のユーザーはこのワークフローを効率的に利用できます。
+
+.. image:: images/workflows_single.png
+
+まったくバージョン管理を使わない場合と比べたこのワークフローの利点は次のとおりです:
+
+ * 古いバージョンのバックアップ
+ * 前の状態へのロールバック
+ * 履歴の追跡
+
+このワークフローに適切なBazaarの主要な機能は管理作業が少ない\
+(サーバーのセットアップは不要)ことと簡単に利用できることです。
+
+
+パートナー
+-----------
+
+時に2人で変更を共有して共同作業をする必要があります。
+これは一般的に *ソロ* のワークフロー (上記を参照) もしくは\
+チーム指向のワークフロー(下記を参照)として始まります。
+ある時点で、2人目の人が最初の人が行った内容(履歴も含む)を含む\
+ブランチを作ります。
+適切なときにマージして変更内容を交換することで並行して作業できます。
+
+.. image:: images/workflows_peer.png
+
+*ソロ* を上回る利点は次のとおりです:
+
+ * 変更の共有が簡単
+ * それぞれのテキストファイルのそれぞれの行は変更した人、\
+   時間と理由を含む特定の変更と結びつけられています。
+
+このワークフローを採用する場合、BazaarはCVSとSubversionに対して
+次のような利点があります:
+
+ * サーバーのセットアップが不要
+ * インテリジェントなマージ機能により複数回のマージ作業が苦痛では
+   なくなります。
+
+
+集中型
+-------
+
+*lock-step* としても知られますが、これはCVSとSubversionによって\
+推奨/強制されるワークフローと本質的に同じです。
+すべての開発者が同じブランチに取り組みます。
+最新の内容をチェックアウトするために ``bzr update`` を実行し、\
+変更内容を中心位置にコミットするために ``bzr commit`` を実行します。
+
+.. image:: images/workflows_centralized.png
+
+このワークフローを導入するのであればSubversionとCVSも簡単なのでよい選択肢です。
+Bazaarはこのワークフローも直接サポートしていて、CVSとSubversionを上回る利点を\
+いくつかもちます:
+
+ * よりよいブランチとマージ
+ * よりよいリネームのサポート
+
+
+ローカルなコミットで集中型
+---------------------------
+
+このワークフローは、開発者が ``commit --local`` もしくはチェックアウトをunbind\
+して一連の変更を行うこと以外は、 *集中型* モデルと基本的に同じです。
+こういった一連の変更が完了するとき、開発者は作業内容を共用のメインラインに\
+コミットします。
+
+.. image:: images/workflows_localcommit.png
+
+*集中型* を越える利点:
+
+ * 旅行の間にネットに接続していないなどのオフラインで作業できます
+ * 誰かの作業を妨げる良くないコミットをする機会が少なくなります
+
+SubversionとCVSはこのモデルをサポートしません。
+他の分散型VCSツールはこれをサポートしますが、Bazaarよりも直接的ではありません。
+
+
+共用のメインラインで分散型
+-----------------------------
+
+このワークフローにおいて、それぞれの開発者は独自のブランチを持ち、\
+加えてメインブランチにコミットする権限があります。
+開発者は個人のブランチに取り組み、準備ができたらそれをメインラインに\
+マージします。
+
+.. image:: images/workflows_shared.png
+
+*ローカルコミットつきの集中型* を越える利点は次のとおりです:
+
+ * 作業内容の編成が簡単になる - それぞれのブランチで個別の変更を開発できます。
+ * 開発者は共同作業に取り組むときに別の人の個人ブランチをマージできます。
+
+SubversionとCVSはこのモデルをサポートしません。\
+他の分散型VCSツールはサポートします。
+Bazaarの多くの機能は、簡単な利用、共用レポジトリ、統合されたマージ機能と\
+リッチなメタデータ(ディレクトリのリネームの追跡を含む)を\
+含めてこのワークフローに有効です。
+
+人間のゲートキーパーで分散型
+-----------------------------
+
+このワークフローにおいて、それぞれの開発者は独自のブランチを持ち、\
+それに加えてメインのブランチに対してリードオンリーのアクセス権限を持ちます。
+1人の開発者(ゲートキーパー)はメインのブランチにコミットする権限を持ちます。
+1人の開発者が彼らの作業をマージしたい場合、ゲートキーパーに\
+マージしてくれるように頼みます。
+ゲートキーパーはコードのレビューを行い、必須の基準を満たすのであれば\
+作業内容をメインブランチにマージします。
+
+.. image:: images/workflows_gatekeeper.png
+
+*共用のメインラインによる分散型* に対する利点は次のとおりです:
+
+ * 常にコードはメインラインに入る前にレビューされます。
+ * 変更をメインラインに組み込むときに厳格なコントロールができます
+
+Bundle Buggyと呼ばれるBazaarのコンパニオンツールはどんな変更が\
+レビュー待ちになっているのか、その変更のステータスとレビューアの\
+コメントを追跡するのにとても便利です。
+
+
+自動的なゲートキーパーで分散型
+-------------------------------
+
+このワークフローにおいて、それぞれの開発者は独自のブランチを持つのに加えて、\
+メインストリームにリードオンリーのアクセス権限を持ちます。
+ソフトウエアのゲートキーパーはメインのブランチにコミットする権限を持ちます。
+開発者が作業内容をマージしたいとき、開発者は別の人にレビューを頼みます。
+レビューに合格したら、チームの方針によって、オリジナルの著者もしくは
+レビューワがゲートキーパーソフトウェアにマージするように頼み、
+ゲートキーパーソフトウェアはマージし、コンパイルし、テストスィートを実行します。コードがパスする場合のみ、メインラインにマージされます。
+
+注: 代替として、レビューのステップをスキップして著者は変更を自動化された\
+ゲートキーパーに投稿できます。
+(これはコードのレビューを別のステップとしてではなくジャストインタイムの\
+レビューを効果的に推進するペアプログラミングといった習慣を利用している\
+ときにとりわけ適切です。)
+
+.. image:: images/workflows_pqm.png
+
+*人間のゲートキーパーによる分散型* に対する利点は次のとおりです:
+
+ * コードはメインラインに入る前に常にテストされます
+   (メインラインの完全性が高まります)
+ * チームの規模の成長に対応できます
+
+BazaarのコンパニオンツールであるPatch Queue Manager (PQM)
+は自動化ゲートキーパーの機能を提供します。
+
+
+ワークフローを実施する
+-----------------------
+
+上記のそれぞれのワークフローを実施する方法を詳しく知りたいのであれば、\
+このマニュアルの3章から6章までを参照してください。最初に、2章で、\
+インストール方法、一般的な使い方の手引きと設定方法に関するティップス\
+が説明されています。

=== added file 'doc/ja/user-guide/branching_a_project.txt'
--- doc/ja/user-guide/branching_a_project.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/branching_a_project.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,100 @@
+プロジェクトをブランチする
+===========================
+
+ブランチのURL
+--------------
+
+誰かがあなたの作品のコピーを手に入れる前に、転送プロトコルを理解する必要があります。
+ブランチのトップレベルのディレクトリを、Windowsユーザーが慣れ親しんだ方法で、\
+ネットワーク上で共有することを決定するとします。
+LinuxとOS Xのユーザーは、大抵のSSHサーバーに組み込まれているセキュアなプロトコルである、\
+SFTPを通してアクセスする方が望ましいです。
+Bazaarは下記で一部が示されるたくさんのプロトコルのサポートに関して *とても* 柔軟です。
+
+  ===========   ==========================================================================
+  スキーム      説明
+  ===========   ==========================================================================
+  file://       標準ファイルシステムを利用してアクセスする (デフォルト)
+  sftp://       SFTPを利用してアクセスする (大抵のSSHサーバーはSFTPを提供する)
+  bzr://        Bazaarのスマートサーバーを利用した高速のアクセス
+  ftp://        パッシブFTPを利用してアクセスする
+  http://       ウェブサーバーによってエクスポートされたブランチへの読み込み限定のアクセス
+  ===========   ==========================================================================
+
+上記で示されるように、ブランチは転送プロトコルを示すスキームを伴うURLを使用して識別されます。
+スキームが無ければ、通常のファイルの名前が想定されます。
+サポートされるプロトコルの完全なリストに関しては、
+``urlspec`` のオンライントピックもしくはBazaarのユーザーリファレンスの
+`URLの識別子 <../user-reference/bzr_man.html#url-identifiers>`_
+のセクションを参照してください。
+
+.. _a-reminder-about-shared-repositories:
+
+共用レポジトリに関するリマインダ
+---------------------------------
+
+ブランチのコピーを手に入れる前に、ファイルシステム上に設置する場所を少し考えて\
+みましょう。
+最大限のストレージの効率性のために、共用リポジトリとしてセットアップされた\
+ディレクトリの元でブランチを作ることを推奨します。
+(よく使われるレイアウトについては、 `作業スペースを構成する
+<organizing_your_workspace.html>`_ の中の `ブランチの機能
+<organizing_your_workspace.html#feature-branches>`_
+を参照してください)
+たとえば::
+
+  bzr init-repo my-repo
+  cd my-repo
+
+誰からでもブランチを入手して好きなようにする準備ができました。
+
+ブランチのコマンド
+-------------------
+
+既存のブランチに基づいたブランチを手に入れるためには、 ``branch``
+コマンドを使用してください。構文は次のとおりです::
+
+  bzr branch URL [directory]
+
+ディレクトリの名前が渡されない場合、URLの最後の部分に基づいてディレクトリが作成されます。
+ドライブ名 (M:/) とSFTPのURLを示すそれぞれの例は次のとおりです::
+
+  bzr branch M:/cool-trunk
+  bzr branch sftp://bill@mary-laptop/cool-repo/cool-trunk
+
+新しいブランチを使うために明示的にディレクトリの名前を渡す例は次のとおりです::
+
+  bzr branch /home/mary/cool-repo/cool-trunk cool
+
+時間とスペースへの考慮
+-----------------------
+
+転送されるブランチのサイズと コンピュータとソースのブランチの間のネットワーク帯域と
+レイテンシによっては、この初期の転送は少し時間がかかります。
+その後の更新は変更のみが転送されるので遙かに速くなります。
+
+Bazaarは最新のスナップショットではなくブランチの完全な履歴を転送することを覚えておいてください。
+結果として、 ``branch`` を完了させた後でネットワークから離脱しても、
+ブランチの履歴に対して ``log`` と ``diff`` を好きなだけ行うことができます。
+さらに、履歴がローカルで保存されているのでこれらのオペレーションは速いです。
+
+Bazaarはバージョンの履歴を保存するために求められるディスクスペースの総量を\
+最小限にするスマートな圧縮技術を使うことに注意してください。
+多くの場合、プロジェクトの完全な履歴は最新バージョンの作業コピーよりも少ない\
+ディスクスペースを占めます。
+
+後の章で説明するように、Bazaarはブランチの軽量チェックアウト、
+すなわち履歴のローカルなストレージなしの作業ツリーもサポートします。
+もちろん、接続しない使い方は利用できませんが、ローカルディスクスペースが\
+本当に厳しいのであればそれはあなたが決めることができるトレードオフです。
+現在、制限された履歴の振り返りのためのサポート - *履歴の水平線(history horizon)* -
+は開発段階にあります。
+
+ブランチの情報を閲覧する
+-------------------------
+
+配布元も含むブランチの情報を見たいのであれば、 ``info`` コマンドを使います::
+
+  bzr info cool
+
+ブランチが引数として渡されなければ、現在のブランチの情報が表示されます。

=== added file 'doc/ja/user-guide/browsing_history.txt'
--- doc/ja/user-guide/browsing_history.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/browsing_history.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,93 @@
+履歴を閲覧する
+================
+
+bzr log
+-------
+
+``bzr log`` コマンドは以前のリビジョンの一覧を表示します。
+
+``bzr diff`` と同じように, ``bzr log`` は ``-r`` の引数をサポートします::
+
+    % bzr log -r 1000..          # リビジョン1000とその後のすべて
+    % bzr log -r ..1000          # r1000とそれまでのすべて
+    % bzr log -r 1000..1100      # 1000から1100までの変更
+    % bzr log -r 1000            # リビジョン1000のみの変更
+
+マージされたリビジョンを見る
+------------------------------
+
+Bazaarのような分散型のVCSは集中型のVCSツールよりもマージが非常に簡単なので、
+ブランチの履歴は、メインラインから分離してその後メインラインにマージされる\
+ようなラインを含むことがあります。
+技術的には、無数のリビジョンノード間の関係は無閉路有向グラフ(Directed Acyclic Graph: DAG)として知られます。
+
+多くの場合、まずはメインラインを見てそのあとに別のラインを見たいものです。
+そのため、log のデフォルトの動作はメインラインを表示して、マージされた\
+リビジョンがあるある場所を指示します。::
+
+  bzr log -n0 -rX
+
+全てのリビジョンと全てのマージされたリビジョンを見る場合は::
+
+  bzr log -n0
+
+-n オプションは表示するレベルを意味し、0の場合は全てを意味することに注意してください。
+もしそれがゴミゴミしているなら、値を変更して調整することが容易にできます。
+たとえば、もしあなたのプロジェクトがトップレベルのgatekeeperがチームレベルのgatekeeperからマージするように構成されている場合、\
+``bzr log`` はトップレベルgatekeeperの履歴だけを表示し、 ``bzr log -n2``
+はチームのgatekeeperの履歴を表示します。
+しかし、ほとんどの場合においては ``-n0`` で十分でしょう。
+
+
+出力をチューニングする
+-----------------------
+
+``log`` コマンドは出力を調整するために便利ないくつかのオプションを持ちます。次のものが含まれます:
+
+ * ``--forward`` はログを年代順で表します。
+    すなわち最新のリビジョンが最後に表示されます。
+
+ * ``--limit`` オプションは表示されるリビジョンの最大数を制御します。
+
+出力の調整方法の詳しい情報に関してはユーザーリファレンスのlogコマンドのオンラインヘルプを参照してください。
+
+ファイルの履歴を閲覧する
+-------------------------
+
+特定のファイルのみに適用されるように履歴をフィルタリングすることが便利であることがよくあります。
+これを行うためには、ファイルの名前を ``log`` コマンドに提供します::
+
+  bzr log foo.py
+
+古いバージョンのファイルを閲覧する
+-----------------------------------
+
+指定されたバージョンでファイルの内容を取得するには、次のように ``cat`` コマンドを使います::
+
+  bzr cat -r X file
+
+``X`` はリビジョンの識別子で ``file`` はファイルの名前です。
+これは出力を標準出力ストリームに送信しますので、次のように\
+閲覧ツール( ``less`` や ``more`` など)に出力をパイプで渡すか\
+リダイレクトするといいでしょう::
+
+  bzr cat -r -2 foo.py | less
+  bzr cat -r 1 foo.py > /tmp/foo-1st-version.py
+
+グラフィカルな履歴ビューワ
+----------------------------
+
+履歴のブラウジングはGUIツールが人生を本当に楽にしてくれる領域です。
+QBzrとbzr-gtkを含めてこの機能を提供するBazaarのプラグインがたくさんあります。
+これらがまだインストールされていなければ `プラグインを利用する <plugins.html>`_ で詳細なインストール方法をご覧ください。
+
+QBzrからグラフィカルビューワを使うには::
+
+  bzr qlog
+
+bzr-gtkからグラフィカルビューワを使うためには::
+
+  bzr viz
+
+``viz`` は実際には ``visualize`` の組み込みのエイリアスなので望むのであれば長い方のコマンド名を使います。
+

=== added file 'doc/ja/user-guide/bug_trackers.txt'
--- doc/ja/user-guide/bug_trackers.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/bug_trackers.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,49 @@
+バグトラッカー
+===============
+
+Bazaarにはコミットをプロジェクトのバグトラッカーのバグに関連づけできる機能があります。
+コミットとバグの間のハイパーリンクを生成する、もしくはコミットを含むブランチで閉じた\
+バグを自動的にマークするために、他のツール (もしくはフック) はこの情報を使うことができます。
+
+コミットとバグを関連付ける
+---------------------------
+
+コミットを行うとき、 ``commit`` の ``--fixes`` オプションを利用することでバグと関連付けることができます。例です::
+
+    $ bzr commit --fixes lp:12345 -m "Properly close the connection"
+
+このコマンドの実行によってコミットとLaunchpdのバグ12345とリンクするBazaarのメタデータが記録されます。
+異なるバグトラッカーを使う場合、( ``lp`` の代わりに) 独自のトラッカーコードを渡して代わりに使うことができます。
+Bugzilla、Trac、Roundupとその他のバグ/問題トラッカーに対してこれを設定する方法の詳細に関しては、
+Bazaarユーザーリファレンスの `バグトラッカーの設定`_ を参照してください。
+
+.. _バグトラッカーの設定: ../user-reference/bzr_man.html#bug-tracker-settings
+
+メタデータの記録 vs バグトラッカーの更新
+------------------------------------------
+
+コミット時に修正されたバグに関するメタデータの記録は完全なバグトラッカーの統合機能の中で唯一必要なものです。
+Bazaarは分散型VCSなので、ユーザーがオフラインでコミットしているためバグトラッカー自身へのアクセスが不可能な場合があります。
+代わりに、プロジェクトのワークフローに適切な中心位置に変更をpushするとき、\
+バグトラッカーを更新するためにフックをインストールすることが推奨されます。
+
+注: この2番目の処理段階はLaunchpadの外部もしくはホストされているブランチがスキャンされるときに
+Launchpadによって提供される統合機能の一部です。
+
+訂正をする
+-----------
+
+リビジョンとバグを関連付けるこの方法にはいくつかの制限があります。
+最初のものは関連づけはコミット時のみにしかできないことです。
+このことは、コミットするもしくは修正した後でバグが報告することを忘れた場合、
+一般的に後から差し戻してリンクを追加できないことを意味します。
+
+これに関連したことは関連づけは不変であるという事実です。
+バグがあるコミットによって修正されたものとしてマークされたが、リビジョンがバグを十分に解決しない、
+もしくは後で回帰がある場合、差し戻してリンクを削除できません。
+
+もちろん、正しいオプションで行うために最新コミットをアンドゥする ``bzr uncommit`` が常に使われます。
+これは正しくないコミットメッセージを訂正するためによく行われ、(たとえば ``--fixes`` を通した)最新コミットに
+記録されたメタデータを訂正するために等しく当てはまります。
+
+注: 正しくないリビジョンが公開される前に ``uncommit`` を行うのがベストです。

=== added file 'doc/ja/user-guide/bzrtools_plugin.txt'
--- doc/ja/user-guide/bzrtools_plugin.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/bzrtools_plugin.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,32 @@
+BzrTools
+========
+
+概要
+-----
+
+BzrToolsは便利なBazaar強化機能のコレクションです。
+インストールの手引きに関しては、BzrToolsのホームページを参照してください:
+http://bazaar-vcs.org/BzrTools.
+よく使われるコマンドのサンプルは下記のとおりです。
+
+
+shell
+-----
+
+``bzr shell`` はBazaarのコマンドを理解する以上のことを行うコマンドインタープリタを起動します。
+これはいくつかの利点を持ちます:
+
+ * すべてのコマンドの冒頭で ``bzr`` を入力する必要が無くなります。
+
+ * インテリジェントな自動入力補完が提供されます。
+
+ * Bazaarのライブラリを毎回ロードする必要がないのでコマンドは少し速く動作します。
+
+
+cdiff
+-----
+
+``bzr cdiff`` は GNU/Linux、UNIXとOS Xで ``bzr diff`` の出力の色つきバージョンを提供します。
+次のようによく使われます::
+
+  bzr cdiff | less -R

=== added file 'doc/ja/user-guide/central_intro.txt'
--- doc/ja/user-guide/central_intro.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/central_intro.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,32 @@
+集中型の開発
+=============
+
+動機
+-----
+
+並行して作業をして時折マージするよりも、ロックステップ、\
+すなわち複数の人が継続して変更を中心位置にコミットして\
+すべてのコミットの前に彼らの作業内容を最新の内容にマージすること、\
+で一度に作業をすることは有用であることがあります。
+
+このワークフローはSubversionとCVSのような集中型のVCSツールのユーザーには\
+とても慣れ親しまれています。
+単独の開発者が複数のマシンに取り組む場合にも応用できます。たとえば、\
+通常はデスクトップで作業をするが旅行の間はラップトップ、\
+もしくは(インターネットに接続した)ホームコンピュータで\
+勤務時間外に事務作業を完了させるといった具合です。
+
+あなたのチームがすでに集中型の開発でうまくいっているのであれば、それは\
+素晴らしいことです。
+多くのチームはこの方法でBazaarを使い始め、後で代替のワークフローを実験します。
+
+集中型のワークフロー
+---------------------
+
+下記のダイアグラムは *集中型のワークフロー* の概要を提供します。
+
+.. image:: images/workflows_centralized.png
+
+あなたのチームがより分散型のワークフローを利用することを計画しているとしても、
+この章でカバーされる多くのタスクは、とりわけブランチを公開する方法に関して\
+あなたにとって有用です。

=== added file 'doc/ja/user-guide/configuring_bazaar.txt'
--- doc/ja/user-guide/configuring_bazaar.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/configuring_bazaar.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,54 @@
+Bazaarを設定する
+==================
+
+Bazaarにあなたの名前を教える
+-----------------------------
+
+バージョン管理システムの機能の1つは誰が何を変更したのかを追跡することです。
+分散型のシステムでは、その機能を実現するためにグローバルにユニークな\
+それぞれの著者のための識別子が必要です。
+大抵の人はそれらの1つを持っています: Eメールアドレスです。
+Bazaarはあなたのユーザー名とホスト名を探し出してEメールアドレスを自動的に\
+生成します。
+Bazaarが行う推測を望まないのであれば、あなたが望む識別子を設定するために
+``whoami`` コマンドを使います::
+
+    % bzr whoami "Your Name <email@example.com>"
+
+``whoami`` は引数なしで使われると、現在の値が表示されます。
+
+設定ファイル
+-------------
+
+設定ファイルはLinux/Unixの場合 ``$HOME/.bazaar`` に、
+Windowsの場合 ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0`` にあります。
+この場所には3つの主要な設定ファイルがあります:
+
+* ``bazaar.conf`` はデフォルトの設定オプションを記述します。
+
+* ``locations.conf`` は特定のブランチの位置を記述しますd
+
+* ``authentication.conf`` はリモートサーバーのためのクレデンシャルな情報を記述します
+
+それぞれのブランチも特定の値をそのブランチに設定する設定ファイルを含みます。
+このファイルはブランチの中の ``.bzr/branch/branch.conf`` で見つかります。
+このファイルは **ブランチのすべてのユーザー** に見えます。
+あなたに固有の設定を持つブランチのための値の1つを上書きしたいのであれば、
+``locations.conf`` でそれを行うことができます。
+
+``whoami`` コマンドを使用してEメールアドレスを設定した後の ``bazaar.conf`` の内容のサンプルは次のとおりです::
+
+  [DEFAULT]
+  email = Your Name <email@example.com>
+
+サポートされる構文と構成設定の詳細については、
+Bazaarのユーザーリファレンスの `構成設定 <../user-reference/bzr_man.html#configuration-settings>`_ の項目を参照してください。
+
+
+ルールベースのプリファレンス
+-----------------------------
+
+いくつかのコマンドとプラグインは特定のパターンにマッチするファイルのカスタムの処理機能を提供します。
+ユーザーごとにルールベースのプリファレンスが ``BZR_HOME/rules`` で定義されます。
+ルールが検索される検索方法と関連ファイルの詳細な構文に関する詳細については、
+Bazaarのユーザープリファレンスの `ルール <../user-reference/bzr_man.html#rules>`_ の項目を参照してください。

=== added file 'doc/ja/user-guide/controlling_registration.txt'
--- doc/ja/user-guide/controlling_registration.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/controlling_registration.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,91 @@
+ファイルの登録を制御する
+=========================
+
+Bazaarは何を追跡するのか？
+--------------------------
+
+前に説明したように、 ``bzr add`` は現在のディレクトリの元でBazaarがバージョン管理すべきだと考える
+すべてのものを見つけ登録します。登録するものは次のようなものになります:
+
+ * ファイル
+ * ディレクトリ
+ * シンボリックリンク
+
+Bazaarは興味を持つファイルと興味を持たないファイルに関してデフォルトのルールを持ちます。
+後で説明される `ファイルを無視する`_ のようにこれらのルールを調整できます。
+
+他の多くのVCSツールとは異なり、Bazaarはディレクトリを第一級の項目として扱います。
+結果として、空のディレクトリは正しくサポートされます -
+ディレクトリが追跡されプロジェクトのエクスポートに含まれることを保証するために
+ディレクトリ内部にダミーファイルを作る必要はありません。
+
+シンボリックリンクに関しては、シンボリックリンクの値は追跡され、
+シンボリックリンクが指し示すものの内容は追跡されません。
+
+注: プロジェクトの中のプロジェクトを追跡するサポート機能 ("入れ子ツリー") は現在開発中です。
+この機能の開発を手伝うもしくはテストすることにご興味がありましたらBazaarの開発者に連絡して下さるようお願いします。
+
+登録を選ぶ
+-----------
+
+いくつかの事例において、登録したいものをBazaarに発見を任せるよりも明示的に指名したいことがあります。
+これを行うためには、パスを引数として ``add`` コマンドに提供します::
+
+  bzr add fileX dirY/
+
+ディレクトリを追加すると暗黙的にそのディレクトリの中の関心のあるすべてのものが追加されます。
+
+ファイルを無視する
+-------------------
+
+エディタのバックアップ、オブジェクト、バイトコードのファイル、ビルドされたプログラムなど、
+多くのソースツリーはバージョン管理する必要のないファイルを含みます。
+単純にこれらを追加しないでおくと、これらは常に未知のファイルとして現れます。
+ツリーのトップでこれらを ``.bzrignore`` と呼ばれるファイルに追加することでBazaarにこれらのファイルを無視するように指示することもできます。
+
+このファイルは一行ごとにファイルのワイルドカード(もしくは "globs")の一覧を含みます。典型的な内容は次のとおりです::
+
+    *.o
+    *~
+    *.tmp
+    *.py[co]
+
+globがスラッシュを含む場合、ツリーのトップからのパス全体がマッチします;
+さもなければファイルの名前だけにマッチします。以前の例では
+すべてのサブディレクトリ内の ``.`` の拡張子を持つファイルが無視されますが、
+次の例ではトップレベルでは ``config.h`` だけと ``doc/`` の中のHTMLが無視されます::
+
+    ./config.h
+    doc/*.html
+
+どのファイルが無視され何のパターンにマッチするのかについての一覧表を得るためには、 ``bzr ignored`` を使います::
+
+    % bzr ignored
+    config.h                 ./config.h
+    configure.in~            *~
+
+無視するパターンがバージョン管理されていないファイルのみにマッチし、それらが"unknown"もしくは"ignored"として扱われるのかを制御します。
+ファイルが明示的に追加されると、無視するパターンにマッチするかに関わらずバージョン管理されたままです。
+
+``.bzrignore`` ファイルは通常はバージョン管理されるので、ブランチの新しいコピーは同じパターンを見ます::
+
+    % bzr add .bzrignore
+    % bzr commit -m "Add ignore patterns"
+
+``bzr ignore PATTERN`` コマンドはPATTERNを ``.bzrignore`` ファイルに手軽に追加するために使われます
+(必要でBazaarによって追跡するために登録する場合、作られます)。
+``.bzrignore`` ファイルを直接編集することでパターンの除去と修正が行われます。
+
+グローバルで無視する
+---------------------
+
+プロジェクト固有のものではないが、ユーザー固有の無視されるファイルがいくつかあります。
+編集者用の一時ファイルもしくは個人の一時ファイルのようなものです。
+これらを無視するようにすべてのプロジェクトに追加するよりも、
+bzrは ``~/.bazaar/ignore`` の中でグローバルで無視するファイルをサポートします [#]_ 。
+これはプロジェクト単位で無視するファイルと同じ構文を持ちます。
+
+.. [#] Windowsにおいて、ユーザーの設定ファイルはアプリケーションデータディレクトリで見つかります。
+   ``~/.bazaar/branch.conf`` の代わりに、設定ファイルは次のように見つかります:
+   ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\branch.conf``
+   同じことが ``locations.conf`` 、 ``ignore`` 、と ``plugins`` ディレクトリにも当てはまります。

=== added file 'doc/ja/user-guide/core_concepts.txt'
--- doc/ja/user-guide/core_concepts.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/core_concepts.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,121 @@
+コアの概念
+===========
+
+単純なユーザーモデル
+---------------------
+
+Bazaarを使うために理解する必要のある概念は4つあります:
+
+* **リビジョン(Revision)** - 取り組むファイルのスナップショット
+
+* **作業ツリー(Working tree)** - バージョン管理されたファイルとサブディレクトリを含むディレクトリ
+
+* **ブランチ(Branch)** - ファイルの履歴を記述する、順序づけされたリビジョンの集合
+
+* **リポジトリ(Repository)**  - リビジョンの貯蔵場所
+
+それぞれを詳しく見てみましょう。
+
+リビジョン
+-----------
+
+リビジョンはファイルとディレクトリの内容と形を含むそれらのツリーの状態の **スナップショット** です。
+リビジョンはそれ自身に関連づけされたメタデータをいくつか含みます。メタデータには次のようなものが含まれます:
+
+* コミットした人
+* コミットした時間
+* コミットメッセージ
+* そのリビジョンの元になった親のリビジョン
+
+リビジョンは不変で、グローバルかつユニークに **リビジョンid (revision-id)** で識別できます。
+リビジョンidの例は次のとおりです::
+
+ pqm@pqm.ubuntu.com-20071129184101-u9506rihe4zbzyyz
+
+リビジョンidはコミットする、もしくは他のシステムからインポートする時点で生成されます。
+リビジョンidは内部で利用するときや外部ツールとの統合に必要ですが、
+ブランチ固有の **リビジョン番号** (*revision numbers*)の方が人間に好まれるインタフェースに\
+なります。
+
+リビジョン番号は 1 や 42 や 2977.1.59 のようにドットで区切られた10進法の識別子で\
+ブランチに対するリビジョン番号のグラフを通してパスを追跡します。
+リビジョン番号は一般的にリビジョンidよりも短く、単独のブランチの範囲では
+それらの関係を理解するためにそれぞれを比較できます。
+たとえば、リビジョン10はリビジョン9の直後のメインライン(下記を参照)のリビジョンです。
+リビジョン番号はコマンドが実行されているときに生成されます。
+これらはブランチ内でどのリビジョンがチップ(すなわち最新のリビジョン)であるかに依存するからです。
+
+Bazaarで指定できるリビジョンとリビジョンの範囲のいくつかの方法に関しては、付録の
+`リビジョンを指定する <specifying_revisions.html>`_ を参照してください。
+リビジョンの番号付けの詳細に関しては `リビジョン番号を理解する <zen.html#understanding-revision-numbers>`_
+を参照してください。
+
+.. *TODO: add diagram*
+
+作業ツリー
+------------
+
+作業ツリー(working tree)は ユーザーが編集できるファイルを保持する
+*バージョン管理されたディレクトリ* です。
+作業ツリーは *ブランチ* に関連付けされます。
+
+多くのコマンドは作業ツリーをそれぞれの文脈で使います。
+たとえば、 ``commit`` コマンドは作業ツリーの中のファイルの\
+現在の内容を利用して新しいリビジョン番号を作ります。
+
+.. *TODO: add diagram*
+
+ブランチ
+---------
+
+最もシンプルな場合、ブランチは *順序づけされた一連のリビジョン* です。
+最終リビジョンは *チップ(tip)* として知られます。
+
+ブランチは分かれたりその後再結合(*marged* back)されたりして、\
+グラフの形をとります。
+技術的にいえば、グラフは(親と子のリビジョンの間)の有行な関係を表し、\
+ループが存在しないので、 *directed acyclic graph* (DAG) として\
+言及されるかもしれません。
+
+この名前にギョッとするかもしれませんが、ご心配なく。
+覚えておくべき重要なことは次のとおりです:
+
+* DAGの範囲内での開発の主要なラインは *メインライン(mineline)*,
+  *トランク(trunk)*, もしくは単に *左側(left hand side: LHS)* と呼ばれます。
+
+* ブランチはメインラインではない開発ラインを持つことがあります。
+  そのとき、別のラインはある時点で始まり別の時点で終わります。
+
+.. *TODO: add diagram*
+
+レポジトリ
+-----------
+
+レポジトリはシンプルにいえば *リビジョンの保管場所* です。
+最もシンプルな事例では、それぞれのブランチが独自のレポジトリを持ちます。\
+別の事例では、ディスクの使用量を最適化するためにブランチに対してレポジトリを\
+共用しています。
+
+.. *TODO: add diagram*
+
+概念をまとめる
+---------------
+
+上記の概念を把握したら、Bazaarのさまざまな使い方が理解しやすくなります。
+Bazaarの最もシンプルな使い方は *スタンドアロンツリー(standalone tree)* で、\
+これは1つの位置に作業ツリー、ブランチとレポジトリのすべてが含まれます。
+他のよくあるシナリオには次のようなものがあります:
+
+* `共用リポジトリ(shared branch) <branching_a_project.html#a-reminder-about-shared-repositories>`_
+  - 作業ツリーとブランチは同じディレクトリにありますが、リポジトリは高い階層の\
+  ディレクトリに存在します。
+
+* `スタックブランチ(stacked branch) <stacked.html>`_
+  - 親のリポジトリと共通なリビジョンは親のリポジトリのものを利用することで、
+  ブランチはユニークなリビジョンだけを保存します。
+
+* `軽量チェックアウト(lightweight checkout) <using_checkouts.html#getting-a-lightweight-checkout>`_
+  - 作業ツリーとは別の場所にブランチが保存されます。
+
+Bazaarを使う最良の方法は、あなたのニーズ次第です。
+次に共通のワークフローを見てみましょう。

=== added file 'doc/ja/user-guide/distributed_intro.txt'
--- doc/ja/user-guide/distributed_intro.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/distributed_intro.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,24 @@
+分散型の開発
+=============
+
+動機
+----
+
+分散型のVCSツールは共同作業の新しい方法を提供します。
+これは私達が生きる現代の世界をより反映したものでより高い品質の\
+成果を可能にします。
+
+分散型の共用のメインラインのワークフロー
+-----------------------------------------
+
+このワークフローにおいて、それぞれの開発者は1つもしくは複数の\
+独自のブランチに加えて、メインブランチのチェックアウトを持ちます。
+開発者は個人のブランチに取り組み、準備ができたら、それをメインラインに\
+マージします。
+
+.. image:: images/workflows_shared.png
+
+他の分散型のワークフローはこの章の後ろの方で検討します。
+
+..
+   vim: tw=74 ft=rst

=== added file 'doc/ja/user-guide/entering_commands.txt'
--- doc/ja/user-guide/entering_commands.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/entering_commands.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,36 @@
+コマンドを入力する
+===================
+
+ユーザーインターフェイス
+-------------------------
+
+Bazaarに対して利用可能な数多くのユーザーインターフェイスが存在します。
+コアパッケージは **bzr** と呼ばれるコマンドラインツールを提供し
+グラフィカルユーザーインターフェイス(GUI)はプラグインとして利用できます。
+
+bzrを使う
+---------
+
+構文は次のとおりです::
+
+  bzr [グローバルオプション] command [オプションと引数]
+
+グローバルオプションはBazaarの動作方法に影響を与え ``command`` の前後に現れます。コマンド特有のオプションはコマンドの後で指定しなければなりませんが、コマンド固有の引数の前後と間で指定することができます。
+
+共通のオプション
+-----------------
+
+下記で示されるいくつかのオプションはすべてのコマンドに対して有効です。
+
+  ==========  =========  =================
+  短い形式    長い形式   説明
+  ==========  =========  =================
+  -h          --help     get help
+  -v          --verbose  be more verbose
+  -q          --quiet    be more quiet
+  ==========  =========  =================
+
+Quietモードはエラーと警告のみを表示します。これはスクリプトで使う際に便利です。
+
+注: 大抵のコマンドは1つのレベルの冗長性だけをサポートします。今後これは変更されるかもしれません。
+高度な冗長性を求めるためには、-vオプションを複数回指定するだけです。

=== added file 'doc/ja/user-guide/filtered_views.txt'
--- doc/ja/user-guide/filtered_views.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/filtered_views.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,165 @@
+Filtered views
+==============
+
+Filtered view の紹介
+--------------------------
+
+Viewはtreeに対するマスクを提供し、ユーザーはtreeの一部分に集中できる\
+ようになります。
+このマスキングが役に立ついくつかの場面があります。たとえば、大きな\
+プロジェクトの技術ライターやテスターはプロジェクトのうち一部のディレクトリ\
+やファイルだけを扱います。
+
+開発者は大規模な変更をviewを使っていくつかのコミットに分解したいと思う\
+かもしれません。 ``shelve`` ``unshelve`` がいくつかの変更を後のコミットまで\
+とっておくのに対して、viewは次のコミットに(何を含めないかではなく)何を\
+含めるかを指定します。
+
+viewを作った後は、ファイルリストをサポートするコマンド - status,
+diff, commit, etc - に暗黙的に毎回そのファイルリストが渡されます。
+それらのコマンドに明示的にファイルリストを渡すことも可能ですが、\
+指名するファイルは現在のviewの中にないといけません。
+対照的に、ツリーを対象とするコマンド - pull, merge, update, etc -
+はviewが作られた後もツリー全体に対して操作しますが、現在のviewに\
+関係するもののみを報告します。
+どちらのケースでも、Bazaarはユーザーに毎回viewが使われていることを\
+報告するので、操作や出力がマスクされていることが判ります。
+
+.. 2aになったらこのnoteは要らない
+.. Note: Bazaar's default format does not yet support filtered views. That
+   is likely to change in the near future. To use filtered views in the
+   meantime, you currently need to upgrade to ``development-wt6`` (or
+   ``development-wt6-rich-root``) format first.
+
+
+view を作る
+---------------
+
+次のように, ``view`` コマンドにファイルやディレクトリを指定することで\
+viewを作ります::
+
+  bzr view file1 file2 dir1 ...
+
+出力は::
+
+  Using 'my' view: file1, file2, dir1
+
+
+現在のviewをリストする
+------------------------
+
+現在のviewを見るには、 ``view`` コマンドに引数をつけないで実行します::
+
+  bzr view
+
+もしviewが無ければ、 ``No current view.`` というメッセージが出力されるでしょう。
+そうでなければ、現在のviewの名前と内容が次のように表示されます::
+
+  'my' view is: a, b, c
+
+
+viewを切り替える
+-----------------------
+
+ほとんどの場合、viewは「変更を選択するために作られて、\
+変更がコミットされると削除される」という具合に短い期間で使われます。
+それ以外の場合では、viewに名前をつけてそれを切り替えたい場合がある\
+かもしれません。
+
+名前つきviewを宣言してそれに切り替えるには::
+
+    bzr view --name view-name file1 dir1 ...
+
+たとえば::
+
+  bzr view --name doc NEWS doc/
+  Using doc view: NEWS, doc/
+
+名前つきviewを見るには::
+
+  bzr view --name view-name
+
+名前つきviewに切り替えるには::
+
+  bzr view --switch view-name
+
+全ての名前つきviewの一覧を得るには::
+
+  bzr view --all
+
+
+一時的にviewを無効にする
+----------------------------
+
+現在のviewを削除せずに無効にしたい場合、 ``off`` という名前の仮想viewに\
+切り替えることができます。これは、ツリー全体を一つか二つのコマンドで操作する\
+必要があり(例: merge)、しかしその後に元のviewに戻りたい場合に便利です。
+
+現在のviewを削除せずに無効にするには::
+
+  bzr view --switch off
+
+ツリー全体に対する操作が終わったら、元のviewの名前を指定して戻ることが\
+できます。たとえば、デフォルトの名前が使われて他のであれば::
+
+  bzr view --switch my
+
+
+viewを削除する
+--------------
+
+現在のviewを削除するには::
+
+  bzr view --delete
+
+名前つきviewを削除するには::
+
+  bzr view --name view-name --delete
+
+全てのviewを削除するには::
+
+  bzr view --delete --all
+
+
+注意点
+---------------------
+
+view を定義しても作業ツリー内のほかのファイルを削除するわけでは\
+ありません。単に作業ツリーに対する "レンズ" を提供するだけです。
+
+view は作業ツリーのメタデータとして保存されます。pull, push, update
+といったブランチコマンドを使っても他の作業ツリーに伝播しません。
+
+view はファイルパスの形で定義されます。もしview内のファイルをview外に
+移動したのであれば、view はそのファイルを追跡しません。
+たとえば、viewが ``doc/`` と定義されていて ``doc/NEWS`` を ``NEWS``
+に移動しても view は ``doc/`` に定義されたままで、 ``doc/`` と ``NEWS``
+のように変更されたりはしません。同じように、view内のファイルを削除しても\
+viewからはそのファイルパスは削除されません。
+
+
+現在のviewを利用するコマンドは:
+
+* status
+* diff
+* commit
+* add
+* remove
+* revert
+* mv
+* ls
+
+ツリー全体に対する操作だけれども現在のviewの中だけを報告するコマンドは:
+
+* pull
+* update
+* merge.
+
+現在のところ、多くのコマンドがviewを無視します。ニーズがある\
+コマンドから徐々に上の対応リストに追加されていくでしょう。
+いくつかのコマンドは全体図を見るのがより適しているために、\
+viewを無視したままになるでしょう。このタイプのコマンドには\
+次のものがあります:
+
+* log
+* info

=== added file 'doc/ja/user-guide/getting_help.txt'
--- doc/ja/user-guide/getting_help.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/getting_help.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,19 @@
+helpを表示する
+==============
+
+Bazaarは組み込みのオンラインヘルプシステムを搭載しています。
+トピックの一覧を見るためには::
+
+  bzr help topics
+
+コマンドの一覧を見るためには::
+
+  bzr help commands
+
+トピックのxxxもしくはコマンドのxxxのヘルプを表示するためには::
+
+  bzr help xxx
+
+ヘルプを検索するもしくは大きなドキュメントとして読みたい場合、
+情報はBazaarのユーザーリファレンスでも手に入ります。
+

=== added file 'doc/ja/user-guide/hooks.txt'
--- doc/ja/user-guide/hooks.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/hooks.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,59 @@
+フックを利用する
+================
+
+フックとは？
+------------
+
+Bazaarのふるまいをカスタマイズする1つの方法は *フック(hook)* です。
+フックによって特定のBazaarの特定のオペレーションの前後でアクションを実行できます。
+オペレーションは ``commit`` 、 ``push`` 、 ``pull`` 、と ``uncommit`` を含みます。
+フックとパラメータの完全なリストに関しては、ユーザーリファレンスの
+`フック <../user-reference/bzr_man.html#hooks>`_ を参照してください。
+
+大抵のフックはクライアントで実行されますが、サーバーで実行されるものもわずかにあります。
+(サーバーサイドのオペレーションの特殊なケースを扱うものは `bzr-push-and-update`_ プラグインも参照。)
+
+.. _bzr-push-and-update: https://launchpad.net/bzr-push-and-update/
+
+
+フックを使用する
+-----------------
+
+フックを使用するには、 `プラグインを書きます <#writing-a-plugin>`_ 。
+新しいコマンドを作成する代わりに、このプラグインはフックを定義してインストールします。例です::
+
+    from bzrlib import branch
+
+
+    def post_push_hook(push_result):
+        print "The new revno is %d" % push_result.new_revno
+
+
+    branch.Branch.hooks.install_named_hook('post_push', post_push_hook,
+                                     'My post_push hook')
+
+この例を使用するには、 ``push_hook.py`` という名前のファイルを作り
+``plugins`` サブディレクトリに設置します。
+(プラグインをインストールしていなければ、 ``plugins`` ディレクトリを作る必要があります)。
+
+以上です！次回にpushすると、"The new revno is..."が表示されます。
+もちろん、Pythonのフルパワーを思いとおりにできるので、フックはこれよりもはるかに手が込んでいます。
+これでフックの使い方を理解したので、それらで何をするかはあなたしだいです。
+
+プラグインのコードは2つのことを行います。
+最初に、これは ``push`` が完了した後に実行する関数を定義します。
+(代わりにインスタンスメソッドもしくは呼び出し可能なオブジェクトを使用することもできます。)
+すべてのpushフックは単独の引数 ``push_result`` をとります。
+
+2番目に、プラグインはフックをインストールします。
+最初の引数 ``'post_push'`` はフックがインストールされている場所を特定します。
+2番目の引数はフック自身です。3番目の引数は ``'My post_push hook'`` という名前で、
+これは進行メッセージとエラーメッセージで使用されます。
+
+
+フックをデバッグする
+---------------------
+
+インストールされたフックの一覧を表示するには、 ``hooks`` コマンドを使います::
+
+    bzr hooks

=== added file 'doc/ja/user-guide/http_smart_server.txt'
--- doc/ja/user-guide/http_smart_server.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/http_smart_server.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,221 @@
+FastCGIでBazaarを提供する
+==========================
+
+このドキュメントでは、Apache 2.0とFastCGIもしくはmod_pythonを利用して
+Bazaar HTTPスマートサーバーをセットアップする1つの方法を説明します。
+
+スマートサーバーに関する詳細な情報とそれを設定する他の方法に関しては、
+メインのスマートサーバーのドキュメントを参照してください。
+
+例
+---
+
+プレーンなHTTPで `/srv/example.com/www/code` を `http://example.com/code/...` として
+すでに公開しているとします。これはbzrのブランチと `/srv/example.com/www/code/branch-one`
+と `/srv/example.com/www/code/my-repo/branch-two` のようなディレクトリを含みます。
+既存のHTTP形式のアクセス権限に加えてリードオンリーのスマートサーバーのアクセス権限を
+これらのディレクトリに提供したい場合を考えます。
+
+Apache 2.0を設定する
+--------------------
+
+FastCGI
+~~~~~~~
+
+最初に、mod_fastcgiを設定します。たとえば次の行をhttpd.confに追加します::
+
+    LoadModule fastcgi_module /usr/lib/apache2/modules/mod_fastcgi.so
+    FastCgiIpcDir /var/lib/apache2/fastcgi
+
+我々の例では、`http://example.com/code` で `/srv/example.com/www/code` をすでに提供しているので
+既存のApacheの設定は次のようになります::
+
+    Alias /code /srv/example.com/www/code
+    <Directory /srv/example.com/www/code>
+        Options Indexes
+        # ...
+    </Directory>
+
+.bzr/smartの形式で終わるURLに対するすべてのリクエストを扱うために
+次のように変更する必要があります::
+
+    Alias /code /srv/example.com/www/code
+    <Directory /srv/example.com/www/code>
+        Options Indexes FollowSymLinks
+        RewriteEngine On
+        RewriteBase /code
+        RewriteRule ^(.*/|)\.bzr/smart$ /srv/example.com/scripts/bzr-smart.fcgi
+    </Directory>
+
+    # bzr-smart.fcgiはDocumentRootの元に存在しないので、実行されるように
+    # AliasはこれをURLの名前空間のエイリアスにする。
+    Alias /srv/example.com/scripts/bzr-smart.fcgi /srv/example.com/scripts/bzr-smart.fcgi
+    <Directory /srv/example.com/scripts>
+        Options ExecCGI
+        <Files bzr-smart.fcgi>
+            SetHandler fastcgi-script
+        </Files>
+    </Directory>
+
+この設定はFastCGIを通して `/code` 内部の `/.bzr/smart` で終わるURLに対する
+Bazaarのスマートサーバーへのリクエストを扱うようにApacheに指示します。
+
+詳細な情報は mod_rewrite_ と mod_fastcgi_ のドキュメントを参照してください。
+
+.. _mod_rewrite: http://httpd.apache.org/docs/2.0/mod/mod_rewrite.html
+.. _mod_fastcgi: http://www.fastcgi.com/mod_fastcgi/docs/mod_fastcgi.html
+
+mod_python
+~~~~~~~~~~
+
+最初に、次のようなコードをhttpd.confに追加してmod_pythonを設定します::
+
+    LoadModule python_module /usr/lib/apache2/modules/mod_python.so
+
+FastCGIと同じ方法でmod_rewriteを用いて書き換えルールを定義します::
+
+    RewriteRule ^(.*/|)\.bzr/smart$ /srv/example.com/scripts/bzr-smart.fcgi
+
+変更は次のようになります::
+
+    RewriteRule ^(.*/|)\.bzr/smart$ /srv/example.com/scripts/bzr-smart.py
+
+mod_fastcgiのように、スクリプトがどのように扱われるのかも定義します::
+
+    Alias /srv/example.com/scripts/bzr-smart.py /srv/example.com/scripts/bzr-smart.py
+    <Directory /srv/example.com/scripts>
+        <Files bzr-smart.py>
+            PythonPath "sys.path+['/srv/example.com/scripts']"
+            AddHandler python-program .py
+            PythonHandler bzr-smart::handler
+        </Files>
+    </Directory>
+
+この設定はmod_pythonを通して `/code` 内部の `/.bzr/smart` で終わるURLに対するリクエストを
+Bazaarのスマートサーバーに渡すように指示します。
+
+注: bzrlibがPATHの中に存在しない場合、次の行を変更する必要があります::
+
+            PythonPath "sys.path+['/srv/example.com/scripts']"
+
+変更後は次のようになります::
+
+            PythonPath "['/path/to/bzr']+sys.path+['/srv/example.com/scripts']"
+
+
+詳細な情報は mod_python_ のドキュメントを参照してください。
+
+.. _mod_python: http://www.modpython.org/
+
+
+Bazaarを設定する
+-----------------
+
+FastCGI
+~~~~~~~
+
+`/srv/example.com/scripts/bzr-smart.fcgi` でスマートサーバーを実行するためにApacheを設定しました。
+これはスマートサーバーを設定するために書く必要のある単なるシンプルなスクリプトで
+サーバーをFastCGIのゲートウェイに結びつけます。次のようになります::
+
+    import fcgi
+    from bzrlib.transport.http import wsgi
+
+    smart_server_app = wsgi.make_app(
+        root='/srv/example.com/www/code',
+        prefix='/code/',
+        path_var='REQUEST_URI',
+        readonly=True,
+        load_plugins=True,
+        enable_logging=True)
+
+    fcgi.WSGIServer(smart_server_app).run()
+
+　`fcgi`のモジュールはhttp://svn.saddi.com/py-lib/trunk/fcgi.pyで見つかります。
+これは flup_ の一部です。
+
+.. _flup: http://www.saddi.com/software/flup/
+
+mod_python
+~~~~~~~~~~
+
+`/srv/example.com/scripts/bzr-smart.py` でスマートサーバーを実行するためにApacheを設定しました。
+これはスマートサーバーを設定するために書く必要のあるシンプルなスクリプトでサーバーをmod_pythonの
+ゲートウェイに結びつけます。次のようになります::
+
+    import modpywsgi
+    from bzrlib.transport.http import wsgi
+
+    smart_server_app = wsgi.make_app(
+        root='/srv/example.com/www/code',
+        prefix='/code/',
+        path_var='REQUEST_URI',
+        readonly=True,
+        load_plugins=True,
+        enable_logging=True)
+
+    def handler(request):
+        """Handle a single request."""
+        wsgi_server = modpywsgi.WSGIServer(smart_server_app)
+        return wsgi_server.run(request)
+
+`modpywsgi` モジュールは
+`http://dev.pocoo.org/projects/pocoo/browser/pocoo/wrappers/modpy.py` で見つかります。
+これは pocoo_ の一部です。modpywsgi.pyをbzr-smart.pyと同じディレクトリ
+(すなわち/srv/example.com/scripts/)に設置していることを確認してください。
+
+.. _pocoo: http://dev.pocoo.org/projects/pocoo/
+
+クライアント
+------------
+
+これで `bzr+http://` 形式のURLを利用できます::
+
+    bzr log bzr+http://example.com/code/my-branch
+
+プレーンなHTTP形式のアクセスも持続します::
+
+    bzr log http://example.com/code/my-branch
+
+
+高度な設定
+-----------
+
+BazaarのHTTPスマートサーバーはWSGIアプリケーションなので、
+WSGI標準に準拠するサードパーティのWSGIのミドルウェアもしくはサーバーで利用できます。
+唯一の要件は以下のとおりです:
+
+  * 　`SmartWSGIApp` をコンストラクトするためには、それが提供する **root transport** を指定する必要があります。
+  * それぞれのリクエストの `environ` dict は **'bzrlib.relpath'** 変数の設定を持たなければなりません。
+
+この例で使われている `make_app` ヘルパーは それに渡される `root` パスに基づいたトランスポートを伴う
+`SmartWSGIApp` をコンストラクトし、引数 `prefix` と`path_var` に基づくそれぞれのリクエストに対する
+　`bzrlib.relpath` を算出します。
+上記の例において、これは (Apacheによって設定される)'REQUEST_URI' を取り、接頭辞の '/code/' と接尾辞の '/.bzr/smart'
+をはぎ取り、それを 'bzrlib.relpath' として設定するので、 '/code/foo/bar/.bzr/smart' に対するリクエストは
+'foo/bzr' の 'bzrlib.relpath' になります。
+
+`SmartWSGIApp` を直接コンストラクトすることで、ローカルではないトランスポートに対して
+スマートサーバーを設定するもしくは任意任意のパスの変換を行うことは可能です。
+詳細な情報に関しては `bzrlib.transport.http.wsgi` のdocstringsと `WSGI標準`_ を参照してください。
+
+.. _WSGI標準: http://www.python.org/dev/peps/pep-0333/
+
+
+``bzr+http://`` を通してpushする
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+httpスマートサーバーを通してデータをプッシュすることは可能です。
+これを行うための最も簡単な方法は、 ``wsgi.make_app()`` コールに ``readonly=False`` を
+提供するだけです。ただし、スマートプロトコルは認証機能が含まれないので注意してください。
+書き込みのサポートを有効にする場合、
+実際にシステム上のデータを書き込みできる人を制限するために、 ``.bzr/smart`` URLへの権限を制限するとよいでしょう。
+
+現時点では、同じURLに対して読み込み限定の人と読み込みと書き込みの人を分けることはできません。
+(認証を行う)HTTPレイヤーにおいて、すべては単なるPOSTリクエストだからです。
+しかしながら、HTTPSアクセスの場合に認証が必要な書き込みサーバーを使い、
+プレーンなHTTPは読み込み限定のアクセスを許可することは確実にできます。
+
+
+..
+   vim: ft=rst tw=74 et

=== added directory 'doc/ja/user-guide/images'
=== added file 'doc/ja/user-guide/images/workflows_centralized.png'
Binary files doc/ja/user-guide/images/workflows_centralized.png and doc/ja/user-guide/images/workflows_centralized.png differ
=== added file 'doc/ja/user-guide/images/workflows_centralized.svg'
--- doc/ja/user-guide/images/workflows_centralized.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_centralized.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1542 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_centralized.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_centralized.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1.4142136"
+     inkscape:cx="536.99132"
+     inkscape:cy="369.73871"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1024"
+     inkscape:window-height="712"
+     inkscape:window-x="-4"
+     inkscape:window-y="-4" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr checkout</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(492.85715,-2.8571472)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.71429"
+       y="191.52307"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="777.71429"
+         y="191.52307">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="819.5625"
+       y="191.21948"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="819.5625"
+         y="191.21948">bzr update</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(51.511043,348.5966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="334.36819"
+       y="540.97681"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="334.36819"
+         y="540.97681">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="369.5625"
+       y="544.09448"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="369.5625"
+         y="544.09448">bzr commit</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_gatekeeper.png'
Binary files doc/ja/user-guide/images/workflows_gatekeeper.png and doc/ja/user-guide/images/workflows_gatekeeper.png differ
=== added file 'doc/ja/user-guide/images/workflows_gatekeeper.svg'
--- doc/ja/user-guide/images/workflows_gatekeeper.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_gatekeeper.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,2137 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_gatekeeper.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_manualpqm.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient7932"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7934"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7936"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7938"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7940"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7942"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7944"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient7946"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7948"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7950"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient7952"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7954"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7956"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7958"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7960"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient7962"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient7964"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7966"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient7968"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient7990"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <radialGradient
+       xlink:href="#linearGradient1861"
+       r="26.285225"
+       inkscape:collect="always"
+       id="radialGradient1887"
+       fy="44.906904"
+       fx="34.609807"
+       cy="45.317611"
+       cx="33.865884"
+       gradientTransform="scale(1.3025634,0.767717)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1861"
+       r="27.313507"
+       inkscape:collect="always"
+       id="radialGradient1885"
+       fy="96.522109"
+       fx="44.745902"
+       cy="96.948882"
+       cx="45.838441"
+       gradientTransform="scale(1.0963096,0.9121511)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="69.990188"
+       y1="60.176033"
+       xlink:href="#linearGradient1864"
+       x2="54.084046"
+       x1="51.210938"
+       inkscape:collect="always"
+       id="linearGradient1883"
+       gradientTransform="scale(1.2343409,0.8101489)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1858">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop1859" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop1860" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1861">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop1862" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1863" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1864">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop1865" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1866" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1867">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop1868" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1869" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11180">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop11182" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11184" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11174">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop11176" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11178" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11168">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop11170" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11172" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11162">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop11164" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop11166" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="559.94128"
+     inkscape:cy="472.46874"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1416"
+     inkscape:window-height="825"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,227.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(635.63525,491.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="73.4375"
+       y="510.12573"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="73.4375"
+         y="510.12573">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(466.18527,201.5491)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="751.04242"
+       y="395.37573"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="751.04242"
+         y="395.37573">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="778.89062"
+       y="392.32886"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="778.89062"
+         y="392.32886"
+         id="tspan2963">make changes</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.52894235;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 578.13978,492.35651 L 518.11306,536.64644 L 515.93459,528.2361 L 482.53728,552.4378 C 482.53728,552.4378 484.9546,560.99862 484.68867,561.16617 C 484.42242,561.33391 461.26447,562.83001 461.26447,562.83001 C 461.26447,562.83001 480.44933,537.04707 480.71524,536.87954 C 480.21048,536.89659 482.77445,545.21473 482.89387,545.28997 L 521.75768,517.49359 L 524.17482,526.05472 L 578.73553,485.35896 L 578.13978,492.35651 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(449.56027,418.37723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="732.41742"
+       y="611.97729"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="732.41742"
+         y="611.97729">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="768.26562"
+       y="608.23511"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="768.26562"
+         y="608.23511">request merge</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="75.5625"
+       y="228.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="75.5625"
+         y="228.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="556.98438"
+       y="165.64139"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="556.98438"
+         y="165.64139">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.27460909;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path7875"
+       d="M 313.49127,554.98551 L 266.8349,508.88833 L 275.69462,507.21539 L 250.19978,481.56811 C 250.19978,481.56811 241.18156,483.42447 241.00507,483.22026 C 240.82835,483.0158 239.25232,465.23179 239.25232,465.23179 C 239.25232,465.23179 266.41286,479.96469 266.58935,480.16889 C 266.57138,479.78127 257.8088,481.75026 257.72954,481.84196 L 287.01109,511.6872 L 277.99254,513.54344 L 320.8627,555.44302 L 313.49127,554.98551 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <g
+       id="g7884"
+       transform="translate(322.22009,479.97324)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient7932);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path7886"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient7934);fill-opacity:1"
+         id="g7888">
+        <path
+           style="fill:url(#linearGradient7936);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path7890"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient7938);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path7892"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient7940);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path7894"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient7942);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7944);stroke-width:1.44734821pt"
+         id="rect7896"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient7946);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path7898"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient7948);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path7900"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient7950);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect7902"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient7952);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient7954);stroke-width:1.4649456pt"
+         id="rect7904"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient7956);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path7906"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g7908">
+        <path
+           style="fill:url(#linearGradient7958);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path7910"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient7960);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path7912"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient7962);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path7914"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient7964);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path7916"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient7966);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path7918"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient7968);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path7920"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient7990);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path7922"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text7924"><tspan
+           id="tspan7926">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text7928"><tspan
+           id="tspan7930">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g11201"
+       transform="translate(224.98935,560.87966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11204"
+         d="M 61.208646,74.540863 C 65.958047,79.724425 68.980394,89.011639 75.672733,89.01164 C 82.14919,87.211791 83.012718,71.805094 83.876245,68.493375 C 76.536261,73.532948 68.980395,76.412704 61.208646,74.540863 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,-0.8485902,18.11889)"
+         style="fill:#ebd5bb;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path11206"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#354b63;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path11208"
+         d="M 32.210275,101.34753 C 31.819634,126.54379 96.449036,129.42515 96.292736,101.34753 C 97.837516,79.018786 86.732289,66.323086 83.972618,68.481556 C 82.571377,69.577533 82.050742,93.917319 72.58281,88.318677 C 67.97993,85.596878 62.831472,75.141814 60.578865,74.794949 C 57.17979,74.271545 50.671042,71.519447 44.693328,66.368738 C 43.125035,65.017418 32.739724,78.907727 32.210275,101.34753 z " />
+      <path
+         style="fill:#7e5429;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccscc"
+         id="path14564"
+         d="M 67.304802,16.686453 C 54.985668,-4.2976037 31.742548,13.847204 34.832083,38.13111 C 28.606909,39.936495 13.38594,55.735942 54.610465,51.217079 C 72.973357,49.204214 127.11969,28.718598 84.679736,22.863615 C 78.797006,1.2972292 67.040662,6.1031815 67.304802,16.686453 z " />
+      <path
+         style="fill:url(#linearGradient1883);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1879"
+         d="M 89.582928,41.074792 C 78.886738,46.748497 62.561318,51.815798 53.926678,52.762292 C 47.018518,53.519536 42.160188,53.578455 38.114178,53.356042 C 39.550848,66.152312 50.849068,76.168541 64.707928,76.168542 C 79.538378,76.168542 91.582928,64.747093 91.582928,50.668542 C 91.582928,47.276803 90.850878,44.035951 89.582928,41.074792 z " />
+      <path
+         style="fill:url(#radialGradient1885);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1884"
+         d="M 43.031249,70.1875 C 35.995246,80.448202 32.902215,93.581638 34.156249,105.875 C 40.334493,118.62839 56.831543,120.43683 69.499999,119.875 C 80.494576,119.32475 94.949065,113.14258 93.695531,100.00002 C 93.939855,90.023763 92.261916,78.780004 84.874999,71.5 C 82.650684,78.396104 83.536195,89.443626 74.999999,91.84375 C 65.062996,91.017122 64.05284,76.914438 54.283675,75.750529 C 50.352102,75.051855 46.009593,69.547093 43.031249,70.1875 z " />
+      <path
+         style="fill:url(#radialGradient1887);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1886"
+         d="M 51.968749,10.15625 C 40.703741,13.843837 36.038494,27.433868 37.531249,38.375 C 35.900906,41.584912 25.71302,45.254989 31.843749,49.03125 C 53.068339,53.154256 75.12687,46.221276 93.715523,36.077723 C 100.42684,33.740896 99.810666,26.846559 92.384918,26.66513 C 86.324151,26.558371 81.674394,23.81643 81.165374,17.307044 C 79.826948,13.582045 74.107596,6.6890987 71.01108,12.623276 C 71.073069,19.511996 65.891703,20.102559 63.230392,14.042893 C 60.468574,10.851605 56.135557,9.1882781 51.968749,10.15625 z " />
+    </g>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2488"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(82.857147,474.9866)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="365.71429"
+       y="668.60229"
+       id="text2490"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2492"
+         x="365.71429"
+         y="668.60229">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="401.5625"
+       y="665.76636"
+       id="text2494"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2496"
+         x="401.5625"
+         y="665.76636">accept or reject</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_localcommit.png'
Binary files doc/ja/user-guide/images/workflows_localcommit.png and doc/ja/user-guide/images/workflows_localcommit.png differ
=== added file 'doc/ja/user-guide/images/workflows_localcommit.svg'
--- doc/ja/user-guide/images/workflows_localcommit.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_localcommit.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1575 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_localcommit.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_localcommit.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient8493"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient8491"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient8485">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop8487" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop8489" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.70710678"
+     inkscape:cx="503.09779"
+     inkscape:cy="201.79714"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1024"
+     inkscape:window-height="712"
+     inkscape:window-x="-4"
+     inkscape:window-y="-4" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="763.75"
+       y="188.09448"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="35.529999"
+       inkscape:export-ydpi="35.529999"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="763.75"
+         y="188.09448">bzr commit --local</tspan><tspan
+         sodipodi:role="line"
+         x="763.75"
+         y="228.09448"
+         id="tspan7922" /></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="801.4375"
+       y="609.46948"
+       id="text7881"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan7883"
+         x="801.4375"
+         y="609.46948">bzr unbind</tspan><tspan
+         sodipodi:role="line"
+         x="801.4375"
+         y="641.46948"
+         id="tspan8507">bzr commit</tspan><tspan
+         sodipodi:role="line"
+         x="801.4375"
+         y="673.46948"
+         id="tspan8511">bzr bind</tspan></text>
+    <g
+       id="g7903"
+       transform="translate(21.8125,50.285718)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path7897"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text7899"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan7901"
+           sodipodi:role="line">1</tspan></text>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="351.375"
+       y="272.69269"
+       id="text7908"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan7910"
+         x="351.375"
+         y="272.69269">bzr checkout</tspan></text>
+    <g
+       id="g7912"
+       transform="translate(438.71429,-31.85714)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path7914"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text7916"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan7918"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.58159733;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path8495"
+       d="M 530.64409,443.90791 L 411.93077,455.56731 L 422.10621,437.94266 L 356.69344,443.63682 C 356.69344,443.63682 346.51796,461.80368 346.0335,461.80368 C 345.54844,461.80368 322.2908,438.21377 322.2908,438.21377 C 322.2908,438.21377 377.0437,413.53911 377.52817,413.53911 C 377.0437,412.99691 367.35272,430.89301 367.35272,431.16411 L 442.94217,425.19852 L 432.76613,443.36572 L 541.30393,431.97742 L 530.64409,443.90791 z " />
+    <g
+       id="g8497"
+       transform="translate(446.57144,390.28572)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path8499"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text8501"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan8503"
+           sodipodi:role="line">2</tspan></text>
+    </g>
+    <g
+       id="g8513"
+       transform="translate(59.142865,311.71429)">
+      <path
+         transform="matrix(0.5652174,0,0,0.5909091,121.25465,81.649039)"
+         d="M 340 221.23734 A 32.857143 31.428572 0 1 1  274.28571,221.23734 A 32.857143 31.428572 0 1 1  340 221.23734 z"
+         sodipodi:ry="31.428572"
+         sodipodi:rx="32.857143"
+         sodipodi:cy="221.23734"
+         sodipodi:cx="307.14285"
+         id="path8515"
+         style="fill:#000000"
+         sodipodi:type="arc" />
+      <text
+         sodipodi:linespacing="125%"
+         id="text8517"
+         y="225.53198"
+         x="286.3125"
+         style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+         xml:space="preserve"><tspan
+           y="225.53198"
+           x="286.3125"
+           id="tspan8519"
+           sodipodi:role="line">3</tspan></text>
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:100%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="389.375"
+       y="534.40698"
+       id="text8525"
+       sodipodi:linespacing="100%"><tspan
+         sodipodi:role="line"
+         id="tspan8527"
+         x="389.375"
+         y="534.40698">bzr commit</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_peer.png'
Binary files doc/ja/user-guide/images/workflows_peer.png and doc/ja/user-guide/images/workflows_peer.png differ
=== added file 'doc/ja/user-guide/images/workflows_peer.svg'
--- doc/ja/user-guide/images/workflows_peer.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_peer.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1589 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_peer.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_peer.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="536.99132"
+     inkscape:cy="369.73871"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1759"
+     inkscape:window-height="875"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       id="g5256"
+       transform="translate(601.5744,309.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(541.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(111.5744,317.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,300.80614,215.0989)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 357.16674,263.66524 L 470.27399,251.12251 L 460.57906,270.08242 L 522.9028,263.95688 C 522.9028,263.95688 532.59773,244.41369 533.05931,244.41369 C 533.52148,244.41369 555.68079,269.79078 555.68079,269.79078 C 555.68079,269.79078 503.51355,296.33479 503.05197,296.33479 C 503.51355,296.91808 512.74689,277.66616 512.74689,277.37453 L 440.72705,283.79207 L 450.42255,264.24852 L 347.01023,276.4996 L 357.16674,263.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="635.5625"
+       y="201.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="635.5625"
+         y="201.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(318.85715,7.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="601.71429"
+       y="199.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="601.71429"
+         y="199.52307">2</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 426.28539,558.28183 L 482.38891,565.59894 L 477.58003,554.5382 L 508.49388,558.1117 C 508.49388,558.1117 513.30276,569.51271 513.53172,569.51271 C 513.76096,569.51271 524.75243,554.70834 524.75243,554.70834 C 524.75243,554.70834 498.87641,539.22321 498.64746,539.22321 C 498.87641,538.88294 503.45634,550.11403 503.45634,550.28417 L 467.73303,546.54033 L 472.54219,557.94156 L 421.24757,550.79458 L 426.28539,558.28183 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-194.48896,372.41254)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="87.591393"
+       y="566.02826"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="87.591393"
+         y="566.02826">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="119.03906"
+       y="543.19232"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="119.03906"
+         y="543.19232">merge changes</tspan><tspan
+         sodipodi:role="line"
+         x="119.03906"
+         y="583.19232"
+         id="tspan2716">from peer</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2670"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-187.14285,5.361605)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="94.539062"
+       y="198.97729"
+       id="text2672"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2674"
+         x="94.539062"
+         y="198.97729">1</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="129.5625"
+       y="195.43823"
+       id="text2676"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2678"
+         x="129.5625"
+         y="195.43823">start project</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2680"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(-20.189728,217.62723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="261.83594"
+       y="411.22729"
+       id="text2682"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2684"
+         x="261.83594"
+         y="411.22729">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="294.51562"
+       y="388.40698"
+       id="text2686"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2688"
+         x="294.51562"
+         y="388.40698">record</tspan><tspan
+         sodipodi:role="line"
+         x="294.51562"
+         y="428.40698"
+         id="tspan2712">changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2690"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(321.8001,372.41254)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="603.88049"
+       y="566.02826"
+       id="text2692"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2694"
+         x="603.88049"
+         y="566.02826">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="635.32812"
+       y="543.19232"
+       id="text2696"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2698"
+         x="635.32812"
+         y="543.19232">merge changes</tspan><tspan
+         sodipodi:role="line"
+         x="635.32812"
+         y="583.19232"
+         id="tspan2718">from peer</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2700"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(462.85715,216.65848)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="744.88281"
+       y="410.25854"
+       id="text2702"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2704"
+         x="744.88281"
+         y="410.25854">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.5625"
+       y="387.43823"
+       id="text2706"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2708"
+         x="777.5625"
+         y="387.43823">record</tspan><tspan
+         sodipodi:role="line"
+         x="777.5625"
+         y="427.43823"
+         id="tspan2714">changes</tspan></text>
+    <path
+       inkscape:export-ydpi="41.964157"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_centralized.png"
+       d="M 515.71461,505.61603 L 459.61109,512.93314 L 464.41997,501.8724 L 433.50612,505.4459 C 433.50612,505.4459 428.69724,516.84691 428.46828,516.84691 C 428.23904,516.84691 417.24757,502.04254 417.24757,502.04254 C 417.24757,502.04254 443.12359,486.55741 443.35254,486.55741 C 443.12359,486.21714 438.54366,497.44823 438.54366,497.61837 L 474.26697,493.87453 L 469.45781,505.27576 L 520.75243,498.12878 L 515.71461,505.61603 z "
+       id="path2710"
+       sodipodi:nodetypes="cccccccccccc"
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:2.49513507;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1" />
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_pqm.png'
Binary files doc/ja/user-guide/images/workflows_pqm.png and doc/ja/user-guide/images/workflows_pqm.png differ
=== added file 'doc/ja/user-guide/images/workflows_pqm.svg'
--- doc/ja/user-guide/images/workflows_pqm.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_pqm.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1794 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_pqm.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_pqm.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient7934"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       id="linearGradient1858">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop1859" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop1860" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1861">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop1862" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1863" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1864">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop1865" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1866" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1867">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop1868" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1869" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11180">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop11182" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11184" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11174">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop11176" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11178" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11168">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop11170" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop11172" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient11162">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop11164" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop11166" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1"
+     inkscape:cx="559.94128"
+     inkscape:cy="392.13154"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1416"
+     inkscape:window-height="825"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2791"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(562.85715,227.14285)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="844.88281"
+       y="420.74292"
+       id="text2793"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2795"
+         x="844.88281"
+         y="420.74292">3</tspan></text>
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,39.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,227.66157)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(593.63525,509.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,417.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,874.16045,452.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="92.546875"
+       y="509.71948"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="92.546875"
+         y="509.71948">Server</tspan><tspan
+         sodipodi:role="line"
+         x="92.546875"
+         y="569.71948"
+         id="tspan2803">(PQM)</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(558.85715,89.5491)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="841.25"
+       y="283.37573"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="841.25"
+         y="283.37573">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="874.89062"
+       y="264.32886"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="874.89062"
+         y="264.32886"
+         id="tspan2788">make</tspan><tspan
+         sodipodi:role="line"
+         x="874.89062"
+         y="304.32886"
+         id="tspan2815">changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(449.56027,432.37723)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="732.41742"
+       y="625.97729"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="732.41742"
+         y="625.97729">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="768.26562"
+       y="622.23511"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="768.26562"
+         y="622.23511">accept or reject</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="75.5625"
+       y="228.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="75.5625"
+         y="228.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="556.98438"
+       y="165.64139"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="556.98438"
+         y="165.64139">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-477.33182,37.826027)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.0657387,0,0,1.0382501,-36.482679,-19.544354)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <g
+       id="g11201"
+       transform="translate(224.98935,560.87966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2488"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(44.857147,386.9866)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="327.71429"
+       y="580.60229"
+       id="text2490"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2492"
+         x="327.71429"
+         y="580.60229">5</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="363.5625"
+       y="577.76636"
+       id="text2494"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         id="tspan2496"
+         x="363.5625"
+         y="577.76636">request merge</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path2801"
+       d="M 530.83326,472.52373 L 417.72601,485.06646 L 427.42094,466.10655 L 365.0972,472.23209 C 365.0972,472.23209 355.40227,491.77528 354.94069,491.77528 C 354.47852,491.77528 332.31921,466.39819 332.31921,466.39819 C 332.31921,466.39819 384.48645,439.85418 384.94803,439.85418 C 384.48645,439.27089 375.25311,458.52281 375.25311,458.81444 L 447.27295,452.3969 L 437.57745,471.94045 L 540.98977,459.68937 L 530.83326,472.52373 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="878.89062"
+       y="396.40698"
+       id="text2811"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_manualpqm.png"
+       inkscape:export-xdpi="38.384644"
+       inkscape:export-ydpi="38.384644"><tspan
+         sodipodi:role="line"
+         x="878.89062"
+         y="396.40698"
+         id="tspan2813">request</tspan><tspan
+         sodipodi:role="line"
+         x="878.89062"
+         y="436.40698"
+         id="tspan2817">review</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_shared.png'
Binary files doc/ja/user-guide/images/workflows_shared.png and doc/ja/user-guide/images/workflows_shared.png differ
=== added file 'doc/ja/user-guide/images/workflows_shared.svg'
--- doc/ja/user-guide/images/workflows_shared.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_shared.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1594 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_shared.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_shared.png"
+   inkscape:export-xdpi="49.419998"
+   inkscape:export-ydpi="49.419998">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="radialGradient5536"
+       gradientUnits="userSpaceOnUse"
+       cx="42.007257"
+       cy="39.007645"
+       fx="42.280806"
+       fy="39.410465"
+       r="11.574221" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5540"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5542"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5544"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5546"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="25.220815"
+       y1="178.48862"
+       x2="25.220815"
+       y2="234.26866" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5548"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       x1="51.460928"
+       y1="269.85831"
+       x2="-16.224496"
+       y2="176.28694" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient893"
+       id="linearGradient5550"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1870691,0.842411)"
+       x1="146.69923"
+       y1="224.57898"
+       x2="74.533693"
+       y2="81.477602" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5552"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       x1="45.685757"
+       y1="110.4447"
+       x2="41.967061"
+       y2="232.24952" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5554"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       x1="-77.726178"
+       y1="208.43991"
+       x2="95.644441"
+       y2="11.699047" />
+    <radialGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1133"
+       id="radialGradient5556"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       cx="60.004654"
+       cy="56.485935"
+       fx="72.107883"
+       fy="39.288476"
+       r="68.589222" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5558"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       x1="92.437968"
+       y1="-3.9104078"
+       x2="27.674331"
+       y2="91.07699" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5560"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       x1="39.810948"
+       y1="90.197025"
+       x2="17.876529"
+       y2="113.71949" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5562"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.329144,0.7523639)"
+       x1="39.690614"
+       y1="49.507656"
+       x2="70.224305"
+       y2="20.481863" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5564"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       x1="35.190362"
+       y1="76.277559"
+       x2="8.346058"
+       y2="105.42543" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient888"
+       id="linearGradient5566"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       x1="141.60217"
+       y1="228.39311"
+       x2="88.447016"
+       y2="133.54711" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient902"
+       id="linearGradient5568"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       x1="101.10657"
+       y1="177.77768"
+       x2="95.100155"
+       y2="173.03153" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5570"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       x1="88.755695"
+       y1="169.09755"
+       x2="88.996957"
+       y2="182.99154" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1317"
+       id="linearGradient5572"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.223869,0.8170809)"
+       x1="111.49758"
+       y1="131.25248"
+       x2="107.04918"
+       y2="148.78619" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient892"
+       id="linearGradient5574"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       x1="31.449743"
+       y1="203.499"
+       x2="31.617281"
+       y2="251.21892" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="39.648127"
+       inkscape:collect="always"
+       id="radialGradient2797"
+       fy="101.92288"
+       fx="50.092871"
+       cy="102.70191"
+       cx="49.760482"
+       gradientTransform="scale(1.1222336,0.8910801)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="35.284406"
+       inkscape:collect="always"
+       id="radialGradient2791"
+       fy="32.061308"
+       fx="81.553592"
+       cy="33.402904"
+       cx="80.599566"
+       gradientTransform="scale(0.8352269,1.1972794)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="67.164412"
+       y1="53.505203"
+       xlink:href="#linearGradient4376"
+       x2="63.804663"
+       x1="64.786456"
+       inkscape:collect="always"
+       id="linearGradient2789"
+       gradientTransform="scale(1.1424512,0.8753109)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.8"
+     inkscape:cx="578.40513"
+     inkscape:cy="404.22798"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1405"
+     inkscape:window-height="869"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       inkscape:label="Layer 1"
+       id="g4996"
+       transform="matrix(0.331077,0,0,0.2676656,75.992157,230.68349)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <g
+         transform="matrix(2.674162,0,0,2.674162,-826.248,-323.8239)"
+         id="g6052">
+        <path
+           style="fill:#c7c7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:6.11299896;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="czcczzz"
+           id="path1306"
+           d="M 362.77592,187.283 C 360.50343,190.98677 361.20593,367.68763 364.14011,374.65173 C 366.46268,380.1642 441.02381,442.12988 444.93699,443.78694 C 495.35017,443.444 529.34176,425.0858 534.99109,415.38735 C 537.14042,403.1889 535.31621,215.19709 533.25552,211.25359 C 531.47859,207.85312 436.04893,173.6386 432.71615,172.86054 C 429.71763,172.16052 365.30189,183.1661 362.77592,187.283 z " />
+        <path
+           style="fill:#ffffff;fill-opacity:0.54385968;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path2066"
+           d="M 366.42857,190.93361 C 391.19048,201.4098 418.60601,218.30739 446.22506,231.64072 C 472.394,225.42153 510.2022,217.10972 529.24981,213.77639 C 504.726,221.39543 472.52022,228.51448 447.99641,236.13353 C 446.56784,293.51448 447.257,380.45861 445.82843,437.83956 C 445.11414,379.98242 443.14285,291.6479 442.42856,233.79075 C 415.99999,219.50504 390,206.64789 366.42857,190.93361 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path4356"
+           d="M 519.99794,379.97737 C 510.93834,392.99882 482.41849,399.43361 468.8726,394.16864 C 471.21835,393.5424 516.96143,380.96883 519.99794,379.97737 z " />
+        <g
+           transform="translate(2.035534,15.20712)"
+           id="g4374">
+          <path
+             style="fill:#ffffff;fill-opacity:0.39473685;fill-rule:evenodd;stroke:none;stroke-width:1.01199996;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="cccccc"
+             id="path4362"
+             d="M 471.29127,340.59039 L 513.55921,324.30516 C 517.9002,325.84805 517.04588,332.27818 517.04588,332.27818 L 510.46155,334.58088 C 510.46155,334.58088 501.26764,349.01224 484.93096,343.36795 C 484.93096,343.36795 472.7787,345.52605 471.29127,340.59039 z " />
+          <path
+             style="fill:#606060;fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:1.11199999;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+             sodipodi:nodetypes="ccccccc"
+             id="path2826"
+             d="M 471.66824,335.10501 C 485.70133,331.45482 499.73443,327.80464 513.76752,324.15445 C 514.30594,326.13864 514.34437,328.99782 513.50779,330.48201 C 511.36566,331.50652 507.10221,332.35425 504.96008,333.37876 C 498.80357,339.27354 493.45917,339.80363 483.65919,338.95243 C 479.87505,339.74603 476.0909,340.36284 472.30676,341.15644 C 471.15285,338.85897 470.82215,337.90248 471.66824,335.10501 z " />
+        </g>
+        <path
+           style="fill:#ffffff;fill-opacity:0.40350874;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccccc"
+           id="path4423"
+           d="M 364.8671,189.69191 L 446.71991,235.61832 L 446.39149,441.00771 L 366.28132,373.53968 L 364.8671,189.69191 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5957"
+           d="M 515.24794,392.97737 C 505.81506,405.42036 486.94113,407.56087 476.3726,403.76831 C 478.1563,403.29212 512.93901,393.73127 515.24794,392.97737 z " />
+        <path
+           style="fill:#000000;fill-opacity:0.16228069;fill-rule:evenodd;stroke:none;stroke-width:0.25pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1"
+           sodipodi:nodetypes="ccc"
+           id="path5959"
+           d="M 508.24794,405.72737 C 502.79158,413.09279 492.2492,415.37141 483.8726,412.49343 C 484.991,412.19485 506.80021,406.20008 508.24794,405.72737 z " />
+        <path
+           style="fill:#fcfcfc;fill-opacity:0.44298245;fill-rule:evenodd;stroke:none;stroke-width:0.31200001;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+           sodipodi:nodetypes="ccccccc"
+           id="path5973"
+           d="M 522.875,227.86218 L 527.04289,228.4302 L 527.79289,326.56929 L 463.46862,344.54896 L 461.88388,339.34073 L 523.68934,322.86218 L 522.875,227.86218 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6026"
+           d="M 462.21967,264.23013 L 462.31434,266.99086 L 522.7929,249.54632 L 462.21967,264.23013 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6036"
+           d="M 461.33579,284.2059 L 461.43046,286.96663 L 521.90902,269.52209 L 461.33579,284.2059 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6038"
+           d="M 462.21967,302.64613 L 462.31434,305.40686 L 522.7929,287.96232 L 462.21967,302.64613 z " />
+        <path
+           style="opacity:1;color:#000000;fill:#000000;fill-opacity:0.22745098;fill-rule:evenodd;stroke:none;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:0.22807013;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="cccc"
+           id="path6040"
+           d="M 462.21967,320.79868 L 462.31434,323.55941 L 522.7929,306.11487 L 462.21967,320.79868 z " />
+        <path
+           style="opacity:1;color:#000000;fill:none;fill-opacity:0.75;fill-rule:evenodd;stroke:#9e9e9e;stroke-width:2.61199999;stroke-linecap:butt;stroke-linejoin:miter;marker:none;marker-start:none;marker-mid:none;marker-end:none;stroke-miterlimit:4;stroke-dasharray:none;stroke-dashoffset:0;stroke-opacity:1;visibility:visible;display:inline;overflow:visible;font-family:Bitstream Vera Sans"
+           sodipodi:nodetypes="ccc"
+           id="path5988"
+           d="M 522.55191,229.64344 L 462.03362,244.76045 L 462.53549,344.35813" />
+      </g>
+    </g>
+    <g
+       id="g5256"
+       transform="translate(601.5744,207.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <g
+       id="g5488"
+       transform="translate(601.5744,407.49165)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient5536);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path5490"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient5538);fill-opacity:1"
+         id="g5492">
+        <path
+           style="fill:url(#linearGradient5540);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5494"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5542);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path5496"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5544);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path5498"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient5546);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5548);stroke-width:1.44734821pt"
+         id="rect5500"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient5550);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path5502"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient5552);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5504"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient5554);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect5506"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient5556);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient5558);stroke-width:1.4649456pt"
+         id="rect5508"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient5560);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path5510"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g5512">
+        <path
+           style="fill:url(#linearGradient5562);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5514"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient5564);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path5516"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient5566);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path5518"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient5568);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path5520"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient5570);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path5522"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient5572);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path5524"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient5574);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path5526"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5528"><tspan
+           id="tspan5530">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text5532"><tspan
+           id="tspan5534">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g6024"
+       transform="matrix(-1,0,0,1,900.16045,422.61731)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192">
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path6027"
+         d="M 60.545133,72.847539 C 65.294534,78.031101 68.316881,87.318315 75.00922,87.318316 C 81.485677,85.518467 82.349205,70.11177 83.212732,66.800051 C 75.872748,71.839624 68.316882,74.71938 60.545133,72.847539 z " />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#d20000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path6029"
+         d="M 31.546762,99.654209 C 31.156121,124.85047 95.78552,127.73183 95.62922,99.654209 C 97.174007,77.325462 86.068776,64.629762 83.309105,66.788232 C 81.907864,67.884209 81.387229,92.223995 71.919297,86.625353 C 67.316417,83.903554 62.167959,73.44849 59.915352,73.101625 C 56.516277,72.578221 50.007529,69.826123 44.029815,64.675414 C 42.461522,63.324094 32.076211,77.214403 31.546762,99.654209 z " />
+      <path
+         style="fill:url(#radialGradient2797);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2796"
+         d="M 43.53125,77.3125 C 40.353026,86.016409 37.202011,96.366079 40.377303,105.23542 C 48.984655,117.18204 66.049398,117.25223 79.222417,115.04972 C 88.094278,113.47345 96.636121,105.87972 94.744454,96.188658 C 94.751182,88.561019 93.319573,80.643142 89.09375,74.1875 C 87.954705,81.120157 85.706152,92.347929 76.686643,91.786583 C 66.841974,89.84774 65.058803,76.33878 54.747596,75.105769 C 49.945701,71.530053 45.566465,69.110698 43.783935,76.852875 L 43.53125,77.3125 z " />
+      <path
+         transform="matrix(0.440859,0,0,0.441062,0.997459,16.38124)"
+         style="fill:#efd7c7;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path6032"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         transform="translate(2.509562,-4.432856e-2)"
+         style="fill:#000000;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccccc"
+         id="path3720"
+         d="M 56.980881,5.8426527 C 39.420698,8.0166254 30.552872,16.206245 24.211446,49.532095 C 14.512196,98.076517 21.871677,115.5525 32.990311,115.56714 C 17.54932,102.40769 63.877625,86.740105 56.295103,44.070713 C 68.4508,48.712358 94.51097,54.349644 95.164349,41.718703 C 97.176702,29.219492 88.64173,4.4775042 56.980881,5.8426527 z " />
+      <path
+         style="fill:url(#linearGradient2789);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2164"
+         d="M 60.687242,45.028999 C 62.530882,55.403773 61.180052,64.151015 58.312242,71.685249 C 61.630122,73.07804 65.296862,73.904 69.155992,73.903999 C 83.975322,73.903999 95.981712,62.468019 95.999742,48.403999 C 88.357632,52.885439 70.244092,48.678277 60.687242,45.028999 z " />
+      <path
+         style="fill:url(#radialGradient2791);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path2790"
+         d="M 52.174948,8.1325312 C 35.846775,12.141346 31.110158,30.475875 28.060647,44.840387 C 24.465246,64.767005 19.485139,85.90438 25.518698,105.82003 C 29.863591,114.87216 28.026452,106.52571 31.049538,102.11795 C 41.311249,87.323083 56.256862,73.307418 55.936774,53.886064 C 56.647391,49.398848 52.34734,38.640985 60.701717,42.254379 C 70.683443,45.202557 82.078811,49.011247 92.143698,44.632531 C 96.945103,37.45042 93.288237,27.137344 88.876323,20.399742 C 81.135092,8.5919962 65.300885,5.0194752 52.174948,8.1325312 z " />
+    </g>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.63842154;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path699"
+       d="M 319.16674,325.66524 L 432.27399,313.12251 L 422.57906,332.08242 L 484.9028,325.95688 C 484.9028,325.95688 494.59773,306.41369 495.05931,306.41369 C 495.52148,306.41369 517.68079,331.79078 517.68079,331.79078 C 517.68079,331.79078 465.51355,358.33479 465.05197,358.33479 C 465.51355,358.91808 474.74689,339.66616 474.74689,339.37453 L 402.72705,345.79207 L 412.42255,326.24852 L 309.01023,338.4996 L 319.16674,325.66524 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:48px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont;font-stretch:normal;font-variant:normal;text-anchor:start;text-align:start;writing-mode:lr;line-height:125%"
+       x="140"
+       y="521.23737"
+       id="text7612"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan7614"
+         x="140"
+         y="521.23737">Server</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="359.5625"
+       y="261.21948"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan7879"
+         x="359.5625"
+         y="261.21948">bzr branch</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(42.857147,67.142853)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="325.71429"
+       y="259.52307"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="325.71429"
+         y="259.52307">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(492.85715,-2.8571472)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="777.71429"
+       y="191.52307"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="777.71429"
+         y="191.52307">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="819.5625"
+       y="179.59448"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="819.5625"
+         y="179.59448">bzr pull</tspan><tspan
+         sodipodi:role="line"
+         x="819.5625"
+         y="219.59448"
+         id="tspan2963">bzr merge</tspan></text>
+    <path
+       style="fill:none;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:4.29065037;stroke-linecap:butt;stroke-linejoin:round;stroke-dasharray:none;stroke-opacity:1"
+       sodipodi:nodetypes="cccccccccccc"
+       id="path9650"
+       d="M 539.95542,466.93556 L 415.85387,476.71718 L 426.49116,461.93102 L 358.1094,466.70812 C 358.1094,466.70812 347.47211,481.94916 346.96566,481.94916 C 346.45858,481.94916 322.14533,462.15846 322.14533,462.15846 C 322.14533,462.15846 379.38334,441.45772 379.88978,441.45772 C 379.38334,441.00284 369.25249,456.01673 369.25249,456.24417 L 448.27282,451.23935 L 437.63489,466.48068 L 551.09912,456.92649 L 539.95542,466.93556 z "
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(51.511043,348.5966)"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="334.36819"
+       y="540.97681"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="334.36819"
+         y="540.97681">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="369.5625"
+       y="544.09448"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="369.5625"
+         y="544.09448">bzr commit</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="61.5625"
+       y="240.09448"
+       id="text2965"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan2967"
+         x="61.5625"
+         y="240.09448">main branch</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="563.43756"
+       y="582.09442"
+       id="text2969"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="C:\devel\public_html\gigo-ice.org\scm\bazaar\wiki\workflows_shared.png"
+       inkscape:export-xdpi="42.227192"
+       inkscape:export-ydpi="42.227192"><tspan
+         sodipodi:role="line"
+         id="tspan2971"
+         x="563.43756"
+         y="582.09442">local branches</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006169;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path4930"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(1.9161749,0,0,1.0419298,-501.33182,49.826027)" />
+    <path
+       sodipodi:type="arc"
+       style="fill:none;fill-opacity:1;stroke:#0000ff;stroke-width:5.00006151;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+       id="path7839"
+       sodipodi:cx="342"
+       sodipodi:cy="171.0945"
+       sodipodi:rx="66"
+       sodipodi:ry="35"
+       d="M 408 171.0945 A 66 35 0 1 1  276,171.0945 A 66 35 0 1 1  408 171.0945 z"
+       transform="matrix(2.1405493,0,0,1.0364644,-57.067817,396.76108)" />
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/images/workflows_single.png'
Binary files doc/ja/user-guide/images/workflows_single.png and doc/ja/user-guide/images/workflows_single.png differ
=== added file 'doc/ja/user-guide/images/workflows_single.svg'
--- doc/ja/user-guide/images/workflows_single.svg	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/images/workflows_single.svg	2009-10-29 10:01:19 +0000
@@ -0,0 +1,1079 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://web.resource.org/cc/"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="1052.3622"
+   height="744.09448"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.45.1"
+   version="1.0"
+   sodipodi:docbase="/home/ian/Desktop/talk/workflows"
+   sodipodi:docname="workflows_single.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+   inkscape:export-xdpi="90"
+   inkscape:export-ydpi="90">
+  <defs
+     id="defs4">
+    <radialGradient
+       xlink:href="#linearGradient5992"
+       r="33.156250"
+       inkscape:collect="always"
+       id="radialGradient6000"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.000000,0.000000,0.000000,1.693685,0.000000,-197.9515)"
+       fy="285.36218"
+       fx="495.50000"
+       cy="285.36218"
+       cx="495.50000" />
+    <linearGradient
+       y2="187.57059"
+       y1="225.40080"
+       xlink:href="#linearGradient5963"
+       x2="458.91232"
+       x1="383.95898"
+       inkscape:collect="always"
+       id="linearGradient5969"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient3586">
+      <stop
+         style="stop-color:#000000;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop3588" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop3590" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5963">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5965" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5967" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       id="linearGradient5992">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1;"
+         offset="0"
+         id="stop5994" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0;"
+         offset="1"
+         id="stop5996" />
+    </linearGradient>
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient893"
+       x2="0.92957747"
+       x1="-2.3960868e-17"
+       id="linearGradient4284" />
+    <linearGradient
+       y2="-0.033519555"
+       y1="2.0837989"
+       xlink:href="#linearGradient893"
+       x2="0.99074072"
+       x1="-0.77314812"
+       id="linearGradient4283" />
+    <linearGradient
+       y2="1.8771822"
+       y1="-0.033741195"
+       xlink:href="#linearGradient902"
+       x2="0.48453596"
+       x1="0.47041038"
+       id="linearGradient2740"
+       gradientTransform="scale(0.997153,1.002855)" />
+    <linearGradient
+       y2="1.9025002"
+       y1="-0.043652620"
+       xlink:href="#linearGradient902"
+       x2="0.48481107"
+       x1="0.47042510"
+       id="linearGradient1506"
+       gradientTransform="scale(0.995847,1.004170)" />
+    <linearGradient
+       y2="1.8570156"
+       y1="-0.024853170"
+       xlink:href="#linearGradient902"
+       x2="0.48548824"
+       x1="0.47157744"
+       id="linearGradient1505"
+       gradientTransform="scale(0.997825,1.002180)" />
+    <linearGradient
+       y2="182.99154"
+       y1="169.09755"
+       xlink:href="#linearGradient892"
+       x2="88.996957"
+       x1="88.755695"
+       id="linearGradient1404"
+       gradientTransform="scale(1.3695887,0.7301462)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.34964636"
+       id="radialGradient1316"
+       fy="0.18269235"
+       fx="0.50352114"
+       cy="0.50000006"
+       cx="0.50000000" />
+    <radialGradient
+       xlink:href="#linearGradient1317"
+       r="0.41197181"
+       id="radialGradient1315"
+       fy="0.26666668"
+       fx="0.47535211"
+       cy="0.53333336"
+       cx="0.47887325" />
+    <linearGradient
+       y2="173.03153"
+       y1="177.77768"
+       xlink:href="#linearGradient902"
+       x2="95.100155"
+       x1="101.10657"
+       id="linearGradient1171"
+       gradientTransform="scale(1.3601783,0.7351977)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="1.8378206"
+       y1="-0.016295359"
+       xlink:href="#linearGradient902"
+       x2="0.48655096"
+       x1="0.47284532"
+       id="linearGradient1170"
+       gradientTransform="scale(0.998371,1.001632)" />
+    <linearGradient
+       y2="81.477602"
+       y1="224.57898"
+       xlink:href="#linearGradient893"
+       x2="74.533693"
+       x1="146.69923"
+       id="linearGradient1169"
+       gradientTransform="scale(1.1870691,0.842411)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="133.54711"
+       y1="228.39311"
+       xlink:href="#linearGradient888"
+       x2="88.447016"
+       x1="141.60217"
+       id="linearGradient1167"
+       gradientTransform="scale(1.1838753,0.8446836)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="148.78619"
+       y1="131.25248"
+       xlink:href="#linearGradient1317"
+       x2="107.04918"
+       x1="111.49758"
+       id="linearGradient1166"
+       gradientTransform="scale(1.223869,0.8170809)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="176.28694"
+       y1="269.85831"
+       xlink:href="#linearGradient888"
+       x2="-16.224496"
+       x1="51.460928"
+       id="linearGradient1157"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="234.26866"
+       y1="178.48862"
+       xlink:href="#linearGradient888"
+       x2="25.220815"
+       x1="25.220815"
+       id="linearGradient1156"
+       gradientTransform="scale(2.4217071,0.4129318)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="105.42543"
+       y1="76.277559"
+       xlink:href="#linearGradient892"
+       x2="8.346058"
+       x1="35.190362"
+       id="linearGradient1150"
+       gradientTransform="scale(1.3283861,0.7527932)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="20.481863"
+       y1="49.507656"
+       xlink:href="#linearGradient892"
+       x2="70.224305"
+       x1="39.690614"
+       id="linearGradient1148"
+       gradientTransform="scale(1.329144,0.7523639)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="113.71949"
+       y1="90.197025"
+       xlink:href="#linearGradient892"
+       x2="17.876529"
+       x1="39.810948"
+       id="linearGradient1146"
+       gradientTransform="scale(1.3207392,0.7571517)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="251.21892"
+       y1="203.499"
+       xlink:href="#linearGradient892"
+       x2="31.617281"
+       x1="31.449743"
+       id="linearGradient1144"
+       gradientTransform="scale(2.1051174,0.4750329)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="-0.45783132"
+       y1="3.3012049"
+       xlink:href="#linearGradient888"
+       x2="0.92957747"
+       x1="0.00000000"
+       id="linearGradient1141" />
+    <linearGradient
+       y2="232.24952"
+       y1="110.4447"
+       xlink:href="#linearGradient888"
+       x2="41.967061"
+       x1="45.685757"
+       id="linearGradient1140"
+       gradientTransform="scale(1.9102155,0.5235012)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="75.912531"
+       y1="375.92199"
+       xlink:href="#linearGradient1806"
+       x2="-268.25407"
+       x1="-249.72067"
+       id="linearGradient1138"
+       gradientTransform="scale(1.087146,0.9198397)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient1133"
+       r="68.589222"
+       id="radialGradient1132"
+       fy="39.288476"
+       fx="72.107883"
+       cy="56.485935"
+       cx="60.004654"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="11.699047"
+       y1="208.43991"
+       xlink:href="#linearGradient888"
+       x2="95.644441"
+       x1="-77.726178"
+       id="linearGradient905"
+       gradientTransform="scale(1.0964158,0.9120627)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       xlink:href="#linearGradient1806"
+       id="linearGradient901" />
+    <linearGradient
+       y2="91.07699"
+       y1="-3.9104078"
+       xlink:href="#linearGradient888"
+       x2="27.674331"
+       x1="92.437968"
+       id="linearGradient891"
+       gradientTransform="scale(1.2267534,0.8151598)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient888">
+      <stop
+         style="stop-color:#626262;stop-opacity:1.0000000;"
+         offset="0.0000000"
+         id="stop889" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop890" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient892">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop893" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop894" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient902">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="0.00000000"
+         id="stop903" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.22000000;"
+         offset="1.0000000"
+         id="stop904" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1098">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1099" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.22314049;"
+         offset="0.50000000"
+         id="stop1101" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.00000000;"
+         offset="0.59930235"
+         id="stop1102" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.60330576;"
+         offset="1.0000000"
+         id="stop1100" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1133">
+      <stop
+         style="stop-color:#8bb7df;stop-opacity:1.0000000;"
+         offset="0.00000000"
+         id="stop1134" />
+      <stop
+         style="stop-color:#2a6092;stop-opacity:1.0000000;"
+         offset="0.76209301"
+         id="stop1136" />
+      <stop
+         style="stop-color:#375e82;stop-opacity:1.0000000;"
+         offset="1.0000000"
+         id="stop1135" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient1317">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52892560;"
+         offset="0.00000000"
+         id="stop1318" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.17355372;"
+         offset="0.50000000"
+         id="stop1320" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.00000000;"
+         offset="1.0000000"
+         id="stop1319" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient893">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop895" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop896" />
+    </linearGradient>
+    <radialGradient
+       xlink:href="#linearGradient1806"
+       r="11.574221"
+       id="radialGradient1977"
+       fy="39.410465"
+       fx="42.280806"
+       cy="39.007645"
+       cx="42.007257"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient1806">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.35051546;"
+         offset="0.0000000"
+         id="stop1807" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.13402061;"
+         offset="0.64999998"
+         id="stop3276" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop1808" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5281"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5283"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5285"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="5.5130484"
+       inkscape:collect="always"
+       id="radialGradient1828"
+       fy="61.38567"
+       fx="86.542037"
+       cy="61.38567"
+       cx="86.542037"
+       gradientTransform="matrix(-0.8164966,0,0,1.2247449,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="11.123441"
+       inkscape:collect="always"
+       id="radialGradient1824"
+       fy="58.887858"
+       fx="118.06427"
+       cy="58.54025"
+       cx="117.17439"
+       gradientTransform="matrix(-0.6229142,0,0,1.6053575,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="22.00904"
+       inkscape:collect="always"
+       id="radialGradient1822"
+       fy="87.892895"
+       fx="45.50637"
+       cy="88.322677"
+       cx="45.139623"
+       gradientTransform="matrix(-1.0914815,0,0,0.9161859,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <radialGradient
+       xlink:href="#linearGradient4362"
+       r="18.836343"
+       inkscape:collect="always"
+       id="radialGradient1818"
+       fy="33.351633"
+       fx="48.40165"
+       cy="32.467054"
+       cx="48.40165"
+       gradientTransform="matrix(-1.1146027,0,0,0.8971807,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       y2="74.834393"
+       y1="57.093738"
+       xlink:href="#linearGradient4376"
+       x2="50.203204"
+       x1="50.52668"
+       inkscape:collect="always"
+       id="linearGradient1815"
+       gradientTransform="matrix(-1.3516689,0,0,0.7398261,262.80373,-280)"
+       gradientUnits="userSpaceOnUse" />
+    <linearGradient
+       id="linearGradient4384">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop4385" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4386" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4376">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop4377" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4378" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4362">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop4363" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop4364" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient4358">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop4359" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop4360" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5538"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient5714"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       id="linearGradient6015">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.77513230;"
+         offset="0.0000000"
+         id="stop6017" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6019" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6009">
+      <stop
+         style="stop-color:#000000;stop-opacity:0.52645504;"
+         offset="0.0000000"
+         id="stop6011" />
+      <stop
+         style="stop-color:#000000;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6013" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient6003">
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.66666669;"
+         offset="0.0000000"
+         id="stop6005" />
+      <stop
+         style="stop-color:#ffffff;stop-opacity:0.0000000;"
+         offset="1.0000000"
+         id="stop6007" />
+    </linearGradient>
+    <linearGradient
+       id="linearGradient5997">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop5999" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop6001" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient1806"
+       id="linearGradient6037"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="scale(1.087146,0.9198397)"
+       x1="-249.72067"
+       y1="375.92199"
+       x2="-268.25407"
+       y2="75.912531" />
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient654"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient653"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient650">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop651" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop652" />
+    </linearGradient>
+    <linearGradient
+       y2="0.46093750"
+       y1="0.46093750"
+       xlink:href="#linearGradient650"
+       x2="1.16666818"
+       x1="1.22222710"
+       spreadMethod="repeat"
+       id="linearGradient9648"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       y2="0.53906250"
+       y1="0.53125000"
+       xlink:href="#linearGradient650"
+       x2="1.16666901"
+       x1="1.00000548"
+       spreadMethod="repeat"
+       id="linearGradient9646"
+       gradientUnits="objectBoundingBox" />
+    <linearGradient
+       id="linearGradient9640">
+      <stop
+         style="stop-color:#000;stop-opacity:1;"
+         offset="0"
+         id="stop9642" />
+      <stop
+         style="stop-color:#fff;stop-opacity:1;"
+         offset="1"
+         id="stop9644" />
+    </linearGradient>
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="1.4142136"
+     inkscape:cx="536.99132"
+     inkscape:cy="529.01021"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     width="1052.3622px"
+     height="744.09448px"
+     showgrid="true"
+     inkscape:window-width="1465"
+     inkscape:window-height="896"
+     inkscape:window-x="0"
+     inkscape:window-y="25" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1">
+    <g
+       id="g5256"
+       transform="translate(631.5744,227.66157)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         transform="matrix(6.392368,0.545409,-0.130014,2.864752,-184.6606,-38.15109)"
+         style="fill:url(#radialGradient1977);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:type="arc"
+         sodipodi:ry="12.562782"
+         sodipodi:rx="12.562782"
+         sodipodi:cy="37.865574"
+         sodipodi:cx="41.875938"
+         id="path1976"
+         d="M 54.438721 37.865574 A 12.562782 12.562782 0 1 1  29.313156,37.865574 A 12.562782 12.562782 0 1 1  54.438721 37.865574 z" />
+      <g
+         transform="matrix(1,0,0,1.036969,356.8306,-11.4294)"
+         style="fill:url(#linearGradient6037);fill-opacity:1"
+         id="g4293">
+        <path
+           style="fill:url(#linearGradient5281);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2720"
+           d="M -270.85787,33.814995 C -289.35564,33.925992 -307.93321,33.592782 -326.38104,33.981747 C -331.43469,35.696391 -331.02221,41.899652 -330.68524,46.15332 C -330.75782,60.227303 -330.53537,74.298225 -330.21167,88.36826 C -328.21297,91.039611 -323.21766,90.618387 -322.68469,94.539015 C -320.78054,96.259426 -317.05071,94.88215 -314.4389,95.333237 C -298.54999,95.360274 -282.66107,95.387302 -266.77215,95.414339 C -266.35587,90.465192 -260.12609,88.824447 -255.81783,89.540255 C -256.01688,89.058389 -261.69557,87.939375 -259.61591,84.491525 C -259.45681,68.72727 -259.19734,52.882199 -259.82064,37.168229 C -261.19394,32.980583 -267.34179,33.83368 -270.85787,33.814995 z M -236.65184,97.260473 C -234.79025,100.12642 -237.08724,103.09386 -239.92892,104.16357 C -242.6311,105.91539 -245.59105,107.62992 -248.52894,108.76804 C -253.1773,108.19079 -251.42424,101.88475 -255.01281,99.896645 C -260.33594,96.447012 -267.21045,98.43943 -273.23329,97.939231 C -291.8249,97.94887 -310.41651,97.958519 -329.00813,97.968158 C -335.45898,103.56578 -339.16595,111.40269 -341.55034,119.32178 C -337.25147,124.2061 -329.89606,122.27575 -324.10438,122.40002 C -298.64553,122.23171 -273.11679,122.61546 -247.69897,122.24542 C -243.40174,121.14669 -247.44685,114.84894 -243.58488,113.04441 C -242.73865,112.73374 -247.81245,114.4382 -247.26205,111.62955 C -245.49117,106.66028 -239.14113,105.99595 -235.92338,102.36811 C -234.39131,99.755669 -236.26958,96.922488 -238.33047,95.260495 C -237.77093,95.927151 -237.21138,96.593817 -236.65184,97.260473 z M -240.64255,111.75263 C -243.64086,113.13223 -237.02792,110.69536 -235.55512,111.97369 C -229.71113,112.74417 -224.16461,117.19625 -218.12358,115.22951 C -225.97639,116.31604 -232.799,109.03014 -240.64255,111.75263 z M -212.01083,112.33724 C -215.98173,113.85021 -208.21543,112.17765 -210.07883,115.87566 C -212.50961,119.93855 -206.99008,113.8662 -209.61436,112.54677 C -210.16198,111.94632 -211.27989,112.47663 -212.01083,112.33724 z M -213.97451,120.82946 C -220.13871,124.32615 -228.37873,119.08124 -233.85995,124.39439 C -238.36465,128.00055 -244.57099,130.35185 -247.0433,135.75122 C -247.65922,139.60202 -243.25109,141.90251 -240.44565,143.71808 C -235.60127,146.54512 -228.8227,145.75388 -225.20082,141.42836 C -220.62679,137.96117 -216.44182,134.08489 -212.48592,129.96782 C -212.82701,126.95048 -214.43694,123.63971 -213.97451,120.82946 z " />
+        <path
+           style="fill:url(#linearGradient5283);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           id="path2723"
+           d="M -269.68453,32.256957 C -288.76965,32.351184 -307.87514,32.249603 -326.94796,32.349264 C -332.63884,33.663474 -333.90446,40.291305 -333.21597,45.149113 C -333.11996,59.896901 -333.07471,74.659754 -332.61729,89.39481 C -331.88583,93.310348 -324.86009,92.098674 -325.11097,96.44089 C -328.07184,96.184706 -331.5534,96.317135 -333.07248,99.246492 C -338.92562,104.98392 -341.99312,112.66465 -344.27268,120.28679 C -340.22572,125.96631 -332.26467,125.31453 -326.02946,124.71751 C -300.16629,124.7277 -274.28316,124.82043 -248.43245,124.77905 C -244.42424,124.78686 -243.30672,120.35609 -243.96666,117.2099 C -242.88598,112.93536 -237.04086,113.94554 -233.80717,114.98513 C -228.01851,116.64297 -221.26418,120.43074 -215.57982,116.37592 C -211.36091,113.71809 -213.05678,118.4029 -215.77936,119.43344 C -220.82539,122.25797 -227.09125,118.98178 -232.39677,121.20855 C -236.53238,123.88957 -240.74707,126.85249 -244.76678,129.74666 C -248.34219,132.01467 -251.90947,137.38626 -248.13747,140.97315 C -243.79274,146.02948 -236.37425,149.4527 -229.68248,147.08651 C -225.09383,144.85973 -221.79206,140.75401 -217.61535,137.88661 C -215.10454,135.69469 -212.49235,133.26839 -210.83749,130.50207 C -210.86477,126.92195 -214.68529,121.91303 -210.252,119.57013 C -207.25619,117.95208 -205.81053,112.12098 -209.75314,110.87946 C -214.16982,109.44692 -216.95156,115.09837 -221.43751,113.68608 C -228.47365,112.76758 -235.5565,107.20489 -242.69931,110.72434 C -246.89551,113.06547 -243.47174,109.4356 -241.45524,108.56544 C -237.85613,106.84628 -232.73147,104.36798 -233.94637,99.617708 C -234.27189,95.083838 -239.22223,93.197522 -242.95318,91.723135 C -247.61613,89.074942 -253.27003,89.345117 -258.06082,86.933298 C -257.89248,70.385101 -257.58805,53.76423 -258.26571,37.261116 C -259.2092,32.393288 -265.59824,31.96057 -269.68453,32.256957 z M -258.66259,91.764016 C -251.5059,92.239344 -243.21163,93.474137 -238.58238,99.271629 C -238.96251,103.06003 -244.00295,103.80224 -246.52821,106.14082 C -248.92267,108.48087 -251.12372,105.80503 -251.02958,103.27159 C -252.70852,98.336432 -258.20582,95.710815 -263.31841,96.533197 C -267.00561,96.7255 -263.71935,91.937514 -261.395,92.380192 C -260.48382,92.178338 -259.57521,91.953759 -258.66259,91.764016 z " />
+        <path
+           style="fill:url(#linearGradient5285);fill-opacity:1;stroke-width:1pt;font-family:helvetica"
+           sodipodi:nodetypes="ccccczccccccccccccccccccczccccc"
+           id="path2737"
+           d="M -324.0398,30.70877 C -336.3492,30.820231 -335.15663,39.652507 -334.79476,45.313268 C -334.5469,60.436643 -334.38614,75.599009 -334.01234,90.698281 C -333.20516,93.057424 -330.71249,93.985661 -328.75475,95.252079 C -334.4553,96.476239 -336.96996,102.43195 -340.11175,106.59303 C -342.33294,111.36531 -347.84019,115.92868 -345.92111,121.43642 C -344.00204,126.94416 -332.21757,127.68181 -324.95408,127.12866 C -299.06901,127.09789 -273.17022,127.14905 -247.29372,127.06713 C -243.29961,126.16956 -240.99668,122.03601 -241.4977,118.23645 C -238.30082,114.95371 -233.32521,118.03039 -229.53292,118.63002 C -225.71641,119.31313 -232.5646,119.27527 -233.19362,120.54849 C -238.23604,122.95799 -242.6166,126.65447 -246.90973,130.10509 C -250.44674,132.97354 -252.4229,138.10741 -249.57412,142.08235 C -246.21315,145.92284 -241.41489,148.84284 -236.30395,149.79628 C -230.65487,150.83779 -225.57101,147.82678 -221.6157,144.24077 C -216.87391,140.59839 -212.0873,136.78287 -208.84361,131.80554 C -207.76302,128.26399 -211.47449,123.86671 -208.08348,121.09796 C -204.93438,118.46115 -204.06893,113.02076 -207.41836,110.2673 C -212.81988,106.81278 -218.36682,114.55112 -223.89705,111.29128 C -227.94209,110.1659 -231.91311,108.52596 -236.17676,108.45194 C -231.52711,105.88023 -229.62903,98.782331 -234.08944,95.153402 C -239.61551,89.404431 -248.455,88.793917 -255.40182,85.744487 C -255.86992,78.940296 -255.53665,71.972758 -255.70928,65.098797 C -255.80747,55.730822 -255.73864,46.312632 -255.94025,36.975777 C -258.03631,31.236293 -265.34014,30.439522 -270.76286,30.729689 C -289.40725,30.770714 -311.88665,30.597309 -324.0398,30.70877 z M -255.46516,94.482857 C -250.34561,95.62106 -244.69322,96.21649 -240.83258,100.05203 C -242.37635,102.55028 -245.27573,103.64481 -247.80048,104.97505 C -249.71506,99.684643 -254.39847,94.970039 -260.51378,95.138259 C -260.66903,94.131274 -256.73261,94.551178 -255.46516,94.482857 z " />
+      </g>
+      <rect
+         y="78.658051"
+         x="33.326111"
+         width="57.567924"
+         style="fill:url(#linearGradient1156);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient1157);stroke-width:1.44734821pt"
+         id="rect1155"
+         height="8.3153667" />
+      <path
+         style="fill:url(#linearGradient1169);fill-rule:evenodd;stroke-width:0.90459263;stroke-opacity:0.07438019"
+         sodipodi:nodetypes="czzczczzzzzzzc"
+         id="path2676"
+         d="M 98.723806,78.927818 C 95.18666,77.759681 93.50122,82.555591 98.766686,81.004087 C 104.03217,79.452583 120.13123,85.906451 120.37383,89.795491 C 120.61643,93.905503 101.5003,98.581154 106.74108,104.42426 C 111.62816,110.70149 115.35468,100.13868 123.54696,104.21261 C 131.73923,108.17607 136.26048,109.72394 142.25488,104.94185 C 149.10027,101.9342 145.04599,107.07658 139.57918,113.60451 C 134.11237,120.13244 144.00251,115.08156 147.91225,105.31962 C 151.93248,95.557673 139.13128,107.33503 133.66268,105.40571 C 128.19408,103.47639 119.73678,97.849788 113.27625,102.55563 C 106.81572,107.26147 109.62894,99.493003 114.85637,97.90307 C 120.0838,96.092166 122.81363,93.045722 122.85597,90.161522 C 122.89831,87.498293 117.92629,84.811803 112.94229,82.402852 C 107.73732,79.993901 100.49788,78.588966 98.723806,78.927818 z " />
+      <path
+         style="fill:url(#linearGradient1140);fill-opacity:1;fill-rule:evenodd;stroke-width:1.44734821pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1139"
+         d="M 15.102732,106.80712 C 13.80355,109.23224 17.148847,113.52338 19.900059,113.52338 L 107.85106,113.52338 C 110.18914,113.52338 113.70766,110.4906 112.64839,108.40622 L 102.7339,88.897093 C 101.97024,87.394398 100.26184,86.65834 98.576216,86.65834 L 28.215425,86.658339 C 26.825434,86.658339 25.353768,87.671846 24.697385,88.897093 L 15.102732,106.80712 z " />
+      <rect
+         y="22.413721"
+         x="26.015469"
+         width="72.279724"
+         style="fill:url(#linearGradient905);fill-opacity:1;fill-rule:evenodd;stroke-width:1.62826681"
+         ry="5.4369707"
+         rx="5.4369707"
+         id="rect1137"
+         height="60.126495" />
+      <rect
+         y="31.695871"
+         x="33.386066"
+         width="58.178177"
+         style="fill:url(#radialGradient1132);fill-opacity:1;fill-rule:evenodd;stroke:url(#linearGradient891);stroke-width:1.4649456pt"
+         id="rect1131"
+         height="38.044163" />
+      <path
+         style="fill:url(#linearGradient1146);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzccccc"
+         id="path1145"
+         d="M 27.690431,52.841444 L 27.370609,74.749236 C 27.319624,78.241665 29.310209,80.477938 32.807578,80.506029 L 72.625393,80.825852 L 76.463254,71.87084 L 32.008024,71.55102 L 31.688202,52.681533 L 27.690431,52.841444 z " />
+      <g
+         transform="matrix(-1,0,0,1,125.4301,0)"
+         id="g1791">
+        <path
+           style="fill:url(#linearGradient1148);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1147"
+           d="M 42.062098,33.460351 L 77.341205,33.008055 C 82.787126,32.938235 89.553204,38.416797 89.553204,43.863165 L 89.553204,60.14583 L 41.609801,59.693534 L 42.062098,33.460351 z " />
+        <path
+           style="fill:url(#linearGradient1150);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+           sodipodi:nodetypes="czzccc"
+           id="path1149"
+           d="M 78.337784,67.629235 L 46.723745,67.724544 C 41.843589,67.739257 35.829319,62.771024 35.877168,57.891081 L 36.020221,43.301821 L 78.973514,44.128288 L 78.337784,67.629235 z " />
+      </g>
+      <path
+         style="fill:url(#linearGradient1167);fill-opacity:1;fill-rule:evenodd;stroke-width:0.72367412;stroke-opacity:0.34710741"
+         sodipodi:nodetypes="cczzzzzzc"
+         id="path1159"
+         d="M 137.39107,112.02341 C 137.39107,112.02341 129.0757,110.26438 123.63872,113.62251 C 118.20176,116.98064 109.96635,123.21719 108.76702,124.81628 C 107.40777,126.57531 107.42036,130.22796 109.24674,131.53253 L 114.84364,135.53031 C 118.31797,138.01198 124.86218,139.25396 128.11624,136.48978 L 142.98795,123.85681 C 144.79792,122.3193 145.72732,118.27921 144.10733,116.82073 C 142.95609,115.04975 140.4892,112.91939 137.39107,112.02341 z " />
+      <path
+         style="fill:url(#linearGradient1171);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzc"
+         id="path1160"
+         d="M 142.3483,121.13833 L 125.91043,133.59673 C 122.97154,135.82414 118.65484,134.11775 116.28283,133.77129 C 113.9108,133.42481 111.88528,131.87901 112.12516,132.33209 C 112.36503,132.78517 115.08349,135.71687 117.72203,136.48978 C 120.36055,137.26267 124.9543,138.89307 127.50953,136.15531 C 130.06477,133.41755 145.2267,123.53699 142.3483,121.13833 z " />
+      <path
+         style="fill:url(#linearGradient1404);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="cczc"
+         id="path1403"
+         d="M 132.11225,127.51984 C 135.31047,122.88242 120.11893,113.12786 109.08509,127.0401 C 110.20446,130.71805 116.80662,132.5992 121.82304,132.33547 C 126.68363,132.07993 129.50037,129.97181 132.11225,127.51984 z " />
+      <path
+         style="fill:url(#linearGradient1166);fill-opacity:1;fill-rule:evenodd;stroke-width:1.08551121"
+         sodipodi:nodetypes="cccccccc"
+         id="path1519"
+         d="M 138.63464,112.68306 C 135.9958,113.22749 132.31739,114.43079 129.87534,116.38362 C 128.77009,115.68011 125.32759,114.5677 123.66767,113.84494 L 123.24572,114.10517 C 129.67287,117.23476 136.43512,117.91249 135.88192,122.87668 C 136.33675,122.98575 137.05589,123.09702 136.73191,122.38863 C 136.41775,118.90392 132.50587,117.23351 131.02697,116.81532 C 133.17224,114.26602 136.255,113.70892 138.63464,112.68306 z " />
+      <path
+         style="fill:url(#linearGradient1144);fill-opacity:1;fill-rule:evenodd;stroke-width:1pt"
+         sodipodi:nodetypes="czzzzzzzz"
+         id="path1143"
+         d="M 18.891612,106.48414 C 17.978451,108.31614 19.173914,111.55774 22.263529,111.55774 L 105.0195,111.55774 C 106.66288,111.55774 109.13595,109.26672 108.39142,107.69215 L 101.42279,92.954575 C 100.88602,91.819403 99.685232,91.263378 98.500462,91.263378 L 28.108183,91.263369 C 27.131195,91.263369 26.0968,92.028994 25.635445,92.954575 L 18.891612,106.48414 z " />
+      <text
+         y="-14.660837"
+         xml:space="preserve"
+         x="6.147172"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1232"><tspan
+           id="tspan1233">Computer</tspan></text>
+      <text
+         y="-34.951134"
+         xml:space="preserve"
+         x="84.564949"
+         transform="scale(0.246729,0.246729)"
+         style="font-size:12px;font-style:normal;font-weight:normal;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:helvetica"
+         id="text1235"><tspan
+           id="tspan1236">Created by Andrew Fitzsimon</tspan></text>
+    </g>
+    <g
+       id="g5474"
+       transform="translate(633.63525,501.49239)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157">
+      <path
+         style="fill:#ffffff;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path9383"
+         d="M 203.47051,-209.74941 C 198.72111,-204.56585 195.69876,-195.27863 189.00642,-195.27863 C 182.52997,-197.07848 181.66644,-212.48518 180.80291,-215.7969 C 188.1429,-210.75732 195.69876,-207.87757 203.47051,-209.74941 z " />
+      <path
+         transform="matrix(-0.440859,0,0,0.441062,265.52775,-266.17138)"
+         style="fill:#f1bb96;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:type="arc"
+         sodipodi:ry="57.825485"
+         sodipodi:rx="60.94183"
+         sodipodi:cy="70.290855"
+         sodipodi:cx="150.27701"
+         id="path3713"
+         d="M 211.21884 70.290855 A 60.94183 57.825485 0 1 1  89.335178,70.290855 A 60.94183 57.825485 0 1 1  211.21884 70.290855 z" />
+      <path
+         style="fill:#233e6a;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccssssc"
+         id="path4369"
+         d="M 232.46888,-182.94274 C 232.85952,-157.74648 168.23012,-154.86512 168.38642,-182.94274 C 166.84164,-205.27149 177.94687,-217.96719 180.70654,-215.80872 C 182.10778,-214.71274 182.62841,-190.37295 192.09635,-195.9716 C 196.69923,-198.69339 201.84768,-209.14846 204.10029,-209.49532 C 207.49937,-210.01873 214.00811,-212.77083 219.98583,-217.92153 C 221.55412,-219.27285 231.93943,-205.38255 232.46888,-182.94274 z " />
+      <path
+         style="fill:#513624;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path11309"
+         d="M 204.55432,-273.85152 C 222.46413,-271.53047 237.32676,-259.28175 231.38357,-231.42099 C 229.66954,-221.67743 222.12426,-217.60887 219.35537,-236.36962 C 211.4578,-233.88387 177.25785,-223.92576 170.54948,-241.26677 C 166.55631,-248.43407 174.86257,-276.23329 204.55432,-273.85152 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path11942"
+         d="M 191.92173,-167.75448 C 192.06919,-184.44566 194.18855,-193.73288 188.47558,-194.95709 C 182.9785,-195.85052 179.91138,-176.52634 179.04785,-173.21462 C 175.85958,-157.19769 189.53653,-154.44605 191.92173,-167.75448 z " />
+      <path
+         style="fill:url(#linearGradient1815);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:8.50416374;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1811"
+         d="M 172.67812,-237.76056 C 182.56217,-225.58826 212.09549,-234.15979 219.36562,-236.44806 C 220.33459,-229.88278 221.90014,-226.25074 223.58437,-224.54181 C 219.31219,-215.8234 210.06249,-209.76056 199.27187,-209.76056 C 184.44142,-209.76056 172.42812,-221.18201 172.42812,-235.26056 C 172.42812,-236.11869 172.59078,-236.92413 172.67812,-237.76056 z " />
+      <path
+         style="fill:url(#radialGradient1818);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1817"
+         d="M 203.17522,-273.74212 C 221.08504,-271.42107 235.94766,-259.17235 230.00448,-231.31159 C 228.29044,-221.56803 220.74517,-217.49946 217.97627,-236.26022 C 210.0787,-233.77447 175.87876,-223.81635 169.17039,-241.15737 C 165.17722,-248.32467 173.48348,-276.12389 203.17522,-273.74212 z " />
+      <path
+         style="fill:url(#radialGradient1822);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         id="path1819"
+         d="M 220.74123,-214.1875 C 227.87764,-203.73841 231.28831,-190.18836 229.45998,-177.71875 C 222.3997,-165.39834 205.93726,-163.52328 193.05373,-164.75 C 194.11526,-173.29796 194.69425,-182.39807 193.51876,-190.98978 C 191.02311,-195.41909 199.33209,-197.29913 200.39748,-201.6875 C 203.70655,-208.92744 212.80427,-208.10966 218.04988,-213.3696 C 218.9201,-213.57294 220.00051,-215.94141 220.74123,-214.1875 z M 179.55373,-210.28125 C 180.69974,-204.97453 181.23339,-199.24919 184.58498,-194.75 C 179.40159,-187.81847 178.05976,-178.63643 176.67873,-170.28125 C 167.10271,-177.01707 169.81568,-190.62142 172.02963,-200.39411 C 173.03008,-204.26346 176.36728,-212.34166 179.19382,-211.77772 C 179.27177,-211.45363 179.5117,-210.45598 179.55373,-210.28125 z " />
+      <path
+         style="fill:url(#radialGradient1824);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="cccc"
+         id="path1823"
+         d="M 192.35803,-167.43887 C 192.50549,-184.13006 194.62485,-193.41727 188.91188,-194.64149 C 183.4148,-195.53491 180.34768,-176.21073 179.48415,-172.89901 C 176.29589,-156.88208 189.97283,-154.13044 192.35803,-167.43887 z " />
+      <path
+         style="fill:#1f4eb3;fill-opacity:1;fill-rule:evenodd;stroke:#000000;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1825"
+         d="M 185.2414,-200.53324 C 185.2414,-197.95291 187.25802,-195.85872 189.74278,-195.85872 C 192.22755,-195.85872 194.24417,-197.95291 194.24417,-200.53324 C 194.24417,-203.11357 193.61259,-209.36288 191.12783,-209.36288 C 188.64306,-209.36288 185.2414,-203.11357 185.2414,-200.53324 z " />
+      <path
+         style="fill:url(#radialGradient1828);fill-opacity:1;fill-rule:evenodd;stroke:none;stroke-width:3.75;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:1"
+         sodipodi:nodetypes="ccccc"
+         id="path1827"
+         d="M 186.28018,-201.05263 C 186.28018,-198.4723 188.2968,-196.37811 190.78156,-196.37811 C 193.26633,-196.37811 195.28295,-198.4723 195.28295,-201.05263 C 195.28295,-203.63296 194.65137,-209.88227 192.16661,-209.88227 C 189.68184,-209.88227 186.28018,-203.63296 186.28018,-201.05263 z " />
+    </g>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="345.5625"
+       y="218.05542"
+       id="text7877"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         x="345.5625"
+         y="218.05542"
+         id="tspan2399">create project</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9548"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,24.174103)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.53906"
+       y="217.78979"
+       id="text9550"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9552"
+         x="314.53906"
+         y="217.78979">1</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9554"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(33.388397,76.658478)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="315.78125"
+       y="270.48511"
+       id="text9556"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9558"
+         x="315.78125"
+         y="270.48511">2</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="344.92188"
+       y="267.43823"
+       id="text9566"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9568"
+         x="344.92188"
+         y="267.43823">record changes</tspan></text>
+    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path9652"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,128.5416)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.88281"
+       y="322.14166"
+       id="text9654"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9656"
+         x="314.88281"
+         y="322.14166">3</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="346.9086"
+       y="319.32135"
+       id="text9658"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan9660"
+         x="346.9086"
+         y="319.32135">browse history</tspan></text>
+    <flowRoot
+       xml:space="preserve"
+       id="flowRoot2405"><flowRegion
+         id="flowRegion2407"><rect
+           id="rect2409"
+           width="274.35742"
+           height="94.045197"
+           x="293.44931"
+           y="485.2934" /></flowRegion><flowPara
+         id="flowPara2411"></flowPara></flowRoot>    <path
+       sodipodi:type="arc"
+       style="fill:#000000"
+       id="path2427"
+       sodipodi:cx="292.14285"
+       sodipodi:cy="181.95163"
+       sodipodi:rx="15"
+       sodipodi:ry="15"
+       d="M 307.14285 181.95163 A 15 15 0 1 1  277.14285,181.95163 A 15 15 0 1 1  307.14285 181.95163 z"
+       transform="translate(32.857147,180.5416)"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157" />
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#ffffff;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="314.9375"
+       y="374.15729"
+       id="text2429"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2431"
+         x="314.9375"
+         y="374.15729">4</tspan></text>
+    <text
+       xml:space="preserve"
+       style="font-size:32px;font-style:normal;font-variant:normal;font-weight:normal;font-stretch:normal;text-align:start;line-height:125%;writing-mode:lr-tb;text-anchor:start;fill:#000000;fill-opacity:1;stroke:none;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1;font-family:aquafont"
+       x="346.9086"
+       y="371.32135"
+       id="text2433"
+       sodipodi:linespacing="125%"
+       inkscape:export-filename="/home/ian/Desktop/talk/workflows/workflows_single.png"
+       inkscape:export-xdpi="41.964157"
+       inkscape:export-ydpi="41.964157"><tspan
+         sodipodi:role="line"
+         id="tspan2435"
+         x="346.9086"
+         y="371.32135">package release</tspan></text>
+  </g>
+</svg>

=== added file 'doc/ja/user-guide/index.txt'
--- doc/ja/user-guide/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/index.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,140 @@
+####################
+Bazaarユーザーガイド
+####################
+
+.. Please mark sections in included files as following:
+..   level 1 ========
+..   level 2 --------
+..   level 3 ~~~~~~~~
+..   level 4 ^^^^^^^^ (it is better not to use nesting deeper than 3 levels)
+
+紹介
+#####
+
+.. toctree::
+   :maxdepth: 1
+
+   introducing_bazaar
+   core_concepts
+   bazaar_workflows
+
+
+始める
+#######
+
+.. toctree::
+   :maxdepth: 1
+
+   installing_bazaar
+   entering_commands
+   getting_help
+   configuring_bazaar
+   using_aliases
+   plugins
+   zen
+
+
+個人用途のバージョン管理
+#########################
+
+.. toctree::
+   :maxdepth: 1
+
+   solo_intro
+   starting_a_project
+   controlling_registration
+   reviewing_changes
+   recording_changes
+   browsing_history
+   releasing_a_project
+   undoing_mistakes
+
+
+同僚と共有する
+##############
+
+.. toctree::
+   :maxdepth: 1
+
+   partner_intro
+   branching_a_project
+   merging_changes
+   resolving_conflicts
+   annotating_changes
+
+
+集中スタイルの、チームコラボレーション
+#######################################
+
+.. toctree::
+   :maxdepth: 1
+
+   central_intro
+   publishing_a_branch
+   using_checkouts
+   working_offline_central
+   reusing_a_checkout
+
+
+分散スタイルの、チームコラボレーション
+#######################################
+
+.. toctree::
+   :maxdepth: 1
+
+   distributed_intro
+   organizing_branches
+   using_gatekeepers
+   sending_changes
+
+
+その他のトピック
+#################
+
+.. toctree::
+   :maxdepth: 1
+
+   part2_intro
+   adv_merging
+   shelving_changes
+   filtered_views
+   stacked
+   server
+   hooks
+   version_info
+
+
+人気のあるプラグインの手短なツアー
+####################################
+
+.. toctree::
+   :maxdepth: 1
+
+   bzrtools_plugin
+   svn_plugin
+
+
+Bazaarを環境に統合する
+#######################
+
+.. toctree::
+   :maxdepth: 1
+
+   web_browsing
+   bug_trackers
+
+
+付録
+#####
+
+.. toctree::
+   :maxdepth: 1
+
+   specifying_revisions
+   organizing_your_workspace
+   shared_repository_layouts
+   setting_up_email
+   http_smart_server
+   writing_a_plugin
+
+.. |--| unicode:: U+2014

=== added file 'doc/ja/user-guide/installing_bazaar.txt'
--- doc/ja/user-guide/installing_bazaar.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/installing_bazaar.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,101 @@
+Bazaarをインストールする
+=========================
+
+Linux
+-----
+
+BazaarのパッケージはUbuntu/Debian、Red HatとGentooを含む人気のある
+大抵のLinuxディストリビューションで利用できます。
+最新の手引きは http://bazaar-vcs.org/Download を参照してください。
+
+Windows
+-------
+
+Windowsユーザーは、Bazaarのコアパッケージと一緒に必要な前提要件と
+いくつかの便利なプラグインを含むインストーラが利用できます。
+最新の手引きは http://bazaar-vcs.org/Download を参照してください。
+
+注: Windows上でCygwinを動かしている場合、Cygwin用のBazaarパッケージを\
+Windows版の代わりに使わなければなりません。
+
+他のオペレーティングシステム
+-----------------------------
+
+BazaarのパッケージはLinuxとWindowsだけでなく、Mac OS X, FreeBSD, Solaris\
+を含む広い範囲のオペレーティングシステムで利用可能です。
+最新の手引きに関しては http://bazaar-vcs.org/Download を参照してください。
+
+
+ゼロからインストールする
+-------------------------
+
+予めビルドされたパッケージよりもソースからBazaarをビルドしたい場合、\
+手順は次のとおりです:
+
+  1. まだインストールしていなければ、バージョン2.4以降のPythonをインストールします。
+
+  2. http://bazaar-vcs.org/Download もしくはLaunchpad (https://launchpad.net/~bzr/)から
+     ``bazaar-xxx.tar.gz`` ファイル(xxxはバージョン番号)をダウンロードします。
+
+  3. tar、WinZipもしくは同等のコマンドを用いてアーカイブを解凍します。
+
+  4. 作成されたディレクトリをPATHに登録します。
+
+インストールが成功したことを確認するために、次のように **bzr** コマンドを試します::
+
+  bzr version
+
+このコマンドによってインストールされているBazaarのバージョンが表示されます。
+このコマンドが動作しない場合、開発者が正常な動作の手助けをできるように
+EメールかIRCを通して開発者に連絡をして頂くようお願いします。
+
+
+site-wide な場所にインストールする
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+ディレクトリにPATHを設定する代わりに、次のコマンドでにbzrを\
+インストールすることができます。::
+
+  python setup.py install
+
+もしあなたがコンパイラやPythonの開発ツールを持っていない場合、
+bzrは全ての拡張モジュールに対して(遅い)pure-pythonの実装を提供します。
+次のコマンドを使って拡張モジュールのコンパイルなしにインストールできます::
+
+  python setup.py install build_ext --allow-python-fallback
+
+
+開発バージョンを稼働させる
+---------------------------
+
+Bazaarの最新の開発バージョンを常に利用したい場合があります。
+バグの危険性が増すので大半のユーザーにはお勧めできないことに注意してください。
+一方で、開発バージョンは(開発プロセスのおかげで)非常に安定しているので、
+これを動かすことで、バグと改善内容のための変更内容を開発者に送ることが楽になります。
+より多くの人が最新のソフトウェアをテストすることで開発者の手助けにもなります。
+
+従うべき手順は次のとおりです:
+
+  1. 上記の方法の1つを利用してBazaarをインストールする。
+
+  2. 次のように開発バージョンのコピーを入手します::
+
+       bzr branch http://bazaar-vcs.org/bzr/bzr.dev
+
+  3. 作成されたディレクトリ(bzr.dev)をPATHに登録します
+
+上級ユーザーはより早く動かすためにC言語の拡張機能をビルドもしたいことでしょう。
+これは ``make`` と ``pyrex`` とCコンパイラを利用することで実現できます。
+このことに関して手助けが必要であればEメールかIRCを通して連絡をして\
+下さるようお願いします。
+
+
+複数のバージョンを稼働させる
+-----------------------------
+
+Bazaarの複数のバージョンをインストールしてそれらを切り替えることは簡単です。
+これを行うためには、実行したい **bzr** のフルパス名を入力するだけです。
+関連ライブラリは自動的に検出されます。もちろん、パス名を提供しない場合、
+通常のシステムパスで見つかる **bzr** のコマンドが使われます。
+
+この機能は最新バージョンと開発バージョンの両方を走らせたい(テストしたい)場合にとりわけ役立ちます。

=== added file 'doc/ja/user-guide/introducing_bazaar.txt'
--- doc/ja/user-guide/introducing_bazaar.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/introducing_bazaar.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,117 @@
+Bazaarの紹介
+=============
+
+Bazaarとは？
+-------------
+
+Bazaarはみんなのコラボレーションを手助けするツールです。
+これは(たとえばソフトウェアのソースコードなどの)ファイルのグループの変化の\
+段階のスナップショットを提供するためにファイルの変更を追跡します。
+この情報を利用することで、Bazaarはあなたの作業と他の人の作業の成果を簡単にマージします。
+
+Bazaarのようなツールはバージョン管理ツール(version control systems: VCS)と呼ばれ\
+長い間ソフトウェアの開発者の間で人気がありました。
+Bazaarは使いやすく、柔軟で簡単にセットアップできるので、ソフトウェアの開発者だけでなく、\
+テクニカルライター、ウェブデザイナー、翻訳者のようなファイルとドキュメントに取り組む\
+人達にも理想的なツールです。
+
+このガイドは、個人で使うのかチームで使うのかに関わらずBazaarのインストールと使い方の手引きをします。
+すでに分散型のバージョン管理システムに慣れ親しんでおりすぐとりかかりたいのであれば、\
+このセクションを流し読みして `さらに学ぶ`_ のセクションに移動するとよいでしょう。
+
+バージョン管理システムの小史
+-----------------------------
+
+バージョン管理ツールは数十年の間に進化してきました。
+簡単に説明すると、ツールは4世代に渡ります:
+
+ 1. ファイルのバージョン管理ツール、たとえばSCCS、RCS
+ 2. ファイルのバージョン管理ツール - 集中型、たとえばCVS
+ 3. ファイルのバージョン管理ツール - 第二世代集中型、たとえばSubversion
+ 4. ファイルのバージョン管理ツール - 分散型、たとえばBazaar
+
+Bazaarの設計と実装は前世代のすべてのツールから学んだことに基づいています。
+とりわけ、Bazaarは集中型と分散型の両方のバージョン管理モデルをサポートするので\
+ツールを変更せずに複数のモデルに対応できます。
+
+集中型 vs 分散型
+-----------------
+
+従来の多くのVCSツールはファイルのツリーに対する履歴(**リポジトリ**, *repository*)
+を提供する中央サーバーが必要です。
+ファイルに対する作業に取り組むために、ユーザーはサーバーに接続してファイルを\
+**チェックアウト** (*checkout*) する必要があります。
+チェックアウトにより、ユーザーが修正できるツリー(**作業ツリー**, *working tree*)ができます。
+これらの変更を記録(**コミット**, *commit*)するためには、集中型のサーバーにアクセスする権限が必要で、\
+コミットをする前に作業内容を最新バージョンとマージしなければなりません。
+このアプローチは集中型モデルとして知られます。
+
+集中型モデルは長期にわたって有用であることを示してきましたが顕著な欠点がいくつかあります。
+先ず第一に、集中型のVCSはバージョン管理機能を利用するためにはサーバーに接続できることを要求します。
+二番目に、集中型のモデルは変更の **スナップショットの記録** のふるまいと変更の **公開**
+のふるまいと密接にリンクさせます。
+これは状況によってはよいこともありますが別の状況では品質にわるい影響を与えることがあります。
+
+分散型のVCSツールは単独の集中型のレポジトリではなく複数のレポジトリをユーザーとチームに持たせます。
+Bazaarでは通常、履歴はバージョン管理されているコードと同じ場所に保存されます。
+これによってユーザーは、オフラインであってもコミットするべきタイミングで変更をコミットできます。
+ネットワークのアクセスは変更を公開するもしくは別の場所の変更にアクセスするときのみ求められます。
+
+実際、分散型VCSツールを賢く使うことでオフライン作業を超えたいくつかの開発者にとっての利点があります。
+
+ * 開発者が実験用のブランチを作るのが簡単になります
+ * 仲間とのアドホックなコラボレーションが簡単になります
+ * ルーチンタスクの時間が減ります - より創造的な活動に時間を割けます
+ * "feature-wide" コミットの利用を通してリリース管理の柔軟性が増します
+ * トランクの質と安定性を高い水準で維持でき、それによって作業者のストレスが少なくなります
+ * オープンソースのコミュニティにおいて:
+
+   * コア開発者ではない人が作成と変更の維持をしやすくなります
+   * コア開発者が外部の開発者と共同作業をしてコアのチームに組み込むことが楽になります
+
+ * 会社において、分散されたチームや外部のチームと連携するのが簡単になります
+
+分散型VCSツールの集中型より優れた点の詳細な一覧に関しては、 http://bazaar-vcs.org/BzrWhy を参照してください。
+
+
+Bazaarの主要な機能
+-------------------
+
+Bazaarは現存する唯一のVCSツールではありませんが、多くのチームとコミュニティにとって\
+よい選択肢になる優れた機能をいくつか持ちます。
+別のVCSツールとの比較の要約はBazaarのWiki、 http://bazaar-vcs.org/ で見つかります。
+
+多くの機能の中で、とりわけ強調するものがあります:
+BazaarはPythonで書かれた完全にフリーなソフトウェアです。
+結果として、改善に貢献することは簡単です。
+手を貸して頂けるのであれば、 http://bazaar-vcs.org/BzrSupport を参照して頂くようお願いします。
+
+
+さらに学ぶ
+-----------
+
+このマニュアルではBazaarの簡単な紹介と効果的な使い方を提供します。
+すべてのユーザーは、少なくとも次の点について書かれたこの章の残りを読むことが推奨されます:
+
+ * ユーザーが知る必要のある中心的な概念を説明します
+ * Bazaarを利用した人気のある方法をいくつか紹介します
+
+2-6章ではさまざまなタスクを実現するためにBazaarを使う方法を詳しく説明します。
+Bazaarを使い始めた後で最初から最後まで読むことをほとんどの方にお勧めします。
+7章とそれ以降はコアの機能を理解した上でBazaarを利用する際に手助けになる追加情報を提供します。
+この教材は必要なときに任意の順番で読むことができます。
+
+すでに他のバージョン管理ツールに慣れ親しんでいるのであれば、次のドキュメントを読んですぐに始めるとよいでしょう:
+
+ * 5分でBazaar_ - ミニチュートリアル
+ * Bazaarクィックスタートカード_ - よく使われるコマンドを1ページにまとめた要約。
+
+加えて、オンラインのヘルプと `Bazaarユーザーリファレンス`_
+は利用可能なコマンドとオプションのすべての詳細を提供します。
+
+.. _5分でBazaar: ../mini-tutorial/index.html
+.. _Bazaarクィックスタートカード: ../quick-reference/quick-start-summary.svg
+.. _Bazaarユーザーリファレンス: ../user-reference/bzr_man.html
+
+このマニュアルがお役に立てることを願っております。Bazaarの残りのドキュメントの改善を提案したいのであれば、
+メーリングリスト(bazaar@lists.canonical.com)に連絡して頂けるようお願いします。

=== added file 'doc/ja/user-guide/merging_changes.txt'
--- doc/ja/user-guide/merging_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/merging_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,93 @@
+変更をマージする
+=================
+
+並行開発
+---------
+
+誰かがプロジェクトの独自ブランチを持ったら、 並行して変更を行い、\
+オリジナルのブランチを続ける開発にコミットできます。
+まもなくですが、開発の独立したラインを結合することが必要にあります。
+このプロセスは *マージ (merging)* として知られます。
+
+mergeコマンド
+-------------
+
+別のブランチから変更を受け入れるためには、 ``merge`` コマンドを使います。
+構文は次のとおりです::
+
+  bzr merge [URL]
+
+URLが渡されない場合、オリジナルのものから由来する初期のブランチがデフォルト\
+として使われます。
+たとえば、BillがMaryの作業内容からブランチを作る場合、
+下記のようにコマンドを入力すれば彼女の次の変更をマージできます::
+
+  bzr merge
+
+一方で、MaryはBillのブランチで行われた作業内容を彼女のブランチにマージ\
+したいかもしれません。
+この場合、彼女は最初に明示的にURLを渡す必要があります::
+
+  bzr merge sftp://mary@bill-laptop/cool-repo/cool-trunk
+
+マージブランチがまだ設定されていなければ、これによってデフォルトの\
+マージブランチが設定されます。
+設定した後でデフォルトを変更するためには、 ``--remember`` オプション\
+を使います。
+
+マージの動作方法は？
+--------------------
+
+マージのためのいくつかのアルゴリズムがあります。
+Bazaarのデフォルトのアルゴリズムは次のように動作する
+*3方向マージ (3-way merging)* の一種です。
+Aが祖先でBとCの2つがブランチであると仮定すると、次のテーブルは使われるルールを\
+提示します。
+
+  === === === ====== =================
+   A   B   C  結果   コメント
+  === === === ====== =================
+   x   x   x  x      unchanged
+   x   x   y  y      line from C
+   x   y   x  y      line from B
+   x   y   z  ?      conflict
+  === === === ====== =================
+
+マージの中には人間の手助けによってのみ完了するものがあることに留意してください。
+これらを解決する方法の詳細は `衝突を解消する <resolving_conflicts.html>`_ を参照してください。
+
+マージを記録する
+-----------------
+
+衝突が解決した後で、マージをコミットする必要があります。例です::
+
+  bzr commit -m "Merged Mary's changes"
+
+衝突が無くても、明確なコミットがまだ必要です。
+他のツールとは異なり、これはBazaarの機能と考えられています。
+クリーンなマージは必ずしもよいマージとは限らないので、個別の明確なステップ\
+としてコミットすることで、すべてがよい状態にあることを検証するための最初の\
+テストスィートを実行できます。
+
+問題が見つかったら、マージをコミットする前にそれらを訂正する\
+もしくは ``revert`` を使用してマージを廃棄すべきです。
+
+マージの追跡
+------------
+
+Bazaarの機能の中で最も重要な機能の1つは、分散型で高品質の\
+*マージトラッキング* です。
+言い換えると、Bazaarは何がすでにマージされていることを覚えており、\
+マージのための最良の祖先を賢く選ぶためにその情報を使い、\
+衝突の回数と規模を最小にします。
+
+あなたが他の多くのVCSツールの難民であるなら、
+*何が何でもマージは避けさせてください* という習慣から抜け出すのは\
+本当に難しいかもしれません。
+Bazaarによっていつでも安全に他の人とのマージを行うことができます。
+peer-to-peerの方法でうまくゆくときに、高い品質を保つために、
+"統合のたまり場"として集中型のブランチを使うことも避けられます。
+コラボレーションしている変更を本当に広く共有する準備ができたら、\
+変更を中心のブランチにマージしてコミットする機会です。
+
+このようにマージ機能がうまくゆけば開発者の共同作業の方法を変えることができます。

=== added file 'doc/ja/user-guide/organizing_branches.txt'
--- doc/ja/user-guide/organizing_branches.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/organizing_branches.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,95 @@
+ブランチを編成する
+===================
+
+ミラーブランチ
+----------------
+
+開発をするために分散型のワークフローを利用する際の主要な違いは\
+メインのローカルブランチは変更を行う場所ではないことです。
+代わりに、中心ブランチのそのままのコピーとして保存されます。
+すなわち、これは *ミラーブランチ* です。
+
+ミラーブランチを作るためには、共用リポジトリ(まだなければ)を作り\
+ミラーを作るために ``branch`` コマンド(もしくは ``checkout``)を使います。
+例です::
+
+  bzr init-repo PROJECT
+  cd PROJECT
+  bzr branch sftp://centralhost/srv/bzr/PROJECT/trunk
+
+タスクのブランチ
+-----------------
+
+それぞれの新しい機能もしくは修正は独自のブランチの中で開発されます。
+これらのブランチは *機能ブランチ* もしくは *タスクブランチ* として言及されます -
+用語はお互いに置き換えて使うことができます。
+
+タスクブランチを作るためには、ミラーブランチに対して  ``branch`` コマンドを使います。
+例です::
+
+  bzr branch trunk fix-123
+  cd fix-123
+  (hack, hack, hack)
+
+この方法には数多くの利点があります:
+
+ 1. 並行して複数の変更に取り組むことができます
+ 2. 変更の間の交換が減ります
+ 3. 複数の人々は準備ができるまでpeer-to-peerモードでブランチに取り組むことができます
+
+とりわけ、変更が他のものより料理するのに時間がかかるのであれば、レビューを求めたり、
+フィードバックを適用することができます。
+中心ブランチにマージする前に個別のブランチで十分な品質の作業を完了させることで、
+中心ブランチの品質と安定性は以前よりも高い水準を維持します。
+
+ミラーブランチをリフレッシュする
+---------------------------------
+
+これを行うためには ``pull`` コマンドを使います::
+
+  cd trunk
+  bzr pull
+
+最新のトランクを機能ブランチにマージする
+-----------------------------------------
+
+これを行うためには ``merge`` コマンドを使います::
+
+  cd fix-123
+  bzr merge
+  (resolve any conflicts)
+  bzr commit -m "merged trunk"
+
+機能をトランクにマージする
+---------------------------
+
+異なる分散型のワークフローの方針は変わります、
+すべての開発者がメイントランクにコミットする権限を持つ最もシンプルな\
+事例は下記のとおりです。
+
+ミラーがチェックアウトなら::
+
+  cd trunk
+  bzr update
+  bzr merge ../fix-123
+  (resolve any conflicts)
+  bzr commit -m "Fixed bug #123"
+
+ミラーがブランチの場合::
+
+  cd trunk
+  bzr pull
+  bzr merge ../fix-123
+  (resolve any conflicts)
+  bzr commit -m "Fixed bug #123"
+  bzr push
+
+タスクブランチをバックアップする
+--------------------------------
+
+集中型ワークフローの副作用の1つは変更がITオペレーションの一部として\
+バックアップされる中心位置にしょっちゅうコミットされることです。
+タスクブランチを開発するとき、作業内容を中心位置に公開することは\
+バックアップになるのでよい考えです(しかし共用位置であることは必須ではありません)。
+この目的のためだけにローカルのタスクブランチをバックアップサーバー上で\
+確立されたリモートブランチにバインドするとよいかもしれません。

=== added file 'doc/ja/user-guide/organizing_your_workspace.txt'
--- doc/ja/user-guide/organizing_your_workspace.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/organizing_your_workspace.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,177 @@
+.. _organizing-your-workspace:
+
+作業スペースを構成する
+=========================
+
+.. _common-workspace-layouts:
+
+一般的なレイアウト
+---------------------
+
+Bazaarのユーザーがプロジェクトのための作業スペースを構成するベストな方法は、\
+次のような要素に依存します:
+
+* ユーザーの役割: プロジェクトオーナー vs コア開発者 vs カジュアルな貢献者
+
+* ワークフロー: プロジェクトが推奨/強制している、貢献のためのワークフロー
+
+* サイズ: 大きいプロジェクトは小さいプロジェクトよりもリソースを要求します。
+
+少なくとも4つの一般的なワークスペースの構成方法があります。
+
+* lightweight checkout
+* standalone tree
+* feature branches
+* switchable sandbox.
+
+各レイアウトの簡単な説明を以下に記します。
+
+
+軽量チェックアウト
+--------------------
+
+このレイアウトでは、作業ツリーはローカルですがブランチはリモートにあります。
+これはCVSやSVNで一般的に利用されるレイアウトで、シンプルで簡単に理解できます。
+
+セットアップするには::
+
+  bzr checkout --lightweight URL project
+  cd project
+
+作業するには::
+
+  (make changes)
+  bzr commit
+  (make changes)
+  bzr commit
+
+各コミットが暗黙的に変更を同じブランチを利用している他の人に公開していることに\
+注意してください。ただし、コミットが成功するには作業ツリーがリモートのブランチの\
+最新の状態になっている必要があります。最新のコードを取得してマージするには、::
+
+  bzr update
+
+
+スタンドアロンツリー
+----------------------
+
+このレイアウトでは、作業ツリーとブランチは一つの場所にあります。
+共有リポジトリが上位のディレクトリに無い限り、リポジトリも同じ場所に\
+格納されます。これはBazaarのデフォルトレイアウトで、小規模から中規模の\
+大きさのプロジェクトに適しています。
+
+セットアップ::
+
+  bzr branch URL project
+  cd project
+
+作業::
+
+  (make changes)
+  bzr commit
+  (make changes)
+  bzr commit
+
+変更を中央の場所に公開する::
+
+  bzr push [URL]
+
+pushするURLは最初の一回だけ要求されます。
+
+もし中央の場所が、pushするまでの間に他のユーザーからの変更を受け取っていた\
+場合、pushする前にそれらの変更をローカルブランチにmergeする必要があります::
+
+  bzr merge
+  (resolve conflicts)
+  bzr commit
+
+代替手段として、チェックアウトを使うこともできます。ブランチと同じように\
+チェックアウトも履歴全体をローカルにコピーしますが、ローカルブランチが\
+リモートの場所に束縛されているので、両方のブランチに一度にコミットされます。
+
+注意: チェックアウトはローカルコミット+pushに比べてスマートです。
+チェックアウトはまずリモートにコミットして、それが成功したときにだけ\
+ローカルにもコミットします。
+
+.. _feature-branches:
+
+機能ブランチ
+--------------
+
+このレイアウトでは、いくつかのブランチとツリーがあって、一般的にリポジトリを共有します。
+一つのブランチは "trunk" のミラーを保存していて、それ以外の作業単位(例:バグ修正や
+機能追加)にはそれぞれの "機能ブランチ" を作ります。
+このレイアウトはほとんどのプロジェクト、特に中規模のものにとって理想的です。
+
+セットアップ::
+
+  bzr init-repo project
+  cd project
+  bzr branch URL trunk
+
+機能ブランチを開始する::
+
+  bzr branch trunk featureX
+  cd featureX
+
+作業する::
+
+  (make changes)
+  bzr commit
+  (make changes)
+  bzr commit
+
+変更をメーリングリストに公開してレビュー&承認してもらう::
+
+  bzr send
+
+変更を公開ブランチで公開する(たとえばLaunchpad上でmerge要求を出すために)::
+
+  bzr push [URL]
+
+変化形として、trunkをチェックアウトとして作ることもできます。
+もしtrunkへのコミット権限を持っているのであれば、trunkへマージして\
+コミットするとその変更は暗黙的に公開されます。
+他には、trunkのURLが読み込み専用だった場合(例: httpアドレス)、チェックアウトを\
+利用することはローカルのtrunkミラーに間違えて変更を登録してしまうことを\
+防止します。これはプロジェクトがPQMなどのゲートキーパー型のワークフロー\
+を利用していたときに有用です。
+
+
+.. _local-sandbox:
+
+ローカルのsandbox
+------------------
+
+このレイアウトは機能ブランチのレイアウトとほぼ同じですが、機能ブランチが\
+それぞれ作業ツリーを持つ代わりに一つの作業ツリーを共用する点が違います。
+これはgitのデフォルトレイアウトに似ていて、大きなツリー(10000ファイル以上\
+とか)を持つプロジェクトや、ビルドによる加工物(.oや.classファイルといった)\
+を大量に作るプロジェクトに適しています。
+
+セットアップ::
+
+  bzr init-repo --no-trees project
+  cd project
+  bzr branch URL trunk
+  bzr checkout --lightweight trunk sandbox
+  cd sandbox
+
+これでsandboxで作業を開始できますが、sandboxがtrunkを参照したままコミット\
+してしまうと、(trunkがcheckoutで無い限り)trunkが元のtrunkのミラーでは\
+なくなってしまいます。
+なので、まず機能branchを作ってsandboxをそちらに紐づけましょう::
+
+  bzr branch ../trunk ../featureX
+  bzr switch ../featureX
+
+この後の、変更を行ったりその変更を公開して適用してもらうまでの\
+プロセスは機能ブランチレイアウトの時と同じです。
+
+
+進んだレイアウト
+----------------
+
+お望みとあれば、あなたのお好みの構成に合わせてレイアウトを決めることができます。
+例やアイデアについては `共有リポジトリのレイアウト <shared_repository_layouts.html>`_
+を参照してください。

=== added file 'doc/ja/user-guide/part2_intro.txt'
--- doc/ja/user-guide/part2_intro.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/part2_intro.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,11 @@
+これからの長い旅
+=================
+
+前の章でBazaarがあなた自身と他の人との共同作業を生産的にすることを手助け\
+してくれる方法について確固として理解して頂けることを筆者達は願っております。
+初めてBazaarを学んでいるのであれば、一度習得したら、このマニュアルに戻るために\
+すでにカバーされた手順を試すとよいかもしれません。
+
+残りの章ではBazaarをより適切に使うためのさまざまなトピックをカバーしています。
+明言されない限り、この章と残りの章はそれぞれ独立しているので好きな順序で
+読むことができます。

=== added file 'doc/ja/user-guide/partner_intro.txt'
--- doc/ja/user-guide/partner_intro.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/partner_intro.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,33 @@
+他の人と連携する
+=================
+
+Peer-to-peerをうまくやる
+-------------------------
+
+多くの場合、1人よりも2人で考える方がベターです。
+1人でプロジェクトを始め、誰かがあなたを手伝いたい、もしくはあなたが別の人に助けを求めたいことがあります。
+ペアプログラマとしてタスクを割り当てられたより大きなチームのメンバーであることでしょう。
+どちらにしても、効率よく共同作業を行うために、2人の人間がプロセス、ガイドラインとツールセットの一式に同意する必要があります。
+
+誰かに電話で直接呼び出すことが許可されていなくて、彼らに話しかける唯一の方法は最初に電話会議を予約することである場合を想像してください。
+集中型のVCSのリポジトリを通してのみコードを共有する企業とコミュニティは毎日\
+そのような拘束に耐えています。
+中央管理がうまくいくときもあれば、peer-to-peerがうまくいくときもあります。
+Bazaarはどちらの場合でも手助けになるように設計されました。
+
+パートナーのワークフロー
+-------------------------
+
+これは唯一の方法ではありませんが、下記の *パートナーのワークフロー* はBazaarを利用してペアで共同作業をしたい人々のためのよいスタート地点です。
+
+.. image:: images/workflows_peer.png
+
+以前の章でカバーしたタスクに加えて、この章では2つの必要不可欠なコラボレーション活動を紹介します:
+
+ * ブランチのコピーを手に入れる
+ * 複数のブランチの間の変更をマージする
+
+コードベースに取り組むだけのときでも、たとえば異なるリリースのために\
+複数のブランチを手元に置き必要に応じてそれらの変更をマージすることは\
+とても実用的です。
+あなたの "パートナー" が本当にあなた自身かもしれませんから。

=== added file 'doc/ja/user-guide/plugins.txt'
--- doc/ja/user-guide/plugins.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/plugins.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,101 @@
+プラグインを利用する
+=====================
+
+.. Information on how to use plugins in Bazaar.
+
+プラグインとは？
+-----------------
+
+プラグインは主にサードパーティによって作られたBazaarのための外部コンポーネントです。
+プラグインは新しい機能を追加することでBazaarを補強する能力があります。
+プラグインは現在の機能を置き換えることでBazaarのふるまいを変更することもできます。
+プラグインのサンプルのアプリケーションは次のとおりです:
+
+* コマンドをオーバーライドする
+* 新しいコマンドを追加する
+* 追加のネットワーク転送機能を提供する
+* ログの出力をカスタマイズする
+
+プラグインを通してできるカスタマイズの可能性は際限がありません。
+実際、開発者が新しい機能を公式のコードベースに含める前にテストするための方法としてプラグインは機能します。
+プラグインは機能の引退時でも同様に役立ちます。たとえば廃止されたファイルのフォーマットがある日Bazaarのコアから除外されるかもしれませんが\
+代わりにプラグインとして利用できます。
+
+プラグインはユーザーにとって、外部の開発者にとっても、Bazaar自身にもよいものです。
+
+プラグインが見つかる場所
+-------------------------
+
+http://bazaar-vcs.org/BzrPlugins ページでプラグインのリストが見つかります。
+
+プラグインをインストールする方法
+---------------------------------
+
+プラグインのインストール作業はとても簡単です！　まだ作られていなければ、
+Bazaarの設定ディレクトリの元で ``plugins`` ディレクトリを作ります。
+Linuxの場合は ``~/.bazaar/`` でWindowsの場合は
+``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\`` です。
+このディレクトリの範囲内では(下記では$BZR_HOMEとして言及される) それぞれのプラグインは独自のサブディレクトリに設置されます。
+
+プラグインはとりわけBazaarのブランチとよく連携します。
+たとえば、Linuxのメインのユーザーアカウント用にbzrtoolsプラグインをインストールするためには、次のコマンドを実行します::
+
+    bzr branch http://panoramicfeedback.com/opensource/bzr/bzrtools
+    ~/.bazaar/plugins/bzrtools
+
+プラグインをインストールするディレクトリの名前はPythonの有効な識別子でなければなりません。
+このことはディレクトリは特定の文字だけを含まなければならないことを意味します。とりわけハイフン (``-``) を含んではなりません。
+``bzr-gtk`` を ``$BZR_HOME/plugins/bzr-gtk`` にインストールするよりも、 ``$BZR_HOME/plugins/gtk`` にインストールします。
+
+プラグインの代替用の場所
+-------------------------
+
+必要なパーミッションがあれば、プラグインをシステム全体のベースにインストールすることもできます。
+現在2つの場所がプラグインのためにチェックされます:
+
+ 1. システムの場所 - bzrlib/plugins
+ 2. 個人の場所 - $BZR_HOME/plugins.
+
+Linuxにおいて、これらの典型的な場所は
+``/usr/lib/python2.4/site-packages/bzrlib/plugins/`` と
+``$HOME/.bazaar/plugins/`` です。
+Windowsにおいて、システムの場所は
+``C:\\Program Files\\Bazaar\\plugins`` になり、
+個人の場所は ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0\plugins`` です。
+
+環境変数 ``BZR_PLUGIN_PATH`` をプラグインが含まれるディレクトリに設定することで\個人のプラグインの場所を上書きできます。
+
+
+インストールされたプラグインの一覧を表示する
+---------------------------------------------
+
+これを行うためには、次のようにpluginsコマンドを使います::
+
+    bzr plugins
+
+それぞれのプラグインの名前、場所とバージョンが表示されます。
+
+プラグインによって追加された新しいコマンドは ``bzr help commands`` を実行することで見ることができます。
+プラグインによって提供されたコマンドはブラケットの中のプラグインの名前に従って表示されます。
+
+人気のあるプラグイン
+--------------------
+
+次の表は人気のあるプラグインのサンプルです。
+
+  ================ ================= ==================================
+  カテゴリ         名前              説明
+  ================ ================= ==================================
+  GUI              QBzr              QtベースのGUIツール
+  GUI              bzr-gtk           GTKベースのGUIツール
+  GUI              bzr-eclipse       Eclipseとの統合
+  General          bzrtools          その他。shelfを含めた機能の強化
+  General          difftools         外部の差分ツールヘルパー
+  General          extmerge          外部のマージツールヘルパー
+  Integration      bzr-svn           Subversionをリポジトリとして利用する
+  Migration        cvsps             CVSパッチセットを移行させる
+  ================ ================= ==================================
+
+あなた独自のプラグインを書きたい場合、難しいことではありません。
+始めるためには付録の `プラグインを書く <writing_a_plugin.html>`_
+の項目をご覧ください。

=== added file 'doc/ja/user-guide/publishing_a_branch.txt'
--- doc/ja/user-guide/publishing_a_branch.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/publishing_a_branch.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,68 @@
+ブランチを公開する
+===================
+
+集中型リポジトリをセットアップする
+-------------------------------------
+
+集中型のワークフローはコンピュータ上のブランチを中心型のブランチ\
+として指名することで使うことができます。
+実際大抵のチームは集中型のブランチをホストするために専用サーバーを\
+持ちます。
+
+共用リポジトリをローカルで使うことが最良の習慣であるように、\
+中心型のブランチを共用リポジトリを設置することもお勧めです。
+通常は、中心型の共用ブランチはファイルの作業コピーではなく\
+履歴のみを保存することに注意してください。
+なので、そのような共有リポジトリを作るときには通常 ``no-trees``
+オプションを使います::
+
+  bzr init-repo --no-trees sftp://centralhost/srv/bzr/PROJECT
+
+この手順をcvsrootもしくはSubversionのリポジトリのセットアップとして\
+似たようなものとして考えることができます。
+しかしながら、Bazaarはリポジトリ内のブランチの編成方法をより柔軟にします。
+ガイドラインと例に関しては付録の
+`共用レポジトリのレイアウト <shared_repository_layouts.html>`_ を参照してください。
+
+
+集中型ブランチを始める
+-------------------------
+
+集中型ブランチに初期の内容を投入する方法は2つあります:
+
+ 1. ローカルのブランチを作り中央にプッシュする
+ 2. 空の中央ブランチを作り内容をコミットする
+
+最初のやり方の例です::
+
+  bzr init-repo PROJECT  (ローカルリポジトリを準備する)
+  bzr init PROJECT/trunk
+  cd PROJECT/trunk
+			 (開発ファイルをコピーする)
+  cp -ar ~/PROJECT .     (OS固有のツールを使用してファイルをコピーする)
+  bzr add                (リポジトリを投入する; バージョン管理を始める)
+  bzr commit -m "Initial import"
+                         (中心リポジトリに公開する)
+  bzr push sftp://centralhost/srv/bzr/PROJECT/trunk
+
+2番目のやり方の例です::
+
+  bzr init-repo PROJECT  (ローカルリポジトリを準備する)
+  cd PROJECT
+  bzr init sftp://centralhost/srv/bzr/PROJECT/trunk
+  bzr checkout sftp://centralhost/srv/bzr/PROJECT/trunk
+  cd trunk
+  cp -ar ~/PROJECT .     (OS固有のツールを使用してファイルをコピーする)
+  bzr add                (リポジトリを投入する; バージョン管理を始める)
+  bzr commit -m "Initial import"
+                         (中心リポジトリに公開する)
+  bzr push sftp://centralhost/srv/bzr/project/trunk
+
+``checkout`` コミットを使って作られた作業ツリー内部でコミットすると\
+ローカルと同様に内容は暗黙の内に中心位置にコミットされることに注意してください。
+``checkout`` の代わりに ``branch`` コマンドを使ったので、\
+内容はローカルにのみコミットされます。
+
+このように中心位置に密接に連動した作業ツリーは *チェックアウト(checkouts)*
+と呼ばれます。
+この章の残りでは数多くの機能を詳しく説明します。

=== added file 'doc/ja/user-guide/recording_changes.txt'
--- doc/ja/user-guide/recording_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/recording_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,76 @@
+変更を記録する
+===============
+
+bzr commit
+----------
+
+作業ツリーの状態が満足のゆくものであるとき、これをブランチに **コミット** できます。
+そしてその状態のスナップショットを保持する新しいリビジョンが作られます。
+
+**commit** コマンドはリビジョンの変更を記述するメッセージをとります。
+コミットはあなたのユーザーID、現在の時間とタイムゾーン、一覧表とツリーの内容も記録します。
+コミットメッセージは ``-m`` もしくは ``--message`` オプションによって指定されます。
+複数行のコミットメッセージを入力できます;
+大抵のシェルでは行の終わりで引用符を開いたままにするだけで入力できます。
+
+::
+
+    % bzr commit -m "added my first file"
+
+ファイルからメッセージを得るために ``-F`` オプションを使うことができます。
+中には、作業している間にコミットメッセージ用のノートを作り、自分が何を行い何を発言したのか
+確認するために差分をレビューしたい人がいます。
+(このファイルは一休みしてから作業を取り出すのにも役立ちます)
+
+エディタからのメッセージ
+-------------------------
+
+``-m`` もしくは ``-F`` オプションを使わないのであれば、
+bzrはメッセージを入力するためにエディタを開きます。
+起動させるエディタは ``$VISUAL`` もしくは ``$EDITOR`` 環境変数によって制御され、
+``~/.bazaar/bazaar.conf`` の中の ``editor`` 設定によって上書きできます;
+``$BZR_EDITOR`` は上記で言及したエディタのオプションを上書きします。
+変更なしでエディタを閉じると、コミットはキャンセルされます。
+
+エディタの中で開かれるファイルは境界線を含みます。
+この行の下のファイルの部分は情報用のみのために含まれ、コミットメッセージには\
+含まれません。
+セパレータの下側はコミットで変更されるファイルの一覧が表示されます。
+上記の行の上側でメッセージを書き、ファイルを保存して閉じます。
+
+編集メッセージとしてコミットする差分を見たければ ``--show-diff`` オプションを使うことができます。
+これはエディタが開くときにエディタの差分を含みます。セパレータの下とファイルに関する情報はコミットされます。
+これは書いたメッセージを読むことができることを意味しますが、
+差分自身は終了したときにコミットメッセージに表示されません。
+一部をメッセージに含めたいのであれば、それらをセパレータの上側にコピー＆ペーストできます。
+
+選択可能なコミット
+------------------
+
+コミットのコマンドラインでファイルもしくはディレクトリの名前を渡すと
+それらのファイルへの変更のみがコミットされます。たとえば::
+
+    % bzr commit -m "documentation fix" commit.py
+
+デフォルトではサブディレクトリから実行されたとしても
+bzrは常にツリーへのすべての変更をコミットします。
+現在のディレクトリのみからコミットするには、ドットを引数として使います::
+
+    % bzr commit .
+
+変更に署名をつける
+-------------------
+
+たとえば誰かのパッチを適用するときなど、コミットしようとしている変更があなたのものでないなら、 ``--author`` という commit のオプションを使って変更に署名をつけられます。 ::
+
+    % bzr commit --author "Jane Rey <jrey@example.com>"
+
+ここで指定された人はそのリビジョンの "author" として記録され、\
+あなたはそのリビジョンの "committer" として記録されます。
+
+もしリビジョンの変更がペアプログラミングなどにより複数の人に作られたもの\
+ならば、 ``--author`` を複数回指定して記録することができます。 ::
+
+    % bzr commit --author "Jane Rey <jrey@example.com>" \
+        --author "John Doe <jdoe@example.com>"
+

=== added file 'doc/ja/user-guide/releasing_a_project.txt'
--- doc/ja/user-guide/releasing_a_project.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/releasing_a_project.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,43 @@
+プロジェクトをリリースする
+==========================
+
+リリースをパッケージ化する
+--------------------------
+
+``export`` コマンドはリリースのパッケージを作成するために使われます。
+すなわち、ブランチの中のファイルとディレクトリをコピーしてそれらを真新しいディレクトリもしくはアーカイブファイルのパッケージを作成します。
+たとえば、このコマンドは最後にコミットされたバージョンを ``tar.gz`` アーカイブファイルにパッケージ化します::
+
+  bzr export ../releases/my-stuff-1.5.tar.gz
+
+``export`` コマンドは下記に示されるアーカイブのタイプを作るためにアーカイブファイルの接尾辞を使います。
+
+      ==========================       ===================
+      サポートされるフォーマット       拡張子で自動検出
+      ==========================       ===================
+         dir                                (none)
+         tar                                 .tar
+         tbz2                           .tar.bz2, .tbz2
+         tgz                             .tar.gz, .tgz
+         zip                                 .zip
+      ==========================       ===================
+
+最新のリビジョン以外のリビジョンをパッケージにすることを望むのであれば、 ``-r`` オプションを使います。
+アーカイブ内部のrootディレクトリを調整したいのであれば、 ``--root``
+オプションを使います。
+``export`` によってサポートされるオプションの詳細については
+オンラインヘルプもしくはユーザーリファレンスを参照してください。
+
+リリースをタギングする
+-----------------------
+
+リリースのパッケージを作成するために使われたバージョンを覚えるよりも、
+``tag`` コマンドを使ってバージョンのためのシンボルを定義する方が便利です::
+
+  bzr tag version-1-5
+
+リビジョンの識別子が必要なときはいつでもそのタグを使うことができます::
+
+  bzr diff -r tag:version-1-5
+
+ブランチの中で定義したタグの一覧を見たい場合、 ``tags`` コマンドを使います。

=== added file 'doc/ja/user-guide/resolving_conflicts.txt'
--- doc/ja/user-guide/resolving_conflicts.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/resolving_conflicts.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,75 @@
+衝突の解消
+===========
+
+ワークフロー
+-------------
+
+マージプロセスの間にそれぞれの衝突を解消することを強制する他のいくつかのツール\
+とは異なり、Bazaarはできる限りマージしてから衝突を報告します。
+これによって衝突の解消をより扱いやすくします。
+解消すべき方法を決めることを手助けするためにポストマージツリー全体の内容が\
+利用可能だからです。
+それぞれの解消もしくはグループがよい状態であることを確認するためにテストを\
+いくつか選んで実行することもよいでしょう。
+
+衝突の一覧を表示する
+---------------------
+
+``merge`` コマンドで報告されるのと同様に、\
+突出した衝突の一覧は ``conflicts`` コマンドを使用することでいつでも表示されます。
+これは ``status`` コマンドから出力の一部として含めることも可能です。
+
+衝突を解消する
+--------------
+
+衝突に遭遇したら、 ``merge`` コマンドは解決されていない領域を表示する\
+埋め込みマーカーをそれぞれのファイルに追加します。
+1つの衝突を持つそれぞれのファイルに対して3つのファイルも作ります:
+
+ * foo.BASE
+ * foo.THIS
+ * foo.OTHER
+
+``foo`` は衝突したファイルの名前です。
+多くの場合、問題になっているそれぞれのファイルを手作業で編集し、\
+関連領域を修正し衝突マーカーを除去することで衝突を解消できます。
+
+衝突の中のすべてのファイルを修正し、マーカーを削除した後で、
+``resolve`` コマンドを使用してBazaarにそれらを解決したものとしてマークするように頼みます::
+
+  bzr resolve
+
+代わりに、それぞれのファイルを修正した後で、これを解消したものとしてマークできます::
+
+  bzr resolve foo
+
+``resolve`` コマンドは作業ツリーからBASE, THIS, OTHERファイルをクリーンナップします。
+
+remergeコマンドを使う
+---------------------
+
+いくつかの場合、任意のファイルに対して異なるマージアルゴリズムを試したいことがあります。
+これを行うためには、ファイルを次のように指定して ``remerge`` コマンドを使います::
+
+  bzr remerge --weave foo
+
+``foo`` はファイルで ``weave`` オプションは利用可能なマージアルゴリズムです。
+いわゆる ``criss-cross`` (十字遺伝)マージが検出されたときに、
+たとえば、2つのブランチが同じものをマージしてからお互いをマージするときに、\
+このアルゴリズムはとりわけ便利です。
+詳細については ``criss-cross`` と ``remerge`` のオンラインヘルプを参照してください。
+
+衝突を解消するために外部ツールを利用する
+-----------------------------------------
+
+衝突を解消するためにGUIツールを利用したいのであれば、
+*extmerge* プラグインをインストールしてください。次のようにインストールできます::
+
+  bzr extmerge foo
+
+``foo`` は衝突したファイルです。
+解消するファイルの一覧を提供するよりも、すべての衝突ファイルを暗黙の内に指定するために ``--all`` オプションを利用できます。
+
+``extmerge`` コマンドは ``bazaar.conf`` ファイルの中の ``external_merge`` 設定によって指定されるツールを使います。
+設定されていなければ、 ``kdiff3`` もしくは ``opendiff`` のような人気のあるマージツールが設定されます。
+後者はOS XのFileMergeのコマンドラインインターフェイスです。

=== added file 'doc/ja/user-guide/reusing_a_checkout.txt'
--- doc/ja/user-guide/reusing_a_checkout.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/reusing_a_checkout.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,83 @@
+チェックアウトを再利用する
+===========================
+
+動機
+-----
+
+時々、複数のブランチに取り組むために単独のチェックアウトを\
+サンドボックスとして持つことは便利です。
+挙げられる理由のいくつかは次の内容を含みます:
+
+ * 作業ツリーが大きいときディスクスペースを節約する
+ * 固定された位置で開発する
+
+多くの場合、作業ツリーのディスクの利用量は ``.bzr`` ディレクトリよりも
+大きくなります。
+複数のブランチに取り組みたいが、それぞれの作業ツリーすべてのオーバーヘッドを\
+許容できない場合、複数のブランチをまたがってチェックアウトを再利用することが\
+うまくゆく方法です。
+
+他の機会において、サンドボックスの位置は数多くの開発とテストツールに設定されます。
+繰り返しますが、複数のブランチをまたがったチェックアウトの再利用は役に立ちます。
+
+
+ブランチが結びつけられた場所を変更する
+---------------------------------------
+
+チェックアウトが結びつけられている場所を変更するためには、次の手順に従います:
+
+ 1. 作業内容が失われないようにローカルの変更が中央ブランチにコミット
+    されたことを確認します
+
+ 2. 取り組みたい新しいリモートブランチのURLを渡して ``bind`` コマンドを使います
+
+ 3. ``revert`` コマンドの後に続いて ``update`` コマンドを使用して望むブランチの
+    コピーをチェックアウトします
+
+新しいブランチに bind して update するだけだと、コミットしたもの、していないもの\
+両方のローカルの変更がマージされることに注意してください。
+``revert`` か ``commit`` を使って、それらを維持するか破棄するかを決めなければ\
+いけません。
+
+bind+update レシピの代わりは ``switch`` コマンドを使うことです。これは基本的に、\
+ツリーの中のコミットされていない変更がマージされること以外は、既存のブランチを\
+除去して新しい位置で ``checkout`` を再び実行することと同じです。
+
+注: 場合によってバインドされた異なるブランチの適切なキャッシュをチェックアウトするために
+``switch`` はコミットされた変更を廃棄するので、ローカルにコミットされているが最も最近\
+バインドされたブランチにまだコミットされていない変更が存在する場合意図的に失敗します。
+これらの変更を本当に廃棄したいのであれば、 ``--force`` オプションを使います。
+
+
+軽量型チェックアウトを切り替える
+----------------------------------
+
+軽量型チェックアウトでは、ローカルのコミットは存在せず、 ``switch`` は\
+作業ツリーが関連づけられたブランチを効率よく選びます。
+1つの可能なセットアップ方法は、ローカルツリーなしのリポジトリと軽量\
+チェックアウトを組み合わせて使うことです。
+これによって取り組むものを簡単に切り替えることができます。例です::
+
+  bzr init-repo --no-trees PROJECT
+  cd PROJECT
+  bzr branch sftp://centralhost/srv/bzr/PROJECT/trunk
+  bzr checkout --lightweight trunk my-sandbox
+  cd my-sandbox
+  (hack away)
+
+この例のこの範囲でtrunk ``.bzr`` ディレクトリを持ちますがそこでの\
+ブランチとしての作業ツリーはツリーなしのリポジトリで作られたことに\
+注意してください。必要な数だけブランチを入手もしくは作成して必要に\
+応じてそれらの間で切り替えることができます。例です::
+
+  (my-sandboxの中にいることを前提とする)
+  bzr branch sftp://centralhost/srv/bzr/PROJECT/PROJECT-1.0 ../PROJECT-1.0
+  bzr switch ../PROJECT-1.0
+  (fix bug in 1.0)
+  bzr commit -m "blah, blah blah"
+  bzr switch ../trunk
+  (go back to working on the trunk)
+
+注: ブランチはローカルのみのものでも、(``checkout`` で作るか ``branch``
+でそれらを作った後で ``bind`` を使うことで)リモートのブランチにバインド\
+されたものでも可能です。

=== added file 'doc/ja/user-guide/reviewing_changes.txt'
--- doc/ja/user-guide/reviewing_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/reviewing_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,50 @@
+変更をレビューする
+==================
+
+リープする前にロックする
+-------------------------
+
+作業が完了したら、恒久的に記録することに先駆けて変更をレビューするのはよい考えです。
+この方法で、何を意図しているのかをコミットすることを確認できます。
+
+2つのbzrコマンド: **status** と **diff** はとりわけ便利です。
+
+bzr status
+----------
+
+ **status** コマンドは最後のリビジョン以降に作業ディレクトリに行われた変更内容を伝えます::
+
+    % bzr status
+    modified:
+       foo
+
+``bzr status`` は 変更されないもしくは無視される "つまらない" ファイルを隠します。
+statusコマンドはチェックするためにオプションとしてファイルもしくはディレクトリの名前を渡すことができます。
+
+bzr diff
+--------
+
+The **diff** コマンドはすべてのファイルへの変更の全文を標準のunified diffとして表示します。
+これは ''patch''、 ''diffstat''、 ''filterdiff'' と ''colordiff''といった多くのプログラムを通してパイプで引き渡すことができます::
+
+    % bzr diff
+    === added file 'hello.txt'
+    --- hello.txt   1970-01-01 00:00:00 +0000
+    +++ hello.txt   2005-10-18 14:23:29 +0000
+    @@ -0,0 +1,1 @@
+    +hello world
+
+
+``-r`` オプションによって、ツリーは前のリビジョン、もしくは示された2つのリビジョンの違いを表示します::
+
+    % bzr diff -r 1000..          # everything since r1000
+    % bzr diff -r 1000..1100      # changes from 1000 to 1100
+
+``--diff-options`` オプションによってbzrは外部のdiffプログラムにオプションを渡して実行します。例です::
+
+    % bzr diff --diff-options --side-by-side foo
+
+プロジェクトの中には新旧のファイルのためのパスの始めで接頭辞を表示するためにパッチを好むところもあります。
+``--prefix`` オプションはそのような接頭辞を提供するために使われます。
+ショートカットとして、 ``bzr diff -p1`` は ``patch -p1`` コマンドで機能する形式を生み出します。
+

=== added file 'doc/ja/user-guide/sending_changes.txt'
--- doc/ja/user-guide/sending_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/sending_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,65 @@
+変更を送信する
+===============
+
+動機
+-----
+
+多くの分散型のシナリオでは、開発者にとってURLを公開することでタスクブランチを\
+共有することが常に現実的であるとは限りません。
+たとえば、開発者が在宅で一晩中作業をする場合、ゲートキーパーが別のタイムゾーンで\
+レビューしてマージしたいときに開発者はタスクブランチに十分にアクセスできません。
+
+Bazaarは手助けする巧妙な機能: *マージディレクティブ* を提供します。
+
+マージのディレクティブを理解する
+---------------------------------
+
+マージディレクティブを"ミニブランチ" - ブランチが作成された後の成長部分 -
+として考えることができます。
+これは変更点を記したソフトウェアパッチですが、追加情報として中間コミット、\
+リネームとデジタル署名のようなメタデータがつきます。
+
+別の実用的なメタファはパケットケーキ: レシピと必要な材料を持った\
+マージディレクティブです。
+具体的にいえば、材料とはブランチ上で加えられた全ての変更のメタデータで、\
+レシピとはそれらの変更点をどうやってマージするかで、 ``merge`` コマンドが\
+共通の祖先を選ぶのに利用する情報です。
+
+それらをどのように考えるのであれ、マージディレクティブはよいものです。
+これらは簡単に作れて、メールに添付して送信するのに最適で、受け取った後で\
+ブランチと同じように処理できます。
+
+マージディレクティブを作る
+-----------------------------
+
+マージディレクトリを作りオプションとして送信するためには、 ``send`` コマンドを使います。
+
+デフォルトでは、 ``send`` はマージディレクティブを ブランチのための "投稿アドレス" 、
+通常はリード開発者もしくは開発メーリングリストにEメールを送信します。
+オプションなしの ``send`` はマージディレクティブを作り、Eメールツールを作動させて添付し、\
+少しの説明文を追加するための準備をします。
+(この設定方法の詳細に関してはオンラインヘルプの ``send`` と
+リファレンスマニュアルの `構成設定 <../user-reference/bzr_man.html#configuration-settings>`_
+を参照)
+
+大抵のプロジェクトではパッチ付きのメールに説明文を追加し、パッチの理由と内容を説明します。
+これによってレビューワは行単位の差分に入る前にいくらかの事情を理解できます。
+
+代わりに、 ``--output`` (or ``-o``) オプションが渡されると、 ``send``
+はマージディレクティブをファイルに書くので、あなた自身にメールを送り、
+それを検査し、後の使用のために保存できます。
+``-`` の出力ファイルが渡されると、ディレクティブはstdoutに書き込まれます。例です::
+
+  cd X-fix-123
+  bzr send -o ../fix-123.patch
+
+
+マージのディレクティブを適用する
+---------------------------------
+
+``merge`` と ``pull`` コマンドを使うことでマージディレクティブはブランチと同じ方法で\
+適用できます
+
+これらはBazaarを使わない上流のプロジェクトとコミュニケーションをするときにも便利です。
+とりわけ、マージディレクティブ内の変更全体のプレビューは無地のソフトウェアパッチの\
+ようになるので、たとえば彼らは ``patch -p0`` を使用してそれらを適用できます。

=== added file 'doc/ja/user-guide/server.txt'
--- doc/ja/user-guide/server.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/server.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,94 @@
+スマートサーバーを稼働させる
+============================
+
+BazaarはHTTP、FTPもしくはSFTPを通して動作するので特化したサーバーは\
+必須ではありません。
+SSH、inetd、もしくは専用モードで起動できるスマートサーバー(smart server)\
+の選択肢があります。
+
+ダムサーバー
+-------------
+
+HTTP、FTP、SFTPとHTTP-WebDAVを"ダム(dumb)"サーバーとして記述します。
+これらはBazaarに支援を提供しないからです。
+これらのプロトコルのどれかを通してBazaarリポジトリを利用できるようにする場合、
+Bazaarはリモートからの読み込みを許可します。
+実行しているBazaarコマンドの中でブランチへのURLを入力するだけです。::
+
+    bzr log http://bazaar-vcs.org/bzr/bzr.dev
+
+BazaarはFTP、SFTPと(プラグインを通した)HTTP-WebDAVを通した書き込みをサポートします。
+
+ハイパフォーマンスなスマートサーバー
+-------------------------------------
+
+ハイパフォーマンスなスマートサーバー(hpss - high-performance smart server)は\
+いくつかのオペレーションをダムサーバーよりも遙かに高速に実行します。
+開発者がパフォーマンスのチューニングを継続するので、将来のリリースでは\
+スマートサーバーを利用することで改善されるオペレーションの範囲は増えます。
+
+高度なセキュリティの維持を可能にするために、
+デフォルトでは現在のスマートサーバーはリードオンリーになります。
+読み込みと書き込み権限を有効にするには、 ``--allow-writes`` で動かします。
+SSHアクセスメソッドを利用するとき、bzrは ``--allow-writes`` オプションで\
+自動的に実行します。
+
+次はスマートサーバーの代替の設定方法を説明します。
+
+SSH
+~~~
+
+SSHを通してBazaarを利用する際にサーバー上の特別な設定は必要ありません::
+
+    BZR_REMOTE_PATH=~/bin/bzr bzr log bzr+ssh://host/path/to/branch
+
+``BZR_REMOTE_PATH`` 環境変数はリモートシステムで `bzr` が起動する方法を調整します。
+デフォルトでは単に `bzr` として起動するので、 `bzr` 実行ファイルはデフォルトの\
+検索パス上にあることが要求されます。
+
+``bzr+ssh://`` URLスキームはファイルシステムのrootからの絶対パスだけをサポートします。
+将来のバージョンでは ``sftp://`` URL (https://bugs.launchpad.net/bzr/+bug/109143) と同じように
+``~`` もサポートされる予定です。
+
+inetd
+~~~~~
+
+この例では ``/srv/bzr/repo/branchname`` にブランチがある ``/srv/bzr/repo`` 内の
+共用リポジトリ用に専用ユーザーの `bzruser` で `bzr` を実行する方法を示しています。
+
+inetdからBazaarサーバーを動かすにはinetd.confエントリが必要です::
+
+    4155  stream  tcp  nowait  bzruser  /usr/bin/bzr /usr/bin/bzr serve --inet --directory=/srv/bzr/repo
+
+クライアントコマンドを実行するとき、提供するURLは
+inetd.confに渡される ``--directory`` オプションに相対的な `bzr://` です::
+
+    bzr log bzr://host/branchname
+
+専用サーバー
+~~~~~~~~~~~~~
+
+このモードはinetdモードと同じパスとURLのふるまいを持ちます。
+特定のユーザーとして実行するには、 ``su`` を使うもしくはそのユーザーとしてログインします。
+
+この例では公式のポート番号の `4155` 上でbzrを稼働しすべてのインターフェイス上でリスンします。
+これによってポート `4155` 上のマシンに到達できる世界のどこからでも接続できます。
+
+サーバー::
+
+    bzr serve --directory=/srv/bzr/repo
+
+クライアント::
+
+    bzr log bzr://host/branchname
+
+この例では `localhost` のポート `1234` で ``bzr serve`` が実行されます。
+
+サーバー::
+
+    bzr serve --port=localhost:1234 --directory=/srv/bzr/repo
+
+クライアント::
+
+    bzr log bzr://localhost:1234/branchname
+

=== added file 'doc/ja/user-guide/setting_up_email.txt'
--- doc/ja/user-guide/setting_up_email.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/setting_up_email.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,93 @@
+Eメールを設定する
+=================
+
+.. Bazaarでコミット用のEメールを指定するさまざまな方法の説明です。
+
+なぜBazaarでEメールアドレスをセットアップするのか？
+---------------------------------------------------
+
+リビジョンが作成されたとき誰がどのリビジョンをコミットしたのかわかるように
+Bazaarは指定されたEメールアドレスをリビジョンに保存します。
+Eメールアドレスは検証されないので、それゆえ 偽造できるので、プロジェクトに関わる人々を信用しなければなりません。
+
+加えて、リビジョンのEメールアドレスはクレジットかつ/もしくは注釈に関してリビジョンの筆者とコンタクトをとる別の方法を提供します。
+
+Eメールアドレスをセットアップする方法
+--------------------------------------
+
+Eメールアドレスが設定されていない場合、Bazaarはユーザー名とホスト名に基づいて推測を試みます。
+これは望む状況ではないかもしれないので、Bazaarに使うメールを伝える方法は3つ存在します:
+
+いくつかの設定ファイルの1つにEメールを設定できます。
+他の設定値のように、 ``bazaar.conf`` で一般的な設定として設定できます。
+特定のブランチ、もしくは複数のブランチの一式用に値を上書きしたい場合、 ``locations.conf`` を利用できます。
+``.bzr/branch/branch.conf`` も動作しますが、
+他の人であってもそのブランチへのすべてのコミットで同じEメールアドレスが使われます。
+
+優先順位は
+
+ 1. ``BZR_EMAIL`` 環境変数が設定されている場合
+ #. Eメールが現在のブランチの ``locations.conf`` ファイルに対して設定されている場合。
+ #. Eメールが現在のブランチの ``.bzr/branch/branch.conf`` ファイルに設定されている場合。
+ #. Eメールがデフォルトの ``bazaar.conf`` 設定ファイルで設定されている場合。
+ #. `EMAIL` 環境変数が設定されている場合
+ #. Bazaarはユーザー名とホスト名から推測しようとします。
+
+Bazaarが現在のEメールと考えるものを確認するには、 ``whoami`` ("who am i?") コマンドを使います::
+
+    % bzr whoami
+    Joe Cool <joe@example.com>
+
+'whoami'コマンドでEメールを設定する
+------------------------------------
+
+Eメールをグローバルに設定するにはwhoamiコマンドを使用します::
+
+    % bzr whoami "Joe Cool <joe@example.com>"
+
+もしくは現在のブランチのみの場合::
+
+    % bzr whoami --branch "Joe Cool <joe@example.com>"
+
+これらのコマンドによってグローバルな ``bazaar.conf`` もしくはブランチの ``branch.conf`` ファイルがそれぞれ修正されます。
+
+デフォルトの設定ファイルでEメールを設定する
+--------------------------------------------
+
+デフォルトのiniファイルを使うには、 ``bazaar.conf`` ファイル
+(Linuxでは ``~/.bazaar/`` 、Windowsでは ``%APPDATA%\bazaar\2.0\`` )を作成し編集して下記で示すようにEメールアドレスを設定します。
+DEFAULTは大文字と個別を区別して、大文字でなければならないことに注意をお願いします。
+::
+
+    [DEFAULT]
+    email=Your Name <name@isp.com>
+
+
+iniファイルのフォーマットの詳細情報に関しては、Bazaarユーザーリファレンスの `構成設定 <../user-reference/bzr_man.html#id21>`_ を参照してください。
+
+ブランチ単位でEメールを設定する
+--------------------------------
+
+2番目のアプローチは ``locations.conf`` 設定ファイルを使用してブランチごとにEメールを設定する方法です::
+
+    [/some/branch/location]
+    email=Your Name <name@other-isp.com>
+
+これによってブランチのEメールアドレスは ``/some/branch/location`` に設定され、
+上記の ``bazaar.conf`` で指定されたデフォルトの値を上書きします。
+
+環境変数を通してEメールを設定する
+---------------------------------
+
+Bazaarが利用する最後の方法は ``BZR_EMAIL`` と ``EMAIL`` 環境変数 に対するチェックです。
+一般的に、スクリプトのコンテキストでEメールを上書きするためにこの方法を利用できます。
+一般的なデフォルトの値に設定したい場合、上記のiniの方法を参照して下さるようお願いします。
+
+スパムに関する懸念事項
+-----------------------
+
+スパムの標的にされないようにEメールアドレスを共有したくない人達がいます。
+公開された場所で自分でブランチもしくはチェンジセットを公開しない限り、BazaarはけっしてEメールアドレスを露出しません。
+他の人があなたに作業内容に関して連絡できるように実際のアドレスを使うことを *強く* お勧めしますが、必須ではありません。
+メールアドレスは難読にしたり、宛先がわからず戻ってくるようにする、もしくは `spamgourmet.cm` のような
+アンチスパムサービスの検査をうけさせたりします。

=== added file 'doc/ja/user-guide/shared_repository_layouts.txt'
--- doc/ja/user-guide/shared_repository_layouts.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/shared_repository_layouts.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,363 @@
+共用レポジトリのレイアウト
+===========================
+
+Bazaarは共用ブランチ内部のブランチのレイアウトを柔軟に決められるように設計されました。
+この柔軟性によってユーザーはBazaarを自分のワークフローに合わせることができますが、\
+"よい"レイアウトとは何かということを疑問に持つようになります。
+ここでは代わりになるものをいくつか説明しそれぞれの利点を検討します。
+
+言及すべき重要な点はよいレイアウトは"一般的な"ユーザーが理解できるように
+ブランチの内容を何らかの形でハイライトします。
+SVNにおいて これは "``trunk/``" ブランチであると考えられ、
+大抵のレイアウトではこの命名規約が守られています。
+これを "``mainline``" もしくは "``dev``" と呼ぶ人もいれば、
+CVSから来た人々はしばし "``HEAD``" と言及します。
+
+
+"SVN形式" (``trunk/``, ``branches/``)
+---------------------------------------
+
+SVNからやってきた人々は次のような"標準的な"プロジェクトのレイアウトに慣れています::
+
+  repository/       # リポジトリ全体
+   +- trunk/        # 開発のメインライン
+   +- branches/     # コンテナディレクトリ
+   |   +- foo/      # 開発中のfoo機能用ブランチ
+   |     ...
+   +- tags/         # コンテナディレクトリ
+       +- release-X # 特定のリリースバージョンをマークするために専用ブランチ
+          ...
+
+Bazaarでは、これは完全に適切なレイアウトです。
+SVNからやって来た人が慣れ親しめることが利点で\
+開発の焦点を当てる場所が明確になります。
+
+同じリポジトリで複数のプロジェクトを持つとき、\
+SVNのレイアウトは何を行うのか少し不透明です。
+
+
+``project/trunk``
+~~~~~~~~~~~~~~~~~
+
+SVN用の望ましい方法はプロジェクトごとにレイアウト用のトップレベルのディレクトリを用意することです::
+
+  repository/            # リポジトリ全体
+   +- project1/          # コンテナディレクトリ
+   |   +- trunk/         # project1の開発のメインライン
+   |   +- branches/      # コンテナディレクトリ
+   |       +- foo/       # project1のfoo機能の開発用ブランチ
+   |         ...
+   |
+   +- project2/          # project2用のコンテナ
+       +- trunk/         # project2用のメインライン
+       +- branches/      # project2のブランチ用のコンテナ
+
+
+これはBazaarでも機能します。
+しかしながら、Bazaarでリポジトリを作るのは簡単で( ``bzr init-repo`` )、
+それらの主要な恩恵を受けられるのは複数のブランチが共通の祖先を共有するときです。
+
+ですのでBazaarに対して望ましい方法は次のとおりです::
+
+    project1/          # project1用のリポジトリ
+     +- trunk/         # project1の開発のメインライン
+     +- branches/      # コンテナディレクトリ
+         +- foo/       # project1のfoo機能の開発用ブランチ
+           ...
+
+    project2/          # project2用のリポジトリ
+     +- trunk/         # project2用のメインライン
+     +- branches/      # project2のブランチ用のコンテナ
+
+
+``trunk/project``
+~~~~~~~~~~~~~~~~~
+
+SVNで次のようなレイアウトを利用するプロジェクトもたまにあります::
+
+  repository/             # リポジトリ全体
+    +- trunk/             # コンテナディレクトリ
+    |   +- project1       # project1用のメインライン
+    |   +- project2       # project2用のメインライン
+    |         ...
+    |
+    +- branches/          # コンテナ
+        +- project1/      # コンテナ (?)
+        |   +- foo        # project1の'foo'ブランチ
+        +- project2/
+            +- bar        # project2の'bar'ブランチ
+
+
+次のレイアウトはちょっと変形させたものです::
+
+  repository/             # リポジトリ全体
+    +- trunk/             # コンテナディレクトリ
+    |   +- project1       # project1用のメインライン
+    |   +- project2       # project2用のメインライン
+    |         ...
+    |
+    +- branches/          # コンテナ
+        +- project1-foo/  # project1の'foo'ブランチ
+        +- project2-bar/  # project2の'bar'ブランチ
+
+"``trunk/``" 全体をチェックアウトすることで、すべてのプロジェクト用の\
+メインラインを入手できるようにすることが、このレイアウトが採用されている理由だと\
+筆者は考えます。
+
+このレイアウトはBazaarでも使えますが、一般的にお勧めできません。
+
+ 1) 一回の ``bzr branch/checkout/get`` は一つのブランチを作ります。
+    単独のコマンドですべてのメインラインを入手する利点が得られません。 [1]_
+
+ 2) ``repository/trunk/foo`` が ``foo`` プロジェクトの ``trunk`` か
+    ``trunk`` ブランチの単なる ``foo`` ディレクトリなのか明らかではありません。
+    この混乱の一部はSVNによるものです。
+    SVNはプロジェクトのブランチ用に使う1つのプロジェクトのファイルに対して同じ"名前空間"を使うからです。
+    Bazaarにおいて、プロジェクトを構成するファイルの明確な定義、もしくはブランチの位置の対立軸があります
+    (ブランチごとに唯一の ``.bzr/`` ディレクトリか、チェックアウトの中にたくさんの
+    ``.svn/`` ディレクトリかという対立軸です)
+
+.. [1] 注: `NestedTreeSupport`_ は"メタプロジェクト"を作成する方法を提供します。
+    メタプロジェクトはリポジトリのレイアウトにかかわらず複数のプロジェクトを集約します。
+    1つのプロジェクトを ``bzr checkout`` すれば、必要なサブプロジェクトがすべて手に入ります。
+
+.. _NestedTreeSupport: http://bazaar-vcs.org/NestedTrees
+
+
+入れ子形式 (``project/branch/sub-branch/``)
+---------------------------------------------
+
+SVNではできない、Bazaarによる別のスタイルは、ブランチ同士を\
+入れ子にすることです。
+Bazaarは作業ツリーなしのリポジトリ作成(``--no-trees``)をサポート\
+(と推奨)しているのでこのスタイルが可能になります。
+作業ファイルはブランチの設置場所に混ぜられていないので、 好きな名前空間にブランチを設置できます。
+
+1つの可能性は次のとおりです::
+
+  project/             # リポジトリ全体、*と* プロジェクトのメインラインのブランチ
+   + joe/              # 開発者Joeの開発のプライマリブランチ
+   |  +- feature1/     # 開発者Joeのfeature1開発ブランチ
+   |  |   +- broken/   # feature1を開発するためのステージングブランチ
+   |  +- feature2/     # Joeのfeature2開発ブランチ
+   |    ...
+   + barry/            # Barryの開発ブランチ
+   |  ...
+   + releases/
+      +- 1.0/
+          +- 1.1.1/
+
+このレイアウトのアイディアはブランチ用の階層的なレイアウトを作ることです。
+変更はたいていより上位の名前空間のブランチへと流れていきます。
+また、このレイアウトではユーザーに独自の作業をするための場所も提供します。
+このレイアウトの素晴らしい点の1つは、グローバルな ``branches`` 名前空間を\
+散らかさずにミニブランチを置けるので、ブランチ作成が"手軽"になることです。
+
+このレイアウトのもう一つの利点は、ブランチの名前の中で詳細な内容を指定する際に\
+繰り返しが減ることです。
+
+例です::
+
+  bzr branch http://host/repository/project/branches/joe-feature-foo-bugfix-10/
+
+上と下を比較します::
+
+  bzr branch http://host/project/joe/foo/bugfix-10
+
+
+また、 ``repository/project/branches/`` ディレクトリの中のリストがあれが何かわかるかもしれません::
+
+  barry-feature-bar/
+  barry-bugfix-10/
+  barry-bugfix-12/
+  joe-bugfix-10/
+  joe-bugfix-13/
+  joe-frizban/
+
+Versus こういったブランチが開発者のディレクトリに分散している。
+ブランチの数が少なければ、 ``branches/`` は一見するだけですべての\
+ブランチが見えるという素晴らしい利点があります。
+ブランチの数が多ければ、 ``branches/`` はすべてのブランチが\
+見えてしまうというはっきりした欠点があります。
+(調べるブランチが100あるとき、興味のあるブランチを見つけるのが難しくなります)。
+
+入れ子ブランチはたくさんのブランチよりもスケーラブルのようです。
+しかしながら、それぞれの個別のブランチは見つけにくいです。
+(たとえば"Joeはfoo機能ブランチでバグ修正10に取り組んでいるのか、\
+それともbarの機能ブランチを取り組んでいるのか？")
+
+他の小さな利点は次のようなものです::
+
+   bzr branch http://host/project/release/1/1/1
+  もしくは
+   bzr branch http://host/project/release/1/1/2
+
+1.1.1と1.1.2のリリースを示します。
+これはリリースする数と一度に見られる能力よりも分割する方がゲインが多いかによります。
+
+
+ステータスによる種類分け (``dev/``, ``merged/``, ``experimental/``)
+---------------------------------------------------------------------
+
+ブランチをbreak upする他の方法はこれらを現在のステータス順でソートすることです。
+そうするとレイアウトは次のようになります::
+
+  project/               # レイアウト全体
+   +- trunk/             # 開発に焦点を当てたブランチ
+   +- dev/               # 進行中の作業用コンテナディレクトリ
+   |   +- joe-feature1   # Joeの現在のfeature-1ブランチ
+   |   +- barry-bugfix10 # bugfix 10に対するBarryの作業内容
+   |    ...
+   +- merged/            # これらのブランチがマージされたことを示すコンテナ
+   |   +- bugfix-12      # すでにマージされたバグ修正
+   +- abandonded/        # 'dead-end'と見なされているブランチ
+
+
+これはたくさんの利点と欠点があります。
+あまり多くない数のアクティブに開発されているブランチを見ることができるか、\
+今までに作られた全てのブランチが見えるかという違いがあります。
+古いブランチは削除しない限り失われませんが、別ディレクトリへと整理されるので\
+たいていの場合お目当てのブランチを見つけやすくなります。
+(反対に、古いブランチは見つけにくくなります)。
+
+このレイアウトで最大の欠点、ブランチが移動することです。
+誰かが ``project/dev/new-feature`` ブランチをフォローしているとき、
+そのブランチが  ``trunk/`` にマージされると ``project/merged/new-feature``
+に移動するので ``bzr pull`` が突然機能しなくなります。
+この回避策はいくつかあります。
+1つは利用者を導くために古いブランチから新しいブランチにリクエストする\
+HTTPリダイレクトを使うことです。
+``bzr`` >= 0.15 ではユーザーに ``http://old/path が http://new/path``
+にリダイレクトされることを教えてくれます。
+しかしながら、HTTP以外の方法(SFTP、ローカルファイルシステム、など)を\
+通してブランチにアクセスしている場合は役に立ちません。
+
+一時的なリダイレクト用にシンボリックリンクを利用することも可能です
+(シンボリックリンクがリポジトリ内にある限りトラブルはほんのわずかしかありません)。
+しかし、シンボリックリンクを結局削除したくなったり、散乱の削減の恩恵を得られません。
+シンボリックリンクの代わりの別の可能性は ``BranchReference`` を使うことです。
+``bzr`` コマンドを通してこれらを作るのは現時点では難しいですが、便利だと思う人がいれば変わるかもしれません。
+これは実際には `Launchpad`_ が ``bzr checkout https://launchpad.net/bzr`` をできるようにしている方法です。
+``BranchReference`` は機能的にはシンボリックリンクですが、他のURLの参照ができます。
+相対パスによる参照ができるように拡張されれば、http、sftp、ローカルパスを通しても\
+動作するでしょう。
+
+.. _Launchpad: https://launchpad.net
+
+
+日付/リリース/その他で種類分け (``2006-06/``, ``2006-07/``, ``0.8/``, ``0.9``)
+------------------------------------------------------------------------------
+
+スケーラビリティを可能にする別の方法は"現在の"ブランチのブラウジングを許可することです。
+基本的に、活発に開発されるブランチは新しく作られ古いブランチはマージもしくは\
+廃棄されることを前提とします。
+
+基本的に日付レイアウトは次のようになります::
+
+  project/                # projectリポジトリ全体
+   +- trunk/              # 一般的なメインライン
+   +- 2006-06/            # この月に作成されたブランチ用のディレクトリのコンテナ
+   |   +- feature1/       # "project"の"feature1"用ブランチ
+   |   +- feature2/       # "project"の"feature2"用ブランチ
+   +- 2005-05/            # 異なる月に作成されるブランチ用のコンテナディレクトリ
+       +- feature3/
+       ...
+
+これは "私の新しいブランチをどこに設置すればいいの？" という質問に素早く答えてくれます。
+機能が長期間開発されるのであれば、ブランチを最新の日付にコピーして、\
+そこで作業を続けることも道理にかなっています。
+最新の日付と、そこからのさかのぼっていくことで活発なブランチを見つけることができます。
+(小さな欠点は 大抵のディレクトリリストは古い順にソートされているので、\
+多くの場合新しいブランチにたどり着くために余計なスクロールが必要になることです)。
+古いブランチを新しい位置にコピーしたくない場合、ブランチを探すのが面倒になるのも欠点です。
+
+別の候補は、リリースをターゲットにしたものです::
+
+  project/          # リポジトリ概要
+   +- trunk/        # メインラインの開発ブランチ
+   +- releases/     # リリースブランチ用のコンテナ
+   |   +- 0.8/      # リリース0.8のブランチ
+   |   +- 0.9/      # リリース0.9のブランチ
+   +- 0.8/          # リリース0.8をターゲットとするブランチ用のコンテナ
+   |   +- feature1/ # 0.8にマージする予定の"feature1"用のブランチ
+   |   +- feature2/ # "リリース0.8をターゲットとしたfeature2"用のブランチ
+   +- 0.9/
+       +- feature3/ # リリース0.9をターゲットとした"feature3"用のブランチ
+
+
+その派生として、ブランチが ``0.9`` ディレクトリに入っていることが 0.9に *向けた*
+ブランチであることではなく 0.9 *から* 派生したブランチであることを意味するように\
+することや、 ``0.8/release`` が0.8ブランチの公式リリースであることを意味するように\
+することが考えられます。
+
+一般的なアイディアはリリースをターゲットにすることで、何のブランチがマージ\
+されるのを待っているのか調べることができます。
+このレイアウトはブランチの状態(開発中なのか、終了してレビューを待っているのか)\
+に関する情報を提供しません。
+これは履歴を隠す効果もあり、日付ベースの種類分けと同じような利点と欠点を持っています。
+
+シンプルな開発者名 (``project/joe/foo``, ``project/barry/bar``)
+----------------------------------------------------------------
+
+別の利用できるレイアウトは、開発者ごとにディレクトリを割り当てて、\
+その下にブランチのためのサブディレクトリを作ることです。次のようになります::
+
+  project/      # リポジトリ全体
+   +- trunk/    # メインラインのブランチ
+   +- joe/      # Joeのブランチ用のコンテナ
+   |   +- foo/  # Joeの"project"の"foo"ブランチ
+   +- barry/
+       +- bar/  # Barryの"project"の"bar"ブランチ
+
+このアイデアでは、branchは入れ子になっておらず、branchは開発者によってのみ\
+グループ化されます。
+
+`Launchpad`_ で使われている派生系はこのようになっています::
+
+  repository/
+   +- joe/             # Joeのブランチ
+   |   +- project1/    # Joeのブランチである"project1"用のコンテナ
+   |   |   +- foo/     # Joeの"project1"の"foo"ブランチ
+   |   +- project2/    # Joeの"project2"ブランチ用のコンテナ
+   |       +- bar/     # Joeの"project2"の"bar"ブランチ
+   |        ...
+   |
+   +- barry/
+   |   +- project1/    # Barryの"project1"のブランチ用のコンテナ
+   |       +- bug-10/  # Barryの"project1"の"bug-10"ブランチ
+   |   ...
+   +- group/
+       +- project1/
+           +- trunk/   # "project1"に焦点をあてたメイン開発
+
+
+このレイアウトではそれぞれの開発者が取り組んでいるものを簡単に見ることができます。
+焦点のブランチは"group" ディレクトリに保存されます。
+これによって"グループ"が取り組んでいるブランチを見分けられます。
+
+これによって異なる人々の作業内容をそれぞれ分離できますが、\
+"プロジェクトX用のすべてのブランチ"を見つけるのが難しくなります。
+`Launchpad`_ はデータベースバックエンドを伴う素晴らしいウェブインターフェイス\
+を提供していて、"view"をこのレイアウトのトップに追加することでこの欠点を補っています。
+これはそれぞれの個人が "``~/public_html``" ディレクトリを持ち、そこで独自の\
+ウェブページを公開する個人用ホームページのモデルに近いです。
+一般的に、集中型のプロジェクト用に共用リポジトリを作成するとき、\
+個人単位で分割してからプロジェクト単位に分割することを望まないでしょう。
+通常はプロジェクト単位で分割してから個人単位で分割するとよいでしょう。
+
+要約
+-----
+
+最後に、誰にとってもうまくいく唯一の命名規則はありません。
+開発者の人数、新しいブランチが作成される頻度、ブランチのライフサイクルなどに\
+よって異なります。
+自身に問いかける質問は次のとおりです:
+
+  1) 寿命の長い少数のブランチを作るか、もしくはたくさんの"ミニ"機能ブランチを作るか
+     (加えて:  ミニ機能ブランチをたくさん *作りたい* が現在のVCSでは苦痛なのでできないのではないか？)
+
+  2) 1人で開発しているのか、大きなチームか？
+
+  3) チームであれば、一般的に全員が同時に同じブランチに取り組むことを計画しているか？
+     もしくは人々が追跡することを想定した"安定"ブランチを持つか。
+

=== added file 'doc/ja/user-guide/shelving_changes.txt'
--- doc/ja/user-guide/shelving_changes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/shelving_changes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,109 @@
+Shelving Changes
+================
+
+ときどき、作業ツリーから一時的に変更点を取り除いて、あとで元に戻したいことが\
+あるかもしれません。
+たとえば何か作業中に小さいバグフィックスを見つけてコミットする場合などです。
+Bazaarは変更を ``shelf`` (書棚)に保存する機能を持っています。
+後で変更を元に戻したくなったときは、 ``unshelve`` を使って作業ツリーに戻す\
+ことができます。
+
+たとえば、一つか複数の変更がされた作業ツリーを考えて見ます...::
+
+  $ bzr diff
+  === modified file 'description.txt'
+  --- description.txt
+  +++ description.txt
+  @@ -2,7 +2,7 @@
+   ===============
+
+   These plugins
+  -by Michael Ellerman
+  +written by Michael Ellerman
+   provide a very
+   fine-grained 'undo'
+   facility
+  @@ -11,6 +11,6 @@
+   This allows you to
+   undo some of
+   your changes,
+  -commit, and get
+  +perform a commit, and get
+   back to where you
+   were before.
+
+``shelve`` コマンドはインタラクティブにどの変更を作業ツリーに保留して\
+おきたいのかを質問します。::
+
+  $ bzr shelve
+  --- description.txt
+  +++ description.txt
+  @@ -2,7 +2,7 @@
+   ===============
+
+   These plugins
+  -by Michael Ellerman
+  +written by Michael Ellerman
+   provide a very
+   fine-grained 'undo'
+   facility
+
+  Shelve? [yNfrq?]: y
+  --- description.txt
+  +++ description.txt
+  @@ -11,6 +11,6 @@
+   This allows you to
+   undo some of
+   your changes,
+  -commit, and get
+  +perform a commit, and get
+   back to where you
+   were before.
+
+  Shelve? [yNfrq?]: n
+  Shelve 2 change(s)? [yNfrq?]', 'y'
+  Selected changes:
+   M  description.txt
+  Changes shelved with id "1".
+
+もしたくさんの変更が作業ツリーにあるのであれば、 ``shelve`` コマンド\
+にファイルのリストを渡して、それらのファイルの変更だけについて質問\
+されるようにすることができます。
+変更を shelve した後に ``diff`` コマンドで作業ツリーに期待する変更だけが\
+残っていることを確認するとよいでしょう。::
+
+  $ bzr diff
+  === modified file 'description.txt'
+  --- description.txt
+  +++ description.txt
+  @@ -2,7 +2,7 @@
+   ===============
+
+   These plugins
+  -by Michael Ellerman
+  +written by Michael Ellerman
+   provide a very
+   fine-grained 'undo'
+   facility
+
+よし! - コミットする準備ができました::
+
+  $ bzr commit -m "improve first sentence"
+
+後になって、shelveした変更を作業ツリーに ``unshelve`` コマンドで\
+戻します::
+
+  $ bzr unshelve
+  Unshelving changes with id "1".
+   M  description.txt
+  All changes applied successfully.
+
+もし望むのであれば、複数のアイテムをshelfに置くことができます。
+通常 ``unshelve`` が実行されるたびに最も最近 shelve された変更が\
+元に戻されます。
+明示的にどの変更を戻すのかを指定することで別の順序で unshelve する\
+こともできます。
+
+Bazaarはshelveされた後に変更があっても、shelfの変更を作業ツリーに\
+マージするので、衝突が発生するかもしれません。
+その場合は通常のマージ後と同じように衝突を解決しなければなりません。

=== added file 'doc/ja/user-guide/solo_intro.txt'
--- doc/ja/user-guide/solo_intro.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/solo_intro.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,23 @@
+単独で始める
+=============
+
+個人の生産性を向上させるツール
+--------------------------------
+
+ツールの中には個人を生産的にする(たとえばエディタ)ためや
+チームもしくは会社全体を生産的にする(たとえばバックエンドサービス)ために設計されたものがあります。
+バージョン管理ツールは伝統的に後者の陣営にありました。
+
+Bazaarがクールであることの1つはセットアップが簡単なのでバージョン管理ツールを個人の生産性を上げるツールとして扱うことができることです。
+既知のよい状態であるかチェックする、もしくは履歴を追跡するために変更を保存したい場合、簡単に行うことができます。
+この章では方法を説明します。
+
+単独用途のワークフロー
+-----------------------
+
+あなた独自の名作を作っているのであれば、ソフトウェア、プロジェクトもしくは\
+ドキュメントの一式であれ、典型的なワークフローは次のようになります:
+
+.. image:: images/workflows_single.png
+
+チームの一員として常に作業をするとしても、この章でカバーされるタスクはあなたが行うことの基本になるので、よいスタート地点です。

=== added file 'doc/ja/user-guide/specifying_revisions.txt'
--- doc/ja/user-guide/specifying_revisions.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/specifying_revisions.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,151 @@
+.. _specifying-revisions:
+
+リビジョンを指定する
+====================
+
+.. _revision-identifiers-and-ranges:
+
+リビジョンの識別子と範囲
+-------------------------
+
+Bazaarは1つのリビジョンもしくはリビジョンの範囲を指定するための豊富な表現方法を持ちます。
+リビジョンの範囲を指定するには、上限と下限を ``..`` のシンボルで区切ります。例です::
+
+    $ bzr log -r 1..4
+
+境界値の片方を省略できます::
+
+    $ bzr log -r 1..
+    $ bzr log -r ..4
+
+コマンドの中には範囲ではなく1つのリビジョンだけをとるものがあります。例です::
+
+    $ bzr cat -r 42 foo.c
+
+他の場合、範囲は必要ですが、範囲の長さを1つにします。
+これに関連したコマンドについて、 ``-c`` オプションは次のように使われます::
+
+    $ bzr diff -c 42
+
+.. _available-revision-identifiers:
+
+利用可能なリビジョンの識別子
+------------------------------
+
+リビジョン、もしくは範囲の境界、は
+下記に示される異なるフォーマットを利用して渡すことができます。
+
+ +----------------------+--------------------------------------------+
+ |  引数の型            | 説明                                       |
+ +----------------------+--------------------------------------------+
+ | *number*             | リビジョン番号                             |
+ +----------------------+--------------------------------------------+
+ | **revno**:*number*   | 正のリビジョン番号                         |
+ +----------------------+--------------------------------------------+
+ | **last**:*number*    | 負のリビジョン番号                         |
+ +----------------------+--------------------------------------------+
+ | **revid**:*guid*     | グローバルでユニークなリビジョンID         |
+ +----------------------+--------------------------------------------+
+ | **before**:*rev*     | ''rev''の左端の親                          |
+ +----------------------+--------------------------------------------+
+ | **date**:*value*     | 渡された日付の後の最初のエントリ           |
+ +----------------------+--------------------------------------------+
+ | **tag**:*value*      | 渡されたタグにマッチするリビジョン         |
+ +----------------------+--------------------------------------------+
+ | **ancestor**:*path*  | ブランチからのマージされた最新のリビジョン |
+ +----------------------+--------------------------------------------+
+ | **branch**:*path*    | 別のブランチの最新リビジョン               |
+ +----------------------+--------------------------------------------+
+ | **submit**:*path*    | 投稿ブランチの共通の祖先                   |
+ +----------------------+--------------------------------------------+
+
+これらのフォーマットの手短な紹介は下記のとおりです。
+完全な詳細内容に関しては、 Bazaarユーザーリファレンスの `リビジョンの識別子`_ を参照してください。
+
+.. _リビジョンの識別子: ../user-reference/bzr_man.html#revision-identifiers
+
+番号
+~~~~~
+
+正の数は現在のブランチにおけるリビジョン番号を表します。
+リビジョン番号は ``bzr log`` の出力の中で "revno"とラベルされます。
+最初の10のリビジョンのログを表示するには::
+
+    $ bzr log -r ..10
+
+負の数は最新リビジョンから数えます。-1は最後にコミットされたリビジョンです。
+
+最新の10のリビジョンのログを表示するには::
+
+    $ bzr log -r -10..
+
+revid
+~~~~~
+
+**revid** は ``bzr log`` と他のコマンドによって示される内部のリビジョンIDの指定を可能にします。
+
+例です::
+
+    $ bzr log -r revid:Matthieu.Moy@imag.fr-20051026185030-93c7cad63ee570df
+
+before
+~~~~~~
+
+**before**
+    ''rev''は''rev'' の左端の親を指定します。
+    これはリビジョンの履歴で ''rev'' の前に現れるリビジョン、
+    もしくは ''rev'' がコミットされたときに最新であったリビジョンです。
+
+''rev'' はリビジョンの識別子であり連結できます。
+
+例です::
+
+    $ bzr log -r before:before:4
+    ...
+    revno: 2
+    ...
+
+date
+~~~~
+
+**date**
+    ''value'' は真夜中もしくは指定された時刻での与えられた日付の、
+    深夜12時か指定された時刻の後の最初の履歴エントリにマッチします。
+
+正式な値は次のとおりです:
+
+ * **yesterday**
+ * **today**
+ * **tomorrow**
+ * **YYYY-MM-DD** 書式の日付
+ * **YYYY-MM-DD,HH:MM:SS** 書式の日付/時間、2番目はオプションです (コンマに注意)
+
+"今日のログエントリすべてをください"ということを伝える適切な方法は次のとおりです::
+
+    $ bzr log -r date:yesterday..date:today
+
+Ancestor
+~~~~~~~~
+
+**ancestor**:*path*
+    現在のブランチと異なるブランチ間の共通の祖先を指定します。
+    これはマージの目的に使われる同じ祖先です。
+
+*path* はリモートブランチのURLもしくはローカルブランチへのファイルパスになります。
+
+たとえば、 ``../parent`` からフォークされた以降のブランチで行われた変更を見るには::
+
+    $ bzr diff -r ancestor:../parent
+
+Branch
+~~~~~~
+
+branch
+   ``path`` は別のブランチの最新リビジョンを指定します。
+
+``path`` はリモートブランチのURLもしくはローカルブランチへのファイルパスです。
+
+たとえば、手元のブランチと別のブランチの間の違いを取得するには::
+
+    $ bzr diff -r branch:http://example.com/bzr/foo.dev
+

=== added file 'doc/ja/user-guide/stacked.txt'
--- doc/ja/user-guide/stacked.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/stacked.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,92 @@
+スタックブランチを利用する
+==========================
+
+スタックブランチとは？
+-------------------------
+
+スタックブランチ(stacked branch)は別のブランチのリビジョンを見つける方法を知っています。
+スタックブランチはユニークなリビジョンのみを保存することで、速く作れたり\
+効率的に保存したりします。
+これらの観点から、スタックブランチは共用リポジトリと似ています。
+しかしながら、スタックブランチは追加の利点があります:
+
+* 新しいブランチはスタックされたブランチとは完全に異なる位置に設置できます。
+
+* スタックブランチを削除すれば(共用リポジトリだと残ってしまう)
+  本当のリビジョンも削除されます
+
+* セキュリティは共用リポジトリよりも向上しています。
+  スタックドオンリポジトリはスタックブランチにコミットする開発者に対して物理的にリードオンリーだからです。
+
+これらの恩恵によって実験ブランチとコードホスティングサイトを含めたさまざまな\
+シナリオに対してスタックブランチは理想的なものになります。
+
+スタックブランチを作成する
+-------------------------
+
+スタックブランチを作成するには、branchコマンドの ``stacked`` オプションを使用します。
+例です::
+
+  bzr branch --stacked source-url my-dir
+
+このコマンドによって ``my-dir`` がローカルリビジョンなしのスタックブランチ\
+として作成されます。
+定義されると、 ``source-url`` に関連づけされた公開ブランチは
+*スタックドオン(stacked on)* の位置として使われます。
+さもなければ、 ``source-url`` は *スタックドオン* の位置になります。
+
+
+スタックチェックアウトを作成する
+-----------------------------------
+
+スタックチェックアウトを直接作成する機能はまもなくサポートされる予定です。
+それまでの間、2段階の処理が必要です:
+
+1. 上記で示されたようにスタックブランチを作成する。
+
+2. ``reconfigure`` もしくは ``bind`` コマンドのどちらかを利用して
+   ブランチをチェックアウトに変換する。
+
+
+スタックブランチをプッシュする
+---------------------------------
+
+多くのプロジェクトの大部分の変更は
+*開発トランク* or *現在の安定* ブランチといった既存のブランチを基礎としています。
+これらの1つにスタックされた新しいブランチの作成は ``push`` コマンドを利用して
+次のように簡単にできます::
+
+  bzr push --stacked-on reference-url my-url
+
+このコマンドによって ``reference-url`` にスタックされた ``my-url`` で新しいブランチが作成され
+``reference-url`` でまだブランチにない現在のブランチのリビジョンのみを格納します。
+
+ローカルブランチがスタックブランチとして作成された場合、
+``push`` するには ``--stacked`` オプションを使うことが可能で
+*stacked-on* な位置が明確になります。例です::
+
+  bzr branch --stacked source-url my-dir
+  cd my-dir
+  (hack, hack, hack)
+  bzr commit -m "fix bug"
+  bzr push --stacked
+
+
+スタックブランチの制限
+----------------------
+
+スタックブランチに関して覚えておくべき大事なことは、ほとんど全ての\
+オペレーションでスタックドオンブランチが必要になることです。
+これは両方のブランチがローカルもしくは同じサーバーにあるときは\
+問題にはなりません。
+
+スタックするブランチを変更する
+-------------------------------
+
+``bzr reconfigure`` コマンドを使ってスタックドオンブランチを変更したり\
+スタックするのをやめたりすることができます。
+``bzr reconfigure --unstacked`` を実行した場合、bzrは全ての参照されているデータを\
+スタックドオンブランチからスタックされていたブランチにコピーしてくることに\
+注意してください。
+大きなレポジトリにおいては、これは時間がかかったりリポジトリサイズを増大\
+させたりします。

=== added file 'doc/ja/user-guide/starting_a_project.txt'
--- doc/ja/user-guide/starting_a_project.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/starting_a_project.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,48 @@
+プロジェクトを始める
+=====================
+
+既存のプロジェクトをバージョン管理する
+---------------------------------------
+
+バージョン管理下に置きたいソースコードのツリー(ドキュメントのディレクトリ)をすでにお持ちなら、
+使うコマンドは以下のとおりです::
+
+  cd my-stuff
+  bzr init
+  bzr add
+  bzr commit -m "Initial import"
+
+``bzr init`` はトップレベルのディレクトリで ``.bzr`` ディレクトリを作ります(上記の例では ``my-stuff`` )。
+次のことに注意してください:
+
+ * Bazaarは必要なすべてのものをそのディレクトリに置きます -
+   データベース、ウェブサーバー、特別なサービスをセットアップする **必要はありません**
+
+ * Bazaarは ``.bzr`` を1つのディレクトリだけに作り、他のすべてのサブディレクトリの中には作らないぐらい礼儀正しいです。
+
+``bzr add`` はバージョン管理化におくべきと考えられるすべてのファイルとディレクトリを見つけ内部で登録します。
+``bzr commit`` はこれらの内容のスナップショットとその情報をコミットメッセージと一緒に記録します。
+
+``init`` 、 ``add`` と ``commit`` に関する詳細な情報は後で提供します。
+現時点で、覚えておくべき大事なことは上記のレシピです。
+
+新しいプロジェクトを始める
+---------------------------
+
+プロジェクトをゼロから始める場合、最初の段階で空のディレクトリを作った後で上述のレシピを使うこともできます。
+後の章で詳しく探求する効率の理由から、プロジェクトのためにトップレベルでレポジトリを作り
+その中で *メイン* のブランチを入れ子にすることはよいアイディアです。次のようになります::
+
+  bzr init-repo my.repo
+  cd my.repo
+  bzr init my.main
+  cd my.main
+  hack, hack, hack
+  bzr add
+  bzr commit -m "Initial import"
+
+*main* の代わりに *trunk* もしくは *dev* のような名前を好む人もいます。
+何であれあなたにとって最も有用な意味のある名前を選んでください。
+
+``init-repo`` と ``init`` コマンドの両方はパスを引数としてとり、すでに存在していなければそのパスを作ることに留意してください。
+

=== added file 'doc/ja/user-guide/svn_plugin.txt'
--- doc/ja/user-guide/svn_plugin.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/svn_plugin.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,112 @@
+bzr-svn
+=======
+
+概要
+-----
+
+bzr-svnによって集中型のSubversionリポジトリをまだ利用しているプロジェクトで\
+BazaarをVCSクライアントとして使うことができます。
+Subversionリポジトリへのアクセスは大部分は透明、\
+すなわちネイティブのBazaarブランチで ``bzr`` を使用するようにSubversion\
+リポジトリで大部分の ``bzr`` コマンドを直接利用できます。
+
+多くのbzr-svnユーザーは集中型のSubversionトランクのローカルミラーを作成し、\
+機能ブランチに取り組み、準備ができたときに変更をすべててSubversionに戻します。
+これによって既存のチーム規模のプロセスとSubversionの上に現在組み込まれている\
+ツール統合フックを妨げずに分散型VCSツールの多くの利点を得られます。
+本当に、これはBazaarを採用しようとしているがタイミングもしくは非技術的な\
+利用からまだ採用していないチームのための共通の暫定ステップです
+
+インストールの手引きに関しては、bzr-svnのホームページをご覧ください:
+http://bazaar-vcs.org/BzrForeignBranches/Subversion.
+
+
+シンプルな例
+-------------
+
+GNOMEプロジェクトの **beagle** でのシンプルな使い方です。
+最初に、ブランチの保存用のローカルな共用リポジトリをセットアップして\
+トランクをチェックアウトします::
+
+  bzr init-repo --rich-root-pack beagle-repo
+  cd beagle-repo
+  bzr checkout svn+ssh://svn.gnome.org/svn/beagle/trunk beagle-trunk
+
+
+``init-repo`` に対して ``rich-root-pack`` オプションを使うことが重要です。
+bzr-svnは追加のメタデータがいくつか必要ですが、Bazaarのデフォルトのリポジトリフォーマットではまだサポートされないからです。
+(訳注: Bazaar 2.0以降を使っているのであれば、 --rich-root-pack オプションは不要です。)
+次に、フィーチャブランチを作成してハックします::
+
+  bzr branch beagle-trunk beagle-feature1
+  cd beagle-feature1
+  (hack, hack, hack)
+  bzr commit -m "blah blah blah"
+  (hack, hack, hack)
+  bzr commit -m "blah blah blah"
+
+機能がクックされたとき、トランクをリフレッシュして変更をマージします::
+
+  cd ../beagle-trunk
+  bzr update
+  bzr merge ../beagle-feature1
+  bzr commit -m "Complete comment for SVN commit"
+
+トランクミラーはチェックアウトなので、それにコミットすれば実際のSubversionトランクにコミットされます。
+以上です！
+
+
+集中型のミラーを利用する
+-------------------------
+
+大きなプロジェクトに関しては、上記のレシピを調整すれば役立つことがしばしあります。
+とりわけ、初期のチェックアウトはとても遅い可能性があるので\
+プロジェクトに関するすべてのSubversionリポジトリをBazaarリポジトリに一旦インポートして、
+そのネイティブのBazaarリポジトリからブランチを作成します。
+bzr-svnはリポジトリからリポジトリへの変換を行うために ``svn-import`` コマンドを提供します。
+使い方の例です::
+
+  bzr svn-import svn+ssh://svn.gnome.org/svn/beagle
+
+中央のBazaarミラーを利用するために更新された上記からのレシピです::
+
+  bzr init-repo --rich-root-pack beagle-repo
+  cd beagle-repo
+  bzr branch bzr+ssh://bzr.gnome.org/beagle.bzr/trunk beagle-trunk
+  bzr branch beagle-trunk beagle-feature1
+  cd beagle-feature1
+  (hack, hack, hack)
+  bzr commit -m "blah blah blah"
+  (hack, hack, hack)
+  bzr commit -m "blah blah blah"
+  cd ../beagle-trunk
+  bzr pull
+  bzr merge ../beagle-feature1
+  bzr commit -m "Complete comment for SVN commit"
+  bzr push
+
+この場合、トランクへのコミットをしてもローカルでマージをコミットするだけです。
+マスターのSubversionトランクにコミットを戻すには、追加コマンド(``bzr push``)が必要です。
+
+注:  トランクブランチで ``pull`` と ``push`` のコマンドを最初に使う際に
+これらのコマンドに関連URLを渡す必要があります。
+その後で、bzrはそれらを記憶します。
+
+このセットアップの最後のピースはSubversionのものと同期される中心のBazaarミラーを\
+Subversionのリポジトリと同期し続けるためにスクリプトを適切な場所に設置することです。
+これはcronジョブを追加したり、Subversionフックを利用するなどによって行われます。
+
+
+bzr-svnの制限
+--------------
+
+BazaarとはSubversionは異なる機能を持つ異なるツールなので\
+何らかの相互運用問題が常に存在します。
+bzr-svn 0.5.4 に関するいくつかの例です:
+
+ * Bazaarはversioned propertiesをサポートしません
+
+ * Bazaarはファイルのコピーのトラッキングをサポートしません
+
+現在の制約の一覧に関しては、bzr-svnのウェブページ、\
+http://bazaar-vcs.org/BzrForeignBranches/Subversion を参照してください。

=== added file 'doc/ja/user-guide/undoing_mistakes.txt'
--- doc/ja/user-guide/undoing_mistakes.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/undoing_mistakes.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,152 @@
+間違いを取り消す
+================
+
+間違いは起きる
+---------------
+
+Bazaarは下記で説明されるような間違いから簡単にリカバーできるように\
+設計されています。
+
+プロジェクトのリビジョンの履歴をドロップする
+---------------------------------------------
+
+思いがけず間違ったツリーをバージョン管理下に置いたとしても、 ``.bzr`` ディレクトリを削除するだけで済みます。
+
+ファイルもしくはディレクトリの登録を解除する
+---------------------------------------------
+
+バージョン管理下に置きたくないファイルを思いがけず ``add`` コマンドで登録しても、
+それを忘れるようにBazaarにそれを忘れさせるために ``remove`` コマンドを使用できます。
+
+``remove`` は修正されたファイルが削除されないよに *安全に物事を行う* ために設計されています。たとえば::
+
+  bzr add foo.html
+  (oops - didn't mean that)
+  bzr remove foo.html
+
+このコマンドは修正されたもしくは未知のファイルについてはエラーを出力します。
+ファイルを維持したいのであれば、 ``--keep`` オプションを使います。
+代わりに、ファイルを削除したいのであれば、 ``--force`` オプションを使います::
+
+  bzr add foo.html
+  (oops - didn't mean that)
+  bzr remove --keep foo.html
+  (foo.html はディスクには残るけれども、bzrには登録されない)
+
+一方で、未変更の ``TODO`` ファイルは登録が解除されエラー出力なしでディスクから削除されます::
+
+  bzr add TODO
+  bzr commit -m "added TODO"
+  (hack, hack, hack - but don't change TODO)
+  bzr remove TODO
+  (TODO ファイルは削除される)
+
+注: IDEもしくはオペレーティングシステムのファイルマネージャーを\
+利用してファイルを削除する場合、 ``commit`` コマンドはそれを削除\
+されるものとして暗黙のうちに扱います。
+
+最後のコミット以降の変更を取り消す
+----------------------------------
+
+バージョン管理ツールを使う理由の1つは作業をしている間にツリーのステータスを楽に調べられることです。
+最新の ``commit`` 以降の変更を廃棄することを決心したら、使うコマンドは ``revert`` です::
+
+  bzr revert
+
+事前の警告として、 実際にすべてが本当に廃棄されたことを確認するために
+``bzr status`` と ``bzr diff`` を最初に使うことはよい習慣です。
+
+最後のコミット以降のファイルへの変更を取り消す
+-----------------------------------------------
+
+最後のコミット以降の特定のファイルの変更を取り消したいが、ツリーの他のすべての変更を維持したい場合、
+ファイルの名前を引数として ``revert`` に渡します::
+
+  bzr revert foo.py
+
+最後のコミットを取り消す
+-------------------------
+
+意図しないコミットをしてしまったら、取り消すために ``uncommit`` コマンドを使います::
+
+  bzr uncommit
+
+``revert`` とは異なり、 ``uncommit`` は作業のツリーの内容をそのままにします。
+意図せずに間違ったエラーメッセージをコミットしてしまった場合、これは本当に重宝します::
+
+  bzr commit -m "Fix bug #11"
+  (damn - wrong bug number)
+  bzr uncommit
+  bzr commit -m "Fix bug #1"
+
+コミットを取り消す別の理由は1つもしくは複数のファイルの追加を忘れたからというものです 。
+これを避けるために、未知のファイルがツリーの中で見つかるとコミットがエラーになるように
+``commit`` を ``commit --strict`` のエイリアスにする人もいます。
+
+注: ``merge`` コマンドは次の章まで紹介しませんが、
+``uncommit`` で追加するマージをリストアすることは無意味です。
+(``uncommit`` の後で ``bzr status`` を実行するとこれらが表示されます)
+``merge`` は履歴の前の方の指定したコミットだけを効率良く取り消すためにも使われます。
+``merge`` に関する詳細な情報は
+次の章の `変更をマージする <merging_changes.html>`_
+とBazaarのユーザーリファレンスを参照してください。
+
+複数のコミットを取り消す
+------------------------
+
+複数のコミットを取り消すためには -r オプションを使います::
+
+  bzr uncommit -r -3
+
+これを行うための理由が本当にいくつかの変更を破棄したいのであるなら、
+``uncommit`` は作業ツリーを変更しないことを覚えておいてください:
+タスクを完了させることと同じようにおそらく ``revert`` コマンドを実行する必要があります。
+しかし多くの場合、履歴をそのままにしておき、最新のよい状態の内容を反映する
+新しいリビジョンを追加する方が間違いなくベターです。
+
+過去のバージョンの状態に戻す
+-----------------------------
+
+望まない変更を行ったが、コードがユーザーに公開されているのでコミットの取り消しが合理的ではない場合、
+作業ツリーを望む状態に戻すために ``revert`` を利用できます::
+
+  % bzr commit "Fix bug #5"
+  Committed revision 20.
+  (release the code)
+  (hmm - bad fix)
+  bzr revert -r 19
+  bzr commit -m "Backout fix for bug #5"
+
+この作業によってツリー全体をリビジョン19の状態に変更します。
+それ以降は新しいコミットをしていなければおそらくこれがあなたのしたい唯一のことです。
+そうであれば、 ``revert`` はこれらをきれいに消去します。
+この場合、わるい修正を取り消す代わりに
+`リバースチェリーピッキング <advanced_merging.html#reverse-cherrypicking>`_
+を使う方がよいでしょう。
+
+注: 19のような絶対的なリビジョン番号の代わりに、
+負の数を使ってチップ(-1)と相対的なリビジョンを指定できます::
+
+  bzr revert -r -2
+
+タグを訂正する
+----------------
+
+早まってタグを定義したのなら、
+``tag`` コマンドの ``--force`` オプションを使って再定義します::
+
+  bzr tag 2.0-beta-1
+  (oops, we're not yet ready for that)
+  (make more commits to include more fixes)
+  bzr tag 2.0-beta-1 --force
+
+タグをクリアする
+-----------------
+
+タグを定義したが使いたくないのであれば、削除するために、
+``tag`` コマンドの ``--delete`` オプションを使うことができます::
+
+  bzr tag 2.0-beta-4
+  (oops, we're not releasing a 4th beta)
+  bzr tag 2.0-beta-4 --delete
+

=== added file 'doc/ja/user-guide/using_aliases.txt'
--- doc/ja/user-guide/using_aliases.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/using_aliases.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,55 @@
+エイリアスを利用する
+====================
+
+エイリアスとは？
+-----------------
+
+エイリアスは良く入力するコマンド用のショートカットを作る
+もしくはコマンド用のデフォルトを設定するための手軽な方法です。
+
+エイリアスを定義する
+---------------------
+
+コマンドのエイリアスは ``bazaar.conf`` ファイルの ``[ALIASES]`` セクションで定義されます。
+エイリアスはエイリアスの名前で始まり、等号(=)、コマンド列が続きます。
+次のコードはALIASESセクションの例です::
+
+    [ALIASES]
+    recentlog=log -r-3..-1
+    ll=log --line -r-10..-1
+    commit=commit --strict
+    diff=diff --diff-options -p
+
+上記の例の説明は次のとおりです:
+
+ * 最初のエイリアスは最新の3つのリビジョンに対するログを表示する新しい ``recentlog`` コマンドを作ります
+ *  ``ll`` エイリアスは行形式で最新の10件のログエントリを表示します。
+ *  ``commit`` エイリアスはツリーの中の新しいファイルが認知されない場合コミットを拒絶するデフォルトのcommitを設定します。
+ *  ``diff`` エイリアスは -pオプションをdiffに追加します
+
+定義したエイリアスを利用する
+-----------------------------
+
+上記で定義されたエイリアスは次のように使われます: ::
+
+   % bzr recentlog
+   % bzr ll
+   % bzr commit
+   % bzr diff
+
+エイリアスのためのルール
+-------------------------
+
+ * コマンドライン上で新しいオプションを指定することでエイリアスに渡されるオプションの一部をオーバーライドできます。
+   たとえば、 ``lastlog -r-5..`` を実行すると 10の代わりに行ベースのログエントリが5つだけ得られます。
+   すべての論理値型のオプションは暗黙的に逆のオプションがあるので、 ``commit --no-strict`` でcommitのエイリアスをオーバーライドできます。
+
+ * エイリアスの名前をオリジナルのコマンドと同じものにすることでエイリアスは既存のコマンドの標準のふるまいをオーバーライドできます。
+   たとえば、デフォルトのコミットは ``commit=commit --strict`` で変更されます。
+
+ * エイリアスは他のエイリアスを参照できません。言い換えると エイリアスの ``lastlog`` を作りそれを ``ll`` で参照しても動作しません。
+   これは標準のコマンドをオーバーライドするエイリアスを含みます。
+
+ * 　 ``--no-aliases`` オプションをbzrのコマンドに渡すと実行時にエイリアスは無視されます。
+   たとえば、 ``bzr --no-aliases commit`` を実行すると ``commit --strict`` ではなく標準のcomitコマンドが実行されます。
+

=== added file 'doc/ja/user-guide/using_checkouts.txt'
--- doc/ja/user-guide/using_checkouts.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/using_checkouts.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,97 @@
+チェックアウト機能を利用する
+============================
+
+ブランチをチェックアウトに変更する
+-----------------------------------
+
+ローカルのブランチを作りチェックアウトに変更したいのであれば、
+``bind`` コマンドを使います::
+
+  bzr bind sftp://centralhost/srv/bzr/PROJECT/trunk
+
+たとえば以前のセクションで説明されたように ``push`` を使って集中型の\
+ブランチを作った後でこれは必要です。
+
+これをした後は、コミットはローカルに適用される前にバインドした\
+ブランチに適用されます。
+
+チェックアウトをブランチに変更する
+----------------------------------
+
+チェックアウトを通常のブランチに変更したい場合、 ``unbind``
+コマンドを使います::
+
+  bzr unbind
+
+この後で、コミットはローカルのみに適用されます。
+
+チェックアウトを入手する
+-------------------------
+
+集中型のブランチを利用してチームで作業するとき、1人の人物が以前の\
+セクションで示される初期の内容を提供する必要があります。
+その後は、それぞれの個人が ローカルのチェックアウト、すなわち\
+彼らが変更を行うサンドボックス、を作るために ``checkout``
+コマンドを使用します。
+
+SubversionとCVSと異なり、Bazaarでは ``checkout`` コマンドは最新の内容を\
+保持している作業ツリーを作るのに加えて履歴のローカルな全コピーを作ります。
+``diff`` や ``log`` といったオペレーションは速く中心位置から接続していない\
+ときも利用できることを意味します。
+
+.. _getting-a-lightweight-checkout:
+
+軽量チェックアウトを入手する
+-----------------------------
+
+Bazaarはバージョン履歴を効率的に保存するために役立つ一方で、\
+履歴が望まれていないときがあります。
+たとえば、チームがBazaarを利用して集中型でウェブサイトの内容を\
+管理している場合、公開ウェブサーバー上の内容のチェックアウトを\
+更新するのと同じぐらいリリースプロセスは単純です。
+この場合、次の理由からその場所にダウンロードする履歴は望まないでしょう:
+
+ * 必要のない履歴を保有することでディスクスペースを無駄遣いする
+ * 秘密を維持したいBazaarブランチを公開する
+
+Bazaarで履歴のないチェックアウトを入手するには、
+``--lightweight`` オプションを使います::
+
+  bzr checkout --lightweight sftp://centralhost/srv/bzr/PROJECT/trunk
+
+もちろん、これによって通常のチェックアウトの多くの利点は失われますが、
+役に立つ場合と時を選ぶトレードオフです。
+``--lightweight`` オプションは、すべてのブランチではなくチェックアウト\
+のみに適用されます。
+
+注: コードベースが実際に大きくコンピュータ上のディスクスペースが限られている場合、
+`共用リポジトリ  <branching_a_project.html#a-reminder-about-shared-repositories>`_,
+`スタックブランチ <stacked.html>`_,
+`チェックアウトを再利用する <reusing_a_checkout.html>`_
+を含めたすべてのオプションを必ず考えてください。
+
+
+最新の内容に更新する
+---------------------
+
+ロックステップでの他の人との連携の重要な面の1つはあなたのチェックアウトを\
+集中型のブランチで行われた最新の変更に更新し続けることです。
+SubversionもしくはCVSで行うように、Bazaarでは ``update`` コマンドを使用して\
+次のように行います::
+
+  bzr update
+
+ブランチに結びつけられたブランチで利用可能な新しいリビジョンを入手して\
+もしあればローカルの変更をマージします。
+
+コミットの失敗を扱う
+---------------------
+
+``commit`` を実行する前にチェックアウトを最新にしなければならないことに注意してください。
+Bazaarはこの点でSubversionもしくはCVSよりも厳密です - 変更したファイルだけでなく\
+すべてのツリーを最新にする必要があります。
+Bazaarはあなたが最後に更新した後で中心位置にリビジョンが追加されたことを検出すると
+``update`` を実行するようにあなたに頼みます。
+
+バインドされたブランチへのネットワーク接続が失われると、コミットは失敗します。
+いくつかの代替の次善策は次のセクションで説明します。

=== added file 'doc/ja/user-guide/using_gatekeepers.txt'
--- doc/ja/user-guide/using_gatekeepers.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/using_gatekeepers.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,42 @@
+ゲートキーパーを利用する
+=========================
+
+分散型の人間のゲートキーパーのワークフロー
+-------------------------------------------
+
+このワークフローでは、1人の開発者(ゲートキーパー) がメインブランチへの\
+コミット権限を持つ一方で他の開発者はリードオンリーの権限のみを持ちます。
+すべての開発者はタスクブランチの中で変更を行います。
+
+.. image:: images/workflows_gatekeeper.png
+
+開発者は彼らの作業内容をマージしたいとき、ゲートキーパーに彼らの変更を\
+レビューして受け入れ可能であればマージするよう頼みます。
+変更がレビューを失敗するとき、準備ができるまで関連のタスクブランチで\
+さらなる開発が進みます。
+
+このアプローチの主要な面は含まれる制御の反転です:
+開発者は変更を中心ブランチに"コミット/プッシュ"するときを決めなくて済みます:
+コードベースはゲートキーパーの "マージ/プル" による統制された変更方法によって発展します。
+複数の中心ブランチとそれぞれ異なるゲートキーパーをを持つことはとてもよい方法で、
+よく採用されている方法です。。
+たとえば、現在の製品リリースと次のリリースのためにそれぞれ1つづつのブランチがあります。
+この場合、たいがいはバグ修正を保持するタスクブランチは両方のゲートキーパーによって\
+通知されます。
+
+このワークフローのすばらしい点の一つはスケーラブルであることです。
+大きなプロジェクトはチームになりそれぞれのチームはゲートキーパーによって管理される
+*ローカルマスターブランチ* を持つことができます。
+チームリーダーがリクエストするときにチームのマスターブランチからの変更を\
+プライマリマスターブランチにマージするために誰かを主席ゲートキーパーに任命できます。
+
+分散型の自動ゲートキーパーのワークフロー
+-----------------------------------------
+
+より高い品質を得るために、すべての開発者は変更を回帰テストスイートが通ったら\
+変更のマージとコミットだけを行う自動ゲートキーパーに投稿できることが求められます。
+このようなゲートキーパーの1つはPQMと呼ばれるソフトウェアツールです。
+
+.. image:: images/workflows_pqm.png
+
+PQMに関する詳細な情報に関しては、 https://launchpad.net/pqm を参照してください。

=== added file 'doc/ja/user-guide/version_info.txt'
--- doc/ja/user-guide/version_info.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/version_info.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,97 @@
+バージョンの情報をエクスポートする
+==================================
+
+最新のリビジョン番号を得る
+--------------------------
+
+ビルドスクリプトの中で最新のリビジョン番号だけが必要な場合、 ``revno`` コマンドを使用できます::
+
+  $ bzr revno
+  3104
+
+
+詳細なバージョン情報を得る
+---------------------------
+
+最新バージョンに関する詳細な情報を出力するには ``version-info`` コマンドを使用できます::
+
+  $ bzr version-info
+  revision-id: pqm@pqm.ubuntu.com-20071211175118-s94sizduj201hrs5
+  date: 2007-12-11 17:51:18 +0000
+  build-date: 2007-12-13 13:14:51 +1000
+  revno: 3104
+  branch-nick: bzr.dev
+
+オペレーティングシステムツールもしくはスクリプトを使用して出力を簡単にフィルタリングできます。
+例です(Linux/Unix)::
+
+  $ bzr version-info | grep ^date
+  date: 2007-12-11 17:51:18 +0000
+
+より高度な後処理のためにすべてのリビジョンに関するバージョン情報が必要であれば、
+``--all`` オプションはその情報を実際にダンプします。
+
+
+Pythonのプロジェクト
+--------------------
+
+.. TODO: Figure out how to attach into ``setup.py``
+
+
+プロジェクトファイルをビルドするためにMakefileを使う場合、
+次のようにバージョン情報用のファイルを簡単に生成できます::
+
+  library/_version.py:
+        bzr version-info --format python > library/_version.py
+
+これは3つのディレクトリを含むファイルを生成します:
+
+  * `version_info`: 現在の状態に関する基本情報を含むディレクトリ。
+
+  * `revisions`: コミット時間とコミットメッセージと一緒に、
+    ツリーの履歴の中のすべてのリビジョンのリストを表示するディクショナリ。
+    ``--all`` もしくは ``--include-history`` が提供されない限り、デフォルトではこれは空です。
+    リリースバージョンに含まれる、バグ修正などを追跡したい場合に便利です。
+    しかし多くのプロジェクトに対してこれは必要以上の情報です。
+
+  * `file_revisions`: プロジェクトのすべてのファイルに対する最終修正のリビジョンのリストを示すディクショナリ。
+    これは ``$Id$`` キーワードがCVSで管理されたファイルと同じように使われます。
+    最終修正の日付は ``revisions`` マップで探すことで決定されます。
+    デフォルトではこれは空で、 ``--all`` もしくは ``--include-file-revisions`` によってのみ有効になります
+
+
+別のフォーマットでバージョン情報を得る
+--------------------------------------
+
+任意のフォーマットのバージョン情報を取得するためにBazaarはテンプレートベースの方法をサポートします。
+``version-info`` への ``--custom`` オプションは作業ツリーのステータスに基づいて拡張された変数を含む
+``--template`` 引数を提供することで使用できます。
+
+たとえば、現在のリビジョン番号を含むフォーマットされた文字列を伴うCヘッダーファイルを生成するには::
+
+ bzr version-info --custom \
+      --template="#define VERSION_INFO \"Project 1.2.3 (r{revno})\"\n" \
+      > version_info.h
+
+``{revno}`` は作業ツリーのリビジョン番号に置き換えされます。
+(上記の例があなたのOSで動作しない場合、一行ですべてのコマンドを入力してみてください)
+テンプレートの中で利用できる変数の詳細な情報に関しては、
+Bazaarのユーザーリファレンスの `Version Info`_ を参照してください。
+
+.. _Version Info: ../user-reference/bzr_man.html#version-info
+
+特定の言語でバージョン情報をダンプするために予め定義されるフォーマットはは現在開発段階にあります。
+この領域の要求に関してはメーリングリストで私達開発者に連絡して下さるようお願いします。
+
+チェッククリーン
+-----------------
+
+プロジェクトの内容に関する大抵の情報はリビジョンエントリを読むだけで簡単に決定できます。
+しかしながら、作業ツリーがパッケージされたときにそれが最新であったこと、
+もしくはローカルな修正があったことを知るためには便利です。
+``--all`` もしくは ``--check-clean`` のどちらかを提供することで ``bzr`` は作業ツリーを検査して、
+``version_info`` ``clean`` を設定します。
+同様に ``modified`` が適切である場合に ``file_revisions`` でエントリを設定します。
+
+..
+   vim: tw=74 ft=rst spell spelllang=en_us

=== added file 'doc/ja/user-guide/web_browsing.txt'
--- doc/ja/user-guide/web_browsing.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/web_browsing.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,15 @@
+ウェブブラウジング
+==================
+
+概要
+-----
+
+BazaarのリポジトリをWeb上で閲覧するために利用できる選択肢は幅広くあり、\
+主要なものは Loggerhead です。
+Loggerhead のホームページは https://launchpad.net/loggerhead にあります。
+
+ダウンロードリンクを含めてこれらのパッケージの最新情報に関しては
+http://bazaar-vcs.org/WebInterface を参照してください。
+
+注: プロジェクトがホストされているもしくはLaunchpadでミラーリングされている場合、
+Loggerheadのコードブラウジング機能はサービスの一部として提供されます。

=== added file 'doc/ja/user-guide/working_offline_central.txt'
--- doc/ja/user-guide/working_offline_central.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/working_offline_central.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,50 @@
+オフラインで集中型のブランチに取り組む
+=======================================
+
+集中型のローカルコミットのワークフロー
+---------------------------------------
+
+旅行のためネットワーク接続できない場合、中心サーバーがダウンする、\
+もしくは今は中心位置に公開せずにローカルで変更のスナップショットを\
+記録したいだけなら、このワークフローはそんなあなたのためにあります。
+
+.. image:: images/workflows_localcommit.png
+
+ローカルでコミットする
+-----------------------
+
+チェックアウトで作業していてローカルだけでコミットする必要がある/したい場合、
+``--local`` オプションを ``commit`` コマンドに追加します::
+
+  bzr commit --local
+
+長期間切断する
+---------------
+
+しばらくの間バインドされたブランチから切断をする予定もしくはしたい場合、
+``--local`` をすべての ``commit`` コマンドを追加することを覚えるのは面倒でしょう。
+代わりの方法は チェックアウトを一時的に通常のブランチにするために ``unbind``
+コマンドを用い、後でロックステップの状態に戻りたくなったときに ``bind`` コマンド\
+を使うことです。
+
+``bind`` コマンドはこのブランチがチェックアウトされた最後の時間が結びつけられた\
+場所を覚えるので、前の ``unbind`` の後で ``bind`` を使うときにリモートブランチの\
+URLを入力する必要がないことに留意してください。
+
+ローカルコミットのシリーズをマージする
+---------------------------------------
+
+中心ブランチ上で進行中の開発から独立してローカルでコミットするとき、\
+次回 ``update`` が実行されるときBazaarはこれらを開発の2つのラインとして扱います。
+この場合、 ``update`` は次のことを行います:
+
+ * これはバインドされたブランチからの最新のリビジョンを取り込み、チェックアウトを\
+   メインラインの状態にします。
+
+ * これは最後に更新した以降のローカルな変更を論理的に並行ブランチに移動します
+
+ * これらを一緒にマージするのでローカルの変更は ``status`` によって未解決マージ
+   として報告されます
+
+常に、この後で作業内容を中心ブランチに送信するためには ``commit`` を実行する\
+必要があります。

=== added file 'doc/ja/user-guide/writing_a_plugin.txt'
--- doc/ja/user-guide/writing_a_plugin.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/writing_a_plugin.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,59 @@
+.. _writing-a-plugin:
+
+プラグインを書く
+================
+
+導入
+-----
+
+プラグインはbzrのコア機能ととてもよく似ています。
+これらはbzrlibから何でもインポートできます。
+プラグインは標準機能を上書きすることもできますが、大抵プラグインは\
+新しいコマンドを提供します。
+
+.. _creating-a-new-command:
+
+新しいコマンドを作る
+---------------------
+
+コマンドを書くには、
+``bzrlib.commands.Command`` を継承する新しいオブジェクトを作り、 ``cmd_foo`` と命名します。
+fooはコマンドの名前です。
+名前にアンダースコアが含まれるコマンドを作ると、UIではアンダースコアはハイフンとして表示されます。
+たとえば、 `cmd_baz_import` は `baz-import` として表示されます。
+コマンドの書き方の実例に関しては、 ``builtins.py`` を参照して頂くようお願いします。
+
+コマンドを作成したらファイルがインポートされるときに
+``bzrlib.commands.register_command(cmd_foo)`` でコマンドを登録しなければなりません。
+さもなければbzrはコマンドを見つけることはありません。
+
+.. _specifying-a-plugin-version-number:
+
+プラグインのバージョン番号を指定する
+-------------------------------------
+
+プラグインのバージョン番号を定義するにはタプルで ``version_info`` を定義します。例：
+``version_info = (0, 9, 0)``
+``version_info = (0, 9, 0, 'dev', 0)``
+
+.. _plugin-searching-rules:
+
+プラグインの検索ルール
+------------------------
+
+デフォルトではbzrはプラグインを見つけるために ``bzrlib/plugins`` と ``~/.bazaar/plugins`` をスキャンします。
+``BZR_PLUGIN_PATH`` でこれを上書きできます。
+プラグインはモジュールもしくはパッケージの形態をとることができます。
+プラグインが単独のファイルであれば、構造をモジュールにできます。
+プラグインが複数のファイルを持つ場合やbzrのブランチとして配布したい場合は、
+構造をパッケージ、すなわち、ディレクトリの中に ``__init__.py`` を含めます。
+
+
+詳しい情報
+-----------
+
+他の人にも役立つと考えましたら、プラグインをBzrToolsにお気軽に寄付してください。
+
+Bazaarの開発ガイドラインと方針の詳細に関しては `Bazaar開発者ガイド`_ を参照してください。
+
+.. _Bazaar開発者ガイド: ../developer-guide/HACKING.html

=== added file 'doc/ja/user-guide/zen.txt'
--- doc/ja/user-guide/zen.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-guide/zen.txt	2009-10-29 10:01:19 +0000
@@ -0,0 +1,195 @@
+Bazaarの哲学
+============
+
+Bazaarを完全に理解する
+-----------------------
+
+Bazaarは多くの点で他のVCSに似ていますが、最初見たときに必ずしも明らかではない大きな違いがいくつかあります。
+このセクションでは Bazaarを"grok"するため、すなわち深く理解するために、
+ユーザーが知る必要のあるいくつかの内容の説明を試みます。
+
+注: Bazaarを使うためにこのセクションを十分に理解する必要はありません。
+このセクションをさっと読んで後で戻るとよいでしょう。
+
+リビジョン番号を理解する
+------------------------
+
+ブランチのメインラインのすべてのリビジョンは単純に増加する整数を持ちます(最初のコミットは1、10番目のコミットは10などです)。
+これによって "私のブランチから10番目のリビジョンを獲得する"、もしくは "リビジョン3050で修正した" という言い方が自然になります。
+
+ブランチにマージされるリビジョンに関しては、ドットつきのバージョンが使われます(たとえば、3112.1.5)。
+ドットつきのリビジョン番号は3つの番号を持ちます [#]_.
+最初の番号はメインのリビジョンの変更の由来を示します。
+2番目の番号はブランチのカウンターです。
+同じリビジョンから多くのブランチが由来することがあり得るので、それらのブランチはユニークな番号を取得します。
+3番目の番号はブランチの開始以降のリビジョン番号です。
+たとえば、3112.1.5はリビジョン3112からの最初のブランチで、そのブランチ上の5番目のリビジョンです。
+
+.. [#] バージョン1.2以前のbzrでは少し異なるアルゴリズムが使われていました。
+   いくつかの入れ子のブランチはよりシンプルな3つの番号システムではなく追加の番号(たとえば1.1.1.1.1)を取得します。
+
+階層形式の履歴はよいものである
+-------------------------------
+
+多くの変更が一連のコミットで構成される状況で複数の開発者が変更を投稿するプロジェクトを想像してください。
+具体例を示すために、次の事例を考えてみましょう:
+
+ * プロジェクトのトランクのチップはリビジョン100です。
+ * Maryは機能Xを配信するために3つの変更を行う
+ * Billは機能Yを配信するために4つの変更を行う
+
+開発者が並行して作業して伝統的な集中型のVCSのアプローチを利用する場合、
+大抵の場合プロジェクトの履歴は次のようにMaryの変更とBillの変更が交互に混ざります::
+
+  107: Add documentation for Y
+  106: Fix bug found in testing Y
+  105: Fix bug found in testing X
+  104: Add code for Y
+  103: Add documentation for X
+  102: Add code and tests for X
+  101: Add tests for Y
+  100: ...
+
+多くのチームはこのアプローチを利用します。彼らのツールではブランチの作成とマージが難しいからです。
+結果として、開発者はトランクからの更新とコミットを頻繁に行い、すべてのコミットを通してそれを広げることで統合の苦痛を最小化します。
+望むのであれば、このようにBazaarを使うことができます。
+Bazaarは考慮すべき別の方法を提供します。
+
+分散型のVCSツールによって推奨される代替のアプローチは機能ブランチを作り、準備ができたらそれらを統合することです。
+この場合、Maryの機能ブランチは次のようになります::
+
+  103: Fix bug found in testing X
+  102: Add documentation for X
+  101: Add code and tests for X
+  100: ...
+
+そしてBillのものは次のようになります::
+
+  104: Add documentation for Y
+  103: Fix bug found in testing Y
+  102: Add code for Y
+  101: Add tests for Y
+  100: ...
+
+機能が独立していてリニアな履歴を維持したいのであれば、変更はバッチでトランクにpushされます。
+(技術的には、これを行う方法は無数にありますがこの検討内容の範囲を超えます。)
+結果の履歴は次のようになります::
+
+  107: Fix bug found in testing X
+  106: Add documentation for X
+  105: Add code and tests for X
+  104: Add documentation for Y
+  103: Fix bug found in testing Y
+  102: Add code for Y
+  101: Add tests for Y
+  100: ...
+
+これを実現するために少し努力が必要な一方で、リビジョンをランダムに織り交ぜるよりもいくつかの利点があります。
+よりベターですが、non-linearな履歴を形成してブランチは一緒にマージできます。
+結果は次のようになります::
+
+  102: Merge feature X
+       100.2.3: Fix bug found in testing X
+       100.2.2: Add documentation for X
+       100.2.1: Add code and tests for X
+  101: Merge feature Y
+       100.1.4: Add documentation for Y
+       100.1.3: Fix bug found in testing Y
+       100.1.2: Add code for Y
+       100.1.1: Add tests for Y
+  100: ...
+
+もしくは次のようになります::
+
+  102: Merge feature X
+       100.2.3: Fix bug
+       100.2.2: Add documentation
+       100.2.1: Add code and tests
+  101: Merge feature Y
+       100.1.4: Add documentation
+       100.1.3: Fix bug found in testing
+       100.1.2: Add code
+       100.1.1: Add tests
+  100: ...
+
+多くの理由からこれはよいものと考えられます:
+
+ * プロジェクトの履歴を理解するのが楽になります。
+   関連した変更はクラスターを形成し明確に区切られます。
+
+ * ブランチのメインライン上のコミットだけを見るために履歴を簡単に折りたたむことができます。
+   (このレベルでは興味のない膨大な数のコミットの代わりに)
+   このようなトランクの履歴を閲覧するとき、高いレベルのコミットだけ見えます。
+
+ * 必要であれば、より簡単に機能の変更を取り消します
+
+ * 継続的インテグレーション(Continuous integration: CI)ツールは
+   マージをメインラインにコミットするためにすべてのテストが合格することを保証するために使われます。
+   (多くの場合、すべての単独のコミットの後でCIツールの引き金を引くのは適切ではありません。
+   テストの中には開発の間に失敗するものがあるからです。
+   実際、テストファーストの追加 - テスト駆動開発(TDD)のスタイル - によってこれが保証されます！)
+
+要約すると、重要な点は次のとおりです:
+
+  *ブランチを利用してあなたの作業内容を編成する*
+
+  *マージ機能を利用して変更を統合する*
+
+  *順序つきの番号と階層によって履歴を追跡するのが楽になる*
+
+
+それぞれのブランチは履歴の独自のビューを持つ
+---------------------------------------------
+
+上述のように、Bazaarは次の内容を区別します:
+
+ * メインラインのリビジョン、すなわちブランチにコミットしたもの
+
+ * マージしたリビジョン、マージをコミットすることで祖先として追加されるもの
+
+それぞれのブランチは効率的に履歴の独自ビューを持ち、すなわち、
+異なるブランチは同じリビジョンに異なる"ローカルな"リビジョン番号を与えます。
+
+マージされたリビジョンは常にドットつきのリビジョン番号を入手するのに対して
+メインラインのリビジョンは常に単独の数字のリビジョン番号が割り当てられます。
+
+上記の例を拡張するためには、Maryが変更を完了させた後でプロジェクトのトランクにマージした後に
+Maryのブランチのリビジョンの履歴は次のようになります::
+
+  104: Merge mainline
+       100.2.1: Merge feature Y
+       100.1.4: Add documentation
+       100.1.3: Fix bug found in testing
+       100.1.2: Add code
+       100.1.1: Add tests
+  103: Fix bug found in testing X
+  102: Add documentation for X
+  101: Add code and tests for X
+  100: ...
+
+繰り返しますが、Maryはこの変更を開発するためにステップを見るために彼女の履歴のトップレベルを調べることが簡単になります。
+この文脈では、トランクのマージ(とそれを行うことによる衝突の解消)はこのブランチの履歴に関しては単なる1つのステップです。
+
+Bazaarは履歴を変更するのでなければグローバルなリビジョン識別子を変更するのでもないことを覚えておくのは大事です。
+本当に望むのであれば常に後者を使用できます。
+実際、ブランチのURLをコンテクストとして提供する *限り* コミュニケーションをするときに特定のリビジョン番号を使うことができます。
+(多くのBazaarのプロジェクトでは、開発者はブランチURLなしでリビジョン番号を交換するとき中心のトランクのブランチをほのめかします)
+
+マージはブランチのリビジョン番号を変更しません。それらはローカルのリビジョン番号を新しくマージしたリビジョンに割り当てるからです。
+Bazaarがブランチのリビジョン番号を変更する唯一のときはあなたが明示的に別のブランチをミラーリングするように頼むときです。
+
+注: リビジョンは安定した方法で番号づけされます: 2つのブランチがメインラインで同じリビジョン番号を持つとき、
+そのリビジョンの祖先のすべてのリビジョンは同じリビジョン番号を持ちます。
+たとえば、AliceとBobのブランチがリビジョン10に一致するのであれば、それらはそれ以前のすべてのリビジョンで一致します。
+
+要約
+-----
+
+一般的に、前に示されたアドバイスに従うのであれば - ブランチの中で作業し、\
+連携するためにマージを使う -
+Bazaarが一般的にあなたが期待することを行うことがわかります。
+
+次の章では、Bazaarを利用したさまざまな方法: もっとも単純なプロジェクト、個人プロジェクトなどを試します。
+
+..
+   vim: ft=rst tw=74 ai

=== added directory 'doc/ja/user-reference'
=== added file 'doc/ja/user-reference/index.txt'
--- doc/ja/user-reference/index.txt	1970-01-01 00:00:00 +0000
+++ doc/ja/user-reference/index.txt	2009-12-02 20:34:07 +0000
@@ -0,0 +1,3853 @@
+.. This file is autogenerated from the output of
+..     bzr help topics
+..     bzr help commands
+..     bzr help <cmd>
+..
+.. Generation time: 2009-01-09 07:03:09 +0000
+
+##########################
+Bazaarユーザーリファレンス
+##########################
+
+:Version:   1.11
+:Generated: 2009-01-09
+
+.. contents:: :depth: 2
+
+-----
+
+このチュートリアルについて
+##########################
+
+このマニュアルはBazaarのオンラインヘルプから生成されました。オンラインヘルプのシステムを
+利用するためには次のコマンドを試してください。
+
+    よく使われるコマンドの一覧を含めて紹介します::
+
+        bzr help
+
+    トピックの一覧とそれぞれの要約::
+
+        bzr help topics
+
+    コマンドの一覧とそれぞれの要約::
+
+        bzr help commands
+
+    特定のトピックもしくはコマンドに関する詳細な情報::
+
+        bzr help topic-or-command-name
+
+次のウェブサイトはBazaarに関する詳細な情報を提供します:
+
+:ホームページ:                     http://www.bazaar-vcs.org/
+:公式ドキュメント:                 http://doc.bazaar-vcs.org/
+:Launchpad:                     https://launchpad.net/bzr/
+
+概念
+####
+
+ブランチ
+=========
+
+ブランチは、すべての履歴を含む、プロジェクトの状態で構成されます。
+すべてのブランチは関連づけされたリポジトリ(ブランチの履歴が保存される場所)を持ちますが、
+複数のブランチは同じリポジトリを共有することもあります(共用リポジトリ)。
+ブランチはコピーしたりマージしたりできます。
+
+関連コマンド::
+
+  init    ディレクトリをバージョン管理されたブランチに変更する。
+  branch  ブランチの新しいコピーを作成する。
+  merge   3方向マージ (3-way merge) を実行する。
+
+
+チェックアウト
+==============
+
+チェックアウトはブランチに結びつけられたソースツリーなので、
+ソースツリーにコミットするときに、コミットの内容はブランチに格納されます。
+必要になるまでBazaarの分散型機能の一部を無視して、よりシンプルに、集中型のワークフローを利用できます。
+共用リポジトリでチェックアウトを利用することはSVNもしくはCVSでの作業とよく似ていますが、同じ制限を持ちません。
+そしてチェックアウトを利用することで望むワークフローがなんであれ他の人もプロジェクトに取り組むことができます。
+
+チェックアウトはbzr checkoutコマンド("help checkout"を参照)によって作成されます。
+これに別のブランチへのリファレンスを渡し、マスターブランチからのチェックアウトを作成したブランチへのリファレンスを
+まだ含むローカルコピーを作成します。
+
+何かコミットをすればこれらは他のブランチで最初に作成されます。
+これによって作業内容のインスタントミラーが作成されるもしくは
+それぞれの開発者が共同で作業して他の人の変更を継続的に統合するロックステップ開発を円滑にします。
+
+しかしながらチェックアウトはまだBazaarの第一級のブランチで、すべての履歴をローカルで保存できます。
+第一級のブランチがあるので、ローカルにコミットすることもできます。
+たとえば、ネットワーク接続による一時的な遅延を回避したいのであれば、ローカルでもコミットできます。
+これを行うには --local オプションを使います。
+次にローカルではないコミットを行うときにすべてのローカルコミットはマスターブランチに行われます。
+
+共用ブランチからのチェックアウトを使用しているとき、周期的に他の人による変更をすべてpullしたくなります。
+これは"update"コマンドによってできます。
+ローカルではないコミットの前に変更が適用される必要がありますが、
+Bazaarは変更が存在することを伝え必要なときにこのコマンドを使うように提示します。
+
+checkoutコマンドに--lightweightフラグを渡すことで"軽量"チェックアウトを作成することも可能です。
+第一級のブランチではなく、主に作業ツリーで構成されるという点で、軽量チェックアウトはSVNのチェックアウトにより近いです。
+履歴のオペレーションはマスターブランチに問い合わせをしなければならないので、
+ネットワーク接続が関わる場合遅くなる可能性があることを意味します。
+また、ローカルブランチを持たないので、ローカルでコミットできません。
+
+マスターブランチに高速で信頼性のあるアクセス権限があるときに軽量チェックアウトは最も良く動作します。
+マスターブランチが同じディスクもしくはLAN上にあれば、(ブランチのコピーの更新だけが必要なので)
+リビジョンを変更するどのコマンドでも軽量ブランチは重量ブランチよりも速くなることを意味します。
+一般的に重量チェックアウトは速いですが、マスターブランチが同じディスク上のあるときは、顕著な違いはありません。
+
+チェックアウトの別の使い方はブランチを格納するツリーなしのリポジトリで使うことです。
+ここでは異なるブランチに取り組むときチェックアウトが指定するマスターブランチを切り替えることで
+1つの作業ツリーだけを維持します。
+
+明確にチェックアウトにコミットするにはマスターブランチへの書き込み権限が必要です。
+マスターブランチはsftp://といった書き込み可能なプロトコルでアクセスしなければならないので、
+相手方で書き込み権限をもたなければならないことを意味します。
+チェックアウトはローカルファイルシステムでも機能するので、すべての問題はファイルのパーミッションです。
+
+"bind"コマンド("help bind"を参照)を使用することでチェックアウトのマスターを変更できます。
+これによってコミットが送信される位置が変更されます。
+bindコマンドはブランチをheavyチェックアウトに変換するためにも使用できます。
+すべてのコミットがローカルで行われるようにheavyチェックアウトを通常のブランチに変換したい場合、
+"unbind" コマンドを使用できます。
+
+関連コマンド::
+
+  checkout    チェックアウトを作成する。軽量チェックアウトを得るには --lightweight を渡す
+  update      マスターブランチの変更をあなたのチェックアウトにpullする
+  commit      マスターブランチに送信されるコミットを行う。
+              重量チェックアウトであれば --localオプションによって
+              マスターにコミットを送信せずにチェックアウトにコミットされます
+  bind        送信されるチェックアウトにコミットされるマスターブランチを変更する
+  unbind      コミットがローカルだけで行われるように重量チェックアウトをスタンドアロンのブランチに変換する
+
+
+クリスクロス
+============
+
+ブランチの履歴のクリスクロス(Criss-cross)は通常期待されるよりも多くのコンフリクトを出すデフォルトのマージテクニックを必要とします。
+
+複雑なマージの場合、 ``bzr merge --lca`` もしくは ``bzr merge --weave`` ではよりよい結果になるかもしれません。
+作業ツリーを ``bzr revert`` して再度マージしたいと願うかもしれません。
+代わりに、特定の衝突しているファイル上で ``bzr remerge`` を使います。
+
+2つのブランチが同じものをマージしてお互いにマージし合う場合、
+もしくは2つのブランチが同時にお互いをマージする場合、クリスクロスはブランチの中で発生します。
+それぞれのブランチが目的の集中型ブランチからもしくはそのブランチからのみマージすることでこれらを回避できます("star topology")。
+
+マージが動作する方法のためクリスクロスは問題を引き起こします。
+Bazaarのデフォルトマージは三方向マージです; OTHERをTHISにマージするには比較、BASE用の基本を見つけなければなりません。
+BASEを利用することで、THISとOTHERの違いが行を追加するワンサイドか、行を削除する別のサイドによるのかを決定できます。
+
+クリスクロスはベースに関してよい選択肢がないことを意味します。
+最近のマージポイントを選択することはワンサイドの変更を少し廃棄してしまう可能性があります。
+(Bazaarが行う)古いマージポイントを選択することは余分な衝突が発せられることを意味します。
+
+``weave`` マージタイプはこの問題の影響を受けません。
+このタイプは違いの原因を決定するためにベースのリビジョンの代わりに行を起点とする検出方法を利用するからです。
+
+
+ストレージフォーマット
+=======================
+
+古いクライアントが不正にデータにアクセスしないことを保証するために、
+Bazaarのポリシーでは新しい機能が新しいメタデータを追加する必要があるときに
+新しいフォーマットを導入することにしています。新しいストレージフォーマットは
+パフォーマンスとスケーラビリティを改善するために導入することもあります。
+
+フォーマットを選ぶために次のガイドラインを利用します(条件がtrueであると同時に停止):
+
+* 既存のプロジェクトに取り組んでいる場合、プロジェクトが利用しているものを使用します。
+  (デフォルトでBazaarはあなたの代わりにこれを行います)。
+
+* Subversionリポジトリと連携するbzr-svnを利用している場合は、
+  1.9-rich-rootを使用します。
+
+* 大きなツリー(5000以上のパス)もしくは深い履歴(5000以上のリビジョン)を持つ
+  プロジェクトに取り組んでいるのであれば、1.9を使用します。
+
+* さもなければ、デフォルトのフォーマットを使用します。大抵のプロジェクトはこれで十分です。
+
+(ディストロのパッケージを利用しているなどで)最新のBazaarを利用できない開発者がいるのであれば、
+それに応じてガイドラインを調整してください。
+たとえば、プロジェクトがBazaar 1.7を標準化している場合、1.9の代わりに1.6を選ぶことが必要です。
+
+注: 現在サポートされるフォーマットの多くは2つのバリアントを持ちます:
+plainのものとrich-rootのものです。
+後者はツリーのrootに関する追加フィールドを含みます。
+rich-rootフォーマットを利用する際にパフォーマンスコストはありませんが
+rich-rootフォーマットからの変更をplainフォーマットに簡単にマージできません。
+結果として、すべての投稿者がほぼ同時にリポジトリをアップグレードする必要があるので、
+プロジェクトをrich-rootフォーマットに移行させるには調整が必要です。
+(これまでのところrich-rootフォーマットをデフォルトにすることを遅らせてきた理由です。
+将来の適切な時期にこれを行います。)
+
+現在サポートされるフォーマットの完全なリストに関しては ``bzr help current-formats`` を参照してください。
+利用可能で実験上もしくは廃止されたフォーマットに関しては ``bzr help other-formats`` を参照してください。
+
+
+パターン
+========
+
+Bazaarはさまざまな時点でマッチするファイルを使用します。
+たとえば、 ``add`` コマンドは無視するパターンにマッチするファイルとスキップし
+プリファレンスはルールパターンを使用するファイルに関連づけできます。
+パターン構文は下記のとおりです。
+
+パターン上のトレーリングスラッシュは無視されます。
+パターンがスラッシュを含むもしくは正規表現である場合、ブランチのroot全体から比較されます。
+さもなければ、これはパスの最後のコンポーネントのみと比較されます。
+rootディレクトリの中のファイルのみにマッチさせるには'./'を用意します。
+絶対パスを指定するパターンは許可されていません。
+
+パターンは次のようなglobのワイルドカードを含むことができます::
+
+  ? - '/'以外の単独文字にマッチする
+  * - '/'以外の0かそれ以上の文字数にマッチする
+  /**/ - パスの中のゼロかそれ以上のディレクトリにマッチする
+  [a-z] - 文字のグループの範囲内からの単独の文字にマッチする
+
+パターンはPythonの正規表現にもなります。
+正規表現のパターンは 'RE:' の接頭辞で始まる正規表現で識別されます。
+正規表現のパターンは名前つきもしくは番号つきのグループを含むことはできません。
+
+
+リポジトリ
+===========
+
+Bazaarのリポジトリはコミットされた情報が保存される場所です。
+すべてのブランチと関連づけされたリポジトリが1つ存在します。
+
+リポジトリは一種のデータベースです。
+通常、パフォーマンスのためにBzrはこれを自動的に維持しますが、ある状況(たとえば短い期間にとても多くのコミットを行う)
+
+データベースのインデックスを最適化するようbzrに求めるとよいでしょう。
+これは'bzr pack' コマンドによって行われます。
+
+デフォルトでは 'bzr init' を実行するだけで新しいブランチの中でリポジトリが作成されますが、
+同じ位置で情報を共有するために複数のブランチを許可する共用リポジトリを作成することが可能です。
+新しいブランチが作成されたとき使用できる共用リポジトリが存在するかどうかを最初に確認します。
+
+同じプロジェクトのブランチが1つのリポジトリを共有するとき、一般的にスペースが大きく節約されます。
+(たとえばリポジトリの範囲内でブランチを作成するなどの)いくつかのコマンドに対してこれは大きな時間の節約になります。
+
+共用リポジトリを作るには、init-repositoryコマンド(もしくはエイリアスのinit-repo)を使います。
+このコマンドは作成するリポジトリの位置をとります。
+このことは'bzr init-repository repo'によって'repo'という名前のディレクトリが作成され
+その中に共用リポジトリが格納されることを意味します。
+このディレクトリの中に作成された新しいブランチはストレージ用にそれを使用します。
+
+1つ以上のプロジェクトのブランチを作成するときに1つのリポジトリを作成することはよい考えです。
+これは開発を行っている作業領域と、ホスティングプロジェクト用のサーバー領域の両方にあてはまります。
+後者の場合、作業ツリーなしのブランチが欲しいことは良くあります。
+ブランチのファイルは直接編集されないので作業ツリー用にディスクスペースを使い切る必要はありません。
+作業ブランチを持たないリポジトリを作成するには、 'init-repository'に'--no-trees'オプションを渡します。
+
+関連コマンド::
+
+  init-repository   共用リポジトリを作成する。
+                    新しいブランチが作業ツリーを作成しないものを作成するには--no-treesを使用する。
+
+
+ルール
+=======
+
+紹介
+-----
+
+ルールはiniファイルフォーマットで定義されます。
+セクションはファイルのglobパターンでそれぞれのセクションの内容は
+そのパターンにマッチするファイル用のプリファレンスです。例です::
+
+    [name *.bat]
+    eol = dos
+
+    [name *.html]
+    keywords = escape
+
+これらのようなプリファレンスは選択されたブランチの中で
+選択されたファイル用にカスタムのふるまいを提供したいコマンドとプラグインに役立ちます。
+
+
+ファイル
+---------
+
+すべてのブランチ用のデフォルトルールはオプションの ``BZR_HOME/rules`` ファイルで定義されます。
+
+ルールのパターン
+-----------------
+
+パターンは順序づけされ1つマッチすると共に検索は停止します。
+結果として、より明確なパターンをファイルのトップの方に置くべきです。
+ルールパターンは無視パターンとまったく同じ仕様を利用します。
+詳細は ``bzr help patterns`` を参照してください。
+
+注: 角かっこを含むパターンはそれらが正しく解析されるようにクォートで囲まなければなりません。
+
+
+スタンドアロンのツリー
+=======================
+
+スタンドアロンのツリーは関連リポジトリを持つ作業ツリーです。
+他に依存していないので、これは独立して利用できるブランチです。
+(bzr initを通して)スタンドアロンのツリーの作成は
+既存のプロジェクトをバージョン管理の元に置くための最も速い方法です。
+
+関連コマンド::
+
+  init    ディレクトリをバージョン管理下にあるブランチにする。
+
+
+同期化がずれているブランチ
+==========================
+
+チェックアウト、ツリーもしくはブランチを軽量ブランチに再設定するとき、
+ローカルのブランチを破壊しなければなりません。
+(チェックアウトに関して、これはキャッシュとして最初に提供するローカルブランチです。)
+破壊されるブランチが同じ最終リビジョンを持たなければ、
+軽量用チェックアウト用の新しい参照ブランチ、データが失われる可能性があるので、
+Bazaarは拒否します。
+
+この取り組み方は *なぜ* ブランチの同期がずれるのかによります。
+
+チェックアウトが手元にありローカルコミットを行う場合、
+"bzr update"(とおそらくは"bzr commit")を実行することで再び同期化できます。
+
+ブランチが手元にあり、リモートブランチが時代遅れになっている場合、
+"bzr push"を使用してローカルの変更をプッシュできます。
+ローカルブランチが時代遅れであれば、"bzr pull"をできます。
+両方のブランチに変更があれば、変更をマージ、コミットしてプッシュできます。
+変更の一部が便利でなければ、"push --overwrite"もしくは代わりに"pull --overwrite"できます。
+
+
+作業ツリー
+===========
+
+作業ツリーはディスク上に設置されたブランチのコンテンツなのでファイルを見て編集できます。
+作業ツリーはブランチに変更を行う場所なので、
+作業ツリーの現在の状態をコミットするとき、コミットに記録されるレコードです。
+
+ブランチをリモートシステムにプッシュするとき、作業ツリーは作成されません。
+ファイルがすでに存在すれば、ファイルは更新されません。
+ブランチの情報は更新され作業ツリーは時代遅れとしてマークされます。
+リモートの作業ツリーを更新するのは難しいです。
+アンコミットされた変更が存在するもしくは更新によってリモートで扱うのが難しい内容の衝突が引き起こされるからです。
+
+作業ツリーなしのブランチがあれば 作業ツリーを作成するために 'checkout' コマンドを使用できます。
+ブランチから 'bzr checkout .' を実行すると作業ツリーが作成されます。
+リモートでブランチが更新されると、そのディレクトリの中で'bzr update'を実行することで作業ツリーを更新できます。
+
+望まない作業ツリーを持つブランチがある場合、安全であれば'remove-tree'コマンドはツリーを除外します。
+ブランチにプッシュするとき更新されないリモート作業ツリーに関する警告を回避することでこれは可能です。
+これは'--no-trees'リポジトリ('bzr help repositories'を参照)に取り組むときにも便利です。
+
+プッシュするリモートマシン上で作業ブランチを持ちたい場合、
+pushするごとにリモートブランチで'bzr update'を実行するか、
+pushの間にツリーを更新する他の方法を使用できます。
+rsyncを使用してpushと同じように作業ツリーを更新する'rspush'プラグインが存在します。
+それぞれのプッシュの後で'bzr update'を自動的に実行する'push-and-update'プラグインも存在します。
+
+便利なコマンド::
+
+  checkout     ブランチが作業ツリーを持たないときにそれを作成する。
+  remove-tree  これを行うときに安全であるときにブランチから作業ツリーを除外する。
+  update       作業ツリーが関連ブランチから同期がずれているとき
+               このコマンドによってブランチにマッチするツリーが更新される。
+
+.. _formats: `ストレージフォーマット`_
+.. _standalone-trees: `スタンドアロンのツリー`_
+.. _sync-for-reconfigure: `同期化がずれているブランチ`_
+.. _working-trees: `作業ツリー`_
+
+
+
+リスト
+#######
+
+認証の設定
+===========
+
+
+Intent
+------
+
+``authentication.conf`` ファイルの中で多くの異なる認証ポリシーは記述できますが
+特定のユーザーはすべてのブランチ用のユーザーとパスワードを指定しなくても
+自分のニーズをカバーするわずかな定義だけが必要です。
+
+このファイルの中で見つかる定義は与えられたurl用のクレデンシャルを見つけるために使われます。
+一般的に同じクレデンシャルを必要とするリモートサーバーの周辺で宣言を分類することで可能な限り多くのブランチに対して
+クレデンシャルを使用できます。
+
+異なるサーバーによって使用されるクレデンシャルを宣言することも可能です。
+
+intentは維持を最少にするためにこのファイルを可能な限り小さくするものです。
+
+このファイルの中で関連のクレデンシャルが宣言されるとパスワード(セキュリティハザード)を埋め込まず
+もしくは(他の人とURLの共有を有効にする)ユーザーなしでブランチのURLを利用できます。
+
+次のURLよりも::
+
+  bzr branch ftp://joe:secret@host.com/path/to/my/branch
+
+シンプルになります::
+
+  bzr branch ftp://host.com/path/to/my/branch
+
+``authentication.conf`` ファイルを作成したことを前提とします::
+
+  [myprojects]
+  scheme=ftp
+  host=host.com
+  user=joe
+  password=secret
+
+
+認証の定義
+-----------
+
+bzrによってサポートされるさまざまなスキームによって使用される2種類の認証があります:
+
+1. ユーザーとパスワード
+
+``FTP`` は ``host`` 用に (``user`` 、 ``password``) を必要とします。
+``SFTP`` は認証用にパスワードもしくはホストキーを使用できます。
+しかしながら、sshエージェントはベターで、よりセキュアな解決方法です。
+独自のセキュアではない方法を提供しないことにします。
+
+2. ユーザー、領域とパスワード
+
+ホストに対して認証するために ``HTTP`` と ``HTTPS`` は(``user, realm, password``)を必要とします。
+``.htaccess`` ファイルを利用することで、たとえば、任意の ``host``
+に対して (``user, realm, password``) をいくつか定義することが可能です。
+ですので本当に必要なのは (``user``, ``password``, ``host``, ``path``)です。
+``realm`` は定義で考慮されませんが、bzrにパスワードを催促される場合表示されます。
+
+``HTTP proxy`` は適切なポートを指定することで ``HTTP`` (もしくは ``HTTPS``) として扱うことができます。
+
+すべてのスキームを考慮するには、パスワードは認証定義の一式 (``scheme``, ``host``, ``port``, ``path``, ``user``, ``password``) から推定されます。
+
+  * ``scheme``: 空にできます (定義の残りは任意のスキームに対して使用できることを意味する)、
+    ``SFTP`` と ``bzr+ssh`` はここでは使うべきではありません。
+    代わりに ``ssh`` が使われるべきです。これが認証に関して本当のスキームだからです。
+
+  * ``host``: 空にできます (ホスト用のデフォルトとして振る舞う),
+
+  * ``port`` は空にできます (ホストが同じスキームに対していくつかのサーバーを提供するときに便利)、
+    数値の値のみが許可され、サーバーがスキームの標準ポートとは異なるポートを使用するときのみにこれは使用されます。
+
+  * ``path``: 空にできます (FTPもしくはSFTPはこれを使用しません),
+
+  * ``user``: 空にできます (デフォルトでは ``bzr`` はpythonの ``getpass.get_user()`` を使用),
+
+  * ``password``: 常にパスワードをプロンプトで入力する方が望ましいのであれば空にできます。
+
+任意のURLに対して、複数の定義を提供できます。
+bzrは次のルールに従って (``user`` [, ``password``]) を選択します:
+
+ 1. 最初にマッチするものが優先される
+
+ 2. すべてにマッチする空のフィールド
+
+ 3. デコレータがリクエストされたURLに使用されていても ``scheme`` はマッチします。
+
+ 4. ``host`` は正確にマッチするか '.' で始まる場合、ドメインとしてふるまいます。
+    (``project.bzr.sf.net`` は ``.bzr.sf.net`` にマッチしますが ``projectbzr.sf.net`` は ``bzr.sf.net`` にマッチしない)。
+
+ 5. ``port`` はリクエストされたURLに含まれる場合(正確にマッチする場合のみ)マッチします。
+
+ 6. ``path`` はリクエストされたURLに含まれる場合マッチします (そして上記のルール #2 によって、
+    空のパスは任意の提供されたパスにマッチします)。
+
+
+
+ファイルのフォーマット
+----------------------
+
+`設定ファイル`_ 用の一般ルールは変数ポリシー意外に当てはまります。
+
+.. _設定ファイル: #configuration-settings
+
+それぞれのセクションで認証の定義を記述します。
+
+セクションの名前は任意の文字列で、 ``DEFAULT`` の値のみが保存され
+*最後* のセクションとして現れます。
+
+それぞれのセクションは次の内容を定義すべきです:
+
+* ``user``: 使用されるログイン名
+
+それぞれのセクションは次の内容を定義できます:
+
+* ``host``: リモートサーバー
+
+* ``port``: サーバーがリスンしているポート番号
+
+* ``path``: ブランチの位置
+
+* ``password``: パスワード
+
+
+例
+---
+
+
+外部でホストされた個人プロジェクト
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+すべての接続は同じ ``user`` で行われ
+(デフォルトのbzrのものが適切でない場合のためのリモートの接続)
+パスワードはいくつかの例外とともに常に催促されます::
+
+        # hobby.netのPetプロジェクト
+        [hobby]
+        host=r.hobby.net
+        user=jim
+        password=obvious1234
+
+        # ホームサーバー
+        [home]
+        scheme=https
+        host=home.net
+        user=joe
+        password=1essobV10us
+
+        [DEFAULT]
+        # ローカルユーザーがbarbazで、すべてのリモートサイト上ではfoobarとして
+        user=foobar
+
+
+ソースホスティングプロバイダ
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+shp.net(仮想)ドメインにおいて、それぞれのプロジェクトは独自のサイトを持ちます::
+
+        [shpnet domain]
+        # sftpを使用するが、sshは認証用に使用される
+        scheme=ssh
+        # '.' は 'shp.net' だけがマッチしないことを保証する
+        host=.shp.net
+        user=joe
+        # bzrはsftp用のパスワードの提供を保証しません
+        # パスワードをインタラクティブに入力したくなければ
+        # sshエージェントを使用することを考えてください(pageant, ssh-agent、など)
+
+HTTPS、SFTPサーバーとプロキシ
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+company.comにおいて、サーバーのホスティングリリースは統合ブランチの背後にはプロキシがあり、
+2つのブランチは異なる認証ポリシーを使用します::
+
+        [reference code]
+        scheme=https
+        host=dev.company.com
+        path=/dev
+        user=user1
+        password=pass1
+
+        # devサーバー上の開発ブランチ
+        [dev]
+        scheme=ssh # bzr+sshとsftpはここで利用可能
+        host=dev.company.com
+        path=/dev/integration
+        user=user2
+
+        # プロキシ
+        [proxy]
+        scheme=http
+        host=proxy.company.com
+        port=3128
+        user=proxyuser1
+        password=proxypass1
+
+
+計画的な強化
+-------------
+
+次の内容はまだ実装されていませんが進行中の作業の一部として計画されています:
+
+* ``password_encoding`` フィールドの追加は次のとおりです:
+
+  - さまざまな難読化のエンコーディング(たとえばbase64)でパスワードを保存する。
+
+  - パスワードの保存をプラグインに委譲する(たとえば.netrc)。
+
+* ユーザーがユーザー名もしくはパスワードの入力を催促されたらクレデンシャルを更新する。
+
+* ``HTTPS`` 用に ``verify_certificates`` フィールドを追加する。
+
+``password_encoding`` と ``verify_certificates`` フィールドは認識されますが
+実際の実装では無視されます。
+
+
+バグトラッカーの設定
+=====================
+
+コミットを行うとき、その変更によって修正されたバグに関するメタデータは --fixes オプションを使用することで記録されます。
+それぞれのバグが修正されたものとしてマークされるために、エントリーが '<url> <status>' を述べる 'bugs' リビジョンプロパティに含まれます。
+(現在サポートされる ``status`` の値は ``fixed.`` だけです)
+Launchpadの中心バグトラッカー用のサポートは組み込まれています。
+他のバグトラッカーに関して、正しいURLが記録されるように設定が予め要求されます。
+
+Launchpadに加えて、BazaarはBugzillaとTracに適切なURLの生成を直接サポートします。
+プロジェクトが異なるバグトラッカーを使用するのであれば、そのサポートを追加するのは簡単です。
+BugzillaもしくはTracを使用しているのであれば、
+バグトラッカーの基底URLを格納する設定変数を設定することだけが必要です。
+これらのオプションは ``bazaar.conf`` 、 ``branch.conf`` もしくは ``locations.conf`` のブランチ固有のセクションに入ります。
+取り組むプロジェクトごとにこれらの値をセットアップできます。
+
+注: それぞれのトラッカーに対して短縮名を提供するのであれば、望むのであればコミット時に1つもしくは複数のトラッカーで1つもしくは複数のバグを指定できます。
+
+Launchpad
+---------
+
+バグ2を修正するコミットを記録するには ``bzr commit --fixes lp:2`` を使用します。
+
+bugzilla_<tracker_abbreviation>_url
+-----------------------------------
+
+存在するのであれば、Bugzillaのバグトラッカーの位置は <tracker_abbreviation> によって参照されます。
+そのバグトラッカーのバグをそのコミットで修正されたものとしてマークするためにはこのオプションは ``bzr commit --fixes`` と一緒に使用できます::
+
+    bugzilla_squid_url = http://www.squid-cache.org/bugs
+
+上記の例はSquidのバグ 1234が修正されたものとしてマークするために ``bzr commit --fixes squid:1234`` を許可します。
+
+trac_<tracker_abbrevation>_url
+------------------------------
+
+存在するのであれば、Tracインスタンスの位置は <tracker_abbreviation> によって参照されます。
+そのコミットによってバグが修正されたものとしてそのトラッカーの中でマークするためにこのオプションは ``bzr commit --fixes`` と一緒に使用できます::
+
+    trac_twisted_url = http://www.twistedmatrix.com/trac
+
+上記の例はTwistedのバグ1234を修正したものとしてマークするために ``bzr commit --fixes twisted:1234`` を許可します。
+
+bugtracker_<tracker_abbrevation>_url
+------------------------------------
+
+存在するのであれば、一般的なバグトラッカーのインスタンスの位置は <tracker_abbreviation> によって参照されます。
+位置は ``{id}`` プレースホルダーを含まなければなりません。プレースホルダーは特定のバグIDに置き換えられます。
+そのコミットによってバグが修正されたものとしてそのトラッカーでマークするためにこのオプションを ``bzr commit --fixes`` と一緒に使用できます::
+
+    bugtracker_python_url = http://bugs.python.org/issue{id}
+
+上記の例はPythonのRoundupバグトラッカーのバグ1234を修正されたものとしてマークするために ``bzr commit --fixes python:1234`` を許可します::
+
+    bugtracker_cpan_url = http://rt.cpan.org/Public/Bug/Display.html?id={id}
+
+上記はCPANのRTバグトラッカー用です。
+
+
+構成設定
+=========
+
+.. TODO: Should have some explanation of why you'd want things in
+.. branch.conf.
+
+
+環境変数の設定
+---------------
+
+大抵の設定が設定ファイルによって取り扱われる一方で、
+半永久的ないくつかのオプションは環境変数を通して制御できます。
+
+BZR_EMAIL
+~~~~~~~~~
+
+Bazaarによって使用されるEメールのIDを上書きする。よくあるフォーマット::
+
+  "John Doe <jdoe@example.com>"
+
+``email`` の設定値も参照してください。
+
+BZR_PROGRESS_BAR
+~~~~~~~~~~~~~~~~
+
+進行状況の表示方法を上書きする。可能な値は "none"、 "dots"、 "tty"
+
+BZR_SIGQUIT_PDB
+~~~~~~~~~~~~~~~
+
+SIGQUITが通常とおりに振る舞うようにするかもしくはブレークインデバッガーを起動するかどうか制御する。
+
+* 0 = 標準のSIGQUITのふるまい(通常はコアダンプを伴ってexitする)
+* 1 = ブレークインデバッガーを起動する (デフォルト)
+
+BZR_HOME
+~~~~~~~~
+
+Bazaarによって使用されるホームディレクトリを上書きする
+
+BZR_SSH
+~~~~~~~
+
+異なるSSHの実装を選択する。
+
+BZR_PDB
+~~~~~~~
+
+デバッガもしくはエラーを立ち上げるか制御する。
+
+* 0 = Standard behavior
+* 1 = Launch debugger
+
+BZR_REMOTE_PATH
+~~~~~~~~~~~~~~~
+
+bzr+sshプロトコルを使用する際に使用するBazaar実行ファイルへのパス。
+
+設定値 ``bzr_remote_path`` も参照。
+
+BZR_EDITOR
+~~~~~~~~~~
+
+コミットメッセージなどの際にBazaarが使用するエディタへのパス。
+
+BZR_PLUGIN_PATH
+~~~~~~~~~~~~~~~
+
+Bazaarが使用するプラグインディレクトリへのパス。
+
+BZRPATH
+~~~~~~~
+
+Bazaarがシェルシェルプラグインの外部コマンドを探すパス。
+
+
+設定ファイル
+-------------
+
+設置場所
+~~~~~~~~~
+
+設定ファイルはLinux/Unixの場合 ``$HOME/.bazaar`` に
+Windowsの場合 ``C:\Documents and Settings\<username>\Application Data\Bazaar\2.0`` に設置されます。
+( ``bzr version`` を使用することでシステムに設置された位置をチェックできます)
+
+この位置に3つの主要な設定ファイルが存在します:
+
+* ``bazaar.conf`` はデフォルトの設定オプションを記述します
+
+* ``locations.conf`` は特定のブランチの位置用の設定情報を記述します。
+
+* ``authentication.conf`` はリモートサーバー用のクレデンシャル情報を記述します。
+
+それぞれのブランチはそのブランチに固有な値を設定する設定ファイルも格納します。
+このファイルはブランチの範囲内の ``.bzr/branch/branch.conf`` で見つかります。
+このファイルはブランチのすべてのユーザーに見えます。
+あなたのブランチ専用に設定値の1つを上書きしたいのであれば、 ``locations.conf`` で行うことができます。
+
+一般的なフォーマット
+~~~~~~~~~~~~~~~~~~~~
+
+iniファイルは3つの種類のコントラクト: セクションヘッダー、セクション変数とコメントを持ちます。
+
+コメント
+^^^^^^^^^
+
+コメント行は "#" で始まります("hash mark", "pound sign"  "number sign"とも呼ばれます)。
+コメント行はiniファイルを解析するときBazaarによって無視されます。
+
+セクションヘッダー
+^^^^^^^^^^^^^^^~~~~
+
+セクションヘッダーは行頭から始まり角かっこで囲まれた単語です。
+典型的なセクションヘッダーは次のとおりです::
+
+    [DEFAULT]
+
+bazaar.confに対して現時点で唯一有効なセクションヘッダーは[DEFAULT]と[ALIASES]です。
+セクションヘッダーは大文字と小文字を区別します。
+デフォルトのセクションが提供する設定変数はブランチの設定ファイルで上書きできます。
+
+``locations.conf`` に対して、
+セクションにマッチする最長のものを持つセクションからの変数は潜在的に有効な別のセクションヘッダーを除外するために使われます。
+セクションヘッダーはブランチ用のパスをセクションヘッダーとして使用します。次のような例があります::
+
+    [http://mybranches.isp.com/~jdoe/branchdir]
+    [/home/jdoe/branches/]
+
+
+セクション変数
+^^^^^^^^^^^^^^^
+
+セクション変数はセクションの範囲に属します。セクション変数は変数名、等号と値を格納します。例です::
+
+    email            = John Doe <jdoe@isp.com>
+    check_signatures = require
+
+
+変数のポリシー
+^^^^^^^^^^^^^^^
+
+セクションの中で定義された変数は名前つきのディレクトリもしくはURLに加えてそれらを格納する位置にも影響を与えます。
+ポリシーは可変変数が含まれる位置のために解釈される方法を変更するために使用できます。現在は3つのポリシーが利用できます:
+
+ none:
+   値は含まれる位置に対して同じように解釈されます。
+   これはデフォルトのふるまいです。
+ norecurse:
+   値はセクション名によって指定された正確な位置のみに対して使用されます。
+ appendpath:
+   for contained locations, 追加パスのコンポーネントは値に追加されます。
+
+ポリシーは "$var:policy" 形式の名前を持つキーによって指定されます。
+たとえば、ブランチのツリー用のpushの位置を定義するには、次の設定が使われます::
+
+  [/top/location]
+  push_location = sftp://example.com/location
+  push_location:policy = appendpath
+
+この設定によって、 ``/top/location/branch1`` 用のpush位置は ``sftp://example.com/location/branch1`` になります。
+
+
+主要な設定ファイルのbazaar.conf
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+``bazaar.conf`` は ``[DEFAULT]`` と呼ばれる1つのセクションだけを許可します。
+このデフォルトセクションはすべてのブランチ用のデフォルト設定オプションを格納します。
+デフォルトセクションは ``locations.conf`` にブランチ固有のセクションを提供することで上書きできます。
+
+典型的な ``bazaar.conf`` セクションは次のようになります::
+
+    [DEFAULT]
+    email             = John Doe <jdoe@isp.com>
+    editor            = /usr/bin/vim
+    check_signatures  = check-available
+    create_signatures = when-required
+
+
+ブランチの位置の設定ファイルのlocations.conf
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+``locations.conf`` によって特定のブランチ用に設定を上書きできます。
+フォーマットは1つの重大な変更を伴うbazaar.confのデフォルトセクションに対してほとんど理想的です:
+デフォルトを記述する代わりに、セクションヘッダーは値を上書きしたいブランチへのパスになります。
+ワイルドカードの '?' と '*' がサポートされます::
+
+    [/home/jdoe/branches/nethack]
+    email = Nethack Admin <nethack@nethack.com>
+
+    [http://hypothetical.site.com/branches/devel-branch]
+    create_signatures = always
+    check_signatures  = always
+
+    [http://bazaar-vcs.org/bzr/*]
+    check_signatures  = require
+
+認証用の設定ファイル、authentication.conf
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+``authentication.conf`` によってリモートサーバー用のクレデンシャルを指定できます。
+これはすべてのサポートされる転送と認証(たとえばsmtp)を必要とするbzrの一部に対して使用できます。
+
+ファイルの構文は適用しない変数ポリシー用の他の例外を除いて同じルールに従います。
+
+設定ファイルにおける認証の使い方の詳細な情報に関しては `認証の設定`_ を参照してください。
+
+
+変数の共通オプション
+---------------------
+
+email
+~~~~~
+
+Eメールアドレスはブランチをコミットする際に使われます。よく次のような形式をとります::
+
+    email = Full Name <account@hostname.tld>
+
+editor
+~~~~~~
+
+コミットメッセージなしで *bzr commit* が実行された場合に使用されるエディタのパスです。
+この設定は環境変数 ``BZR_EDITOR`` によって設定され、
+環境変数 ``VISUAL`` と ``EDITOR`` によって上書きされます。
+
+check_signatures
+~~~~~~~~~~~~~~~~
+
+署名用のふるまいを定義します。
+
+require
+    リビジョン用のgnupg署名が存在して有効でなければなりません。
+
+ignore
+    リビジョンのgnupgの署名をチェックしない。
+
+check-available
+    (デフォルト) リビジョン用のgnupgの署名が存在する場合、それらをチェックします。
+    わるい署名であることが分かるとBazaarは失敗しますが、署名が存在しない場合は失敗しません。
+
+create_signatures
+~~~~~~~~~~~~~~~~~
+
+リビジョン署名のふるまいを定義します。
+
+always
+    コミットされるすべての新しいリビジョンに署名する。
+
+when-required
+    (デフォルト) ブランチが署名つきのリビジョンを要求するときのみ新しくコミットされたリビジョンに署名する。
+
+never
+    ブランチが署名を要求する場合でも新しくコミットされたリビジョンに署名するのを拒否する。
+
+recurse
+~~~~~~~
+
+``locations.conf`` でのみ便利です。
+このセクション用の設定をサブディレクトリにも適用するかどうか定義します:
+
+true
+    (デフォルト このセクションはサブディレクトリにも適用される。
+
+false
+    このセクションはこのディレクトリのブランチのみに適用されその下のブランチには適用されない。
+
+gpg_signing_command
+~~~~~~~~~~~~~~~~~~~
+
+(デフォルト: "gpg"). リビジョンの署名とチェックのために使用されるプログラム。例です::
+
+    gpg_signing_command = /usr/bin/gnpg
+
+bzr_remote_path
+~~~~~~~~~~~~~~~
+
+(デフォルト: "bzr").  bzr用のスマートサーバーを稼働させるために使われるコマンドへのパス。
+この値はlocations.confでのみ指定が許可されます。理由は次のとおりです:
+
+- branch.confがアクセスできる前に必要だから
+- セキュリティリスクになるコマンドを指定するためにリモートのbranch.confファイルを許可するから
+
+これはBZR_REMOTE_PATH 環境変数によって上書きされます。
+
+smtp_server
+~~~~~~~~~~~
+
+(デフォルト: "localhost")。たとえば ``merge-directive --mail-to`` 、もしくはbzr-emailプラグインによって
+BazaarがEメールを送信する必要があるときに使用するSMTPサーバー、
+
+
+smtp_username, smtp_password
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+SMTPサーバーで認証するユーザーとパスワード。
+smtp_usernameが設定されていて、smtp_passwordが設定されていなければ、Bazaarはパスワードを催促します。
+Eメールを送信するためにSMTPサーバーが認証を必要とする場合のみこれらの設定が必要です。
+
+mail_client
+~~~~~~~~~~~
+
+マージリクエストを送信するために使うメールクライアント。
+デフォルトでは、Windowsではbzrは ``mapi`` を使うことを試みます。
+他のプラットフォームでは、 ``xdg-email`` を試みます。
+これらのどちらかが失敗すると、 ``editor`` に戻ります。
+
+特定のクライアント用のサポートされた値:
+
+:claws: Clawsを使用する。ファイル添付のダイアログはスキップする。
+:evolution: Evolutionを使用する
+:kmail: KMailを使用する
+:mutt: Muttを使用する
+:thunderbird: Mozilla ThunderbirdもしくはIcedoveを使用する。Thunderbird/Icedove 1.5に関して、
+    これはxdg-emailが扱えないいくつかのバグに対処します。
+
+サポートされる一般的な値は次のとおりです:
+
+:default: 上記を参照。
+:editor: マージリクエストを書くエディタを使用します。
+    これはコミットID( ``bzr whoami`` を参照),
+    smtp_serverと(オプションで)smtp_usernameとsmtp_passwordも使用します。
+:mapi: Windowsで好きなメールクライアントを使用します。
+:xdg-email: 好きなメールプラグラムを実行するためにxdg-emailを使用する
+
+submit_branch
+~~~~~~~~~~~~~
+
+現在の作業内容を投稿しようとしているブランチ。
+これは ``bzr send`` によって自動的に設定され ``submit:`` リビジョンスペックにも使用されます。
+通常、これはブランチ単位ロケーション単位で設定されます。
+
+public_branch
+~~~~~~~~~~~~~
+
+このブランチの公開されアクセス可能なバージョン
+(このブランチが公開されてアクセス可能ではないことを暗示する)。
+``bzr send`` によって使用されます(そして設定されます)。
+
+
+ブランチ特有のオプション
+-------------------------
+
+これらのオプションは ``dirstate-tags`` もしくは後のフォーマットを使用するブランチにのみ適用します。
+通常これらは自動的に ``.bzr/branch/branch.conf`` 設定される
+もしくは手動で ``locations.conf`` もしくは ``bazaar.conf`` に設定されます。
+
+append_revisions_only
+~~~~~~~~~~~~~~~~~~~~~
+
+"True"に設定されていればリビジョンはログにのみ追加され、削除されません。
+この設定が有効なブランチは、他のブランチのログがそれ自身のリビジョンより長い場合、別のブランチからのみpullできます。
+通常これは ``bzr init --append-revisions-only`` によって設定されます。
+
+parent_location
+~~~~~~~~~~~~~~~
+
+存在すれば、pullもしくはmerge用のデフォルトブランチの位置。
+通常このオプションは ``pull --remember`` もしくは ``merge --remember`` によって設定されます。
+
+push_location
+~~~~~~~~~~~~~
+
+存在すれば、push用のデフォルトブランチの位置。
+通常このオプションは ``push --remember`` によって設定されます。
+
+bound_location
+~~~~~~~~~~~~~~
+
+チェックアウトとして振る舞うときコミットが向かう位置。
+通常このオプションは ``bind`` によって設定されます。
+
+bound
+~~~~~
+
+"True"に設定されていると、ブランチはチェックアウトとしてふるまい、bound_locationにそれぞれのコミットをpushします。
+通常このオプションは ``bind``/``unbind`` に設定されます。
+
+
+衝突のタイプ
+=============
+
+オペレーションの中には、merge、revertとpullのように、作業ツリーの内容を修正するものがあります。
+これらの修正はプログラムで生成されるので、作業ツリーの現在の状態と衝突することがあります。
+多くの種類の変更はプログラムで結合できますが、 正しいことを行われているか時々人間だけしか判断できないことがあります。
+これが起きるとき Bazaarはあなたに衝突が存在するのでそれを解消するように伝えます。
+Bazaarに衝突が解消したことを伝えるコマンドは ``resolve`` ですが、
+これを実行できる前にいくつかのアクションを実行しなければなりません。
+
+それぞれの衝突は下記のセクションで説明され、衝突を解消するために行わなければならないアクションの概要が説明されています。
+
+
+テキストの衝突
+---------------
+
+典型的なメッセージは次のとおりです::
+
+  Text conflict in FILE
+
+テキストのマージが2つのセットのテキストの変更を完全に折り合いをつけられないときにこれらは生み出されます。
+BazaarはTHIS、OTHER、とBASEのエクステンションでそれぞれのバージョン用にファイルをemitします。
+THISはターゲットツリーからのファイルのバージョン、すなわち、変更をマージしようとしているツリーです。
+OTHERはターゲットにマージしようとしているバージョン、BASEは比較用のベースとして使われる古いバージョンです。
+
+ファイルのメインコピーにおいて、Bazaarは調整できるすべての変更を含み、
+未調整の衝突は ``<<<<<<<`` のように "herringbone" マーカーによって囲まれます。
+
+たとえば、初期のテキストが "The project leader released it."、でTHISはこれを "Martin Pool released it." に修正する一方で、
+OTHERは"The project leader released Bazaar."に修正します。衝突は次のようになります::
+
+  <<<<<<< TREE
+  Martin Pool released it.
+  =======
+  The project leader released Bazaar.
+  >>>>>>> MERGE-SOURCE
+
+正しい解消方法は"Martin Pool released Bazaar."になります。
+
+ファイルのメインコピーを編集する、もしくはTHIS、OTHERとBASEバージョン上で外部ツールを起動することのどちらかでテキストの衝突を扱うことができます。
+テキストの衝突の解消において他のものから変更のセットの1つの選別はめったにないことは言っておく価値があります。
+
+より頻繁に、2つのセットの変更はインテリジェントに結合しなければなりません。
+
+メインコピーを編集するとき、 herringbone マーカーを必ず削除してください。
+編集作業を終えたとき、ファイルは衝突がけっして起こらないようであれば、コミットする準備ができています。
+
+テキストの衝突を解消したとき、"bzr resolve"を実行するだけでBazaarは解消した衝突を自動検出します。
+
+内容の衝突
+----------
+
+典型的なメッセージ::
+
+  Contents conflict in FILE
+
+ターゲットツリーとマージソースの中の変更の衝突が存在するときにこの衝突は起こりますが、
+が衝突したアイテムはテキストファイルではありません。
+これらはバイナリファイルもしくはシンボリックリンクもしくはディレクトリになります。
+片方が削除され、もう一方が修正されたファイルでも起こり得ます。
+
+テキストの衝突のように、BazaarはTHIS、OTHER とBASEファイルをエミットしますが
+(これらは通常のファイル、シンボリックリンクもしくはディレクトリになります)、
+これはherringbone衝突マーカーを持つファイルの"メインコピー"を含みません。
+"メインコピー"がTHISもくはOTHERにリネームされたときにこれは現れます。
+
+これを解消するには、ファイルを通常の名前に戻すために "bzr mv" を使用し変更を手動で結合します。
+満足したときに、 "bzr resolve FILE" を実行します。この種の衝突が解消されたときにBazaarは自動検出できません。
+
+重複したパス
+-------------
+
+典型的なメッセージ::
+
+  Conflict adding file FILE.  Moved existing file to FILE.moved.
+
+時々Bazaarはすでに使用されているパス名を用いてファイルを作成しようとします。
+既存のファイルは "FILE.moved" にリネームされます。
+望むのであれば、これらのファイルの1つをリネームするか、それらの内容を結合できます。
+満足したら、衝突を解消したものとしてマークするために "bzr resolve FILE" を実行できます。
+
+バージョン管理下にない親
+-------------------------
+
+典型的なメッセージ::
+
+    Conflict because FILE is not versioned, but has versioned children.
+
+ときどきBazaarは親ディレクトリがバージョン管理されていないファイルを作成しようとします。
+ターゲットの中でディレクトリが削除されたときにこれが起こりますが、
+ソースの中の新しい子を持ちます。逆も同様です。
+この状況において、Bazaarは親ディレクトリも同様にバージョン管理します。
+この問題の解決方法は特定のシナリオに大きく依存します。
+ファイルもしくはディレクトリをリネームもしくは削除するとよいでしょう。
+満足したら、衝突を解消したものとして"bzr resolve FILE"を実行できます。
+
+見つからない親
+---------------
+
+典型的なメッセージ::
+
+  Conflict adding files to FILE.  Created directory.
+
+ターゲットの中でファイルを削除するときにこれが起こりますが、ソースの中に新しい子があります。
+これは "unversioned parent" の衝突と似ています。
+バージョン管理を解除される代わりに、親ディレクトリが *存在しない* ことを除いて、
+この状況において、Bazaarは見つからない親を作成します。
+この問題の解決方法は特定のシナリオに大いに依存します。
+ファイルもしくはディレクトリをリネームもしくは削除するとよいでしょう。
+満足したら、衝突を解消したものとして "bzr resolve FILE" を実行できます。
+
+親を削除する
+------------
+
+典型的なメッセージ::
+
+  Conflict: can't delete FILE because it is not empty.  Not deleting.
+
+これは"見つからない親"の反対です。ソースの中でディレクトリは削除されますが、
+ターゲットの中で新しい子はあります。Bazaarはディレクトリを保有し続けます。
+この問題の解消は特定のシナリオに大いに依存します。
+ファイルもしくはディレクトリをリネームもしくは削除するとよいでしょう。
+満足したら、衝突を解消したものとしてマークするために"bzr resolve FILE"を実行できます。
+
+パスの衝突
+-----------
+
+典型的なメッセージ::
+
+  Path conflict: PATH1 / PATH2
+
+ソースとターゲットがファイルの名前もしくは親ディレクトリを修正したときに起こります。
+Bazaarはソースからパス要素を使用します。
+ファイルをリネームできれば、衝突を解消したものとしてマークするために "bzr resolve FILE" を実行します。
+
+親のループ
+-----------
+
+典型的なメッセージ::
+
+  Conflict moving FILE into DIRECTORY.  Cancelled move.
+
+ソースとターゲットがそれぞれディレクトリを移動させたので、
+変更が適用可能であれば、ディレクトリはそれ自身を含むときにこれは起こります。
+例です::
+
+  $ bzr init
+  $ bzr mkdir a
+  $ bzr mkdir b
+  $ bzr commit -m "BASE"
+  $ bzr branch . ../other
+  $ bzr mv a b
+  $ bzr commit -m "THIS"
+  $ bzr mv ../other/b ../other/a
+  $ bzr commit ../other -m "OTHER"
+  $ bzr merge ../other
+
+この状況において、Bazaarは移動をキャンセルして、"a"を"b"の中に残しておきます。
+望むのであればディレクトリをリネームできれば
+衝突を解消したものとしてマークするために "bzr resolve FILE" を実行します。
+
+ディレクトリではない親
+-----------------------
+
+典型的なメッセージ::
+
+  Conflict: FILE.new is not a directory, but has files in it.
+  Created directory.
+
+片方がファイルをディレクトリを追加したとき、もう一方がディレクトリをファイルもしくはシンボリックリンクに変更したときにこれは起きます。
+例です::
+
+  $ bzr init
+  $ bzr mkdir a
+  $ bzr commit -m "BASE"
+  $ bzr branch . ../other
+  $ rmdir a
+  $ touch a
+  $ bzr commit -m "THIS"
+  $ bzr mkdir ../other/a/b
+  $ bzr commit ../other -m "OTHER"
+  $ bzr merge ../other
+
+
+MalformedTransform
+-------------------
+
+Bazaarに例外のMalformedTransformを起動させること可能です(非常にまれですが)。
+これはBazaarが解決できないファイルシステムの衝突に遭遇したことを意味します。
+通常これはバグを示します。これに遭遇したら教えて頂くようお願いします。
+バグトラッカーは https://launchpad.net/bzr/+bugs です。
+
+
+現在のストレージフォーマット
+============================
+
+:pack-0.92:
+    (ネイティブ) (デフォルト) 0.92で新しく導入:
+    dirstate-tagsフォーマットリポジトリと互換性のあるデータを持つパックベースのフォーマット。
+    0.92以前のbzrリポジトリと相互運用できますが0.92以前のbzrでは読めません。
+    以前はknitpack-experimentalと呼ばれていました。詳細な情報に関しては、
+    http://doc.bazaar-vcs.org/latest/developers/packrepo.html を参照。
+
+:1.6:
+    (ネイティブ) スタックをサポートするディレクトリに基づいたブランチとパック。
+
+:1.6.1-rich-root:
+    (ネイティブ) スタックとリッチrootデータをサポートするブランチとパックベースのリポジトリ(bzr-svnが必要)
+
+:1.9:
+    (ネイティブ) btreeインデックスを使用するブランチとパックベースのリポジトリ。
+
+:1.9-rich-root:
+    (ネイティブ) btreeインデックスとrich rootデータを使用する
+    ブランチとパックベースのリポジトリ(bzr-svnに必要)。
+
+
+ストレージフォーマットは ``bzr help formats`` を参照。
+
+
+環境変数
+========
+
+================ =================================================================
+BZRPATH          bzrがシェルプラグインコマンドを探すパス。
+BZR_EMAIL        ユーザーのEメールアドレス。EMAILを上書きする。
+EMAIL            ユーザーのEメールアドレス。
+BZR_EDITOR       コミットメッセージの編集用エディタ。EDITORを上書きする。
+EDITOR           コミットメッセージの編集用エディタ
+BZR_PLUGIN_PATH  bzrがプラグインを探すパス。
+BZR_HOME         .bazaarの設定ディレクトリを保持するディレクトリ。HOMEを上書きする。
+BZR_HOME (Win32) bazaar設定ディレクトリを保持するディレクトリ。APPDATAとHOMEを上書きする。
+BZR_REMOTE_PATH  リモート'bzr'コマンドのフルネーム(bzr+ssh:// URL用).
+BZR_SSH          SSHクライアント: paramiko (デフォルト), openssh, ssh, plink.
+BZR_LOG          .bzr.logの位置(ロギングを停止するには'/dev/null'を使う)。
+BZR_LOG (Win32)  .bzr.logの位置(ロギングを停止するには'NUL'を使う)。
+================ =================================================================
+
+
+ファイル
+========
+
+:On Linux:   ~/.bazaar/bazaar.conf
+:On Windows: C:\\Documents and Settings\\username\\Application Data\\bazaar\\2.0\\bazaar.conf
+
+ユーザーのデフォルト設定は上記のとおりです。
+``[DEFAULT]`` セクションすべての場所に適用される一般的な設定を定義するために使用できます。
+``[ALIASES]`` セクションは共通に使用されるオプション用のコマンドエイリアスを作成するために使用できます。
+
+典型的な設定ファイルは次のとおりです::
+
+  [DEFAULT]
+  email=John Doe <jdoe@isp.com>
+
+  [ALIASES]
+  commit = commit --strict
+  log10 = log --short -r -10..-1
+
+
+グローバルオプション
+=====================
+
+これらのオプションは任意のコマンドで使用可能で、コマンドの前で入力します(たとえば"bzr --profile help")。
+
+--version      バージョン番号を表示する。コマンドの前に入力しなければならない。
+--no-aliases   このコマンドを実行する際にコマンドエイリアスを処理しない。
+--builtin      プラグインのコマンドではなく、組み込みのコマンドを使用する。
+               このオプションは他のプラグインの効果を抑制しない。
+--no-plugins   プラグインを処理しない。
+
+--profile      ホットスポットプロファイラを使用するプロファイルの実行。
+--lsprof       lsprofプロファイラを使用したプロファイルの実行。
+--lsprof-file  lsprofプロファイラを使用するプロファイルを実行し、結果を指定ファイルに書き込む。
+               ファイル名が".txt"で終わる場合, テキストフォーマットが使用されます。
+               ファイル名が"callgrind.out"で始まる、もしくは".callgrind"で終わる場合、
+               KCacheGrind用に出力がフォーマットされる。
+               さもなければ、出力はpickleになる。
+--coverage     指定ディレクトリの行カバレージレポートを生成する。
+
+プロファイリングに関する詳細な情報はdoc/developers/profiling.txtを参照してください。
+トラブルシューティングと開発を手助けするためのたくさんのデバッグフラッグも利用可能です。
+
+-Dauth            使用される認証セクションをトレースする。
+-Derror           通常のエラーハンドリングの代わりに、常にエラー上のトラックバックを表示する。
+-Devil            割高なもしくはわるいスケーリングオペレーションを行うコールサイトをキャプチャする。
+-Dfetch           リポジトリ間のコピーの履歴をトレースする。
+-Dhashcache       ハッシュを決定するために作業ファイルが読み込まれるたびにログを記録する
+-Dhooks           フックの実行をトレースする。
+-Dhpss            スマートプロトコルリクエストとレスポンスをトレースする。
+-Dhttp            http接続、リクエストとレスポンスをトレースする。
+-Dindex           主要なindexオペレーションをトレースする。
+-Dknit            knitオペレーションをトレースする。
+-Dlock            lockdirロックがとられるもしくはリリースされるときをトレースする。
+-Dmerge           マージのデバッグ用の情報を表示する。
+-Dpack            packオペレーション用の情報を表示する。
+
+
+フック
+=======
+
+紹介
+-----
+
+*yyy* クラスの *xxx* タイプのフックを使用するには登録する必要があります::
+
+  yyy.hooks.install_named_hook("xxx", ...)
+
+例に関してはユーザーガイドの `フックを利用する`_ を参照してください。
+
+.. _フックを利用する: ../user-guide/index.html#id186
+
+それぞれのフックが含むクラスは下記のそれぞれのフックタイプの後で丸かっこの中で示されます。
+
+それぞれの説明ではクライアント(bzrが実行されるマシン)もしくはサーバー
+(ブランチURLで示されるマシン)で実行されるか示します。
+これらは必ずしも同じマシンではありません。
+
+以下の1つがtrueの場合(フックを含む)プラグインはサーバー上で実行されます:
+
+  * リモートブランチがクライアントと同じマシン上にあり、クライアントはプラグインを有効にしている。
+
+  * 接続はスマートサーバー経由で行われ("bzr://"、"bzr+ssh://"もしくは"bzr+http://"で
+    始まるURLでアクセスするもしくはスマートサーバーがHTTP経由で利用可能なときに
+    "http://"でアクセスする)、サーバーがプラグインを有効にしている。
+
+
+open (Branch)
+-------------
+
+Branchオブジェクトが開いた後で、Branchオブジェクトによって呼び出されます。
+クライアントとサーバーで実行します。
+
+post_push (Branch)
+------------------
+
+``push`` が完了した後で実行されます。
+クライアントで実行します。
+
+フックのシグネチャは (push_result) でメンバーを含みます。
+
+  source_branch
+    データがpushされる場所(読み込みはロックされる)。
+    これは最も低いレイテンシブランチになります。
+
+  target_branch
+    データが送信される直接の場所(書き込みがロックされる)。
+
+  master_branch
+    target_branch、もしくはターゲットがバインドされたブランチの場合、
+    これはマスターロケーションになります(書き込みはロックされる)。
+
+  local_branch
+    ターゲットがバインドされたブランチの場合、これがターゲットブランチになる、
+    そうでなければ、Noneになります。
+
+  old_revno
+    push以前のブランチのリビジョン番号(たとえば10)。
+
+  old_revid
+    push以前のリビジョンid (たとえば joe@foo.com-1234234-aoeua34)。
+
+  new_revno
+    push後のブランチのリビジョン番号(たとえば12)。
+
+  new_revid
+    push後のリビジョンid (たとえば joe@foo.com-5676566-boa234a)
+
+
+post_pull (Branch)
+------------------
+
+``pull`` が完了し後で実行されます。
+
+フックのシグネチャは (push_result) で次のメンバーを含みます:
+(source, local, master, old_revno, old_revid, new_revno, new_revid)。
+localはローカルのターゲットブランチもしくはNoneで、
+masterはターゲットのマスターブランチで、残りは見たとおりです。
+sourceでは読み込みがロックされターゲットブランチでは書き込みがロックされます。
+sourceはローカルの低レイテンシブランチになります。
+
+
+start_commit (MutableTree)
+--------------------------
+
+``commit`` が作業ツリーの処理を始める前に作業ツリー上で実行されます。
+クライアントで実行します。
+
+``pre_commit`` フック(下記を参照)とは異なり、
+``start_commit`` フックは作業ツリーを安全に変更できます。
+
+フックのシグネチャはツリーがMutableTreeオブジェクトである場所(ツリー)です
+
+
+pre_commit (Branch)
+-------------------
+
+``commit`` が完了する前に実行されます。
+クライアントで実行します。
+
+フックのシグネチャは
+(local, master, old_revno, old_revid, future_revno, future_revid, tree_delta, future_tree)です。
+old_revnoはブランチに最初にコミットするためのNULL_REVISIONで、
+tree_deltaは基底リビジョンからの変更を記述するTreeDeltaオブジェクトで、
+future_treeはインメモリツリーでCommitBuilder.revision_tree()から得られます。
+フックはtree_deltaとfuture_treeを修正する *必要はありません* 。
+
+
+post_commit (Branch)
+--------------------
+
+``commit`` が完了した後で実行されます。
+クライアントで実行します。
+
+フックのシグネチャは (local, master, old_revno, old_revid, new_revno, new_revid)です。
+old_revidはブランチへの最初のコミットのためのNULL_REVISIONです。
+
+
+post_uncommit (Branch)
+----------------------
+
+``uncommit`` が完了した後で実行されます。
+
+apiのシグネチャは (local, master, old_revno, old_revid, new_revno, new_revid)です。
+localはローカルブランチもしくはNoneで、masterはターゲットブランチで、
+空のブランチは0のnew_revno、Noneのnew_revidを受け取ります。
+
+
+pre_change_branch_tip (Branch)
+-------------------------------
+
+ブランチの書き込みがロックされている間に、ブランチチップが変更される前に実行されます。
+クライアントとサーバーで実行します。
+push、pull、commitとuncommitのすべてはこのフックを起動させることに注意してください。
+
+フックのシグネチャは (params) で、paramsはメンバーを含むオブジェクトです。
+
+  branch
+    チップが変更されるブランチ。
+
+  old_revno
+    変更前のブランチのリビジョン番号(たとえば10)。
+
+  old_revid
+    変更前のリビジョンid (たとえば joe@foo.com-1234234-aoeua34)。
+
+  new_revno
+    変更後のブランチのリビジョン番号(たとえば12)。
+
+  new_revid
+    変更後のリビジョンid (たとえば joe@foo.com-5676566-boa234a)。
+
+ヘッドリビジョンはドットつきのリビジョン番号をけっして持たないので、old_revnoとnew_revnoメンバーは整数です。
+
+
+post_change_branch_tip (Branch)
+-------------------------------
+
+ブランチの書き込みがまだロックされている間にブランチのチップが変更された後に実行されます。
+クライアントとサーバーで実行します。
+push、pull、commitとuncommitすべてがこのフックを起動させることに注意してください。
+
+フックシグネチャは(params)で、paramsは次のメンバーを含むオブジェクトです。
+
+  branch
+    チップが変更されるブランチ。
+
+  old_revno
+    変更前のブランチのリビジョン番号 (たとえば10)。
+
+  old_revid
+    変更前のリビジョンid(たとえば joe@foo.com-1234234-aoeua34)。
+
+  new_revno
+    変更後のブランチのリビジョン番号(たとえば12)。
+
+  new_revid
+    変更後のリビジョンid(たとえば joe@foo.com-5676566-boa234a)。
+
+ヘッドリビジョンはドットつきのリビジョン番号をけっして持たないのでold_revnoとnew_revnoメンバーは整数です。
+
+
+set_rh (Branch)
+---------------
+
+注意: このフックは廃止され近い将来の内に削除されます。
+代わりに ``post_change_branch_tip`` フックを使用してくださるようお願いします。
+
+
+transform_fallback_location (Branch)
+------------------------------------
+
+スタックドブランチとして起動させ、フォールバックロケーションをアクティベイトします。
+
+フックのシグネチャは(branch, url)です:
+
+  branch
+    開いたブランチ。まだフォールバックロケーションがアクティベイトされなければ、
+    ブランチは半分ビルドされたものとして扱われることに注意してください。
+
+  url
+    フォールバックロケーション用にブランチが指定されたURL。
+    フックはフォールバックロケーションを含むブランチのためにURLを返さなければなりません。
+    複数のフックが登録されていると、呼び出される順番は未定義で変更の影響を受けます。
+
+(1.9の新しい機能)
+
+
+server_started (SmartTCPServer)
+-------------------------------
+
+サーバーがディレクトリのサービスを提供始めるたびに起動します。
+サーバーで実行されます。
+フックのシグネチャは (backing urls, public url)です。
+
+  backing_url
+    サーバー固有のディレクトリの位置を渡す(string) URLのリスト。
+
+  public_url
+    ディレクトリ用の公開URL。
+
+
+server_stopped (SmartTCPServer)
+-------------------------------
+
+サーバーがディレクトリの提供を停止するときに常に起動します。
+サーバーで実行します。
+フックのシグネチャは ``server_started`` と同じです。
+
+
+lock_acquired (LockDir)
+----------------------------
+
+ロックの取得が成功したときにLockResultオブジェクトで呼び出されます(1.8で導入)。
+
+lock_released (LockDir)
+----------------------------
+
+ロックのリリースが成功したときにLockResultオブジェクトで呼び出されます(1.8で導入)。
+クライアントで実行します。
+
+
+commit_message_template (msgeditor)
+-----------------------------------
+
+コミットメッセージテンプレートを生成するためにコミットによって起動する。
+それぞれのフックはコミットメッセージテンプレートを修正できます。
+フックのシグネチャは (commit, start_message)です:
+
+  commit
+    進行中のコミットのための、コミットオブジェクト
+
+  start_message
+    オリジナルのコミットメッセージで、初期はNone。
+
+フックは新しいコミットメッセージテンプレートを返します。
+
+(1.10の新しい機能)
+
+
+その他のストレージフォーマット
+==============================
+
+実験的なフォーマットは次のとおりです。
+
+:1.12-preview:
+    (ネイティブ) ビューとコンテンツのフィルタリングをサポートする作業ツリーフォーマット。
+
+:1.12-preview-rich-root:
+    (ネイティブ) rich-rootデータをサポートする1.12-previewのバリアント(bzr-svnに必要)。
+
+:development:
+    (ネイティブ) 現在の開発フォーマット。
+    pack-0.92 (とpack-0.92と互換性のある)フォーマットリポジトリにデータを変換できます。
+    このフォーマットのリポジトリとブランチはbzr.devによってのみ読み込みできます。
+    使用する前に http://doc.bazaar-vcs.org/latest/developers/development-repo.html
+    をご覧下さるようお願いします。
+
+
+:development-subtree:
+    (ネイティブ) 現在の開発フォーマット。サブツリーのバリアント。
+    pack-0.92-subtree (pack-0.92-subtreeと互換性のあるものなら何でも)フォーマットリポジトリ
+    から/へのデータの変換ができる。このフォーマットのリポジトリとブランチは
+    bzr.devによってのみ読み込みできます。
+    使用する前に http://doc.bazaar-vcs.org/latest/developers/development-repo.html
+    をご覧下さるようお願いします。
+
+
+廃止されたフォーマットは下記のとおりです。
+
+:metaweave:
+    (ネイティブ) 0.8の暫定的なフォーマット。knitよりも遅い
+
+:weave:
+    (ネイティブ) 0.8以前のフォーマット。knitよりも遅くチェックアウトと共用リポジトリをサポートしない。
+
+:knit:
+    (ネイティブ) knitを使用するフォーマット。0.14とそれ以前のbzrとの相互運用に推奨される。
+
+:dirstate:
+    (ネイティブ) 0.15での新しいフォーマット: ローカルオペレーションが速い。
+    ネットワークを通してアクセスするときは0.8とそれ以降のbzrと互換性がある。
+
+:dirstate-tags:
+    (ネイティブ) 0.15での新しいフォーマット: 速いローカルオペレーションとネットワークオペレーションに関する改善されたスケーリング。
+    タグ用のサポートを追加。0.15以前のbzrとは互換性がない
+
+:rich-root:
+    (ネイティブ) 1.0での新しいフォーマット。ツリーrootの扱いを改善。1.0以前のbzrと互換性がない。
+
+
+詳細なストレージフォーマットは ``bzr help formats`` を参照してください。
+
+
+リビジョンの識別子
+====================
+
+リビジョンの識別子はブランチの履歴の特定の状態を参照します。
+これはリビジョン番号、もしくは ':' が後に続くキーワード、と他のパラメータになります。
+識別子の例として '3' 、 'last:1' 、 'before:yesterday' と 'submit:' などがあります。
+
+'REV1' と 'REV2' がリビジョンの識別子である場合、
+'REV1..REV2' はリビジョンの範囲を表示します。
+例: '3647..3649' 、 'date:yesterday..-1' と 'branch:/path/to/branch1/..branch:/branch2'
+('..'周辺にはクォートもしくはスペースが存在しません)。
+
+範囲は異なるコマンドによって異なる解釈がなされます。
+"log" コマンドに対して、範囲はログメッセージのシーケンスで、
+"diff" コマンドに対しては、範囲は(変更のシーケンスではなく)リビジョン間の変更を表示します。
+加えて、 "log" はclosed rangeを考慮するのに対して"diff"と"merge"はopen-endedとみなす、
+すなわち、これらは1つのendを含みますが他方は含みません。
+例です: "bzr log -r 3647..3649"はリビジョン3647、3648と3649のメッセージを表示するのに対して、
+"bzr diff -r 3647..3649"は3647と3648の間に行われた変更を含み、3649の変更は含みません。
+
+リビジョン選択方法として使用されるキーワードは次のとおりです:
+
+:revno:
+	番号を使用するリビジョンを選択する。
+:revid:
+	リビジョンidを使用するリビジョンを選択する。
+:last:
+	最後からn番目のリビジョンを選択する。
+:before:
+	指定されたリビジョンの親を選択する。
+:tag:
+	タグ名によって識別されるリビジョンを選択する。
+:date:
+	日付スタンプを基本とするリビジョンを選択する。
+:ancestor:
+	2番目のブランチで共通の祖先を選択する。
+:branch:
+	指定ブランチの最終リビジョンを選択する。
+:submit:
+	投稿ブランチで共通の祖先を選択する。
+
+加えて、プラグインは他のキーワードを提供できます。
+
+それぞれのキーワードの詳細な説明は下記のとおりです。
+
+:revno:
+
+    ブランチの履歴内のリビジョンを指定するために整数を使用する。
+    オプションとしてブランチを指定できます。接頭辞の 'revno:' はオプションです。
+    負の数はブランチの最後から数えます(-1は最後のリビジョン、-2はその前のリビジョン)。
+    負の数がブランチの履歴よりも大きい場合、最初のリビジョンが返されます。
+    例::
+
+      revno:1                   -> このブランチの最初のリビジョンを返す
+      revno:3:/path/to/branch   -> '/path/to/branch' ブランチの3番目のリビジョンを返す
+      revno:-1                  -> ブランチの最後のリビジョン。
+      -2:http://other/branch    -> リモートブランチの最後から2番目のリビジョン。
+      -1000000                  -> 履歴がとても長くなければ、おそらくは最初のリビジョン。
+
+:revid:
+
+    特定のリビジョンidを提供します。
+    ブランチの祖先のリビジョンidを指定するために使用できます。
+    マージと、マージの追加を含む。
+    例::
+
+      revid:aaaa@bbbb-123456789 -> リビジョン 'aaaa@bbbb-123456789' を選択する
+
+:last:
+
+    最後からn番目のリビジョンを取得するには正の数を提供する。
+    負の数の提供に関しては 'revno:' の仕様と同じです。
+    例::
+
+      last:1        -> 最後のバージョンを返す。
+      last:3        -> 最後の2つ前のリビジョンを返す。
+
+:before:
+
+    そのリビジョンの親を返すリビジョンスペックを提供する。
+    主にブランチのリビジョンの履歴の中に存在しないリビジョンを検査する際に便利です。
+
+    nullリビジョン(before:0)の親をリクエストするのは間違いです。
+
+    例::
+
+      before:1913    -> revno 1913の親を返す (revno 1912)
+      before:revid:aaaa@bbbb-1234567890  -> リビジョンaaaa@bbbb-1234567890の親を返す
+      bzr diff -r before:1913..1913
+            -> リビジョン1913とその親(1912)の間の変更を見つける
+               (リビジョン1913が導入する変更が行うこと)。
+               これは bzr diff -c 1913と同等です
+
+:tag:
+
+    タグはブランチに保存され、'tag'コマンドによって作成される。
+
+:date:
+
+    日付にマッチする最初のリビジョンを選択するためのデータスタンプを提供する。
+    日付は 'yesterday'、'today'、'tomorrow' もしくはYYYY-MM-DDの文字列です。
+    与えられた日付(深夜もしくは指定された時間のどちらか)の後の最初のエントリにマッチする。
+
+    昨日以降のすべての変更を表示する方法の1つは次のとおりです::
+
+        bzr log -r date:yesterday..
+
+    例::
+
+      date:yesterday            -> 昨日以降の最初のリビジョンを選択する
+      date:2006-08-14,17:10:14  -> August 14th, 2006 at 5:10pmの後の最初のリビジョンを選択する。
+
+:ancestor:
+
+    共通の祖先を選択するためにブランチへのパスを提供する。
+
+    共通の祖先は両方のブランチの中に存在する最後のリビジョンです。
+    通常これはブランチポイントですが、マージされたリビジョンにもなり得ます。
+
+    リモートブランチからマージしなかった変更を除外する一方で、
+    これはブランチが導入したすべての変更を返すために 'diff' でよく使用されます。
+
+    例::
+
+      ancestor:/path/to/branch
+      $ bzr diff -r ancestor:../../mainline/branch
+
+:branch:
+
+    最後のリビジョンを選択するためにブランチへのパスを提供する。
+
+    例::
+
+      branch:/path/to/branch
+
+:submit:
+
+    これに対する差分は、このブランチで行われたすべての変更を表示し、
+    マージされる予定のもののよい予測子です。
+    投稿ブランチはbundleとmergeコマンドによって使用されます。
+    投稿ブランチが指定されなければ、親ブランチが代わりに使用されます。
+
+    共通の祖先は両方のブランチ内に存在する最終リビジョンです。
+    通常これはブランチポイントですが、マージされたリビジョンにもなり得ます。
+
+    例::
+
+      $ bzr diff -r submit:
+
+
+標準オプション
+===============
+
+標準オプションはすべてのコマンドで有効です。
+
+--help, -h     ヘルプメッセージを表示する。
+--verbose, -v  詳細な情報を表示する。
+--quiet, -q    エラーと警告のみ表示する。
+
+グローバルオプションとは異なり、標準オプションはエイリアスで利用可能です。
+
+
+ステータスフラグ
+==================
+
+簡潔な方法で作業ツリーへの変更を要約するためにステータスフラグが使用されます。これらは次の形式をとります::
+
+   xxx   <filename>
+
+カラムの意味は次のとおりです。
+カラム 1 - バージョン管理/リネーム::
+
+  + バージョン管理されているファイル
+  - バージョン管理されていないファイル
+  R リネームされたファイル
+  ? 未知のファイル
+  C 衝突した内容を持つファイル
+  P マージを追加するためのエントリ(ファイルではない)
+
+カラム 2 - コンテンツ::
+
+  N 作成されたファイル
+  D 削除されたファイル
+  K 変更されたファイルの種類
+  M 修正されたファイル
+
+カラム 3 - 実行::
+
+  * 実行が少し変更された
+
+
+URLの識別子
+============
+
+サポートされるURLの接頭辞::
+
+  aftp://             アクティブFTPを利用したアクセス
+  bzr://              Bazaarスマートサーバーを利用したファーストアクセス
+  bzr+ssh://          SSHを通したBazaarスマートサーバーを利用したファーストアクセス
+  file://             標準ファイルシステムを利用したアクセス(デフォルト)
+  ftp://              パッシブFTPを利用したアクセス
+  http://             ウェブにエクスポートされたブランチへのリードオンリーのアクセス。
+  https://            SSLを利用したウェブにエクスポートされたブランチへのリードオンリーのアクセス。
+  sftp://             SFTPを利用したアクセス(大抵のSSHサーバーはSFTPを提供する)。
+
+
+.. _authentication: `認証の設定`_
+.. _bugs: `バグトラッカーの設定`_
+.. _configuration: `構成設定`_
+.. _conflicts: `衝突のタイプ`_
+.. _current-formats: `現在のストレージフォーマット`_
+.. _env-variables: `環境変数`_
+.. _global-options: `グローバルオプション`_
+.. _other-formats: `その他のストレージフォーマット`_
+.. _revisionspec: `リビジョンの識別子`_
+.. _standard-options: `標準オプション`_
+.. _status-flags: `ステータスフラグ`_
+.. _urlspec: `URLの識別子`_
+
+
+
+コマンド
+#########
+
+add
+===
+:目的: 指定したファイルもしくはディレクトリを追加する。
+:使い方:   bzr add [FILE...]
+
+:オプション:
+  --dry-run            何が行われるか表示するが、実際には行わない。
+  -v, --verbose        詳細な情報を表示する。
+  --no-recurse         ディレクトリの内容を再帰的に追加しない。
+  -h, --help           ヘルプメッセージを表示する。
+  -q, --quiet          エラーと警告だけ表示する。
+  --file-ids-from=ARG  このツリーからファイルのidを探索する。
+
+:説明:
+  non-recursiveモードでは、以前無視されたファイルであっても、
+  名前つきのすべてのアイテムが追加されます。
+  名前つきファイルがすでにバージョン管理されている場合は警告が表示されます。
+
+  recursiveモード(デフォルト)では、ファイルは同じ方法で扱われますが、
+  ディレクトリに対するふるまいは異なります。
+  すでにバージョン管理されているディレクトリであれば警告は表示されません。
+  すべてのディレクトリは、バージョン管理されているかいないかに関わらず、
+  ファイルもしくはバージョン管理も無視もされているサブディレクトリのための検索対象になり、
+  これらは追加されます。
+  この検索はバージョン管理されたディレクトリにも再帰的に進められます。
+  名前が渡されなければ、'.'が想定されます。
+
+  それゆえ単に 'bzr add' を実行すると現在未知であるファイルのすべてがバージョン管理されます。
+
+  親ディレクトリがバージョン管理されていないファイルを追加すると
+  親およびそのrootまでも暗黙の内に追加されます。
+  このことが意味するのはディレクトリを明示的に追加する必要はなく、
+  ディレクトリの中のファイルを1つ追加するときにそれらのディレクトリも追加されます。
+
+  --dry-runは追加されるファイルを表示しますが、それらを実際に追加しません。
+
+  --file-ids-fromは提供されたパスからファイルのidの使用を試みます。
+  これは同じファイル名を持ちマッチするディレクトリの発見をするためにidを探し、また純粋なパスによって行います。
+  このオプションが必要になるのはめったにありませんが、後でマージする2つのブランチに同じ論理ファイルを追加する
+  ときに便利です(2つの異なる追加を衝突として表示しません)。
+  別のプロジェクトをこのプロジェクトのサブディレクトリにマージする際にも便利です。
+
+:関連コマンド: `remove`_
+
+
+alias
+=====
+:目的: エイリアスの設定/設定解除と表示を行う。
+:使い方:   bzr alias [NAME]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  --remove       エイリアスを削除する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:例:
+    現在のエイリアスを表示するには::
+
+        bzr alias
+
+    'll'用に指定されたエイリアスを表示するには::
+
+        bzr alias ll
+
+    'll'のエイリアスを設定するには::
+
+        bzr alias ll="log --line -r-10..-1"
+
+    'll'のエイリアスを削除するには::
+
+        bzr alias --remove ll
+
+
+
+annotate
+========
+:目的: ファイルのそれぞれの行のoriginを表示する。
+:使い方:   bzr annotate FILENAME
+
+:オプション:
+  --all                 すべての行の注釈を表示する。
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --long                注釈のコミット日時を表示する。
+  --show-ids            内部のオブジェクトidを表示する。
+  -r ARG, --revision=ARG
+                        "help revisionspec"の詳細を参照。
+
+:説明:
+  このコマンドは与えられたファイルの、変更によって導入されたリビジョン、
+  筆者と日付を示す注釈を左側で表示します。
+
+  連続した行の続きに関してoriginが同じ場合、
+  --allオプションが渡されない限り、これはトップでのみ表示されます。
+
+:エイリアス:  ann, blame, praise
+
+
+bind
+====
+:目的: 現在のブランチを提供されたブランチのチェックアウトに変換する。
+:使い方:   bzr bind [LOCATION]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  チェックアウトに変換されると、コミットはローカルブランチに適用される前に
+  コミットはマスターブランチを継承しなければなりません。
+
+  ローカルに設定されない限りバインドされたブランチは
+  マスターブランチのニックネームを使用します。
+  この場合、バインディングはローカルなニックネームをマスターのものに更新します。
+
+:関連コマンド: `checkout`_, `unbind`_
+
+
+branch
+======
+:目的: ブランチの新しいコピーを作成する。
+:使い方:   bzr branch FROM_LOCATION [TO_LOCATION]
+
+:オプション:
+  --stacked             ソースブランチを参照するスタックドブランチを作成する。
+                        すべてのオペレーションに関して
+                        新しいブランチはソースブランチの利用可能性に依存する。
+  -v, --verbose         詳細な情報を表示する。
+  --standalone          利用可能であっても共用リポジトリを使用しない。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --hardlink            可能な作業ツリーファイルをハードリンクする。
+  -r ARG, --revision=ARG
+                        詳細は "help revisionspec" を参照。
+
+:説明:
+  TO_LOCATIONが省略されると、FROM_LOCATIONの最終コンポーネントが使用されます。
+  言い換えると、 "branch ../foo/bar" は./bar を作成しようとします。
+  FROM_LOCATIONが/を持たない もしくは埋め込みのパスの区切り文字を持つ場合
+  冒頭のスキームもしくはドライブの識別子を剥ぎ取ることで、
+  FROM_LOCATIONからTO_LOCATIONが得られます。
+  たとえば、"branch lp:foo-bar"は./foo-barを作成しようとします。
+
+  ブランチの特定のリビジョンを読み取るには、
+  "branch foo/bar -r 5"のような、--revisionパラメータを提供します。
+
+:エイリアス:  get, clone
+:関連コマンド: `checkout`_
+
+
+break-lock
+==========
+:目的: リポジトリ、ブランチもしくは作業ディレクトリのデッドロックをブレークする。
+:使い方:   bzr break-lock [LOCATION]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  警告: ロックを保持するプロセスが停止したときにのみロックはブレークします。
+
+  'bzr info'コマンドを通して開いているロックに関する情報を得ることができます。
+
+:例:
+    bzr break-lock
+
+
+
+cat
+===
+:目的: 与えられたリビジョンのファイルの内容を標準出力に書き込む。
+:使い方:   bzr cat FILENAME
+
+:オプション:
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --name-from-revision  古いツリーのパス名。
+  -h, --help            ヘルプメッセージを表示する。
+
+:説明:
+  リビジョンが指定されなければ、最後のリビジョンが使用されます。
+
+  注意: バイナリファイルでこのコマンドを使用する際には
+        標準出力をリダイレクトするように気をつけてください。
+
+:関連コマンド: `ls`_
+
+
+check
+=====
+:目的: 作業ツリーの構造、ブランチの一貫性、とリポジトリの履歴をバリデートする。
+:使い方:   bzr check [PATH]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  --tree         現在のディレクトリに関連した作業ツリーをチェックする。
+  -q, --quiet    エラーと警告だけ表示する。
+  --repo         現在のディレクトリに関連したリポジトリをチェックする。
+  --branch       現在のディレクトリに関連したブランチをチェックする。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドはデータの破損もしくはbzrのバグを検出するために
+  ブランチとリポジトリストレージに関するさまざまな不変量をチェックします・
+
+  問題が検出された場合のみ作業ツリーとブランチのチェックは出力をします。
+  リポジトリチェックの出力フィールドは次のとおりです:
+
+      revisions: これはチェックされるリビジョンの番号です。
+          これは問題を示しません。
+      versionedfiles: これはチェックされるバージョン管理されたファイルの数です。
+          これは問題を示しません。
+      unreferenced ancestors: 他のテキストの祖先であるテキストは、
+          リビジョンの祖先によって適切に参照されません。
+          これはBazaarが対処できるsubtleな問題です。
+      unique file texts: チェックされるリビジョンで見つかる
+          ファイルの内容の合計数です。これは問題を示しません。
+      repeated file texts: チェックされるリビジョンで見つかる、
+          繰り返されるテキストの合計数です。
+          テキストのエントリが修正されたときにテキストは繰り返しできますが、
+          ファイルの内容は繰り返しできません。
+          これは問題を示しません。
+
+  制限が指定されなければ、すべてのBazaarデータはチェックされる位置で見つかります。
+
+:例:
+    'foo' でのツリーとブランチをチェックする::
+
+        bzr check --tree --branch foo
+
+    'bar'でのリポジトリのみをチェックする::
+
+        bzr check --repo bar
+
+    'baz' ですべてをチェックする::
+
+        bzr check baz
+
+:関連コマンド: `reconcile`_
+
+
+checkout
+========
+:目的: 既存のブランチの新しいチェックアウトを作成する。
+:使い方:   bzr checkout [BRANCH_LOCATION] [TO_LOCATION]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  --files-from=ARG      このツリーからファイルの内容を取得する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --hardlink            利用可能な作業ツリーファイルをハードリンクする。
+  --lightweight         軽量チェックアウトを実行する。オペレーションに関して
+                        軽量チェックアウトはブランチへの権限に依存する。
+                        通常のチェックアウトはdiffやstatusのようなアクセスが
+                        不要な共通のオペレーションを実行可能で、
+                        ローカルコミットもサポートします。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  BRANCH_LOCATIONが省略されると、'.'で見つかるブランチ用に
+  チェックアウトは作業ツリーを再構成します。
+  作業ツリーを削除した場合もしくはこれがけっして作成されない場合
+  - すなわち、SFTPを使用してブランチを現在の位置にpushする場合、これは便利です。
+
+  TO_LOCATIONが省略されると、BRANCH_LOCATIONの最後のコンポーネントが使用されます。
+  言い換えると、"checkout ../foo/bar" は./barを作成しようとします。
+  BRANCH_LOCATIONが has no /を持たないもしくはパスの区切り文字が埋め込まれている場合、
+  先頭のスキームもしくはドライブの識別子を除去することでBRANCH_LOCATIONからTO_LOCATIONが
+  得られます。たとえば、"checkout lp:foo-bar"は./foo-barを作成しようとします。
+
+  特定のリビジョンのブランチを読み取るには、
+  "checkout foo/bar -r 5"のように--revisionパラメータを提供します。
+  これはすぐに時代遅れになりますが[なのでコミットできない]
+  役に立つことがあります(すなわち古いコードを検査するため)。
+
+:エイリアス:  co
+:関連コマンド: `branch`_, `チェックアウト`_
+
+
+commit
+======
+:目的: 変更を新しいリビジョンにコミットする。
+:使い方:   bzr commit [SELECTED...]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  --author=ARG          著者の名前がコミッターとは異なる場合、著者の名前を設定する。
+  --unchanged           何も変更されていなくてもコミットする。
+  --fixes=ARG           このリビジョンをバグが修正されたものとしてマークする。
+  -q, --quiet           エラーと警告のみを表示する。
+  --show-diff           メッセージが提供されないとき、
+                        メッセージエディタでステータスの要約と一緒に差分を表示する。
+  --strict              作業ツリーの中に未知のファイルが存在する場合コミットを拒否する。
+  -F MSGFILE, --file=MSGFILE
+                        このファイルからコミットメッセージを取得する。
+  -x ARG, --exclude=ARG
+                        与えられたパスへの変更を考慮しない。
+  -m ARG, --message=ARG
+                        新しいリビジョンの説明。
+  --local               バインドされたブランチにローカルコミットを実行する。
+                        通常のコミットが実行されるまで
+                        ローカルコミットはマスターブランチにpushされません。
+
+  -h, --help            ヘルプメッセージを表示する。
+
+:説明:
+  引数が渡されなければ、ツリー全体がコミットされます。
+
+  選択されたファイルが指定されると、これらのファイルへの変更のみがコミットされます。
+  ディレクトリが指定されるとディレクトリとその中のすべてがコミットされます。
+
+  excludesが渡されるとき、これらは選択されたファイルよりも優先されます。
+  たとえば、fooの範囲での変更のみコミットされますが、foo/barの範囲の変更はコミットされません::
+
+    bzr commit foo -x foo/bar
+
+  変更の著者がコミッターと同じ人物でなければ、
+  --authorオプションを使用して著者の名前を指定できます。
+  名前はコミッターidと同じフォーマットです。たとえば"John Doe <jdoe@example.com>"です。
+
+  コミットされるツリーが無効である場合選択されたファイルのコミットが失敗することがあります。
+  次の一連のコマンドを考えてみましょう::
+
+    bzr init foo
+    mkdir foo/bar
+    bzr add foo/bar
+    bzr commit foo -m "committing foo"
+    bzr mv foo/bar foo/baz
+    mkdir foo/bar
+    bzr add foo/bar
+    bzr commit foo/bar -m "committing bar but not baz"
+
+  上記の例において、最終コミットは故意に失敗します。
+  これによってユーザーは、同時に、最初に個別に、もしくはまったく
+  リネームしたくないかどうかを決める機会を得ます。
+  (一般的なルールとして、判断がつかないとき、Bazaarは安全に物事を行う方針を持ちます。)
+
+  注: マージの後の選択されたファイルのコミットはまだサポートされていません。
+
+:エイリアス:  ci, checkin
+:関連コマンド: `bugs`_, `uncommit`_
+
+
+conflicts
+=========
+:目的: 衝突を持つファイルの一覧を表示する。
+:使い方:   bzr conflicts
+
+:オプション:
+  --text         テキストの衝突を持つファイルのパスの一覧を表示する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  マージは2つのブランチの変更を結合するために最善を尽くしますが、
+  人間だけが修正できるある種の問題が存在します。
+  この問題に遭遇するとき、衝突がマークされます。
+  衝突はコミットする前に何かを修正する必要があることを意味します。
+
+  通常の衝突は短く人間が読めるメッセージとして一覧が示されます。
+  --textが提供される場合、代わりに、テキストの衝突を持つファイルのパスの一覧が表示されます。
+  (これはテキストの衝突を持つファイルをすべて編集するために便利です。)
+
+  問題を修正したらbzr resolveを使用します。
+
+:関連コマンド: `resolve`_
+
+
+
+deleted
+=======
+:目的: 作業ツリーの中で削除されたファイルの一覧を表示する。
+:使い方:   bzr deleted
+
+:オプション:
+  --show-ids     内部のオブジェクトidを表示する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:関連コマンド: `ls`_, `status`_
+
+
+diff
+====
+:目的: リビジョンもしくはブランチの間の、作業ツリーの中の違いを表示する。
+:使い方:   bzr diff [FILE...]
+
+:オプション:
+  --old=ARG             から比較するブランチ/ツリー。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -p ARG, --prefix=ARG  コロンによって区切られた2つの値として
+                        新旧のファイル名に追加される接頭辞を設定する(たとえば"old/:new/")。
+  --using=ARG           ファイルを比較するためにこのコマンドを使用する。
+  --new=ARG             へ比較するブランチ/ツリー。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  --diff-options=ARG    これらのオプションを外部diffプログラムに渡す。
+  -c ARG, --change=ARG  指定されたリビジョンによって導入された変更を選択する。
+                        "help revisionspec"も参照。
+  -h, --help            ヘルプメッセージを表示する。
+
+:説明:
+  引数が渡されなければ、現在のツリーに対するすべての変更の一覧が表示されます。
+  ファイルが渡されれば、これらのファイルの中の変更の一覧だけが表示されます。
+  リモートと複数のブランチは--oldと--newオプションを使用して比較できます。
+  これらのオプションが提供されなければ、両方のデフォルトは、存在すれば最初の引数、
+  引数が渡されなければ現在のツリーから得られます。
+
+  "bzr diff -p1" は "bzr diff --prefix old/:new/"と同等で、
+  "patch -p1"に最適なパッチが生成されます。
+
+:例:
+    作業ツリーと最終コミットの間の違いを表示する::
+
+        bzr diff
+
+    作業ツリーとリビジョン1の間の違い::
+
+        bzr diff -r1
+
+    リビジョン1とリビジョン2の間の違い::
+
+        bzr diff -r1..2
+
+    ブランチxxxのリビジョン1とリビジョン2の間の違い::
+
+        bzr diff -r1..2 xxx
+
+    NEWSファイルの違いだけ表示する::
+
+        bzr diff NEWS
+
+    NEWSファイルに対する作業ツリーの中の違いを表示する::
+
+        bzr diff xxx/NEWS
+
+    xxxブランチからこの作業ツリーの違いを表示する:
+
+        bzr diff --old xxx
+
+    NEWSファイルに対する2つのブランチの違いを表示する::
+
+        bzr diff --old xxx --new yyy NEWS
+
+    'bzr diff'と同じであるがold/とnew/でパスに接頭辞を追加する::
+
+        bzr diff --prefix old/:new/
+
+:Exitの値:
+    1 - 変更された
+    2 - 表現できない変更
+    3 - エラー
+    0 - 変更なし
+
+
+:エイリアス:  di, dif
+:関連コマンド: `status`_
+
+
+export
+======
+:目的: 現在のリビジョンを指定されたディレクトリもしくはアーカイブにエクスポートする。
+:使い方:   bzr export DEST [BRANCH_OR_SUBDIR]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  --format=ARG          Type of file to export to.
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --root=ARG            エクスポートされたファイル内部のrootディレクトリの名前。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  リビジョンが指定されなければこれは最終コミットのリビジョンをエクスポートします。
+
+  フォーマットはtar、tgz、tbz2のような"exporter"の名前になることができます。
+  何も渡されなければ、拡張子かｒフォーマットを見つけようとします。
+  拡張子が見つからなければディレクトリにエクスポートします(--format=dirと同等)。
+
+  rootが提供されると、これはコンテナフォーマット(tar、zip、その他)内部のrootディレクトリとして使用されます。
+  これが提供されなければエクスポートされるファイル名へのデフォルトになります。
+  rootオプションは'dir'フォーマットに対して効果がありません。
+
+  ブランチが省略されると現在の作業ディレクトリを含むブランチが使用されます。
+
+  注: ASCIIではないファイル名でのツリーのエクスポートはサポートされません。
+
+    ==========================       =========================
+    サポートされるフォーマット        拡張子で自動検出
+    ==========================       =========================
+       dir                              (none)
+       tar                               .tar
+       tbz2                              .tar.bz2, .tbz2
+       tgz                               .tar.gz, .tgz
+       zip                               .zip
+    ==========================       =========================
+
+
+
+help
+====
+:目的: コマンドもしくは他のトピックのヘルプを表示する。
+:使い方:   bzr help [TOPIC]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  --long         すべてのコマンドのヘルプを表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:エイリアス:  ?, --help, -?, -h
+:関連コマンド: topics
+
+
+ignore
+======
+:目的: 指定されたファイルもしくはパターンを無視する。
+:使い方:   bzr ignore [NAME_PATTERN...]
+
+:オプション:
+  --old-default-rules   bzr < 0.9で使用される無視ルールを書き出す。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -h, --help            ヘルプメッセージを表示する。
+
+:説明:
+  パターンの構文の詳細は ``bzr help patterns`` を参照。
+
+  無視リストからパターンを除外するには、.bzrignoreファイルを編集します。
+  追加した後で、コマンドを使用して間接的に、もしくはエディタを使用して
+  直接そのファイルを編集もしくは削除した後で、そのコミットを確認してください。
+
+  注: シェルのワイルドカードを含む無視パターンはUnixのシェルからクォートされなければなりません。
+
+:例:
+    トップレベルのMakefileを無視する::
+
+        bzr ignore ./Makefile
+
+    すべてのディレクトリのクラスファイルを無視する::
+
+        bzr ignore "*.class"
+
+    libディレクトリ下の.oファイルを無視する::
+
+        bzr ignore "lib/**/*.o"
+
+    libディレクトリ下の.oファイルを無視する::
+
+        bzr ignore "RE:lib/.*\.o"
+
+    "debian"トップレベルディレクトリ以外のすべてを無視する::
+
+        bzr ignore "RE:(?!debian/).*"
+
+:関連コマンド: `ignored`_, `パターン`_, `status`_
+
+
+ignored
+=======
+:目的: 無視するファイルとそれらにマッチするパターンの一覧を表示する。
+:使い方:   bzr ignored
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  無視されるファイルと無視パターンのすべての一覧を表示します。
+
+  代わりにファイルの一覧だけを表示するには::
+
+      bzr ls --ignored
+
+:関連コマンド: `ignore`_, `ls`_
+
+
+info
+====
+:目的: 作業ツリー、ブランチもしくはリポジトリに関する情報を表示する。
+:使い方:   bzr info [LOCATION]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドはツリー、ブランチもしくはリポジトリに関連する既知の位置とフォーマットのすべてを表示します。
+  統計情報はそれぞれのレポートに含まれます。
+
+  ブランチと作業ツリーは見つからないリビジョンもレポートします。
+
+:関連項目: `リポジトリ`_, `revno`_, `作業ツリー`_
+
+
+init
+====
+:目的: ディレクトリをバージョン管理下にあるブランチにする。
+:使い方:   bzr init [LOCATION]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  --create-prefix       ブランチに通じるパスがまだ存在していなければそれを作成する。
+  --append-revisions-only
+                        revnosもしくは既存のログを変更しない。
+                        リビジョンを追加するのみ。
+  -q, --quiet           エラーと警告のみを表示する。
+  -h, --help            ヘルプメッセージを表示する。
+
+  ブランチのフォーマット::
+
+    --format=ARG        このブランチのフォーマットを指定する。"help formats"を参照。
+    --1.12-preview      ビューとコンテンツのフィルタリングをサポートする作業ツリーフォーマット。
+    --1.12-preview-rich-root
+                        rich-rootデータをサポートする1.12-previewのバリアント(bzr-svnに必要)
+    --1.6               スタックをサポートするリポジトリに基づいたブランチとパック。
+    --1.6.1-rich-root   スタックとリッチなrootデータをサポートするリポジトリに基づいた
+                        ブランチとパック(bzr-svnに必要)。
+    --1.9               btreeインデックスを使用するリポジトリに基づいたブランチとパック
+    --1.9-rich-root     btreeインデックスとリッチrootデータを使用する
+                        リポジトリに基づいたブランチとパック(bzr-svnに必要)。
+    --default           0.92の新しい機能: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用しますが
+                        bzr < 0.92では読むことができません。
+                        以前はknitpack-experimentalと呼ばれていました。
+                        詳細な情報は http://doc.bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --development       現在の開発フォーマット。データをpack-0.92 (とpack-0.92と互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devによってのみ読み込みできます。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-repo.html を参照して頂くようお願いします。
+    --development-subtree
+                        現在の開発フォーマットで、subtreeバリアント。
+                        データをpack-0.92-subtree(とpack-0.92-subtreeと互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devでのみ読み込みできる。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-
+                        repo.html をご覧いただくようお願いします。
+    --dirstate          0.15の新しいフォーマット: 速いローカルオペレーション。
+                        ネットワークを通したアクセスのときbzr 0.8とそれ以降と互換性がある。
+    --dirstate-tags     0.15の新しいフォーマット: 速いローカルオペレーションで
+                        ネットワークオペレーションに関するスケーリングを改善。
+                        タグのサポートを追加。bzr < 0.15とは互換性がない。
+    --knit              knitsを使用するフォーマット。bzr <= 0.14との相互運用に推奨。
+    --metaweave         0.8での暫定フォーマット。knitよりも遅い。
+    --pack-0.92         0.92の新しいフォーマット: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用できるがbzr < 0.92.によって読み込みできない。
+                        以前はknitpack-experimentalと呼ばれていた。
+                        詳細な情報に関しては、 http://doc
+                        .bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --rich-root         1.0の新しいフォーマット。ツリーrootのベターな扱い。
+                        bzr < 1.0と互換性がない。
+    --rich-root-pack    1.0の新しいフォーマット: rich-rootデータをサポートする
+                        pack-0.92のバリアント(bzr-svnに必要)。
+    --weave             0.8以前のフォーマット。knitよりも遅く
+                        チェックアウトもしくは共用リポジトリをサポートしない。
+
+:説明:
+  空のブランチを作成するもしくは既存のプロジェクトをインポートする前に使用します。
+
+  親ディレクトリの位置にリポジトリが存在する場合、
+  ブランチの履歴はリポジトリに保存されます。
+  さもなければinitは.bzrのディレクトリに独自の履歴を運ぶスタンドアロンのブランチを作成します。
+
+  ロケーションにブランチがすでにあるが作業ツリーがない場合、ツリーは'bzr checkout'で投入できます。
+
+  ファイルのツリーをインポートする方法のレシピです::
+
+      cd ~/project
+      bzr init
+      bzr add .
+      bzr status
+      bzr commit -m "imported project"
+
+:関連コマンド: `branch`_, `checkout`_, `init-repository`_
+
+
+init-repository
+===============
+:目的: ブランチを保持する共用リポジトリを作成する。
+:使い方:   bzr init-repository LOCATION
+
+:オプション:
+  --no-trees            リポジトリのブランチはデフォルトで作業ツリーを持ちません。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -h, --help            ヘルプメッセージを表示する。
+
+  ブランチのフォーマット::
+
+    --format=ARG        このブランチのフォーマットを指定する。"help formats"を参照。
+    --1.12-preview      ビューとコンテンツのフィルタリングをサポートする作業ツリーフォーマット。
+    --1.12-preview-rich-root
+                        rich-rootデータをサポートする1.12-previewのバリアント(bzr-svnに必要)
+    --1.6               スタックをサポートするリポジトリに基づいたブランチとパック。
+    --1.6.1-rich-root   スタックとリッチなrootデータをサポートするリポジトリに基づいた
+                        ブランチとパック(bzr-svnに必要)。
+    --1.9               btreeインデックスを使用するリポジトリに基づいたブランチとパック
+    --1.9-rich-root     btreeインデックスとリッチrootデータを使用する
+                        リポジトリに基づいたブランチとパック(bzr-svnに必要)。
+    --default           0.92の新しい機能: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用しますが
+                        bzr < 0.92では読むことができません。
+                        以前はknitpack-experimentalと呼ばれていました。
+                        詳細な情報は http://doc.bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --development       現在の開発フォーマット。データをpack-0.92 (とpack-0.92と互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devによってのみ読み込みできます。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-repo.html を参照して頂くようお願いします。
+    --development-subtree
+                        現在の開発フォーマットで、subtreeバリアント。
+                        データをpack-0.92-subtree(とpack-0.92-subtreeと互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devでのみ読み込みできる。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-
+                        repo.html をご覧いただくようお願いします。
+    --dirstate          0.15の新しいフォーマット: 速いローカルオペレーション。
+                        ネットワークを通したアクセスのときbzr 0.8とそれ以降と互換性がある。
+    --dirstate-tags     0.15の新しいフォーマット: 速いローカルオペレーションで
+                        ネットワークオペレーションに関するスケーリングを改善。
+                        タグのサポートを追加。bzr < 0.15とは互換性がない。
+    --knit              knitsを使用するフォーマット。bzr <= 0.14との相互運用に推奨。
+    --metaweave         0.8での暫定フォーマット。knitよりも遅い。
+    --pack-0.92         0.92の新しいフォーマット: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用できるがbzr < 0.92.によって読み込みできない。
+                        以前はknitpack-experimentalと呼ばれていた。
+                        詳細な情報に関しては、 http://doc
+                        .bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --rich-root         1.0の新しいフォーマット。ツリーrootのベターな扱い。
+                        bzr < 1.0と互換性がない。
+    --rich-root-pack    1.0の新しいフォーマット: rich-rootデータをサポートする
+                        pack-0.92のバリアント(bzr-svnに必要)。
+    --weave             0.8以前のフォーマット。knitよりも遅く
+                        チェックアウトもしくは共用リポジトリをサポートしない。
+
+:説明:
+  ブランチのディレクトリではなく、リポジトリにリビジョンを保存する
+  リポジトリディレクトリの元で作成された新しいブランチ。
+
+  --no-treesオプションが使用されるとリポジトリのブランチはデフォルトで作業ツリーを持ちません。
+
+:例:
+    ブランチだけを保有する共用リポジトリを作成する::
+
+        bzr init-repo --no-trees repo
+        bzr init repo/trunk
+
+    軽量チェックアウトを作成する::
+
+        bzr checkout --lightweight repo/trunk trunk-checkout
+        cd trunk-checkout
+        (add files here)
+
+:エイリアス:  init-repo
+:関連項目: `branch`_, `checkout`_, `init`_, `リポジトリ`_
+
+
+log
+===
+:目的: ブランチ、ファイル、もしくはディレクトリのログを表示する。
+:使い方:   bzr log [LOCATION]
+
+:オプション:
+  -v, --verbose         それぞれのリビジョンで変更されたファイルを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -l N, --limit=N       出力を最初のNのリビジョンに制限する。
+  --forward             最古から最新までを表示する。
+  --timezone=ARG        ローカル、オリジナル、utcのタイムゾーンを表示する。
+  --show-ids            内部オブジェクトidを表示する。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  -m ARG, --message=ARG
+                        メッセージが正規表現にマッチするリビジョンを表示する。
+  -c ARG, --change=ARG  指定されたリビジョンだけを表示する。"help revisionspec"も参照。
+  -h, --help            ヘルプメッセージを表示する。
+
+  ログのフォーマット::
+    --log-format=ARG    指定されたログフォーマットを使用する。
+    --line              リビジョン単位の1行のログフォーマット
+    --long              詳細なログフォーマット
+    --short             適切に短いログフォーマット
+
+:説明:
+  デフォルトでは作業ディレクトリを含むブランチのログを表示する。
+
+  ログの範囲をリクエストするには、-r begin..endコマンドを使用できます。
+  -r revisionは指定したリビジョンをリクエストし、
+  -r ..end もしくは -r begin.. も有効です。
+
+:例:
+    現在のブランチのログ::
+
+        bzr log
+
+    ファイルのログ::
+
+        bzr log foo.c
+
+    ブランチの最後の10リビジョンのログ::
+
+        bzr log -r -10.. http://server/branch
+
+
+
+ls
+==
+:目的: ツリーのファイルの一覧を表示する。
+:使い方:   bzr ls [PATH]
+
+:オプション:
+  --from-root           ブランチのrootから相対的なパスを出力する。
+  --ignored             無視されたファイルを出力する。
+  --kind=ARG            特定の種類:file、directory、symlinkのエントリの一覧を表示する。
+  -v, --verbose         詳細な情報を表示する。
+  -V, --versioned       バージョン管理されたファイルを出力する。
+  --unknown             未知のファイルを出力する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --non-recursive       サブディレクトリで再帰的処理を行わない。
+  --show-ids            内部オブジェクトidを表示する。
+  --null                ファイルの間に改行の代わりに NUL (\0) 区切り文字を書く。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:関連項目: `cat`_, `status`_
+
+
+merge
+=====
+:目的: 三方向マージを実行する。
+:使い方:   bzr merge [LOCATION]
+
+:オプション:
+  --pull                すでに対象が完全にソースにマージされる場合、
+                        マージよりもソースからpullする。
+                        これが起きるとき、結果をコミットする必要はない。
+  --remember            指定されたロケーションをデフォルトとして記録する。
+  --force               目的のツリーがコミットされていない変更を持っていてもマージする。
+  -v, --verbose         詳細な情報を表示する。
+  --reprocess           誤った衝突を減らすために再処理する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --uncommitted         ブランチの変更の代わりに、作業ツリーからコミットされていない変更を適用する。
+
+  -d ARG, --directory=ARG
+                        作業ディレクトリを含むものよりも、マージするブランチ。
+  --show-base           衝突のベースリビジョンテキストを表示する。
+  --preview             マージする代わりに、マージの差分を表示する。
+  -c ARG, --change=ARG  指定されたリビジョンで導入された変更を選択する。
+                        "help revisionspec"も参照。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+  マージアルゴリズム::
+    --merge-type=ARG    特定のマージアルゴリズムを選択する。
+    --diff3             外部diff3を使用するマージ
+    --lca               新しいLCAマージ
+    --merge3            ネイティブのdiff3スタイルのマージ
+    --weave             weaveベースのマージ
+
+:説明:
+  マージのソースはブランチの形式、もしくはbzr sendで生成された
+  mergeディレクティブを含むファイルへのパスの形式で指定できます。
+  どちらも指定されなければ、デフォルトは上流ブランチもしくは
+  --rememberを使用して最近マージされたブランチです。
+
+  マージをブランチするとき、デフォルトではチップがマージされます。
+  異なるリビジョンをピックするには、--revisionを渡します。
+  2つの値を指定する場合、最初の値はBASEとして、2番目の値はOTHERとして使用されます。
+  個別のリビジョン、もしくはこのように利用可能なリビジョンのサブセットをマージすることは
+  一般的に"チェリーピック"として言及されます。
+
+  リビジョン番号はマージされるブランチに対して常に相対的です。
+
+  デフォルトでは、bzrは、自動的に適切なベースを検出して、
+  他のブランチからすべてのネットワークでマージしようとします。
+  これが失敗すると、明示的なベースを渡すことが必要になることがあります。
+
+  マージは2つのブランチの変更を結合するために最善を尽くしますが、
+  人間だけが修正できる種類の問題があります。
+  この問題に遭遇するとき、衝突マークがつけられます。
+  衝突はコミットする前に何かを修正する必要があることを意味します。
+
+  問題を修正したらbzr resolveを使用します。bzr conflictsも参照してください。
+
+  デフォルトのブランチセットが存在しない場合、最初のマージはそれを設定します。
+  その後で、デフォルトを使用するブランチを省略できます。
+  デフォルトを変更するには、--rememberを使用します。
+  リモートロケーションがアクセス可能場合のみ値は保存されます。
+
+  マージの結果は目的の作業ディレクトリに設置されます。
+  このディレクトリは(bzr diffで)閲覧、テスト、
+  とマージの結果を記録するためにコミット可能です。
+
+  --forceが渡されない限り、コミットされていない変更が存在すればマージの実行は拒否されます。
+
+:例:
+    bzr.devから最新のリビジョンをマージするには::
+
+        bzr merge ../bzr.dev
+
+    bzr.devからリビジョン82を含めて変更をマージするには::
+
+        bzr merge -r 82 ../bzr.dev
+
+    以前の変更なしに、82で導入された変更をマージするには::
+
+        bzr merge -r 81..82 ../bzr.dev
+
+    /tmp/mergeに含まれるmergeディレクトリを適用するには:
+
+        bzr merge /tmp/merge
+
+:関連項目: `remerge`_, `status-flags`_, `update`_
+
+
+missing
+=======
+:目的: 2つのブランチの間のmergeされていない/pullされていない リビジョンを表示する。
+:使い方:   bzr missing [OTHER_BRANCH]
+
+:オプション:
+  --reverse            リビジョンの順序をリバースする。
+  --this               --mine-onlyと同じ。
+  -h, --help           ヘルプメッセージを表示する。
+  -q, --quiet          エラーと警告だけ表示する。
+  --other              --theirs-onlyと同じ。
+  --include-merges     マージされたリビジョンを表示する。
+  --mine-only          ローカルブランチの変更のみを表示する。
+  --show-ids           内部オブジェクトidを表示する。
+  --theirs-only        リモートブランチの変更のみを表示する。
+  -v, --verbose        詳細な情報を表示する。
+
+  ログフォーマット::
+    --log-format=ARG   指定したログフォーマットを使用する。
+    --line             リビジョンごとの1行のログフォーマット
+    --long             詳細なログフォーマット
+    --short            適切に短いログフォーマット
+
+:説明:
+  OTHER_BRANCHはlocalもしくはremoteになります。
+
+:関連項目: `merge`_, `pull`_
+
+
+mkdir
+=====
+:目的: バージョン管理下にある新しいディレクトリを作成する。
+:使い方:   bzr mkdir DIR...
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  これはディレクトリの作成と追加と同等です。
+
+
+
+mv
+==
+:目的: ファイルを移動もしくはリネームする。
+:使い方:
+    bzr mv OLDNAME NEWNAME
+
+    bzr mv SOURCE... DESTINATION
+
+
+:オプション:
+  --after        ファイルがすでに移動しているので、ファイルのbzr識別子のみを移動させる。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  最後の引数がバージョン管理されているディレクトリの場合、
+  他のすべての名前はそこに移動します。
+  さもなければ、2つの引数だけにしなければならず
+  ファイルは新しい名前に変更されます。
+
+  OLDNAMEがファイルシステム上に存在しないがバージョン管理されていて
+  NEWNAMEはファイルシステム上に存在せずバージョン管理もされていない場合、
+  mvはファイルが手動で移動させられその変更を反映するために
+  内部インベントリだけを更新することを想定します。
+  多くのSOURCEファイルをDESTINATIONに移動させるときも同じです。
+
+  ブランチの間でファイルを移動させることはできません。
+
+:エイリアス:  move, rename
+
+
+nick
+====
+:目的: ブランチのニックネームを表示もしくは設定する。
+:使い方:   bzr nick [NICKNAME]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  設定が解除されると、ツリーのrootディレクトリの名前がニックネームとして使用されます。
+  現在のニックネームを表示するには、引数なしで実行します。
+
+  ローカルに設定されていない限りバインドされたブランチはマスターブランチのニックネームを使用します。
+
+:関連コマンド: `info`_
+
+
+pack
+====
+:目的: リポジトリ内のデータを圧縮する。
+:使い方:   bzr pack [BRANCH_OR_REPO]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:関連コマンド: `リポジトリ`_
+
+
+plugins
+=======
+:目的: インストールされたプラグインの一覧を表示する。
+:使い方:   bzr plugins
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドはプラグインのバージョンとそれぞれの手短な説明を含めて
+  インストールされたプラグインの一覧を表示します
+
+  --verboseはそれぞれのプラグインが設置されたパスを表示します。
+
+  プラグインはコードを追加したり置き換えたりすることで
+  リビジョン管理システムを拡張する外部コンポーネントです。
+  コマンドの上書き、新しいコマンドの追加、追加のネットワーク転送の提供や
+  ログ出力のカスタマイズなどを含めて
+  プラグインはさまざまなことを行うことができます。
+
+  プラグインを見つけてインストール方法を含めた詳細な情報に関しては、
+  Bazaarのウェブサイト、http://bazaar-vcs.org を参照してください。
+  プログラミング言語のPyhonを利用して
+  新しいコマンドを作成する方法に関する手引きもあります。
+
+
+
+pull
+====
+:目的: このブランチを別のブランチのミラーにする。
+:使い方:   bzr pull [LOCATION]
+
+:オプション:
+  -v, --verbose         pullされたリビジョン用のログを表示する。
+  --remember            デフォルトとして指定されたロケーションを記録する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -d ARG, --directory=ARG
+                        作業ディレクトリを含むものよりもpullするブランチ。
+  --overwrite           ブランチの間の違いを無視して無条件で上書きする。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  このコマンドは分岐されていないブランチのみで動作します。
+  目的のブランチの最新の変更コミットが親にマージされなかった場合(直接もしくは間接)、
+  ブランチは分岐したものとして見なされます。
+
+  ブランチが分岐していれば、あるブランチからの変更を他のブランチに統合するために
+  'bzr merge'を使用できます。
+  一旦あるブランチがマージされると、他のブランチは再びそれをpullできるようになります。
+
+  ローカルの変更を忘れてリモートブランチを満たすようにブランチを更新したいだけなら、
+  pull --overwriteを使用します。
+
+  デフォルトのロケーションが存在しない場合、最初のpullはこれを設定します。
+  その後で、デフォルトを使用するロケーションを省略できます。
+  デフォルトを変更するには、--rememberを使用します。
+  リモートロケーションがアクセスできる場合のみ値は保存されます。
+
+  注: 位置がブランチのフォーマットもしくはbzr sendで生成されたmergeディレクトリを格納する
+      ファイルへのパスで指定できます。
+
+:関連項目: `push`_, `status-flags`_, `update`_
+
+
+push
+====
+:目的: このブランチのミラーを更新する。
+:使い方:   bzr push [LOCATION]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  --remember            指定された位置をデフォルトとして覚える。
+  --create-prefix       まだ存在しなればブランチへのパスを作成する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --stacked-on=ARG      コミットの履歴に関して別のブランチを参照するスタックドブランチを作成する。
+                        参照されるブランチに存在しない作業内容は作成されたブランチに格納される。
+  --use-existing-dir    デフォルトでは、ターゲットのディレクトリが存在するが
+                        まだコントロールディレクトリを持たない場合pushは失敗する。
+                        このフラグはpushの続行を可能にする。
+  -d ARG, --directory=ARG
+                        作業ディレクトリを含むブランチよりも、pushするブランチ
+  --stacked             親ブランチの公開位置を参照するスタックドブランチを作成する。
+  --overwrite           ブランチ間の違いを無視して無条件に上書きする。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  これは割高でリモートファイルシステムではサポートされないので、
+  ターゲットブランチは投入された作業ツリーを持ちません。
+
+  スマートサーバーもしくはプロトコルの中には将来作業ツリーを導入しないものがあります。
+
+  このコマンドは分岐されていないブランチでのみ動作します。
+  目的のブランチの最新のコミットがソースブランチによって(直接もしくは間接的に)マージされなければ
+  ブランチは分岐されたものとして見なされます。
+
+  ブランチが分岐されると、他のブランチを完全に置き換えるために
+  'bzr push --overwrite'を使用できます。この場合、マージされていない変更は廃棄されます。
+
+  他のブランチに異なる変更があることを保証したい場合は、
+  他のブランチからマージを行い(bzr help mergeを参照)、それをコミットします。
+  その後で'--overwrite'なしでpushを行うことができるようになります。
+
+  デフォルトのpush位置の設定がなければ、最初のpushはこれを設定します。
+  その後では、デフォルトを省略できます。
+  デフォルトを変更するには、--rememberを使用します。
+  リモート位置がアクセスできる場合のみ値は保存されます。
+
+:関連項目: `pull`_, `update`_, `working-trees`_
+
+
+reconcile
+=========
+:目的: ブランチのメタデータを調整する。
+:使い方:   bzr reconcile [BRANCH]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  これは以前の実在しないオペレーションもしくはbzrの更新によって
+  引き起こされるデータのミスマッチを訂正できます。
+  'bzr check'もしくはbzrの開発者がそのコマンドを実行するようにアドバイスするのであれば、
+  このコマンドを実行することだけが必要になります。
+
+  2番目のブランチが提供されると、
+  ブランチをまたがる調整も行われます。これによってbzrの初期のバージョンでは存在しなかった
+  ツリーのroot idのようなデータがチェックされ、両方のブランチで正しく表示されます。
+
+  同時にデータが再圧縮されるのでディスクスペースの節約やパフォーマンスのゲインにつながります。
+
+  ブランチはローカルディスクもしくはsftpのようにリスト可能なシステム上になければなりません。
+
+:関連項目: `check`_
+
+
+reconfigure
+===========
+:目的: bzrディレクトリのタイプを再設定する。
+:使い方:   bzr reconfigure [LOCATION]
+
+:オプション:
+  --force               ローカルの変更が失われていた場合でも再設定を実行する。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --bind-to=ARG         チェックアウトをバインドするブランチ。
+  -h, --help            ヘルプメッセージを表示する。
+
+  Target type:
+    --branch            作業ツリーを持たないバインドされていないブランチに再設定する。
+    --checkout          作業ツリーを持つバインドされたブランチに再設定する。
+    --lightweight-checkout
+                        軽量チェックアウトに再設定する(ローカルの履歴はなし)。
+    --standalone        スタンドアロンブランチに再設定する(すなわち共用リポジトリの使用を停止する)。
+    --tree              作業ツリーを持つバインドされていないブランチに再設定する。
+    --use-shared        共用リポジトリを使用するように再設定する。
+
+:説明:
+  ターゲットの設定を指定しなければなりません。
+
+  チェックアウトに関しては指定されていなければ、bind-toのロケーションは自動検出されます。
+  優先順位は
+  1. 軽量チェックアウトに関しては、現在バインドされているロケーション。
+  2. チェックアウトに使用されるブランチに関しては、以前バインドされたロケーション。
+  3. pushのロケーション。
+  4. 親のロケーション。
+  これらが利用できなければ、--bind-toを指定しなければなりません。
+
+:関連項目: `ブランチ`_, `チェックアウト`_, `スタンドアロンのツリー`_, `作業ツリー`_
+
+
+remerge
+=======
+:目的: マージを再び行う。
+:使い方:   bzr remerge [FILE...]
+
+:オプション:
+  -v, --verbose       詳細な情報を表示する。
+  --reprocess         誤った衝突を減らすために再処理する。
+  -q, --quiet         エラーと警告のみ表示する。
+  --show-base         衝突内のベースリビジョンのテキストを表示する。
+  -h, --help          ヘルプメッセージを表示する。
+
+  マージアルゴリズム:
+    --merge-type=ARG  特定のマージアルゴリズムを指定する。
+    --diff3           外部diff3を使用するマージ
+    --lca             新しいLCAマージ
+    --merge3          ネイティブのdiff3スタイルのマージ
+    --weave           weaveベースのマージ
+
+:説明:
+  衝突を解消している間に異なるマージテクニックを試したい場合はこれを使用します。
+  マージテクニックの中には他のものよりもすぐれたものがあり、
+  remergeによって異なるファイルで異なるテクニックを試すことができます。
+  remergeのオプションはmergeのものと同じ意味とデフォルトを持ちます。
+  違いは未解決のマージが存在するときのみremergeは実行できて
+  特定のファイルを指定できることです。
+
+:例:
+    すべてのファイルのマージを再実行し、通常のTHISとOTHERテキストに加えて、
+    衝突領域のベーステキストを表示する::
+
+        bzr remerge --show-base
+
+    weaveマージアルゴリズムを使用して"foobar"のマージを再実行して、
+    衝突領域のサイズを減らすために追加処理を行う::
+
+        bzr remerge --merge-type weave --reprocess foobar
+
+
+
+remove
+======
+:目的: ファイルもしくはディレクトリを除外する。
+:使い方:   bzr remove [FILE...]
+
+:オプション:
+  --new         けっしてコミットされなかったファイルのみを除外する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+  削除戦略:
+    --force      指定されたファイルがリカバーできないまたは空のディレクトリではなくても
+                 これらすべてを削除する。
+    --keep       ファイルを削除しない。
+    --safe       ファイルを安全にリカバーできるのであればファイルを削除することだけ行う(デフォルト)。
+
+:説明:
+  このコマンドによってbzrは指定されたファイルへの変更の追跡を止めます。
+  rebertコマンドで容易に復元できるのであればbzrはこれらのファイルを削除します。
+  オプションもしくはパラメータが与えられなければbzrは追跡されているファイルをスキャンしますが
+  ツリーの中で見つからなければそれらの追跡を停止します。
+
+:エイリアス:  rm, del
+
+
+remove-tree
+===========
+:目的: 与えられたブランチ/チェックアウトから作業ツリーを除外する。
+:使い方:   bzr remove-tree [LOCATION]
+
+:オプション:
+  --force        コミットされていない変更があっても作業ツリーを除外する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  軽量チェックアウトは作業ツリーと大差ないので、これはそれに対する実行を拒絶します。
+
+  作業ツリーを再現するには、"bzr checkout"を使用します。
+
+:関連項目: `checkout`_, `working-trees`_
+
+
+renames
+=======
+:目的: リネームされたファイルの一覧を表示する。
+:使い方:   bzr renames [DIR]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:関連項目: `status`_
+
+
+resolve
+=======
+:目的: 衝突を解消されたものとしてマークする。
+:使い方:   bzr resolve [FILE...]
+
+:オプション:
+  --all          このツリーのすべての衝突を解消する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  2つのブランチの間の変更を結合するためにマージは最善を尽くしますが、
+  人間だけが修正できる種類の問題があります。
+  この問題に遭遇するとき、衝突がマークされます。
+  衝突はコミットする前に何かを修正する必要があることを意味します。
+
+  一旦問題を修正すれば、自動的にテキストの衝突を修正したものとしてマークするために"bzr resolve"を使用し、
+  特定の衝突を解消したものとしてマークするためにFILEをresolveします。
+  すべての衝突が解消されたものとしてマークするにはor "bzr resolve --all"を行います。
+
+:関連コマンド: `bzr conflicts`
+
+:エイリアス:  resolved
+
+
+revert
+======
+:目的: ファイルを以前のリビジョンに差し戻す。
+:使い方:   bzr revert [FILE...]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --forget-merges       ファイルを変更せずに、未解決のマージマーカーを取り除く。
+  --no-backup           差し戻しされたファイルのバックアップを保存しない。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  指定されたテキストだけを差し戻すファイルのリストを渡します。
+  さもなければ、すべてのファイルが差し戻されます。
+  '--revision'でリビジョンが指定されなければ、最後にコミットされたリビジョンが使用されます。
+
+  以前のリビジョンに差し戻さずに、いくつかの変更を除外するには、代わりにmergeを使用します。
+  たとえば、"merge . --revision -2..-3"は-2で導入された変更を除外しますが、
+  -1で導入された変更には影響を与えません。
+  hunk-by-hunkベースである変更を除外するには、Shelfプラグインを参照してください。
+
+  デフォルトでは、手動で変更されてきたファイルは最初にバックアップされます。
+  (マージのみで変更されたファイルはバックアップされません。)
+  バックアップファイルの名前には '.~#~' が追加されます。#は番号です。
+
+  ファイルを提供する場合、現在のパス名もしくはターゲットリビジョンからのパス名を使用できます。
+  名前でファイルを"undelete"するためにrevertを使用できます。
+  ディレクトリに名前をつけると、そのディレクトリのすべての内容が差し戻されます。
+
+  そのリビジョン以降に新しく追加されたファイルは削除されます。適切であればバックアップは維持されます。
+  未知のファイルを持つディレクトリは削除されません。
+
+  作業ツリーは未解決のマージされたリビジョンのリストを含みます。
+  これは次のコミットで親として含まれます。
+  通常は、ファイルを差し戻すのと同様にrevertはそのリストをクリーンにします。
+  ファイルが指定されていれば、revertは未解決のマージリストをそのままにしてファイルだけを差し戻します。
+  すべてのファイルを差し戻すがマージの記録を維持するにはツリーのrootで"bzr revert ."を使用し、
+  ファイルの差し戻しを行わずに未解決のマージリストをクリアするには"bzr revert --forget-merges"を使用します。
+
+:関連項目: `cat`_, `export`_
+
+
+revno
+=====
+:目的: 現在のリビジョン番号を表示する。
+:使い方:   bzr revno [LOCATION]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  これはこのブランチのリビジョン番号と等しいです。
+
+:関連項目: `info`_
+
+
+root
+====
+:目的: ツリーのrootディレクトリを表示する。
+:使い方:   bzr root [FILENAME]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  The rootは.bzrコントロールディレクトリを持つもっとも近い同封ディレクトリです。
+
+send
+====
+:目的: 変更を投稿するためにメールを送るもしくはmergeディレクティブを作成する。
+:使い方:   bzr send [SUBMIT_BRANCH] [PUBLIC_BRANCH]
+
+:オプション:
+  -f ARG, --from=ARG    作業ディレクトリを含むブランチよりも、投稿フォームを生成するブランチ。
+  --remember            投稿と公開ブランチを覚える。
+  --mail-to=ARG         このアドレスにリクエストメールを送信する。
+  --format=ARG          指定されたフォーマットを使用する。
+                        "0.9": バンドルフォーマット 0.9、マージディレクティブ 1。
+                        "4": バンドルフォーマット 4、マージディレクティブ 2 (デフォルト)。
+  --no-bundle           バンドルをmergeディレクティブに含めない。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -o ARG, --output=ARG  mergeディレクティブをこのファイルに書き込む; stdout用に-を使用する。
+  -m ARG, --message=ARG
+                        メッセージの文字列。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  --no-patch            mergeディレクティブにプレビューパッチを含めない。
+  -v, --verbose         詳細な情報を表示する。
+
+:説明:
+  mergeディレクティブはmergeリクエストを行うために必要な多くのものを提供します:
+
+  * 実行するマージのマシンが理解できる説明
+
+  * リクエストされた変更のプレビューであるオプションのパッチ
+
+  * リビジョンデータのオプションバンドル、
+    ブランチからデータを読み込まずに、mergeディレクトリからの変更を直接適用できるようになります。
+
+  --no-bundleが指定されると、public_branchが必要です(また最新でなければなりません)、
+  受け取り手がpublic_branchを使用するマージを実行できるように
+  後で他の人がチェックできるように、知っているのであればpublic_branchを常に含まれていなければなりません。
+
+  投稿ブランチのデフォルトは親ですが、上書きできます。
+  提供されれば投稿ブランチと公開ブランチの両方が記録されます。
+
+  public_branchがsubmit_branchに知られていれば、
+  その公開と投稿ブランチはマージのインストラクションで使用されます。
+  これはそのローカルミラーに対してpublic_branchを設定すれば、
+  そのミラーは実際の投稿ブランチとして使用できることを意味します。
+
+  メールは好きなプログラムで送信されます。
+  Windowsではこれは透過的です(MAPIが使用される)。
+  Linuxでは、xdg-emailユーティリティを必要とします。
+  望ましいクライアントが見つからなければ(もしくは使用できなければ)、エディタが使用されます。
+
+  特定のメールプログラムを使用するには、mail_client設定オプションを設定します。
+  (Thunderbird 1.5に関して、これはいくつかのバグに対処します。)
+  特定のクライアント用にサポートされる値は"claws"、"evolution"、"kmail"、"mutt"、と"thunderbird";
+  一般的なオプションは"default"、"editor"、"emacsclient"、"mapi"、と"xdg-email"です。
+  プラグインがサポートされるクライアントを追加することもあります。
+
+  メールが送信されている場合、to addressが必要になります。
+  これはコマンドライン、submit_to設定オプションをブランチ自身に設定するか、
+  投稿ブランチでchild_submit_to設定オプションを設定することで提供できます。
+
+  現在2つのフォーマットがサポートされています: "4"はリビジョンバンドルフォーマット4
+  とマージディレクトリフォーマット2です。
+  これは古いフォーマットよりも顕著に速く小さいです。
+  これはBazaar 0.19とそれ以降で互換性があります。
+  これはデフォルトです。
+  "0.9"はリビジョンバンドルフォーマット0.9とマージディレクティブフォーマット1を使用します。
+  これは0.12 - 0.18と互換性があります。
+
+  mergeもしくはpullコマンドを使用することでmergeディレクトリが適用されます。
+
+:関連項目: `merge`_, `pull`_
+
+
+serve
+=====
+:目的: bzrサーバーを稼働させる。
+:使い方:   bzr serve
+
+:オプション:
+  --allow-writes     デフォルトではサーバーはリードオンリーのサーバーです。
+                     --allow-writesを提供すると提供されるディレクトリと
+                     その下の内容への書き込み権限を有効にできる。
+  -v, --verbose      詳細な情報を表示する。
+  -q, --quiet        エラーと警告のみを表示する。
+  --directory=ARG    このディレクトリの内容をサーブする。
+  --port=ARG         [hostname:]portnumber形式で指名されたポート上で接続するためにリスンする。
+                     0をポート番号として割り当てるとポートは動的な割り当てになります。
+                     デフォルトのポートは4155です。
+  --inet             inetdもしくはsshdからの使用のためにstdin/outでserveする。
+  -h, --help         ヘルプメッセージを表示する。
+
+:エイリアス:  server
+
+
+shelve
+======
+:目的: いくつかの変更を現在のツリーから一時的に退避する。
+:使い方:   bzr shelve [FILE...]
+
+:オプション:
+  --all                 すべての変更を退避する。
+  -v, --verbose         詳細な情報を表示する。
+  --list                退避された変更の一覧を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告だけ表示する。
+  -m ARG, --message=ARG
+                        メッセージの文字列。
+  -r ARG, --revision=ARG
+                        詳細に関しては"help revisionspec"を参照。
+
+  writer:
+    --plain             プレーンテキスト形式での差分の出力。
+
+:説明:
+  shelveによって変更を一時的に"棚に上げる"、すなわち邪魔にならない場所に置くことができます。
+  'unshelve'コマンドで後で元に戻すことができます。
+
+  shelve --listが指定されると、以前退避された変更の一覧が表示されます。
+
+  shelveは不適切に混ぜられた変更のいくつかのセットの分離を手助けすることを目的としています。
+  すべての変更を除去したいだけで後で退避する必要がなければ、revertを使用します。
+  一度にすべてのテキストの変更をshelveするには、shelve --allを使用します。
+
+  ファイル名が指定されると、それらのファイルの変更のみ退避されます。
+  他のファイルは手つかずのままです。
+
+  リビジョンが指定されれば、そのリビジョン以降の変更は退避されます。
+
+  複数のアイテムを退避することができ、デフォルトでは、
+  'unshelve'は最近shelveされた変更を復元します。
+
+:関連項目: `unshelve`_
+
+sign-my-commits
+===============
+:目的: 与えられたコミッターですべてのコミットに署名する。
+:使い方:   bzr sign-my-commits [LOCATION] [COMMITTER]
+
+:オプション:
+  --dry-run      実際に署名しない。
+                 署名されるリビジョンを表示するだけ。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  位置が指定されなければローカルツリーが使用されます。
+  コミッターが指定されなければデフォルトのコミッターが使用されます。
+
+  これはすでにシグネチャを持つコミットには署名しません。
+
+
+
+split
+=====
+:目的: ツリーのサブディレクトリを個別のツリーに分割する。
+:使い方:   bzr split TREE
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドは'rich-root' もしくは 'rich-root-pack'のように
+  リッチrootをサポートするフォーマットでターゲットツリーを生み出します。
+  これらのフォーマットは'dirstate-tags'のような初期のフォーマットに変換できません。
+
+  TREEの引数は作業ツリーのサブディレクトリになります。
+  そのサブディレクトリは独自のブランチを持つ独立したツリーに変換されます。
+  トップレベルツリーのコミットは新しいサブツリーに適用されません。
+
+
+
+status
+======
+:目的: ステータスの要約を表示する。
+:使い方:   bzr status [FILE...]
+
+:オプション:
+  -S, --short           短いステータスインジケーターを表示する。
+  -v, --verbose         詳細な情報を表示する。
+  -V, --versioned       バージョン管理されたファイルだけを表示する。
+  --no-pending          未解決のマージを表示しない。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --show-ids            内部オブジェクトidを表示する。
+  -c ARG, --change=ARG  指定されたリビジョンで導入された変更を選択する。
+                        "help revisionspec"を参照。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  これはバージョン管理されたファイルと未知のファイルを状態で
+  分類してレポートします。利用可能な状態は次のとおりです:
+
+  added
+      作業ツリーでバージョン管理されているが以前のリビジョンではない。
+
+  removed
+      以前のリビジョンでバージョン管理されているが作業コピーでは移動もしくは削除されている。
+
+  renamed
+      以前のリビジョンから変更されたファイルのパス;
+      テキストも変更されていることがある。
+      これは親ディレクトリがリネームされたファイルを含む。
+
+  modified
+      以前のリビジョン以降変更されたテキスト。
+
+  kind changed
+      変更されたファイルの種類(たとえばファイルからディレクトリへ)。
+
+  unknown
+      バージョン管理されていないかつ無視パターンにマッチしない。
+
+  無視されるファイルを見るには'bzr ignored'を使用します。
+  ファイルテキストへの詳細な変更に関しては、'bzr diff'を使用します。
+
+  --shortもしくは-Sは、Subversionのstatusコマンドに似た、
+  それぞれのアイテムに対するステータスフラグを提供することに注意してください。
+  svn -qと似たような出力を得るには、bzr status -SVを使用します。
+
+  引数が指定されなければ、作業ディレクトリ全体のステータスが示されます。
+  さもなければ、指定されたファイルもしくはディレクトリのステータスのみが報告されます。
+  ディレクトリが渡されれば、そのディレクトリ内部のすべてに関するステータスが報告されます。
+
+  1つのリビジョンの引数が渡されれば、ステータスはそのリビジョンに対して
+  2つの引数の場合は2つのリビジョンの間で算出されます。
+
+:エイリアス:  st, stat
+:関連項目: `diff`_, `revert`_, `status-flags`_
+
+
+switch
+======
+:目的: チェックアウトのブランチを設定してupdateする。
+:使い方:   bzr switch TO_LOCATION
+
+:オプション:
+  --force        ローカルコミットが失われていても切り替える。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  軽量チェックアウトに対して、これは参照されているブランチを変更します。
+  重量チェックアウトに対して、これはローカルコミットがなく、
+  バインドされたブランチがないことを確認して、
+  ローカルブランチを新しいロケーションのミラーにしてそれにバインドします。
+
+  両方の場合において、作業ツリーはupdateされコミットされてない変更はマージされます。
+  ユーザーは望むのであればcommitもしくはrevertできます。
+
+  マージの追加にはswithを使用する前にcommitもしくはrevertする必要があります。
+
+  swithするブランチへのパスは現在のブランチの親ディレクトリに対して相対的に指定できます。
+  たとえば、現在/path/to/branchのチェックアウトの中にいるのであれば
+  'newbranch'を指定すれば/path/to/newbranchでのブランチが発見されます。
+
+  ローカルに設定されていない限りバインドされたブランチはマスターブランチのニックネームを使用します。
+  この場合、switchを行うとローカルのニックネームはマスターのものに更新されます。
+
+
+tag
+===
+:目的: リビジョンを名づけっるタグを作成、削除もしくは修正する。
+:使い方:   bzr tag TAG_NAME
+
+:オプション:
+  --force               既存のタグを置き換える。
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -d ARG, --directory=ARG
+                        タグを設置するブランチ
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  --delete              置き換えるよりもタグを削除する。
+
+:説明:
+  タグはリビジョンに人間が理解できる名前を与えます。
+  -r (--revision)オプションをとるコマンドは-rtag:Xに渡されます。
+  Xは以前作成されたタグです。
+
+  タグはブランチに保存されます。
+  branch、push、pullもしくはmergeを行うときタグはあるブランチから他のブランチにコピーされます。
+
+  --forceを渡さない限り、既存のタグ名を与えるとエラーになります。
+  この場合新しいリビジョンを示すようにタグは移動します。
+
+  タグをリネームする(名前を変更するが同じリビジョンで維持する)には、
+  ``bzr tag new-name -r tag:old-name`` と ``bzr tag --delete oldname`` を実行します。
+
+:関連項目: `commit`_, `tags`_
+
+
+tags
+====
+:目的: タグの一覧を表示する。
+:使い方:   bzr tags
+
+:オプション:
+  --sort=ARG            異なる基準でタグをソートする。
+                        "alpha": 辞書式でタグをソートする(デフォルト)。
+                        "time": 年代順でタグをソートする。
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -d ARG, --directory=ARG
+                        タグが表示されるブランチ。
+  --show-ids            内部オブジェクトidを表示する。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+  -h, --help            ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドはこれらが参照するタグ名とリビジョンのテーブルを表示します。
+
+:関連項目: `tag`_
+
+
+testament
+=========
+:目的: リビジョンのtestament(署名のフォーム)を表示する。
+:使い方:   bzr testament [BRANCH]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --long                長いフォーマットのtestamentを生成する。
+  --strict              厳密なフォーマットのtestamentを生成する。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+
+
+unbind
+======
+:目的: 現在のチェックアウトを通常のブランチに変換する。
+:使い方:   bzr unbind
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  unbindした後で、ローカルブランチは独立したものとして見なされ
+  その後のコミットはローカルのみで行われます。
+
+:関連項目: `bind`_, `チェックアウト`_
+
+
+uncommit
+========
+:目的: 最後にコミットされたリビジョンを削除する。
+:使い方:   bzr uncommit [LOCATION]
+
+:オプション:
+  --dry-run             実際には変更しない。
+  -v, --verbose         詳細な情報を表示する。
+  -h, --help            ヘルプメッセージを表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  --force               すべての質問にyesと答える。
+  --local               チェックアウトのときローカルブランチからコミットのみを削除する。
+  -r ARG, --revision=ARG
+                        詳細は"help revisionspec"を参照。
+
+:説明:
+  --verboseは削除されているものを表示します。
+  --dry-runはすべてのモーションを経験しますが、実際には何も削除しません。
+
+  --revisionが指定されると、指定されたリビジョンでブランチをそのままにするために
+  リビジョンをuncommitします。たとえば、"bzr uncommit -r 15"はリビジョン15でのブランチを
+  そのままにします。
+
+  uncommitは新しいコミットの準備ができている作業ツリーをそのままにします。
+  唯一行われる変更はコミット以前に存在していた追加マージをリストアすることです。
+
+:関連項目: `commit`_
+
+unshelve
+========
+:目的: shelveされた変更を復元する。
+:使い方Usage:   bzr unshelve [SHELF_ID]
+
+:オプション:
+  -v, --verbose    詳細な情報を表示する。
+  -q, --quiet      エラーと警告だけ表示する。
+  -h, --help       ヘルプメッセージを表示する。
+
+  アクション:
+    --apply        変更を適用してshelfから削除する。
+    --delete-only  変更を適用せずにそれらを削除する。
+    --dry-run      編子を表示するがそれらを適用もしくは除外しない。
+
+:説明:
+  デフォルトでは、最近shelveされた変更が復元されます。
+  んまでパッチを指定したとしてもそれらの変更が代わりに復元されます。
+  変更がお互いに依存しないときにこれはもっとも良く機能します。
+
+:関連項目: `shelve`_
+
+
+update
+======
+:目的: ブランチにコミットした最新コードにツリーを更新する。
+:使い方:   bzr update [DIR]
+
+:オプション:
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:説明:
+  このコマンドは作業ツリーでマージを実行し、衝突を生成することがあります。
+  ローカルの変更がある場合、updateを完了させるために
+  updateの後でそれらをコミットする必要があります。
+
+  ローカルの変更を破棄したい場合、updateの後で'bzr commit'の代わりに
+  'bzr revert'を使用できます。
+
+:エイリアス:  up
+:関連項目: `pull`_, `status-flags`_, `working-trees`_
+
+
+upgrade
+=======
+:目的: ブランチのストレージを現在のフォーマットにアップグレードする。
+:使い方:   bzr upgrade [URL]
+
+:オプション:
+  -v, --verbose         詳細な情報を表示する。
+  -q, --quiet           エラーと警告のみを表示する。
+  -h, --help            ヘルプメッセージを表示する。
+
+  ブランチのフォーマット::
+
+    --format=ARG        このブランチのフォーマットを指定する。"help formats"を参照。
+    --1.12-preview      ビューとコンテンツのフィルタリングをサポートする作業ツリーフォーマット。
+    --1.12-preview-rich-root
+                        rich-rootデータをサポートする1.12-previewのバリアント(bzr-svnに必要)
+    --1.6               スタックをサポートするリポジトリに基づいたブランチとパック。
+    --1.6.1-rich-root   スタックとリッチなrootデータをサポートするリポジトリに基づいた
+                        ブランチとパック(bzr-svnに必要)。
+    --1.9               btreeインデックスを使用するリポジトリに基づいたブランチとパック
+    --1.9-rich-root     btreeインデックスとリッチrootデータを使用する
+                        リポジトリに基づいたブランチとパック(bzr-svnに必要)。
+    --default           0.92の新しい機能: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用しますが
+                        bzr < 0.92では読むことができません。
+                        以前はknitpack-experimentalと呼ばれていました。
+                        詳細な情報は http://doc.bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --development       現在の開発フォーマット。データをpack-0.92 (とpack-0.92と互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devによってのみ読み込みできます。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-repo.html を参照して頂くようお願いします。
+    --development-subtree
+                        現在の開発フォーマットで、subtreeバリアント。
+                        データをpack-0.92-subtree(とpack-0.92-subtreeと互換性のある)
+                        フォーマットリポジトリに変換できる。
+                        このフォーマットのリポジトリとブランチはbzr.devでのみ読み込みできる。
+                        使用する前に http://doc.bazaar-vcs.org/latest/developers/development-
+                        repo.html をご覧いただくようお願いします。
+    --dirstate          0.15の新しいフォーマット: 速いローカルオペレーション。
+                        ネットワークを通したアクセスのときbzr 0.8とそれ以降と互換性がある。
+    --dirstate-tags     0.15の新しいフォーマット: 速いローカルオペレーションで
+                        ネットワークオペレーションに関するスケーリングを改善。
+                        タグのサポートを追加。bzr < 0.15とは互換性がない。
+    --knit              knitsを使用するフォーマット。bzr <= 0.14との相互運用に推奨。
+    --metaweave         0.8での暫定フォーマット。knitよりも遅い。
+    --pack-0.92         0.92の新しいフォーマット: dirstate-tagsフォーマットリポジトリと
+                        互換性のあるデータを持つパックベースのフォーマット。
+                        0.92以前のbzrリポジトリと相互運用できるがbzr < 0.92.によって読み込みできない。
+                        以前はknitpack-experimentalと呼ばれていた。
+                        詳細な情報に関しては、 http://doc
+                        .bazaar-vcs.org/latest/developers/packrepo.html を参照。
+    --rich-root         1.0の新しいフォーマット。ツリーrootのベターな扱い。
+                        bzr < 1.0と互換性がない。
+    --rich-root-pack    1.0の新しいフォーマット: rich-rootデータをサポートする
+                        pack-0.92のバリアント(bzr-svnに必要)。
+    --weave             0.8以前のフォーマット。knitよりも遅く
+                        チェックアウトもしくは共用リポジトリをサポートしない。
+
+:説明:
+  ときどきこのコマンドを実行するにcheckコマンドもしくはbzrの開発者がアドバイスすることがあります。
+  デフォルトフォーマットが変更されたときアップグレードする他のオペレーションの実行中に警告されることもあります。
+
+:関連コマンド: `check`_
+
+
+version
+=======
+:目的: bzrのバージョンを表示する
+:使い方:   bzr version
+
+:オプション:
+  --short        バージョン番号だけを表示する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告だけ表示する。
+  -h, --help     ヘルプメッセージを表示する。
+
+
+
+version-info
+============
+:目的: このツリーに関するバージョン情報を表示する。
+:使い方:   bzr version-info [LOCATION]
+
+:オプション:
+  --all                 すべての入手可能な情報を含める。
+  -v, --verbose         詳細な情報を表示する。
+  --check-clean         ツリーがクリーンであるかチェックする。
+  --include-history     リビジョンの履歴を含める。
+  -q, --quiet           エラーと警告のみを表示する。
+  --template=ARG        出力用のテンプレート。
+  --include-file-revisions
+                        それぞれのファイルに対する最終リビジョンを含める。
+  -h, --help            ヘルプメッセージを表示する。
+
+  フォーマット::
+    --format=ARG        出力フォーマットを選択する。
+    --custom            カスタムテンプレートベースのフォーマットでのバージョン情報。
+    --python            Pythonフォーマットでのバージョン情報。
+    --rio               RIOフォーマット(シンプルなテキスト)でのバージョン情報(デフォルト)。
+
+:説明:
+  バージョンに関する情報をアプリケーションのソースコードに追加するために
+  このコマンドを使用できます。出力のフォーマットはサポートされているもの1つか
+  テンプレートに基づいてカスタマイズされたものです。
+
+  例::
+
+    bzr version-info --custom \
+      --template="#define VERSION_INFO \"Project 1.2.3 (r{revno})\"\n"
+
+  現在のリビジョン番号を含むフォーマットされた文字列でCヘッダファイルを生成します。
+  テンプレートでのサポートされた他の変数は次のとおりです:
+
+    * {date} - 最終リビジョンの日付
+    * {build_date} - 現在の日付
+    * {revno} - リビジョン番号
+    * {revision_id} - リビジョンid
+    * {branch_nick} - ブランチのニックネーム
+    * {clean} - ソースコードがコミットされていない変更を含むときは0でそれ以外は1
+
+
+
+whoami
+======
+:目的: bzrのユーザーidを表示もしくは設定する。
+:使い方:   bzr whoami [NAME]
+
+:オプション:
+  --email        Eメールアドレスのみ表示する。
+  -v, --verbose  詳細な情報を表示する。
+  -q, --quiet    エラーと警告のみを表示する。
+  --branch       グローバルの代わりに現在のブランチ用のIDを設定する。
+  -h, --help     ヘルプメッセージを表示する。
+
+:例:
+    現在のユーザーのEメールを表示する::
+
+        bzr whoami --email
+
+    現在のユーザーを設定する::
+
+        bzr whoami "Frank Chu <fchu@example.com>"
+
+
+
+

=== modified file 'doc/ru/_templates/layout.html'
--- doc/ru/_templates/layout.html	2009-09-08 15:06:56 +0000
+++ doc/ru/_templates/layout.html	2009-10-30 07:51:16 +0000
@@ -6,3 +6,22 @@
 <a href="http://doc.bazaar-vcs.org/ru/">Документация</a>&nbsp;|&nbsp;</li>
 {{ super() }}
 {% endblock %}
+
+{% block document %}
+ <script type="text/javascript">
+  var gaJsHost = (("https:" == document.location.protocol) ?  "https://ssl." : "http://www.");
+  document.write(unescape("%3Cscript src='" + gaJsHost + "google-analytics.com/ga.js' type='text/javascript'%3E%3C/script%3E"));
+  </script>
+  <script type="text/javascript">
+  try{
+  var pageTracker = _gat._getTracker("UA-1018242-1");
+  pageTracker._trackPageview();
+  } catch(err) {}
+  try {
+    /* bazaar team tracker */
+    var pageTracker = _gat._getTracker("UA-11329411-2");
+    pageTracker._trackPageview();
+  } catch(err) {}
+</script>
+{{ super() }}
+{% endblock %}

=== modified file 'doc/ru/index.txt'
--- doc/ru/index.txt	2009-09-09 02:30:32 +0000
+++ doc/ru/index.txt	2009-12-02 20:34:07 +0000
@@ -2,7 +2,7 @@
 Главный каталог документов Bazaar
 =================================
 
-Последняя версия этих документов доступа со страницы документации 
+Последняя версия этих документов доступа со страницы документации
 на сайте Bazaar, <http://doc.bazaar-vcs.org/ru/>.
 
 Основная документация
@@ -25,9 +25,9 @@
 * `Руководство по миграции <http://doc.bazaar-vcs.org/migration/en/>`_
   |--| для команд переносящих историю с других систем контроля версий
 
-* `Словарь терминов <http://bazaar-vcs.org/BzrGlossary>`_ (англ.), 
-  см. также `русскую версию`__ 
-  
+* `Словарь терминов <http://bazaar-vcs.org/BzrGlossary>`_ (англ.),
+  см. также `русскую версию`__
+
 __  http://groups.google.com/group/ru_bzr/web/%D0%B3%D0%BB%D0%BE%D1%81%D1%81%D0%B0%D1%80%D0%B8%D0%B9
 
 * `Часто задаваемые вопросы <https://answers.launchpad.net/bzr>`_ (англ.)

=== modified file 'doc/ru/mini-tutorial/index.txt'
--- doc/ru/mini-tutorial/index.txt	2009-05-05 21:16:12 +0000
+++ doc/ru/mini-tutorial/index.txt	2009-12-02 20:34:07 +0000
@@ -15,20 +15,20 @@
 ваших файлов, как вносить изменения, проверять вашу работу, публиковать её и
 отправлять для объединения с главной веткой проекта.
 
-Если вы предпочитаете более подробное введение, обратитесь к разделу 
+Если вы предпочитаете более подробное введение, обратитесь к разделу
 `Узнать больше`_.
 
 Установка
 =========
 
-Это руководство не описывает как установить Bazaar, потому что обычно 
+Это руководство не описывает как установить Bazaar, потому что обычно
 это очень легко. Инструкции по установке вы найдете тут:
 
 - **GNU/Linux:** скорее всего Bazaar уже присутствует в вашем дистрибутиве GNU/Linux.
 - **Windows:** `инструкции по установке для Windows`_.
 - **Mac OS X:** `инструкции по установке для Mac OS X`_.
 
-Для других платформ и для установки из исходных кодов, обратитесь к страницам 
+Для других платформ и для установки из исходных кодов, обратитесь к страницам
 Загрузка_ и Установка_.
 
 .. _инструкции по установке для Windows: http://bazaar-vcs.org/WindowsDownloads
@@ -39,7 +39,7 @@
 Представьтесь
 =============
 
-Прежде чем начать работать, было бы неплохо сообщить Bazaar кто вы такой. 
+Прежде чем начать работать, было бы неплохо сообщить Bazaar кто вы такой.
 В этом случае ваша работа будет корректно идентифицирована в истории ревизий.
 
 Используя ваше имя и адрес электронной почты, вместо данных Васи Пупкина,
@@ -66,8 +66,8 @@
     $ mkdir subdirectory
     $ touch test1.txt test2.txt test3.txt subdirectory/test4.txt
 
-**Замечание для пользователей Windows:** используйте Windows Explorer 
-для создания ваших каталогов, затем нажимайте правую кнопку мыши 
+**Замечание для пользователей Windows:** используйте Windows Explorer
+для создания ваших каталогов, затем нажимайте правую кнопку мыши
 в этих каталогах и выбирайте ``Новый файл``, чтобы создать ваши файлы.
 
 Теперь дадим Bazaar возможность инициализировать свои данные в каталоге вашего
@@ -182,8 +182,8 @@
 свободного программного обеспечения. Вы можете использовать его для публикации
 своей ветки.
 
-Если у вас нет учетной записи Launchpad, следуйте 
-`руководству по получению учетной записи`_ и `зарегистрируйте SSH ключ`_ 
+Если у вас нет учетной записи Launchpad, следуйте
+`руководству по получению учетной записи`_ и `зарегистрируйте SSH ключ`_
 в своей новой учетной записи.
 
 .. _руководству по получению учетной записи: https://help.launchpad.net/CreatingYourLaunchpadAccount
@@ -264,14 +264,14 @@
     Using saved parent location: http://bazaar.launchpad.net/~bzr/bzr-gtk/trunk
 
 Теперь вы можете отправить директиву объединения по электронной почте
-в проект bzr-gtk. Если разработчики bzr-gtk захотят, то смогут использовать 
+в проект bzr-gtk. Если разработчики bzr-gtk захотят, то смогут использовать
 эту директиву для включения вашей работы в основную ветку.
 
 
 Узнать больше
 =============
 
-Больше информации о Bazaar вы найдете в 
+Больше информации о Bazaar вы найдете в
 `Руководстве пользователя Bazaar <../user-guide/index.html>`_.
 
 Чтобы узнать больше о Bazaar из командой строки::

=== modified file 'doc/ru/tutorials/centralized_workflow.txt'
--- doc/ru/tutorials/centralized_workflow.txt	2009-06-05 18:59:14 +0000
+++ doc/ru/tutorials/centralized_workflow.txt	2009-12-02 20:34:07 +0000
@@ -45,7 +45,7 @@
 использоваться в сообщениях журнала и аннотациях, таким образом лучше что
 бы она была похожа на что-то реальное.
 
-::  
+::
 
    % bzr whoami "Иван Пупкин <ivan@pupkin.ru>"
 
@@ -109,7 +109,7 @@
 
 .. _Отслеживание изменений на основной ветке: http://bazaar-vcs.org/TrackingUpstream
 
-.. 
+..
    TODO: На самом деле нам нужен другой документ для описания
    конвертирования проекта. Но пока ссылка выше - это лучшее.
 
@@ -288,7 +288,7 @@
 ::
 
   % bzr branch sftp://centralhost/srv/bzr/sigil/user-a \
-               sftp://centralhost/srv/bzr/sigil/user-a/feature 
+               sftp://centralhost/srv/bzr/sigil/user-a/feature
   % cd ~/work/sigil
   % bzr checkout sftp://centralhost/srv/bzr/sigil/user-a/feature myfeature
 
@@ -315,5 +315,5 @@
 ветки разделяют историю и они могут так же разделять и хранилище истории.
 
 
-.. 
+..
    vim: tw=74 ft=rst spell spelllang=en_us

=== modified file 'doc/ru/tutorials/tutorial.txt'
--- doc/ru/tutorials/tutorial.txt	2009-06-05 18:59:14 +0000
+++ doc/ru/tutorials/tutorial.txt	2009-12-02 20:34:07 +0000
@@ -482,7 +482,7 @@
 готовой ветки. Так как эта копия может быть потенциальной новой веткой эта
 команда называется **branch**::
 
-    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev 
+    % bzr branch http://bazaar-vcs.org/bzr/bzr.dev
     % cd bzr.dev
 
 Эта команда копирует полную историю ветки и после этого вы можете делать все
@@ -553,7 +553,7 @@
 
   ::
 
-    % bzr push sftp://servername.com/path/to/directory 
+    % bzr push sftp://servername.com/path/to/directory
 
   (Каталог назначения должна быть создан заранее, если только не указана
   опция ``--create-prefix``)

=== modified file 'doc/ru/tutorials/using_bazaar_with_launchpad.txt'
--- doc/ru/tutorials/using_bazaar_with_launchpad.txt	2009-05-31 11:46:02 +0000
+++ doc/ru/tutorials/using_bazaar_with_launchpad.txt	2009-12-02 20:34:07 +0000
@@ -301,7 +301,7 @@
 Как поясняется далее, функция отслеживания объединений веток на Launchpad в
 настоящее время находится в стадии разработки. Как только эта функция будет
 готова более подходящим поведением станет автоматическое изменение состояния
-ошибки на *Fix Committed* (исправление зафиксировано). 
+ошибки на *Fix Committed* (исправление зафиксировано).
 
 
 Связь ветки с планом

=== modified file 'doc/ru/user-guide/branching_a_project.txt'
--- doc/ru/user-guide/branching_a_project.txt	2009-06-02 11:14:10 +0000
+++ doc/ru/user-guide/branching_a_project.txt	2009-12-02 20:34:07 +0000
@@ -93,7 +93,7 @@
 the latest version.
 
 As explained in later chapters, Bazaar also has support for
-`lightweight checkouts <#getting-a-lightweight-checkout>`_ 
+`lightweight checkouts <#getting-a-lightweight-checkout>`_
 of a branch, i.e. working trees with
 no local storage of history. Of course, disconnected usage
 is not available then but that's a tradeoff you can decide

=== modified file 'doc/ru/user-guide/index-plain.txt'
--- doc/ru/user-guide/index-plain.txt	2009-09-09 12:57:43 +0000
+++ doc/ru/user-guide/index-plain.txt	2009-12-02 20:34:07 +0000
@@ -87,7 +87,7 @@
 .. include:: ../../en/user-guide/server.txt
 .. include:: ../../en/user-guide/hooks.txt
 .. include:: ../../en/user-guide/version_info.txt
- 
+
 
 Краткое описание некоторых популярных плагинов
 ##############################################

=== modified file 'doc/ru/user-guide/index.txt'
--- doc/ru/user-guide/index.txt	2009-06-02 11:14:10 +0000
+++ doc/ru/user-guide/index.txt	2009-12-02 20:34:07 +0000
@@ -87,7 +87,7 @@
 .. include:: ../../en/user-guide/server.txt
 .. include:: ../../en/user-guide/hooks.txt
 .. include:: ../../en/user-guide/version_info.txt
- 
+
 
 Краткое описание некоторых популярных плагинов
 ##############################################

=== modified file 'doc/ru/user-guide/introducing_bazaar.txt'
--- doc/ru/user-guide/introducing_bazaar.txt	2009-06-02 11:14:10 +0000
+++ doc/ru/user-guide/introducing_bazaar.txt	2009-12-02 20:34:07 +0000
@@ -86,10 +86,10 @@
 
  * для сообществ с открытым исходным кодом:
 
-   * более легкое создание и поддержка изменений для сторонних разработчиков 
+   * более легкое создание и поддержка изменений для сторонних разработчиков
 
    * упрощение взаимодействия основных разработчиков со сторонними
-     разработчиками и более простая миграция сторонних разработчиков в основные 
+     разработчиками и более простая миграция сторонних разработчиков в основные
 
  * для компаний - упрощение работы с распределенными и внешними командами.
 

=== modified file 'doc/ru/user-guide/specifying_revisions.txt'
--- doc/ru/user-guide/specifying_revisions.txt	2009-06-02 11:14:10 +0000
+++ doc/ru/user-guide/specifying_revisions.txt	2009-12-02 20:34:07 +0000
@@ -128,7 +128,7 @@
 ~~~~~~~~
 
 **ancestor**:*path*
-    specifies the common ancestor between the current branch and a 
+    specifies the common ancestor between the current branch and a
     different branch. This is the same ancestor that would be used for
     merging purposes.
 

=== modified file 'doc/ru/user-guide/zen.txt'
--- doc/ru/user-guide/zen.txt	2009-06-05 20:06:14 +0000
+++ doc/ru/user-guide/zen.txt	2009-12-02 20:34:07 +0000
@@ -4,13 +4,13 @@
 Глубокое понимание Bazaar
 -------------------------
 
-Хотя Bazaar во многом похож на другие инструменты контроля версий, есть 
+Хотя Bazaar во многом похож на другие инструменты контроля версий, есть
 некоторые важные различия, которые не всегда очевидны на первый взгляд. Этот
 раздел пытается объяснить некоторые вещи, который пользователь должен знать
 чтобы разбираться в Bazaar, т.е. глубоко его понимать.
 
-Заметьте: чтобы использовать Bazaar совсем необязательно полностью понимать 
-этот раздел. Вы можете просмотреть этот раздел сейчас и вернуться к нему позже. 
+Заметьте: чтобы использовать Bazaar совсем необязательно полностью понимать
+этот раздел. Вы можете просмотреть этот раздел сейчас и вернуться к нему позже.
 
 Понимание номеров ревизий
 -------------------------
@@ -55,7 +55,7 @@
   102: Add code and tests for X
   101: Add tests for Y
   100: ...
-  
+
 Many teams use this approach because their tools make branching and merging
 difficult. As a consequence, developers update from and commit to the trunk
 frequently, minimizing integration pain by spreading it over every commit.
@@ -205,10 +205,10 @@
 ------
 
 Обычно, если вы следовали ранее полученным советам - организовать вашу работу
-в ветках и использовать объединение для сотрудничества - вы обнаружите что 
+в ветках и использовать объединение для сотрудничества - вы обнаружите что
 чаще всего Bazaar делает то что вы ожидаете.
 
-В следующих главах, мы проверим различный способы использования Bazaar, начиная 
+В следующих главах, мы проверим различный способы использования Bazaar, начиная
 с самого простого: использование Bazaar для личных проектов.
 
 ..

=== modified file 'setup.py'
--- setup.py	2009-10-15 21:28:14 +0000
+++ setup.py	2010-01-12 06:30:41 +0000
@@ -40,7 +40,7 @@
     'url':          'http://www.bazaar-vcs.org/',
     'description':  'Friendly distributed version control system',
     'license':      'GNU GPL v2',
-    'download_url': 'http://bazaar-vcs.org/Download',
+    'download_url': 'https://launchpad.net/bzr/+download',
     'long_description': get_long_description(),
     'classifiers': [
         'Development Status :: 6 - Mature',
@@ -282,11 +282,13 @@
     add_pyrex_extension('bzrlib._walkdirs_win32')
     z_lib = 'zdll'
 else:
-    if have_pyrex and pyrex_version == '0.9.4.1':
+    if have_pyrex and pyrex_version.startswith('0.9.4'):
         # Pyrex 0.9.4.1 fails to compile this extension correctly
         # The code it generates re-uses a "local" pointer and
         # calls "PY_DECREF" after having set it to NULL. (It mixes PY_XDECREF
         # which is NULL safe with PY_DECREF which is not.)
+        # <https://bugs.edge.launchpad.net/bzr/+bug/449372>
+        # <https://bugs.edge.launchpad.net/bzr/+bug/276868>
         print 'Cannot build extension "bzrlib._dirstate_helpers_pyx" using'
         print 'your version of pyrex "%s". Please upgrade your pyrex' % (
             pyrex_version,)
@@ -401,6 +403,7 @@
     # PyQt4 itself still escapes the plugin detection code for some reason...
     packages.append('PyQt4')
     excludes.append('PyQt4.elementtree.ElementTree')
+    excludes.append('PyQt4.uic.port_v3')
     includes.append('sip') # extension module required for Qt.
     packages.append('pygments') # colorizer for qbzr
     packages.append('docutils') # html formatting

